/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var $=["require","exports","vs/base/common/platform","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/editor/common/core/range","vs/base/common/functional","vs/base/common/lifecycle","vs/base/common/stopwatch","vs/base/common/event","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/base/common/uri","vs/base/common/diff/diffChange","vs/base/common/iterator","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/base/common/hash","vs/editor/common/core/characterClassifier","vs/editor/common/core/selection","vs/editor/common/core/token","vs/editor/common/diff/diffComputer","vs/editor/common/model/wordHelper","vs/editor/common/modes/linkComputer","vs/editor/common/modes/supports/inplaceReplaceSupport","vs/editor/common/standalone/standaloneEnums","vs/editor/common/standalone/standaloneBase","vs/editor/common/viewModel/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],V=function(F){for(var t=[],P=0,R=F.length;P<R;P++)t[P]=$[F[P]];return t},Le=this,Se=typeof global=="object"?global:{},K;(function(F){F.global=Le;var t=function(){function P(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1}return Object.defineProperty(P.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(P.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(P.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(P.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),P.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=P._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof F.global.importScripts=="function")},P._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},P}();F.Environment=t})(K||(K={}));var K;(function(F){var t=function(){function C(s,E,o){this.type=s,this.detail=E,this.timestamp=o}return C}();F.LoaderEvent=t;var P=function(){function C(s){this._events=[new t(1,"",s)]}return C.prototype.record=function(s,E){this._events.push(new t(s,E,F.Utilities.getHighPerformanceTimestamp()))},C.prototype.getEvents=function(){return this._events},C}();F.LoaderEventRecorder=P;var R=function(){function C(){}return C.prototype.record=function(s,E){},C.prototype.getEvents=function(){return[]},C.INSTANCE=new C,C}();F.NullLoaderEventRecorder=R})(K||(K={}));var K;(function(F){var t=function(){function P(){}return P.fileUriToFilePath=function(R,C){if(C=decodeURI(C).replace(/%23/g,"#"),R){if(/^file:\/\/\//.test(C))return C.substr(8);if(/^file:\/\//.test(C))return C.substr(5)}else if(/^file:\/\//.test(C))return C.substr(7);return C},P.startsWith=function(R,C){return R.length>=C.length&&R.substr(0,C.length)===C},P.endsWith=function(R,C){return R.length>=C.length&&R.substr(R.length-C.length)===C},P.containsQueryString=function(R){return/^[^\#]*\?/gi.test(R)},P.isAbsolutePath=function(R){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(R)},P.forEachProperty=function(R,C){if(R){var s=void 0;for(s in R)R.hasOwnProperty(s)&&C(s,R[s])}},P.isEmpty=function(R){var C=!0;return P.forEachProperty(R,function(){C=!1}),C},P.recursiveClone=function(R){if(!R||typeof R!="object"||R instanceof RegExp||!Array.isArray(R)&&Object.getPrototypeOf(R)!==Object.prototype)return R;var C=Array.isArray(R)?[]:{};return P.forEachProperty(R,function(s,E){E&&typeof E=="object"?C[s]=P.recursiveClone(E):C[s]=E}),C},P.generateAnonymousModule=function(){return"===anonymous"+P.NEXT_ANONYMOUS_ID+++"==="},P.isAnonymousModule=function(R){return P.startsWith(R,"===anonymous")},P.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=F.global.performance&&typeof F.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?F.global.performance.now():Date.now()},P.NEXT_ANONYMOUS_ID=1,P.PERFORMANCE_NOW_PROBED=!1,P.HAS_PERFORMANCE_NOW=!1,P}();F.Utilities=t})(K||(K={}));var K;(function(F){function t(C){if(C instanceof Error)return C;var s=new Error(C.message||String(C)||"Unknown Error");return C.stack&&(s.stack=C.stack),s}F.ensureError=t;var P=function(){function C(){}return C.validateConfigurationOptions=function(s){function E(u){if(u.phase==="loading"){console.error('Loading "'+u.moduleId+'" failed'),console.error(u),console.error("Here are the modules that depend on it:"),console.error(u.neededBy);return}if(u.phase==="factory"){console.error('The factory method of "'+u.moduleId+'" has thrown an exception'),console.error(u);return}}if(s=s||{},typeof s.baseUrl!="string"&&(s.baseUrl=""),typeof s.isBuild!="boolean"&&(s.isBuild=!1),typeof s.paths!="object"&&(s.paths={}),typeof s.config!="object"&&(s.config={}),typeof s.catchError=="undefined"&&(s.catchError=!1),typeof s.recordStats=="undefined"&&(s.recordStats=!1),typeof s.urlArgs!="string"&&(s.urlArgs=""),typeof s.onError!="function"&&(s.onError=E),Array.isArray(s.ignoreDuplicateModules)||(s.ignoreDuplicateModules=[]),s.baseUrl.length>0&&(F.Utilities.endsWith(s.baseUrl,"/")||(s.baseUrl+="/")),typeof s.cspNonce!="string"&&(s.cspNonce=""),typeof s.preferScriptTags=="undefined"&&(s.preferScriptTags=!1),Array.isArray(s.nodeModules)||(s.nodeModules=[]),s.nodeCachedData&&typeof s.nodeCachedData=="object"&&(typeof s.nodeCachedData.seed!="string"&&(s.nodeCachedData.seed="seed"),(typeof s.nodeCachedData.writeDelay!="number"||s.nodeCachedData.writeDelay<0)&&(s.nodeCachedData.writeDelay=1e3*7),!s.nodeCachedData.path||typeof s.nodeCachedData.path!="string")){var o=t(new Error("INVALID cached data configuration, 'path' MUST be set"));o.phase="configuration",s.onError(o),s.nodeCachedData=void 0}return s},C.mergeConfigurationOptions=function(s,E){s===void 0&&(s=null),E===void 0&&(E=null);var o=F.Utilities.recursiveClone(E||{});return F.Utilities.forEachProperty(s,function(u,c){u==="ignoreDuplicateModules"&&typeof o.ignoreDuplicateModules!="undefined"?o.ignoreDuplicateModules=o.ignoreDuplicateModules.concat(c):u==="paths"&&typeof o.paths!="undefined"?F.Utilities.forEachProperty(c,function(v,w){return o.paths[v]=w}):u==="config"&&typeof o.config!="undefined"?F.Utilities.forEachProperty(c,function(v,w){return o.config[v]=w}):o[u]=F.Utilities.recursiveClone(c)}),C.validateConfigurationOptions(o)},C}();F.ConfigurationOptionsUtil=P;var R=function(){function C(s,E){if(this._env=s,this.options=P.mergeConfigurationOptions(E),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var o=this.options.nodeRequire.main.filename,u=Math.max(o.lastIndexOf("/"),o.lastIndexOf("\\"));this.options.baseUrl=o.substring(0,u+1)}if(this.options.nodeMain&&this._env.isNode){var o=this.options.nodeMain,u=Math.max(o.lastIndexOf("/"),o.lastIndexOf("\\"));this.options.baseUrl=o.substring(0,u+1)}}}return C.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var s=0;s<this.options.ignoreDuplicateModules.length;s++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[s]]=!0},C.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var s=0,E=this.options.nodeModules;s<E.length;s++){var o=E[s];this.nodeModulesMap[o]=!0}},C.prototype._createSortedPathsRules=function(){var s=this;this.sortedPathsRules=[],F.Utilities.forEachProperty(this.options.paths,function(E,o){Array.isArray(o)?s.sortedPathsRules.push({from:E,to:o}):s.sortedPathsRules.push({from:E,to:[o]})}),this.sortedPathsRules.sort(function(E,o){return o.from.length-E.from.length})},C.prototype.cloneAndMerge=function(s){return new C(this._env,P.mergeConfigurationOptions(s,this.options))},C.prototype.getOptionsLiteral=function(){return this.options},C.prototype._applyPaths=function(s){for(var E,o=0,u=this.sortedPathsRules.length;o<u;o++)if(E=this.sortedPathsRules[o],F.Utilities.startsWith(s,E.from)){for(var c=[],v=0,w=E.to.length;v<w;v++)c.push(E.to[v]+s.substr(E.from.length));return c}return[s]},C.prototype._addUrlArgsToUrl=function(s){return F.Utilities.containsQueryString(s)?s+"&"+this.options.urlArgs:s+"?"+this.options.urlArgs},C.prototype._addUrlArgsIfNecessaryToUrl=function(s){return this.options.urlArgs?this._addUrlArgsToUrl(s):s},C.prototype._addUrlArgsIfNecessaryToUrls=function(s){if(this.options.urlArgs)for(var E=0,o=s.length;E<o;E++)s[E]=this._addUrlArgsToUrl(s[E]);return s},C.prototype.moduleIdToPaths=function(s){var E=this.nodeModulesMap[s]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(s);if(E)return this.isBuild()?["empty:"]:["node|"+s];var o=s,u;if(!F.Utilities.endsWith(o,".js")&&!F.Utilities.isAbsolutePath(o)){u=this._applyPaths(o);for(var c=0,v=u.length;c<v;c++)this.isBuild()&&u[c]==="empty:"||(F.Utilities.isAbsolutePath(u[c])||(u[c]=this.options.baseUrl+u[c]),!F.Utilities.endsWith(u[c],".js")&&!F.Utilities.containsQueryString(u[c])&&(u[c]=u[c]+".js"))}else!F.Utilities.endsWith(o,".js")&&!F.Utilities.containsQueryString(o)&&(o=o+".js"),u=[o];return this._addUrlArgsIfNecessaryToUrls(u)},C.prototype.requireToUrl=function(s){var E=s;return F.Utilities.isAbsolutePath(E)||(E=this._applyPaths(E)[0],F.Utilities.isAbsolutePath(E)||(E=this.options.baseUrl+E)),this._addUrlArgsIfNecessaryToUrl(E)},C.prototype.isBuild=function(){return this.options.isBuild},C.prototype.isDuplicateMessageIgnoredFor=function(s){return this.ignoreDuplicateModulesMap.hasOwnProperty(s)},C.prototype.getConfigForModule=function(s){if(this.options.config)return this.options.config[s]},C.prototype.shouldCatchError=function(){return this.options.catchError},C.prototype.shouldRecordStats=function(){return this.options.recordStats},C.prototype.onError=function(s){this.options.onError(s)},C}();F.Configuration=R})(K||(K={}));var K;(function(F){var t=function(){function u(c){this._env=c,this._scriptLoader=null,this._callbackMap={}}return u.prototype.load=function(c,v,w,g){var f=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new C;else if(this._env.isElectronRenderer){var m=c.getConfig().getOptionsLiteral().preferScriptTags;m?this._scriptLoader=new P:this._scriptLoader=new s(this._env)}else this._env.isNode?this._scriptLoader=new s(this._env):this._scriptLoader=new P;var L={callback:w,errorback:g};if(this._callbackMap.hasOwnProperty(v)){this._callbackMap[v].push(L);return}this._callbackMap[v]=[L],this._scriptLoader.load(c,v,function(){return f.triggerCallback(v)},function(A){return f.triggerErrorback(v,A)})},u.prototype.triggerCallback=function(c){var v=this._callbackMap[c];delete this._callbackMap[c];for(var w=0;w<v.length;w++)v[w].callback()},u.prototype.triggerErrorback=function(c,v){var w=this._callbackMap[c];delete this._callbackMap[c];for(var g=0;g<w.length;g++)w[g].errorback(v)},u}(),P=function(){function u(){}return u.prototype.attachListeners=function(c,v,w){var g=function(){c.removeEventListener("load",f),c.removeEventListener("error",m)},f=function(L){g(),v()},m=function(L){g(),w(L)};c.addEventListener("load",f),c.addEventListener("error",m)},u.prototype.load=function(c,v,w,g){if(/^node\|/.test(v)){var f=c.getConfig().getOptionsLiteral(),m=E(c.getRecorder(),f.nodeRequire||F.global.nodeRequire),L=v.split("|"),A=null;try{A=m(L[1])}catch(r){g(r);return}c.enqueueDefineAnonymousModule([],function(){return A}),w()}else{var S=document.createElement("script");S.setAttribute("async","async"),S.setAttribute("type","text/javascript"),this.attachListeners(S,w,g);var n=c.getConfig().getOptionsLiteral().trustedTypesPolicy;n&&(v=n.createScriptURL(v)),S.setAttribute("src",v);var i=c.getConfig().getOptionsLiteral().cspNonce;i&&S.setAttribute("nonce",i),document.getElementsByTagName("head")[0].appendChild(S)}},u}();function R(u){var c=u.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var v=c?self.eval(c.createScript("","true")):new Function("true");return v.call(self),!0}catch(w){return!1}}var C=function(){function u(){this._cachedCanUseEval=null}return u.prototype._canUseEval=function(c){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=R(c)),this._cachedCanUseEval},u.prototype.load=function(c,v,w,g){var f=c.getConfig().getOptionsLiteral().trustedTypesPolicy,m=/^((http:)|(https:)|(file:))/.test(v)&&v.substring(0,self.origin.length)!==self.origin;if(!m&&this._canUseEval(c)){fetch(v).then(function(L){if(L.status!==200)throw new Error(L.statusText);return L.text()}).then(function(L){L=L+`
//# sourceURL=`+v;var A=f?self.eval(f.createScript("",L)):new Function(L);A.call(self),w()}).then(void 0,g);return}try{f&&(v=f.createScriptURL(v)),importScripts(v),w()}catch(L){g(L)}},u}(),s=function(){function u(c){this._env=c,this._didInitialize=!1,this._didPatchNodeRequire=!1}return u.prototype._init=function(c){this._didInitialize||(this._didInitialize=!0,this._fs=c("fs"),this._vm=c("vm"),this._path=c("path"),this._crypto=c("crypto"))},u.prototype._initNodeRequire=function(c,v){var w=v.getConfig().getOptionsLiteral().nodeCachedData;if(!w||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var g=this,f=c("module");function m(L){var A=L.constructor,S=function(i){try{return L.require(i)}finally{}};return S.resolve=function(i,r){return A._resolveFilename(i,L,!1,r)},S.resolve.paths=function(i){return A._resolveLookupPaths(i,L)},S.main=process.mainModule,S.extensions=A._extensions,S.cache=A._cache,S}f.prototype._compile=function(L,A){var S=f.wrap(L.replace(/^#!.*/,"")),n=v.getRecorder(),i=g._getCachedDataPath(w,A),r={filename:A},l;try{var h=g._fs.readFileSync(i);l=h.slice(0,16),r.cachedData=h.slice(16),n.record(60,i)}catch(p){n.record(61,i)}var _=new g._vm.Script(S,r),a=_.runInThisContext(r),d=g._path.dirname(A),N=m(this),M=[this.exports,N,this,A,d,process,Se,Buffer],D=a.apply(this.exports,M);return g._handleCachedData(_,S,i,!r.cachedData,v),g._verifyCachedData(_,S,i,l,v),D}},u.prototype.load=function(c,v,w,g){var f=this,m=c.getConfig().getOptionsLiteral(),L=E(c.getRecorder(),m.nodeRequire||F.global.nodeRequire),A=m.nodeInstrumenter||function(a){return a};this._init(L),this._initNodeRequire(L,c);var S=c.getRecorder();if(/^node\|/.test(v)){var n=v.split("|"),i=null;try{i=L(n[1])}catch(a){g(a);return}c.enqueueDefineAnonymousModule([],function(){return i}),w()}else{v=F.Utilities.fileUriToFilePath(this._env.isWindows,v);var r=this._path.normalize(v),l=this._getElectronRendererScriptPathOrUri(r),h=Boolean(m.nodeCachedData),_=h?this._getCachedDataPath(m.nodeCachedData,v):void 0;this._readSourceAndCachedData(r,_,S,function(a,d,N,M){if(a){g(a);return}var D;d.charCodeAt(0)===u._BOM?D=u._PREFIX+d.substring(1)+u._SUFFIX:D=u._PREFIX+d+u._SUFFIX,D=A(D,r);var p={filename:l,cachedData:N},U=f._createAndEvalScript(c,D,p,w,g);f._handleCachedData(U,D,_,h&&!N,c),f._verifyCachedData(U,D,_,M,c)})}},u.prototype._createAndEvalScript=function(c,v,w,g,f){var m=c.getRecorder();m.record(31,w.filename);var L=new this._vm.Script(v,w),A=L.runInThisContext(w),S=c.getGlobalAMDDefineFunc(),n=!1,i=function(){return n=!0,S.apply(null,arguments)};return i.amd=S.amd,A.call(F.global,c.getGlobalAMDRequireFunc(),i,w.filename,this._path.dirname(w.filename)),m.record(32,w.filename),n?g():f(new Error("Didn't receive define call in "+w.filename+"!")),L},u.prototype._getElectronRendererScriptPathOrUri=function(c){if(!this._env.isElectronRenderer)return c;var v=c.match(/^([a-z])\:(.*)/i);return v?"file:///"+(v[1].toUpperCase()+":"+v[2]).replace(/\\/g,"/"):"file://"+c},u.prototype._getCachedDataPath=function(c,v){var w=this._crypto.createHash("md5").update(v,"utf8").update(c.seed,"utf8").update(process.arch,"").digest("hex"),g=this._path.basename(v).replace(/\.js$/,"");return this._path.join(c.path,g+"-"+w+".code")},u.prototype._handleCachedData=function(c,v,w,g,f){var m=this;c.cachedDataRejected?this._fs.unlink(w,function(L){f.getRecorder().record(62,w),m._createAndWriteCachedData(c,v,w,f),L&&f.getConfig().onError(L)}):g&&this._createAndWriteCachedData(c,v,w,f)},u.prototype._createAndWriteCachedData=function(c,v,w,g){var f=this,m=Math.ceil(g.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),L=-1,A=0,S=void 0,n=function(){setTimeout(function(){S||(S=f._crypto.createHash("md5").update(v,"utf8").digest());var i=c.createCachedData();if(!(i.length===0||i.length===L||A>=5)){if(i.length<L){n();return}L=i.length,f._fs.writeFile(w,Buffer.concat([S,i]),function(r){r&&g.getConfig().onError(r),g.getRecorder().record(63,w),n()})}},m*Math.pow(4,A++))};n()},u.prototype._readSourceAndCachedData=function(c,v,w,g){if(!v)this._fs.readFile(c,{encoding:"utf8"},g);else{var f=void 0,m=void 0,L=void 0,A=2,S=function(n){n?g(n):--A==0&&g(void 0,f,m,L)};this._fs.readFile(c,{encoding:"utf8"},function(n,i){f=i,S(n)}),this._fs.readFile(v,function(n,i){!n&&i&&i.length>0?(L=i.slice(0,16),m=i.slice(16),w.record(60,v)):w.record(61,v),S()})}},u.prototype._verifyCachedData=function(c,v,w,g,f){var m=this;!g||c.cachedDataRejected||setTimeout(function(){var L=m._crypto.createHash("md5").update(v,"utf8").digest();g.equals(L)||(f.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+w+"' now, but a RESTART IS REQUIRED")),m._fs.unlink(w,function(A){A&&f.getConfig().onError(A)}))},Math.ceil(5e3*(1+Math.random())))},u._BOM=65279,u._PREFIX="(function (require, define, __filename, __dirname) { ",u._SUFFIX=`
});`,u}();function E(u,c){if(c.__$__isRecorded)return c;var v=function(g){u.record(33,g);try{return c(g)}finally{u.record(34,g)}};return v.__$__isRecorded=!0,v}F.ensureRecordedNodeRequire=E;function o(u){return new t(u)}F.createScriptLoader=o})(K||(K={}));var K;(function(F){var t=function(){function o(u){var c=u.lastIndexOf("/");c!==-1?this.fromModulePath=u.substr(0,c+1):this.fromModulePath=""}return o._normalizeModuleId=function(u){var c=u,v;for(v=/\/\.\//;v.test(c);)c=c.replace(v,"/");for(c=c.replace(/^\.\//g,""),v=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;v.test(c);)c=c.replace(v,"/");return c=c.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),c},o.prototype.resolveModule=function(u){var c=u;return F.Utilities.isAbsolutePath(c)||(F.Utilities.startsWith(c,"./")||F.Utilities.startsWith(c,"../"))&&(c=o._normalizeModuleId(this.fromModulePath+c)),c},o.ROOT=new o(""),o}();F.ModuleIdResolver=t;var P=function(){function o(u,c,v,w,g,f){this.id=u,this.strId=c,this.dependencies=v,this._callback=w,this._errorback=g,this.moduleIdResolver=f,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return o._safeInvokeFunction=function(u,c){try{return{returnedValue:u.apply(F.global,c),producedError:null}}catch(v){return{returnedValue:null,producedError:v}}},o._invokeFactory=function(u,c,v,w){return u.isBuild()&&!F.Utilities.isAnonymousModule(c)?{returnedValue:null,producedError:null}:u.shouldCatchError()?this._safeInvokeFunction(v,w):{returnedValue:v.apply(F.global,w),producedError:null}},o.prototype.complete=function(u,c,v){this._isComplete=!0;var w=null;if(this._callback)if(typeof this._callback=="function"){u.record(21,this.strId);var g=o._invokeFactory(c,this.strId,this._callback,v);w=g.producedError,u.record(22,this.strId),!w&&typeof g.returnedValue!="undefined"&&(!this.exportsPassedIn||F.Utilities.isEmpty(this.exports))&&(this.exports=g.returnedValue)}else this.exports=this._callback;if(w){var f=F.ensureError(w);f.phase="factory",f.moduleId=this.strId,this.error=f,c.onError(f)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},o.prototype.onDependencyError=function(u){return this._isComplete=!0,this.error=u,this._errorback?(this._errorback(u),!0):!1},o.prototype.isComplete=function(){return this._isComplete},o}();F.Module=P;var R=function(){function o(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return o.prototype.getMaxModuleId=function(){return this._nextId},o.prototype.getModuleId=function(u){var c=this._strModuleIdToIntModuleId.get(u);return typeof c=="undefined"&&(c=this._nextId++,this._strModuleIdToIntModuleId.set(u,c),this._intModuleIdToStrModuleId[c]=u),c},o.prototype.getStrModuleId=function(u){return this._intModuleIdToStrModuleId[u]},o}(),C=function(){function o(u){this.id=u}return o.EXPORTS=new o(0),o.MODULE=new o(1),o.REQUIRE=new o(2),o}();F.RegularDependency=C;var s=function(){function o(u,c,v){this.id=u,this.pluginId=c,this.pluginParam=v}return o}();F.PluginDependency=s;var E=function(){function o(u,c,v,w,g){g===void 0&&(g=0),this._env=u,this._scriptLoader=c,this._loaderAvailableTimestamp=g,this._defineFunc=v,this._requireFunc=w,this._moduleIdProvider=new R,this._config=new F.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return o.prototype.reset=function(){return new o(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},o.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},o.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},o._findRelevantLocationInStack=function(u,c){for(var v=function(r){return r.replace(/\\/g,"/")},w=v(u),g=c.split(/\n/),f=0;f<g.length;f++){var m=g[f].match(/(.*):(\d+):(\d+)\)?$/);if(m){var L=m[1],A=m[2],S=m[3],n=Math.max(L.lastIndexOf(" ")+1,L.lastIndexOf("(")+1);if(L=L.substr(n),L=v(L),L===w){var i={line:parseInt(A,10),col:parseInt(S,10)};return i.line===1&&(i.col-="(function (require, define, __filename, __dirname) { ".length),i}}}throw new Error("Could not correlate define call site for needle "+u)},o.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var u=[],c=0,v=0,w=this._modules2.length;v<w;v++){var g=this._modules2[v];if(!!g){var f=this._buildInfoPath[g.id]||null,m=this._buildInfoDefineStack[g.id]||null,L=this._buildInfoDependencies[g.id];u[c++]={id:g.strId,path:f,defineLocation:f&&m?o._findRelevantLocationInStack(f,m):null,dependencies:L,shim:null,exports:g.exports}}}return u},o.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new F.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=F.NullLoaderEventRecorder.INSTANCE),this._recorder},o.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},o.prototype.enqueueDefineAnonymousModule=function(u,c){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var v=null;this._config.isBuild()&&(v=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:v,dependencies:u,callback:c}},o.prototype.defineModule=function(u,c,v,w,g,f){var m=this;f===void 0&&(f=new t(u));var L=this._moduleIdProvider.getModuleId(u);if(this._modules2[L]){this._config.isDuplicateMessageIgnoredFor(u)||console.warn("Duplicate definition of module '"+u+"'");return}var A=new P(L,u,this._normalizeDependencies(c,f),v,w,f);this._modules2[L]=A,this._config.isBuild()&&(this._buildInfoDefineStack[L]=g,this._buildInfoDependencies[L]=(A.dependencies||[]).map(function(S){return m._moduleIdProvider.getStrModuleId(S.id)})),this._resolve(A)},o.prototype._normalizeDependency=function(u,c){if(u==="exports")return C.EXPORTS;if(u==="module")return C.MODULE;if(u==="require")return C.REQUIRE;var v=u.indexOf("!");if(v>=0){var w=c.resolveModule(u.substr(0,v)),g=c.resolveModule(u.substr(v+1)),f=this._moduleIdProvider.getModuleId(w+"!"+g),m=this._moduleIdProvider.getModuleId(w);return new s(f,m,g)}return new C(this._moduleIdProvider.getModuleId(c.resolveModule(u)))},o.prototype._normalizeDependencies=function(u,c){for(var v=[],w=0,g=0,f=u.length;g<f;g++)v[w++]=this._normalizeDependency(u[g],c);return v},o.prototype._relativeRequire=function(u,c,v,w){if(typeof c=="string")return this.synchronousRequire(c,u);this.defineModule(F.Utilities.generateAnonymousModule(),c,v,w,null,u)},o.prototype.synchronousRequire=function(u,c){c===void 0&&(c=new t(u));var v=this._normalizeDependency(u,c),w=this._modules2[v.id];if(!w)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This is the first mention of this module!");if(!w.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This module has not been resolved completely yet.");if(w.error)throw w.error;return w.exports},o.prototype.configure=function(u,c){var v=this._config.shouldRecordStats();c?this._config=new F.Configuration(this._env,u):this._config=this._config.cloneAndMerge(u),this._config.shouldRecordStats()&&!v&&(this._recorder=null)},o.prototype.getConfig=function(){return this._config},o.prototype._onLoad=function(u){if(this._currentAnonymousDefineCall!==null){var c=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(u),c.dependencies,c.callback,null,c.stack)}},o.prototype._createLoadError=function(u,c){var v=this,w=this._moduleIdProvider.getStrModuleId(u),g=(this._inverseDependencies2[u]||[]).map(function(m){return v._moduleIdProvider.getStrModuleId(m)}),f=F.ensureError(c);return f.phase="loading",f.moduleId=w,f.neededBy=g,f},o.prototype._onLoadError=function(u,c){var v=this._createLoadError(u,c);this._modules2[u]||(this._modules2[u]=new P(u,this._moduleIdProvider.getStrModuleId(u),[],function(){},function(){},null));for(var w=[],g=0,f=this._moduleIdProvider.getMaxModuleId();g<f;g++)w[g]=!1;var m=!1,L=[];for(L.push(u),w[u]=!0;L.length>0;){var A=L.shift(),S=this._modules2[A];S&&(m=S.onDependencyError(v)||m);var n=this._inverseDependencies2[A];if(n)for(var g=0,f=n.length;g<f;g++){var i=n[g];w[i]||(L.push(i),w[i]=!0)}}m||this._config.onError(v)},o.prototype._hasDependencyPath=function(u,c){var v=this._modules2[u];if(!v)return!1;for(var w=[],g=0,f=this._moduleIdProvider.getMaxModuleId();g<f;g++)w[g]=!1;var m=[];for(m.push(v),w[u]=!0;m.length>0;){var L=m.shift(),A=L.dependencies;if(A)for(var g=0,f=A.length;g<f;g++){var S=A[g];if(S.id===c)return!0;var n=this._modules2[S.id];n&&!w[S.id]&&(w[S.id]=!0,m.push(n))}}return!1},o.prototype._findCyclePath=function(u,c,v){if(u===c||v===50)return[u];var w=this._modules2[u];if(!w)return null;var g=w.dependencies;if(g)for(var f=0,m=g.length;f<m;f++){var L=this._findCyclePath(g[f].id,c,v+1);if(L!==null)return L.push(u),L}return null},o.prototype._createRequire=function(u){var c=this,v=function(w,g,f){return c._relativeRequire(u,w,g,f)};return v.toUrl=function(w){return c._config.requireToUrl(u.resolveModule(w))},v.getStats=function(){return c.getLoaderEvents()},v.hasDependencyCycle=function(){return c._hasDependencyCycle},v.config=function(w,g){g===void 0&&(g=!1),c.configure(w,g)},v.__$__nodeRequire=F.global.nodeRequire,v},o.prototype._loadModule=function(u){var c=this;if(!(this._modules2[u]||this._knownModules2[u])){this._knownModules2[u]=!0;var v=this._moduleIdProvider.getStrModuleId(u),w=this._config.moduleIdToPaths(v),g=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(v.indexOf("/")===-1||g.test(v))&&w.push("node|"+v);var f=-1,m=function(L){if(f++,f>=w.length)c._onLoadError(u,L);else{var A=w[f],S=c.getRecorder();if(c._config.isBuild()&&A==="empty:"){c._buildInfoPath[u]=A,c.defineModule(c._moduleIdProvider.getStrModuleId(u),[],null,null,null),c._onLoad(u);return}S.record(10,A),c._scriptLoader.load(c,A,function(){c._config.isBuild()&&(c._buildInfoPath[u]=A),S.record(11,A),c._onLoad(u)},function(n){S.record(12,A),m(n)})}};m(null)}},o.prototype._loadPluginDependency=function(u,c){var v=this;if(!(this._modules2[c.id]||this._knownModules2[c.id])){this._knownModules2[c.id]=!0;var w=function(g){v.defineModule(v._moduleIdProvider.getStrModuleId(c.id),[],g,null,null)};w.error=function(g){v._config.onError(v._createLoadError(c.id,g))},u.load(c.pluginParam,this._createRequire(t.ROOT),w,this._config.getOptionsLiteral())}},o.prototype._resolve=function(u){var c=this,v=u.dependencies;if(v)for(var w=0,g=v.length;w<g;w++){var f=v[w];if(f===C.EXPORTS){u.exportsPassedIn=!0,u.unresolvedDependenciesCount--;continue}if(f===C.MODULE){u.unresolvedDependenciesCount--;continue}if(f===C.REQUIRE){u.unresolvedDependenciesCount--;continue}var m=this._modules2[f.id];if(m&&m.isComplete()){if(m.error){u.onDependencyError(m.error);return}u.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(f.id,u.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(f.id)+"' and '"+this._moduleIdProvider.getStrModuleId(u.id)+"'. The cyclic path follows:");var L=this._findCyclePath(f.id,u.id,0)||[];L.reverse(),L.push(f.id),console.warn(L.map(function(n){return c._moduleIdProvider.getStrModuleId(n)}).join(` => 
`)),u.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[f.id]=this._inverseDependencies2[f.id]||[],this._inverseDependencies2[f.id].push(u.id),f instanceof s){var A=this._modules2[f.pluginId];if(A&&A.isComplete()){this._loadPluginDependency(A.exports,f);continue}var S=this._inversePluginDependencies2.get(f.pluginId);S||(S=[],this._inversePluginDependencies2.set(f.pluginId,S)),S.push(f),this._loadModule(f.pluginId);continue}this._loadModule(f.id)}u.unresolvedDependenciesCount===0&&this._onModuleComplete(u)},o.prototype._onModuleComplete=function(u){var c=this,v=this.getRecorder();if(!u.isComplete()){var w=u.dependencies,g=[];if(w)for(var f=0,m=w.length;f<m;f++){var L=w[f];if(L===C.EXPORTS){g[f]=u.exports;continue}if(L===C.MODULE){g[f]={id:u.strId,config:function(){return c._config.getConfigForModule(u.strId)}};continue}if(L===C.REQUIRE){g[f]=this._createRequire(u.moduleIdResolver);continue}var A=this._modules2[L.id];if(A){g[f]=A.exports;continue}g[f]=null}u.complete(v,this._config,g);var S=this._inverseDependencies2[u.id];if(this._inverseDependencies2[u.id]=null,S)for(var f=0,m=S.length;f<m;f++){var n=S[f],i=this._modules2[n];i.unresolvedDependenciesCount--,i.unresolvedDependenciesCount===0&&this._onModuleComplete(i)}var r=this._inversePluginDependencies2.get(u.id);if(r){this._inversePluginDependencies2.delete(u.id);for(var f=0,m=r.length;f<m;f++)this._loadPluginDependency(u.exports,r[f])}}},o}();F.ModuleManager=E})(K||(K={}));var j,K;(function(F){var t=new F.Environment,P=null,R=function(o,u,c){typeof o!="string"&&(c=u,u=o,o=null),(typeof u!="object"||!Array.isArray(u))&&(c=u,u=null),u||(u=["require","exports","module"]),o?P.defineModule(o,u,c,null,null):P.enqueueDefineAnonymousModule(u,c)};R.amd={jQuery:!0};var C=function(o,u){u===void 0&&(u=!1),P.configure(o,u)},s=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){C(arguments[0]);return}if(typeof arguments[0]=="string")return P.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){P.defineModule(F.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};s.config=C,s.getConfig=function(){return P.getConfig().getOptionsLiteral()},s.reset=function(){P=P.reset()},s.getBuildInfo=function(){return P.getBuildInfo()},s.getStats=function(){return P.getLoaderEvents()},s.define=function(){return R.apply(null,arguments)};function E(){if(typeof F.global.require!="undefined"||typeof require!="undefined"){var o=F.global.require||require;if(typeof o=="function"&&typeof o.resolve=="function"){var u=F.ensureRecordedNodeRequire(P.getRecorder(),o);F.global.nodeRequire=u,s.nodeRequire=u,s.__$__nodeRequire=u}}t.isNode&&!t.isElectronRenderer?(module.exports=s,require=s):(t.isElectronRenderer||(F.global.define=R),F.global.require=s)}F.init=E,(typeof F.global.define!="function"||!F.global.define.amd)&&(P=new F.ModuleManager(t,F.createScriptLoader(t),R,s,F.Utilities.getHighPerformanceTimestamp()),typeof F.global.require!="undefined"&&typeof F.global.require!="function"&&s.config(F.global.require),j=function(){return R.apply(null,arguments)},j.amd=R.amd,typeof doNotInitLoader=="undefined"&&E())})(K||(K={}));var Ee=this,de;(function(F){var t=Ee||{},P=t.Plugin&&t.Plugin.Resources?t.Plugin.Resources:void 0,R=t&&t.document&&t.document.location&&t.document.location.hash.indexOf("pseudo=true")>=0;function C(c,v){var w;return v.length===0?w=c:w=c.replace(/\{(\d+)\}/g,function(g,f){var m=f[0];return typeof v[m]!="undefined"?v[m]:g}),R&&(w="\uFF3B"+w.replace(/[aouei]/g,"$&$&")+"\uFF3D"),w}function s(c,v){var w=c[v];return w||(w=c["*"],w)?w:null}function E(c,v){for(var w=[],g=0;g<arguments.length-2;g++)w[g]=arguments[g+2];return C(v,w)}function o(c){return function(v,w){var g=Array.prototype.slice.call(arguments,2);return C(c[v],g)}}var u=function(){function c(){this.localize=E}return c.prototype.setPseudoTranslation=function(v){R=v},c.prototype.create=function(v,w){return{localize:o(w[v])}},c.prototype.load=function(v,w,g,f){if(f=f||{},!v||v.length===0)g({localize:E});else{var m=void 0;if(P&&P.getString)m=".nls.keys",w([v+m],function(S){g({localize:function(n,i){if(!S[n])return"NLS error: unknown key "+n;var r=S[n].keys;if(i>=r.length)return"NLS error unknown index "+i;var l=r[i],h=[];h[0]=n+"_"+l;for(var _=0;_<arguments.length-2;_++)h[_+1]=arguments[_+2];return P.getString.apply(P,h)}})});else if(f.isBuild)w([v+".nls",v+".nls.keys"],function(S,n){c.BUILD_MAP[v]=S,c.BUILD_MAP_KEYS[v]=n,g(S)});else{var L=f["vs/nls"]||{},A=L.availableLanguages?s(L.availableLanguages,v):null;m=".nls",A!==null&&A!==c.DEFAULT_TAG&&(m=m+"."+A),w([v+m],function(S){Array.isArray(S)?S.localize=o(S):S.localize=o(S[v]),g(S)})}}},c.prototype._getEntryPointsMap=function(){return t.nlsPluginEntryPoints=t.nlsPluginEntryPoints||{},t.nlsPluginEntryPoints},c.prototype.write=function(v,w,g){var f=g.getEntryPoint(),m=this._getEntryPointsMap();m[f]=m[f]||[],m[f].push(w),w!==f&&g.asModule(v+"!"+w,"define(['vs/nls', 'vs/nls!"+f+`'], function(nls, data) { return nls.create("`+w+'", data); });')},c.prototype.writeFile=function(v,w,g,f,m){var L=this._getEntryPointsMap();if(L.hasOwnProperty(w)){for(var A=g.toUrl(w+".nls.js"),S=["/*---------------------------------------------------------"," * Copyright (c) Microsoft Corporation. All rights reserved."," *--------------------------------------------------------*/"],n=L[w],i={},r=0;r<n.length;r++)i[n[r]]=c.BUILD_MAP[n[r]];S.push('define("'+w+'.nls", '+JSON.stringify(i,null,"	")+");"),f(A,S.join(`\r
`))}},c.prototype.finishBuild=function(v){v("nls.metadata.json",JSON.stringify({keys:c.BUILD_MAP_KEYS,messages:c.BUILD_MAP,bundles:this._getEntryPointsMap()},null,"	"))},c.DEFAULT_TAG="i-default",c.BUILD_MAP={},c.BUILD_MAP_KEYS={},c}();F.NLSPlugin=u,function(){j("vs/nls",new u)}()})(de||(de={})),j($[15],V([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class P{constructor(C,s,E,o){this.originalStart=C,this.originalLength=s,this.modifiedStart=E,this.modifiedLength=o}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=P}),j($[4],V([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createErrorWithActions=t.isErrorWithActions=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isPromiseCanceledError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class P{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(h){setTimeout(()=>{throw h.stack?new Error(h.message+`

`+h.stack):h},0)}}addListener(h){return this.listeners.push(h),()=>{this._removeListener(h)}}emit(h){this.listeners.forEach(_=>{_(h)})}_removeListener(h){this.listeners.splice(this.listeners.indexOf(h),1)}setUnexpectedErrorHandler(h){this.unexpectedErrorHandler=h}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(h){this.unexpectedErrorHandler(h),this.emit(h)}onUnexpectedExternalError(h){this.unexpectedErrorHandler(h)}}t.ErrorHandler=P,t.errorHandler=new P;function R(l){t.errorHandler.setUnexpectedErrorHandler(l)}t.setUnexpectedErrorHandler=R;function C(l){u(l)||t.errorHandler.onUnexpectedError(l)}t.onUnexpectedError=C;function s(l){u(l)||t.errorHandler.onUnexpectedExternalError(l)}t.onUnexpectedExternalError=s;function E(l){if(l instanceof Error){let{name:h,message:_}=l;const a=l.stacktrace||l.stack;return{$isError:!0,name:h,message:_,stack:a}}return l}t.transformErrorForSerialization=E;const o="Canceled";function u(l){return l instanceof Error&&l.name===o&&l.message===o}t.isPromiseCanceledError=u;class c extends Error{constructor(){super(o);this.name=this.message}}t.CancellationError=c;function v(){const l=new Error(o);return l.name=l.message,l}t.canceled=v;function w(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}t.illegalArgument=w;function g(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}t.illegalState=g;function f(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=f;function m(l){const h=new Error(`${l} has been disposed`);return h.name="DISPOSED",h}t.disposed=m;function L(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}t.getErrorMessage=L;class A extends Error{constructor(h){super("NotImplemented");h&&(this.message=h)}}t.NotImplementedError=A;class S extends Error{constructor(h){super("NotSupported");h&&(this.message=h)}}t.NotSupportedError=S;class n extends Error{constructor(){super(...arguments);this.isExpected=!0}}t.ExpectedError=n;function i(l){const h=l;return h instanceof Error&&Array.isArray(h.actions)}t.isErrorWithActions=i;function r(l,h=Object.create(null)){const _=new Error(l);return h.actions&&(_.actions=h.actions),_}t.createErrorWithActions=r}),j($[7],V([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function P(R){const C=this;let s=!1,E;return function(){return s||(s=!0,E=R.apply(C,arguments)),E}}t.once=P}),j($[16],V([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var P;(function(R){function C(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}R.is=C;const s=Object.freeze([]);function E(){return s}R.empty=E;function*o(l){yield l}R.single=o;function u(l){return l||s}R.from=u;function c(l){return!l||l[Symbol.iterator]().next().done===!0}R.isEmpty=c;function v(l){return l[Symbol.iterator]().next().value}R.first=v;function w(l,h){for(const _ of l)if(h(_))return!0;return!1}R.some=w;function g(l,h){for(const _ of l)if(h(_))return _}R.find=g;function*f(l,h){for(const _ of l)h(_)&&(yield _)}R.filter=f;function*m(l,h){let _=0;for(const a of l)yield h(a,_++)}R.map=m;function*L(...l){for(const h of l)for(const _ of h)yield _}R.concat=L;function*A(l){for(const h of l)for(const _ of h)yield _}R.concatNested=A;function S(l,h,_){let a=_;for(const d of l)a=h(a,d);return a}R.reduce=S;function*n(l,h,_=l.length){for(h<0&&(h+=l.length),_<0?_+=l.length:_>l.length&&(_=l.length);h<_;h++)yield l[h]}R.slice=n;function i(l,h=Number.POSITIVE_INFINITY){const _=[];if(h===0)return[_,l];const a=l[Symbol.iterator]();for(let d=0;d<h;d++){const N=a.next();if(N.done)return[_,R.empty()];_.push(N.value)}return[_,{[Symbol.iterator](){return a}}]}R.consume=i;function r(l,h,_=(a,d)=>a===d){const a=l[Symbol.iterator](),d=h[Symbol.iterator]();for(;;){const N=a.next(),M=d.next();if(N.done!==M.done)return!1;if(N.done)return!0;if(!_(N.value,M.value))return!1}}R.equals=r})(P=t.Iterable||(t.Iterable={}))}),j($[17],V([0,1,4]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.KeyCode=void 0;var R;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.KEY_0=21]="KEY_0",n[n.KEY_1=22]="KEY_1",n[n.KEY_2=23]="KEY_2",n[n.KEY_3=24]="KEY_3",n[n.KEY_4=25]="KEY_4",n[n.KEY_5=26]="KEY_5",n[n.KEY_6=27]="KEY_6",n[n.KEY_7=28]="KEY_7",n[n.KEY_8=29]="KEY_8",n[n.KEY_9=30]="KEY_9",n[n.KEY_A=31]="KEY_A",n[n.KEY_B=32]="KEY_B",n[n.KEY_C=33]="KEY_C",n[n.KEY_D=34]="KEY_D",n[n.KEY_E=35]="KEY_E",n[n.KEY_F=36]="KEY_F",n[n.KEY_G=37]="KEY_G",n[n.KEY_H=38]="KEY_H",n[n.KEY_I=39]="KEY_I",n[n.KEY_J=40]="KEY_J",n[n.KEY_K=41]="KEY_K",n[n.KEY_L=42]="KEY_L",n[n.KEY_M=43]="KEY_M",n[n.KEY_N=44]="KEY_N",n[n.KEY_O=45]="KEY_O",n[n.KEY_P=46]="KEY_P",n[n.KEY_Q=47]="KEY_Q",n[n.KEY_R=48]="KEY_R",n[n.KEY_S=49]="KEY_S",n[n.KEY_T=50]="KEY_T",n[n.KEY_U=51]="KEY_U",n[n.KEY_V=52]="KEY_V",n[n.KEY_W=53]="KEY_W",n[n.KEY_X=54]="KEY_X",n[n.KEY_Y=55]="KEY_Y",n[n.KEY_Z=56]="KEY_Z",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.NumLock=78]="NumLock",n[n.ScrollLock=79]="ScrollLock",n[n.US_SEMICOLON=80]="US_SEMICOLON",n[n.US_EQUAL=81]="US_EQUAL",n[n.US_COMMA=82]="US_COMMA",n[n.US_MINUS=83]="US_MINUS",n[n.US_DOT=84]="US_DOT",n[n.US_SLASH=85]="US_SLASH",n[n.US_BACKTICK=86]="US_BACKTICK",n[n.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",n[n.US_BACKSLASH=88]="US_BACKSLASH",n[n.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",n[n.US_QUOTE=90]="US_QUOTE",n[n.OEM_8=91]="OEM_8",n[n.OEM_102=92]="OEM_102",n[n.NUMPAD_0=93]="NUMPAD_0",n[n.NUMPAD_1=94]="NUMPAD_1",n[n.NUMPAD_2=95]="NUMPAD_2",n[n.NUMPAD_3=96]="NUMPAD_3",n[n.NUMPAD_4=97]="NUMPAD_4",n[n.NUMPAD_5=98]="NUMPAD_5",n[n.NUMPAD_6=99]="NUMPAD_6",n[n.NUMPAD_7=100]="NUMPAD_7",n[n.NUMPAD_8=101]="NUMPAD_8",n[n.NUMPAD_9=102]="NUMPAD_9",n[n.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",n[n.NUMPAD_ADD=104]="NUMPAD_ADD",n[n.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",n[n.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",n[n.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",n[n.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",n[n.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",n[n.ABNT_C1=110]="ABNT_C1",n[n.ABNT_C2=111]="ABNT_C2",n[n.MAX_VALUE=112]="MAX_VALUE"})(R=t.KeyCode||(t.KeyCode={}));class C{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(i,r){this._keyCodeToStr[i]=r,this._strToKeyCode[r.toLowerCase()]=i}keyCodeToStr(i){return this._keyCodeToStr[i]}strToKeyCode(i){return this._strToKeyCode[i.toLowerCase()]||0}}const s=new C,E=new C,o=new C;(function(){function n(i,r,l=r,h=l){s.define(i,r),E.define(i,l),o.define(i,h)}n(0,"unknown"),n(1,"Backspace"),n(2,"Tab"),n(3,"Enter"),n(4,"Shift"),n(5,"Ctrl"),n(6,"Alt"),n(7,"PauseBreak"),n(8,"CapsLock"),n(9,"Escape"),n(10,"Space"),n(11,"PageUp"),n(12,"PageDown"),n(13,"End"),n(14,"Home"),n(15,"LeftArrow","Left"),n(16,"UpArrow","Up"),n(17,"RightArrow","Right"),n(18,"DownArrow","Down"),n(19,"Insert"),n(20,"Delete"),n(21,"0"),n(22,"1"),n(23,"2"),n(24,"3"),n(25,"4"),n(26,"5"),n(27,"6"),n(28,"7"),n(29,"8"),n(30,"9"),n(31,"A"),n(32,"B"),n(33,"C"),n(34,"D"),n(35,"E"),n(36,"F"),n(37,"G"),n(38,"H"),n(39,"I"),n(40,"J"),n(41,"K"),n(42,"L"),n(43,"M"),n(44,"N"),n(45,"O"),n(46,"P"),n(47,"Q"),n(48,"R"),n(49,"S"),n(50,"T"),n(51,"U"),n(52,"V"),n(53,"W"),n(54,"X"),n(55,"Y"),n(56,"Z"),n(57,"Meta"),n(58,"ContextMenu"),n(59,"F1"),n(60,"F2"),n(61,"F3"),n(62,"F4"),n(63,"F5"),n(64,"F6"),n(65,"F7"),n(66,"F8"),n(67,"F9"),n(68,"F10"),n(69,"F11"),n(70,"F12"),n(71,"F13"),n(72,"F14"),n(73,"F15"),n(74,"F16"),n(75,"F17"),n(76,"F18"),n(77,"F19"),n(78,"NumLock"),n(79,"ScrollLock"),n(80,";",";","OEM_1"),n(81,"=","=","OEM_PLUS"),n(82,",",",","OEM_COMMA"),n(83,"-","-","OEM_MINUS"),n(84,".",".","OEM_PERIOD"),n(85,"/","/","OEM_2"),n(86,"`","`","OEM_3"),n(110,"ABNT_C1"),n(111,"ABNT_C2"),n(87,"[","[","OEM_4"),n(88,"\\","\\","OEM_5"),n(89,"]","]","OEM_6"),n(90,"'","'","OEM_7"),n(91,"OEM_8"),n(92,"OEM_102"),n(93,"NumPad0"),n(94,"NumPad1"),n(95,"NumPad2"),n(96,"NumPad3"),n(97,"NumPad4"),n(98,"NumPad5"),n(99,"NumPad6"),n(100,"NumPad7"),n(101,"NumPad8"),n(102,"NumPad9"),n(103,"NumPad_Multiply"),n(104,"NumPad_Add"),n(105,"NumPad_Separator"),n(106,"NumPad_Subtract"),n(107,"NumPad_Decimal"),n(108,"NumPad_Divide")})();var u;(function(n){function i(a){return s.keyCodeToStr(a)}n.toString=i;function r(a){return s.strToKeyCode(a)}n.fromString=r;function l(a){return E.keyCodeToStr(a)}n.toUserSettingsUS=l;function h(a){return o.keyCodeToStr(a)}n.toUserSettingsGeneral=h;function _(a){return E.strToKeyCode(a)||o.strToKeyCode(a)}n.fromUserSettings=_})(u=t.KeyCodeUtils||(t.KeyCodeUtils={}));var c;(function(n){n[n.CtrlCmd=2048]="CtrlCmd",n[n.Shift=1024]="Shift",n[n.Alt=512]="Alt",n[n.WinCtrl=256]="WinCtrl",n[n.KeyCode=255]="KeyCode"})(c||(c={}));var v;(function(n){n[n.CtrlCmd=2048]="CtrlCmd",n[n.Shift=1024]="Shift",n[n.Alt=512]="Alt",n[n.WinCtrl=256]="WinCtrl"})(v=t.KeyMod||(t.KeyMod={}));function w(n,i){const r=(i&65535)<<16>>>0;return(n|r)>>>0}t.KeyChord=w;function g(n,i){if(n===0)return null;const r=(n&65535)>>>0,l=(n&4294901760)>>>16;return l!==0?new L([f(r,i),f(l,i)]):new L([f(r,i)])}t.createKeybinding=g;function f(n,i){const r=!!(n&2048),l=!!(n&256),h=i===2?l:r,_=!!(n&1024),a=!!(n&512),d=i===2?r:l,N=n&255;return new m(h,_,a,d,N)}t.createSimpleKeybinding=f;class m{constructor(i,r,l,h,_){this.ctrlKey=i,this.shiftKey=r,this.altKey=l,this.metaKey=h,this.keyCode=_}equals(i){return this.ctrlKey===i.ctrlKey&&this.shiftKey===i.shiftKey&&this.altKey===i.altKey&&this.metaKey===i.metaKey&&this.keyCode===i.keyCode}getHashCode(){const i=this.ctrlKey?"1":"0",r=this.shiftKey?"1":"0",l=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`${i}${r}${l}${h}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new L([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=m;class L{constructor(i){if(i.length===0)throw(0,P.illegalArgument)("parts");this.parts=i}getHashCode(){let i="";for(let r=0,l=this.parts.length;r<l;r++)r!==0&&(i+=";"),i+=this.parts[r].getHashCode();return i}equals(i){if(i===null||this.parts.length!==i.parts.length)return!1;for(let r=0;r<this.parts.length;r++)if(!this.parts[r].equals(i.parts[r]))return!1;return!0}}t.ChordKeybinding=L;class A{constructor(i,r,l,h,_,a){this.ctrlKey=i,this.shiftKey=r,this.altKey=l,this.metaKey=h,this.keyLabel=_,this.keyAriaLabel=a}}t.ResolvedKeybindingPart=A;class S{}t.ResolvedKeybinding=S}),j($[8],V([0,1,7,16]),function(F,t,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.MultiDisposeError=t.markAsSingleton=t.setDisposableTracker=void 0;const C=!1;let s=null;function E(a){s=a}if(t.setDisposableTracker=E,C){const a="__is_disposable_tracked__";E(new class{trackDisposable(d){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{d[a]||console.log(N)},3e3)}setParent(d,N){if(d&&d!==n.None)try{d[a]=!0}catch{}}markAsDisposed(d){if(d&&d!==n.None)try{d[a]=!0}catch{}}markAsSingleton(d){}})}function o(a){return s?.trackDisposable(a),a}function u(a){s?.markAsDisposed(a)}function c(a,d){s?.setParent(a,d)}function v(a,d){if(!!s)for(const N of a)s.setParent(N,d)}function w(a){return s?.markAsSingleton(a),a}t.markAsSingleton=w;class g extends Error{constructor(d){super(`Encountered errors while disposing of store. Errors: [${d.join(", ")}]`);this.errors=d}}t.MultiDisposeError=g;function f(a){return typeof a.dispose=="function"&&a.dispose.length===0}t.isDisposable=f;function m(a){if(R.Iterable.is(a)){let d=[];for(const N of a)if(N)try{N.dispose()}catch(M){d.push(M)}if(d.length===1)throw d[0];if(d.length>1)throw new g(d);return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}t.dispose=m;function L(...a){const d=A(()=>m(a));return v(a,d),d}t.combinedDisposable=L;function A(a){const d=o({dispose:(0,P.once)(()=>{u(d),a()})});return d}t.toDisposable=A;class S{constructor(){this._toDispose=new Set,this._isDisposed=!1,o(this)}dispose(){this._isDisposed||(u(this),this._isDisposed=!0,this.clear())}clear(){try{m(this._toDispose.values())}finally{this._toDispose.clear()}}add(d){if(!d)return d;if(d===this)throw new Error("Cannot register a disposable on itself!");return c(d,this),this._isDisposed?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(d),d}}t.DisposableStore=S,S.DISABLE_DISPOSED_WARNING=!1;class n{constructor(){this._store=new S,o(this),c(this._store,this)}dispose(){u(this),this._store.dispose()}_register(d){if(d===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(d)}}t.Disposable=n,n.None=Object.freeze({dispose(){}});class i{constructor(){this._isDisposed=!1,o(this)}get value(){return this._isDisposed?void 0:this._value}set value(d){this._isDisposed||d===this._value||(this._value?.dispose(),d&&c(d,this),this._value=d)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,u(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const d=this._value;return this._value=void 0,d&&c(d,null),d}}t.MutableDisposable=i;class r{constructor(d){this._disposable=d,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}t.RefCountedDisposable=r;class l{constructor(){this.references=new Map}acquire(d,...N){let M=this.references.get(d);M||(M={counter:0,object:this.createReferencedObject(d,...N)},this.references.set(d,M));const{object:D}=M,p=(0,P.once)(()=>{--M.counter==0&&(this.destroyReferencedObject(d,M.object),this.references.delete(d))});return M.counter++,{object:D,dispose:p}}}t.ReferenceCollection=l;class h{constructor(d){this.referenceCollection=d}async acquire(d,...N){const M=this.referenceCollection.acquire(d,...N);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(D){throw M.dispose(),D}}}t.AsyncReferenceCollection=h;class _{constructor(d){this.object=d}dispose(){}}t.ImmortalReference=_}),j($[18],V([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class P{constructor(s){this.element=s,this.next=P.Undefined,this.prev=P.Undefined}}P.Undefined=new P(void 0);class R{constructor(){this._first=P.Undefined,this._last=P.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===P.Undefined}clear(){let s=this._first;for(;s!==P.Undefined;){const E=s.next;s.prev=P.Undefined,s.next=P.Undefined,s=E}this._first=P.Undefined,this._last=P.Undefined,this._size=0}unshift(s){return this._insert(s,!1)}push(s){return this._insert(s,!0)}_insert(s,E){const o=new P(s);if(this._first===P.Undefined)this._first=o,this._last=o;else if(E){const c=this._last;this._last=o,o.prev=c,c.next=o}else{const c=this._first;this._first=o,o.next=c,c.prev=o}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(o))}}shift(){if(this._first!==P.Undefined){const s=this._first.element;return this._remove(this._first),s}}pop(){if(this._last!==P.Undefined){const s=this._last.element;return this._remove(this._last),s}}_remove(s){if(s.prev!==P.Undefined&&s.next!==P.Undefined){const E=s.prev;E.next=s.next,s.next.prev=E}else s.prev===P.Undefined&&s.next===P.Undefined?(this._first=P.Undefined,this._last=P.Undefined):s.next===P.Undefined?(this._last=this._last.prev,this._last.next=P.Undefined):s.prev===P.Undefined&&(this._first=this._first.next,this._first.prev=P.Undefined);this._size-=1}*[Symbol.iterator](){let s=this._first;for(;s!==P.Undefined;)yield s.element,s=s.next}}t.LinkedList=R}),j($[2],V([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isLittleEndian=t.OS=t.OperatingSystem=t.setImmediate=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isIOS=t.isWeb=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.isElectronSandboxed=t.globals=void 0;const P="en";let R=!1,C=!1,s=!1,E=!1,o=!1,u=!1,c=!1,v,w=P,g,f;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.process!="undefined"?m=t.globals.vscode.process:typeof process!="undefined"&&(m=process);const L=typeof m?.versions?.electron=="string"&&m.type==="renderer";if(t.isElectronSandboxed=L&&m?.sandboxed,typeof navigator=="object"&&!L)f=navigator.userAgent,R=f.indexOf("Windows")>=0,C=f.indexOf("Macintosh")>=0,c=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,s=f.indexOf("Linux")>=0,u=!0,v=navigator.language,w=v;else if(typeof m=="object"){R=m.platform==="win32",C=m.platform==="darwin",s=m.platform==="linux",E=s&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,v=P,w=P;const a=m.env.VSCODE_NLS_CONFIG;if(a)try{const d=JSON.parse(a),N=d.availableLanguages["*"];v=d.locale,w=N||P,g=d._translationsConfigFile}catch(d){}o=!0}else console.error("Unable to resolve platform.");var A;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(A=t.Platform||(t.Platform={}));function S(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=S;let n=0;C?n=1:R?n=3:s&&(n=2),t.isWindows=R,t.isMacintosh=C,t.isLinux=s,t.isLinuxSnap=E,t.isNative=o,t.isWeb=u,t.isIOS=c,t.platform=n,t.userAgent=f,t.language=w;var i;(function(a){function d(){return t.language}a.value=d;function N(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}a.isDefaultVariant=N;function M(){return t.language==="en"}a.isDefault=M})(i=t.Language||(t.Language={})),t.locale=v,t.translationsConfigFile=g,t.setImmediate=function(){if(t.globals.setImmediate)return t.globals.setImmediate.bind(t.globals);if(typeof t.globals.postMessage=="function"&&!t.globals.importScripts){let N=[];t.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeSetImmediateId)for(let p=0,U=N.length;p<U;p++){const k=N[p];if(k.id===D.data.vscodeSetImmediateId){N.splice(p,1),k.callback();return}}});let M=0;return D=>{const p=++M;N.push({id:p,callback:D}),t.globals.postMessage({vscodeSetImmediateId:p},"*")}}if(typeof m?.nextTick=="function")return m.nextTick.bind(m);const d=Promise.resolve();return N=>d.then(N)}();var r;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(r=t.OperatingSystem||(t.OperatingSystem={})),t.OS=C||c?2:R?1:3;let l=!0,h=!1;function _(){if(!h){h=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,l=new Uint16Array(a.buffer)[0]===(2<<8)+1}return l}t.isLittleEndian=_}),j($[19],V([0,1,2]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.nextTick=t.platform=t.env=t.cwd=void 0;let R;if(typeof P.globals.vscode!="undefined"&&typeof P.globals.vscode.process!="undefined"){const C=P.globals.vscode.process;R={get platform(){return C.platform},get arch(){return C.arch},get env(){return C.env},cwd(){return C.cwd()},nextTick(s){return(0,P.setImmediate)(s)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(C){return process.nextTick(C)}}:R={get platform(){return P.isWindows?"win32":P.isMacintosh?"darwin":"linux"},get arch(){},nextTick(C){return(0,P.setImmediate)(C)},get env(){return{}},cwd(){return"/"}};t.cwd=R.cwd,t.env=R.env,t.platform=R.platform,t.nextTick=R.nextTick,t.arch=R.arch}),j($[20],V([0,1,19]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const R=65,C=97,s=90,E=122,o=46,u=47,c=92,v=58,w=63;class g extends Error{constructor(r,l,h){let _;typeof l=="string"&&l.indexOf("not ")===0?(_="must not be",l=l.replace(/^not /,"")):_="must be";const a=r.indexOf(".")!==-1?"property":"argument";let d=`The "${r}" ${a} ${_} of type ${l}`;d+=`. Received type ${typeof h}`,super(d),this.code="ERR_INVALID_ARG_TYPE"}}function f(i,r){if(typeof i!="string")throw new g(r,"string",i)}function m(i){return i===u||i===c}function L(i){return i===u}function A(i){return i>=R&&i<=s||i>=C&&i<=E}function S(i,r,l,h){let _="",a=0,d=-1,N=0,M=0;for(let D=0;D<=i.length;++D){if(D<i.length)M=i.charCodeAt(D);else{if(h(M))break;M=u}if(h(M)){if(!(d===D-1||N===1))if(N===2){if(_.length<2||a!==2||_.charCodeAt(_.length-1)!==o||_.charCodeAt(_.length-2)!==o){if(_.length>2){const p=_.lastIndexOf(l);p===-1?(_="",a=0):(_=_.slice(0,p),a=_.length-1-_.lastIndexOf(l)),d=D,N=0;continue}else if(_.length!==0){_="",a=0,d=D,N=0;continue}}r&&(_+=_.length>0?`${l}..`:"..",a=2)}else _.length>0?_+=`${l}${i.slice(d+1,D)}`:_=i.slice(d+1,D),a=D-d-1;d=D,N=0}else M===o&&N!==-1?++N:N=-1}return _}function n(i,r){if(r===null||typeof r!="object")throw new g("pathObject","Object",r);const l=r.dir||r.root,h=r.base||`${r.name||""}${r.ext||""}`;return l?l===r.root?`${l}${h}`:`${l}${i}${h}`:h}t.win32={resolve(...i){let r="",l="",h=!1;for(let _=i.length-1;_>=-1;_--){let a;if(_>=0){if(a=i[_],f(a,"path"),a.length===0)continue}else r.length===0?a=P.cwd():(a=P.env[`=${r}`]||P.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==r.toLowerCase()&&a.charCodeAt(2)===c)&&(a=`${r}\\`));const d=a.length;let N=0,M="",D=!1;const p=a.charCodeAt(0);if(d===1)m(p)&&(N=1,D=!0);else if(m(p))if(D=!0,m(a.charCodeAt(1))){let U=2,k=U;for(;U<d&&!m(a.charCodeAt(U));)U++;if(U<d&&U!==k){const W=a.slice(k,U);for(k=U;U<d&&m(a.charCodeAt(U));)U++;if(U<d&&U!==k){for(k=U;U<d&&!m(a.charCodeAt(U));)U++;(U===d||U!==k)&&(M=`\\\\${W}\\${a.slice(k,U)}`,N=U)}}}else N=1;else A(p)&&a.charCodeAt(1)===v&&(M=a.slice(0,2),N=2,d>2&&m(a.charCodeAt(2))&&(D=!0,N=3));if(M.length>0)if(r.length>0){if(M.toLowerCase()!==r.toLowerCase())continue}else r=M;if(h){if(r.length>0)break}else if(l=`${a.slice(N)}\\${l}`,h=D,D&&r.length>0)break}return l=S(l,!h,"\\",m),h?`${r}\\${l}`:`${r}${l}`||"."},normalize(i){f(i,"path");const r=i.length;if(r===0)return".";let l=0,h,_=!1;const a=i.charCodeAt(0);if(r===1)return L(a)?"\\":i;if(m(a))if(_=!0,m(i.charCodeAt(1))){let N=2,M=N;for(;N<r&&!m(i.charCodeAt(N));)N++;if(N<r&&N!==M){const D=i.slice(M,N);for(M=N;N<r&&m(i.charCodeAt(N));)N++;if(N<r&&N!==M){for(M=N;N<r&&!m(i.charCodeAt(N));)N++;if(N===r)return`\\\\${D}\\${i.slice(M)}\\`;N!==M&&(h=`\\\\${D}\\${i.slice(M,N)}`,l=N)}}}else l=1;else A(a)&&i.charCodeAt(1)===v&&(h=i.slice(0,2),l=2,r>2&&m(i.charCodeAt(2))&&(_=!0,l=3));let d=l<r?S(i.slice(l),!_,"\\",m):"";return d.length===0&&!_&&(d="."),d.length>0&&m(i.charCodeAt(r-1))&&(d+="\\"),h===void 0?_?`\\${d}`:d:_?`${h}\\${d}`:`${h}${d}`},isAbsolute(i){f(i,"path");const r=i.length;if(r===0)return!1;const l=i.charCodeAt(0);return m(l)||r>2&&A(l)&&i.charCodeAt(1)===v&&m(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let r,l;for(let a=0;a<i.length;++a){const d=i[a];f(d,"path"),d.length>0&&(r===void 0?r=l=d:r+=`\\${d}`)}if(r===void 0)return".";let h=!0,_=0;if(typeof l=="string"&&m(l.charCodeAt(0))){++_;const a=l.length;a>1&&m(l.charCodeAt(1))&&(++_,a>2&&(m(l.charCodeAt(2))?++_:h=!1))}if(h){for(;_<r.length&&m(r.charCodeAt(_));)_++;_>=2&&(r=`\\${r.slice(_)}`)}return t.win32.normalize(r)},relative(i,r){if(f(i,"from"),f(r,"to"),i===r)return"";const l=t.win32.resolve(i),h=t.win32.resolve(r);if(l===h||(i=l.toLowerCase(),r=h.toLowerCase(),i===r))return"";let _=0;for(;_<i.length&&i.charCodeAt(_)===c;)_++;let a=i.length;for(;a-1>_&&i.charCodeAt(a-1)===c;)a--;const d=a-_;let N=0;for(;N<r.length&&r.charCodeAt(N)===c;)N++;let M=r.length;for(;M-1>N&&r.charCodeAt(M-1)===c;)M--;const D=M-N,p=d<D?d:D;let U=-1,k=0;for(;k<p;k++){const Y=i.charCodeAt(_+k);if(Y!==r.charCodeAt(N+k))break;Y===c&&(U=k)}if(k!==p){if(U===-1)return h}else{if(D>p){if(r.charCodeAt(N+k)===c)return h.slice(N+k+1);if(k===2)return h.slice(N+k)}d>p&&(i.charCodeAt(_+k)===c?U=k:k===2&&(U=3)),U===-1&&(U=0)}let W="";for(k=_+U+1;k<=a;++k)(k===a||i.charCodeAt(k)===c)&&(W+=W.length===0?"..":"\\..");return N+=U,W.length>0?`${W}${h.slice(N,M)}`:(h.charCodeAt(N)===c&&++N,h.slice(N,M))},toNamespacedPath(i){if(typeof i!="string")return i;if(i.length===0)return"";const r=t.win32.resolve(i);if(r.length<=2)return i;if(r.charCodeAt(0)===c){if(r.charCodeAt(1)===c){const l=r.charCodeAt(2);if(l!==w&&l!==o)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(A(r.charCodeAt(0))&&r.charCodeAt(1)===v&&r.charCodeAt(2)===c)return`\\\\?\\${r}`;return i},dirname(i){f(i,"path");const r=i.length;if(r===0)return".";let l=-1,h=0;const _=i.charCodeAt(0);if(r===1)return m(_)?i:".";if(m(_)){if(l=h=1,m(i.charCodeAt(1))){let N=2,M=N;for(;N<r&&!m(i.charCodeAt(N));)N++;if(N<r&&N!==M){for(M=N;N<r&&m(i.charCodeAt(N));)N++;if(N<r&&N!==M){for(M=N;N<r&&!m(i.charCodeAt(N));)N++;if(N===r)return i;N!==M&&(l=h=N+1)}}}}else A(_)&&i.charCodeAt(1)===v&&(l=r>2&&m(i.charCodeAt(2))?3:2,h=l);let a=-1,d=!0;for(let N=r-1;N>=h;--N)if(m(i.charCodeAt(N))){if(!d){a=N;break}}else d=!1;if(a===-1){if(l===-1)return".";a=l}return i.slice(0,a)},basename(i,r){r!==void 0&&f(r,"ext"),f(i,"path");let l=0,h=-1,_=!0,a;if(i.length>=2&&A(i.charCodeAt(0))&&i.charCodeAt(1)===v&&(l=2),r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let d=r.length-1,N=-1;for(a=i.length-1;a>=l;--a){const M=i.charCodeAt(a);if(m(M)){if(!_){l=a+1;break}}else N===-1&&(_=!1,N=a+1),d>=0&&(M===r.charCodeAt(d)?--d==-1&&(h=a):(d=-1,h=N))}return l===h?h=N:h===-1&&(h=i.length),i.slice(l,h)}for(a=i.length-1;a>=l;--a)if(m(i.charCodeAt(a))){if(!_){l=a+1;break}}else h===-1&&(_=!1,h=a+1);return h===-1?"":i.slice(l,h)},extname(i){f(i,"path");let r=0,l=-1,h=0,_=-1,a=!0,d=0;i.length>=2&&i.charCodeAt(1)===v&&A(i.charCodeAt(0))&&(r=h=2);for(let N=i.length-1;N>=r;--N){const M=i.charCodeAt(N);if(m(M)){if(!a){h=N+1;break}continue}_===-1&&(a=!1,_=N+1),M===o?l===-1?l=N:d!==1&&(d=1):l!==-1&&(d=-1)}return l===-1||_===-1||d===0||d===1&&l===_-1&&l===h+1?"":i.slice(l,_)},format:n.bind(null,"\\"),parse(i){f(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const l=i.length;let h=0,_=i.charCodeAt(0);if(l===1)return m(_)?(r.root=r.dir=i,r):(r.base=r.name=i,r);if(m(_)){if(h=1,m(i.charCodeAt(1))){let U=2,k=U;for(;U<l&&!m(i.charCodeAt(U));)U++;if(U<l&&U!==k){for(k=U;U<l&&m(i.charCodeAt(U));)U++;if(U<l&&U!==k){for(k=U;U<l&&!m(i.charCodeAt(U));)U++;U===l?h=U:U!==k&&(h=U+1)}}}}else if(A(_)&&i.charCodeAt(1)===v){if(l<=2)return r.root=r.dir=i,r;if(h=2,m(i.charCodeAt(2))){if(l===3)return r.root=r.dir=i,r;h=3}}h>0&&(r.root=i.slice(0,h));let a=-1,d=h,N=-1,M=!0,D=i.length-1,p=0;for(;D>=h;--D){if(_=i.charCodeAt(D),m(_)){if(!M){d=D+1;break}continue}N===-1&&(M=!1,N=D+1),_===o?a===-1?a=D:p!==1&&(p=1):a!==-1&&(p=-1)}return N!==-1&&(a===-1||p===0||p===1&&a===N-1&&a===d+1?r.base=r.name=i.slice(d,N):(r.name=i.slice(d,a),r.base=i.slice(d,N),r.ext=i.slice(a,N))),d>0&&d!==h?r.dir=i.slice(0,d-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...i){let r="",l=!1;for(let h=i.length-1;h>=-1&&!l;h--){const _=h>=0?i[h]:P.cwd();f(_,"path"),_.length!==0&&(r=`${_}/${r}`,l=_.charCodeAt(0)===u)}return r=S(r,!l,"/",L),l?`/${r}`:r.length>0?r:"."},normalize(i){if(f(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===u,l=i.charCodeAt(i.length-1)===u;return i=S(i,!r,"/",L),i.length===0?r?"/":l?"./":".":(l&&(i+="/"),r?`/${i}`:i)},isAbsolute(i){return f(i,"path"),i.length>0&&i.charCodeAt(0)===u},join(...i){if(i.length===0)return".";let r;for(let l=0;l<i.length;++l){const h=i[l];f(h,"path"),h.length>0&&(r===void 0?r=h:r+=`/${h}`)}return r===void 0?".":t.posix.normalize(r)},relative(i,r){if(f(i,"from"),f(r,"to"),i===r||(i=t.posix.resolve(i),r=t.posix.resolve(r),i===r))return"";const l=1,h=i.length,_=h-l,a=1,d=r.length-a,N=_<d?_:d;let M=-1,D=0;for(;D<N;D++){const U=i.charCodeAt(l+D);if(U!==r.charCodeAt(a+D))break;U===u&&(M=D)}if(D===N)if(d>N){if(r.charCodeAt(a+D)===u)return r.slice(a+D+1);if(D===0)return r.slice(a+D)}else _>N&&(i.charCodeAt(l+D)===u?M=D:D===0&&(M=0));let p="";for(D=l+M+1;D<=h;++D)(D===h||i.charCodeAt(D)===u)&&(p+=p.length===0?"..":"/..");return`${p}${r.slice(a+M)}`},toNamespacedPath(i){return i},dirname(i){if(f(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===u;let l=-1,h=!0;for(let _=i.length-1;_>=1;--_)if(i.charCodeAt(_)===u){if(!h){l=_;break}}else h=!1;return l===-1?r?"/":".":r&&l===1?"//":i.slice(0,l)},basename(i,r){r!==void 0&&f(r,"ext"),f(i,"path");let l=0,h=-1,_=!0,a;if(r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let d=r.length-1,N=-1;for(a=i.length-1;a>=0;--a){const M=i.charCodeAt(a);if(M===u){if(!_){l=a+1;break}}else N===-1&&(_=!1,N=a+1),d>=0&&(M===r.charCodeAt(d)?--d==-1&&(h=a):(d=-1,h=N))}return l===h?h=N:h===-1&&(h=i.length),i.slice(l,h)}for(a=i.length-1;a>=0;--a)if(i.charCodeAt(a)===u){if(!_){l=a+1;break}}else h===-1&&(_=!1,h=a+1);return h===-1?"":i.slice(l,h)},extname(i){f(i,"path");let r=-1,l=0,h=-1,_=!0,a=0;for(let d=i.length-1;d>=0;--d){const N=i.charCodeAt(d);if(N===u){if(!_){l=d+1;break}continue}h===-1&&(_=!1,h=d+1),N===o?r===-1?r=d:a!==1&&(a=1):r!==-1&&(a=-1)}return r===-1||h===-1||a===0||a===1&&r===h-1&&r===l+1?"":i.slice(r,h)},format:n.bind(null,"/"),parse(i){f(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const l=i.charCodeAt(0)===u;let h;l?(r.root="/",h=1):h=0;let _=-1,a=0,d=-1,N=!0,M=i.length-1,D=0;for(;M>=h;--M){const p=i.charCodeAt(M);if(p===u){if(!N){a=M+1;break}continue}d===-1&&(N=!1,d=M+1),p===o?_===-1?_=M:D!==1&&(D=1):_!==-1&&(D=-1)}if(d!==-1){const p=a===0&&l?1:a;_===-1||D===0||D===1&&_===d-1&&_===a+1?r.base=r.name=i.slice(p,d):(r.name=i.slice(p,_),r.base=i.slice(p,d),r.ext=i.slice(_,d))}return a>0?r.dir=i.slice(0,a-1):l&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=P.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=P.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=P.platform==="win32"?t.win32.join:t.posix.join,t.resolve=P.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=P.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=P.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=P.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=P.platform==="win32"?t.win32.extname:t.posix.extname,t.format=P.platform==="win32"?t.win32.format:t.posix.format,t.parse=P.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=P.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=P.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=P.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),j($[9],V([0,1,2]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const R=P.globals.performance&&typeof P.globals.performance.now=="function";class C{constructor(E){this._highResolution=R&&E,this._startTime=this._now(),this._stopTime=-1}static create(E=!0){return new C(E)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?P.globals.performance.now():Date.now()}}t.StopWatch=C}),j($[10],V([0,1,4,7,8,18,9]),function(F,t,P,R,C,s,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.Emitter=t.setGlobalLeakWarningThreshold=t.Event=void 0;var o;(function(i){i.None=()=>C.Disposable.None;function r(e){return(O,y=null,B)=>{let G=!1,X;return X=e(x=>{if(!G)return X?X.dispose():G=!0,O.call(y,x)},null,B),G&&X.dispose(),X}}i.once=r;function l(e,O){return M((y,B=null,G)=>e(X=>y.call(B,O(X)),null,G))}i.map=l;function h(e,O){return M((y,B=null,G)=>e(X=>{O(X),y.call(B,X)},null,G))}i.forEach=h;function _(e,O){return M((y,B=null,G)=>e(X=>O(X)&&y.call(B,X),null,G))}i.filter=_;function a(e){return e}i.signal=a;function d(...e){return(O,y=null,B)=>(0,C.combinedDisposable)(...e.map(G=>G(X=>O.call(y,X),null,B)))}i.any=d;function N(e,O,y){let B=y;return l(e,G=>(B=O(B,G),B))}i.reduce=N;function M(e){let O;const y=new g({onFirstListenerAdd(){O=e(y.fire,y)},onLastListenerRemove(){O.dispose()}});return y.event}function D(e,O,y=100,B=!1,G){let X,x,te,ue=0;const ae=new g({leakWarningThreshold:G,onFirstListenerAdd(){X=e(fe=>{ue++,x=O(x,fe),B&&!te&&(ae.fire(x),x=void 0),clearTimeout(te),te=setTimeout(()=>{const he=x;x=void 0,te=void 0,(!B||ue>1)&&ae.fire(he),ue=0},y)})},onLastListenerRemove(){X.dispose()}});return ae.event}i.debounce=D;function p(e,O=(y,B)=>y===B){let y=!0,B;return _(e,G=>{const X=y||!O(G,B);return y=!1,B=G,X})}i.latch=p;function U(e,O){return[i.filter(e,O),i.filter(e,y=>!O(y))]}i.split=U;function k(e,O=!1,y=[]){let B=y.slice(),G=e(te=>{B?B.push(te):x.fire(te)});const X=()=>{B&&B.forEach(te=>x.fire(te)),B=null},x=new g({onFirstListenerAdd(){G||(G=e(te=>x.fire(te)))},onFirstListenerDidAdd(){B&&(O?setTimeout(X):X())},onLastListenerRemove(){G&&G.dispose(),G=null}});return x.event}i.buffer=k;class W{constructor(O){this.event=O}map(O){return new W(l(this.event,O))}forEach(O){return new W(h(this.event,O))}filter(O){return new W(_(this.event,O))}reduce(O,y){return new W(N(this.event,O,y))}latch(){return new W(p(this.event))}debounce(O,y=100,B=!1,G){return new W(D(this.event,O,y,B,G))}on(O,y,B){return this.event(O,y,B)}once(O,y,B){return r(this.event)(O,y,B)}}function Y(e){return new W(e)}i.chain=Y;function Z(e,O,y=B=>B){const B=(...te)=>x.fire(y(...te)),G=()=>e.on(O,B),X=()=>e.removeListener(O,B),x=new g({onFirstListenerAdd:G,onLastListenerRemove:X});return x.event}i.fromNodeEventEmitter=Z;function z(e,O,y=B=>B){const B=(...te)=>x.fire(y(...te)),G=()=>e.addEventListener(O,B),X=()=>e.removeEventListener(O,B),x=new g({onFirstListenerAdd:G,onLastListenerRemove:X});return x.event}i.fromDOMEventEmitter=z;function J(e){return new Promise(O=>r(e)(O))}i.toPromise=J})(o=t.Event||(t.Event={}));class u{constructor(r){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${r}_${u._idPool++}`}start(r){this._stopWatch=new E.StopWatch(!0),this._listenerCount=r}stop(){if(this._stopWatch){const r=this._stopWatch.elapsed();this._elapsedOverall+=r,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${r.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}u._idPool=0;let c=-1;function v(i){const r=c;return c=i,{dispose(){c=r}}}t.setGlobalLeakWarningThreshold=v;class w{constructor(r,l=Math.random().toString(18).slice(2,5)){this.customThreshold=r,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(r){let l=c;if(typeof this.customThreshold=="number"&&(l=this.customThreshold),l<=0||r<l)return;this._stacks||(this._stacks=new Map);const h=new Error().stack.split(`
`).slice(3).join(`
`),_=this._stacks.get(h)||0;if(this._stacks.set(h,_+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=l*.5;let a,d=0;for(const[N,M]of this._stacks)(!a||d<M)&&(a=N,d=M);console.warn(`[${this.name}] potential listener LEAK detected, having ${r} listeners already. MOST frequent listener (${d}):`),console.warn(a)}return()=>{const a=this._stacks.get(h)||0;this._stacks.set(h,a-1)}}}class g{constructor(r){this._disposed=!1,this._options=r,this._leakageMon=c>0?new w(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new u(this._options._profName):void 0}get event(){return this._event||(this._event=(r,l,h)=>{this._listeners||(this._listeners=new s.LinkedList);const _=this._listeners.isEmpty();_&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const a=this._listeners.push(l?[r,l]:r);_&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,r,l);const d=this._leakageMon?.check(this._listeners.size),N=(0,C.toDisposable)(()=>{d&&d(),this._disposed||(a(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return h instanceof C.DisposableStore?h.add(N):Array.isArray(h)&&h.push(N),N}),this._event}fire(r){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new s.LinkedList);for(let l of this._listeners)this._deliveryQueue.push([l,r]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[l,h]=this._deliveryQueue.shift();try{typeof l=="function"?l.call(void 0,h):l[0].call(l[1],h)}catch(_){(0,P.onUnexpectedError)(_)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}t.Emitter=g;class f extends g{async fireAsync(r,l,h){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new s.LinkedList);for(const _ of this._listeners)this._asyncDeliveryQueue.push([_,r]);for(;this._asyncDeliveryQueue.size>0&&!l.isCancellationRequested;){const[_,a]=this._asyncDeliveryQueue.shift(),d=[],N={...a,waitUntil:M=>{if(Object.isFrozen(d))throw new Error("waitUntil can NOT be called asynchronous");h&&(M=h(M,typeof _=="function"?_:_[0])),d.push(M)}};try{typeof _=="function"?_.call(void 0,N):_[0].call(_[1],N)}catch(M){(0,P.onUnexpectedError)(M);continue}Object.freeze(d),await Promise.allSettled(d).then(M=>{for(const D of M)D.status==="rejected"&&(0,P.onUnexpectedError)(D.reason)})}}}}t.AsyncEmitter=f;class m extends g{constructor(r){super(r);this._isPaused=0,this._eventQueue=new s.LinkedList,this._mergeFn=r?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const r=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(r))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(r){this._listeners&&(this._isPaused!==0?this._eventQueue.push(r):super.fire(r))}}t.PauseableEmitter=m;class L extends m{constructor(r){super(r);this._delay=r.delay??100}fire(r){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(r)}}t.DebounceEmitter=L;class A{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(r){const l={event:r,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const h=()=>{this.hasListeners&&this.unhook(l);const _=this.events.indexOf(l);this.events.splice(_,1)};return(0,C.toDisposable)((0,R.once)(h))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(r=>this.hook(r))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(r=>this.unhook(r))}hook(r){r.listener=r.event(l=>this.emitter.fire(l))}unhook(r){r.listener&&r.listener.dispose(),r.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=A;class S{constructor(){this.buffers=[]}wrapEvent(r){return(l,h,_)=>r(a=>{const d=this.buffers[this.buffers.length-1];d?d.push(()=>l.call(h,a)):l.call(h,a)},void 0,_)}bufferEvents(r){const l=[];this.buffers.push(l);const h=r();return this.buffers.pop(),l.forEach(_=>_()),h}}t.EventBufferer=S;class n{constructor(){this.listening=!1,this.inputEvent=o.None,this.inputEventListener=C.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(r){this.inputEvent=r,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=r(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=n}),j($[21],V([0,1,10]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const R=Object.freeze(function(o,u){const c=setTimeout(o.bind(u),0);return{dispose(){clearTimeout(c)}}});var C;(function(o){function u(c){return c===o.None||c===o.Cancelled||c instanceof s?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}o.isCancellationToken=u,o.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),o.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(C=t.CancellationToken||(t.CancellationToken={}));class s{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new P.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new s),this._token}cancel(){this._token?this._token instanceof s&&this._token.cancel():this._token=C.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof s&&this._token.dispose():this._token=C.None}}t.CancellationTokenSource=E}),j($[5],V([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLeftDeleteOffset=t.GraphemeBreakType=t.breakBetweenGraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsEmoji=t.containsRTL=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function P(b){return!b||typeof b!="string"?!0:b.trim().length===0}t.isFalsyOrWhitespace=P;const R=/{(\d+)}/g;function C(b,...I){return I.length===0?b:b.replace(R,function(T,q){const H=parseInt(q,10);return isNaN(H)||H<0||H>=I.length?T:I[H]})}t.format=C;const s=/{([^}]+)}/g;function E(b,I){return b.replace(s,(T,q)=>I[q]??T)}t.format2=E;function o(b){return b.replace(/[<>&]/g,function(I){switch(I){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return I}})}t.escape=o;function u(b){return b.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=u;function c(b,I){let T=0;const q=I.charCodeAt(0);for(let H=b.length-1;H>=0;H--)b.charCodeAt(H)===q&&T++;return T}t.count=c;function v(b,I,T="\u2026"){return b.length<=I?b:`${b.substr(0,I)}${T}`}t.truncate=v;function w(b,I=" "){const T=g(b,I);return f(T,I)}t.trim=w;function g(b,I){if(!b||!I)return b;const T=I.length;if(T===0||b.length===0)return b;let q=0;for(;b.indexOf(I,q)===q;)q=q+T;return b.substring(q)}t.ltrim=g;function f(b,I){if(!b||!I)return b;const T=I.length,q=b.length;if(T===0||q===0)return b;let H=q,Q=-1;for(;Q=b.lastIndexOf(I,H-1),!(Q===-1||Q+T!==H);){if(Q===0)return"";H=Q}return b.substring(0,H)}t.rtrim=f;function m(b){return b.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=m;function L(b){return b.replace(/\*/g,"")}t.stripWildcards=L;function A(b,I,T={}){if(!b)throw new Error("Cannot create regex from empty string");I||(b=u(b)),T.wholeWord&&(/\B/.test(b.charAt(0))||(b="\\b"+b),/\B/.test(b.charAt(b.length-1))||(b=b+"\\b"));let q="";return T.global&&(q+="g"),T.matchCase||(q+="i"),T.multiline&&(q+="m"),T.unicode&&(q+="u"),new RegExp(b,q)}t.createRegExp=A;function S(b){return b.source==="^"||b.source==="^$"||b.source==="$"||b.source==="^\\s*$"?!1:!!(b.exec("")&&b.lastIndex===0)}t.regExpLeadsToEndlessLoop=S;function n(b){return!!b.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=n;function i(b){return(b.global?"g":"")+(b.ignoreCase?"i":"")+(b.multiline?"m":"")+(b.unicode?"u":"")}t.regExpFlags=i;function r(b){return b.split(/\r\n|\r|\n/)}t.splitLines=r;function l(b){for(let I=0,T=b.length;I<T;I++){const q=b.charCodeAt(I);if(q!==32&&q!==9)return I}return-1}t.firstNonWhitespaceIndex=l;function h(b,I=0,T=b.length){for(let q=I;q<T;q++){const H=b.charCodeAt(q);if(H!==32&&H!==9)return b.substring(I,q)}return b.substring(I,T)}t.getLeadingWhitespace=h;function _(b,I=b.length-1){for(let T=I;T>=0;T--){const q=b.charCodeAt(T);if(q!==32&&q!==9)return T}return-1}t.lastNonWhitespaceIndex=_;function a(b,I){return b<I?-1:b>I?1:0}t.compare=a;function d(b,I,T=0,q=b.length,H=0,Q=I.length){for(;T<q&&H<Q;T++,H++){let re=b.charCodeAt(T),ie=I.charCodeAt(H);if(re<ie)return-1;if(re>ie)return 1}const ee=q-T,ne=Q-H;return ee<ne?-1:ee>ne?1:0}t.compareSubstring=d;function N(b,I){return M(b,I,0,b.length,0,I.length)}t.compareIgnoreCase=N;function M(b,I,T=0,q=b.length,H=0,Q=I.length){for(;T<q&&H<Q;T++,H++){let re=b.charCodeAt(T),ie=I.charCodeAt(H);if(re===ie)continue;const le=re-ie;if(!(le===32&&p(ie))&&!(le===-32&&p(re)))return D(re)&&D(ie)?le:d(b.toLowerCase(),I.toLowerCase(),T,q,H,Q)}const ee=q-T,ne=Q-H;return ee<ne?-1:ee>ne?1:0}t.compareSubstringIgnoreCase=M;function D(b){return b>=97&&b<=122}t.isLowerAsciiLetter=D;function p(b){return b>=65&&b<=90}t.isUpperAsciiLetter=p;function U(b){return D(b)||p(b)}function k(b,I){return b.length===I.length&&W(b,I)}t.equalsIgnoreCase=k;function W(b,I,T=b.length){for(let q=0;q<T;q++){const H=b.charCodeAt(q),Q=I.charCodeAt(q);if(H!==Q){if(U(H)&&U(Q)){const ee=Math.abs(H-Q);if(ee!==0&&ee!==32)return!1}else if(String.fromCharCode(H).toLowerCase()!==String.fromCharCode(Q).toLowerCase())return!1}}return!0}function Y(b,I){const T=I.length;return I.length>b.length?!1:W(b,I,T)}t.startsWithIgnoreCase=Y;function Z(b,I){let T,q=Math.min(b.length,I.length);for(T=0;T<q;T++)if(b.charCodeAt(T)!==I.charCodeAt(T))return T;return q}t.commonPrefixLength=Z;function z(b,I){let T,q=Math.min(b.length,I.length);const H=b.length-1,Q=I.length-1;for(T=0;T<q;T++)if(b.charCodeAt(H-T)!==I.charCodeAt(Q-T))return T;return q}t.commonSuffixLength=z;function J(b){return 55296<=b&&b<=56319}t.isHighSurrogate=J;function e(b){return 56320<=b&&b<=57343}t.isLowSurrogate=e;function O(b,I){return(b-55296<<10)+(I-56320)+65536}t.computeCodePoint=O;function y(b,I,T){const q=b.charCodeAt(T);if(J(q)&&T+1<I){const H=b.charCodeAt(T+1);if(e(H))return O(q,H)}return q}t.getNextCodePoint=y;function B(b,I){const T=b.charCodeAt(I-1);if(e(T)&&I>1){const q=b.charCodeAt(I-2);if(J(q))return O(q,T)}return T}function G(b,I){const T=se.getInstance(),q=I,H=b.length,Q=y(b,H,I);I+=Q>=65536?2:1;let ee=T.getGraphemeBreakType(Q);for(;I<H;){const ne=y(b,H,I),re=T.getGraphemeBreakType(ne);if(oe(ee,re))break;I+=ne>=65536?2:1,ee=re}return I-q}t.nextCharLength=G;function X(b,I){const T=se.getInstance(),q=I,H=B(b,I);I-=H>=65536?2:1;let Q=T.getGraphemeBreakType(H);for(;I>0;){const ee=B(b,I),ne=T.getGraphemeBreakType(ee);if(oe(ne,Q))break;I-=ee>=65536?2:1,Q=ne}return q-I}t.prevCharLength=X;function x(b,I){const T=se.getInstance(),q=b.length,H=I,Q=y(b,q,I),ee=T.getGraphemeBreakType(Q);I+=Q>=65536?2:1;let ne=ee;for(;I<q;){const ie=y(b,q,I),le=T.getGraphemeBreakType(ie);if(oe(ne,le))break;I+=ie>=65536?2:1,ne=le}const re=I;for(I=H,ne=ee;I>0;){const ie=B(b,I),le=T.getGraphemeBreakType(ie);if(oe(le,ne))break;I-=ie>=65536?2:1,ne=le}return[I,re]}function te(b,I){return I>0&&e(b.charCodeAt(I))?x(b,I-1):x(b,I)}t.getCharContainingOffset=te;const ue=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ae(b){return ue.test(b)}t.containsRTL=ae;const fe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function he(b){return fe.test(b)}t.containsEmoji=he;const be=/^[\t\n\r\x20-\x7E]*$/;function Ae(b){return be.test(b)}t.isBasicASCII=Ae,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ne(b){return t.UNUSUAL_LINE_TERMINATORS.test(b)}t.containsUnusualLineTerminators=Ne;function we(b){for(let I=0,T=b.length;I<T;I++)if(ge(b.charCodeAt(I)))return!0;return!1}t.containsFullWidthCharacter=we;function ge(b){return b=+b,b>=11904&&b<=55215||b>=63744&&b<=64255||b>=65281&&b<=65374}t.isFullWidthCharacter=ge;function me(b){return b>=127462&&b<=127487||b===8986||b===8987||b===9200||b===9203||b>=9728&&b<=10175||b===11088||b===11093||b>=127744&&b<=128591||b>=128640&&b<=128764||b>=128992&&b<=129003||b>=129280&&b<=129535||b>=129648&&b<=129750}t.isEmojiImprecise=me;function Ce(b,I){if(b.length<I)return b;const T=/\b/g;let q=0;for(;T.test(b)&&!(b.length-T.lastIndex<I);)q=T.lastIndex,T.lastIndex+=1;return b.substring(q).replace(/^\s/,"")}t.lcut=Ce;const Pe=/\x1B\x5B[12]?K/g,Me=/\x1b\[\d+m/g,pe=/\x1b\[0?m/g;function De(b){return b&&(b=b.replace(Pe,""),b=b.replace(Me,""),b=b.replace(pe,"")),b}t.removeAnsiEscapeCodes=De,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function _e(b){return!!(b&&b.length>0&&b.charCodeAt(0)===65279)}t.startsWithUTF8BOM=_e;function Ue(b){return _e(b)?b.substr(1):b}t.stripUTF8BOM=Ue;function Re(b,I){if(!b||!I||b.length<I.length)return!1;const T=I.length,q=b.toLowerCase();let H=0,Q=-1;for(;H<T;){const ee=q.indexOf(I[H],Q+1);if(ee<0)return!1;Q=ee,H++}return!0}t.fuzzyContains=Re;function Ie(b,I=!1){return b?(I&&(b=b.replace(/\\./g,"")),b.toLowerCase()!==b):!1}t.containsUppercaseCharacter=Ie;function Fe(b){return b.charAt(0).toUpperCase()+b.slice(1)}t.uppercaseFirstLetter=Fe;function Te(b,I=1){if(I===0)return"";let T=-1;do T=b.indexOf(`
`,T+1),I--;while(I>0&&T>=0);return T===-1?b:(b[T-1]==="\r"&&T--,b.substr(0,T))}t.getNLines=Te;function ke(b){const I=90-65+1;return b=b%(2*I),b<I?String.fromCharCode(97+b):String.fromCharCode(65+b-I)}t.singleLetterHash=ke;function ye(b){return se.getInstance().getGraphemeBreakType(b)}t.getGraphemeBreakType=ye;function oe(b,I){return b===0?I!==5&&I!==7:b===2&&I===3?!1:b===4||b===2||b===3||I===4||I===2||I===3?!0:!(b===8&&(I===8||I===9||I===11||I===12)||(b===11||b===9)&&(I===9||I===10)||(b===12||b===10)&&I===10||I===5||I===13||I===7||b===1||b===13&&I===14||b===6&&I===6)}t.breakBetweenGraphemeBreakType=oe;var We;(function(b){b[b.Other=0]="Other",b[b.Prepend=1]="Prepend",b[b.CR=2]="CR",b[b.LF=3]="LF",b[b.Control=4]="Control",b[b.Extend=5]="Extend",b[b.Regional_Indicator=6]="Regional_Indicator",b[b.SpacingMark=7]="SpacingMark",b[b.L=8]="L",b[b.V=9]="V",b[b.T=10]="T",b[b.LV=11]="LV",b[b.LVT=12]="LVT",b[b.ZWJ=13]="ZWJ",b[b.Extended_Pictographic=14]="Extended_Pictographic"})(We=t.GraphemeBreakType||(t.GraphemeBreakType={}));class se{constructor(){this._data=Oe()}static getInstance(){return se._INSTANCE||(se._INSTANCE=new se),se._INSTANCE}getGraphemeBreakType(I){if(I<32)return I===10?3:I===13?2:4;if(I<127)return 0;const T=this._data,q=T.length/3;let H=1;for(;H<=q;)if(I<T[3*H])H=2*H;else if(I>T[3*H+1])H=2*H+1;else return T[3*H+2];return 0}}se._INSTANCE=null;function Oe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function qe(b,I){if(b===0)return 0;const T=Be(b,I);if(T!==void 0)return T;const q=B(I,b);return b-=ce(q),b}t.getLeftDeleteOffset=qe;function Be(b,I){let T=B(I,b);for(b-=ce(T);He(T)||T===65039||T===8419;){if(b===0)return;T=B(I,b),b-=ce(T)}if(!!me(T)){if(b>=0){const q=B(I,b);q===8205&&(b-=ce(q))}return b}}function ce(b){return b>=65536?2:1}function He(b){return 127995<=b&&b<=127999}var ve;(function(b){b[b.zwj=8205]="zwj",b[b.emojiVariantSelector=65039]="emojiVariantSelector",b[b.enclosingKeyCap=8419]="enclosingKeyCap"})(ve||(ve={}))}),j($[22],V([0,1,5]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.doHash=t.hash=void 0;function R(S){return C(S,0)}t.hash=R;function C(S,n){switch(typeof S){case"object":return S===null?s(349,n):Array.isArray(S)?u(S,n):c(S,n);case"string":return o(S,n);case"boolean":return E(S,n);case"number":return s(S,n);case"undefined":return s(937,n);default:return s(617,n)}}t.doHash=C;function s(S,n){return(n<<5)-n+S|0}function E(S,n){return s(S?433:863,n)}function o(S,n){n=s(149417,n);for(let i=0,r=S.length;i<r;i++)n=s(S.charCodeAt(i),n);return n}t.stringHash=o;function u(S,n){return n=s(104579,n),S.reduce((i,r)=>C(r,i),n)}function c(S,n){return n=s(181387,n),Object.keys(S).sort().reduce((i,r)=>(i=o(r,i),C(S[r],i)),n)}class v{constructor(){this._value=0}get value(){return this._value}hash(n){return this._value=C(n,this._value),this._value}}t.Hasher=v;var w;(function(S){S[S.BLOCK_SIZE=64]="BLOCK_SIZE",S[S.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function g(S,n,i=32){const r=i-n,l=~((1<<r)-1);return(S<<n|(l&S)>>>r)>>>0}function f(S,n=0,i=S.byteLength,r=0){for(let l=0;l<i;l++)S[n+l]=r}function m(S,n,i="0"){for(;S.length<n;)S=i+S;return S}function L(S,n=32){return S instanceof ArrayBuffer?Array.from(new Uint8Array(S)).map(i=>i.toString(16).padStart(2,"0")).join(""):m((S>>>0).toString(16),n/4)}t.toHexString=L;class A{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(n){const i=n.length;if(i===0)return;const r=this._buff;let l=this._buffLen,h=this._leftoverHighSurrogate,_,a;for(h!==0?(_=h,a=-1,h=0):(_=n.charCodeAt(0),a=0);;){let d=_;if(P.isHighSurrogate(_))if(a+1<i){const N=n.charCodeAt(a+1);P.isLowSurrogate(N)?(a++,d=P.computeCodePoint(_,N)):d=65533}else{h=_;break}else P.isLowSurrogate(_)&&(d=65533);if(l=this._push(r,l,d),a++,a<i)_=n.charCodeAt(a);else break}this._buffLen=l,this._leftoverHighSurrogate=h}_push(n,i,r){return r<128?n[i++]=r:r<2048?(n[i++]=192|(r&1984)>>>6,n[i++]=128|(r&63)>>>0):r<65536?(n[i++]=224|(r&61440)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0):(n[i++]=240|(r&1835008)>>>18,n[i++]=128|(r&258048)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0),i>=64&&(this._step(),i-=64,this._totalLen+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),i}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),L(this._h0)+L(this._h1)+L(this._h2)+L(this._h3)+L(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const n=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(n/4294967296),!1),this._buffDV.setUint32(60,n%4294967296,!1),this._step()}_step(){const n=A._bigBlock32,i=this._buffDV;for(let D=0;D<64;D+=4)n.setUint32(D,i.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)n.setUint32(D,g(n.getUint32(D-12,!1)^n.getUint32(D-32,!1)^n.getUint32(D-56,!1)^n.getUint32(D-64,!1),1),!1);let r=this._h0,l=this._h1,h=this._h2,_=this._h3,a=this._h4,d,N,M;for(let D=0;D<80;D++)D<20?(d=l&h|~l&_,N=1518500249):D<40?(d=l^h^_,N=1859775393):D<60?(d=l&h|l&_|h&_,N=2400959708):(d=l^h^_,N=3395469782),M=g(r,5)+d+a+N+n.getUint32(D*4,!1)&4294967295,a=_,_=h,h=g(l,30),l=r,r=M;this._h0=this._h0+r&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+h&4294967295,this._h3=this._h3+_&4294967295,this._h4=this._h4+a&4294967295}}t.StringSHA1=A,A._bigBlock32=new DataView(new ArrayBuffer(320))}),j($[11],V([0,1,15,22]),function(F,t,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.MyArray=t.Debug=t.stringDiff=t.StringDiffSequence=void 0;class C{constructor(g){this.source=g}getElements(){const g=this.source,f=new Int32Array(g.length);for(let m=0,L=g.length;m<L;m++)f[m]=g.charCodeAt(m);return f}}t.StringDiffSequence=C;function s(w,g,f){return new v(new C(w),new C(g)).ComputeDiff(f).changes}t.stringDiff=s;class E{static Assert(g,f){if(!g)throw new Error(f)}}t.Debug=E;class o{static Copy(g,f,m,L,A){for(let S=0;S<A;S++)m[L+S]=g[f+S]}static Copy2(g,f,m,L,A){for(let S=0;S<A;S++)m[L+S]=g[f+S]}}t.MyArray=o;var u;(function(w){w[w.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(u||(u={}));class c{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new P.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(g,f){this.m_originalStart=Math.min(this.m_originalStart,g),this.m_modifiedStart=Math.min(this.m_modifiedStart,f),this.m_originalCount++}AddModifiedElement(g,f){this.m_originalStart=Math.min(this.m_originalStart,g),this.m_modifiedStart=Math.min(this.m_modifiedStart,f),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class v{constructor(g,f,m=null){this.ContinueProcessingPredicate=m,this._originalSequence=g,this._modifiedSequence=f;const[L,A,S]=v._getElements(g),[n,i,r]=v._getElements(f);this._hasStrings=S&&r,this._originalStringElements=L,this._originalElementsOrHash=A,this._modifiedStringElements=n,this._modifiedElementsOrHash=i,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(g){return g.length>0&&typeof g[0]=="string"}static _getElements(g){const f=g.getElements();if(v._isStringArray(f)){const m=new Int32Array(f.length);for(let L=0,A=f.length;L<A;L++)m[L]=(0,R.stringHash)(f[L],0);return[f,m,!0]}return f instanceof Int32Array?[[],f,!1]:[[],new Int32Array(f),!1]}ElementsAreEqual(g,f){return this._originalElementsOrHash[g]!==this._modifiedElementsOrHash[f]?!1:this._hasStrings?this._originalStringElements[g]===this._modifiedStringElements[f]:!0}ElementsAreStrictEqual(g,f){if(!this.ElementsAreEqual(g,f))return!1;const m=v._getStrictElement(this._originalSequence,g),L=v._getStrictElement(this._modifiedSequence,f);return m===L}static _getStrictElement(g,f){return typeof g.getStrictElement=="function"?g.getStrictElement(f):null}OriginalElementsAreEqual(g,f){return this._originalElementsOrHash[g]!==this._originalElementsOrHash[f]?!1:this._hasStrings?this._originalStringElements[g]===this._originalStringElements[f]:!0}ModifiedElementsAreEqual(g,f){return this._modifiedElementsOrHash[g]!==this._modifiedElementsOrHash[f]?!1:this._hasStrings?this._modifiedStringElements[g]===this._modifiedStringElements[f]:!0}ComputeDiff(g){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,g)}_ComputeDiff(g,f,m,L,A){const S=[!1];let n=this.ComputeDiffRecursive(g,f,m,L,S);return A&&(n=this.PrettifyChanges(n)),{quitEarly:S[0],changes:n}}ComputeDiffRecursive(g,f,m,L,A){for(A[0]=!1;g<=f&&m<=L&&this.ElementsAreEqual(g,m);)g++,m++;for(;f>=g&&L>=m&&this.ElementsAreEqual(f,L);)f--,L--;if(g>f||m>L){let h;return m<=L?(E.Assert(g===f+1,"originalStart should only be one more than originalEnd"),h=[new P.DiffChange(g,0,m,L-m+1)]):g<=f?(E.Assert(m===L+1,"modifiedStart should only be one more than modifiedEnd"),h=[new P.DiffChange(g,f-g+1,m,0)]):(E.Assert(g===f+1,"originalStart should only be one more than originalEnd"),E.Assert(m===L+1,"modifiedStart should only be one more than modifiedEnd"),h=[]),h}const S=[0],n=[0],i=this.ComputeRecursionPoint(g,f,m,L,S,n,A),r=S[0],l=n[0];if(i!==null)return i;if(!A[0]){const h=this.ComputeDiffRecursive(g,r,m,l,A);let _=[];return A[0]?_=[new P.DiffChange(r+1,f-(r+1)+1,l+1,L-(l+1)+1)]:_=this.ComputeDiffRecursive(r+1,f,l+1,L,A),this.ConcatenateChanges(h,_)}return[new P.DiffChange(g,f-g+1,m,L-m+1)]}WALKTRACE(g,f,m,L,A,S,n,i,r,l,h,_,a,d,N,M,D,p){let U=null,k=null,W=new c,Y=f,Z=m,z=a[0]-M[0]-L,J=-1073741824,e=this.m_forwardHistory.length-1;do{const O=z+g;O===Y||O<Z&&r[O-1]<r[O+1]?(h=r[O+1],d=h-z-L,h<J&&W.MarkNextChange(),J=h,W.AddModifiedElement(h+1,d),z=O+1-g):(h=r[O-1]+1,d=h-z-L,h<J&&W.MarkNextChange(),J=h-1,W.AddOriginalElement(h,d+1),z=O-1-g),e>=0&&(r=this.m_forwardHistory[e],g=r[0],Y=1,Z=r.length-1)}while(--e>=-1);if(U=W.getReverseChanges(),p[0]){let O=a[0]+1,y=M[0]+1;if(U!==null&&U.length>0){const B=U[U.length-1];O=Math.max(O,B.getOriginalEnd()),y=Math.max(y,B.getModifiedEnd())}k=[new P.DiffChange(O,_-O+1,y,N-y+1)]}else{W=new c,Y=S,Z=n,z=a[0]-M[0]-i,J=1073741824,e=D?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const O=z+A;O===Y||O<Z&&l[O-1]>=l[O+1]?(h=l[O+1]-1,d=h-z-i,h>J&&W.MarkNextChange(),J=h+1,W.AddOriginalElement(h+1,d+1),z=O+1-A):(h=l[O-1],d=h-z-i,h>J&&W.MarkNextChange(),J=h,W.AddModifiedElement(h+1,d+1),z=O-1-A),e>=0&&(l=this.m_reverseHistory[e],A=l[0],Y=1,Z=l.length-1)}while(--e>=-1);k=W.getChanges()}return this.ConcatenateChanges(U,k)}ComputeRecursionPoint(g,f,m,L,A,S,n){let i=0,r=0,l=0,h=0,_=0,a=0;g--,m--,A[0]=0,S[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const d=f-g+(L-m),N=d+1,M=new Int32Array(N),D=new Int32Array(N),p=L-m,U=f-g,k=g-m,W=f-L,Z=(U-p)%2==0;M[p]=g,D[U]=f,n[0]=!1;for(let z=1;z<=d/2+1;z++){let J=0,e=0;l=this.ClipDiagonalBound(p-z,z,p,N),h=this.ClipDiagonalBound(p+z,z,p,N);for(let y=l;y<=h;y+=2){y===l||y<h&&M[y-1]<M[y+1]?i=M[y+1]:i=M[y-1]+1,r=i-(y-p)-k;const B=i;for(;i<f&&r<L&&this.ElementsAreEqual(i+1,r+1);)i++,r++;if(M[y]=i,i+r>J+e&&(J=i,e=r),!Z&&Math.abs(y-U)<=z-1&&i>=D[y])return A[0]=i,S[0]=r,B<=D[y]&&1447>0&&z<=1447+1?this.WALKTRACE(p,l,h,k,U,_,a,W,M,D,i,f,A,r,L,S,Z,n):null}const O=(J-g+(e-m)-z)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(J,O))return n[0]=!0,A[0]=J,S[0]=e,O>0&&1447>0&&z<=1447+1?this.WALKTRACE(p,l,h,k,U,_,a,W,M,D,i,f,A,r,L,S,Z,n):(g++,m++,[new P.DiffChange(g,f-g+1,m,L-m+1)]);_=this.ClipDiagonalBound(U-z,z,U,N),a=this.ClipDiagonalBound(U+z,z,U,N);for(let y=_;y<=a;y+=2){y===_||y<a&&D[y-1]>=D[y+1]?i=D[y+1]-1:i=D[y-1],r=i-(y-U)-W;const B=i;for(;i>g&&r>m&&this.ElementsAreEqual(i,r);)i--,r--;if(D[y]=i,Z&&Math.abs(y-p)<=z&&i<=M[y])return A[0]=i,S[0]=r,B>=M[y]&&1447>0&&z<=1447+1?this.WALKTRACE(p,l,h,k,U,_,a,W,M,D,i,f,A,r,L,S,Z,n):null}if(z<=1447){let y=new Int32Array(h-l+2);y[0]=p-l+1,o.Copy2(M,l,y,1,h-l+1),this.m_forwardHistory.push(y),y=new Int32Array(a-_+2),y[0]=U-_+1,o.Copy2(D,_,y,1,a-_+1),this.m_reverseHistory.push(y)}}return this.WALKTRACE(p,l,h,k,U,_,a,W,M,D,i,f,A,r,L,S,Z,n)}PrettifyChanges(g){for(let f=0;f<g.length;f++){const m=g[f],L=f<g.length-1?g[f+1].originalStart:this._originalElementsOrHash.length,A=f<g.length-1?g[f+1].modifiedStart:this._modifiedElementsOrHash.length,S=m.originalLength>0,n=m.modifiedLength>0;for(;m.originalStart+m.originalLength<L&&m.modifiedStart+m.modifiedLength<A&&(!S||this.OriginalElementsAreEqual(m.originalStart,m.originalStart+m.originalLength))&&(!n||this.ModifiedElementsAreEqual(m.modifiedStart,m.modifiedStart+m.modifiedLength));){const r=this.ElementsAreStrictEqual(m.originalStart,m.modifiedStart);if(this.ElementsAreStrictEqual(m.originalStart+m.originalLength,m.modifiedStart+m.modifiedLength)&&!r)break;m.originalStart++,m.modifiedStart++}let i=[null];if(f<g.length-1&&this.ChangesOverlap(g[f],g[f+1],i)){g[f]=i[0],g.splice(f+1,1),f--;continue}}for(let f=g.length-1;f>=0;f--){const m=g[f];let L=0,A=0;if(f>0){const h=g[f-1];L=h.originalStart+h.originalLength,A=h.modifiedStart+h.modifiedLength}const S=m.originalLength>0,n=m.modifiedLength>0;let i=0,r=this._boundaryScore(m.originalStart,m.originalLength,m.modifiedStart,m.modifiedLength);for(let h=1;;h++){const _=m.originalStart-h,a=m.modifiedStart-h;if(_<L||a<A||S&&!this.OriginalElementsAreEqual(_,_+m.originalLength)||n&&!this.ModifiedElementsAreEqual(a,a+m.modifiedLength))break;const N=(_===L&&a===A?5:0)+this._boundaryScore(_,m.originalLength,a,m.modifiedLength);N>r&&(r=N,i=h)}m.originalStart-=i,m.modifiedStart-=i;const l=[null];if(f>0&&this.ChangesOverlap(g[f-1],g[f],l)){g[f-1]=l[0],g.splice(f,1),f++;continue}}if(this._hasStrings)for(let f=1,m=g.length;f<m;f++){const L=g[f-1],A=g[f],S=A.originalStart-L.originalStart-L.originalLength,n=L.originalStart,i=A.originalStart+A.originalLength,r=i-n,l=L.modifiedStart,h=A.modifiedStart+A.modifiedLength,_=h-l;if(S<5&&r<20&&_<20){const a=this._findBetterContiguousSequence(n,r,l,_,S);if(a){const[d,N]=a;(d!==L.originalStart+L.originalLength||N!==L.modifiedStart+L.modifiedLength)&&(L.originalLength=d-L.originalStart,L.modifiedLength=N-L.modifiedStart,A.originalStart=d+S,A.modifiedStart=N+S,A.originalLength=i-A.originalStart,A.modifiedLength=h-A.modifiedStart)}}}return g}_findBetterContiguousSequence(g,f,m,L,A){if(f<A||L<A)return null;const S=g+f-A+1,n=m+L-A+1;let i=0,r=0,l=0;for(let h=g;h<S;h++)for(let _=m;_<n;_++){const a=this._contiguousSequenceScore(h,_,A);a>0&&a>i&&(i=a,r=h,l=_)}return i>0?[r,l]:null}_contiguousSequenceScore(g,f,m){let L=0;for(let A=0;A<m;A++){if(!this.ElementsAreEqual(g+A,f+A))return 0;L+=this._originalStringElements[g+A].length}return L}_OriginalIsBoundary(g){return g<=0||g>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[g])}_OriginalRegionIsBoundary(g,f){if(this._OriginalIsBoundary(g)||this._OriginalIsBoundary(g-1))return!0;if(f>0){const m=g+f;if(this._OriginalIsBoundary(m-1)||this._OriginalIsBoundary(m))return!0}return!1}_ModifiedIsBoundary(g){return g<=0||g>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[g])}_ModifiedRegionIsBoundary(g,f){if(this._ModifiedIsBoundary(g)||this._ModifiedIsBoundary(g-1))return!0;if(f>0){const m=g+f;if(this._ModifiedIsBoundary(m-1)||this._ModifiedIsBoundary(m))return!0}return!1}_boundaryScore(g,f,m,L){const A=this._OriginalRegionIsBoundary(g,f)?1:0,S=this._ModifiedRegionIsBoundary(m,L)?1:0;return A+S}ConcatenateChanges(g,f){let m=[];if(g.length===0||f.length===0)return f.length>0?f:g;if(this.ChangesOverlap(g[g.length-1],f[0],m)){const L=new Array(g.length+f.length-1);return o.Copy(g,0,L,0,g.length-1),L[g.length-1]=m[0],o.Copy(f,1,L,g.length,f.length-1),L}else{const L=new Array(g.length+f.length);return o.Copy(g,0,L,0,g.length),o.Copy(f,0,L,g.length,f.length),L}}ChangesOverlap(g,f,m){if(E.Assert(g.originalStart<=f.originalStart,"Left change is not less than or equal to right change"),E.Assert(g.modifiedStart<=f.modifiedStart,"Left change is not less than or equal to right change"),g.originalStart+g.originalLength>=f.originalStart||g.modifiedStart+g.modifiedLength>=f.modifiedStart){const L=g.originalStart;let A=g.originalLength;const S=g.modifiedStart;let n=g.modifiedLength;return g.originalStart+g.originalLength>=f.originalStart&&(A=f.originalStart+f.originalLength-g.originalStart),g.modifiedStart+g.modifiedLength>=f.modifiedStart&&(n=f.modifiedStart+f.modifiedLength-g.modifiedStart),m[0]=new P.DiffChange(L,A,S,n),!0}else return m[0]=null,!1}ClipDiagonalBound(g,f,m,L){if(g>=0&&g<L)return g;const A=m,S=L-m-1,n=f%2==0;if(g<0){const i=A%2==0;return n===i?0:1}else{const i=S%2==0;return n===i?L-1:L-2}}}t.LcsDiff=v}),j($[12],V([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isPromise=t.assertNever=t.NotImplementedProxy=t.withUndefinedAsNull=t.withNullAsUndefined=t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isObject=t.isStringArray=t.isString=t.isArray=void 0;function P(p){return Array.isArray(p)}t.isArray=P;function R(p){return typeof p=="string"}t.isString=R;function C(p){return Array.isArray(p)&&p.every(U=>R(U))}t.isStringArray=C;function s(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}t.isObject=s;function E(p){return typeof p=="number"&&!isNaN(p)}t.isNumber=E;function o(p){return!!p&&typeof p[Symbol.iterator]=="function"}t.isIterable=o;function u(p){return p===!0||p===!1}t.isBoolean=u;function c(p){return typeof p=="undefined"}t.isUndefined=c;function v(p){return!w(p)}t.isDefined=v;function w(p){return c(p)||p===null}t.isUndefinedOrNull=w;function g(p,U){if(!p)throw new Error(U?`Unexpected type, expected '${U}'`:"Unexpected type")}t.assertType=g;function f(p){if(w(p))throw new Error("Assertion Failed: argument is undefined or null");return p}t.assertIsDefined=f;function m(...p){const U=[];for(let k=0;k<p.length;k++){const W=p[k];if(w(W))throw new Error(`Assertion Failed: argument at index ${k} is undefined or null`);U.push(W)}return U}t.assertAllDefined=m;const L=Object.prototype.hasOwnProperty;function A(p){if(!s(p))return!1;for(let U in p)if(L.call(p,U))return!1;return!0}t.isEmptyObject=A;function S(p){return typeof p=="function"}t.isFunction=S;function n(...p){return p.length>0&&p.every(S)}t.areFunctions=n;function i(p,U){const k=Math.min(p.length,U.length);for(let W=0;W<k;W++)r(p[W],U[W])}t.validateConstraints=i;function r(p,U){if(R(U)){if(typeof p!==U)throw new Error(`argument does not match constraint: typeof ${U}`)}else if(S(U)){try{if(p instanceof U)return}catch{}if(!w(p)&&p.constructor===U||U.length===1&&U.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=r;function l(p){let U=[],k=Object.getPrototypeOf(p);for(;Object.prototype!==k;)U=U.concat(Object.getOwnPropertyNames(k)),k=Object.getPrototypeOf(k);return U}t.getAllPropertyNames=l;function h(p){const U=[];for(const k of l(p))typeof p[k]=="function"&&U.push(k);return U}t.getAllMethodNames=h;function _(p,U){const k=Y=>function(){const Z=Array.prototype.slice.call(arguments,0);return U(Y,Z)};let W={};for(const Y of p)W[Y]=k(Y);return W}t.createProxyObject=_;function a(p){return p===null?void 0:p}t.withNullAsUndefined=a;function d(p){return typeof p=="undefined"?null:p}t.withUndefinedAsNull=d;function N(p){return class{constructor(){return new Proxy({},{get(U,k){if(U[k])return U[k];throw new Error(`Not Implemented: ${p}->${String(k)}`)}})}}}t.NotImplementedProxy=N;function M(p,U="Unreachable"){throw new Error(U)}t.assertNever=M;function D(p){return!!p&&typeof p.then=="function"&&typeof p.catch=="function"}t.isPromise=D}),j($[13],V([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0;var P;(function(s){s[s.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",s[s.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",s[s.MAX_UINT_8=255]="MAX_UINT_8",s[s.MAX_UINT_16=65535]="MAX_UINT_16",s[s.MAX_UINT_32=4294967295]="MAX_UINT_32",s[s.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(P=t.Constants||(t.Constants={}));function R(s){return s<0?0:s>255?255:s|0}t.toUint8=R;function C(s){return s<0?0:s>4294967295?4294967295:s|0}t.toUint32=C}),j($[14],V([0,1,20,2]),function(F,t,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const C=/^\w[\w\d+.-]*$/,s=/^\//,E=/^\/\//;function o(a,d){if(!a.scheme&&d)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!C.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!s.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(a,d){return!a&&!d?"file":a}function c(a,d){switch(a){case"https":case"http":case"file":d?d[0]!==w&&(d=w+d):d=w;break}return d}const v="",w="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(d,N,M,D,p,U=!1){typeof d=="object"?(this.scheme=d.scheme||v,this.authority=d.authority||v,this.path=d.path||v,this.query=d.query||v,this.fragment=d.fragment||v):(this.scheme=u(d,U),this.authority=N||v,this.path=c(this.scheme,M||v),this.query=D||v,this.fragment=p||v,o(this,U))}static isUri(d){return d instanceof f?!0:d?typeof d.authority=="string"&&typeof d.fragment=="string"&&typeof d.path=="string"&&typeof d.query=="string"&&typeof d.scheme=="string"&&typeof d.fsPath=="string"&&typeof d.with=="function"&&typeof d.toString=="function":!1}get fsPath(){return i(this,!1)}with(d){if(!d)return this;let{scheme:N,authority:M,path:D,query:p,fragment:U}=d;return N===void 0?N=this.scheme:N===null&&(N=v),M===void 0?M=this.authority:M===null&&(M=v),D===void 0?D=this.path:D===null&&(D=v),p===void 0?p=this.query:p===null&&(p=v),U===void 0?U=this.fragment:U===null&&(U=v),N===this.scheme&&M===this.authority&&D===this.path&&p===this.query&&U===this.fragment?this:new L(N,M,D,p,U)}static parse(d,N=!1){const M=g.exec(d);return M?new L(M[2]||v,_(M[4]||v),_(M[5]||v),_(M[7]||v),_(M[9]||v),N):new L(v,v,v,v,v)}static file(d){let N=v;if(R.isWindows&&(d=d.replace(/\\/g,w)),d[0]===w&&d[1]===w){const M=d.indexOf(w,2);M===-1?(N=d.substring(2),d=w):(N=d.substring(2,M),d=d.substring(M)||w)}return new L("file",N,d,v,v)}static from(d){const N=new L(d.scheme,d.authority,d.path,d.query,d.fragment);return o(N,!0),N}static joinPath(d,...N){if(!d.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let M;return R.isWindows&&d.scheme==="file"?M=f.file(P.win32.join(i(d,!0),...N)).path:M=P.posix.join(d.path,...N),d.with({path:M})}toString(d=!1){return r(this,d)}toJSON(){return this}static revive(d){if(d){if(d instanceof f)return d;{const N=new L(d);return N._formatted=d.external,N._fsPath=d._sep===m?d.fsPath:null,N}}else return d}}t.URI=f;const m=R.isWindows?1:void 0;class L extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(d=!1){return d?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const d={$mid:1};return this._fsPath&&(d.fsPath=this._fsPath,d._sep=m),this._formatted&&(d.external=this._formatted),this.path&&(d.path=this.path),this.scheme&&(d.scheme=this.scheme),this.authority&&(d.authority=this.authority),this.query&&(d.query=this.query),this.fragment&&(d.fragment=this.fragment),d}}const A={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function S(a,d){let N,M=-1;for(let D=0;D<a.length;D++){const p=a.charCodeAt(D);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||d&&p===47)M!==-1&&(N+=encodeURIComponent(a.substring(M,D)),M=-1),N!==void 0&&(N+=a.charAt(D));else{N===void 0&&(N=a.substr(0,D));const U=A[p];U!==void 0?(M!==-1&&(N+=encodeURIComponent(a.substring(M,D)),M=-1),N+=U):M===-1&&(M=D)}}return M!==-1&&(N+=encodeURIComponent(a.substring(M))),N!==void 0?N:a}function n(a){let d;for(let N=0;N<a.length;N++){const M=a.charCodeAt(N);M===35||M===63?(d===void 0&&(d=a.substr(0,N)),d+=A[M]):d!==void 0&&(d+=a[N])}return d!==void 0?d:a}function i(a,d){let N;return a.authority&&a.path.length>1&&a.scheme==="file"?N=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?d?N=a.path.substr(1):N=a.path[1].toLowerCase()+a.path.substr(2):N=a.path,R.isWindows&&(N=N.replace(/\//g,"\\")),N}t.uriToFsPath=i;function r(a,d){const N=d?n:S;let M="",{scheme:D,authority:p,path:U,query:k,fragment:W}=a;if(D&&(M+=D,M+=":"),(p||D==="file")&&(M+=w,M+=w),p){let Y=p.indexOf("@");if(Y!==-1){const Z=p.substr(0,Y);p=p.substr(Y+1),Y=Z.indexOf(":"),Y===-1?M+=N(Z,!1):(M+=N(Z.substr(0,Y),!1),M+=":",M+=N(Z.substr(Y+1),!1)),M+="@"}p=p.toLowerCase(),Y=p.indexOf(":"),Y===-1?M+=N(p,!1):(M+=N(p.substr(0,Y),!1),M+=p.substr(Y))}if(U){if(U.length>=3&&U.charCodeAt(0)===47&&U.charCodeAt(2)===58){const Y=U.charCodeAt(1);Y>=65&&Y<=90&&(U=`/${String.fromCharCode(Y+32)}:${U.substr(3)}`)}else if(U.length>=2&&U.charCodeAt(1)===58){const Y=U.charCodeAt(0);Y>=65&&Y<=90&&(U=`${String.fromCharCode(Y+32)}:${U.substr(2)}`)}M+=N(U,!0)}return k&&(M+="?",M+=N(k,!1)),W&&(M+="#",M+=d?W:S(W,!1)),M}function l(a){try{return decodeURIComponent(a)}catch{return a.length>3?a.substr(0,3)+l(a.substr(3)):a}}const h=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function _(a){return a.match(h)?a.replace(h,d=>l(d)):a}}),j($[34],V([0,1,4,8,2,12]),function(F,t,P,R,C,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const E="$initialize";let o=!1;function u(f){!C.isWeb||(o||(o=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(f.message))}t.logOnceWebWorkerWarning=u;class c{constructor(m){this._workerId=-1,this._handler=m,this._lastSentReq=0,this._pendingReplies=Object.create(null)}setWorkerId(m){this._workerId=m}sendMessage(m,L){let A=String(++this._lastSentReq);return new Promise((S,n)=>{this._pendingReplies[A]={resolve:S,reject:n},this._send({vsWorker:this._workerId,req:A,method:m,args:L})})}handleMessage(m){!m||!m.vsWorker||this._workerId!==-1&&m.vsWorker!==this._workerId||this._handleMessage(m)}_handleMessage(m){if(m.seq){let n=m;if(!this._pendingReplies[n.seq]){console.warn("Got reply to unknown seq");return}let i=this._pendingReplies[n.seq];if(delete this._pendingReplies[n.seq],n.err){let r=n.err;n.err.$isError&&(r=new Error,r.name=n.err.name,r.message=n.err.message,r.stack=n.err.stack),i.reject(r);return}i.resolve(n.res);return}let L=m,A=L.req;this._handler.handleMessage(L.method,L.args).then(n=>{this._send({vsWorker:this._workerId,seq:A,res:n,err:void 0})},n=>{n.detail instanceof Error&&(n.detail=(0,P.transformErrorForSerialization)(n.detail)),this._send({vsWorker:this._workerId,seq:A,res:void 0,err:(0,P.transformErrorForSerialization)(n)})})}_send(m){let L=[];if(m.req){const A=m;for(let S=0;S<A.args.length;S++)A.args[S]instanceof ArrayBuffer&&L.push(A.args[S])}else{const A=m;A.res instanceof ArrayBuffer&&L.push(A.res)}this._handler.sendMessage(m,L)}}class v extends R.Disposable{constructor(m,L,A){super();let S=null;this._worker=this._register(m.create("vs/base/common/worker/simpleWorker",l=>{this._protocol.handleMessage(l)},l=>{S&&S(l)})),this._protocol=new c({sendMessage:(l,h)=>{this._worker.postMessage(l,h)},handleMessage:(l,h)=>{if(typeof A[l]!="function")return Promise.reject(new Error("Missing method "+l+" on main thread host."));try{return Promise.resolve(A[l].apply(A,h))}catch(_){return Promise.reject(_)}}}),this._protocol.setWorkerId(this._worker.getId());let n=null;typeof self.require!="undefined"&&typeof self.require.getConfig=="function"?n=self.require.getConfig():typeof self.requirejs!="undefined"&&(n=self.requirejs.s.contexts._.config);const i=s.getAllMethodNames(A);this._onModuleLoaded=this._protocol.sendMessage(E,[this._worker.getId(),JSON.parse(JSON.stringify(n)),L,i]);const r=(l,h)=>this._request(l,h);this._lazyProxy=new Promise((l,h)=>{S=h,this._onModuleLoaded.then(_=>{l(s.createProxyObject(_,r))},_=>{h(_),this._onError("Worker failed to load "+L,_)})})}getProxyObject(){return this._lazyProxy}_request(m,L){return new Promise((A,S)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(m,L).then(A,S)},S)})}_onError(m,L){console.error(m),console.info(L)}}t.SimpleWorkerClient=v;class w{constructor(m,L){this._requestHandlerFactory=L,this._requestHandler=null,this._protocol=new c({sendMessage:(A,S)=>{m(A,S)},handleMessage:(A,S)=>this._handleMessage(A,S)})}onmessage(m){this._protocol.handleMessage(m)}_handleMessage(m,L){if(m===E)return this.initialize(L[0],L[1],L[2],L[3]);if(!this._requestHandler||typeof this._requestHandler[m]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+m));try{return Promise.resolve(this._requestHandler[m].apply(this._requestHandler,L))}catch(A){return Promise.reject(A)}}initialize(m,L,A,S){this._protocol.setWorkerId(m);const n=(r,l)=>this._protocol.sendMessage(r,l),i=s.createProxyObject(S,n);return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(i),Promise.resolve(s.getAllMethodNames(this._requestHandler))):(L&&(typeof L.baseUrl!="undefined"&&delete L.baseUrl,typeof L.paths!="undefined"&&typeof L.paths.vs!="undefined"&&delete L.paths.vs,typeof L.trustedTypesPolicy!==void 0&&delete L.trustedTypesPolicy,L.catchError=!0,self.require.config(L)),new Promise((r,l)=>{self.require([A],h=>{if(this._requestHandler=h.create(i),!this._requestHandler){l(new Error("No RequestHandler!"));return}r(s.getAllMethodNames(this._requestHandler))},l)}))}}t.SimpleWorkerServer=w;function g(f){return new w(f,null)}t.create=g}),j($[23],V([0,1,13]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class R{constructor(o){let u=(0,P.toUint8)(o);this._defaultValue=u,this._asciiMap=R._createAsciiMap(u),this._map=new Map}static _createAsciiMap(o){let u=new Uint8Array(256);for(let c=0;c<256;c++)u[c]=o;return u}set(o,u){let c=(0,P.toUint8)(u);o>=0&&o<256?this._asciiMap[o]=c:this._map.set(o,c)}get(o){return o>=0&&o<256?this._asciiMap[o]:this._map.get(o)||this._defaultValue}}t.CharacterClassifier=R;var C;(function(E){E[E.False=0]="False",E[E.True=1]="True"})(C||(C={}));class s{constructor(){this._actual=new R(0)}add(o){this._actual.set(o,1)}has(o){return this._actual.get(o)===1}}t.CharacterSet=s}),j($[3],V([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class P{constructor(C,s){this.lineNumber=C,this.column=s}with(C=this.lineNumber,s=this.column){return C===this.lineNumber&&s===this.column?this:new P(C,s)}delta(C=0,s=0){return this.with(this.lineNumber+C,this.column+s)}equals(C){return P.equals(this,C)}static equals(C,s){return!C&&!s?!0:!!C&&!!s&&C.lineNumber===s.lineNumber&&C.column===s.column}isBefore(C){return P.isBefore(this,C)}static isBefore(C,s){return C.lineNumber<s.lineNumber?!0:s.lineNumber<C.lineNumber?!1:C.column<s.column}isBeforeOrEqual(C){return P.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,s){return C.lineNumber<s.lineNumber?!0:s.lineNumber<C.lineNumber?!1:C.column<=s.column}static compare(C,s){let E=C.lineNumber|0,o=s.lineNumber|0;if(E===o){let u=C.column|0,c=s.column|0;return u-c}return E-o}clone(){return new P(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new P(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}t.Position=P}),j($[6],V([0,1,3]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class R{constructor(s,E,o,u){s>o||s===o&&E>u?(this.startLineNumber=o,this.startColumn=u,this.endLineNumber=s,this.endColumn=E):(this.startLineNumber=s,this.startColumn=E,this.endLineNumber=o,this.endColumn=u)}isEmpty(){return R.isEmpty(this)}static isEmpty(s){return s.startLineNumber===s.endLineNumber&&s.startColumn===s.endColumn}containsPosition(s){return R.containsPosition(this,s)}static containsPosition(s,E){return!(E.lineNumber<s.startLineNumber||E.lineNumber>s.endLineNumber||E.lineNumber===s.startLineNumber&&E.column<s.startColumn||E.lineNumber===s.endLineNumber&&E.column>s.endColumn)}containsRange(s){return R.containsRange(this,s)}static containsRange(s,E){return!(E.startLineNumber<s.startLineNumber||E.endLineNumber<s.startLineNumber||E.startLineNumber>s.endLineNumber||E.endLineNumber>s.endLineNumber||E.startLineNumber===s.startLineNumber&&E.startColumn<s.startColumn||E.endLineNumber===s.endLineNumber&&E.endColumn>s.endColumn)}strictContainsRange(s){return R.strictContainsRange(this,s)}static strictContainsRange(s,E){return!(E.startLineNumber<s.startLineNumber||E.endLineNumber<s.startLineNumber||E.startLineNumber>s.endLineNumber||E.endLineNumber>s.endLineNumber||E.startLineNumber===s.startLineNumber&&E.startColumn<=s.startColumn||E.endLineNumber===s.endLineNumber&&E.endColumn>=s.endColumn)}plusRange(s){return R.plusRange(this,s)}static plusRange(s,E){let o,u,c,v;return E.startLineNumber<s.startLineNumber?(o=E.startLineNumber,u=E.startColumn):E.startLineNumber===s.startLineNumber?(o=E.startLineNumber,u=Math.min(E.startColumn,s.startColumn)):(o=s.startLineNumber,u=s.startColumn),E.endLineNumber>s.endLineNumber?(c=E.endLineNumber,v=E.endColumn):E.endLineNumber===s.endLineNumber?(c=E.endLineNumber,v=Math.max(E.endColumn,s.endColumn)):(c=s.endLineNumber,v=s.endColumn),new R(o,u,c,v)}intersectRanges(s){return R.intersectRanges(this,s)}static intersectRanges(s,E){let o=s.startLineNumber,u=s.startColumn,c=s.endLineNumber,v=s.endColumn,w=E.startLineNumber,g=E.startColumn,f=E.endLineNumber,m=E.endColumn;return o<w?(o=w,u=g):o===w&&(u=Math.max(u,g)),c>f?(c=f,v=m):c===f&&(v=Math.min(v,m)),o>c||o===c&&u>v?null:new R(o,u,c,v)}equalsRange(s){return R.equalsRange(this,s)}static equalsRange(s,E){return!!s&&!!E&&s.startLineNumber===E.startLineNumber&&s.startColumn===E.startColumn&&s.endLineNumber===E.endLineNumber&&s.endColumn===E.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(s){return new P.Position(s.endLineNumber,s.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(s){return new P.Position(s.startLineNumber,s.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(s,E){return new R(this.startLineNumber,this.startColumn,s,E)}setStartPosition(s,E){return new R(s,E,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(s){return new R(s.startLineNumber,s.startColumn,s.startLineNumber,s.startColumn)}static fromPositions(s,E=s){return new R(s.lineNumber,s.column,E.lineNumber,E.column)}static lift(s){return s?new R(s.startLineNumber,s.startColumn,s.endLineNumber,s.endColumn):null}static isIRange(s){return s&&typeof s.startLineNumber=="number"&&typeof s.startColumn=="number"&&typeof s.endLineNumber=="number"&&typeof s.endColumn=="number"}static areIntersectingOrTouching(s,E){return!(s.endLineNumber<E.startLineNumber||s.endLineNumber===E.startLineNumber&&s.endColumn<E.startColumn||E.endLineNumber<s.startLineNumber||E.endLineNumber===s.startLineNumber&&E.endColumn<s.startColumn)}static areIntersecting(s,E){return!(s.endLineNumber<E.startLineNumber||s.endLineNumber===E.startLineNumber&&s.endColumn<=E.startColumn||E.endLineNumber<s.startLineNumber||E.endLineNumber===s.startLineNumber&&E.endColumn<=s.startColumn)}static compareRangesUsingStarts(s,E){if(s&&E){const c=s.startLineNumber|0,v=E.startLineNumber|0;if(c===v){const w=s.startColumn|0,g=E.startColumn|0;if(w===g){const f=s.endLineNumber|0,m=E.endLineNumber|0;if(f===m){const L=s.endColumn|0,A=E.endColumn|0;return L-A}return f-m}return w-g}return c-v}return(s?1:0)-(E?1:0)}static compareRangesUsingEnds(s,E){return s.endLineNumber===E.endLineNumber?s.endColumn===E.endColumn?s.startLineNumber===E.startLineNumber?s.startColumn-E.startColumn:s.startLineNumber-E.startLineNumber:s.endColumn-E.endColumn:s.endLineNumber-E.endLineNumber}static spansMultipleLines(s){return s.endLineNumber>s.startLineNumber}}t.Range=R}),j($[24],V([0,1,3,6]),function(F,t,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var C;(function(E){E[E.LTR=0]="LTR",E[E.RTL=1]="RTL"})(C=t.SelectionDirection||(t.SelectionDirection={}));class s extends R.Range{constructor(o,u,c,v){super(o,u,c,v);this.selectionStartLineNumber=o,this.selectionStartColumn=u,this.positionLineNumber=c,this.positionColumn=v}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(o){return s.selectionsEqual(this,o)}static selectionsEqual(o,u){return o.selectionStartLineNumber===u.selectionStartLineNumber&&o.selectionStartColumn===u.selectionStartColumn&&o.positionLineNumber===u.positionLineNumber&&o.positionColumn===u.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(o,u){return this.getDirection()===0?new s(this.startLineNumber,this.startColumn,o,u):new s(o,u,this.startLineNumber,this.startColumn)}getPosition(){return new P.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(o,u){return this.getDirection()===0?new s(o,u,this.endLineNumber,this.endColumn):new s(this.endLineNumber,this.endColumn,o,u)}static fromPositions(o,u=o){return new s(o.lineNumber,o.column,u.lineNumber,u.column)}static liftSelection(o){return new s(o.selectionStartLineNumber,o.selectionStartColumn,o.positionLineNumber,o.positionColumn)}static selectionsArrEqual(o,u){if(o&&!u||!o&&u)return!1;if(!o&&!u)return!0;if(o.length!==u.length)return!1;for(let c=0,v=o.length;c<v;c++)if(!this.selectionsEqual(o[c],u[c]))return!1;return!0}static isISelection(o){return o&&typeof o.selectionStartLineNumber=="number"&&typeof o.selectionStartColumn=="number"&&typeof o.positionLineNumber=="number"&&typeof o.positionColumn=="number"}static createWithDirection(o,u,c,v,w){return w===0?new s(o,u,c,v):new s(c,v,o,u)}}t.Selection=s}),j($[25],V([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationResult2=t.TokenizationResult=t.Token=void 0;class P{constructor(E,o,u){this._tokenBrand=void 0,this.offset=E|0,this.type=o,this.language=u}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=P;class R{constructor(E,o){this._tokenizationResultBrand=void 0,this.tokens=E,this.endState=o}}t.TokenizationResult=R;class C{constructor(E,o){this._tokenizationResult2Brand=void 0,this.tokens=E,this.endState=o}}t.TokenizationResult2=C}),j($[26],V([0,1,11,5]),function(F,t,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=void 0;const C=3;function s(L,A,S,n){return new P.LcsDiff(L,A,S).ComputeDiff(n)}class E{constructor(A){const S=[],n=[];for(let i=0,r=A.length;i<r;i++)S[i]=g(A[i],1),n[i]=f(A[i],1);this.lines=A,this._startColumns=S,this._endColumns=n}getElements(){const A=[];for(let S=0,n=this.lines.length;S<n;S++)A[S]=this.lines[S].substring(this._startColumns[S]-1,this._endColumns[S]-1);return A}getStrictElement(A){return this.lines[A]}getStartLineNumber(A){return A+1}getEndLineNumber(A){return A+1}createCharSequence(A,S,n){const i=[],r=[],l=[];let h=0;for(let _=S;_<=n;_++){const a=this.lines[_],d=A?this._startColumns[_]:1,N=A?this._endColumns[_]:a.length+1;for(let M=d;M<N;M++)i[h]=a.charCodeAt(M-1),r[h]=_+1,l[h]=M,h++}return new o(i,r,l)}}class o{constructor(A,S,n){this._charCodes=A,this._lineNumbers=S,this._columns=n}getElements(){return this._charCodes}getStartLineNumber(A){return this._lineNumbers[A]}getStartColumn(A){return this._columns[A]}getEndLineNumber(A){return this._lineNumbers[A]}getEndColumn(A){return this._columns[A]+1}}class u{constructor(A,S,n,i,r,l,h,_){this.originalStartLineNumber=A,this.originalStartColumn=S,this.originalEndLineNumber=n,this.originalEndColumn=i,this.modifiedStartLineNumber=r,this.modifiedStartColumn=l,this.modifiedEndLineNumber=h,this.modifiedEndColumn=_}static createFromDiffChange(A,S,n){let i,r,l,h,_,a,d,N;return A.originalLength===0?(i=0,r=0,l=0,h=0):(i=S.getStartLineNumber(A.originalStart),r=S.getStartColumn(A.originalStart),l=S.getEndLineNumber(A.originalStart+A.originalLength-1),h=S.getEndColumn(A.originalStart+A.originalLength-1)),A.modifiedLength===0?(_=0,a=0,d=0,N=0):(_=n.getStartLineNumber(A.modifiedStart),a=n.getStartColumn(A.modifiedStart),d=n.getEndLineNumber(A.modifiedStart+A.modifiedLength-1),N=n.getEndColumn(A.modifiedStart+A.modifiedLength-1)),new u(i,r,l,h,_,a,d,N)}}function c(L){if(L.length<=1)return L;const A=[L[0]];let S=A[0];for(let n=1,i=L.length;n<i;n++){const r=L[n],l=r.originalStart-(S.originalStart+S.originalLength),h=r.modifiedStart-(S.modifiedStart+S.modifiedLength);Math.min(l,h)<C?(S.originalLength=r.originalStart+r.originalLength-S.originalStart,S.modifiedLength=r.modifiedStart+r.modifiedLength-S.modifiedStart):(A.push(r),S=r)}return A}class v{constructor(A,S,n,i,r){this.originalStartLineNumber=A,this.originalEndLineNumber=S,this.modifiedStartLineNumber=n,this.modifiedEndLineNumber=i,this.charChanges=r}static createFromDiffResult(A,S,n,i,r,l,h){let _,a,d,N,M;if(S.originalLength===0?(_=n.getStartLineNumber(S.originalStart)-1,a=0):(_=n.getStartLineNumber(S.originalStart),a=n.getEndLineNumber(S.originalStart+S.originalLength-1)),S.modifiedLength===0?(d=i.getStartLineNumber(S.modifiedStart)-1,N=0):(d=i.getStartLineNumber(S.modifiedStart),N=i.getEndLineNumber(S.modifiedStart+S.modifiedLength-1)),l&&S.originalLength>0&&S.originalLength<20&&S.modifiedLength>0&&S.modifiedLength<20&&r()){const D=n.createCharSequence(A,S.originalStart,S.originalStart+S.originalLength-1),p=i.createCharSequence(A,S.modifiedStart,S.modifiedStart+S.modifiedLength-1);let U=s(D,p,r,!0).changes;h&&(U=c(U)),M=[];for(let k=0,W=U.length;k<W;k++)M.push(u.createFromDiffChange(U[k],D,p))}return new v(_,a,d,N,M)}}class w{constructor(A,S,n){this.shouldComputeCharChanges=n.shouldComputeCharChanges,this.shouldPostProcessCharChanges=n.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=n.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=n.shouldMakePrettyDiff,this.originalLines=A,this.modifiedLines=S,this.original=new E(A),this.modified=new E(S),this.continueLineDiff=m(n.maxComputationTime),this.continueCharDiff=m(n.maxComputationTime===0?0:Math.min(n.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const A=s(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),S=A.changes,n=A.quitEarly;if(this.shouldIgnoreTrimWhitespace){const h=[];for(let _=0,a=S.length;_<a;_++)h.push(v.createFromDiffResult(this.shouldIgnoreTrimWhitespace,S[_],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:n,changes:h}}const i=[];let r=0,l=0;for(let h=-1,_=S.length;h<_;h++){const a=h+1<_?S[h+1]:null,d=a?a.originalStart:this.originalLines.length,N=a?a.modifiedStart:this.modifiedLines.length;for(;r<d&&l<N;){const M=this.originalLines[r],D=this.modifiedLines[l];if(M!==D){{let p=g(M,1),U=g(D,1);for(;p>1&&U>1;){const k=M.charCodeAt(p-2),W=D.charCodeAt(U-2);if(k!==W)break;p--,U--}(p>1||U>1)&&this._pushTrimWhitespaceCharChange(i,r+1,1,p,l+1,1,U)}{let p=f(M,1),U=f(D,1);const k=M.length+1,W=D.length+1;for(;p<k&&U<W;){const Y=M.charCodeAt(p-1),Z=M.charCodeAt(U-1);if(Y!==Z)break;p++,U++}(p<k||U<W)&&this._pushTrimWhitespaceCharChange(i,r+1,p,k,l+1,U,W)}}r++,l++}a&&(i.push(v.createFromDiffResult(this.shouldIgnoreTrimWhitespace,a,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),r+=a.originalLength,l+=a.modifiedLength)}return{quitEarly:n,changes:i}}_pushTrimWhitespaceCharChange(A,S,n,i,r,l,h){if(this._mergeTrimWhitespaceCharChange(A,S,n,i,r,l,h))return;let _;this.shouldComputeCharChanges&&(_=[new u(S,n,S,i,r,l,r,h)]),A.push(new v(S,S,r,r,_))}_mergeTrimWhitespaceCharChange(A,S,n,i,r,l,h){const _=A.length;if(_===0)return!1;const a=A[_-1];return a.originalEndLineNumber===0||a.modifiedEndLineNumber===0?!1:a.originalEndLineNumber+1===S&&a.modifiedEndLineNumber+1===r?(a.originalEndLineNumber=S,a.modifiedEndLineNumber=r,this.shouldComputeCharChanges&&a.charChanges&&a.charChanges.push(new u(S,n,S,i,r,l,r,h)),!0):!1}}t.DiffComputer=w;function g(L,A){const S=R.firstNonWhitespaceIndex(L);return S===-1?A:S+1}function f(L,A){const S=R.lastNonWhitespaceIndex(L);return S===-1?A:S+2}function m(L){if(L===0)return()=>!0;const A=Date.now();return()=>Date.now()-A<L}}),j($[27],V([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(o=""){let u="(-?\\d*\\.\\d\\w*)|([^";for(const c of t.USUAL_WORD_SEPARATORS)o.indexOf(c)>=0||(u+="\\"+c);return u+="\\s]+)",new RegExp(u,"g")}t.DEFAULT_WORD_REGEXP=P();function R(o){let u=t.DEFAULT_WORD_REGEXP;if(o&&o instanceof RegExp)if(o.global)u=o;else{let c="g";o.ignoreCase&&(c+="i"),o.multiline&&(c+="m"),o.unicode&&(c+="u"),u=new RegExp(o.source,c)}return u.lastIndex=0,u}t.ensureValidWordDefinition=R;const C={maxLen:1e3,windowSize:15,timeBudget:150};function s(o,u,c,v,w=C){if(c.length>w.maxLen){let A=o-w.maxLen/2;return A<0?A=0:v+=A,c=c.substring(A,o+w.maxLen/2),s(o,u,c,v,w)}const g=Date.now(),f=o-1-v;let m=-1,L=null;for(let A=1;!(Date.now()-g>=w.timeBudget);A++){const S=f-w.windowSize*A;u.lastIndex=Math.max(0,S);const n=E(u,c,f,m);if(!n&&L||(L=n,S<=0))break;m=S}if(L){let A={word:L[0],startColumn:v+1+L.index,endColumn:v+1+L.index+L[0].length};return u.lastIndex=0,A}return null}t.getWordAtText=s;function E(o,u,c,v){let w;for(;w=o.exec(u);){const g=w.index||0;if(g<=c&&o.lastIndex>=c)return w;if(v>0&&g>v)return null}return null}}),j($[28],V([0,1,23]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.Uint8Matrix=t.State=void 0;var R;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(R=t.State||(t.State={}));class C{constructor(m,L,A){const S=new Uint8Array(m*L);for(let n=0,i=m*L;n<i;n++)S[n]=A;this._data=S,this.rows=m,this.cols=L}get(m,L){return this._data[m*this.cols+L]}set(m,L,A){this._data[m*this.cols+L]=A}}t.Uint8Matrix=C;class s{constructor(m){let L=0,A=0;for(let n=0,i=m.length;n<i;n++){let[r,l,h]=m[n];l>L&&(L=l),r>A&&(A=r),h>A&&(A=h)}L++,A++;let S=new C(A,L,0);for(let n=0,i=m.length;n<i;n++){let[r,l,h]=m[n];S.set(r,l,h)}this._states=S,this._maxCharCode=L}nextState(m,L){return L<0||L>=this._maxCharCode?0:this._states.get(m,L)}}t.StateMachine=s;let E=null;function o(){return E===null&&(E=new s([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),E}var u;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(u||(u={}));let c=null;function v(){if(c===null){c=new P.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let L=0;L<f.length;L++)c.set(f.charCodeAt(L),1);const m=".,;";for(let L=0;L<m.length;L++)c.set(m.charCodeAt(L),2)}return c}class w{static _createLink(m,L,A,S,n){let i=n-1;do{const r=L.charCodeAt(i);if(m.get(r)!==2)break;i--}while(i>S);if(S>0){const r=L.charCodeAt(S-1),l=L.charCodeAt(i);(r===40&&l===41||r===91&&l===93||r===123&&l===125)&&i--}return{range:{startLineNumber:A,startColumn:S+1,endLineNumber:A,endColumn:i+2},url:L.substring(S,i+1)}}static computeLinks(m,L=o()){const A=v();let S=[];for(let n=1,i=m.getLineCount();n<=i;n++){const r=m.getLineContent(n),l=r.length;let h=0,_=0,a=0,d=1,N=!1,M=!1,D=!1,p=!1;for(;h<l;){let U=!1;const k=r.charCodeAt(h);if(d===13){let W;switch(k){case 40:N=!0,W=0;break;case 41:W=N?0:1;break;case 91:D=!0,M=!0,W=0;break;case 93:D=!1,W=M?0:1;break;case 123:p=!0,W=0;break;case 125:W=p?0:1;break;case 39:W=a===34||a===96?0:1;break;case 34:W=a===39||a===96?0:1;break;case 96:W=a===39||a===34?0:1;break;case 42:W=a===42?1:0;break;case 124:W=a===124?1:0;break;case 32:W=D?0:1;break;default:W=A.get(k)}W===1&&(S.push(w._createLink(A,r,n,_,h)),U=!0)}else if(d===12){let W;k===91?(M=!0,W=0):W=A.get(k),W===1?U=!0:d=13}else d=L.nextState(d,k),d===0&&(U=!0);U&&(d=1,N=!1,M=!1,p=!1,_=h+1,a=k),h++}d===13&&S.push(w._createLink(A,r,n,_,l))}return S}}t.LinkComputer=w;function g(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:w.computeLinks(f)}t.computeLinks=g}),j($[29],V([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class P{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(C,s,E,o,u){if(C&&s){let c=this.doNavigateValueSet(s,u);if(c)return{range:C,value:c}}if(E&&o){let c=this.doNavigateValueSet(o,u);if(c)return{range:E,value:c}}return null}doNavigateValueSet(C,s){let E=this.numberReplace(C,s);return E!==null?E:this.textReplace(C,s)}numberReplace(C,s){let E=Math.pow(10,C.length-(C.lastIndexOf(".")+1)),o=Number(C),u=parseFloat(C);return!isNaN(o)&&!isNaN(u)&&o===u?o===0&&!s?null:(o=Math.floor(o*E),o+=s?E:-E,String(o/E)):null}textReplace(C,s){return this.valueSetsReplace(this._defaultValueSet,C,s)}valueSetsReplace(C,s,E){let o=null;for(let u=0,c=C.length;o===null&&u<c;u++)o=this.valueSetReplace(C[u],s,E);return o}valueSetReplace(C,s,E){let o=C.indexOf(s);return o>=0?(o+=E?1:-1,o<0?o=C.length-1:o%=C.length,C[o]):null}}t.BasicInplaceReplace=P,P.INSTANCE=new P}),j($[30],V([0,1]),function(F,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.IndentAction=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.AccessibilitySupport=void 0;var P;(function(e){e[e.Unknown=0]="Unknown",e[e.Disabled=1]="Disabled",e[e.Enabled=2]="Enabled"})(P=t.AccessibilitySupport||(t.AccessibilitySupport={}));var R;(function(e){e[e.KeepWhitespace=1]="KeepWhitespace",e[e.InsertAsSnippet=4]="InsertAsSnippet"})(R=t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={}));var C;(function(e){e[e.Method=0]="Method",e[e.Function=1]="Function",e[e.Constructor=2]="Constructor",e[e.Field=3]="Field",e[e.Variable=4]="Variable",e[e.Class=5]="Class",e[e.Struct=6]="Struct",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Event=10]="Event",e[e.Operator=11]="Operator",e[e.Unit=12]="Unit",e[e.Value=13]="Value",e[e.Constant=14]="Constant",e[e.Enum=15]="Enum",e[e.EnumMember=16]="EnumMember",e[e.Keyword=17]="Keyword",e[e.Text=18]="Text",e[e.Color=19]="Color",e[e.File=20]="File",e[e.Reference=21]="Reference",e[e.Customcolor=22]="Customcolor",e[e.Folder=23]="Folder",e[e.TypeParameter=24]="TypeParameter",e[e.User=25]="User",e[e.Issue=26]="Issue",e[e.Snippet=27]="Snippet"})(C=t.CompletionItemKind||(t.CompletionItemKind={}));var s;(function(e){e[e.Deprecated=1]="Deprecated"})(s=t.CompletionItemTag||(t.CompletionItemTag={}));var E;(function(e){e[e.Invoke=0]="Invoke",e[e.TriggerCharacter=1]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(E=t.CompletionTriggerKind||(t.CompletionTriggerKind={}));var o;(function(e){e[e.EXACT=0]="EXACT",e[e.ABOVE=1]="ABOVE",e[e.BELOW=2]="BELOW"})(o=t.ContentWidgetPositionPreference||(t.ContentWidgetPositionPreference={}));var u;(function(e){e[e.NotSet=0]="NotSet",e[e.ContentFlush=1]="ContentFlush",e[e.RecoverFromMarkers=2]="RecoverFromMarkers",e[e.Explicit=3]="Explicit",e[e.Paste=4]="Paste",e[e.Undo=5]="Undo",e[e.Redo=6]="Redo"})(u=t.CursorChangeReason||(t.CursorChangeReason={}));var c;(function(e){e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(c=t.DefaultEndOfLine||(t.DefaultEndOfLine={}));var v;(function(e){e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"})(v=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));var w;(function(e){e[e.None=0]="None",e[e.Keep=1]="Keep",e[e.Brackets=2]="Brackets",e[e.Advanced=3]="Advanced",e[e.Full=4]="Full"})(w=t.EditorAutoIndentStrategy||(t.EditorAutoIndentStrategy={}));var g;(function(e){e[e.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",e[e.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",e[e.accessibilitySupport=2]="accessibilitySupport",e[e.accessibilityPageSize=3]="accessibilityPageSize",e[e.ariaLabel=4]="ariaLabel",e[e.autoClosingBrackets=5]="autoClosingBrackets",e[e.autoClosingDelete=6]="autoClosingDelete",e[e.autoClosingOvertype=7]="autoClosingOvertype",e[e.autoClosingQuotes=8]="autoClosingQuotes",e[e.autoIndent=9]="autoIndent",e[e.automaticLayout=10]="automaticLayout",e[e.autoSurround=11]="autoSurround",e[e.bracketPairColorization=12]="bracketPairColorization",e[e.codeLens=13]="codeLens",e[e.codeLensFontFamily=14]="codeLensFontFamily",e[e.codeLensFontSize=15]="codeLensFontSize",e[e.colorDecorators=16]="colorDecorators",e[e.columnSelection=17]="columnSelection",e[e.comments=18]="comments",e[e.contextmenu=19]="contextmenu",e[e.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",e[e.cursorBlinking=21]="cursorBlinking",e[e.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",e[e.cursorStyle=23]="cursorStyle",e[e.cursorSurroundingLines=24]="cursorSurroundingLines",e[e.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",e[e.cursorWidth=26]="cursorWidth",e[e.disableLayerHinting=27]="disableLayerHinting",e[e.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",e[e.domReadOnly=29]="domReadOnly",e[e.dragAndDrop=30]="dragAndDrop",e[e.emptySelectionClipboard=31]="emptySelectionClipboard",e[e.extraEditorClassName=32]="extraEditorClassName",e[e.fastScrollSensitivity=33]="fastScrollSensitivity",e[e.find=34]="find",e[e.fixedOverflowWidgets=35]="fixedOverflowWidgets",e[e.folding=36]="folding",e[e.foldingStrategy=37]="foldingStrategy",e[e.foldingHighlight=38]="foldingHighlight",e[e.foldingImportsByDefault=39]="foldingImportsByDefault",e[e.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",e[e.fontFamily=41]="fontFamily",e[e.fontInfo=42]="fontInfo",e[e.fontLigatures=43]="fontLigatures",e[e.fontSize=44]="fontSize",e[e.fontWeight=45]="fontWeight",e[e.formatOnPaste=46]="formatOnPaste",e[e.formatOnType=47]="formatOnType",e[e.glyphMargin=48]="glyphMargin",e[e.gotoLocation=49]="gotoLocation",e[e.hideCursorInOverviewRuler=50]="hideCursorInOverviewRuler",e[e.highlightActiveIndentGuide=51]="highlightActiveIndentGuide",e[e.hover=52]="hover",e[e.inDiffEditor=53]="inDiffEditor",e[e.inlineSuggest=54]="inlineSuggest",e[e.letterSpacing=55]="letterSpacing",e[e.lightbulb=56]="lightbulb",e[e.lineDecorationsWidth=57]="lineDecorationsWidth",e[e.lineHeight=58]="lineHeight",e[e.lineNumbers=59]="lineNumbers",e[e.lineNumbersMinChars=60]="lineNumbersMinChars",e[e.linkedEditing=61]="linkedEditing",e[e.links=62]="links",e[e.matchBrackets=63]="matchBrackets",e[e.minimap=64]="minimap",e[e.mouseStyle=65]="mouseStyle",e[e.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",e[e.mouseWheelZoom=67]="mouseWheelZoom",e[e.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",e[e.multiCursorModifier=69]="multiCursorModifier",e[e.multiCursorPaste=70]="multiCursorPaste",e[e.occurrencesHighlight=71]="occurrencesHighlight",e[e.overviewRulerBorder=72]="overviewRulerBorder",e[e.overviewRulerLanes=73]="overviewRulerLanes",e[e.padding=74]="padding",e[e.parameterHints=75]="parameterHints",e[e.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",e[e.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",e[e.quickSuggestions=78]="quickSuggestions",e[e.quickSuggestionsDelay=79]="quickSuggestionsDelay",e[e.readOnly=80]="readOnly",e[e.renameOnType=81]="renameOnType",e[e.renderControlCharacters=82]="renderControlCharacters",e[e.renderIndentGuides=83]="renderIndentGuides",e[e.renderFinalNewline=84]="renderFinalNewline",e[e.renderLineHighlight=85]="renderLineHighlight",e[e.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",e[e.renderValidationDecorations=87]="renderValidationDecorations",e[e.renderWhitespace=88]="renderWhitespace",e[e.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",e[e.roundedSelection=90]="roundedSelection",e[e.rulers=91]="rulers",e[e.scrollbar=92]="scrollbar",e[e.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",e[e.scrollBeyondLastLine=94]="scrollBeyondLastLine",e[e.scrollPredominantAxis=95]="scrollPredominantAxis",e[e.selectionClipboard=96]="selectionClipboard",e[e.selectionHighlight=97]="selectionHighlight",e[e.selectOnLineNumbers=98]="selectOnLineNumbers",e[e.showFoldingControls=99]="showFoldingControls",e[e.showUnused=100]="showUnused",e[e.snippetSuggestions=101]="snippetSuggestions",e[e.smartSelect=102]="smartSelect",e[e.smoothScrolling=103]="smoothScrolling",e[e.stickyTabStops=104]="stickyTabStops",e[e.stopRenderingLineAfter=105]="stopRenderingLineAfter",e[e.suggest=106]="suggest",e[e.suggestFontSize=107]="suggestFontSize",e[e.suggestLineHeight=108]="suggestLineHeight",e[e.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",e[e.suggestSelection=110]="suggestSelection",e[e.tabCompletion=111]="tabCompletion",e[e.tabIndex=112]="tabIndex",e[e.unusualLineTerminators=113]="unusualLineTerminators",e[e.useShadowDOM=114]="useShadowDOM",e[e.useTabStops=115]="useTabStops",e[e.wordSeparators=116]="wordSeparators",e[e.wordWrap=117]="wordWrap",e[e.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",e[e.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",e[e.wordWrapColumn=120]="wordWrapColumn",e[e.wordWrapOverride1=121]="wordWrapOverride1",e[e.wordWrapOverride2=122]="wordWrapOverride2",e[e.wrappingIndent=123]="wrappingIndent",e[e.wrappingStrategy=124]="wrappingStrategy",e[e.showDeprecated=125]="showDeprecated",e[e.inlayHints=126]="inlayHints",e[e.editorClassName=127]="editorClassName",e[e.pixelRatio=128]="pixelRatio",e[e.tabFocusMode=129]="tabFocusMode",e[e.layoutInfo=130]="layoutInfo",e[e.wrappingInfo=131]="wrappingInfo"})(g=t.EditorOption||(t.EditorOption={}));var f;(function(e){e[e.TextDefined=0]="TextDefined",e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"})(f=t.EndOfLinePreference||(t.EndOfLinePreference={}));var m;(function(e){e[e.LF=0]="LF",e[e.CRLF=1]="CRLF"})(m=t.EndOfLineSequence||(t.EndOfLineSequence={}));var L;(function(e){e[e.None=0]="None",e[e.Indent=1]="Indent",e[e.IndentOutdent=2]="IndentOutdent",e[e.Outdent=3]="Outdent"})(L=t.IndentAction||(t.IndentAction={}));var A;(function(e){e[e.Other=0]="Other",e[e.Type=1]="Type",e[e.Parameter=2]="Parameter"})(A=t.InlayHintKind||(t.InlayHintKind={}));var S;(function(e){e[e.Automatic=0]="Automatic",e[e.Explicit=1]="Explicit"})(S=t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.KEY_0=21]="KEY_0",e[e.KEY_1=22]="KEY_1",e[e.KEY_2=23]="KEY_2",e[e.KEY_3=24]="KEY_3",e[e.KEY_4=25]="KEY_4",e[e.KEY_5=26]="KEY_5",e[e.KEY_6=27]="KEY_6",e[e.KEY_7=28]="KEY_7",e[e.KEY_8=29]="KEY_8",e[e.KEY_9=30]="KEY_9",e[e.KEY_A=31]="KEY_A",e[e.KEY_B=32]="KEY_B",e[e.KEY_C=33]="KEY_C",e[e.KEY_D=34]="KEY_D",e[e.KEY_E=35]="KEY_E",e[e.KEY_F=36]="KEY_F",e[e.KEY_G=37]="KEY_G",e[e.KEY_H=38]="KEY_H",e[e.KEY_I=39]="KEY_I",e[e.KEY_J=40]="KEY_J",e[e.KEY_K=41]="KEY_K",e[e.KEY_L=42]="KEY_L",e[e.KEY_M=43]="KEY_M",e[e.KEY_N=44]="KEY_N",e[e.KEY_O=45]="KEY_O",e[e.KEY_P=46]="KEY_P",e[e.KEY_Q=47]="KEY_Q",e[e.KEY_R=48]="KEY_R",e[e.KEY_S=49]="KEY_S",e[e.KEY_T=50]="KEY_T",e[e.KEY_U=51]="KEY_U",e[e.KEY_V=52]="KEY_V",e[e.KEY_W=53]="KEY_W",e[e.KEY_X=54]="KEY_X",e[e.KEY_Y=55]="KEY_Y",e[e.KEY_Z=56]="KEY_Z",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.US_SEMICOLON=80]="US_SEMICOLON",e[e.US_EQUAL=81]="US_EQUAL",e[e.US_COMMA=82]="US_COMMA",e[e.US_MINUS=83]="US_MINUS",e[e.US_DOT=84]="US_DOT",e[e.US_SLASH=85]="US_SLASH",e[e.US_BACKTICK=86]="US_BACKTICK",e[e.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",e[e.US_BACKSLASH=88]="US_BACKSLASH",e[e.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",e[e.US_QUOTE=90]="US_QUOTE",e[e.OEM_8=91]="OEM_8",e[e.OEM_102=92]="OEM_102",e[e.NUMPAD_0=93]="NUMPAD_0",e[e.NUMPAD_1=94]="NUMPAD_1",e[e.NUMPAD_2=95]="NUMPAD_2",e[e.NUMPAD_3=96]="NUMPAD_3",e[e.NUMPAD_4=97]="NUMPAD_4",e[e.NUMPAD_5=98]="NUMPAD_5",e[e.NUMPAD_6=99]="NUMPAD_6",e[e.NUMPAD_7=100]="NUMPAD_7",e[e.NUMPAD_8=101]="NUMPAD_8",e[e.NUMPAD_9=102]="NUMPAD_9",e[e.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",e[e.NUMPAD_ADD=104]="NUMPAD_ADD",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",e[e.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",e[e.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.MAX_VALUE=112]="MAX_VALUE"})(n=t.KeyCode||(t.KeyCode={}));var i;(function(e){e[e.Hint=1]="Hint",e[e.Info=2]="Info",e[e.Warning=4]="Warning",e[e.Error=8]="Error"})(i=t.MarkerSeverity||(t.MarkerSeverity={}));var r;(function(e){e[e.Unnecessary=1]="Unnecessary",e[e.Deprecated=2]="Deprecated"})(r=t.MarkerTag||(t.MarkerTag={}));var l;(function(e){e[e.Inline=1]="Inline",e[e.Gutter=2]="Gutter"})(l=t.MinimapPosition||(t.MinimapPosition={}));var h;(function(e){e[e.UNKNOWN=0]="UNKNOWN",e[e.TEXTAREA=1]="TEXTAREA",e[e.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",e[e.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",e[e.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",e[e.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",e[e.CONTENT_TEXT=6]="CONTENT_TEXT",e[e.CONTENT_EMPTY=7]="CONTENT_EMPTY",e[e.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",e[e.CONTENT_WIDGET=9]="CONTENT_WIDGET",e[e.OVERVIEW_RULER=10]="OVERVIEW_RULER",e[e.SCROLLBAR=11]="SCROLLBAR",e[e.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",e[e.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(h=t.MouseTargetType||(t.MouseTargetType={}));var _;(function(e){e[e.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",e[e.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",e[e.TOP_CENTER=2]="TOP_CENTER"})(_=t.OverlayWidgetPositionPreference||(t.OverlayWidgetPositionPreference={}));var a;(function(e){e[e.Left=1]="Left",e[e.Center=2]="Center",e[e.Right=4]="Right",e[e.Full=7]="Full"})(a=t.OverviewRulerLane||(t.OverviewRulerLane={}));var d;(function(e){e[e.Off=0]="Off",e[e.On=1]="On",e[e.Relative=2]="Relative",e[e.Interval=3]="Interval",e[e.Custom=4]="Custom"})(d=t.RenderLineNumbersType||(t.RenderLineNumbersType={}));var N;(function(e){e[e.None=0]="None",e[e.Text=1]="Text",e[e.Blocks=2]="Blocks"})(N=t.RenderMinimap||(t.RenderMinimap={}));var M;(function(e){e[e.Smooth=0]="Smooth",e[e.Immediate=1]="Immediate"})(M=t.ScrollType||(t.ScrollType={}));var D;(function(e){e[e.Auto=1]="Auto",e[e.Hidden=2]="Hidden",e[e.Visible=3]="Visible"})(D=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));var p;(function(e){e[e.LTR=0]="LTR",e[e.RTL=1]="RTL"})(p=t.SelectionDirection||(t.SelectionDirection={}));var U;(function(e){e[e.Invoke=1]="Invoke",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.ContentChange=3]="ContentChange"})(U=t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={}));var k;(function(e){e[e.File=0]="File",e[e.Module=1]="Module",e[e.Namespace=2]="Namespace",e[e.Package=3]="Package",e[e.Class=4]="Class",e[e.Method=5]="Method",e[e.Property=6]="Property",e[e.Field=7]="Field",e[e.Constructor=8]="Constructor",e[e.Enum=9]="Enum",e[e.Interface=10]="Interface",e[e.Function=11]="Function",e[e.Variable=12]="Variable",e[e.Constant=13]="Constant",e[e.String=14]="String",e[e.Number=15]="Number",e[e.Boolean=16]="Boolean",e[e.Array=17]="Array",e[e.Object=18]="Object",e[e.Key=19]="Key",e[e.Null=20]="Null",e[e.EnumMember=21]="EnumMember",e[e.Struct=22]="Struct",e[e.Event=23]="Event",e[e.Operator=24]="Operator",e[e.TypeParameter=25]="TypeParameter"})(k=t.SymbolKind||(t.SymbolKind={}));var W;(function(e){e[e.Deprecated=1]="Deprecated"})(W=t.SymbolTag||(t.SymbolTag={}));var Y;(function(e){e[e.Hidden=0]="Hidden",e[e.Blink=1]="Blink",e[e.Smooth=2]="Smooth",e[e.Phase=3]="Phase",e[e.Expand=4]="Expand",e[e.Solid=5]="Solid"})(Y=t.TextEditorCursorBlinkingStyle||(t.TextEditorCursorBlinkingStyle={}));var Z;(function(e){e[e.Line=1]="Line",e[e.Block=2]="Block",e[e.Underline=3]="Underline",e[e.LineThin=4]="LineThin",e[e.BlockOutline=5]="BlockOutline",e[e.UnderlineThin=6]="UnderlineThin"})(Z=t.TextEditorCursorStyle||(t.TextEditorCursorStyle={}));var z;(function(e){e[e.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",e[e.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",e[e.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",e[e.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(z=t.TrackedRangeStickiness||(t.TrackedRangeStickiness={}));var J;(function(e){e[e.None=0]="None",e[e.Same=1]="Same",e[e.Indent=2]="Indent",e[e.DeepIndent=3]="DeepIndent"})(J=t.WrappingIndent||(t.WrappingIndent={}))}),j($[31],V([0,1,21,10,17,14,3,6,24,25,30]),function(F,t,P,R,C,s,E,o,u,c,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class w{static chord(m,L){return(0,C.KeyChord)(m,L)}}t.KeyMod=w,w.CtrlCmd=2048,w.Shift=1024,w.Alt=512,w.WinCtrl=256;function g(){return{editor:void 0,languages:void 0,CancellationTokenSource:P.CancellationTokenSource,Emitter:R.Emitter,KeyCode:v.KeyCode,KeyMod:w,Position:E.Position,Range:o.Range,Selection:u.Selection,SelectionDirection:v.SelectionDirection,MarkerSeverity:v.MarkerSeverity,MarkerTag:v.MarkerTag,Uri:s.URI,Token:c.Token}}t.createMonacoBaseAPI=g}),j($[32],V([0,1,13]),function(F,t,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumComputer=t.PrefixSumIndexOfResult=void 0;class R{constructor(E,o){this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=o}}t.PrefixSumIndexOfResult=R;class C{constructor(E){this.values=E,this.prefixSum=new Uint32Array(E.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(E,o){E=(0,P.toUint32)(E);const u=this.values,c=this.prefixSum,v=o.length;return v===0?!1:(this.values=new Uint32Array(u.length+v),this.values.set(u.subarray(0,E),0),this.values.set(u.subarray(E),E+v),this.values.set(o,E),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(c.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(E,o){return E=(0,P.toUint32)(E),o=(0,P.toUint32)(o),this.values[E]===o?!1:(this.values[E]=o,E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),!0)}removeValues(E,o){E=(0,P.toUint32)(E),o=(0,P.toUint32)(o);const u=this.values,c=this.prefixSum;if(E>=u.length)return!1;let v=u.length-E;return o>=v&&(o=v),o===0?!1:(this.values=new Uint32Array(u.length-o),this.values.set(u.subarray(0,E),0),this.values.set(u.subarray(E+o),E),this.prefixSum=new Uint32Array(this.values.length),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(c.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(E){return E<0?0:(E=(0,P.toUint32)(E),this._getPrefixSum(E))}_getPrefixSum(E){if(E<=this.prefixSumValidIndex[0])return this.prefixSum[E];let o=this.prefixSumValidIndex[0]+1;o===0&&(this.prefixSum[0]=this.values[0],o++),E>=this.values.length&&(E=this.values.length-1);for(let u=o;u<=E;u++)this.prefixSum[u]=this.prefixSum[u-1]+this.values[u];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],E),this.prefixSum[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let o=0,u=this.values.length-1,c=0,v=0,w=0;for(;o<=u;)if(c=o+(u-o)/2|0,v=this.prefixSum[c],w=v-this.values[c],E<w)u=c-1;else if(E>=v)o=c+1;else break;return new R(c,E-w)}}t.PrefixSumComputer=C}),j($[33],V([0,1,5,3,32]),function(F,t,P,R,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class s{constructor(o,u,c,v){this._uri=o,this._lines=u,this._eol=c,this._versionId=v,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(o){o.eol&&o.eol!==this._eol&&(this._eol=o.eol,this._lineStarts=null);const u=o.changes;for(const c of u)this._acceptDeleteRange(c.range),this._acceptInsertText(new R.Position(c.range.startLineNumber,c.range.startColumn),c.text);this._versionId=o.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const o=this._eol.length,u=this._lines.length,c=new Uint32Array(u);for(let v=0;v<u;v++)c[v]=this._lines[v].length+o;this._lineStarts=new C.PrefixSumComputer(c)}}_setLineText(o,u){this._lines[o]=u,this._lineStarts&&this._lineStarts.changeValue(o,this._lines[o].length+this._eol.length)}_acceptDeleteRange(o){if(o.startLineNumber===o.endLineNumber){if(o.startColumn===o.endColumn)return;this._setLineText(o.startLineNumber-1,this._lines[o.startLineNumber-1].substring(0,o.startColumn-1)+this._lines[o.startLineNumber-1].substring(o.endColumn-1));return}this._setLineText(o.startLineNumber-1,this._lines[o.startLineNumber-1].substring(0,o.startColumn-1)+this._lines[o.endLineNumber-1].substring(o.endColumn-1)),this._lines.splice(o.startLineNumber,o.endLineNumber-o.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(o.startLineNumber,o.endLineNumber-o.startLineNumber)}_acceptInsertText(o,u){if(u.length===0)return;let c=(0,P.splitLines)(u);if(c.length===1){this._setLineText(o.lineNumber-1,this._lines[o.lineNumber-1].substring(0,o.column-1)+c[0]+this._lines[o.lineNumber-1].substring(o.column-1));return}c[c.length-1]+=this._lines[o.lineNumber-1].substring(o.column-1),this._setLineText(o.lineNumber-1,this._lines[o.lineNumber-1].substring(0,o.column-1)+c[0]);let v=new Uint32Array(c.length-1);for(let w=1;w<c.length;w++)this._lines.splice(o.lineNumber+w-1,0,c[w]),v[w-1]=c[w].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(o.lineNumber,v)}}t.MirrorTextModel=s}),j($[35],V([0,1,11,2,14,3,6,26,33,27,28,29,31,12,9]),function(F,t,P,R,C,s,E,o,u,c,v,w,g,f,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=t.MirrorModel=void 0;class L extends u.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,r){let l=(0,c.getWordAtText)(i.column,(0,c.ensureValidWordDefinition)(r),this._lines[i.lineNumber-1],0);return l?new E.Range(i.lineNumber,l.startColumn,i.lineNumber,l.endColumn):null}getWordUntilPosition(i,r){const l=this.getWordAtPosition(i,r);return l?{word:this._lines[i.lineNumber-1].substring(l.startColumn-1,i.column-1),startColumn:l.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const r=this._lines,l=this._wordenize.bind(this);let h=0,_="",a=0,d=[];return{*[Symbol.iterator](){for(;;)if(a<d.length){const N=_.substring(d[a].start,d[a].end);a+=1,yield N}else if(h<r.length)_=r[h],d=l(_,i),a=0,h+=1;else break}}}getLineWords(i,r){let l=this._lines[i-1],h=this._wordenize(l,r),_=[];for(const a of h)_.push({word:l.substring(a.start,a.end),startColumn:a.start+1,endColumn:a.end+1});return _}_wordenize(i,r){const l=[];let h;for(r.lastIndex=0;(h=r.exec(i))&&h[0].length!==0;)l.push({start:h.index,end:h.index+h[0].length});return l}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);let r=this._eol,l=i.startLineNumber-1,h=i.endLineNumber-1,_=[];_.push(this._lines[l].substring(i.startColumn-1));for(let a=l+1;a<h;a++)_.push(this._lines[a]);return _.push(this._lines[h].substring(0,i.endColumn-1)),_.join(r)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();let r=this._lineStarts.getIndexOf(i),l=this._lines[r.index].length;return{lineNumber:1+r.index,column:1+Math.min(r.remainder,l)}}_validateRange(i){const r=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),l=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return r.lineNumber!==i.startLineNumber||r.column!==i.startColumn||l.lineNumber!==i.endLineNumber||l.column!==i.endColumn?{startLineNumber:r.lineNumber,startColumn:r.column,endLineNumber:l.lineNumber,endColumn:l.column}:i}_validatePosition(i){if(!s.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:r,column:l}=i,h=!1;if(r<1)r=1,l=1,h=!0;else if(r>this._lines.length)r=this._lines.length,l=this._lines[r-1].length+1,h=!0;else{let _=this._lines[r-1].length+1;l<1?(l=1,h=!0):l>_&&(l=_,h=!0)}return h?{lineNumber:r,column:l}:i}}t.MirrorModel=L;class A{constructor(i,r){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=r,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){let i=[];return Object.keys(this._models).forEach(r=>i.push(this._models[r])),i}acceptNewModel(i){this._models[i.url]=new L(C.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,r){if(!this._models[i])return;this._models[i].onEvents(r)}acceptRemovedModel(i){!this._models[i]||delete this._models[i]}async computeDiff(i,r,l,h){const _=this._getModel(i),a=this._getModel(r);if(!_||!a)return null;const d=_.getLinesContent(),N=a.getLinesContent(),D=new o.DiffComputer(d,N,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:l,shouldMakePrettyDiff:!0,maxComputationTime:h}).computeDiff(),p=D.changes.length>0?!1:this._modelsAreIdentical(_,a);return{quitEarly:D.quitEarly,identical:p,changes:D.changes}}_modelsAreIdentical(i,r){const l=i.getLineCount(),h=r.getLineCount();if(l!==h)return!1;for(let _=1;_<=l;_++){const a=i.getLineContent(_),d=r.getLineContent(_);if(a!==d)return!1}return!0}async computeDirtyDiff(i,r,l){let h=this._getModel(i),_=this._getModel(r);if(!h||!_)return null;let a=h.getLinesContent(),d=_.getLinesContent();return new o.DiffComputer(a,d,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:l,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(i,r){const l=this._getModel(i);if(!l)return r;const h=[];let _;r=r.slice(0).sort((a,d)=>{if(a.range&&d.range)return E.Range.compareRangesUsingStarts(a.range,d.range);let N=a.range?0:1,M=d.range?0:1;return N-M});for(let{range:a,text:d,eol:N}of r){if(typeof N=="number"&&(_=N),E.Range.isEmpty(a)&&!d)continue;const M=l.getValueInRange(a);if(d=d.replace(/\r\n|\n|\r/g,l.eol),M===d)continue;if(Math.max(d.length,M.length)>A._diffLimit){h.push({range:a,text:d});continue}const D=(0,P.stringDiff)(M,d,!1),p=l.offsetAt(E.Range.lift(a).getStartPosition());for(const U of D){const k=l.positionAt(p+U.originalStart),W=l.positionAt(p+U.originalStart+U.originalLength),Y={text:d.substr(U.modifiedStart,U.modifiedLength),range:{startLineNumber:k.lineNumber,startColumn:k.column,endLineNumber:W.lineNumber,endColumn:W.column}};l.getValueInRange(Y.range)!==Y.text&&h.push(Y)}}return typeof _=="number"&&h.push({eol:_,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),h}async computeLinks(i){let r=this._getModel(i);return r?(0,v.computeLinks)(r):null}async textualSuggest(i,r,l,h){const _=new m.StopWatch(!0),a=new RegExp(l,h),d=new Set;e:for(let N of i){const M=this._getModel(N);if(!!M){for(let D of M.words(a))if(!(D===r||!isNaN(Number(D)))&&(d.add(D),d.size>A._suggestionsLimit))break e}}return{words:Array.from(d),duration:_.elapsed()}}async computeWordRanges(i,r,l,h){let _=this._getModel(i);if(!_)return Object.create(null);const a=new RegExp(l,h),d=Object.create(null);for(let N=r.startLineNumber;N<r.endLineNumber;N++){let M=_.getLineWords(N,a);for(const D of M){if(!isNaN(Number(D.word)))continue;let p=d[D.word];p||(p=[],d[D.word]=p),p.push({startLineNumber:N,startColumn:D.startColumn,endLineNumber:N,endColumn:D.endColumn})}}return d}async navigateValueSet(i,r,l,h,_){let a=this._getModel(i);if(!a)return null;let d=new RegExp(h,_);r.startColumn===r.endColumn&&(r={startLineNumber:r.startLineNumber,startColumn:r.startColumn,endLineNumber:r.endLineNumber,endColumn:r.endColumn+1});let N=a.getValueInRange(r),M=a.getWordAtPosition({lineNumber:r.startLineNumber,column:r.startColumn},d);if(!M)return null;let D=a.getValueInRange(M);return w.BasicInplaceReplace.INSTANCE.navigateValueSet(r,N,M,D,l)}loadForeignModule(i,r,l){const h=(d,N)=>this._host.fhr(d,N);let a={host:f.createProxyObject(l,h),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(a,r),Promise.resolve(f.getAllMethodNames(this._foreignModule))):new Promise((d,N)=>{F([i],M=>{this._foreignModule=M.create(a,r),d(f.getAllMethodNames(this._foreignModule))},N)})}fmr(i,r){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,r))}catch(l){return Promise.reject(l)}}}t.EditorSimpleWorker=A,A._diffLimit=1e5,A._suggestionsLimit=1e4;function S(n){return new A(n,null)}t.create=S,typeof importScripts=="function"&&(R.globals.monaco=(0,g.createMonacoBaseAPI)())}),function(){const F=self.MonacoEnvironment,t=F&&F.baseUrl?F.baseUrl:"../../../",P=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:u=>u,createScript:(u,...c)=>{const v=c.slice(0,-1).join(","),w=c.pop().toString();return`(function anonymous(${v}) {
${w}
})`}}):void 0;function R(){try{return(P?self.eval(P.createScript("","true")):new Function("true")).call(self),!0}catch(u){return!1}}function C(){return new Promise((u,c)=>{if(typeof self.define=="function"&&self.define.amd)return u();const v=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(v)&&v.substring(0,self.origin.length)!==self.origin)&&R()){fetch(v).then(g=>{if(g.status!==200)throw new Error(g.statusText);return g.text()}).then(g=>{g=`${g}
//# sourceURL=${v}`,(P?self.eval(P.createScript("",g)):new Function(g)).call(self),u()}).then(void 0,c);return}P?importScripts(P.createScriptURL(v)):importScripts(v),u()})}const s=function(u){C().then(()=>{require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:P}),require([u],function(c){setTimeout(function(){let v=c.create((w,g)=>{self.postMessage(w,g)},null);for(self.onmessage=w=>v.onmessage(w.data);o.length>0;)self.onmessage(o.shift())},0)})})};let E=!0,o=[];self.onmessage=u=>{if(!E){o.push(u);return}E=!1,s(u.data)}}()}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0c83ca1ced83259971d80890d93abbe19cbfc992/core/vs/base/worker/workerMain.js.map
