/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/errors","vs/base/common/buffer","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/workspaces/common/workspaces","vs/base/common/uuid","vs/platform/telemetry/common/telemetry","vs/base/common/extpath","fs","vs/base/common/arrays","vs/base/common/process","vs/base/common/labels","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/product/common/product","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],x=function(K){for(var e=[],v=0,L=K.length;v<L;v++)e[v]=Z[K[v]];return e};define(Z[102],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(L,k){if(!L)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=v}),define(Z[47],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(E){return(n,f,w)=>{let t=null,I=null;if(typeof w.value=="function"?(t="value",I=w.value):typeof w.get=="function"&&(t="get",I=w.get),!I)throw new Error("not supported");w[t]=E(I,f)}}e.createDecorator=v;function L(E,n,f){let w=null,t=null;if(typeof f.value=="function"?(w="value",t=f.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(w="get",t=f.get),!t)throw new Error("not supported");const I=`$memoize$${n}`;f[w]=function(...b){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,b)}),this[I]}}e.memoize=L;function k(E,n,f){return v((w,t)=>{const I=`$debounce$${t}`,b=`$debounce$result$${t}`;return function(...y){this[b]||(this[b]=f?f():void 0),clearTimeout(this[I]),n&&(this[b]=n(this[b],...y),y=[this[b]]),this[I]=setTimeout(()=>{w.apply(this,y),this[b]=f?f():void 0},E)}})}e.debounce=k;function M(E,n,f){return v((w,t)=>{const I=`$throttle$timer$${t}`,b=`$throttle$result$${t}`,y=`$throttle$lastRun$${t}`,h=`$throttle$pending$${t}`;return function(...g){if(this[b]||(this[b]=f?f():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),n&&(this[b]=n(this[b],...g)),this[h])return;const P=this[y]+E;P<=Date.now()?(this[y]=Date.now(),w.apply(this,[this[b]]),this[b]=f?f():void 0):(this[h]=!0,this[I]=setTimeout(()=>{this[h]=!1,this[y]=Date.now(),w.apply(this,[this[b]]),this[b]=f?f():void 0},P-Date.now()))}})}e.throttle=M}),define(Z[17],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(a=>{a(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=v,e.errorHandler=new v;function L(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=L;function k(u){f(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=k;function M(u){f(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=M;function E(u){if(u instanceof Error){let{name:i,message:a}=u;const r=u.stacktrace||u.stack;return{$isError:!0,name:i,message:a,stack:r}}return u}e.transformErrorForSerialization=E;const n="Canceled";function f(u){return u instanceof Error&&u.name===n&&u.message===n}e.isPromiseCanceledError=f;class w extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=w;function t(){const u=new Error(n);return u.name=u.message,u}e.canceled=t;function I(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=I;function b(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=b;function y(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function h(u){const i=new Error(`${u} has been disposed`);return i.name="DISPOSED",i}e.disposed=h;function g(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=g;class P extends Error{constructor(i){super("NotImplemented");i&&(this.message=i)}}e.NotImplementedError=P;class p extends Error{constructor(i){super("NotSupported");i&&(this.message=i)}}e.NotSupportedError=p;class c extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=c;function d(u){const i=u;return i instanceof Error&&Array.isArray(i.actions)}e.isErrorWithActions=d;function o(u,i=Object.create(null)){const a=new Error(u);return i.actions&&(a.actions=i.actions),a}e.createErrorWithActions=o}),define(Z[32],x([0,1,17]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(T,A=0){return T[T.length-(1+A)]}e.tail=L;function k(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.tail2=k;function M(T,A,O=(z,N)=>z===N){if(T===A)return!0;if(!T||!A||T.length!==A.length)return!1;for(let z=0,N=T.length;z<N;z++)if(!O(T[z],A[z]))return!1;return!0}e.equals=M;function E(T,A,O){let z=0,N=T.length-1;for(;z<=N;){const C=(z+N)/2|0,q=O(T[C],A);if(q<0)z=C+1;else if(q>0)N=C-1;else return C}return-(z+1)}e.binarySearch=E;function n(T,A){let O=0,z=T.length;if(z===0)return 0;for(;O<z;){const N=Math.floor((O+z)/2);A(T[N])?z=N:O=N+1}return O}e.findFirstInSorted=n;function f(T,A,O){if(T=T|0,T>=A.length)throw new TypeError("invalid index");let z=A[Math.floor(A.length*Math.random())],N=[],C=[],q=[];for(let Q of A){const ie=O(Q,z);ie<0?N.push(Q):ie>0?C.push(Q):q.push(Q)}return T<N.length?f(T,N,O):T<N.length+q.length?q[0]:f(T-(N.length+q.length),C,O)}e.quickSelect=f;function w(T,A){const O=[];let z;for(const N of T.slice(0).sort(A))!z||A(z[0],N)!==0?(z=[N],O.push(z)):z.push(N);return O}e.groupBy=w;function t(T,A,O){const z=[];function N(Q,ie,oe){if(ie===0&&oe.length===0)return;const ae=z[z.length-1];ae&&ae.start+ae.deleteCount===Q?(ae.deleteCount+=ie,ae.toInsert.push(...oe)):z.push({start:Q,deleteCount:ie,toInsert:oe})}let C=0,q=0;for(;;){if(C===T.length){N(C,0,A.slice(q));break}if(q===A.length){N(C,T.length-C,[]);break}const Q=T[C],ie=A[q],oe=O(Q,ie);oe===0?(C+=1,q+=1):oe<0?(N(C,1,[]),C+=1):oe>0&&(N(C,0,[ie]),q+=1)}return z}e.sortedDiff=t;function I(T,A,O){const z=t(T,A,O),N=[],C=[];for(const q of z)N.push(...T.slice(q.start,q.start+q.deleteCount)),C.push(...q.toInsert);return{removed:N,added:C}}e.delta=I;function b(T,A,O){if(O===0)return[];const z=T.slice(0,O).sort(A);return h(T,A,z,O,T.length),z}e.top=b;function y(T,A,O,z,N){return O===0?Promise.resolve([]):new Promise((C,q)=>{(async()=>{const Q=T.length,ie=T.slice(0,O).sort(A);for(let oe=O,ae=Math.min(O+z,Q);oe<Q;oe=ae,ae=Math.min(ae+z,Q)){if(oe>O&&await new Promise(ee=>setTimeout(ee)),N&&N.isCancellationRequested)throw(0,v.canceled)();h(T,A,ie,oe,ae)}return ie})().then(C,q)})}e.topAsync=y;function h(T,A,O,z,N){for(const C=O.length;z<N;z++){const q=T[z];if(A(q,O[C-1])<0){O.pop();const Q=n(O,ie=>A(q,ie)<0);O.splice(Q,0,q)}}}function g(T){return T.filter(A=>!!A)}e.coalesce=g;function P(T){let A=0;for(let O=0;O<T.length;O++)T[O]&&(T[A]=T[O],A+=1);T.length=A}e.coalesceInPlace=P;function p(T,A,O){T.splice(O,0,T.splice(A,1)[0])}e.move=p;function c(T){return!Array.isArray(T)||T.length===0}e.isFalsyOrEmpty=c;function d(T){return Array.isArray(T)&&T.length>0}e.isNonEmptyArray=d;function o(T,A){if(!A)return T.filter((z,N)=>T.indexOf(z)===N);const O=Object.create(null);return T.filter(z=>{const N=A(z);return O[N]?!1:(O[N]=!0,!0)})}e.distinct=o;function u(T){const A=new Set;return T.filter(O=>A.has(O)?!1:(A.add(O),!0))}e.distinctES6=u;function i(T){const A=Object.create(null);return O=>{const z=T(O);return A[z]?!1:(A[z]=!0,!0)}}e.uniqueFilter=i;function a(T,A){for(let O=T.length-1;O>=0;O--){const z=T[O];if(A(z))return O}return-1}e.lastIndex=a;function r(T,A){return T.length>0?T[0]:A}e.firstOrDefault=r;function s(T,A,O=(z,N)=>z===N){let z=0;for(let N=0,C=Math.min(T.length,A.length);N<C&&O(T[N],A[N]);N++)z++;return z}e.commonPrefixLength=s;function l(T){return[].concat(...T)}e.flatten=l;function m(T,A){let O=typeof A=="number"?T:0;typeof A=="number"?O=T:(O=0,A=T);const z=[];if(O<=A)for(let N=O;N<A;N++)z.push(N);else for(let N=O;N>A;N--)z.push(N);return z}e.range=m;function S(T,A,O){return T.reduce((z,N)=>(z[A(N)]=O?O(N):N,z),Object.create(null))}e.index=S;function D(T,A){return T.push(A),()=>R(T,A)}e.insert=D;function R(T,A){const O=T.indexOf(A);if(O>-1)return T.splice(O,1),A}e.remove=R;function F(T,A,O){const z=T.slice(0,A),N=T.slice(A);return z.concat(O,N)}e.arrayInsert=F;function U(T,A){let O;if(typeof A=="number"){let z=A;O=()=>{const N=Math.sin(z++)*179426549;return N-Math.floor(N)}}else O=Math.random;for(let z=T.length-1;z>0;z-=1){const N=Math.floor(O()*(z+1)),C=T[z];T[z]=T[N],T[N]=C}}e.shuffle=U;function X(T,A){const O=T.indexOf(A);O>-1&&(T.splice(O,1),T.unshift(A))}e.pushToStart=X;function ne(T,A){const O=T.indexOf(A);O>-1&&(T.splice(O,1),T.push(A))}e.pushToEnd=ne;function se(T,A){return Array.isArray(T)?T.map(A):A(T)}e.mapArrayOrNot=se;function G(T){return Array.isArray(T)?T:[T]}e.asArray=G;function J(T){return T[Math.floor(Math.random()*T.length)]}e.getRandomElement=J;function W(T,A){for(const O of T){const z=A(O);if(z!==void 0)return z}}e.mapFind=W;function V(T,A,O){const z=$(T,A),N=T.length,C=O.length;T.length=N+C;for(let q=N-1;q>=z;q--)T[q+C]=T[q];for(let q=0;q<C;q++)T[q+z]=O[q]}e.insertInto=V;function B(T,A,O,z){const N=$(T,A),C=T.splice(N,O);return V(T,N,z),C}e.splice=B;function $(T,A){return A<0?Math.max(A+T.length,0):Math.min(A,T.length)}function H(T,A){let O=Number.MAX_SAFE_INTEGER,z=0;return T.forEach((N,C)=>{const q=A(N);q<O&&(O=q,z=C)}),z}e.minIndex=H;function _(T,A){let O=Number.MIN_SAFE_INTEGER,z=0;return T.forEach((N,C)=>{const q=A(N);q>O&&(O=q,z=C)}),z}e.maxIndex=_;class j{constructor(A){this.items=A,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(A){let O=this.firstIdx;for(;O<this.items.length&&A(this.items[O]);)O++;const z=O===this.firstIdx?null:this.items.slice(this.firstIdx,O);return this.firstIdx=O,z}takeFromEndWhile(A){let O=this.lastIdx;for(;O>=0&&A(this.items[O]);)O--;const z=O===this.lastIdx?null:this.items.slice(O+1,this.lastIdx+1);return this.lastIdx=O,z}}e.ArrayQueue=j}),define(Z[43],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(L){const k=this;let M=!1,E;return function(){return M||(M=!0,E=L.apply(k,arguments)),E}}e.once=v}),define(Z[64],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(L){function k(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}L.is=k;const M=Object.freeze([]);function E(){return M}L.empty=E;function*n(u){yield u}L.single=n;function f(u){return u||M}L.from=f;function w(u){return!u||u[Symbol.iterator]().next().done===!0}L.isEmpty=w;function t(u){return u[Symbol.iterator]().next().value}L.first=t;function I(u,i){for(const a of u)if(i(a))return!0;return!1}L.some=I;function b(u,i){for(const a of u)if(i(a))return a}L.find=b;function*y(u,i){for(const a of u)i(a)&&(yield a)}L.filter=y;function*h(u,i){let a=0;for(const r of u)yield i(r,a++)}L.map=h;function*g(...u){for(const i of u)for(const a of i)yield a}L.concat=g;function*P(u){for(const i of u)for(const a of i)yield a}L.concatNested=P;function p(u,i,a){let r=a;for(const s of u)r=i(r,s);return r}L.reduce=p;function*c(u,i,a=u.length){for(i<0&&(i+=u.length),a<0?a+=u.length:a>u.length&&(a=u.length);i<a;i++)yield u[i]}L.slice=c;function d(u,i=Number.POSITIVE_INFINITY){const a=[];if(i===0)return[a,u];const r=u[Symbol.iterator]();for(let s=0;s<i;s++){const l=r.next();if(l.done)return[a,L.empty()];a.push(l.value)}return[a,{[Symbol.iterator](){return r}}]}L.consume=d;function o(u,i,a=(r,s)=>r===s){const r=u[Symbol.iterator](),s=i[Symbol.iterator]();for(;;){const l=r.next(),m=s.next();if(l.done!==m.done)return!1;if(l.done)return!0;if(!a(l.value,m.value))return!1}}L.equals=o})(v=e.Iterable||(e.Iterable={}))}),define(Z[40],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var L;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function E(i,a=!1){let r=0,s=i.length,l="",m=0,S=16,D=0;function R(J){let W=0,V=0;for(;W<J;){const B=i.charCodeAt(r);if(B>=48&&B<=57)V=V*16+B-48;else if(B>=65&&B<=70)V=V*16+B-65+10;else if(B>=97&&B<=102)V=V*16+B-97+10;else break;r++,W++}return W<J&&(V=-1),V}function F(J){r=J,l="",m=0,S=16,D=0}function U(){const J=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&w(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&w(i.charCodeAt(r)))for(r++;r<i.length&&w(i.charCodeAt(r));)r++;else return D=3,i.substring(J,r);let W=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&w(i.charCodeAt(r))){for(r++;r<i.length&&w(i.charCodeAt(r));)r++;W=r}else D=3;return i.substring(J,W)}function X(){let J="",W=r;for(;;){if(r>=s){J+=i.substring(W,r),D=2;break}const V=i.charCodeAt(r);if(V===34){J+=i.substring(W,r),r++;break}if(V===92){if(J+=i.substring(W,r),r++,r>=s){D=2;break}switch(i.charCodeAt(r++)){case 34:J+='"';break;case 92:J+="\\";break;case 47:J+="/";break;case 98:J+="\b";break;case 102:J+="\f";break;case 110:J+=`
`;break;case 114:J+="\r";break;case 116:J+="	";break;case 117:const $=R(4);$>=0?J+=String.fromCharCode($):D=4;break;default:D=5}W=r;continue}if(V>=0&&V<=31)if(f(V)){J+=i.substring(W,r),D=2;break}else D=6;r++}return J}function ne(){if(l="",D=0,m=r,r>=s)return m=s,S=17;let J=i.charCodeAt(r);if(n(J)){do r++,l+=String.fromCharCode(J),J=i.charCodeAt(r);while(n(J));return S=15}if(f(J))return r++,l+=String.fromCharCode(J),J===13&&i.charCodeAt(r)===10&&(r++,l+=`
`),S=14;switch(J){case 123:return r++,S=1;case 125:return r++,S=2;case 91:return r++,S=3;case 93:return r++,S=4;case 58:return r++,S=6;case 44:return r++,S=5;case 34:return r++,l=X(),S=10;case 47:const W=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<s&&!f(i.charCodeAt(r));)r++;return l=i.substring(W,r),S=12}if(i.charCodeAt(r+1)===42){r+=2;const V=s-1;let B=!1;for(;r<V;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,B=!0;break}r++}return B||(r++,D=1),l=i.substring(W,r),S=13}return l+=String.fromCharCode(J),r++,S=16;case 45:if(l+=String.fromCharCode(J),r++,r===s||!w(i.charCodeAt(r)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=U(),S=11;default:for(;r<s&&se(J);)r++,J=i.charCodeAt(r);if(m!==r){switch(l=i.substring(m,r),l){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return l+=String.fromCharCode(J),r++,S=16}}function se(J){if(n(J)||f(J))return!1;switch(J){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let J;do J=ne();while(J>=12&&J<=15);return J}return{setPosition:F,getPosition:()=>r,scan:a?G:ne,getToken:()=>S,getTokenValue:()=>l,getTokenOffset:()=>m,getTokenLength:()=>r-m,getTokenError:()=>D}}e.createScanner=E;function n(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function f(i){return i===10||i===13||i===8232||i===8233}function w(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function I(i,a){const r=[],s=new Object;let l;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function D(R,F,U,X){m.value=R,m.offset=F,m.length=U,m.type=X,m.colonOffset=void 0,l=m}try{d(i,{onObjectBegin:(R,F)=>{if(a<=R)throw s;l=void 0,S=a>R,r.push("")},onObjectProperty:(R,F,U)=>{if(a<F||(D(R,F,U,"property"),r[r.length-1]=R,a<=F+U))throw s},onObjectEnd:(R,F)=>{if(a<=R)throw s;l=void 0,r.pop()},onArrayBegin:(R,F)=>{if(a<=R)throw s;l=void 0,r.push(0)},onArrayEnd:(R,F)=>{if(a<=R)throw s;l=void 0,r.pop()},onLiteralValue:(R,F,U)=>{if(a<F||(D(R,F,U,u(R)),a<=F+U))throw s},onSeparator:(R,F,U)=>{if(a<=F)throw s;if(R===":"&&l&&l.type==="property")l.colonOffset=F,S=!1,l=void 0;else if(R===","){const X=r[r.length-1];typeof X=="number"?r[r.length-1]=X+1:(S=!0,r[r.length-1]=""),l=void 0}}})}catch(R){if(R!==s)throw R}return{path:r,previousNode:l,isAtPropertyKey:S,matches:R=>{let F=0;for(let U=0;F<R.length&&U<r.length;U++)if(R[F]===r[U]||R[F]==="*")F++;else if(R[F]!=="**")return!1;return F===R.length}}}e.getLocation=I;function b(i,a=[],r=M.DEFAULT){let s=null,l=[];const m=[];function S(R){Array.isArray(l)?l.push(R):s!==null&&(l[s]=R)}return d(i,{onObjectBegin:()=>{const R={};S(R),m.push(l),l=R,s=null},onObjectProperty:R=>{s=R},onObjectEnd:()=>{l=m.pop()},onArrayBegin:()=>{const R=[];S(R),m.push(l),l=R,s=null},onArrayEnd:()=>{l=m.pop()},onLiteralValue:S,onError:(R,F,U)=>{a.push({error:R,offset:F,length:U})}},r),l[0]}e.parse=b;function y(i,a=[],r=M.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(R){s.type==="property"&&(s.length=R-s.offset,s=s.parent)}function m(R){return s.children.push(R),R}d(i,{onObjectBegin:R=>{s=m({type:"object",offset:R,length:-1,parent:s,children:[]})},onObjectProperty:(R,F,U)=>{s=m({type:"property",offset:F,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:R,offset:F,length:U,parent:s})},onObjectEnd:(R,F)=>{s.length=R+F-s.offset,s=s.parent,l(R+F)},onArrayBegin:(R,F)=>{s=m({type:"array",offset:R,length:-1,parent:s,children:[]})},onArrayEnd:(R,F)=>{s.length=R+F-s.offset,s=s.parent,l(R+F)},onLiteralValue:(R,F,U)=>{m({type:u(R),offset:F,length:U,parent:s,value:R}),l(F+U)},onSeparator:(R,F,U)=>{s.type==="property"&&(R===":"?s.colonOffset=F:R===","&&l(F))},onError:(R,F,U)=>{a.push({error:R,offset:F,length:U})}},r);const D=s.children[0];return D&&delete D.parent,D}e.parseTree=y;function h(i,a){if(!i)return;let r=i;for(let s of a)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let l=!1;for(const m of r.children)if(Array.isArray(m.children)&&m.children[0].value===s){r=m.children[1],l=!0;break}if(!l)return}else{const l=s;if(r.type!=="array"||l<0||!Array.isArray(r.children)||l>=r.children.length)return;r=r.children[l]}return r}e.findNodeAtLocation=h;function g(i){if(!i.parent||!i.parent.children)return[];const a=g(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;a.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&a.push(r)}return a}e.getNodePath=g;function P(i){switch(i.type){case"array":return i.children.map(P);case"object":const a=Object.create(null);for(let r of i.children){const s=r.children[1];s&&(a[r.children[0].value]=P(s))}return a;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=P;function p(i,a,r=!1){return a>=i.offset&&a<i.offset+i.length||r&&a===i.offset+i.length}e.contains=p;function c(i,a,r=!1){if(p(i,a,r)){const s=i.children;if(Array.isArray(s))for(let l=0;l<s.length&&s[l].offset<=a;l++){const m=c(s[l],a,r);if(m)return m}return i}}e.findNodeAtOffset=c;function d(i,a,r=M.DEFAULT){const s=E(i,!1);function l(O){return O?()=>O(s.getTokenOffset(),s.getTokenLength()):()=>!0}function m(O){return O?z=>O(z,s.getTokenOffset(),s.getTokenLength()):()=>!0}const S=l(a.onObjectBegin),D=m(a.onObjectProperty),R=l(a.onObjectEnd),F=l(a.onArrayBegin),U=l(a.onArrayEnd),X=m(a.onLiteralValue),ne=m(a.onSeparator),se=l(a.onComment),G=m(a.onError),J=r&&r.disallowComments,W=r&&r.allowTrailingComma;function V(){for(;;){const O=s.scan();switch(s.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:J||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(O){case 12:case 13:J?B(10):se();break;case 16:B(1);break;case 15:case 14:break;default:return O}}}function B(O,z=[],N=[]){if(G(O),z.length+N.length>0){let C=s.getToken();for(;C!==17;){if(z.indexOf(C)!==-1){V();break}else if(N.indexOf(C)!==-1)break;C=V()}}}function $(O){const z=s.getTokenValue();return O?X(z):D(z),V(),!0}function H(){switch(s.getToken()){case 11:let O=0;try{O=JSON.parse(s.getTokenValue()),typeof O!="number"&&(B(2),O=0)}catch(z){B(2)}X(O);break;case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return V(),!0}function _(){return s.getToken()!==10?(B(3,[],[2,5]),!1):($(!1),s.getToken()===6?(ne(":"),V(),A()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function j(){S(),V();let O=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(O||B(4,[],[]),ne(","),V(),s.getToken()===2&&W)break}else O&&B(6,[],[]);_()||B(4,[],[2,5]),O=!0}return R(),s.getToken()!==2?B(7,[2],[]):V(),!0}function T(){F(),V();let O=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(O||B(4,[],[]),ne(","),V(),s.getToken()===4&&W)break}else O&&B(6,[],[]);A()||B(4,[],[4,5]),O=!0}return U(),s.getToken()!==4?B(8,[4],[]):V(),!0}function A(){switch(s.getToken()){case 3:return T();case 1:return j();case 10:return $(!0);default:return H()}}return V(),s.getToken()===17?r.allowEmptyContent?!0:(B(4,[],[]),!1):A()?(s.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=d;function o(i,a){let r=E(i),s=[],l,m=0,S;do switch(S=r.getPosition(),l=r.scan(),l){case 12:case 13:case 17:m!==S&&s.push(i.substring(m,S)),a!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,a)),m=r.getPosition();break}while(l!==17);return s.join("")}e.stripComments=o;function u(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(Z[103],x([0,1,40]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(f,w,t){let I,b,y,h,g;if(w){for(h=w.offset,g=h+w.length,y=h;y>0&&!n(f,y-1);)y--;let m=g;for(;m<f.length&&!n(f,m);)m++;b=f.substring(y,m),I=M(b,t)}else b=f,I=0,y=0,h=0,g=f.length;const P=E(t,f);let p=!1,c=0,d;t.insertSpaces?d=k(" ",t.tabSize||4):d="	";const o=(0,v.createScanner)(b,!1);let u=!1;function i(){return P+k(d,I+c)}function a(){let m=o.scan();for(p=!1;m===15||m===14;)p=p||m===14,m=o.scan();return u=m===16||o.getTokenError()!==0,m}const r=[];function s(m,S,D){!u&&S<g&&D>h&&f.substring(S,D)!==m&&r.push({offset:S,length:D-S,content:m})}let l=a();if(l!==17){const m=o.getTokenOffset()+y,S=k(d,I);s(S,y,m)}for(;l!==17;){let m=o.getTokenOffset()+o.getTokenLength()+y,S=a(),D="";for(;!p&&(S===12||S===13);){const F=o.getTokenOffset()+y;s(" ",m,F),m=o.getTokenOffset()+o.getTokenLength()+y,D=S===12?i():"",S=a()}if(S===2)l!==1&&(c--,D=i());else if(S===4)l!==3&&(c--,D=i());else{switch(l){case 3:case 1:c++,D=i();break;case 5:case 12:D=i();break;case 13:p?D=i():D=" ";break;case 6:D=" ";break;case 10:if(S===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:S===12||S===13?D=" ":S!==5&&S!==17&&(u=!0);break;case 16:u=!0;break}p&&(S===12||S===13)&&(D=i())}const R=o.getTokenOffset()+y;s(D,m,R),l=S}return r}e.format=L;function k(f,w){let t="";for(let I=0;I<w;I++)t+=f;return t}function M(f,w){let t=0,I=0;const b=w.tabSize||4;for(;t<f.length;){const y=f.charAt(t);if(y===" ")I++;else if(y==="	")I+=b;else break;t++}return Math.floor(I/b)}function E(f,w){for(let t=0;t<w.length;t++){const I=w.charAt(t);if(I==="\r")return t+1<w.length&&w.charAt(t+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return f&&f.eol||`
`}e.getEOL=E;function n(f,w){return`\r
`.indexOf(f.charAt(w))!==-1}e.isEOL=n}),define(Z[77],x([0,1,40,103]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(w,t,I){return M(w,t,void 0,I)}e.removeProperty=k;function M(w,t,I,b,y){const h=t.slice(),g=[],P=(0,v.parseTree)(w,g);let p,c;for(;h.length>0&&(c=h.pop(),p=(0,v.findNodeAtLocation)(P,h),p===void 0&&I!==void 0);)typeof c=="string"?I={[c]:I}:I=[I];if(p)if(p.type==="object"&&typeof c=="string"&&Array.isArray(p.children)){const d=(0,v.findNodeAtLocation)(p,[c]);if(d!==void 0)if(I===void 0){if(!d.parent)throw new Error("Malformed AST");const o=p.children.indexOf(d.parent);let u,i=d.parent.offset+d.parent.length;if(o>0){const a=p.children[o-1];u=a.offset+a.length}else u=p.offset+1,p.children.length>1&&(i=p.children[1].offset);return E(w,{offset:u,length:i-u,content:""},b)}else return E(w,{offset:d.offset,length:d.length,content:JSON.stringify(I)},b);else{if(I===void 0)return[];const o=`${JSON.stringify(c)}: ${JSON.stringify(I)}`,u=y?y(p.children.map(a=>a.children[0].value)):p.children.length;let i;if(u>0){const a=p.children[u-1];i={offset:a.offset+a.length,length:0,content:","+o}}else p.children.length===0?i={offset:p.offset+1,length:0,content:o}:i={offset:p.offset+1,length:0,content:o+","};return E(w,i,b)}}else if(p.type==="array"&&typeof c=="number"&&Array.isArray(p.children))if(I!==void 0){const d=`${JSON.stringify(I)}`;let o;if(p.children.length===0||c===0)o={offset:p.offset+1,length:0,content:p.children.length===0?d:d+","};else{const u=c===-1||c>p.children.length?p.children.length:c,i=p.children[u-1];o={offset:i.offset+i.length,length:0,content:","+d}}return E(w,o,b)}else{const d=c,o=p.children[d];let u;if(p.children.length===1)u={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===d){const i=p.children[d-1],a=i.offset+i.length,r=p.offset+p.length;u={offset:a,length:r-2-a,content:""}}else u={offset:o.offset,length:p.children[d+1].offset-o.offset,content:""};return E(w,u,b)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${p.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return E(w,{offset:P?P.offset:0,length:P?P.length:0,content:JSON.stringify(I)},b)}}e.setProperty=M;function E(w,t,I){let b=n(w,t),y=t.offset,h=t.offset+t.content.length;if(t.length===0||t.content.length===0){for(;y>0&&!(0,L.isEOL)(b,y-1);)y--;for(;h<b.length&&!(0,L.isEOL)(b,h);)h++}const g=(0,L.format)(b,{offset:y,length:h-y},I);for(let p=g.length-1;p>=0;p--){const c=g[p];b=n(b,c),y=Math.min(y,c.offset),h=Math.max(h,c.offset+c.length),h+=c.content.length-c.length}const P=w.length-(b.length-h)-y;return[{offset:y,length:P,content:b.substring(y,h)}]}e.withFormatting=E;function n(w,t){return w.substring(0,t.offset)+t.content+w.substring(t.offset+t.length)}e.applyEdit=n;function f(w,t){let I=t.slice(0).sort((y,h)=>{const g=y.offset-h.offset;return g===0?y.length-h.length:g}),b=w.length;for(let y=I.length-1;y>=0;y--){let h=I[y];if(h.offset+h.length<=b)w=n(w,h);else throw new Error("Overlapping edit");b=h.offset}return w}e.applyEdits=f}),define(Z[57],x([0,1,17]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var L;(function(c){c[c.DependsOnKbLayout=-1]="DependsOnKbLayout",c[c.Unknown=0]="Unknown",c[c.Backspace=1]="Backspace",c[c.Tab=2]="Tab",c[c.Enter=3]="Enter",c[c.Shift=4]="Shift",c[c.Ctrl=5]="Ctrl",c[c.Alt=6]="Alt",c[c.PauseBreak=7]="PauseBreak",c[c.CapsLock=8]="CapsLock",c[c.Escape=9]="Escape",c[c.Space=10]="Space",c[c.PageUp=11]="PageUp",c[c.PageDown=12]="PageDown",c[c.End=13]="End",c[c.Home=14]="Home",c[c.LeftArrow=15]="LeftArrow",c[c.UpArrow=16]="UpArrow",c[c.RightArrow=17]="RightArrow",c[c.DownArrow=18]="DownArrow",c[c.Insert=19]="Insert",c[c.Delete=20]="Delete",c[c.KEY_0=21]="KEY_0",c[c.KEY_1=22]="KEY_1",c[c.KEY_2=23]="KEY_2",c[c.KEY_3=24]="KEY_3",c[c.KEY_4=25]="KEY_4",c[c.KEY_5=26]="KEY_5",c[c.KEY_6=27]="KEY_6",c[c.KEY_7=28]="KEY_7",c[c.KEY_8=29]="KEY_8",c[c.KEY_9=30]="KEY_9",c[c.KEY_A=31]="KEY_A",c[c.KEY_B=32]="KEY_B",c[c.KEY_C=33]="KEY_C",c[c.KEY_D=34]="KEY_D",c[c.KEY_E=35]="KEY_E",c[c.KEY_F=36]="KEY_F",c[c.KEY_G=37]="KEY_G",c[c.KEY_H=38]="KEY_H",c[c.KEY_I=39]="KEY_I",c[c.KEY_J=40]="KEY_J",c[c.KEY_K=41]="KEY_K",c[c.KEY_L=42]="KEY_L",c[c.KEY_M=43]="KEY_M",c[c.KEY_N=44]="KEY_N",c[c.KEY_O=45]="KEY_O",c[c.KEY_P=46]="KEY_P",c[c.KEY_Q=47]="KEY_Q",c[c.KEY_R=48]="KEY_R",c[c.KEY_S=49]="KEY_S",c[c.KEY_T=50]="KEY_T",c[c.KEY_U=51]="KEY_U",c[c.KEY_V=52]="KEY_V",c[c.KEY_W=53]="KEY_W",c[c.KEY_X=54]="KEY_X",c[c.KEY_Y=55]="KEY_Y",c[c.KEY_Z=56]="KEY_Z",c[c.Meta=57]="Meta",c[c.ContextMenu=58]="ContextMenu",c[c.F1=59]="F1",c[c.F2=60]="F2",c[c.F3=61]="F3",c[c.F4=62]="F4",c[c.F5=63]="F5",c[c.F6=64]="F6",c[c.F7=65]="F7",c[c.F8=66]="F8",c[c.F9=67]="F9",c[c.F10=68]="F10",c[c.F11=69]="F11",c[c.F12=70]="F12",c[c.F13=71]="F13",c[c.F14=72]="F14",c[c.F15=73]="F15",c[c.F16=74]="F16",c[c.F17=75]="F17",c[c.F18=76]="F18",c[c.F19=77]="F19",c[c.NumLock=78]="NumLock",c[c.ScrollLock=79]="ScrollLock",c[c.US_SEMICOLON=80]="US_SEMICOLON",c[c.US_EQUAL=81]="US_EQUAL",c[c.US_COMMA=82]="US_COMMA",c[c.US_MINUS=83]="US_MINUS",c[c.US_DOT=84]="US_DOT",c[c.US_SLASH=85]="US_SLASH",c[c.US_BACKTICK=86]="US_BACKTICK",c[c.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",c[c.US_BACKSLASH=88]="US_BACKSLASH",c[c.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",c[c.US_QUOTE=90]="US_QUOTE",c[c.OEM_8=91]="OEM_8",c[c.OEM_102=92]="OEM_102",c[c.NUMPAD_0=93]="NUMPAD_0",c[c.NUMPAD_1=94]="NUMPAD_1",c[c.NUMPAD_2=95]="NUMPAD_2",c[c.NUMPAD_3=96]="NUMPAD_3",c[c.NUMPAD_4=97]="NUMPAD_4",c[c.NUMPAD_5=98]="NUMPAD_5",c[c.NUMPAD_6=99]="NUMPAD_6",c[c.NUMPAD_7=100]="NUMPAD_7",c[c.NUMPAD_8=101]="NUMPAD_8",c[c.NUMPAD_9=102]="NUMPAD_9",c[c.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",c[c.NUMPAD_ADD=104]="NUMPAD_ADD",c[c.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",c[c.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",c[c.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",c[c.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",c[c.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",c[c.ABNT_C1=110]="ABNT_C1",c[c.ABNT_C2=111]="ABNT_C2",c[c.MAX_VALUE=112]="MAX_VALUE"})(L=e.KeyCode||(e.KeyCode={}));class k{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(d,o){this._keyCodeToStr[d]=o,this._strToKeyCode[o.toLowerCase()]=d}keyCodeToStr(d){return this._keyCodeToStr[d]}strToKeyCode(d){return this._strToKeyCode[d.toLowerCase()]||0}}const M=new k,E=new k,n=new k;(function(){function c(d,o,u=o,i=u){M.define(d,o),E.define(d,u),n.define(d,i)}c(0,"unknown"),c(1,"Backspace"),c(2,"Tab"),c(3,"Enter"),c(4,"Shift"),c(5,"Ctrl"),c(6,"Alt"),c(7,"PauseBreak"),c(8,"CapsLock"),c(9,"Escape"),c(10,"Space"),c(11,"PageUp"),c(12,"PageDown"),c(13,"End"),c(14,"Home"),c(15,"LeftArrow","Left"),c(16,"UpArrow","Up"),c(17,"RightArrow","Right"),c(18,"DownArrow","Down"),c(19,"Insert"),c(20,"Delete"),c(21,"0"),c(22,"1"),c(23,"2"),c(24,"3"),c(25,"4"),c(26,"5"),c(27,"6"),c(28,"7"),c(29,"8"),c(30,"9"),c(31,"A"),c(32,"B"),c(33,"C"),c(34,"D"),c(35,"E"),c(36,"F"),c(37,"G"),c(38,"H"),c(39,"I"),c(40,"J"),c(41,"K"),c(42,"L"),c(43,"M"),c(44,"N"),c(45,"O"),c(46,"P"),c(47,"Q"),c(48,"R"),c(49,"S"),c(50,"T"),c(51,"U"),c(52,"V"),c(53,"W"),c(54,"X"),c(55,"Y"),c(56,"Z"),c(57,"Meta"),c(58,"ContextMenu"),c(59,"F1"),c(60,"F2"),c(61,"F3"),c(62,"F4"),c(63,"F5"),c(64,"F6"),c(65,"F7"),c(66,"F8"),c(67,"F9"),c(68,"F10"),c(69,"F11"),c(70,"F12"),c(71,"F13"),c(72,"F14"),c(73,"F15"),c(74,"F16"),c(75,"F17"),c(76,"F18"),c(77,"F19"),c(78,"NumLock"),c(79,"ScrollLock"),c(80,";",";","OEM_1"),c(81,"=","=","OEM_PLUS"),c(82,",",",","OEM_COMMA"),c(83,"-","-","OEM_MINUS"),c(84,".",".","OEM_PERIOD"),c(85,"/","/","OEM_2"),c(86,"`","`","OEM_3"),c(110,"ABNT_C1"),c(111,"ABNT_C2"),c(87,"[","[","OEM_4"),c(88,"\\","\\","OEM_5"),c(89,"]","]","OEM_6"),c(90,"'","'","OEM_7"),c(91,"OEM_8"),c(92,"OEM_102"),c(93,"NumPad0"),c(94,"NumPad1"),c(95,"NumPad2"),c(96,"NumPad3"),c(97,"NumPad4"),c(98,"NumPad5"),c(99,"NumPad6"),c(100,"NumPad7"),c(101,"NumPad8"),c(102,"NumPad9"),c(103,"NumPad_Multiply"),c(104,"NumPad_Add"),c(105,"NumPad_Separator"),c(106,"NumPad_Subtract"),c(107,"NumPad_Decimal"),c(108,"NumPad_Divide")})();var f;(function(c){function d(r){return M.keyCodeToStr(r)}c.toString=d;function o(r){return M.strToKeyCode(r)}c.fromString=o;function u(r){return E.keyCodeToStr(r)}c.toUserSettingsUS=u;function i(r){return n.keyCodeToStr(r)}c.toUserSettingsGeneral=i;function a(r){return E.strToKeyCode(r)||n.strToKeyCode(r)}c.fromUserSettings=a})(f=e.KeyCodeUtils||(e.KeyCodeUtils={}));var w;(function(c){c[c.CtrlCmd=2048]="CtrlCmd",c[c.Shift=1024]="Shift",c[c.Alt=512]="Alt",c[c.WinCtrl=256]="WinCtrl",c[c.KeyCode=255]="KeyCode"})(w||(w={}));var t;(function(c){c[c.CtrlCmd=2048]="CtrlCmd",c[c.Shift=1024]="Shift",c[c.Alt=512]="Alt",c[c.WinCtrl=256]="WinCtrl"})(t=e.KeyMod||(e.KeyMod={}));function I(c,d){const o=(d&65535)<<16>>>0;return(c|o)>>>0}e.KeyChord=I;function b(c,d){if(c===0)return null;const o=(c&65535)>>>0,u=(c&4294901760)>>>16;return u!==0?new g([y(o,d),y(u,d)]):new g([y(o,d)])}e.createKeybinding=b;function y(c,d){const o=!!(c&2048),u=!!(c&256),i=d===2?u:o,a=!!(c&1024),r=!!(c&512),s=d===2?o:u,l=c&255;return new h(i,a,r,s,l)}e.createSimpleKeybinding=y;class h{constructor(d,o,u,i,a){this.ctrlKey=d,this.shiftKey=o,this.altKey=u,this.metaKey=i,this.keyCode=a}equals(d){return this.ctrlKey===d.ctrlKey&&this.shiftKey===d.shiftKey&&this.altKey===d.altKey&&this.metaKey===d.metaKey&&this.keyCode===d.keyCode}getHashCode(){const d=this.ctrlKey?"1":"0",o=this.shiftKey?"1":"0",u=this.altKey?"1":"0",i=this.metaKey?"1":"0";return`${d}${o}${u}${i}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new g([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=h;class g{constructor(d){if(d.length===0)throw(0,v.illegalArgument)("parts");this.parts=d}getHashCode(){let d="";for(let o=0,u=this.parts.length;o<u;o++)o!==0&&(d+=";"),d+=this.parts[o].getHashCode();return d}equals(d){if(d===null||this.parts.length!==d.parts.length)return!1;for(let o=0;o<this.parts.length;o++)if(!this.parts[o].equals(d.parts[o]))return!1;return!0}}e.ChordKeybinding=g;class P{constructor(d,o,u,i,a,r){this.ctrlKey=d,this.shiftKey=o,this.altKey=u,this.metaKey=i,this.keyLabel=a,this.keyAriaLabel=r}}e.ResolvedKeybindingPart=P;class p{}e.ResolvedKeybinding=p}),define(Z[2],x([0,1,43,64]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let M=null;function E(r){M=r}if(e.setDisposableTracker=E,k){const r="__is_disposable_tracked__";E(new class{trackDisposable(s){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[r]||console.log(l)},3e3)}setParent(s,l){if(s&&s!==c.None)try{s[r]=!0}catch{}}markAsDisposed(s){if(s&&s!==c.None)try{s[r]=!0}catch{}}markAsSingleton(s){}})}function n(r){return M?.trackDisposable(r),r}function f(r){M?.markAsDisposed(r)}function w(r,s){M?.setParent(r,s)}function t(r,s){if(!!M)for(const l of r)M.setParent(l,s)}function I(r){return M?.markAsSingleton(r),r}e.markAsSingleton=I;class b extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=b;function y(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=y;function h(r){if(L.Iterable.is(r)){let s=[];for(const l of r)if(l)try{l.dispose()}catch(m){s.push(m)}if(s.length===1)throw s[0];if(s.length>1)throw new b(s);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=h;function g(...r){const s=P(()=>h(r));return t(r,s),s}e.combinedDisposable=g;function P(r){const s=n({dispose:(0,v.once)(()=>{f(s),r()})});return s}e.toDisposable=P;class p{constructor(){this._toDispose=new Set,this._isDisposed=!1,n(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return w(s,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=p,p.DISABLE_DISPOSED_WARNING=!1;class c{constructor(){this._store=new p,n(this),w(this._store,this)}dispose(){f(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=c,c.None=Object.freeze({dispose(){}});class d{constructor(){this._isDisposed=!1,n(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&w(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&w(s,null),s}}e.MutableDisposable=d;class o{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class u{constructor(){this.references=new Map}acquire(s,...l){let m=this.references.get(s);m||(m={counter:0,object:this.createReferencedObject(s,...l)},this.references.set(s,m));const{object:S}=m,D=(0,v.once)(()=>{--m.counter==0&&(this.destroyReferencedObject(s,m.object),this.references.delete(s))});return m.counter++,{object:S,dispose:D}}}e.ReferenceCollection=u;class i{constructor(s){this.referenceCollection=s}async acquire(s,...l){const m=this.referenceCollection.acquire(s,...l);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(S){throw m.dispose(),S}}}e.AsyncReferenceCollection=i;class a{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=a}),define(Z[104],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(M){this.element=M,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class L{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let M=this._first;for(;M!==v.Undefined;){const E=M.next;M.prev=v.Undefined,M.next=v.Undefined,M=E}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(M){return this._insert(M,!1)}push(M){return this._insert(M,!0)}_insert(M,E){const n=new v(M);if(this._first===v.Undefined)this._first=n,this._last=n;else if(E){const w=this._last;this._last=n,n.prev=w,w.next=n}else{const w=this._first;this._first=n,n.next=w,w.prev=n}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(n))}}shift(){if(this._first!==v.Undefined){const M=this._first.element;return this._remove(this._first),M}}pop(){if(this._last!==v.Undefined){const M=this._last.element;return this._remove(this._last),M}}_remove(M){if(M.prev!==v.Undefined&&M.next!==v.Undefined){const E=M.prev;E.next=M.next,M.next.prev=E}else M.prev===v.Undefined&&M.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):M.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):M.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let M=this._first;for(;M!==v.Undefined;)yield M.element,M=M.next}}e.LinkedList=L}),function(){function K(k){const M=[];typeof k=="number"&&M.push("code/timeOrigin",k);function E(f){M.push(f,Date.now())}function n(){const f=[];for(let w=0;w<M.length;w+=2)f.push({name:M[w],startTime:M[w+1]});return f}return{mark:E,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const E of performance.getEntriesByType("mark"))M.push({name:E.name,startTime:Math.round(k+E.startTime)});return M}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function v(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=v(L))}(),define(Z[3],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const v="en";let L=!1,k=!1,M=!1,E=!1,n=!1,f=!1,w=!1,t,I=v,b,y;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const g=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=g&&h?.sandboxed,typeof navigator=="object"&&!g)y=navigator.userAgent,L=y.indexOf("Windows")>=0,k=y.indexOf("Macintosh")>=0,w=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=y.indexOf("Linux")>=0,f=!0,t=navigator.language,I=t;else if(typeof h=="object"){L=h.platform==="win32",k=h.platform==="darwin",M=h.platform==="linux",E=M&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,t=v,I=v;const r=h.env.VSCODE_NLS_CONFIG;if(r)try{const s=JSON.parse(r),l=s.availableLanguages["*"];t=s.locale,I=l||v,b=s._translationsConfigFile}catch(s){}n=!0}else console.error("Unable to resolve platform.");var P;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(P=e.Platform||(e.Platform={}));function p(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=p;let c=0;k?c=1:L?c=3:M&&(c=2),e.isWindows=L,e.isMacintosh=k,e.isLinux=M,e.isLinuxSnap=E,e.isNative=n,e.isWeb=f,e.isIOS=w,e.platform=c,e.userAgent=y,e.language=I;var d;(function(r){function s(){return e.language}r.value=s;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=l;function m(){return e.language==="en"}r.isDefault=m})(d=e.Language||(e.Language={})),e.locale=t,e.translationsConfigFile=b,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeSetImmediateId)for(let D=0,R=l.length;D<R;D++){const F=l[D];if(F.id===S.data.vscodeSetImmediateId){l.splice(D,1),F.callback();return}}});let m=0;return S=>{const D=++m;l.push({id:D,callback:S}),e.globals.postMessage({vscodeSetImmediateId:D},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const s=Promise.resolve();return l=>s.then(l)}();var o;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||w?2:L?1:3;let u=!0,i=!1;function a(){if(!i){i=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,u=new Uint16Array(r.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=a}),define(Z[33],x([0,1,3]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const k=v.globals.vscode.process;L={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()},nextTick(M){return(0,v.setImmediate)(M)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:L={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},nextTick(k){return(0,v.setImmediate)(k)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(Z[8],x([0,1,33]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,k=97,M=90,E=122,n=46,f=47,w=92,t=58,I=63;class b extends Error{constructor(o,u,i){let a;typeof u=="string"&&u.indexOf("not ")===0?(a="must not be",u=u.replace(/^not /,"")):a="must be";const r=o.indexOf(".")!==-1?"property":"argument";let s=`The "${o}" ${r} ${a} of type ${u}`;s+=`. Received type ${typeof i}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function y(d,o){if(typeof d!="string")throw new b(o,"string",d)}function h(d){return d===f||d===w}function g(d){return d===f}function P(d){return d>=L&&d<=M||d>=k&&d<=E}function p(d,o,u,i){let a="",r=0,s=-1,l=0,m=0;for(let S=0;S<=d.length;++S){if(S<d.length)m=d.charCodeAt(S);else{if(i(m))break;m=f}if(i(m)){if(!(s===S-1||l===1))if(l===2){if(a.length<2||r!==2||a.charCodeAt(a.length-1)!==n||a.charCodeAt(a.length-2)!==n){if(a.length>2){const D=a.lastIndexOf(u);D===-1?(a="",r=0):(a=a.slice(0,D),r=a.length-1-a.lastIndexOf(u)),s=S,l=0;continue}else if(a.length!==0){a="",r=0,s=S,l=0;continue}}o&&(a+=a.length>0?`${u}..`:"..",r=2)}else a.length>0?a+=`${u}${d.slice(s+1,S)}`:a=d.slice(s+1,S),r=S-s-1;s=S,l=0}else m===n&&l!==-1?++l:l=-1}return a}function c(d,o){if(o===null||typeof o!="object")throw new b("pathObject","Object",o);const u=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return u?u===o.root?`${u}${i}`:`${u}${d}${i}`:i}e.win32={resolve(...d){let o="",u="",i=!1;for(let a=d.length-1;a>=-1;a--){let r;if(a>=0){if(r=d[a],y(r,"path"),r.length===0)continue}else o.length===0?r=v.cwd():(r=v.env[`=${o}`]||v.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===w)&&(r=`${o}\\`));const s=r.length;let l=0,m="",S=!1;const D=r.charCodeAt(0);if(s===1)h(D)&&(l=1,S=!0);else if(h(D))if(S=!0,h(r.charCodeAt(1))){let R=2,F=R;for(;R<s&&!h(r.charCodeAt(R));)R++;if(R<s&&R!==F){const U=r.slice(F,R);for(F=R;R<s&&h(r.charCodeAt(R));)R++;if(R<s&&R!==F){for(F=R;R<s&&!h(r.charCodeAt(R));)R++;(R===s||R!==F)&&(m=`\\\\${U}\\${r.slice(F,R)}`,l=R)}}}else l=1;else P(D)&&r.charCodeAt(1)===t&&(m=r.slice(0,2),l=2,s>2&&h(r.charCodeAt(2))&&(S=!0,l=3));if(m.length>0)if(o.length>0){if(m.toLowerCase()!==o.toLowerCase())continue}else o=m;if(i){if(o.length>0)break}else if(u=`${r.slice(l)}\\${u}`,i=S,S&&o.length>0)break}return u=p(u,!i,"\\",h),i?`${o}\\${u}`:`${o}${u}`||"."},normalize(d){y(d,"path");const o=d.length;if(o===0)return".";let u=0,i,a=!1;const r=d.charCodeAt(0);if(o===1)return g(r)?"\\":d;if(h(r))if(a=!0,h(d.charCodeAt(1))){let l=2,m=l;for(;l<o&&!h(d.charCodeAt(l));)l++;if(l<o&&l!==m){const S=d.slice(m,l);for(m=l;l<o&&h(d.charCodeAt(l));)l++;if(l<o&&l!==m){for(m=l;l<o&&!h(d.charCodeAt(l));)l++;if(l===o)return`\\\\${S}\\${d.slice(m)}\\`;l!==m&&(i=`\\\\${S}\\${d.slice(m,l)}`,u=l)}}}else u=1;else P(r)&&d.charCodeAt(1)===t&&(i=d.slice(0,2),u=2,o>2&&h(d.charCodeAt(2))&&(a=!0,u=3));let s=u<o?p(d.slice(u),!a,"\\",h):"";return s.length===0&&!a&&(s="."),s.length>0&&h(d.charCodeAt(o-1))&&(s+="\\"),i===void 0?a?`\\${s}`:s:a?`${i}\\${s}`:`${i}${s}`},isAbsolute(d){y(d,"path");const o=d.length;if(o===0)return!1;const u=d.charCodeAt(0);return h(u)||o>2&&P(u)&&d.charCodeAt(1)===t&&h(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let o,u;for(let r=0;r<d.length;++r){const s=d[r];y(s,"path"),s.length>0&&(o===void 0?o=u=s:o+=`\\${s}`)}if(o===void 0)return".";let i=!0,a=0;if(typeof u=="string"&&h(u.charCodeAt(0))){++a;const r=u.length;r>1&&h(u.charCodeAt(1))&&(++a,r>2&&(h(u.charCodeAt(2))?++a:i=!1))}if(i){for(;a<o.length&&h(o.charCodeAt(a));)a++;a>=2&&(o=`\\${o.slice(a)}`)}return e.win32.normalize(o)},relative(d,o){if(y(d,"from"),y(o,"to"),d===o)return"";const u=e.win32.resolve(d),i=e.win32.resolve(o);if(u===i||(d=u.toLowerCase(),o=i.toLowerCase(),d===o))return"";let a=0;for(;a<d.length&&d.charCodeAt(a)===w;)a++;let r=d.length;for(;r-1>a&&d.charCodeAt(r-1)===w;)r--;const s=r-a;let l=0;for(;l<o.length&&o.charCodeAt(l)===w;)l++;let m=o.length;for(;m-1>l&&o.charCodeAt(m-1)===w;)m--;const S=m-l,D=s<S?s:S;let R=-1,F=0;for(;F<D;F++){const X=d.charCodeAt(a+F);if(X!==o.charCodeAt(l+F))break;X===w&&(R=F)}if(F!==D){if(R===-1)return i}else{if(S>D){if(o.charCodeAt(l+F)===w)return i.slice(l+F+1);if(F===2)return i.slice(l+F)}s>D&&(d.charCodeAt(a+F)===w?R=F:F===2&&(R=3)),R===-1&&(R=0)}let U="";for(F=a+R+1;F<=r;++F)(F===r||d.charCodeAt(F)===w)&&(U+=U.length===0?"..":"\\..");return l+=R,U.length>0?`${U}${i.slice(l,m)}`:(i.charCodeAt(l)===w&&++l,i.slice(l,m))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const o=e.win32.resolve(d);if(o.length<=2)return d;if(o.charCodeAt(0)===w){if(o.charCodeAt(1)===w){const u=o.charCodeAt(2);if(u!==I&&u!==n)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(P(o.charCodeAt(0))&&o.charCodeAt(1)===t&&o.charCodeAt(2)===w)return`\\\\?\\${o}`;return d},dirname(d){y(d,"path");const o=d.length;if(o===0)return".";let u=-1,i=0;const a=d.charCodeAt(0);if(o===1)return h(a)?d:".";if(h(a)){if(u=i=1,h(d.charCodeAt(1))){let l=2,m=l;for(;l<o&&!h(d.charCodeAt(l));)l++;if(l<o&&l!==m){for(m=l;l<o&&h(d.charCodeAt(l));)l++;if(l<o&&l!==m){for(m=l;l<o&&!h(d.charCodeAt(l));)l++;if(l===o)return d;l!==m&&(u=i=l+1)}}}}else P(a)&&d.charCodeAt(1)===t&&(u=o>2&&h(d.charCodeAt(2))?3:2,i=u);let r=-1,s=!0;for(let l=o-1;l>=i;--l)if(h(d.charCodeAt(l))){if(!s){r=l;break}}else s=!1;if(r===-1){if(u===-1)return".";r=u}return d.slice(0,r)},basename(d,o){o!==void 0&&y(o,"ext"),y(d,"path");let u=0,i=-1,a=!0,r;if(d.length>=2&&P(d.charCodeAt(0))&&d.charCodeAt(1)===t&&(u=2),o!==void 0&&o.length>0&&o.length<=d.length){if(o===d)return"";let s=o.length-1,l=-1;for(r=d.length-1;r>=u;--r){const m=d.charCodeAt(r);if(h(m)){if(!a){u=r+1;break}}else l===-1&&(a=!1,l=r+1),s>=0&&(m===o.charCodeAt(s)?--s==-1&&(i=r):(s=-1,i=l))}return u===i?i=l:i===-1&&(i=d.length),d.slice(u,i)}for(r=d.length-1;r>=u;--r)if(h(d.charCodeAt(r))){if(!a){u=r+1;break}}else i===-1&&(a=!1,i=r+1);return i===-1?"":d.slice(u,i)},extname(d){y(d,"path");let o=0,u=-1,i=0,a=-1,r=!0,s=0;d.length>=2&&d.charCodeAt(1)===t&&P(d.charCodeAt(0))&&(o=i=2);for(let l=d.length-1;l>=o;--l){const m=d.charCodeAt(l);if(h(m)){if(!r){i=l+1;break}continue}a===-1&&(r=!1,a=l+1),m===n?u===-1?u=l:s!==1&&(s=1):u!==-1&&(s=-1)}return u===-1||a===-1||s===0||s===1&&u===a-1&&u===i+1?"":d.slice(u,a)},format:c.bind(null,"\\"),parse(d){y(d,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return o;const u=d.length;let i=0,a=d.charCodeAt(0);if(u===1)return h(a)?(o.root=o.dir=d,o):(o.base=o.name=d,o);if(h(a)){if(i=1,h(d.charCodeAt(1))){let R=2,F=R;for(;R<u&&!h(d.charCodeAt(R));)R++;if(R<u&&R!==F){for(F=R;R<u&&h(d.charCodeAt(R));)R++;if(R<u&&R!==F){for(F=R;R<u&&!h(d.charCodeAt(R));)R++;R===u?i=R:R!==F&&(i=R+1)}}}}else if(P(a)&&d.charCodeAt(1)===t){if(u<=2)return o.root=o.dir=d,o;if(i=2,h(d.charCodeAt(2))){if(u===3)return o.root=o.dir=d,o;i=3}}i>0&&(o.root=d.slice(0,i));let r=-1,s=i,l=-1,m=!0,S=d.length-1,D=0;for(;S>=i;--S){if(a=d.charCodeAt(S),h(a)){if(!m){s=S+1;break}continue}l===-1&&(m=!1,l=S+1),a===n?r===-1?r=S:D!==1&&(D=1):r!==-1&&(D=-1)}return l!==-1&&(r===-1||D===0||D===1&&r===l-1&&r===s+1?o.base=o.name=d.slice(s,l):(o.name=d.slice(s,r),o.base=d.slice(s,l),o.ext=d.slice(r,l))),s>0&&s!==i?o.dir=d.slice(0,s-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let o="",u=!1;for(let i=d.length-1;i>=-1&&!u;i--){const a=i>=0?d[i]:v.cwd();y(a,"path"),a.length!==0&&(o=`${a}/${o}`,u=a.charCodeAt(0)===f)}return o=p(o,!u,"/",g),u?`/${o}`:o.length>0?o:"."},normalize(d){if(y(d,"path"),d.length===0)return".";const o=d.charCodeAt(0)===f,u=d.charCodeAt(d.length-1)===f;return d=p(d,!o,"/",g),d.length===0?o?"/":u?"./":".":(u&&(d+="/"),o?`/${d}`:d)},isAbsolute(d){return y(d,"path"),d.length>0&&d.charCodeAt(0)===f},join(...d){if(d.length===0)return".";let o;for(let u=0;u<d.length;++u){const i=d[u];y(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.posix.normalize(o)},relative(d,o){if(y(d,"from"),y(o,"to"),d===o||(d=e.posix.resolve(d),o=e.posix.resolve(o),d===o))return"";const u=1,i=d.length,a=i-u,r=1,s=o.length-r,l=a<s?a:s;let m=-1,S=0;for(;S<l;S++){const R=d.charCodeAt(u+S);if(R!==o.charCodeAt(r+S))break;R===f&&(m=S)}if(S===l)if(s>l){if(o.charCodeAt(r+S)===f)return o.slice(r+S+1);if(S===0)return o.slice(r+S)}else a>l&&(d.charCodeAt(u+S)===f?m=S:S===0&&(m=0));let D="";for(S=u+m+1;S<=i;++S)(S===i||d.charCodeAt(S)===f)&&(D+=D.length===0?"..":"/..");return`${D}${o.slice(r+m)}`},toNamespacedPath(d){return d},dirname(d){if(y(d,"path"),d.length===0)return".";const o=d.charCodeAt(0)===f;let u=-1,i=!0;for(let a=d.length-1;a>=1;--a)if(d.charCodeAt(a)===f){if(!i){u=a;break}}else i=!1;return u===-1?o?"/":".":o&&u===1?"//":d.slice(0,u)},basename(d,o){o!==void 0&&y(o,"ext"),y(d,"path");let u=0,i=-1,a=!0,r;if(o!==void 0&&o.length>0&&o.length<=d.length){if(o===d)return"";let s=o.length-1,l=-1;for(r=d.length-1;r>=0;--r){const m=d.charCodeAt(r);if(m===f){if(!a){u=r+1;break}}else l===-1&&(a=!1,l=r+1),s>=0&&(m===o.charCodeAt(s)?--s==-1&&(i=r):(s=-1,i=l))}return u===i?i=l:i===-1&&(i=d.length),d.slice(u,i)}for(r=d.length-1;r>=0;--r)if(d.charCodeAt(r)===f){if(!a){u=r+1;break}}else i===-1&&(a=!1,i=r+1);return i===-1?"":d.slice(u,i)},extname(d){y(d,"path");let o=-1,u=0,i=-1,a=!0,r=0;for(let s=d.length-1;s>=0;--s){const l=d.charCodeAt(s);if(l===f){if(!a){u=s+1;break}continue}i===-1&&(a=!1,i=s+1),l===n?o===-1?o=s:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||i===-1||r===0||r===1&&o===i-1&&o===u+1?"":d.slice(o,i)},format:c.bind(null,"/"),parse(d){y(d,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return o;const u=d.charCodeAt(0)===f;let i;u?(o.root="/",i=1):i=0;let a=-1,r=0,s=-1,l=!0,m=d.length-1,S=0;for(;m>=i;--m){const D=d.charCodeAt(m);if(D===f){if(!l){r=m+1;break}continue}s===-1&&(l=!1,s=m+1),D===n?a===-1?a=m:S!==1&&(S=1):a!==-1&&(S=-1)}if(s!==-1){const D=r===0&&u?1:r;a===-1||S===0||S===1&&a===s-1&&a===r+1?o.base=o.name=d.slice(D,s):(o.name=d.slice(D,a),o.base=d.slice(D,s),o.ext=d.slice(a,s))}return r>0?o.dir=d.slice(0,r-1):u&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[105],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var v;(function(M){M[M.stdout=0]="stdout",M[M.stderr=1]="stderr"})(v=e.Source||(e.Source={}));var L;(function(M){M[M.Success=0]="Success",M[M.Unknown=1]="Unknown",M[M.AccessDenied=2]="AccessDenied",M[M.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(M,...E){const n=E.reduce((t,I)=>(t[I]=!0,t),{}),f=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(M).filter(t=>!n[t]).forEach(t=>{for(let I=0;I<f.length;I++)if(t.search(f[I])!==-1){delete M[t];break}})}e.sanitizeProcessEnvironment=k}),define(Z[78],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var v;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(v=e.ScanCode||(e.ScanCode={}));const L=[],k=Object.create(null),M=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>M[n]||0,toEnum:n=>k[n]||0,toString:n=>L[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class E{constructor(f,w,t,I,b){this.ctrlKey=f,this.shiftKey=w,this.altKey=t,this.metaKey=I,this.scanCode=b}equals(f){return this.ctrlKey===f.ctrlKey&&this.shiftKey===f.shiftKey&&this.altKey===f.altKey&&this.metaKey===f.metaKey&&this.scanCode===f.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=E,function(){function n(f,w){L[f]=w,k[w]=f,M[w.toLowerCase()]=f}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let f=0;f<=193;f++)e.IMMUTABLE_CODE_TO_KEY_CODE[f]=-1;for(let f=0;f<=112;f++)e.IMMUTABLE_KEY_CODE_TO_CODE[f]=-1;function n(f,w){e.IMMUTABLE_CODE_TO_KEY_CODE[f]=w,w!==0&&w!==3&&w!==5&&w!==4&&w!==6&&w!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[w]=f)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(Z[106],x([0,1,57,78]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class k{static _readModifiers(E){E=E.toLowerCase().trim();let n=!1,f=!1,w=!1,t=!1,I;do I=!1,/^ctrl(\+|\-)/.test(E)&&(n=!0,E=E.substr("ctrl-".length),I=!0),/^shift(\+|\-)/.test(E)&&(f=!0,E=E.substr("shift-".length),I=!0),/^alt(\+|\-)/.test(E)&&(w=!0,E=E.substr("alt-".length),I=!0),/^meta(\+|\-)/.test(E)&&(t=!0,E=E.substr("meta-".length),I=!0),/^win(\+|\-)/.test(E)&&(t=!0,E=E.substr("win-".length),I=!0),/^cmd(\+|\-)/.test(E)&&(t=!0,E=E.substr("cmd-".length),I=!0);while(I);let b;const y=E.indexOf(" ");return y>0?(b=E.substring(0,y),E=E.substring(y)):(b=E,E=""),{remains:E,ctrl:n,shift:f,alt:w,meta:t,key:b}}static parseSimpleKeybinding(E){const n=this._readModifiers(E),f=v.KeyCodeUtils.fromUserSettings(n.key);return[new v.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,f),n.remains]}static parseKeybinding(E,n){if(!E)return null;const f=[];let w;do[w,E]=this.parseSimpleKeybinding(E),f.push(w);while(E.length>0);return new v.ChordKeybinding(f)}static parseSimpleUserBinding(E){const n=this._readModifiers(E),f=n.key.match(/^\[([^\]]+)\]$/);if(f){const t=f[1],I=L.ScanCodeUtils.lowerCaseToEnum(t);return[new L.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,I),n.remains]}const w=v.KeyCodeUtils.fromUserSettings(n.key);return[new v.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,w),n.remains]}static parseUserBinding(E){if(!E)return[];const n=[];let f;for(;E.length>0;)[f,E]=this.parseSimpleUserBinding(E),n.push(f);return n}}e.KeybindingParser=k}),define(Z[107],x([0,1,3]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=v.globals.performance&&typeof v.globals.performance.now=="function";class k{constructor(E){this._highResolution=L&&E,this._startTime=this._now(),this._stopTime=-1}static create(E=!0){return new k(E)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=k}),define(Z[4],x([0,1,17,43,2,104,107]),function(K,e,v,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(d){d.None=()=>k.Disposable.None;function o(J){return(W,V=null,B)=>{let $=!1,H;return H=J(_=>{if(!$)return H?H.dispose():$=!0,W.call(V,_)},null,B),$&&H.dispose(),H}}d.once=o;function u(J,W){return m((V,B=null,$)=>J(H=>V.call(B,W(H)),null,$))}d.map=u;function i(J,W){return m((V,B=null,$)=>J(H=>{W(H),V.call(B,H)},null,$))}d.forEach=i;function a(J,W){return m((V,B=null,$)=>J(H=>W(H)&&V.call(B,H),null,$))}d.filter=a;function r(J){return J}d.signal=r;function s(...J){return(W,V=null,B)=>(0,k.combinedDisposable)(...J.map($=>$(H=>W.call(V,H),null,B)))}d.any=s;function l(J,W,V){let B=V;return u(J,$=>(B=W(B,$),B))}d.reduce=l;function m(J){let W;const V=new b({onFirstListenerAdd(){W=J(V.fire,V)},onLastListenerRemove(){W.dispose()}});return V.event}function S(J,W,V=100,B=!1,$){let H,_,j,T=0;const A=new b({leakWarningThreshold:$,onFirstListenerAdd(){H=J(O=>{T++,_=W(_,O),B&&!j&&(A.fire(_),_=void 0),clearTimeout(j),j=setTimeout(()=>{const z=_;_=void 0,j=void 0,(!B||T>1)&&A.fire(z),T=0},V)})},onLastListenerRemove(){H.dispose()}});return A.event}d.debounce=S;function D(J,W=(V,B)=>V===B){let V=!0,B;return a(J,$=>{const H=V||!W($,B);return V=!1,B=$,H})}d.latch=D;function R(J,W){return[d.filter(J,W),d.filter(J,V=>!W(V))]}d.split=R;function F(J,W=!1,V=[]){let B=V.slice(),$=J(j=>{B?B.push(j):_.fire(j)});const H=()=>{B&&B.forEach(j=>_.fire(j)),B=null},_=new b({onFirstListenerAdd(){$||($=J(j=>_.fire(j)))},onFirstListenerDidAdd(){B&&(W?setTimeout(H):H())},onLastListenerRemove(){$&&$.dispose(),$=null}});return _.event}d.buffer=F;class U{constructor(W){this.event=W}map(W){return new U(u(this.event,W))}forEach(W){return new U(i(this.event,W))}filter(W){return new U(a(this.event,W))}reduce(W,V){return new U(l(this.event,W,V))}latch(){return new U(D(this.event))}debounce(W,V=100,B=!1,$){return new U(S(this.event,W,V,B,$))}on(W,V,B){return this.event(W,V,B)}once(W,V,B){return o(this.event)(W,V,B)}}function X(J){return new U(J)}d.chain=X;function ne(J,W,V=B=>B){const B=(...j)=>_.fire(V(...j)),$=()=>J.on(W,B),H=()=>J.removeListener(W,B),_=new b({onFirstListenerAdd:$,onLastListenerRemove:H});return _.event}d.fromNodeEventEmitter=ne;function se(J,W,V=B=>B){const B=(...j)=>_.fire(V(...j)),$=()=>J.addEventListener(W,B),H=()=>J.removeEventListener(W,B),_=new b({onFirstListenerAdd:$,onLastListenerRemove:H});return _.event}d.fromDOMEventEmitter=se;function G(J){return new Promise(W=>o(J)(W))}d.toPromise=G})(n=e.Event||(e.Event={}));class f{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${f._idPool++}`}start(o){this._stopWatch=new E.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}f._idPool=0;let w=-1;function t(d){const o=w;return w=d,{dispose(){w=o}}}e.setGlobalLeakWarningThreshold=t;class I{constructor(o,u=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o){let u=w;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),u<=0||o<u)return;this._stacks||(this._stacks=new Map);const i=new Error().stack.split(`
`).slice(3).join(`
`),a=this._stacks.get(i)||0;if(this._stacks.set(i,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let r,s=0;for(const[l,m]of this._stacks)(!r||s<m)&&(r=l,s=m);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${s}):`),console.warn(r)}return()=>{const r=this._stacks.get(i)||0;this._stacks.set(i,r-1)}}}class b{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=w>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new f(this._options._profName):void 0}get event(){return this._event||(this._event=(o,u,i)=>{this._listeners||(this._listeners=new M.LinkedList);const a=this._listeners.isEmpty();a&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(u?[o,u]:o);a&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,u);const s=this._leakageMon?.check(this._listeners.size),l=(0,k.toDisposable)(()=>{s&&s(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return i instanceof k.DisposableStore?i.add(l):Array.isArray(i)&&i.push(l),l}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new M.LinkedList);for(let u of this._listeners)this._deliveryQueue.push([u,o]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[u,i]=this._deliveryQueue.shift();try{typeof u=="function"?u.call(void 0,i):u[0].call(u[1],i)}catch(a){(0,v.onUnexpectedError)(a)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=b;class y extends b{async fireAsync(o,u,i){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const a of this._listeners)this._asyncDeliveryQueue.push([a,o]);for(;this._asyncDeliveryQueue.size>0&&!u.isCancellationRequested;){const[a,r]=this._asyncDeliveryQueue.shift(),s=[],l={...r,waitUntil:m=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");i&&(m=i(m,typeof a=="function"?a:a[0])),s.push(m)}};try{typeof a=="function"?a.call(void 0,l):a[0].call(a[1],l)}catch(m){(0,v.onUnexpectedError)(m);continue}Object.freeze(s),await Promise.allSettled(s).then(m=>{for(const S of m)S.status==="rejected"&&(0,v.onUnexpectedError)(S.reason)})}}}}e.AsyncEmitter=y;class h extends b{constructor(o){super(o);this._isPaused=0,this._eventQueue=new M.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=h;class g extends h{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=g;class P{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const u={event:o,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const i=()=>{this.hasListeners&&this.unhook(u);const a=this.events.indexOf(u);this.events.splice(a,1)};return(0,k.toDisposable)((0,L.once)(i))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(u=>this.emitter.fire(u))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=P;class p{constructor(){this.buffers=[]}wrapEvent(o){return(u,i,a)=>o(r=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>u.call(i,r)):u.call(i,r)},void 0,a)}bufferEvents(o){const u=[];this.buffers.push(u);const i=o();return this.buffers.pop(),u.forEach(a=>a()),i}}e.EventBufferer=p;class c{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=k.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(Z[23],x([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(n,f){const w=setTimeout(n.bind(f),0);return{dispose(){clearTimeout(w)}}});var k;(function(n){function f(w){return w===n.None||w===n.Cancelled||w instanceof M?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}n.isCancellationToken=f,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(k=e.CancellationToken||(e.CancellationToken={}));class M{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new M),this._token}cancel(){this._token?this._token instanceof M&&this._token.cancel():this._token=k.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof M&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=E}),define(Z[108],x([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(I){const b=this._icons.get(I.id);b?I.description?b.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new L;e.iconRegistry=k;function M(t,I){return new n(t,I)}e.registerCodicon=M;function E(t){return t?t.replace(/\$\((.*?)\)/g,(I,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=E;class n{constructor(I,b,y){this.id=I,this.definition=b,this.description=y,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n;function f(t,I){const b=["codicon","codicon-"+t];return I&&b.push("codicon-modifier-"+I),b}e.getClassNamesArray=f;var w;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function b(g){if(g instanceof n)return["codicon","codicon-"+g.id];const P=I.exec(g.id);if(!P)return b(n.error);let[,p,c]=P;const d=["codicon","codicon-"+p];return c&&d.push("codicon-modifier-"+c.substr(1)),d}t.asClassNameArray=b;function y(g){return b(g).join(" ")}t.asClassName=y;function h(g){return"."+b(g).join(".")}t.asCSSSelector=h})(w=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(n=e.Codicon||(e.Codicon={}))}),define(Z[65],x([0,1,17,2]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(d){const o=d;return o?[o.on,o.pause,o.resume,o.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=k;function M(d){const o=d;return o?k(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=M;function E(d,o){return new n(d,o)}e.newWriteableStream=E;class n{constructor(o,u){this.reducer=o,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(u=>u(o))}emitError(o){this.listeners.error.length===0?(0,v.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(u=>u(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,u){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(o,u){if(this.state.destroyed)return;let i;switch(o){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const a=i.indexOf(u);a>=0&&i.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(d,o){const u=[];let i;for(;(i=d.read())!==null;)u.push(i);return o(u)}e.consumeReadable=f;function w(d,o,u){const i=[];let a;for(;(a=d.read())!==null&&i.length<u;)i.push(a);return a===null&&i.length>0?o(i):{read:()=>{if(i.length>0)return i.shift();if(typeof a!="undefined"){const r=a;return a=void 0,r}return d.read()}}}e.peekReadable=w;function t(d,o){return new Promise((u,i)=>{const a=[];I(d,{onData:r=>{o&&a.push(r)},onError:r=>{o?i(r):u(void 0)},onEnd:()=>{u(o?o(a):void 0)}})})}e.consumeStream=t;function I(d,o){d.on("error",u=>o.onError(u)),d.on("end",()=>o.onEnd()),d.on("data",u=>o.onData(u))}e.listenStream=I;function b(d,o){return new Promise((u,i)=>{const a=new L.DisposableStore,r=[],s=S=>{if(r.push(S),r.length>o)return a.dispose(),d.pause(),u({stream:d,buffer:r,ended:!1})},l=S=>i(S),m=()=>u({stream:d,buffer:r,ended:!0});a.add((0,L.toDisposable)(()=>d.removeListener("error",l))),d.on("error",l),a.add((0,L.toDisposable)(()=>d.removeListener("end",m))),d.on("end",m),a.add((0,L.toDisposable)(()=>d.removeListener("data",s))),d.on("data",s)})}e.peekStream=b;function y(d,o){const u=E(o);return u.end(d),u}e.toStream=y;function h(){const d=E(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=h;function g(d){let o=!1;return{read:()=>o?null:(o=!0,d)}}e.toReadable=g;function P(d,o,u){const i=E(u);return I(d,{onData:a=>i.write(o.data(a)),onError:a=>i.error(o.error?o.error(a):a),onEnd:()=>i.end()}),i}e.transform=P;function p(d,o,u){let i=!1;return{read:()=>{const a=o.read();return i?a:(i=!0,a!==null?u([d,a]):d)}}}e.prefixedReadable=p;function c(d,o,u){let i=!1;const a=E(u);return I(o,{onData:r=>i?a.write(r):(i=!0,a.write(u([d,r]))),onError:r=>a.error(r),onEnd:()=>{i||(i=!0,a.write(d)),a.end()}}),a}e.prefixedStream=c}),define(Z[18],x([0,1,65]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let k,M;class E{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return L?new E(Buffer.allocUnsafe(s)):new E(new Uint8Array(s))}static wrap(s){return L&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new E(s)}static fromString(s,l){return!(l?.dontUseNodeBuffer||!1)&&L?new E(Buffer.from(s)):(k||(k=new TextEncoder),new E(k.encode(s)))}static concat(s,l){if(typeof l=="undefined"){l=0;for(let D=0,R=s.length;D<R;D++)l+=s[D].byteLength}const m=E.alloc(l);let S=0;for(let D=0,R=s.length;D<R;D++){const F=s[D];m.set(F,S),S+=F.byteLength}return m}toString(){return L?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(s,l){return new E(this.buffer.subarray(s,l))}set(s,l){s instanceof E?this.buffer.set(s.buffer,l):this.buffer.set(s,l)}readUInt32BE(s){return w(this.buffer,s)}writeUInt32BE(s,l){t(this.buffer,s,l)}readUInt32LE(s){return I(this.buffer,s)}writeUInt32LE(s,l){b(this.buffer,s,l)}readUInt8(s){return y(this.buffer,s)}writeUInt8(s,l){h(this.buffer,s,l)}}e.VSBuffer=E;function n(r,s){return r[s+0]<<0>>>0|r[s+1]<<8>>>0}e.readUInt16LE=n;function f(r,s,l){r[l+0]=s&255,s=s>>>8,r[l+1]=s&255}e.writeUInt16LE=f;function w(r,s){return r[s]*2**24+r[s+1]*2**16+r[s+2]*2**8+r[s+3]}e.readUInt32BE=w;function t(r,s,l){r[l+3]=s,s=s>>>8,r[l+2]=s,s=s>>>8,r[l+1]=s,s=s>>>8,r[l]=s}e.writeUInt32BE=t;function I(r,s){return r[s+0]<<0>>>0|r[s+1]<<8>>>0|r[s+2]<<16>>>0|r[s+3]<<24>>>0}e.readUInt32LE=I;function b(r,s,l){r[l+0]=s&255,s=s>>>8,r[l+1]=s&255,s=s>>>8,r[l+2]=s&255,s=s>>>8,r[l+3]=s&255}e.writeUInt32LE=b;function y(r,s){return r[s]}e.readUInt8=y;function h(r,s,l){r[l]=s}e.writeUInt8=h;function g(r){return v.consumeReadable(r,s=>E.concat(s))}e.readableToBuffer=g;function P(r){return v.toReadable(r)}e.bufferToReadable=P;function p(r){return v.consumeStream(r,s=>E.concat(s))}e.streamToBuffer=p;async function c(r){return r.ended?E.concat(r.buffer):E.concat([...r.buffer,await p(r.stream)])}e.bufferedStreamToBuffer=c;function d(r){return v.toStream(r,s=>E.concat(s))}e.bufferToStream=d;function o(r){return v.transform(r,{data:s=>typeof s=="string"?E.fromString(s):E.wrap(s)},s=>E.concat(s))}e.streamToBufferReadableStream=o;function u(r){return v.newWriteableStream(s=>E.concat(s),r)}e.newWriteableBufferStream=u;function i(r,s){return v.prefixedReadable(r,s,l=>E.concat(l))}e.prefixedBufferReadable=i;function a(r,s){return v.prefixedStream(r,s,l=>E.concat(l))}e.prefixedBufferStream=a}),define(Z[25],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function v(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=v;const L=/{(\d+)}/g;function k(Y,...re){return re.length===0?Y:Y.replace(L,function(ce,ge){const ye=parseInt(ge,10);return isNaN(ye)||ye<0||ye>=re.length?ce:re[ye]})}e.format=k;const M=/{([^}]+)}/g;function E(Y,re){return Y.replace(M,(ce,ge)=>re[ge]??ce)}e.format2=E;function n(Y){return Y.replace(/[<>&]/g,function(re){switch(re){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return re}})}e.escape=n;function f(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=f;function w(Y,re){let ce=0;const ge=re.charCodeAt(0);for(let ye=Y.length-1;ye>=0;ye--)Y.charCodeAt(ye)===ge&&ce++;return ce}e.count=w;function t(Y,re,ce="\u2026"){return Y.length<=re?Y:`${Y.substr(0,re)}${ce}`}e.truncate=t;function I(Y,re=" "){const ce=b(Y,re);return y(ce,re)}e.trim=I;function b(Y,re){if(!Y||!re)return Y;const ce=re.length;if(ce===0||Y.length===0)return Y;let ge=0;for(;Y.indexOf(re,ge)===ge;)ge=ge+ce;return Y.substring(ge)}e.ltrim=b;function y(Y,re){if(!Y||!re)return Y;const ce=re.length,ge=Y.length;if(ce===0||ge===0)return Y;let ye=ge,Me=-1;for(;Me=Y.lastIndexOf(re,ye-1),!(Me===-1||Me+ce!==ye);){if(Me===0)return"";ye=Me}return Y.substring(0,ye)}e.rtrim=y;function h(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function g(Y){return Y.replace(/\*/g,"")}e.stripWildcards=g;function P(Y,re,ce={}){if(!Y)throw new Error("Cannot create regex from empty string");re||(Y=f(Y)),ce.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let ge="";return ce.global&&(ge+="g"),ce.matchCase||(ge+="i"),ce.multiline&&(ge+="m"),ce.unicode&&(ge+="u"),new RegExp(Y,ge)}e.createRegExp=P;function p(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function c(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function d(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=d;function o(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=o;function u(Y){for(let re=0,ce=Y.length;re<ce;re++){const ge=Y.charCodeAt(re);if(ge!==32&&ge!==9)return re}return-1}e.firstNonWhitespaceIndex=u;function i(Y,re=0,ce=Y.length){for(let ge=re;ge<ce;ge++){const ye=Y.charCodeAt(ge);if(ye!==32&&ye!==9)return Y.substring(re,ge)}return Y.substring(re,ce)}e.getLeadingWhitespace=i;function a(Y,re=Y.length-1){for(let ce=re;ce>=0;ce--){const ge=Y.charCodeAt(ce);if(ge!==32&&ge!==9)return ce}return-1}e.lastNonWhitespaceIndex=a;function r(Y,re){return Y<re?-1:Y>re?1:0}e.compare=r;function s(Y,re,ce=0,ge=Y.length,ye=0,Me=re.length){for(;ce<ge&&ye<Me;ce++,ye++){let Ce=Y.charCodeAt(ce),ze=re.charCodeAt(ye);if(Ce<ze)return-1;if(Ce>ze)return 1}const Fe=ge-ce,We=Me-ye;return Fe<We?-1:Fe>We?1:0}e.compareSubstring=s;function l(Y,re){return m(Y,re,0,Y.length,0,re.length)}e.compareIgnoreCase=l;function m(Y,re,ce=0,ge=Y.length,ye=0,Me=re.length){for(;ce<ge&&ye<Me;ce++,ye++){let Ce=Y.charCodeAt(ce),ze=re.charCodeAt(ye);if(Ce===ze)continue;const de=Ce-ze;if(!(de===32&&D(ze))&&!(de===-32&&D(Ce)))return S(Ce)&&S(ze)?de:s(Y.toLowerCase(),re.toLowerCase(),ce,ge,ye,Me)}const Fe=ge-ce,We=Me-ye;return Fe<We?-1:Fe>We?1:0}e.compareSubstringIgnoreCase=m;function S(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=S;function D(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=D;function R(Y){return S(Y)||D(Y)}function F(Y,re){return Y.length===re.length&&U(Y,re)}e.equalsIgnoreCase=F;function U(Y,re,ce=Y.length){for(let ge=0;ge<ce;ge++){const ye=Y.charCodeAt(ge),Me=re.charCodeAt(ge);if(ye!==Me){if(R(ye)&&R(Me)){const Fe=Math.abs(ye-Me);if(Fe!==0&&Fe!==32)return!1}else if(String.fromCharCode(ye).toLowerCase()!==String.fromCharCode(Me).toLowerCase())return!1}}return!0}function X(Y,re){const ce=re.length;return re.length>Y.length?!1:U(Y,re,ce)}e.startsWithIgnoreCase=X;function ne(Y,re){let ce,ge=Math.min(Y.length,re.length);for(ce=0;ce<ge;ce++)if(Y.charCodeAt(ce)!==re.charCodeAt(ce))return ce;return ge}e.commonPrefixLength=ne;function se(Y,re){let ce,ge=Math.min(Y.length,re.length);const ye=Y.length-1,Me=re.length-1;for(ce=0;ce<ge;ce++)if(Y.charCodeAt(ye-ce)!==re.charCodeAt(Me-ce))return ce;return ge}e.commonSuffixLength=se;function G(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=G;function J(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=J;function W(Y,re){return(Y-55296<<10)+(re-56320)+65536}e.computeCodePoint=W;function V(Y,re,ce){const ge=Y.charCodeAt(ce);if(G(ge)&&ce+1<re){const ye=Y.charCodeAt(ce+1);if(J(ye))return W(ge,ye)}return ge}e.getNextCodePoint=V;function B(Y,re){const ce=Y.charCodeAt(re-1);if(J(ce)&&re>1){const ge=Y.charCodeAt(re-2);if(G(ge))return W(ge,ce)}return ce}function $(Y,re){const ce=Be.getInstance(),ge=re,ye=Y.length,Me=V(Y,ye,re);re+=Me>=65536?2:1;let Fe=ce.getGraphemeBreakType(Me);for(;re<ye;){const We=V(Y,ye,re),Ce=ce.getGraphemeBreakType(We);if(Ue(Fe,Ce))break;re+=We>=65536?2:1,Fe=Ce}return re-ge}e.nextCharLength=$;function H(Y,re){const ce=Be.getInstance(),ge=re,ye=B(Y,re);re-=ye>=65536?2:1;let Me=ce.getGraphemeBreakType(ye);for(;re>0;){const Fe=B(Y,re),We=ce.getGraphemeBreakType(Fe);if(Ue(We,Me))break;re-=Fe>=65536?2:1,Me=We}return ge-re}e.prevCharLength=H;function _(Y,re){const ce=Be.getInstance(),ge=Y.length,ye=re,Me=V(Y,ge,re),Fe=ce.getGraphemeBreakType(Me);re+=Me>=65536?2:1;let We=Fe;for(;re<ge;){const ze=V(Y,ge,re),de=ce.getGraphemeBreakType(ze);if(Ue(We,de))break;re+=ze>=65536?2:1,We=de}const Ce=re;for(re=ye,We=Fe;re>0;){const ze=B(Y,re),de=ce.getGraphemeBreakType(ze);if(Ue(de,We))break;re-=ze>=65536?2:1,We=de}return[re,Ce]}function j(Y,re){return re>0&&J(Y.charCodeAt(re))?_(Y,re-1):_(Y,re)}e.getCharContainingOffset=j;const T=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function A(Y){return T.test(Y)}e.containsRTL=A;const O=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function z(Y){return O.test(Y)}e.containsEmoji=z;const N=/^[\t\n\r\x20-\x7E]*$/;function C(Y){return N.test(Y)}e.isBasicASCII=C,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function q(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=q;function Q(Y){for(let re=0,ce=Y.length;re<ce;re++)if(ie(Y.charCodeAt(re)))return!0;return!1}e.containsFullWidthCharacter=Q;function ie(Y){return Y=+Y,Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=ie;function oe(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129003||Y>=129280&&Y<=129535||Y>=129648&&Y<=129750}e.isEmojiImprecise=oe;function ae(Y,re){if(Y.length<re)return Y;const ce=/\b/g;let ge=0;for(;ce.test(Y)&&!(Y.length-ce.lastIndex<re);)ge=ce.lastIndex,ce.lastIndex+=1;return Y.substring(ge).replace(/^\s/,"")}e.lcut=ae;const ee=/\x1B\x5B[12]?K/g,le=/\x1b\[\d+m/g,me=/\x1b\[0?m/g;function ue(Y){return Y&&(Y=Y.replace(ee,""),Y=Y.replace(le,""),Y=Y.replace(me,"")),Y}e.removeAnsiEscapeCodes=ue,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ve(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ve;function Pe(Y){return ve(Y)?Y.substr(1):Y}e.stripUTF8BOM=Pe;function we(Y,re){if(!Y||!re||Y.length<re.length)return!1;const ce=re.length,ge=Y.toLowerCase();let ye=0,Me=-1;for(;ye<ce;){const Fe=ge.indexOf(re[ye],Me+1);if(Fe<0)return!1;Me=Fe,ye++}return!0}e.fuzzyContains=we;function fe(Y,re=!1){return Y?(re&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=fe;function Ee(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Ee;function De(Y,re=1){if(re===0)return"";let ce=-1;do ce=Y.indexOf(`
`,ce+1),re--;while(re>0&&ce>=0);return ce===-1?Y:(Y[ce-1]==="\r"&&ce--,Y.substr(0,ce))}e.getNLines=De;function Ae(Y){const re=90-65+1;return Y=Y%(2*re),Y<re?String.fromCharCode(97+Y):String.fromCharCode(65+Y-re)}e.singleLetterHash=Ae;function Ne(Y){return Be.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=Ne;function Ue(Y,re){return Y===0?re!==5&&re!==7:Y===2&&re===3?!1:Y===4||Y===2||Y===3||re===4||re===2||re===3?!0:!(Y===8&&(re===8||re===9||re===11||re===12)||(Y===11||Y===9)&&(re===9||re===10)||(Y===12||Y===10)&&re===10||re===5||re===13||re===7||Y===1||Y===13&&re===14||Y===6&&re===6)}e.breakBetweenGraphemeBreakType=Ue;var Ge;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(Ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=st()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(re){if(re<32)return re===10?3:re===13?2:4;if(re<127)return 0;const ce=this._data,ge=ce.length/3;let ye=1;for(;ye<=ge;)if(re<ce[3*ye])ye=2*ye;else if(re>ce[3*ye+1])ye=2*ye+1;else return ce[3*ye+2];return 0}}Be._INSTANCE=null;function st(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Ze(Y,re){if(Y===0)return 0;const ce=ot(Y,re);if(ce!==void 0)return ce;const ge=B(re,Y);return Y-=Ye(ge),Y}e.getLeftDeleteOffset=Ze;function ot(Y,re){let ce=B(re,Y);for(Y-=Ye(ce);ut(ce)||ce===65039||ce===8419;){if(Y===0)return;ce=B(re,Y),Y-=Ye(ce)}if(!!oe(ce)){if(Y>=0){const ge=B(re,Y);ge===8205&&(Y-=Ye(ge))}return Y}}function Ye(Y){return Y>=65536?2:1}function ut(Y){return 127995<=Y&&Y<=127999}var xe;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(xe||(xe={}))}),define(Z[79],x([0,1,25]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(p){return k(p,0)}e.hash=L;function k(p,c){switch(typeof p){case"object":return p===null?M(349,c):Array.isArray(p)?f(p,c):w(p,c);case"string":return n(p,c);case"boolean":return E(p,c);case"number":return M(p,c);case"undefined":return M(937,c);default:return M(617,c)}}e.doHash=k;function M(p,c){return(c<<5)-c+p|0}function E(p,c){return M(p?433:863,c)}function n(p,c){c=M(149417,c);for(let d=0,o=p.length;d<o;d++)c=M(p.charCodeAt(d),c);return c}e.stringHash=n;function f(p,c){return c=M(104579,c),p.reduce((d,o)=>k(o,d),c)}function w(p,c){return c=M(181387,c),Object.keys(p).sort().reduce((d,o)=>(d=n(o,d),k(p[o],d)),c)}class t{constructor(){this._value=0}get value(){return this._value}hash(c){return this._value=k(c,this._value),this._value}}e.Hasher=t;var I;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function b(p,c,d=32){const o=d-c,u=~((1<<o)-1);return(p<<c|(u&p)>>>o)>>>0}function y(p,c=0,d=p.byteLength,o=0){for(let u=0;u<d;u++)p[c+u]=o}function h(p,c,d="0"){for(;p.length<c;)p=d+p;return p}function g(p,c=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(d=>d.toString(16).padStart(2,"0")).join(""):h((p>>>0).toString(16),c/4)}e.toHexString=g;class P{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(c){const d=c.length;if(d===0)return;const o=this._buff;let u=this._buffLen,i=this._leftoverHighSurrogate,a,r;for(i!==0?(a=i,r=-1,i=0):(a=c.charCodeAt(0),r=0);;){let s=a;if(v.isHighSurrogate(a))if(r+1<d){const l=c.charCodeAt(r+1);v.isLowSurrogate(l)?(r++,s=v.computeCodePoint(a,l)):s=65533}else{i=a;break}else v.isLowSurrogate(a)&&(s=65533);if(u=this._push(o,u,s),r++,r<d)a=c.charCodeAt(r);else break}this._buffLen=u,this._leftoverHighSurrogate=i}_push(c,d,o){return o<128?c[d++]=o:o<2048?(c[d++]=192|(o&1984)>>>6,c[d++]=128|(o&63)>>>0):o<65536?(c[d++]=224|(o&61440)>>>12,c[d++]=128|(o&4032)>>>6,c[d++]=128|(o&63)>>>0):(c[d++]=240|(o&1835008)>>>18,c[d++]=128|(o&258048)>>>12,c[d++]=128|(o&4032)>>>6,c[d++]=128|(o&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const c=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(c/4294967296),!1),this._buffDV.setUint32(60,c%4294967296,!1),this._step()}_step(){const c=P._bigBlock32,d=this._buffDV;for(let S=0;S<64;S+=4)c.setUint32(S,d.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)c.setUint32(S,b(c.getUint32(S-12,!1)^c.getUint32(S-32,!1)^c.getUint32(S-56,!1)^c.getUint32(S-64,!1),1),!1);let o=this._h0,u=this._h1,i=this._h2,a=this._h3,r=this._h4,s,l,m;for(let S=0;S<80;S++)S<20?(s=u&i|~u&a,l=1518500249):S<40?(s=u^i^a,l=1859775393):S<60?(s=u&i|u&a|i&a,l=2400959708):(s=u^i^a,l=3395469782),m=b(o,5)+s+r+l+c.getUint32(S*4,!1)&4294967295,r=a,a=i,i=b(u,30),u=o,o=m;this._h0=this._h0+o&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=P,P._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Z[13],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(D){return Array.isArray(D)}e.isArray=v;function L(D){return typeof D=="string"}e.isString=L;function k(D){return Array.isArray(D)&&D.every(R=>L(R))}e.isStringArray=k;function M(D){return typeof D=="object"&&D!==null&&!Array.isArray(D)&&!(D instanceof RegExp)&&!(D instanceof Date)}e.isObject=M;function E(D){return typeof D=="number"&&!isNaN(D)}e.isNumber=E;function n(D){return!!D&&typeof D[Symbol.iterator]=="function"}e.isIterable=n;function f(D){return D===!0||D===!1}e.isBoolean=f;function w(D){return typeof D=="undefined"}e.isUndefined=w;function t(D){return!I(D)}e.isDefined=t;function I(D){return w(D)||D===null}e.isUndefinedOrNull=I;function b(D,R){if(!D)throw new Error(R?`Unexpected type, expected '${R}'`:"Unexpected type")}e.assertType=b;function y(D){if(I(D))throw new Error("Assertion Failed: argument is undefined or null");return D}e.assertIsDefined=y;function h(...D){const R=[];for(let F=0;F<D.length;F++){const U=D[F];if(I(U))throw new Error(`Assertion Failed: argument at index ${F} is undefined or null`);R.push(U)}return R}e.assertAllDefined=h;const g=Object.prototype.hasOwnProperty;function P(D){if(!M(D))return!1;for(let R in D)if(g.call(D,R))return!1;return!0}e.isEmptyObject=P;function p(D){return typeof D=="function"}e.isFunction=p;function c(...D){return D.length>0&&D.every(p)}e.areFunctions=c;function d(D,R){const F=Math.min(D.length,R.length);for(let U=0;U<F;U++)o(D[U],R[U])}e.validateConstraints=d;function o(D,R){if(L(R)){if(typeof D!==R)throw new Error(`argument does not match constraint: typeof ${R}`)}else if(p(R)){try{if(D instanceof R)return}catch{}if(!I(D)&&D.constructor===R||R.length===1&&R.call(void 0,D)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function u(D){let R=[],F=Object.getPrototypeOf(D);for(;Object.prototype!==F;)R=R.concat(Object.getOwnPropertyNames(F)),F=Object.getPrototypeOf(F);return R}e.getAllPropertyNames=u;function i(D){const R=[];for(const F of u(D))typeof D[F]=="function"&&R.push(F);return R}e.getAllMethodNames=i;function a(D,R){const F=X=>function(){const ne=Array.prototype.slice.call(arguments,0);return R(X,ne)};let U={};for(const X of D)U[X]=F(X);return U}e.createProxyObject=a;function r(D){return D===null?void 0:D}e.withNullAsUndefined=r;function s(D){return typeof D=="undefined"?null:D}e.withUndefinedAsNull=s;function l(D){return class{constructor(){return new Proxy({},{get(R,F){if(R[F])return R[F];throw new Error(`Not Implemented: ${D}->${String(F)}`)}})}}}e.NotImplementedProxy=l;function m(D,R="Unreachable"){throw new Error(R)}e.assertNever=m;function S(D){return!!D&&typeof D.then=="function"&&typeof D.catch=="function"}e.isPromise=S}),define(Z[30],x([0,1,8,3,25,13]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function E(r){return r===47||r===92}e.isPathSeparator=E;function n(r){return r.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=n;function f(r){return r.indexOf("/")===-1&&(r=n(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=f;function w(r,s=v.posix.sep){if(!r)return"";const l=r.length,m=r.charCodeAt(0);if(E(m)){if(E(r.charCodeAt(1))&&!E(r.charCodeAt(2))){let D=3;const R=D;for(;D<l&&!E(r.charCodeAt(D));D++);if(R!==D&&!E(r.charCodeAt(D+1))){for(D+=1;D<l;D++)if(E(r.charCodeAt(D)))return r.slice(0,D+1).replace(/[\\/]/g,s)}}return s}else if(p(m)&&r.charCodeAt(1)===58)return E(r.charCodeAt(2))?r.slice(0,2)+s:r.slice(0,2);let S=r.indexOf("://");if(S!==-1){for(S+=3;S<l;S++)if(E(r.charCodeAt(S)))return r.slice(0,S+1)}return""}e.getRoot=w;function t(r){if(!L.isWindows||!r||r.length<5)return!1;let s=r.charCodeAt(0);if(s!==92||(s=r.charCodeAt(1),s!==92))return!1;let l=2;const m=l;for(;l<r.length&&(s=r.charCodeAt(l),s!==92);l++);return!(m===l||(s=r.charCodeAt(l+1),isNaN(s)||s===92))}e.isUNC=t;const I=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(r,s=L.isWindows){const l=s?I:b;return!(!r||r.length===0||/^\s+$/.test(r)||(l.lastIndex=0,l.test(r))||s&&y.test(r)||r==="."||r===".."||s&&r[r.length-1]==="."||s&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=h;function g(r,s,l){const m=r===s;return!l||m?m:!r||!s?!1:(0,k.equalsIgnoreCase)(r,s)}e.isEqual=g;function P(r,s,l,m=v.sep){if(r===s)return!0;if(!r||!s||s.length>r.length)return!1;if(l){if(!(0,k.startsWithIgnoreCase)(r,s))return!1;if(s.length===r.length)return!0;let D=s.length;return s.charAt(s.length-1)===m&&D--,r.charAt(D)===m}return s.charAt(s.length-1)!==m&&(s+=m),r.indexOf(s)===0}e.isEqualOrParent=P;function p(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=p;function c(r,s){return L.isWindows&&r.endsWith(":")&&(r+=v.sep),(0,v.isAbsolute)(r)||(r=(0,v.join)(s,r)),r=(0,v.normalize)(r),L.isWindows?(r=(0,k.rtrim)(r,v.sep),r.endsWith(":")&&(r+=v.sep)):(r=(0,k.rtrim)(r,v.sep),r||(r=v.sep)),r}e.sanitizeFilePath=c;function d(r){const s=(0,v.normalize)(r);return L.isWindows?r.length>3?!1:o(s)&&(r.length===2||s.charCodeAt(2)===92):s===v.posix.sep}e.isRootOrDriveLetter=d;function o(r){return L.isWindows?p(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function u(r){return o(r)?r[0]:void 0}e.getDriveLetter=u;function i(r,s,l){return s.length>r.length?-1:r===s?0:(l&&(r=r.toLowerCase(),s=s.toLowerCase()),r.indexOf(s))}e.indexOfPath=i;function a(r){const s=r.split(":");let l,m,S;if(s.forEach(D=>{const R=Number(D);(0,M.isNumber)(R)?m===void 0?m=R:S===void 0&&(S=R):l=l?[l,D].join(":"):D}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:m!==void 0?m:void 0,column:S!==void 0?S:m!==void 0?1:void 0}}e.parseLineAndColumnAware=a}),define(Z[44],x([0,1,13]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const P=Array.isArray(g)?[]:{};return Object.keys(g).forEach(p=>{g[p]&&typeof g[p]=="object"?P[p]=L(g[p]):P[p]=g[p]}),P}e.deepClone=L;function k(g){if(!g||typeof g!="object")return g;const P=[g];for(;P.length>0;){const p=P.shift();Object.freeze(p);for(const c in p)if(M.call(p,c)){const d=p[c];typeof d=="object"&&!Object.isFrozen(d)&&P.push(d)}}return g}e.deepFreeze=k;const M=Object.prototype.hasOwnProperty;function E(g,P){return n(g,P,new Set)}e.cloneAndChange=E;function n(g,P,p){if((0,v.isUndefinedOrNull)(g))return g;const c=P(g);if(typeof c!="undefined")return c;if((0,v.isArray)(g)){const d=[];for(const o of g)d.push(n(o,P,p));return d}if((0,v.isObject)(g)){if(p.has(g))throw new Error("Cannot clone recursive data-structure");p.add(g);const d={};for(let o in g)M.call(g,o)&&(d[o]=n(g[o],P,p));return p.delete(g),d}return g}function f(g,P,p=!0){return(0,v.isObject)(g)?((0,v.isObject)(P)&&Object.keys(P).forEach(c=>{c in g?p&&((0,v.isObject)(g[c])&&(0,v.isObject)(P[c])?f(g[c],P[c],p):g[c]=P[c]):g[c]=P[c]}),g):P}e.mixin=f;function w(g,P){if(g===P)return!0;if(g==null||P===null||P===void 0||typeof g!=typeof P||typeof g!="object"||Array.isArray(g)!==Array.isArray(P))return!1;let p,c;if(Array.isArray(g)){if(g.length!==P.length)return!1;for(p=0;p<g.length;p++)if(!w(g[p],P[p]))return!1}else{const d=[];for(c in g)d.push(c);d.sort();const o=[];for(c in P)o.push(c);if(o.sort(),!w(d,o))return!1;for(p=0;p<d.length;p++)if(!w(g[d[p]],P[d[p]]))return!1}return!0}e.equals=w;function t(g){const P=new Set;return JSON.stringify(g,(p,c)=>{if((0,v.isObject)(c)||Array.isArray(c)){if(P.has(c))return"[Circular]";P.add(c)}return c})}e.safeStringify=t;function I(g,P,p){const c=P(g);return typeof c=="undefined"?p:c}e.getOrDefault=I;function b(g,P){const p=Object.create(null);return!g||!P||Object.keys(P).forEach(d=>{const o=g[d],u=P[d];w(o,u)||(p[d]=u)}),p}e.distinct=b;function y(g,P){const p=P.toLowerCase(),c=Object.keys(g).find(d=>d.toLowerCase()===p);return c?g[c]:g[P]}e.getCaseInsensitive=y;function h(g,P){const p=Object.create(null);for(const c of Object.keys(g))P(c,g[c])&&(p[c]=g[c]);return p}e.filter=h}),define(Z[7],x([0,1,8,3]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,M=/^\//,E=/^\/\//;function n(r,s){if(!r.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!k.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!M.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(r,s){return!r&&!s?"file":r}function w(r,s){switch(r){case"https":case"http":case"file":s?s[0]!==I&&(s=I+s):s=I;break}return s}const t="",I="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(s,l,m,S,D,R=!1){typeof s=="object"?(this.scheme=s.scheme||t,this.authority=s.authority||t,this.path=s.path||t,this.query=s.query||t,this.fragment=s.fragment||t):(this.scheme=f(s,R),this.authority=l||t,this.path=w(this.scheme,m||t),this.query=S||t,this.fragment=D||t,n(this,R))}static isUri(s){return s instanceof y?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return d(this,!1)}with(s){if(!s)return this;let{scheme:l,authority:m,path:S,query:D,fragment:R}=s;return l===void 0?l=this.scheme:l===null&&(l=t),m===void 0?m=this.authority:m===null&&(m=t),S===void 0?S=this.path:S===null&&(S=t),D===void 0?D=this.query:D===null&&(D=t),R===void 0?R=this.fragment:R===null&&(R=t),l===this.scheme&&m===this.authority&&S===this.path&&D===this.query&&R===this.fragment?this:new g(l,m,S,D,R)}static parse(s,l=!1){const m=b.exec(s);return m?new g(m[2]||t,a(m[4]||t),a(m[5]||t),a(m[7]||t),a(m[9]||t),l):new g(t,t,t,t,t)}static file(s){let l=t;if(L.isWindows&&(s=s.replace(/\\/g,I)),s[0]===I&&s[1]===I){const m=s.indexOf(I,2);m===-1?(l=s.substring(2),s=I):(l=s.substring(2,m),s=s.substring(m)||I)}return new g("file",l,s,t,t)}static from(s){const l=new g(s.scheme,s.authority,s.path,s.query,s.fragment);return n(l,!0),l}static joinPath(s,...l){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return L.isWindows&&s.scheme==="file"?m=y.file(v.win32.join(d(s,!0),...l)).path:m=v.posix.join(s.path,...l),s.with({path:m})}toString(s=!1){return o(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof y)return s;{const l=new g(s);return l._formatted=s.external,l._fsPath=s._sep===h?s.fsPath:null,l}}else return s}}e.URI=y;const h=L.isWindows?1:void 0;class g extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(s=!1){return s?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=h),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const P={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(r,s){let l,m=-1;for(let S=0;S<r.length;S++){const D=r.charCodeAt(S);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||s&&D===47)m!==-1&&(l+=encodeURIComponent(r.substring(m,S)),m=-1),l!==void 0&&(l+=r.charAt(S));else{l===void 0&&(l=r.substr(0,S));const R=P[D];R!==void 0?(m!==-1&&(l+=encodeURIComponent(r.substring(m,S)),m=-1),l+=R):m===-1&&(m=S)}}return m!==-1&&(l+=encodeURIComponent(r.substring(m))),l!==void 0?l:r}function c(r){let s;for(let l=0;l<r.length;l++){const m=r.charCodeAt(l);m===35||m===63?(s===void 0&&(s=r.substr(0,l)),s+=P[m]):s!==void 0&&(s+=r[l])}return s!==void 0?s:r}function d(r,s){let l;return r.authority&&r.path.length>1&&r.scheme==="file"?l=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?s?l=r.path.substr(1):l=r.path[1].toLowerCase()+r.path.substr(2):l=r.path,L.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=d;function o(r,s){const l=s?c:p;let m="",{scheme:S,authority:D,path:R,query:F,fragment:U}=r;if(S&&(m+=S,m+=":"),(D||S==="file")&&(m+=I,m+=I),D){let X=D.indexOf("@");if(X!==-1){const ne=D.substr(0,X);D=D.substr(X+1),X=ne.indexOf(":"),X===-1?m+=l(ne,!1):(m+=l(ne.substr(0,X),!1),m+=":",m+=l(ne.substr(X+1),!1)),m+="@"}D=D.toLowerCase(),X=D.indexOf(":"),X===-1?m+=l(D,!1):(m+=l(D.substr(0,X),!1),m+=D.substr(X))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const X=R.charCodeAt(1);X>=65&&X<=90&&(R=`/${String.fromCharCode(X+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const X=R.charCodeAt(0);X>=65&&X<=90&&(R=`${String.fromCharCode(X+32)}:${R.substr(2)}`)}m+=l(R,!0)}return F&&(m+="?",m+=l(F,!1)),U&&(m+="#",m+=s?U:p(U,!1)),m}function u(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+u(r.substr(3)):r}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(r){return r.match(i)?r.replace(i,s=>u(s)):r}}),define(Z[109],x([0,1,7]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(w){const t=w;return t&&typeof t.type=="string"&&typeof t.severity=="string"}e.isRemoteConsoleLog=L;function k(w){const t=[];let I;try{const b=JSON.parse(w.arguments),y=b[b.length-1];y&&y.__$stack&&(b.pop(),I=y.__$stack),t.push(...b)}catch(b){t.push("Unable to log remote console arguments",w.arguments)}return{args:t,stack:I}}e.parse=k;function M(w){if(typeof w!="string")return M(k(w).stack);const t=w;if(t){const I=E(t),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(b&&b.length===4)return{uri:v.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=M;function E(w){if(!w)return w;const t=w.indexOf(`
`);return t===-1?w:w.substring(0,t)}function n(w,t){const{args:I,stack:b}=k(w),y=typeof I[0]=="string"&&I.length===1;let h=E(b);h&&(h=`(${h.trim()})`);let g=[];if(typeof I[0]=="string"?h&&y?g=[`%c[${t}] %c${I[0]} %c${h}`,f("blue"),f(""),f("grey")]:g=[`%c[${t}] %c${I[0]}`,f("blue"),f(""),...I.slice(1)]:g=[`%c[${t}]%`,f("blue"),...I],h&&!y&&g.push(h),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,g)}e.log=n;function f(w){return`color: ${w}`}});var bt=this&&this.__classPrivateFieldSet||function(K,e,v,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!k:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(K,v):k?k.value=v:e.set(K,v),v},qe=this&&this.__classPrivateFieldGet||function(K,e,v,L){if(v==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!L:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?L:v==="a"?L.call(K):L?L.value:e.get(K)};define(Z[37],x([0,1,32,25,7]),function(K,e,v,L,k){"use strict";var M,E,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function f(a,r,s){let l=a.get(r);return l===void 0&&(l=s,a.set(r,l)),l}e.getOrSet=f;function w(a){const r=[];return a.forEach((s,l)=>{r.push(`${l} => ${s}`)}),`Map(${a.size}) {${r.join(", ")}}`}e.mapToString=w;function t(a){const r=[];return a.forEach(s=>{r.push(s)}),`Set(${a.size}) {${r.join(", ")}}`}e.setToString=t;class I{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),l=this._value.charCodeAt(this._pos);return s-l}value(){return this._value[this._pos]}}e.StringIterator=I;class b{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class y{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=y;var h;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(h||(h={}));class g{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class P{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class p{constructor(r){this._iter=r}static forUris(r=()=>!1){return new p(new g(r))}static forPaths(){return new p(new y)}static forStrings(){return new p(new I)}static forConfigKeys(){return new p(new b)}clear(){this._root=void 0}set(r,s){const l=this._iter.reset(r);let m;for(this._root||(this._root=new P,this._root.segment=l.value()),m=this._root;;){const D=l.cmp(m.segment);if(D>0)m.left||(m.left=new P,m.left.segment=l.value()),m=m.left;else if(D<0)m.right||(m.right=new P,m.right.segment=l.value()),m=m.right;else if(l.hasNext())l.next(),m.mid||(m.mid=new P,m.mid.segment=l.value()),m=m.mid;else break}const S=m.value;return m.value=s,m.key=r,S}fill(r,s){const l=s.slice(0);(0,v.shuffle)(l);for(let m of l)this.set(m,r)}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let l=this._root;for(;l;){const m=s.cmp(l.segment);if(m>0)l=l.left;else if(m<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else break}return l}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const l=this._iter.reset(r),m=[];let S=this._root;for(;S;){const D=l.cmp(S.segment);if(D>0)m.push([1,S]),S=S.left;else if(D<0)m.push([-1,S]),S=S.right;else if(l.hasNext())l.next(),m.push([0,S]),S=S.mid;else{for(s?(S.left=void 0,S.mid=void 0,S.right=void 0):S.value=void 0;m.length>0&&S.isEmpty();){let[R,F]=m.pop();switch(R){case 1:F.left=void 0;break;case 0:F.mid=void 0;break;case-1:F.right=void 0;break}S=F}break}}}findSubstr(r){const s=this._iter.reset(r);let l=this._root,m;for(;l;){const S=s.cmp(l.segment);if(S>0)l=l.left;else if(S<0)l=l.right;else if(s.hasNext())s.next(),m=l.value||m,l=l.mid;else break}return l&&l.value||m}findSuperstr(r){const s=this._iter.reset(r);let l=this._root;for(;l;){const m=s.cmp(l.segment);if(m>0)l=l.left;else if(m<0)l=l.right;else if(s.hasNext())s.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(r){for(const[s,l]of this)r(l,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const l=s.pop();l&&(l.value&&(yield[l.key,l.value]),l.left&&s.push(l.left),l.mid&&s.push(l.mid),l.right&&s.push(l.right))}}}e.TernarySearchTree=p;class c{constructor(r,s){this[M]="ResourceMap",r instanceof c?(this.map=new Map(r.map),this.toKey=s??c.defaultToKey):(this.map=new Map,this.toKey=r??c.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[l,m]of this.map)r(m,k.URI.parse(l),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield k.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[k.URI.parse(r[0]),r[1]]}*[(M=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[k.URI.parse(r[0]),r[1]]}}e.ResourceMap=c,c.defaultToKey=a=>a.toString();var d;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(d=e.Touch||(e.Touch={}));class o{constructor(){this[E]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const l=this._map.get(r);if(!!l)return s!==0&&this.touch(l,s),l.value}set(r,s,l=0){let m=this._map.get(r);if(m)m.value=s,l!==0&&this.touch(m,l);else{switch(m={key:r,value:s,next:void 0,previous:void 0},l){case 0:this.addItemLast(m);break;case 1:this.addItemFirst(m);break;case 2:this.addItemLast(m);break;default:this.addItemLast(m);break}this._map.set(r,m),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const l=this._state;let m=this._head;for(;m;){if(s?r.bind(s)(m.value,m.key,this):r(m.value,m.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const r=this,s=this._state;let l=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const S={value:l.key,done:!1};return l=l.next,S}else return{value:void 0,done:!0}}};return m}values(){const r=this,s=this._state;let l=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const S={value:l.value,done:!1};return l=l.next,S}else return{value:void 0,done:!0}}};return m}entries(){const r=this,s=this._state;let l=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const S={value:[l.key,l.value],done:!1};return l=l.next,S}else return{value:void 0,done:!0}}};return m}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,l=this.size;for(;s&&l>r;)this._map.delete(s.key),s=s.next,l--;this._head=s,this._size=l,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,l=r.previous;if(!s||!l)throw new Error("Invalid list");s.previous=l,l.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const l=r.next,m=r.previous;r===this._tail?(m.next=void 0,this._tail=m):(l.previous=m,m.next=l),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const l=r.next,m=r.previous;r===this._head?(l.previous=void 0,this._head=l):(l.previous=m,m.next=l),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,l)=>{r.push([l,s])}),r}fromJSON(r){this.clear();for(const[s,l]of r)this.set(s,l)}}e.LinkedMap=o;class u extends o{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u;class i{constructor(r){n.set(this,void 0),bt(this,n,r,"f")}get size(){return qe(this,n,"f").size}forEach(r,s){qe(this,n,"f").forEach(r,s)}get(r){return qe(this,n,"f").get(r)}has(r){return qe(this,n,"f").has(r)}entries(){return qe(this,n,"f").entries()}keys(){return qe(this,n,"f").keys()}values(){return qe(this,n,"f").values()}[(n=new WeakMap,Symbol.iterator)](){return qe(this,n,"f").entries()}}e.ReadonlyMapView=i}),define(Z[110],x([0,1,18,25,7]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function M(t){return JSON.stringify(t,f)}e.stringify=M;function E(t){let I=JSON.parse(t);return I=w(I),I}e.parse=E;var n;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(n=e.MarshalledId||(e.MarshalledId={}));function f(t,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function w(t,I=0){if(!t||I>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return k.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof v.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let b=0;b<t.length;++b)t[b]=w(t[b],I+1);else for(const b in t)Object.hasOwnProperty.call(t,b)&&(t[b]=w(t[b],I+1))}return t}e.revive=w}),define(Z[10],x([0,1,3,7]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractive="vscode-interactive",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}set(f,w,t){this._hosts[f]=w,this._ports[f]=t}setConnectionToken(f,w){this._connectionTokens[f]=w}rewrite(f){if(this._delegate)return this._delegate(f);const w=f.authority;let t=this._hosts[w];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const I=this._ports[w],b=this._connectionTokens[w];let y=`path=${encodeURIComponent(f.path)}`;return typeof b=="string"&&(y+=`&tkn=${encodeURIComponent(b)}`),L.URI.from({scheme:v.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${t}:${I}`,path:"/vscode-remote-resource",query:y})}}e.RemoteAuthorities=new M;class E{asBrowserUri(f,w){const t=this.toUri(f,w);return t.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===k.file&&(v.isNative||typeof v.globals.importScripts=="function"&&v.globals.origin===`${k.vscodeFileResource}://${E.FALLBACK_AUTHORITY}`)?t.with({scheme:k.vscodeFileResource,authority:t.authority||E.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(f,w){const t=this.toUri(f,w);return t.scheme===k.vscodeFileResource?t.with({scheme:k.file,authority:t.authority!==E.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(f,w){return L.URI.isUri(f)?f:L.URI.parse(w.toUrl(f))}}E.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new E}),define(Z[66],x([0,1,37]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new v.LRUCache(1e4);function k(w){return f(w,"NFC",L)}e.normalizeNFC=k;const M=new v.LRUCache(1e4);function E(w){return f(w,"NFD",M)}e.normalizeNFD=E;const n=/[^\u0000-\u0080]/;function f(w,t,I){if(!w)return w;const b=I.get(w);if(b)return b;let y;return n.test(w)?y=w.normalize(t):y=w,I.set(w,y),y}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(t){return E(t).replace(w,"")}}()}),define(Z[15],x([0,1,30,10,8,3,25,7]),function(K,e,v,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(y){return(0,n.uriToFsPath)(y,!0)}e.originalFSPath=f;class w{constructor(h){this._ignorePathCasing=h}compare(h,g,P=!1){return h===g?0:(0,E.compare)(this.getComparisonKey(h,P),this.getComparisonKey(g,P))}isEqual(h,g,P=!1){return h===g?!0:!h||!g?!1:this.getComparisonKey(h,P)===this.getComparisonKey(g,P)}getComparisonKey(h,g=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,g,P=!1){if(h.scheme===g.scheme){if(h.scheme===L.Schemas.file)return v.isEqualOrParent(f(h),f(g),this._ignorePathCasing(h))&&h.query===g.query&&(P||h.fragment===g.fragment);if((0,e.isEqualAuthority)(h.authority,g.authority))return v.isEqualOrParent(h.path,g.path,this._ignorePathCasing(h),"/")&&h.query===g.query&&(P||h.fragment===g.fragment)}return!1}joinPath(h,...g){return n.URI.joinPath(h,...g)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return k.posix.basename(h.path)}extname(h){return k.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let g;return h.scheme===L.Schemas.file?g=n.URI.file(k.dirname(f(h))).path:(g=k.posix.dirname(h.path),h.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),g="/")),h.with({path:g})}normalizePath(h){if(!h.path.length)return h;let g;return h.scheme===L.Schemas.file?g=n.URI.file(k.normalize(f(h))).path:g=k.posix.normalize(h.path),h.with({path:g})}relativePath(h,g){if(h.scheme!==g.scheme||!(0,e.isEqualAuthority)(h.authority,g.authority))return;if(h.scheme===L.Schemas.file){const c=k.relative(f(h),f(g));return M.isWindows?v.toSlashes(c):c}let P=h.path||"/",p=g.path||"/";if(this._ignorePathCasing(h)){let c=0;for(const d=Math.min(P.length,p.length);c<d&&!(P.charCodeAt(c)!==p.charCodeAt(c)&&P.charAt(c).toLowerCase()!==p.charAt(c).toLowerCase());c++);P=p.substr(0,c)+P.substr(c)}return k.posix.relative(P,p)}resolvePath(h,g){if(h.scheme===L.Schemas.file){const P=n.URI.file(k.resolve(f(h),g));return h.with({authority:P.authority,path:P.path})}return g=v.toPosixPath(g),h.with({path:k.posix.resolve(h.path,g)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,g){return h===g||(0,E.equalsIgnoreCase)(h,g)}hasTrailingPathSeparator(h,g=k.sep){if(h.scheme===L.Schemas.file){const P=f(h);return P.length>v.getRoot(P).length&&P[P.length-1]===g}else{const P=h.path;return P.length>1&&P.charCodeAt(P.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,g=k.sep){return(0,e.hasTrailingPathSeparator)(h,g)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,g=k.sep){let P=!1;if(h.scheme===L.Schemas.file){const p=f(h);P=p!==void 0&&p.length===v.getRoot(p).length&&p[p.length-1]===g}else{g="/";const p=h.path;P=p.length===1&&p.charCodeAt(p.length-1)===47}return!P&&!(0,e.hasTrailingPathSeparator)(h,g)?h.with({path:h.path+"/"}):h}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(y=>y.scheme===L.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new w(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(y,h){const g=[];for(let P=0;P<y.length;P++){const p=h(y[P]);y.some((c,d)=>d===P?!1:(0,e.isEqualOrParent)(p,h(c)))||g.push(y[P])}return g}e.distinctParents=t;var I;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function h(g){const P=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(d=>{const[o,u]=d.split(":");o&&u&&P.set(o,u)});const c=g.path.substring(0,g.path.indexOf(";"));return c&&P.set(y.META_DATA_MIME,c),P}y.parseMetaData=h})(I=e.DataUri||(e.DataUri={}));function b(y,h,g){if(h){let P=y.path;return P&&P[0]!==k.posix.sep&&(P=k.posix.sep+P),y.with({scheme:g,authority:h,path:P})}return y.with({scheme:g})}e.toLocalResource=b}),define(Z[9],x([0,1,23,17,4,2,15]),function(K,e,v,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function n(B){return!!B&&typeof B.then=="function"}e.isThenable=n;function f(B){const $=new v.CancellationTokenSource,H=B($.token),_=new Promise((j,T)=>{const A=$.token.onCancellationRequested(()=>{A.dispose(),$.dispose(),T((0,L.canceled)())});Promise.resolve(H).then(O=>{A.dispose(),$.dispose(),j(O)},O=>{A.dispose(),$.dispose(),T(O)})});return new class{cancel(){$.cancel()}then(j,T){return _.then(j,T)}catch(j){return this.then(void 0,j)}finally(j){return _.finally(j)}}}e.createCancelablePromise=f;function w(B,$,H){return Promise.race([B,new Promise(_=>$.onCancellationRequested(()=>_(H)))])}e.raceCancellation=w;async function t(B){let $=-1;const H=B.map((j,T)=>j.then(A=>($=T,A))),_=await Promise.race(H);return B.forEach((j,T)=>{T!==$&&j.cancel()}),_}e.raceCancellablePromises=t;function I(B,$,H){let _;const j=setTimeout(()=>{_?.(void 0),H?.()},$);return Promise.race([B.finally(()=>clearTimeout(j)),new Promise(T=>_=T)])}e.raceTimeout=I;function b(B){return new Promise(($,H)=>{const _=B();n(_)?_.then($,H):$(_)})}e.asPromise=b;class y{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue($){if(this.activePromise){if(this.queuedPromiseFactory=$,!this.queuedPromise){const H=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(H,H).then(_)})}return new Promise((H,_)=>{this.queuedPromise.then(H,_)})}return this.activePromise=$(),new Promise((H,_)=>{this.activePromise.then(j=>{this.activePromise=null,H(j)},j=>{this.activePromise=null,_(j)})})}}e.Throttler=y;class h{constructor(){this.current=Promise.resolve(null)}queue($){return this.current=this.current.then(()=>$(),()=>$())}}e.Sequencer=h;class g{constructor(){this.promiseMap=new Map}queue($,H){const j=(this.promiseMap.get($)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.promiseMap.get($)===j&&this.promiseMap.delete($)});return this.promiseMap.set($,j),j}}e.SequencerByKey=g;class P{constructor($){this.defaultDelay=$,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger($,H=this.defaultDelay){return this.task=$,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((_,j)=>{this.doResolve=_,this.doReject=j}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const _=this.task;return this.task=null,_()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},H),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=P;class p{constructor($){this.delayer=new P($),this.throttler=new y}trigger($,H){return this.delayer.trigger(()=>this.throttler.queue($),H)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=p;class c{constructor(){this._isOpen=!1,this._promise=new Promise(($,H)=>{this._completePromise=$})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class d extends c{constructor($){super();this._timeout=setTimeout(()=>this.open(),$)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function o(B,$){return $?new Promise((H,_)=>{const j=setTimeout(()=>{T.dispose(),H()},B),T=$.onCancellationRequested(()=>{clearTimeout(j),T.dispose(),_((0,L.canceled)())})}):f(H=>o(B,H))}e.timeout=o;function u(B,$=0){const H=setTimeout(B,$);return(0,M.toDisposable)(()=>clearTimeout(H))}e.disposableTimeout=u;function i(B){const $=[];let H=0;const _=B.length;function j(){return H<_?B[H++]():null}function T(A){A!=null&&$.push(A);const O=j();return O?O.then(T):Promise.resolve($)}return Promise.resolve(null).then(T)}e.sequence=i;function a(B,$=_=>!!_,H=null){let _=0;const j=B.length,T=()=>{if(_>=j)return Promise.resolve(H);const A=B[_++];return Promise.resolve(A()).then(z=>$(z)?Promise.resolve(z):T())};return T()}e.first=a;function r(B,$=_=>!!_,H=null){if(B.length===0)return Promise.resolve(H);let _=B.length;const j=()=>{_=-1;for(const T of B)T.cancel?.()};return new Promise((T,A)=>{for(const O of B)O.then(z=>{--_>=0&&$(z)?(j(),T(z)):_===0&&T(H)}).catch(z=>{--_>=0&&(j(),A(z))})})}e.firstParallel=r;class s{constructor($){this._size=0,this.maxDegreeOfParalellism=$,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue($){return this._size++,new Promise((H,_)=>{this.outstandingPromises.push({factory:$,c:H,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const $=this.outstandingPromises.shift();this.runningPromises++;const H=$.factory();H.then($.c,$.e),H.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class l extends s{constructor(){super(1)}}e.Queue=l;class m{constructor(){this.queues=new Map}queueFor($,H=E.extUri){const _=H.getComparisonKey($);let j=this.queues.get(_);return j||(j=new l,k.Event.once(j.onFinished)(()=>{j?.dispose(),this.queues.delete(_)}),this.queues.set(_,j)),j}dispose(){this.queues.forEach($=>$.dispose()),this.queues.clear()}}e.ResourceQueue=m;class S{constructor($,H){this._token=-1,typeof $=="function"&&typeof H=="number"&&this.setIfNotSet($,H)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet($,H){this.cancel(),this._token=setTimeout(()=>{this._token=-1,$()},H)}setIfNotSet($,H){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,$()},H))}}e.TimeoutTimer=S;class D{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet($,H){this.cancel(),this._token=setInterval(()=>{$()},H)}}e.IntervalTimer=D;class R{constructor($,H){this.timeoutToken=-1,this.runner=$,this.timeout=H,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule($=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,$)}get delay(){return this.timeout}set delay($){this.timeout=$}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class F{constructor($,H){H%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.runner=$,this.timeout=H,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule($=this.timeout){$%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil($/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=F;class U extends R{constructor($,H){super($,H);this.units=[]}work($){this.units.push($),this.isScheduled()||this.schedule()}doRun(){const $=this.units;this.units=[],this.runner&&this.runner($)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class X extends M.Disposable{constructor($,H,_,j){super();this.maxWorkChunkSize=$,this.maxPendingWork=H,this.throttleDelay=_,this.handler=j,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work($){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+$.length>this.maxPendingWork)return!1}else if(this.pending+$.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...$),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=X,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const B=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=$=>{const H=setTimeout(()=>$(B));let _=!1;return{dispose(){_||(_=!0,clearTimeout(H))}}}}else e.runWhenIdle=(B,$)=>{const H=requestIdleCallback(B,typeof $=="number"?{timeout:$}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(H))}}}}();class ne{constructor($){this._didRun=!1,this._executor=()=>{try{this._value=$()}catch(H){this._error=H}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ne;async function se(B,$,H){let _;for(let j=0;j<H;j++)try{return await B()}catch(T){_=T,await o($)}throw _}e.retry=se;class G{hasPending($){return this._pending?typeof $=="number"?this._pending.taskId===$:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending($,H,_){return this._pending={taskId:$,cancel:()=>_?.(),promise:H},H.then(()=>this.donePending($),()=>this.donePending($)),H}donePending($){this._pending&&$===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const $=this._next;this._next=void 0,$.run().then($.promiseResolve,$.promiseReject)}}setNext($){if(this._next)this._next.run=$;else{let H,_;const j=new Promise((T,A)=>{H=T,_=A});this._next={run:$,promise:j,promiseResolve:H,promiseReject:_}}return this._next.promise}}e.TaskSequentializer=G;class J{constructor($){this.interval=$,this.lastIncrementTime=0,this.value=0}increment(){const $=Date.now();return $-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=$,this.value=0),this.value++,this.value}}e.IntervalCounter=J;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise(($,H)=>{this.completeCallback=$,this.errorCallback=H})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete($){return new Promise(H=>{this.completeCallback($),this.resolved=!0,H()})}error($){return new Promise(H=>{this.errorCallback($),this.rejected=!0,H()})}cancel(){new Promise($=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,$()})}}e.DeferredPromise=W;var V;(function(B){async function $(H){let _;const j=await Promise.all(H.map(T=>T.then(A=>A,A=>{_||(_=A)})));if(typeof _!="undefined")throw _;return j}B.settled=$})(V=e.Promises||(e.Promises={}))}),define(Z[111],x([0,1,9,30,37,8,25]),function(K,e,v,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const f="**",w="/",t="[/\\\\]",I="[^/\\\\]",b=/\//g;function y(_){switch(_){case 0:return"";case 1:return`${I}*?`;default:return`(?:${t}|${I}+${t}|${t}${I}+)*?`}}function h(_,j){if(!_)return[];const T=[];let A=!1,O=!1,z="";for(const N of _){switch(N){case j:if(!A&&!O){T.push(z),z="";continue}break;case"{":A=!0;break;case"}":A=!1;break;case"[":O=!0;break;case"]":O=!1;break}z+=N}return z&&T.push(z),T}e.splitGlobAware=h;function g(_){if(!_)return"";let j="";const T=h(_,w);if(T.every(A=>A===f))j=".*";else{let A=!1;T.forEach((O,z)=>{if(O===f){A||(j+=y(2),A=!0);return}let N=!1,C="",q=!1,Q="";for(const ie of O){if(ie!=="}"&&N){C+=ie;continue}if(q&&(ie!=="]"||!Q)){let oe;ie==="-"?oe=ie:(ie==="^"||ie==="!")&&!Q?oe="^":ie===w?oe="":oe=E.escapeRegExpCharacters(ie),Q+=oe;continue}switch(ie){case"{":N=!0;continue;case"[":q=!0;continue;case"}":j+=`(?:${h(C,",").map(ee=>g(ee)).join("|")})`,N=!1,C="";break;case"]":j+="["+Q+"]",q=!1,Q="";break;case"?":j+=I;continue;case"*":j+=y(1);continue;default:j+=E.escapeRegExpCharacters(ie)}}z<T.length-1&&(T[z+1]!==f||z+2<T.length)&&(j+=t),A=!1})}return j}const P=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new k.LRUCache(1e4),a=function(){return!1},r=function(){return null};function s(_,j){if(!_)return r;let T;typeof _!="string"?T=_.pattern:T=_,T=T.trim();const A=`${T}_${!!j.trimForExclusions}`;let O=i.get(A);if(O)return l(O,_);let z;if(P.test(T)){const N=T.substr(4);O=function(C,q){return typeof C=="string"&&C.endsWith(N)?T:null}}else(z=p.exec(m(T,j)))?O=S(z[1],T):(j.trimForExclusions?d:c).test(T)?O=D(T,j):(z=o.exec(m(T,j)))?O=R(z[1].substr(1),T,!0):(z=u.exec(m(T,j)))?O=R(z[1],T,!1):O=F(T);return i.set(A,O),l(O,_)}function l(_,j){return typeof j=="string"?_:function(T,A){return L.isEqualOrParent(T,j.base)?_(M.relative(j.base,T),A):null}}function m(_,j){return j.trimForExclusions&&_.endsWith("/**")?_.substr(0,_.length-2):_}function S(_,j){const T=`/${_}`,A=`\\${_}`,O=function(N,C){return typeof N!="string"?null:C?C===_?j:null:N===_||N.endsWith(T)||N.endsWith(A)?j:null},z=[_];return O.basenames=z,O.patterns=[j],O.allBasenames=z,O}function D(_,j){const T=H(_.slice(1,-1).split(",").map(C=>s(C,j)).filter(C=>C!==r),_),A=T.length;if(!A)return r;if(A===1)return T[0];const O=function(C,q){for(let Q=0,ie=T.length;Q<ie;Q++)if(T[Q](C,q))return _;return null},z=T.find(C=>!!C.allBasenames);z&&(O.allBasenames=z.allBasenames);const N=T.reduce((C,q)=>q.allPaths?C.concat(q.allPaths):C,[]);return N.length&&(O.allPaths=N),O}function R(_,j,T){const A=M.sep===M.posix.sep,O=A?_:_.replace(b,M.sep),z=M.sep+O,N=M.posix.sep+_,C=T?function(q,Q){return typeof q=="string"&&(q===O||q.endsWith(z)||!A&&(q===_||q.endsWith(N)))?j:null}:function(q,Q){return typeof q=="string"&&(q===O||!A&&q===_)?j:null};return C.allPaths=[(T?"*/":"./")+_],C}function F(_){try{const j=new RegExp(`^${g(_)}$`);return function(T){return j.lastIndex=0,typeof T=="string"&&j.test(T)?_:null}}catch(j){return r}}function U(_,j,T){return!_||typeof j!="string"?!1:X(_)(j,void 0,T)}e.match=U;function X(_,j={}){if(!_)return a;if(typeof _=="string"||J(_)){const T=s(_,j);if(T===r)return a;const A=function(O,z){return!!T(O,z)};return T.allBasenames&&(A.allBasenames=T.allBasenames),T.allPaths&&(A.allPaths=T.allPaths),A}return B(_,j)}e.parse=X;function ne(_){if(!_)return;let j;return T=>(j||(j=(_()||Promise.resolve([])).then(A=>A?G(A):{})),j.then(A=>!!A[T]))}e.hasSiblingPromiseFn=ne;function se(_){if(!_)return;let j;return T=>{if(!j){const A=_();j=A?G(A):{}}return!!j[T]}}e.hasSiblingFn=se;function G(_){const j={};for(const T of _)j[T]=!0;return j}function J(_){const j=_;return j&&typeof j.base=="string"&&typeof j.pattern=="string"}e.isRelativePattern=J;function W(_){return _.allBasenames||[]}e.getBasenameTerms=W;function V(_){return _.allPaths||[]}e.getPathTerms=V;function B(_,j){const T=H(Object.getOwnPropertyNames(_).map(C=>$(C,_[C],j)).filter(C=>C!==r)),A=T.length;if(!A)return r;if(!T.some(C=>!!C.requiresSiblings)){if(A===1)return T[0];const C=function(ie,oe){for(let ae=0,ee=T.length;ae<ee;ae++){const le=T[ae](ie,oe);if(le)return le}return null},q=T.find(ie=>!!ie.allBasenames);q&&(C.allBasenames=q.allBasenames);const Q=T.reduce((ie,oe)=>oe.allPaths?ie.concat(oe.allPaths):ie,[]);return Q.length&&(C.allPaths=Q),C}const O=function(C,q,Q){let ie;for(let oe=0,ae=T.length;oe<ae;oe++){const ee=T[oe];ee.requiresSiblings&&Q&&(q||(q=M.basename(C)),ie||(ie=q.substr(0,q.length-M.extname(C).length)));const le=ee(C,q,ie,Q);if(le)return le}return null},z=T.find(C=>!!C.allBasenames);z&&(O.allBasenames=z.allBasenames);const N=T.reduce((C,q)=>q.allPaths?C.concat(q.allPaths):C,[]);return N.length&&(O.allPaths=N),O}function $(_,j,T){if(j===!1)return r;const A=s(_,T);if(A===r)return r;if(typeof j=="boolean")return A;if(j){const O=j.when;if(typeof O=="string"){const z=(N,C,q,Q)=>{if(!Q||!A(N,C))return null;const ie=O.replace("$(basename)",q),oe=Q(ie);return(0,v.isThenable)(oe)?oe.then(ae=>ae?_:null):oe?_:null};return z.requiresSiblings=!0,z}}return A}function H(_,j){const T=_.filter(C=>!!C.basenames);if(T.length<2)return _;const A=T.reduce((C,q)=>{const Q=q.basenames;return Q?C.concat(Q):C},[]);let O;if(j){O=[];for(let C=0,q=A.length;C<q;C++)O.push(j)}else O=T.reduce((C,q)=>{const Q=q.patterns;return Q?C.concat(Q):C},[]);const z=function(C,q){if(typeof C!="string")return null;if(!q){let ie;for(ie=C.length;ie>0;ie--){const oe=C.charCodeAt(ie-1);if(oe===47||oe===92)break}q=C.substr(ie)}const Q=A.indexOf(q);return Q!==-1?O[Q]:null};z.basenames=A,z.patterns=O,z.allBasenames=A;const N=_.filter(C=>!C.basenames);return N.push(z),N}}),define(Z[34],x([0,1,30,10,8,3,15,25,7]),function(K,e,v,L,k,M,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function w(s,l,m){if(typeof s=="string"&&(s=f.URI.file(s)),m){const D=m.getWorkspaceFolder(s);if(D){const R=m.getWorkspace().folders.length>1;let F;if((0,E.isEqual)(D.uri,s)?F="":F=(0,E.relativePath)(D.uri,s),R){const U=D.name?D.name:(0,E.basename)(D.uri);F=F?U+" \u2022 "+F:U}return F}}if(s.scheme!==L.Schemas.file&&s.scheme!==L.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,v.hasDriveLetter)(s.fsPath))return(0,k.normalize)(I(s.fsPath));let S=(0,k.normalize)(s.fsPath);return!M.isWindows&&l?.userHome&&(S=y(S,l.userHome.fsPath)),S}e.getPathLabel=w;function t(s){if(!s)return;typeof s=="string"&&(s=f.URI.file(s));const l=(0,E.basename)(s)||(s.scheme===L.Schemas.file?s.fsPath:s.path);return M.isWindows&&(0,v.isRootOrDriveLetter)(l)?I(l):l}e.getBaseLabel=t;function I(s){return(0,v.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=I;let b=Object.create(null);function y(s,l){if(M.isWindows||!s||!l)return s;let m=b.original===l?b.normalized:void 0;return m||(m=`${(0,n.rtrim)(l,k.posix.sep)}${k.posix.sep}`,b={original:l,normalized:m}),(M.isLinux?s.startsWith(m):(0,n.startsWithIgnoreCase)(s,m))&&(s=`~/${s.substr(m.length)}`),s}e.tildify=y;function h(s,l){return s.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=h;const g="\u2026",P="\\\\",p="~";function c(s,l=k.sep){const m=new Array(s.length);let S=!1;for(let D=0;D<s.length;D++){let R=s[D];if(R===""){m[D]=`.${l}`;continue}if(!R){m[D]=R;continue}S=!0;let F="";R.indexOf(P)===0?(F=R.substr(0,R.indexOf(P)+P.length),R=R.substr(R.indexOf(P)+P.length)):R.indexOf(l)===0?(F=R.substr(0,R.indexOf(l)+l.length),R=R.substr(R.indexOf(l)+l.length)):R.indexOf(p)===0&&(F=R.substr(0,R.indexOf(p)+p.length),R=R.substr(R.indexOf(p)+p.length));const U=R.split(l);for(let X=1;S&&X<=U.length;X++)for(let ne=U.length-X;S&&ne>=0;ne--){S=!1;let se=U.slice(ne,ne+X).join(l);for(let G=0;!S&&G<s.length;G++)if(G!==D&&s[G]&&s[G].indexOf(se)>-1){const J=ne+X===U.length,W=ne>0&&s[G].indexOf(l)>-1?l+se:se,V=s[G].endsWith(W);S=!J||V}if(!S){let G="";(U[0].endsWith(":")||F!=="")&&(ne===1&&(ne=0,X++,se=U[0]+l+se),ne>0&&(G=U[0]+l),G=F+G),ne>0&&(G=G+g+l),G=G+se,ne+X<U.length&&(G=G+l+g),m[D]=G}}S&&(m[D]=R)}return m}e.shorten=c;var d;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function o(s,l=Object.create(null)){const m=[];let S=!1,D="";for(const R of s)if(R==="$"||S&&R==="{")D&&m.push({value:D,type:d.TEXT}),D="",S=!0;else if(R==="}"&&S){const F=l[D];if(typeof F=="string")F.length&&m.push({value:F,type:d.VARIABLE});else if(F){const U=m[m.length-1];(!U||U.type!==d.SEPARATOR)&&m.push({value:F.label,type:d.SEPARATOR})}D="",S=!1}else D+=R;return D&&!S&&m.push({value:D,type:d.TEXT}),m.filter((R,F)=>{if(R.type===d.SEPARATOR){const U=m[F-1],X=m[F+1];return[U,X].every(ne=>ne&&(ne.type===d.VARIABLE||ne.type===d.TEXT)&&ne.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=o;function u(s,l){return M.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):s.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function i(s,l){return M.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,""):M.isWindows?s.replace(/&&|&/g,m=>m==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function a(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=a;function r(s){const l=s.indexOf("/")!==-1?k.posix:k.win32,m=l.basename(s),S=l.dirname(s);return m.length?{name:m,parentPath:S}:{name:S,parentPath:""}}e.splitName=r}),define(Z[28],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(f){return v.test(f)}e.isUUID=L;const k=new Uint8Array(16),M=[];for(let f=0;f<256;f++)M.push(f.toString(16).padStart(2,"0"));let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(f){for(let w=0;w<f.length;w++)f[w]=Math.floor(Math.random()*256);return f};function n(){E(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let f=0,w="";return w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+="-",w+=M[k[f++]],w+=M[k[f++]],w+="-",w+=M[k[f++]],w+=M[k[f++]],w+="-",w+=M[k[f++]],w+=M[k[f++]],w+="-",w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w}e.generateUuid=n}),define(Z[112],x([0,1,58,31,43]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function M(E,n){if(await new Promise((t,I)=>{const b=L.createReadStream(E),y=v.createHash("sha1");b.pipe(y);const h=(0,k.once)((g,P)=>{b.removeAllListeners(),y.removeAllListeners(),g?I(g):t(P)});b.once("error",h),b.once("end",h),y.once("error",h),y.once("data",g=>h(void 0,g.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=M}),define(Z[80],x([0,1,239]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(M="utf8"){this.stringDecoder=new v.StringDecoder(M),this.remaining=null}write(M){const E=[],n=this.remaining?this.remaining+this.stringDecoder.write(M):this.stringDecoder.write(M);if(n.length<1)return E;let f=0,w,t=f;for(;t<n.length;)if(w=n.charCodeAt(t),w===13||w===10){if(E.push(n.substring(f,t)),t++,t<n.length){const I=w;w=n.charCodeAt(t),(I===13&&w===10||I===10&&w===13)&&t++}f=t}else t++;return this.remaining=f<n.length?n.substr(f):null,E}end(){return this.remaining}}e.LineDecoder=L}),define(Z[113],x([0,1,26]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(n){const f=n.replace(/\-/g,":").toLowerCase();return!L.has(f)}function M(){return new Promise(async(n,f)=>{const w=setTimeout(()=>f("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await E())}catch(t){f(t)}finally{clearTimeout(w)}})}e.getMac=M;function E(){return new Promise((n,f)=>{try{const w=(0,v.networkInterfaces)();for(let t in w){const I=w[t];if(I){for(const{mac:b}of I)if(k(b))return n(b)}}f("Unable to retrieve mac address (unexpected format)")}catch(w){f(w)}})}}),define(Z[67],x([0,1,26,17,37,28,113]),function(K,e,v,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(t){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(t)}value(){if(this._value===void 0){let t=0,I=0;const b=(0,v.networkInterfaces)();for(let y in b){const h=b[y];if(h)for(const{mac:g,internal:P}of h)P||(I+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(t+=1))}this._value=I>0?t/I:0}return this._value}};let n;async function f(){return n||(n=(async()=>await w()||M.generateUuid())()),n}e.getMachineId=f;async function w(){try{const t=await new Promise((b,y)=>{K(["crypto"],b,y)}),I=await(0,E.getMac)();return t.createHash("sha256").update(I,"utf8").digest("hex")}catch(t){L.onUnexpectedError(t);return}}}),define(Z[19],x([0,1,31,26,114,9,30,66,8,3,15,7,28]),function(K,e,v,L,k,M,E,n,f,w,t,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function h(W,V=y.UNLINK){if((0,E.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");return V===y.UNLINK?P(W):g(W)}async function g(W){try{const V=(0,f.join)((0,L.tmpdir)(),(0,b.generateUuid)());try{await e.Promises.rename(W,V)}catch(B){return P(W)}P(V).catch(B=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function P(W){return e.Promises.rmdir(W,{recursive:!0,maxRetries:3})}function p(W){if((0,E.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(W,{recursive:!0})}e.rimrafSync=p;async function c(W,V){return u(await(V?d(W):(0,k.promisify)(v.readdir)(W)))}async function d(W){try{return await(0,k.promisify)(v.readdir)(W,{withFileTypes:!0})}catch($){console.warn("[node.js fs] readdir with filetypes failed with error: ",$)}const V=[],B=await c(W);for(const $ of B){let H=!1,_=!1,j=!1;try{const T=await e.Promises.lstat((0,f.join)(W,$));H=T.isFile(),_=T.isDirectory(),j=T.isSymbolicLink()}catch(T){console.warn("[node.js fs] unexpected error from lstat after readdir: ",T)}V.push({name:$,isFile:()=>H,isDirectory:()=>_,isSymbolicLink:()=>j})}return V}function o(W){return u(v.readdirSync(W))}e.readdirSync=o;function u(W){return W.map(V=>typeof V=="string"?w.isMacintosh?(0,n.normalizeNFC)(V):V:(V.name=w.isMacintosh?(0,n.normalizeNFC)(V.name):V.name,V))}async function i(W){const V=await c(W),B=[];for(const $ of V)await r.existsDirectory((0,f.join)(W,$))&&B.push($);return B}function a(W,V=1e3){return new Promise(B=>{let $=!1;const H=setInterval(()=>{$||($=!0,v.access(W,_=>{$=!1,_&&(clearInterval(H),B(void 0))}))},V)})}e.whenDeleted=a;var r;(function(W){async function V(H){let _;try{if(_=await e.Promises.lstat(H),!_.isSymbolicLink())return{stat:_}}catch(j){}try{return{stat:await e.Promises.stat(H),symbolicLink:_?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};if(w.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(T){if(T.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};throw T}throw j}}W.stat=V;async function B(H){try{const{stat:_,symbolicLink:j}=await W.stat(H);return _.isFile()&&j?.dangling!==!0}catch(_){}return!1}W.existsFile=B;async function $(H){try{const{stat:_,symbolicLink:j}=await W.stat(H);return _.isDirectory()&&j?.dangling!==!0}catch(_){}return!1}W.existsDirectory=$})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new M.ResourceQueue;function l(W,V,B){return s.queueFor(I.URI.file(W),t.extUriBiasedIgnorePathCase).queue(()=>{const $=R(B);return new Promise((H,_)=>S(W,V,$,j=>j?_(j):H()))})}let m=!0;function S(W,V,B,$){if(!m)return v.writeFile(W,V,{mode:B.mode,flag:B.flag},$);v.open(W,B.flag,B.mode,(H,_)=>{if(H)return $(H);v.writeFile(_,V,j=>{if(j)return v.close(_,()=>$(j));v.fdatasync(_,T=>(T&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",T),m=!1),v.close(_,A=>$(A))))})})}function D(W,V,B){const $=R(B);if(!m)return v.writeFileSync(W,V,{mode:$.mode,flag:$.flag});const H=v.openSync(W,$.flag,$.mode);try{v.writeFileSync(H,V);try{v.fdatasyncSync(H)}catch(_){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",_),m=!1}}finally{v.closeSync(H)}}e.writeFileSync=D;function R(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function F(W,V){if(W===V)return;async function B($){try{const H=await e.Promises.lstat($);if(H.isDirectory()||H.isSymbolicLink())return;await e.Promises.utimes($,H.atime,new Date)}catch(H){}}try{await e.Promises.rename(W,V),await B(V)}catch($){if(W.toLowerCase()!==V.toLowerCase()&&$.code==="EXDEV"||W.endsWith("."))await U(W,V,{preserveSymlinks:!1}),await h(W,y.MOVE),await B(V);else throw $}}async function U(W,V,B){return ne(W,V,{root:{source:W,target:V},options:B,handledSourcePaths:new Set})}const X=511;async function ne(W,V,B){if(B.handledSourcePaths.has(W))return;B.handledSourcePaths.add(W);const{stat:$,symbolicLink:H}=await r.stat(W);if(H){if(B.options.preserveSymlinks)try{return await J(W,V,B)}catch(_){console.warn("[node.js fs] copy of symlink failed: ",_)}if(H.dangling)return}return $.isDirectory()?se(W,V,$.mode&X,B):G(W,V,$.mode&X)}async function se(W,V,B,$){await e.Promises.mkdir(V,{recursive:!0,mode:B});const H=await c(W);for(const _ of H)await ne((0,f.join)(W,_),(0,f.join)(V,_),$)}async function G(W,V,B){await e.Promises.copyFile(W,V),await e.Promises.chmod(V,B)}async function J(W,V,B){let $=await e.Promises.readlink(W);(0,E.isEqualOrParent)($,B.root.source,!w.isLinux)&&($=(0,f.join)(B.root.target,$.substr(B.root.source.length+1))),await e.Promises.symlink($,V)}e.Promises=new class{get access(){return(0,k.promisify)(v.access)}get stat(){return(0,k.promisify)(v.stat)}get lstat(){return(0,k.promisify)(v.lstat)}get utimes(){return(0,k.promisify)(v.utimes)}get read(){return(0,k.promisify)(v.read)}get readFile(){return(0,k.promisify)(v.readFile)}get write(){return(0,k.promisify)(v.write)}get appendFile(){return(0,k.promisify)(v.appendFile)}get fdatasync(){return(0,k.promisify)(v.fdatasync)}get truncate(){return(0,k.promisify)(v.truncate)}get rename(){return(0,k.promisify)(v.rename)}get copyFile(){return(0,k.promisify)(v.copyFile)}get open(){return(0,k.promisify)(v.open)}get close(){return(0,k.promisify)(v.close)}get symlink(){return(0,k.promisify)(v.symlink)}get readlink(){return(0,k.promisify)(v.readlink)}get chmod(){return(0,k.promisify)(v.chmod)}get mkdir(){return(0,k.promisify)(v.mkdir)}get unlink(){return(0,k.promisify)(v.unlink)}get rmdir(){return(0,k.promisify)(v.rmdir)}get realpath(){return(0,k.promisify)(v.realpath)}async exists(W){try{return await e.Promises.access(W),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return i}get writeFile(){return l}get rm(){return h}get move(){return F}get copy(){return U}}}),define(Z[81],x([0,1,31,8,25,19]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function E(t){const I=(0,L.dirname)(t);if(t===I)return t;const b=((0,L.basename)(t)||t).toLowerCase();try{const h=(0,M.readdirSync)(I).filter(g=>g.toLowerCase()===b);if(h.length===1){const g=E(I);if(g)return(0,L.join)(g,h[0])}else if(h.length>1){const g=h.indexOf(b);if(g>=0){const P=E(I);if(P)return(0,L.join)(P,h[g])}}}catch(y){}return null}e.realcaseSync=E;async function n(t){try{return await M.Promises.realpath(t)}catch(I){const b=w(t);return await M.Promises.access(b,v.constants.R_OK),b}}e.realpath=n;function f(t){try{return v.realpathSync(t)}catch(I){const b=w(t);return v.accessSync(b,v.constants.R_OK),b}}e.realpathSync=f;function w(t){return(0,k.rtrim)((0,L.normalize)(t),L.sep)}}),define(Z[115],x([0,1,59]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(n,f,w,t=1){let I=!1;return new Promise(b=>{const y=setTimeout(()=>{if(!I)return I=!0,b(0)},w);k(n,f,t,h=>{if(!I)return I=!0,clearTimeout(y),b(h)})})}e.findFreePort=L;function k(n,f,w,t){if(f===0)return t(0);const I=new v.Socket;I.once("connect",()=>(E(I),k(n+w,f-1,w,t))),I.once("data",()=>{}),I.once("error",b=>(E(I),b.code!=="ECONNREFUSED"?k(n+w,f-1,w,t):t(n))),I.connect(n,"127.0.0.1")}function M(n,f,w){let t=!1,I,b=1;const y=v.createServer({pauseOnConnect:!0});function h(g,P){t||(t=!0,y.removeAllListeners(),y.close(),I&&clearTimeout(I),P(g))}return new Promise(g=>{I=setTimeout(()=>{h(0,g)},w),y.on("listening",()=>{h(n,g)}),y.on("error",P=>{P&&(P.code==="EADDRINUSE"||P.code==="EACCES")&&b<f?(n++,b++,y.listen(n,"127.0.0.1")):h(0,g)}),y.on("close",()=>{h(0,g)}),y.listen(n,"127.0.0.1")})}e.findFreePortFaster=M;function E(n){try{n.removeAllListeners("connect"),n.removeAllListeners("error"),n.end(),n.destroy(),n.unref()}catch(f){console.error(f)}}}),define(Z[116],x([0,1,26,8,19]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const M=/^\d+$/,E=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var f;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(f||(f={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let t;process.env.PROCESSOR_ARCHITEW6432?t=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?t=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?t=1:t=0;class I{constructor(u,i,a){this.exePath=u,this.displayName=i,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function b({useAlternateBitness:o=!1}={}){return o?w===0?process.env["ProgramFiles(x86)"]||null:t===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:o=!1,findPreview:u=!1}={}){const i=b({useAlternateBitness:o});if(!i)return null;const a=L.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(a))return null;let r=-1,s=null;for(const S of await k.Promises.readdir(a)){let D=-1;if(u){const F=S.indexOf("-");if(F<0)continue;const U=S.substring(0,F);if(!M.test(U)||S.substring(F+1)!=="preview")continue;D=parseInt(U,10)}else{if(!M.test(S))continue;D=parseInt(S,10)}if(D<=r)continue;const R=L.join(a,S,"pwsh.exe");!await k.SymlinkSupport.existsFile(R)||(s=R,r=D)}if(!s)return null;const l=i.includes("x86")?" (x86)":"",m=u?" Preview":"";return new I(s,`PowerShell${m}${l}`,!0)}async function h({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const u=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:i,pwshMsixName:a}=o?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:E,pwshMsixName:"PowerShell (Store)"};for(const r of await k.Promises.readdir(u))if(i.test(r)){const s=L.join(u,r,"pwsh.exe");return new I(s,a)}return null}function g(){const o=L.join(v.homedir(),".dotnet","tools","pwsh.exe");return new I(o,".NET Core PowerShell Global Tool")}function P(){const o=L.join(process.env.windir,w===1&&t!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(o,"Windows PowerShell",!0)}async function*p(){let o=await y();o&&(yield o),o=await y({useAlternateBitness:!0}),o&&(yield o),o=await h(),o&&(yield o),o=g(),o&&(yield o),o=await y({findPreview:!0}),o&&(yield o),o=await h({findPreview:!0}),o&&(yield o),o=await y({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=P(),o&&(yield o)}async function*c(){for await(const o of p())await o.exists()&&(yield o)}e.enumeratePowerShellInstallations=c;async function d(){for await(const o of c())return o;return null}e.getFirstAvailablePowerShellInstallation=d}),define(Z[82],x([0,1,41,10]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(E){return new Promise((n,f)=>{let w;const t=new Map;function I(y,h,g,P,p){const c=t.get(h);if(y===E||c){const d={name:b(g),cmd:g,pid:y,ppid:h,load:P,mem:p};t.set(y,d),y===E&&(w=d),c&&(c.children||(c.children=[]),c.children.push(d),c.children.length>1&&(c.children=c.children.sort((o,u)=>o.pid-u.pid)))}}function b(y){const h=/--disable-blink-features=Auxclick/,g=/\\watcher\\win32\\CodeHelper\.exe/,P=/--crashes-directory/,p=/\\pipe\\winpty-control/,c=/conhost\.exe/,d=/--type=([a-zA-Z-]+)/;if(g.exec(y))return"watcherService ";if(P.exec(y))return"electron-crash-reporter";if(p.exec(y))return"winpty-process";if(c.exec(y))return"console-window-host (Windows internal process)";let o=d.exec(y);if(o&&o.length===2)return o[1]==="renderer"?h.exec(y)?"shared-process":"window":o[1];const u=/[a-zA-Z-]+\.js/g;let i="";do o=u.exec(y),o&&(i+=o+" ");while(o);return i&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${i}`:y}if(process.platform==="win32"){const y=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,g)=>{K(["windows-process-tree"],h,g)}).then(h=>{h.getProcessList(E,g=>{h.getProcessCpuUsage(g,P=>{const p=new Map;P.forEach(c=>{const d=y(c.commandLine||"");p.set(c.pid,{name:b(d),cmd:d,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),w=p.get(E),w?(p.forEach(c=>{const d=p.get(c.ppid);d&&(d.children||(d.children=[]),d.children.push(c))}),p.forEach(c=>{c.children&&(c.children=c.children.sort((d,o)=>d.pid-o.pid))}),n(w)):f(new Error(`Root process ${E} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let y=function(){let h=[w];const g=[];for(;h.length;){const p=h.shift();p&&(g.push(p.pid),p.children&&(h=h.concat(p.children)))}let P=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);P+=" "+g.join(" "),(0,v.exec)(P,{},(p,c,d)=>{if(p||d)f(p||new Error(d.toString()));else{const o=c.toString().split(`
`);for(let u=0;u<g.length;u++){const i=t.get(g[u]);i.load=parseFloat(o[u])}if(!w){f(new Error(`Root process ${E} not found`));return}n(w)}})};(0,v.exec)("which ps",{},(h,g,P)=>{if(h||P)if(process.platform!=="linux")f(h||new Error(P.toString()));else{const p=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,v.exec)(p,{},(c,d,o)=>{c||o?f(c||new Error(o.toString())):(M(d,I),y())})}else{const p=g.toString().trim(),c="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${p} ${c}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,o,u)=>{d||u&&!u.includes("screen size is bogus")?f(d||new Error(u.toString())):(M(o,I),process.platform==="linux"?y():w?n(w):f(new Error(`Root process ${E} not found`)))})}})}})}e.listProcesses=k;function M(E,n){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=E.toString().split(`
`);for(const t of w){const I=f.exec(t.trim());I&&I.length===6&&n(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(Z[117],x([0,1,31,23,30,2,66,8,3,19]),function(K,e,v,L,k,M,E,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function t(h,g,P){return b({path:h,isDirectory:!1},g,P)}e.watchFile=t;function I(h,g,P){return b({path:h,isDirectory:!0},g,P)}e.watchFolder=I,e.CHANGE_BUFFER_DELAY=100;function b(h,g,P){if(f.isMacintosh&&(0,k.isEqualOrParent)(h.path,"/Volumes/"))return P(`Refusing to watch ${h.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const p=(0,n.basename)(h.path),c=new Map;let d=!1,o=[(0,M.toDisposable)(()=>{c.forEach(u=>(0,M.dispose)(u)),c.clear()})];try{const u=(0,v.watch)(h.path);o.push((0,M.toDisposable)(()=>{u.removeAllListeners(),u.close()}));const i=new Set;h.isDirectory&&w.Promises.readdir(h.path).then(a=>a.forEach(r=>i.add(r))),u.on("error",(a,r)=>{d||P(`Failed to watch ${h.path} for changes using fs.watch() (${a}, ${r})`)}),u.on("change",(a,r)=>{if(d)return;let s="";if(r&&(s=r.toString(),f.isMacintosh&&(s=(0,E.normalizeNFC)(s))),!s||a!=="change"&&a!=="rename")return;const l=h.isDirectory?(0,n.join)(h.path,s):h.path;if(h.isDirectory)if(a==="rename"){const m=c.get(l);m&&(0,M.dispose)(m);const S=setTimeout(async()=>{c.delete(l);const D=await w.Promises.exists(l);if(d)return;let R;D?i.has(s)?R="changed":(R="added",i.add(s)):(i.delete(s),R="deleted"),g(R,l)},e.CHANGE_BUFFER_DELAY);c.set(l,(0,M.toDisposable)(()=>clearTimeout(S)))}else{let m;i.has(s)?m="changed":(m="added",i.add(s)),g(m,l)}else if(a==="rename"||s!==p){const m=setTimeout(async()=>{const S=await w.Promises.exists(l);d||(S?(g("changed",l),o=[b(h,g,P)]):g("deleted",l))},e.CHANGE_BUFFER_DELAY);(0,M.dispose)(o),o=[(0,M.toDisposable)(()=>clearTimeout(m))]}else g("changed",l)})}catch(u){w.Promises.exists(h.path).then(i=>{i&&!d&&P(`Failed to watch ${h.path} for changes using fs.watch() (${u.toString()})`)})}return(0,M.toDisposable)(()=>{d=!0,o=(0,M.dispose)(o)})}async function y(h,g,P,p=512){const c=await w.Promises.open(h,"r"),d=Buffer.allocUnsafe(p),o=new L.CancellationTokenSource(P);let u,i=!1;const a=t(h,async r=>{if(r==="changed"){if(i)return;i=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:s}=await w.Promises.read(c,d,0,p,null);if(!s||o.token.isCancellationRequested)break;g(d.slice(0,s))}}catch(s){u=new Error(s),o.dispose(!0)}finally{i=!1}}},r=>{u=new Error(r),o.dispose(!0)});return new Promise((r,s)=>{o.token.onCancellationRequested(async()=>{a.dispose(),await w.Promises.close(c),u?s(u):r()})})}e.watchFileContents=y}),define(Z[118],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[119],x([0,1,14,13,118]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){v.ipcMain.on(k.CONTEXT_MENU_CHANNEL,(n,f,w,t,I)=>{const b=E(n,t,w);b.popup({window:(0,L.withNullAsUndefined)(v.BrowserWindow.fromWebContents(n.sender)),x:I?I.x:void 0,y:I?I.y:void 0,positioningItem:I?I.positioningItem:void 0,callback:()=>{b&&n.sender.send(k.CONTEXT_MENU_CLOSE_CHANNEL,f)}})})}e.registerContextMenuListener=M;function E(n,f,w){const t=new v.Menu;return w.forEach(I=>{let b;I.type==="separator"?b=new v.MenuItem({type:I.type}):Array.isArray(I.submenu)?b=new v.MenuItem({submenu:E(n,f,I.submenu),label:I.label}):b=new v.MenuItem({label:I.label,type:I.type,accelerator:I.accelerator,checked:I.checked,enabled:I.enabled,visible:I.visible,click:(y,h,g)=>n.sender.send(f,I.id,g)}),t.append(b)}),t}});var he=this&&this.__decorate||function(K,e,v,L){var k=arguments.length,M=k<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,v):L,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(K,e,v,L);else for(var n=K.length-1;n>=0;n--)(E=K[n])&&(M=(k<3?E(M):k>3?E(e,v,M):E(e,v))||M);return k>3&&M&&Object.defineProperty(e,v,M),M};define(Z[35],x([0,1,32,9,18,23,47,17,4,2,110,25,13]),function(K,e,v,L,k,M,E,n,f,w,t,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function h(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function P(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(p||(p={}));class c{constructor(_){this.buffer=_,this.pos=0}read(_){const j=this.buffer.slice(this.pos,this.pos+_);return this.pos+=j.byteLength,j}}class d{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(_){this.buffers.push(_)}}var o;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object"})(o||(o={}));function u(H){const _=k.VSBuffer.alloc(4);return _.writeUInt32BE(H,0),_}function i(H){return H.read(4).readUInt32BE(0)}function a(H){const _=k.VSBuffer.alloc(1);return _.writeUInt8(H,0),_}const r={Undefined:a(o.Undefined),String:a(o.String),Buffer:a(o.Buffer),VSBuffer:a(o.VSBuffer),Array:a(o.Array),Object:a(o.Object)},s=typeof Buffer!="undefined";function l(H,_){if(typeof _=="undefined")H.write(r.Undefined);else if(typeof _=="string"){const j=k.VSBuffer.fromString(_);H.write(r.String),H.write(u(j.byteLength)),H.write(j)}else if(s&&Buffer.isBuffer(_)){const j=k.VSBuffer.wrap(_);H.write(r.Buffer),H.write(u(j.byteLength)),H.write(j)}else if(_ instanceof k.VSBuffer)H.write(r.VSBuffer),H.write(u(_.byteLength)),H.write(_);else if(Array.isArray(_)){H.write(r.Array),H.write(u(_.length));for(const j of _)l(H,j)}else{const j=k.VSBuffer.fromString(JSON.stringify(_));H.write(r.Object),H.write(u(j.byteLength)),H.write(j)}}function m(H){switch(H.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return H.read(i(H)).toString();case o.Buffer:return H.read(i(H)).buffer;case o.VSBuffer:return H.read(i(H));case o.Array:{const j=i(H),T=[];for(let A=0;A<j;A++)T.push(m(H));return T}case o.Object:return JSON.parse(H.read(i(H)).toString())}}class S{constructor(_,j,T=null,A=1e3){this.protocol=_,this.ctx=j,this.logger=T,this.timeoutDelay=A,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(O=>this.onRawMessage(O)),this.sendResponse({type:200})}registerChannel(_,j){this.channels.set(_,j),setTimeout(()=>this.flushPendingRequests(_),0)}sendResponse(_){switch(_.type){case 200:{const j=this.send([_.type]);this.logger&&this.logger.logOutgoing(j,0,1,P(_.type));return}case 201:case 202:case 204:case 203:{const j=this.send([_.type,_.id],_.data);this.logger&&this.logger.logOutgoing(j,_.id,1,P(_.type),_.data);return}}}send(_,j=void 0){const T=new d;return l(T,_),l(T,j),this.sendBuffer(T.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch(j){return 0}}onRawMessage(_){const j=new c(_),T=m(j),A=m(j),O=T[0];switch(O){case 100:return this.logger&&this.logger.logIncoming(_.byteLength,T[1],1,`${h(O)}: ${T[2]}.${T[3]}`,A),this.onPromise({type:O,id:T[1],channelName:T[2],name:T[3],arg:A});case 102:return this.logger&&this.logger.logIncoming(_.byteLength,T[1],1,`${h(O)}: ${T[2]}.${T[3]}`,A),this.onEventListen({type:O,id:T[1],channelName:T[2],name:T[3],arg:A});case 101:return this.logger&&this.logger.logIncoming(_.byteLength,T[1],1,`${h(O)}`),this.disposeActiveRequest({type:O,id:T[1]});case 103:return this.logger&&this.logger.logIncoming(_.byteLength,T[1],1,`${h(O)}`),this.disposeActiveRequest({type:O,id:T[1]})}}onPromise(_){const j=this.channels.get(_.channelName);if(!j){this.collectPendingRequest(_);return}const T=new M.CancellationTokenSource;let A;try{A=j.call(this.ctx,_.name,_.arg,T.token)}catch(N){A=Promise.reject(N)}const O=_.id;A.then(N=>{this.sendResponse({id:O,data:N,type:201}),this.activeRequests.delete(_.id)},N=>{N instanceof Error?this.sendResponse({id:O,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.sendResponse({id:O,data:N,type:203}),this.activeRequests.delete(_.id)});const z=(0,w.toDisposable)(()=>T.cancel());this.activeRequests.set(_.id,z)}onEventListen(_){const j=this.channels.get(_.channelName);if(!j){this.collectPendingRequest(_);return}const T=_.id,O=j.listen(this.ctx,_.name,_.arg)(z=>this.sendResponse({id:T,data:z,type:204}));this.activeRequests.set(_.id,O)}disposeActiveRequest(_){const j=this.activeRequests.get(_.id);j&&(j.dispose(),this.activeRequests.delete(_.id))}collectPendingRequest(_){let j=this.pendingRequests.get(_.channelName);j||(j=[],this.pendingRequests.set(_.channelName,j));const T=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.sendResponse({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:_,timeoutTimer:T})}flushPendingRequests(_){const j=this.pendingRequests.get(_);if(j){for(const T of j)switch(clearTimeout(T.timeoutTimer),T.request.type){case 100:this.onPromise(T.request);break;case 102:this.onEventListen(T.request);break}this.pendingRequests.delete(_)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(_=>_.dispose()),this.activeRequests.clear()}}e.ChannelServer=S;var D;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(D=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(_,j=null){this.protocol=_,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(T=>this.onBuffer(T)),this.logger=j}getChannel(_){const j=this;return{call(T,A,O){return j.isDisposed?Promise.reject(n.canceled()):j.requestPromise(_,T,A,O)},listen(T,A){return j.isDisposed?Promise.reject(n.canceled()):j.requestEvent(_,T,A)}}}requestPromise(_,j,T,A=M.CancellationToken.None){const O=this.lastRequestId++,N={id:O,type:100,channelName:_,name:j,arg:T};if(A.isCancellationRequested)return Promise.reject(n.canceled());let C;return new Promise((Q,ie)=>{if(A.isCancellationRequested)return ie(n.canceled());const oe=()=>{const me=ue=>{switch(ue.type){case 201:this.handlers.delete(O),Q(ue.data);break;case 202:this.handlers.delete(O);const ve=new Error(ue.data.message);ve.stack=ue.data.stack,ve.name=ue.data.name,ie(ve);break;case 203:this.handlers.delete(O),ie(ue.data);break}};this.handlers.set(O,me),this.sendRequest(N)};let ae=null;this.state===p.Idle?oe():(ae=(0,L.createCancelablePromise)(me=>this.whenInitialized()),ae.then(()=>{ae=null,oe()}));const ee=()=>{ae?(ae.cancel(),ae=null):this.sendRequest({id:O,type:101}),ie(n.canceled())},le=A.onCancellationRequested(ee);C=(0,w.combinedDisposable)((0,w.toDisposable)(ee),le),this.activeRequests.add(C)}).finally(()=>{this.activeRequests.delete(C)})}requestEvent(_,j,T){const A=this.lastRequestId++,z={id:A,type:102,channelName:_,name:j,arg:T};let N=null;const C=new f.Emitter({onFirstListenerAdd:()=>{N=(0,L.createCancelablePromise)(Q=>this.whenInitialized()),N.then(()=>{N=null,this.activeRequests.add(C),this.sendRequest(z)})},onLastListenerRemove:()=>{N?(N.cancel(),N=null):(this.activeRequests.delete(C),this.sendRequest({id:A,type:103}))}}),q=Q=>C.fire(Q.data);return this.handlers.set(A,q),C.event}sendRequest(_){switch(_.type){case 100:case 102:{const j=this.send([_.type,_.id,_.channelName,_.name],_.arg);this.logger&&this.logger.logOutgoing(j,_.id,0,`${h(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const j=this.send([_.type,_.id]);this.logger&&this.logger.logOutgoing(j,_.id,0,h(_.type));return}}}send(_,j=void 0){const T=new d;return l(T,_),l(T,j),this.sendBuffer(T.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch(j){return 0}}onBuffer(_){const j=new c(_),T=m(j),A=m(j),O=T[0];switch(O){case 200:return this.logger&&this.logger.logIncoming(_.byteLength,0,0,P(O)),this.onResponse({type:T[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(_.byteLength,T[1],0,P(O),A),this.onResponse({type:T[0],id:T[1],data:A})}}onResponse(_){if(_.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(_.id);j&&j(_)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(_=>_.dispose()),this.activeRequests.clear()}}he([E.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class F{constructor(_){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,_(({protocol:j,onDidClientDisconnect:T})=>{f.Event.once(j.onMessage)(O=>{const z=new c(O),N=m(z),C=new S(j,N),q=new R(j);this.channels.forEach((ie,oe)=>C.registerChannel(oe,ie));const Q={channelServer:C,channelClient:q,ctx:N};this._connections.add(Q),this._onDidAddConnection.fire(Q),T(()=>{C.dispose(),q.dispose(),this._connections.delete(Q),this._onDidRemoveConnection.fire(Q)})})})}get connections(){const _=[];return this._connections.forEach(j=>_.push(j)),_}getChannel(_,j){const T=this;return{call(A,O,z){let N;if((0,b.isFunction)(j)){let q=(0,v.getRandomElement)(T.connections.filter(j));N=q?Promise.resolve(q):f.Event.toPromise(f.Event.filter(T.onDidAddConnection,j))}else N=j.routeCall(T,A,O);const C=N.then(q=>q.channelClient.getChannel(_));return X(C).call(A,O,z)},listen(A,O){if((0,b.isFunction)(j))return T.getMulticastEvent(_,j,A,O);const z=j.routeEvent(T,A,O).then(N=>N.channelClient.getChannel(_));return X(z).listen(A,O)}}}getMulticastEvent(_,j,T,A){const O=this;let z=new w.DisposableStore;const N=new f.Emitter({onFirstListenerAdd:()=>{z=new w.DisposableStore;const C=new f.EventMultiplexer,q=new Map,Q=oe=>{const ee=oe.channelClient.getChannel(_).listen(T,A),le=C.add(ee);q.set(oe,le)},ie=oe=>{const ae=q.get(oe);!ae||(ae.dispose(),q.delete(oe))};O.connections.filter(j).forEach(Q),f.Event.filter(O.onDidAddConnection,j)(Q,void 0,z),O.onDidRemoveConnection(ie,void 0,z),C.event(N.fire,N,z),z.add(C)},onLastListenerRemove:()=>{z.dispose()}});return N.event}registerChannel(_,j){this.channels.set(_,j),this._connections.forEach(T=>{T.channelServer.registerChannel(_,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=F;class U{constructor(_,j,T=null){const A=new d;l(A,j),_.send(A.buffer),this.channelClient=new R(_,T),this.channelServer=new S(_,j,T)}getChannel(_){return this.channelClient.getChannel(_)}registerChannel(_,j){this.channelServer.registerChannel(_,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=U;function X(H){return{call(_,j,T){return H.then(A=>A.call(_,j,T))},listen(_,j){const T=new f.Relay;return H.then(A=>T.input=A.listen(_,j)),T.event}}}e.getDelayedChannel=X;function ne(H){let _=!1;return{call(j,T,A){return _?H.call(j,T,A):(0,L.timeout)(0).then(()=>_=!0).then(()=>H.call(j,T,A))},listen(j,T){if(_)return H.listen(j,T);const A=new f.Relay;return(0,L.timeout)(0).then(()=>_=!0).then(()=>A.input=H.listen(j,T)),A.event}}}e.getNextTickChannel=ne;class se{constructor(_){this.fn=_}routeCall(_){return this.route(_)}routeEvent(_){return this.route(_)}async route(_){for(const j of _.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await f.Event.toPromise(_.onDidAddConnection),await this.route(_)}}e.StaticRouter=se;var G;(function(H){function _(A,O){const z=A,N=O&&O.disableMarshalling,C=new Map;for(const q in z)T(q)&&C.set(q,f.Event.buffer(z[q],!0));return new class{listen(q,Q){const ie=C.get(Q);if(ie)return ie;throw new Error(`Event not found: ${Q}`)}call(q,Q,ie){const oe=z[Q];if(typeof oe=="function"){if(!N&&Array.isArray(ie))for(let ae=0;ae<ie.length;ae++)ie[ae]=(0,t.revive)(ie[ae]);return oe.apply(z,ie)}throw new Error(`Method not found: ${Q}`)}}}H.fromService=_;function j(A,O){const z=O&&O.disableMarshalling;return new Proxy({},{get(N,C){if(typeof C=="string")return O?.properties?.has(C)?O.properties.get(C):T(C)?A.listen(C):async function(...q){let Q;O&&!(0,b.isUndefinedOrNull)(O.context)?Q=[O.context,...q]:Q=q;const ie=await A.call(C,Q);return z?ie:(0,t.revive)(ie)};throw new Error(`Property not found: ${String(C)}`)}})}H.toService=j;function T(A){return A[0]==="o"&&A[1]==="n"&&I.isUpperAsciiLetter(A.charCodeAt(2))}})(G=e.ProxyChannel||(e.ProxyChannel={}));const J=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){let _=H.toString();if(_!=="[object Object]")return _}return H}function V(H){return Array.isArray(H)?H.map(W):W(H)}function B(H,_,j,T,A,O,z){z=V(z);const N=J[A],C=N[T%N.length];let q=[`%c[${H}]%c[${String(_).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(T).padStart(5," ")} - ${O}`,"color: darkgreen","color: grey","color: grey",`color: ${C}`];/\($/.test(O)?(q=q.concat(z),q.push(")")):q.push(z),console.log.apply(console,q)}e.logWithColors=B;class ${constructor(_,j){this._outgoingPrefix=_,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(_,j,T,A,O){this._totalOutgoing+=_,B(this._outgoingPrefix,this._totalOutgoing,_,j,T,A,O)}logIncoming(_,j,T,A,O){this._totalIncoming+=_,B(this._incomingPrefix,this._totalIncoming,_,j,T,A,O)}}e.IPCLogger=$}),define(Z[120],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(k,M){this.sender=k,this.onMessage=M}send(k){try{this.sender.send("vscode:message",k.buffer)}catch(M){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(Z[121],x([0,1,18,4,35]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class M{constructor(f){this.port=f,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",w=>v.VSBuffer.wrap(w.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=M;class E extends k.IPCClient{constructor(f,w){const t=new M(f);super(t,w);this.protocol=t}dispose(){this.protocol.disconnect()}}e.Client=E}),define(Z[83],x([0,1,18,4,2,3,33,35]),function(K,e,v,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var f;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function t(){return w||(w=v.VSBuffer.alloc(0)),w}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,l){if(s===0)return t();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const R=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=s),R}if(this._chunks[0].byteLength>s){const R=this._chunks[0].slice(0,s);return l&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),R}let m=v.VSBuffer.alloc(s),S=0,D=0;for(;s>0;){const R=this._chunks[D];if(R.byteLength>s){const F=R.slice(0,s);m.set(F,S),S+=s,l&&(this._chunks[D]=R.slice(s),this._totalLength-=s),s-=s}else m.set(R,S),S+=R.byteLength,l?(this._chunks.shift(),this._totalLength-=R.byteLength):D++,s-=R.byteLength}return m}}e.ChunkStream=I;var b;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(b||(b={}));var y;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(y=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(s,l,m,S){this.type=s,this.id=l,this.ack=m,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends k.Disposable{constructor(s){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5);else{const m=this._state.messageType,S=this._state.id,D=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(m,S,D,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class P{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=v.VSBuffer.alloc(13);l.writeUInt8(s.type,0),l.writeUInt32BE(s.id,1),l.writeUInt32BE(s.ack,5),l.writeUInt32BE(s.data.byteLength,9),this._writeSoon(l,s.data)}_bufferAdd(s,l){const m=this._totalLength===0;return this._data.push(s,l),this._totalLength+=s.byteLength+l.byteLength,m}_bufferTake(){const s=v.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,l){this._bufferAdd(s,l)&&M.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class p extends k.Disposable{constructor(s){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new P(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new h(1,0,0,s))}}e.Protocol=p;class c extends n.IPCClient{constructor(s,l,m=null){super(s,l,m);this.protocol=s}static fromSocket(s,l){return new c(new p(s),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=c;class d{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,E.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=d;class o{constructor(s){this.data=s,this.next=null}}class u{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],l=0,m=this._first;for(;m;)s[l++]=m.data,m=m.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const l=new o(s);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class i{constructor(){this.lastRuns=[];const s=Date.now();for(let l=0;l<i._HISTORY_LENGTH;l++)this.lastRuns[l]=s-1e3*l;setInterval(()=>{for(let l=i._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return i._INSTANCE||(i._INSTANCE=new i),i._INSTANCE}load(){const s=Date.now(),l=(1+i._HISTORY_LENGTH)*1e3;let m=0;for(let S=0;S<i._HISTORY_LENGTH;S++)s-this.lastRuns[S]<=l&&m++;return 1-m/i._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}i._HISTORY_LENGTH=10,i._INSTANCE=null;class a{constructor(s,l=null,m=i.getInstance()){this._onControlMessage=new d,this.onControlMessage=this._onControlMessage.event,this._onMessage=new d,this.onMessage=this._onMessage.event,this._onDidDispose=new d,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new d,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new d,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=m,this._isReconnecting=!1,this._outgoingUnackMsg=new u,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new P(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(S=>this._receiveMessage(S))),this._socketDisposables.push(this._socket.onClose(S=>this._onSocketClose.fire(S))),l&&this._socketReader.acceptChunk(l),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new h(5,0,0,t());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const l=new h(4,0,0,t());this._socketWriter.write(l),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,l){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new P(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(m=>this._receiveMessage(m))),this._socketDisposables.push(this._socket.onClose(m=>this._onSocketClose.fire(m))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let l=0,m=s.length;l<m;l++)this._socketWriter.write(s[l]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new h(6,0,0,t())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const l=this._outgoingUnackMsg.toArray();for(let m=0,S=l.length;m<S;m++)this._socketWriter.write(l[m]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const m=new h(1,l,this._incomingAckId,s);this._outgoingUnackMsg.push(m),this._isReconnecting||(this._socketWriter.write(m),this._recvAckCheck())}sendControl(s){const l=new h(2,0,0,s);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),l=Date.now()-s.writtenTime;if(l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-l,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new h(3,0,this._incomingAckId,t());this._socketWriter.write(s)}}e.PersistentProtocol=a}),define(Z[122],x([0,1,14,18,4,2,35,120]),function(K,e,v,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(t,I){const b=k.Event.fromNodeEventEmitter(v.ipcMain,I,(h,g)=>({event:h,message:g})),y=k.Event.filter(b,({event:h})=>h.sender.id===t);return k.Event.map(y,({message:h})=>h&&L.VSBuffer.wrap(h))}class w extends E.IPCServer{constructor(){super(w.getOnDidClientConnect())}static getOnDidClientConnect(){const I=k.Event.fromNodeEventEmitter(v.ipcMain,"vscode:hello",({sender:b})=>b);return k.Event.map(I,b=>{const y=b.id,h=w.Clients.get(y);h&&h.dispose();const g=new k.Emitter;w.Clients.set(y,(0,M.toDisposable)(()=>g.fire()));const P=f(y,"vscode:message"),p=k.Event.any(k.Event.signal(f(y,"vscode:disconnect")),g.event);return{protocol:new n.Protocol(b,P),onDidClientDisconnect:p}})}}e.Server=w,w.Clients=new Map}),define(Z[84],x([0,1,14,4,28,121]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class E extends M.Client{constructor(w,t){super({addEventListener:(I,b)=>w.addListener(I,b),removeEventListener:(I,b)=>w.removeListener(I,b),postMessage:I=>w.postMessage(I),start:()=>w.start(),close:()=>w.close()},t)}}e.Client=E;async function n(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const w=(0,k.generateUuid)();f.webContents.send("vscode:createMessageChannel",w);const t=L.Event.fromNodeEventEmitter(v.ipcMain,"vscode:createMessageChannelResult",(b,y)=>({nonce:y,port:b.ports[0]})),{port:I}=await L.Event.toPromise(L.Event.once(L.Event.filter(t,b=>b.nonce===w)));return I}e.connect=n}),define(Z[85],x([0,1,9,4,2,13]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var E;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(E=e.StorageHint||(e.StorageHint={}));function n(I){const b=I;return b?.changed instanceof Map||b?.deleted instanceof Set}e.isStorageItemsChangeEvent=n;var f;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(f||(f={}));class w extends k.Disposable{constructor(b,y=Object.create(null)){super();this.database=b,this.options=y,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=f.None,this.cache=new Map,this.flushDelayer=new v.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(b=>this.onDidChangeItemsExternal(b)))}onDidChangeItemsExternal(b){b.changed?.forEach((y,h)=>this.accept(h,y)),b.deleted?.forEach(y=>this.accept(y,void 0))}accept(b,y){if(this.state===f.Closed)return;let h=!1;(0,M.isUndefinedOrNull)(y)?h=this.cache.delete(b):this.cache.get(b)!==y&&(this.cache.set(b,y),h=!0),h&&this._onDidChangeStorage.fire(b)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===f.None&&(this.state=f.Initialized,this.options.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(b,y){const h=this.cache.get(b);return(0,M.isUndefinedOrNull)(h)?y:h}getBoolean(b,y){const h=this.get(b);return(0,M.isUndefinedOrNull)(h)?y:h==="true"}getNumber(b,y){const h=this.get(b);return(0,M.isUndefinedOrNull)(h)?y:parseInt(h,10)}async set(b,y){if(this.state===f.Closed)return;if((0,M.isUndefinedOrNull)(y))return this.delete(b);const h=String(y);if(this.cache.get(b)!==h)return this.cache.set(b,h),this.pendingInserts.set(b,h),this.pendingDeletes.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async delete(b){if(!(this.state===f.Closed||!this.cache.delete(b)))return this.pendingDeletes.has(b)||this.pendingDeletes.add(b),this.pendingInserts.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=f.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(b){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const b={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(b).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(b=>this.whenFlushedCallbacks.push(b))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class t{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(b){b.insert&&b.insert.forEach((y,h)=>this.items.set(h,y)),b.delete&&b.delete.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=t}),define(Z[123],x([0,1,9,4,37,8,19]),function(K,e,v,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class n{constructor(t,I=Object.create(null)){this.path=t,this.options=I,this.name=(0,M.basename)(this.path),this.logger=new f(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return L.Event.None}async getItems(){const t=await this.whenConnected,I=new Map;return(await this.all(t,"SELECT * FROM ItemTable")).forEach(y=>I.set(y.key,y.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${I.size} rows`),I}async updateItems(t){const I=await this.whenConnected;return this.doUpdateItems(I,t)}doUpdateItems(t,I){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${I.insert?(0,k.mapToString)(I.insert):"0"}), delete(${I.delete?(0,k.setToString)(I.delete):"0"})`),this.transaction(t,()=>{const b=I.insert,y=I.delete;if(b&&b.size>0){const h=[];h.push([]);let g=0;b.forEach((P,p)=>{let c=h[g];c.length>n.MAX_HOST_PARAMETERS&&(g++,c=[],h.push(c)),c.push(p,P)}),h.forEach(P=>{this.prepare(t,`INSERT INTO ItemTable VALUES ${new Array(P.length/2).fill("(?,?)").join(",")}`,p=>p.run(P),()=>{const p=[];let c=0;return b.forEach((d,o)=>{p.push(o),c+=d.length}),`Keys: ${p.join(", ")} Length: ${c}`})})}if(y&&y.size){const h=[];h.push([]);let g=0;y.forEach(P=>{let p=h[g];p.length>n.MAX_HOST_PARAMETERS&&(g++,p=[],h.push(p)),p.push(P)}),h.forEach(P=>{this.prepare(t,`DELETE FROM ItemTable WHERE key IN (${new Array(P.length).fill("?").join(",")})`,p=>p.run(P),()=>{const p=[];return y.forEach(c=>{p.push(c)}),`Keys: ${p.join(", ")}`})})}})}async close(t){this.logger.trace(`[storage ${this.name}] close()`);const I=await this.whenConnected;return this.doClose(I,t)}doClose(t,I){return new Promise((b,y)=>{t.db.close(h=>(h&&this.handleSQLiteError(t,`[storage ${this.name}] close(): ${h}`),this.path===n.IN_MEMORY_PATH?b():!t.isErroneous&&!t.isInMemory?this.backup().then(b,g=>(this.logger.error(`[storage ${this.name}] backup(): ${g}`),b())):typeof I=="function"?E.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(g=>{const P=()=>this.doClose(g,void 0);return this.doUpdateItems(g,{insert:I()}).then(()=>P(),p=>(P(),Promise.reject(p)))})).then(b,y):y(h||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const t=this.toBackupPath(this.path);return E.Promises.copy(this.path,t,{preserveSymlinks:!1})}toBackupPath(t){return`${t}.backup`}async checkIntegrity(t){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${t})`);const I=await this.whenConnected,b=await this.get(I,t?"PRAGMA integrity_check":"PRAGMA quick_check"),y=t?b.integrity_check:b.quick_check;return I.isErroneous?`${y} (last error: ${I.lastError})`:I.isInMemory?`${y} (in-memory!)`:y}async connect(t,I=!0){this.logger.trace(`[storage ${this.name}] open(${t}, retryOnBusy: ${I})`);try{return await this.doConnect(t)}catch(b){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${b}`),b.code==="SQLITE_BUSY"&&I)return await(0,v.timeout)(n.BUSY_OPEN_TIMEOUT),this.connect(t,!1);try{await E.Promises.unlink(t);try{await E.Promises.rename(this.toBackupPath(t),t)}catch(y){}return await this.doConnect(t)}catch(y){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${y}`),this.doConnect(n.IN_MEMORY_PATH)}}}handleSQLiteError(t,I){t.isErroneous=!0,t.lastError=I,this.logger.error(I)}doConnect(t){return new Promise((I,b)=>{new Promise((y,h)=>{K(["@vscode/sqlite3"],y,h)}).then(y=>{const h={db:new(this.logger.isTracing?y.verbose().Database:y.Database)(t,g=>g?h.db?h.db.close(()=>b(g)):b(g):this.exec(h,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>I(h),P=>h.db.close(()=>b(P)))),isInMemory:t===n.IN_MEMORY_PATH};h.db.on("error",g=>this.handleSQLiteError(h,`[storage ${this.name}] Error (event): ${g}`)),this.logger.isTracing&&h.db.on("trace",g=>this.logger.trace(`[storage ${this.name}] Trace (event): ${g}`))},b)})}exec(t,I){return new Promise((b,y)=>{t.db.exec(I,h=>h?(this.handleSQLiteError(t,`[storage ${this.name}] exec(): ${h}`),y(h)):b())})}get(t,I){return new Promise((b,y)=>{t.db.get(I,(h,g)=>h?(this.handleSQLiteError(t,`[storage ${this.name}] get(): ${h}`),y(h)):b(g))})}all(t,I){return new Promise((b,y)=>{t.db.all(I,(h,g)=>h?(this.handleSQLiteError(t,`[storage ${this.name}] all(): ${h}`),y(h)):b(g))})}transaction(t,I){return new Promise((b,y)=>{t.db.serialize(()=>{t.db.run("BEGIN TRANSACTION"),I(),t.db.run("END TRANSACTION",h=>h?(this.handleSQLiteError(t,`[storage ${this.name}] transaction(): ${h}`),y(h)):b())})})}prepare(t,I,b,y){const h=t.db.prepare(I),g=P=>{this.handleSQLiteError(t,`[storage ${this.name}] prepare(): ${P} (${I}). Details: ${y()}`)};h.on("error",g),b(h),h.finalize(P=>{P&&g(P),h.removeListener("error",g)})}}e.SQLiteStorageDatabase=n,n.IN_MEMORY_PATH=":memory:",n.BUSY_OPEN_TIMEOUT=2e3,n.MAX_HOST_PARAMETERS=256;class f{constructor(t){t&&typeof t.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.logTrace=t.logTrace),t&&typeof t.logError=="function"&&(this.logError=t.logError)}get isTracing(){return!!this.logTrace}trace(t){this.logTrace&&this.logTrace(t)}error(t){this.logError&&this.logError(t)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[124],x([12,11]),function(K,e){return K.create("vs/base/common/date",e)}),define(Z[125],x([0,1,124]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,k=L*60,M=k*24,E=M*7,n=M*30,f=M*365;function w(I,b){typeof I!="number"&&(I=I.getTime());const y=Math.round((new Date().getTime()-I)/1e3);if(y<-30)return(0,v.localize)(0,null,w(new Date().getTime()+y*1e3,!1));if(y<30)return(0,v.localize)(1,null);let h;return y<L?(h=y,b?h===1?(0,v.localize)(2,null,h):(0,v.localize)(3,null,h):h===1?(0,v.localize)(4,null,h):(0,v.localize)(5,null,h)):y<k?(h=Math.floor(y/L),b?h===1?(0,v.localize)(6,null,h):(0,v.localize)(7,null,h):h===1?(0,v.localize)(8,null,h):(0,v.localize)(9,null,h)):y<M?(h=Math.floor(y/k),b?h===1?(0,v.localize)(10,null,h):(0,v.localize)(11,null,h):h===1?(0,v.localize)(12,null,h):(0,v.localize)(13,null,h)):y<E?(h=Math.floor(y/M),b?h===1?(0,v.localize)(14,null,h):(0,v.localize)(15,null,h):h===1?(0,v.localize)(16,null,h):(0,v.localize)(17,null,h)):y<n?(h=Math.floor(y/E),b?h===1?(0,v.localize)(18,null,h):(0,v.localize)(19,null,h):h===1?(0,v.localize)(20,null,h):(0,v.localize)(21,null,h)):y<f?(h=Math.floor(y/n),b?h===1?(0,v.localize)(22,null,h):(0,v.localize)(23,null,h):h===1?(0,v.localize)(24,null,h):(0,v.localize)(25,null,h)):(h=Math.floor(y/f),b?h===1?(0,v.localize)(26,null,h):(0,v.localize)(27,null,h):h===1?(0,v.localize)(28,null,h):(0,v.localize)(29,null,h))}e.fromNow=w;function t(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=t}),define(Z[126],x([12,11]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(Z[68],x([0,1,32,13,126]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function M(w,t){return t&&(w.stack||w.stacktrace)?k.localize(0,null,n(w),E(w.stack)||E(w.stacktrace)):n(w)}function E(w){return Array.isArray(w)?w.join(`
`):w}function n(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?k.localize(1,null,w.message):w.message||k.localize(2,null)}function f(w=null,t=!1){if(!w)return k.localize(3,null);if(Array.isArray(w)){const I=v.coalesce(w),b=f(I[0],t);return I.length>1?k.localize(4,null,b,I.length):b}if(L.isString(w))return w;if(w.detail){const I=w.detail;if(I.error)return M(I.error,t);if(I.exception)return M(I.exception,t)}return w.stack?M(w,t):w.message?w.message:k.localize(5,null)}e.toErrorMessage=f}),define(Z[127],x([12,11]),function(K,e){return K.create("vs/base/common/keybindingLabels",e)}),define(Z[128],x([0,1,127]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class L{constructor(E,n,f=n){this.modifierLabels=[null],this.modifierLabels[2]=E,this.modifierLabels[1]=n,this.modifierLabels[3]=f}toLabel(E,n,f){if(n.length===0)return null;const w=[];for(let t=0,I=n.length;t<I;t++){const b=n[t],y=f(b);if(y===null)return null;w[t]=k(b,y,this.modifierLabels[E])}return w.join(" ")}}e.ModifierLabelProvider=L,e.UILabelProvider=new L({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:v.localize(0,null),shiftKey:v.localize(1,null),altKey:v.localize(2,null),metaKey:v.localize(3,null),separator:"+"},{ctrlKey:v.localize(4,null),shiftKey:v.localize(5,null),altKey:v.localize(6,null),metaKey:v.localize(7,null),separator:"+"}),e.AriaLabelProvider=new L({ctrlKey:v.localize(8,null),shiftKey:v.localize(9,null),altKey:v.localize(10,null),metaKey:v.localize(11,null),separator:"+"},{ctrlKey:v.localize(12,null),shiftKey:v.localize(13,null),altKey:v.localize(14,null),metaKey:v.localize(15,null),separator:"+"},{ctrlKey:v.localize(16,null),shiftKey:v.localize(17,null),altKey:v.localize(18,null),metaKey:v.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new L({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new L({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function k(M,E,n){if(E===null)return"";const f=[];return M.ctrlKey&&f.push(n.ctrlKey),M.shiftKey&&f.push(n.shiftKey),M.altKey&&f.push(n.altKey),M.metaKey&&f.push(n.metaKey),E!==""&&f.push(E),f.join(n.separator)}}),define(Z[129],x([12,11]),function(K,e){return K.create("vs/base/node/processes",e)}),define(Z[69],x([0,1,41,30,10,44,8,3,33,13,80,19,129]),function(K,e,v,L,k,M,E,n,f,w,t,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function y(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(o,u){if(n.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};u&&(i.cwd=u);const a=v.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],i);return new Promise(r=>{a.once("error",s=>{r({success:!1,error:s})}),a.once("exit",(s,l)=>{r(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?y(i.status):1})}else if(n.isLinux||n.isMacintosh)try{const i=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(a=>{v.execFile(i,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,s,l)=>{a(r?{success:!1,error:r}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function g(o=f.env){return o.comspec||"cmd.exe"}e.getWindowsShell=g;class P{constructor(u,i,a,r){if(i!==void 0&&a!==void 0&&r!==void 0)this.cmd=u,this.args=i,this.shell=a,this.options=r;else{const s=u;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(f.env).forEach(l=>{s[l]=f.env[l]}),Object.keys(this.options.env).forEach(l=>{s[l]=this.options.env[l]}),this.options.env=s}}getSanitizedCommand(){let u=this.cmd.toLowerCase();const i=u.lastIndexOf(E.sep);return i!==-1&&(u=u.substring(i+1)),P.WellKnowCommands[u]?u:"other"}start(u){return n.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(f.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(i=>{let a,r;const s=new Promise((l,m)=>{a=l,r=m});if(i){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=v.exec(l,this.options,(m,S,D)=>{this.childProcess=null;const R=m;R&&R.killed?r({killed:this.terminateRequested,stdout:S.toString(),stderr:D.toString()}):this.handleExec(a,u,m,S,D)})}else{let l=null;const m=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,a,u,r);const D={terminated:this.terminateRequested};w.isNumber(S)&&(D.cmdCode=S),a(D)};if(this.shell&&n.isWindows){const S=M.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let D=!1,R=!1;const F=[];let U=this.ensureQuotes(this.cmd);F.push(U.value),D=U.quoted,this.args&&this.args.forEach(ne=>{U=this.ensureQuotes(ne),F.push(U.value),R=R&&U.quoted});const X=["/s","/c"];D?R?X.push('"'+F.join(" ")+'"'):F.length>1?X.push('"'+F[0]+'" '+F.slice(1).join(" ")):X.push('"'+F[0]+'"'):X.push(F.join(" ")),l=v.spawn(g(),X,S)}else this.cmd&&(l=v.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(w.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",S=>{this.childProcess=null,r({terminated:this.terminateRequested,error:S})}),l.pid&&(this.childProcess.on("close",m),this.handleSpawn(l,a,u,r,!0)))}return s})}handleClose(u,i,a,r){}ensureQuotes(u){return P.regexp.test(u)?{value:'"'+u+'"',quoted:!0}:{value:u,quoted:u.length>0&&u[0]==='"'&&u[u.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(u=>u.pid,u=>-1):new Promise(u=>{this.pidResolve=u})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(u=>(this.terminateRequested=!0,h(u,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),u=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(u=>{if(!this.shell||!n.isWindows)return u(!1);const i=v.spawn(g(),["/s","/c"]);i.on("error",a=>u(!0)),i.on("exit",a=>u(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class p extends P{constructor(u,i,a,r){super(u,i,a,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(u,i,a,r,s){[r,s].forEach((l,m)=>{const S=new t.LineDecoder;S.write(l).forEach(F=>{i({line:F,source:m===0?0:1})});const R=S.end();R&&i({line:R,source:m===0?0:1})}),u({terminated:this.terminateRequested,error:a})}handleSpawn(u,i,a,r,s){const l=new t.LineDecoder,m=new t.LineDecoder;u.stdout.on("data",S=>{l.write(S).forEach(R=>a({line:R,source:0}))}),u.stderr.on("data",S=>{m.write(S).forEach(R=>a({line:R,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=m}handleClose(u,i,a,r){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&a({line:s,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&a({line:l,source:1})}}e.LineProcess=p;function c(o){let u=[],i=!1;const a=function(r){if(i){u.push(r);return}(!o.send(r,l=>{if(l&&console.error(l),i=!1,u.length>0){const m=u.slice(0);u=[],m.forEach(S=>a(S))}})||n.isWindows)&&(i=!0)};return{send:a}}e.createQueuedSender=c;var d;(function(o){async function u(i,a,r){if(E.isAbsolute(i))return i;if(a===void 0&&(a=f.cwd()),E.dirname(i)!=="."||(r===void 0&&w.isString(f.env.PATH)&&(r=f.env.PATH.split(E.delimiter)),r===void 0||r.length===0))return E.join(a,i);async function l(m){if(await I.Promises.exists(m)){let S;try{S=await I.Promises.stat(m)}catch(D){D.message.startsWith("EACCES")&&(S=await I.Promises.lstat(m))}return S?!S.isDirectory():!1}return!1}for(let m of r){let S;if(E.isAbsolute(m)?S=E.join(m,i):S=E.join(a,m,i),await l(S))return S;let D=S+".com";if(await l(D)||(D=S+".exe",await l(D)))return D}return E.join(a,i)}o.findExecutable=u})(d=e.win32||(e.win32={}))}),define(Z[130],x([0,1,26,3,116,69]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function E(y,h){return y===1?L.isWindows?I():M.getWindowsShell(h):w(y,h)}e.getSystemShell=E;function n(y,h){return y===1?L.isWindows?b(h):M.getWindowsShell(h):w(y,h)}e.getSystemShellSync=n;let f=null;function w(y,h){if(L.isLinux&&y===2||L.isMacintosh&&y===3)return"/bin/bash";if(!f){let g;if(L.isWindows)g="/bin/bash";else{if(g=h.SHELL,!g)try{g=(0,v.userInfo)().shell}catch(P){}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}f=g}return f}let t=null;async function I(){return t||(t=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),t}function b(y){if(t)return t;const h=L.isWindows&&parseFloat((0,v.release)())>=10,g=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),P=`${y.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?P:M.getWindowsShell(y)}}),define(Z[86],x([0,1,41,9,18,23,109,17,4,2,44,3,69,35]),function(K,e,v,L,k,M,E,n,f,w,t,I,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends y.ChannelServer{constructor(p){super({send:c=>{try{process.send&&process.send(c.buffer.toString("base64"))}catch(d){}},onMessage:f.Event.fromNodeEventEmitter(process,"message",c=>k.VSBuffer.wrap(Buffer.from(c,"base64")))},p);process.once("disconnect",()=>this.dispose())}}e.Server=h;class g{constructor(p,c){this.modulePath=p,this.options=c,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const d=c&&c.timeout?c.timeout:6e4;this.disposeDelayer=new L.Delayer(d),this.child=null,this._client=null}getChannel(p){const c=this;return{call(d,o,u){return c.requestPromise(p,d,o,u)},listen(d,o){return c.requestEvent(p,d,o)}}}requestPromise(p,c,d,o=M.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(n.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(p),i=(0,L.createCancelablePromise)(s=>u.call(c,d,s)),a=o.onCancellationRequested(()=>i.cancel()),r=(0,w.toDisposable)(()=>i.cancel());return this.activeRequests.add(r),i.finally(()=>{a.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(p,c,d){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let o;const u=new f.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(p).listen(c,d)(u.fire,u),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],c=Object.create(null);c.env={...(0,t.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(c.env={...c.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(c.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l))),I.isMacintosh&&c.env&&delete c.env.DYLD_LIBRARY_PATH,this.child=(0,v.fork)(this.modulePath,p,c);const d=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,E.isRemoteConsoleLog)(l)){(0,E.log)(l,`IPC Library: ${this.options.serverName}`);return}d.fire(k.VSBuffer.wrap(Buffer.from(l,"base64")))});const u=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,i=l=>this.child&&this.child.connected&&u.send(l.buffer.toString("base64")),a=d.event,r={send:i,onMessage:a};this._client=new y.ChannelClient(r);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,m)=>{process.removeListener("exit",s),this.activeRequests.forEach(S=>(0,w.dispose)(S)),this.activeRequests.clear(),l!==0&&m!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+m),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:m})})}return this._client}getCachedChannel(p){let c=this.channels.get(p);return c||(c=this.client.getChannel(p),this.channels.set(p,c)),c}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=g}),define(Z[131],x([12,11]),function(K,e){return K.create("vs/code/electron-main/app",e)}),define(Z[132],x([12,11]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[133],x([12,11]),function(K,e){return K.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[134],x([12,11]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(Z[135],x([12,11]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(Z[136],x([12,11]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[137],x([12,11]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[138],x([12,11]),function(K,e){return K.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[139],x([12,11]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(Z[140],x([12,11]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(Z[141],x([12,11]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(Z[142],x([12,11]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[143],x([12,11]),function(K,e){return K.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[144],x([12,11]),function(K,e){return K.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[145],x([12,11]),function(K,e){return K.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[146],x([12,11]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(Z[147],x([12,11]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[148],x([12,11]),function(K,e){return K.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[149],x([12,11]),function(K,e){return K.create("vs/platform/windows/electron-main/window",e)}),define(Z[150],x([12,11]),function(K,e){return K.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[151],x([12,11]),function(K,e){return K.create("vs/platform/workspaces/common/workspaces",e)}),define(Z[152],x([12,11]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[153],x([12,11]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[154],x([0,1,4,2]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(n,f,w){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:w[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:w[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:w[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:w[0],port:w[1],subId:w[2]}))}throw new Error("Method not implemented.")}listen(n,f,w){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class M extends L.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,f,w){this.channel.call("attach",[n,f,w])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,f){this.channel.call("terminate",[n,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,f,w){return this.channel.call("openExtensionDevelopmentHostWindow",[n,f||{},w])}}e.ExtensionHostDebugChannelClient=M}),define(Z[155],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class v{constructor(E){this.driver=E}listen(E,n){throw new Error(`No event found: ${n}`)}call(E,n,f){switch(n){case"click":return this.driver.click(f[0],f[1],f[2]);case"doubleClick":return this.driver.doubleClick(f);case"setValue":return this.driver.setValue(f[0],f[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(f);case"getElements":return this.driver.getElements(f[0],f[1]);case"getElementXY":return this.driver.getElementXY(f[0],f[1],f[2]);case"typeInEditor":return this.driver.typeInEditor(f[0],f[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(f);case"writeInTerminal":return this.driver.writeInTerminal(f[0],f[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${n}`)}}e.WindowDriverChannel=v;class L{constructor(E){this.channel=E}click(E,n,f){return this.channel.call("click",[E,n,f])}doubleClick(E){return this.channel.call("doubleClick",E)}setValue(E,n){return this.channel.call("setValue",[E,n])}getTitle(){return this.channel.call("getTitle")}isActiveElement(E){return this.channel.call("isActiveElement",E)}getElements(E,n){return this.channel.call("getElements",[E,n])}getElementXY(E,n,f){return this.channel.call("getElementXY",[E,n,f])}typeInEditor(E,n){return this.channel.call("typeInEditor",[E,n])}getTerminalBuffer(E){return this.channel.call("getTerminalBuffer",E)}writeInTerminal(E,n){return this.channel.call("writeInTerminal",[E,n])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=L;class k{constructor(E){this.channel=E}registerWindowDriver(E){return this.channel.call("registerWindowDriver",E)}reloadWindowDriver(E){return this.channel.call("reloadWindowDriver",E)}}e.WindowDriverRegistryChannelClient=k}),define(Z[156],x([0,1,125,47,10,8,33,15,7]),function(K,e,v,L,k,M,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class w{constructor(h,g,P){this._args=h,this.paths=g,this.productService=P}get appRoot(){return(0,M.dirname)(k.FileAccess.asFileUri("",K).fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,M.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,n.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,n.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return f.URI.file((0,M.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,n.joinPath)(f.URI.file((0,M.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return f.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return f.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,n.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,n.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=E.env.VSCODE_PORTABLE;return h?f.URI.file((0,M.join)(h,"argv.json")):(0,n.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,n.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,M.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,M.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,M.resolve)(h):(0,M.normalize)((0,M.join)(k.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,M.resolve)(h):(0,M.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,M.resolve)(h);const g=E.env.VSCODE_EXTENSIONS;if(g)return g;const P=E.env.VSCODE_PORTABLE;return P?(0,M.join)(P,"extensions"):(0,n.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(g=>/^[^:/?#]+?:\/\//.test(g)?f.URI.parse(g):f.URI.file((0,M.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?f.URI.parse(h):f.URI.file((0,M.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return t(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!E.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,n.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return f.URI.file((0,M.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([L.memoize],w.prototype,"appRoot",null),he([L.memoize],w.prototype,"userHome",null),he([L.memoize],w.prototype,"userDataPath",null),he([L.memoize],w.prototype,"appSettingsHome",null),he([L.memoize],w.prototype,"tmpDir",null),he([L.memoize],w.prototype,"userRoamingDataHome",null),he([L.memoize],w.prototype,"settingsResource",null),he([L.memoize],w.prototype,"userDataSyncHome",null),he([L.memoize],w.prototype,"userDataSyncLogResource",null),he([L.memoize],w.prototype,"sync",null),he([L.memoize],w.prototype,"machineSettingsResource",null),he([L.memoize],w.prototype,"globalStorageHome",null),he([L.memoize],w.prototype,"workspaceStorageHome",null),he([L.memoize],w.prototype,"keybindingsResource",null),he([L.memoize],w.prototype,"keyboardLayoutResource",null),he([L.memoize],w.prototype,"argvResource",null),he([L.memoize],w.prototype,"snippetsHome",null),he([L.memoize],w.prototype,"isExtensionDevelopment",null),he([L.memoize],w.prototype,"untitledWorkspacesHome",null),he([L.memoize],w.prototype,"installSourcePath",null),he([L.memoize],w.prototype,"builtinExtensionsPath",null),he([L.memoize],w.prototype,"extensionsPath",null),he([L.memoize],w.prototype,"extensionDevelopmentLocationURI",null),he([L.memoize],w.prototype,"extensionDevelopmentKind",null),he([L.memoize],w.prototype,"extensionTestsLocationURI",null),he([L.memoize],w.prototype,"debugExtensionHost",null),he([L.memoize],w.prototype,"serviceMachineIdResource",null),he([L.memoize],w.prototype,"telemetryLogResource",null),he([L.memoize],w.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=w;function t(y,h){return b(y["inspect-extensions"],y["inspect-brk-extensions"],5870,h,y.debugId)}e.parseExtensionHostPort=t;function I(y,h){return b(y["inspect-search"],y["inspect-brk-search"],5876,h)}e.parseSearchPort=I;function b(y,h,g,P,p){const d=Number(h||y)||(P?null:g),o=d?Boolean(!!h):!1;return{port:d,break:o,debugId:p}}}),define(Z[87],x([0,1,240,3,134]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const M={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,k.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(14,null)},category:{type:"string",cat:"e",description:(0,k.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,k.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,k.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,k.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,k.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,k.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const E={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(h,g,P=E){const p={},c=[],d=[];for(let a in g){const r=g[a];r.alias&&(p[a]=r.alias),r.type==="string"||r.type==="string[]"?(c.push(a),r.deprecates&&c.push(r.deprecates)):r.type==="boolean"&&(d.push(a),r.deprecates&&d.push(r.deprecates))}const o=v(h,{string:c,boolean:d,alias:p}),u={},i=o;u._=o._.map(a=>String(a)).filter(a=>a.length>0),delete i._;for(let a in g){const r=g[a];r.alias&&delete i[r.alias];let s=i[a];r.deprecates&&i.hasOwnProperty(r.deprecates)&&(s||(s=i[r.deprecates]),delete i[r.deprecates]),typeof s!="undefined"&&(r.type==="string[]"?s&&!Array.isArray(s)&&(s=[s]):r.type==="string"&&Array.isArray(s)&&(s=s.pop(),P.onMultipleValues(a,s)),u[a]=s),delete i[a]}for(let a in i)P.onUnknownOption(a);return u}e.parseArgs=n;function f(h,g){let P="";return g.args&&(Array.isArray(g.args)?P=` <${g.args.join("> <")}>`:P=` <${g.args}>`),g.alias?`-${g.alias} --${h}${P}`:`--${h}${P}`}function w(h,g){let P=0,p=[];for(const u in h){const i=h[u],a=f(u,i);P=Math.max(P,a.length),p.push([a,i.description])}let c=P+2+1;if(g-c<25)return p.reduce((u,i)=>u.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);let d=g-c-1,o=[];for(const u of p){let i=u[0],a=I(u[1],d),r=t(c-i.length-2);o.push("  "+i+r+a[0]);for(let s=1;s<a.length;s++)o.push(t(c)+a[s])}return o}e.formatOptions=w;function t(h){return" ".repeat(h)}function I(h,g){let P=[];for(;h.length;){let p=h.length<g?h.length:h.lastIndexOf(" ",g),c=h.slice(0,p).trim();h=h.slice(p),P.push(c)}return P}function b(h,g,P,p,c=!0){const d=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${h} ${P}`];o.push(""),o.push(`${(0,k.localize)(32,null)}: ${g} [${(0,k.localize)(33,null)}][${(0,k.localize)(34,null)}...]`),o.push(""),c&&(L.isWindows?o.push((0,k.localize)(35,null,g)):o.push((0,k.localize)(36,null,g)),o.push(""));const u={};for(const i in p){const a=p[i];if(a.description&&a.cat){let r=u[a.cat];r||(u[a.cat]=r={}),r[i]=a}}for(let i in u){const a=i;let r=u[a];r&&(o.push(M[a]),o.push(...w(r,d)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=b;function y(h,g){return`${h||(0,k.localize)(37,null)}
${g||(0,k.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=y}),define(Z[157],x([0,1,59,154,87]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class M extends L.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,f,w){return f==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(w[0],w[1],w[2]):super.call(n,f,w)}async openExtensionDevelopmentHostWindow(n,f,w){const t=(0,k.parseArgs)(n,k.OPTIONS);t.debugRenderer=w;const I=t.extensionDevelopmentPath;if(!I)return{success:!1};let b;const y=Object.keys(f);for(let d of y){let o=f[d];o===null||(b||(b=Object.create(null)),b[d]=o)}const[h]=this.windowsMainService.openExtensionDevelopmentHostWindow(I,{context:5,cli:t,userEnv:b});if(!w)return{success:!0};const g=h.win;if(!g)return{success:!0};const P=g.webContents.debugger;let p=P.isAttached()?Infinity:0;const c=(0,v.createServer)(d=>{p++==0&&P.attach();let o=!1;const u=r=>{o||d.write(JSON.stringify(r)+"\0")},i=(r,s,l,m)=>u({method:s,params:l,sessionId:m});g.on("close",()=>{P.removeListener("message",i),d.end(),o=!0}),P.addListener("message",i);let a=Buffer.alloc(0);d.on("data",r=>{a=Buffer.concat([a,r]);for(let s=a.indexOf(0);s!==-1;s=a.indexOf(0)){let l;try{const m=a.slice(0,s).toString("utf8");a=a.slice(s+1),l=JSON.parse(m)}catch(m){console.error("error reading cdp line",m)}P.sendCommand(l.method,l.params,l.sessionId).then(m=>u({id:l.id,sessionId:l.sessionId,result:m})).catch(m=>u({id:l.id,sessionId:l.sessionId,error:{code:0,message:m.message}}))}}),d.on("error",r=>{console.error("error on cdp pipe:",r)}),d.on("close",()=>{o=!0,--p==0&&P.detach()})});return await new Promise(d=>c.listen(0,d)),g.on("close",()=>c.close()),{rendererDebugPort:c.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=M}),function(){"use strict";function K(e,v,L,k){function M(n){const f=E(n),w=[f];return e.isAbsolute(f)||w.unshift(k),e.resolve(...w)}function E(n){const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,L);const t=n["user-data-dir"];if(t)return t;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(I,"AppData","Roaming")}break;case"darwin":w=e.join(v.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,L)}return{getUserDataPath:M}}if(typeof define=="function")define(Z[158],x([0,159,26,10,15,33]),function(e,v,L,k,M,E){const n=M.dirname(k.FileAccess.asFileUri("",e)),f=e.__$__nodeRequire(M.joinPath(n,"package.json").fsPath);return K(v,L,f.name,E.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),L=require("os");module.exports=K(v,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[160],x([0,1,26,156,158]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class M extends L.AbstractNativeEnvironmentService{constructor(n,f){super(n,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,k.getUserDataPath)(n)},f)}}e.NativeEnvironmentService=M}),define(Z[161],x([0,1,31,26,8]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function M(E){const n=(0,k.join)((0,L.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return v.writeFileSync(n,""),E&&console.log(`Marker file for --wait created: ${n}`),n}catch(f){E&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFile=M}),define(Z[162],x([0,1,137]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function M(b){return b=b.trim(),b==="*"||L.test(b)}e.isValidVersionStr=M;function E(b){if(!M(b))return null;if(b=b.trim(),b==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=b.match(L);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=E;function n(b){if(!b)return null;let y=b.majorBase,h=b.majorMustEqual,g=b.minorBase,P=b.minorMustEqual,p=b.patchBase,c=b.patchMustEqual;b.hasCaret&&(y===0||(P=!1),c=!1);let d=0;if(b.preRelease){const o=k.exec(b.preRelease);if(o){const[,u,i,a]=o;d=Date.UTC(Number(u),Number(i)-1,Number(a))}}return{majorBase:y,majorMustEqual:h,minorBase:g,minorMustEqual:P,patchBase:p,patchMustEqual:c,isMinimum:b.hasGreaterEquals,notBefore:d}}e.normalizeVersion=n;function f(b,y,h){let g;typeof b=="string"?g=n(E(b)):g=b;let P;y instanceof Date?P=y.getTime():typeof y=="string"&&(P=new Date(y).getTime());let p;if(typeof h=="string"?p=n(E(h)):p=h,!g||!p)return!1;let c=g.majorBase,d=g.minorBase,o=g.patchBase,u=p.majorBase,i=p.minorBase,a=p.patchBase,r=p.notBefore,s=p.majorMustEqual,l=p.minorMustEqual,m=p.patchMustEqual;return p.isMinimum?c>u?!0:c<u?!1:d>i?!0:d<i||P&&P<r?!1:o>=a:(c===1&&u===0&&(!s||!l||!m)&&(u=1,i=0,a=0,s=!0,l=!1,m=!1),c<u?!1:c>u?!s:d<i?!1:d>i?!l:o<a?!1:o>a?!m:!(P&&P<r))}e.isValidVersion=f;function w(b,y,h,g){return h.isBuiltin||typeof h.main=="undefined"?!0:I(b,y,h.engines.vscode,g)}e.isValidExtensionVersion=w;function t(b,y,h){return b==="*"||I(y,h,b)}e.isEngineValid=t;function I(b,y,h,g=[]){let P=n(E(h));if(!P)return g.push(v.localize(0,null,h)),!1;if(P.majorBase===0){if(!P.majorMustEqual||!P.minorMustEqual)return g.push(v.localize(1,null,h)),!1}else if(!P.majorMustEqual)return g.push(v.localize(2,null,h)),!1;return f(b,y,P)?!0:(g.push(v.localize(3,null,b,h)),!1)}}),define(Z[163],x([0,1,2,10,35,86]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends v.Disposable{constructor(f,w,t,I){super();this.folders=f,this.onDidFilesChange=w,this.onLogMessage=t,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new M.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=k.ProxyChannel.toService((0,k.getNextTickChannel)(f.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.setFolders(this.folders)}setVerboseLogging(f){this.verboseLogging=f,!this.isDisposed&&this.service&&this.service.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${f}`})}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(Z[164],x([0,1,2,10,35,86]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends v.Disposable{constructor(f,w,t,I,b={}){super();this.folders=f,this.onDidFilesChange=w,this.onLogMessage=t,this.verboseLogging=I,this.watcherOptions=b,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new M.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=k.ProxyChannel.toService((0,k.getNextTickChannel)(f.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.service.setRoots(this.folders)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${f}`})}setVerboseLogging(f){this.verboseLogging=f,this.service&&this.service.setVerboseLogging(f)}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(Z[165],x([0,1,41,111,10,80]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class E{constructor(f,w,t,I,b){this.watchedFolder=f,this.eventCallback=t,this.logCallback=I,this.verboseLogging=b,this.restartCounter=0,Array.isArray(w)?this.ignored=w.map(y=>(0,L.parse)(y)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${f}, excludes: ${w.join(",")}`),this.startWatcher()}startWatcher(){const f=[this.watchedFolder];this.verboseLogging&&f.push("-verbose"),this.handle=(0,v.spawn)(k.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,f);const w=new M.LineDecoder;this.handle.stdout.on("data",t=>{const I=[];for(const b of w.write(t)){const y=b.split("|");if(y.length===2){const h=Number(y[0]),g=y[1];if(h>=0&&h<3){if(this.ignored&&this.ignored.some(P=>P(g))){this.verboseLogging&&this.log(g);continue}I.push({type:E.changeTypeMap[h],path:g})}else this.log(y[1])}}I.length>0&&this.eventCallback(I)}),this.handle.on("error",t=>this.onError(t)),this.handle.stderr.on("data",t=>this.onError(t)),this.handle.on("exit",(t,I)=>this.onExit(t,I))}onError(f){this.error("process error: "+f.toString())}onExit(f,w){this.handle&&(this.error(`terminated unexpectedly (code: ${f}, signal: ${w})`),this.restartCounter<=E.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(f){this.logCallback({type:"error",message:`[File Watcher (C#)] ${f}`})}log(f){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${f}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=E,E.MAX_RESTARTS=5,E.changeTypeMap=[0,1,2]}),define(Z[166],x([0,1,8,25,165]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class M{constructor(n,f,w,t){this.onDidFilesChange=f,this.onLogMessage=w,this.verboseLogging=t,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(v.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,v.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new k.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=M}),define(Z[70],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(k,M=[],E=!1){this.ctor=k,this.staticArguments=M,this.supportsDelayedInstantiation=E}}e.SyncDescriptor=v}),define(Z[167],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(M){this.incoming=new Map,this.outgoing=new Map,this.data=M}}e.Node=v;class L{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(let E of this._nodes.values())E.outgoing.size===0&&M.push(E);return M}insertEdge(M,E){const n=this.lookupOrInsertNode(M),f=this.lookupOrInsertNode(E);n.outgoing.set(this._hashFn(E),f),f.incoming.set(this._hashFn(M),n)}removeNode(M){const E=this._hashFn(M);this._nodes.delete(E);for(let n of this._nodes.values())n.outgoing.delete(E),n.incoming.delete(E)}lookupOrInsertNode(M){const E=this._hashFn(M);let n=this._nodes.get(E);return n||(n=new v(M),this._nodes.set(E,n)),n}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){let M=[];for(let[E,n]of this._nodes)M.push(`${E}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return M.join(`
`)}findCycleSlow(){for(let[M,E]of this._nodes){const n=new Set([M]),f=this._findCycle(E,n);if(f)return f}}_findCycle(M,E){for(let[n,f]of M.outgoing){if(E.has(n))return[...E,n].join(" -> ");E.add(n);const w=this._findCycle(f,E);if(w)return w;E.delete(n)}}}e.Graph=L}),define(Z[5],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function f(w){return w[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=f})(v=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function L(n,f,w,t){f[v.DI_TARGET]===f?f[v.DI_DEPENDENCIES].push({id:n,index:w,optional:t}):(f[v.DI_DEPENDENCIES]=[{id:n,index:w,optional:t}],f[v.DI_TARGET]=f)}function k(n){if(v.serviceIds.has(n))return v.serviceIds.get(n);const f=function(w,t,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(f,w,I,!1)};return f.toString=()=>n,v.serviceIds.set(n,f),f}e.createDecorator=k;function M(n){return n}e.refineServiceDecorator=M;function E(n){return function(f,w,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(n,f,t,!0)}}e.optional=E}),define(Z[71],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function L(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=L}),define(Z[88],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService");class L{constructor(M){this.machineId=M}encryption(){return new Promise((M,E)=>K(["vscode-encrypt"],M,E))}async encrypt(M){try{return(await this.encryption()).encrypt(this.machineId,M)}catch(E){return M}}async decrypt(M){try{return(await this.encryption()).decrypt(this.machineId,M)}catch(E){return M}}}e.EncryptionMainService=L}),define(Z[48],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[168],x([0,1,10,136,5]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var M;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(M=e.TargetPlatform||(e.TargetPlatform={}));function E(p){switch(p){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=E;function n(p){switch(p){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=n;function f(p,c){switch(p){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=f;function w(p,c){return c==="web"&&!p.includes("web")}e.isNotWebExtensionInWebTargetPlatform=w;function t(p,c,d){if(w(c,d))return!1;if(p==="undefined"||p==="universal")return!0;if(p==="unknown")return!1;if(p===d)return!0;switch(d){case"win32-x64":return p==="win32-ia32";case"win32-arm64":return p==="win32-ia32";default:return!1}}e.isTargetPlatformCompatible=t;function I(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=I;var b;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=5]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var y;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var h;(function(p){p.Install="install",p.Uninstall="uninstall"})(h=e.StatisticType||(e.StatisticType={}));var g;(function(p){p[p.None=0]="None",p[p.Install=1]="Install",p[p.Update=2]="Update"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class P extends Error{constructor(c,d){super(c);this.code=d,this.name=d}}e.ExtensionManagementError=P,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=v.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(Z[169],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(Z[170],x([0,1,25,5]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=k;function M(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));class n{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,b){if(typeof I=="undefined"||I===null)return typeof b=="undefined"||b===null;if(typeof b=="undefined"||b===null)return!1;if(typeof I=="string"||typeof b=="string"){let y=typeof I=="string"?I:I.value,h=typeof b=="string"?b:b.value;return v.equalsIgnoreCase(y,h)}return I._lower===b._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=n;function f(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=f;function w(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=w,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[171],x([0,1,25,170]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(h,g){return h.uuid&&g.uuid?h.uuid===g.uuid:h.id===g.id?!0:(0,v.compareIgnoreCase)(h.id,g.id)===0}e.areSameExtensions=k;class M{constructor(g,P){this.version=P,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof M?k(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=M;function E(h,g){return`${h}.${g}`}e.getExtensionId=E;function n(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function f(h,g){return n(E(h,g))}e.getGalleryExtensionId=f;function w(h,g){const P=[],p=c=>{for(const d of P)if(d.some(o=>k(g(o),g(c))))return d;return null};for(const c of h){const d=p(c);d?d.push(c):P.push([c])}return P}e.groupByExtension=w;function t(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function I(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function b(h){const g=new Set;for(const P of h)P.malicious&&g.add(P.id.id);return g}e.getMaliciousExtensionsSet=b;function y(h,g){const P=[],p=g.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const c=p.shift();if(c&&P.every(d=>!k(d.identifier,{id:c}))){const d=h.filter(o=>k(o.identifier,{id:c}));d.length===1&&(P.push(d[0]),p.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return P}e.getExtensionDependencies=y}),define(Z[89],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(Z[172],x([0,1,41,10,8,3,105,19,69,138,89]),function(K,e,v,L,k,M,E,n,f,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=w.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends b{openTerminal(o,u){return this.spawnTerminal(v,o,f.getWindowsShell(),u)}spawnTerminal(o,u,i,a){const r=u.windowsExec||y.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const s=k.basename(r).toLowerCase();if(s==="cmder"||s==="cmder.exe")return o.spawn(r,a?[a]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return r.indexOf(" ")>=0&&l.push('""'),l.push(r),(s==="wt"||s==="wt.exe")&&l.push("-d ."),new Promise((m,S)=>{const D=P(process),R=o.spawn(i,l,{cwd:a,env:D});R.on("error",S),R.on("exit",()=>m())})}runInTerminal(o,u,i,a,r){const s="windowsExec"in r&&r.windowsExec?r.windowsExec:y.getDefaultTerminalWindows();return new Promise((l,m)=>{const S=`"${u} - ${I}"`,D=`""${i.join('" "')}" & pause"`,R=["/c","start",S,"/wait",s,"/c",D],F=Object.assign({},P(process),a);Object.keys(F).filter(ne=>F[ne]===null).forEach(ne=>delete F[ne]);const U={cwd:u,env:F,windowsVerbatimArguments:!0};v.spawn(y.CMD,R,U).on("error",ne=>{m(p(ne))}),l(void 0)})}static getDefaultTerminalWindows(){if(!y._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return y._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=y,y.CMD="cmd.exe";class h extends b{openTerminal(o,u){return this.spawnTerminal(v,o,u)}runInTerminal(o,u,i,a,r){const s=r.osxExec||t.DEFAULT_TERMINAL_OSX;return new Promise((l,m)=>{if(s===t.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const S=s===t.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`,K).fsPath,"-t",o||I,"-w",u];for(let X of i)R.push("-a"),R.push(X);if(a){const X=Object.assign({},P(process),a);for(let ne in X){const se=X[ne];se===null?(R.push("-u"),R.push(ne)):(R.push("-e"),R.push(`${ne}=${se}`))}}let F="";const U=v.spawn(h.OSASCRIPT,R);U.on("error",X=>{m(p(X))}),U.stderr.on("data",X=>{F+=X.toString()}),U.on("exit",X=>{if(X===0)l(void 0);else if(F){const ne=F.split(`
`,1);m(new Error(ne[0]))}else m(new Error(w.localize(1,null,S,X)))})}else m(new Error(w.localize(2,null,s)))})}spawnTerminal(o,u,i){const a=u.osxExec||t.DEFAULT_TERMINAL_OSX;return new Promise((r,s)=>{const l=["-a",a];i&&l.push(i);const m=P(process),S=o.spawn("/usr/bin/open",l,{cwd:i,env:m});S.on("error",s),S.on("exit",()=>r())})}}e.MacExternalTerminalService=h,h.OSASCRIPT="/usr/bin/osascript";class g extends b{openTerminal(o,u){return this.spawnTerminal(v,o,u)}runInTerminal(o,u,i,a,r){const s=r.linuxExec?Promise.resolve(r.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((l,m)=>{let S=[];s.then(D=>{D.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const R=`${c(i)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;S.push(`''${R}''`);const F=Object.assign({},P(process),a);Object.keys(F).filter(se=>F[se]===null).forEach(se=>delete F[se]);const U={cwd:u,env:F};let X="";const ne=v.spawn(D,S,U);ne.on("error",se=>{m(p(se))}),ne.stderr.on("data",se=>{X+=se.toString()}),ne.on("exit",se=>{if(se===0)l(void 0);else if(X){const G=X.split(`
`,1);m(new Error(G[0]))}else m(new Error(w.localize(4,null,D,se)))})})})}static async getDefaultTerminalLinuxReady(){return g._DEFAULT_TERMINAL_LINUX_READY||(g._DEFAULT_TERMINAL_LINUX_READY=new Promise(async o=>{M.isLinux?await n.Promises.exists("/etc/debian_version")?o("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?o("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?o("konsole"):process.env.COLORTERM?o(process.env.COLORTERM):process.env.TERM?o(process.env.TERM):o("xterm"):o("xterm")})),g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,u,i){const a=u.linuxExec?Promise.resolve(u.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((r,s)=>{a.then(l=>{const m=P(process),S=o.spawn(l,[],{cwd:i,env:m});S.on("error",s),S.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=w.localize(3,null);function P(d){const o={...d.env};return(0,E.sanitizeProcessEnvironment)(o),o}function p(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(w.localize(5,null,d.path)):d}function c(d){let o="";for(let u of d)u.indexOf(" ")>=0?o+='"'+u+'"':o+=u,o+=" ";return o}}),define(Z[20],x([0,1,37,8,25,13,7,140,5]),function(K,e,v,L,k,M,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function w(W){return W.create===!0}e.isFileOpenForWriteOptions=w;var t;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var I;(function(W){W[W.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var b;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock"})(b=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=y;function h(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=h;function g(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function P(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=P;var p;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(V,B){super(V);this.code=B}}e.FileSystemProviderError=c;function d(W,V){const B=new c(W.toString(),V);return u(B,V),B}e.createFileSystemProviderError=d;function o(W){return W||d((0,n.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=o;function u(W,V){return W.name=V?`${V} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=u;function i(W){if(!W)return p.Unknown;if(W instanceof c)return W.code;const V=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!V)return p.Unknown;switch(V[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=i;function a(W){if(W instanceof D)return W.fileOperationResult;switch(i(W)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var r;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class s{constructor(V,B,$){this.resource=V,this.operation=B,this.target=$}isOperation(V){return this.operation===V}}e.FileOperationEvent=s;var l;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class m{constructor(V,B){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const $ of V)switch($.type){case 1:this.added||(this.added=v.TernarySearchTree.forUris(()=>B)),this.added.set($.resource,$);break;case 0:this.updated||(this.updated=v.TernarySearchTree.forUris(()=>B)),this.updated.set($.resource,$);break;case 2:this.deleted||(this.deleted=v.TernarySearchTree.forUris(()=>B)),this.deleted.set($.resource,$);break}}contains(V,...B){return this.doContains(V,{includeChildren:!1},...B)}affects(V,...B){return this.doContains(V,{includeChildren:!0},...B)}doContains(V,B,...$){if(!V)return!1;const H=$.length>0;return!!((!H||$.includes(1))&&(this.added?.get(V)||B.includeChildren&&this.added?.findSuperstr(V))||(!H||$.includes(0))&&(this.updated?.get(V)||B.includeChildren&&this.updated?.findSuperstr(V))||(!H||$.includes(2))&&(this.deleted?.findSubstr(V)||B.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=m;function S(W,V,B){return!W||!V||W===V||V.length>W.length?!1:(V.charAt(V.length-1)!==L.sep&&(V+=L.sep),B?(0,k.startsWithIgnoreCase)(W,V):W.indexOf(V)===0)}e.isParent=S;class D extends Error{constructor(V,B,$){super(V);this.fileOperationResult=B,this.options=$}}e.FileOperationError=D;class R extends D{constructor(V,B,$){super(V,2,$);this.stat=B}}e.NotModifiedSinceFileOperationError=R;var F;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(F=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function X(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=X;async function ne(W,V){if(!V.canHandleResource(E.URI.from({scheme:W.scheme})))return new Promise(B=>{const $=V.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===W.scheme&&H.added&&($.dispose(),B())})})}e.whenProviderRegistered=ne,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class se{static formatSize(V){return(0,M.isNumber)(V)||(V=0),V<se.KB?(0,n.localize)(1,null,V.toFixed(0)):V<se.MB?(0,n.localize)(2,null,(V/se.KB).toFixed(2)):V<se.GB?(0,n.localize)(3,null,(V/se.MB).toFixed(2)):V<se.TB?(0,n.localize)(4,null,(V/se.GB).toFixed(2)):(0,n.localize)(5,null,(V/se.TB).toFixed(2))}}e.ByteSize=se,se.KB=1024,se.MB=se.KB*se.KB,se.GB=se.MB*se.KB,se.TB=se.GB*se.KB;var G;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(G=e.Arch||(e.Arch={}));function J(W){return{maxFileSize:W===0?300*se.MB:16*se.GB,maxHeapSize:W===0?700*se.MB:2*700*se.MB}}e.getPlatformLimits=J}),define(Z[54],x([0,1,241,135,87,20]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function E(b,y){const h={onUnknownOption:P=>{console.warn((0,L.localize)(0,null,P))},onMultipleValues:(P,p)=>{console.warn((0,L.localize)(1,null,P,p))}},g=(0,k.parseArgs)(b,k.OPTIONS,y?h:void 0);return g.goto&&g._.forEach(P=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(P),(0,L.localize)(2,null))),g["max-memory"]&&v(parseInt(g["max-memory"])>=M.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${M.MIN_MAX_MEMORY_SIZE_MB} MB.`),g}function n(b){const y=b.findIndex(h=>!/^-/.test(h));if(y>-1)return[...b.slice(0,y),...b.slice(y+1)]}function f(b){let[,...y]=b;process.env.VSCODE_DEV&&(y=n(y)||[]);const h=!I(process.env);return E(y,h)}e.parseMainProcessArgv=f;function w(b){const[,,...y]=b;return E(y,!0)}e.parseCLIProcessArgv=w;function t(b,...y){const h=b.indexOf("--");return h===-1?b.push(...y):b.splice(h,0,...y),b}e.addArg=t;function I(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),define(Z[90],x([0,1,41,159,23,68,17,3,28,130,54]),function(K,e,v,L,k,M,E,n,f,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function I(h,g,P){return g["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):n.isWindows?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,t.isLaunchedFromCli)(P)&&!g["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,t.isLaunchedFromCli)(P)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),b||(b=new Promise(async p=>{const c=new k.CancellationTokenSource,d=setTimeout(()=>{h.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),c.dispose(!0),p({})},1e4);try{const o=await y(h,c.token);p(o)}catch(o){(0,E.isPromiseCanceledError)(o)||h.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),p({})}finally{clearTimeout(d),c.dispose()}})),b)}e.resolveShellEnv=I;let b;async function y(h,g){const P=new Promise(async(p,c)=>{const d=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",d);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",o);const u=(0,f.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(u+"(.*)"+u),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};h.trace("getUnixShellEnvironment#env",a);const r=await(0,w.getSystemShell)(n.OS,a);if(h.trace("getUnixShellEnvironment#shell",r),g.isCancellationRequested)return c(E.canceled);const s=L.basename(r);let l,m;/^pwsh(-preview)?$/.test(s)?(l=`& '${process.execPath}' -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,m=["-Login","-Command"]):(l=`'${process.execPath}' -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,m=["-ilc"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(m),l);const S=(0,v.spawn)(r,[...m,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});g.onCancellationRequested(()=>(S.kill(),c(E.canceled))),S.on("error",F=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(F)),p({})});const D=[];S.stdout.on("data",F=>D.push(F));const R=[];S.stderr.on("data",F=>R.push(F)),S.on("close",(F,U)=>{const X=Buffer.concat(D).toString("utf8");h.trace("getUnixShellEnvironment#raw",X);const ne=Buffer.concat(R).toString("utf8");if(ne.trim()&&h.trace("getUnixShellEnvironment#stderr",ne),F||U)return c(new Error(`Failed to get environment (code ${F}, signal ${U})`));const se=i.exec(X),G=se?se[1]:"{}";try{const J=JSON.parse(G);d?J.ELECTRON_RUN_AS_NODE=d:delete J.ELECTRON_RUN_AS_NODE,o?J.ELECTRON_NO_ATTACH_CONSOLE=o:delete J.ELECTRON_NO_ATTACH_CONSOLE,delete J.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",J),p(J)}catch(J){h.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(J)),c(J)}})});try{return await P}catch(p){return h.error("getUnixShellEnvironment#error",(0,M.toErrorMessage)(p)),{}}}}),define(Z[91],x([0,1,3,7,20]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function M(f){return f.map(w=>({type:w.type,resource:L.URI.file(w.path)}))}e.toFileChanges=M;function E(f){const w=new n;for(const t of f)w.processEvent(t);return w.normalize()}e.normalizeFileChanges=E;class n{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(w){const t=this.mapPathToChange.get(w.path);if(t){const I=t.type,b=w.type;I===1&&b===2?(this.mapPathToChange.delete(w.path),this.normalized.splice(this.normalized.indexOf(t),1)):I===2&&b===1?t.type=0:I===1&&b===0||(t.type=b)}else this.normalized.push(w),this.mapPathToChange.set(w.path,w)}normalize(){const w=[],t=[];return this.normalized.filter(I=>I.type!==2?(w.push(I),!1):!0).sort((I,b)=>I.path.length-b.path.length).filter(I=>t.some(b=>(0,k.isParent)(I.path,b,!v.isLinux))?!1:(t.push(I.path),!0)).concat(w)}}}),define(Z[173],x([0,1,9,2,8,81,19,117,91]),function(K,e,v,L,k,M,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class w extends L.Disposable{constructor(I,b,y,h){super();this.path=I,this.onDidFilesChange=b,this.onLogMessage=y,this.verboseLogging=h,this.fileChangesDelayer=this._register(new v.ThrottledDelayer(n.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:b}=await E.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let y=this.path;if(b)try{y=await(0,M.realpath)(y)}catch(h){if(this.onError(h),b.dangling)return}I.isDirectory()?this._register((0,n.watchFolder)(y,(h,g)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,k.join)(this.path,(0,k.basename)(g))})},h=>this.onError(h))):this._register((0,n.watchFile)(y,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const b=this.fileChangesBuffer;this.fileChangesBuffer=[];const y=(0,f.normalizeFileChanges)(b);if(this.verboseLogging)for(const h of y)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);y.length>0&&this.onDidFilesChange(y)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=w}),define(Z[72],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...k){this._entries=new Map;for(let[M,E]of k)this.set(M,E)}set(k,M){const E=this._entries.get(k);return this._entries.set(k,M),E}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=v}),define(Z[174],x([0,1,9,17,70,167,5,72]),function(K,e,v,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const f=!1;class w extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class t{constructor(h=new n.ServiceCollection,g=!1,P){this._activeInstantiations=new Set,this._services=h,this._strict=g,this._parent=P,this._services.set(E.IInstantiationService,this)}createChild(h){return new t(h,this._strict,this)}invokeFunction(h,...g){let P=b.traceInvocation(h),p=!1;try{return h({get:(d,o)=>{if(p)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(d,P);if(!u&&o!==E.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return u}},...g)}finally{p=!0,P.stop()}}createInstance(h,...g){let P,p;return h instanceof k.SyncDescriptor?(P=b.traceCreation(h.ctor),p=this._createInstance(h.ctor,h.staticArguments.concat(g),P)):(P=b.traceCreation(h),p=this._createInstance(h,g,P)),P.stop(),p}_createInstance(h,g=[],P){let p=E._util.getServiceDependencies(h).sort((o,u)=>o.index-u.index),c=[];for(const o of p){let u=this._getOrCreateServiceInstance(o.id,P);if(!u&&this._strict&&!o.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${o.id}.`);c.push(u)}let d=p.length>0?p[0].index:g.length;if(g.length!==d){console.warn(`[createInstance] First service dependency of ${h.name} at position ${d+1} conflicts with ${g.length} static arguments`);let o=d-g.length;o>0?g=g.concat(new Array(o)):g=g.slice(0,d)}return new h(...[...g,...c])}_setServiceInstance(h,g){if(this._services.get(h)instanceof k.SyncDescriptor)this._services.set(h,g);else if(this._parent)this._parent._setServiceInstance(h,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let g=this._services.get(h);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):g}_getOrCreateServiceInstance(h,g){let P=this._getServiceInstanceOrDescriptor(h);return P instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,P,g.branch(h,!0)):(g.branch(h,!1),P)}_safeCreateAndCacheServiceInstance(h,g,P){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,g,P)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,g,P){const p=new M.Graph(o=>o.id.toString());let c=0;const d=[{id:h,desc:g,_trace:P}];for(;d.length;){const o=d.pop();if(p.lookupOrInsertNode(o),c++>1e3)throw new w(p);for(let u of E._util.getServiceDependencies(o.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(u.id);if(!i&&!u.optional&&console.warn(`[createInstance] ${h} depends on ${u.id} which is NOT registered.`),i instanceof k.SyncDescriptor){const a={id:u.id,desc:i,_trace:o._trace.branch(u.id,!0)};p.insertEdge(o,a),d.push(a)}}}for(;;){const o=p.roots();if(o.length===0){if(!p.isEmpty())throw new w(p);break}for(const{data:u}of o){if(this._getServiceInstanceOrDescriptor(u.id)instanceof k.SyncDescriptor){const a=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,a)}p.removeNode(u)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,g,P=[],p,c){if(this._services.get(h)instanceof k.SyncDescriptor)return this._createServiceInstance(g,P,p,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,g,P,p,c);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(h,g=[],P,p){if(P){const c=new v.IdleValue(()=>this._createInstance(h,g,p));return new Proxy(Object.create(null),{get(d,o){if(o in d)return d[o];let u=c.value,i=u[o];return typeof i!="function"||(i=i.bind(u),d[o]=i),i},set(d,o,u){return c.value[o]=u,!0}})}else return this._createInstance(h,g,p)}}e.InstantiationService=t;var I;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(I||(I={}));class b{constructor(h,g){this.type=h,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return f?new b(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):b._None}static traceCreation(h){return f?new b(0,h.name):b._None}branch(h,g){let P=new b(2,h.toString());return this._dep.push([h,g,P]),P}stop(){let h=Date.now()-this._start;b._totals+=h;let g=!1;function P(c,d){let o=[],u=new Array(c+1).join("	");for(const[i,a,r]of d._dep)if(a&&r){g=!0,o.push(`${u}CREATES -> ${i}`);let s=P(c+1,r);s&&o.push(s)}else o.push(`${u}uses -> ${i}`);return o.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${P(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(h>2||g)&&console.log(p.join(`
`))}}b._None=new class extends b{constructor(){super(-1,null)}stop(){}branch(){return this}},b._totals=0}),define(Z[175],x([0,1,17,128,57]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class M extends k.ResolvedKeybinding{constructor(n,f){super();if(f.length===0)throw(0,v.illegalArgument)("parts");this._os=n,this._parts=f}getLabel(){return L.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return L.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:L.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return L.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new k.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=M}),define(Z[176],x([0,1,57,175]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class k extends L.BaseResolvedKeybinding{constructor(E,n){super(n,E.parts)}_keyCodeToUILabel(E){if(this._os===2)switch(E){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return v.KeyCodeUtils.toString(E)}_getLabel(E){return E.isDuplicateModifierCase()?"":this._keyCodeToUILabel(E.keyCode)}_getAriaLabel(E){return E.isDuplicateModifierCase()?"":v.KeyCodeUtils.toString(E.keyCode)}_keyCodeToElectronAccelerator(E){if(E>=93&&E<=108)return null;switch(E){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return v.KeyCodeUtils.toString(E)}_getElectronAccelerator(E){return E.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(E.keyCode)}_getUserSettingsLabel(E){if(E.isDuplicateModifierCase())return"";const n=v.KeyCodeUtils.toUserSettingsUS(E.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(E){return k.getDispatchStr(E)}static getDispatchStr(E){if(E.isModifierKey())return null;let n="";return E.ctrlKey&&(n+="ctrl+"),E.shiftKey&&(n+="shift+"),E.altKey&&(n+="alt+"),E.metaKey&&(n+="meta+"),n+=v.KeyCodeUtils.toString(E.keyCode),n}_getSingleModifierDispatchPart(E){return E.keyCode===5&&!E.shiftKey&&!E.altKey&&!E.metaKey?"ctrl":E.keyCode===4&&!E.ctrlKey&&!E.altKey&&!E.metaKey?"shift":E.keyCode===6&&!E.ctrlKey&&!E.shiftKey&&!E.metaKey?"alt":E.keyCode===57&&!E.ctrlKey&&!E.shiftKey&&!E.altKey?"meta":null}}e.USLayoutResolvedKeybinding=k}),define(Z[177],x([0,1,9]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function L(k,M){if(k.length===0)return Promise.resolve(!1);const E=[];let n=!1;for(let f of k){if(f===!0)return Promise.resolve(!0);(0,v.isThenable)(f)&&E.push(f.then(w=>{w&&(n=!0)},w=>{M(w),n=!0}))}return v.Promises.settled(E).then(()=>n)}e.handleVetos=L}),define(Z[6],x([0,1,68,4,2,3,5]),function(K,e,v,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function n(){return new Date().toISOString()}var f;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;class w extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class t extends w{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...a){this.checkLogLevel(f.Trace)&&this.log(f.Trace,this.format([i,...a]))}debug(i,...a){this.checkLogLevel(f.Debug)&&this.log(f.Debug,this.format([i,...a]))}info(i,...a){this.checkLogLevel(f.Info)&&this.log(f.Info,this.format([i,...a]))}warn(i,...a){this.checkLogLevel(f.Warning)&&this.log(f.Warning,this.format([i,...a]))}error(i,...a){if(this.checkLogLevel(f.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(f.Error,this.format(r))}else this.log(f.Error,this.format([i,...a]))}critical(i,...a){this.checkLogLevel(f.Critical)&&this.log(f.Critical,this.format([i,...a]))}flush(){}format(i){let a="";for(let r=0;r<i.length;r++){let s=i[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch(l){}a+=(r>0?" ":"")+s}return a}}e.AbstractMessageLogger=t;class I extends w{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!M.isWindows}trace(i,...a){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...a):console.log(`[main ${n()}]`,i,...a))}debug(i,...a){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...a):console.log(`[main ${n()}]`,i,...a))}info(i,...a){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...a):console.log(`[main ${n()}]`,i,...a))}warn(i,...a){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,i,...a):console.warn(`[main ${n()}]`,i,...a))}error(i,...a){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,i,...a):console.error(`[main ${n()}]`,i,...a))}critical(i,...a){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,i,...a):console.error(`[main ${n()}]`,i,...a))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class b extends w{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...a){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",i,...a)}debug(i,...a){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...a)}info(i,...a){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",i,...a)}warn(i,...a){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",i,...a)}error(i,...a){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",i,...a)}critical(i,...a){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...a)}dispose(){}flush(){}}e.ConsoleLogger=b;class y extends w{constructor(i,a=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(a)}trace(i,...a){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(i),...a])}debug(i,...a){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(i),...a])}info(i,...a){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(i),...a])}warn(i,...a){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(i),...a])}error(i,...a){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(i),...a])}critical(i,...a){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(i),...a])}extractMessage(i){return typeof i=="string"?i:(0,v.toErrorMessage)(i,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.AdapterLogger=y;class h extends w{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const a of this.logServices)a.setLevel(i);super.setLevel(i)}trace(i,...a){for(const r of this.logServices)r.trace(i,...a)}debug(i,...a){for(const r of this.logServices)r.debug(i,...a)}info(i,...a){for(const r of this.logServices)r.info(i,...a)}warn(i,...a){for(const r of this.logServices)r.warn(i,...a)}error(i,...a){for(const r of this.logServices)r.error(i,...a)}critical(i,...a){for(const r of this.logServices)r.critical(i,...a)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=h;class g extends k.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...a){this.logger.trace(i,...a)}debug(i,...a){this.logger.debug(i,...a)}info(i,...a){this.logger.info(i,...a)}warn(i,...a){this.logger.warn(i,...a)}error(i,...a){this.logger.error(i,...a)}critical(i,...a){this.logger.critical(i,...a)}flush(){this.logger.flush()}}e.LogService=g;class P extends k.Disposable{constructor(i,a){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(a(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,a){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,a?.always?f.Trace:this.logLevel,a),this.loggers.set(i.toString(),r),a?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class p{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(i){}getLevel(){return f.Info}trace(i,...a){}debug(i,...a){}info(i,...a){}warn(i,...a){}error(i,...a){}critical(i,...a){}dispose(){}flush(){}}e.NullLogService=p;function c(u){if(u.verbose)return f.Trace;if(typeof u.logLevel=="string"){const i=d(u.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function d(u){switch(u){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=d;function o(u){switch(u){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=o});var te=this&&this.__param||function(K,e){return function(v,L){e(v,L,K)}};define(Z[178],x([0,1,9,18,40,77,48,20,5,6]),function(K,e,v,L,k,M,E,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var t;(function(b){b.ERROR_INVALID_FILE="ERROR_INVALID_FILE",b.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(t=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,f.createDecorator)(e.UserConfigurationFileServiceId);let I=class{constructor(y,h,g){this.environmentService=y,this.fileService=h,this.logService=g,this.queue=new v.Queue}async updateSettings(y,h){return this.queue.queue(()=>this.doWrite(this.environmentService.settingsResource,y,h))}async doWrite(y,h,g){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,y.toString(),h);const{value:P,mtime:p,etag:c}=await this.fileService.readFile(y,{atomic:!0});let d=P.toString();const o=[];if((0,k.parse)(d,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length)throw new Error("ERROR_INVALID_FILE");const u=this.getEdits(h,d,g)[0];if(u){d=d.substring(0,u.offset)+u.content+d.substring(u.offset+u.length);try{await this.fileService.writeFile(y,L.VSBuffer.fromString(d),{etag:c,mtime:p})}catch(i){if(i.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}getEdits({value:y,path:h},g,P){return h.length?(0,M.setProperty)(g,h,y,P):[{content:JSON.stringify(y,null,P.insertSpaces&&P.tabSize?" ".repeat(P.tabSize):"	"),length:g.length,offset:0}]}};I=he([te(0,E.IEnvironmentService),te(1,n.IFileService),te(2,w.ILogService)],I),e.UserConfigurationFileService=I}),define(Z[92],x([0,1,6]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function L(M,E){switch(E){case v.LogLevel.Trace:return M.trace;case v.LogLevel.Debug:return M.debug;case v.LogLevel.Info:return M.info;case v.LogLevel.Warning:return M.warn;case v.LogLevel.Error:return M.error;case v.LogLevel.Critical:return M.critical;default:throw new Error("Invalid log level")}}class k extends v.AbstractLogger{constructor(E=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(E),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(E){this._logger=E;for(const{level:n,args:f}of this.buffer)L(E,n).apply(E,f);this.buffer=[]}_log(E,...n){this._logger?L(this._logger,E).apply(this._logger,n):this.getLevel()<=E&&this.buffer.push({level:E,args:n})}trace(E,...n){this._log(v.LogLevel.Trace,E,...n)}debug(E,...n){this._log(v.LogLevel.Debug,E,...n)}info(E,...n){this._log(v.LogLevel.Info,E,...n)}warn(E,...n){this._log(v.LogLevel.Warning,E,...n)}error(E,...n){this._log(v.LogLevel.Error,E,...n)}critical(E,...n){this._log(v.LogLevel.Critical,E,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=k}),define(Z[179],x([0,1,9,18,15,20,5,92,6]),function(K,e,v,L,k,M,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const w=5*M.ByteSize.MB;let t=class extends f.AbstractLogger{constructor(y,h,g,P,p){super();this.name=y,this.resource=h,this.donotUseFormatters=P,this.fileService=p,this.backupIndex=1,this.setLevel(g),this.queue=this._register(new v.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=f.LogLevel.Trace&&this._log(f.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=f.LogLevel.Debug&&this._log(f.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=f.LogLevel.Info&&this._log(f.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=f.LogLevel.Warning&&this._log(f.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=f.LogLevel.Error){const y=arguments[0];if(y instanceof Error){const h=Array.prototype.slice.call(arguments);h[0]=y.stack,this._log(f.LogLevel.Error,this.format(h))}else this._log(f.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=f.LogLevel.Critical&&this._log(f.LogLevel.Critical,this.format(arguments))}flush(){}log(y,h){this._log(y,this.format(h))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(y){if(y.fileOperationResult!==3)throw y}}_log(y,h){this.queue.queue(async()=>{await this.initializePromise;let g=await this.loadContent();g.length>w&&(await this.fileService.writeFile(this.getBackupResource(),L.VSBuffer.fromString(g)),g=""),this.donotUseFormatters?g+=h:g+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(y)}] ${h}
`,await this.fileService.writeFile(this.resource,L.VSBuffer.fromString(g))})}getCurrentTimestamp(){const y=P=>P<10?`0${P}`:P,h=P=>P<10?`00${P}`:P<100?`0${P}`:P,g=new Date;return`${g.getFullYear()}-${y(g.getMonth()+1)}-${y(g.getDate())} ${y(g.getHours())}:${y(g.getMinutes())}:${y(g.getSeconds())}.${h(g.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(y){return""}}stringifyLogLevel(y){switch(y){case f.LogLevel.Critical:return"critical";case f.LogLevel.Debug:return"debug";case f.LogLevel.Error:return"error";case f.LogLevel.Info:return"info";case f.LogLevel.Trace:return"trace";case f.LogLevel.Warning:return"warning"}return""}format(y){let h="";for(let g=0;g<y.length;g++){let P=y[g];if(typeof P=="object")try{P=JSON.stringify(P)}catch(p){}h+=(g>0?" ":"")+P}return h}};t=he([te(4,M.IFileService)],t),e.FileLogger=t;let I=class extends f.AbstractLoggerService{constructor(y,h,g){super(y.getLevel(),y.onDidChangeLogLevel);this.instantiationService=h,this.fileService=g}doCreateLogger(y,h,g){const P=new n.BufferLogService(h);return(0,M.whenProviderRegistered)(y,this.fileService).then(()=>P.logger=this.instantiationService.createInstance(t,(0,k.basename)(y),y,P.getLevel(),!!g?.donotUseFormatters)),P}};I=he([te(0,f.ILogService),te(1,E.IInstantiationService),te(2,M.IFileService)],I),e.FileLoggerService=I}),define(Z[180],x([0,1,4,7,6]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class M{constructor(b){this.service=b,this.onDidChangeLogLevel=v.Event.buffer(b.onDidChangeLogLevel,!0)}listen(b,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(b,y,h){switch(y){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=M;class E{constructor(b){this.channel=b}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(b){E.setLevel(this.channel,b)}static setLevel(b,y){return b.call("setLevel",y)}}e.LogLevelChannelClient=E;class n{constructor(b){this.loggerService=b,this.loggers=new Map}listen(b,y){throw new Error(`Event not found: ${y}`)}async call(b,y,h){switch(y){case"createLogger":this.createLogger(L.URI.revive(h[0]),h[1]);return;case"log":return this.log(L.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${y}`)}createLogger(b,y){this.loggers.set(b.toString(),this.loggerService.createLogger(b,y))}consoleLog(b,y){let h=console.log;switch(b){case k.LogLevel.Error:h=console.error;break;case k.LogLevel.Warning:h=console.warn;break;case k.LogLevel.Info:h=console.info;break}h.call(console,...y)}log(b,y){const h=this.loggers.get(b.toString());if(!h)throw new Error("Create the logger before logging");for(const[g,P]of y)switch(g){case k.LogLevel.Trace:h.trace(P);break;case k.LogLevel.Debug:h.debug(P);break;case k.LogLevel.Info:h.info(P);break;case k.LogLevel.Warning:h.warn(P);break;case k.LogLevel.Error:h.error(P);break;case k.LogLevel.Critical:h.critical(P);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class f extends k.AbstractLoggerService{constructor(b,y,h){super(b,y);this.channel=h}createConsoleMainLogger(){return new k.AdapterLogger({log:(b,y)=>{this.channel.call("consoleLog",[b,y])}})}doCreateLogger(b,y,h){return new w(this.channel,b,y,h)}}e.LoggerChannelClient=f;class w extends k.AbstractMessageLogger{constructor(b,y,h,g){super(g?.always);this.channel=b,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[y,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(b,y){const h=[[b,y]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(b){this.channel.call("log",[this.file,b])}}class t extends k.LogService{constructor(b,y){super(y);this.parent=b,this._register(b.onDidChangeLogLevel(h=>y.setLevel(h)))}setLevel(b){super.setLevel(b),this.parent.setLevel(b)}}e.FollowerLogService=t}),define(Z[93],x([0,1,20,6]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(f,w,t,I){try{const b=await new Promise((y,h)=>{K(["spdlog"],y,h)});return b.setFlushOn(L.LogLevel.Trace),b.createAsyncRotatingLogger(f,w,t,I)}catch(b){console.error(b)}return null}function M(f,w,t,I){const b=K.__$__nodeRequire("spdlog");return b.setFlushOn(L.LogLevel.Trace),b.createRotatingLogger(f,w,t,I)}e.createRotatingLogger=M;function E(f,w,t){switch(w){case L.LogLevel.Trace:f.trace(t);break;case L.LogLevel.Debug:f.debug(t);break;case L.LogLevel.Info:f.info(t);break;case L.LogLevel.Warning:f.warn(t);break;case L.LogLevel.Error:f.error(t);break;case L.LogLevel.Critical:f.critical(t);break;default:throw new Error("Invalid log level")}}class n extends L.AbstractMessageLogger{constructor(w,t,I,b){super();this.name=w,this.filepath=t,this.rotating=I,this.buffer=[],this.setLevel(b),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}_createSpdLogLogger(){const w=this.rotating?6:1,t=30/w*v.ByteSize.MB;return k(this.name,this.filepath,t,w).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:b,message:y}of this.buffer)E(this._logger,b,y);this.buffer=[]}})}log(w,t){this._logger?E(this._logger,w,t):this.getLevel()<=w&&this.buffer.push({level:w,message:t})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(Z[181],x([0,1,10,15,28,20,179,6,93]),function(K,e,v,L,k,M,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let w=class extends n.AbstractLoggerService{constructor(I,b){super(I.getLevel(),I.onDidChangeLogLevel);this.fileService=b}doCreateLogger(I,b,y){if(I.scheme===v.Schemas.file){const h=new f.SpdLogLogger(y?.name||(0,k.generateUuid)(),I.fsPath,!y?.donotRotate,b);return y?.donotUseFormatters&&h.clearFormatters(),h}else return new E.FileLogger(y?.name??(0,L.basename)(I),I,b,!!y?.donotUseFormatters,this.fileService)}};w=he([te(0,n.ILogService),te(1,M.IFileService)],w),e.LoggerService=w}),define(Z[182],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(E){return E.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function L(E){return E.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function k(E){return E.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function M(E){return!v(E)&&!L(E)&&!k(E)}e.isMenubarMenuItemAction=M}),define(Z[45],x([0,1,10,3,33,15]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let E;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const n=L.globals.vscode.context.configuration();if(n)E=n.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof K?.__$__nodeRequire=="function"){const n=(0,M.dirname)(v.FileAccess.asFileUri("",K));E=K.__$__nodeRequire((0,M.joinPath)(n,"product.json").fsPath);const f=K.__$__nodeRequire((0,M.joinPath)(n,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(E,{nameShort:`${E.nameShort} Dev`,nameLong:`${E.nameLong} Dev`,dataFolderName:`${E.dataFolderName}-dev`}),Object.assign(E,{version:f.version})}else E={},Object.keys(E).length===0&&Object.assign(E,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=E}),define(Z[94],x([0,1,18,17,141,20,45]),function(K,e,v,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(I,b,y,h,g,P){let p;try{await f(I,b,y,h,g,P)}catch(c){p=c}finally{p&&g.errorTransformer&&(p=g.errorTransformer(p)),typeof p!="undefined"&&y.error(p),y.end()}}e.readFileIntoStream=n;async function f(I,b,y,h,g,P){w(P);const p=await I.open(b,{create:!1});try{w(P);let c=0,d=0,o=g&&typeof g.length=="number"?g.length:void 0,u=v.VSBuffer.alloc(Math.min(g.bufferSize,typeof o=="number"?o:g.bufferSize)),i=g&&typeof g.position=="number"?g.position:0,a=0;do d=await I.read(p,i,u.buffer,a,u.byteLength-a),i+=d,a+=d,c+=d,typeof o=="number"&&(o-=d),a===u.byteLength&&(await y.write(h(u)),u=v.VSBuffer.alloc(Math.min(g.bufferSize,typeof o=="number"?o:g.bufferSize)),a=0);while(d>0&&(typeof o!="number"||o>0)&&w(P)&&t(c,g));if(a>0){let r=a;typeof o=="number"&&(r=Math.min(a,o)),y.write(h(u.slice(0,r)))}}catch(c){throw(0,M.ensureFileSystemProviderError)(c)}finally{await I.close(p)}}function w(I){if(I.isCancellationRequested)throw(0,L.canceled)();return!0}function t(I,b){if(b?.limits){if(typeof b.limits.memory=="number"&&I>b.limits.memory)throw(0,M.createFileSystemProviderError)((0,k.localize)(0,null,E.default.nameShort),M.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&I>b.limits.size)throw(0,M.createFileSystemProviderError)((0,k.localize)(1,null),M.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[183],x([0,1,32,9,18,23,4,64,2,37,10,73,15,65,139,20,94,6]),function(K,e,v,L,k,M,E,n,f,w,t,I,b,y,h,g,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class Ve extends f.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new E.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new E.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new E.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new E.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new E.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new E.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new g.FileChangesEvent(u,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new g.FileChangesEvent(u,!0)))),this.watchedResources=w.TernarySearchTree.forUris(u=>{const i=this.getProvider(u.scheme);return i?!this.isPathCaseSensitive(i):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(o,u){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,u),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:u});const i=new f.DisposableStore;return i.add(u.onDidChangeFile(a=>this.onDidChangeFile(a,this.isPathCaseSensitive(u)))),i.add(u.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:u,scheme:o}))),typeof u.onDidErrorOccur=="function"&&i.add(u.onDidErrorOccur(a=>this._onError.fire(new Error(a)))),(0,f.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:u}),this.provider.delete(o),(0,f.dispose)(i)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const u=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(i){u.push(i)}}),!this.provider.has(o)&&await L.Promises.settled(u)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,u){const i=this.provider.get(o.scheme);return!!(i&&i.capabilities&u)}listCapabilities(){return n.Iterable.map(this.provider,([o,u])=>({scheme:o,capabilities:u.capabilities}))}async withProvider(o){if(!(0,b.isAbsolutePath)(o))throw new g.FileOperationError((0,h.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const u=this.provider.get(o.scheme);if(!u){const i=new Error;throw i.name="ENOPRO",i.message=(0,h.localize)(1,null,o.toString()),i}return u}async withReadProvider(o){const u=await this.withProvider(o);if((0,g.hasOpenReadWriteCloseCapability)(u)||(0,g.hasReadWriteCapability)(u)||(0,g.hasFileReadStreamCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const u=await this.withProvider(o);if((0,g.hasOpenReadWriteCloseCapability)(u)||(0,g.hasReadWriteCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,u){try{return await this.doResolveFile(o,u)}catch(i){throw(0,g.toFileSystemProviderErrorCode)(i)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,h.localize)(2,null,this.resourceForError(o)),1):(0,g.ensureFileSystemProviderError)(i)}}async doResolveFile(o,u){const i=await this.withProvider(o),a=this.isPathCaseSensitive(i),r=u?.resolveTo,s=u?.resolveSingleChildDescendants,l=u?.resolveMetadata,m=await i.stat(o);let S;return this.toFileStat(i,o,m,void 0,!!l,(D,R)=>{if(!S&&(S=w.TernarySearchTree.forUris(()=>!a),S.set(o,!0),r))for(const F of r)S.set(F,!0);return S.get(D.resource)||S.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&s?R===1:!1})}async toFileStat(o,u,i,a,r,s){const{providerExtUri:l}=this.getExtUri(o),m={resource:u,name:l.basename(u),isFile:(i.type&g.FileType.File)!=0,isDirectory:(i.type&g.FileType.Directory)!=0,isSymbolicLink:(i.type&g.FileType.SymbolicLink)!=0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&g.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,g.etag)({mtime:i.mtime,size:i.size})};if(m.isDirectory&&s(m,a)){try{const S=await o.readdir(u),D=await L.Promises.settled(S.map(async([R,F])=>{try{const U=l.joinPath(u,R),X=r?await o.stat(U):{type:F};return await this.toFileStat(o,U,X,S.length,r,s)}catch(U){return this.logService.trace(U),null}}));m.children=(0,v.coalesce)(D)}catch(S){this.logService.trace(S),m.children=[]}return m}return m}async resolveAll(o){return L.Promises.settled(o.map(async u=>{try{return{stat:await this.doResolveFile(u.resource,u.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async exists(o){const u=await this.withProvider(o);try{return!!await u.stat(o)}catch(i){return!1}}async canCreateFile(o,u){try{await this.doValidateCreateFile(o,u)}catch(i){return i}return!0}async doValidateCreateFile(o,u){if(!u?.overwrite&&await this.exists(o))throw new g.FileOperationError((0,h.localize)(3,null,this.resourceForError(o)),3,u)}async createFile(o,u=k.VSBuffer.fromString(""),i){await this.doValidateCreateFile(o,i);const a=await this.writeFile(o,u);return this._onDidRunOperation.fire(new g.FileOperationEvent(o,0,a)),a}async writeFile(o,u,i){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:r}=this.getExtUri(a);try{await this.validateWriteFile(a,o,i)||await this.mkdirp(a,r.dirname(o));let l;if((0,g.hasReadWriteCapability)(a)&&!(u instanceof k.VSBuffer))if((0,y.isReadableStream)(u)){const m=await(0,y.peekStream)(u,3);m.ended?l=k.VSBuffer.concat(m.buffer):l=m}else l=(0,y.peekReadable)(u,m=>k.VSBuffer.concat(m),3);else l=u;!(0,g.hasOpenReadWriteCloseCapability)(a)||(0,g.hasReadWriteCapability)(a)&&l instanceof k.VSBuffer?await this.doWriteUnbuffered(a,o,i,l):await this.doWriteBuffered(a,o,i,l instanceof k.VSBuffer?(0,k.bufferToReadable)(l):l)}catch(s){throw new g.FileOperationError((0,h.localize)(4,null,this.resourceForError(o),(0,g.ensureFileSystemProviderError)(s).toString()),(0,g.toFileOperationResult)(s),i)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,u,i){if(!!i?.unlock&&!(o.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(u)));let r;try{r=await o.stat(u)}catch(s){return}if((r.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,h.localize)(6,null,this.resourceForError(u)),0,i);if(this.throwIfFileIsReadonly(u,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==g.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,g.etag)({mtime:i.mtime,size:r.size}))throw new g.FileOperationError((0,h.localize)(7,null),3,i);return r}async readFile(o,u){const i=await this.withReadProvider(o);return u?.atomic?this.doReadFileAtomic(i,o,u):this.doReadFile(i,o,u)}async doReadFileAtomic(o,u,i){return new Promise((a,r)=>{this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(o,u,i);a(s)}catch(s){r(s)}})})}async doReadFile(o,u,i){const a=await this.doReadFileStream(o,u,{...i,preferUnbuffered:!0});return{...a,value:await(0,k.streamToBuffer)(a.value)}}async readFileStream(o,u){const i=await this.withReadProvider(o);return this.doReadFileStream(i,o,u)}async doReadFileStream(o,u,i){const a=new M.CancellationTokenSource,r=this.validateReadFile(u,i).then(l=>l,l=>{throw a.cancel(),l});let s;try{return typeof i?.etag=="string"&&i.etag!==g.ETAG_DISABLED&&await r,!((0,g.hasOpenReadWriteCloseCapability)(o)||(0,g.hasFileReadStreamCapability)(o))||(0,g.hasReadWriteCapability)(o)&&i?.preferUnbuffered?s=this.readFileUnbuffered(o,u,i):(0,g.hasFileReadStreamCapability)(o)?s=this.readFileStreamed(o,u,a.token,i):s=this.readFileBuffered(o,u,a.token,i),{...await r,value:s}}catch(l){s&&await(0,y.consumeStream)(s);const m=(0,h.localize)(8,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(l).toString());throw l instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(m,l.stat,i):new g.FileOperationError(m,(0,g.toFileOperationResult)(l),i)}}readFileStreamed(o,u,i,a=Object.create(null)){const r=o.readFileStream(u,a,i);return(0,y.transform)(r,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>new g.FileOperationError((0,h.localize)(9,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(s).toString()),(0,g.toFileOperationResult)(s),a)},s=>k.VSBuffer.concat(s))}readFileBuffered(o,u,i,a=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,P.readFileIntoStream)(o,u,r,s=>s,{...a,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new g.FileOperationError((0,h.localize)(10,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(s).toString()),(0,g.toFileOperationResult)(s),a)},i),r}readFileUnbuffered(o,u,i){const a=(0,y.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r=await o.readFile(u);typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.validateReadFileLimits(u,r.byteLength,i),a.end(k.VSBuffer.wrap(r))}catch(r){a.error(r),a.end()}})(),a}async validateReadFile(o,u){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new g.FileOperationError((0,h.localize)(11,null,this.resourceForError(o)),0,u);if(typeof u?.etag=="string"&&u.etag!==g.ETAG_DISABLED&&u.etag===i.etag)throw new g.NotModifiedSinceFileOperationError((0,h.localize)(12,null),i,u);return this.validateReadFileLimits(o,i.size,u),i}validateReadFileLimits(o,u,i){if(i?.limits){let a;if(typeof i.limits.memory=="number"&&u>i.limits.memory&&(a=9),typeof i.limits.size=="number"&&u>i.limits.size&&(a=7),typeof a=="number")throw new g.FileOperationError((0,h.localize)(13,null,this.resourceForError(o)),a)}}async canMove(o,u,i){return this.doCanMoveCopy(o,u,"move",i)}async canCopy(o,u,i){return this.doCanMoveCopy(o,u,"copy",i)}async doCanMoveCopy(o,u,i,a){if(o.toString()!==u.toString())try{const r=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);await this.doValidateMoveCopy(r,o,s,u,i,a)}catch(r){return r}return!0}async move(o,u,i){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),s=await this.doMoveCopy(a,o,r,u,"move",!!i),l=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,s==="move"?2:3,l)),l}async copy(o,u,i){const a=await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),s=await this.doMoveCopy(a,o,r,u,"copy",!!i),l=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,s==="copy"?3:2,l)),l}async doMoveCopy(o,u,i,a,r,s){if(u.toString()===a.toString())return r;const{exists:l,isSameResourceWithDifferentPathCase:m}=await this.doValidateMoveCopy(o,u,i,a,r,s);if(l&&!m&&s&&await this.del(a,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(a)),r==="copy"){if(o===i&&(0,g.hasFileFolderCopyCapability)(o))await o.copy(u,a,{overwrite:s});else{const S=await this.resolve(u);S.isDirectory?await this.doCopyFolder(o,S,i,a):await this.doCopyFile(o,u,i,a)}return r}else return o===i?(await o.rename(u,a,{overwrite:s}),r):(await this.doMoveCopy(o,u,i,a,"copy",s),await this.del(u,{recursive:!0}),"copy")}async doCopyFile(o,u,i,a){if((0,g.hasOpenReadWriteCloseCapability)(o)&&(0,g.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(o,u,i,a);if((0,g.hasOpenReadWriteCloseCapability)(o)&&(0,g.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(o,u,i,a);if((0,g.hasReadWriteCapability)(o)&&(0,g.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(o,u,i,a);if((0,g.hasReadWriteCapability)(o)&&(0,g.hasReadWriteCapability)(i))return this.doPipeUnbuffered(o,u,i,a)}async doCopyFolder(o,u,i,a){await i.mkdir(a),Array.isArray(u.children)&&await L.Promises.settled(u.children.map(async r=>{const s=this.getExtUri(i).providerExtUri.joinPath(a,r.name);return r.isDirectory?this.doCopyFolder(o,await this.resolve(r.resource),i,s):this.doCopyFile(o,r.resource,i,s)}))}async doValidateMoveCopy(o,u,i,a,r,s){let l=!1;if(o===i){const{providerExtUri:S,isPathCaseSensitive:D}=this.getExtUri(o);if(D||(l=S.isEqual(u,a)),l&&r==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(u),this.resourceForError(a)));if(!l&&S.isEqualOrParent(a,u))throw new Error((0,h.localize)(15,null,this.resourceForError(u),this.resourceForError(a)))}const m=await this.exists(a);if(m&&!l){if(!s)throw new g.FileOperationError((0,h.localize)(16,null,this.resourceForError(u),this.resourceForError(a)),4);if(o===i){const{providerExtUri:S}=this.getExtUri(o);if(S.isEqualOrParent(u,a))throw new Error((0,h.localize)(17,null,this.resourceForError(u),this.resourceForError(a)))}}return{exists:m,isSameResourceWithDifferentPathCase:l}}getExtUri(o){const u=this.isPathCaseSensitive(o);return{providerExtUri:u?b.extUri:b.extUriIgnorePathCase,isPathCaseSensitive:u}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(u,o);const i=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(o,0,i)),i}async mkdirp(o,u){const i=[],{providerExtUri:a}=this.getExtUri(o);for(;!a.isEqual(u,a.dirname(u));)try{if(((await o.stat(u)).type&g.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(u)));break}catch(r){if((0,g.toFileSystemProviderErrorCode)(r)!==g.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(a.basename(u)),u=a.dirname(u)}for(let r=i.length-1;r>=0;r--){u=a.joinPath(u,i[r]);try{await o.mkdir(u)}catch(s){if((0,g.toFileSystemProviderErrorCode)(s)!==g.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,u){try{await this.doValidateDelete(o,u)}catch(i){return i}return!0}async doValidateDelete(o,u){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!u?.useTrash&&!(i.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(o)));let r;try{r=await i.stat(o)}catch(l){}if(r)this.throwIfFileIsReadonly(o,r);else throw new g.FileOperationError((0,h.localize)(20,null,this.resourceForError(o)),1);if(!!!u?.recursive){const l=await this.resolve(o);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(o)))}return i}async del(o,u){const i=await this.doValidateDelete(o,u),a=!!u?.useTrash,r=!!u?.recursive;await i.delete(o,{recursive:r,useTrash:a}),this._onDidRunOperation.fire(new g.FileOperationEvent(o,1))}onDidChangeFile(o,u){this._onDidChangeFilesRaw.fire({changes:o});let i,a;{for(const r of o)this.watchedResources.has(r.resource)?(i||(i=[]),i.push(r)):(a||(a=[]),a.push(r));i&&this._onDidFilesChange.fire(new g.FileChangesEvent(i,!u))}if(a){const r=u?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(a)&&Ve.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,u={recursive:!1,excludes:[]}){const i=new f.DisposableStore;{let a=!1,r=()=>{a=!0};i.add((0,f.toDisposable)(()=>r())),this.doWatch(o,u).then(s=>{a?(0,f.dispose)(s):r=()=>(0,f.dispose)(s)},s=>this.logService.error(s))}return u.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),i.add((0,f.toDisposable)(()=>{const a=this.watchedResources.get(o);typeof a=="number"&&(a<=1?this.watchedResources.delete(o):this.watchedResources.set(o,a-1))}))),i}async doWatch(o,u){const i=await this.withProvider(o),a=this.toWatchKey(i,o,u),r=this.activeWatchers.get(a)||{count:0,disposable:i.watch(o,u)};return this.activeWatchers.has(a)||this.activeWatchers.set(a,r),r.count+=1,(0,f.toDisposable)(()=>{r.count--,r.count===0&&((0,f.dispose)(r.disposable),this.activeWatchers.delete(a))})}toWatchKey(o,u,i){const{providerExtUri:a}=this.getExtUri(o);return[a.getComparisonKey(u),String(i.recursive),i.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,f.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,u,i,a){return this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri).queue(async()=>{const r=await o.open(u,{create:!0,unlock:i?.unlock??!1});try{(0,y.isReadableStream)(a)||(0,y.isReadableBufferedStream)(a)?await this.doWriteStreamBufferedQueued(o,r,a):await this.doWriteReadableBufferedQueued(o,r,a)}catch(s){throw(0,g.ensureFileSystemProviderError)(s)}finally{await o.close(r)}})}async doWriteStreamBufferedQueued(o,u,i){let a=0,r;if((0,y.isReadableBufferedStream)(i)){if(i.buffer.length>0){const s=k.VSBuffer.concat(i.buffer);await this.doWriteBuffer(o,u,s,s.byteLength,a,0),a+=s.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise(async(s,l)=>{(0,y.listenStream)(r,{onData:async m=>{r.pause();try{await this.doWriteBuffer(o,u,m,m.byteLength,a,0)}catch(S){return l(S)}a+=m.byteLength,setTimeout(()=>r.resume())},onError:m=>l(m),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(o,u,i){let a=0,r;for(;(r=i.read())!==null;)await this.doWriteBuffer(o,u,r,r.byteLength,a,0),a+=r.byteLength}async doWriteBuffer(o,u,i,a,r,s){let l=0;for(;l<a;)l+=await o.write(u,r+l,i.buffer,s+l,a-l)}async doWriteUnbuffered(o,u,i,a){return this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,u,i,a))}async doWriteUnbufferedQueued(o,u,i,a){let r;a instanceof k.VSBuffer?r=a:(0,y.isReadableStream)(a)?r=await(0,k.streamToBuffer)(a):(0,y.isReadableBufferedStream)(a)?r=await(0,k.bufferedStreamToBuffer)(a):r=(0,k.readableToBuffer)(a),await o.writeFile(u,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async doPipeBuffered(o,u,i,a){return this.writeQueue.queueFor(a,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,u,i,a))}async doPipeBufferedQueued(o,u,i,a){let r,s;try{r=await o.open(u,{create:!1}),s=await i.open(a,{create:!0,unlock:!1});const l=k.VSBuffer.alloc(this.BUFFER_SIZE);let m=0,S=0,D=0;do D=await o.read(r,m,l.buffer,S,l.byteLength-S),await this.doWriteBuffer(i,s,l,D,m,S),m+=D,S+=D,S===l.byteLength&&(S=0);while(D>0)}catch(l){throw(0,g.ensureFileSystemProviderError)(l)}finally{await L.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof s=="number"?i.close(s):Promise.resolve()])}}async doPipeUnbuffered(o,u,i,a){return this.writeQueue.queueFor(a,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,u,i,a))}async doPipeUnbufferedQueued(o,u,i,a){return i.writeFile(a,await o.readFile(u),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,u,i,a){return this.writeQueue.queueFor(a,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,u,i,a))}async doPipeUnbufferedToBufferedQueued(o,u,i,a){const r=await i.open(a,{create:!0,unlock:!1});try{const s=await o.readFile(u);await this.doWriteBuffer(i,r,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,g.ensureFileSystemProviderError)(s)}finally{await i.close(r)}}async doPipeBufferedToUnbuffered(o,u,i,a){const r=await(0,k.streamToBuffer)(this.readFileBuffered(o,u,M.CancellationToken.None));await this.doWriteUnbuffered(i,a,void 0,r)}throwIfFileSystemIsReadonly(o,u){if(o.capabilities&2048)throw new g.FileOperationError((0,h.localize)(22,null,this.resourceForError(u)),6);return o}throwIfFileIsReadonly(o,u){if((u.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,h.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===t.Schemas.file?o.fsPath:o.toString(!0)}};c.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},c=he([te(0,p.ILogService)],c),e.FileService=c}),define(Z[184],x([0,1,32,9,18,4,30,2,8,3,15,65,19,142,20,94,173,163,164,91,166,6,45]),function(K,e,v,L,k,M,E,n,f,w,t,I,b,y,h,g,P,p,c,d,o,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class a extends n.Disposable{constructor(s,l){super();this.logService=s,this.options=l,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=M.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new M.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:l,symbolicLink:m}=await b.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(l,m),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size}}catch(l){throw this.toFileSystemProviderError(l)}}async readdir(s){try{const l=await b.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),m=[];return await Promise.all(l.map(async S=>{try{let D;S.isSymbolicLink()?D=(await this.stat((0,t.joinPath)(s,S.name))).type:D=this.toType(S),m.push([S.name,D])}catch(D){this.logService.trace(D)}})),m}catch(l){throw this.toFileSystemProviderError(l)}}toType(s,l){let m;return l?.dangling?m=h.FileType.Unknown:s.isFile()?m=h.FileType.File:s.isDirectory()?m=h.FileType.Directory:m=h.FileType.Unknown,l&&(m|=h.FileType.SymbolicLink),m}async readFile(s){try{const l=this.toFilePath(s);return await b.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}}readFileStream(s,l,m){const S=(0,I.newWriteableStream)(D=>k.VSBuffer.concat(D.map(R=>k.VSBuffer.wrap(R))).buffer);return(0,g.readFileIntoStream)(this,s,S,D=>D.buffer,{...l,bufferSize:this.BUFFER_SIZE},m),S}async writeFile(s,l,m){let S;try{const D=this.toFilePath(s);if(!m.create||!m.overwrite){if(await b.Promises.exists(D)){if(!m.overwrite)throw(0,h.createFileSystemProviderError)((0,y.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!m.create)throw(0,h.createFileSystemProviderError)((0,y.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(s,{create:!0,unlock:m.unlock}),await this.write(S,0,l,0,l.byteLength)}catch(D){throw await this.toFileSystemProviderWriteError(s,D)}finally{typeof S=="number"&&await this.close(S)}}async open(s,l){try{const m=this.toFilePath(s);if((0,h.isFileOpenForWriteOptions)(l)&&l.unlock)try{const{stat:R}=await b.SymlinkSupport.stat(m);R.mode&128||await b.Promises.chmod(m,R.mode|128)}catch(R){this.logService.trace(R)}let S;if((0,h.isFileOpenForWriteOptions)(l)){if(w.isWindows)try{await b.Promises.truncate(m,0),S="r+"}catch(R){R.code!=="ENOENT"&&this.logService.trace(R)}S||(S="w")}else S="r";const D=await b.Promises.open(m,S);return this.mapHandleToPos.set(D,0),(0,h.isFileOpenForWriteOptions)(l)&&this.writeHandles.set(D,s),D}catch(m){throw(0,h.isFileOpenForWriteOptions)(l)?await this.toFileSystemProviderWriteError(s,m):this.toFileSystemProviderError(m)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await b.Promises.fdatasync(s)}catch(l){this.canFlush=!1,this.logService.error(l)}return await b.Promises.close(s)}catch(l){throw this.toFileSystemProviderError(l)}}async read(s,l,m,S,D){const R=this.normalizePos(s,l);let F=null;try{const U=await b.Promises.read(s,m,S,D,R);return typeof U=="number"?F=U:F=U.bytesRead,F}catch(U){throw this.toFileSystemProviderError(U)}finally{this.updatePos(s,R,F)}}normalizePos(s,l){return l===this.mapHandleToPos.get(s)?null:l}updatePos(s,l,m){const S=this.mapHandleToPos.get(s);typeof S=="number"&&(typeof l=="number"||(typeof m=="number"?this.mapHandleToPos.set(s,S+m):this.mapHandleToPos.delete(s)))}async write(s,l,m,S,D){return(0,L.retry)(()=>this.doWrite(s,l,m,S,D),100,3)}async doWrite(s,l,m,S,D){const R=this.normalizePos(s,l);let F=null;try{const U=await b.Promises.write(s,m,S,D,R);return typeof U=="number"?F=U:F=U.bytesWritten,F}catch(U){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),U)}finally{this.updatePos(s,R,F)}}async mkdir(s){try{await b.Promises.mkdir(this.toFilePath(s))}catch(l){throw this.toFileSystemProviderError(l)}}async delete(s,l){try{const m=this.toFilePath(s);await this.doDelete(m,l)}catch(m){throw this.toFileSystemProviderError(m)}}async doDelete(s,l){l.recursive?await b.Promises.rm(s,b.RimRafMode.MOVE):await b.Promises.unlink(s)}async rename(s,l,m){const S=this.toFilePath(s),D=this.toFilePath(l);if(S!==D)try{await this.validateTargetDeleted(s,l,"move",m.overwrite),await b.Promises.move(S,D)}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,y.localize)(2,null,(0,f.basename)(S),(0,f.basename)((0,f.dirname)(D)),R.toString()))),this.toFileSystemProviderError(R)}}async copy(s,l,m){const S=this.toFilePath(s),D=this.toFilePath(l);if(S!==D)try{await this.validateTargetDeleted(s,l,"copy",m.overwrite),await b.Promises.copy(S,D,{preserveSymlinks:!0})}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,y.localize)(3,null,(0,f.basename)(S),(0,f.basename)((0,f.dirname)(D)),R.toString()))),this.toFileSystemProviderError(R)}}async validateTargetDeleted(s,l,m,S){const D=this.toFilePath(s),R=this.toFilePath(l);let F=!1;if(!!(this.capabilities&1024)||(F=(0,E.isEqual)(D,R,!0)),F&&m==="copy")throw(0,h.createFileSystemProviderError)((0,y.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!F&&await b.Promises.exists(R)){if(!S)throw(0,h.createFileSystemProviderError)((0,y.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(l,{recursive:!0,useTrash:!1})}}watch(s,l){return l.recursive?this.watchRecursive(s,l.excludes):this.watchNonRecursive(s)}watchRecursive(s,l){const m={path:this.toFilePath(s),excludes:l},S=(0,v.insert)(this.recursiveFoldersToWatch,m);return this.refreshRecursiveWatchers(),(0,n.toDisposable)(()=>{S(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof p.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,n.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let s,l;this.options?.watcher?.usePolling?(s=c.FileWatcher,l=this.options?.watcher):i.default.quality==="stable"&&this.recursiveFoldersToWatch.length===1?w.isWindows?s=o.FileWatcher:s=c.FileWatcher:s=p.FileWatcher,this.recursiveWatcher=new s(this.recursiveFoldersToWatch,m=>this._onDidChangeFile.fire((0,d.toFileChanges)(m)),m=>{m.type==="error"&&this._onDidWatchErrorOccur.fire(m.message),this.logService[m.type](m.message)},this.logService.getLevel()===u.LogLevel.Trace,l),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===u.LogLevel.Trace)}))}}watchNonRecursive(s){const l=new P.FileWatcher(this.toFilePath(s),S=>this._onDidChangeFile.fire((0,d.toFileChanges)(S)),S=>{S.type==="error"&&this._onDidWatchErrorOccur.fire(S.message),this.logService[S.type](S.message)},this.logService.getLevel()===u.LogLevel.Trace),m=this.logService.onDidChangeLogLevel(()=>{l.setVerboseLogging(this.logService.getLevel()===u.LogLevel.Trace)});return(0,n.combinedDisposable)(l,m)}toFilePath(s){return(0,f.normalize)(s.fsPath)}toFileSystemProviderError(s){if(s instanceof h.FileSystemProviderError)return s;let l;switch(s.code){case"ENOENT":l=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=h.FileSystemProviderErrorCode.NoPermissions;break;default:l=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(s,l)}async toFileSystemProviderWriteError(s,l){let m=this.toFileSystemProviderError(l);if(s&&m.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:S}=await b.SymlinkSupport.stat(this.toFilePath(s));S.mode&128||(m=(0,h.createFileSystemProviderError)(l,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(S){this.logService.trace(S)}return m}dispose(){super.dispose(),(0,n.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,n.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=a}),define(Z[21],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService")}),define(Z[185],x([0,1,58,6,21]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let M=class{constructor(n,f){this.productService=n,this.logService=f,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,f){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const w=/^(.*)#([^#]+)$/.exec(f);if(!w)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,t,I]=w;let b=this.trustedExtensionUrlPublicKeys.get(n);if(!b){if(b=this.productService.trustedExtensionUrlPublicKeys[n],!b||b.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...b])}const y=Buffer.from(decodeURIComponent(I),"base64");if(y.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const h=y.slice(0,6),g=y.readUIntBE(0,6),P=Date.now()-g;if(P<0||P>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const p=y.slice(6),c=v.createVerify("SHA256");c.write(h),c.write(Buffer.from(t)),c.end();for(let d=0;d<b.length;d++){let o=b[d];if(o!==null){if(typeof o=="string")try{o=v.createPublicKey({key:Buffer.from(o,"base64"),format:"der",type:"spki"}),b[d]=o}catch(u){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${d+1} for ${n}:`,u),b[d]=null;continue}if(c.verify(o,p))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};M=he([te(0,k.IProductService),te(1,L.ILogService)],M),e.ExtensionUrlTrustService=M}),define(Z[55],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(Z[186],x([0,1,14,2,37,10,3,15,7,28,48,6]),function(K,e,v,L,k,M,E,n,f,w,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let b=class extends L.Disposable{constructor(h,g){super();this.logService=g,this.validRoots=k.TernarySearchTree.forUris(()=>!E.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(f.URI.file(h.appRoot)),this.addValidFileRoot(f.URI.file(h.extensionsPath)),this.addValidFileRoot(h.globalStorageHome),this.addValidFileRoot(h.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:h}=v.session;h.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(g,P)=>this.handleResourceRequest(g,P)),h.protocol.interceptFileProtocol(M.Schemas.file,(g,P)=>this.handleFileRequest(g,P)),this._register((0,L.toDisposable)(()=>{h.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),h.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(h){return this.validRoots.get(h)?L.Disposable.None:(this.validRoots.set(h,!0),(0,L.toDisposable)(()=>this.validRoots.delete(h)))}handleFileRequest(h,g){const P=f.URI.parse(h.url);return this.logService.error(`Refused to load resource ${P.fsPath} from ${M.Schemas.file}: protocol (original URL: ${h.url})`),g({error:-3})}handleResourceRequest(h,g){const P=f.URI.parse(h.url),p=M.FileAccess.asFileUri(P);return this.validRoots.findSubstr(p)?g({path:p.fsPath}):this.validExtensions.has((0,n.extname)(p))?g({path:p.fsPath}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${p.fsPath} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${h.url})`),g({error:-3}))}createIPCObjectUrl(){let h;const g=f.URI.from({scheme:"vscode",path:(0,w.generateUuid)()}),P=g.toString(),p=async()=>h;return v.ipcMain.handle(P,p),this.logService.trace(`IPC Object URL: Registered new channel ${P}.`),{resource:g,update:c=>h=c,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${P}.`),v.ipcMain.removeHandler(P)}}}};b=he([te(0,t.INativeEnvironmentService),te(1,I.ILogService)],b),e.ProtocolMainService=b}),define(Z[38],x([0,1,102,13]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(E,n){v.ok(L.isString(E)),v.ok(L.isObject(n)),v.ok(!this.data.has(E),"There is already an extension with this id"),this.data.set(E,n)}knows(E){return this.data.has(E)}as(E){return this.data.get(E)||null}}e.Registry=new k}),define(Z[187],x([0,1,4,38]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class M{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,w){this.schemasById[k(f)]=w,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const E=new M;L.Registry.add(e.Extensions.JSONContribution,E)}),define(Z[49],x([0,1,4,13,132,187,38]),function(K,e,v,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var n;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(n=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var f;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const w=E.Registry.as(M.Extensions.JSONContribution);class t{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new v.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new v.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(c,d=!0){this.registerConfigurations([c],d)}registerConfigurations(c,d=!0){const o=[];c.forEach(u=>{o.push(...this.validateAndRegisterProperties(u,d,u.extensionInfo)),this.configurationContributors.push(u),this.registerJSONConfiguration(u)}),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(c){const d=[],o=u=>{if(u.properties)for(const i in u.properties)d.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,u.properties[i]);u.allOf&&u.allOf.forEach(i=>o(i))};for(const u of c){o(u);const i=this.configurationContributors.indexOf(u);i!==-1&&this.configurationContributors.splice(i,1)}w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}registerDefaultConfigurations(c){const d=[],o=[];for(const u of c)for(const i in u)if(d.push(i),e.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...u[i]};const a={type:"object",default:this.defaultValues[i],description:k.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};o.push(b(i)),this.configurationProperties[i]=a,this.defaultLanguageConfigurationOverridesNode.properties[i]=a}else{this.defaultValues[i]=u[i];const a=this.configurationProperties[i];a&&(this.updatePropertyDefaultValue(i,a),this.updateSchema(i,a))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterDefaultConfigurations(c){const d=[];for(const o of c)for(const u in o)if(d.push(u),delete this.defaultValues[u],e.OVERRIDE_PROPERTY_PATTERN.test(u))delete this.configurationProperties[u],delete this.defaultLanguageConfigurationOverridesNode.properties[u];else{const i=this.configurationProperties[u];i&&(this.updatePropertyDefaultValue(u,i),this.updateSchema(u,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}notifyConfigurationSchemaUpdated(...c){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(c){for(const d of c)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(c,d=!0,o,u=3){u=L.isUndefinedOrNull(c.scope)?u:c.scope;let i=[],a=c.properties;if(a)for(let s in a){if(d&&g(s)){delete a[s];continue}const l=a[s];if(this.updatePropertyDefaultValue(s,l),e.OVERRIDE_PROPERTY_PATTERN.test(s)?l.scope=void 0:(l.scope=L.isUndefinedOrNull(l.scope)?u:l.scope,l.restricted=L.isUndefinedOrNull(l.restricted)?!!o?.restrictedConfigurations?.includes(s):l.restricted),a[s].hasOwnProperty("included")&&!a[s].included){this.excludedConfigurationProperties[s]=a[s],delete a[s];continue}else this.configurationProperties[s]=a[s];!a[s].deprecationMessage&&a[s].markdownDeprecationMessage&&(a[s].deprecationMessage=a[s].markdownDeprecationMessage),i.push(s)}let r=c.allOf;if(r)for(let s of r)i.push(...this.validateAndRegisterProperties(s,d,o,u));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(c){const d=o=>{let u=o.properties;if(u)for(const a in u)this.updateSchema(a,u[a]);let i=o.allOf;i&&i.forEach(d)};d(c)}updateSchema(c,d){switch(e.allSettings.properties[c]=d,d.scope){case 1:e.applicationSettings.properties[c]=d;break;case 2:e.machineSettings.properties[c]=d;break;case 6:e.machineOverridableSettings.properties[c]=d;break;case 3:e.windowSettings.properties[c]=d;break;case 4:e.resourceSettings.properties[c]=d;break;case 5:e.resourceSettings.properties[c]=d,this.resourceLanguageSettingsSchema.properties[c]=d;break}}removeFromSchema(c,d){switch(delete e.allSettings.properties[c],d.scope){case 1:delete e.applicationSettings.properties[c];break;case 2:delete e.machineSettings.properties[c];break;case 6:delete e.machineOverridableSettings.properties[c];break;case 3:delete e.windowSettings.properties[c];break;case 4:case 5:delete e.resourceSettings.properties[c];break}}updateOverridePropertyPatternKey(){for(const c of this.overrideIdentifiers.values()){const d=`[${c}]`,o={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,o),e.allSettings.properties[d]=o,e.applicationSettings.properties[d]=o,e.machineSettings.properties[d]=o,e.machineOverridableSettings.properties[d]=o,e.windowSettings.properties[d]=o,e.resourceSettings.properties[d]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(c,d){let o=this.defaultValues[c];L.isUndefined(o)&&(o=d.default),L.isUndefined(o)&&(o=y(d.type)),d.default=o}}const I="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(I);function b(p){return p.substring(1,p.length-1)}e.overrideIdentifierFromKey=b;function y(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=y;const h=new t;E.Registry.add(e.Extensions.Configuration,h);function g(p){return p.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(p)?k.localize(5,null,p):h.getConfigurationProperties()[p]!==void 0?k.localize(6,null,p):null:k.localize(4,null)}e.validateProperty=g;function P(){const p=[],c=h.getConfigurationProperties();for(const d of Object.keys(c))p.push([d,c[d].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=P}),define(Z[16],x([0,1,44,13,7,49,5,38]),function(K,e,v,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,E.createDecorator)("configurationService");function f(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof k.URI)}e.isConfigurationOverrides=f;var w;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(w=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function I(a,r){const s=r?a?r.keys.filter(U=>a.keys.indexOf(U)===-1):[...r.keys]:[],l=a?r?a.keys.filter(U=>r.keys.indexOf(U)===-1):[...a.keys]:[],m=[];if(r&&a){for(const U of a.keys)if(r.keys.indexOf(U)!==-1){const X=p(a.contents,U),ne=p(r.contents,U);v.equals(X,ne)||m.push(U)}}const S=[],D=U=>{const X={};for(const ne of U)for(const se of ne.identifiers)X[u(se)]=ne;return X},R=r?D(r.overrides):{},F=a?D(a.overrides):{};if(Object.keys(R).length)for(const U of s){const X=R[U];X&&S.push([(0,M.overrideIdentifierFromKey)(U),X.keys])}if(Object.keys(F).length)for(const U of l){const X=F[U];X&&S.push([(0,M.overrideIdentifierFromKey)(U),X.keys])}if(Object.keys(R).length&&Object.keys(F).length)for(const U of m){const X=F[U],ne=R[U];if(X&&ne){const se=I({contents:X.contents,keys:X.keys,overrides:[]},{contents:ne.contents,keys:ne.keys,overrides:[]});S.push([(0,M.overrideIdentifierFromKey)(U),[...se.added,...se.removed,...se.updated]])}}return{added:s,removed:l,updated:m,overrides:S}}e.compare=I;function b(a,r){const s=[];for(const l of Object.keys(a))if(M.OVERRIDE_PROPERTY_PATTERN.test(l)){const m={};for(const S in a[l])m[S]=a[l][S];s.push({identifiers:[(0,M.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(m),contents:y(m,r)})}return s}e.toOverrides=b;function y(a,r){const s=Object.create(null);for(let l in a)h(s,l,a[l],r);return s}e.toValuesTree=y;function h(a,r,s,l){const m=r.split("."),S=m.pop();let D=a;for(let R=0;R<m.length;R++){let F=m[R],U=D[F];switch(typeof U){case"undefined":U=D[F]=Object.create(null);break;case"object":break;default:l(`Ignoring ${r} as ${m.slice(0,R+1).join(".")} is ${JSON.stringify(U)}`);return}D=U}if(typeof D=="object"&&D!==null)try{D[S]=s}catch(R){l(`Ignoring ${r} as ${m.join(".")} is ${JSON.stringify(D)}`)}else l(`Ignoring ${r} as ${m.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=h;function g(a,r){const s=r.split(".");P(a,s)}e.removeFromValueTree=g;function P(a,r){const s=r.shift();if(r.length===0){delete a[s];return}if(Object.keys(a).indexOf(s)!==-1){const l=a[s];typeof l=="object"&&!Array.isArray(l)&&(P(l,r),Object.keys(l).length===0&&delete a[s])}}function p(a,r,s){function l(D,R){let F=D;for(const U of R){if(typeof F!="object"||F===null)return;F=F[U]}return F}const m=r.split("."),S=l(a,m);return typeof S=="undefined"?s:S}e.getConfigurationValue=p;function c(a,r,s){Object.keys(r).forEach(l=>{l!=="__proto__"&&(l in a?L.isObject(a[l])&&L.isObject(r[l])?c(a[l],r[l],s):s&&(a[l]=r[l]):a[l]=r[l])})}e.merge=c;function d(){const a=n.Registry.as(M.Extensions.Configuration).getConfigurationProperties();return Object.keys(a)}e.getConfigurationKeys=d;function o(){const a=Object.create(null),r=n.Registry.as(M.Extensions.Configuration).getConfigurationProperties();for(let s in r){let l=r[s].default;h(a,s,l,m=>console.error(`Conflict in default settings: ${m}`))}return a}e.getDefaultValues=o;function u(a){return`[${a}]`}e.keyFromOverrideIdentifier=u;function i(a,r,s){const l=a.inspect(r),m=a.inspect(s);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:l.defaultValue}e.getMigratedSettingValue=i}),define(Z[188],x([0,1,32,4,40,2,37,44,13,7,16,49,38]),function(K,e,v,L,k,M,E,n,f,w,t,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class y{constructor(i={},a=[],r=[]){this._contents=i,this._keys=a,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,a){const r=this.getContentsForOverrideIdentifer(a);return r?i?(0,t.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){for(const a of this.overrides)if(a.identifiers.indexOf(i)!==-1)return a.keys;return[]}override(i){const a=this.getContentsForOverrideIdentifer(i);if(!a||typeof a!="object"||!Object.keys(a).length)return this;let r={};for(const s of v.distinct([...Object.keys(this.contents),...Object.keys(a)])){let l=this.contents[s],m=a[s];m&&(typeof l=="object"&&typeof m=="object"?(l=n.deepClone(l),this.mergeContents(l,m)):l=m),r[s]=l}return new y(r,this.keys,this.overrides)}merge(...i){const a=n.deepClone(this.contents),r=n.deepClone(this.overrides),s=[...this.keys];for(const l of i){this.mergeContents(a,l.contents);for(const m of l.overrides){const[S]=r.filter(D=>v.equals(D.identifiers,m.identifiers));S?this.mergeContents(S.contents,m.contents):r.push(n.deepClone(m))}for(const m of l.keys)s.indexOf(m)===-1&&s.push(m)}return new y(a,s,r)}freeze(){return this.isFrozen=!0,this}mergeContents(i,a){for(const r of Object.keys(a)){if(r in i&&f.isObject(i[r])&&f.isObject(a[r])){this.mergeContents(i[r],a[r]);continue}i[r]=n.deepClone(a[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?n.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const a of this.overrides)if(a.identifiers.indexOf(i)!==-1)return a.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,a){this.addKey(i),(0,t.addToValueTree)(this.contents,i,a,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let a=this.keys.length;for(let r=0;r<a;r++)i.indexOf(this.keys[r])===0&&(a=r);this.keys.splice(a,1,i)}removeKey(i){let a=this.keys.indexOf(i);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=y;class h extends y{constructor(){const i=(0,t.getDefaultValues)(),a=(0,t.getConfigurationKeys)(),r=[];for(const s of Object.keys(i))I.OVERRIDE_PROPERTY_PATTERN.test(s)&&r.push({identifiers:[(0,I.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(i[s]),contents:(0,t.toValuesTree)(i[s],l=>console.error(`Conflict in default settings file: ${l}`))});super(i,a,r)}}e.DefaultConfigurationModel=h;class g{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,a){if(!f.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,a)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,a){this._raw=i;const{contents:r,keys:s,overrides:l,restricted:m}=this.doParseRaw(i,a);this._configurationModel=new y(r,s,l),this._restrictedConfigurations=m||[]}doParseContent(i){let a={},r=null,s=[],l=[],m=[];function S(R){Array.isArray(s)?s.push(R):r!==null&&(s[r]=R)}let D={onObjectBegin:()=>{let R={};S(R),l.push(s),s=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{let R=[];S(R),l.push(s),s=R,r=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:S,onError:(R,F,U)=>{m.push({error:R,offset:F,length:U})}};if(i)try{k.visit(i,D),a=s[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return a}doParseRaw(i,a){const r=b.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),s=this.filter(i,r,!0,a);i=s.raw;const l=(0,t.toValuesTree)(i,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),m=Object.keys(i),S=(0,t.toOverrides)(i,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:l,keys:m,overrides:S,restricted:s.restricted}}filter(i,a,r,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:i,restricted:[]};const l={},m=[];for(let S in i)if(I.OVERRIDE_PROPERTY_PATTERN.test(S)&&r){const D=this.filter(i[S],a,!1,s);l[S]=D.raw,m.push(...D.restricted)}else{const D=a[S],R=D?typeof D.scope!="undefined"?D.scope:3:void 0;D?.restricted&&m.push(S),(R===void 0||s.scopes===void 0||s.scopes.includes(R))&&(s.skipRestricted&&D?.restricted||(l[S]=i[S]))}return{raw:l,restricted:m}}}e.ConfigurationModelParser=g;class P extends M.Disposable{constructor(i,a,r,s){super();this.userSettingsResource=i,this.scopes=a,this.fileService=s,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=P;class p{constructor(i,a,r=new y,s=new y,l=new E.ResourceMap,m=new y,S=new E.ResourceMap,D=!0){this._defaultConfiguration=i,this._localUserConfiguration=a,this._remoteUserConfiguration=r,this._workspaceConfiguration=s,this._folderConfigurations=l,this._memoryConfiguration=m,this._memoryConfigurationByResource=S,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new E.ResourceMap,this._userConfiguration=null}getValue(i,a,r){return this.getConsolidateConfigurationModel(a,r).getValue(i)}updateValue(i,a,r={}){let s;r.resource?(s=this._memoryConfigurationByResource.get(r.resource),s||(s=new y,this._memoryConfigurationByResource.set(r.resource,s))):s=this._memoryConfiguration,a===void 0?s.removeValue(i):s.setValue(i,a),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,a,r){const s=this.getConsolidateConfigurationModel(a,r),l=this.getFolderConfigurationModelForResource(a.resource,r),m=a.resource?this._memoryConfigurationByResource.get(a.resource)||this._memoryConfiguration:this._memoryConfiguration,S=a.overrideIdentifier?this._defaultConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),D=a.overrideIdentifier?this.userConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),R=a.overrideIdentifier?this.localUserConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),F=a.overrideIdentifier?this.remoteUserConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),U=r?a.overrideIdentifier?this._workspaceConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,X=l?a.overrideIdentifier?l.freeze().override(a.overrideIdentifier).getValue(i):l.freeze().getValue(i):void 0,ne=a.overrideIdentifier?m.override(a.overrideIdentifier).getValue(i):m.getValue(i),se=s.getValue(i),G=v.distinct(v.flatten(s.overrides.map(J=>J.identifiers))).filter(J=>s.getOverrideValue(i,J)!==void 0);return{defaultValue:S,userValue:D,userLocalValue:R,userRemoteValue:F,workspaceValue:U,workspaceFolderValue:X,memoryValue:ne,value:se,default:S!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,userRemote:F!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,workspaceFolder:X!==void 0?{value:l?.freeze().getValue(i),override:a.overrideIdentifier?l?.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,memory:ne!==void 0?{value:m.getValue(i),override:a.overrideIdentifier?m.getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,overrideIdentifiers:G.length?G:void 0}}keys(i){const a=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,a){this._folderConfigurations.set(i,a),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,a){const r=a.filter(s=>I.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const l=(0,I.overrideIdentifierFromKey)(s),m=this._defaultConfiguration.getKeysForOverrideIdentifier(l),S=i.getKeysForOverrideIdentifier(l),D=[...S.filter(R=>m.indexOf(R)===-1),...m.filter(R=>S.indexOf(R)===-1),...m.filter(R=>!n.equals(this._defaultConfiguration.override(l).getValue(R),i.override(l).getValue(R)))];return[l,D]});return this.updateDefaultConfiguration(i),{keys:a,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:a,updated:r,removed:s,overrides:l}=(0,t.compare)(this.localUserConfiguration,i),m=[...a,...r,...s];return m.length&&this.updateLocalUserConfiguration(i),{keys:m,overrides:l}}compareAndUpdateRemoteUserConfiguration(i){const{added:a,updated:r,removed:s,overrides:l}=(0,t.compare)(this.remoteUserConfiguration,i);let m=[...a,...r,...s];return m.length&&this.updateRemoteUserConfiguration(i),{keys:m,overrides:l}}compareAndUpdateWorkspaceConfiguration(i){const{added:a,updated:r,removed:s,overrides:l}=(0,t.compare)(this.workspaceConfiguration,i);let m=[...a,...r,...s];return m.length&&this.updateWorkspaceConfiguration(i),{keys:m,overrides:l}}compareAndUpdateFolderConfiguration(i,a){const r=this.folderConfigurations.get(i),{added:s,updated:l,removed:m,overrides:S}=(0,t.compare)(r,a);let D=[...s,...l,...m];return(D.length||!r)&&this.updateFolderConfiguration(i,a),{keys:D,overrides:S}}compareAndDeleteFolderConfiguration(i){const a=this.folderConfigurations.get(i);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:s,removed:l,overrides:m}=(0,t.compare)(a,void 0);return{keys:[...r,...s,...l],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,a){let r=this.getConsolidatedConfigurationModelForResource(i,a);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},a){let r=this.getWorkspaceConsolidatedConfiguration();if(a&&i){const s=a.getFolder(i);s&&(r=this.getFolderConsolidatedConfiguration(s.uri)||r);const l=this._memoryConfigurationByResource.get(i);l&&(r=r.merge(l))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let a=this._foldersConsolidatedConfigurations.get(i);if(!a){const r=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(i);s?(a=r.merge(s),this._freeze&&(a=a.freeze()),this._foldersConsolidatedConfigurations.set(i,a)):a=r}return a}getFolderConfigurationModelForResource(i,a){if(a&&i){const r=a.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,a)=>{const{contents:r,overrides:s,keys:l}=this._folderConfigurations.get(a);return i.push([a,{contents:r,overrides:s,keys:l}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(a=>i.add(a)),this.userConfiguration.freeze().keys.forEach(a=>i.add(a)),this._workspaceConfiguration.freeze().keys.forEach(a=>i.add(a)),this._folderConfigurations.forEach(a=>a.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const a=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>a.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>a.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>a.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(s=>a.add(s))),[...a.values()]}static parse(i){const a=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),s=this.parseConfigurationModel(i.workspace),l=i.folders.reduce((m,S)=>(m.set(w.URI.revive(S[0]),this.parseConfigurationModel(S[1])),m),new E.ResourceMap);return new p(a,r,new y,s,l,new y,new E.ResourceMap,!1)}static parseConfigurationModel(i){return new y(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=p;function c(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const i=new Set,a=new Map;for(const s of u)s.keys.forEach(l=>i.add(l)),s.overrides.forEach(([l,m])=>{const S=(0,E.getOrSet)(a,l,new Set);m.forEach(D=>S.add(D))});const r=[];return a.forEach((s,l)=>r.push([l,[...s.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=c;class d{constructor(i,a,r,s){this.change=i,this.previous=a,this.currentConfiguraiton=r,this.currentWorkspace=s,this._previousConfiguration=void 0;const l=new Set;i.keys.forEach(S=>l.add(S)),i.overrides.forEach(([,S])=>S.forEach(D=>l.add(D))),this.affectedKeys=[...l.values()];const m=new y;this.affectedKeys.forEach(S=>m.setValue(S,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,a){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(a){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,a,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(i,a,this.currentWorkspace);return!n.equals(r,s)}return!0}return!1}doesAffectedKeysTreeContains(i,a){let r=(0,t.toValuesTree)({[a]:!0},()=>{}),s;for(;typeof r=="object"&&(s=Object.keys(r)[0]);){if(i=i[s],!i)return!1;r=r[s]}return!0}}e.ConfigurationChangeEvent=d;class o extends d{constructor(i,a,r,s){super({keys:i.allKeys(),overrides:[]},void 0,i,a);this.source=r,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=o}),define(Z[189],x([0,1,9,4,2,15,16,188,49,38]),function(K,e,v,L,k,M,E,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class t extends k.Disposable{constructor(b,y){super();this.settingsResource=b,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new n.UserSettings(this.settingsResource,void 0,M.extUriBiasedIgnorePathCase,y)),this.configuration=new n.Configuration(new n.DefaultConfigurationModel,new n.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(w.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const b=await this.userConfiguration.loadConfiguration();this.configuration=new n.Configuration(new n.DefaultConfigurationModel,b)}getConfigurationData(){return this.configuration.toData()}getValue(b,y){const h=typeof b=="string"?b:void 0,g=(0,E.isConfigurationOverrides)(b)?b:(0,E.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(h,g,void 0)}updateValue(b,y,h,g){return Promise.reject(new Error("not supported"))}inspect(b){return this.configuration.inspect(b,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const b=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(b)}onDidChangeUserConfiguration(b){const y=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(b);this.trigger(h,y,1)}onDidDefaultConfigurationChange(b){const y=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new n.DefaultConfigurationModel,b);this.trigger(h,y,6)}trigger(b,y,h){const g=new n.ConfigurationChangeEvent(b,{data:y},this.configuration);g.source=h,g.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(b){switch(b){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=t}),define(Z[190],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var L;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(E,n=L.Unknown,f){super(E);this._message=E,this._code=n,this._detail=f,this.isHandled=n===L.NotAvailable&&f===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(E){return E instanceof k&&E._code===L.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof k&&E._code===L.NoResolverFound}static isHandled(E){return E instanceof k&&E.isHandled}}e.RemoteAuthorityResolverError=k}),define(Z[191],x([0,1,9,18,23,17,4,2,28,83,190]),function(K,e,v,L,k,M,E,n,f,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var b;(function(T){T[T.Management=1]="Management",T[T.ExtensionHost=2]="ExtensionHost",T[T.Tunnel=3]="Tunnel"})(b=e.ConnectionType||(e.ConnectionType={}));function y(T){switch(T){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(T){const A=new k.CancellationTokenSource;return setTimeout(()=>A.cancel(),T),A.token}function g(T,A){if(T.isCancellationRequested||A.isCancellationRequested)return k.CancellationToken.Cancelled;const O=new k.CancellationTokenSource;return T.onCancellationRequested(()=>O.cancel()),A.onCancellationRequested(()=>O.cancel()),O.token}class P{constructor(A){this._state="pending",this._disposables=new n.DisposableStore,this.promise=new Promise((O,z)=>{this._resolvePromise=O,this._rejectPromise=z}),A.isCancellationRequested?this._timeout():this._disposables.add(A.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(A){this._state==="pending"?this._disposables.add(A):A.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(A))}reject(A){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(A))}}function p(T,A){const O=new P(A);return O.registerDisposable(T.onControlMessage(z=>{const N=JSON.parse(z.toString()),C=B(N);C?O.reject(C):O.resolve(N)})),O.promise}function c(T,A,O,z,N,C){const q=new P(C);return A.connect(O,z,N,(Q,ie)=>{q.didTimeout?(Q&&T.error(Q),ie?.dispose()):Q||!ie?q.reject(Q):q.resolve(ie)}),q.promise}function d(T,A){const O=new P(A);return T.then(z=>{O.didTimeout||O.resolve(z)},z=>{O.didTimeout||O.reject(z)}),O.promise}async function o(T,A,O,z){const N=_(T,A);T.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let C;try{C=await c(T.logService,T.socketFactory,T.host,T.port,`reconnectionToken=${T.reconnectionToken}&reconnection=${T.reconnectionProtocol?"true":"false"}`,z)}catch(oe){throw T.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),T.logService.error(oe),oe}T.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let q,Q;T.reconnectionProtocol?(T.reconnectionProtocol.beginAcceptReconnection(C,null),q=T.reconnectionProtocol,Q=!1):(q=new w.PersistentProtocol(C,null),Q=!0),T.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const ie={type:"auth",auth:T.connectionToken||"00000000000000000000"};q.sendControl(L.VSBuffer.fromString(JSON.stringify(ie)));try{const oe=await p(q,g(z,h(1e4)));if(oe.type!=="sign"||typeof oe.data!="string"){const le=new Error("Unexpected handshake message");throw le.code="VSCODE_CONNECTION_ERROR",le}T.logService.trace(`${N} 4/6. received SignRequest control message.`);const ae=await d(T.signService.sign(oe.data),z),ee={type:"connectionType",commit:T.commit,signedData:ae,desiredConnectionType:A};return O&&(ee.args=O),T.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),q.sendControl(L.VSBuffer.fromString(JSON.stringify(ee))),{protocol:q,ownsProtocol:Q}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&(T.logService.error(`${N} the handshake timed out. Error:`),T.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&(T.logService.error(`${N} received error control message when negotiating connection. Error:`),T.logService.error(oe)),Q&&V(q),oe}}async function u(T,A,O,z){const N=Date.now(),C=_(T,A),{protocol:q,ownsProtocol:Q}=await o(T,A,O,z),ie=new P(z);return ie.registerDisposable(q.onControlMessage(oe=>{const ae=JSON.parse(oe.toString()),ee=B(ae);ee?(T.logService.error(`${C} received error control message when negotiating connection. Error:`),T.logService.error(ee),Q&&V(q),ie.reject(ee)):(T.reconnectionProtocol&&T.reconnectionProtocol.endAcceptReconnection(),T.logService.trace(`${C} 6/6. handshake finished, connection is up and running after ${j(N)}!`),ie.resolve({protocol:q,firstMessage:ae}))})),ie.promise}async function i(T,A){const{protocol:O}=await u(T,1,void 0,A);return{protocol:O}}async function a(T,A,O){const{protocol:z,firstMessage:N}=await u(T,2,A,O),C=N&&N.debugPort;return{protocol:z,debugPort:C}}async function r(T,A,O){const z=Date.now(),N=_(T,3),{protocol:C}=await o(T,3,A,O);return T.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${j(z)}!`),C}async function s(T,A,O){const{host:z,port:N,connectionToken:C}=await T.addressProvider.getAddress();return{commit:T.commit,host:z,port:N,connectionToken:C,reconnectionToken:A,reconnectionProtocol:O,socketFactory:T.socketFactory,signService:T.signService,logService:T.logService}}async function l(T,A,O){try{const z=(0,f.generateUuid)(),N=await s(T,z,null),{protocol:C}=await i(N,k.CancellationToken.None);return new J(T,A,O,z,C)}catch(z){throw T.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),T.logService.error(z),G.triggerPermanentFailure(0,0,t.RemoteAuthorityResolverError.isHandled(z)),z}}e.connectRemoteAgentManagement=l;async function m(T,A){try{const O=(0,f.generateUuid)(),z=await s(T,O,null),{protocol:N,debugPort:C}=await a(z,A,k.CancellationToken.None);return new W(T,A,O,N,C)}catch(O){throw T.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),T.logService.error(O),G.triggerPermanentFailure(0,0,t.RemoteAuthorityResolverError.isHandled(O)),O}}e.connectRemoteAgentExtensionHost=m;async function S(T,A,O){const z=await s(T,(0,f.generateUuid)(),null);return await r(z,{host:A,port:O},k.CancellationToken.None)}e.connectRemoteAgentTunnel=S;function D(T){return(0,v.createCancelablePromise)(A=>new Promise((O,z)=>{const N=setTimeout(O,T*1e3);A.onCancellationRequested(()=>{clearTimeout(N),O()})}))}var R;(function(T){T[T.ConnectionLost=0]="ConnectionLost",T[T.ReconnectionWait=1]="ReconnectionWait",T[T.ReconnectionRunning=2]="ReconnectionRunning",T[T.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",T[T.ConnectionGain=4]="ConnectionGain"})(R=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class F{constructor(A,O){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.type=0}}e.ConnectionLostEvent=F;class U{constructor(A,O,z,N){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.durationSeconds=z,this.cancellableTimer=N,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=U;class X{constructor(A,O,z){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.attempt=z,this.type=2}}e.ReconnectionRunningEvent=X;class ne{constructor(A,O,z){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.attempt=z,this.type=4}}e.ConnectionGainEvent=ne;class se{constructor(A,O,z,N){this.reconnectionToken=A,this.millisSinceLastIncomingData=O,this.attempt=z,this.handled=N,this.type=3}}e.ReconnectionPermanentFailureEvent=se;class G extends n.Disposable{constructor(A,O,z,N){super();this._connectionType=A,this._onDidStateChange=this._register(new E.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=O,this.reconnectionToken=z,this.protocol=N,this._isReconnecting=!1,this._onDidStateChange.fire(new ne(this.reconnectionToken,0,0)),this._register(N.onSocketClose(C=>{const q=H(this._connectionType,this.reconnectionToken,!0);C?C.type===0?(this._options.logService.info(`${q} received socket close event (hadError: ${C.hadError}).`),C.error&&this._options.logService.error(C.error)):(this._options.logService.info(`${q} received socket close event (wasClean: ${C.wasClean}, code: ${C.code}, reason: ${C.reason}).`),C.event&&this._options.logService.error(C.event)):this._options.logService.info(`${q} received socket close event.`),this._beginReconnecting()})),this._register(N.onSocketTimeout(()=>{const C=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${C} received socket timeout event.`),this._beginReconnecting()})),G._instances.push(this),G._permanentFailure&&this._gotoPermanentFailure(G._permanentFailureMillisSinceLastIncomingData,G._permanentFailureAttempt,G._permanentFailureHandled)}static triggerPermanentFailure(A,O,z){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=A,this._permanentFailureAttempt=O,this._permanentFailureHandled=z,this._instances.forEach(N=>N._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(G._permanentFailure)return;const A=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const O=[0,5,5,10,10,10,10,10,30];let z=-1;do{z++;const N=z<O.length?O[z]:O[O.length-1];try{if(N>0){const q=D(N);this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,q)),this._options.logService.info(`${A} waiting for ${N} seconds before reconnecting...`);try{await q}catch{}}if(G._permanentFailure){this._options.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1)),this._options.logService.info(`${A} resolving connection...`);const C=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${A} connecting to ${C.host}:${C.port}...`),await this._reconnect(C,h(I)),this._options.logService.info(`${A} reconnected!`),this._onDidStateChange.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1));break}catch(C){if(C.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(C),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(z>360){this._options.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(C),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(t.RemoteAuthorityResolverError.isTemporarilyNotAvailable(C)){this._options.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(C);continue}if((C.code==="ETIMEDOUT"||C.code==="ENETUNREACH"||C.code==="ECONNREFUSED"||C.code==="ECONNRESET")&&C.syscall==="connect"){this._options.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(C);continue}if((0,M.isPromiseCanceledError)(C)){this._options.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(C);continue}if(C instanceof t.RemoteAuthorityResolverError){this._options.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(C),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),z+1,t.RemoteAuthorityResolverError.isHandled(C));break}this._options.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(C),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}}while(!G._permanentFailure)}_gotoPermanentFailure(A,O,z){this._onDidStateChange.fire(new se(this.reconnectionToken,A,O,z)),V(this.protocol)}}G._permanentFailure=!1,G._permanentFailureMillisSinceLastIncomingData=0,G._permanentFailureAttempt=0,G._permanentFailureHandled=!1,G._instances=[];class J extends G{constructor(A,O,z,N,C){super(1,A,N,C);this.client=this._register(new w.Client(C,{remoteAuthority:O,clientId:z},A.ipcLogger))}async _reconnect(A,O){await i(A,O)}}e.ManagementPersistentConnection=J;class W extends G{constructor(A,O,z,N,C){super(2,A,z,N);this._startArguments=O,this.debugPort=C}async _reconnect(A,O){await a(A,this._startArguments,O)}}e.ExtensionHostPersistentConnection=W;function V(T){try{T.acceptDisconnect();const A=T.getSocket();T.dispose(),A.dispose()}catch(A){(0,M.onUnexpectedError)(A)}}function B(T){if(T&&T.type==="error"){const A=new Error(`Connection error: ${T.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function $(T,A){for(;T.length<A;)T+=" ";return T}function H(T,A,O){return`[remote-connection][${$(y(T),13)}][${A.substr(0,5)}\u2026][${O?"reconnect":"initial"}]`}function _(T,A){return`${H(A,T.reconnectionToken,!!T.reconnectionProtocol)}[${T.host}:${T.port}]`}function j(T){return`${Date.now()-T} ms`}}),define(Z[74],x([0,1,10]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(w){return w.scheme===v.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=L;function k(w){if(!w)return;const t=w.indexOf("+");return t<0?w:w.substr(0,t)}e.getRemoteName=k;function M(w){return w.scheme!==v.Schemas.file&&w.scheme!==v.Schemas.vscodeRemote}e.isVirtualResource=M;function E(w){if(w.folders.length)return w.folders.every(t=>M(t.uri))?w.folders[0].uri:void 0;if(w.configuration&&M(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=E;function n(w){return E(w)?.scheme}e.getVirtualWorkspaceScheme=n;function f(w){return E(w)!==void 0}e.isVirtualWorkspace=f}),define(Z[95],x([0,1,4,3,5,6]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService");var E;(function(y){y.Http="http",y.Https="https"})(E=e.TunnelProtocol||(e.TunnelProtocol={}));var n;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(n=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function f(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=f,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(y){return e.LOCALHOST_ADDRESSES.indexOf(y)>=0}e.isLocalhost=w,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function t(y){return e.ALL_INTERFACES_ADDRESSES.indexOf(y)>=0}e.isAllInterfaces=t;function I(y,h){return h?h!==1&&y<1024:!L.isWindows&&y<1024}e.isPortPrivileged=I;let b=class{constructor(h){this.logService=h,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new v.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(h,g){return this._tunnelProvider=h,h?(this._canElevate=g.elevation,this._canMakePublic=g.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async h=>{const g=[],P=Array.from(this._tunnels.values());for(let p of P){const c=Array.from(p.values());for(let d of c){const o=await d.value;o&&g.push(o)}}h(g)})}async dispose(){for(const h of this._tunnels.values()){for(const{value:g}of h.values())await g.then(P=>P?.dispose());h.clear()}this._tunnels.clear()}openTunnel(h,g,P,p,c=!1,d=!1,o){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${P} on local port ${p}.`),!h)return;g||(g="localhost");const u=this.retainOrCreateTunnel(h,g,P,p,c,d,o);return u?u.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,P);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(i);return(i.tunnelRemoteHost!==g||i.tunnelRemotePort!==P)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,public:h.public,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const g=this._tunnels.get(h.tunnelRemoteHost);if(g){const P=g.get(h.tunnelRemotePort);P&&(P.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,P))}}}}async tryDisposeTunnel(h,g,P){if(P.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${g}.`);const p=P.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(g),p}}async closeTunnel(h,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${g} `);const P=this._tunnels.get(h);if(P&&P.has(g)){const p=P.get(g);p.refcount=0,await this.tryDisposeTunnel(h,g,p)}}addTunnelToMap(h,g,P){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(g,{refcount:1,value:P})}async removeEmptyTunnelFromMap(h,g){const P=this._tunnels.get(h);P&&(await P.get(g)||P.delete(g),P.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,g){let P=[h];w(h)?(P.push(...e.LOCALHOST_ADDRESSES),P.push(...e.ALL_INTERFACES_ADDRESSES)):t(h)&&P.push(...e.ALL_INTERFACES_ADDRESSES);const p=P.map(c=>this._tunnels.get(c));for(const c of p){const d=c?.get(g);if(d)return d}}canTunnel(h){return!!f(h)}createWithProvider(h,g,P,p,c,d,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${P} on local port ${p}.`);const i={elevationRequired:c?I(p===void 0?P:p):!1},a={remoteAddress:{host:g,port:P},localAddressPort:p,public:d,protocol:o},r=h.forwardPort(a,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(g,P,r),r}};b=he([te(0,M.ILogService)],b),e.AbstractTunnelService=b}),define(Z[50],x([0,1,18,146,49,5,38]),function(K,e,v,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,M.createDecorator)("requestService");function n(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=n;function f(h){return h.res.statusCode===204}async function w(h){if(!n(h))throw new Error("Server returned "+h.res.statusCode);return f(h)?null:(await(0,v.streamToBuffer)(h.stream)).toString()}e.asText=w;async function t(h){if(!n(h))throw new Error("Server returned "+h.res.statusCode);if(f(h))return null;const P=(await(0,v.streamToBuffer)(h.stream)).toString();try{return JSON.parse(P)}catch(p){throw p.message+=`:
`+P,p}}e.asJson=t;function I(h){y(h)}e.updateProxyConfigurationsScope=I;let b;function y(h){const g=E.Registry.as(k.Extensions.Configuration);b&&g.deregisterConfigurations([b]),b={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},g.registerConfiguration(b)}y(2)}),define(Z[192],x([0,1,193,13]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(E,n){return E.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:E.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function M(E,n,f={}){const w=(0,v.parse)(E),t=f.proxyUrl||k(w,n);if(!t)return null;const I=(0,v.parse)(t);if(!/^https?:$/.test(I.protocol||""))return null;const b={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,L.isBoolean)(f.strictSSL)?f.strictSSL:!0};return w.protocol==="http:"?new(await new Promise((y,h)=>{K(["http-proxy-agent"],y,h)}))(b):new(await new Promise((y,h)=>{K(["https-proxy-agent"],y,h)}))(b)}e.getProxyAgent=M}),define(Z[194],x([0,1,18,28]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(M,E,n){let f=n&&n.get("storage.serviceMachineId",0)||null;if(f)return f;try{const t=(await E.readFile(M.serviceMachineIdResource)).value.toString();f=(0,L.isUUID)(t)?t:null}catch(w){f=null}if(!f){f=(0,L.generateUuid)();try{await E.writeFile(M.serviceMachineIdResource,v.VSBuffer.fromString(f))}catch(w){}}return n&&n.store("storage.serviceMachineId",f,0,1),f}e.getServiceMachineId=k}),define(Z[75],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[195],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{vsda(){return new Promise((k,M)=>K(["vsda"],k,M))}async sign(k){try{const M=await this.vsda(),E=new M.signer;if(E)return E.sign(k)}catch(M){}return k}}e.SignService=v}),define(Z[39],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,v.createDecorator)("stateMainService")}),define(Z[22],x([0,1,14,9,4,2,3,33,13,5,177,6,39]),function(K,e,v,L,k,M,E,n,f,w,t,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,w.createDecorator)("lifecycleMainService");var y;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen"})(y=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let h=class lt extends M.Disposable{constructor(P,p){super();this.logService=P,this.stateMainService=p,this._onBeforeShutdown=this._register(new k.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new k.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new k.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new k.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new k.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(lt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(lt.QUIT_AND_RESTART_KEY)}registerListeners(){const P=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),E.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};v.app.addListener("before-quit",P);const p=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!E.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",p),v.app.once("will-quit",c=>{this.logService.trace("Lifecycle#app.on(will-quit)"),c.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",P),v.app.removeListener("window-all-closed",p),v.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const P=[];return this._onWillShutdown.fire({join(p){P.push(p)}}),this.pendingWillShutdownPromise=(async()=>{try{await L.Promises.settled(P)}catch(p){this.logService.error(p)}try{await this.stateMainService.close()}catch(p){this.logService.error(p)}})(),this.pendingWillShutdownPromise}set phase(P){if(P<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===P)return;this.logService.trace(`lifecycle (main): phase changed (value: ${P})`),this._phase=P;const p=this.phaseWhen.get(this._phase);p&&(p.open(),this.phaseWhen.delete(this._phase))}async when(P){if(P<=this._phase)return;let p=this.phaseWhen.get(P);p||(p=new L.Barrier,this.phaseWhen.set(P,p)),await p.wait()}registerWindow(P){const p=new M.DisposableStore;this.windowCounter++,p.add(P.onWillLoad(d=>this._onWillLoadWindow.fire({window:P,workspace:d.workspace,reason:d.reason})));const c=(0,f.assertIsDefined)(P.win);c.on("close",d=>{const o=P.id;if(this.windowToCloseRequest.has(o)){this.windowToCloseRequest.delete(o);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${P.id}`),d.preventDefault(),this.unload(P,1).then(u=>{if(u){this.windowToCloseRequest.delete(o);return}this.windowToCloseRequest.add(o),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this._onBeforeCloseWindow.fire(P),P.close()})}),c.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${P.id}`),this.windowCounter--,p.dispose(),this.windowCounter===0&&(!E.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(P,p){await this.unload(P,3)||P.reload(p)}async unload(P,p){if(!P.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${P.id}`);const c=this._quitRequested?2:p;let d=await this.onBeforeUnloadWindowInRenderer(P,c);return d?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${P.id})`),this.handleWindowUnloadVeto(d)):(d=await this.onBeforeUnloadWindowInMain(P,c),d?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${P.id})`),this.handleWindowUnloadVeto(d)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${P.id})`),await this.onWillUnloadWindowInRenderer(P,c),!1))}handleWindowUnloadVeto(P){return P?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(P){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(P),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(P,p){return new Promise(c=>{const d=this.oneTimeListenerTokenGenerator++,o=`vscode:ok${d}`,u=`vscode:cancel${d}`;v.ipcMain.once(o,()=>{c(!1)}),v.ipcMain.once(u,()=>{c(!0)}),P.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:u,reason:p})})}onBeforeUnloadWindowInMain(P,p){const c=[];return this._onBeforeUnloadWindow.fire({reason:p,window:P,veto(d){c.push(d)}}),(0,t.handleVetos)(c,d=>this.logService.error(d))}onWillUnloadWindowInRenderer(P,p){return new Promise(c=>{const o=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;v.ipcMain.once(o,()=>c()),P.send("vscode:onWillUnload",{replyChannel:o,reason:p})})}quit(P){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${P}`),P&&this.stateMainService.setItem(lt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(p=>{this.pendingQuitPromiseResolve=p,this.logService.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}async relaunch(P){this.logService.trace("Lifecycle#relaunch()");const p=process.argv.slice(1);if(P?.addArgs&&p.push(...P.addArgs),P?.removeArgs)for(const o of P.removeArgs){const u=p.indexOf(o);u>=0&&p.splice(u,1)}const c=()=>{try{if(E.isWindows){const o=(0,n.cwd)();o!==process.cwd()&&process.chdir(o)}}catch(o){this.logService.error(o)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:p})};v.app.once("quit",c),await this.quit(!0)&&v.app.removeListener("quit",c)}async kill(P){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,L.timeout)(1e3),(async()=>{for(const p of v.BrowserWindow.getAllWindows())if(p&&!p.isDestroyed()){let c;p.webContents&&!p.webContents.isDestroyed()?c=new Promise(d=>p.once("closed",d)):c=Promise.resolve(),p.destroy(),await c}})()]),v.app.exit(P)}};h.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",h=he([te(0,I.ILogService),te(1,b.IStateMainService)],h),e.LifecycleMainService=h}),define(Z[196],x([0,1,4,2,5,22]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,k.createDecorator)("keyboardLayoutMainService");let E=class extends L.Disposable{constructor(w){super();this._onDidChangeKeyboardLayout=this._register(new v.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,w.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const w=await new Promise((t,I)=>{K(["native-keymap"],t,I)});this._keyboardLayoutData=n(w),w.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(w),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};E=he([te(0,M.ILifecycleMainService)],E),e.KeyboardLayoutMainService=E;function n(f){const w=f.getKeyMap(),t=f.getCurrentKeyboardLayout();return{keyboardMapping:w,keyboardLayoutInfo:t}}}),define(Z[96],x([0,1,9,4,2,13,85,5]),function(K,e,v,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,n.createDecorator)("storageService");var w;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var t;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(t=e.StorageScope||(e.StorageScope={}));var I;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class b extends k.Disposable{constructor(P={flushInterval:b.DEFAULT_FLUSH_INTERVAL}){super();this.options=P,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new v.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,v.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(P,p){p===f?(P===0?this._globalKeyTargets=void 0:P===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:P})):this._onDidChangeValue.fire({scope:P,key:p,target:this.getKeyTargets(P)[p]})}emitWillSaveState(P){this._onWillSaveState.fire({reason:P})}get(P,p,c){return this.getStorage(p)?.get(P,c)}getBoolean(P,p,c){return this.getStorage(p)?.getBoolean(P,c)}getNumber(P,p,c){return this.getStorage(p)?.getNumber(P,c)}store(P,p,c,d){if((0,M.isUndefinedOrNull)(p)){this.remove(P,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(P,c,d),this.getStorage(c)?.set(P,p)})}remove(P,p){this.withPausedEmitters(()=>{this.updateKeyTarget(P,p,void 0),this.getStorage(p)?.delete(P)})}withPausedEmitters(P){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{P()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(P,p){const c=[],d=this.getKeyTargets(P);for(const o of Object.keys(d))d[o]===p&&c.push(o);return c}updateKeyTarget(P,p,c){const d=this.getKeyTargets(p);typeof c=="number"?d[P]!==c&&(d[P]=c,this.getStorage(p)?.set(f,JSON.stringify(d))):typeof d[P]=="number"&&(delete d[P],this.getStorage(p)?.set(f,JSON.stringify(d)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(P){return P===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(P){const p=this.get(f,P);if(p)try{return JSON.parse(p)}catch(c){}return Object.create(null)}isNew(P){return this.getBoolean(e.IS_NEW_KEY,P)===!0}async flush(P=w.NONE){this._onWillSaveState.fire({reason:P}),await v.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const P=this.getStorage(0)?.items??new Map,p=this.getStorage(1)?.items??new Map;return h(P,p,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=b,b.DEFAULT_FLUSH_INTERVAL=60*1e3;class y extends b{constructor(){super();this.globalStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(P=>this.emitDidChangeValue(1,P))),this._register(this.globalStorage.onDidChangeStorage(P=>this.emitDidChangeValue(0,P)))}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(P){}}e.InMemoryStorageService=y;async function h(g,P,p,c){const d=l=>{try{return JSON.parse(l)}catch(m){return l}},o=new Map,u=new Map;g.forEach((l,m)=>{o.set(m,l),u.set(m,d(l))});const i=new Map,a=new Map;P.forEach((l,m)=>{i.set(m,l),a.set(m,d(l))}),console.group(`Storage: Global (path: ${p})`);let r=[];o.forEach((l,m)=>{r.push({key:m,value:l})}),console.table(r),console.groupEnd(),console.log(u),console.group(`Storage: Workspace (path: ${c})`);let s=[];i.forEach((l,m)=>{s.push({key:m,value:l})}),console.table(s),console.groupEnd(),console.log(a)}e.logStorage=h}),define(Z[197],x([0,1,3,33,7,28]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function E(w){if(v.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function n(w,t,I,b,y,h,g,P,p,c){const d=Object.create(null);d["common.machineId"]=g,d.sessionID=(0,M.generateUuid)()+Date.now(),d.commitHash=y,d.version=h,d["common.platformVersion"]=(t||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,v.PlatformToString)(v.platform),d["common.nodePlatform"]=L.platform,d["common.nodeArch"]=b,d["common.product"]=c||"desktop";const o=f(P||[]);o&&(d["common.msftInternal"]=o);let u=0;const i=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),v.isLinuxSnap&&(d["common.snap"]="true");const a=E(I);a&&(d["common.platformDetail"]=a);try{const r=await w.readFile(k.URI.file(p));d["common.source"]=r.value.toString().slice(0,30)}catch(r){}return d}e.resolveCommonProperties=n;function f(w){const t=L.env.USERDNSDOMAIN;if(!t)return!1;const I=t.toLowerCase();return w.some(b=>I===b)}e.verifyMicrosoftInternalDomain=f}),define(Z[29],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(M){M[M.NONE=0]="NONE",M[M.LOG=1]="LOG",M[M.USER=2]="USER"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(M){M.OFF="off",M.ERROR="error",M.ON="on"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[198],x([0,1,26,64,40,10,8,3,7,67,19,82,71,20,21,29]),function(K,e,v,L,k,M,E,n,f,w,t,I,b,y,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function P(u,i){const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],r=new Map,s=new Map,l=2e4;function m(R,F,U,X){const ne=F.substring(R.length+1);return new Promise(async se=>{let G;try{G=await t.Promises.readdir(F,{withFileTypes:!0})}catch(V){se();return}if(X.count>=l){X.count+=G.length,X.maxReached=!0,se();return}let J=G.length;if(J===0){se();return}let W=G;X.count+G.length>l&&(X.maxReached=!0,J=l-X.count,W=G.slice(0,J)),X.count+=G.length;for(const V of W)if(V.isDirectory()){if(U.includes(V.name)||await m(R,(0,E.join)(F,V.name),U,X),--J==0){se();return}}else{const B=V.name.lastIndexOf(".");if(B>=0){const $=V.name.substring(B+1);$&&r.set($,(r.get($)??0)+1)}for(const $ of a)$.relativePathPattern?.test(ne)!==!1&&$.filePattern.test(V.name)&&s.set($.tag,(s.get($.tag)??0)+1);if(--J==0){se();return}}})}const S={count:0,maxReached:!1};await m(u,u,i,S);const D=await d(u);return{configFiles:p(s),fileTypes:p(r),fileCount:S.count,maxFilesReached:S.maxReached,launchConfigFiles:D}}e.collectWorkspaceStats=P;function p(u){return[...L.Iterable.map(u.entries(),([i,a])=>({name:i,count:a}))].sort((i,a)=>a.count-i.count)}function c(){const u={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/y.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/y.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(w.virtualMachineHint.value()*100)}%`},i=v.cpus();return i&&i.length>0&&(u.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),u}e.getMachineInfo=c;async function d(u){try{const i=new Map,a=(0,E.join)(u,".vscode","launch.json"),r=await t.Promises.readFile(a),s=[],l=(0,k.parse)(r.toString(),s);if(s.length)return console.log(`Unable to parse ${a}`),[];if((0,k.getNodeType)(l)==="object"&&l.configurations)for(const m of l.configurations){const S=m.type;S&&(i.has(S)?i.set(S,i.get(S)+1):i.set(S,1))}return p(i)}catch(i){return[]}}e.collectLaunchConfigs=d;let o=class{constructor(i,a){this.telemetryService=i,this.productService=a}formatMachineInfo(i){const a=[];return a.push(`OS Version:       ${i.os}`),a.push(`CPUs:             ${i.cpus}`),a.push(`Memory (System):  ${i.memory}`),a.push(`VM:               ${i.vmHint}`),a.join(`
`)}formatEnvironment(i){const a=[];a.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),a.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const r=v.cpus();return r&&r.length>0&&a.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),a.push(`Memory (System):  ${(v.totalmem()/y.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/y.ByteSize.GB).toFixed(2)}GB free)`),n.isWindows||a.push(`Load (avg):       ${v.loadavg().map(s=>Math.round(s)).join(", ")}`),a.push(`VM:               ${Math.round(w.virtualMachineHint.value()*100)}%`),a.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),a.push(`Process Argv:     ${i.mainArguments.join(" ")}`),a.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),a.join(`
`)}async getPerformanceInfo(i,a){return Promise.all([(0,I.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async r=>{let[s,l]=r,m=this.formatProcessList(i,s);return a.forEach(S=>{if((0,b.isRemoteDiagnosticError)(S))m+=`
${S.errorMessage}`,l+=`
${S.errorMessage}`;else if(m+=`

Remote: ${S.hostName}`,S.processes&&(m+=`
${this.formatProcessList(i,S.processes)}`),S.workspaceMetadata){l+=`
|  Remote: ${S.hostName}`;for(const D of Object.keys(S.workspaceMetadata)){const R=S.workspaceMetadata[D];let F=`${R.fileCount} files`;R.maxFilesReached&&(F=`more than ${F}`),l+=`|    Folder (${D}): ${F}`,l+=this.formatWorkspaceStats(R)}}}),{processInfo:m,workspaceInfo:l}})}async getSystemInfo(i,a){const{memory:r,vmHint:s,os:l,cpus:m}=c(),S={os:l,memory:r,cpus:m,vmHint:s,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:a};return n.isWindows||(S.load=`${v.loadavg().map(D=>Math.round(D)).join(", ")}`),n.isLinux&&(S.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(S)}async getDiagnostics(i,a){const r=[];return(0,I.listProcesses)(i.mainPID).then(async s=>(r.push(""),r.push(this.formatEnvironment(i)),r.push(""),r.push(this.formatProcessList(i,s)),i.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(i))),a.forEach(l=>{if((0,b.isRemoteDiagnosticError)(l))r.push(`
${l.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${l.hostName}`),r.push(this.formatMachineInfo(l.machineInfo)),l.processes&&r.push(this.formatProcessList(i,l.processes)),l.workspaceMetadata)for(const m of Object.keys(l.workspaceMetadata)){const S=l.workspaceMetadata[m];let D=`${S.fileCount} files`;S.maxFilesReached&&(D=`more than ${D}`),r.push(`Folder (${m}): ${D}`),r.push(this.formatWorkspaceStats(S))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(i){const a=[],r=60;let s=0;const l=(R,F)=>{const U=` ${R}(${F})`;s+U.length>r?(a.push(m),m="|                 ",s=m.length):s+=U.length,m+=U};let m="|      File types:";const S=10;let D=i.fileTypes.length>S?S:i.fileTypes.length;for(let R=0;R<D;R++){const F=i.fileTypes[R];l(F.name,F.count)}if(a.push(m),i.configFiles.length>=0&&(m="|      Conf files:",s=0,i.configFiles.forEach(R=>{l(R.name,R.count)}),a.push(m)),i.launchConfigFiles.length>0){let R="|      Launch Configs:";i.launchConfigFiles.forEach(F=>{R+=F.count>1?` ${F.name}(${F.count})`:` ${F.name}`}),a.push(R)}return a.join(`
`)}expandGPUFeatures(i){const a=Math.max(...Object.keys(i).map(r=>r.length));return Object.keys(i).map(r=>`${r}:  ${" ".repeat(a-r.length)}  ${i[r]}`).join(`
                  `)}formatWorkspaceMetadata(i){const a=[],r=[];return i.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(a.push(`|  Window (${s.title})`),s.folderURIs.forEach(l=>{const m=f.URI.revive(l);if(m.scheme===M.Schemas.file){const S=m.fsPath;r.push(P(S,["node_modules",".git"]).then(D=>{let R=`${D.fileCount} files`;D.maxFilesReached&&(R=`more than ${R}`),a.push(`|    Folder (${(0,E.basename)(S)}): ${R}`),a.push(this.formatWorkspaceStats(D))}).catch(D=>{a.push(`|      Error: Unable to collect workspace stats for folder ${S} (${D.toString()})`)}))}else a.push(`|    Folder (${m.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(s=>a.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(i,a){const r=new Map;i.windows.forEach(l=>r.set(l.pid,l.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),a&&this.formatProcessItem(i.mainPID,r,s,a,0),s.join(`
`)}formatProcessItem(i,a,r,s,l){const m=l===0;let S;m?S=s.pid===i?`${this.productService.applicationName} main`:"remote agent":(S=`${"  ".repeat(l)} ${s.name}`,s.name==="window"&&(S=`${S} (${a.get(s.pid)})`));const D=process.platform==="win32"?s.mem:v.totalmem()*(s.mem/100);r.push(`${s.load.toFixed(0).padStart(5," ")}	${(D/y.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${S}`),Array.isArray(s.children)&&s.children.forEach(R=>this.formatProcessItem(i,a,r,R,l+1))}async reportWorkspaceStats(i){for(const{uri:a}of i.folders){const r=f.URI.revive(a);if(r.scheme!==M.Schemas.file)continue;const s=r.fsPath;try{const l=await P(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),l.fileTypes.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:m.name,count:m.count})}),l.launchConfigFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:m.name,count:m.count})}),l.configFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:m.name,count:m.count})})}catch{}}}};o=he([te(0,g.ITelemetryService),te(1,h.IProductService)],o),e.DiagnosticsService=o}),define(Z[199],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(M){this.appender=M}listen(M,E){throw new Error(`Event not found: ${E}`)}call(M,E,{eventName:n,data:f}){return this.appender.log(n,f),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class L{constructor(M){this.channel=M}log(M,E){return this.channel.call("log",{eventName:M,data:E}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(Z[60],x([0,1,9,44,13,16,29]),function(K,e,v,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryConfiguration=e.getTelemetryLevel=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(p,c){return Promise.resolve(void 0)}publicLog2(p,c){return this.publicLog(p,c)}publicLogError(p,c){return Promise.resolve(void 0)}publicLogError2(p,c){return this.publicLogError(p,c)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class n{async publicLog(c,d,o){}async publicLogError(c,d,o){}}e.NullEndpointTelemetryService=n;function f(...p){return{log:(c,d)=>p.forEach(o=>o.log(c,d)),flush:()=>v.Promises.settled(p.map(c=>c.flush()))}}e.combinedAppender=f,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(p,c){return c.onDidChangeConfiguration(d=>{d.source!==6&&p.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(d.source),configurationKeys:g(d.sourceConfig)})})}e.configurationTelemetry=w;function t(p,c){return c.disableTelemetry||!p.enableTelemetry?0:c.isBuilt?2:1}e.getTelemetryLevel=t;function I(p){const c=p.getValue(E.TELEMETRY_SETTING_ID),d=p.getValue(E.TELEMETRY_OLD_SETTING_ID);return d!==void 0&&d===!1?"off":c??"on"}e.getTelemetryConfiguration=I;function b(p){const c=Object.create(null),d=Object.create(null),o=Object.create(null);h(p,o);for(let u in o){u=u.length>150?u.substr(u.length-149):u;const i=o[u];typeof i=="number"?d[u]=i:typeof i=="boolean"?d[u]=i?1:0:typeof i=="string"?c[u]=i.substring(0,1023):typeof i!="undefined"&&i!==null&&(c[u]=i)}return{properties:c,measurements:d}}e.validateTelemetryData=b;function y(p){if(!p)return"none";let c="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(o=>{p.indexOf(`${o}+`)===0&&(c=o)}),c}e.cleanRemoteAuthority=y;function h(p,c,d=0,o){if(!!p)for(let u of Object.getOwnPropertyNames(p)){const i=p[u],a=o?o+u:u;Array.isArray(i)?c[a]=(0,L.safeStringify)(i):i instanceof Date?c[a]=i.toISOString():(0,k.isObject)(i)?d<2?h(i,c,d+1,a+"."):c[a]=(0,L.safeStringify)(i):c[a]=i}}function g(p){if(!p)return[];const c=[];return P(c,"",p),c}function P(p,c,d){d&&typeof d=="object"&&!Array.isArray(d)?Object.keys(d).forEach(o=>P(p,c?`${c}.${o}`:o,d[o])):p.push(c)}}),define(Z[200],x([0,1,32,23,17,44,3,33,7,16,48,168,171,162,20,6,21,50,194,96,29,60]),function(K,e,v,L,k,M,E,n,f,w,t,I,b,y,h,g,P,p,c,d,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=void 0;const i=E.isWeb?"web":(0,I.getTargetPlatform)(E.platform,n.arch);var a;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished"})(a||(a={}));function r(...N){return String(N.reduce((C,q)=>C|q,0))}var s;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const l={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},m={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},D={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class R{constructor(C=D){this.state=C}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(C,q=this.state.pageSize){return new R({...this.state,pageNumber:C,pageSize:q})}withFilter(C,...q){const Q=[...this.state.criteria,...q.length?q.map(ie=>({filterType:C,value:ie})):[{filterType:C}]];return new R({...this.state,criteria:Q})}withSortBy(C){return new R({...this.state,sortBy:C})}withSortOrder(C){return new R({...this.state,sortOrder:C})}withFlags(...C){return new R({...this.state,flags:C.reduce((q,Q)=>q|Q,0)})}withAssetTypes(...C){return new R({...this.state,assetTypes:C})}get raw(){const{criteria:C,pageNumber:q,pageSize:Q,sortBy:ie,sortOrder:oe,flags:ae,assetTypes:ee}=this.state;return{filters:[{criteria:C,pageNumber:q,pageSize:Q,sortBy:ie,sortOrder:oe}],assetTypes:ee,flags:ae}}get searchText(){const C=this.state.criteria.filter(q=>q.filterType===s.SearchText)[0];return C&&C.value?C.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(C=>String(C.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function F(N,C){const q=(N||[]).filter(Q=>Q.statisticName===C)[0];return q?q.value:0}function U(N){const C="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(Q=>Q.assetType.indexOf(C)===0).reduce((Q,ie)=>{const oe=G(N,ie.assetType);return oe&&Q.push([ie.assetType.substring(C.length),oe]),Q},[])}function X(N){if(N.properties){const C=N.properties.filter(ie=>ie.key===l.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Q=C.filter(ie=>q.test(ie.value))[0];return Q?{uri:Q.value,fallbackUri:Q.value}:null}return G(N,l.Repository)}function ne(N){return{uri:`${N.fallbackAssetUri}/${l.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${l.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function se(N){const C=G(N,l.Icon);if(C)return C;const q=I.DefaultIconPath;return{uri:q,fallbackUri:q}}function G(N,C){return N.files.filter(Q=>Q.assetType===C)[0]?{uri:`${N.assetUri}/${C}`,fallbackUri:`${N.fallbackAssetUri}/${C}`}:null}function J(N,C){const q=N.properties?N.properties.filter(ie=>ie.key===C):[],Q=q.length>0&&q[0].value;return Q?Q.split(",").map(ie=>(0,b.adoptToGalleryExtensionId)(ie)):[]}function W(N){const C=N.properties?N.properties.filter(q=>q.key===m.Engine):[];return C.length>0&&C[0].value||""}function V(N){const C=N.properties?N.properties.filter(Q=>Q.key===m.LocalizedLanguages):[],q=C.length>0&&C[0].value||"";return q?q.split(","):[]}function B(N){return N.indexOf("preview")!==-1}function $(N){return N.targetPlatform?(0,I.toTargetPlatform)(N.targetPlatform):"undefined"}function H(N){const C=(0,v.distinct)(N.versions.map($)),q=!!N.tags?.includes(I.WEB_EXTENSION_TAG),Q=C.indexOf("web");return q?Q===-1&&C.push("web"):Q!==-1&&C.splice(Q,1),C}function _(N,C,q,Q){const ie=H(N);let oe=N.versions[0];return oe=N.versions.find(ae=>ae.version===oe.version&&(0,I.isTargetPlatformCompatible)($(ae),ie,i))||oe,j(N,oe,ie,C,q,Q)}function j(N,C,q,Q,ie,oe){const ae={manifest:G(C,l.Manifest),readme:G(C,l.Details),changelog:G(C,l.Changelog),license:G(C,l.License),repository:X(C),download:ne(C),icon:se(C),coreTranslations:U(C)};return{identifier:{id:(0,b.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:C.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,description:N.shortDescription||"",installCount:F(N.statistics,"install"),rating:F(N.statistics,"averagerating"),ratingCount:F(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:q,assets:ae,properties:{dependencies:J(C,m.Dependency),extensionPack:J(C,m.ExtensionPack),engine:W(C),localizedLanguages:V(C),targetPlatform:$(C)},preview:B(N.flags),telemetryData:{index:(ie.pageNumber-1)*ie.pageSize+Q,querySource:oe}}}let T=class{constructor(C,q,Q,ie,oe,ae,ee,le){this.requestService=q,this.logService=Q,this.environmentService=ie,this.telemetryService=oe,this.fileService=ae,this.productService=ee,this.configurationService=le;const me=ee.extensionsGallery;this.extensionsGalleryUrl=me&&me.serviceUrl,this.extensionsControlUrl=me&&me.controlUrl,this.commonHeadersPromise=z(ee.version,ee,this.environmentService,this.configurationService,this.fileService,C)}api(C=""){return`${this.extensionsGalleryUrl}${C}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(C,q){const Q=[];let ie=new R().withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,C.length).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionName,...C.map(({id:ae})=>ae.toLowerCase()));C.every(ae=>!ae.version)&&(ie=ie.withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties,a.IncludeLatestVersionOnly));const{galleryExtensions:oe}=await this.queryGallery(ie,L.CancellationToken.None);for(let ae=0;ae<oe.length;ae++){const ee=oe[ae];if(!ee.versions.length)continue;const le=(0,b.getGalleryExtensionId)(ee.publisher.publisherName,ee.extensionName),me=C.find(ue=>(0,b.areSameExtensions)(ue,{id:le}))?.version;if(me){const ue=ee.versions.find(ve=>ve.version===me);ue&&Q.push(j(ee,ue,H(ee),ae,ie))}else Q.push(_(ee,ae,ie))}return Q}async getCompatibleExtension(C,q){const Q=(0,I.isIExtensionIdentifier)(C)?null:C;if(Q){if((0,I.isNotWebExtensionInWebTargetPlatform)(Q.allTargetPlatforms,q))return null;if(await this.isExtensionCompatible(Q,q))return Q}const{id:ie,uuid:oe}=Q?Q.identifier:C;let ae=new R().withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");oe?ae=ae.withFilter(s.ExtensionId,oe):ae=ae.withFilter(s.ExtensionName,ie);const{galleryExtensions:ee}=await this.queryGallery(ae,L.CancellationToken.None),[le]=ee;if(!le||!le.versions.length)return null;const me=H(le);if((0,I.isNotWebExtensionInWebTargetPlatform)(me,q))return null;for(let ue of le.versions){if(!W(ue)){const ve=await this.getEngine(ue);ue={...ue,properties:[...ue.properties||[],{key:m.Engine,value:ve}]}}if(await this.isRawExtensionVersionCompatible(ue,me,q))return j(le,ue,me,0,ae)}return null}async isExtensionCompatible(C,q){if(!(0,I.isTargetPlatformCompatible)(C.properties.targetPlatform,C.allTargetPlatforms,q))return!1;let Q=C.properties.engine;if(!Q){const ie=await this.getManifest(C,L.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");Q=ie.engines.vscode}return(0,y.isEngineValid)(Q,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(C,q,Q){if(!(0,I.isTargetPlatformCompatible)($(C),q,Q))return!1;const ie=await this.getEngine(C);return(0,y.isEngineValid)(ie,this.productService.version,this.productService.date)}async query(C,q){const Q=L.CancellationToken.isCancellationToken(C)?{}:C,ie=L.CancellationToken.isCancellationToken(C)?C:q;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let oe=Q.text||"";const ae=(0,M.getOrDefault)(Q,Pe=>Pe.pageSize,50);let ee=new R().withFlags(a.IncludeLatestVersionOnly,a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,ae).withFilter(s.Target,"Microsoft.VisualStudio.Code");oe?(oe=oe.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,we,fe)=>(ee=ee.withFilter(s.Category,fe||we),"")),oe=oe.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,we,fe)=>(ee=ee.withFilter(s.Tag,fe||we),"")),oe=oe.replace(/\bfeatured(\s+|\b|$)/g,()=>(ee=ee.withFilter(s.Featured),"")),oe=oe.trim(),oe&&(oe=oe.length<200?oe:oe.substring(0,200),ee=ee.withFilter(s.SearchText,oe)),ee=ee.withSortBy(0)):Q.ids?ee=ee.withFilter(s.ExtensionId,...Q.ids):Q.names?ee=ee.withFilter(s.ExtensionName,...Q.names):ee=ee.withSortBy(4),typeof Q.sortBy=="number"&&(ee=ee.withSortBy(Q.sortBy)),typeof Q.sortOrder=="number"&&(ee=ee.withSortOrder(Q.sortOrder));const{galleryExtensions:le,total:me}=await this.queryGallery(ee,ie),ue=le.map((Pe,we)=>_(Pe,we,ee,Q.source)),ve=async(Pe,we)=>{if(we.isCancellationRequested)throw(0,k.canceled)();const fe=ee.withPage(Pe+1),{galleryExtensions:Ee}=await this.queryGallery(fe,we);return Ee.map((De,Ae)=>_(De,Ae,fe,Q.source))};return{firstPage:ue,total:me,pageSize:ee.pageSize,getPage:ve}}async queryGallery(C,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");C=C.withFlags(C.flags,a.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,r(a.Unpublished));const Q=await this.commonHeadersPromise,ie=JSON.stringify(C.raw),oe={...Q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ie.length)},ae=new Date().getTime();let ee,le,me=0;try{if(ee=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ie,headers:oe},q),ee.res.statusCode&&ee.res.statusCode>=400&&ee.res.statusCode<500)return{galleryExtensions:[],total:me};const ue=await(0,p.asJson)(ee);if(ue){const ve=ue.results[0],Pe=ve.extensions,we=ve.resultMetadata&&ve.resultMetadata.filter(fe=>fe.metadataType==="ResultCount")[0];return me=we&&we.metadataItems.filter(fe=>fe.name==="TotalCount")[0].count||0,{galleryExtensions:Pe,total:me}}return{galleryExtensions:[],total:me}}catch(ue){throw le=ue,ue}finally{this.telemetryService.publicLog2("galleryService:query",{...C.telemetryData,requestBodySize:String(ie.length),duration:new Date().getTime()-ae,success:!!ee&&(0,p.isSuccess)(ee),responseBodySize:ee?.res.headers["Content-Length"],statusCode:ee?String(ee.res.statusCode):void 0,errorCode:le?(0,k.isPromiseCanceledError)(le)?"canceled":(0,k.getErrorMessage)(le).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(me)})}}async reportStatistic(C,q,Q,ie){if(!this.isEnabled())return;const oe=E.isWeb?this.api(`/itemName/${C}.${q}/version/${Q}/statType/${ie==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${C}/extensions/${q}/${Q}/stats?statType=${ie}`),ae=E.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",le={...await this.commonHeadersPromise,Accept:ae};try{await this.requestService.request({type:"POST",url:oe,headers:le},L.CancellationToken.None)}catch(me){}}async download(C,q,Q){this.logService.trace("ExtensionGalleryService#download",C.identifier.id);const ie=(0,b.getGalleryExtensionTelemetryData)(C),oe=new Date().getTime(),ae=ue=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ie,duration:ue}),ee=Q===1?"install":Q===2?"update":"",le=ee?{uri:`${C.assets.download.uri}${f.URI.parse(C.assets.download.uri).query?"&":"?"}${ee}=true`,fallbackUri:`${C.assets.download.fallbackUri}${f.URI.parse(C.assets.download.fallbackUri).query?"&":"?"}${ee}=true`}:C.assets.download,me=await this.getAsset(le);await this.fileService.writeFile(q,me.stream),ae(new Date().getTime()-oe)}async getReadme(C,q){if(C.assets.readme){const Q=await this.getAsset(C.assets.readme,{},q);return await(0,p.asText)(Q)||""}return""}async getManifest(C,q){if(C.assets.manifest){const Q=await this.getAsset(C.assets.manifest,{},q),ie=await(0,p.asText)(Q);return ie?JSON.parse(ie):null}return null}async getManifestFromRawExtensionVersion(C,q){const Q=G(C,l.Manifest);if(!Q)throw new Error("Manifest was not found");const ie={"Accept-Encoding":"gzip"},oe=await this.getAsset(Q,{headers:ie});return await(0,p.asJson)(oe)}async getCoreTranslation(C,q){const Q=C.assets.coreTranslations.filter(ie=>ie[0]===q.toUpperCase())[0];if(Q){const ie=await this.getAsset(Q[1]),oe=await(0,p.asText)(ie);return oe?JSON.parse(oe):null}return null}async getChangelog(C,q){if(C.assets.changelog){const Q=await this.getAsset(C.assets.changelog,{},q);return await(0,p.asText)(Q)||""}return""}async getAllCompatibleVersions(C,q){let Q=new R().withFlags(a.IncludeVersions,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");C.identifier.uuid?Q=Q.withFilter(s.ExtensionId,C.identifier.uuid):Q=Q.withFilter(s.ExtensionName,C.identifier.id);const{galleryExtensions:ie}=await this.queryGallery(Q,L.CancellationToken.None);if(!ie.length)return[];const oe=H(ie[0]);if((0,I.isNotWebExtensionInWebTargetPlatform)(oe,q))return[];const ae=[];for(const ee of ie[0].versions)try{await this.isRawExtensionVersionCompatible(ee,oe,q)&&ae.push({version:ee.version,date:ee.lastUpdated})}catch(le){}return ae}async getAsset(C,q={},Q=L.CancellationToken.None){const ie=await this.commonHeadersPromise,oe={type:"GET"},ae={...ie,...q.headers||{}};q={...q,...oe,headers:ae};const ee=C.uri,le=C.fallbackUri,me={...q,url:ee};try{const ue=await this.requestService.request(me,Q);if(ue.res.statusCode===200)return ue;const ve=await(0,p.asText)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${ve}`)}catch(ue){if((0,k.isPromiseCanceledError)(ue))throw ue;const ve=(0,k.getErrorMessage)(ue);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ee,message:ve});const Pe={...q,url:le};return this.requestService.request(Pe,Q)}}async getEngine(C){let q=W(C);if(!q){const Q=await this.getManifestFromRawExtensionVersion(C,L.CancellationToken.None);if(!Q)throw new Error("Manifest was not found");q=Q.engines.vscode}return q}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const C=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(C.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,p.asJson)(C),Q=new Map;if(q)for(const ie of q.malicious){const oe=Q.get(ie)||{id:{id:ie},malicious:!0,slow:!1};oe.malicious=!0,Q.set(ie,oe)}return[...Q.values()]}};T=he([te(1,p.IRequestService),te(2,g.ILogService),te(3,t.IEnvironmentService),te(4,o.ITelemetryService),te(5,h.IFileService),te(6,P.IProductService),te(7,w.IConfigurationService)],T);let A=class extends T{constructor(C,q,Q,ie,oe,ae,ee,le){super(C,q,Q,ie,oe,ae,ee,le)}};A=he([te(0,d.IStorageService),te(1,p.IRequestService),te(2,g.ILogService),te(3,t.IEnvironmentService),te(4,o.ITelemetryService),te(5,h.IFileService),te(6,P.IProductService),te(7,w.IConfigurationService)],A),e.ExtensionGalleryService=A;let O=class extends T{constructor(C,q,Q,ie,oe,ae,ee){super(void 0,C,q,Q,ie,oe,ae,ee)}};O=he([te(0,p.IRequestService),te(1,g.ILogService),te(2,t.IEnvironmentService),te(3,o.ITelemetryService),te(4,h.IFileService),te(5,P.IProductService),te(6,w.IConfigurationService)],O),e.ExtensionGalleryServiceWithNoStorageService=O;async function z(N,C,q,Q,ie,oe){const ae={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N}`},ee=await(0,c.getServiceMachineId)(q,ie,oe);return(0,u.getTelemetryLevel)(C,q)>=2&&(0,u.getTelemetryConfiguration)(Q)==="on"&&(ae["X-Market-User-Id"]=ee),ae}e.resolveMarketplaceHeaders=z}),define(Z[201],x([0,1,2,44,25,147,16,49,45,38,29,60]),function(K,e,v,L,k,M,E,n,f,w,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let b=class{constructor(h,g){this._configurationService=g,this._experimentProperties={},this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appender=h.appender,this._commonProperties=h.commonProperties||Promise.resolve({}),this._piiPaths=h.piiPaths||[],this._userOptIn=!0,this._errorOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(P),"gi"));this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(P=>{const p=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!p})})}setExperimentProperty(h,g){this._experimentProperties[h]=g}setEnabled(h){this._enabled=h}_updateUserOptIn(){const h=(0,I.getTelemetryConfiguration)(this._configurationService);this._errorOptIn=h!=="off",this._userOptIn=h==="on"}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const h=await this._commonProperties;let g=h.sessionID,P=h["common.instanceId"],p=h["common.machineId"],c=h["common.firstSessionDate"],d=h["common.msftInternal"];return{sessionId:g,instanceId:P,machineId:p,firstSessionDate:c,msftInternal:d}}dispose(){this._disposables.dispose()}publicLog(h,g,P){return this.isOptedIn?this._commonProperties.then(p=>{g=(0,L.mixin)(g,p),g=(0,L.mixin)(g,this._experimentProperties),g=(0,L.cloneAndChange)(g,c=>{if(typeof c=="string")return this._cleanupInfo(c,P)}),this._appender.log(h,g)},p=>{console.error(p)}):Promise.resolve(void 0)}publicLog2(h,g,P){return this.publicLog(h,g,P)}publicLogError(h,g){return!this.sendErrorTelemetry||!this._errorOptIn?Promise.resolve(void 0):this.publicLog(h,g,!0)}publicLogError2(h,g){return this.publicLogError(h,g)}_anonymizeFilePaths(h){let g=h;const P=[];for(let o of this._cleanupPatterns)for(;;){const u=o.exec(h);if(!u)break;P.push([u.index,o.lastIndex])}const p=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let d=0;for(g="";;){const o=c.exec(h);if(!o)break;!p.test(o[0])&&P.every(([u,i])=>o.index<u||o.index>=i)&&(g+=h.substring(d,o.index)+"<REDACTED: user-file-path>",d=c.lastIndex)}return d<h.length&&(g+=h.substr(d)),g}_removePropertiesWithPossibleUserInfo(h){if(!h)return h;const g=h.toLowerCase(),P=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(g)?"<REDACTED: secret>":P.test(g)?"<REDACTED: email>":h}_cleanupInfo(h,g){let P=h;g&&(P=this._anonymizeFilePaths(P));for(let p of this._cleanupPatterns)P=P.replace(p,"");return P=this._removePropertiesWithPossibleUserInfo(P),P}};b.IDLE_START_EVENT_NAME="UserIdleStart",b.IDLE_STOP_EVENT_NAME="UserIdleStop",b=he([te(1,E.IConfigurationService)],b),e.TelemetryService=b,w.Registry.as(n.Extensions.Configuration).registerConfiguration({id:t.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,M.localize)(0,null),properties:{[t.TELEMETRY_SETTING_ID]:{type:"string",enum:["on","error","off"],enumDescriptions:[(0,M.localize)(1,null),(0,M.localize)(2,null),(0,M.localize)(3,null)],markdownDescription:f.default.privacyStatementUrl?(0,M.localize)(5,null,f.default.nameLong,f.default.privacyStatementUrl):(0,M.localize)(4,null,f.default.nameLong),default:"on",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.Registry.as(n.Extensions.Configuration).registerConfiguration({id:t.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,M.localize)(6,null),properties:{[t.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:f.default.privacyStatementUrl?(0,M.localize)(8,null,f.default.nameLong,f.default.privacyStatementUrl):(0,M.localize)(7,null,f.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,M.localize)(9,null,`\`#${t.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[202],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(Z[203],x([0,1,108,4,2,5,38,202]),function(K,e,v,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var f;(function(P){function p(c){return c&&typeof c=="object"&&typeof c.id=="string"}P.isThemeColor=p})(f=e.ThemeColor||(e.ThemeColor={}));function w(P){return{id:P}}e.themeColorFromId=w;var t;(function(P){function p(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color=="undefined"||f.isThemeColor(a.color))}P.isThemeIcon=p;const c=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function d(a){const r=c.exec(a);if(!r)return;let[,s]=r;return{id:s}}P.fromString=d;function o(a,r){let s=a.id;const l=s.lastIndexOf("~");return l!==-1&&(s=s.substring(0,l)),r&&(s=`${s}~${r}`),{id:s}}P.modify=o;function u(a,r){return a.id===r.id&&a.color?.id===r.color?.id}P.isEqual=u;function i(a,r){return{id:a.id,color:r?w(r):void 0}}P.asThemeIcon=i,P.asClassNameArray=v.CSSIcon.asClassNameArray,P.asClassName=v.CSSIcon.asClassName,P.asCSSSelector=v.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=v.Codicon.file,e.FolderThemeIcon=v.Codicon.folder;function I(P){switch(P){case n.ColorScheme.DARK:return"vs-dark";case n.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class b{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,k.toDisposable)(()=>{const c=this.themingParticipants.indexOf(p);this.themingParticipants.splice(c,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let y=new b;E.Registry.add(e.Extensions.ThemingContribution,y);function h(P){return y.onColorThemeChange(P)}e.registerThemingParticipant=h;class g extends k.Disposable{constructor(p){super();this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(c=>this.onThemeChange(c)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,c){let d=this.theme.getColor(p);return d&&c&&(d=c(d,this.theme)),d?d.toString():null}}e.Themable=g}),define(Z[61],x([0,1,14,3,5,39]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const E="#FFFFFF",n="#1E1E1E",f="#000000",w="theme",t="themeBackground",I="windowSplash";e.IThemeMainService=(0,k.createDecorator)("themeMainService");let b=class{constructor(h){this.stateMainService=h}getBackgroundColor(){if((L.isWindows||L.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme)return f;let h=this.stateMainService.getItem(t,null);if(!h){let g;(L.isWindows||L.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme?g="hc-black":g=this.stateMainService.getItem(w,"vs-dark").split(" ")[0],h=g==="hc-black"?f:g==="vs"?E:n}return L.isMacintosh&&h.toUpperCase()===n&&(h="#171717"),h}saveWindowSplash(h,g){this.stateMainService.setItems([{key:w,data:g.baseTheme},{key:t,data:g.colorInfo.background},{key:I,data:g}]),typeof h=="number"&&this.updateBackgroundColor(h,g)}updateBackgroundColor(h,g){for(const P of v.BrowserWindow.getAllWindows())if(P.id===h){P.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(I)}};b=he([te(0,M.IStateMainService)],b),e.ThemeMainService=b}),define(Z[42],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(L=e.StateType||(e.StateType={}));var k;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(M,E)=>({type:"idle",updateType:M,error:E}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(Z[204],x([0,1,3,148,49,38]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:v.isWindows&&!v.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[205],x([0,1,4,42]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(n){this.service=n}listen(n,f){switch(f){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${f}`)}call(n,f,w){switch(f){case"checkForUpdates":return this.service.checkForUpdates(w);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=k;class M{constructor(n){this.channel=n,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(f=>this.state=f),this.channel.call("_getInitialState").then(f=>this.state=f)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=M}),define(Z[97],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(Z[206],x([0,1,7]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(n){this.handler=n}listen(n,f){throw new Error(`Event not found: ${f}`)}call(n,f,w){switch(f){case"handleURL":return this.handler.handleURL(v.URI.revive(w[0]),w[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=L;class k{constructor(n){this.channel=n}handleURL(n,f){return this.channel.call("handleURL",[n.toJSON(),f])}}e.URLHandlerChannelClient=k;class M{constructor(n){this.next=n}async routeCall(n,f,w,t){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(w){const I=v.URI.revive(w);if(I&&I.query){const b=/\bwindowId=(\d+)/.exec(I.query);if(b){const y=b[1],h=new RegExp(`window:${y}`),g=n.connections.find(P=>h.test(P.ctx));if(g)return g}}}return this.next.routeCall(n,f,w,t)}routeEvent(n,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=M}),define(Z[207],x([0,1,9,2,7,21]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class E extends L.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(w,t){const I=[...this.handlers.values()];return(0,v.first)(I.map(b=>()=>b.handleURL(w,t)),void 0,!1).then(b=>b||!1)}registerHandler(w){return this.handlers.add(w),(0,L.toDisposable)(()=>this.handlers.delete(w))}}e.AbstractURLService=E;let n=class extends E{constructor(w){super();this.productService=w}create(w){let{authority:t,path:I,query:b,fragment:y}=w||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return t&&I&&I.indexOf("/")!==0&&(I=`/${I}`),k.URI.from({scheme:this.productService.urlProtocol,authority:t,path:I,query:b,fragment:y})}};n=he([te(0,M.IProductService)],n),e.NativeURLService=n}),define(Z[208],x([0,1,14,9,4,2,3,7]),function(K,e,v,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function f(t){try{return n.URI.parse(t)}catch(I){return null}}class w{constructor(I,b,y,h,g){if(this.urlService=b,this.uris=[],this.retryCount=0,this.flushDisposable=M.Disposable.None,this.disposables=new M.DisposableStore,this.uris=I,E.isWindows){const c=h.isBuilt?[]:[`"${h.appRoot}"`];c.push("--open-url","--"),v.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,c)}const P=k.Event.map(k.Event.fromNodeEventEmitter(v.app,"open-url",(c,d)=>({event:c,url:d})),({event:c,url:d})=>(c.preventDefault(),d));this.disposables.add(P(c=>{const d=f(c);!d||this.urlService.open(d,{originalUrl:c})})),y.getWindows().filter(c=>c.isReady).length>0?this.flush():k.Event.once(y.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const I=[];for(const b of this.uris)await this.urlService.open(b.uri,{originalUrl:b.url})||I.push(b);I.length!==0&&(this.uris=I,this.flushDisposable=(0,L.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=w}),define(Z[209],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService")}),define(Z[210],x([0,1,14,2,10,7]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class E extends L.Disposable{constructor(){super();const f=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(k.Schemas.vscodeWebview,f)}handleWebviewRequest(f,w){try{const t=M.URI.parse(f.url),I=E.validWebviewFilePaths.get(t.path);if(typeof I=="string"){const b=`vs/workbench/contrib/webview/browser/pre/${I}`,y=k.FileAccess.asFileUri(b,K);return w(decodeURIComponent(y.fsPath))}else return w({error:-10})}catch{}return w({error:-2})}}e.WebviewProtocolProvider=E,E.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Z[62],x([0,1,3]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(w){return!!w.workspaceUri}e.isWorkspaceToOpen=L;function k(w){return!!w.folderUri}e.isFolderToOpen=k;function M(w){return!!w.fileUri}e.isFileToOpen=M;function E(w){const t=n(w),I=w.getValue("window.menuBarVisibility");return I==="default"||t==="native"&&I==="compact"||v.isMacintosh&&v.isNative?"classic":I}e.getMenuBarVisibility=E;function n(w){if(v.isWeb)return"custom";const t=w.getValue("window");if(t){if(v.isMacintosh&&t.nativeTabs===!0||v.isMacintosh&&t.nativeFullScreen===!1)return"native";const y=t.titleBarStyle;if(y==="native"||y==="custom")return y}return v.isLinux?"native":"custom"}e.getTitleBarStyle=n;function f(w=0){return Math.pow(1.2,w)}e.zoomLevelToZoomFactor=f}),define(Z[36],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var L;(function(w){w[w.INITIAL=1]="INITIAL",w[w.LOAD=2]="LOAD",w[w.RELOAD=3]="RELOAD"})(L=e.LoadReason||(e.LoadReason={}));var k;(function(w){w[w.CLOSE=1]="CLOSE",w[w.QUIT=2]="QUIT",w[w.RELOAD=3]="RELOAD",w[w.LOAD=4]="LOAD"})(k=e.UnloadReason||(e.UnloadReason={}));var M;(function(w){w[w.CLI=0]="CLI",w[w.DOCK=1]="DOCK",w[w.MENU=2]="MENU",w[w.DIALOG=3]="DIALOG",w[w.DESKTOP=4]="DESKTOP",w[w.API=5]="API"})(M=e.OpenContext||(e.OpenContext={}));const E=function(w=1){return{width:1024,height:768,mode:w}};e.defaultWindowState=E;var n;(function(w){w[w.Maximized=0]="Maximized",w[w.Normal=1]="Normal",w[w.Minimized=2]="Minimized",w[w.Fullscreen=3]="Fullscreen"})(n=e.WindowMode||(e.WindowMode={}));var f;(function(w){w[w.UNRESPONSIVE=1]="UNRESPONSIVE",w[w.CRASHED=2]="CRASHED",w[w.LOAD=3]="LOAD"})(f=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,v.createDecorator)("windowsMainService")}),define(Z[211],x([0,1,14,4,2,210,36]),function(K,e,v,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let n=class extends k.Disposable{constructor(w){super();this.windowsMainService=w,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new M.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(w,t){let I;if(typeof w.windowId=="number"){const{windowId:b}=w,y=this.windowsMainService.getWindowById(b);if(!y?.win)throw new Error(`Invalid windowId: ${b}`);I=y.win.webContents}else{const{webContentsId:b}=w;if(I=v.webContents.fromId(b),!I)throw new Error(`Invalid webContentsId: ${b}`)}I.isDestroyed()||I.setIgnoreMenuShortcuts(t)}async findInFrame(w,t,I,b){const y=this.getFrameByName(w,t),h=y;if(typeof h.findInFrame=="function"){h.findInFrame(I,{findNext:b.findNext,forward:b.forward});const g=(P,p)=>{p.finalUpdate&&(this._onFoundInFrame.fire(p),y.removeListener("found-in-frame",g))};y.on("found-in-frame",g)}}async stopFindInFrame(w,t,I){const y=this.getFrameByName(w,t);typeof y.stopFindInFrame=="function"&&y.stopFindInFrame(I.keepSelection?"keepSelection":"clearSelection")}getFrameByName(w,t){const I=this.windowsMainService.getWindowById(w.windowId);if(!I?.win)throw new Error(`Invalid windowId: ${w}`);const b=I.win.webContents.mainFrame.framesInSubtree.find(y=>y.name===t);if(!b)throw new Error(`Unknown frame: ${t}`);return b}};n=he([te(0,E.IWindowsMainService)],n),e.WebviewMainService=n}),define(Z[212],x([0,1,9,4,2]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class M extends k.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:f,getActiveWindowId:w}){super();this.disposables=this._register(new k.DisposableStore),L.Event.latch(L.Event.any(n,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,v.createCancelablePromise)(()=>w()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch(I){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=M}),define(Z[213],x([0,1,37,15,7,5]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,M.createDecorator)("contextService");var E;(function(b){b[b.EMPTY=1]="EMPTY",b[b.FOLDER=2]="FOLDER",b[b.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function n(b){const y=b;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.isWorkspace=n;function f(b){const y=b;return!!(y&&typeof y=="object"&&k.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.isWorkspaceFolder=f;class w{constructor(y,h,g,P){this._id=y,this._configuration=g,this._ignorePathCasing=P,this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=h}update(y){this._id=y.id,this._configuration=y.configuration,this._ignorePathCasing=y._ignorePathCasing,this.folders=y.folders}get folders(){return this._folders}set folders(y){this._folders=y,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(y){this._configuration=y}getFolder(y){return y&&this._foldersMap.findSubstr(y.with({scheme:y.scheme,authority:y.authority,path:y.path}))||null}updateFoldersMap(){this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing);for(const y of this.folders)this._foldersMap.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=w;class t{constructor(y,h){this.raw=h,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return(0,L.joinPath)(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function I(b){return new t({uri:b,index:0,name:(0,L.basenameOrAuthority)(b)},{uri:b.toString()})}e.toWorkspaceFolder=I}),define(Z[27],x([0,1,30,40,77,34,10,8,3,15,7,151,5,74,213]),function(K,e,v,L,k,M,E,n,f,w,t,I,b,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function P(W){return(typeof W=="string"?(0,n.extname)(W):(0,w.extname)(W))===g}e.hasWorkspaceFileExtension=P,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function p(W){return W.hasOwnProperty("workspace")}e.isRecentWorkspace=p;function c(W){return W.hasOwnProperty("folderUri")}e.isRecentFolder=c;function d(W){return W.hasOwnProperty("fileUri")}e.isRecentFile=d;function o(W){const V=W;return typeof V?.id=="string"&&t.URI.isUri(V.uri)}e.isSingleFolderWorkspaceIdentifier=o;function u(W){if(W.configuration)return{id:W.id,configPath:W.configuration};if(W.folders.length===1)return{id:W.id,uri:W.folders[0].uri}}e.toWorkspaceIdentifier=u;function i(W){const V=W;return typeof V?.id=="string"&&t.URI.isUri(V.configPath)}e.isWorkspaceIdentifier=i;function a(W){const V=W;if(V?.uri)return{id:V.id,uri:t.URI.revive(V.uri)};const B=W;if(B?.configPath)return{id:B.id,configPath:t.URI.revive(B.configPath)};if(W?.id)return{id:W.id}}e.reviveIdentifier=a;function r(W,V){return w.extUriBiasedIgnorePathCase.isEqualOrParent(W,V.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function s(W){return l(W)||m(W)}e.isStoredWorkspaceFolder=s;function l(W){const V=W;return typeof V?.path=="string"&&(!V.name||typeof V.name=="string")}e.isRawFileWorkspaceFolder=l;function m(W){const V=W;return typeof V?.uri=="string"&&(!V.name||typeof V.name=="string")}e.isRawUriWorkspaceFolder=m;function S(W,V,B,$,H=!f.isWindows,_){if(W.scheme!==$.scheme)return{name:B,uri:W.toString(!0)};let j=V?void 0:_.relativePath($,W);if(j!==void 0)j.length===0?j=".":f.isWindows&&W.scheme===E.Schemas.file&&!H&&(j=j.replace(/\//g,"\\"));else if(W.scheme===E.Schemas.file)j=W.fsPath,f.isWindows&&(j=(0,M.normalizeDriveLetter)(j),H&&(j=(0,v.toSlashes)(j)));else{if(!_.isEqualAuthority(W.authority,$.authority))return{name:B,uri:W.toString(!0)};j=W.path}return{name:B,path:j}}e.getStoredWorkspaceFolder=S;function D(W,V,B){let $=[],H=new Set;const _=B.dirname(V);for(let j of W){let T;if(l(j))j.path&&(T=B.resolvePath(_,j.path));else if(m(j))try{T=t.URI.parse(j.uri),T.path[0]!=="/"&&(T=T.with({path:"/"+T.path}))}catch(A){console.warn(A)}if(T){let A=B.getComparisonKey(T);if(!H.has(A)){H.add(A);const O=j.name||B.basenameOrAuthority(T);$.push(new h.WorkspaceFolder({uri:T,name:O,index:$.length},j))}}}return $}e.toWorkspaceFolders=D;function R(W,V,B,$,H){let _=F(V,W);const j=H.dirname(V),T=H.dirname($),A=[],O=U(_.folders);for(const q of _.folders){const Q=l(q)?H.resolvePath(j,q.path):t.URI.parse(q.uri);let ie;B?ie=!1:ie=!l(q)||(0,n.isAbsolute)(q.path),A.push(S(Q,ie,q.name,T,O,H))}const z={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},N=k.setProperty(W,["folders"],A,z);let C=k.applyEdits(W,N);return _.remoteAuthority===(0,y.getRemoteAuthority)($)&&(C=k.applyEdits(C,k.removeProperty(C,["remoteAuthority"],z))),C}e.rewriteWorkspaceFileForNewLocation=R;function F(W,V){let B=L.parse(V);if(B&&Array.isArray(B.folders))B.folders=B.folders.filter($=>s($));else throw new Error(`${W} looks like an invalid workspace file.`);return B}function U(W){return f.isWindows?W.some(V=>l(V)&&V.path.indexOf("/")>=0):!0}e.useSlashForPath=U;function X(W){return W.workspace&&typeof W.workspace=="object"&&typeof W.workspace.id=="string"&&typeof W.workspace.configPath=="string"}function ne(W){return typeof W.folderUri=="string"}function se(W){return typeof W.fileUri=="string"}function G(W,V){const B={workspaces:[],files:[]};if(W){const $=function(_,j){for(let T=0;T<_.length;T++)try{j(_[T],T)}catch(A){V.warn(`Error restoring recent entry ${JSON.stringify(_[T])}: ${A.toString()}. Skip entry.`)}},H=W;if(Array.isArray(H.entries))$(H.entries,_=>{const j=_.label,T=_.remoteAuthority;X(_)?B.workspaces.push({label:j,remoteAuthority:T,workspace:{id:_.workspace.id,configPath:t.URI.parse(_.workspace.configPath)}}):ne(_)?B.workspaces.push({label:j,remoteAuthority:T,folderUri:t.URI.parse(_.folderUri)}):se(_)&&B.files.push({label:j,remoteAuthority:T,fileUri:t.URI.parse(_.fileUri)})});else{const _=W;Array.isArray(_.workspaces3)&&$(_.workspaces3,(j,T)=>{const A=Array.isArray(_.workspaceLabels)&&_.workspaceLabels[T]||void 0;typeof j=="object"&&typeof j.id=="string"&&typeof j.configURIPath=="string"?B.workspaces.push({label:A,workspace:{id:j.id,configPath:t.URI.parse(j.configURIPath)}}):typeof j=="string"&&B.workspaces.push({label:A,folderUri:t.URI.parse(j)})}),Array.isArray(_.files2)&&$(_.files2,(j,T)=>{const A=Array.isArray(_.fileLabels)&&_.fileLabels[T]||void 0;typeof j=="string"&&B.files.push({label:A,fileUri:t.URI.parse(j)})})}}return B}e.restoreRecentlyOpened=G;function J(W){const V={entries:[]};for(const B of W.workspaces)c(B)?V.entries.push({folderUri:B.folderUri.toString(),label:B.label,remoteAuthority:B.remoteAuthority}):V.entries.push({workspace:{id:B.workspace.id,configPath:B.workspace.configPath.toString()},label:B.label,remoteAuthority:B.remoteAuthority});for(const B of W.files)V.entries.push({fileUri:B.fileUri.toString(),label:B.label,remoteAuthority:B.remoteAuthority});return V}e.toStoreData=J}),define(Z[51],x([0,1,5,27]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService");function k(M){const E=M;return E&&(0,L.isWorkspaceIdentifier)(E.workspace)}e.isWorkspaceBackupInfo=k}),define(Z[52],x([0,1,14,9,79,34,2,66,8,3,13,19,133,5,39,27]),function(K,e,v,L,k,M,E,n,f,w,t,I,b,y,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,y.createDecorator)("dialogMainService");let P=class gt{constructor(c){this.stateMainService=c,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(c,d){return this.doPick({...c,pickFolders:!0,pickFiles:!0,title:(0,b.localize)(0,null)},d)}pickFolder(c,d){return this.doPick({...c,pickFolders:!0,title:(0,b.localize)(1,null)},d)}pickFile(c,d){return this.doPick({...c,pickFiles:!0,title:(0,b.localize)(2,null)},d)}pickWorkspace(c,d){const o=(0,b.localize)(3,null),u=(0,M.mnemonicButtonLabel)((0,b.localize)(4,null)),i=g.WORKSPACE_FILTER;return this.doPick({...c,pickFiles:!0,title:o,filters:i,buttonLabel:u},d)}async doPick(c,d){const o={title:c.title,buttonLabel:c.buttonLabel,filters:c.filters};o.defaultPath=c.defaultPath||this.stateMainService.getItem(gt.workingDirPickerStorageKey),(typeof c.pickFiles=="boolean"||typeof c.pickFolders=="boolean")&&(o.properties=void 0,c.pickFiles&&c.pickFolders&&(o.properties=["multiSelections","openDirectory","openFile","createDirectory"])),o.properties||(o.properties=["multiSelections",c.pickFolders?"openDirectory":"openFile","createDirectory"]),w.isMacintosh&&o.properties.push("treatPackageAsDirectory");const u=d||v.BrowserWindow.getFocusedWindow(),i=await this.showOpenDialog(o,(0,t.withNullAsUndefined)(u));if(i&&i.filePaths&&i.filePaths.length>0)return this.stateMainService.setItem(gt.workingDirPickerStorageKey,(0,f.dirname)(i.filePaths[0])),i.filePaths}getWindowDialogQueue(c){if(c){let d=this.windowDialogQueues.get(c.id);return d||(d=new L.Queue,this.windowDialogQueues.set(c.id,d)),d}else return this.noWindowDialogueQueue}showMessageBox(c,d){return this.getWindowDialogQueue(d).queue(async()=>d?v.dialog.showMessageBox(d,c):v.dialog.showMessageBox(c))}async showSaveDialog(c,d){const o=this.acquireFileDialogLock(c,d);if(!o)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(d).queue(async()=>{let u;return d?u=await v.dialog.showSaveDialog(d,c):u=await v.dialog.showSaveDialog(c),u.filePath=this.normalizePath(u.filePath),u})}finally{(0,E.dispose)(o)}}normalizePath(c){return c&&w.isMacintosh&&(c=(0,n.normalizeNFC)(c)),c}normalizePaths(c){return c.map(d=>this.normalizePath(d))}async showOpenDialog(c,d){c.defaultPath&&(await I.Promises.exists(c.defaultPath)||(c.defaultPath=void 0));const o=this.acquireFileDialogLock(c,d);if(!o)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(d).queue(async()=>{let u;return d?u=await v.dialog.showOpenDialog(d,c):u=await v.dialog.showOpenDialog(c),u.filePaths=this.normalizePaths(u.filePaths),u})}finally{(0,E.dispose)(o)}}acquireFileDialogLock(c,d){if(!d)return E.Disposable.None;let o=this.windowFileDialogLocks.get(d.id);o||(o=new Set,this.windowFileDialogLocks.set(d.id,o));const u=(0,k.hash)(c);if(!o.has(u))return o.add(u),(0,E.toDisposable)(()=>{o?.delete(u),o?.size===0&&this.windowFileDialogLocks.delete(d.id)})}};P.workingDirPickerStorageKey="pickerWorkingDir",P=he([te(0,h.IStateMainService)],P),e.DialogMainService=P}),define(Z[214],x([0,1,4,2,27]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends L.Disposable{constructor(n,f){super();this.logService=n,this.storageMainService=f,this._onDidChangeGlobalStorage=this._register(new v.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(v.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,f)=>(n?n.push(f):n=[f],n),M.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const f=new Map,w=new Set;return n.forEach(t=>{const I=this.storageMainService.globalStorage.get(t.key);typeof I=="string"?f.set(t.key,I):w.add(t.key)}),{changed:Array.from(f.entries()),deleted:Array.from(w.values())}}listen(n,f){switch(f){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${f}`)}async call(n,f,w){const t=(0,k.reviveIdentifier)(w.workspace),I=await this.withStorageInitialized(t);switch(f){case"getItems":return Array.from(I.items.entries());case"updateItems":{const b=w;if(b.insert)for(const[y,h]of b.insert)I.set(y,h);b.delete&&b.delete.forEach(y=>I.delete(y));break}case"close":{if(t)return I.close();break}default:throw new Error(`Call not found: ${f}`)}}async withStorageInitialized(n){const f=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await f.init()}catch(w){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${w}`)}return f}}e.StorageDatabaseChannel=M,M.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[215],x([0,1,4,2,8,28,19,85,123,6,96,29,27]),function(K,e,v,L,k,M,E,n,f,w,t,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class y extends L.Disposable{constructor(p){super();this.logService=p,this._onDidChangeStorage=this._register(new v.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new v.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const p=await this.doCreate();this.storage.dispose(),this.storage=p,this._register(p.onDidChangeStorage(d=>this._onDidChangeStorage.fire({key:d}))),await this.doInit(p);const c=p.getBoolean(t.IS_NEW_KEY);c===void 0?p.set(t.IS_NEW_KEY,!0):c&&p.set(t.IS_NEW_KEY,!1)}catch(p){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${p}`)}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===w.LogLevel.Trace?p=>this.logService.trace(p):void 0,logError:p=>this.logService.error(p)}}doInit(p){return p.init()}get items(){return this.storage.items}get(p,c){return this.storage.get(p,c)}set(p,c){return this.storage.set(p,c)}delete(p){return this.storage.delete(p)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class h extends y{constructor(p,c,d){super(c);this.options=p,this.environmentService=d}async doCreate(){let p;return this.options.useInMemoryStorage?p=f.SQLiteStorageDatabase.IN_MEMORY_PATH:p=(0,k.join)(this.environmentService.globalStorageHome.fsPath,h.STORAGE_NAME),new n.Storage(new f.SQLiteStorageDatabase(p,{logging:this.createLoggingOptions()}))}async doInit(p){await super.doInit(p),this.updateTelemetryState(p)}updateTelemetryState(p){p.get(I.instanceStorageKey,void 0)===void 0&&p.set(I.instanceStorageKey,(0,M.generateUuid)()),p.get(I.firstSessionDateStorageKey,void 0)===void 0&&p.set(I.firstSessionDateStorageKey,new Date().toUTCString());const o=p.get(I.currentSessionDateStorageKey,void 0),u=new Date().toUTCString();p.set(I.lastSessionDateStorageKey,typeof o=="undefined"?null:o),p.set(I.currentSessionDateStorageKey,u)}}e.GlobalStorageMain=h,h.STORAGE_NAME="state.vscdb";class g extends y{constructor(p,c,d,o){super(d);this.workspace=p,this.options=c,this.environmentService=o}async doCreate(){const{storageFilePath:p,wasCreated:c}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new f.SQLiteStorageDatabase(p,{logging:this.createLoggingOptions()}),{hint:c?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:f.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const p=(0,k.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),c=(0,k.join)(p,g.WORKSPACE_STORAGE_NAME);return await E.Promises.exists(p)?{storageFilePath:c,wasCreated:!1}:(await E.Promises.mkdir(p,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(p),{storageFilePath:c,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(p){let c;if((0,b.isSingleFolderWorkspaceIdentifier)(this.workspace)?c={folder:this.workspace.uri.toString()}:(0,b.isWorkspaceIdentifier)(this.workspace)&&(c={workspace:this.workspace.configPath.toString()}),c)try{const d=(0,k.join)(p,g.WORKSPACE_META_NAME);await E.Promises.exists(d)||await E.Promises.writeFile(d,JSON.stringify(c,void 0,2))}catch(d){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${d}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json"}),define(Z[98],x([0,1,43,2,48,5,22,6,215]),function(K,e,v,L,k,M,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,M.createDecorator)("storageMainService");let w=class extends L.Disposable{constructor(I,b,y){super();this.logService=I,this.environmentService=b,this.lifecycleMainService=y,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async I=>{I.workspace&&this.workspaceStorage(I.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(I=>{I.join(this.globalStorage.close());for(const[,b]of this.mapWorkspaceToStorage)I.join(b.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const I=new f.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,v.once)(I.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),I}createWorkspaceStorage(I){return new f.WorkspaceStorageMain(I,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(I){let b=this.mapWorkspaceToStorage.get(I.id);return b||(this.logService.trace(`StorageMainService: creating workspace storage (${I.id})`),b=this.createWorkspaceStorage(I),this.mapWorkspaceToStorage.set(I.id,b),(0,v.once)(b.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${I.id})`),this.mapWorkspaceToStorage.delete(I.id)})),b}};w=he([te(0,n.ILogService),te(1,k.IEnvironmentService),te(2,E.ILifecycleMainService)],w),e.StorageMainService=w}),define(Z[99],x([0,1,15,7,27]),function(K,e,v,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function M(f,w,t){for(const b of f){const y=b.openedWorkspace;if((0,k.isWorkspaceIdentifier)(y)){const h=t(y);if(h){if(h.folders.some(g=>v.extUriBiasedIgnorePathCase.isEqualOrParent(w,g.uri)))return b}else if(v.extUriBiasedIgnorePathCase.isEqualOrParent(w,y.configPath))return b}}const I=f.filter(b=>(0,k.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqualOrParent(w,b.openedWorkspace.uri));if(I.length)return I.sort((b,y)=>-(b.openedWorkspace.uri.path.length-y.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=M;function E(f,w){for(const t of f)if((0,k.isWorkspaceIdentifier)(t.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(t.openedWorkspace.configPath,w)||(0,k.isSingleFolderWorkspaceIdentifier)(t.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(t.openedWorkspace.uri,w))return t}e.findWindowOnWorkspaceOrFolder=E;function n(f,w){const t=I=>w.some(b=>v.extUriBiasedIgnorePathCase.isEqual(L.URI.file(b),L.URI.file(I)));for(const I of f)if(I.config?.extensionDevelopmentPath?.some(b=>t(b)))return I}e.findWindowOnExtensionDevelopmentPath=n}),define(Z[216],x([0,1,14,2,3,15,7,16,22,6,39,36,27]),function(K,e,v,L,k,M,E,n,f,w,t,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let y=class mt extends L.Disposable{constructor(d,o,u,i,a){super();this.windowsMainService=d,this.stateMainService=o,this.lifecycleMainService=u,this.logService=i,this.configurationService=a,this._state=h(this.stateMainService.getItem(mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(d=>this.onBeforeCloseWindow(d)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(d=>{d.newCount-d.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(d=>this.onBeforeCloseWindow(d))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const d={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!d.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(a=>!a.isExtensionDevelopmentHost)),i&&(d.lastActiveWindow=this.toWindowState(i))}const o=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);o&&(d.lastPluginDevelopmentHostWindow=this.toWindowState(o)),this.windowsMainService.getWindowCount()>1&&(d.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>this.toWindowState(i)));const u=P(d);this.stateMainService.setItem(mt.windowsStateStorageKey,u),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",u)}onBeforeCloseWindow(d){if(this.lifecycleMainService.quitRequested)return;const o=this.toWindowState(d);d.isExtensionDevelopmentHost&&!d.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=o:!d.isExtensionDevelopmentHost&&d.openedWorkspace&&this._state.openedWindows.forEach(u=>{const i=(0,b.isWorkspaceIdentifier)(d.openedWorkspace)&&u.workspace?.id===d.openedWorkspace.id,a=(0,b.isSingleFolderWorkspaceIdentifier)(d.openedWorkspace)&&u.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(u.folderUri,d.openedWorkspace.uri);(i||a)&&(u.uiState=o.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=o)}toWindowState(d){return{workspace:(0,b.isWorkspaceIdentifier)(d.openedWorkspace)?d.openedWorkspace:void 0,folderUri:(0,b.isSingleFolderWorkspaceIdentifier)(d.openedWorkspace)?d.openedWorkspace.uri:void 0,backupPath:d.backupPath,remoteAuthority:d.remoteAuthority,uiState:d.serializeWindowState()}}getNewWindowState(d){const o=this.doGetNewWindowState(d),u=this.configurationService.getValue("window");let i;return o.hasDefaultState?i=!!(u?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(u.newWindowDimensions)>=0):(i=!!(this.lifecycleMainService.wasRestarted||u?.restoreFullscreen),i&&k.isMacintosh&&this.windowsMainService.getWindows().some(a=>a.isFullScreen)&&(i=!1)),o.mode===3&&!i&&(o.mode=1),o}doGetNewWindowState(d){const o=this.windowsMainService.getLastActiveWindow();if(!d.extensionTestsPath){if(!!d.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=d.workspace;if((0,b.isWorkspaceIdentifier)(l)){const S=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===l.id).map(D=>D.uiState);if(S.length)return S[0]}if((0,b.isSingleFolderWorkspaceIdentifier)(l)){const S=this.state.openedWindows.filter(D=>D.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(D.folderUri,l.uri)).map(D=>D.uiState);if(S.length)return S[0]}else if(d.backupPath){const S=this.state.openedWindows.filter(D=>D.backupPath===d.backupPath).map(D=>D.uiState);if(S.length)return S[0]}const m=this.lastClosedState||this.state.lastActiveWindow;if(!o&&m)return m.uiState}let u;const i=v.screen.getAllDisplays();if(i.length===1)u=i[0];else{if(k.isMacintosh){const l=v.screen.getCursorScreenPoint();u=v.screen.getDisplayNearestPoint(l)}!u&&o&&(u=v.screen.getDisplayMatching(o.getBounds())),u||(u=v.screen.getPrimaryDisplay()||i[0])}let a=(0,I.defaultWindowState)();a.x=Math.round(u.bounds.x+u.bounds.width/2-a.width/2),a.y=Math.round(u.bounds.y+u.bounds.height/2-a.height/2);const r=this.configurationService.getValue("window");let s=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")a.mode=0,s=!1;else if(r.newWindowDimensions==="fullscreen")a.mode=3,s=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&o){const l=o.serializeWindowState();l.mode===3?a.mode=3:a=l,s=a.mode!==3&&r.newWindowDimensions==="offset"}}return s&&(a=this.ensureNoOverlap(a)),a.hasDefaultState=!0,a}ensureNoOverlap(d){if(this.windowsMainService.getWindows().length===0)return d;d.x=typeof d.x=="number"?d.x:0,d.y=typeof d.y=="number"?d.y:0;const o=this.windowsMainService.getWindows().map(u=>u.getBounds());for(;o.some(u=>u.x===d.x||u.y===d.y);)d.x+=30,d.y+=30;return d}};y.windowsStateStorageKey="windowsState",y=he([te(0,I.IWindowsMainService),te(1,t.IStateMainService),te(2,f.ILifecycleMainService),te(3,w.ILogService),te(4,n.IConfigurationService)],y),e.WindowsStateHandler=y;function h(c){const d={openedWindows:[]},o=c||{openedWindows:[]};return o.lastActiveWindow&&(d.lastActiveWindow=g(o.lastActiveWindow)),o.lastPluginDevelopmentHostWindow&&(d.lastPluginDevelopmentHostWindow=g(o.lastPluginDevelopmentHostWindow)),Array.isArray(o.openedWindows)&&(d.openedWindows=o.openedWindows.map(u=>g(u))),d}e.restoreWindowsState=h;function g(c){const d={uiState:c.uiState};return c.backupPath&&(d.backupPath=c.backupPath),c.remoteAuthority&&(d.remoteAuthority=c.remoteAuthority),c.folder&&(d.folderUri=E.URI.parse(c.folder)),c.workspaceIdentifier&&(d.workspace={id:c.workspaceIdentifier.id,configPath:E.URI.parse(c.workspaceIdentifier.configURIPath)}),d}function P(c){return{lastActiveWindow:c.lastActiveWindow&&p(c.lastActiveWindow),lastPluginDevelopmentHostWindow:c.lastPluginDevelopmentHostWindow&&p(c.lastPluginDevelopmentHostWindow),openedWindows:c.openedWindows.map(d=>p(d))}}e.getWindowsStateStoreData=P;function p(c){return{workspaceIdentifier:c.workspace&&{id:c.workspace.id,configURIPath:c.workspace.configPath.toString()},folder:c.folderUri&&c.folderUri.toString(),backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.uiState}}}),define(Z[100],x([0,1,58,31,10,3,15]),function(K,e,v,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function n(w){function t(){let I=w.scheme===k.Schemas.file?(0,E.originalFSPath)(w):w.toString();return M.isLinux||(I=I.toLowerCase()),(0,v.createHash)("md5").update(I).digest("hex")}return{id:t(),configPath:w}}e.getWorkspaceIdentifier=n;function f(w,t){function I(){if(w.scheme!==k.Schemas.file)return(0,v.createHash)("md5").update(w.toString()).digest("hex");if(!t)try{t=(0,L.statSync)(w.fsPath)}catch(h){return}let y;return M.isLinux?y=t.ino:M.isMacintosh?y=t.birthtime.getTime():M.isWindows&&(typeof t.birthtimeMs=="number"?y=Math.floor(t.birthtimeMs):y=t.birthtime.getTime()),(0,v.createHash)("md5").update(w.fsPath).update(y?String(y):"").digest("hex")}const b=I();if(typeof b=="string")return{id:b,uri:w}}e.getSingleFolderWorkspaceIdentifier=f}),define(Z[56],x([0,1,58,59,26,18,17,4,2,8,3,28,35,83,217]),function(K,e,v,L,k,M,E,n,f,w,t,I,b,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(S){this.socket=S,this._errorListener=D=>{if(D){if(D.code==="EPIPE")return;(0,E.onUnexpectedError)(D)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(S){const D=R=>S(M.VSBuffer.wrap(R));return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(S){const D=R=>{S({type:0,hadError:R,error:void 0})};return this.socket.on("close",D),{dispose:()=>this.socket.off("close",D)}}onEnd(S){return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(S){if(!this.socket.destroyed)try{this.socket.write(S.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,E.onUnexpectedError)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,E.onUnexpectedError)(D)}}end(){this.socket.end()}drain(){return new Promise((S,D)=>{if(this.socket.bufferSize===0){S();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),S()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=g;var P;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(P||(P={}));var p;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(p||(p={}));class c extends f.Disposable{constructor(S,D,R,F){super();this._onDidZlibFlush=this._register(new n.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new n.Emitter),this._onClose=this._register(new n.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=S,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=D,this._recordInflateBytes=F,D?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",U=>{console.error(U),(0,E.onUnexpectedError)(U),this._onClose.fire({type:0,hadError:!0,error:U})}),this._zlibInflate.on("data",U=>{this._pendingInflateData.push(U)}),R&&(this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",U=>{console.error(U),(0,E.onUnexpectedError)(U),this._onClose.fire({type:0,hadError:!0,error:U})}),this._zlibDeflate.on("data",U=>{this._pendingDeflateData.push(U)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new y.ChunkStream,this._register(this.socket.onData(U=>this._acceptChunk(U))),this._register(this.socket.onClose(U=>this._onClose.fire(U)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?M.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):M.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this._onData.event(S)}onClose(S){return this._onClose.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){this._totalOutgoingDataBytes+=S.byteLength,this._zlibDeflate?(this._zlibDeflate.write(S.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let D=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,D=D.slice(0,D.length-4),this._isEnded||this._write(M.VSBuffer.wrap(D),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(S,!1)}_write(S,D){let R=2;S.byteLength<126?R+=0:S.byteLength<2**16?R+=2:R+=8;const F=M.VSBuffer.alloc(R);if(D?F.writeUInt8(194,0):F.writeUInt8(130,0),S.byteLength<126)F.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){F.writeUInt8(126,1);let U=1;F.writeUInt8(S.byteLength>>>8&255,++U),F.writeUInt8(S.byteLength>>>0&255,++U)}else{F.writeUInt8(127,1);let U=1;F.writeUInt8(0,++U),F.writeUInt8(0,++U),F.writeUInt8(0,++U),F.writeUInt8(0,++U),F.writeUInt8(S.byteLength>>>24&255,++U),F.writeUInt8(S.byteLength>>>16&255,++U),F.writeUInt8(S.byteLength>>>8&255,++U),F.writeUInt8(S.byteLength>>>0&255,++U)}this._totalOutgoingWireBytes+=F.byteLength+S.byteLength,this.socket.write(M.VSBuffer.concat([F,S]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(S){if(S.byteLength!==0){for(this._totalIncomingWireBytes+=S.byteLength,this._incomingData.acceptChunk(S);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const D=this._incomingData.peek(this._state.readLen),F=(D.readUInt8(0)&128)>>>7,U=D.readUInt8(1),X=(U&128)>>>7,ne=U&127;this._state.state=2,this._state.readLen=2+(X?4:0)+(ne===126?2:0)+(ne===127?8:0),this._state.fin=F,this._state.mask=0}else if(this._state.state===2){const D=this._incomingData.read(this._state.readLen),R=D.readUInt8(1),F=(R&128)>>>7;let U=R&127,X=1;U===126?U=D.readUInt8(++X)*2**8+D.readUInt8(++X):U===127&&(U=D.readUInt8(++X)*0+D.readUInt8(++X)*0+D.readUInt8(++X)*0+D.readUInt8(++X)*0+D.readUInt8(++X)*2**24+D.readUInt8(++X)*2**16+D.readUInt8(++X)*2**8+D.readUInt8(++X));let ne=0;F&&(ne=D.readUInt8(++X)*2**24+D.readUInt8(++X)*2**16+D.readUInt8(++X)*2**8+D.readUInt8(++X)),this._state.state=3,this._state.readLen=U,this._state.mask=ne}else if(this._state.state===3){const D=this._incomingData.read(this._state.readLen);d(D,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(D.buffer)),this._zlibInflate.write(D.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const R=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=R.length,this._onData.fire(M.VSBuffer.wrap(R))})):(this._totalIncomingDataBytes+=D.byteLength,this._onData.fire(D))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await n.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=c;function d(m,S){if(S===0)return;let D=m.byteLength>>>2;for(let se=0;se<D;se++){const G=m.readUInt32BE(se*4);m.writeUInt32BE(G^S,se*4)}let R=D*4,F=m.byteLength-R;const U=S>>>24&255,X=S>>>16&255,ne=S>>>8&255;F>=1&&m.writeUInt8(m.readUInt8(R)^U,R),F>=2&&m.writeUInt8(m.readUInt8(R+1)^X,R+1),F>=3&&m.writeUInt8(m.readUInt8(R+2)^ne,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function u(){const m=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let S;return e.XDG_RUNTIME_DIR?S=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):S=(0,w.join)((0,k.tmpdir)(),`vscode-ipc-${m}.sock`),a(S),S}e.createRandomIPCHandle=u;function i(m,S,D){const R=(0,v.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${D}-${S}-sock`;let F;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?F=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-${R.substr(0,8)}-${D}-${S}.sock`):F=(0,w.join)(m,`${D}-${S}.sock`),a(F),F}e.createStaticIPCHandle=i;function a(m){const S=o[t.platform];typeof S=="number"&&m.length>=S&&console.warn(`WARNING: IPC handle "${m}" is longer than ${S} chars, try a shorter --user-data-dir`)}class r extends b.IPCServer{constructor(S){super(r.toClientConnectionEvent(S));this.server=S}static toClientConnectionEvent(S){const D=n.Event.fromNodeEventEmitter(S,"connection");return n.Event.map(D,R=>({protocol:new y.Protocol(new g(R)),onDidClientDisconnect:n.Event.once(n.Event.fromNodeEventEmitter(R,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function s(m){return new Promise((S,D)=>{const R=(0,L.createServer)();R.on("error",D),R.listen(m,()=>{R.removeListener("error",D),S(new r(R))})})}e.serve=s;function l(m,S){return new Promise((D,R)=>{const F=(0,L.createConnection)(m,()=>{F.removeListener("error",R),D(y.Client.fromSocket(new g(F),S))});F.once("error",R)})}e.connect=l}),define(Z[218],x([0,1,56]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class L{constructor(f){this.driver=f}listen(f,w){throw new Error("No event found")}call(f,w,t){switch(w){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(t);case"reloadWindow":return this.driver.reloadWindow(t);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(t[0],t[1]);case"click":return this.driver.click(t[0],t[1],t[2],t[3]);case"doubleClick":return this.driver.doubleClick(t[0],t[1]);case"setValue":return this.driver.setValue(t[0],t[1],t[2]);case"getTitle":return this.driver.getTitle(t[0]);case"isActiveElement":return this.driver.isActiveElement(t[0],t[1]);case"getElements":return this.driver.getElements(t[0],t[1],t[2]);case"getElementXY":return this.driver.getElementXY(t[0],t[1],t[2]);case"typeInEditor":return this.driver.typeInEditor(t[0],t[1],t[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(t[0],t[1]);case"writeInTerminal":return this.driver.writeInTerminal(t[0],t[1],t[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(t);case"getLocalizedStrings":return this.driver.getLocalizedStrings(t)}throw new Error(`Call not found: ${w}`)}}e.DriverChannel=L;class k{constructor(f){this.channel=f}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(f){return this.channel.call("capturePage",f)}reloadWindow(f){return this.channel.call("reloadWindow",f)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(f,w){return this.channel.call("dispatchKeybinding",[f,w])}click(f,w,t,I){return this.channel.call("click",[f,w,t,I])}doubleClick(f,w){return this.channel.call("doubleClick",[f,w])}setValue(f,w,t){return this.channel.call("setValue",[f,w,t])}getTitle(f){return this.channel.call("getTitle",[f])}isActiveElement(f,w){return this.channel.call("isActiveElement",[f,w])}getElements(f,w,t){return this.channel.call("getElements",[f,w,t])}getElementXY(f,w,t,I){return this.channel.call("getElementXY",[f,w,t,I])}typeInEditor(f,w,t){return this.channel.call("typeInEditor",[f,w,t])}getTerminalBuffer(f,w){return this.channel.call("getTerminalBuffer",[f,w])}writeInTerminal(f,w,t){return this.channel.call("writeInTerminal",[f,w,t])}getLocaleInfo(f){return this.channel.call("getLocaleInfo",f)}getLocalizedStrings(f){return this.channel.call("getLocalizedStrings",f)}}e.DriverChannelClient=k;class M{constructor(f){this.registry=f}listen(f,w){throw new Error(`Event not found: ${w}`)}call(f,w,t){switch(w){case"registerWindowDriver":return this.registry.registerWindowDriver(t);case"reloadWindowDriver":return this.registry.reloadWindowDriver(t)}throw new Error(`Call not found: ${w}`)}}e.WindowDriverRegistryChannel=M;async function E(n){const f=await(0,v.connect)(n,"driverClient"),w=f.getChannel("driver"),t=new k(w);return{client:f,driver:t}}e.connect=E}),define(Z[219],x([0,1,9,4,106,57,2,3,78,35,56,155,218,176,22,36]),function(K,e,v,L,k,M,E,n,f,w,t,I,b,y,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function P(d){return d<21}let p=class{constructor(o,u,i,a){this.windowServer=o,this.options=u,this.windowsMainService=i,this.lifecycleMainService=a,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new L.Emitter}async registerWindowDriver(o){return this.registeredWindowIds.add(o),this.reloadingWindowIds.delete(o),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(o){this.reloadingWindowIds.add(o)}async getWindowIds(){return this.windowsMainService.getWindows().map(o=>o.id).filter(o=>this.registeredWindowIds.has(o)&&!this.reloadingWindowIds.has(o))}async capturePage(o){await this.whenUnfrozen(o);const u=this.windowsMainService.getWindowById(o);if(!u?.win)throw new Error("Invalid window");return(await u.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(o){await this.whenUnfrozen(o);const u=this.windowsMainService.getWindowById(o);if(!u)throw new Error("Invalid window");this.reloadingWindowIds.add(o),this.lifecycleMainService.reload(u)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(o,u){await this.whenUnfrozen(o);const i=k.KeybindingParser.parseUserBinding(u);for(let a of i)await this._dispatchKeybinding(o,a)}async _dispatchKeybinding(o,u){if(u instanceof f.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const i=this.windowsMainService.getWindowById(o);if(!i?.win)throw new Error("Invalid window");const a=i.win.webContents,r=new M.SimpleKeybinding(!1,!1,!1,!1,u.keyCode),l=new y.USLayoutResolvedKeybinding(r.toChord(),n.OS).getElectronAccelerator(),m=[];u.ctrlKey&&m.push("ctrl"),u.metaKey&&m.push("meta"),u.shiftKey&&m.push("shift"),u.altKey&&m.push("alt"),a.sendInputEvent({type:"keyDown",keyCode:l,modifiers:m}),P(u.keyCode)||a.sendInputEvent({type:"char",keyCode:l,modifiers:m}),a.sendInputEvent({type:"keyUp",keyCode:l,modifiers:m}),await(0,v.timeout)(100)}async click(o,u,i,a){await(await this.getWindowDriver(o)).click(u,i,a)}async doubleClick(o,u){await(await this.getWindowDriver(o)).doubleClick(u)}async setValue(o,u,i){await(await this.getWindowDriver(o)).setValue(u,i)}async getTitle(o){return await(await this.getWindowDriver(o)).getTitle()}async isActiveElement(o,u){return await(await this.getWindowDriver(o)).isActiveElement(u)}async getElements(o,u,i){return await(await this.getWindowDriver(o)).getElements(u,i)}async getElementXY(o,u,i,a){return await(await this.getWindowDriver(o)).getElementXY(u,i,a)}async typeInEditor(o,u,i){await(await this.getWindowDriver(o)).typeInEditor(u,i)}async getTerminalBuffer(o,u){return await(await this.getWindowDriver(o)).getTerminalBuffer(u)}async writeInTerminal(o,u,i){await(await this.getWindowDriver(o)).writeInTerminal(u,i)}async getLocaleInfo(o){return await(await this.getWindowDriver(o)).getLocaleInfo()}async getLocalizedStrings(o){return await(await this.getWindowDriver(o)).getLocalizedStrings()}async getWindowDriver(o){await this.whenUnfrozen(o);const u=`window:${o}`,i=new w.StaticRouter(r=>r===u),a=this.windowServer.getChannel("windowDriver",i);return new I.WindowDriverChannelClient(a)}async whenUnfrozen(o){for(;this.reloadingWindowIds.has(o);)await L.Event.toPromise(this.onDidReloadingChange.event)}};p=he([te(2,g.IWindowsMainService),te(3,h.ILifecycleMainService)],p),e.Driver=p;async function c(d,o,u,i){const a=u.driverVerbose,r=i.createInstance(p,d,{verbose:a}),s=new b.WindowDriverRegistryChannel(r);d.registerChannel("windowDriverRegistry",s);const l=await(0,t.serve)(o),m=new b.DriverChannel(r);return l.registerChannel("driver",m),(0,E.combinedDisposable)(l,d)}e.serve=c}),define(Z[24],x([0,1,47,8,56,48,160,5]),function(K,e,v,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,n.refineServiceDecorator)(M.IEnvironmentService);class f extends E.NativeEnvironmentService{get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,L.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}he([v.memoize],f.prototype,"cachedLanguagesPath",null),he([v.memoize],f.prototype,"backupHome",null),he([v.memoize],f.prototype,"backupWorkspacesPath",null),he([v.memoize],f.prototype,"mainIPCHandle",null),he([v.memoize],f.prototype,"mainLockfile",null),he([v.memoize],f.prototype,"sandbox",null),he([v.memoize],f.prototype,"driverVerbose",null),he([v.memoize],f.prototype,"disableUpdates",null),he([v.memoize],f.prototype,"disableKeytar",null),he([v.memoize],f.prototype,"codeCachePath",null),he([v.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(Z[220],x([0,1,58,31,30,10,8,3,15,7,19,51,16,24,20,6,27]),function(K,e,v,L,k,M,E,n,f,w,t,I,b,y,h,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let p=class{constructor(d,o,u){this.configurationService=o,this.logService=u,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=f.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,a)=>(0,k.isEqual)(i,a,!n.isLinux)},this.backupHome=d.backupHome,this.workspacesJsonPath=d.backupWorkspacesPath}async initialize(){let d;try{d=JSON.parse(await t.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(i){d=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(d.emptyWorkspaceInfos);let o=[];try{Array.isArray(d.rootURIWorkspaces)&&(o=d.rootURIWorkspaces.map(i=>({workspace:{id:i.id,configPath:w.URI.parse(i.configURIPath)},remoteAuthority:i.remoteAuthority})))}catch(i){}this.workspaces=await this.validateWorkspaces(o);let u=[];try{Array.isArray(d.folderURIWorkspaces)&&(u=d.folderURIWorkspaces.map(i=>w.URI.parse(i)))}catch(i){}this.folders=await this.validateFolders(u),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==h.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===h.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||h.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(d,o){this.workspaces.some(i=>d.workspace.id===i.workspace.id)||(this.workspaces.push(d),this.saveSync());const u=this.getBackupPath(d.workspace.id);return o&&this.moveBackupFolderSync(u,o),u}moveBackupFolderSync(d,o){if(L.existsSync(d)&&this.convertToEmptyWindowBackupSync(d),L.existsSync(o))try{L.renameSync(o,d)}catch(u){this.logService.error(`Backup: Could not move backup folder to new location: ${u.toString()}`)}}unregisterWorkspaceBackupSync(d){const o=d.id,u=this.workspaces.findIndex(i=>i.workspace.id===o);u!==-1&&(this.workspaces.splice(u,1),this.saveSync())}registerFolderBackupSync(d){return this.folders.some(o=>this.backupUriComparer.isEqual(d,o))||(this.folders.push(d),this.saveSync()),this.getBackupPath(this.getFolderHash(d))}unregisterFolderBackupSync(d){const o=this.folders.findIndex(u=>this.backupUriComparer.isEqual(d,u));o!==-1&&(this.folders.splice(o,1),this.saveSync())}registerEmptyWindowBackupSync(d,o){const u=d||this.getRandomEmptyWindowId();return this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,u))||(this.emptyWindows.push({backupFolder:u,remoteAuthority:o}),this.saveSync()),this.getBackupPath(u)}unregisterEmptyWindowBackupSync(d){const o=this.emptyWindows.findIndex(u=>!!u.backupFolder&&this.backupPathComparer.isEqual(u.backupFolder,d));o!==-1&&(this.emptyWindows.splice(o,1),this.saveSync())}getBackupPath(d){return(0,E.join)(this.backupHome,d)}async validateWorkspaces(d){if(!Array.isArray(d))return[];const o=new Set,u=[];for(let i of d){const a=i.workspace;if(!(0,P.isWorkspaceIdentifier)(a))return[];if(!o.has(a.id)){o.add(a.id);const r=this.getBackupPath(a.id);await this.doHasBackups(r)?a.configPath.scheme!==M.Schemas.file||await t.Promises.exists(a.configPath.fsPath)?u.push(i):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return u}async validateFolders(d){if(!Array.isArray(d))return[];const o=[],u=new Set;for(let i of d){const a=this.backupUriComparer.getComparisonKey(i);if(!u.has(a)){u.add(a);const r=this.getBackupPath(this.getFolderHash(i));await this.doHasBackups(r)?i.scheme!==M.Schemas.file||await t.Promises.exists(i.fsPath)?o.push(i):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return o}async validateEmptyWorkspaces(d){if(!Array.isArray(d))return[];const o=[],u=new Set;for(let i of d){const a=i.backupFolder;if(typeof a!="string")return[];if(!u.has(a)){u.add(a);const r=this.getBackupPath(a);await this.doHasBackups(r)?o.push(i):await this.deleteStaleBackup(r)}}return o}async deleteStaleBackup(d){try{await t.Promises.exists(d)&&await t.Promises.rm(d,t.RimRafMode.MOVE)}catch(o){this.logService.error(`Backup: Could not delete stale backup: ${o.toString()}`)}}async convertToEmptyWindowBackup(d){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,o));)o=this.getRandomEmptyWindowId();const u=this.getBackupPath(o);try{await t.Promises.rename(d,u)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}convertToEmptyWindowBackupSync(d){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,o));)o=this.getRandomEmptyWindowId();const u=this.getBackupPath(o);try{L.renameSync(d,u)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}async getDirtyWorkspaces(){const d=[];for(const o of this.workspaces)await this.hasBackups(o)&&d.push(o.workspace);for(const o of this.folders)await this.hasBackups(o)&&d.push(o);return d}hasBackups(d){let o;return w.URI.isUri(d)?o=this.getBackupPath(this.getFolderHash(d)):(0,I.isWorkspaceBackupInfo)(d)?o=this.getBackupPath(d.workspace.id):o=d.backupFolder,this.doHasBackups(o)}async doHasBackups(d){try{const o=await t.Promises.readdir(d);for(const u of o)try{if((await t.Promises.readdir((0,E.join)(d,u))).length>0)return!0}catch(i){}}catch(o){}return!1}saveSync(){try{(0,t.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(d){this.logService.error(`Backup: Could not save workspaces.json: ${d.toString()}`)}}async save(){try{await t.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(d){this.logService.error(`Backup: Could not save workspaces.json: ${d.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(d=>({id:d.workspace.id,configURIPath:d.workspace.configPath.toString(),remoteAuthority:d.remoteAuthority})),folderURIWorkspaces:this.folders.map(d=>d.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(d){let o;return d.scheme===M.Schemas.file?o=n.isLinux?d.fsPath:d.fsPath.toLowerCase():o=d.toString().toLowerCase(),(0,v.createHash)("md5").update(o).digest("hex")}};p=he([te(0,y.IEnvironmentMainService),te(1,b.IConfigurationService),te(2,g.ILogService)],p),e.BackupMainService=p}),define(Z[221],x([0,1,59,56]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,M,E,n){const f=t=>n(t,void 0),w=v.createConnection({host:k,port:M},()=>{w.removeListener("error",f);const t=Buffer.alloc(16);for(let h=0;h<16;h++)t[h]=Math.round(Math.random()*256);const I=t.toString("base64");let b=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${M}/?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${I}`];w.write(b.join(`\r
`)+`\r
\r
`);const y=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",y),n(void 0,new L.NodeSocket(w)))};w.on("data",y)});w.once("error",f)}}}),define(Z[222],x([0,1,59,9,2,115,16,6,21,191,95,221,75]),function(K,e,v,L,k,M,E,n,f,w,t,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function y(p,c,d,o,u){return new h(p,c,d,o,u).waitForReady()}class h extends k.Disposable{constructor(c,d,o,u,i){super();this.defaultTunnelHost=d,this.suggestedLocalPort=i,this.public=!1,this._socketsDispose=new Map,this._options=c,this._server=v.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=a=>this._onConnection(a),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=u,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(d=>{d()})}async waitForReady(){let c=await(0,M.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),d=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),d=this._server.address(),d||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),d=this._server.address()),this.tunnelLocalPort=d.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${d.port}`,this}async _onConnection(c){c.pause();const d=await(0,w.connectRemoteAgentTunnel)(this._options,this.tunnelRemoteHost,this.tunnelRemotePort),o=d.getSocket().socket,u=d.readEntireBuffer();d.dispose(),u.byteLength>0&&c.write(u.buffer),c.on("end",()=>{this._socketsDispose.delete(c.localAddress),o.end()}),c.on("close",()=>o.end()),c.on("error",()=>{this._socketsDispose.delete(c.localAddress),o.destroy()}),o.on("end",()=>c.end()),o.on("close",()=>c.end()),o.on("error",()=>{c.destroy()}),c.pipe(o),o.pipe(c),this._socketsDispose.set(c.localAddress,()=>{c.end(),o.end()})}}let g=class extends t.AbstractTunnelService{constructor(c,d,o,u,i){super(d);this.socketFactory=c,this.signService=o,this.productService=u,this.configurationService=i}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(c,d,o,u,i,a,r){const s=this.getTunnelFromMap(d,o);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,d,o,u,i,a,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${o} on local port ${u}.`);const l={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},m=y(l,this.defaultTunnelHost,d,o,u);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(d,o,m),m}}};g=he([te(1,n.ILogService),te(2,b.ISignService),te(3,f.IProductService),te(4,E.IConfigurationService)],g),e.BaseTunnelService=g;let P=class extends g{constructor(c,d,o,u){super(I.nodeSocketFactory,c,d,o,u)}};P=he([te(0,n.ILogService),te(1,b.ISignService),te(2,f.IProductService),te(3,E.IConfigurationService)],P),e.TunnelService=P}),define(Z[223],x([0,1,193,18,17,2,13,16,48,90,6,192,217]),function(K,e,v,L,k,M,E,n,f,w,t,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let y=class extends M.Disposable{constructor(g,P,p){super();this.environmentService=P,this.logService=p,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,P){this.logService.trace("RequestService#request",g.url);const{proxyUrl:p,strictSSL:c}=this,d={...process.env,...await(0,w.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},o=g.agent?g.agent:await(0,I.getProxyAgent)(g.url||"",d,{proxyUrl:p,strictSSL:c});return g.agent=o,g.strictSSL=c,this.authorization&&(g.headers={...g.headers||{},"Proxy-Authorization":this.authorization}),this._request(g,P)}async getNodeRequest(g){return((0,v.parse)(g.url).protocol==="https:"?await new Promise((c,d)=>{K(["https"],c,d)}):await new Promise((c,d)=>{K(["http"],c,d)})).request}_request(g,P){return new Promise(async(p,c)=>{let d;const o=(0,v.parse)(g.url),u=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),i={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,E.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(i.auth=g.user+":"+g.password),d=u(i,a=>{const r=(0,E.isNumber)(g.followRedirects)?g.followRedirects:3;if(a.statusCode&&a.statusCode>=300&&a.statusCode<400&&r>0&&a.headers.location)this._request({...g,url:a.headers.location,followRedirects:r-1},P).then(p,c);else{let s=a;a.headers["content-encoding"]==="gzip"&&(s=a.pipe((0,b.createGunzip)())),p({res:a,stream:(0,L.streamToBufferReadableStream)(s)})}}),d.on("error",c),g.timeout&&d.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&d.write(g.data),d.end(),P.onCancellationRequested(()=>{d.abort(),c((0,k.canceled)())})})}async resolveProxy(g){}};y=he([te(0,n.IConfigurationService),te(1,f.INativeEnvironmentService),te(2,t.ILogService)],y),e.RequestService=y}),define(Z[224],x([0,1,14,223]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(E){return v.net.request}class M extends L.RequestService{request(n,f){return super.request({...n||{},getRawRequest:k},f)}}e.RequestMainService=M}),define(Z[225],x([0,1,14,9,4,2,10,13,84,24,22,6,45,55,61]),function(K,e,v,L,k,M,E,n,f,w,t,I,b,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let g=class extends M.Disposable{constructor(p,c,d,o,u,i,a){super();this.machineId=p,this.userEnv=c,this.environmentMainService=d,this.lifecycleMainService=o,this.logService=u,this.themeMainService=i,this.protocolMainService=a,this.firstWindowConnectionBarrier=new L.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new k.Emitter),this.onDidError=k.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),v.ipcMain.on("vscode:createSharedProcessMessageChannel",async(p,c)=>this.onWindowConnection(p,c))}async onWindowConnection(p,c){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const d=await this.connect();if(p.sender.isDestroyed())return d.close();p.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[d])}onWillShutdown(){const p=this.window;!p||(!p.isDestroyed()&&!p.webContents.isDestroyed()&&p.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(p.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{p.close()}catch(c){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(p=>v.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),p()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(p=>v.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),p()}))})()),this._whenIpcReady}createWindow(){const p=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new v.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",K).fsPath,additionalArguments:[`--vscode-window-config=${p.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),p.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:b.default}),this.window.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",K).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=p=>{this.logService.trace("SharedProcess#close prevented"),p.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(p,c)=>this._onDidError.fire({type:2,details:c})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(p,c,d)=>this._onDidError.fire({type:3,details:{reason:d,exitCode:c}})))}async connect(){await this.whenIpcReady;const p=(0,n.assertIsDefined)(this.window);return(0,f.connect)(p)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}};g=he([te(2,w.IEnvironmentMainService),te(3,t.ILifecycleMainService),te(4,I.ILogService),te(5,h.IThemeMainService),te(6,y.IProtocolMainService)],g),e.SharedProcess=g}),define(Z[226],x([0,1,9,18,8,13,7,24,20,6]),function(K,e,v,L,k,M,E,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class t{constructor(y,h,g){this.storagePath=y,this.logService=h,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new v.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}}getItem(y,h){const g=this.storage[y];return(0,M.isUndefinedOrNull)(g)?h:g}setItem(y,h){this.setItems([{key:y,data:h}])}setItems(y){let h=!1;for(const{key:g,data:P}of y)this.storage[g]!==P&&((0,M.isUndefinedOrNull)(P)?(0,M.isUndefined)(this.storage[g])||(this.storage[g]=void 0,h=!0):(this.storage[g]=P,h=!0));h&&this.save()}removeItem(y){(0,M.isUndefined)(this.storage[y])||(this.storage[y]=void 0,this.save())}async save(y){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),y)}async doSave(){if(!this.initializing)return;await this.initializing;const y=JSON.stringify(this.storage,null,4);if(y!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(y)),this.lastSavedStorageContents=y}catch(h){this.logService.error(h)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=t;let I=class yt{constructor(y,h,g){this.fileStorage=new t(E.URI.file((0,k.join)(y.userDataPath,yt.STATE_FILE)),h,g)}async init(){return this.fileStorage.init()}getItem(y,h){return this.fileStorage.getItem(y,h)}setItem(y,h){this.fileStorage.setItem(y,h)}setItems(y){this.fileStorage.setItems(y)}removeItem(y){this.fileStorage.removeItem(y)}close(){return this.fileStorage.close()}};I.STATE_FILE="storage.json",I=he([te(0,n.IEnvironmentMainService),te(1,w.ILogService),te(2,f.IFileService)],I),e.StateMainService=I}),define(Z[76],x([0,1,9,23,4,16,24,22,6,21,50,42]),function(K,e,v,L,k,M,E,n,f,w,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function b(h,g,P){return`${P.updateUrl}/api/update/${h}/${g}/${P.commit}`}e.createUpdateURL=b;let y=class{constructor(g,P,p,c,d,o){this.lifecycleMainService=g,this.configurationService=P,this.environmentMainService=p,this.requestService=c,this.logService=d,this.productService=o,this._state=I.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const g=(0,M.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),P=this.getProductQuality(g);if(!P){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(P),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(I.State.Idle(this.getUpdateType())),g==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,p=>this.logService.error(p))}getProductQuality(g){return g==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(g=60*60*1e3){return(0,v.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(g){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},L.CancellationToken.None).then(g=>g.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};y=he([te(0,n.ILifecycleMainService),te(1,M.IConfigurationService),te(2,E.IEnvironmentMainService),te(3,t.IRequestService),te(4,f.ILogService),te(5,w.IProductService)],y),e.AbstractUpdateService=y}),define(Z[227],x([0,1,14,47,4,2,16,24,22,6,21,50,29,42,76]),function(K,e,v,L,k,M,E,n,f,w,t,I,b,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let g=class extends h.AbstractUpdateService{constructor(p,c,d,o,u,i,a){super(p,c,o,u,i,a);this.telemetryService=d,this.disposables=new M.DisposableStore}get onRawError(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"error",(p,c)=>c)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(p,c,d)=>({url:c,version:d,productVersion:d}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(p,c,d,o)=>({releaseNotes:c,version:d,productVersion:d,date:o}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(p){this.logService.error("UpdateService error:",p);const d=(this.state.type==="checking for updates"?this.state.explicit:!0)?p:void 0;this.setState(y.State.Idle(1,d))}buildUpdateFeedUrl(p){let c;this.productService.darwinUniversalAssetId?c=this.productService.darwinUniversalAssetId:c=process.arch==="x64"?"darwin":"darwin-arm64";const d=(0,h.createUpdateURL)(c,p,this.productService);try{v.autoUpdater.setFeedURL({url:d})}catch(o){this.logService.error("Failed to set update feed URL",o);return}return d}doCheckForUpdates(p){this.setState(y.State.CheckingForUpdates(p)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(p){this.state.type==="checking for updates"&&this.setState(y.State.Downloading(p))}onUpdateDownloaded(p){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:p.version}),this.setState(y.State.Ready(p)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(y.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([L.memoize],g.prototype,"onRawError",null),he([L.memoize],g.prototype,"onRawUpdateNotAvailable",null),he([L.memoize],g.prototype,"onRawUpdateAvailable",null),he([L.memoize],g.prototype,"onRawUpdateDownloaded",null),g=he([te(0,f.ILifecycleMainService),te(1,E.IConfigurationService),te(2,b.ITelemetryService),te(3,n.IEnvironmentMainService),te(4,I.IRequestService),te(5,w.ILogService),te(6,t.IProductService)],g),e.DarwinUpdateService=g}),define(Z[228],x([0,1,41,31,9,4,8,24,22,6,29,42]),function(K,e,v,L,k,M,E,n,f,w,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let b=class{constructor(g,P,p){if(this.lifecycleMainService=g,this.logService=p,this._state=I.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event,P.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(I.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,c=>this.logService.error(c))}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}scheduleCheckForUpdates(g=60*60*1e3){return(0,k.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(g){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};b=he([te(0,f.ILifecycleMainService),te(1,n.IEnvironmentMainService),te(2,w.ILogService)],b);let y=class extends b{constructor(g,P,p,c,d,o){super(p,c,d);this.snap=g,this.snapRevision=P,this.telemetryService=o;const u=(0,L.watch)(E.dirname(this.snap)),i=M.Event.fromNodeEventEmitter(u,"change",(l,m)=>m),a=M.Event.filter(i,l=>l==="current"),s=M.Event.debounce(a,(l,m)=>m,2e3)(()=>this.checkForUpdates(!1));p.onWillShutdown(()=>{s.dispose(),u.close()})}doCheckForUpdates(){this.setState(I.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(g=>{g?this.setState(I.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2)))},g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2,g.message||g))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,v.spawn)("sleep 3 && "+E.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const g=await new Promise((p,c)=>(0,L.realpath)(`${E.dirname(this.snap)}/current`,(d,o)=>d?c(d):p(o))),P=E.basename(g);return this.snapRevision!==P}isLatestVersion(){return this.isUpdateAvailable().then(void 0,g=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};y=he([te(2,f.ILifecycleMainService),te(3,n.IEnvironmentMainService),te(4,w.ILogService),te(5,t.ITelemetryService)],y),e.SnapUpdateService=y}),define(Z[46],x([0,1,14,31,4,40,34,2,10,8,3,15,13,19,153,51,52,24,5,6,21,99,27,100]),function(K,e,v,L,k,M,E,n,f,w,t,I,b,y,h,g,P,p,c,d,o,u,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,c.createDecorator)("workspacesManagementMainService");let r=class extends n.Disposable{constructor(l,m,S,D,R){super();this.environmentMainService=l,this.logService=m,this.backupMainService=S,this.dialogMainService=D,this.productService=R,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new k.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new k.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(l){return this.doResolveLocalWorkspace(l,m=>(0,L.readFileSync)(m,"utf8"))}resolveLocalWorkspace(l){return this.doResolveLocalWorkspace(l,m=>y.Promises.readFile(m,"utf8"))}doResolveLocalWorkspace(l,m){if(!!this.isWorkspacePath(l)&&l.scheme===f.Schemas.file)try{const S=m(l.fsPath);return S instanceof Promise?S.then(D=>this.doResolveWorkspace(l,D),D=>{}):this.doResolveWorkspace(l,S)}catch{return}}isWorkspacePath(l){return(0,i.isUntitledWorkspace)(l,this.environmentMainService)||(0,i.hasWorkspaceFileExtension)(l)}doResolveWorkspace(l,m){try{const S=this.doParseStoredWorkspace(l,m),D=(0,a.getWorkspaceIdentifier)(l);return{id:D.id,configPath:D.configPath,folders:(0,i.toWorkspaceFolders)(S.folders,D.configPath,I.extUriBiasedIgnorePathCase),remoteAuthority:S.remoteAuthority,transient:S.transient}}catch(S){this.logService.warn(S.toString())}}doParseStoredWorkspace(l,m){const S=(0,M.parse)(m);if(S&&Array.isArray(S.folders))S.folders=S.folders.filter(D=>(0,i.isStoredWorkspaceFolder)(D));else throw new Error(`${l.toString(!0)} looks like an invalid workspace file.`);return S}async createUntitledWorkspace(l,m){const{workspace:S,storedWorkspace:D}=this.newUntitledWorkspace(l,m),R=S.configPath.fsPath;return await y.Promises.mkdir((0,w.dirname)(R),{recursive:!0}),await y.Promises.writeFile(R,JSON.stringify(D,null,"	")),S}createUntitledWorkspaceSync(l,m){const{workspace:S,storedWorkspace:D}=this.newUntitledWorkspace(l,m),R=S.configPath.fsPath;return(0,L.mkdirSync)((0,w.dirname)(R),{recursive:!0}),(0,y.writeFileSync)(R,JSON.stringify(D,null,"	")),S}newUntitledWorkspace(l=[],m){const S=(Date.now()+Math.round(Math.random()*1e3)).toString(),D=(0,I.joinPath)(this.untitledWorkspacesHome,S),R=(0,I.joinPath)(D,i.UNTITLED_WORKSPACE_NAME),F=[];for(const U of l)F.push((0,i.getStoredWorkspaceFolder)(U.uri,!0,U.name,D,!t.isWindows,I.extUriBiasedIgnorePathCase));return{workspace:(0,a.getWorkspaceIdentifier)(R),storedWorkspace:{folders:F,remoteAuthority:m}}}async getWorkspaceIdentifier(l){return(0,a.getWorkspaceIdentifier)(l)}isUntitledWorkspace(l){return(0,i.isUntitledWorkspace)(l.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(l){!this.isUntitledWorkspace(l)||(this.doDeleteUntitledWorkspaceSync(l),this._onDidDeleteUntitledWorkspace.fire(l))}async deleteUntitledWorkspace(l){this.deleteUntitledWorkspaceSync(l)}doDeleteUntitledWorkspaceSync(l){const m=(0,I.originalFSPath)(l.configPath);try{(0,y.rimrafSync)((0,w.dirname)(m));const S=(0,w.join)(this.environmentMainService.workspaceStorageHome.fsPath,l.id);(0,L.existsSync)(S)&&(0,y.writeFileSync)((0,w.join)(S,"obsolete"),"")}catch(S){this.logService.warn(`Unable to delete untitled workspace ${m} (${S}).`)}}getUntitledWorkspacesSync(){const l=[];try{const m=(0,y.readdirSync)(this.untitledWorkspacesHome.fsPath).map(S=>(0,I.joinPath)(this.untitledWorkspacesHome,S,i.UNTITLED_WORKSPACE_NAME));for(const S of m){const D=(0,a.getWorkspaceIdentifier)(S),R=this.resolveLocalWorkspaceSync(S);R?l.push({workspace:D,remoteAuthority:R.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(D)}}catch(m){m.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${m}).`)}return l}async enterWorkspace(l,m,S){if(!l||!l.win||!l.isReady||!await this.isValidTargetWorkspacePath(l,m,S))return;const R=this.doEnterWorkspace(l,(0,a.getWorkspaceIdentifier)(S));if(!!R)return this._onDidEnterWorkspace.fire({window:l,workspace:R.workspace}),R}async isValidTargetWorkspacePath(l,m,S){if(!S)return!0;if((0,i.isWorkspaceIdentifier)(l.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(l.openedWorkspace.configPath,S))return!1;if((0,u.findWindowOnWorkspaceOrFolder)(m,S)){const D={title:this.productService.nameLong,type:"info",buttons:[(0,E.mnemonicButtonLabel)((0,h.localize)(0,null))],message:(0,h.localize)(1,null,(0,I.basename)(S)),detail:(0,h.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(D,(0,b.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(l,m){if(!l.config)return;l.focus();let S;return l.config.extensionDevelopmentPath||(S=this.backupMainService.registerWorkspaceBackupSync({workspace:m,remoteAuthority:l.remoteAuthority},l.config.backupPath)),(0,i.isWorkspaceIdentifier)(l.openedWorkspace)&&this.isUntitledWorkspace(l.openedWorkspace)&&this.deleteUntitledWorkspaceSync(l.openedWorkspace),l.config.workspace=m,l.config.backupPath=S,{workspace:m,backupPath:S}}};r=he([te(0,p.IEnvironmentMainService),te(1,d.ILogService),te(2,g.IBackupMainService),te(3,P.IDialogMainService),te(4,o.IProductService)],r),e.WorkspacesManagementMainService=r}),define(Z[101],x([0,1,14,32,23,3,13,7,19,16,54,5,6,97,36,27,46]),function(K,e,v,L,k,M,E,n,f,w,t,I,b,y,h,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,I.createDecorator)(e.ID);let p=class{constructor(d,o,u,i,a){this.logService=d,this.windowsMainService=o,this.urlService=u,this.workspacesManagementMainService=i,this.configurationService=a}async start(d,o){this.logService.trace("Received data from other instance: ",d,o),M.isMacintosh&&v.app.focus({steal:!0});const u=this.parseOpenUrl(d);if(u.length){let i=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(i=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),i.then(()=>{for(const{uri:a,url:r}of u)this.urlService.open(a,{originalUrl:r})})}else return this.startOpenWindow(d,o)}parseOpenUrl(d){return d["open-url"]&&d._urls&&d._urls.length>0?(0,L.coalesce)(d._urls.map(o=>{try{return{uri:n.URI.parse(o),url:o}}catch(u){return null}})):[]}async startOpenWindow(d,o){const u=(0,t.isLaunchedFromCli)(o)?0:4;let i=[];const a=d.wait&&d.waitMarkerFilePath?n.URI.file(d.waitMarkerFilePath):void 0,r=d.remote||void 0;if(d.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(d.extensionDevelopmentPath,{context:u,cli:d,userEnv:o,waitMarkerFileURI:a,remoteAuthority:r});else if(!d._.length&&!d["folder-uri"]&&!d["file-uri"]){let s=!1;if(d["new-window"]||d["unity-launch"])s=!0;else if(d["reuse-window"])s=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":s=!0;break;case"off":s=!1;break;default:s=!M.isMacintosh}if(s)i=this.windowsMainService.open({context:u,cli:d,userEnv:o,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:a,remoteAuthority:r});else{const l=this.windowsMainService.getLastActiveWindow();l?(l.focus(),i=[l]):i=this.windowsMainService.open({context:u,cli:d,forceEmpty:!0,remoteAuthority:r})}}else i=this.windowsMainService.open({context:u,cli:d,userEnv:o,forceNewWindow:d["new-window"],preferNewWindow:!d["reuse-window"]&&!d.wait,forceReuseWindow:d["reuse-window"],diffMode:d.diff,addMode:d.add,noRecentEntry:!!d["skip-add-to-recently-opened"],waitMarkerFileURI:a,gotoLineMode:d.goto,remoteAuthority:r});if(a&&i.length===1&&i[0])return Promise.race([i[0].whenClosedOrLoaded,(0,f.whenDeleted)(a.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const d=[];return v.BrowserWindow.getAllWindows().forEach(o=>{const u=this.windowsMainService.getWindowById(o.id);u?d.push(this.codeWindowToInfo(u)):d.push(this.browserWindowToInfo(o))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:d,screenReader:!!v.app.accessibilitySupportEnabled,gpuFeatureStatus:v.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(d){const o=this.windowsMainService.getWindows();return(await Promise.all(o.map(i=>new Promise(a=>{const r=i.remoteAuthority;if(r){const s=`vscode:getDiagnosticInfoResponse${i.id}`,l={includeProcesses:d.includeProcesses,folders:d.includeWorkspaceMetadata?this.getFolderURIs(i):void 0};i.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:s,args:l}),v.ipcMain.once(s,(m,S)=>{S||a({hostName:r,errorMessage:`Unable to resolve connection to '${r}'.`}),a(S)}),setTimeout(()=>{a({hostName:r,errorMessage:`Fetching remote diagnostics for '${r}' timed out.`})},5e3)}else a(void 0)})))).filter(i=>!!i)}getFolderURIs(d){const o=[],u=d.openedWorkspace;if((0,g.isSingleFolderWorkspaceIdentifier)(u))o.push(u.uri);else if((0,g.isWorkspaceIdentifier)(u)){const i=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);i&&i.folders.forEach(r=>{o.push(r.uri)})}return o}codeWindowToInfo(d){const o=this.getFolderURIs(d),u=(0,E.assertIsDefined)(d.win);return this.browserWindowToInfo(u,o,d.remoteAuthority)}browserWindowToInfo(d,o=[],u){return{pid:d.webContents.getOSProcessId(),title:d.getTitle(),folderURIs:o,remoteAuthority:u}}};p=he([te(0,b.ILogService),te(1,h.IWindowsMainService),te(2,y.IURLService),te(3,P.IWorkspacesManagementMainService),te(4,w.IConfigurationService)],p),e.LaunchMainService=p}),define(Z[53],x([0,1,41,14,26,114,47,4,34,2,10,8,3,7,81,67,19,145,52,24,5,22,6,21,29,61,36,27,46]),function(K,e,v,L,k,M,E,n,f,w,t,I,b,y,h,g,P,p,c,d,o,u,i,a,r,s,l,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,o.createDecorator)("nativeHostMainService");let D=class ct extends w.Disposable{constructor(F,U,X,ne,se,G,J,W,V,B){super();this.sharedProcess=F,this.windowsMainService=U,this.dialogMainService=X,this.lifecycleMainService=ne,this.environmentMainService=se,this.telemetryService=G,this.logService=J,this.productService=W,this.themeMainService=V,this.workspacesManagementMainService=B,this.onDidOpenWindow=n.Event.map(this.windowsMainService.onDidOpenWindow,$=>$.id),this.onDidMaximizeWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",($,H)=>H.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidUnmaximizeWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",($,H)=>H.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidBlurWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-blur",($,H)=>H.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidFocusWindow=n.Event.any(n.Event.map(n.Event.filter(n.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),$=>!!$),$=>$.id),n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-focus",($,H)=>H.id),$=>!!this.windowsMainService.getWindowById($))),this.onDidResumeOS=n.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new n.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new n.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=n.Event.debounce(n.Event.any(n.Event.filter(n.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",($,H,_)=>_),$=>!(Array.isArray($)&&$.length===1&&$[0]==="workArea")),n.Event.fromNodeEventEmitter(L.screen,"display-added"),n.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){L.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:L.nativeTheme.shouldUseInvertedColorScheme||L.nativeTheme.shouldUseHighContrastColors,dark:L.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(U=>({id:U.id,workspace:U.openedWorkspace,title:U.win?.getTitle()??"",filename:U.getRepresentedFilename(),dirty:U.isDocumentEdited()}))}async getWindowCount(F){return this.windowsMainService.getWindowCount()}async getActiveWindowId(F){const U=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(U)return U.id}openWindow(F,U,X){return Array.isArray(U)?this.doOpenWindow(F,U,X):this.doOpenEmptyWindow(F,U)}async doOpenWindow(F,U,X=Object.create(null)){U.length>0&&this.windowsMainService.open({context:5,contextWindowId:F,urisToOpen:U,cli:this.environmentMainService.args,forceNewWindow:X.forceNewWindow,forceReuseWindow:X.forceReuseWindow,preferNewWindow:X.preferNewWindow,diffMode:X.diffMode,addMode:X.addMode,gotoLineMode:X.gotoLineMode,noRecentEntry:X.noRecentEntry,waitMarkerFileURI:X.waitMarkerFileURI,remoteAuthority:X.remoteAuthority||void 0})}async doOpenEmptyWindow(F,U){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:F},U)}async toggleFullScreen(F){const U=this.windowById(F);U&&U.toggleFullScreen()}async handleTitleDoubleClick(F){const U=this.windowById(F);U&&U.handleTitleDoubleClick()}async isMaximized(F){const U=this.windowById(F);return U?.win?U.win.isMaximized():!1}async maximizeWindow(F){const U=this.windowById(F);U?.win&&U.win.maximize()}async unmaximizeWindow(F){const U=this.windowById(F);U?.win&&U.win.unmaximize()}async minimizeWindow(F){const U=this.windowById(F);U?.win&&U.win.minimize()}async focusWindow(F,U){U&&typeof U.windowId=="number"&&(F=U.windowId);const X=this.windowById(F);X&&X.focus({force:U?.force??!1})}async setMinimumSize(F,U,X){const ne=this.windowById(F);if(ne?.win){const[se,G]=ne.win.getSize(),[J,W]=ne.win.getMinimumSize(),[V,B]=[U??J,X??W],[$,H]=[Math.max(se,V),Math.max(G,B)];(J!==V||W!==B)&&ne.win.setMinimumSize(V,B),(se!==$||G!==H)&&ne.win.setSize($,H)}}async saveWindowSplash(F,U){this.themeMainService.saveWindowSplash(F,U)}async installShellCommand(F){const{source:U,target:X}=await this.getShellCommandLink();try{const{symbolicLink:ne}=await P.SymlinkSupport.stat(U);if(ne&&!ne.dangling){const se=await(0,h.realpath)(U);if(X===se)return}await P.Promises.unlink(U)}catch(ne){if(ne.code!=="ENOENT")throw ne}try{await P.Promises.symlink(X,U)}catch(ne){if(ne.code!=="EACCES"&&ne.code!=="ENOENT")throw ne;const{response:se}=await this.showMessageBox(F,{title:this.productService.nameLong,type:"info",message:(0,p.localize)(0,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,p.localize)(1,null)),(0,f.mnemonicButtonLabel)((0,p.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const G=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${X}' '${U}'\\" with administrator privileges"`;await(0,M.promisify)(v.exec)(G)}catch(G){throw new Error((0,p.localize)(3,null,U))}}}async uninstallShellCommand(F){const{source:U}=await this.getShellCommandLink();try{await P.Promises.unlink(U)}catch(X){switch(X.code){case"EACCES":const{response:ne}=await this.showMessageBox(F,{title:this.productService.nameLong,type:"info",message:(0,p.localize)(4,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,p.localize)(5,null)),(0,f.mnemonicButtonLabel)((0,p.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(ne===0)try{const se=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,M.promisify)(v.exec)(se)}catch(se){throw new Error((0,p.localize)(7,null,U))}break;case"ENOENT":break;default:throw X}}}async getShellCommandLink(){const F=(0,I.resolve)(this.environmentMainService.appRoot,"bin","code"),U=`/usr/local/bin/${this.productService.applicationName}`;if(!await P.Promises.exists(F))throw new Error((0,p.localize)(8,null,F));return{source:U,target:F}}async showMessageBox(F,U){return this.dialogMainService.showMessageBox(U,this.toBrowserWindow(F))}async showSaveDialog(F,U){return this.dialogMainService.showSaveDialog(U,this.toBrowserWindow(F))}async showOpenDialog(F,U){return this.dialogMainService.showOpenDialog(U,this.toBrowserWindow(F))}toBrowserWindow(F){const U=this.windowById(F);if(U?.win)return U.win}async pickFileFolderAndOpen(F,U){const X=await this.dialogMainService.pickFileFolder(U);X&&(this.sendPickerTelemetry(X,U.telemetryEventName||"openFileFolder",U.telemetryExtraData),this.doOpenPicked(await Promise.all(X.map(async ne=>await P.SymlinkSupport.existsDirectory(ne)?{folderUri:y.URI.file(ne)}:{fileUri:y.URI.file(ne)})),U,F))}async pickFolderAndOpen(F,U){const X=await this.dialogMainService.pickFolder(U);X&&(this.sendPickerTelemetry(X,U.telemetryEventName||"openFolder",U.telemetryExtraData),this.doOpenPicked(X.map(ne=>({folderUri:y.URI.file(ne)})),U,F))}async pickFileAndOpen(F,U){const X=await this.dialogMainService.pickFile(U);X&&(this.sendPickerTelemetry(X,U.telemetryEventName||"openFile",U.telemetryExtraData),this.doOpenPicked(X.map(ne=>({fileUri:y.URI.file(ne)})),U,F))}async pickWorkspaceAndOpen(F,U){const X=await this.dialogMainService.pickWorkspace(U);X&&(this.sendPickerTelemetry(X,U.telemetryEventName||"openWorkspace",U.telemetryExtraData),this.doOpenPicked(X.map(ne=>({workspaceUri:y.URI.file(ne)})),U,F))}doOpenPicked(F,U,X){this.windowsMainService.open({context:3,contextWindowId:X,cli:this.environmentMainService.args,urisToOpen:F,forceNewWindow:U.forceNewWindow})}sendPickerTelemetry(F,U,X){const ne=F?F.length:0;this.telemetryService.publicLog(U,{...X,outcome:ne?"success":"canceled",numberOfPaths:ne})}async showItemInFolder(F,U){L.shell.showItemInFolder(U)}async setRepresentedFilename(F,U){const X=this.windowById(F);X&&X.setRepresentedFilename(U)}async setDocumentEdited(F,U){const X=this.windowById(F);X&&X.setDocumentEdited(U)}async openExternal(F,U){return b.isLinuxSnap?this.safeSnapOpenExternal(U):L.shell.openExternal(U),!0}safeSnapOpenExternal(F){const U=process.env.GDK_PIXBUF_MODULE_FILE,X=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(F),process.env.GDK_PIXBUF_MODULE_FILE=U,process.env.GDK_PIXBUF_MODULEDIR=X}moveItemToTrash(F,U){return L.shell.trashItem(U)}async isAdmin(){let F;return b.isWindows?F=(await new Promise((U,X)=>{K(["native-is-elevated"],U,X)}))():F=process.getuid()===0,F}async writeElevated(F,U,X,ne){const se=await new Promise((G,J)=>{K(["sudo-prompt"],G,J)});return new Promise((G,J)=>{const W=[`"${this.cliPath}"`];ne?.unlock&&W.push("--file-chmod"),W.push("--file-write",`"${U.fsPath}"`,`"${X.fsPath}"`);const V={name:this.productService.nameLong.replace("-",""),icns:b.isMacintosh&&this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};se.exec(W.join(" "),V,(B,$,H)=>{$&&this.logService.trace(`[sudo-prompt] received stdout: ${$}`),H&&this.logService.trace(`[sudo-prompt] received stderr: ${H}`),B?J(B):G(void 0)})})}get cliPath(){return b.isWindows?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):b.isLinux?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,I.join)(this.environmentMainService.appRoot,"bin","code"):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return g.virtualMachineHint.value()}async killProcess(F,U,X){process.kill(U,X)}async readClipboardText(F,U){return L.clipboard.readText(U)}async writeClipboardText(F,U,X){return L.clipboard.writeText(U,X)}async readClipboardFindText(F){return L.clipboard.readFindText()}async writeClipboardFindText(F,U){return L.clipboard.writeFindText(U)}async writeClipboardBuffer(F,U,X,ne){return L.clipboard.writeBuffer(U,Buffer.from(X),ne)}async readClipboardBuffer(F,U){return L.clipboard.readBuffer(U)}async hasClipboard(F,U,X){return L.clipboard.has(U,X)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,U){const X=this.windowById(F);X&&X.updateTouchBar(U)}async notifyReady(F){const U=this.windowById(F);U&&U.setReady()}async relaunch(F,U){return this.lifecycleMainService.relaunch(U)}async reload(F,U){const X=this.windowById(F);if(X){if((0,m.isWorkspaceIdentifier)(X.openedWorkspace)){const ne=X.openedWorkspace.configPath;if(ne.scheme===t.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(ne))?.transient)return this.openWindow(X.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(X,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(F){this.closeWindowById(F,F)}async closeWindowById(F,U){const X=this.windowById(U);if(X?.win)return X.win.close()}async quit(F){const U=this.windowsMainService.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&U.win?U.win.close():this.lifecycleMainService.quit()}async exit(F,U){await this.lifecycleMainService.kill(U)}async resolveProxy(F,U){const ne=this.windowById(F)?.win?.webContents?.session;if(ne)return ne.resolveProxy(U)}async openDevTools(F,U){const X=this.windowById(F);X?.win&&X.win.webContents.openDevTools(U)}async toggleDevTools(F){const U=this.windowById(F);U?.win&&U.win.webContents.toggleDevTools()}async sendInputEvent(F,U){const X=this.windowById(F);X?.win&&(U.type==="mouseDown"||U.type==="mouseUp")&&X.win.webContents.sendInputEvent(U)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(F,U,X,ne){if(!b.isWindows)return;const se=await new Promise((G,J)=>{K(["vscode-windows-registry"],G,J)});try{return se.GetStringRegKey(U,X,ne)}catch{return}}async getPassword(F,U,X){const ne=await this.withKeytar(),se=await ne.getPassword(U,X);if(se)try{let{content:G,hasNextChunk:J}=JSON.parse(se);if(!G||!J)return se;let W=1;for(;J;){const V=await ne.getPassword(U,`${X}-${W}`),B=JSON.parse(V);G+=B.content,J=B.hasNextChunk,W++}return G}catch{return se}return se}async setPassword(F,U,X,ne){const se=await this.withKeytar(),G=3,J=async(W,V,B)=>{let $=0,H;for(;$<G;)try{await se.setPassword(W,V,B);return}catch(_){H=_,this.logService.warn("Error attempting to set a password: ",_),$++,await new Promise(j=>setTimeout(j,200))}throw H};if(b.isWindows&&ne.length>ct.MAX_PASSWORD_LENGTH){let W=0,V=0,B=!0;for(;B;){const $=ne.substring(W,W+ct.PASSWORD_CHUNK_SIZE);W+=ct.PASSWORD_CHUNK_SIZE,B=ne.length-W>0;const H={content:$,hasNextChunk:B};await J(U,V?`${X}-${V}`:X,JSON.stringify(H)),V++}}else await J(U,X,ne);this._onDidChangePassword.fire({service:U,account:X})}async deletePassword(F,U,X){const se=await(await this.withKeytar()).deletePassword(U,X);return se&&this._onDidChangePassword.fire({service:U,account:X}),se}async findPassword(F,U){return(await this.withKeytar()).findPassword(U)}async findCredentials(F,U){return(await this.withKeytar()).findCredentials(U)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((F,U)=>{K(["keytar"],F,U)})}windowById(F){if(typeof F=="number")return this.windowsMainService.getWindowById(F)}};D.MAX_PASSWORD_LENGTH=2500,D.PASSWORD_CHUNK_SIZE=D.MAX_PASSWORD_LENGTH-100,he([E.memoize],D.prototype,"cliPath",null),D=he([te(1,l.IWindowsMainService),te(2,c.IDialogMainService),te(3,u.ILifecycleMainService),te(4,d.IEnvironmentMainService),te(5,r.ITelemetryService),te(6,i.ILogService),te(7,a.IProductService),te(8,s.IThemeMainService),te(9,S.IWorkspacesManagementMainService)],D),e.NativeHostMainService=D}),define(Z[229],x([0,1,14,23,4,79,2,28,88,6,53,21,36]),function(K,e,v,L,k,M,E,n,f,w,t,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var y;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let h=class extends E.Disposable{constructor(P,p,c,d,o){super();this.logService=P,this.windowsMainService=p,this.nativeHostMainService=c,this.encryptionMainService=d,this.productService=o,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=y.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const P=k.Event.fromNodeEventEmitter(v.app,"login",(p,c,d,o,u)=>({event:p,webContents:c,req:d,authInfo:o,callback:u}));this._register(P(this.onLogin,this))}async onLogin({event:P,authInfo:p,req:c,callback:d}){if(!p.isProxy)return;if(!this.pendingProxyResolve&&this.state===y.LoginDialogShown&&c.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}P.preventDefault();let o;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),o=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(p);try{o=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}d(o?.username,o?.password)}async resolveProxyCredentials(P){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.doResolveProxyCredentials(P);if(p)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(P){this.logService.trace("auth#doResolveProxyCredentials - enter",P);const p=String((0,M.hash)({scheme:P.scheme,host:P.host,port:P.port}));let c,d;try{const a=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,p);if(a){const r=JSON.parse(await this.encryptionMainService.decrypt(a));c=r.username,d=r.password}}catch(a){this.logService.error(a)}if(this.state!==y.StoredCredentialsUsed&&typeof c=="string"&&typeof d=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=y.StoredCredentialsUsed,{username:c,password:d};const o=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!o){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${o.id} to handle proxy login`);const u={authInfo:P,username:this.sessionCredentials?.username??c,password:this.sessionCredentials?.password??d,replyChannel:`vscode:proxyAuthResponse:${(0,n.generateUuid)()}`};o.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,u),this.state=y.LoginDialogShown;const i=await new Promise(a=>{const r=async(s,l,m)=>{if(l===u.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${o.id}`),o.win?.webContents.off("ipc-message",r),m){const S={username:m.username,password:m.password};try{if(m.remember){const D=await this.encryptionMainService.encrypt(JSON.stringify(S));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,p,D)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,p)}catch(D){this.logService.error(D)}a({username:S.username,password:S.password})}else a(void 0)};o.win?.webContents.on("ipc-message",r)});return this.sessionCredentials=i,i}};h=he([te(0,w.ILogService),te(1,b.IWindowsMainService),te(2,t.INativeHostMainService),te(3,f.IEncryptionMainService),te(4,I.IProductService)],h),e.ProxyAuthHandler=h}),define(Z[230],x([0,1,14,26,34,2,10,3,82,143,71,52,24,5,101,6,53,45,21,55,62]),function(K,e,v,L,k,M,E,n,f,w,t,I,b,y,h,g,P,p,c,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,y.createDecorator)("issueMainService");let u=class St{constructor(a,r,s,l,m,S,D,R,F){this.userEnv=a,this.environmentMainService=r,this.launchMainService=s,this.logService=l,this.diagnosticsService=m,this.dialogMainService=S,this.nativeHostMainService=D,this.protocolMainService=R,this.productService=F,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){v.ipcMain.on("vscode:issueSystemInfoRequest",async a=>{const[r,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),l=await this.diagnosticsService.getSystemInfo(r,s);this.safeSend(a,"vscode:issueSystemInfoResponse",l)}),v.ipcMain.on("vscode:listProcesses",async a=>{const r=[];try{const s=await this.launchMainService.getMainProcessId();r.push({name:(0,w.localize)(0,null),rootProcess:await(0,f.listProcesses)(s)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(m=>{(0,t.isRemoteDiagnosticError)(m)?r.push({name:m.hostName,rootProcess:m}):m.processes&&r.push({name:m.hostName,rootProcess:m.processes})})}catch(s){this.logService.error(`Listing processes failed: ${s}`)}this.safeSend(a,"vscode:listProcessesResponse",r)}),v.ipcMain.on("vscode:issueReporterClipboard",async a=>{const r={title:this.productService.nameLong,message:(0,w.localize)(1,null),type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,w.localize)(2,null)),(0,k.mnemonicButtonLabel)((0,w.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const s=await this.dialogMainService.showMessageBox(r,this.issueReporterWindow);this.safeSend(a,"vscode:issueReporterClipboardResponse",s.response===0)}}),v.ipcMain.on("vscode:issuePerformanceInfoRequest",async a=>{const r=await this.getPerformanceInfo();this.safeSend(a,"vscode:issuePerformanceInfoResponse",r)}),v.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const a={title:this.productService.nameLong,message:(0,w.localize)(4,null),type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,w.localize)(5,null)),(0,k.mnemonicButtonLabel)((0,w.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(a,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),v.ipcMain.on("vscode:workbenchCommand",(a,r)=>{const{id:s,from:l,args:m}=r;let S;switch(l){case"issueReporter":S=this.issueReporterParentWindow;break;case"processExplorer":S=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${l}`)}S&&S.webContents.send("vscode:runAction",{id:s,from:l,args:m})}),v.ipcMain.on("vscode:openExternal",(a,r)=>{this.nativeHostMainService.openExternal(void 0,r)}),v.ipcMain.on("vscode:closeIssueReporter",a=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),v.ipcMain.on("vscode:closeProcessExplorer",a=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),v.ipcMain.on("vscode:windowsInfoRequest",async a=>{const r=await this.launchMainService.getMainProcessInfo();this.safeSend(a,"vscode:windowsInfoResponse",r.windows)})}safeSend(a,r,...s){a.sender.isDestroyed()||a.sender.send(r,...s)}async openReporter(a){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=v.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new M.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(l,s,{backgroundColor:a.styles.backgroundColor,title:(0,w.localize)(7,null),zoomLevel:a.zoomLevel,alwaysOnTop:!1}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:a,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,L.type)(),arch:(0,L.arch)(),release:(0,L.release)()},product:p.default}),this.issueReporterWindow.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",K).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(a){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=v.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new M.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(l,s,{backgroundColor:a.styles.backgroundColor,title:(0,w.localize)(8,null),zoomLevel:a.zoomLevel,alwaysOnTop:!0}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:a,product:p.default}),this.processExplorerWindow.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",K).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(a,r,s){const l=new v.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:a.width,height:a.height,minWidth:300,minHeight:200,x:a.x,y:a.y,title:s.title,backgroundColor:s.backgroundColor||St.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",K).fsPath,additionalArguments:[`--vscode-window-config=${r.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,o.zoomLevelToZoomFactor)(s.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:s.alwaysOnTop});return l.setMenuBarVisibility(!1),l}async getSystemStatus(){const[a,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(a,r)}getWindowPosition(a,r,s){let l;const m=v.screen.getAllDisplays();if(m.length===1)l=m[0];else{if(n.isMacintosh){const R=v.screen.getCursorScreenPoint();l=v.screen.getDisplayNearestPoint(R)}!l&&a&&(l=v.screen.getDisplayMatching(a.getBounds())),l||(l=v.screen.getPrimaryDisplay()||m[0])}const S={width:r,height:s},D=l.bounds;return S.x=D.x+D.width/2-S.width/2,S.y=D.y+D.height/2-S.height/2,D.width>0&&D.height>0&&(S.x<D.x&&(S.x=D.x),S.y<D.y&&(S.y=D.y),S.x>D.x+D.width&&(S.x=D.x),S.y>D.y+D.height&&(S.y=D.y),S.width>D.width&&(S.width=D.width),S.height>D.height&&(S.height=D.height)),S}async getPerformanceInfo(){try{const[a,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(a,r)}catch(a){throw this.logService.warn("issueService#getPerformanceInfo ",a.message),a}}};u.DEFAULT_BACKGROUND_COLOR="#1E1E1E",u=he([te(1,b.IEnvironmentMainService),te(2,h.ILaunchMainService),te(3,g.ILogService),te(4,t.IDiagnosticsService),te(5,I.IDialogMainService),te(6,P.INativeHostMainService),te(7,d.IProtocolMainService),te(8,c.IProductService)],u),e.IssueMainService=u}),define(Z[231],x([0,1,23,16,24,22,6,53,21,50,29,42,76]),function(K,e,v,L,k,M,E,n,f,w,t,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let y=class extends b.AbstractUpdateService{constructor(g,P,p,c,d,o,u,i){super(g,P,c,d,o,i);this.telemetryService=p,this.nativeHostMainService=u}buildUpdateFeedUrl(g){return(0,b.createUpdateURL)(`linux-${process.arch}`,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(I.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},v.CancellationToken.None).then(w.asJson).then(P=>{!P||!P.url||!P.version||!P.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(I.State.Idle(1))):this.setState(I.State.AvailableForDownload(P))}).then(void 0,P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const p=g?P.message||P:void 0;this.setState(I.State.Idle(1,p))}))}async doDownloadUpdate(g){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(I.State.Idle(1))}};y=he([te(0,M.ILifecycleMainService),te(1,L.IConfigurationService),te(2,t.ITelemetryService),te(3,k.IEnvironmentMainService),te(4,w.IRequestService),te(5,E.ILogService),te(6,n.INativeHostMainService),te(7,f.IProductService)],y),e.LinuxUpdateService=y}),define(Z[232],x([0,1,41,31,26,9,23,47,8,7,112,19,16,24,20,22,6,53,21,50,29,42,76]),function(K,e,v,L,k,M,E,n,f,w,t,I,b,y,h,g,P,p,c,d,o,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function a(m,S=1e3){for(;!m();)await(0,M.timeout)(S)}let r;function s(){return typeof r=="undefined"&&(r=L.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),r}let l=class extends i.AbstractUpdateService{constructor(S,D,R,F,U,X,ne,se,G){super(S,D,F,U,X,G);this.telemetryService=R,this.fileService=ne,this.nativeHostMainService=se}get cachePath(){const S=f.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return I.Promises.mkdir(S,{recursive:!0}).then(()=>S)}initialize(){super.initialize(),s()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(S){let D="win32";return process.arch!=="ia32"&&(D+=`-${process.arch}`),s()===1?D+="-archive":this.productService.target==="user"&&(D+="-user"),(0,i.createUpdateURL)(D,S,this.productService)}doCheckForUpdates(S){!this.url||(this.setState(u.State.CheckingForUpdates(S)),this.requestService.request({url:this.url},E.CancellationToken.None).then(d.asJson).then(D=>{const R=s();return!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!S}),this.setState(u.State.Idle(R)),Promise.resolve(null)):R===1?(this.setState(u.State.AvailableForDownload(D)),Promise.resolve(null)):(this.setState(u.State.Downloading(D)),this.cleanup(D.version).then(()=>this.getUpdatePackagePath(D.version).then(F=>I.Promises.exists(F).then(U=>{if(U)return Promise.resolve(F);const X=D.url,ne=D.hash,se=`${F}.tmp`;return this.requestService.request({url:X},E.CancellationToken.None).then(G=>this.fileService.writeFile(w.URI.file(se),G.stream)).then(ne?()=>(0,t.checksum)(se,D.hash):()=>{}).then(()=>I.Promises.rename(se,F)).then(()=>F)})).then(F=>{const U=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:F},U&&D.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(u.State.Downloaded(D)):this.setState(u.State.Ready(D))})))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!S});const R=S?D.message||D:void 0;this.setState(u.State.Idle(s(),R))}))}async doDownloadUpdate(S){S.update.url&&this.nativeHostMainService.openExternal(void 0,S.update.url),this.setState(u.State.Idle(s()))}async getUpdatePackagePath(S){const D=await this.cachePath;return f.join(D,`CodeSetup-${this.productService.quality}-${S}.exe`)}async cleanup(S=null){const D=S?X=>!new RegExp(`${this.productService.quality}-${S}\\.exe$`).test(X):()=>!0,R=await this.cachePath,U=(await I.Promises.readdir(R)).filter(D).map(async X=>{try{await I.Promises.unlink(f.join(R,X))}catch(ne){}});await Promise.all(U)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const S=this.state.update;this.setState(u.State.Updating(S));const D=await this.cachePath;this.availableUpdate.updateFilePath=f.join(D,`CodeSetup-${this.productService.quality}-${S.version}.flag`),await I.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,v.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(u.State.Idle(s()))});const F=`${this.productService.win32MutexName}-ready`,U=await new Promise((X,ne)=>{K(["windows-mutex"],X,ne)});a(()=>U.isActive(F)).then(()=>this.setState(u.State.Ready(S)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):(0,v.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return s()}};he([n.memoize],l.prototype,"cachePath",null),l=he([te(0,g.ILifecycleMainService),te(1,b.IConfigurationService),te(2,o.ITelemetryService),te(3,y.IEnvironmentMainService),te(4,d.IRequestService),te(5,P.ILogService),te(6,h.IFileService),te(7,p.INativeHostMainService),te(8,c.IProductService)],l),e.Win32UpdateService=l}),define(Z[233],x([0,1,14,9,23,4,34,2,10,8,73,3,7,149,51,16,52,24,54,200,20,22,6,21,55,98,29,203,61,62,36,27,46]),function(K,e,v,L,k,M,E,n,f,w,t,I,b,y,h,g,P,p,c,d,o,u,i,a,r,s,l,m,S,D,R,F,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var X;(function(se){se[se.NONE=0]="NONE",se[se.LOADING=1]="LOADING",se[se.NAVIGATING=2]="NAVIGATING",se[se.READY=3]="READY"})(X||(X={}));let ne=class extends n.Disposable{constructor(G,J,W,V,B,$,H,_,j,T,A,O,z,N){super();this.logService=J,this.environmentMainService=W,this.fileService=V,this.configurationService=$,this.themeMainService=H,this.workspacesManagementMainService=_,this.backupMainService=j,this.telemetryService=T,this.dialogMainService=A,this.lifecycleMainService=O,this.productService=z,this.protocolMainService=N,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[C,q]=this.restoreWindowState(G.state);this.windowState=C,this.logService.trace("window#ctor: using window state",C);const Q=this.windowState.mode===0||this.windowState.mode===3,ie=this.configurationService.getValue("window"),oe={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:D.WindowMinimumSize.WIDTH,minHeight:D.WindowMinimumSize.HEIGHT,show:!Q,title:this.productService.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",K).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,D.zoomLevelToZoomFactor)(ie?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};I.isLinux?oe.icon=(0,w.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):I.isWindows&&!this.environmentMainService.isBuilt&&(oe.icon=(0,w.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),I.isMacintosh&&!this.useNativeFullScreen()&&(oe.fullscreenable=!1),I.isMacintosh&&(oe.acceptFirstMouse=!0,ie?.clickThroughInactive===!1&&(oe.acceptFirstMouse=!1));const ae=I.isMacintosh&&ie?.nativeTabs===!0;ae&&(oe.tabbingIdentifier=this.productService.nameShort);const ee=(0,D.getTitleBarStyle)(this.configurationService)==="custom";if(ee&&(oe.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,I.isMacintosh||(oe.frame=!1)),(0,t.mark)("code/willCreateCodeBrowserWindow"),this._win=new v.BrowserWindow(oe),(0,t.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),I.isMacintosh&&ee&&this._win.setSheetOffset(22),I.isMacintosh&&q&&(!ae||v.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(le=>typeof le=="number")){const le=this.windowState;this._win.setBounds({width:le.width,height:le.height,x:le.x,y:le.y})}Q&&((0,t.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,t.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,d.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:C=>B.globalStorage.get(C),store:(C,q)=>B.globalStorage.set(C,q)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(G){I.isMacintosh?this._win.setRepresentedFilename(G):this.representedFilename=G}getRepresentedFilename(){return I.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(G){I.isMacintosh&&this._win.setDocumentEdited(G),this.documentEdited=G}isDocumentEdited(){return I.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(G){I.isMacintosh&&G?.force&&v.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(G=>{if(this.isReady)return G(this);this.whenReadyCallbacks.push(G)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(G=>{function J(){W.dispose(),V.dispose(),G()}const W=this.onDidClose(()=>J()),V=this.onWillLoad(()=>J())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(B,$)=>this.onWindowError(2,$)),this._win.webContents.on("did-fail-load",(B,$,H)=>this.onWindowError(3,{reason:H,exitCode:$})),this._win.webContents.on("will-prevent-unload",B=>{B.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const G=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),J=B=>{for(let $=B;$;$=$.parent)if($.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},W=B=>B.resourceType==="xhr"||J(B.frame);this._win.webContents.session.webRequest.onBeforeRequest((B,$)=>{const H=b.URI.parse(B.url);return H.path.endsWith(".svg")&&!(G.has(H.scheme)||H.path.includes(f.Schemas.vscodeRemoteResource))?$({cancel:!W(B)}):$({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((B,$)=>{const H=B.responseHeaders,_=H["content-type"]||H["Content-Type"];if(_&&Array.isArray(_)){const j=b.URI.parse(B.url);if(j.path.endsWith(".svg")&&G.has(j.scheme))return H["Content-Type"]=["image/svg+xml"],$({cancel:!1,responseHeaders:H});if(!j.path.includes(f.Schemas.vscodeRemoteResource)&&_.some(T=>T.toLowerCase().includes("image/svg")))return $({cancel:!W(B)})}return $({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",B=>{this.currentConfig&&(this.currentConfig.maximized=!0),v.app.emit("browser-window-maximize",B,this._win)}),this._win.on("unmaximize",B=>{this.currentConfig&&(this.currentConfig.maximized=!1),v.app.emit("browser-window-unmaximize",B,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(B=>this.onDidDeleteUntitledWorkspace(B)));const V=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:V},async(B,$)=>{const H=await this.marketplaceHeadersPromise;$({cancel:!1,requestHeaders:Object.assign(B.requestHeaders,H)})})}async onWindowError(G,J){switch(G){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${J?.reason||"<unknown>"}, code: ${J?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${J?.reason||"<unknown>"}, code: ${J?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:G,reason:J?.reason,code:J?.exitCode}),G){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(G===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const W=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,y.localize)(0,null)),(0,E.mnemonicButtonLabel)((0,y.localize)(1,null)),(0,E.mnemonicButtonLabel)((0,y.localize)(2,null))],message:(0,y.localize)(3,null),detail:(0,y.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(!this._win)return;W.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):W.response===2&&this.destroyWindow()}else if(G===2){let W;J?W=(0,y.localize)(6,null,J.reason,J.exitCode??"<unknown>"):W=(0,y.localize)(5,null);const V=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,y.localize)(7,null)),(0,E.mnemonicButtonLabel)((0,y.localize)(8,null))],message:W,detail:(0,y.localize)(9,null),noLink:!0,defaultId:0},this._win);if(!this._win)return;V.response===0?this.reload():V.response===1&&this.destroyWindow()}break}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(G){this.openedWorkspace?.id===G.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const G=this.getMenuBarVisibility();G!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=G,this.setMenuBarVisibility(G));let J=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;J?.endsWith("/")&&(J=J.substr(0,J.length-1));const W=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((J||"").indexOf("@")===-1&&(J!==this.currentHttpProxy||W!==this.currentNoProxy)){this.currentHttpProxy=J,this.currentNoProxy=W;const V=J||"",B=W?`${W},<local>`:"<local>";this.logService.trace(`Setting proxy to '${V}', bypassing '${B}'`),this._win.webContents.session.setProxy({proxyRules:V,proxyBypassRules:B,pacScript:""})}}addTabbedWindow(G){I.isMacintosh&&G.win&&this._win.addTabbedWindow(G.win)}load(G,J=Object.create(null)){this.isDocumentEdited()&&(!J.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),J.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(G,J),this.readyState===0?this.currentConfig=G:(this.pendingLoadConfig=G,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",K).toString(!0));const W=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:G.workspace,reason:J.isReload?3:W?2:1})}updateConfiguration(G,J){const W=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(W){const V=(0,c.isLaunchedFromCli)(W)&&!(0,c.isLaunchedFromCli)(G.userEnv),B=this.isExtensionDevelopmentHost;(V||B)&&(G.userEnv={...W,...G.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(G.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),J.disableExtensions!==void 0&&(G["disable-extensions"]=J.disableExtensions),G.fullscreen=this.isFullScreen,G.maximized=this._win.isMaximized(),G.partsSplash=this.themeMainService.getWindowSplash(),(0,t.mark)("code/willOpenNewWindow"),G.perfMarks=(0,t.getMarks)(),this.configObjectUrl.update(G)}async reload(G){const J=Object.assign({},this.currentConfig);J.workspace=await this.validateWorkspaceBeforeReload(J),delete J.filesToOpenOrCreate,delete J.filesToDiff,delete J.filesToWait,this.isExtensionDevelopmentHost&&G&&(J.verbose=G.verbose,J.debugId=G.debugId,J["inspect-extensions"]=G["inspect-extensions"],J["inspect-brk-extensions"]=G["inspect-brk-extensions"],J["extensions-dir"]=G["extensions-dir"]),J.isInitialStartup=!1,this.load(J,{isReload:!0,disableExtensions:G?.["disable-extensions"]})}async validateWorkspaceBeforeReload(G){if((0,F.isWorkspaceIdentifier)(G.workspace)){const J=G.workspace.configPath;if(J.scheme===f.Schemas.file&&!await this.fileService.exists(J))return}else if((0,F.isSingleFolderWorkspaceIdentifier)(G.workspace)){const J=G.workspace.uri;if(J.scheme===f.Schemas.file&&!await this.fileService.exists(J))return}return G.workspace}serializeWindowState(){if(!this._win)return(0,R.defaultWindowState)();if(this.isFullScreen){let W;try{W=v.screen.getDisplayMatching(this.getBounds())}catch($){}const V=(0,R.defaultWindowState)();return{mode:3,display:W?W.id:void 0,width:this.windowState.width||V.width,height:this.windowState.height||V.height,x:this.windowState.x||0,y:this.windowState.y||0}}const G=Object.create(null);let J;if(!I.isMacintosh&&this._win.isMaximized()?J=0:J=1,J===0?G.mode=0:G.mode=1,J===1||J===0){let W;J===1?W=this.getBounds():W=this._win.getNormalBounds(),G.x=W.x,G.y=W.y,G.width=W.width,G.height=W.height}return G}restoreWindowState(G){(0,t.mark)("code/willRestoreCodeWindowState");let J=!1;if(G)try{const W=v.screen.getAllDisplays();J=W.length>1,G=this.validateWindowState(G,W)}catch(W){this.logService.warn(`Unexpected error validating window state: ${W}
${W.stack}`)}return(0,t.mark)("code/didRestoreCodeWindowState"),[G||(0,R.defaultWindowState)(),J]}validateWindowState(G,J){if(this.logService.trace(`window#validateWindowState: validating window state on ${J.length} display(s)`,G),typeof G.x!="number"||typeof G.y!="number"||typeof G.width!="number"||typeof G.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(G.width<=0||G.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(J.length===1){const B=this.getWorkingArea(J[0]);if(B){let $=function(){!G||typeof G.x!="number"||typeof G.y!="number"||!B||(G.x<B.x&&(G.x=B.x),G.y<B.y&&(G.y=B.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",B),$(),G.width>B.width&&(G.width=B.width),G.height>B.height&&(G.height=B.height),G.x>B.x+B.width-128&&(G.x=B.x+B.width-G.width),G.y>B.y+B.height-128&&(G.y=B.y+B.height-G.height),$()}return G}if(G.display&&G.mode===3){const B=J.find($=>$.id===G.display);if(B&&typeof B.bounds?.x=="number"&&typeof B.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const $=(0,R.defaultWindowState)(3);return $.x=B.bounds.x,$.y=B.bounds.y,$}}let W,V;try{W=v.screen.getDisplayMatching({x:G.x,y:G.y,width:G.width,height:G.height}),V=this.getWorkingArea(W)}catch(B){}if(W&&V&&G.x+G.width>V.x&&G.y+G.height>V.y&&G.x<V.x+V.width&&G.y<V.y+V.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",V),G}getWorkingArea(G){if(G.workArea.width>0&&G.workArea.height>0)return G.workArea;if(G.bounds.width>0&&G.bounds.height>0)return G.bounds}getBounds(){const[G,J]=this._win.getPosition(),[W,V]=this._win.getSize();return{x:G,y:J,width:W,height:V}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(G){this.useNativeFullScreen()?this.setNativeFullScreen(G):this.setSimpleFullScreen(G),this.sendWhenReady(G?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(G){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(G)}setSimpleFullScreen(G){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(G),this._win.webContents.focus()}useNativeFullScreen(){const G=this.configurationService.getValue("window");return!G||typeof G.nativeFullScreen!="boolean"||G.nativeTabs?!0:G.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let G=(0,D.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(G)<0&&(G="classic"),G}setMenuBarVisibility(G,J=!0){I.isMacintosh||(G==="toggle"&&J&&this.send("vscode:showInfoMessage",(0,y.localize)(10,null)),G==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(G)}):this.doSetMenuBarVisibility(G))}doSetMenuBarVisibility(G){const J=this.isFullScreen;switch(G){case"classic":this._win.setMenuBarVisibility(!J),this._win.autoHideMenuBar=J;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(I.isMacintosh)switch(v.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(G,J,...W){this.isReady?this.send(G,...W):this.ready().then(()=>{J.isCancellationRequested||this.send(G,...W)})}send(G,...J){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${G} for window that is destroyed`);return}this._win.webContents.send(G,...J)}}updateTouchBar(G){!I.isMacintosh||this.touchBarGroups.forEach((J,W)=>{const V=G[W];J.segments=this.createTouchBarGroupSegments(V)})}createTouchBar(){if(!!I.isMacintosh){for(let G=0;G<10;G++){const J=this.createTouchBarGroup();this.touchBarGroups.push(J)}this._win.setTouchBar(new v.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(G=[]){const J=this.createTouchBarGroupSegments(G),W=new v.TouchBar.TouchBarSegmentedControl({segments:J,mode:"buttons",segmentStyle:"automatic",change:V=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:W.segments[V].id,from:"touchbar"})}});return W}createTouchBarGroupSegments(G=[]){return G.map(W=>{let V;W.icon&&!m.ThemeIcon.isThemeIcon(W.icon)&&W.icon?.dark?.scheme===f.Schemas.file&&(V=v.nativeImage.createFromPath(b.URI.revive(W.icon.dark).fsPath),V.isEmpty()&&(V=void 0));let B;return typeof W.title=="string"?B=W.title:B=W.title.value,{id:W.id,label:V?void 0:B,icon:V}})}dispose(){super.dispose(),this._win=null}};ne=he([te(1,i.ILogService),te(2,p.IEnvironmentMainService),te(3,o.IFileService),te(4,s.IStorageMainService),te(5,g.IConfigurationService),te(6,S.IThemeMainService),te(7,U.IWorkspacesManagementMainService),te(8,h.IBackupMainService),te(9,l.ITelemetryService),te(10,P.IDialogMainService),te(11,u.ILifecycleMainService),te(12,a.IProductService),te(13,r.IProtocolMainService)],ne),e.CodeWindow=ne}),define(Z[63],x([0,1,14,32,9,4,34,2,10,3,15,7,19,152,5,22,6,39,27,46]),function(K,e,v,L,k,M,E,n,f,w,t,I,b,y,h,g,P,p,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,h.createDecorator)("workspacesHistoryMainService");let o=class je extends n.Disposable{constructor(m,S,D,R){super();this.stateMainService=m,this.logService=S,this.workspacesManagementMainService=D,this.lifecycleMainService=R,this._onDidChangeRecentlyOpened=this._register(new M.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(m=>this.addRecentlyOpened([{workspace:m.workspace}])))}handleWindowsJumpList(){!w.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(m){const S=[],D=[];for(let R of m)if((0,c.isRecentWorkspace)(R))!this.workspacesManagementMainService.isUntitledWorkspace(R.workspace)&&a(S,R.workspace)===-1&&S.push(R);else if((0,c.isRecentFolder)(R))r(S,R.folderUri)===-1&&S.push(R);else{const F=s(D,R.fileUri)>=0,U=R.fileUri.scheme===f.Schemas.file&&je.COMMON_FILES_FILTER.indexOf((0,t.basename)(R.fileUri))>=0;!F&&!U&&(D.push(R),w.isWindows&&R.fileUri.scheme===f.Schemas.file&&v.app.addRecentDocument(R.fileUri.fsPath))}this.addEntriesFromStorage(S,D),S.length>je.MAX_TOTAL_RECENT_ENTRIES&&(S.length=je.MAX_TOTAL_RECENT_ENTRIES),D.length>je.MAX_TOTAL_RECENT_ENTRIES&&(D.length=je.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:S,files:D}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(m){const S=U=>{const X=i(U);for(const ne of m)if(t.extUriBiasedIgnorePathCase.isEqual(ne,X))return!1;return!0},D=this.getRecentlyOpened(),R=D.workspaces.filter(S),F=D.files.filter(S);(R.length!==D.workspaces.length||F.length!==D.files.length)&&(this.saveRecentlyOpened({files:F,workspaces:R}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!w.isMacintosh)return;v.app.clearRecentDocuments();const m=this.getRecentlyOpened(),S=[];let D=0;for(let F=0;F<m.workspaces.length&&D<je.MAX_MACOS_DOCK_RECENT_WORKSPACES;F++){const U=i(m.workspaces[F]);if(U.scheme===f.Schemas.file){const X=(0,t.originalFSPath)(U);await b.Promises.exists(X)&&(S.push(X),D++)}}const R=[];for(let F=0;F<m.files.length&&D<je.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;F++){const U=i(m.files[F]);if(U.scheme===f.Schemas.file){const X=(0,t.originalFSPath)(U);if(je.COMMON_FILES_FILTER.includes((0,t.basename)(U))||S.includes(X))continue;await b.Promises.exists(X)&&(R.push(X),D++)}}R.reverse().forEach(F=>v.app.addRecentDocument(F)),S.reverse().forEach(F=>v.app.addRecentDocument(F))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),v.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(m){const S=[],D=[],R=m?.config?.workspace;(0,c.isWorkspaceIdentifier)(R)&&!this.workspacesManagementMainService.isUntitledWorkspace(R)?S.push({workspace:R}):(0,c.isSingleFolderWorkspaceIdentifier)(R)&&S.push({folderUri:R.uri});const F=m?.config?.filesToOpenOrCreate;if(F)for(let U of F){const X=U.fileUri;X&&s(D,X)===-1&&D.push({fileUri:X})}return this.addEntriesFromStorage(S,D),{workspaces:S,files:D}}addEntriesFromStorage(m,S){let D=this.getRecentlyOpenedFromStorage();for(let R of D.workspaces){let F=(0,c.isRecentFolder)(R)?r(m,R.folderUri):a(m,R.workspace);F>=0?m[F].label=m[F].label||R.label:m.push(R)}for(let R of D.files){let F=s(S,R.fileUri);F>=0?S[F].label=S[F].label||R.label:S.push(R)}}getRecentlyOpenedFromStorage(){const m=this.stateMainService.getItem(je.recentlyOpenedStorageKey);return(0,c.restoreRecentlyOpened)(m,this.logService)}saveRecentlyOpened(m){const S=(0,c.toStoreData)(m);this.stateMainService.setItem(je.recentlyOpenedStorageKey,S)}updateWindowsJumpList(){if(!w.isWindows)return;const m=[];if(m.push({type:"tasks",items:[{type:"task",title:(0,y.localize)(0,null),description:(0,y.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let S=[];for(let F of v.app.getJumpListSettings().removedItems){const U=F.args;if(U){const X=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(U);X&&S.push(I.URI.parse(X[2]))}}this.removeRecentlyOpened(S);let D=!1;const R=(0,L.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(F=>{const U=(0,c.isRecentWorkspace)(F)?F.workspace:F.folderUri,{title:X,description:ne}=this.getWindowsJumpListLabel(U,F.label);let se;return I.URI.isUri(U)?se=`--folder-uri "${U.toString()}"`:(D=!0,se=`--file-uri "${U.configPath.toString()}"`),{type:"task",title:X.substr(0,255),description:ne.substr(0,255),program:process.execPath,args:se,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&m.push({type:"custom",name:D?(0,y.localize)(2,null):(0,y.localize)(3,null),items:R})}m.push({type:"recent"});try{v.app.setJumpList(m)}catch(S){this.logService.warn("updateWindowsJumpList#setJumpList",S)}}getWindowsJumpListLabel(m,S){if(S)return{title:(0,E.splitName)(S).name,description:S};if(I.URI.isUri(m))return{title:(0,t.basename)(m),description:u(m)};if(this.workspacesManagementMainService.isUntitledWorkspace(m))return{title:(0,y.localize)(4,null),description:""};let D=(0,t.basename)(m.configPath);return D.endsWith(c.WORKSPACE_EXTENSION)&&(D=D.substr(0,D.length-c.WORKSPACE_EXTENSION.length-1)),{title:(0,y.localize)(5,null,D),description:u(m.configPath)}}};o.MAX_TOTAL_RECENT_ENTRIES=100,o.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,o.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],o.recentlyOpenedStorageKey="openedPathsList",o=he([te(0,p.IStateMainService),te(1,P.ILogService),te(2,d.IWorkspacesManagementMainService),te(3,g.ILifecycleMainService)],o),e.WorkspacesHistoryMainService=o;function u(l){return l.scheme==="file"?(0,E.normalizeDriveLetter)(l.fsPath):l.toString()}function i(l){return(0,c.isRecentFolder)(l)?l.folderUri:(0,c.isRecentFile)(l)?l.fileUri:l.workspace.configPath}function a(l,m){return l.findIndex(S=>(0,c.isRecentWorkspace)(S)&&S.workspace.id===m.id)}function r(l,m){return l.findIndex(S=>(0,c.isRecentFolder)(S)&&t.extUriBiasedIgnorePathCase.isEqual(S.folderUri,m))}function s(l,m){return l.findIndex(S=>t.extUriBiasedIgnorePathCase.isEqual(S.fileUri,m))}}),define(Z[234],x([0,1,14,9,23,34,3,7,144,16,24,22,6,182,53,21,39,29,42,62,36,63]),function(K,e,v,L,k,M,E,n,f,w,t,I,b,y,h,g,P,p,c,d,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let a=class wt{constructor(l,m,S,D,R,F,U,X,ne,se,G){this.updateService=l,this.configurationService=m,this.windowsMainService=S,this.environmentMainService=D,this.telemetryService=R,this.workspacesHistoryMainService=F,this.stateMainService=U,this.lifecycleMainService=X,this.logService=ne,this.nativeHostMainService=se,this.productService=G,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(E.isMacintosh||(0,d.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const l=this.stateMainService.getItem(wt.lastKnownMenubarStorageKey);l&&(l.menus&&(this.menubarMenus=l.menus),l.keybindings&&(this.keybindings=l.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(F,U,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:U?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(F,U,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:U?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(F,U,X)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(F,U,X)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const l=this.productService.twitterUrl;l&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(l,"openTwitterUrl"));const m=this.productService.requestFeatureUrl;m&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(m,"openUserVoiceUrl"));const S=this.productService.reportIssueUrl;S&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(S,"openReportIssues"));const D=this.productService.licenseUrl;D&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(E.language){const F=D.indexOf("?")>0?"&":"?";this.openUrl(`${D}${F}lang=${E.language}`,"openLicenseUrl")}else this.openUrl(D,"openLicenseUrl")});const R=this.productService.privacyStatementUrl;R&&D&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(R,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(l=>this.onDidChangeWindowsCount(l)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let l=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof l!="boolean"?!0:l}get currentEnableNativeTabs(){if(!E.isMacintosh)return!1;let l=this.configurationService.getValue("window.nativeTabs");return typeof l!="boolean"?!1:l}updateMenu(l,m){this.menubarMenus=l.menus,this.keybindings=l.keybindings,this.stateMainService.setItem(wt.lastKnownMenubarStorageKey,l),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(l){!E.isMacintosh||(l.oldCount===0&&l.newCount>0||l.oldCount>0&&l.newCount===0)&&(this.closedLastWindow=l.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!E.isMacintosh||(this.noActiveWindow=!v.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const l=v.Menu.getApplicationMenu();if(l&&this.oldMenus.push(l),Object.keys(this.menubarMenus).length===0){v.Menu.setApplicationMenu(E.isMacintosh?new v.Menu:null);return}const m=new v.Menu;let S;if(E.isMacintosh){const R=new v.Menu;S=new v.MenuItem({label:this.productService.nameShort,submenu:R}),this.setMacApplicationMenu(R),m.append(S)}if(E.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const R=new v.Menu;R.append(new v.MenuItem({label:this.mnemonicLabel(f.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),v.app.dock.setMenu(R)}if(this.shouldDrawMenu("File")){const R=new v.Menu,F=new v.MenuItem({label:this.mnemonicLabel(f.localize(1,null)),submenu:R});this.setMenuById(R,"File"),m.append(F)}if(this.shouldDrawMenu("Edit")){const R=new v.Menu,F=new v.MenuItem({label:this.mnemonicLabel(f.localize(2,null)),submenu:R});this.setMenuById(R,"Edit"),m.append(F)}if(this.shouldDrawMenu("Selection")){const R=new v.Menu,F=new v.MenuItem({label:this.mnemonicLabel(f.localize(3,null)),submenu:R});this.setMenuById(R,"Selection"),m.append(F)}if(this.shouldDrawMenu("View")){const R=new v.Menu,F=new v.MenuItem({label:this.mnemonicLabel(f.localize(4,null)),submenu:R});this.setMenuById(R,"View"),m.append(F)}if(this.shouldDrawMenu("Go")){const R=new v.Menu,F=new v.MenuItem({label:this.mnemonicLabel(f.localize(5,null)),submenu:R});this.setMenuById(R,"Go"),m.append(F)}if(this.shouldDrawMenu("Run")){const R=new v.Menu,F=new v.MenuItem({label:this.mnemonicLabel(f.localize(6,null)),submenu:R});this.setMenuById(R,"Run"),m.append(F)}if(this.shouldDrawMenu("Terminal")){const R=new v.Menu,F=new v.MenuItem({label:this.mnemonicLabel(f.localize(7,null)),submenu:R});this.setMenuById(R,"Terminal"),m.append(F)}let D;if(this.shouldDrawMenu("Window")){const R=new v.Menu;D=new v.MenuItem({label:this.mnemonicLabel(f.localize(8,null)),submenu:R,role:"window"}),this.setMacWindowMenu(R)}if(D&&m.append(D),this.shouldDrawMenu("Help")){const R=new v.Menu,F=new v.MenuItem({label:this.mnemonicLabel(f.localize(9,null)),submenu:R,role:"help"});this.setMenuById(R,"Help"),m.append(F)}m.items&&m.items.length>0?v.Menu.setApplicationMenu(m):v.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(l){const m=this.createMenuItem(f.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),S=this.getUpdateMenuItems();let D;if(this.shouldDrawMenu("Preferences")){const J=new v.Menu;this.setMenuById(J,"Preferences"),D=new v.MenuItem({label:this.mnemonicLabel(f.localize(11,null)),submenu:J})}const R=new v.Menu,F=new v.MenuItem({label:f.localize(12,null),role:"services",submenu:R}),U=new v.MenuItem({label:f.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),X=new v.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ne=new v.MenuItem({label:f.localize(15,null),role:"unhide"}),se=new v.MenuItem(this.likeAction("workbench.action.quit",{label:f.localize(16,null,this.productService.nameLong),click:()=>{const J=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!v.BrowserWindow.getFocusedWindow()||J?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),G=[m];G.push(...S),D&&G.push(r(),D),G.push(r(),F,r(),U,X,ne,r(),se),G.forEach(J=>l.append(J))}shouldDrawMenu(l){if(!E.isMacintosh&&(0,d.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(l){case"File":case"Help":if(E.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[l];case"Window":if(E.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[l]}}setMenu(l,m){m.forEach(S=>{if((0,y.isMenubarMenuItemSeparator)(S))l.append(r());else if((0,y.isMenubarMenuItemSubmenu)(S)){const D=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(S.label),submenu:D});this.setMenu(D,S.submenu.items),l.append(R)}else(0,y.isMenubarMenuItemRecentAction)(S)?l.append(this.createOpenRecentMenuItem(S)):(0,y.isMenubarMenuItemAction)(S)&&(S.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(l),E.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[S.id]?l.append(new v.MenuItem(this.likeAction(S.id,{label:this.mnemonicLabel(S.label),click:this.fallbackMenuHandlers[S.id]}))):l.append(this.createMenuItem(S.label,S.id,!1,S.checked)):l.append(this.createMenuItem(S.label,S.id,S.enabled!==!1,!!S.checked)):l.append(this.createMenuItem(S.label,S.id,S.enabled!==!1,!!S.checked)))})}setMenuById(l,m){this.menubarMenus&&this.menubarMenus[m]&&this.setMenu(l,this.menubarMenus[m].items)}insertCheckForUpdatesItems(l){const m=this.getUpdateMenuItems();m.length&&(m.forEach(S=>l.append(S)),l.append(r()))}createOpenRecentMenuItem(l){const m=n.URI.revive(l.uri),S=l.id,D=S==="openRecentFile"?{fileUri:m}:S==="openRecentWorkspace"?{workspaceUri:m}:{folderUri:m};return new v.MenuItem(this.likeAction(S,{label:l.label,click:(R,F,U)=>{const X=this.isOptionClick(U);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[D],forceNewWindow:X,gotoLineMode:!1,remoteAuthority:l.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([m])}},!1))}isOptionClick(l){return!!(l&&(!E.isMacintosh&&(l.ctrlKey||l.shiftKey)||E.isMacintosh&&(l.metaKey||l.altKey)))}createRoleMenuItem(l,m,S){const D={label:this.mnemonicLabel(l),role:S,enabled:!0};return new v.MenuItem(this.withKeybinding(m,D))}setMacWindowMenu(l){const m=new v.MenuItem({label:f.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),S=new v.MenuItem({label:f.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),D=new v.MenuItem({label:f.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),R=this.createMenuItem(f.localize(20,null),"workbench.action.switchWindow"),F=[];this.currentEnableNativeTabs&&(F.push(r()),F.push(this.createMenuItem(f.localize(21,null),"workbench.action.newWindowTab")),F.push(this.createRoleMenuItem(f.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),F.push(this.createRoleMenuItem(f.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),F.push(this.createRoleMenuItem(f.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),F.push(this.createRoleMenuItem(f.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[m,S,r(),R,...F,r(),D].forEach(U=>l.append(U))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new v.MenuItem({label:f.localize(27,null),enabled:!1})];case"available for download":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new v.MenuItem({label:f.localize(29,null),enabled:!1})];case"downloaded":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new v.MenuItem({label:f.localize(31,null),enabled:!1})];case"ready":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(l,m,S,D){const R=this.mnemonicLabel(l),F=typeof m=="function"?m:(G,J,W)=>{const V=G?G.userSettingsLabel:null;let B=m;Array.isArray(m)&&(B=this.isOptionClick(W)?m[1]:m[0]),V&&W.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:V}):this.runActionInRenderer({type:"commandId",commandId:B})},U=typeof S=="boolean"?S:this.windowsMainService.getWindowCount()>0,X=typeof D=="boolean"?D:!1,ne={label:R,click:F,enabled:U};X&&(ne.type="checkbox",ne.checked=X);let se;return typeof m=="string"?se=m:Array.isArray(m)&&(se=m[0]),E.isMacintosh&&(se==="editor.action.clipboardCutAction"?ne.role="cut":se==="editor.action.clipboardCopyAction"?ne.role="copy":se==="editor.action.clipboardPasteAction"&&(ne.role="paste"),se==="undo"?ne.click=this.makeContextAwareClickHandler(F,{inDevTools:G=>G.undo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("undo:")}):se==="redo"?ne.click=this.makeContextAwareClickHandler(F,{inDevTools:G=>G.redo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("redo:")}):se==="editor.action.selectAll"&&(ne.click=this.makeContextAwareClickHandler(F,{inDevTools:G=>G.selectAll(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("selectAll:")}))),new v.MenuItem(this.withKeybinding(se,ne))}makeContextAwareClickHandler(l,m){return(S,D,R)=>{const F=v.BrowserWindow.getFocusedWindow();if(!F)return m.inNoWindow();if(F.webContents.isDevToolsFocused()&&F.webContents.devToolsWebContents)return m.inDevTools(F.webContents.devToolsWebContents);l(S,D||F,R)}}runActionInRenderer(l){let m=v.BrowserWindow.getFocusedWindow();if(!m){const D=this.windowsMainService.getLastActiveWindow();D?.isMinimized()&&(m=D.win)}const S=m?this.windowsMainService.getWindowById(m.id):void 0;if(S){if(this.logService.trace("menubar#runActionInRenderer",l),E.isMacintosh&&!this.environmentMainService.isBuilt&&!S.isReady&&(l.type==="commandId"&&l.commandId==="workbench.action.toggleDevTools"||l.type!=="commandId"&&l.userSettingsLabel==="alt+cmd+i"))return;if(l.type==="commandId"){const D={id:l.commandId,from:"menu"};S.sendWhenReady("vscode:runAction",k.CancellationToken.None,D)}else{const D={userSettingsLabel:l.userSettingsLabel};S.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,D)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",l)}withKeybinding(l,m){const S=typeof l=="string"?this.keybindings[l]:void 0;if(S?.label){if(S.isNative!==!1)m.accelerator=S.label,m.userSettingsLabel=S.userSettingsLabel;else if(typeof m.label=="string"){const D=m.label.indexOf("[");D>=0?m.label=`${m.label.substr(0,D)} [${S.label}]`:m.label=`${m.label} [${S.label}]`}}else m.accelerator=void 0;return m}likeAction(l,m,S=!m.accelerator){S&&(m=this.withKeybinding(l,m));const D=m.click;return m.click=(R,F,U)=>{this.reportMenuActionTelemetry(l),D&&D(R,F,U)},m}openUrl(l,m){this.nativeHostMainService.openExternal(void 0,l),this.reportMenuActionTelemetry(m)}reportMenuActionTelemetry(l){this.telemetryService.publicLog2("workbenchActionExecuted",{id:l,from:i})}mnemonicLabel(l){return(0,M.mnemonicMenuLabel)(l,!this.currentEnableMenuBarMnemonics)}};a.lastKnownMenubarStorageKey="lastKnownMenubarData",a=he([te(0,c.IUpdateService),te(1,w.IConfigurationService),te(2,o.IWindowsMainService),te(3,t.IEnvironmentMainService),te(4,p.ITelemetryService),te(5,u.IWorkspacesHistoryMainService),te(6,P.IStateMainService),te(7,I.ILifecycleMainService),te(8,b.ILogService),te(9,h.INativeHostMainService),te(10,g.IProductService)],a),e.Menubar=a;function r(){return new v.MenuItem({type:"separator"})}}),define(Z[235],x([0,1,5,22,6,234]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,v.createDecorator)("menubarMainService");let E=class{constructor(f,w,t){this.instantiationService=f,this.lifecycleMainService=w,this.logService=t,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(M.Menubar)}async updateMenubar(f,w){this.logService.trace("menubarService#updateMenubar",f),(await this.menubar).updateMenu(w,f)}};E=he([te(0,v.IInstantiationService),te(1,L.ILifecycleMainService),te(2,k.ILogService)],E),e.MenubarMainService=E}),define(Z[236],x([0,1,14,31,26,32,23,4,30,43,34,2,10,8,73,3,33,15,13,7,150,51,16,52,24,20,5,22,6,45,21,55,74,39,62,233,99,216,27,100,63,46]),function(K,e,v,L,k,M,E,n,f,w,t,I,b,y,h,g,P,p,c,d,o,u,i,a,r,s,l,m,S,D,R,F,U,X,ne,se,G,J,W,V,B,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function H(T){return(0,W.isWorkspaceIdentifier)(T?.workspace)}function _(T){return(0,W.isSingleFolderWorkspaceIdentifier)(T?.workspace)}let j=class Je extends I.Disposable{constructor(A,O,z,N,C,q,Q,ie,oe,ae,ee,le,me,ue,ve){super();this.machineId=A,this.initialUserEnv=O,this.logService=z,this.stateMainService=N,this.environmentMainService=C,this.lifecycleMainService=q,this.backupMainService=Q,this.configurationService=ie,this.workspacesHistoryMainService=oe,this.workspacesManagementMainService=ae,this.instantiationService=ee,this.dialogMainService=le,this.fileService=me,this.productService=ue,this.protocolMainService=ve,this._onDidOpenWindow=this._register(new n.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new n.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new n.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new n.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new J.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(A=>this._onDidSignalReadyWindow.fire(A.window))),this._register(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const O=new I.DisposableStore;if(O.add(n.Event.any(A.onDidClose,A.onDidDestroy)(()=>O.dispose())),A.config.extensionDevelopmentPath)for(const z of A.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(d.URI.file(z)));A.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(d.URI.file(A.config.extensionTestsPath)))}}))}openEmptyWindow(A,O){let z=this.environmentMainService.args;const N=O?.remoteAuthority||void 0,C=!0,q=O?.forceReuseWindow,Q=!q;return this.open({...A,cli:z,forceEmpty:C,forceNewWindow:Q,forceReuseWindow:q,remoteAuthority:N})}open(A){this.logService.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const O=[],z=[],N=[],C=[],q=[];let Q,ie=0;const oe=this.getPathsToOpen(A);this.logService.trace("windowsManager#open pathsToOpen",oe);for(const ue of oe)_(ue)?A.addMode?O.push(ue):z.push(ue):H(ue)?N.push(ue):ue.fileUri?(Q||(Q={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:ue.remoteAuthority}),Q.filesToOpenOrCreate.push(ue)):ue.backupPath?q.push({backupFolder:(0,y.basename)(ue.backupPath),remoteAuthority:ue.remoteAuthority}):ie++;A.diffMode&&Q&&Q.filesToOpenOrCreate.length>=2&&(Q.filesToDiff=Q.filesToOpenOrCreate.slice(0,2),Q.filesToOpenOrCreate=[]),Q&&A.waitMarkerFileURI&&(Q.filesToWait={paths:[...Q.filesToDiff,...Q.filesToOpenOrCreate],waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(C.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),N.push(...C),q.push(...this.backupMainService.getEmptyWindowBackupPaths())):q.length=0;const{windows:ae,filesOpenedInWindow:ee}=this.doOpen(A,N,z,q,ie,Q,O);if(this.logService.trace(`windowsManager#open used window count ${ae.length} (workspacesToOpen: ${N.length}, foldersToOpen: ${z.length}, emptyToRestore: ${q.length}, emptyToOpen: ${ie})`),ae.length>1)if(ee)ee.focus();else{const ue=this.windowsStateHandler.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let ve=!0,Pe=!0;if(ue){const we=ae.filter(fe=>this.windowsStateHandler.state.lastActiveWindow&&fe.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),ve=!1,Pe=!1)}if(ve)for(let we=ae.length-1;we>=0;we--){const fe=ae[we];if(!(fe.openedWorkspace&&C.some(Ee=>fe.openedWorkspace&&Ee.workspace.id===fe.openedWorkspace.id)||fe.backupPath&&q.some(Ee=>fe.backupPath&&Ee.backupFolder===(0,y.basename)(fe.backupPath)))){fe.focus(),Pe=!1;break}}Pe&&ae[ae.length-1].focus()}const le=Q&&Q.filesToDiff.length>0;if(!ae.some(ue=>ue.isExtensionDevelopmentHost)&&!le&&!A.noRecentEntry){const ue=[];for(const ve of oe)H(ve)&&!ve.transient?ue.push({label:ve.label,workspace:ve.workspace,remoteAuthority:ve.remoteAuthority}):_(ve)?ue.push({label:ve.label,folderUri:ve.workspace.uri,remoteAuthority:ve.remoteAuthority}):ve.fileUri&&ue.push({label:ve.label,fileUri:ve.fileUri,remoteAuthority:ve.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ue)}const me=A.waitMarkerFileURI;return A.context===0&&me&&ae.length===1&&ae[0]&&(async()=>{await ae[0].whenClosedOrLoaded;try{await this.fileService.del(me)}catch(ue){}})(),ae}doOpen(A,O,z,N,C,q,Q){const ie=[];let oe;function ae(we,fe){ie.push(we),fe&&(oe=we,q=void 0)}let{openFolderInNewWindow:ee,openFilesInNewWindow:le}=this.shouldOpenNewWindow(A);if(!A.initialStartup&&Q.length>0){const we=Q[0].remoteAuthority,fe=this.getLastActiveWindowForAuthority(we);fe&&ae(this.doAddFoldersToExistingWindow(fe,Q.map(Ee=>Ee.workspace.uri)))}const me=z.length+O.length+N.length;if(q&&me===0){const we=q.filesToOpenOrCreate[0]||q.filesToDiff[0],fe=this.getWindows().filter(De=>q&&De.remoteAuthority===q.remoteAuthority);let Ee;we?.fileUri&&!le&&((A.context===4||A.context===0||A.context===1)&&(Ee=(0,G.findWindowOnFile)(fe,we.fileUri,De=>De.configPath.scheme===b.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(De.configPath):void 0)),Ee||(Ee=this.doGetLastActiveWindow(fe))),Ee?(0,W.isWorkspaceIdentifier)(Ee.openedWorkspace)?O.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):(0,W.isSingleFolderWorkspaceIdentifier)(Ee.openedWorkspace)?z.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):ae(this.doOpenFilesInExistingWindow(A,Ee,q),!0):ae(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:q,forceNewWindow:!0,remoteAuthority:q.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow}),!0)}const ue=(0,M.distinct)(O,we=>we.workspace.id);if(ue.length>0){const we=(0,M.coalesce)(ue.map(fe=>(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe.workspace.configPath)));if(we.length>0){const fe=we[0],Ee=q?.remoteAuthority===fe.remoteAuthority?q:void 0;ae(this.doOpenFilesInExistingWindow(A,fe,Ee),!!Ee),ee=!0}ue.forEach(fe=>{if(we.some(Ae=>Ae.openedWorkspace&&Ae.openedWorkspace.id===fe.workspace.id))return;const Ee=fe.remoteAuthority,De=q?.remoteAuthority===Ee?q:void 0;ae(this.doOpenFolderOrWorkspace(A,fe,ee,De),!!De),ee=!0})}const ve=(0,M.distinct)(z,we=>p.extUriBiasedIgnorePathCase.getComparisonKey(we.workspace.uri));if(ve.length>0){const we=(0,M.coalesce)(ve.map(fe=>(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),fe.workspace.uri)));if(we.length>0){const fe=we[0],Ee=q?.remoteAuthority===fe.remoteAuthority?q:void 0;ae(this.doOpenFilesInExistingWindow(A,fe,Ee),!!Ee),ee=!0}ve.forEach(fe=>{if(we.some(Ae=>(0,W.isSingleFolderWorkspaceIdentifier)(Ae.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(Ae.openedWorkspace.uri,fe.workspace.uri)))return;const Ee=fe.remoteAuthority,De=q?.remoteAuthority===Ee?q:void 0;ae(this.doOpenFolderOrWorkspace(A,fe,ee,De),!!De),ee=!0})}const Pe=(0,M.distinct)(N,we=>we.backupFolder);if(Pe.length>0&&Pe.forEach(we=>{const fe=we.remoteAuthority,Ee=q?.remoteAuthority===fe?q:void 0;ae(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:Ee,remoteAuthority:fe,forceNewWindow:!0,forceNewTabbedWindow:A.forceNewTabbedWindow,emptyWindowBackupInfo:we}),!!Ee),ee=!0}),ie.length===0||q){q&&!C&&C++;const we=q?q.remoteAuthority:A.remoteAuthority;for(let fe=0;fe<C;fe++)ae(this.doOpenEmpty(A,ee,we,q),!!q),ee=!0}return{windows:(0,M.distinct)(ie),filesOpenedInWindow:oe}}doOpenFilesInExistingWindow(A,O,z){this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),O.focus();const N={filesToOpenOrCreate:z?.filesToOpenOrCreate,filesToDiff:z?.filesToDiff,filesToWait:z?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",E.CancellationToken.None,N),O}doAddFoldersToExistingWindow(A,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),A.focus();const z={foldersToAdd:O};return A.sendWhenReady("vscode:addFolders",E.CancellationToken.None,z),A}doOpenEmpty(A,O,z,N,C){return!O&&!C&&typeof A.contextWindowId=="number"&&(C=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:z,forceNewWindow:O,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:N,windowToUse:C})}doOpenFolderOrWorkspace(A,O,z,N,C){return!z&&!C&&typeof A.contextWindowId=="number"&&(C=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:z,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:N,windowToUse:C})}getPathsToOpen(A){let O,z=!1,N=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(O=this.doExtractPathsFromAPI(A),z=!0):A.forceEmpty?O=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(O=this.doExtractPathsFromCLI(A.cli),O.length===0&&O.push(Object.create(null)),z=!0):(O=this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),N=!0),!A.addMode&&z){const C=O.filter(q=>_(q));if(C.length>1){const q=C[0].remoteAuthority;if(C.every(Q=>Q.remoteAuthority===q)){const Q=this.workspacesManagementMainService.createUntitledWorkspaceSync(C.map(ie=>({uri:ie.workspace.uri})));O.push({workspace:Q,remoteAuthority:q}),O=O.filter(ie=>!_(ie))}}}return A.initialStartup&&!N&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&O.unshift(...this.doGetPathsFromLastSession().filter(C=>H(C)||_(C)||C.backupPath)),O}doExtractPathsFromAPI(A){const O=[],z={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority};for(const N of(0,M.coalesce)(A.urisToOpen||[])){const C=this.resolveOpenable(N,z);if(C)C.label=N.label,O.push(C);else{const q=this.resourceFromOpenable(N),Q={title:this.productService.nameLong,type:"info",buttons:[(0,t.mnemonicButtonLabel)((0,o.localize)(0,null))],defaultId:0,message:q.scheme===b.Schemas.file?(0,o.localize)(1,null):(0,o.localize)(2,null),detail:q.scheme===b.Schemas.file?(0,o.localize)(3,null,(0,t.getPathLabel)(q.fsPath,this.environmentMainService)):(0,o.localize)(4,null,q.toString()),noLink:!0};this.dialogMainService.showMessageBox(Q,(0,c.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))}}return O}doExtractPathsFromCLI(A){const O=[],z={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:!1},N=A["folder-uri"];if(N)for(const Q of N){const ie=this.cliArgToUri(Q);if(ie){const oe=this.resolveOpenable({folderUri:ie},z);oe&&O.push(oe)}}const C=A["file-uri"];if(C)for(const Q of C){const ie=this.cliArgToUri(Q);if(ie){const oe=this.resolveOpenable((0,W.hasWorkspaceFileExtension)(Q)?{workspaceUri:ie}:{fileUri:ie},z);oe&&O.push(oe)}}const q=A._;for(const Q of q){const ie=z.remoteAuthority?this.doResolvePathRemote(Q,z):this.doResolveFilePath(Q,z);ie&&O.push(ie)}return O}cliArgToUri(A){try{const O=d.URI.parse(A);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${A}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${A}, ${O.message}`)}}doGetPathsFromLastSession(){const A=this.getRestoreWindowsSetting();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":const O=[];A!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const z=[];for(const N of O)if(N.workspace){const C=this.resolveOpenable({workspaceUri:N.workspace.configPath},{remoteAuthority:N.remoteAuthority,rejectTransientWorkspaces:!0});H(C)&&z.push(C)}else if(N.folderUri){const C=this.resolveOpenable({folderUri:N.folderUri},{remoteAuthority:N.remoteAuthority});_(C)&&z.push(C)}else A!=="folders"&&N.backupPath&&z.push({backupPath:N.backupPath,remoteAuthority:N.remoteAuthority});return z}}getRestoreWindowsSetting(){let A;return this.lifecycleMainService.wasRestarted?A="all":(A=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}resolveOpenable(A,O=Object.create(null)){let z=this.resourceFromOpenable(A);return z.scheme===b.Schemas.file?((0,ne.isFileToOpen)(A)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(z.fsPath,O)):this.doResolveRemoteOpenable(A,O)}doResolveRemoteOpenable(A,O){let z=this.resourceFromOpenable(A);const N=(0,U.getRemoteAuthority)(z)||O.remoteAuthority;if(z=(0,p.removeTrailingPathSeparator)((0,p.normalizePath)(z)),(0,ne.isFileToOpen)(A)){if(O.gotoLineMode){const{path:C,line:q,column:Q}=(0,f.parseLineAndColumnAware)(z.path);return{fileUri:z.with({path:C}),selection:q?{startLineNumber:q,startColumn:Q||1}:void 0,remoteAuthority:N}}return{fileUri:z,remoteAuthority:N}}else if((0,ne.isWorkspaceToOpen)(A))return{workspace:(0,V.getWorkspaceIdentifier)(z),remoteAuthority:N};return{workspace:(0,V.getSingleFolderWorkspaceIdentifier)(z),remoteAuthority:N}}resourceFromOpenable(A){return(0,ne.isWorkspaceToOpen)(A)?A.workspaceUri:(0,ne.isFolderToOpen)(A)?A.folderUri:A.fileUri}doResolveFilePath(A,O){let z,N;O.gotoLineMode&&({path:A,line:z,column:N}=(0,f.parseLineAndColumnAware)(A)),A=(0,f.sanitizeFilePath)((0,y.normalize)(A),(0,P.cwd)());try{const C=(0,L.statSync)(A);if(C.isFile()){if(!O.forceOpenWorkspaceAsFile){const q=this.workspacesManagementMainService.resolveLocalWorkspaceSync(d.URI.file(A));if(q)return q.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:q.id,configPath:q.configPath},remoteAuthority:q.remoteAuthority,exists:!0,transient:q.transient}}return{fileUri:d.URI.file(A),selection:z?{startLineNumber:z,startColumn:N||1}:void 0,exists:!0}}else if(C.isDirectory())return{workspace:(0,V.getSingleFolderWorkspaceIdentifier)(d.URI.file(A),C),exists:!0}}catch(C){const q=d.URI.file(A);if(this.workspacesHistoryMainService.removeRecentlyOpened([q]),O.ignoreFileNotFound)return{fileUri:q,exists:!1}}}doResolvePathRemote(A,O){const z=A.charCodeAt(0),N=O.remoteAuthority;let C,q;O.gotoLineMode&&({path:A,line:C,column:q}=(0,f.parseLineAndColumnAware)(A)),z!==47&&((0,f.isWindowsDriveLetter)(z)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,f.toSlashes)(A)),A=`/${A}`);const Q=d.URI.from({scheme:b.Schemas.vscodeRemote,authority:N,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,W.hasWorkspaceFileExtension)(A))return O.forceOpenWorkspaceAsFile?{fileUri:Q,selection:C?{startLineNumber:C,startColumn:q||1}:void 0,remoteAuthority:O.remoteAuthority}:{workspace:(0,V.getWorkspaceIdentifier)(Q),remoteAuthority:N};if(O.gotoLineMode||y.posix.basename(A).indexOf(".")!==-1)return{fileUri:Q,selection:C?{startLineNumber:C,startColumn:q||1}:void 0,remoteAuthority:N}}return{workspace:(0,V.getSingleFolderWorkspaceIdentifier)(Q),remoteAuthority:N}}shouldOpenNewWindow(A){const O=this.configurationService.getValue("window"),z=O?.openFoldersInNewWindow||"default",N=O?.openFilesInNewWindow||"off";let C=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(z==="on"||z==="off")&&(C=z==="on");let q=!1;return A.forceNewWindow||A.forceReuseWindow?q=!!A.forceNewWindow&&!A.forceReuseWindow:(g.isMacintosh?A.context===1&&(q=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(q=!0),!A.cli.extensionDevelopmentPath&&(N==="on"||N==="off")&&(q=N==="on")),{openFolderInNewWindow:!!C,openFilesInNewWindow:q}}openExtensionDevelopmentHostWindow(A,O){const z=(0,G.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(z)return this.lifecycleMainService.reload(z,O.cli),z.focus(),[z];let N=O.cli["folder-uri"]||[],C=O.cli["file-uri"]||[],q=O.cli._;if(!q.length&&!N.length&&!C.length&&!O.cli.extensionTestsPath){const ae=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ee=ae&&(ae.workspace||ae.folderUri);ee&&(d.URI.isUri(ee)?ee.scheme===b.Schemas.file?q=[ee.fsPath]:N=[ee.toString()]:ee.configPath.scheme===b.Schemas.file?q=[(0,p.originalFSPath)(ee.configPath)]:C=[ee.configPath.toString()])}let Q=O.remoteAuthority;for(const ae of A)if(ae.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ee=d.URI.parse(ae),le=(0,U.getRemoteAuthority)(ee);le&&(Q?le!==Q&&this.logService.error("more than one extension development path authority"):Q=le)}q=q.filter(ae=>{const ee=d.URI.file(ae);return(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ee)?!1:(0,U.getRemoteAuthority)(ee)===Q}),N=N.filter(ae=>{const ee=this.cliArgToUri(ae);return ee&&!!(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ee)?!1:ee?(0,U.getRemoteAuthority)(ee)===Q:!1}),C=C.filter(ae=>{const ee=this.cliArgToUri(ae);return ee&&!!(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ee)?!1:ee?(0,U.getRemoteAuthority)(ee)===Q:!1}),O.cli._=q,O.cli["folder-uri"]=N,O.cli["file-uri"]=C;const ie=!q.length&&!N.length&&!C.length,oe={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:ie,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:Q};return this.open(oe)}openInBrowserWindow(A){const O=this.configurationService.getValue("window"),z={...this.environmentMainService.args,...A.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,y.join)(this.environmentMainService.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.initialUserEnv,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:D.default,isInitialStartup:A.initialStartup,perfMarks:(0,h.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,accessibilitySupport:v.app.accessibilitySupportEnabled,colorScheme:{dark:v.nativeTheme.shouldUseDarkColors,highContrast:v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors}};let N;if(!A.forceNewWindow&&!A.forceNewTabbedWindow&&(N=A.windowToUse||this.getLastActiveWindow(),N&&N.focus()),N){const C=N.config;!z.extensionDevelopmentPath&&C&&!!C.extensionDevelopmentPath&&(z.extensionDevelopmentPath=C.extensionDevelopmentPath,z.verbose=C.verbose,z["inspect-brk-extensions"]=C["inspect-brk-extensions"],z.debugId=C.debugId,z["inspect-extensions"]=C["inspect-extensions"],z["extensions-dir"]=C["extensions-dir"])}else{const C=this.windowsStateHandler.getNewWindowState(z);(0,h.mark)("code/willCreateCodeWindow");const q=N=this.instantiationService.createInstance(se.CodeWindow,{state:C,extensionDevelopmentPath:z.extensionDevelopmentPath,isExtensionTestHost:!!z.extensionTestsPath});if((0,h.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow){const ie=this.getLastActiveWindow();ie&&ie.addTabbedWindow(q)}Je.WINDOWS.push(q),this._onDidOpenWindow.fire(q),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,w.once)(q.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(q)),(0,w.once)(q.onDidClose)(()=>this.onWindowClosed(q)),(0,w.once)(q.onDidDestroy)(()=>this._onDidDestroyWindow.fire(q));const Q=(0,c.assertIsDefined)(q.win?.webContents);Q.removeAllListeners("devtools-reload-page"),Q.on("devtools-reload-page",()=>this.lifecycleMainService.reload(q)),this.lifecycleMainService.registerWindow(q)}return z.windowId=N.id,N.isReady?this.lifecycleMainService.unload(N,4).then(C=>{C||this.doOpenInBrowserWindow(N,z,A)}):this.doOpenInBrowserWindow(N,z,A),N}doOpenInBrowserWindow(A,O,z){if(!O.extensionDevelopmentPath)if((0,W.isWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:O.workspace,remoteAuthority:O.remoteAuthority});else if((0,W.isSingleFolderWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerFolderBackupSync(O.workspace.uri);else{const N=z.emptyWindowBackupInfo&&z.emptyWindowBackupInfo.backupFolder;O.backupPath=this.backupMainService.registerEmptyWindowBackupSync(N,O.remoteAuthority)}A.load(O)}onWindowClosed(A){const O=Je.WINDOWS.indexOf(A);Je.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=v.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(A){return this.doGetLastActiveWindow(this.getWindows().filter(O=>O.remoteAuthority===A))}doGetLastActiveWindow(A){const O=Math.max.apply(Math,A.map(z=>z.lastFocusTime));return A.find(z=>z.lastFocusTime===O)}sendToFocused(A,...O){const z=this.getFocusedWindow()||this.getLastActiveWindow();z&&z.sendWhenReady(A,E.CancellationToken.None,...O)}sendToAll(A,O,z){for(const N of this.getWindows())z&&z.indexOf(N.id)>=0||N.sendWhenReady(A,E.CancellationToken.None,O)}getWindows(){return Je.WINDOWS}getWindowCount(){return Je.WINDOWS.length}getWindowById(A){const O=this.getWindows().filter(z=>z.id===A);return(0,M.firstOrDefault)(O)}getWindowByWebContents(A){const O=v.BrowserWindow.fromWebContents(A);if(!!O)return this.getWindowById(O.id)}};j.WINDOWS=[],j=he([te(2,S.ILogService),te(3,X.IStateMainService),te(4,r.IEnvironmentMainService),te(5,m.ILifecycleMainService),te(6,u.IBackupMainService),te(7,i.IConfigurationService),te(8,B.IWorkspacesHistoryMainService),te(9,$.IWorkspacesManagementMainService),te(10,l.IInstantiationService),te(11,a.IDialogMainService),te(12,s.IFileService),te(13,R.IProductService),te(14,F.IProtocolMainService)],j),e.WindowsMainService=j}),define(Z[237],x([0,1,51,36,63,46]),function(K,e,v,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let E=class{constructor(f,w,t,I){this.workspacesManagementMainService=f,this.windowsMainService=w,this.workspacesHistoryMainService=t,this.backupMainService=I,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(f,w){const t=this.windowsMainService.getWindowById(f);if(t)return this.workspacesManagementMainService.enterWorkspace(t,this.windowsMainService.getWindows(),w)}createUntitledWorkspace(f,w,t){return this.workspacesManagementMainService.createUntitledWorkspace(w,t)}deleteUntitledWorkspace(f,w){return this.workspacesManagementMainService.deleteUntitledWorkspace(w)}getWorkspaceIdentifier(f,w){return this.workspacesManagementMainService.getWorkspaceIdentifier(w)}async getRecentlyOpened(f){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(f))}async addRecentlyOpened(f,w){return this.workspacesHistoryMainService.addRecentlyOpened(w)}async removeRecentlyOpened(f,w){return this.workspacesHistoryMainService.removeRecentlyOpened(w)}async clearRecentlyOpened(f){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};E=he([te(0,M.IWorkspacesManagementMainService),te(1,L.IWindowsMainService),te(2,k.IWorkspacesHistoryMainService),te(3,v.IBackupMainService)],E),e.WorkspacesMainService=E}),define(Z[238],x([0,1,14,31,26,18,17,30,43,40,34,2,10,8,3,15,13,7,28,67,119,35,122,84,229,131,51,220,16,178,157,71,52,219,88,24,54,90,169,185,89,172,20,70,5,72,230,196,101,22,6,180,235,53,21,74,225,75,39,214,98,197,29,199,201,60,42,205,227,231,228,232,97,206,207,208,209,211,36,236,212,27,63,237,46]),function(K,e,v,L,k,M,E,n,f,w,t,I,b,y,h,g,P,p,c,d,o,u,i,a,r,s,l,m,S,D,R,F,U,X,ne,se,G,J,W,V,B,$,H,_,j,T,A,O,z,N,C,q,Q,ie,oe,ae,ee,le,me,ue,ve,Pe,we,fe,Ee,De,Ae,Ne,Ue,Ge,Be,st,Ze,ot,Ye,ut,xe,Y,re,ce,ge,ye,Me,Fe,We){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ce=class extends I.Disposable{constructor(de,Se,be,pe,Ie,Le,ke,Re,Te,$e){super();this.mainProcessNodeIpcServer=de,this.userEnv=Se,this.mainInstantiationService=be,this.logService=pe,this.environmentMainService=Ie,this.lifecycleMainService=Le,this.configurationService=ke,this.stateMainService=Re,this.fileService=Te,this.productService=$e,this.configureSession(),this.registerListeners()}configureSession(){const de=pe=>pe?.startsWith(`${b.Schemas.vscodeWebview}://`),Se=new Set(["clipboard-read","clipboard-sanitized-write"]);v.session.defaultSession.setPermissionRequestHandler((pe,Ie,Le,ke)=>de(ke.requestingUrl)?Le(Se.has(Ie)):Le(!1)),v.session.defaultSession.setPermissionCheckHandler((pe,Ie,Le,ke)=>de(ke.requestingUrl)?Se.has(Ie):!1);const be=v.session.defaultSession;typeof be.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&be.setCodeCachePath((0,y.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,E.setUnexpectedErrorHandler)(be=>this.onUnexpectedError(be)),process.on("uncaughtException",be=>(0,E.onUnexpectedError)(be)),process.on("unhandledRejection",be=>(0,E.onUnexpectedError)(be)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,o.registerContextMenuListener)(),v.app.on("accessibility-support-changed",(be,pe)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",pe)}),v.app.on("activate",(be,pe)=>{this.logService.trace("app#activate"),pe||this.windowsMainService?.openEmptyWindow({context:1})}),v.app.on("web-contents-created",(be,pe)=>{pe.on("will-navigate",Ie=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ie.preventDefault()}),pe.setWindowOpenHandler(({url:Ie})=>(this.nativeHostMainService?.openExternal(void 0,Ie),{action:"deny"}))});let de=[],Se;v.app.on("open-file",(be,pe)=>{this.logService.trace("app#open-file: ",pe),be.preventDefault(),de.push(this.getWindowOpenableFromPathSync(pe)),Se!==void 0&&(clearTimeout(Se),Se=void 0),Se=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:de,gotoLineMode:!1,preferNewWindow:!0}),de=[],Se=void 0},100)}),v.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),v.ipcMain.handle("vscode:fetchShellEnv",be=>{const pe=this.windowsMainService?.getWindowByWebContents(be.sender);let Ie,Le;return pe?.config?(Ie=pe.config,Le={...process.env,...pe.config.userEnv}):(Ie=this.environmentMainService.args,Le=process.env),(0,J.resolveShellEnv)(this.logService,Ie,Le)}),v.ipcMain.handle("vscode:writeNlsFile",(be,pe,Ie)=>{const Le=this.validateNlsPath([pe]);if(!Le||typeof Ie!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Le,M.VSBuffer.fromString(Ie))}),v.ipcMain.handle("vscode:readNlsFile",async(be,...pe)=>{const Ie=this.validateNlsPath(pe);if(!Ie)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Ie)).value.toString()}),v.ipcMain.on("vscode:toggleDevTools",be=>be.sender.toggleDevTools()),v.ipcMain.on("vscode:openDevTools",be=>be.sender.openDevTools()),v.ipcMain.on("vscode:reloadWindow",be=>be.sender.reload())}validateNlsPath(de){let Se;for(const be of de)typeof be=="string"&&(typeof Se!="string"?Se=be:Se=(0,y.join)(Se,be));if(!(typeof Se!="string"||!(0,y.isAbsolute)(Se)||!(0,n.isEqualOrParent)(Se,this.environmentMainService.cachedLanguagesPath,!h.isLinux)))return p.URI.file(Se)}onUnexpectedError(de){if(de){const Se={message:`[uncaught exception in main]: ${de.message}`,stack:de.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Se))}this.logService.error(`[uncaught exception in main]: ${de}`),de.stack&&this.logService.error(de.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const de=this.productService.win32AppUserModelId;h.isWindows&&de&&v.app.setAppUserModelId(de);try{h.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!v.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&v.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Te){this.logService.error(Te)}const Se=new i.Server;this.logService.trace("Resolving machine identifier...");const be=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${be}`);const{sharedProcess:pe,sharedProcessReady:Ie,sharedProcessClient:Le}=this.setupSharedProcess(be),ke=await this.initServices(be,pe,Ie);if(this.environmentMainService.driverHandle){const Te=await(0,X.serve)(Se,this.environmentMainService.driverHandle,this.environmentMainService,ke);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Te)}this._register(ke.createInstance(r.ProxyAuthHandler)),ke.invokeFunction(Te=>this.initChannels(Te,Se,Le));const Re=ke.invokeFunction(Te=>this.openFirstWindow(Te,Se));ke.invokeFunction(Te=>this.afterWindowOpen(Te,pe)),this.environmentMainService.args.trace&&ke.invokeFunction(Te=>this.stopTracingEventually(Te,Re))}async resolveMachineId(){let de=this.stateMainService.getItem(we.machineIdKey);return(!de||h.isMacintosh&&de==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(de=await(0,d.getMachineId)(),this.stateMainService.setItem(we.machineIdKey,de)),de}setupSharedProcess(de){const Se=this._register(this.mainInstantiationService.createInstance(ee.SharedProcess,de,this.userEnv)),be=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ie=await Se.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new a.Client(Ie,"main")})(),pe=(async()=>(await Se.whenReady(),be))();return{sharedProcess:Se,sharedProcessReady:pe,sharedProcessClient:be}}async initServices(de,Se,be){const pe=new T.ServiceCollection;switch(process.platform){case"win32":pe.set(Ae.IUpdateService,new _.SyncDescriptor(st.Win32UpdateService));break;case"linux":h.isLinuxSnap?pe.set(Ae.IUpdateService,new _.SyncDescriptor(Be.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(Ae.IUpdateService,new _.SyncDescriptor(Ge.LinuxUpdateService));break;case"darwin":pe.set(Ae.IUpdateService,new _.SyncDescriptor(Ue.DarwinUpdateService));break}pe.set(re.IWindowsMainService,new _.SyncDescriptor(ce.WindowsMainService,[de,this.userEnv])),pe.set(U.IDialogMainService,new _.SyncDescriptor(U.DialogMainService)),pe.set(z.ILaunchMainService,new _.SyncDescriptor(z.LaunchMainService)),pe.set(F.IDiagnosticsService,u.ProxyChannel.toService((0,u.getDelayedChannel)(be.then(Le=>Le.getChannel("diagnostics"))))),pe.set(A.IIssueMainService,new _.SyncDescriptor(A.IssueMainService,[this.userEnv])),pe.set(ne.IEncryptionMainService,new _.SyncDescriptor(ne.EncryptionMainService,[de])),pe.set(O.IKeyboardLayoutMainService,new _.SyncDescriptor(O.KeyboardLayoutMainService)),pe.set(ie.INativeHostMainService,new _.SyncDescriptor(ie.NativeHostMainService,[Se])),pe.set(xe.IWebviewManagerService,new _.SyncDescriptor(Y.WebviewMainService)),pe.set(ye.IWorkspacesService,new _.SyncDescriptor(Fe.WorkspacesMainService)),pe.set(We.IWorkspacesManagementMainService,new _.SyncDescriptor(We.WorkspacesManagementMainService)),pe.set(Me.IWorkspacesHistoryMainService,new _.SyncDescriptor(Me.WorkspacesHistoryMainService)),pe.set(Q.IMenubarMainService,new _.SyncDescriptor(Q.MenubarMainService)),pe.set(W.IExtensionUrlTrustService,new _.SyncDescriptor(V.ExtensionUrlTrustService)),pe.set(ve.IStorageMainService,new _.SyncDescriptor(ve.StorageMainService)),h.isWindows?pe.set(B.IExternalTerminalMainService,new _.SyncDescriptor($.WindowsExternalTerminalService)):h.isMacintosh?pe.set(B.IExternalTerminalMainService,new _.SyncDescriptor($.MacExternalTerminalService)):h.isLinux&&pe.set(B.IExternalTerminalMainService,new _.SyncDescriptor($.LinuxExternalTerminalService));const Ie=new m.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(pe.set(l.IBackupMainService,Ie),pe.set(Ze.IURLService,new _.SyncDescriptor(Ye.NativeURLService)),(0,De.getTelemetryLevel)(this.productService,this.environmentMainService)>=2){const Le=(0,u.getDelayedChannel)(be.then(Ke=>Ke.getChannel("telemetryAppender"))),ke=new fe.TelemetryAppenderClient(Le),Re=(0,Pe.resolveCommonProperties)(this.fileService,(0,k.release)(),(0,k.hostname)(),process.arch,this.productService.commit,this.productService.version,de,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Te=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],$e={appender:ke,commonProperties:Re,piiPaths:Te,sendErrorTelemetry:!0};pe.set(we.ITelemetryService,new _.SyncDescriptor(Ee.TelemetryService,[$e]))}else pe.set(we.ITelemetryService,De.NullTelemetryService);return await Ie.initialize(),this.mainInstantiationService.createChild(pe)}initChannels(de,Se,be){const pe=u.ProxyChannel.fromService(de.get(z.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",pe),Se.registerChannel(D.UserConfigurationFileServiceId,u.ProxyChannel.fromService(new D.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService)));const Ie=new Ne.UpdateChannel(de.get(Ae.IUpdateService));Se.registerChannel("update",Ie);const Le=u.ProxyChannel.fromService(de.get(A.IIssueMainService));Se.registerChannel("issue",Le);const ke=u.ProxyChannel.fromService(de.get(ne.IEncryptionMainService));Se.registerChannel("encryption",ke);const Re=u.ProxyChannel.fromService(de.get(le.ISignService));Se.registerChannel("sign",Re);const Te=u.ProxyChannel.fromService(de.get(O.IKeyboardLayoutMainService));Se.registerChannel("keyboardLayout",Te),this.nativeHostMainService=de.get(ie.INativeHostMainService);const $e=u.ProxyChannel.fromService(this.nativeHostMainService);Se.registerChannel("nativeHost",$e),be.then(He=>He.registerChannel("nativeHost",$e));const Ke=u.ProxyChannel.fromService(de.get(ye.IWorkspacesService));Se.registerChannel("workspaces",Ke);const et=u.ProxyChannel.fromService(de.get(Q.IMenubarMainService));Se.registerChannel("menubar",et);const tt=u.ProxyChannel.fromService(de.get(Ze.IURLService));Se.registerChannel("url",tt);const ht=u.ProxyChannel.fromService(de.get(W.IExtensionUrlTrustService));Se.registerChannel("extensionUrlTrust",ht);const _e=u.ProxyChannel.fromService(de.get(xe.IWebviewManagerService));Se.registerChannel("webview",_e);const it=this._register(new ue.StorageDatabaseChannel(this.logService,de.get(ve.IStorageMainService)));Se.registerChannel("storage",it),be.then(He=>He.registerChannel("storage",it));const nt=u.ProxyChannel.fromService(de.get(B.IExternalTerminalMainService));Se.registerChannel("externalTerminal",nt);const Xe=new q.LogLevelChannel(de.get(C.ILogService));Se.registerChannel("logLevel",Xe),be.then(He=>He.registerChannel("logLevel",Xe));const rt=new q.LoggerChannel(de.get(C.ILoggerService));Se.registerChannel("logger",rt),be.then(He=>He.registerChannel("logger",rt));const at=new R.ElectronExtensionHostDebugBroadcastChannel(de.get(re.IWindowsMainService));Se.registerChannel("extensionhostdebugservice",at)}openFirstWindow(de,Se){const be=this.windowsMainService=de.get(re.IWindowsMainService),pe=de.get(Ze.IURLService),Ie=de.get(ie.INativeHostMainService);this.lifecycleMainService.phase=2;const Le=[],ke=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Oe=>{try{return{uri:p.URI.parse(Oe),url:Oe}}catch{return}}).filter(Oe=>{if(!Oe||this.shouldBlockURI(Oe.uri))return!1;const Qe=this.getWindowOpenableFromProtocolLink(Oe.uri);return Qe?(Le.push(Qe),!1):!0}),Re=this,Te=this.environmentMainService,$e=this.productService;pe.registerHandler({async handleURL(Oe,Qe){if(Oe.scheme===$e.urlProtocol&&Oe.path==="workspace"&&(Oe=Oe.with({authority:"file",path:p.URI.parse(Oe.query).path,query:""})),Re.shouldBlockURI(Oe))return!0;const vt=Re.getWindowOpenableFromProtocolLink(Oe);if(vt){const[ft]=be.open({context:5,cli:{...Te.args},urisToOpen:[vt],gotoLineMode:!0});return ft.focus(),!0}if(h.isMacintosh&&be.getWindowCount()===0){const[ft]=be.open({context:5,cli:{...Te.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ae.getRemoteAuthority)(Oe)});return await ft.ready(),pe.open(Oe,Qe)}return!1}});const Ke=this._register(new ge.ActiveWindowManager({onDidOpenWindow:Ie.onDidOpenWindow,onDidFocusWindow:Ie.onDidFocusWindow,getActiveWindowId:()=>Ie.getActiveWindowId(-1)})),et=new u.StaticRouter(Oe=>Ke.getActiveClientId().then(Qe=>Oe===Qe)),tt=new ot.URLHandlerRouter(et),ht=Se.getChannel("urlHandler",tt);pe.registerHandler(new ot.URLHandlerChannelClient(ht)),this._register(new ut.ElectronURLListener(ke,pe,be,this.environmentMainService,this.productService));const _e=this.environmentMainService.args,it=global.macOpenFiles,nt=(0,G.isLaunchedFromCli)(process.env)?0:4,Xe=_e._.length,rt=!!_e["folder-uri"],at=!!_e["file-uri"],He=_e["skip-add-to-recently-opened"]===!0,dt=_e.wait&&_e.waitMarkerFilePath?p.URI.file(_e.waitMarkerFilePath):void 0,pt=_e.remote||void 0;return Le.length>0?be.open({context:nt,cli:_e,urisToOpen:Le,gotoLineMode:!0,initialStartup:!0}):_e["new-window"]&&!Xe&&!rt&&!at?be.open({context:nt,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:He,waitMarkerFileURI:dt,initialStartup:!0,remoteAuthority:pt}):it.length&&!Xe&&!rt&&!at?be.open({context:1,cli:_e,urisToOpen:it.map(Oe=>this.getWindowOpenableFromPathSync(Oe)),noRecentEntry:He,waitMarkerFileURI:dt,initialStartup:!0}):be.open({context:nt,cli:_e,forceNewWindow:_e["new-window"]||!Xe&&_e["unity-launch"],diffMode:_e.diff,noRecentEntry:He,waitMarkerFileURI:dt,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:pt})}shouldBlockURI(de){return!!(de.authority===b.Schemas.file&&h.isWindows&&v.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,t.mnemonicButtonLabel)((0,s.localize)(0,null)),(0,t.mnemonicButtonLabel)((0,s.localize)(1,null))],defaultId:0,cancelId:1,message:(0,s.localize)(2,null,(0,t.getPathLabel)(de.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,s.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(de){if(!!de.path){if(de.authority===b.Schemas.file)return{fileUri:p.URI.file(de.fsPath)};if(de.authority===b.Schemas.vscodeRemote){const Se=de.path.indexOf(y.posix.sep,1);if(Se!==-1){const be=de.path.substring(1,Se),pe=de.path.substring(Se),Ie=p.URI.from({scheme:b.Schemas.vscodeRemote,authority:be,path:pe,query:de.query,fragment:de.fragment});return(0,ye.hasWorkspaceFileExtension)(pe)?{workspaceUri:Ie}:/:[\d]+$/.test(pe)?{fileUri:Ie}:{folderUri:Ie}}}}}getWindowOpenableFromPathSync(de){try{if((0,L.statSync)(de).isDirectory())return{folderUri:p.URI.file(de)};if((0,ye.hasWorkspaceFileExtension)(de))return{workspaceUri:p.URI.file(de)}}catch(Se){}return{fileUri:p.URI.file(de)}}async afterWindowOpen(de,Se){this.lifecycleMainService.phase=3;let be=!1;(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>be=!0);const pe=de.get(we.ITelemetryService);this._register(Se.onDidError(({type:ke,details:Re})=>{let Te;switch(ke){case 1:Te="SharedProcess: detected unresponsive window";break;case 2:Te=`SharedProcess: crashed (detail: ${Re?.reason??"<unknown>"}, code: ${Re?.exitCode??"<unknown>"})`;break;case 3:Te=`SharedProcess: failed to load (detail: ${Re?.reason??"<unknown>"}, code: ${Re?.exitCode??"<unknown>"})`;break}(0,E.onUnexpectedError)(new Error(Te)),pe.publicLog2("sharedprocesserror",{type:ke,reason:Re?.reason,code:Re?.exitCode,visible:Se.isVisible(),shuttingdown:be})}));const Ie=this.productService.win32MutexName;if(h.isWindows&&Ie)try{const ke=K.__$__nodeRequire("windows-mutex").Mutex,Re=new ke(Ie);(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Re.release())}catch(ke){this.logService.error(ke)}v.protocol.registerHttpProtocol(b.Schemas.vscodeRemoteResource,(ke,Re)=>{Re({url:ke.url.replace(/^vscode-remote-resource:/,"http:"),method:ke.method})});const Le=de.get(Ae.IUpdateService);(Le instanceof st.Win32UpdateService||Le instanceof Ge.LinuxUpdateService||Le instanceof Ue.DarwinUpdateService)&&Le.initialize(),(0,J.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env);try{const Re=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,w.stripComments)(Re))["enable-crash-reporter"]===void 0){const $e=this.configurationService.getValue("telemetry.enableCrashReporter"),Ke=typeof $e=="boolean"?$e:!0,et=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ke},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,c.generateUuid)()}"`,"}"],tt=Re.substring(0,Re.length-2).concat(`,
`,et.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(tt))}}catch(ke){this.logService.error(ke)}}stopTracingEventually(de,Se){this.logService.info("Tracing: waiting for windows to get ready...");const be=de.get(U.IDialogMainService);let pe=!1;const Ie=async ke=>{if(pe)return;pe=!0;const Re=await v.contentTracing.stopRecording((0,g.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);ke?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Re}`):be.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,s.localize)(4,null),detail:(0,s.localize)(5,null,Re),buttons:[(0,t.mnemonicButtonLabel)((0,s.localize)(6,null))],defaultId:0,noLink:!0},(0,P.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))},Le=setTimeout(()=>Ie(!0),3e4);Promise.all(Se.map(ke=>ke.ready())).then(()=>{clearTimeout(Le),Ie(!1)})}};Ce=he([te(2,j.IInstantiationService),te(3,C.ILogService),te(4,se.IEnvironmentMainService),te(5,N.ILifecycleMainService),te(6,S.IConfigurationService),te(7,me.IStateMainService),te(8,H.IFileService),te(9,oe.IProductService)],Ce),e.CodeApplication=Ce}),define(Z[242],x([0,1,14,31,32,9,68,17,30,43,34,10,8,73,3,33,25,19,35,56,238,11,16,189,198,24,54,161,20,183,184,70,174,72,22,92,6,181,93,45,21,55,186,95,222,50,224,75,195,39,226,60,61,204]),function(K,e,v,L,k,M,E,n,f,w,t,I,b,y,h,g,P,p,c,d,o,u,i,a,r,s,l,m,S,D,R,F,U,X,ne,se,G,J,W,V,B,$,H,_,j,T,A,O,z,N,C,q,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ie{main(){try{this.startup()}catch(ee){console.error(ee.message),v.app.exit(1)}}async startup(){(0,n.setUnexpectedErrorHandler)(fe=>console.error(fe));const[ee,le,me,ue,ve,Pe,we]=this.createServices();try{try{await this.initServices(me,ue,ve)}catch(fe){throw this.handleStartupDataDirError(me,we.nameLong,fe),fe}await ee.invokeFunction(async fe=>{const Ee=fe.get(G.ILogService),De=fe.get(ne.ILifecycleMainService),Ae=fe.get(S.IFileService),Ne=await this.claimInstance(Ee,me,De,ee,we,!0);return p.Promises.writeFile(me.mainLockfile,String(process.pid)).catch(Ue=>{Ee.warn(`Error writing main lockfile: ${Ue.stack}`)}),Pe.logger=new W.SpdLogLogger("main",(0,b.join)(me.logsPath,"main.log"),!0,Pe.getLevel()),(0,w.once)(De.onWillShutdown)(Ue=>{Ae.dispose(),ue.dispose(),Ue.join(p.Promises.unlink(me.mainLockfile).catch(()=>{}))}),ee.createInstance(o.CodeApplication,Ne,le).startup()})}catch(fe){ee.invokeFunction(this.quit,fe)}}createServices(){const ee=new X.ServiceCollection,le={_serviceBrand:void 0,...V.default};ee.set(B.IProductService,le);const me=new s.EnvironmentMainService(this.resolveArgs(),le),ue=this.patchEnvironment(me);ee.set(s.IEnvironmentMainService,me);const ve=new se.BufferLogService,Pe=new G.MultiplexLogService([new G.ConsoleMainLogger((0,G.getLogLevel)(me)),ve]);process.once("exit",()=>Pe.dispose()),ee.set(G.ILogService,Pe);const we=new D.FileService(Pe);ee.set(S.IFileService,we);const fe=new R.DiskFileSystemProvider(Pe);we.registerProvider(I.Schemas.file,fe),ee.set(G.ILoggerService,new J.LoggerService(Pe,we));const Ee=new a.ConfigurationService(me.settingsResource,we);ee.set(i.IConfigurationService,Ee),ee.set(ne.ILifecycleMainService,new F.SyncDescriptor(ne.LifecycleMainService));const De=new C.StateMainService(me,Pe,we);return ee.set(N.IStateMainService,De),ee.set(T.IRequestService,new F.SyncDescriptor(A.RequestMainService)),ee.set(Q.IThemeMainService,new F.SyncDescriptor(Q.ThemeMainService)),ee.set(O.ISignService,new F.SyncDescriptor(z.SignService)),ee.set(_.ITunnelService,new F.SyncDescriptor(j.TunnelService)),ee.set($.IProtocolMainService,new F.SyncDescriptor(H.ProtocolMainService)),[new U.InstantiationService(ee,!0),ue,me,Ee,De,ve,le]}patchEnvironment(ee){const le={VSCODE_IPC_HOOK:ee.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(me=>{const ue=process.env[me];typeof ue=="string"&&(le[me]=ue)}),Object.assign(process.env,le),le}initServices(ee,le,me){return M.Promises.settled([Promise.all([ee.extensionsPath,ee.codeCachePath,ee.logsPath,ee.globalStorageHome.fsPath,ee.workspaceStorageHome.fsPath,ee.backupHome].map(ue=>ue?p.Promises.mkdir(ue,{recursive:!0}):void 0)),le.initialize(),me.init()])}async claimInstance(ee,le,me,ue,ve,Pe){let we;try{(0,y.mark)("code/willStartMainServer"),we=await(0,d.serve)(le.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),(0,w.once)(me.onWillShutdown)(()=>we.dispose())}catch(fe){if(fe.code!=="EADDRINUSE")throw this.handleStartupDataDirError(le,ve.nameLong,fe),fe;let Ee;try{Ee=await(0,d.connect)(le.mainIPCHandle,"main")}catch(Ne){if(!Pe||h.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog((0,u.localize)(0,null,ve.nameShort),(0,u.localize)(1,null),ve.nameLong),Ne;try{(0,L.unlinkSync)(le.mainIPCHandle)}catch(Ue){throw ee.warn("Could not delete obsolete instance handle",Ue),Ue}return this.claimInstance(ee,le,me,ue,ve,!1)}if(le.extensionTestsLocationURI&&!le.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ee.error(Ne),Ee.dispose(),new Error(Ne)}let De;!le.args.wait&&!le.args.status&&(De=setTimeout(()=>{this.showStartupWarningDialog((0,u.localize)(2,null,ve.nameShort),(0,u.localize)(3,null),ve.nameLong)},1e4));const Ae=c.ProxyChannel.toService(Ee.getChannel("launch"),{disableMarshalling:!0});if(le.args.status)return ue.invokeFunction(async()=>{const Ne=new r.DiagnosticsService(q.NullTelemetryService,ve),Ue=await Ae.getMainProcessInfo(),Ge=await Ae.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Be=await Ne.getDiagnostics(Ue,Ge);throw console.log(Be),new n.ExpectedError});throw h.isWindows&&await this.windowsAllowSetForegroundWindow(Ae,ee),ee.trace("Sending env to running instance..."),await Ae.start(le.args,process.env),Ee.dispose(),De&&clearTimeout(De),new n.ExpectedError("Sent env to running instance. Terminating...")}if(le.args.status)throw ee.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new n.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),we}handleStartupDataDirError(ee,le,me){if(me.code==="EACCES"||me.code==="EPERM"){const ue=(0,k.coalesce)([ee.userDataPath,ee.extensionsPath,d.XDG_RUNTIME_DIR]).map(ve=>(0,t.getPathLabel)(ve,ee));this.showStartupWarningDialog((0,u.localize)(4,null),(0,u.localize)(5,null,(0,E.toErrorMessage)(me),ue.join(`
`)),le)}}showStartupWarningDialog(ee,le,me){v.dialog.showMessageBoxSync({title:me,type:"warning",buttons:[(0,t.mnemonicButtonLabel)((0,u.localize)(6,null))],message:ee,detail:le,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ee,le){if(h.isWindows){const me=await ee.getMainProcessId();le.trace("Sending some foreground love to the running instance:",me);try{(await new Promise((ue,ve)=>{K(["windows-foreground-love"],ue,ve)})).allowSetForegroundWindow(me)}catch(ue){le.error(ue)}}}quit(ee,le){const me=ee.get(G.ILogService),ue=ee.get(ne.ILifecycleMainService);let ve=0;le&&(le.isExpected?le.message&&me.trace(le.message):(ve=1,le.stack?me.error(le.stack):me.error(`Startup error: ${le.toString()}`))),ue.kill(ve)}resolveArgs(){const ee=this.validatePaths((0,l.parseMainProcessArgv)(process.argv));if(ee.wait&&!ee.waitMarkerFilePath){const le=(0,m.createWaitMarkerFile)(ee.verbose);le&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",le),ee.waitMarkerFilePath=le)}return ee}validatePaths(ee){if(ee["open-url"]&&(ee._urls=ee._,ee._=[]),!ee.remote){const le=this.doValidatePaths(ee._,ee.goto);ee._=le}return ee}doValidatePaths(ee,le){const me=(0,g.cwd)(),ue=ee.map(we=>{let fe=String(we),Ee;le&&(Ee=(0,f.parseLineAndColumnAware)(fe),fe=Ee.path),fe&&(fe=this.preparePath(me,fe));const De=(0,f.sanitizeFilePath)(fe,me),Ae=(0,b.basename)(De);return Ae&&!(0,f.isValidBasename)(Ae)?null:le&&Ee?(Ee.path=De,this.toPath(Ee)):De}),ve=h.isWindows||h.isMacintosh,Pe=(0,k.distinct)(ue,we=>we&&ve?we.toLowerCase():we||"");return(0,k.coalesce)(Pe)}preparePath(ee,le){return h.isWindows&&(le=(0,P.rtrim)(le,'"')),le=(0,P.trim)((0,P.trim)(le," "),"	"),h.isWindows&&(le=(0,b.resolve)(ee,le),le=(0,P.rtrim)(le,".")),le}toPath(ee){const le=[ee.path];return typeof ee.line=="number"&&le.push(String(ee.line)),typeof ee.column=="number"&&le.push(String(ee.column)),le.join(":")}}new ie().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0c83ca1ced83259971d80890d93abbe19cbfc992/core/vs/code/electron-main/main.js.map
