/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/path","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/network","vs/base/common/errors","vs/base/common/types","vs/base/common/platform","vs/base/node/pfs","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/strings","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/process","vs/platform/telemetry/common/telemetry","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","os","child_process","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","fs","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/download/common/download","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/platform/environment/node/argvHelper","vs/base/node/watcher","crypto","vs/base/common/iterator","vs/base/common/performance","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],ee=function($){for(var t=[],O=0,S=$.length;O<S;O++)t[O]=Q[$[O]];return t};define(Q[58],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function O(S,y){if(!S)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}t.ok=O}),define(Q[45],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function O(D){return(T,c,g)=>{let v=null,P=null;if(typeof g.value=="function"?(v="value",P=g.value):typeof g.get=="function"&&(v="get",P=g.get),!P)throw new Error("not supported");g[v]=D(P,c)}}t.createDecorator=O;function S(D,T,c){let g=null,v=null;if(typeof c.value=="function"?(g="value",v=c.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(g="get",v=c.get),!v)throw new Error("not supported");const P=`$memoize$${T}`;c[g]=function(...d){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:v.apply(this,d)}),this[P]}}t.memoize=S;function y(D,T,c){return O((g,v)=>{const P=`$debounce$${v}`,d=`$debounce$result$${v}`;return function(...I){this[d]||(this[d]=c?c():void 0),clearTimeout(this[P]),T&&(this[d]=T(this[d],...I),I=[this[d]]),this[P]=setTimeout(()=>{g.apply(this,I),this[d]=c?c():void 0},D)}})}t.debounce=y;function R(D,T,c){return O((g,v)=>{const P=`$throttle$timer$${v}`,d=`$throttle$result$${v}`,I=`$throttle$lastRun$${v}`,l=`$throttle$pending$${v}`;return function(...u){if(this[d]||(this[d]=c?c():void 0),(this[I]===null||this[I]===void 0)&&(this[I]=-Number.MAX_VALUE),T&&(this[d]=T(this[d],...u)),this[l])return;const b=this[I]+D;b<=Date.now()?(this[I]=Date.now(),g.apply(this,[this[d]]),this[d]=c?c():void 0):(this[l]=!0,this[P]=setTimeout(()=>{this[l]=!1,this[I]=Date.now(),g.apply(this,[this[d]]),this[d]=c?c():void 0},b-Date.now()))}})}t.throttle=R}),define(Q[59],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var O;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(O=t.ScanError||(t.ScanError={}));var S;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(S=t.SyntaxKind||(t.SyntaxKind={}));var y;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(y=t.ParseErrorCode||(t.ParseErrorCode={}));var R;(function(e){e.DEFAULT={allowTrailingComma:!0}})(R=t.ParseOptions||(t.ParseOptions={}));function D(e,i=!1){let r=0,n=e.length,a="",E=0,w=16,A=0;function p(Z){let ce=0,le=0;for(;ce<Z;){const _=e.charCodeAt(r);if(_>=48&&_<=57)le=le*16+_-48;else if(_>=65&&_<=70)le=le*16+_-65+10;else if(_>=97&&_<=102)le=le*16+_-97+10;else break;r++,ce++}return ce<Z&&(le=-1),le}function C(Z){r=Z,a="",E=0,w=16,A=0}function N(){const Z=r;if(e.charCodeAt(r)===48)r++;else for(r++;r<e.length&&g(e.charCodeAt(r));)r++;if(r<e.length&&e.charCodeAt(r)===46)if(r++,r<e.length&&g(e.charCodeAt(r)))for(r++;r<e.length&&g(e.charCodeAt(r));)r++;else return A=3,e.substring(Z,r);let ce=r;if(r<e.length&&(e.charCodeAt(r)===69||e.charCodeAt(r)===101))if(r++,(r<e.length&&e.charCodeAt(r)===43||e.charCodeAt(r)===45)&&r++,r<e.length&&g(e.charCodeAt(r))){for(r++;r<e.length&&g(e.charCodeAt(r));)r++;ce=r}else A=3;return e.substring(Z,ce)}function j(){let Z="",ce=r;for(;;){if(r>=n){Z+=e.substring(ce,r),A=2;break}const le=e.charCodeAt(r);if(le===34){Z+=e.substring(ce,r),r++;break}if(le===92){if(Z+=e.substring(ce,r),r++,r>=n){A=2;break}switch(e.charCodeAt(r++)){case 34:Z+='"';break;case 92:Z+="\\";break;case 47:Z+="/";break;case 98:Z+="\b";break;case 102:Z+="\f";break;case 110:Z+=`
`;break;case 114:Z+="\r";break;case 116:Z+="	";break;case 117:const ne=p(4);ne>=0?Z+=String.fromCharCode(ne):A=4;break;default:A=5}ce=r;continue}if(le>=0&&le<=31)if(c(le)){Z+=e.substring(ce,r),A=2;break}else A=6;r++}return Z}function Y(){if(a="",A=0,E=r,r>=n)return E=n,w=17;let Z=e.charCodeAt(r);if(T(Z)){do r++,a+=String.fromCharCode(Z),Z=e.charCodeAt(r);while(T(Z));return w=15}if(c(Z))return r++,a+=String.fromCharCode(Z),Z===13&&e.charCodeAt(r)===10&&(r++,a+=`
`),w=14;switch(Z){case 123:return r++,w=1;case 125:return r++,w=2;case 91:return r++,w=3;case 93:return r++,w=4;case 58:return r++,w=6;case 44:return r++,w=5;case 34:return r++,a=j(),w=10;case 47:const ce=r-1;if(e.charCodeAt(r+1)===47){for(r+=2;r<n&&!c(e.charCodeAt(r));)r++;return a=e.substring(ce,r),w=12}if(e.charCodeAt(r+1)===42){r+=2;const le=n-1;let _=!1;for(;r<le;){if(e.charCodeAt(r)===42&&e.charCodeAt(r+1)===47){r+=2,_=!0;break}r++}return _||(r++,A=1),a=e.substring(ce,r),w=13}return a+=String.fromCharCode(Z),r++,w=16;case 45:if(a+=String.fromCharCode(Z),r++,r===n||!g(e.charCodeAt(r)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=N(),w=11;default:for(;r<n&&te(Z);)r++,Z=e.charCodeAt(r);if(E!==r){switch(a=e.substring(E,r),a){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return a+=String.fromCharCode(Z),r++,w=16}}function te(Z){if(T(Z)||c(Z))return!1;switch(Z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let Z;do Z=Y();while(Z>=12&&Z<=15);return Z}return{setPosition:C,getPosition:()=>r,scan:i?se:Y,getToken:()=>w,getTokenValue:()=>a,getTokenOffset:()=>E,getTokenLength:()=>r-E,getTokenError:()=>A}}t.createScanner=D;function T(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function c(e){return e===10||e===13||e===8232||e===8233}function g(e){return e>=48&&e<=57}var v;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(v||(v={}));function P(e,i){const r=[],n=new Object;let a;const E={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function A(p,C,N,j){E.value=p,E.offset=C,E.length=N,E.type=j,E.colonOffset=void 0,a=E}try{h(e,{onObjectBegin:(p,C)=>{if(i<=p)throw n;a=void 0,w=i>p,r.push("")},onObjectProperty:(p,C,N)=>{if(i<C||(A(p,C,N,"property"),r[r.length-1]=p,i<=C+N))throw n},onObjectEnd:(p,C)=>{if(i<=p)throw n;a=void 0,r.pop()},onArrayBegin:(p,C)=>{if(i<=p)throw n;a=void 0,r.push(0)},onArrayEnd:(p,C)=>{if(i<=p)throw n;a=void 0,r.pop()},onLiteralValue:(p,C,N)=>{if(i<C||(A(p,C,N,s(p)),i<=C+N))throw n},onSeparator:(p,C,N)=>{if(i<=C)throw n;if(p===":"&&a&&a.type==="property")a.colonOffset=C,w=!1,a=void 0;else if(p===","){const j=r[r.length-1];typeof j=="number"?r[r.length-1]=j+1:(w=!0,r[r.length-1]=""),a=void 0}}})}catch(p){if(p!==n)throw p}return{path:r,previousNode:a,isAtPropertyKey:w,matches:p=>{let C=0;for(let N=0;C<p.length&&N<r.length;N++)if(p[C]===r[N]||p[C]==="*")C++;else if(p[C]!=="**")return!1;return C===p.length}}}t.getLocation=P;function d(e,i=[],r=R.DEFAULT){let n=null,a=[];const E=[];function w(p){Array.isArray(a)?a.push(p):n!==null&&(a[n]=p)}return h(e,{onObjectBegin:()=>{const p={};w(p),E.push(a),a=p,n=null},onObjectProperty:p=>{n=p},onObjectEnd:()=>{a=E.pop()},onArrayBegin:()=>{const p=[];w(p),E.push(a),a=p,n=null},onArrayEnd:()=>{a=E.pop()},onLiteralValue:w,onError:(p,C,N)=>{i.push({error:p,offset:C,length:N})}},r),a[0]}t.parse=d;function I(e,i=[],r=R.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(p){n.type==="property"&&(n.length=p-n.offset,n=n.parent)}function E(p){return n.children.push(p),p}h(e,{onObjectBegin:p=>{n=E({type:"object",offset:p,length:-1,parent:n,children:[]})},onObjectProperty:(p,C,N)=>{n=E({type:"property",offset:C,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:p,offset:C,length:N,parent:n})},onObjectEnd:(p,C)=>{n.length=p+C-n.offset,n=n.parent,a(p+C)},onArrayBegin:(p,C)=>{n=E({type:"array",offset:p,length:-1,parent:n,children:[]})},onArrayEnd:(p,C)=>{n.length=p+C-n.offset,n=n.parent,a(p+C)},onLiteralValue:(p,C,N)=>{E({type:s(p),offset:C,length:N,parent:n,value:p}),a(C+N)},onSeparator:(p,C,N)=>{n.type==="property"&&(p===":"?n.colonOffset=C:p===","&&a(C))},onError:(p,C,N)=>{i.push({error:p,offset:C,length:N})}},r);const A=n.children[0];return A&&delete A.parent,A}t.parseTree=I;function l(e,i){if(!e)return;let r=e;for(let n of i)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let a=!1;for(const E of r.children)if(Array.isArray(E.children)&&E.children[0].value===n){r=E.children[1],a=!0;break}if(!a)return}else{const a=n;if(r.type!=="array"||a<0||!Array.isArray(r.children)||a>=r.children.length)return;r=r.children[a]}return r}t.findNodeAtLocation=l;function u(e){if(!e.parent||!e.parent.children)return[];const i=u(e.parent);if(e.parent.type==="property"){const r=e.parent.children[0].value;i.push(r)}else if(e.parent.type==="array"){const r=e.parent.children.indexOf(e);r!==-1&&i.push(r)}return i}t.getNodePath=u;function b(e){switch(e.type){case"array":return e.children.map(b);case"object":const i=Object.create(null);for(let r of e.children){const n=r.children[1];n&&(i[r.children[0].value]=b(n))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=b;function f(e,i,r=!1){return i>=e.offset&&i<e.offset+e.length||r&&i===e.offset+e.length}t.contains=f;function m(e,i,r=!1){if(f(e,i,r)){const n=e.children;if(Array.isArray(n))for(let a=0;a<n.length&&n[a].offset<=i;a++){const E=m(n[a],i,r);if(E)return E}return e}}t.findNodeAtOffset=m;function h(e,i,r=R.DEFAULT){const n=D(e,!1);function a(B){return B?()=>B(n.getTokenOffset(),n.getTokenLength()):()=>!0}function E(B){return B?X=>B(X,n.getTokenOffset(),n.getTokenLength()):()=>!0}const w=a(i.onObjectBegin),A=E(i.onObjectProperty),p=a(i.onObjectEnd),C=a(i.onArrayBegin),N=a(i.onArrayEnd),j=E(i.onLiteralValue),Y=E(i.onSeparator),te=a(i.onComment),se=E(i.onError),Z=r&&r.disallowComments,ce=r&&r.allowTrailingComma;function le(){for(;;){const B=n.scan();switch(n.getTokenError()){case 4:_(14);break;case 5:_(15);break;case 3:_(13);break;case 1:Z||_(11);break;case 2:_(12);break;case 6:_(16);break}switch(B){case 12:case 13:Z?_(10):te();break;case 16:_(1);break;case 15:case 14:break;default:return B}}}function _(B,X=[],k=[]){if(se(B),X.length+k.length>0){let F=n.getToken();for(;F!==17;){if(X.indexOf(F)!==-1){le();break}else if(k.indexOf(F)!==-1)break;F=le()}}}function ne(B){const X=n.getTokenValue();return B?j(X):A(X),le(),!0}function z(){switch(n.getToken()){case 11:let B=0;try{B=JSON.parse(n.getTokenValue()),typeof B!="number"&&(_(2),B=0)}catch(X){_(2)}j(B);break;case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return le(),!0}function L(){return n.getToken()!==10?(_(3,[],[2,5]),!1):(ne(!1),n.getToken()===6?(Y(":"),le(),G()||_(4,[],[2,5])):_(5,[],[2,5]),!0)}function M(){w(),le();let B=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(B||_(4,[],[]),Y(","),le(),n.getToken()===2&&ce)break}else B&&_(6,[],[]);L()||_(4,[],[2,5]),B=!0}return p(),n.getToken()!==2?_(7,[2],[]):le(),!0}function U(){C(),le();let B=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(B||_(4,[],[]),Y(","),le(),n.getToken()===4&&ce)break}else B&&_(6,[],[]);G()||_(4,[],[4,5]),B=!0}return N(),n.getToken()!==4?_(8,[4],[]):le(),!0}function G(){switch(n.getToken()){case 3:return U();case 1:return M();case 10:return ne(!0);default:return z()}}return le(),n.getToken()===17?r.allowEmptyContent?!0:(_(4,[],[]),!1):G()?(n.getToken()!==17&&_(9,[],[]),!0):(_(4,[],[]),!1)}t.visit=h;function o(e,i){let r=D(e),n=[],a,E=0,w;do switch(w=r.getPosition(),a=r.scan(),a){case 12:case 13:case 17:E!==w&&n.push(e.substring(E,w)),i!==void 0&&n.push(r.getTokenValue().replace(/[^\r\n]/g,i)),E=r.getPosition();break}while(a!==17);return n.join("")}t.stripComments=o;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function $(y){const R=[];typeof y=="number"&&R.push("code/timeOrigin",y);function D(c){R.push(c,Date.now())}function T(){const c=[];for(let g=0;g<R.length;g+=2)c.push({name:R[g],startTime:R[g+1]});return c}return{mark:D,getMarks:T}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const D of performance.getEntriesByType("mark"))R.push({name:D.name,startTime:Math.round(y+D.startTime)});return R}};if(typeof process=="object"){const y=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function O(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=t()),y.MonacoPerformanceMarks}var S;typeof global=="object"?S=global:typeof self=="object"?S=self:S={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(S)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(S):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),S.perf=O(S))}(),function($,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var O=t();for(var S in O)(typeof exports=="object"?exports:$)[S]=O[S]}}(typeof self!="undefined"?self:this,function(){return function($){var t={};function O(S){if(t[S])return t[S].exports;var y=t[S]={i:S,l:!1,exports:{}};return $[S].call(y.exports,y,y.exports,O),y.l=!0,y.exports}return O.m=$,O.c=t,O.d=function(S,y,R){O.o(S,y)||Object.defineProperty(S,y,{enumerable:!0,get:R})},O.r=function(S){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(S,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(S,"__esModule",{value:!0})},O.t=function(S,y){if(1&y&&(S=O(S)),8&y||4&y&&typeof S=="object"&&S&&S.__esModule)return S;var R=Object.create(null);if(O.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:S}),2&y&&typeof S!="string")for(var D in S)O.d(R,D,function(T){return S[T]}.bind(null,D));return R},O.n=function(S){var y=S&&S.__esModule?function(){return S.default}:function(){return S};return O.d(y,"a",y),y},O.o=function(S,y){return Object.prototype.hasOwnProperty.call(S,y)},O.p="",O(O.s=0)}([function($,t,O){(function(S){var y;t=$.exports=k,y=typeof S=="object"&&S.env&&S.env.NODE_DEBUG&&/\bsemver\b/i.test(S.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var R=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,T=t.re=[],c=t.src=[],g=0,v=g++;c[v]="0|[1-9]\\d*";var P=g++;c[P]="[0-9]+";var d=g++;c[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=g++;c[I]="("+c[v]+")\\.("+c[v]+")\\.("+c[v]+")";var l=g++;c[l]="("+c[P]+")\\.("+c[P]+")\\.("+c[P]+")";var u=g++;c[u]="(?:"+c[v]+"|"+c[d]+")";var b=g++;c[b]="(?:"+c[P]+"|"+c[d]+")";var f=g++;c[f]="(?:-("+c[u]+"(?:\\."+c[u]+")*))";var m=g++;c[m]="(?:-?("+c[b]+"(?:\\."+c[b]+")*))";var h=g++;c[h]="[0-9A-Za-z-]+";var o=g++;c[o]="(?:\\+("+c[h]+"(?:\\."+c[h]+")*))";var s=g++,e="v?"+c[I]+c[f]+"?"+c[o]+"?";c[s]="^"+e+"$";var i="[v=\\s]*"+c[l]+c[m]+"?"+c[o]+"?",r=g++;c[r]="^"+i+"$";var n=g++;c[n]="((?:<|>)?=?)";var a=g++;c[a]=c[P]+"|x|X|\\*";var E=g++;c[E]=c[v]+"|x|X|\\*";var w=g++;c[w]="[v=\\s]*("+c[E]+")(?:\\.("+c[E]+")(?:\\.("+c[E]+")(?:"+c[f]+")?"+c[o]+"?)?)?";var A=g++;c[A]="[v=\\s]*("+c[a]+")(?:\\.("+c[a]+")(?:\\.("+c[a]+")(?:"+c[m]+")?"+c[o]+"?)?)?";var p=g++;c[p]="^"+c[n]+"\\s*"+c[w]+"$";var C=g++;c[C]="^"+c[n]+"\\s*"+c[A]+"$";var N=g++;c[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=g++;c[j]="(?:~>?)";var Y=g++;c[Y]="(\\s*)"+c[j]+"\\s+",T[Y]=new RegExp(c[Y],"g");var te=g++;c[te]="^"+c[j]+c[w]+"$";var se=g++;c[se]="^"+c[j]+c[A]+"$";var Z=g++;c[Z]="(?:\\^)";var ce=g++;c[ce]="(\\s*)"+c[Z]+"\\s+",T[ce]=new RegExp(c[ce],"g");var le=g++;c[le]="^"+c[Z]+c[w]+"$";var _=g++;c[_]="^"+c[Z]+c[A]+"$";var ne=g++;c[ne]="^"+c[n]+"\\s*("+i+")$|^$";var z=g++;c[z]="^"+c[n]+"\\s*("+e+")$|^$";var L=g++;c[L]="(\\s*)"+c[n]+"\\s*("+i+"|"+c[w]+")",T[L]=new RegExp(c[L],"g");var M=g++;c[M]="^\\s*("+c[w]+")\\s+-\\s+("+c[w]+")\\s*$";var U=g++;c[U]="^\\s*("+c[A]+")\\s+-\\s+("+c[A]+")\\s*$";var G=g++;c[G]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)y(B,c[B]),T[B]||(T[B]=new RegExp(c[B]));function X(x,q){if(x instanceof k)return x;if(typeof x!="string"||x.length>R||!(q?T[r]:T[s]).test(x))return null;try{return new k(x,q)}catch(K){return null}}function k(x,q){if(x instanceof k){if(x.loose===q)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof k))return new k(x,q);y("SemVer",x,q),this.loose=q;var K=x.trim().match(q?T[r]:T[s]);if(!K)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(oe){if(/^[0-9]+$/.test(oe)){var ue=+oe;if(ue>=0&&ue<D)return ue}return oe}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}t.parse=X,t.valid=function(x,q){var K=X(x,q);return K?K.version:null},t.clean=function(x,q){var K=X(x.trim().replace(/^[=v]+/,""),q);return K?K.version:null},t.SemVer=k,k.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},k.prototype.toString=function(){return this.version},k.prototype.compare=function(x){return y("SemVer.compare",this.version,this.loose,x),x instanceof k||(x=new k(x,this.loose)),this.compareMain(x)||this.comparePre(x)},k.prototype.compareMain=function(x){return x instanceof k||(x=new k(x,this.loose)),W(this.major,x.major)||W(this.minor,x.minor)||W(this.patch,x.patch)},k.prototype.comparePre=function(x){if(x instanceof k||(x=new k(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var q=0;do{var K=this.prerelease[q],oe=x.prerelease[q];if(y("prerelease compare",q,K,oe),K===void 0&&oe===void 0)return 0;if(oe===void 0)return 1;if(K===void 0)return-1;if(K!==oe)return W(K,oe)}while(++q)},k.prototype.inc=function(x,q){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",q),this.inc("pre",q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",q),this.inc("pre",q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}q&&(this.prerelease[0]===q?isNaN(this.prerelease[1])&&(this.prerelease=[q,0]):this.prerelease=[q,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},t.inc=function(x,q,K,oe){typeof K=="string"&&(oe=K,K=void 0);try{return new k(x,K).inc(q,oe).version}catch(ue){return null}},t.diff=function(x,q){if(re(x,q))return null;var K=X(x),oe=X(q);if(K.prerelease.length||oe.prerelease.length){for(var ue in K)if((ue==="major"||ue==="minor"||ue==="patch")&&K[ue]!==oe[ue])return"pre"+ue;return"prerelease"}for(var ue in K)if((ue==="major"||ue==="minor"||ue==="patch")&&K[ue]!==oe[ue])return ue},t.compareIdentifiers=W;var F=/^[0-9]+$/;function W(x,q){var K=F.test(x),oe=F.test(q);return K&&oe&&(x=+x,q=+q),K&&!oe?-1:oe&&!K?1:x<q?-1:x>q?1:0}function V(x,q,K){return new k(x,K).compare(new k(q,K))}function H(x,q,K){return V(x,q,K)>0}function J(x,q,K){return V(x,q,K)<0}function re(x,q,K){return V(x,q,K)===0}function ie(x,q,K){return V(x,q,K)!==0}function ge(x,q,K){return V(x,q,K)>=0}function ve(x,q,K){return V(x,q,K)<=0}function de(x,q,K,oe){var ue;switch(q){case"===":typeof x=="object"&&(x=x.version),typeof K=="object"&&(K=K.version),ue=x===K;break;case"!==":typeof x=="object"&&(x=x.version),typeof K=="object"&&(K=K.version),ue=x!==K;break;case"":case"=":case"==":ue=re(x,K,oe);break;case"!=":ue=ie(x,K,oe);break;case">":ue=H(x,K,oe);break;case">=":ue=ge(x,K,oe);break;case"<":ue=J(x,K,oe);break;case"<=":ue=ve(x,K,oe);break;default:throw new TypeError("Invalid operator: "+q)}return ue}function Ee(x,q){if(x instanceof Ee){if(x.loose===q)return x;x=x.value}if(!(this instanceof Ee))return new Ee(x,q);y("comparator",x,q),this.loose=q,this.parse(x),this.semver===Re?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}t.rcompareIdentifiers=function(x,q){return W(q,x)},t.major=function(x,q){return new k(x,q).major},t.minor=function(x,q){return new k(x,q).minor},t.patch=function(x,q){return new k(x,q).patch},t.compare=V,t.compareLoose=function(x,q){return V(x,q,!0)},t.rcompare=function(x,q,K){return V(q,x,K)},t.sort=function(x,q){return x.sort(function(K,oe){return t.compare(K,oe,q)})},t.rsort=function(x,q){return x.sort(function(K,oe){return t.rcompare(K,oe,q)})},t.gt=H,t.lt=J,t.eq=re,t.neq=ie,t.gte=ge,t.lte=ve,t.cmp=de,t.Comparator=Ee;var Re={};function pe(x,q){if(x instanceof pe)return x.loose===q?x:new pe(x.raw,q);if(x instanceof Ee)return new pe(x.value,q);if(!(this instanceof pe))return new pe(x,q);if(this.loose=q,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function we(x){return!x||x.toLowerCase()==="x"||x==="*"}function ze(x,q,K,oe,ue,Te,ye,Oe,Ie,Ce,ke,Pe,Le){return((q=we(K)?"":we(oe)?">="+K+".0.0":we(ue)?">="+K+"."+oe+".0":">="+q)+" "+(Oe=we(Ie)?"":we(Ce)?"<"+(+Ie+1)+".0.0":we(ke)?"<"+Ie+"."+(+Ce+1)+".0":Pe?"<="+Ie+"."+Ce+"."+ke+"-"+Pe:"<="+Oe)).trim()}function We(x,q){for(var K=0;K<x.length;K++)if(!x[K].test(q))return!1;if(q.prerelease.length){for(K=0;K<x.length;K++)if(y(x[K].semver),x[K].semver!==Re&&x[K].semver.prerelease.length>0){var oe=x[K].semver;if(oe.major===q.major&&oe.minor===q.minor&&oe.patch===q.patch)return!0}return!1}return!0}function Me(x,q,K){try{q=new pe(q,K)}catch(oe){return!1}return q.test(x)}function Ve(x,q,K,oe){var ue,Te,ye,Oe,Ie;switch(x=new k(x,oe),q=new pe(q,oe),K){case">":ue=H,Te=ve,ye=J,Oe=">",Ie=">=";break;case"<":ue=J,Te=ge,ye=H,Oe="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Me(x,q,oe))return!1;for(var Ce=0;Ce<q.set.length;++Ce){var ke=q.set[Ce],Pe=null,Le=null;if(ke.forEach(function(Fe){Fe.semver===Re&&(Fe=new Ee(">=0.0.0")),Pe=Pe||Fe,Le=Le||Fe,ue(Fe.semver,Pe.semver,oe)?Pe=Fe:ye(Fe.semver,Le.semver,oe)&&(Le=Fe)}),Pe.operator===Oe||Pe.operator===Ie||(!Le.operator||Le.operator===Oe)&&Te(x,Le.semver)||Le.operator===Ie&&ye(x,Le.semver))return!1}return!0}Ee.prototype.parse=function(x){var q=this.loose?T[ne]:T[z],K=x.match(q);if(!K)throw new TypeError("Invalid comparator: "+x);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new k(K[2],this.loose):this.semver=Re},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(x){return y("Comparator.test",x,this.loose),this.semver===Re||(typeof x=="string"&&(x=new k(x,this.loose)),de(x,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(x,q){if(!(x instanceof Ee))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new pe(x.value,q),Me(this.value,K,q);if(x.operator==="")return K=new pe(this.value,q),Me(x.semver,K,q);var oe=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),ue=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),Te=this.semver.version===x.semver.version,ye=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Oe=de(this.semver,"<",x.semver,q)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),Ie=de(this.semver,">",x.semver,q)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return oe||ue||Te&&ye||Oe||Ie},t.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(x){var q=this.loose;x=x.trim(),y("range",x,q);var K=q?T[U]:T[M];x=x.replace(K,ze),y("hyphen replace",x),x=x.replace(T[L],"$1$2$3"),y("comparator trim",x,T[L]),x=(x=(x=x.replace(T[Y],"$1~")).replace(T[ce],"$1^")).split(/\s+/).join(" ");var oe=q?T[ne]:T[z],ue=x.split(" ").map(function(Te){return function(ye,Oe){return y("comp",ye),ye=function(Ie,Ce){return Ie.trim().split(/\s+/).map(function(ke){return function(Pe,Le){y("caret",Pe,Le);var Fe=Le?T[_]:T[le];return Pe.replace(Fe,function(Ae,he,me,Se,be){var De;return y("caret",Pe,Ae,he,me,Se,be),we(he)?De="":we(me)?De=">="+he+".0.0 <"+(+he+1)+".0.0":we(Se)?De=he==="0"?">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":">="+he+"."+me+".0 <"+(+he+1)+".0.0":be?(y("replaceCaret pr",be),be.charAt(0)!=="-"&&(be="-"+be),De=he==="0"?me==="0"?">="+he+"."+me+"."+Se+be+" <"+he+"."+me+"."+(+Se+1):">="+he+"."+me+"."+Se+be+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+Se+be+" <"+(+he+1)+".0.0"):(y("no pr"),De=he==="0"?me==="0"?">="+he+"."+me+"."+Se+" <"+he+"."+me+"."+(+Se+1):">="+he+"."+me+"."+Se+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+Se+" <"+(+he+1)+".0.0"),y("caret return",De),De})}(ke,Ce)}).join(" ")}(ye,Oe),y("caret",ye),ye=function(Ie,Ce){return Ie.trim().split(/\s+/).map(function(ke){return function(Pe,Le){var Fe=Le?T[se]:T[te];return Pe.replace(Fe,function(Ae,he,me,Se,be){var De;return y("tilde",Pe,Ae,he,me,Se,be),we(he)?De="":we(me)?De=">="+he+".0.0 <"+(+he+1)+".0.0":we(Se)?De=">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":be?(y("replaceTilde pr",be),be.charAt(0)!=="-"&&(be="-"+be),De=">="+he+"."+me+"."+Se+be+" <"+he+"."+(+me+1)+".0"):De=">="+he+"."+me+"."+Se+" <"+he+"."+(+me+1)+".0",y("tilde return",De),De})}(ke,Ce)}).join(" ")}(ye,Oe),y("tildes",ye),ye=function(Ie,Ce){return y("replaceXRanges",Ie,Ce),Ie.split(/\s+/).map(function(ke){return function(Pe,Le){Pe=Pe.trim();var Fe=Le?T[C]:T[p];return Pe.replace(Fe,function(Ae,he,me,Se,be,De){y("xRange",Pe,Ae,he,me,Se,be,De);var je=we(me),xe=je||we(Se),Ue=xe||we(be);return he==="="&&Ue&&(he=""),je?Ae=he===">"||he==="<"?"<0.0.0":"*":he&&Ue?(xe&&(Se=0),Ue&&(be=0),he===">"?(he=">=",xe?(me=+me+1,Se=0,be=0):Ue&&(Se=+Se+1,be=0)):he==="<="&&(he="<",xe?me=+me+1:Se=+Se+1),Ae=he+me+"."+Se+"."+be):xe?Ae=">="+me+".0.0 <"+(+me+1)+".0.0":Ue&&(Ae=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0"),y("xRange return",Ae),Ae})}(ke,Ce)}).join(" ")}(ye,Oe),y("xrange",ye),ye=function(Ie,Ce){return y("replaceStars",Ie,Ce),Ie.trim().replace(T[G],"")}(ye,Oe),y("stars",ye),ye}(Te,q)}).join(" ").split(/\s+/);return this.loose&&(ue=ue.filter(function(Te){return!!Te.match(oe)})),ue=ue.map(function(Te){return new Ee(Te,q)})},pe.prototype.intersects=function(x,q){if(!(x instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(oe){return x.set.some(function(ue){return ue.every(function(Te){return oe.intersects(Te,q)})})})})},t.toComparators=function(x,q){return new pe(x,q).set.map(function(K){return K.map(function(oe){return oe.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new k(x,this.loose));for(var q=0;q<this.set.length;q++)if(We(this.set[q],x))return!0;return!1},t.satisfies=Me,t.maxSatisfying=function(x,q,K){var oe=null,ue=null;try{var Te=new pe(q,K)}catch(ye){return null}return x.forEach(function(ye){Te.test(ye)&&(oe&&ue.compare(ye)!==-1||(ue=new k(oe=ye,K)))}),oe},t.minSatisfying=function(x,q,K){var oe=null,ue=null;try{var Te=new pe(q,K)}catch(ye){return null}return x.forEach(function(ye){Te.test(ye)&&(oe&&ue.compare(ye)!==1||(ue=new k(oe=ye,K)))}),oe},t.validRange=function(x,q){try{return new pe(x,q).range||"*"}catch(K){return null}},t.ltr=function(x,q,K){return Ve(x,q,"<",K)},t.gtr=function(x,q,K){return Ve(x,q,">",K)},t.outside=Ve,t.prerelease=function(x,q){var K=X(x,q);return K&&K.prerelease.length?K.prerelease:null},t.intersects=function(x,q,K){return x=new pe(x,K),q=new pe(q,K),x.intersects(q)},t.coerce=function(x){if(x instanceof k)return x;if(typeof x!="string")return null;var q=x.match(T[N]);return q==null?null:X((q[1]||"0")+"."+(q[2]||"0")+"."+(q[3]||"0"))}}).call(this,O(1))},function($,t){var O,S,y=$.exports={};function R(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function T(b){if(O===setTimeout)return setTimeout(b,0);if((O===R||!O)&&setTimeout)return O=setTimeout,setTimeout(b,0);try{return O(b,0)}catch(f){try{return O.call(null,b,0)}catch(m){return O.call(this,b,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:R}catch(b){O=R}try{S=typeof clearTimeout=="function"?clearTimeout:D}catch(b){S=D}})();var c,g=[],v=!1,P=-1;function d(){v&&c&&(v=!1,c.length?g=c.concat(g):P=-1,g.length&&I())}function I(){if(!v){var b=T(d);v=!0;for(var f=g.length;f;){for(c=g,g=[];++P<f;)c&&c[P].run();P=-1,f=g.length}c=null,v=!1,function(m){if(S===clearTimeout)return clearTimeout(m);if((S===D||!S)&&clearTimeout)return S=clearTimeout,clearTimeout(m);try{S(m)}catch(h){try{return S.call(null,m)}catch(o){return S.call(this,m)}}}(b)}}function l(b,f){this.fun=b,this.array=f}function u(){}y.nextTick=function(b){var f=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)f[m-1]=arguments[m];g.push(new l(b,f)),g.length!==1||v||T(I)},l.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=u,y.addListener=u,y.once=u,y.off=u,y.removeListener=u,y.removeAllListeners=u,y.emit=u,y.prependListener=u,y.prependOnceListener=u,y.listeners=function(b){return[]},y.binding=function(b){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(b){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(Q[37],ee([0,1,9,2]),function($,t,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function y(h){const o=h;return o?[o.on,o.pause,o.resume,o.destroy].every(s=>typeof s=="function"):!1}t.isReadableStream=y;function R(h){const o=h;return o?y(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}t.isReadableBufferedStream=R;function D(h,o){return new T(h,o)}t.newWriteableStream=D;class T{constructor(o,s){this.reducer=o,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(s=>s(o))}emitError(o){this.listeners.error.length===0?(0,O.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(s=>s(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,s){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(o,s){if(this.state.destroyed)return;let e;switch(o){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(s);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(h,o){const s=[];let e;for(;(e=h.read())!==null;)s.push(e);return o(s)}t.consumeReadable=c;function g(h,o,s){const e=[];let i;for(;(i=h.read())!==null&&e.length<s;)e.push(i);return i===null&&e.length>0?o(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const r=i;return i=void 0,r}return h.read()}}}t.peekReadable=g;function v(h,o){return new Promise((s,e)=>{const i=[];P(h,{onData:r=>{o&&i.push(r)},onError:r=>{o?e(r):s(void 0)},onEnd:()=>{s(o?o(i):void 0)}})})}t.consumeStream=v;function P(h,o){h.on("error",s=>o.onError(s)),h.on("end",()=>o.onEnd()),h.on("data",s=>o.onData(s))}t.listenStream=P;function d(h,o){return new Promise((s,e)=>{const i=new S.DisposableStore,r=[],n=w=>{if(r.push(w),r.length>o)return i.dispose(),h.pause(),s({stream:h,buffer:r,ended:!1})},a=w=>e(w),E=()=>s({stream:h,buffer:r,ended:!0});i.add((0,S.toDisposable)(()=>h.removeListener("error",a))),h.on("error",a),i.add((0,S.toDisposable)(()=>h.removeListener("end",E))),h.on("end",E),i.add((0,S.toDisposable)(()=>h.removeListener("data",n))),h.on("data",n)})}t.peekStream=d;function I(h,o){const s=D(o);return s.end(h),s}t.toStream=I;function l(){const h=D(()=>{throw new Error("not supported")});return h.end(),h}t.emptyStream=l;function u(h){let o=!1;return{read:()=>o?null:(o=!0,h)}}t.toReadable=u;function b(h,o,s){const e=D(s);return P(h,{onData:i=>e.write(o.data(i)),onError:i=>e.error(o.error?o.error(i):i),onEnd:()=>e.end()}),e}t.transform=b;function f(h,o,s){let e=!1;return{read:()=>{const i=o.read();return e?i:(e=!0,i!==null?s([h,i]):h)}}}t.prefixedReadable=f;function m(h,o,s){let e=!1;const i=D(s);return P(o,{onData:r=>e?i.write(r):(e=!0,i.write(s([h,r]))),onError:r=>i.error(r),onEnd:()=>{e||(e=!0,i.write(h)),i.end()}}),i}t.prefixedStream=m}),define(Q[17],ee([0,1,37]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const S=typeof Buffer!="undefined";let y,R;class D{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return S?new D(Buffer.allocUnsafe(n)):new D(new Uint8Array(n))}static wrap(n){return S&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new D(n)}static fromString(n,a){return!(a?.dontUseNodeBuffer||!1)&&S?new D(Buffer.from(n)):(y||(y=new TextEncoder),new D(y.encode(n)))}static concat(n,a){if(typeof a=="undefined"){a=0;for(let A=0,p=n.length;A<p;A++)a+=n[A].byteLength}const E=D.alloc(a);let w=0;for(let A=0,p=n.length;A<p;A++){const C=n[A];E.set(C,w),w+=C.byteLength}return E}toString(){return S?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(n,a){return new D(this.buffer.subarray(n,a))}set(n,a){n instanceof D?this.buffer.set(n.buffer,a):this.buffer.set(n,a)}readUInt32BE(n){return g(this.buffer,n)}writeUInt32BE(n,a){v(this.buffer,n,a)}readUInt32LE(n){return P(this.buffer,n)}writeUInt32LE(n,a){d(this.buffer,n,a)}readUInt8(n){return I(this.buffer,n)}writeUInt8(n,a){l(this.buffer,n,a)}}t.VSBuffer=D;function T(r,n){return r[n+0]<<0>>>0|r[n+1]<<8>>>0}t.readUInt16LE=T;function c(r,n,a){r[a+0]=n&255,n=n>>>8,r[a+1]=n&255}t.writeUInt16LE=c;function g(r,n){return r[n]*2**24+r[n+1]*2**16+r[n+2]*2**8+r[n+3]}t.readUInt32BE=g;function v(r,n,a){r[a+3]=n,n=n>>>8,r[a+2]=n,n=n>>>8,r[a+1]=n,n=n>>>8,r[a]=n}t.writeUInt32BE=v;function P(r,n){return r[n+0]<<0>>>0|r[n+1]<<8>>>0|r[n+2]<<16>>>0|r[n+3]<<24>>>0}t.readUInt32LE=P;function d(r,n,a){r[a+0]=n&255,n=n>>>8,r[a+1]=n&255,n=n>>>8,r[a+2]=n&255,n=n>>>8,r[a+3]=n&255}t.writeUInt32LE=d;function I(r,n){return r[n]}t.readUInt8=I;function l(r,n,a){r[a]=n}t.writeUInt8=l;function u(r){return O.consumeReadable(r,n=>D.concat(n))}t.readableToBuffer=u;function b(r){return O.toReadable(r)}t.bufferToReadable=b;function f(r){return O.consumeStream(r,n=>D.concat(n))}t.streamToBuffer=f;async function m(r){return r.ended?D.concat(r.buffer):D.concat([...r.buffer,await f(r.stream)])}t.bufferedStreamToBuffer=m;function h(r){return O.toStream(r,n=>D.concat(n))}t.bufferToStream=h;function o(r){return O.transform(r,{data:n=>typeof n=="string"?D.fromString(n):D.wrap(n)},n=>D.concat(n))}t.streamToBufferReadableStream=o;function s(r){return O.newWriteableStream(n=>D.concat(n),r)}t.newWriteableBufferStream=s;function e(r,n){return O.prefixedReadable(r,n,a=>D.concat(a))}t.prefixedBufferReadable=e;function i(r,n){return O.prefixedStream(r,n,a=>D.concat(a))}t.prefixedBufferStream=i}),define(Q[18],ee([0,1,10]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function S(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const b=Array.isArray(u)?[]:{};return Object.keys(u).forEach(f=>{u[f]&&typeof u[f]=="object"?b[f]=S(u[f]):b[f]=u[f]}),b}t.deepClone=S;function y(u){if(!u||typeof u!="object")return u;const b=[u];for(;b.length>0;){const f=b.shift();Object.freeze(f);for(const m in f)if(R.call(f,m)){const h=f[m];typeof h=="object"&&!Object.isFrozen(h)&&b.push(h)}}return u}t.deepFreeze=y;const R=Object.prototype.hasOwnProperty;function D(u,b){return T(u,b,new Set)}t.cloneAndChange=D;function T(u,b,f){if((0,O.isUndefinedOrNull)(u))return u;const m=b(u);if(typeof m!="undefined")return m;if((0,O.isArray)(u)){const h=[];for(const o of u)h.push(T(o,b,f));return h}if((0,O.isObject)(u)){if(f.has(u))throw new Error("Cannot clone recursive data-structure");f.add(u);const h={};for(let o in u)R.call(u,o)&&(h[o]=T(u[o],b,f));return f.delete(u),h}return u}function c(u,b,f=!0){return(0,O.isObject)(u)?((0,O.isObject)(b)&&Object.keys(b).forEach(m=>{m in u?f&&((0,O.isObject)(u[m])&&(0,O.isObject)(b[m])?c(u[m],b[m],f):u[m]=b[m]):u[m]=b[m]}),u):b}t.mixin=c;function g(u,b){if(u===b)return!0;if(u==null||b===null||b===void 0||typeof u!=typeof b||typeof u!="object"||Array.isArray(u)!==Array.isArray(b))return!1;let f,m;if(Array.isArray(u)){if(u.length!==b.length)return!1;for(f=0;f<u.length;f++)if(!g(u[f],b[f]))return!1}else{const h=[];for(m in u)h.push(m);h.sort();const o=[];for(m in b)o.push(m);if(o.sort(),!g(h,o))return!1;for(f=0;f<h.length;f++)if(!g(u[h[f]],b[h[f]]))return!1}return!0}t.equals=g;function v(u){const b=new Set;return JSON.stringify(u,(f,m)=>{if((0,O.isObject)(m)||Array.isArray(m)){if(b.has(m))return"[Circular]";b.add(m)}return m})}t.safeStringify=v;function P(u,b,f){const m=b(u);return typeof m=="undefined"?f:m}t.getOrDefault=P;function d(u,b){const f=Object.create(null);return!u||!b||Object.keys(b).forEach(h=>{const o=u[h],s=b[h];g(o,s)||(f[h]=s)}),f}t.distinct=d;function I(u,b){const f=b.toLowerCase(),m=Object.keys(u).find(h=>h.toLowerCase()===f);return m?u[m]:u[b]}t.getCaseInsensitive=I;function l(u,b){const f=Object.create(null);for(const m of Object.keys(u))b(m,u[m])&&(f[m]=u[m]);return f}t.filter=l}),define(Q[60],ee([0,1,7]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function S(g){const v=g;return v&&typeof v.type=="string"&&typeof v.severity=="string"}t.isRemoteConsoleLog=S;function y(g){const v=[];let P;try{const d=JSON.parse(g.arguments),I=d[d.length-1];I&&I.__$stack&&(d.pop(),P=I.__$stack),v.push(...d)}catch(d){v.push("Unable to log remote console arguments",g.arguments)}return{args:v,stack:P}}t.parse=y;function R(g){if(typeof g!="string")return R(y(g).stack);const v=g;if(v){const P=D(v),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(d&&d.length===4)return{uri:O.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}t.getFirstFrame=R;function D(g){if(!g)return g;const v=g.indexOf(`
`);return v===-1?g:g.substring(0,v)}function T(g,v){const{args:P,stack:d}=y(g),I=typeof P[0]=="string"&&P.length===1;let l=D(d);l&&(l=`(${l.trim()})`);let u=[];if(typeof P[0]=="string"?l&&I?u=[`%c[${v}] %c${P[0]} %c${l}`,c("blue"),c(""),c("grey")]:u=[`%c[${v}] %c${P[0]}`,c("blue"),c(""),...P.slice(1)]:u=[`%c[${v}]%`,c("blue"),...P],l&&!I&&u.push(l),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,u)}t.log=T;function c(g){return`color: ${g}`}}),define(Q[61],ee([0,1,17,21,7]),function($,t,O,S,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function R(v){return JSON.stringify(v,c)}t.stringify=R;function D(v){let P=JSON.parse(v);return P=g(P),P}t.parse=D;var T;(function(v){v[v.Uri=1]="Uri",v[v.Regexp=2]="Regexp",v[v.ScmResource=3]="ScmResource",v[v.ScmResourceGroup=4]="ScmResourceGroup",v[v.ScmProvider=5]="ScmProvider",v[v.CommentController=6]="CommentController",v[v.CommentThread=7]="CommentThread",v[v.CommentThreadReply=8]="CommentThreadReply",v[v.CommentNode=9]="CommentNode",v[v.CommentThreadNode=10]="CommentThreadNode",v[v.TimelineActionContext=11]="TimelineActionContext",v[v.NotebookCellActionContext=12]="NotebookCellActionContext",v[v.TestItemContext=13]="TestItemContext"})(T=t.MarshalledId||(t.MarshalledId={}));function c(v,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,S.regExpFlags)(P)}:P}function g(v,P=0){if(!v||P>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return y.URI.revive(v);case 2:return new RegExp(v.source,v.flags)}if(v instanceof O.VSBuffer||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let d=0;d<v.length;++d)v[d]=g(v[d],P+1);else for(const d in v)Object.hasOwnProperty.call(v,d)&&(v[d]=g(v[d],P+1))}return v}t.revive=g}),define(Q[62],ee([0,1,3,38,46,4,21]),function($,t,O,S,y,R,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function T(){return Object.create(null)}t.getEmptyExpression=T;const c="**",g="/",v="[/\\\\]",P="[^/\\\\]",d=/\//g;function I(L){switch(L){case 0:return"";case 1:return`${P}*?`;default:return`(?:${v}|${P}+${v}|${v}${P}+)*?`}}function l(L,M){if(!L)return[];const U=[];let G=!1,B=!1,X="";for(const k of L){switch(k){case M:if(!G&&!B){U.push(X),X="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":B=!0;break;case"]":B=!1;break}X+=k}return X&&U.push(X),U}t.splitGlobAware=l;function u(L){if(!L)return"";let M="";const U=l(L,g);if(U.every(G=>G===c))M=".*";else{let G=!1;U.forEach((B,X)=>{if(B===c){G||(M+=I(2),G=!0);return}let k=!1,F="",W=!1,V="";for(const H of B){if(H!=="}"&&k){F+=H;continue}if(W&&(H!=="]"||!V)){let J;H==="-"?J=H:(H==="^"||H==="!")&&!V?J="^":H===g?J="":J=D.escapeRegExpCharacters(H),V+=J;continue}switch(H){case"{":k=!0;continue;case"[":W=!0;continue;case"}":M+=`(?:${l(F,",").map(ie=>u(ie)).join("|")})`,k=!1,F="";break;case"]":M+="["+V+"]",W=!1,V="";break;case"?":M+=P;continue;case"*":M+=I(1);continue;default:M+=D.escapeRegExpCharacters(H)}}X<U.length-1&&(U[X+1]!==c||X+2<U.length)&&(M+=v),G=!1})}return M}const b=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new y.LRUCache(1e4),i=function(){return!1},r=function(){return null};function n(L,M){if(!L)return r;let U;typeof L!="string"?U=L.pattern:U=L,U=U.trim();const G=`${U}_${!!M.trimForExclusions}`;let B=e.get(G);if(B)return a(B,L);let X;if(b.test(U)){const k=U.substr(4);B=function(F,W){return typeof F=="string"&&F.endsWith(k)?U:null}}else(X=f.exec(E(U,M)))?B=w(X[1],U):(M.trimForExclusions?h:m).test(U)?B=A(U,M):(X=o.exec(E(U,M)))?B=p(X[1].substr(1),U,!0):(X=s.exec(E(U,M)))?B=p(X[1],U,!1):B=C(U);return e.set(G,B),a(B,L)}function a(L,M){return typeof M=="string"?L:function(U,G){return S.isEqualOrParent(U,M.base)?L(R.relative(M.base,U),G):null}}function E(L,M){return M.trimForExclusions&&L.endsWith("/**")?L.substr(0,L.length-2):L}function w(L,M){const U=`/${L}`,G=`\\${L}`,B=function(k,F){return typeof k!="string"?null:F?F===L?M:null:k===L||k.endsWith(U)||k.endsWith(G)?M:null},X=[L];return B.basenames=X,B.patterns=[M],B.allBasenames=X,B}function A(L,M){const U=z(L.slice(1,-1).split(",").map(F=>n(F,M)).filter(F=>F!==r),L),G=U.length;if(!G)return r;if(G===1)return U[0];const B=function(F,W){for(let V=0,H=U.length;V<H;V++)if(U[V](F,W))return L;return null},X=U.find(F=>!!F.allBasenames);X&&(B.allBasenames=X.allBasenames);const k=U.reduce((F,W)=>W.allPaths?F.concat(W.allPaths):F,[]);return k.length&&(B.allPaths=k),B}function p(L,M,U){const G=R.sep===R.posix.sep,B=G?L:L.replace(d,R.sep),X=R.sep+B,k=R.posix.sep+L,F=U?function(W,V){return typeof W=="string"&&(W===B||W.endsWith(X)||!G&&(W===L||W.endsWith(k)))?M:null}:function(W,V){return typeof W=="string"&&(W===B||!G&&W===L)?M:null};return F.allPaths=[(U?"*/":"./")+L],F}function C(L){try{const M=new RegExp(`^${u(L)}$`);return function(U){return M.lastIndex=0,typeof U=="string"&&M.test(U)?L:null}}catch(M){return r}}function N(L,M,U){return!L||typeof M!="string"?!1:j(L)(M,void 0,U)}t.match=N;function j(L,M={}){if(!L)return i;if(typeof L=="string"||Z(L)){const U=n(L,M);if(U===r)return i;const G=function(B,X){return!!U(B,X)};return U.allBasenames&&(G.allBasenames=U.allBasenames),U.allPaths&&(G.allPaths=U.allPaths),G}return _(L,M)}t.parse=j;function Y(L){if(!L)return;let M;return U=>(M||(M=(L()||Promise.resolve([])).then(G=>G?se(G):{})),M.then(G=>!!G[U]))}t.hasSiblingPromiseFn=Y;function te(L){if(!L)return;let M;return U=>{if(!M){const G=L();M=G?se(G):{}}return!!M[U]}}t.hasSiblingFn=te;function se(L){const M={};for(const U of L)M[U]=!0;return M}function Z(L){const M=L;return M&&typeof M.base=="string"&&typeof M.pattern=="string"}t.isRelativePattern=Z;function ce(L){return L.allBasenames||[]}t.getBasenameTerms=ce;function le(L){return L.allPaths||[]}t.getPathTerms=le;function _(L,M){const U=z(Object.getOwnPropertyNames(L).map(F=>ne(F,L[F],M)).filter(F=>F!==r)),G=U.length;if(!G)return r;if(!U.some(F=>!!F.requiresSiblings)){if(G===1)return U[0];const F=function(H,J){for(let re=0,ie=U.length;re<ie;re++){const ge=U[re](H,J);if(ge)return ge}return null},W=U.find(H=>!!H.allBasenames);W&&(F.allBasenames=W.allBasenames);const V=U.reduce((H,J)=>J.allPaths?H.concat(J.allPaths):H,[]);return V.length&&(F.allPaths=V),F}const B=function(F,W,V){let H;for(let J=0,re=U.length;J<re;J++){const ie=U[J];ie.requiresSiblings&&V&&(W||(W=R.basename(F)),H||(H=W.substr(0,W.length-R.extname(F).length)));const ge=ie(F,W,H,V);if(ge)return ge}return null},X=U.find(F=>!!F.allBasenames);X&&(B.allBasenames=X.allBasenames);const k=U.reduce((F,W)=>W.allPaths?F.concat(W.allPaths):F,[]);return k.length&&(B.allPaths=k),B}function ne(L,M,U){if(M===!1)return r;const G=n(L,U);if(G===r)return r;if(typeof M=="boolean")return G;if(M){const B=M.when;if(typeof B=="string"){const X=(k,F,W,V)=>{if(!V||!G(k,F))return null;const H=B.replace("$(basename)",W),J=V(H);return(0,O.isThenable)(J)?J.then(re=>re?L:null):J?L:null};return X.requiresSiblings=!0,X}}return G}function z(L,M){const U=L.filter(F=>!!F.basenames);if(U.length<2)return L;const G=U.reduce((F,W)=>{const V=W.basenames;return V?F.concat(V):F},[]);let B;if(M){B=[];for(let F=0,W=G.length;F<W;F++)B.push(M)}else B=U.reduce((F,W)=>{const V=W.patterns;return V?F.concat(V):F},[]);const X=function(F,W){if(typeof F!="string")return null;if(!W){let H;for(H=F.length;H>0;H--){const J=F.charCodeAt(H-1);if(J===47||J===92)break}W=F.substr(H)}const V=G.indexOf(W);return V!==-1?B[V]:null};X.basenames=G,X.patterns=B,X.allBasenames=G;const k=L.filter(F=>!F.basenames);return k.push(X),k}}),define(Q[63],ee([0,1,38,8,4,11,19,21,7]),function($,t,O,S,y,R,D,T,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function g(n,a,E){if(typeof n=="string"&&(n=c.URI.file(n)),E){const A=E.getWorkspaceFolder(n);if(A){const p=E.getWorkspace().folders.length>1;let C;if((0,D.isEqual)(A.uri,n)?C="":C=(0,D.relativePath)(A.uri,n),p){const N=A.name?A.name:(0,D.basename)(A.uri);C=C?N+" \u2022 "+C:N}return C}}if(n.scheme!==S.Schemas.file&&n.scheme!==S.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,O.hasDriveLetter)(n.fsPath))return(0,y.normalize)(P(n.fsPath));let w=(0,y.normalize)(n.fsPath);return!R.isWindows&&a?.userHome&&(w=I(w,a.userHome.fsPath)),w}t.getPathLabel=g;function v(n){if(!n)return;typeof n=="string"&&(n=c.URI.file(n));const a=(0,D.basename)(n)||(n.scheme===S.Schemas.file?n.fsPath:n.path);return R.isWindows&&(0,O.isRootOrDriveLetter)(a)?P(a):a}t.getBaseLabel=v;function P(n){return(0,O.hasDriveLetter)(n)?n.charAt(0).toUpperCase()+n.slice(1):n}t.normalizeDriveLetter=P;let d=Object.create(null);function I(n,a){if(R.isWindows||!n||!a)return n;let E=d.original===a?d.normalized:void 0;return E||(E=`${(0,T.rtrim)(a,y.posix.sep)}${y.posix.sep}`,d={original:a,normalized:E}),(R.isLinux?n.startsWith(E):(0,T.startsWithIgnoreCase)(n,E))&&(n=`~/${n.substr(E.length)}`),n}t.tildify=I;function l(n,a){return n.replace(/^~($|\/|\\)/,`${a}$1`)}t.untildify=l;const u="\u2026",b="\\\\",f="~";function m(n,a=y.sep){const E=new Array(n.length);let w=!1;for(let A=0;A<n.length;A++){let p=n[A];if(p===""){E[A]=`.${a}`;continue}if(!p){E[A]=p;continue}w=!0;let C="";p.indexOf(b)===0?(C=p.substr(0,p.indexOf(b)+b.length),p=p.substr(p.indexOf(b)+b.length)):p.indexOf(a)===0?(C=p.substr(0,p.indexOf(a)+a.length),p=p.substr(p.indexOf(a)+a.length)):p.indexOf(f)===0&&(C=p.substr(0,p.indexOf(f)+f.length),p=p.substr(p.indexOf(f)+f.length));const N=p.split(a);for(let j=1;w&&j<=N.length;j++)for(let Y=N.length-j;w&&Y>=0;Y--){w=!1;let te=N.slice(Y,Y+j).join(a);for(let se=0;!w&&se<n.length;se++)if(se!==A&&n[se]&&n[se].indexOf(te)>-1){const Z=Y+j===N.length,ce=Y>0&&n[se].indexOf(a)>-1?a+te:te,le=n[se].endsWith(ce);w=!Z||le}if(!w){let se="";(N[0].endsWith(":")||C!=="")&&(Y===1&&(Y=0,j++,te=N[0]+a+te),Y>0&&(se=N[0]+a),se=C+se),Y>0&&(se=se+u+a),se=se+te,Y+j<N.length&&(se=se+a+u),E[A]=se}}w&&(E[A]=p)}return E}t.shorten=m;var h;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function o(n,a=Object.create(null)){const E=[];let w=!1,A="";for(const p of n)if(p==="$"||w&&p==="{")A&&E.push({value:A,type:h.TEXT}),A="",w=!0;else if(p==="}"&&w){const C=a[A];if(typeof C=="string")C.length&&E.push({value:C,type:h.VARIABLE});else if(C){const N=E[E.length-1];(!N||N.type!==h.SEPARATOR)&&E.push({value:C.label,type:h.SEPARATOR})}A="",w=!1}else A+=p;return A&&!w&&E.push({value:A,type:h.TEXT}),E.filter((p,C)=>{if(p.type===h.SEPARATOR){const N=E[C-1],j=E[C+1];return[N,j].every(Y=>Y&&(Y.type===h.VARIABLE||Y.type===h.TEXT)&&Y.value.length>0)}return!0}).map(p=>p.value).join("")}t.template=o;function s(n,a){return R.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):n.replace(/&&|&/g,E=>E==="&"?"&&":"&")}t.mnemonicMenuLabel=s;function e(n,a){return R.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,""):R.isWindows?n.replace(/&&|&/g,E=>E==="&"?"&&":"&"):n.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(n){return n.replace(/&/g,"&&")}t.unmnemonicLabel=i;function r(n){const a=n.indexOf("/")!==-1?y.posix:y.win32,E=a.basename(n),w=a.dirname(n);return E.length?{name:E,parentPath:w}:{name:w,parentPath:""}}t.splitName=r}),define(Q[47],ee([0,1,126]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class S{constructor(R="utf8"){this.stringDecoder=new O.StringDecoder(R),this.remaining=null}write(R){const D=[],T=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(T.length<1)return D;let c=0,g,v=c;for(;v<T.length;)if(g=T.charCodeAt(v),g===13||g===10){if(D.push(T.substring(c,v)),v++,v<T.length){const P=g;g=T.charCodeAt(v),(P===13&&g===10||P===10&&g===13)&&v++}c=v}else v++;return this.remaining=c<T.length?T.substr(c):null,D}end(){return this.remaining}}t.LineDecoder=S}),define(Q[64],ee([0,1,48,4,21,12]),function($,t,O,S,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function D(v){const P=(0,S.dirname)(v);if(v===P)return v;const d=((0,S.basename)(v)||v).toLowerCase();try{const l=(0,R.readdirSync)(P).filter(u=>u.toLowerCase()===d);if(l.length===1){const u=D(P);if(u)return(0,S.join)(u,l[0])}else if(l.length>1){const u=l.indexOf(d);if(u>=0){const b=D(P);if(b)return(0,S.join)(b,l[u])}}}catch(I){}return null}t.realcaseSync=D;async function T(v){try{return await R.Promises.realpath(v)}catch(P){const d=g(v);return await R.Promises.access(d,O.constants.R_OK),d}}t.realpath=T;function c(v){try{return O.realpathSync(v)}catch(P){const d=g(v);return O.accessSync(d,O.constants.R_OK),d}}t.realpathSync=c;function g(v){return(0,y.rtrim)((0,S.normalize)(v),S.sep)}}),define(Q[65],ee([0,1,34,4,12]),function($,t,O,S,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,D=/^Microsoft.PowerShell_.*/,T=/^Microsoft.PowerShellPreview_.*/;var c;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(c||(c={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let v;process.env.PROCESSOR_ARCHITEW6432?v=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?v=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?v=1:v=0;class P{constructor(s,e,i){this.exePath=s,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await y.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:o=!1}={}){return o?g===0?process.env["ProgramFiles(x86)"]||null:v===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function I({useAlternateBitness:o=!1,findPreview:s=!1}={}){const e=d({useAlternateBitness:o});if(!e)return null;const i=S.join(e,"PowerShell");if(!await y.SymlinkSupport.existsDirectory(i))return null;let r=-1,n=null;for(const w of await y.Promises.readdir(i)){let A=-1;if(s){const C=w.indexOf("-");if(C<0)continue;const N=w.substring(0,C);if(!R.test(N)||w.substring(C+1)!=="preview")continue;A=parseInt(N,10)}else{if(!R.test(w))continue;A=parseInt(w,10)}if(A<=r)continue;const p=S.join(i,w,"pwsh.exe");!await y.SymlinkSupport.existsFile(p)||(n=p,r=A)}if(!n)return null;const a=e.includes("x86")?" (x86)":"",E=s?" Preview":"";return new P(n,`PowerShell${E}${a}`,!0)}async function l({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const s=S.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await y.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=o?{pwshMsixDirRegex:T,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const r of await y.Promises.readdir(s))if(e.test(r)){const n=S.join(s,r,"pwsh.exe");return new P(n,i)}return null}function u(){const o=S.join(O.homedir(),".dotnet","tools","pwsh.exe");return new P(o,".NET Core PowerShell Global Tool")}function b(){const o=S.join(process.env.windir,g===1&&v!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(o,"Windows PowerShell",!0)}async function*f(){let o=await I();o&&(yield o),o=await I({useAlternateBitness:!0}),o&&(yield o),o=await l(),o&&(yield o),o=u(),o&&(yield o),o=await I({findPreview:!0}),o&&(yield o),o=await l({findPreview:!0}),o&&(yield o),o=await I({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=b(),o&&(yield o)}async function*m(){for await(const o of f())await o.exists()&&(yield o)}t.enumeratePowerShellInstallations=m;async function h(){for await(const o of m())return o;return null}t.getFirstAvailablePowerShellInstallation=h});var fe=this&&this.__decorate||function($,t,O,S){var y=arguments.length,R=y<3?t:S===null?S=Object.getOwnPropertyDescriptor(t,O):S,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate($,t,O,S);else for(var T=$.length-1;T>=0;T--)(D=$[T])&&(R=(y<3?D(R):y>3?D(t,O,R):D(t,O))||R);return y>3&&R&&Object.defineProperty(t,O,R),R};define(Q[39],ee([0,1,22,3,17,25,45,9,13,2,61,21,10]),function($,t,O,S,y,R,D,T,c,g,v,P,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var I;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(I=t.RequestType||(t.RequestType={}));function l(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(u=t.ResponseType||(t.ResponseType={}));function b(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(f||(f={}));class m{constructor(L){this.buffer=L,this.pos=0}read(L){const M=this.buffer.slice(this.pos,this.pos+L);return this.pos+=M.byteLength,M}}class h{constructor(){this.buffers=[]}get buffer(){return y.VSBuffer.concat(this.buffers)}write(L){this.buffers.push(L)}}var o;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(o||(o={}));function s(z){const L=y.VSBuffer.alloc(4);return L.writeUInt32BE(z,0),L}function e(z){return z.read(4).readUInt32BE(0)}function i(z){const L=y.VSBuffer.alloc(1);return L.writeUInt8(z,0),L}const r={Undefined:i(o.Undefined),String:i(o.String),Buffer:i(o.Buffer),VSBuffer:i(o.VSBuffer),Array:i(o.Array),Object:i(o.Object)},n=typeof Buffer!="undefined";function a(z,L){if(typeof L=="undefined")z.write(r.Undefined);else if(typeof L=="string"){const M=y.VSBuffer.fromString(L);z.write(r.String),z.write(s(M.byteLength)),z.write(M)}else if(n&&Buffer.isBuffer(L)){const M=y.VSBuffer.wrap(L);z.write(r.Buffer),z.write(s(M.byteLength)),z.write(M)}else if(L instanceof y.VSBuffer)z.write(r.VSBuffer),z.write(s(L.byteLength)),z.write(L);else if(Array.isArray(L)){z.write(r.Array),z.write(s(L.length));for(const M of L)a(z,M)}else{const M=y.VSBuffer.fromString(JSON.stringify(L));z.write(r.Object),z.write(s(M.byteLength)),z.write(M)}}function E(z){switch(z.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return z.read(e(z)).toString();case o.Buffer:return z.read(e(z)).buffer;case o.VSBuffer:return z.read(e(z));case o.Array:{const M=e(z),U=[];for(let G=0;G<M;G++)U.push(E(z));return U}case o.Object:return JSON.parse(z.read(e(z)).toString())}}class w{constructor(L,M,U=null,G=1e3){this.protocol=L,this.ctx=M,this.logger=U,this.timeoutDelay=G,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(L,M){this.channels.set(L,M),setTimeout(()=>this.flushPendingRequests(L),0)}sendResponse(L){switch(L.type){case 200:{const M=this.send([L.type]);this.logger&&this.logger.logOutgoing(M,0,1,b(L.type));return}case 201:case 202:case 204:case 203:{const M=this.send([L.type,L.id],L.data);this.logger&&this.logger.logOutgoing(M,L.id,1,b(L.type),L.data);return}}}send(L,M=void 0){const U=new h;return a(U,L),a(U,M),this.sendBuffer(U.buffer)}sendBuffer(L){try{return this.protocol.send(L),L.byteLength}catch(M){return 0}}onRawMessage(L){const M=new m(L),U=E(M),G=E(M),B=U[0];switch(B){case 100:return this.logger&&this.logger.logIncoming(L.byteLength,U[1],1,`${l(B)}: ${U[2]}.${U[3]}`,G),this.onPromise({type:B,id:U[1],channelName:U[2],name:U[3],arg:G});case 102:return this.logger&&this.logger.logIncoming(L.byteLength,U[1],1,`${l(B)}: ${U[2]}.${U[3]}`,G),this.onEventListen({type:B,id:U[1],channelName:U[2],name:U[3],arg:G});case 101:return this.logger&&this.logger.logIncoming(L.byteLength,U[1],1,`${l(B)}`),this.disposeActiveRequest({type:B,id:U[1]});case 103:return this.logger&&this.logger.logIncoming(L.byteLength,U[1],1,`${l(B)}`),this.disposeActiveRequest({type:B,id:U[1]})}}onPromise(L){const M=this.channels.get(L.channelName);if(!M){this.collectPendingRequest(L);return}const U=new R.CancellationTokenSource;let G;try{G=M.call(this.ctx,L.name,L.arg,U.token)}catch(k){G=Promise.reject(k)}const B=L.id;G.then(k=>{this.sendResponse({id:B,data:k,type:201}),this.activeRequests.delete(L.id)},k=>{k instanceof Error?this.sendResponse({id:B,data:{message:k.message,name:k.name,stack:k.stack?k.stack.split?k.stack.split(`
`):k.stack:void 0},type:202}):this.sendResponse({id:B,data:k,type:203}),this.activeRequests.delete(L.id)});const X=(0,g.toDisposable)(()=>U.cancel());this.activeRequests.set(L.id,X)}onEventListen(L){const M=this.channels.get(L.channelName);if(!M){this.collectPendingRequest(L);return}const U=L.id,B=M.listen(this.ctx,L.name,L.arg)(X=>this.sendResponse({id:U,data:X,type:204}));this.activeRequests.set(L.id,B)}disposeActiveRequest(L){const M=this.activeRequests.get(L.id);M&&(M.dispose(),this.activeRequests.delete(L.id))}collectPendingRequest(L){let M=this.pendingRequests.get(L.channelName);M||(M=[],this.pendingRequests.set(L.channelName,M));const U=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.sendResponse({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);M.push({request:L,timeoutTimer:U})}flushPendingRequests(L){const M=this.pendingRequests.get(L);if(M){for(const U of M)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.onPromise(U.request);break;case 102:this.onEventListen(U.request);break}this.pendingRequests.delete(L)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(L=>L.dispose()),this.activeRequests.clear()}}t.ChannelServer=w;var A;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(A=t.RequestInitiator||(t.RequestInitiator={}));class p{constructor(L,M=null){this.protocol=L,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(U=>this.onBuffer(U)),this.logger=M}getChannel(L){const M=this;return{call(U,G,B){return M.isDisposed?Promise.reject(T.canceled()):M.requestPromise(L,U,G,B)},listen(U,G){return M.isDisposed?Promise.reject(T.canceled()):M.requestEvent(L,U,G)}}}requestPromise(L,M,U,G=R.CancellationToken.None){const B=this.lastRequestId++,k={id:B,type:100,channelName:L,name:M,arg:U};if(G.isCancellationRequested)return Promise.reject(T.canceled());let F;return new Promise((V,H)=>{if(G.isCancellationRequested)return H(T.canceled());const J=()=>{const ve=de=>{switch(de.type){case 201:this.handlers.delete(B),V(de.data);break;case 202:this.handlers.delete(B);const Ee=new Error(de.data.message);Ee.stack=de.data.stack,Ee.name=de.data.name,H(Ee);break;case 203:this.handlers.delete(B),H(de.data);break}};this.handlers.set(B,ve),this.sendRequest(k)};let re=null;this.state===f.Idle?J():(re=(0,S.createCancelablePromise)(ve=>this.whenInitialized()),re.then(()=>{re=null,J()}));const ie=()=>{re?(re.cancel(),re=null):this.sendRequest({id:B,type:101}),H(T.canceled())},ge=G.onCancellationRequested(ie);F=(0,g.combinedDisposable)((0,g.toDisposable)(ie),ge),this.activeRequests.add(F)}).finally(()=>{this.activeRequests.delete(F)})}requestEvent(L,M,U){const G=this.lastRequestId++,X={id:G,type:102,channelName:L,name:M,arg:U};let k=null;const F=new c.Emitter({onFirstListenerAdd:()=>{k=(0,S.createCancelablePromise)(V=>this.whenInitialized()),k.then(()=>{k=null,this.activeRequests.add(F),this.sendRequest(X)})},onLastListenerRemove:()=>{k?(k.cancel(),k=null):(this.activeRequests.delete(F),this.sendRequest({id:G,type:103}))}}),W=V=>F.fire(V.data);return this.handlers.set(G,W),F.event}sendRequest(L){switch(L.type){case 100:case 102:{const M=this.send([L.type,L.id,L.channelName,L.name],L.arg);this.logger&&this.logger.logOutgoing(M,L.id,0,`${l(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const M=this.send([L.type,L.id]);this.logger&&this.logger.logOutgoing(M,L.id,0,l(L.type));return}}}send(L,M=void 0){const U=new h;return a(U,L),a(U,M),this.sendBuffer(U.buffer)}sendBuffer(L){try{return this.protocol.send(L),L.byteLength}catch(M){return 0}}onBuffer(L){const M=new m(L),U=E(M),G=E(M),B=U[0];switch(B){case 200:return this.logger&&this.logger.logIncoming(L.byteLength,0,0,b(B)),this.onResponse({type:U[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(L.byteLength,U[1],0,b(B),G),this.onResponse({type:U[0],id:U[1],data:G})}}onResponse(L){if(L.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}const M=this.handlers.get(L.id);M&&M(L)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(L=>L.dispose()),this.activeRequests.clear()}}fe([D.memoize],p.prototype,"onDidInitializePromise",null),t.ChannelClient=p;class C{constructor(L){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,L(({protocol:M,onDidClientDisconnect:U})=>{c.Event.once(M.onMessage)(B=>{const X=new m(B),k=E(X),F=new w(M,k),W=new p(M);this.channels.forEach((H,J)=>F.registerChannel(J,H));const V={channelServer:F,channelClient:W,ctx:k};this._connections.add(V),this._onDidAddConnection.fire(V),U(()=>{F.dispose(),W.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const L=[];return this._connections.forEach(M=>L.push(M)),L}getChannel(L,M){const U=this;return{call(G,B,X){let k;if((0,d.isFunction)(M)){let W=(0,O.getRandomElement)(U.connections.filter(M));k=W?Promise.resolve(W):c.Event.toPromise(c.Event.filter(U.onDidAddConnection,M))}else k=M.routeCall(U,G,B);const F=k.then(W=>W.channelClient.getChannel(L));return j(F).call(G,B,X)},listen(G,B){if((0,d.isFunction)(M))return U.getMulticastEvent(L,M,G,B);const X=M.routeEvent(U,G,B).then(k=>k.channelClient.getChannel(L));return j(X).listen(G,B)}}}getMulticastEvent(L,M,U,G){const B=this;let X=new g.DisposableStore;const k=new c.Emitter({onFirstListenerAdd:()=>{X=new g.DisposableStore;const F=new c.EventMultiplexer,W=new Map,V=J=>{const ie=J.channelClient.getChannel(L).listen(U,G),ge=F.add(ie);W.set(J,ge)},H=J=>{const re=W.get(J);!re||(re.dispose(),W.delete(J))};B.connections.filter(M).forEach(V),c.Event.filter(B.onDidAddConnection,M)(V,void 0,X),B.onDidRemoveConnection(H,void 0,X),F.event(k.fire,k,X),X.add(F)},onLastListenerRemove:()=>{X.dispose()}});return k.event}registerChannel(L,M){this.channels.set(L,M),this._connections.forEach(U=>{U.channelServer.registerChannel(L,M)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=C;class N{constructor(L,M,U=null){const G=new h;a(G,M),L.send(G.buffer),this.channelClient=new p(L,U),this.channelServer=new w(L,M,U)}getChannel(L){return this.channelClient.getChannel(L)}registerChannel(L,M){this.channelServer.registerChannel(L,M)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=N;function j(z){return{call(L,M,U){return z.then(G=>G.call(L,M,U))},listen(L,M){const U=new c.Relay;return z.then(G=>U.input=G.listen(L,M)),U.event}}}t.getDelayedChannel=j;function Y(z){let L=!1;return{call(M,U,G){return L?z.call(M,U,G):(0,S.timeout)(0).then(()=>L=!0).then(()=>z.call(M,U,G))},listen(M,U){if(L)return z.listen(M,U);const G=new c.Relay;return(0,S.timeout)(0).then(()=>L=!0).then(()=>G.input=z.listen(M,U)),G.event}}}t.getNextTickChannel=Y;class te{constructor(L){this.fn=L}routeCall(L){return this.route(L)}routeEvent(L){return this.route(L)}async route(L){for(const M of L.connections)if(await Promise.resolve(this.fn(M.ctx)))return Promise.resolve(M);return await c.Event.toPromise(L.onDidAddConnection),await this.route(L)}}t.StaticRouter=te;var se;(function(z){function L(G,B){const X=G,k=B&&B.disableMarshalling,F=new Map;for(const W in X)U(W)&&F.set(W,c.Event.buffer(X[W],!0));return new class{listen(W,V){const H=F.get(V);if(H)return H;throw new Error(`Event not found: ${V}`)}call(W,V,H){const J=X[V];if(typeof J=="function"){if(!k&&Array.isArray(H))for(let re=0;re<H.length;re++)H[re]=(0,v.revive)(H[re]);return J.apply(X,H)}throw new Error(`Method not found: ${V}`)}}}z.fromService=L;function M(G,B){const X=B&&B.disableMarshalling;return new Proxy({},{get(k,F){if(typeof F=="string")return B?.properties?.has(F)?B.properties.get(F):U(F)?G.listen(F):async function(...W){let V;B&&!(0,d.isUndefinedOrNull)(B.context)?V=[B.context,...W]:V=W;const H=await G.call(F,V);return X?H:(0,v.revive)(H)};throw new Error(`Property not found: ${String(F)}`)}})}z.toService=M;function U(G){return G[0]==="o"&&G[1]==="n"&&P.isUpperAsciiLetter(G.charCodeAt(2))}})(se=t.ProxyChannel||(t.ProxyChannel={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){let L=z.toString();if(L!=="[object Object]")return L}return z}function le(z){return Array.isArray(z)?z.map(ce):ce(z)}function _(z,L,M,U,G,B,X){X=le(X);const k=Z[G],F=k[U%k.length];let W=[`%c[${z}]%c[${String(L).padStart(7," ")}]%c[len: ${String(M).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${F}`];/\($/.test(B)?(W=W.concat(X),W.push(")")):W.push(X),console.log.apply(console,W)}t.logWithColors=_;class ne{constructor(L,M){this._outgoingPrefix=L,this._incomingPrefix=M,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(L,M,U,G,B){this._totalOutgoing+=L,_(this._outgoingPrefix,this._totalOutgoing,L,M,U,G,B)}logIncoming(L,M,U,G,B){this._totalIncoming+=L,_(this._incomingPrefix,this._totalIncoming,L,M,U,G,B)}}t.IPCLogger=ne}),define(Q[66],ee([0,1,3,13,2,10]),function($,t,O,S,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var D;(function(P){P[P.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=t.StorageHint||(t.StorageHint={}));function T(P){const d=P;return d?.changed instanceof Map||d?.deleted instanceof Set}t.isStorageItemsChangeEvent=T;var c;(function(P){P[P.None=0]="None",P[P.Initialized=1]="Initialized",P[P.Closed=2]="Closed"})(c||(c={}));class g extends y.Disposable{constructor(d,I=Object.create(null)){super();this.database=d,this.options=I,this._onDidChangeStorage=this._register(new S.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=new O.ThrottledDelayer(g.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){d.changed?.forEach((I,l)=>this.accept(l,I)),d.deleted?.forEach(I=>this.accept(I,void 0))}accept(d,I){if(this.state===c.Closed)return;let l=!1;(0,R.isUndefinedOrNull)(I)?l=this.cache.delete(d):this.cache.get(d)!==I&&(this.cache.set(d,I),l=!0),l&&this._onDidChangeStorage.fire(d)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,I){const l=this.cache.get(d);return(0,R.isUndefinedOrNull)(l)?I:l}getBoolean(d,I){const l=this.get(d);return(0,R.isUndefinedOrNull)(l)?I:l==="true"}getNumber(d,I){const l=this.get(d);return(0,R.isUndefinedOrNull)(l)?I:parseInt(l,10)}async set(d,I){if(this.state===c.Closed)return;if((0,R.isUndefinedOrNull)(I))return this.delete(d);const l=String(I);if(this.cache.get(d)!==l)return this.cache.set(d,l),this.pendingInserts.set(d,l),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.flushDelayer.trigger(()=>this.flushPending())}async delete(d){if(!(this.state===c.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(d){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=g,g.DEFAULT_FLUSH_DELAY=100;class v{constructor(){this.onDidChangeItemsExternal=S.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((I,l)=>this.items.set(l,I)),d.delete&&d.delete.forEach(I=>this.items.delete(I))}async close(){}}t.InMemoryStorageDatabase=v}),define(Q[67],ee([5,6]),function($,t){return $.create("vs/base/common/date",t)}),define(Q[68],ee([0,1,67]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const S=60,y=S*60,R=y*24,D=R*7,T=R*30,c=R*365;function g(P,d){typeof P!="number"&&(P=P.getTime());const I=Math.round((new Date().getTime()-P)/1e3);if(I<-30)return(0,O.localize)(0,null,g(new Date().getTime()+I*1e3,!1));if(I<30)return(0,O.localize)(1,null);let l;return I<S?(l=I,d?l===1?(0,O.localize)(2,null,l):(0,O.localize)(3,null,l):l===1?(0,O.localize)(4,null,l):(0,O.localize)(5,null,l)):I<y?(l=Math.floor(I/S),d?l===1?(0,O.localize)(6,null,l):(0,O.localize)(7,null,l):l===1?(0,O.localize)(8,null,l):(0,O.localize)(9,null,l)):I<R?(l=Math.floor(I/y),d?l===1?(0,O.localize)(10,null,l):(0,O.localize)(11,null,l):l===1?(0,O.localize)(12,null,l):(0,O.localize)(13,null,l)):I<D?(l=Math.floor(I/R),d?l===1?(0,O.localize)(14,null,l):(0,O.localize)(15,null,l):l===1?(0,O.localize)(16,null,l):(0,O.localize)(17,null,l)):I<T?(l=Math.floor(I/D),d?l===1?(0,O.localize)(18,null,l):(0,O.localize)(19,null,l):l===1?(0,O.localize)(20,null,l):(0,O.localize)(21,null,l)):I<c?(l=Math.floor(I/T),d?l===1?(0,O.localize)(22,null,l):(0,O.localize)(23,null,l):l===1?(0,O.localize)(24,null,l):(0,O.localize)(25,null,l)):(l=Math.floor(I/c),d?l===1?(0,O.localize)(26,null,l):(0,O.localize)(27,null,l):l===1?(0,O.localize)(28,null,l):(0,O.localize)(29,null,l))}t.fromNow=g;function v(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=v}),define(Q[69],ee([5,6]),function($,t){return $.create("vs/base/common/errorMessage",t)}),define(Q[30],ee([0,1,22,10,69]),function($,t,O,S,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function R(g,v){return v&&(g.stack||g.stacktrace)?y.localize(0,null,T(g),D(g.stack)||D(g.stacktrace)):T(g)}function D(g){return Array.isArray(g)?g.join(`
`):g}function T(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?y.localize(1,null,g.message):g.message||y.localize(2,null)}function c(g=null,v=!1){if(!g)return y.localize(3,null);if(Array.isArray(g)){const P=O.coalesce(g),d=c(P[0],v);return P.length>1?y.localize(4,null,d,P.length):d}if(S.isString(g))return g;if(g.detail){const P=g.detail;if(P.error)return R(P.error,v);if(P.exception)return R(P.exception,v)}return g.stack?R(g,v):g.message?g.message:y.localize(5,null)}t.toErrorMessage=c}),define(Q[70],ee([5,6]),function($,t){return $.create("vs/base/node/processes",t)}),define(Q[49],ee([0,1,35,38,8,18,4,11,28,10,47,12,70]),function($,t,O,S,y,R,D,T,c,g,v,P,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function I(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function l(o,s){if(T.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};s&&(e.cwd=s);const i=O.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],e);return new Promise(r=>{i.once("error",n=>{r({success:!1,error:n})}),i.once("exit",(n,a)=>{r(n===0?{success:!0}:{success:!1,code:n!==null?n:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?I(e.status):1})}else if(T.isLinux||T.isMacintosh)try{const e=y.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(i=>{O.execFile(e,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,n,a)=>{i(r?{success:!1,error:r}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function u(o=c.env){return o.comspec||"cmd.exe"}t.getWindowsShell=u;class b{constructor(s,e,i,r){if(e!==void 0&&i!==void 0&&r!==void 0)this.cmd=s,this.args=e,this.shell=i,this.options=r;else{const n=s;this.cmd=n.command,this.shell=n.isShellCommand,this.args=n.args.slice(0),this.options=n.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const n=Object.create(null);Object.keys(c.env).forEach(a=>{n[a]=c.env[a]}),Object.keys(this.options.env).forEach(a=>{n[a]=this.options.env[a]}),this.options.env=n}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const e=s.lastIndexOf(D.sep);return e!==-1&&(s=s.substring(e+1)),b.WellKnowCommands[s]?s:"other"}start(s){return T.isWindows&&(this.options&&this.options.cwd&&S.isUNC(this.options.cwd)||!this.options&&S.isUNC(c.cwd()))?Promise.reject(new Error(d.localize(0,null))):this.useExec().then(e=>{let i,r;const n=new Promise((a,E)=>{i=a,r=E});if(e){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=O.exec(a,this.options,(E,w,A)=>{this.childProcess=null;const p=E;p&&p.killed?r({killed:this.terminateRequested,stdout:w.toString(),stderr:A.toString()}):this.handleExec(i,s,E,w,A)})}else{let a=null;const E=w=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(w,i,s,r);const A={terminated:this.terminateRequested};g.isNumber(w)&&(A.cmdCode=w),i(A)};if(this.shell&&T.isWindows){const w=R.deepClone(this.options);w.windowsVerbatimArguments=!0,w.detached=!1;let A=!1,p=!1;const C=[];let N=this.ensureQuotes(this.cmd);C.push(N.value),A=N.quoted,this.args&&this.args.forEach(Y=>{N=this.ensureQuotes(Y),C.push(N.value),p=p&&N.quoted});const j=["/s","/c"];A?p?j.push('"'+C.join(" ")+'"'):C.length>1?j.push('"'+C[0]+'" '+C.slice(1).join(" ")):j.push('"'+C[0]+'"'):j.push(C.join(" ")),a=O.spawn(u(),j,w)}else this.cmd&&(a=O.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(g.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",w=>{this.childProcess=null,r({terminated:this.terminateRequested,error:w})}),a.pid&&(this.childProcess.on("close",E),this.handleSpawn(a,i,s,r,!0)))}return n})}handleClose(s,e,i,r){}ensureQuotes(s){return b.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,l(s,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!T.isWindows)return s(!1);const e=O.spawn(u(),["/s","/c"]);e.on("error",i=>s(!0)),e.on("exit",i=>s(!1))})}}t.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class f extends b{constructor(s,e,i,r){super(s,e,i,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,e,i,r,n){[r,n].forEach((a,E)=>{const w=new v.LineDecoder;w.write(a).forEach(C=>{e({line:C,source:E===0?0:1})});const p=w.end();p&&e({line:p,source:E===0?0:1})}),s({terminated:this.terminateRequested,error:i})}handleSpawn(s,e,i,r,n){const a=new v.LineDecoder,E=new v.LineDecoder;s.stdout.on("data",w=>{a.write(w).forEach(p=>i({line:p,source:0}))}),s.stderr.on("data",w=>{E.write(w).forEach(p=>i({line:p,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=E}handleClose(s,e,i,r){const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&i({line:n,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&i({line:a,source:1})}}t.LineProcess=f;function m(o){let s=[],e=!1;const i=function(r){if(e){s.push(r);return}(!o.send(r,a=>{if(a&&console.error(a),e=!1,s.length>0){const E=s.slice(0);s=[],E.forEach(w=>i(w))}})||T.isWindows)&&(e=!0)};return{send:i}}t.createQueuedSender=m;var h;(function(o){async function s(e,i,r){if(D.isAbsolute(e))return e;if(i===void 0&&(i=c.cwd()),D.dirname(e)!=="."||(r===void 0&&g.isString(c.env.PATH)&&(r=c.env.PATH.split(D.delimiter)),r===void 0||r.length===0))return D.join(i,e);async function a(E){if(await P.Promises.exists(E)){let w;try{w=await P.Promises.stat(E)}catch(A){A.message.startsWith("EACCES")&&(w=await P.Promises.lstat(E))}return w?!w.isDirectory():!1}return!1}for(let E of r){let w;if(D.isAbsolute(E)?w=D.join(E,e):w=D.join(i,E,e),await a(w))return w;let A=w+".com";if(await a(A)||(A=w+".exe",await a(A)))return A}return D.join(i,e)}o.findExecutable=s})(h=t.win32||(t.win32={}))}),define(Q[71],ee([0,1,34,11,65,49]),function($,t,O,S,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function D(I,l){return I===1?S.isWindows?P():R.getWindowsShell(l):g(I,l)}t.getSystemShell=D;function T(I,l){return I===1?S.isWindows?d(l):R.getWindowsShell(l):g(I,l)}t.getSystemShellSync=T;let c=null;function g(I,l){if(S.isLinux&&I===2||S.isMacintosh&&I===3)return"/bin/bash";if(!c){let u;if(S.isWindows)u="/bin/bash";else{if(u=l.SHELL,!u)try{u=(0,O.userInfo)().shell}catch(b){}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}c=u}return c}let v=null;async function P(){return v||(v=(await(0,y.getFirstAvailablePowerShellInstallation)()).exePath),v}function d(I){if(v)return v;const l=S.isWindows&&parseFloat((0,O.release)())>=10,u=I.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${I.windir}\\${u?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return l?b:R.getWindowsShell(I)}}),define(Q[50],ee([0,1,35,3,17,25,60,9,13,2,18,11,49,39]),function($,t,O,S,y,R,D,T,c,g,v,P,d,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class l extends I.ChannelServer{constructor(f){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch(h){}},onMessage:c.Event.fromNodeEventEmitter(process,"message",m=>y.VSBuffer.wrap(Buffer.from(m,"base64")))},f);process.once("disconnect",()=>this.dispose())}}t.Server=l;class u{constructor(f,m){this.modulePath=f,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new c.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new S.Delayer(h),this.child=null,this._client=null}getChannel(f){const m=this;return{call(h,o,s){return m.requestPromise(f,h,o,s)},listen(h,o){return m.requestEvent(f,h,o)}}}requestPromise(f,m,h,o=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(T.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(f),e=(0,S.createCancelablePromise)(n=>s.call(m,h,n)),i=o.onCancellationRequested(()=>e.cancel()),r=(0,g.toDisposable)(()=>e.cancel());return this.activeRequests.add(r),e.finally(()=>{i.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(f,m,h){if(!this.disposeDelayer)return c.Event.None;this.disposeDelayer.cancel();let o;const s=new c.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(f).listen(m,h)(s.fire,s),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const f=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,v.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),P.isMacintosh&&m.env&&delete m.env.DYLD_LIBRARY_PATH,this.child=(0,O.fork)(this.modulePath,f,m);const h=new c.Emitter;c.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,D.isRemoteConsoleLog)(a)){(0,D.log)(a,`IPC Library: ${this.options.serverName}`);return}h.fire(y.VSBuffer.wrap(Buffer.from(a,"base64")))});const s=this.options.useQueue?(0,d.createQueuedSender)(this.child):this.child,e=a=>this.child&&this.child.connected&&s.send(a.buffer.toString("base64")),i=h.event,r={send:e,onMessage:i};this._client=new I.ChannelClient(r);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,E)=>{process.removeListener("exit",n),this.activeRequests.forEach(w=>(0,g.dispose)(w)),this.activeRequests.clear(),a!==0&&E!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+E),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:E})})}return this._client}getCachedChannel(f){let m=this.channels.get(f);return m||(m=this.client.getChannel(f),this.channels.set(f,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=u}),define(Q[72],ee([5,6]),function($,t){return $.create("vs/base/node/zip",t)}),define(Q[73],ee([5,6]),function($,t){return $.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Q[74],ee([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Q[75],ee([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Q[76],ee([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Q[77],ee([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Q[78],ee([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Q[79],ee([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Q[80],ee([5,6]),function($,t){return $.create("vs/platform/extensions/common/extensionValidator",t)}),define(Q[81],ee([5,6]),function($,t){return $.create("vs/platform/files/common/fileService",t)}),define(Q[82],ee([5,6]),function($,t){return $.create("vs/platform/files/common/io",t)}),define(Q[83],ee([5,6]),function($,t){return $.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Q[84],ee([5,6]),function($,t){return $.create("vs/platform/request/common/request",t)}),define(Q[85],ee([5,6]),function($,t){return $.create("vs/platform/telemetry/common/telemetryService",t)}),define(Q[86],ee([0,1,68,45,8,4,28,19,7]),function($,t,O,S,y,R,D,T,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class g{constructor(l,u,b){this._args=l,this.paths=u,this.productService=b}get appRoot(){return(0,R.dirname)(y.FileAccess.asFileUri("",$).fsPath)}get userHome(){return c.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return c.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return c.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,T.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const l=(0,O.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",l)}return this.args.logsPath}get userDataSyncLogResource(){return c.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,T.joinPath)(c.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return c.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return c.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=D.env.VSCODE_PORTABLE;return l?c.URI.file((0,R.join)(l,"argv.json")):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,T.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return c.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,R.resolve)(l):(0,R.normalize)((0,R.join)(y.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const l=this.args["extensions-download-dir"];return l?(0,R.resolve)(l):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,R.resolve)(l);const u=D.env.VSCODE_EXTENSIONS;if(u)return u;const b=D.env.VSCODE_PORTABLE;return b?(0,R.join)(b,"extensions"):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(u=>/^[^:/?#]+?:\/\//.test(u)?c.URI.parse(u):c.URI.file((0,R.normalize)(u)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?c.URI.parse(l):c.URI.file((0,R.normalize)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return v(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,T.joinPath)(c.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return c.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}fe([S.memoize],g.prototype,"appRoot",null),fe([S.memoize],g.prototype,"userHome",null),fe([S.memoize],g.prototype,"userDataPath",null),fe([S.memoize],g.prototype,"appSettingsHome",null),fe([S.memoize],g.prototype,"tmpDir",null),fe([S.memoize],g.prototype,"userRoamingDataHome",null),fe([S.memoize],g.prototype,"settingsResource",null),fe([S.memoize],g.prototype,"userDataSyncHome",null),fe([S.memoize],g.prototype,"userDataSyncLogResource",null),fe([S.memoize],g.prototype,"sync",null),fe([S.memoize],g.prototype,"machineSettingsResource",null),fe([S.memoize],g.prototype,"globalStorageHome",null),fe([S.memoize],g.prototype,"workspaceStorageHome",null),fe([S.memoize],g.prototype,"keybindingsResource",null),fe([S.memoize],g.prototype,"keyboardLayoutResource",null),fe([S.memoize],g.prototype,"argvResource",null),fe([S.memoize],g.prototype,"snippetsHome",null),fe([S.memoize],g.prototype,"isExtensionDevelopment",null),fe([S.memoize],g.prototype,"untitledWorkspacesHome",null),fe([S.memoize],g.prototype,"installSourcePath",null),fe([S.memoize],g.prototype,"builtinExtensionsPath",null),fe([S.memoize],g.prototype,"extensionsPath",null),fe([S.memoize],g.prototype,"extensionDevelopmentLocationURI",null),fe([S.memoize],g.prototype,"extensionDevelopmentKind",null),fe([S.memoize],g.prototype,"extensionTestsLocationURI",null),fe([S.memoize],g.prototype,"debugExtensionHost",null),fe([S.memoize],g.prototype,"serviceMachineIdResource",null),fe([S.memoize],g.prototype,"telemetryLogResource",null),fe([S.memoize],g.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=g;function v(I,l){return d(I["inspect-extensions"],I["inspect-brk-extensions"],5870,l,I.debugId)}t.parseExtensionHostPort=v;function P(I,l){return d(I["inspect-search"],I["inspect-brk-search"],5876,l)}t.parseSearchPort=P;function d(I,l,u,b,f){const h=Number(l||I)||(b?null:u),o=h?Boolean(!!l):!1;return{port:h,break:o,debugId:f}}}),function(){"use strict";function $(t,O,S,y){function R(T){const c=D(T),g=[c];return t.isAbsolute(c)||g.unshift(y),t.resolve(...g)}function D(T){const c=process.env.VSCODE_PORTABLE;if(c)return t.join(c,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return t.join(g,S);const v=T["user-data-dir"];if(v)return v;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=t.join(P,"AppData","Roaming")}break;case"darwin":g=t.join(O.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||t.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(g,S)}return{getUserDataPath:R}}if(typeof define=="function")define(Q[87],ee([0,88,34,8,19,28]),function(t,O,S,y,R,D){const T=R.dirname(y.FileAccess.asFileUri("",t)),c=t.__$__nodeRequire(R.joinPath(T,"package.json").fsPath);return $(O,S,c.name,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),O=require("path"),S=require("os");module.exports=$(O,S,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[89],ee([0,1,34,86,87]),function($,t,O,S,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class R extends S.AbstractNativeEnvironmentService{constructor(T,c){super(T,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,y.getUserDataPath)(T)},c)}}t.NativeEnvironmentService=R}),define(Q[90],ee([0,1,18]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const S=/^%([\w\d.-]+)%$/i;function y(R,D){const T=c=>{if(typeof c!="string")return;const g=S.exec(c);if(!g)return;const v=D[g[1]]??c;return typeof v=="string"?v:typeof v.message=="string"?v.message:c};return(0,O.cloneAndChange)(R,T)}t.localizeManifest=y}),define(Q[51],ee([0,1,80]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const S=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function R(d){return d=d.trim(),d==="*"||S.test(d)}t.isValidVersionStr=R;function D(d){if(!R(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let I=d.match(S);return I?{hasCaret:I[1]==="^",hasGreaterEquals:I[1]===">=",majorBase:I[2]==="x"?0:parseInt(I[2],10),majorMustEqual:I[2]!=="x",minorBase:I[4]==="x"?0:parseInt(I[4],10),minorMustEqual:I[4]!=="x",patchBase:I[6]==="x"?0:parseInt(I[6],10),patchMustEqual:I[6]!=="x",preRelease:I[8]||null}:null}t.parseVersion=D;function T(d){if(!d)return null;let I=d.majorBase,l=d.majorMustEqual,u=d.minorBase,b=d.minorMustEqual,f=d.patchBase,m=d.patchMustEqual;d.hasCaret&&(I===0||(b=!1),m=!1);let h=0;if(d.preRelease){const o=y.exec(d.preRelease);if(o){const[,s,e,i]=o;h=Date.UTC(Number(s),Number(e)-1,Number(i))}}return{majorBase:I,majorMustEqual:l,minorBase:u,minorMustEqual:b,patchBase:f,patchMustEqual:m,isMinimum:d.hasGreaterEquals,notBefore:h}}t.normalizeVersion=T;function c(d,I,l){let u;typeof d=="string"?u=T(D(d)):u=d;let b;I instanceof Date?b=I.getTime():typeof I=="string"&&(b=new Date(I).getTime());let f;if(typeof l=="string"?f=T(D(l)):f=l,!u||!f)return!1;let m=u.majorBase,h=u.minorBase,o=u.patchBase,s=f.majorBase,e=f.minorBase,i=f.patchBase,r=f.notBefore,n=f.majorMustEqual,a=f.minorMustEqual,E=f.patchMustEqual;return f.isMinimum?m>s?!0:m<s?!1:h>e?!0:h<e||b&&b<r?!1:o>=i:(m===1&&s===0&&(!n||!a||!E)&&(s=1,e=0,i=0,n=!0,a=!1,E=!1),m<s?!1:m>s?!n:h<e?!1:h>e?!a:o<i?!1:o>i?!E:!(b&&b<r))}t.isValidVersion=c;function g(d,I,l,u){return l.isBuiltin||typeof l.main=="undefined"?!0:P(d,I,l.engines.vscode,u)}t.isValidExtensionVersion=g;function v(d,I,l){return d==="*"||P(I,l,d)}t.isEngineValid=v;function P(d,I,l,u=[]){let b=T(D(l));if(!b)return u.push(O.localize(0,null,l)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return u.push(O.localize(1,null,l)),!1}else if(!b.majorMustEqual)return u.push(O.localize(2,null,l)),!1;return c(d,I,b)?!0:(u.push(O.localize(3,null,d,l)),!1)}}),define(Q[91],ee([0,1,2,8,39,50]),function($,t,O,S,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class D extends O.Disposable{constructor(c,g,v,P){super();this.folders=c,this.onDidFilesChange=g,this.onLogMessage=v,this.verboseLogging=P,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const c=this._register(new R.Client(S.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(c.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=D.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=y.ProxyChannel.toService((0,y.getNextTickChannel)(c.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.setFolders(this.folders)}setVerboseLogging(c){this.verboseLogging=c,!this.isDisposed&&this.service&&this.service.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${c}`})}setFolders(c){this.folders=c,this.service&&this.service.setRoots(c)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=D,D.MAX_RESTARTS=5}),define(Q[92],ee([0,1,2,8,39,50]),function($,t,O,S,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class D extends O.Disposable{constructor(c,g,v,P,d={}){super();this.folders=c,this.onDidFilesChange=g,this.onLogMessage=v,this.verboseLogging=P,this.watcherOptions=d,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const c=this._register(new R.Client(S.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(c.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=D.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=y.ProxyChannel.toService((0,y.getNextTickChannel)(c.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.service.setRoots(this.folders)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${c}`})}setVerboseLogging(c){this.verboseLogging=c,this.service&&this.service.setVerboseLogging(c)}setFolders(c){this.folders=c,this.service&&this.service.setRoots(c)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=D,D.MAX_RESTARTS=5}),define(Q[93],ee([0,1,35,62,8,47]),function($,t,O,S,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class D{constructor(c,g,v,P,d){this.watchedFolder=c,this.eventCallback=v,this.logCallback=P,this.verboseLogging=d,this.restartCounter=0,Array.isArray(g)?this.ignored=g.map(I=>(0,S.parse)(I)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${c}, excludes: ${g.join(",")}`),this.startWatcher()}startWatcher(){const c=[this.watchedFolder];this.verboseLogging&&c.push("-verbose"),this.handle=(0,O.spawn)(y.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",$).fsPath,c);const g=new R.LineDecoder;this.handle.stdout.on("data",v=>{const P=[];for(const d of g.write(v)){const I=d.split("|");if(I.length===2){const l=Number(I[0]),u=I[1];if(l>=0&&l<3){if(this.ignored&&this.ignored.some(b=>b(u))){this.verboseLogging&&this.log(u);continue}P.push({type:D.changeTypeMap[l],path:u})}else this.log(I[1])}}P.length>0&&this.eventCallback(P)}),this.handle.on("error",v=>this.onError(v)),this.handle.stderr.on("data",v=>this.onError(v)),this.handle.on("exit",(v,P)=>this.onExit(v,P))}onError(c){this.error("process error: "+c.toString())}onExit(c,g){this.handle&&(this.error(`terminated unexpectedly (code: ${c}, signal: ${g})`),this.restartCounter<=D.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(c){this.logCallback({type:"error",message:`[File Watcher (C#)] ${c}`})}log(c){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${c}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=D,D.MAX_RESTARTS=5,D.changeTypeMap=[0,1,2]}),define(Q[94],ee([0,1,4,21,93]),function($,t,O,S,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class R{constructor(T,c,g,v){this.onDidFilesChange=c,this.onLogMessage=g,this.verboseLogging=v,this.service=void 0,this.folder=T[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(O.posix.sep)&&(this.folder.path=(0,S.rtrim)(this.folder.path,O.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new y.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,T=>this.onFileEvents(T),T=>this.onLogMessage(T),this.verboseLogging)}setVerboseLogging(T){this.verboseLogging=T,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(T){this.isDisposed||T.length>0&&this.onDidFilesChange(T)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=R}),define(Q[52],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class O{constructor(y,R=[],D=!1){this.ctor=y,this.staticArguments=R,this.supportsDelayedInstantiation=D}}t.SyncDescriptor=O}),define(Q[95],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class O{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}t.Node=O;class S{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let D of this._nodes.values())D.outgoing.size===0&&R.push(D);return R}insertEdge(R,D){const T=this.lookupOrInsertNode(R),c=this.lookupOrInsertNode(D);T.outgoing.set(this._hashFn(D),c),c.incoming.set(this._hashFn(R),T)}removeNode(R){const D=this._hashFn(R);this._nodes.delete(D);for(let T of this._nodes.values())T.outgoing.delete(D),T.incoming.delete(D)}lookupOrInsertNode(R){const D=this._hashFn(R);let T=this._nodes.get(D);return T||(T=new O(R),this._nodes.set(D,T)),T}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[D,T]of this._nodes)R.push(`${D}, (incoming)[${[...T.incoming.keys()].join(", ")}], (outgoing)[${[...T.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(let[R,D]of this._nodes){const T=new Set([R]),c=this._findCycle(D,T);if(c)return c}}_findCycle(R,D){for(let[T,c]of R.outgoing){if(D.has(T))return[...D,T].join(" -> ");D.add(T);const g=this._findCycle(c,D);if(g)return g;D.delete(T)}}}t.Graph=S}),define(Q[53],ee([0,1,15]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,O.createDecorator)("downloadService")}),define(Q[20],ee([0,1,15]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,O.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,O.refineServiceDecorator)(t.IEnvironmentService)}),define(Q[23],ee([0,1,8,75,15]),function($,t,O,S,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.TargetPlatform=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";var R;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(R=t.TargetPlatform||(t.TargetPlatform={}));function D(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=D;function T(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=T;function c(f,m){switch(f){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=c;function g(f,m){return m==="web"&&!f.includes("web")}t.isNotWebExtensionInWebTargetPlatform=g;function v(f,m,h){if(g(m,h))return!1;if(f==="undefined"||f==="universal")return!0;if(f==="unknown")return!1;if(f===h)return!0;switch(h){case"win32-x64":return f==="win32-ia32";case"win32-arm64":return f==="win32-ia32";default:return!1}}t.isTargetPlatformCompatible=v;function P(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}t.isIExtensionIdentifier=P;var d;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=5]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(d=t.SortBy||(t.SortBy={}));var I;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(I=t.SortOrder||(t.SortOrder={}));var l;(function(f){f.Install="install",f.Uninstall="uninstall"})(l=t.StatisticType||(t.StatisticType={}));var u;(function(f){f[f.None=0]="None",f[f.Install=1]="Install",f[f.Update=2]="Update"})(u=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,y.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class b extends Error{constructor(m,h){super(m);this.code=h,this.name=h}}t.ExtensionManagementError=b,t.IExtensionManagementService=(0,y.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,y.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,y.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=O.FileAccess.asBrowserUri("./media/defaultIcon.png",$).toString(!0),t.ExtensionsLabel=(0,S.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,S.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,y.createDecorator)("IExtensionManagementCLIService")}),define(Q[40],ee([0,1,21,15]),function($,t,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function y(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}t.getWorkspaceSupportTypeMessage=y;function R(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}t.isIExtensionIdentifier=R,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(D=t.ExtensionType||(t.ExtensionType={}));class T{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,d){if(typeof P=="undefined"||P===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof P=="string"||typeof d=="string"){let I=typeof P=="string"?P:P.value,l=typeof d=="string"?d:d.value;return O.equalsIgnoreCase(I,l)}return P._lower===d._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}t.ExtensionIdentifier=T;function c(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}t.isLanguagePackExtension=c;function g(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=g,t.IBuiltinExtensionsScannerService=(0,S.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[24],ee([0,1,21,40]),function($,t,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function y(l,u){return l.uuid&&u.uuid?l.uuid===u.uuid:l.id===u.id?!0:(0,O.compareIgnoreCase)(l.id,u.id)===0}t.areSameExtensions=y;class R{constructor(u,b){this.version=b,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof R?y(this,u)&&this.version===u.version:!1}}t.ExtensionIdentifierWithVersion=R;function D(l,u){return`${l}.${u}`}t.getExtensionId=D;function T(l){return l.toLocaleLowerCase()}t.adoptToGalleryExtensionId=T;function c(l,u){return T(D(l,u))}t.getGalleryExtensionId=c;function g(l,u){const b=[],f=m=>{for(const h of b)if(h.some(o=>y(u(o),u(m))))return h;return null};for(const m of l){const h=f(m);h?h.push(m):b.push([m])}return b}t.groupByExtension=g;function v(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=v;function P(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}t.getGalleryExtensionTelemetryData=P,t.BetterMergeId=new S.ExtensionIdentifier("pprice.better-merge");function d(l){const u=new Set;for(const b of l)b.malicious&&u.add(b.id.id);return u}t.getMaliciousExtensionsSet=d;function I(l,u){const b=[],f=u.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const m=f.shift();if(m&&b.every(h=>!y(h.identifier,{id:m}))){const h=l.filter(o=>y(o.identifier,{id:m}));h.length===1&&(b.push(h[0]),f.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}t.getExtensionDependencies=I});var ae=this&&this.__param||function($,t){return function(O,S){t(O,S,$)}};define(Q[96],ee([0,1,25,9,63,8,41,7,76,23,24,40]),function($,t,O,S,y,R,D,T,c,g,v,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const d=m=>(0,c.localize)(0,null,m),I=(0,c.localize)(1,null,"ms-dotnettools.csharp");function l(m,h){return h?`${m.publisher}.${m.name}@${m.version}`:`${m.publisher}.${m.name}`}const u=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function b(m){const h=u.exec(m);return h&&h[1]?[(0,v.adoptToGalleryExtensionId)(h[1]),h[2]]:[(0,v.adoptToGalleryExtensionId)(m),void 0]}t.getIdAndVersion=b;let f=class{constructor(h,o){this.extensionManagementService=h,this.extensionGalleryService=o}get location(){}async listExtensions(h,o,s=console){let e=await this.extensionManagementService.getInstalled(1);const i=P.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(o&&o!==""){if(i.indexOf(o.toLowerCase())<0){s.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(n=>n.manifest.categories?n.manifest.categories.map(E=>E.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){s.log("Possible Categories: "),i.forEach(n=>{s.log(n)});return}this.location&&s.log((0,c.localize)(2,null,this.location)),e=e.sort((n,a)=>n.identifier.id.localeCompare(a.identifier.id));let r;for(let n of e)r!==n.identifier.id&&(r=n.identifier.id,s.log(l(n.manifest,h)))}async installExtensions(h,o,s,e,i=console){const r=[],n=[];h.length&&i.log(this.location?(0,c.localize)(3,null,this.location):(0,c.localize)(4,null));const a=await this.extensionManagementService.getInstalled(1),E=(p,C)=>{const N=a.find(j=>(0,v.areSameExtensions)(j.identifier,{id:p}));if(N){if(!C&&!e)return i.log((0,c.localize)(5,null,p,N.manifest.version,p)),!1;if(C&&N.manifest.version===C)return i.log((0,c.localize)(6,null,`${p}@${C}`)),!1}return!0},w=[],A=[];for(const p of h)if(p instanceof T.URI)w.push(p);else{const[C,N]=b(p);E(C,N)&&A.push({id:C,version:N,installOptions:{isBuiltin:!1,isMachineScoped:s}})}for(const p of o){const[C,N]=b(p);E(C,N)&&A.push({id:C,version:N,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(w.length&&await Promise.all(w.map(async p=>{try{const C=await this.installVSIX(p,{isBuiltin:!1,isMachineScoped:s},e,i);C&&n.push(C)}catch(C){i.error(C.message||C.stack||C),r.push(p.toString())}})),A.length){const p=await this.getGalleryExtensions(A);await Promise.all(A.map(async C=>{const N=p.get(C.id.toLowerCase());if(N)try{const j=await this.installFromGallery(C,N,a,e,i);j&&n.push(j)}catch(j){i.error(j.message||j.stack||j),r.push(C.id)}else i.error(`${d(C.version?`${C.id}@${C.version}`:C.id)}
${I}`),r.push(C.id)}))}if(r.length)throw new Error((0,c.localize)(7,null,r.join(", ")))}async installVSIX(h,o,s,e){const i=await this.extensionManagementService.getManifest(h);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,s,e))try{return await this.extensionManagementService.install(h,o),e.log((0,c.localize)(8,null,(0,y.getBaseLabel)(h))),i}catch(n){if((0,S.isPromiseCanceledError)(n))return e.log((0,c.localize)(9,null,(0,y.getBaseLabel)(h))),null;throw n}return null}async getGalleryExtensions(h){const o=new Map,s=await this.extensionGalleryService.getExtensions(h,O.CancellationToken.None);for(const e of s)o.set(e.identifier.id.toLowerCase(),e);return o}async installFromGallery({id:h,version:o,installOptions:s},e,i,r,n){const a=await this.extensionGalleryService.getManifest(e,O.CancellationToken.None);if(a&&!this.validateExtensionKind(a,n))return null;const E=i.find(w=>(0,v.areSameExtensions)(w.identifier,e.identifier));if(E){if(e.version===E.manifest.version)return n.log((0,c.localize)(10,null,o?`${h}@${o}`:h)),null;n.log((0,c.localize)(11,null,h,e.version))}try{return s.isBuiltin?n.log(o?(0,c.localize)(12,null,h,o):(0,c.localize)(13,null,h)):n.log(o?(0,c.localize)(14,null,h,o):(0,c.localize)(15,null,h)),await this.extensionManagementService.installFromGallery(e,{...s,installGivenVersion:!!o}),n.log((0,c.localize)(16,null,h,e.version)),a}catch(w){if((0,S.isPromiseCanceledError)(w))return n.log((0,c.localize)(17,null,h)),null;throw w}}validateExtensionKind(h,o){return!0}async validateVSIX(h,o,s){const e={id:(0,v.getGalleryExtensionId)(h.publisher,h.name)},r=(await this.extensionManagementService.getInstalled(1)).find(n=>(0,v.areSameExtensions)(e,n.identifier)&&(0,D.gt)(n.manifest.version,h.version));return r&&!o?(s.log((0,c.localize)(18,null,r.identifier.id,r.manifest.version,h.version)),!1):this.validateExtensionKind(h,s)}async uninstallExtensions(h,o,s=console){const e=async r=>{if(r instanceof T.URI){const n=await this.extensionManagementService.getManifest(r);return l(n)}return r},i=[];for(const r of h){const n=await e(r),E=(await this.extensionManagementService.getInstalled()).filter(w=>(0,v.areSameExtensions)(w.identifier,{id:n}));if(!E.length)throw new Error(`${this.notInstalled(n)}
${I}`);if(E.some(w=>w.type===0)){s.log((0,c.localize)(19,null,n));return}if(!o&&E.some(w=>w.isBuiltin)){s.log((0,c.localize)(20,null,n));return}s.log((0,c.localize)(21,null,n));for(const w of E)await this.extensionManagementService.uninstall(w),i.push(w);this.location?s.log((0,c.localize)(22,null,n,this.location)):s.log((0,c.localize)(23,null,n))}}async locateExtension(h,o=console){const s=await this.extensionManagementService.getInstalled();h.forEach(e=>{s.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===R.Schemas.file){o.log(i.location.fsPath);return}})})}notInstalled(h){return this.location?(0,c.localize)(24,null,h,this.location):(0,c.localize)(25,null,h)}};f=fe([ae(0,g.IExtensionManagementService),ae(1,g.IExtensionGalleryService)],f),t.ExtensionManagementCLIService=f}),define(Q[97],ee([0,1,2,4,12,40]),function($,t,O,S,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class D extends O.Disposable{constructor(c,g){super();this.environmentService=c,this.extensionsManifestCache=(0,S.join)(this.environmentService.userDataPath,R.MANIFEST_CACHE_FOLDER,R.USER_MANIFEST_CACHE_FILE),this._register(g.onDidInstallExtensions(v=>this.onDidInstallExtensions(v))),this._register(g.onDidUninstallExtension(v=>this.onDidUnInstallExtension(v)))}onDidInstallExtensions(c){c.some(g=>!!g.local)&&this.invalidate()}onDidUnInstallExtension(c){c.error||this.invalidate()}invalidate(){y.Promises.rm(this.extensionsManifestCache,y.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=D}),define(Q[98],ee([0,1,35,88,25,30,9,11,31,71,127]),function($,t,O,S,y,R,D,T,c,g,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function P(l,u,b){return u["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):T.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.isLaunchedFromCli)(b)&&!u["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.isLaunchedFromCli)(b)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=new Promise(async f=>{const m=new y.CancellationTokenSource,h=setTimeout(()=>{l.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),m.dispose(!0),f({})},1e4);try{const o=await I(l,m.token);f(o)}catch(o){(0,D.isPromiseCanceledError)(o)||l.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),f({})}finally{clearTimeout(h),m.dispose()}})),d)}t.resolveShellEnv=P;let d;async function I(l,u){const b=new Promise(async(f,m)=>{const h=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",h);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",o);const s=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};l.trace("getUnixShellEnvironment#env",i);const r=await(0,g.getSystemShell)(T.OS,i);if(l.trace("getUnixShellEnvironment#shell",r),u.isCancellationRequested)return m(D.canceled);const n=S.basename(r);let a,E;/^pwsh(-preview)?$/.test(n)?(a=`& '${process.execPath}' -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,E=["-Login","-Command"]):(a=`'${process.execPath}' -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,E=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(E),a);const w=(0,O.spawn)(r,[...E,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});u.onCancellationRequested(()=>(w.kill(),m(D.canceled))),w.on("error",C=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,R.toErrorMessage)(C)),f({})});const A=[];w.stdout.on("data",C=>A.push(C));const p=[];w.stderr.on("data",C=>p.push(C)),w.on("close",(C,N)=>{const j=Buffer.concat(A).toString("utf8");l.trace("getUnixShellEnvironment#raw",j);const Y=Buffer.concat(p).toString("utf8");if(Y.trim()&&l.trace("getUnixShellEnvironment#stderr",Y),C||N)return m(new Error(`Failed to get environment (code ${C}, signal ${N})`));const te=e.exec(j),se=te?te[1]:"{}";try{const Z=JSON.parse(se);h?Z.ELECTRON_RUN_AS_NODE=h:delete Z.ELECTRON_RUN_AS_NODE,o?Z.ELECTRON_NO_ATTACH_CONSOLE=o:delete Z.ELECTRON_NO_ATTACH_CONSOLE,delete Z.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",Z),f(Z)}catch(Z){l.error("getUnixShellEnvironment#errorCaught",(0,R.toErrorMessage)(Z)),m(Z)}})});try{return await b}catch(f){return l.error("getUnixShellEnvironment#error",(0,R.toErrorMessage)(f)),{}}}}),define(Q[54],ee([0,1,11,7,16]),function($,t,O,S,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function R(c){return c.map(g=>({type:g.type,resource:S.URI.file(g.path)}))}t.toFileChanges=R;function D(c){const g=new T;for(const v of c)g.processEvent(v);return g.normalize()}t.normalizeFileChanges=D;class T{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(g){const v=this.mapPathToChange.get(g.path);if(v){const P=v.type,d=g.type;P===1&&d===2?(this.mapPathToChange.delete(g.path),this.normalized.splice(this.normalized.indexOf(v),1)):P===2&&d===1?v.type=0:P===1&&d===0||(v.type=d)}else this.normalized.push(g),this.mapPathToChange.set(g.path,g)}normalize(){const g=[],v=[];return this.normalized.filter(P=>P.type!==2?(g.push(P),!1):!0).sort((P,d)=>P.path.length-d.path.length).filter(P=>v.some(d=>(0,y.isParent)(P.path,d,!O.isLinux))?!1:(v.push(P.path),!0)).concat(g)}}}),define(Q[99],ee([0,1,3,2,4,64,12,128,54]),function($,t,O,S,y,R,D,T,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class g extends S.Disposable{constructor(P,d,I,l){super();this.path=P,this.onDidFilesChange=d,this.onLogMessage=I,this.verboseLogging=l,this.fileChangesDelayer=this._register(new O.ThrottledDelayer(T.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(P){this.verboseLogging=P}async startWatching(){try{const{stat:P,symbolicLink:d}=await D.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let I=this.path;if(d)try{I=await(0,R.realpath)(I)}catch(l){if(this.onError(l),d.dangling)return}P.isDirectory()?this._register((0,T.watchFolder)(I,(l,u)=>{this.onFileChange({type:l==="changed"?0:l==="added"?1:2,path:(0,y.join)(this.path,(0,y.basename)(u))})},l=>this.onError(l))):this._register((0,T.watchFile)(I,l=>{this.onFileChange({type:l==="changed"?0:2,path:this.path})},l=>this.onError(l)))}catch(P){P.code!=="ENOENT"&&this.onError(P)}}onFileChange(P){this.fileChangesBuffer.push(P),this.verboseLogging&&this.onVerbose(`${P.type===1?"[ADDED]":P.type===2?"[DELETED]":"[CHANGED]"} ${P.path}`),this.fileChangesDelayer.trigger(async()=>{const d=this.fileChangesBuffer;this.fileChangesBuffer=[];const I=(0,c.normalizeFileChanges)(d);if(this.verboseLogging)for(const l of I)this.onVerbose(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);I.length>0&&this.onDidFilesChange(I)})}onError(P){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${P}`})}onVerbose(P){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${P}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=g}),define(Q[55],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class O{constructor(...y){this._entries=new Map;for(let[R,D]of y)this.set(R,D)}set(y,R){const D=this._entries.get(y);return this._entries.set(y,R),D}has(y){return this._entries.has(y)}get(y){return this._entries.get(y)}}t.ServiceCollection=O}),define(Q[100],ee([0,1,3,9,52,95,15,55]),function($,t,O,S,y,R,D,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const c=!1;class g extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class v{constructor(l=new T.ServiceCollection,u=!1,b){this._activeInstantiations=new Set,this._services=l,this._strict=u,this._parent=b,this._services.set(D.IInstantiationService,this)}createChild(l){return new v(l,this._strict,this)}invokeFunction(l,...u){let b=d.traceInvocation(l),f=!1;try{return l({get:(h,o)=>{if(f)throw(0,S.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(h,b);if(!s&&o!==D.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return s}},...u)}finally{f=!0,b.stop()}}createInstance(l,...u){let b,f;return l instanceof y.SyncDescriptor?(b=d.traceCreation(l.ctor),f=this._createInstance(l.ctor,l.staticArguments.concat(u),b)):(b=d.traceCreation(l),f=this._createInstance(l,u,b)),b.stop(),f}_createInstance(l,u=[],b){let f=D._util.getServiceDependencies(l).sort((o,s)=>o.index-s.index),m=[];for(const o of f){let s=this._getOrCreateServiceInstance(o.id,b);if(!s&&this._strict&&!o.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${o.id}.`);m.push(s)}let h=f.length>0?f[0].index:u.length;if(u.length!==h){console.warn(`[createInstance] First service dependency of ${l.name} at position ${h+1} conflicts with ${u.length} static arguments`);let o=h-u.length;o>0?u=u.concat(new Array(o)):u=u.slice(0,h)}return new l(...[...u,...m])}_setServiceInstance(l,u){if(this._services.get(l)instanceof y.SyncDescriptor)this._services.set(l,u);else if(this._parent)this._parent._setServiceInstance(l,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let u=this._services.get(l);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):u}_getOrCreateServiceInstance(l,u){let b=this._getServiceInstanceOrDescriptor(l);return b instanceof y.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,b,u.branch(l,!0)):(u.branch(l,!1),b)}_safeCreateAndCacheServiceInstance(l,u,b){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,u,b)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,u,b){const f=new R.Graph(o=>o.id.toString());let m=0;const h=[{id:l,desc:u,_trace:b}];for(;h.length;){const o=h.pop();if(f.lookupOrInsertNode(o),m++>1e3)throw new g(f);for(let s of D._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(s.id);if(!e&&!s.optional&&console.warn(`[createInstance] ${l} depends on ${s.id} which is NOT registered.`),e instanceof y.SyncDescriptor){const i={id:s.id,desc:e,_trace:o._trace.branch(s.id,!0)};f.insertEdge(o,i),h.push(i)}}}for(;;){const o=f.roots();if(o.length===0){if(!f.isEmpty())throw new g(f);break}for(const{data:s}of o){if(this._getServiceInstanceOrDescriptor(s.id)instanceof y.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,i)}f.removeNode(s)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,u,b=[],f,m){if(this._services.get(l)instanceof y.SyncDescriptor)return this._createServiceInstance(u,b,f,m);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,u,b,f,m);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(l,u=[],b,f){if(b){const m=new O.IdleValue(()=>this._createInstance(l,u,f));return new Proxy(Object.create(null),{get(h,o){if(o in h)return h[o];let s=m.value,e=s[o];return typeof e!="function"||(e=e.bind(s),h[o]=e),e},set(h,o,s){return m.value[o]=s,!0}})}else return this._createInstance(l,u,f)}}t.InstantiationService=v;var P;(function(I){I[I.Creation=0]="Creation",I[I.Invocation=1]="Invocation",I[I.Branch=2]="Branch"})(P||(P={}));class d{constructor(l,u){this.type=l,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return c?new d(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(l){return c?new d(0,l.name):d._None}branch(l,u){let b=new d(2,l.toString());return this._dep.push([l,u,b]),b}stop(){let l=Date.now()-this._start;d._totals+=l;let u=!1;function b(m,h){let o=[],s=new Array(m+1).join("	");for(const[e,i,r]of h._dep)if(i&&r){u=!0,o.push(`${s}CREATES -> ${e}`);let n=b(m+1,r);n&&o.push(n)}else o.push(`${s}uses -> ${e}`);return o.join(`
`)}let f=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(l>2||u)&&console.log(f.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(Q[56],ee([0,1,15]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,O.createDecorator)("localizationsService");function S(y){if(typeof y.languageId!="string"||!Array.isArray(y.translations)||y.translations.length===0)return!1;for(const R of y.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(y.languageName&&typeof y.languageName!="string"||y.localizedLanguageName&&typeof y.localizedLanguageName!="string")}t.isValidLocalization=S}),define(Q[14],ee([0,1,30,13,2,11,15]),function($,t,O,S,y,R,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,D.createDecorator)("logService"),t.ILoggerService=(0,D.createDecorator)("loggerService");function T(){return new Date().toISOString()}var c;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(c=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=c.Info;class g extends y.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=g;class v extends g{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(c.Trace)&&this.log(c.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(c.Debug)&&this.log(c.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(c.Info)&&this.log(c.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(c.Warning)&&this.log(c.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(c.Error))if(e instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=e.stack,this.log(c.Error,this.format(r))}else this.log(c.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(c.Critical)&&this.log(c.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let r=0;r<e.length;r++){let n=e[r];if(typeof n=="object")try{n=JSON.stringify(n)}catch(a){}i+=(r>0?" ":"")+n}return i}}t.AbstractMessageLogger=v;class P extends g{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!R.isWindows}trace(e,...i){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${T()}][0m`,e,...i):console.log(`[main ${T()}]`,e,...i))}debug(e,...i){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${T()}][0m`,e,...i):console.log(`[main ${T()}]`,e,...i))}info(e,...i){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${T()}][0m`,e,...i):console.log(`[main ${T()}]`,e,...i))}warn(e,...i){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${T()}][0m`,e,...i):console.warn(`[main ${T()}]`,e,...i))}error(e,...i){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${T()}][0m`,e,...i):console.error(`[main ${T()}]`,e,...i))}critical(e,...i){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${T()}][0m`,e,...i):console.error(`[main ${T()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=P;class d extends g{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=d;class I extends g{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=c.Trace&&this.adapter.log(c.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=c.Debug&&this.adapter.log(c.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=c.Info&&this.adapter.log(c.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=c.Warning&&this.adapter.log(c.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=c.Error&&this.adapter.log(c.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=c.Critical&&this.adapter.log(c.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,O.toErrorMessage)(e,this.getLevel()<=c.Trace)}dispose(){}flush(){}}t.AdapterLogger=I;class l extends g{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const r of this.logServices)r.trace(e,...i)}debug(e,...i){for(const r of this.logServices)r.debug(e,...i)}info(e,...i){for(const r of this.logServices)r.info(e,...i)}warn(e,...i){for(const r of this.logServices)r.warn(e,...i)}error(e,...i){for(const r of this.logServices)r.error(e,...i)}critical(e,...i){for(const r of this.logServices)r.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=l;class u extends y.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=u;class b extends y.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(r))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,i){let r=this.loggers.get(e.toString());return r||(r=this.doCreateLogger(e,i?.always?c.Trace:this.logLevel,i),this.loggers.set(e.toString(),r),i?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=b;class f{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(e){}getLevel(){return c.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=f;function m(s){if(s.verbose)return c.Trace;if(typeof s.logLevel=="string"){const e=h(s.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=m;function h(s){switch(s){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}t.parseLogLevel=h;function o(s){switch(s){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}t.LogLevelToString=o}),define(Q[101],ee([0,1,3,9,2,11,19,41,7,31,12,20,23,24,16,14]),function($,t,O,S,y,R,D,T,c,g,v,P,d,I,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let f=class extends y.Disposable{constructor(h,o,s,e){super();this.fileService=o,this.extensionGalleryService=s,this.logService=e,this.extensionsDownloadDir=c.URI.file(h.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(h,o){await this.cleanUpPromise;const s=this.getName(h),e=(0,D.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(e)){const i=(0,D.joinPath)(this.extensionsDownloadDir,`.${(0,g.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(h,i,o);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(i)}catch(n){}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",h.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,S.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,i.path),r}}return e}async delete(h){}async rename(h,o,s){try{await v.Promises.rename(h.fsPath,o.fsPath)}catch(e){if(R.isWindows&&e&&e.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${h} to ${o} with 'EPERM' error. Trying again...`),this.rename(h,o,s);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const h=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(h.children){const o=[],s=[];for(const r of h.children){const n=this.parse(r.name);n&&s.push([n,r])}const e=(0,I.groupByExtension)(s,([r])=>r),i=[];for(const r of e)r.sort((n,a)=>T.rcompare(n[0].version,a[0].version)),o.push(...r.slice(1).map(n=>n[1].resource)),i.push(r[0][1]);i.sort((r,n)=>r.mtime-n.mtime),o.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(r=>r.resource)),await O.Promises.settled(o.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(h){this.logService.error(h)}}getName(h){return this.cache?`${new I.ExtensionIdentifierWithVersion(h.identifier,h.version).key().toLowerCase()}${h.properties.targetPlatform!=="undefined"?`-${h.properties.targetPlatform}`:""}`:(0,g.generateUuid)()}parse(h){const o=b.exec(h);return o&&o[1]&&o[2]?new I.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};f=fe([ae(0,P.INativeEnvironmentService),ae(1,l.IFileService),ae(2,d.IExtensionGalleryService),ae(3,u.ILogService)],f),t.ExtensionsDownloader=f}),define(Q[102],ee([0,1,35,3,30,13,2,8,4,12,20,14]),function($,t,O,S,y,R,D,T,c,g,v,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let d=class extends D.Disposable{constructor(l,u){super();this.environmentService=l,this.logService=u,this.processesLimiter=new S.Limiter(5)}async postUninstall(l){const u=this.parseScript(l,"uninstall");return u&&(this.logService.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(u.script,"uninstall",u.args,!0,l).then(()=>this.logService.info(l.identifier.id,l.manifest.version,"Finished running post uninstall script"),b=>this.logService.error(l.identifier.id,l.manifest.version,`Failed to run post uninstall script: ${b}`)))),g.Promises.rm(this.getExtensionStoragePath(l)).then(void 0,b=>this.logService.error("Error while removing extension storage path",b))}parseScript(l,u){const b=`vscode:${u}`;if(l.location.scheme===T.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[b]=="string"){const f=l.manifest.scripts[b].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.logService.warn(l.identifier.id,l.manifest.version,`${b} should be a node script`),null):{script:(0,c.join)(l.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}runLifecycleHook(l,u,b,f,m){return new Promise((h,o)=>{const s=this.start(l,u,b,m);let e;const i=r=>{e&&(clearTimeout(e),e=null),r?o(r):h(void 0)};s.on("error",r=>{i((0,y.toErrorMessage)(r)||"Unknown")}),s.on("exit",(r,n)=>{i(r?`post-${u} process exited with code ${r}`:void 0)}),f&&(e=setTimeout(()=>{e=null,s.kill(),o("timed out")},5e3))})}start(l,u,b,f){const m={silent:!0,execArgv:void 0},h=(0,O.fork)(l,[`--type=extension-post-${u}`,...b],m);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const o=R.Event.fromNodeEventEmitter(h.stdout,"data"),s=R.Event.fromNodeEventEmitter(h.stderr,"data");o(r=>this.logService.info(f.identifier.id,f.manifest.version,`post-${u}`,r)),s(r=>this.logService.error(f.identifier.id,f.manifest.version,`post-${u}`,r));const e=R.Event.any(R.Event.map(o,r=>({data:`%c${r}`,format:[""]})),R.Event.map(s,r=>({data:`%c${r}`,format:["color: red"]})));return R.Event.debounce(e,(r,n)=>r?{data:r.data+n.data,format:[...r.format,...n.format]}:{data:n.data,format:n.format},100)(r=>{console.group(f.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),h}getExtensionStoragePath(l){return(0,c.join)(this.environmentService.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};d=fe([ae(0,v.IEnvironmentService),ae(1,P.ILogService)],d),t.ExtensionsLifecycle=d}),define(Q[103],ee([0,1,13,2,19,7,20,24,16,14]),function($,t,O,S,y,R,D,T,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let v=class extends S.Disposable{constructor(d,I,l,u){super();this.extensionsManagementService=d,this.logService=u,this._onDidChangeExtensionsByAnotherSource=this._register(new O.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(m=>{this.installedExtensions=m.map(h=>h.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(m=>this.onInstallExtension(m))),this._register(d.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(d.onDidUninstallExtension(m=>this.onDidUninstallExtension(m)));const b=R.URI.file(l.extensionsPath),f=new y.ExtUri(m=>!I.hasCapability(m,1024));this._register(I.watch(b)),this._register(O.Event.filter(I.onDidChangeFilesRaw,m=>m.changes.some(h=>this.doesChangeAffects(h,b,f)))(()=>this.onDidChange()))}doesChangeAffects(d,I,l){return l.isEqual(l.dirname(d.resource),I)?l.isEqual(d.resource,l.joinPath(I,".obsolete"))?!0:!(d.type!==1&&d.type!==2||l.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtensions(d){for(const I of d)this.removeInstallingExtension(I.identifier),I.local&&this.addInstalledExtension(I.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(I=>!(0,T.areSameExtensions)(I,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(I=>!(0,T.areSameExtensions)(I,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),I=d.filter(u=>[...this.installingExtensions,...this.installedExtensions].some(b=>(0,T.areSameExtensions)(b,u.identifier))?!1:u.installedTimestamp&&u.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",u.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",u.identifier.id),!1)),l=this.installedExtensions.filter(u=>this.installingExtensions.some(b=>(0,T.areSameExtensions)(b,u))?!1:d.every(b=>!(0,T.areSameExtensions)(b.identifier,u))?(this.logService.info("Detected extension removed from another source",u.id),!0):!1);this.installedExtensions=d.map(u=>u.identifier),(I.length||l.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:I,removed:l})}}};v=fe([ae(1,c.IFileService),ae(2,D.INativeEnvironmentService),ae(3,g.ILogService)],v),t.ExtensionsWatcher=v}),define(Q[104],ee([0,1,129,22,3,2,8,4,12,20,23,24,56,14]),function($,t,O,S,y,R,D,T,c,g,v,P,d,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let l=class extends R.Disposable{constructor(f,m,h){super();this.extensionManagementService=f,this.logService=h,this.cache=this._register(new u(m,h)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const f=await this.cache.getLanguagePacks(),m=["en",...Object.keys(f)];return(0,S.distinct)(m)}async postInstallExtension(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",f.identifier.id),await this.update())}async postUninstallExtension(f){const m=await this.cache.getLanguagePacks();Object.keys(m).some(h=>m[h]&&m[h].extensions.some(o=>(0,P.areSameExtensions)(o.extensionIdentifier,f.identifier)))&&(this.logService.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,m]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),h=await this.cache.update(m);return!(0,S.equals)(Object.keys(f),Object.keys(h))}};l=fe([ae(0,v.IExtensionManagementService),ae(1,g.INativeEnvironmentService),ae(2,I.ILogService)],l),t.LocalizationsService=l;let u=class extends R.Disposable{constructor(f,m){super();this.logService=m,this.languagePacks={},this.languagePacksFilePath=(0,T.join)(f.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new y.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(f){return this.withLanguagePacks(m=>{Object.keys(m).forEach(h=>delete m[h]),this.createLanguagePacksFromExtensions(m,...f)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(f,...m){for(const h of m)h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(f,h);Object.keys(f).forEach(h=>this.updateHash(f[h]))}createLanguagePacksFromExtension(f,m){const h=m.identifier,o=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const s of o)if(m.location.scheme===D.Schemas.file&&(0,d.isValidLocalization)(s)){let e=f[s.languageId];e||(e={hash:"",extensions:[],translations:{}},f[s.languageId]=e);let i=e.extensions.filter(r=>(0,P.areSameExtensions)(r.extensionIdentifier,h))[0];i?i.version=m.manifest.version:e.extensions.push({extensionIdentifier:h,version:m.manifest.version});for(const r of s.translations)e.translations[r.id]=(0,T.join)(m.location.fsPath,r.path)}}updateHash(f){if(f){const m=(0,O.createHash)("md5");for(const h of f.extensions)m.update(h.extensionIdentifier.uuid||h.extensionIdentifier.id).update(h.version);f.hash=m.digest("hex")}}withLanguagePacks(f=()=>null){return this.languagePacksFileLimiter.queue(()=>{let m=null;return c.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,h=>h.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(h)).then(h=>{try{return JSON.parse(h)}catch(o){return{}}}).then(h=>(m=f(h),h)).then(h=>{for(const s of Object.keys(h))h[s]||delete h[s];this.languagePacks=h,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),c.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>m,h=>this.logService.error(h))})}};u=fe([ae(0,g.INativeEnvironmentService),ae(1,I.ILogService)],u)}),define(Q[105],ee([0,1,16,14]),function($,t,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function y(c,g,v,P){try{const d=await new Promise((I,l)=>{$(["spdlog"],I,l)});return d.setFlushOn(S.LogLevel.Trace),d.createAsyncRotatingLogger(c,g,v,P)}catch(d){console.error(d)}return null}function R(c,g,v,P){const d=$.__$__nodeRequire("spdlog");return d.setFlushOn(S.LogLevel.Trace),d.createRotatingLogger(c,g,v,P)}t.createRotatingLogger=R;function D(c,g,v){switch(g){case S.LogLevel.Trace:c.trace(v);break;case S.LogLevel.Debug:c.debug(v);break;case S.LogLevel.Info:c.info(v);break;case S.LogLevel.Warning:c.warn(v);break;case S.LogLevel.Error:c.error(v);break;case S.LogLevel.Critical:c.critical(v);break;default:throw new Error("Invalid log level")}}class T extends S.AbstractMessageLogger{constructor(g,v,P,d){super();this.name=g,this.filepath=v,this.rotating=P,this.buffer=[],this.setLevel(d),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(I=>{this._logger&&this._logger.setLevel(I)}))}_createSpdLogLogger(){const g=this.rotating?6:1,v=30/g*O.ByteSize.MB;return y(this.name,this.filepath,v,g).then(P=>{if(P){this._logger=P,this._logger.setLevel(this.getLevel());for(const{level:d,message:I}of this.buffer)D(this._logger,d,I);this.buffer=[]}})}log(g,v){this._logger?D(this._logger,g,v):this.getLevel()<=g&&this.buffer.push({level:g,message:v})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=T}),define(Q[57],ee([0,1,17,9,82,16,32]),function($,t,O,S,y,R,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function T(P,d,I,l,u,b){let f;try{await c(P,d,I,l,u,b)}catch(m){f=m}finally{f&&u.errorTransformer&&(f=u.errorTransformer(f)),typeof f!="undefined"&&I.error(f),I.end()}}t.readFileIntoStream=T;async function c(P,d,I,l,u,b){g(b);const f=await P.open(d,{create:!1});try{g(b);let m=0,h=0,o=u&&typeof u.length=="number"?u.length:void 0,s=O.VSBuffer.alloc(Math.min(u.bufferSize,typeof o=="number"?o:u.bufferSize)),e=u&&typeof u.position=="number"?u.position:0,i=0;do h=await P.read(f,e,s.buffer,i,s.byteLength-i),e+=h,i+=h,m+=h,typeof o=="number"&&(o-=h),i===s.byteLength&&(await I.write(l(s)),s=O.VSBuffer.alloc(Math.min(u.bufferSize,typeof o=="number"?o:u.bufferSize)),i=0);while(h>0&&(typeof o!="number"||o>0)&&g(b)&&v(m,u));if(i>0){let r=i;typeof o=="number"&&(r=Math.min(i,o)),I.write(l(s.slice(0,r)))}}catch(m){throw(0,R.ensureFileSystemProviderError)(m)}finally{await P.close(f)}}function g(P){if(P.isCancellationRequested)throw(0,S.canceled)();return!0}function v(P,d){if(d?.limits){if(typeof d.limits.memory=="number"&&P>d.limits.memory)throw(0,R.createFileSystemProviderError)((0,y.localize)(0,null,D.default.nameShort),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof d.limits.size=="number"&&P>d.limits.size)throw(0,R.createFileSystemProviderError)((0,y.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[106],ee([0,1,22,3,17,25,13,130,2,46,8,131,19,37,81,16,57,14]),function($,t,O,S,y,R,D,T,c,g,v,P,d,I,l,u,b,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let m=class Ne extends c.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new D.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new S.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new u.FileChangesEvent(s,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new S.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new u.FileChangesEvent(s,!0)))),this.watchedResources=g.TernarySearchTree.forUris(s=>{const e=this.getProvider(s.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new S.ResourceQueue)}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,P.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s});const e=new c.DisposableStore;return e.add(s.onDidChangeFile(i=>this.onDidChangeFile(i,this.isPathCaseSensitive(s)))),e.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),typeof s.onDidErrorOccur=="function"&&e.add(s.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,c.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),(0,c.dispose)(e)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){s.push(e)}}),!this.provider.has(o)&&await S.Promises.settled(s)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,s){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&s)}listCapabilities(){return T.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!(0,d.isAbsolutePath)(o))throw new u.FileOperationError((0,l.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const e=new Error;throw e.name="ENOPRO",e.message=(0,l.localize)(1,null,o.toString()),e}return s}async withReadProvider(o){const s=await this.withProvider(o);if((0,u.hasOpenReadWriteCloseCapability)(s)||(0,u.hasReadWriteCapability)(s)||(0,u.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if((0,u.hasOpenReadWriteCloseCapability)(s)||(0,u.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(e){throw(0,u.toFileSystemProviderErrorCode)(e)===u.FileSystemProviderErrorCode.FileNotFound?new u.FileOperationError((0,l.localize)(2,null,this.resourceForError(o)),1):(0,u.ensureFileSystemProviderError)(e)}}async doResolveFile(o,s){const e=await this.withProvider(o),i=this.isPathCaseSensitive(e),r=s?.resolveTo,n=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,E=await e.stat(o);let w;return this.toFileStat(e,o,E,void 0,!!a,(A,p)=>{if(!w&&(w=g.TernarySearchTree.forUris(()=>!i),w.set(o,!0),r))for(const C of r)w.set(C,!0);return w.get(A.resource)||w.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&n?p===1:!1})}async toFileStat(o,s,e,i,r,n){const{providerExtUri:a}=this.getExtUri(o),E={resource:s,name:a.basename(s),isFile:(e.type&u.FileType.File)!=0,isDirectory:(e.type&u.FileType.Directory)!=0,isSymbolicLink:(e.type&u.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&u.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,u.etag)({mtime:e.mtime,size:e.size})};if(E.isDirectory&&n(E,i)){try{const w=await o.readdir(s),A=await S.Promises.settled(w.map(async([p,C])=>{try{const N=a.joinPath(s,p),j=r?await o.stat(N):{type:C};return await this.toFileStat(o,N,j,w.length,r,n)}catch(N){return this.logService.trace(N),null}}));E.children=(0,O.coalesce)(A)}catch(w){this.logService.trace(w),E.children=[]}return E}return E}async resolveAll(o){return S.Promises.settled(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch(e){return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(e){return e}return!0}async doValidateCreateFile(o,s){if(!s?.overwrite&&await this.exists(o))throw new u.FileOperationError((0,l.localize)(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=y.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const i=await this.writeFile(o,s);return this._onDidRunOperation.fire(new u.FileOperationEvent(o,0,i)),i}async writeFile(o,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:r}=this.getExtUri(i);try{await this.validateWriteFile(i,o,e)||await this.mkdirp(i,r.dirname(o));let a;if((0,u.hasReadWriteCapability)(i)&&!(s instanceof y.VSBuffer))if((0,I.isReadableStream)(s)){const E=await(0,I.peekStream)(s,3);E.ended?a=y.VSBuffer.concat(E.buffer):a=E}else a=(0,I.peekReadable)(s,E=>y.VSBuffer.concat(E),3);else a=s;!(0,u.hasOpenReadWriteCloseCapability)(i)||(0,u.hasReadWriteCapability)(i)&&a instanceof y.VSBuffer?await this.doWriteUnbuffered(i,o,e,a):await this.doWriteBuffered(i,o,e,a instanceof y.VSBuffer?(0,y.bufferToReadable)(a):a)}catch(n){throw new u.FileOperationError((0,l.localize)(4,null,this.resourceForError(o),(0,u.ensureFileSystemProviderError)(n).toString()),(0,u.toFileOperationResult)(n),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,e){if(!!e?.unlock&&!(o.capabilities&8192))throw new Error((0,l.localize)(5,null,this.resourceForError(s)));let r;try{r=await o.stat(s)}catch(n){return}if((r.type&u.FileType.Directory)!=0)throw new u.FileOperationError((0,l.localize)(6,null,this.resourceForError(s)),0,e);if(this.throwIfFileIsReadonly(s,r),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==u.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&e.mtime<r.mtime&&e.etag!==(0,u.etag)({mtime:e.mtime,size:r.size}))throw new u.FileOperationError((0,l.localize)(7,null),3,e);return r}async readFile(o,s){const e=await this.withReadProvider(o);return s?.atomic?this.doReadFileAtomic(e,o,s):this.doReadFile(e,o,s)}async doReadFileAtomic(o,s,e){return new Promise((i,r)=>{this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{try{const n=await this.doReadFile(o,s,e);i(n)}catch(n){r(n)}})})}async doReadFile(o,s,e){const i=await this.doReadFileStream(o,s,{...e,preferUnbuffered:!0});return{...i,value:await(0,y.streamToBuffer)(i.value)}}async readFileStream(o,s){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,s)}async doReadFileStream(o,s,e){const i=new R.CancellationTokenSource,r=this.validateReadFile(s,e).then(a=>a,a=>{throw i.cancel(),a});let n;try{return typeof e?.etag=="string"&&e.etag!==u.ETAG_DISABLED&&await r,!((0,u.hasOpenReadWriteCloseCapability)(o)||(0,u.hasFileReadStreamCapability)(o))||(0,u.hasReadWriteCapability)(o)&&e?.preferUnbuffered?n=this.readFileUnbuffered(o,s,e):(0,u.hasFileReadStreamCapability)(o)?n=this.readFileStreamed(o,s,i.token,e):n=this.readFileBuffered(o,s,i.token,e),{...await r,value:n}}catch(a){n&&await(0,I.consumeStream)(n);const E=(0,l.localize)(8,null,this.resourceForError(s),(0,u.ensureFileSystemProviderError)(a).toString());throw a instanceof u.NotModifiedSinceFileOperationError?new u.NotModifiedSinceFileOperationError(E,a.stat,e):new u.FileOperationError(E,(0,u.toFileOperationResult)(a),e)}}readFileStreamed(o,s,e,i=Object.create(null)){const r=o.readFileStream(s,i,e);return(0,I.transform)(r,{data:n=>n instanceof y.VSBuffer?n:y.VSBuffer.wrap(n),error:n=>new u.FileOperationError((0,l.localize)(9,null,this.resourceForError(s),(0,u.ensureFileSystemProviderError)(n).toString()),(0,u.toFileOperationResult)(n),i)},n=>y.VSBuffer.concat(n))}readFileBuffered(o,s,e,i=Object.create(null)){const r=(0,y.newWriteableBufferStream)();return(0,b.readFileIntoStream)(o,s,r,n=>n,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:n=>new u.FileOperationError((0,l.localize)(10,null,this.resourceForError(s),(0,u.ensureFileSystemProviderError)(n).toString()),(0,u.toFileOperationResult)(n),i)},e),r}readFileUnbuffered(o,s,e){const i=(0,I.newWriteableStream)(r=>y.VSBuffer.concat(r));return(async()=>{try{let r=await o.readFile(s);typeof e?.position=="number"&&(r=r.slice(e.position)),typeof e?.length=="number"&&(r=r.slice(0,e.length)),this.validateReadFileLimits(s,r.byteLength,e),i.end(y.VSBuffer.wrap(r))}catch(r){i.error(r),i.end()}})(),i}async validateReadFile(o,s){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new u.FileOperationError((0,l.localize)(11,null,this.resourceForError(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==u.ETAG_DISABLED&&s.etag===e.etag)throw new u.NotModifiedSinceFileOperationError((0,l.localize)(12,null),e,s);return this.validateReadFileLimits(o,e.size,s),e}validateReadFileLimits(o,s,e){if(e?.limits){let i;if(typeof e.limits.memory=="number"&&s>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&s>e.limits.size&&(i=7),typeof i=="number")throw new u.FileOperationError((0,l.localize)(13,null,this.resourceForError(o)),i)}}async canMove(o,s,e){return this.doCanMoveCopy(o,s,"move",e)}async canCopy(o,s,e){return this.doCanMoveCopy(o,s,"copy",e)}async doCanMoveCopy(o,s,e,i){if(o.toString()!==s.toString())try{const r=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(r,o,n,s,e,i)}catch(r){return r}return!0}async move(o,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=await this.doMoveCopy(i,o,r,s,"move",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(o,n==="move"?2:3,a)),a}async copy(o,s,e){const i=await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=await this.doMoveCopy(i,o,r,s,"copy",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(o,n==="copy"?3:2,a)),a}async doMoveCopy(o,s,e,i,r,n){if(s.toString()===i.toString())return r;const{exists:a,isSameResourceWithDifferentPathCase:E}=await this.doValidateMoveCopy(o,s,e,i,r,n);if(a&&!E&&n&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),r==="copy"){if(o===e&&(0,u.hasFileFolderCopyCapability)(o))await o.copy(s,i,{overwrite:n});else{const w=await this.resolve(s);w.isDirectory?await this.doCopyFolder(o,w,e,i):await this.doCopyFile(o,s,e,i)}return r}else return o===e?(await o.rename(s,i,{overwrite:n}),r):(await this.doMoveCopy(o,s,e,i,"copy",n),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,e,i){if((0,u.hasOpenReadWriteCloseCapability)(o)&&(0,u.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(o,s,e,i);if((0,u.hasOpenReadWriteCloseCapability)(o)&&(0,u.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(o,s,e,i);if((0,u.hasReadWriteCapability)(o)&&(0,u.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(o,s,e,i);if((0,u.hasReadWriteCapability)(o)&&(0,u.hasReadWriteCapability)(e))return this.doPipeUnbuffered(o,s,e,i)}async doCopyFolder(o,s,e,i){await e.mkdir(i),Array.isArray(s.children)&&await S.Promises.settled(s.children.map(async r=>{const n=this.getExtUri(e).providerExtUri.joinPath(i,r.name);return r.isDirectory?this.doCopyFolder(o,await this.resolve(r.resource),e,n):this.doCopyFile(o,r.resource,e,n)}))}async doValidateMoveCopy(o,s,e,i,r,n){let a=!1;if(o===e){const{providerExtUri:w,isPathCaseSensitive:A}=this.getExtUri(o);if(A||(a=w.isEqual(s,i)),a&&r==="copy")throw new Error((0,l.localize)(14,null,this.resourceForError(s),this.resourceForError(i)));if(!a&&w.isEqualOrParent(i,s))throw new Error((0,l.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}const E=await this.exists(i);if(E&&!a){if(!n)throw new u.FileOperationError((0,l.localize)(16,null,this.resourceForError(s),this.resourceForError(i)),4);if(o===e){const{providerExtUri:w}=this.getExtUri(o);if(w.isEqualOrParent(s,i))throw new Error((0,l.localize)(17,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:E,isSameResourceWithDifferentPathCase:a}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new u.FileOperationEvent(o,0,e)),e}async mkdirp(o,s){const e=[],{providerExtUri:i}=this.getExtUri(o);for(;!i.isEqual(s,i.dirname(s));)try{if(((await o.stat(s)).type&u.FileType.Directory)==0)throw new Error((0,l.localize)(18,null,this.resourceForError(s)));break}catch(r){if((0,u.toFileSystemProviderErrorCode)(r)!==u.FileSystemProviderErrorCode.FileNotFound)throw r;e.push(i.basename(s)),s=i.dirname(s)}for(let r=e.length-1;r>=0;r--){s=i.joinPath(s,e[r]);try{await o.mkdir(s)}catch(n){if((0,u.toFileSystemProviderErrorCode)(n)!==u.FileSystemProviderErrorCode.FileExists)throw n}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(e){return e}return!0}async doValidateDelete(o,s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!s?.useTrash&&!(e.capabilities&4096))throw new Error((0,l.localize)(19,null,this.resourceForError(o)));let r;try{r=await e.stat(o)}catch(a){}if(r)this.throwIfFileIsReadonly(o,r);else throw new u.FileOperationError((0,l.localize)(20,null,this.resourceForError(o)),1);if(!!!s?.recursive){const a=await this.resolve(o);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,l.localize)(21,null,this.resourceForError(o)))}return e}async del(o,s){const e=await this.doValidateDelete(o,s),i=!!s?.useTrash,r=!!s?.recursive;await e.delete(o,{recursive:r,useTrash:i}),this._onDidRunOperation.fire(new u.FileOperationEvent(o,1))}onDidChangeFile(o,s){this._onDidChangeFilesRaw.fire({changes:o});let e,i;{for(const r of o)this.watchedResources.has(r.resource)?(e||(e=[]),e.push(r)):(i||(i=[]),i.push(r));e&&this._onDidFilesChange.fire(new u.FileChangesEvent(e,!s))}if(i){const r=s?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(i)&&Ne.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,s={recursive:!1,excludes:[]}){const e=new c.DisposableStore;{let i=!1,r=()=>{i=!0};e.add((0,c.toDisposable)(()=>r())),this.doWatch(o,s).then(n=>{i?(0,c.dispose)(n):r=()=>(0,c.dispose)(n)},n=>this.logService.error(n))}return s.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),e.add((0,c.toDisposable)(()=>{const i=this.watchedResources.get(o);typeof i=="number"&&(i<=1?this.watchedResources.delete(o):this.watchedResources.set(o,i-1))}))),e}async doWatch(o,s){const e=await this.withProvider(o),i=this.toWatchKey(e,o,s),r=this.activeWatchers.get(i)||{count:0,disposable:e.watch(o,s)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,r),r.count+=1,(0,c.toDisposable)(()=>{r.count--,r.count===0&&((0,c.dispose)(r.disposable),this.activeWatchers.delete(i))})}toWatchKey(o,s,e){const{providerExtUri:i}=this.getExtUri(o);return[i.getComparisonKey(s),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,c.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{const r=await o.open(s,{create:!0,unlock:e?.unlock??!1});try{(0,I.isReadableStream)(i)||(0,I.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(o,r,i):await this.doWriteReadableBufferedQueued(o,r,i)}catch(n){throw(0,u.ensureFileSystemProviderError)(n)}finally{await o.close(r)}})}async doWriteStreamBufferedQueued(o,s,e){let i=0,r;if((0,I.isReadableBufferedStream)(e)){if(e.buffer.length>0){const n=y.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,s,n,n.byteLength,i,0),i+=n.byteLength}if(e.ended)return;r=e.stream}else r=e;return new Promise(async(n,a)=>{(0,I.listenStream)(r,{onData:async E=>{r.pause();try{await this.doWriteBuffer(o,s,E,E.byteLength,i,0)}catch(w){return a(w)}i+=E.byteLength,setTimeout(()=>r.resume())},onError:E=>a(E),onEnd:()=>n()})})}async doWriteReadableBufferedQueued(o,s,e){let i=0,r;for(;(r=e.read())!==null;)await this.doWriteBuffer(o,s,r,r.byteLength,i,0),i+=r.byteLength}async doWriteBuffer(o,s,e,i,r,n){let a=0;for(;a<i;)a+=await o.write(s,r+a,e.buffer,n+a,i-a)}async doWriteUnbuffered(o,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,s,e,i))}async doWriteUnbufferedQueued(o,s,e,i){let r;i instanceof y.VSBuffer?r=i:(0,I.isReadableStream)(i)?r=await(0,y.streamToBuffer)(i):(0,I.isReadableBufferedStream)(i)?r=await(0,y.bufferedStreamToBuffer)(i):r=(0,y.readableToBuffer)(i),await o.writeFile(s,r.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,s,e,i))}async doPipeBufferedQueued(o,s,e,i){let r,n;try{r=await o.open(s,{create:!1}),n=await e.open(i,{create:!0,unlock:!1});const a=y.VSBuffer.alloc(this.BUFFER_SIZE);let E=0,w=0,A=0;do A=await o.read(r,E,a.buffer,w,a.byteLength-w),await this.doWriteBuffer(e,n,a,A,E,w),E+=A,w+=A,w===a.byteLength&&(w=0);while(A>0)}catch(a){throw(0,u.ensureFileSystemProviderError)(a)}finally{await S.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof n=="number"?e.close(n):Promise.resolve()])}}async doPipeUnbuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,s,e,i))}async doPipeUnbufferedQueued(o,s,e,i){return e.writeFile(i,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,s,e,i))}async doPipeUnbufferedToBufferedQueued(o,s,e,i){const r=await e.open(i,{create:!0,unlock:!1});try{const n=await o.readFile(s);await this.doWriteBuffer(e,r,y.VSBuffer.wrap(n),n.byteLength,0,0)}catch(n){throw(0,u.ensureFileSystemProviderError)(n)}finally{await e.close(r)}}async doPipeBufferedToUnbuffered(o,s,e,i){const r=await(0,y.streamToBuffer)(this.readFileBuffered(o,s,R.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,r)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new u.FileOperationError((0,l.localize)(22,null,this.resourceForError(s)),6);return o}throwIfFileIsReadonly(o,s){if((s.permissions??0)&u.FilePermission.Readonly)throw new u.FileOperationError((0,l.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===v.Schemas.file?o.fsPath:o.toString(!0)}};m.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},m=fe([ae(0,f.ILogService)],m),t.FileService=m}),define(Q[107],ee([0,1,22,3,17,13,38,2,4,11,19,37,12,83,16,57,99,91,92,54,94,14,32]),function($,t,O,S,y,R,D,T,c,g,v,P,d,I,l,u,b,f,m,h,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class i extends T.Disposable{constructor(n,a){super();this.logService=n,this.options=a,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=R.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new R.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new S.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,g.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:a,symbolicLink:E}=await d.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(a,E),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(n){try{const a=await d.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),E=[];return await Promise.all(a.map(async w=>{try{let A;w.isSymbolicLink()?A=(await this.stat((0,v.joinPath)(n,w.name))).type:A=this.toType(w),E.push([w.name,A])}catch(A){this.logService.trace(A)}})),E}catch(a){throw this.toFileSystemProviderError(a)}}toType(n,a){let E;return a?.dangling?E=l.FileType.Unknown:n.isFile()?E=l.FileType.File:n.isDirectory()?E=l.FileType.Directory:E=l.FileType.Unknown,a&&(E|=l.FileType.SymbolicLink),E}async readFile(n){try{const a=this.toFilePath(n);return await d.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(n,a,E){const w=(0,P.newWriteableStream)(A=>y.VSBuffer.concat(A.map(p=>y.VSBuffer.wrap(p))).buffer);return(0,u.readFileIntoStream)(this,n,w,A=>A.buffer,{...a,bufferSize:this.BUFFER_SIZE},E),w}async writeFile(n,a,E){let w;try{const A=this.toFilePath(n);if(!E.create||!E.overwrite){if(await d.Promises.exists(A)){if(!E.overwrite)throw(0,l.createFileSystemProviderError)((0,I.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!E.create)throw(0,l.createFileSystemProviderError)((0,I.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}w=await this.open(n,{create:!0,unlock:E.unlock}),await this.write(w,0,a,0,a.byteLength)}catch(A){throw await this.toFileSystemProviderWriteError(n,A)}finally{typeof w=="number"&&await this.close(w)}}async open(n,a){try{const E=this.toFilePath(n);if((0,l.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:p}=await d.SymlinkSupport.stat(E);p.mode&128||await d.Promises.chmod(E,p.mode|128)}catch(p){this.logService.trace(p)}let w;if((0,l.isFileOpenForWriteOptions)(a)){if(g.isWindows)try{await d.Promises.truncate(E,0),w="r+"}catch(p){p.code!=="ENOENT"&&this.logService.trace(p)}w||(w="w")}else w="r";const A=await d.Promises.open(E,w);return this.mapHandleToPos.set(A,0),(0,l.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(A,n),A}catch(E){throw(0,l.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(n,E):this.toFileSystemProviderError(E)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await d.Promises.fdatasync(n)}catch(a){this.canFlush=!1,this.logService.error(a)}return await d.Promises.close(n)}catch(a){throw this.toFileSystemProviderError(a)}}async read(n,a,E,w,A){const p=this.normalizePos(n,a);let C=null;try{const N=await d.Promises.read(n,E,w,A,p);return typeof N=="number"?C=N:C=N.bytesRead,C}catch(N){throw this.toFileSystemProviderError(N)}finally{this.updatePos(n,p,C)}}normalizePos(n,a){return a===this.mapHandleToPos.get(n)?null:a}updatePos(n,a,E){const w=this.mapHandleToPos.get(n);typeof w=="number"&&(typeof a=="number"||(typeof E=="number"?this.mapHandleToPos.set(n,w+E):this.mapHandleToPos.delete(n)))}async write(n,a,E,w,A){return(0,S.retry)(()=>this.doWrite(n,a,E,w,A),100,3)}async doWrite(n,a,E,w,A){const p=this.normalizePos(n,a);let C=null;try{const N=await d.Promises.write(n,E,w,A,p);return typeof N=="number"?C=N:C=N.bytesWritten,C}catch(N){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),N)}finally{this.updatePos(n,p,C)}}async mkdir(n){try{await d.Promises.mkdir(this.toFilePath(n))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(n,a){try{const E=this.toFilePath(n);await this.doDelete(E,a)}catch(E){throw this.toFileSystemProviderError(E)}}async doDelete(n,a){a.recursive?await d.Promises.rm(n,d.RimRafMode.MOVE):await d.Promises.unlink(n)}async rename(n,a,E){const w=this.toFilePath(n),A=this.toFilePath(a);if(w!==A)try{await this.validateTargetDeleted(n,a,"move",E.overwrite),await d.Promises.move(w,A)}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,I.localize)(2,null,(0,c.basename)(w),(0,c.basename)((0,c.dirname)(A)),p.toString()))),this.toFileSystemProviderError(p)}}async copy(n,a,E){const w=this.toFilePath(n),A=this.toFilePath(a);if(w!==A)try{await this.validateTargetDeleted(n,a,"copy",E.overwrite),await d.Promises.copy(w,A,{preserveSymlinks:!0})}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,I.localize)(3,null,(0,c.basename)(w),(0,c.basename)((0,c.dirname)(A)),p.toString()))),this.toFileSystemProviderError(p)}}async validateTargetDeleted(n,a,E,w){const A=this.toFilePath(n),p=this.toFilePath(a);let C=!1;if(!!(this.capabilities&1024)||(C=(0,D.isEqual)(A,p,!0)),C&&E==="copy")throw(0,l.createFileSystemProviderError)((0,I.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(!C&&await d.Promises.exists(p)){if(!w)throw(0,l.createFileSystemProviderError)((0,I.localize)(5,null),l.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(n,a){return a.recursive?this.watchRecursive(n,a.excludes):this.watchNonRecursive(n)}watchRecursive(n,a){const E={path:this.toFilePath(n),excludes:a},w=(0,O.insert)(this.recursiveFoldersToWatch,E);return this.refreshRecursiveWatchers(),(0,T.toDisposable)(()=>{w(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof f.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,T.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let n,a;this.options?.watcher?.usePolling?(n=m.FileWatcher,a=this.options?.watcher):e.default.quality==="stable"&&this.recursiveFoldersToWatch.length===1?g.isWindows?n=o.FileWatcher:n=m.FileWatcher:n=f.FileWatcher,this.recursiveWatcher=new n(this.recursiveFoldersToWatch,E=>this._onDidChangeFile.fire((0,h.toFileChanges)(E)),E=>{E.type==="error"&&this._onDidWatchErrorOccur.fire(E.message),this.logService[E.type](E.message)},this.logService.getLevel()===s.LogLevel.Trace,a),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)}))}}watchNonRecursive(n){const a=new b.FileWatcher(this.toFilePath(n),w=>this._onDidChangeFile.fire((0,h.toFileChanges)(w)),w=>{w.type==="error"&&this._onDidWatchErrorOccur.fire(w.message),this.logService[w.type](w.message)},this.logService.getLevel()===s.LogLevel.Trace),E=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)});return(0,T.combinedDisposable)(a,E)}toFilePath(n){return(0,c.normalize)(n.fsPath)}toFileSystemProviderError(n){if(n instanceof l.FileSystemProviderError)return n;let a;switch(n.code){case"ENOENT":a=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=l.FileSystemProviderErrorCode.NoPermissions;break;default:a=l.FileSystemProviderErrorCode.Unknown}return(0,l.createFileSystemProviderError)(n,a)}async toFileSystemProviderWriteError(n,a){let E=this.toFileSystemProviderError(a);if(n&&E.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:w}=await d.SymlinkSupport.stat(this.toFilePath(n));w.mode&128||(E=(0,l.createFileSystemProviderError)(a,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(w){this.logService.trace(w)}return E}dispose(){super.dispose(),(0,T.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,T.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=i}),define(Q[42],ee([0,1,15]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,O.createDecorator)("productService")}),define(Q[26],ee([0,1,58,10]),function($,t,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class y{constructor(){this.data=new Map}add(D,T){O.ok(S.isString(D)),O.ok(S.isObject(T)),O.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,T)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}t.Registry=new y}),define(Q[108],ee([0,1,13,26]),function($,t,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function y(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class R{constructor(){this._onDidChangeSchema=new O.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,g){this.schemasById[y(c)]=g,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new R;S.Registry.add(t.Extensions.JSONContribution,D)}),define(Q[33],ee([0,1,13,10,73,108,26]),function($,t,O,S,y,R,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var T;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(T=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var c;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(c=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const g=D.Registry.as(R.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:y.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},g.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(m,h=!0){this.registerConfigurations([m],h)}registerConfigurations(m,h=!0){const o=[];m.forEach(s=>{o.push(...this.validateAndRegisterProperties(s,h,s.extensionInfo)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),g.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(m){const h=[],o=s=>{if(s.properties)for(const e in s.properties)h.push(e),delete this.configurationProperties[e],this.removeFromSchema(e,s.properties[e]);s.allOf&&s.allOf.forEach(e=>o(e))};for(const s of m){o(s);const e=this.configurationContributors.indexOf(s);e!==-1&&this.configurationContributors.splice(e,1)}g.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}registerDefaultConfigurations(m){const h=[],o=[];for(const s of m)for(const e in s)if(h.push(e),t.OVERRIDE_PROPERTY_PATTERN.test(e)){this.defaultValues[e]={...this.defaultValues[e]||{},...s[e]};const i={type:"object",default:this.defaultValues[e],description:y.localize(1,null,e),$ref:t.resourceLanguageSettingsSchemaId};o.push(d(e)),this.configurationProperties[e]=i,this.defaultLanguageConfigurationOverridesNode.properties[e]=i}else{this.defaultValues[e]=s[e];const i=this.configurationProperties[e];i&&(this.updatePropertyDefaultValue(e,i),this.updateSchema(e,i))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterDefaultConfigurations(m){const h=[];for(const o of m)for(const s in o)if(h.push(s),delete this.defaultValues[s],t.OVERRIDE_PROPERTY_PATTERN.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const e=this.configurationProperties[s];e&&(this.updatePropertyDefaultValue(s,e),this.updateSchema(s,e))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}notifyConfigurationSchemaUpdated(...m){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(m){for(const h of m)this.overrideIdentifiers.add(h);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(m,h=!0,o,s=3){s=S.isUndefinedOrNull(m.scope)?s:m.scope;let e=[],i=m.properties;if(i)for(let n in i){if(h&&u(n)){delete i[n];continue}const a=i[n];if(this.updatePropertyDefaultValue(n,a),t.OVERRIDE_PROPERTY_PATTERN.test(n)?a.scope=void 0:(a.scope=S.isUndefinedOrNull(a.scope)?s:a.scope,a.restricted=S.isUndefinedOrNull(a.restricted)?!!o?.restrictedConfigurations?.includes(n):a.restricted),i[n].hasOwnProperty("included")&&!i[n].included){this.excludedConfigurationProperties[n]=i[n],delete i[n];continue}else this.configurationProperties[n]=i[n];!i[n].deprecationMessage&&i[n].markdownDeprecationMessage&&(i[n].deprecationMessage=i[n].markdownDeprecationMessage),e.push(n)}let r=m.allOf;if(r)for(let n of r)e.push(...this.validateAndRegisterProperties(n,h,o,s));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(m){const h=o=>{let s=o.properties;if(s)for(const i in s)this.updateSchema(i,s[i]);let e=o.allOf;e&&e.forEach(h)};h(m)}updateSchema(m,h){switch(t.allSettings.properties[m]=h,h.scope){case 1:t.applicationSettings.properties[m]=h;break;case 2:t.machineSettings.properties[m]=h;break;case 6:t.machineOverridableSettings.properties[m]=h;break;case 3:t.windowSettings.properties[m]=h;break;case 4:t.resourceSettings.properties[m]=h;break;case 5:t.resourceSettings.properties[m]=h,this.resourceLanguageSettingsSchema.properties[m]=h;break}}removeFromSchema(m,h){switch(delete t.allSettings.properties[m],h.scope){case 1:delete t.applicationSettings.properties[m];break;case 2:delete t.machineSettings.properties[m];break;case 6:delete t.machineOverridableSettings.properties[m];break;case 3:delete t.windowSettings.properties[m];break;case 4:case 5:delete t.resourceSettings.properties[m];break}}updateOverridePropertyPatternKey(){for(const m of this.overrideIdentifiers.values()){const h=`[${m}]`,o={type:"object",description:y.localize(2,null),errorMessage:y.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(h,o),t.allSettings.properties[h]=o,t.applicationSettings.properties[h]=o,t.machineSettings.properties[h]=o,t.machineOverridableSettings.properties[h]=o,t.windowSettings.properties[h]=o,t.resourceSettings.properties[h]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(m,h){let o=this.defaultValues[m];S.isUndefined(o)&&(o=h.default),S.isUndefined(o)&&(o=I(h.type)),h.default=o}}const P="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(P);function d(f){return f.substring(1,f.length-1)}t.overrideIdentifierFromKey=d;function I(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=I;const l=new v;D.Registry.add(t.Extensions.Configuration,l);function u(f){return f.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(f)?y.localize(5,null,f):l.getConfigurationProperties()[f]!==void 0?y.localize(6,null,f):null:y.localize(4,null)}t.validateProperty=u;function b(){const f=[],m=l.getConfigurationProperties();for(const h of Object.keys(m))f.push([h,m[h].scope]);return f.push(["launch",4]),f.push(["task",4]),f}t.getScopes=b}),define(Q[27],ee([0,1,18,10,7,33,15,26]),function($,t,O,S,y,R,D,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,D.createDecorator)("configurationService");function c(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof y.URI)}t.isConfigurationOverrides=c;var g;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(g=t.ConfigurationTarget||(t.ConfigurationTarget={}));function v(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=v;function P(i,r){const n=r?i?r.keys.filter(N=>i.keys.indexOf(N)===-1):[...r.keys]:[],a=i?r?i.keys.filter(N=>r.keys.indexOf(N)===-1):[...i.keys]:[],E=[];if(r&&i){for(const N of i.keys)if(r.keys.indexOf(N)!==-1){const j=f(i.contents,N),Y=f(r.contents,N);O.equals(j,Y)||E.push(N)}}const w=[],A=N=>{const j={};for(const Y of N)for(const te of Y.identifiers)j[s(te)]=Y;return j},p=r?A(r.overrides):{},C=i?A(i.overrides):{};if(Object.keys(p).length)for(const N of n){const j=p[N];j&&w.push([(0,R.overrideIdentifierFromKey)(N),j.keys])}if(Object.keys(C).length)for(const N of a){const j=C[N];j&&w.push([(0,R.overrideIdentifierFromKey)(N),j.keys])}if(Object.keys(p).length&&Object.keys(C).length)for(const N of E){const j=C[N],Y=p[N];if(j&&Y){const te=P({contents:j.contents,keys:j.keys,overrides:[]},{contents:Y.contents,keys:Y.keys,overrides:[]});w.push([(0,R.overrideIdentifierFromKey)(N),[...te.added,...te.removed,...te.updated]])}}return{added:n,removed:a,updated:E,overrides:w}}t.compare=P;function d(i,r){const n=[];for(const a of Object.keys(i))if(R.OVERRIDE_PROPERTY_PATTERN.test(a)){const E={};for(const w in i[a])E[w]=i[a][w];n.push({identifiers:[(0,R.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(E),contents:I(E,r)})}return n}t.toOverrides=d;function I(i,r){const n=Object.create(null);for(let a in i)l(n,a,i[a],r);return n}t.toValuesTree=I;function l(i,r,n,a){const E=r.split("."),w=E.pop();let A=i;for(let p=0;p<E.length;p++){let C=E[p],N=A[C];switch(typeof N){case"undefined":N=A[C]=Object.create(null);break;case"object":break;default:a(`Ignoring ${r} as ${E.slice(0,p+1).join(".")} is ${JSON.stringify(N)}`);return}A=N}if(typeof A=="object"&&A!==null)try{A[w]=n}catch(p){a(`Ignoring ${r} as ${E.join(".")} is ${JSON.stringify(A)}`)}else a(`Ignoring ${r} as ${E.join(".")} is ${JSON.stringify(A)}`)}t.addToValueTree=l;function u(i,r){const n=r.split(".");b(i,n)}t.removeFromValueTree=u;function b(i,r){const n=r.shift();if(r.length===0){delete i[n];return}if(Object.keys(i).indexOf(n)!==-1){const a=i[n];typeof a=="object"&&!Array.isArray(a)&&(b(a,r),Object.keys(a).length===0&&delete i[n])}}function f(i,r,n){function a(A,p){let C=A;for(const N of p){if(typeof C!="object"||C===null)return;C=C[N]}return C}const E=r.split("."),w=a(i,E);return typeof w=="undefined"?n:w}t.getConfigurationValue=f;function m(i,r,n){Object.keys(r).forEach(a=>{a!=="__proto__"&&(a in i?S.isObject(i[a])&&S.isObject(r[a])?m(i[a],r[a],n):n&&(i[a]=r[a]):i[a]=r[a])})}t.merge=m;function h(){const i=T.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=h;function o(){const i=Object.create(null),r=T.Registry.as(R.Extensions.Configuration).getConfigurationProperties();for(let n in r){let a=r[n].default;l(i,n,a,E=>console.error(`Conflict in default settings: ${E}`))}return i}t.getDefaultValues=o;function s(i){return`[${i}]`}t.keyFromOverrideIdentifier=s;function e(i,r,n){const a=i.inspect(r),E=i.inspect(n);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof E.userValue!="undefined"||typeof E.workspaceValue!="undefined"||typeof E.workspaceFolderValue!="undefined"?E.value:a.defaultValue}t.getMigratedSettingValue=e}),define(Q[109],ee([0,1,22,13,59,2,46,18,10,7,27,33,26]),function($,t,O,S,y,R,D,T,c,g,v,P,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class I{constructor(e={},i=[],r=[]){this._contents=e,this._keys=i,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,v.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const r=this.getContentsForOverrideIdentifer(i);return r?e?(0,v.getConfigurationValue)(r,e):r:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let r={};for(const n of O.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[n],E=i[n];E&&(typeof a=="object"&&typeof E=="object"?(a=T.deepClone(a),this.mergeContents(a,E)):a=E),r[n]=a}return new I(r,this.keys,this.overrides)}merge(...e){const i=T.deepClone(this.contents),r=T.deepClone(this.overrides),n=[...this.keys];for(const a of e){this.mergeContents(i,a.contents);for(const E of a.overrides){const[w]=r.filter(A=>O.equals(A.identifiers,E.identifiers));w?this.mergeContents(w.contents,E.contents):r.push(T.deepClone(E))}for(const E of a.keys)n.indexOf(E)===-1&&n.push(E)}return new I(i,n,r)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const r of Object.keys(i)){if(r in e&&c.isObject(e[r])&&c.isObject(i[r])){this.mergeContents(e[r],i[r]);continue}e[r]=T.deepClone(i[r])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?T.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,v.addToValueTree)(this.contents,e,i,r=>{throw new Error(r)})}removeValue(e){this.removeKey(e)&&(0,v.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let r=0;r<i;r++)e.indexOf(this.keys[r])===0&&(i=r);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=I;class l extends I{constructor(){const e=(0,v.getDefaultValues)(),i=(0,v.getConfigurationKeys)(),r=[];for(const n of Object.keys(e))P.OVERRIDE_PROPERTY_PATTERN.test(n)&&r.push({identifiers:[(0,P.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(e[n]),contents:(0,v.toValuesTree)(e[n],a=>console.error(`Conflict in default settings file: ${a}`))});super(e,i,r)}}t.DefaultConfigurationModel=l;class u{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new I}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!c.isUndefinedOrNull(e)){const r=this.doParseContent(e);this.parseRaw(r,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:r,keys:n,overrides:a,restricted:E}=this.doParseRaw(e,i);this._configurationModel=new I(r,n,a),this._restrictedConfigurations=E||[]}doParseContent(e){let i={},r=null,n=[],a=[],E=[];function w(p){Array.isArray(n)?n.push(p):r!==null&&(n[r]=p)}let A={onObjectBegin:()=>{let p={};w(p),a.push(n),n=p,r=null},onObjectProperty:p=>{r=p},onObjectEnd:()=>{n=a.pop()},onArrayBegin:()=>{let p=[];w(p),a.push(n),n=p,r=null},onArrayEnd:()=>{n=a.pop()},onLiteralValue:w,onError:(p,C,N)=>{E.push({error:p,offset:C,length:N})}};if(e)try{y.visit(e,A),i=n[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return i}doParseRaw(e,i){const r=d.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),n=this.filter(e,r,!0,i);e=n.raw;const a=(0,v.toValuesTree)(e,A=>console.error(`Conflict in settings file ${this._name}: ${A}`)),E=Object.keys(e),w=(0,v.toOverrides)(e,A=>console.error(`Conflict in settings file ${this._name}: ${A}`));return{contents:a,keys:E,overrides:w,restricted:n.restricted}}filter(e,i,r,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:e,restricted:[]};const a={},E=[];for(let w in e)if(P.OVERRIDE_PROPERTY_PATTERN.test(w)&&r){const A=this.filter(e[w],i,!1,n);a[w]=A.raw,E.push(...A.restricted)}else{const A=i[w],p=A?typeof A.scope!="undefined"?A.scope:3:void 0;A?.restricted&&E.push(w),(p===void 0||n.scopes===void 0||n.scopes.includes(p))&&(n.skipRestricted&&A?.restricted||(a[w]=e[w]))}return{raw:a,restricted:E}}}t.ConfigurationModelParser=u;class b extends R.Disposable{constructor(e,i,r,n){super();this.userSettingsResource=e,this.scopes=i,this.fileService=n,this._onDidChange=this._register(new S.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(S.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new I}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=b;class f{constructor(e,i,r=new I,n=new I,a=new D.ResourceMap,E=new I,w=new D.ResourceMap,A=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=r,this._workspaceConfiguration=n,this._folderConfigurations=a,this._memoryConfiguration=E,this._memoryConfigurationByResource=w,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(e,i,r){return this.getConsolidateConfigurationModel(i,r).getValue(e)}updateValue(e,i,r={}){let n;r.resource?(n=this._memoryConfigurationByResource.get(r.resource),n||(n=new I,this._memoryConfigurationByResource.set(r.resource,n))):n=this._memoryConfiguration,i===void 0?n.removeValue(e):n.setValue(e,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,r){const n=this.getConsolidateConfigurationModel(i,r),a=this.getFolderConfigurationModelForResource(i.resource,r),E=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,w=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),A=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),p=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),C=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),N=r?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,j=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(e):a.freeze().getValue(e):void 0,Y=i.overrideIdentifier?E.override(i.overrideIdentifier).getValue(e):E.getValue(e),te=n.getValue(e),se=O.distinct(O.flatten(n.overrides.map(Z=>Z.identifiers))).filter(Z=>n.getOverrideValue(e,Z)!==void 0);return{defaultValue:w,userValue:A,userLocalValue:p,userRemoteValue:C,workspaceValue:N,workspaceFolderValue:j,memoryValue:Y,value:te,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:p!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:C!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:j!==void 0?{value:a?.freeze().getValue(e),override:i.overrideIdentifier?a?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:Y!==void 0?{value:E.getValue(e),override:i.overrideIdentifier?E.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:se.length?se:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const r=i.filter(n=>P.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const a=(0,P.overrideIdentifierFromKey)(n),E=this._defaultConfiguration.getKeysForOverrideIdentifier(a),w=e.getKeysForOverrideIdentifier(a),A=[...w.filter(p=>E.indexOf(p)===-1),...E.filter(p=>w.indexOf(p)===-1),...E.filter(p=>!T.equals(this._defaultConfiguration.override(a).getValue(p),e.override(a).getValue(p)))];return[a,A]});return this.updateDefaultConfiguration(e),{keys:i,overrides:r}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:r,removed:n,overrides:a}=(0,v.compare)(this.localUserConfiguration,e),E=[...i,...r,...n];return E.length&&this.updateLocalUserConfiguration(e),{keys:E,overrides:a}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:r,removed:n,overrides:a}=(0,v.compare)(this.remoteUserConfiguration,e);let E=[...i,...r,...n];return E.length&&this.updateRemoteUserConfiguration(e),{keys:E,overrides:a}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:r,removed:n,overrides:a}=(0,v.compare)(this.workspaceConfiguration,e);let E=[...i,...r,...n];return E.length&&this.updateWorkspaceConfiguration(e),{keys:E,overrides:a}}compareAndUpdateFolderConfiguration(e,i){const r=this.folderConfigurations.get(e),{added:n,updated:a,removed:E,overrides:w}=(0,v.compare)(r,i);let A=[...n,...a,...E];return(A.length||!r)&&this.updateFolderConfiguration(e,i),{keys:A,overrides:w}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:r,updated:n,removed:a,overrides:E}=(0,v.compare)(i,void 0);return{keys:[...r,...n,...a],overrides:E}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let r=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?r.override(e.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:e},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const n=i.getFolder(e);n&&(r=this.getFolderConsolidatedConfiguration(n.uri)||r);const a=this._memoryConfigurationByResource.get(e);a&&(r=r.merge(a))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(e);n?(i=r.merge(n),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=r}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const r=i.getFolder(e);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:r,overrides:n,keys:a}=this._folderConfigurations.get(i);return e.push([i,{contents:r,overrides:n,keys:a}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(r=>e.add(r))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),r=this.parseConfigurationModel(e.user),n=this.parseConfigurationModel(e.workspace),a=e.folders.reduce((E,w)=>(E.set(g.URI.revive(w[0]),this.parseConfigurationModel(w[1])),E),new D.ResourceMap);return new f(i,r,new I,n,a,new I,new D.ResourceMap,!1)}static parseConfigurationModel(e){return new I(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=f;function m(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,i=new Map;for(const n of s)n.keys.forEach(a=>e.add(a)),n.overrides.forEach(([a,E])=>{const w=(0,D.getOrSet)(i,a,new Set);E.forEach(A=>w.add(A))});const r=[];return i.forEach((n,a)=>r.push([a,[...n.values()]])),{keys:[...e.values()],overrides:r}}t.mergeChanges=m;class h{constructor(e,i,r,n){this.change=e,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=n,this._previousConfiguration=void 0;const a=new Set;e.keys.forEach(w=>a.add(w)),e.overrides.forEach(([,w])=>w.forEach(A=>a.add(A))),this.affectedKeys=[...a.values()];const E=new I;this.affectedKeys.forEach(w=>E.setValue(w,{})),this.affectedKeysTree=E.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=f.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!T.equals(r,n)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let r=(0,v.toValuesTree)({[i]:!0},()=>{}),n;for(;typeof r=="object"&&(n=Object.keys(r)[0]);){if(e=e[n],!e)return!1;r=r[n]}return!0}}t.ConfigurationChangeEvent=h;class o extends h{constructor(e,i,r,n){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=r,this.sourceConfig=n}}t.AllKeysConfigurationChangeEvent=o}),define(Q[110],ee([0,1,3,13,2,19,27,109,33,26]),function($,t,O,S,y,R,D,T,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class v extends y.Disposable{constructor(d,I){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new S.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new T.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,I)),this.configuration=new T.Configuration(new T.DefaultConfigurationModel,new T.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new O.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(g.Registry.as(c.Extensions.Configuration).onDidUpdateConfiguration(l=>this.onDidDefaultConfigurationChange(l))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new T.Configuration(new T.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,I){const l=typeof d=="string"?d:void 0,u=(0,D.isConfigurationOverrides)(d)?d:(0,D.isConfigurationOverrides)(I)?I:{};return this.configuration.getValue(l,u,void 0)}updateValue(d,I,l,u){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const I=this.configuration.toData(),l=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(l,I,1)}onDidDefaultConfigurationChange(d){const I=this.configuration.toData(),l=this.configuration.compareAndUpdateDefaultConfiguration(new T.DefaultConfigurationModel,d);this.trigger(l,I,6)}trigger(d,I,l){const u=new T.ConfigurationChangeEvent(d,{data:I},this.configuration);u.source=l,u.sourceConfig=this.getTargetConfiguration(l),this._onDidChangeConfiguration.fire(u)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=v}),define(Q[43],ee([0,1,17,84,33,15,26]),function($,t,O,S,y,R,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,R.createDecorator)("requestService");function T(l){return l.res.statusCode&&l.res.statusCode>=200&&l.res.statusCode<300||l.res.statusCode===1223}t.isSuccess=T;function c(l){return l.res.statusCode===204}async function g(l){if(!T(l))throw new Error("Server returned "+l.res.statusCode);return c(l)?null:(await(0,O.streamToBuffer)(l.stream)).toString()}t.asText=g;async function v(l){if(!T(l))throw new Error("Server returned "+l.res.statusCode);if(c(l))return null;const b=(await(0,O.streamToBuffer)(l.stream)).toString();try{return JSON.parse(b)}catch(f){throw f.message+=`:
`+b,f}}t.asJson=v;function P(l){I(l)}t.updateProxyConfigurationsScope=P;let d;function I(l){const u=D.Registry.as(y.Extensions.Configuration);d&&u.deregisterConfigurations([d]),d={id:"http",order:15,title:(0,S.localize)(0,null),type:"object",scope:l,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,S.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,S.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,S.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,S.localize)(4,null),(0,S.localize)(5,null),(0,S.localize)(6,null),(0,S.localize)(7,null)],default:"override",description:(0,S.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,S.localize)(9,null),restricted:!0}}},u.registerConfiguration(d)}I(2)}),define(Q[111],ee([0,1,25,8,16,43]),function($,t,O,S,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let D=class{constructor(c,g){this.requestService=c,this.fileService=g}async download(c,g,v=O.CancellationToken.None){if(c.scheme===S.Schemas.file||c.scheme===S.Schemas.vscodeRemote){await this.fileService.copy(c,g);return}const P={type:"GET",url:c.toString()},d=await this.requestService.request(P,v);if(d.res.statusCode===200)await this.fileService.writeFile(g,d.stream);else{const I=await(0,R.asText)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${I}`)}}};D=fe([ae(0,R.IRequestService),ae(1,y.IFileService)],D),t.DownloadService=D}),define(Q[112],ee([0,1,113,10]),function($,t,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function y(D,T){return D.protocol==="http:"?T.HTTP_PROXY||T.http_proxy||null:D.protocol==="https:"&&(T.HTTPS_PROXY||T.https_proxy||T.HTTP_PROXY||T.http_proxy)||null}async function R(D,T,c={}){const g=(0,O.parse)(D),v=c.proxyUrl||y(g,T);if(!v)return null;const P=(0,O.parse)(v);if(!/^https?:$/.test(P.protocol||""))return null;const d={host:P.hostname||"",port:P.port||(P.protocol==="https"?"443":"80"),auth:P.auth,rejectUnauthorized:(0,S.isBoolean)(c.strictSSL)?c.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((I,l)=>{$(["http-proxy-agent"],I,l)}))(d):new(await new Promise((I,l)=>{$(["https-proxy-agent"],I,l)}))(d)}t.getProxyAgent=R}),define(Q[114],ee([0,1,17,31]),function($,t,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function y(R,D,T){let c=T&&T.get("storage.serviceMachineId",0)||null;if(c)return c;try{const v=(await D.readFile(R.serviceMachineIdResource)).value.toString();c=(0,S.isUUID)(v)?v:null}catch(g){c=null}if(!c){c=(0,S.generateUuid)();try{await D.writeFile(R.serviceMachineIdResource,O.VSBuffer.fromString(c))}catch(g){}}return T&&T.store("storage.serviceMachineId",c,0,1),c}t.getServiceMachineId=y}),define(Q[115],ee([0,1,3,13,2,10,66,15]),function($,t,O,S,y,R,D,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const c="__$__targetStorageMarker";t.IStorageService=(0,T.createDecorator)("storageService");var g;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(g=t.WillSaveStateReason||(t.WillSaveStateReason={}));var v;(function(u){u[u.GLOBAL=0]="GLOBAL",u[u.WORKSPACE=1]="WORKSPACE"})(v=t.StorageScope||(t.StorageScope={}));var P;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(P=t.StorageTarget||(t.StorageTarget={}));class d extends y.Disposable{constructor(b={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super();this.options=b,this._onDidChangeValue=this._register(new S.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new S.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new S.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new O.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new y.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,O.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,y.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,f){f===c?(b===0?this._globalKeyTargets=void 0:b===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:b})):this._onDidChangeValue.fire({scope:b,key:f,target:this.getKeyTargets(b)[f]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,f,m){return this.getStorage(f)?.get(b,m)}getBoolean(b,f,m){return this.getStorage(f)?.getBoolean(b,m)}getNumber(b,f,m){return this.getStorage(f)?.getNumber(b,m)}store(b,f,m,h){if((0,R.isUndefinedOrNull)(f)){this.remove(b,m);return}this.withPausedEmitters(()=>{this.updateKeyTarget(b,m,h),this.getStorage(m)?.set(b,f)})}remove(b,f){this.withPausedEmitters(()=>{this.updateKeyTarget(b,f,void 0),this.getStorage(f)?.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,f){const m=[],h=this.getKeyTargets(b);for(const o of Object.keys(h))h[o]===f&&m.push(o);return m}updateKeyTarget(b,f,m){const h=this.getKeyTargets(f);typeof m=="number"?h[b]!==m&&(h[b]=m,this.getStorage(f)?.set(c,JSON.stringify(h))):typeof h[b]=="number"&&(delete h[b],this.getStorage(f)?.set(c,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(b){return b===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(b){const f=this.get(c,b);if(f)try{return JSON.parse(f)}catch(m){}return Object.create(null)}isNew(b){return this.getBoolean(t.IS_NEW_KEY,b)===!0}async flush(b=g.NONE){this._onWillSaveState.fire({reason:b}),await O.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const b=this.getStorage(0)?.items??new Map,f=this.getStorage(1)?.items??new Map;return l(b,f,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;class I extends d{constructor(){super();this.globalStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new D.Storage(new D.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.globalStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b)))}getStorage(b){return b===0?this.globalStorage:this.workspaceStorage}getLogDetails(b){return b===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(b){}}t.InMemoryStorageService=I;async function l(u,b,f,m){const h=a=>{try{return JSON.parse(a)}catch(E){return a}},o=new Map,s=new Map;u.forEach((a,E)=>{o.set(E,a),s.set(E,h(a))});const e=new Map,i=new Map;b.forEach((a,E)=>{e.set(E,a),i.set(E,h(a))}),console.group(`Storage: Global (path: ${f})`);let r=[];o.forEach((a,E)=>{r.push({key:E,value:a})}),console.table(r),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${m})`);let n=[];e.forEach((a,E)=>{n.push({key:E,value:a})}),console.table(n),console.groupEnd(),console.log(i)}t.logStorage=l}),define(Q[116],ee([0,1,11,28,7,31]),function($,t,O,S,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function D(g){if(O.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function T(g,v,P,d,I,l,u,b,f,m){const h=Object.create(null);h["common.machineId"]=u,h.sessionID=(0,R.generateUuid)()+Date.now(),h.commitHash=I,h.version=l,h["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,O.PlatformToString)(O.platform),h["common.nodePlatform"]=S.platform,h["common.nodeArch"]=d,h["common.product"]=m||"desktop";const o=c(b||[]);o&&(h["common.msftInternal"]=o);let s=0;const e=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),O.isLinuxSnap&&(h["common.snap"]="true");const i=D(P);i&&(h["common.platformDetail"]=i);try{const r=await g.readFile(y.URI.file(f));h["common.source"]=r.value.toString().slice(0,30)}catch(r){}return h}t.resolveCommonProperties=T;function c(g){const v=S.env.USERDNSDOMAIN;if(!v)return!1;const P=v.toLowerCase();return g.some(d=>P===d)}t.verifyMicrosoftInternalDomain=c}),define(Q[29],ee([0,1,15]),function($,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,O.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,O.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var S;(function(R){R[R.NONE=0]="NONE",R[R.LOG=1]="LOG",R[R.USER=2]="USER"})(S=t.TelemetryLevel||(t.TelemetryLevel={}));var y;(function(R){R.OFF="off",R.ERROR="error",R.ON="on"})(y=t.TelemetryConfiguration||(t.TelemetryConfiguration={}))}),define(Q[117],ee([0,1,22,3,25,9,13,2,11,7,74,23,24,14,32,29]),function($,t,O,S,y,R,D,T,c,g,v,P,d,I,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=t.INSTALL_ERROR_LOCAL=t.ERROR_UNKNOWN=t.INSTALL_ERROR_VALIDATING=void 0,t.INSTALL_ERROR_VALIDATING="validating",t.ERROR_UNKNOWN="unknown",t.INSTALL_ERROR_LOCAL="local";let b=class extends T.Disposable{constructor(s,e,i){super();this.galleryService=s,this.telemetryService=e,this.logService=i,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,T.toDisposable)(()=>{this.installingExtensions.forEach(r=>r.cancel()),this.uninstallingExtensions.forEach(r=>r.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(s){const e=await this.getTargetPlatform();return s.allTargetPlatforms.some(i=>(0,P.isTargetPlatformCompatible)(i,s.allTargetPlatforms,e))}async installFromGallery(s,e={}){if(!this.galleryService.isEnabled())throw new Error(v.localize(0,null));if(!await this.canInstall(s)){const r=await this.getTargetPlatform(),n=new P.ExtensionManagementError(v.localize(1,null,s.identifier.id,l.default.nameLong,(0,P.TargetPlatformToString)(r)),t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension.",s.identifier.id,n.message),m(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(s),void 0,n),n}try{s=await this.checkAndGetCompatibleVersion(s,!e.installGivenVersion)}catch(r){throw this.logService.error((0,R.getErrorMessage)(r)),m(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(s),void 0,r),r}const i=await this.galleryService.getManifest(s,y.CancellationToken.None);if(i===null){const r=new P.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",s.identifier.id,r.message),m(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(s),void 0,r),r}if(i.version!==s.version){const r=new P.ExtensionManagementError(`Cannot install '${s.identifier.id}' extension because of version mismatch in Marketplace`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error(r.message),m(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(s),void 0,r),r}return this.installExtension(i,s,e)}async uninstall(s,e={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.unininstallExtension(s,e)}async reinstallFromGallery(s){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",s.identifier.id),!this.galleryService.isEnabled())throw new Error(v.localize(2,null));const e=await this.findGalleryExtension(s);if(!e)throw new Error(v.localize(3,null));await this.createUninstallExtensionTask(s,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsReport(){const s=new Date().getTime();return(!this.reportedExtensions||s-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=s),this.reportedExtensions}registerParticipant(s){this.participants.push(s)}async installExtension(s,e,i){if(!g.URI.isUri(e)){let w=this.installingExtensions.get(new d.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(w)return this.logService.info("Extensions is already requested to install",e.identifier.id),w.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],n=[],a=this.createInstallExtensionTask(s,e,i);g.URI.isUri(e)||this.installingExtensions.set(new d.ExtensionIdentifierWithVersion(a.identifier,s.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:e}),this.logService.info("Installing extension:",a.identifier.id),r.push({task:a,manifest:s});let E=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const A=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,s,!!i.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:p,manifest:C}of A)if(E=E||!!C.extensionDependencies?.some(N=>(0,d.areSameExtensions)({id:N},a.identifier)),this.installingExtensions.has(new d.ExtensionIdentifierWithVersion(p.identifier,p.version).key()))this.logService.info("Extension is already requested to install",p.identifier.id);else{const N=this.createInstallExtensionTask(C,p,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new d.ExtensionIdentifierWithVersion(N.identifier,C.version).key(),N),this._onInstallExtension.fire({identifier:N.identifier,source:p}),this.logService.info("Installing extension:",N.identifier.id),r.push({task:N,manifest:C})}}catch(A){if(g.URI.isUri(a.source))(0,O.isNonEmptyArray)(s.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,A.message),(0,O.isNonEmptyArray)(s.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,A.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(A),A}const w=r.reduce((A,{task:p,manifest:C})=>(A.set(p.identifier.id.toLowerCase(),{task:p,manifest:C}),A),new Map);for(;w.size;){let A;const p=[...w.values()].filter(({manifest:C})=>!C.extensionDependencies?.some(N=>w.has(N.toLowerCase())));p.length?A=w.size===1?p:p.filter(({task:C})=>!(C===a&&!E)):(this.logService.info("Found extensions with circular dependencies",p.map(({task:C})=>C.identifier.id)),A=[...w.values()]),await this.joinAllSettled(A.map(async({task:C})=>{const N=new Date().getTime();try{const j=await C.run();if(await this.joinAllSettled(this.participants.map(Y=>Y.postInstall(j,C.source,i,y.CancellationToken.None))),!g.URI.isUri(C.source)&&(m(this.telemetryService,C.operation===2?"extensionGallery:update":"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(C.source),new Date().getTime()-N,void 0),c.isWeb&&C.operation===1))try{await this.galleryService.reportStatistic(j.manifest.publisher,j.manifest.name,j.manifest.version,"install")}catch(Y){}n.push({local:j,identifier:C.identifier,operation:C.operation,source:C.source})}catch(j){throw g.URI.isUri(C.source)||m(this.telemetryService,C.operation===2?"extensionGallery:update":"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(C.source),new Date().getTime()-N,j),this.logService.error("Error while installing the extension:",C.identifier.id),this.logService.error(j),j}finally{w.delete(C.identifier.id.toLowerCase())}}))}return n.forEach(({identifier:A})=>this.logService.info("Extension installed successfully:",A.id)),this._onDidInstallExtensions.fire(n),n.filter(({identifier:A})=>(0,d.areSameExtensions)(A,a.identifier))[0].local}catch(w){if(r.forEach(({task:A})=>A.cancel()),n.length)try{const A=await Promise.allSettled(n.map(({local:p})=>this.createUninstallExtensionTask(p,{versionOnly:!0}).run()));for(let p=0;p<A.length;p++){const C=A[p],{identifier:N}=n[p];C.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",N.id):this.logService.warn("Rollback: Error while uninstalling extension",N.id,(0,R.getErrorMessage)(C.reason))}}catch(A){this.logService.warn("Error while rolling back extensions",(0,R.getErrorMessage)(A),n.map(({identifier:p})=>p.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,R.getErrorMessage)(w)),this._onDidInstallExtensions.fire(r.map(({task:A})=>({identifier:A.identifier,operation:1,source:A.source}))),w instanceof Error&&(w.name=w&&w.code?w.code:t.ERROR_UNKNOWN),w}finally{for(const{task:w,manifest:A}of r)if(!g.URI.isUri(w.source)){const p=new d.ExtensionIdentifierWithVersion(w.identifier,A.version).key();this.installingExtensions.delete(p)||this.logService.warn("Installation task is not found in the cache",p)}}}async joinAllSettled(s){const e=[],i=[],r=await Promise.allSettled(s);for(const n of r)n.status==="fulfilled"?e.push(n.value):i.push(n.reason);if(i.length)throw f(i);return e}async getAllDepsAndPackExtensionsToInstall(s,e,i){if(!this.galleryService.isEnabled())return[];let r=await this.getInstalled();const n=[s,...r.map(w=>w.identifier)],a=[],E=async(w,A)=>{const p=A.extensionDependencies||[],C=[...p];if(A.extensionPack){const N=i?r.find(j=>(0,d.areSameExtensions)(j.identifier,w)):void 0;for(const j of A.extensionPack)N&&N.manifest.extensionPack&&N.manifest.extensionPack.some(Y=>(0,d.areSameExtensions)({id:Y},{id:j}))||C.every(Y=>!(0,d.areSameExtensions)({id:Y},{id:j}))&&C.push(j)}if(C.length){const N=[...n,...a.map(Y=>Y.gallery.identifier)],j=C.filter(Y=>N.every(te=>!(0,d.areSameExtensions)(te,{id:Y})));if(j.length){const Y=await this.galleryService.query({names:j,pageSize:C.length},y.CancellationToken.None);for(const te of Y.firstPage){if(N.find(le=>(0,d.areSameExtensions)(le,te.identifier)))continue;if(!p.some(le=>(0,d.areSameExtensions)({id:le},te.identifier))&&!await this.canInstall(te)){this.logService.info("Skipping the packed extension as it cannot be installed",te.identifier.id);continue}const Z=await this.checkAndGetCompatibleVersion(te,!0),ce=await this.galleryService.getManifest(Z,y.CancellationToken.None);if(ce===null)throw new P.ExtensionManagementError(`Missing manifest for extension ${Z.identifier.id}`,t.INSTALL_ERROR_VALIDATING);a.push({gallery:Z,manifest:ce}),await E(Z.identifier,ce)}}}};return await E(s,e),r=await this.getInstalled(),a.filter(w=>!r.some(A=>(0,d.areSameExtensions)(A.identifier,w.gallery.identifier)))}async checkAndGetCompatibleVersion(s,e){if(await this.isMalicious(s))throw new P.ExtensionManagementError(v.localize(4,null,s.identifier.id),P.INSTALL_ERROR_MALICIOUS);const i=await this.getTargetPlatform();let r=null;if(await this.galleryService.isExtensionCompatible(s,i)&&(r=s),!r&&e&&(r=await this.galleryService.getCompatibleExtension(s,i)),!r)throw new P.ExtensionManagementError(v.localize(5,null,s.identifier.id,l.default.version),P.INSTALL_ERROR_INCOMPATIBLE);return r}async isMalicious(s){const e=await this.getExtensionsReport();return(0,d.getMaliciousExtensionsSet)(e).has(s.identifier.id)}async unininstallExtension(s,e){const i=this.uninstallingExtensions.get(s.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),i.waitUntilTaskIsFinished();const r=(w,A)=>{const p=this.createUninstallExtensionTask(w,A);return this.uninstallingExtensions.set(p.extension.identifier.id.toLowerCase(),p),this.logService.info("Uninstalling extension:",w.identifier.id),this._onUninstallExtension.fire(w.identifier),p},n=(w,A)=>{A?this.logService.error("Failed to uninstall extension:",w.identifier.id,A.message):this.logService.info("Successfully uninstalled extension:",w.identifier.id),m(this.telemetryService,"extensionGallery:uninstall",(0,d.getLocalExtensionTelemetryData)(w),void 0,A),this._onDidUninstallExtension.fire({identifier:w.identifier,error:A?.code})},a=[],E=[];try{a.push(r(s,{}));const w=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",s.identifier.id);else{const A=this.getAllPackExtensionsToUninstall(s,w);for(const p of A)this.uninstallingExtensions.has(p.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",p.identifier.id):a.push(r(p,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",s.identifier.id):this.checkForDependents(a.map(A=>A.extension),w,s),await this.joinAllSettled(a.map(async A=>{try{if(await A.run(),await this.joinAllSettled(this.participants.map(p=>p.postUninstall(A.extension,e,y.CancellationToken.None))),A.extension.identifier.uuid)try{await this.galleryService.reportStatistic(A.extension.manifest.publisher,A.extension.manifest.name,A.extension.manifest.version,"uninstall")}catch(p){}n(A.extension)}catch(p){const C=p instanceof P.ExtensionManagementError?p:new P.ExtensionManagementError((0,R.getErrorMessage)(p),t.ERROR_UNKNOWN);throw n(A.extension,C),C}finally{E.push(A)}}))}catch(w){const A=w instanceof P.ExtensionManagementError?w:new P.ExtensionManagementError((0,R.getErrorMessage)(w),t.ERROR_UNKNOWN);for(const p of a){try{p.cancel()}catch(C){}E.includes(p)||n(p.extension,A)}throw A}finally{for(const w of a)this.uninstallingExtensions.delete(w.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",w.extension.identifier.id)}}checkForDependents(s,e,i){for(const r of s){const n=this.getDependents(r,e);if(n.length){const a=n.filter(E=>!s.some(w=>(0,d.areSameExtensions)(w.identifier,E.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(r,a,i))}}}getDependentsErrorMessage(s,e,i){return i===s?e.length===1?v.localize(6,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?v.localize(7,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):v.localize(8,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?v.localize(9,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?v.localize(10,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):v.localize(11,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(s,e,i=[]){if(i.indexOf(s)!==-1)return[];i.push(s);const r=s.manifest.extensionPack?s.manifest.extensionPack:[];if(r.length){const n=e.filter(E=>!E.isBuiltin&&r.some(w=>(0,d.areSameExtensions)({id:w},E.identifier))),a=[];for(const E of n)a.push(...this.getAllPackExtensionsToUninstall(E,e,i));return[...n,...a]}return[]}getDependents(s,e){return e.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(r=>(0,d.areSameExtensions)({id:r},s.identifier)))}async findGalleryExtension(s){if(s.identifier.uuid){const e=await this.findGalleryExtensionById(s.identifier.uuid);return e||this.findGalleryExtensionByName(s.identifier.id)}return this.findGalleryExtensionByName(s.identifier.id)}async findGalleryExtensionById(s){return(await this.galleryService.query({ids:[s],pageSize:1},y.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(s){return(await this.galleryService.query({names:[s],pageSize:1},y.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const s=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${s.length} reported extensions from service`),s}catch(s){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};b=fe([ae(0,P.IExtensionGalleryService),ae(1,u.ITelemetryService),ae(2,I.ILogService)],b),t.AbstractExtensionManagementService=b;function f(o){const s=Array.isArray(o)?o:[o];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((e,i)=>new Error(`${e.message}${e.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}t.joinErrors=f;function m(o,s,e,i,r){const n=r?r instanceof P.ExtensionManagementError?r.code:t.ERROR_UNKNOWN:void 0;o.publicLogError(s,{...e,success:!r,duration:i,errorcode:n})}t.reportTelemetry=m;class h{constructor(){this.barrier=new S.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,S.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,S.createCancelablePromise)(s=>new Promise((e,i)=>{const r=s.onCancellationRequested(()=>{r.dispose(),i((0,R.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=h}),define(Q[36],ee([0,1,3,18,10,27,29]),function($,t,O,S,y,R,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryConfiguration=t.getTelemetryLevel=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(f,m){return Promise.resolve(void 0)}publicLog2(f,m){return this.publicLog(f,m)}publicLogError(f,m){return Promise.resolve(void 0)}publicLogError2(f,m){return this.publicLogError(f,m)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class T{async publicLog(m,h,o){}async publicLogError(m,h,o){}}t.NullEndpointTelemetryService=T;function c(...f){return{log:(m,h)=>f.forEach(o=>o.log(m,h)),flush:()=>O.Promises.settled(f.map(m=>m.flush()))}}t.combinedAppender=c,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(f,m){return m.onDidChangeConfiguration(h=>{h.source!==6&&f.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(h.source),configurationKeys:u(h.sourceConfig)})})}t.configurationTelemetry=g;function v(f,m){return m.disableTelemetry||!f.enableTelemetry?0:m.isBuilt?2:1}t.getTelemetryLevel=v;function P(f){const m=f.getValue(D.TELEMETRY_SETTING_ID),h=f.getValue(D.TELEMETRY_OLD_SETTING_ID);return h!==void 0&&h===!1?"off":m??"on"}t.getTelemetryConfiguration=P;function d(f){const m=Object.create(null),h=Object.create(null),o=Object.create(null);l(f,o);for(let s in o){s=s.length>150?s.substr(s.length-149):s;const e=o[s];typeof e=="number"?h[s]=e:typeof e=="boolean"?h[s]=e?1:0:typeof e=="string"?m[s]=e.substring(0,1023):typeof e!="undefined"&&e!==null&&(m[s]=e)}return{properties:m,measurements:h}}t.validateTelemetryData=d;function I(f){if(!f)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(o=>{f.indexOf(`${o}+`)===0&&(m=o)}),m}t.cleanRemoteAuthority=I;function l(f,m,h=0,o){if(!!f)for(let s of Object.getOwnPropertyNames(f)){const e=f[s],i=o?o+s:s;Array.isArray(e)?m[i]=(0,S.safeStringify)(e):e instanceof Date?m[i]=e.toISOString():(0,y.isObject)(e)?h<2?l(e,m,h+1,i+"."):m[i]=(0,S.safeStringify)(e):m[i]=e}}function u(f){if(!f)return[];const m=[];return b(m,"",f),m}function b(f,m,h){h&&typeof h=="object"&&!Array.isArray(h)?Object.keys(h).forEach(o=>b(f,m?`${m}.${o}`:o,h[o])):f.push(m)}}),define(Q[118],ee([0,1,22,25,9,18,11,28,7,27,20,23,24,51,16,14,42,43,114,115,29,36]),function($,t,O,S,y,R,D,T,c,g,v,P,d,I,l,u,b,f,m,h,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=void 0;const e=D.isWeb?"web":(0,P.getTargetPlatform)(D.platform,T.arch);var i;(function(k){k[k.None=0]="None",k[k.IncludeVersions=1]="IncludeVersions",k[k.IncludeFiles=2]="IncludeFiles",k[k.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",k[k.IncludeSharedAccounts=8]="IncludeSharedAccounts",k[k.IncludeVersionProperties=16]="IncludeVersionProperties",k[k.ExcludeNonValidated=32]="ExcludeNonValidated",k[k.IncludeInstallationTargets=64]="IncludeInstallationTargets",k[k.IncludeAssetUri=128]="IncludeAssetUri",k[k.IncludeStatistics=256]="IncludeStatistics",k[k.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",k[k.Unpublished=4096]="Unpublished"})(i||(i={}));function r(...k){return String(k.reduce((F,W)=>F|W,0))}var n;(function(k){k[k.Tag=1]="Tag",k[k.ExtensionId=4]="ExtensionId",k[k.Category=5]="Category",k[k.ExtensionName=7]="ExtensionName",k[k.Target=8]="Target",k[k.Featured=9]="Featured",k[k.SearchText=10]="SearchText",k[k.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},E={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},A={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class p{constructor(F=A){this.state=F}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(F,W=this.state.pageSize){return new p({...this.state,pageNumber:F,pageSize:W})}withFilter(F,...W){const V=[...this.state.criteria,...W.length?W.map(H=>({filterType:F,value:H})):[{filterType:F}]];return new p({...this.state,criteria:V})}withSortBy(F){return new p({...this.state,sortBy:F})}withSortOrder(F){return new p({...this.state,sortOrder:F})}withFlags(...F){return new p({...this.state,flags:F.reduce((W,V)=>W|V,0)})}withAssetTypes(...F){return new p({...this.state,assetTypes:F})}get raw(){const{criteria:F,pageNumber:W,pageSize:V,sortBy:H,sortOrder:J,flags:re,assetTypes:ie}=this.state;return{filters:[{criteria:F,pageNumber:W,pageSize:V,sortBy:H,sortOrder:J}],assetTypes:ie,flags:re}}get searchText(){const F=this.state.criteria.filter(W=>W.filterType===n.SearchText)[0];return F&&F.value?F.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(F=>String(F.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function C(k,F){const W=(k||[]).filter(V=>V.statisticName===F)[0];return W?W.value:0}function N(k){const F="Microsoft.VisualStudio.Code.Translation.";return k.files.filter(V=>V.assetType.indexOf(F)===0).reduce((V,H)=>{const J=se(k,H.assetType);return J&&V.push([H.assetType.substring(F.length),J]),V},[])}function j(k){if(k.properties){const F=k.properties.filter(H=>H.key===a.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),V=F.filter(H=>W.test(H.value))[0];return V?{uri:V.value,fallbackUri:V.value}:null}return se(k,a.Repository)}function Y(k){return{uri:`${k.fallbackAssetUri}/${a.VSIX}?redirect=true${k.targetPlatform?`&targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${a.VSIX}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}}function te(k){const F=se(k,a.Icon);if(F)return F;const W=P.DefaultIconPath;return{uri:W,fallbackUri:W}}function se(k,F){return k.files.filter(V=>V.assetType===F)[0]?{uri:`${k.assetUri}/${F}`,fallbackUri:`${k.fallbackAssetUri}/${F}`}:null}function Z(k,F){const W=k.properties?k.properties.filter(H=>H.key===F):[],V=W.length>0&&W[0].value;return V?V.split(",").map(H=>(0,d.adoptToGalleryExtensionId)(H)):[]}function ce(k){const F=k.properties?k.properties.filter(W=>W.key===E.Engine):[];return F.length>0&&F[0].value||""}function le(k){const F=k.properties?k.properties.filter(V=>V.key===E.LocalizedLanguages):[],W=F.length>0&&F[0].value||"";return W?W.split(","):[]}function _(k){return k.indexOf("preview")!==-1}function ne(k){return k.targetPlatform?(0,P.toTargetPlatform)(k.targetPlatform):"undefined"}function z(k){const F=(0,O.distinct)(k.versions.map(ne)),W=!!k.tags?.includes(P.WEB_EXTENSION_TAG),V=F.indexOf("web");return W?V===-1&&F.push("web"):V!==-1&&F.splice(V,1),F}function L(k,F,W,V){const H=z(k);let J=k.versions[0];return J=k.versions.find(re=>re.version===J.version&&(0,P.isTargetPlatformCompatible)(ne(re),H,e))||J,M(k,J,H,F,W,V)}function M(k,F,W,V,H,J){const re={manifest:se(F,a.Manifest),readme:se(F,a.Details),changelog:se(F,a.Changelog),license:se(F,a.License),repository:j(F),download:Y(F),icon:te(F),coreTranslations:N(F)};return{identifier:{id:(0,d.getGalleryExtensionId)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},name:k.extensionName,version:F.version,displayName:k.displayName,publisherId:k.publisher.publisherId,publisher:k.publisher.publisherName,publisherDisplayName:k.publisher.displayName,description:k.shortDescription||"",installCount:C(k.statistics,"install"),rating:C(k.statistics,"averagerating"),ratingCount:C(k.statistics,"ratingcount"),categories:k.categories||[],tags:k.tags||[],releaseDate:Date.parse(k.releaseDate),lastUpdated:Date.parse(k.lastUpdated),allTargetPlatforms:W,assets:re,properties:{dependencies:Z(F,E.Dependency),extensionPack:Z(F,E.ExtensionPack),engine:ce(F),localizedLanguages:le(F),targetPlatform:ne(F)},preview:_(k.flags),telemetryData:{index:(H.pageNumber-1)*H.pageSize+V,querySource:J}}}let U=class{constructor(F,W,V,H,J,re,ie,ge){this.requestService=W,this.logService=V,this.environmentService=H,this.telemetryService=J,this.fileService=re,this.productService=ie,this.configurationService=ge;const ve=ie.extensionsGallery;this.extensionsGalleryUrl=ve&&ve.serviceUrl,this.extensionsControlUrl=ve&&ve.controlUrl,this.commonHeadersPromise=X(ie.version,ie,this.environmentService,this.configurationService,this.fileService,F)}api(F=""){return`${this.extensionsGalleryUrl}${F}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(F,W){const V=[];let H=new p().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,F.length).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExtensionName,...F.map(({id:re})=>re.toLowerCase()));F.every(re=>!re.version)&&(H=H.withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties,i.IncludeLatestVersionOnly));const{galleryExtensions:J}=await this.queryGallery(H,S.CancellationToken.None);for(let re=0;re<J.length;re++){const ie=J[re];if(!ie.versions.length)continue;const ge=(0,d.getGalleryExtensionId)(ie.publisher.publisherName,ie.extensionName),ve=F.find(de=>(0,d.areSameExtensions)(de,{id:ge}))?.version;if(ve){const de=ie.versions.find(Ee=>Ee.version===ve);de&&V.push(M(ie,de,z(ie),re,H))}else V.push(L(ie,re,H))}return V}async getCompatibleExtension(F,W){const V=(0,P.isIExtensionIdentifier)(F)?null:F;if(V){if((0,P.isNotWebExtensionInWebTargetPlatform)(V.allTargetPlatforms,W))return null;if(await this.isExtensionCompatible(V,W))return V}const{id:H,uuid:J}=V?V.identifier:F;let re=new p().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");J?re=re.withFilter(n.ExtensionId,J):re=re.withFilter(n.ExtensionName,H);const{galleryExtensions:ie}=await this.queryGallery(re,S.CancellationToken.None),[ge]=ie;if(!ge||!ge.versions.length)return null;const ve=z(ge);if((0,P.isNotWebExtensionInWebTargetPlatform)(ve,W))return null;for(let de of ge.versions){if(!ce(de)){const Ee=await this.getEngine(de);de={...de,properties:[...de.properties||[],{key:E.Engine,value:Ee}]}}if(await this.isRawExtensionVersionCompatible(de,ve,W))return M(ge,de,ve,0,re)}return null}async isExtensionCompatible(F,W){if(!(0,P.isTargetPlatformCompatible)(F.properties.targetPlatform,F.allTargetPlatforms,W))return!1;let V=F.properties.engine;if(!V){const H=await this.getManifest(F,S.CancellationToken.None);if(!H)throw new Error("Manifest was not found");V=H.engines.vscode}return(0,I.isEngineValid)(V,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(F,W,V){if(!(0,P.isTargetPlatformCompatible)(ne(F),W,V))return!1;const H=await this.getEngine(F);return(0,I.isEngineValid)(H,this.productService.version,this.productService.date)}async query(F,W){const V=S.CancellationToken.isCancellationToken(F)?{}:F,H=S.CancellationToken.isCancellationToken(F)?F:W;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let J=V.text||"";const re=(0,R.getOrDefault)(V,Re=>Re.pageSize,50);let ie=new p().withFlags(i.IncludeLatestVersionOnly,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,re).withFilter(n.Target,"Microsoft.VisualStudio.Code");J?(J=J.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Re,pe,we)=>(ie=ie.withFilter(n.Category,we||pe),"")),J=J.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Re,pe,we)=>(ie=ie.withFilter(n.Tag,we||pe),"")),J=J.replace(/\bfeatured(\s+|\b|$)/g,()=>(ie=ie.withFilter(n.Featured),"")),J=J.trim(),J&&(J=J.length<200?J:J.substring(0,200),ie=ie.withFilter(n.SearchText,J)),ie=ie.withSortBy(0)):V.ids?ie=ie.withFilter(n.ExtensionId,...V.ids):V.names?ie=ie.withFilter(n.ExtensionName,...V.names):ie=ie.withSortBy(4),typeof V.sortBy=="number"&&(ie=ie.withSortBy(V.sortBy)),typeof V.sortOrder=="number"&&(ie=ie.withSortOrder(V.sortOrder));const{galleryExtensions:ge,total:ve}=await this.queryGallery(ie,H),de=ge.map((Re,pe)=>L(Re,pe,ie,V.source)),Ee=async(Re,pe)=>{if(pe.isCancellationRequested)throw(0,y.canceled)();const we=ie.withPage(Re+1),{galleryExtensions:ze}=await this.queryGallery(we,pe);return ze.map((We,Me)=>L(We,Me,we,V.source))};return{firstPage:de,total:ve,pageSize:ie.pageSize,getPage:Ee}}async queryGallery(F,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");F=F.withFlags(F.flags,i.ExcludeNonValidated).withFilter(n.ExcludeWithFlags,r(i.Unpublished));const V=await this.commonHeadersPromise,H=JSON.stringify(F.raw),J={...V,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},re=new Date().getTime();let ie,ge,ve=0;try{if(ie=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:H,headers:J},W),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:ve};const de=await(0,f.asJson)(ie);if(de){const Ee=de.results[0],Re=Ee.extensions,pe=Ee.resultMetadata&&Ee.resultMetadata.filter(we=>we.metadataType==="ResultCount")[0];return ve=pe&&pe.metadataItems.filter(we=>we.name==="TotalCount")[0].count||0,{galleryExtensions:Re,total:ve}}return{galleryExtensions:[],total:ve}}catch(de){throw ge=de,de}finally{this.telemetryService.publicLog2("galleryService:query",{...F.telemetryData,requestBodySize:String(H.length),duration:new Date().getTime()-re,success:!!ie&&(0,f.isSuccess)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:ge?(0,y.isPromiseCanceledError)(ge)?"canceled":(0,y.getErrorMessage)(ge).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(F,W,V,H){if(!this.isEnabled())return;const J=D.isWeb?this.api(`/itemName/${F}.${W}/version/${V}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${F}/extensions/${W}/${V}/stats?statType=${H}`),re=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.commonHeadersPromise,Accept:re};try{await this.requestService.request({type:"POST",url:J,headers:ge},S.CancellationToken.None)}catch(ve){}}async download(F,W,V){this.logService.trace("ExtensionGalleryService#download",F.identifier.id);const H=(0,d.getGalleryExtensionTelemetryData)(F),J=new Date().getTime(),re=de=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...H,duration:de}),ie=V===1?"install":V===2?"update":"",ge=ie?{uri:`${F.assets.download.uri}${c.URI.parse(F.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${F.assets.download.fallbackUri}${c.URI.parse(F.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:F.assets.download,ve=await this.getAsset(ge);await this.fileService.writeFile(W,ve.stream),re(new Date().getTime()-J)}async getReadme(F,W){if(F.assets.readme){const V=await this.getAsset(F.assets.readme,{},W);return await(0,f.asText)(V)||""}return""}async getManifest(F,W){if(F.assets.manifest){const V=await this.getAsset(F.assets.manifest,{},W),H=await(0,f.asText)(V);return H?JSON.parse(H):null}return null}async getManifestFromRawExtensionVersion(F,W){const V=se(F,a.Manifest);if(!V)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},J=await this.getAsset(V,{headers:H});return await(0,f.asJson)(J)}async getCoreTranslation(F,W){const V=F.assets.coreTranslations.filter(H=>H[0]===W.toUpperCase())[0];if(V){const H=await this.getAsset(V[1]),J=await(0,f.asText)(H);return J?JSON.parse(J):null}return null}async getChangelog(F,W){if(F.assets.changelog){const V=await this.getAsset(F.assets.changelog,{},W);return await(0,f.asText)(V)||""}return""}async getAllCompatibleVersions(F,W){let V=new p().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");F.identifier.uuid?V=V.withFilter(n.ExtensionId,F.identifier.uuid):V=V.withFilter(n.ExtensionName,F.identifier.id);const{galleryExtensions:H}=await this.queryGallery(V,S.CancellationToken.None);if(!H.length)return[];const J=z(H[0]);if((0,P.isNotWebExtensionInWebTargetPlatform)(J,W))return[];const re=[];for(const ie of H[0].versions)try{await this.isRawExtensionVersionCompatible(ie,J,W)&&re.push({version:ie.version,date:ie.lastUpdated})}catch(ge){}return re}async getAsset(F,W={},V=S.CancellationToken.None){const H=await this.commonHeadersPromise,J={type:"GET"},re={...H,...W.headers||{}};W={...W,...J,headers:re};const ie=F.uri,ge=F.fallbackUri,ve={...W,url:ie};try{const de=await this.requestService.request(ve,V);if(de.res.statusCode===200)return de;const Ee=await(0,f.asText)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${Ee}`)}catch(de){if((0,y.isPromiseCanceledError)(de))throw de;const Ee=(0,y.getErrorMessage)(de);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:Ee});const Re={...W,url:ge};return this.requestService.request(Re,V)}}async getEngine(F){let W=ce(F);if(!W){const V=await this.getManifestFromRawExtensionVersion(F,S.CancellationToken.None);if(!V)throw new Error("Manifest was not found");W=V.engines.vscode}return W}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const F=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},S.CancellationToken.None);if(F.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,f.asJson)(F),V=new Map;if(W)for(const H of W.malicious){const J=V.get(H)||{id:{id:H},malicious:!0,slow:!1};J.malicious=!0,V.set(H,J)}return[...V.values()]}};U=fe([ae(1,f.IRequestService),ae(2,u.ILogService),ae(3,v.IEnvironmentService),ae(4,o.ITelemetryService),ae(5,l.IFileService),ae(6,b.IProductService),ae(7,g.IConfigurationService)],U);let G=class extends U{constructor(F,W,V,H,J,re,ie,ge){super(F,W,V,H,J,re,ie,ge)}};G=fe([ae(0,h.IStorageService),ae(1,f.IRequestService),ae(2,u.ILogService),ae(3,v.IEnvironmentService),ae(4,o.ITelemetryService),ae(5,l.IFileService),ae(6,b.IProductService),ae(7,g.IConfigurationService)],G),t.ExtensionGalleryService=G;let B=class extends U{constructor(F,W,V,H,J,re,ie){super(void 0,F,W,V,H,J,re,ie)}};B=fe([ae(0,f.IRequestService),ae(1,u.ILogService),ae(2,v.IEnvironmentService),ae(3,o.ITelemetryService),ae(4,l.IFileService),ae(5,b.IProductService),ae(6,g.IConfigurationService)],B),t.ExtensionGalleryServiceWithNoStorageService=B;async function X(k,F,W,V,H,J){const re={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k}`},ie=await(0,m.getServiceMachineId)(W,H,J);return(0,s.getTelemetryLevel)(F,W)>=2&&(0,s.getTelemetryConfiguration)(V)==="on"&&(re["X-Market-User-Id"]=ie),re}t.resolveMarketplaceHeaders=X}),define(Q[119],ee([0,1,2,18,21,85,27,33,32,26,29,36]),function($,t,O,S,y,R,D,T,c,g,v,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let d=class{constructor(l,u){this._configurationService=u,this._experimentProperties={},this._disposables=new O.DisposableStore,this._cleanupPatterns=[],this._appender=l.appender,this._commonProperties=l.commonProperties||Promise.resolve({}),this._piiPaths=l.piiPaths||[],this._userOptIn=!0,this._errorOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!l.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let b of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,y.escapeRegExpCharacters)(b),"gi"));this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(b=>{const f=/^[a-f0-9]+$/i.test(b["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!f})})}setExperimentProperty(l,u){this._experimentProperties[l]=u}setEnabled(l){this._enabled=l}_updateUserOptIn(){const l=(0,P.getTelemetryConfiguration)(this._configurationService);this._errorOptIn=l!=="off",this._userOptIn=l==="on"}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const l=await this._commonProperties;let u=l.sessionID,b=l["common.instanceId"],f=l["common.machineId"],m=l["common.firstSessionDate"],h=l["common.msftInternal"];return{sessionId:u,instanceId:b,machineId:f,firstSessionDate:m,msftInternal:h}}dispose(){this._disposables.dispose()}publicLog(l,u,b){return this.isOptedIn?this._commonProperties.then(f=>{u=(0,S.mixin)(u,f),u=(0,S.mixin)(u,this._experimentProperties),u=(0,S.cloneAndChange)(u,m=>{if(typeof m=="string")return this._cleanupInfo(m,b)}),this._appender.log(l,u)},f=>{console.error(f)}):Promise.resolve(void 0)}publicLog2(l,u,b){return this.publicLog(l,u,b)}publicLogError(l,u){return!this.sendErrorTelemetry||!this._errorOptIn?Promise.resolve(void 0):this.publicLog(l,u,!0)}publicLogError2(l,u){return this.publicLogError(l,u)}_anonymizeFilePaths(l){let u=l;const b=[];for(let o of this._cleanupPatterns)for(;;){const s=o.exec(l);if(!s)break;b.push([s.index,o.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(u="";;){const o=m.exec(l);if(!o)break;!f.test(o[0])&&b.every(([s,e])=>o.index<s||o.index>=e)&&(u+=l.substring(h,o.index)+"<REDACTED: user-file-path>",h=m.lastIndex)}return h<l.length&&(u+=l.substr(h)),u}_removePropertiesWithPossibleUserInfo(l){if(!l)return l;const u=l.toLowerCase(),b=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(u)?"<REDACTED: secret>":b.test(u)?"<REDACTED: email>":l}_cleanupInfo(l,u){let b=l;u&&(b=this._anonymizeFilePaths(b));for(let f of this._cleanupPatterns)b=b.replace(f,"");return b=this._removePropertiesWithPossibleUserInfo(b),b}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=fe([ae(1,D.IConfigurationService)],d),t.TelemetryService=d,g.Registry.as(T.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(0,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["on","error","off"],enumDescriptions:[(0,R.localize)(1,null),(0,R.localize)(2,null),(0,R.localize)(3,null)],markdownDescription:c.default.privacyStatementUrl?(0,R.localize)(5,null,c.default.nameLong,c.default.privacyStatementUrl):(0,R.localize)(4,null,c.default.nameLong),default:"on",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),g.Registry.as(T.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(6,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,R.localize)(8,null,c.default.nameLong,c.default.privacyStatementUrl):(0,R.localize)(7,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(9,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[120],ee([0,1,9,18,36]),function($,t,O,S,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function R(T){const c=await new Promise((v,P)=>{$(["applicationinsights"],v,P)});let g;return c.defaultClient?(g=new c.TelemetryClient(T),g.channel.setUseDiskRetryCaching(!0)):(c.setup(T).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),g=c.defaultClient),T.indexOf("AIF-")===0&&(g.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),g}class D{constructor(c,g,v){this._eventPrefix=c,this._defaultData=g,this._defaultData||(this._defaultData=Object.create(null)),typeof v=="function"?this._aiClient=v():this._aiClient=v,this._asyncAIClient=null}_withAIClient(c){if(!!this._aiClient){if(typeof this._aiClient!="string"){c(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient)),this._asyncAIClient.then(g=>{c(g)},g=>{(0,O.onUnexpectedError)(g),console.error(g)})}}log(c,g){!this._aiClient||(g=(0,S.mixin)(g,this._defaultData),g=(0,y.validateTelemetryData)(g),this._withAIClient(v=>v.trackEvent({name:this._eventPrefix+"/"+c,properties:g.properties,measurements:g.measurements})))}flush(){return this._aiClient?new Promise(c=>{this._withAIClient(g=>{g.flush({callback:()=>{this._aiClient=void 0,c(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=D}),define(Q[121],ee([0,1,4,12]),function($,t,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function y(R,D){const T=Object.create(null),c=(v,P)=>{const d=JSON.parse(v);T[P]=d};if(D){const v=[],P=await S.Promises.readdir(D);for(const I of P)try{(await S.Promises.stat((0,O.join)(D,I))).isDirectory()&&v.push(I)}catch{}const d=[];for(const I of v)(await S.Promises.readdir((0,O.join)(D,I))).filter(u=>u==="telemetry.json").length===1&&d.push(I);for(const I of d){const l=(await S.Promises.readFile((0,O.join)(D,I,"telemetry.json"))).toString();c(l,I)}}let g=(await S.Promises.readFile((0,O.join)(R,"telemetry-core.json"))).toString();return c(g,"vscode-core"),g=(await S.Promises.readFile((0,O.join)(R,"telemetry-extensions.json"))).toString(),c(g,"vscode-extensions"),JSON.stringify(T,null,4)}t.buildTelemetryMessage=y}),define(Q[44],ee([0,1,48,3,4,10,12,72,132,133]),function($,t,O,S,y,R,D,T,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class v extends Error{constructor(e,i){let r=i.message;switch(e){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r);this.type=e,this.cause=i}}t.ExtractError=v;function P(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,r)=>i+r,e&61440)}function d(s){if(s instanceof v)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new v(e,s)}function I(s,e,i,r,n,a){const E=y.dirname(e),w=y.join(r,E);if(!w.startsWith(r))return Promise.reject(new Error(T.localize(0,null,e)));const A=y.join(r,e);let p;return a.onCancellationRequested(()=>{p&&p.destroy()}),Promise.resolve(D.Promises.mkdir(w,{recursive:!0})).then(()=>new Promise((C,N)=>{if(!a.isCancellationRequested)try{p=(0,O.createWriteStream)(A,{mode:i}),p.once("close",()=>C()),p.once("error",N),s.once("error",N),s.pipe(p)}catch(j){N(j)}}))}function l(s,e,i,r){let n=(0,S.createCancelablePromise)(()=>Promise.resolve()),a=0;return r.onCancellationRequested(()=>{n.cancel(),s.close()}),new Promise((E,w)=>{const A=new S.Sequencer,p=C=>{C.isCancellationRequested||(a++,s.readEntry())};s.once("error",w),s.once("close",()=>n.then(()=>{r.isCancellationRequested||s.entryCount===a?E():w(new v("Incomplete",new Error(T.localize(1,null,a,s.entryCount))))},w)),s.readEntry(),s.on("entry",C=>{if(r.isCancellationRequested)return;if(!i.sourcePathRegex.test(C.fileName)){p(r);return}const N=C.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(N)){const te=y.join(e,N);n=(0,S.createCancelablePromise)(se=>D.Promises.mkdir(te,{recursive:!0}).then(()=>p(se)).then(void 0,w));return}const j=b(s,C),Y=P(C);n=(0,S.createCancelablePromise)(te=>A.queue(()=>j.then(se=>I(se,N,Y,e,i,te).then(()=>p(te)))).then(null,w))})})}function u(s,e=!1){return new Promise((i,r)=>{(0,c.open)(s,e?{lazyEntries:!0}:void 0,(n,a)=>{n?r(d(n)):i((0,R.assertIsDefined)(a))})})}function b(s,e){return new Promise((i,r)=>{s.openReadStream(e,(n,a)=>{n?r(d(n)):i((0,R.assertIsDefined)(a))})})}function f(s,e){return new Promise((i,r)=>{const n=new g.ZipFile;e.forEach(E=>{E.contents?n.addBuffer(typeof E.contents=="string"?Buffer.from(E.contents,"utf8"):E.contents,E.path):E.localPath&&n.addFile(E.localPath,E.path)}),n.end();const a=(0,O.createWriteStream)(s);n.outputStream.pipe(a),n.outputStream.once("error",r),a.once("error",r),a.once("finish",()=>i(s))})}t.zip=f;function m(s,e,i={},r){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let a=u(s,!0);return i.overwrite&&(a=a.then(E=>D.Promises.rm(e).then(()=>E))),a.then(E=>l(E,e,{sourcePathRegex:n},r))}t.extract=m;function h(s,e){return u(s).then(i=>new Promise((r,n)=>{i.on("entry",a=>{a.fileName===e&&b(i,a).then(E=>r(E),E=>n(E))}),i.once("close",()=>n(new Error(T.localize(2,null,e))))}))}function o(s,e){return h(s,e).then(i=>new Promise((r,n)=>{const a=[];i.once("error",n),i.on("data",E=>a.push(E)),i.on("end",()=>r(Buffer.concat(a)))}))}t.buffer=o}),define(Q[122],ee([0,1,44,78]),function($,t,O,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function y(R){return(0,O.buffer)(R,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch(T){throw new Error((0,S.localize)(0,null))}})}t.getManifest=y}),define(Q[123],ee([0,1,22,3,9,2,8,4,11,19,41,7,31,12,44,79,20,23,24,90,16,14,42]),function($,t,O,S,y,R,D,T,c,g,v,P,d,I,l,u,b,f,m,h,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const i="scanningSystem",r="scanningUser",n="extracting",a="deleting",E="renaming";let w=class extends R.Disposable{constructor(p,C,N,j,Y){super();this.beforeRemovingExtension=p,this.fileService=C,this.logService=N,this.environmentService=j,this.productService=Y,this._devSystemExtensionsPath=null,this.systemExtensionsPath=j.builtinExtensionsPath,this.extensionsPath=j.extensionsPath,this.uninstalledPath=T.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new S.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(p){const C=[];(p===null||p===0)&&C.push(this.scanSystemExtensions().then(null,N=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(N).message,i)))),(p===null||p===1)&&C.push(this.scanUserExtensions(!0).then(null,N=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(N).message,r))));try{const N=await Promise.all(C);return(0,O.flatten)(N)}catch(N){throw this.joinErrors(N)}}async scanUserExtensions(p){this.logService.trace("Started scanning user extensions");let[C,N]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return N=N.filter(j=>!C[new m.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version).key()]),p&&(N=(0,m.groupByExtension)(N,Y=>Y.identifier).map(Y=>Y.sort((te,se)=>v.rcompare(te.manifest.version,se.manifest.version))[0])),this.logService.trace("Scanned user extensions:",N.length),N}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(p,C,N,j){const Y=p.key(),te=T.join(this.extensionsPath,`.${(0,d.generateUuid)()}`),se=T.join(this.extensionsPath,Y);try{await I.Promises.rm(se)}catch(ce){try{await I.Promises.rm(se)}catch(le){}throw new f.ExtensionManagementError((0,u.localize)(0,null,se,p.id),a)}await this.extractAtLocation(p,C,te,j);let Z=await this.scanExtension(P.URI.file(te),1);if(!Z)throw new Error((0,u.localize)(1,null,te));await this.storeMetadata(Z,{...N,installedTimestamp:Date.now()});try{await this.rename(p,te,se,Date.now()+2*60*1e3),this.logService.info("Renamed to",se)}catch(ce){try{await I.Promises.rm(te)}catch(le){}if(ce.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",p.id);else throw this.logService.info(`Rename failed because of ${(0,y.getErrorMessage)(ce)}. Deleted from extracted location`,te),ce}try{Z=await this.scanExtension(P.URI.file(se),1)}catch(ce){}if(Z)return Z;throw new Error((0,u.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(p,C){return this.setMetadata(p,C),await this.storeMetadata(p,{...C,installedTimestamp:p.installedTimestamp}),p}async storeMetadata(p,C){C.isMachineScoped=C.isMachineScoped||void 0,C.isBuiltin=C.isBuiltin||void 0,C.installedTimestamp=C.installedTimestamp||void 0;const N=T.join(p.location.fsPath,"package.json"),j=await I.Promises.readFile(N,"utf8"),{manifest:Y}=await this.parseManifest(j);return Y.__metadata=C,await I.Promises.writeFile(N,JSON.stringify(Y,null,"	")),p}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...p){const C=p.map(N=>new m.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version));await this.withUninstalledExtensions(N=>{C.forEach(j=>N[j.key()]=!0)})}async setInstalled(p){await this.withUninstalledExtensions(j=>delete j[p.key()]);const N=(await this.scanExtensions(1)).find(j=>new m.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version).equals(p))||null;return N?(await this.storeMetadata(N,{installedTimestamp:Date.now()}),this.scanExtension(N.location,1)):null}async withUninstalledExtensions(p){return this.uninstalledFileLimiter.queue(async()=>{let C;try{C=await I.Promises.readFile(this.uninstalledPath,"utf8")}catch(j){if(j.code!=="ENOENT")throw j}let N={};if(C)try{N=JSON.parse(C)}catch(j){}return p&&(p(N),Object.keys(N).length?await I.Promises.writeFile(this.uninstalledPath,JSON.stringify(N)):await I.Promises.rm(this.uninstalledPath)),N})}async removeExtension(p,C){this.logService.trace(`Deleting ${C} extension from disk`,p.identifier.id,p.location.fsPath),await I.Promises.rm(p.location.fsPath),this.logService.info("Deleted from disk",p.identifier.id,p.location.fsPath)}async removeUninstalledExtension(p){await this.removeExtension(p,"uninstalled"),await this.withUninstalledExtensions(C=>delete C[new m.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()])}async extractAtLocation(p,C,N,j){this.logService.trace(`Started extracting the extension from ${C} to ${N}`);try{await I.Promises.rm(N)}catch(Y){throw new f.ExtensionManagementError(this.joinErrors(Y).message,a)}try{await(0,l.extract)(C,N,{sourcePath:"extension",overwrite:!0},j),this.logService.info(`Extracted extension to ${N}:`,p.id)}catch(Y){try{await I.Promises.rm(N)}catch(te){}throw new f.ExtensionManagementError(Y.message,Y instanceof l.ExtractError&&Y.type?Y.type:n)}}async rename(p,C,N,j){try{await I.Promises.rename(C,N)}catch(Y){if(c.isWindows&&Y&&Y.code==="EPERM"&&Date.now()<j)return this.logService.info(`Failed renaming ${C} to ${N} with 'EPERM' error. Trying again...`,p.id),this.rename(p,C,N,j);throw new f.ExtensionManagementError(Y.message||(0,u.localize)(3,null,C,N),Y.code||E)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const p=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return p;const C=this.scanDevSystemExtensions(),[N,j]=await Promise.all([p,C]);return[...N,...j]}async scanExtensionsInDir(p,C){const N=new S.Limiter(10),j=await this.fileService.resolve(P.URI.file(p));return j.children?(await Promise.all(j.children.filter(te=>te.isDirectory).map(te=>N.queue(async()=>C===1&&(0,g.basename)(te.resource).indexOf(".")===0?null:this.scanExtension(te.resource,C))))).filter(te=>te&&te.identifier):[]}async scanExtension(p,C){try{const N=await this.fileService.resolve(p);if(N.children){const{manifest:j,metadata:Y}=await this.readManifest(p.fsPath),te=N.children.find(({name:le})=>/^readme(\.txt|\.md|)$/i.test(le))?.resource,se=N.children.find(({name:le})=>/^changelog(\.txt|\.md|)$/i.test(le))?.resource,Z={id:(0,m.getGalleryExtensionId)(j.publisher,j.name)},ce={type:C,identifier:Z,manifest:j,location:p,readmeUrl:te,changelogUrl:se,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:C===0};return Y&&(this.setMetadata(ce,Y),ce.installedTimestamp=Y.installedTimestamp),ce}}catch(N){C!==0&&this.logService.trace(N)}return null}async scanDefaultSystemExtensions(){const p=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",p.length),p}async scanDevSystemExtensions(){const p=this.getDevSystemExtensionsList();if(p.length){const C=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",C.length),C.filter(N=>p.some(j=>(0,m.areSameExtensions)(N.identifier,{id:j})))}else return[]}setMetadata(p,C){p.publisherDisplayName=C.publisherDisplayName||null,p.publisherId=C.publisherId||null,p.identifier.uuid=C.id,p.isMachineScoped=!!C.isMachineScoped,p.isBuiltin=p.type===0||!!C.isBuiltin}async removeUninstalledExtensions(){const p=await this.getUninstalledExtensions(),C=await this.scanAllUserExtensions(),N=new Set;for(const te of C)p[new m.ExtensionIdentifierWithVersion(te.identifier,te.manifest.version).key()]||N.add(te.identifier.id.toLowerCase());const j=(0,m.groupByExtension)(C,te=>te.identifier);await S.Promises.settled(j.map(async te=>{const se=te.sort((Z,ce)=>v.rcompare(Z.manifest.version,ce.manifest.version))[0];N.has(se.identifier.id.toLowerCase())||await this.beforeRemovingExtension(se)}));const Y=C.filter(te=>p[new m.ExtensionIdentifierWithVersion(te.identifier,te.manifest.version).key()]);await S.Promises.settled(Y.map(te=>this.removeUninstalledExtension(te)))}async removeOutdatedExtensions(){const p=await this.scanAllUserExtensions(),C=[],N=(0,m.groupByExtension)(p,j=>j.identifier);C.push(...(0,O.flatten)(N.map(j=>j.sort((Y,te)=>v.rcompare(Y.manifest.version,te.manifest.version)).slice(1)))),await S.Promises.settled(C.map(j=>this.removeExtension(j,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(p=>p.name)}joinErrors(p){const C=Array.isArray(p)?p:[p];return C.length===1?C[0]instanceof Error?C[0]:new Error(C[0]):C.reduce((N,j)=>new Error(`${N.message}${N.message?",":""}${j instanceof Error?j.message:j}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=T.normalize(T.join(D.FileAccess.asFileUri("",$).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(p){const C=[I.Promises.readFile(T.join(p,"package.json"),"utf8").then(te=>this.parseManifest(te)),I.Promises.readFile(T.join(p,"package.nls.json"),"utf8").then(void 0,te=>te.code!=="ENOENT"?Promise.reject(te):"{}").then(te=>JSON.parse(te))],[{manifest:N,metadata:j},Y]=await Promise.all(C);return{manifest:(0,h.localizeManifest)(N,Y),metadata:j}}parseManifest(p){return new Promise((C,N)=>{try{const j=JSON.parse(p),Y=j.__metadata||null;C({manifest:j,metadata:Y})}catch(j){N(new Error((0,u.localize)(4,null)))}})}};w=fe([ae(1,o.IFileService),ae(2,s.ILogService),ae(3,b.INativeEnvironmentService),ae(4,e.IProductService)],w),t.ExtensionsScanner=w}),define(Q[124],ee([0,1,30,9,8,4,11,28,19,41,7,31,12,44,77,53,20,117,23,24,101,102,122,97,123,103,51,16,15,14,32,29]),function($,t,O,S,y,R,D,T,c,g,v,P,d,I,l,u,b,f,m,h,o,s,e,i,r,n,a,E,w,A,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const N="unsetUninstalled",j="downloading";let Y=class extends f.AbstractExtensionManagementService{constructor(_,ne,z,L,M,U,G){super(_,ne,z);this.environmentService=L,this.downloadService=M,this.fileService=G;const B=this._register(U.createInstance(s.ExtensionsLifecycle));this.extensionsScanner=this._register(U.createInstance(r.ExtensionsScanner,k=>B.postUninstall(k))),this.manifestCache=this._register(new i.ExtensionsManifestCache(L,this)),this.extensionsDownloader=this._register(U.createInstance(o.ExtensionsDownloader));const X=this._register(new n.ExtensionsWatcher(this,G,L,z));this._register(X.onDidChangeExtensionsByAnotherSource(({added:k,removed:F})=>{k.length&&this._onDidInstallExtensions.fire(k.map(W=>({identifier:W.identifier,operation:0,local:W}))),F.forEach(W=>this._onDidUninstallExtension.fire({identifier:W}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const _=await this.isAlpineLinux(),ne=(0,m.getTargetPlatform)(_?"alpine":D.platform,T.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",ne),ne})()),this._targetPlatformPromise}async isAlpineLinux(){if(!D.isLinux)return!1;let _;try{_=(await this.fileService.readFile(v.URI.file("/etc/os-release"))).value.toString()}catch(ne){try{_=(await this.fileService.readFile(v.URI.file("/usr/lib/os-release"))).value.toString()}catch(z){this.logService.debug("Error while getting the os-release file.",(0,S.getErrorMessage)(z))}}return!!_&&(_.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(_){this.logService.trace("ExtensionManagementService#zip",_.identifier.id);const ne=await this.collectFiles(_),z=await(0,I.zip)((0,c.joinPath)(this.environmentService.tmpDir,(0,P.generateUuid)()).fsPath,ne);return v.URI.file(z)}async unzip(_){return this.logService.trace("ExtensionManagementService#unzip",_.toString()),(await this.install(_)).identifier}async getManifest(_){const ne=await this.downloadVsix(_),z=R.resolve(ne.fsPath);return(0,e.getManifest)(z)}getInstalled(_=null){return this.extensionsScanner.scanExtensions(_)}async install(_,ne={}){this.logService.trace("ExtensionManagementService#install",_.toString());const z=await this.downloadVsix(_),L=await(0,e.getManifest)(R.resolve(z.fsPath));if(L.engines&&L.engines.vscode&&!(0,a.isEngineValid)(L.engines.vscode,p.default.version,p.default.date))throw new Error(l.localize(0,null,(0,h.getGalleryExtensionId)(L.publisher,L.name),p.default.version));return this.installExtension(L,z,ne)}async updateMetadata(_,ne){return this.logService.trace("ExtensionManagementService#updateMetadata",_.identifier.id),_=await this.extensionsScanner.saveMetadataForLocalExtension(_,{..._.manifest.__metadata||{},...ne}),this.manifestCache.invalidate(),_}async updateExtensionScope(_,ne){return this.logService.trace("ExtensionManagementService#updateExtensionScope",_.identifier.id),_=await this.extensionsScanner.saveMetadataForLocalExtension(_,{..._.manifest.__metadata||{},isMachineScoped:ne}),this.manifestCache.invalidate(),_}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(_){if(_.scheme===y.Schemas.file)return _;const ne=(0,c.joinPath)(this.environmentService.tmpDir,(0,P.generateUuid)());return await this.downloadService.download(_,ne),ne}createInstallExtensionTask(_,ne,z){return v.URI.isUri(ne)?new Z(_,ne,z,this.galleryService,this.extensionsScanner,this.logService):new se(ne,z,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(_,ne){return new ce(_,ne,this.extensionsScanner)}async collectFiles(_){const ne=async L=>{let M=await d.Promises.readdir(L);M=M.map(B=>R.join(L,B));const U=await Promise.all(M.map(B=>d.Promises.stat(B)));let G=Promise.resolve([]);return U.forEach((B,X)=>{const k=M[X];B.isFile()&&(G=G.then(F=>[...F,k])),B.isDirectory()&&(G=G.then(F=>ne(k).then(W=>[...F,...W])))}),G};return(await ne(_.location.fsPath)).map(L=>({path:`extension/${R.relative(_.location.fsPath,L)}`,localPath:L}))}};Y=fe([ae(0,m.IExtensionGalleryService),ae(1,C.ITelemetryService),ae(2,A.ILogService),ae(3,b.INativeEnvironmentService),ae(4,u.IDownloadService),ae(5,w.IInstantiationService),ae(6,E.IFileService)],Y),t.ExtensionManagementService=Y;class te extends f.AbstractExtensionTask{constructor(_,ne,z,L){super();this.identifier=_,this.source=ne,this.extensionsScanner=z,this.logService=L,this._operation=1}get operation(){return this._operation}async installExtension(_,ne){try{const z=await this.unsetUninstalledAndGetLocal(_.identifierWithVersion);if(z)return _.metadata?this.extensionsScanner.saveMetadataForLocalExtension(z,_.metadata):z}catch(z){throw D.isMacintosh?new m.ExtensionManagementError(l.localize(1,null),N):new m.ExtensionManagementError(l.localize(2,null),N)}return this.extract(_,ne)}async unsetUninstalledAndGetLocal(_){if(!await this.isUninstalled(_))return null;this.logService.trace("Removing the extension from uninstalled list:",_.id);const z=await this.extensionsScanner.setInstalled(_);return this.logService.info("Removed the extension from uninstalled list:",_.id),z}async isUninstalled(_){return!!(await this.extensionsScanner.getUninstalledExtensions())[_.key()]}async extract({zipPath:_,identifierWithVersion:ne,metadata:z},L){let M=await this.extensionsScanner.extractUserExtension(ne,_,z,L);return this.logService.info("Extracting completed.",ne.id),M}}class se extends te{constructor(_,ne,z,L,M){super(_.identifier,_,L,M);this.gallery=_,this.options=ne,this.extensionsDownloader=z}async doRun(_){const z=(await this.extensionsScanner.scanExtensions(null)).find(U=>(0,h.areSameExtensions)(U.identifier,this.gallery.identifier));z&&(this._operation=2);const L=await this.downloadInstallableExtension(this.gallery,this._operation);L.metadata.isMachineScoped=this.options.isMachineScoped||z?.isMachineScoped,L.metadata.isBuiltin=this.options.isBuiltin||z?.isBuiltin;const M=await this.installExtension(L,_);z&&g.neq(z.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(z);try{await this.extensionsDownloader.delete(v.URI.file(L.zipPath))}catch(U){}return M}async downloadInstallableExtension(_,ne){const z={id:_.identifier.uuid,publisherId:_.publisherId,publisherDisplayName:_.publisherDisplayName};let L;try{this.logService.trace("Started downloading extension:",_.identifier.id),L=(await this.extensionsDownloader.downloadExtension(_,ne)).fsPath,this.logService.info("Downloaded extension:",_.identifier.id,L)}catch(M){throw new m.ExtensionManagementError((0,f.joinErrors)(M).message,j)}try{const M=await(0,e.getManifest)(L);return{zipPath:L,identifierWithVersion:new h.ExtensionIdentifierWithVersion(_.identifier,M.version),metadata:z}}catch(M){throw new m.ExtensionManagementError((0,f.joinErrors)(M).message,f.INSTALL_ERROR_VALIDATING)}}}class Z extends te{constructor(_,ne,z,L,M,U){super({id:(0,h.getGalleryExtensionId)(_.publisher,_.name)},ne,M,U);this.manifest=_,this.location=ne,this.options=z,this.galleryService=L}async doRun(_){const ne=new h.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),L=(await this.extensionsScanner.scanExtensions(1)).find(U=>(0,h.areSameExtensions)(this.identifier,U.identifier)),M=await this.getMetadata(this.identifier.id,_);if(M.isMachineScoped=this.options.isMachineScoped||L?.isMachineScoped,M.isBuiltin=this.options.isBuiltin||L?.isBuiltin,L)if(this._operation=2,ne.equals(new h.ExtensionIdentifierWithVersion(L.identifier,L.manifest.version)))try{await this.extensionsScanner.removeExtension(L,"existing")}catch(U){throw new Error(l.localize(3,null,this.manifest.displayName||this.manifest.name))}else g.gt(L.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(L);else{const U=await this.unsetUninstalledAndGetLocal(ne);if(U)try{await this.extensionsScanner.removeExtension(U,"existing")}catch(G){throw new Error(l.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:R.resolve(this.location.fsPath),identifierWithVersion:ne,metadata:M},_)}async getMetadata(_,ne){try{const z=(await this.galleryService.query({names:[_],pageSize:1},ne)).firstPage[0];if(z)return{id:z.identifier.uuid,publisherDisplayName:z.publisherDisplayName,publisherId:z.publisherId}}catch(z){}return{}}}class ce extends f.AbstractExtensionTask{constructor(_,ne,z){super();this.extension=_,this.options=ne,this.extensionsScanner=z}async doRun(_){const ne=[],z=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const L=new h.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);ne.push(...z.filter(M=>L.equals(new h.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version))))}else ne.push(...z.filter(L=>(0,h.areSameExtensions)(L.identifier,this.extension.identifier)));if(!ne.length)throw new Error(l.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...ne),this.options.remove)for(const L of ne)try{_.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(L)}catch(M){throw new Error(l.localize(6,null,(0,O.toErrorMessage)(M)))}}}}),define(Q[125],ee([0,1,113,17,9,2,10,27,20,98,14,112,134]),function($,t,O,S,y,R,D,T,c,g,v,P,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let I=class extends R.Disposable{constructor(u,b,f){super();this.environmentService=b,this.logService=f,this.configure(u.getValue()),this._register(u.onDidChangeConfiguration(()=>this.configure(u.getValue()),this))}configure(u){this.proxyUrl=u.http&&u.http.proxy,this.strictSSL=!!(u.http&&u.http.proxyStrictSSL),this.authorization=u.http&&u.http.proxyAuthorization}async request(u,b){this.logService.trace("RequestService#request",u.url);const{proxyUrl:f,strictSSL:m}=this,h={...process.env,...await(0,g.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},o=u.agent?u.agent:await(0,P.getProxyAgent)(u.url||"",h,{proxyUrl:f,strictSSL:m});return u.agent=o,u.strictSSL=m,this.authorization&&(u.headers={...u.headers||{},"Proxy-Authorization":this.authorization}),this._request(u,b)}async getNodeRequest(u){return((0,O.parse)(u.url).protocol==="https:"?await new Promise((m,h)=>{$(["https"],m,h)}):await new Promise((m,h)=>{$(["http"],m,h)})).request}_request(u,b){return new Promise(async(f,m)=>{let h;const o=(0,O.parse)(u.url),s=u.getRawRequest?u.getRawRequest(u):await this.getNodeRequest(u),e={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,D.isBoolean)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(e.auth=u.user+":"+u.password),h=s(e,i=>{const r=(0,D.isNumber)(u.followRedirects)?u.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&r>0&&i.headers.location)this._request({...u,url:i.headers.location,followRedirects:r-1},b).then(f,m);else{let n=i;i.headers["content-encoding"]==="gzip"&&(n=i.pipe((0,d.createGunzip)())),f({res:i,stream:(0,S.streamToBufferReadableStream)(n)})}}),h.on("error",m),u.timeout&&h.setTimeout(u.timeout),u.data&&typeof u.data=="string"&&h.write(u.data),h.end(),b.onCancellationRequested(()=>{h.abort(),m((0,y.canceled)())})})}async resolveProxy(u){}};I=fe([ae(0,T.IConfigurationService),ae(1,c.INativeEnvironmentService),ae(2,v.ILogService)],I),t.RequestService=I}),define(Q[135],ee([0,1,48,136,34,3,17,30,9,2,8,4,28,7,12,27,110,53,111,20,89,118,23,96,124,16,106,107,52,100,55,56,104,14,105,32,42,43,125,116,29,119,36,120,121]),function($,t,O,S,y,R,D,T,c,g,v,P,d,I,l,u,b,f,m,h,o,s,e,i,r,n,a,E,w,A,p,C,N,j,Y,te,se,Z,ce,le,_,ne,z,L,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class U extends g.Disposable{constructor(X){super();this.argv=X,(0,S.gracefulify)(O),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[X,k]=await this.initServices();return X.invokeFunction(async F=>{const W=F.get(j.ILogService),V=F.get(n.IFileService),H=F.get(h.INativeEnvironmentService),J=F.get(e.IExtensionManagementCLIService);return W.info("CLI main",this.argv),this.registerErrorHandler(W),await this.doRun(H,J,V),(0,R.raceTimeout)((0,z.combinedAppender)(...k).flush(),1e3)})}async initServices(){const X=new p.ServiceCollection,k={_serviceBrand:void 0,...te.default};X.set(se.IProductService,k);const F=new o.NativeEnvironmentService(this.argv,k);X.set(h.INativeEnvironmentService,F),await Promise.all([F.appSettingsHome.fsPath,F.extensionsPath].map(ve=>ve?l.Promises.mkdir(ve,{recursive:!0}):void 0));const W=(0,j.getLogLevel)(F),V=[];V.push(new Y.SpdLogLogger("cli",(0,P.join)(F.logsPath,"cli.log"),!0,W)),W===j.LogLevel.Trace&&V.push(new j.ConsoleLogger(W));const H=this._register(new j.MultiplexLogService(V));X.set(j.ILogService,H);const J=this._register(new a.FileService(H));X.set(n.IFileService,J);const re=this._register(new E.DiskFileSystemProvider(H));J.registerProvider(v.Schemas.file,re);const ie=this._register(new b.ConfigurationService(F.settingsResource,J));X.set(u.IConfigurationService,ie),await ie.initialize(),X.set(Z.IRequestService,new w.SyncDescriptor(ce.RequestService)),X.set(f.IDownloadService,new w.SyncDescriptor(m.DownloadService)),X.set(e.IExtensionManagementService,new w.SyncDescriptor(r.ExtensionManagementService)),X.set(e.IExtensionGalleryService,new w.SyncDescriptor(s.ExtensionGalleryServiceWithNoStorageService)),X.set(e.IExtensionManagementCLIService,new w.SyncDescriptor(i.ExtensionManagementCLIService)),X.set(C.ILocalizationsService,new w.SyncDescriptor(N.LocalizationsService));const ge=[];if((0,z.getTelemetryLevel)(k,F)>=2){k.aiConfig&&k.aiConfig.asimovKey&&ge.push(new L.AppInsightsAppender("monacoworkbench",null,k.aiConfig.asimovKey));const{appRoot:ve,extensionsPath:de,installSourcePath:Ee}=F,Re={appender:(0,z.combinedAppender)(...ge),sendErrorTelemetry:!1,commonProperties:(async()=>{let pe;try{const we=await l.Promises.readFile((0,P.join)(F.userDataPath,"storage.json"));pe=JSON.parse(we.toString())[_.machineIdKey]}catch(we){we.code!=="ENOENT"&&H.error(we)}return(0,le.resolveCommonProperties)(J,(0,y.release)(),(0,y.hostname)(),process.arch,k.commit,k.version,pe,k.msftInternalDomains,Ee)})(),piiPaths:[ve,de]};X.set(_.ITelemetryService,new w.SyncDescriptor(ne.TelemetryService,[Re]))}else X.set(_.ITelemetryService,z.NullTelemetryService);return[new A.InstantiationService(X),ge]}registerErrorHandler(X){(0,c.setUnexpectedErrorHandler)(k=>{const F=(0,T.toErrorMessage)(k,!0);!F||X.error(`[uncaught exception in CLI]: ${F}`)}),process.on("uncaughtException",k=>(0,c.onUnexpectedError)(k)),process.on("unhandledRejection",k=>(0,c.onUnexpectedError)(k))}async doRun(X,k,F){if(this.argv["install-source"])return this.setInstallSource(X,F,this.argv["install-source"]);if(this.argv["list-extensions"])return k.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return k.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return k.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return k.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(X.appRoot,X.extensionsPath))}asExtensionIdOrVSIX(X){return X.map(k=>/\.vsix$/i.test(k)?I.URI.file((0,P.isAbsolute)(k)?k:(0,P.join)((0,d.cwd)(),k)):k)}async setInstallSource(X,k,F){await k.writeFile(I.URI.file(X.installSourcePath),D.VSBuffer.fromString(F.slice(0,30)))}}async function G(B){const X=new U(B);try{await X.run()}finally{X.dispose()}}t.main=G})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0c83ca1ced83259971d80890d93abbe19cbfc992/core/vs/code/node/cliProcessMain.js.map
