/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/map","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/hash","vs/base/common/severity","fs","vs/editor/common/core/position","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/skipList","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","path","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(J){for(var e=[],m=0,L=J.length;m<L;m++)e[m]=me[J[m]];return e};define(me[56],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(L,k){if(!L)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=m}),define(me[57],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const m=Object.prototype.hasOwnProperty;function L(n){const P=[];for(let c in n)m.call(n,c)&&P.push(n[c]);return P}e.values=L;function k(n,P){for(let c in n)if(m.call(n,c)&&P({key:c,value:n[c]},function(){delete n[c]})===!1)return}e.forEach=k;function C(n,P){const c=Object.create(null);for(const h of n){const d=P(h);let g=c[d];g||(g=c[d]=[]),g.push(h)}return c}e.groupBy=C;function R(n){const P=Object.create(null);return n&&n.forEach((c,h)=>{P[h]=c}),P}e.fromMap=R;function E(n,P){const c=[],h=[];for(let d of n)P.has(d)||c.push(d);for(let d of P)n.has(d)||h.push(d);return{removed:c,added:h}}e.diffSets=E;function S(n,P){const c=[],h=[];for(let[d,g]of n)P.has(d)||c.push(g);for(let[d,g]of P)n.has(d)||h.push(g);return{removed:c,added:h}}e.diffMaps=S;class A{constructor(){this.map=new Map}add(P,c){let h=this.map.get(P);h||(h=new Set,this.map.set(P,h)),h.add(c)}delete(P,c){const h=this.map.get(P);!h||(h.delete(c),h.size===0&&this.map.delete(P))}forEach(P,c){const h=this.map.get(P);!h||h.forEach(c)}}e.SetMap=A}),define(me[58],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(R){return(E,S,A)=>{let n=null,P=null;if(typeof A.value=="function"?(n="value",P=A.value):typeof A.get=="function"&&(n="get",P=A.get),!P)throw new Error("not supported");A[n]=R(P,S)}}e.createDecorator=m;function L(R,E,S){let A=null,n=null;if(typeof S.value=="function"?(A="value",n=S.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(A="get",n=S.get),!n)throw new Error("not supported");const P=`$memoize$${E}`;S[A]=function(...c){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,c)}),this[P]}}e.memoize=L;function k(R,E,S){return m((A,n)=>{const P=`$debounce$${n}`,c=`$debounce$result$${n}`;return function(...h){this[c]||(this[c]=S?S():void 0),clearTimeout(this[P]),E&&(this[c]=E(this[c],...h),h=[this[c]]),this[P]=setTimeout(()=>{A.apply(this,h),this[c]=S?S():void 0},R)}})}e.debounce=k;function C(R,E,S){return m((A,n)=>{const P=`$throttle$timer$${n}`,c=`$throttle$result$${n}`,h=`$throttle$lastRun$${n}`,d=`$throttle$pending$${n}`;return function(...g){if(this[c]||(this[c]=S?S():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),E&&(this[c]=E(this[c],...g)),this[d])return;const y=this[h]+R;y<=Date.now()?(this[h]=Date.now(),A.apply(this,[this[c]]),this[c]=S?S():void 0):(this[d]=!0,this[P]=setTimeout(()=>{this[d]=!1,this[h]=Date.now(),A.apply(this,[this[c]]),this[c]=S?S():void 0},y-Date.now()))}})}e.throttle=C}),define(me[16],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(a=>{a(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=m,e.errorHandler=new m;function L(p){e.errorHandler.setUnexpectedErrorHandler(p)}e.setUnexpectedErrorHandler=L;function k(p){S(p)||e.errorHandler.onUnexpectedError(p)}e.onUnexpectedError=k;function C(p){S(p)||e.errorHandler.onUnexpectedExternalError(p)}e.onUnexpectedExternalError=C;function R(p){if(p instanceof Error){let{name:t,message:a}=p;const r=p.stacktrace||p.stack;return{$isError:!0,name:t,message:a,stack:r}}return p}e.transformErrorForSerialization=R;const E="Canceled";function S(p){return p instanceof Error&&p.name===E&&p.message===E}e.isPromiseCanceledError=S;class A extends Error{constructor(){super(E);this.name=this.message}}e.CancellationError=A;function n(){const p=new Error(E);return p.name=p.message,p}e.canceled=n;function P(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}e.illegalArgument=P;function c(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}e.illegalState=c;function h(p){return p?new Error(`readonly property '${p} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function d(p){const t=new Error(`${p} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function g(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}e.getErrorMessage=g;class y extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=y;class I extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=I;class _ extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=_;function s(p){const t=p;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=s;function o(p,t=Object.create(null)){const a=new Error(p);return t.actions&&(a.actions=t.actions),a}e.createErrorWithActions=o}),define(me[17],ge([0,1,16]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(W,Q=0){return W[W.length-(1+Q)]}e.tail=L;function k(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=k;function C(W,Q,Y=(he,_e)=>he===_e){if(W===Q)return!0;if(!W||!Q||W.length!==Q.length)return!1;for(let he=0,_e=W.length;he<_e;he++)if(!Y(W[he],Q[he]))return!1;return!0}e.equals=C;function R(W,Q,Y){let he=0,_e=W.length-1;for(;he<=_e;){const Se=(he+_e)/2|0,Re=Y(W[Se],Q);if(Re<0)he=Se+1;else if(Re>0)_e=Se-1;else return Se}return-(he+1)}e.binarySearch=R;function E(W,Q){let Y=0,he=W.length;if(he===0)return 0;for(;Y<he;){const _e=Math.floor((Y+he)/2);Q(W[_e])?he=_e:Y=_e+1}return Y}e.findFirstInSorted=E;function S(W,Q,Y){if(W=W|0,W>=Q.length)throw new TypeError("invalid index");let he=Q[Math.floor(Q.length*Math.random())],_e=[],Se=[],Re=[];for(let xe of Q){const Ue=Y(xe,he);Ue<0?_e.push(xe):Ue>0?Se.push(xe):Re.push(xe)}return W<_e.length?S(W,_e,Y):W<_e.length+Re.length?Re[0]:S(W-(_e.length+Re.length),Se,Y)}e.quickSelect=S;function A(W,Q){const Y=[];let he;for(const _e of W.slice(0).sort(Q))!he||Q(he[0],_e)!==0?(he=[_e],Y.push(he)):he.push(_e);return Y}e.groupBy=A;function n(W,Q,Y){const he=[];function _e(xe,Ue,je){if(Ue===0&&je.length===0)return;const V=he[he.length-1];V&&V.start+V.deleteCount===xe?(V.deleteCount+=Ue,V.toInsert.push(...je)):he.push({start:xe,deleteCount:Ue,toInsert:je})}let Se=0,Re=0;for(;;){if(Se===W.length){_e(Se,0,Q.slice(Re));break}if(Re===Q.length){_e(Se,W.length-Se,[]);break}const xe=W[Se],Ue=Q[Re],je=Y(xe,Ue);je===0?(Se+=1,Re+=1):je<0?(_e(Se,1,[]),Se+=1):je>0&&(_e(Se,0,[Ue]),Re+=1)}return he}e.sortedDiff=n;function P(W,Q,Y){const he=n(W,Q,Y),_e=[],Se=[];for(const Re of he)_e.push(...W.slice(Re.start,Re.start+Re.deleteCount)),Se.push(...Re.toInsert);return{removed:_e,added:Se}}e.delta=P;function c(W,Q,Y){if(Y===0)return[];const he=W.slice(0,Y).sort(Q);return d(W,Q,he,Y,W.length),he}e.top=c;function h(W,Q,Y,he,_e){return Y===0?Promise.resolve([]):new Promise((Se,Re)=>{(async()=>{const xe=W.length,Ue=W.slice(0,Y).sort(Q);for(let je=Y,V=Math.min(Y+he,xe);je<xe;je=V,V=Math.min(V+he,xe)){if(je>Y&&await new Promise(ee=>setTimeout(ee)),_e&&_e.isCancellationRequested)throw(0,m.canceled)();d(W,Q,Ue,je,V)}return Ue})().then(Se,Re)})}e.topAsync=h;function d(W,Q,Y,he,_e){for(const Se=Y.length;he<_e;he++){const Re=W[he];if(Q(Re,Y[Se-1])<0){Y.pop();const xe=E(Y,Ue=>Q(Re,Ue)<0);Y.splice(xe,0,Re)}}}function g(W){return W.filter(Q=>!!Q)}e.coalesce=g;function y(W){let Q=0;for(let Y=0;Y<W.length;Y++)W[Y]&&(W[Q]=W[Y],Q+=1);W.length=Q}e.coalesceInPlace=y;function I(W,Q,Y){W.splice(Y,0,W.splice(Q,1)[0])}e.move=I;function _(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=_;function s(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=s;function o(W,Q){if(!Q)return W.filter((he,_e)=>W.indexOf(he)===_e);const Y=Object.create(null);return W.filter(he=>{const _e=Q(he);return Y[_e]?!1:(Y[_e]=!0,!0)})}e.distinct=o;function p(W){const Q=new Set;return W.filter(Y=>Q.has(Y)?!1:(Q.add(Y),!0))}e.distinctES6=p;function t(W){const Q=Object.create(null);return Y=>{const he=W(Y);return Q[he]?!1:(Q[he]=!0,!0)}}e.uniqueFilter=t;function a(W,Q){for(let Y=W.length-1;Y>=0;Y--){const he=W[Y];if(Q(he))return Y}return-1}e.lastIndex=a;function r(W,Q){return W.length>0?W[0]:Q}e.firstOrDefault=r;function i(W,Q,Y=(he,_e)=>he===_e){let he=0;for(let _e=0,Se=Math.min(W.length,Q.length);_e<Se&&Y(W[_e],Q[_e]);_e++)he++;return he}e.commonPrefixLength=i;function l(W){return[].concat(...W)}e.flatten=l;function u(W,Q){let Y=typeof Q=="number"?W:0;typeof Q=="number"?Y=W:(Y=0,Q=W);const he=[];if(Y<=Q)for(let _e=Y;_e<Q;_e++)he.push(_e);else for(let _e=Y;_e>Q;_e--)he.push(_e);return he}e.range=u;function f(W,Q,Y){return W.reduce((he,_e)=>(he[Q(_e)]=Y?Y(_e):_e,he),Object.create(null))}e.index=f;function b(W,Q){return W.push(Q),()=>D(W,Q)}e.insert=b;function D(W,Q){const Y=W.indexOf(Q);if(Y>-1)return W.splice(Y,1),Q}e.remove=D;function w(W,Q,Y){const he=W.slice(0,Q),_e=W.slice(Q);return he.concat(Y,_e)}e.arrayInsert=w;function T(W,Q){let Y;if(typeof Q=="number"){let he=Q;Y=()=>{const _e=Math.sin(he++)*179426549;return _e-Math.floor(_e)}}else Y=Math.random;for(let he=W.length-1;he>0;he-=1){const _e=Math.floor(Y()*(he+1)),Se=W[he];W[he]=W[_e],W[_e]=Se}}e.shuffle=T;function v(W,Q){const Y=W.indexOf(Q);Y>-1&&(W.splice(Y,1),W.unshift(Q))}e.pushToStart=v;function F(W,Q){const Y=W.indexOf(Q);Y>-1&&(W.splice(Y,1),W.push(Q))}e.pushToEnd=F;function M(W,Q){return Array.isArray(W)?W.map(Q):Q(W)}e.mapArrayOrNot=M;function G(W){return Array.isArray(W)?W:[W]}e.asArray=G;function K(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=K;function U(W,Q){for(const Y of W){const he=Q(Y);if(he!==void 0)return he}}e.mapFind=U;function z(W,Q,Y){const he=x(W,Q),_e=W.length,Se=Y.length;W.length=_e+Se;for(let Re=_e-1;Re>=he;Re--)W[Re+Se]=W[Re];for(let Re=0;Re<Se;Re++)W[Re+he]=Y[Re]}e.insertInto=z;function N(W,Q,Y,he){const _e=x(W,Q),Se=W.splice(_e,Y);return z(W,_e,he),Se}e.splice=N;function x(W,Q){return Q<0?Math.max(Q+W.length,0):Math.min(Q,W.length)}function B(W,Q){let Y=Number.MAX_SAFE_INTEGER,he=0;return W.forEach((_e,Se)=>{const Re=Q(_e);Re<Y&&(Y=Re,he=Se)}),he}e.minIndex=B;function O(W,Q){let Y=Number.MIN_SAFE_INTEGER,he=0;return W.forEach((_e,Se)=>{const Re=Q(_e);Re>Y&&(Y=Re,he=Se)}),he}e.maxIndex=O;class H{constructor(Q){this.items=Q,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Q){let Y=this.firstIdx;for(;Y<this.items.length&&Q(this.items[Y]);)Y++;const he=Y===this.firstIdx?null:this.items.slice(this.firstIdx,Y);return this.firstIdx=Y,he}takeFromEndWhile(Q){let Y=this.lastIdx;for(;Y>=0&&Q(this.items[Y]);)Y--;const he=Y===this.lastIdx?null:this.items.slice(Y+1,this.lastIdx+1);return this.lastIdx=Y,he}}e.ArrayQueue=H}),define(me[75],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(L){const k=this;let C=!1,R;return function(){return C||(C=!0,R=L.apply(k,arguments)),R}}e.once=m}),define(me[76],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class m{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=m,e.defaultGenerator=new m("id#")}),define(me[94],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(L){function k(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}L.is=k;const C=Object.freeze([]);function R(){return C}L.empty=R;function*E(p){yield p}L.single=E;function S(p){return p||C}L.from=S;function A(p){return!p||p[Symbol.iterator]().next().done===!0}L.isEmpty=A;function n(p){return p[Symbol.iterator]().next().value}L.first=n;function P(p,t){for(const a of p)if(t(a))return!0;return!1}L.some=P;function c(p,t){for(const a of p)if(t(a))return a}L.find=c;function*h(p,t){for(const a of p)t(a)&&(yield a)}L.filter=h;function*d(p,t){let a=0;for(const r of p)yield t(r,a++)}L.map=d;function*g(...p){for(const t of p)for(const a of t)yield a}L.concat=g;function*y(p){for(const t of p)for(const a of t)yield a}L.concatNested=y;function I(p,t,a){let r=a;for(const i of p)r=t(r,i);return r}L.reduce=I;function*_(p,t,a=p.length){for(t<0&&(t+=p.length),a<0?a+=p.length:a>p.length&&(a=p.length);t<a;t++)yield p[t]}L.slice=_;function s(p,t=Number.POSITIVE_INFINITY){const a=[];if(t===0)return[a,p];const r=p[Symbol.iterator]();for(let i=0;i<t;i++){const l=r.next();if(l.done)return[a,L.empty()];a.push(l.value)}return[a,{[Symbol.iterator](){return r}}]}L.consume=s;function o(p,t,a=(r,i)=>r===i){const r=p[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const l=r.next(),u=i.next();if(l.done!==u.done)return!1;if(l.done)return!0;if(!a(l.value,u.value))return!1}}L.equals=o})(m=e.Iterable||(e.Iterable={}))}),define(me[59],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(t){t.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function R(t,a=!1){let r=0,i=t.length,l="",u=0,f=16,b=0;function D(K){let U=0,z=0;for(;U<K;){const N=t.charCodeAt(r);if(N>=48&&N<=57)z=z*16+N-48;else if(N>=65&&N<=70)z=z*16+N-65+10;else if(N>=97&&N<=102)z=z*16+N-97+10;else break;r++,U++}return U<K&&(z=-1),z}function w(K){r=K,l="",u=0,f=16,b=0}function T(){const K=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&A(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&A(t.charCodeAt(r)))for(r++;r<t.length&&A(t.charCodeAt(r));)r++;else return b=3,t.substring(K,r);let U=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&A(t.charCodeAt(r))){for(r++;r<t.length&&A(t.charCodeAt(r));)r++;U=r}else b=3;return t.substring(K,U)}function v(){let K="",U=r;for(;;){if(r>=i){K+=t.substring(U,r),b=2;break}const z=t.charCodeAt(r);if(z===34){K+=t.substring(U,r),r++;break}if(z===92){if(K+=t.substring(U,r),r++,r>=i){b=2;break}switch(t.charCodeAt(r++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:const x=D(4);x>=0?K+=String.fromCharCode(x):b=4;break;default:b=5}U=r;continue}if(z>=0&&z<=31)if(S(z)){K+=t.substring(U,r),b=2;break}else b=6;r++}return K}function F(){if(l="",b=0,u=r,r>=i)return u=i,f=17;let K=t.charCodeAt(r);if(E(K)){do r++,l+=String.fromCharCode(K),K=t.charCodeAt(r);while(E(K));return f=15}if(S(K))return r++,l+=String.fromCharCode(K),K===13&&t.charCodeAt(r)===10&&(r++,l+=`
`),f=14;switch(K){case 123:return r++,f=1;case 125:return r++,f=2;case 91:return r++,f=3;case 93:return r++,f=4;case 58:return r++,f=6;case 44:return r++,f=5;case 34:return r++,l=v(),f=10;case 47:const U=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!S(t.charCodeAt(r));)r++;return l=t.substring(U,r),f=12}if(t.charCodeAt(r+1)===42){r+=2;const z=i-1;let N=!1;for(;r<z;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,N=!0;break}r++}return N||(r++,b=1),l=t.substring(U,r),f=13}return l+=String.fromCharCode(K),r++,f=16;case 45:if(l+=String.fromCharCode(K),r++,r===i||!A(t.charCodeAt(r)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=T(),f=11;default:for(;r<i&&M(K);)r++,K=t.charCodeAt(r);if(u!==r){switch(l=t.substring(u,r),l){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return l+=String.fromCharCode(K),r++,f=16}}function M(K){if(E(K)||S(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let K;do K=F();while(K>=12&&K<=15);return K}return{setPosition:w,getPosition:()=>r,scan:a?G:F,getToken:()=>f,getTokenValue:()=>l,getTokenOffset:()=>u,getTokenLength:()=>r-u,getTokenError:()=>b}}e.createScanner=R;function E(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function A(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function P(t,a){const r=[],i=new Object;let l;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function b(D,w,T,v){u.value=D,u.offset=w,u.length=T,u.type=v,u.colonOffset=void 0,l=u}try{s(t,{onObjectBegin:(D,w)=>{if(a<=D)throw i;l=void 0,f=a>D,r.push("")},onObjectProperty:(D,w,T)=>{if(a<w||(b(D,w,T,"property"),r[r.length-1]=D,a<=w+T))throw i},onObjectEnd:(D,w)=>{if(a<=D)throw i;l=void 0,r.pop()},onArrayBegin:(D,w)=>{if(a<=D)throw i;l=void 0,r.push(0)},onArrayEnd:(D,w)=>{if(a<=D)throw i;l=void 0,r.pop()},onLiteralValue:(D,w,T)=>{if(a<w||(b(D,w,T,p(D)),a<=w+T))throw i},onSeparator:(D,w,T)=>{if(a<=w)throw i;if(D===":"&&l&&l.type==="property")l.colonOffset=w,f=!1,l=void 0;else if(D===","){const v=r[r.length-1];typeof v=="number"?r[r.length-1]=v+1:(f=!0,r[r.length-1]=""),l=void 0}}})}catch(D){if(D!==i)throw D}return{path:r,previousNode:l,isAtPropertyKey:f,matches:D=>{let w=0;for(let T=0;w<D.length&&T<r.length;T++)if(D[w]===r[T]||D[w]==="*")w++;else if(D[w]!=="**")return!1;return w===D.length}}}e.getLocation=P;function c(t,a=[],r=C.DEFAULT){let i=null,l=[];const u=[];function f(D){Array.isArray(l)?l.push(D):i!==null&&(l[i]=D)}return s(t,{onObjectBegin:()=>{const D={};f(D),u.push(l),l=D,i=null},onObjectProperty:D=>{i=D},onObjectEnd:()=>{l=u.pop()},onArrayBegin:()=>{const D=[];f(D),u.push(l),l=D,i=null},onArrayEnd:()=>{l=u.pop()},onLiteralValue:f,onError:(D,w,T)=>{a.push({error:D,offset:w,length:T})}},r),l[0]}e.parse=c;function h(t,a=[],r=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(D){i.type==="property"&&(i.length=D-i.offset,i=i.parent)}function u(D){return i.children.push(D),D}s(t,{onObjectBegin:D=>{i=u({type:"object",offset:D,length:-1,parent:i,children:[]})},onObjectProperty:(D,w,T)=>{i=u({type:"property",offset:w,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:D,offset:w,length:T,parent:i})},onObjectEnd:(D,w)=>{i.length=D+w-i.offset,i=i.parent,l(D+w)},onArrayBegin:(D,w)=>{i=u({type:"array",offset:D,length:-1,parent:i,children:[]})},onArrayEnd:(D,w)=>{i.length=D+w-i.offset,i=i.parent,l(D+w)},onLiteralValue:(D,w,T)=>{u({type:p(D),offset:w,length:T,parent:i,value:D}),l(w+T)},onSeparator:(D,w,T)=>{i.type==="property"&&(D===":"?i.colonOffset=w:D===","&&l(w))},onError:(D,w,T)=>{a.push({error:D,offset:w,length:T})}},r);const b=i.children[0];return b&&delete b.parent,b}e.parseTree=h;function d(t,a){if(!t)return;let r=t;for(let i of a)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let l=!1;for(const u of r.children)if(Array.isArray(u.children)&&u.children[0].value===i){r=u.children[1],l=!0;break}if(!l)return}else{const l=i;if(r.type!=="array"||l<0||!Array.isArray(r.children)||l>=r.children.length)return;r=r.children[l]}return r}e.findNodeAtLocation=d;function g(t){if(!t.parent||!t.parent.children)return[];const a=g(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;a.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&a.push(r)}return a}e.getNodePath=g;function y(t){switch(t.type){case"array":return t.children.map(y);case"object":const a=Object.create(null);for(let r of t.children){const i=r.children[1];i&&(a[r.children[0].value]=y(i))}return a;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=y;function I(t,a,r=!1){return a>=t.offset&&a<t.offset+t.length||r&&a===t.offset+t.length}e.contains=I;function _(t,a,r=!1){if(I(t,a,r)){const i=t.children;if(Array.isArray(i))for(let l=0;l<i.length&&i[l].offset<=a;l++){const u=_(i[l],a,r);if(u)return u}return t}}e.findNodeAtOffset=_;function s(t,a,r=C.DEFAULT){const i=R(t,!1);function l(Y){return Y?()=>Y(i.getTokenOffset(),i.getTokenLength()):()=>!0}function u(Y){return Y?he=>Y(he,i.getTokenOffset(),i.getTokenLength()):()=>!0}const f=l(a.onObjectBegin),b=u(a.onObjectProperty),D=l(a.onObjectEnd),w=l(a.onArrayBegin),T=l(a.onArrayEnd),v=u(a.onLiteralValue),F=u(a.onSeparator),M=l(a.onComment),G=u(a.onError),K=r&&r.disallowComments,U=r&&r.allowTrailingComma;function z(){for(;;){const Y=i.scan();switch(i.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:K||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(Y){case 12:case 13:K?N(10):M();break;case 16:N(1);break;case 15:case 14:break;default:return Y}}}function N(Y,he=[],_e=[]){if(G(Y),he.length+_e.length>0){let Se=i.getToken();for(;Se!==17;){if(he.indexOf(Se)!==-1){z();break}else if(_e.indexOf(Se)!==-1)break;Se=z()}}}function x(Y){const he=i.getTokenValue();return Y?v(he):b(he),z(),!0}function B(){switch(i.getToken()){case 11:let Y=0;try{Y=JSON.parse(i.getTokenValue()),typeof Y!="number"&&(N(2),Y=0)}catch(he){N(2)}v(Y);break;case 7:v(null);break;case 8:v(!0);break;case 9:v(!1);break;default:return!1}return z(),!0}function O(){return i.getToken()!==10?(N(3,[],[2,5]),!1):(x(!1),i.getToken()===6?(F(":"),z(),Q()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function H(){f(),z();let Y=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Y||N(4,[],[]),F(","),z(),i.getToken()===2&&U)break}else Y&&N(6,[],[]);O()||N(4,[],[2,5]),Y=!0}return D(),i.getToken()!==2?N(7,[2],[]):z(),!0}function W(){w(),z();let Y=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Y||N(4,[],[]),F(","),z(),i.getToken()===4&&U)break}else Y&&N(6,[],[]);Q()||N(4,[],[4,5]),Y=!0}return T(),i.getToken()!==4?N(8,[4],[]):z(),!0}function Q(){switch(i.getToken()){case 3:return W();case 1:return H();case 10:return x(!0);default:return B()}}return z(),i.getToken()===17?r.allowEmptyContent?!0:(N(4,[],[]),!1):Q()?(i.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=s;function o(t,a){let r=R(t),i=[],l,u=0,f;do switch(f=r.getPosition(),l=r.scan(),l){case 12:case 13:case 17:u!==f&&i.push(t.substring(u,f)),a!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,a)),u=r.getPosition();break}while(l!==17);return i.join("")}e.stripComments=o;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(me[137],ge([0,1,59]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(S,A,n){let P,c,h,d,g;if(A){for(d=A.offset,g=d+A.length,h=d;h>0&&!E(S,h-1);)h--;let u=g;for(;u<S.length&&!E(S,u);)u++;c=S.substring(h,u),P=C(c,n)}else c=S,P=0,h=0,d=0,g=S.length;const y=R(n,S);let I=!1,_=0,s;n.insertSpaces?s=k(" ",n.tabSize||4):s="	";const o=(0,m.createScanner)(c,!1);let p=!1;function t(){return y+k(s,P+_)}function a(){let u=o.scan();for(I=!1;u===15||u===14;)I=I||u===14,u=o.scan();return p=u===16||o.getTokenError()!==0,u}const r=[];function i(u,f,b){!p&&f<g&&b>d&&S.substring(f,b)!==u&&r.push({offset:f,length:b-f,content:u})}let l=a();if(l!==17){const u=o.getTokenOffset()+h,f=k(s,P);i(f,h,u)}for(;l!==17;){let u=o.getTokenOffset()+o.getTokenLength()+h,f=a(),b="";for(;!I&&(f===12||f===13);){const w=o.getTokenOffset()+h;i(" ",u,w),u=o.getTokenOffset()+o.getTokenLength()+h,b=f===12?t():"",f=a()}if(f===2)l!==1&&(_--,b=t());else if(f===4)l!==3&&(_--,b=t());else{switch(l){case 3:case 1:_++,b=t();break;case 5:case 12:b=t();break;case 13:I?b=t():b=" ";break;case 6:b=" ";break;case 10:if(f===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?b=" ":f!==5&&f!==17&&(p=!0);break;case 16:p=!0;break}I&&(f===12||f===13)&&(b=t())}const D=o.getTokenOffset()+h;i(b,u,D),l=f}return r}e.format=L;function k(S,A){let n="";for(let P=0;P<A;P++)n+=S;return n}function C(S,A){let n=0,P=0;const c=A.tabSize||4;for(;n<S.length;){const h=S.charAt(n);if(h===" ")P++;else if(h==="	")P+=c;else break;n++}return Math.floor(P/c)}function R(S,A){for(let n=0;n<A.length;n++){const P=A.charAt(n);if(P==="\r")return n+1<A.length&&A.charAt(n+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=R;function E(S,A){return`\r
`.indexOf(S.charAt(A))!==-1}e.isEOL=E}),define(me[138],ge([0,1,59,137]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(A,n,P){return C(A,n,void 0,P)}e.removeProperty=k;function C(A,n,P,c,h){const d=n.slice(),g=[],y=(0,m.parseTree)(A,g);let I,_;for(;d.length>0&&(_=d.pop(),I=(0,m.findNodeAtLocation)(y,d),I===void 0&&P!==void 0);)typeof _=="string"?P={[_]:P}:P=[P];if(I)if(I.type==="object"&&typeof _=="string"&&Array.isArray(I.children)){const s=(0,m.findNodeAtLocation)(I,[_]);if(s!==void 0)if(P===void 0){if(!s.parent)throw new Error("Malformed AST");const o=I.children.indexOf(s.parent);let p,t=s.parent.offset+s.parent.length;if(o>0){const a=I.children[o-1];p=a.offset+a.length}else p=I.offset+1,I.children.length>1&&(t=I.children[1].offset);return R(A,{offset:p,length:t-p,content:""},c)}else return R(A,{offset:s.offset,length:s.length,content:JSON.stringify(P)},c);else{if(P===void 0)return[];const o=`${JSON.stringify(_)}: ${JSON.stringify(P)}`,p=h?h(I.children.map(a=>a.children[0].value)):I.children.length;let t;if(p>0){const a=I.children[p-1];t={offset:a.offset+a.length,length:0,content:","+o}}else I.children.length===0?t={offset:I.offset+1,length:0,content:o}:t={offset:I.offset+1,length:0,content:o+","};return R(A,t,c)}}else if(I.type==="array"&&typeof _=="number"&&Array.isArray(I.children))if(P!==void 0){const s=`${JSON.stringify(P)}`;let o;if(I.children.length===0||_===0)o={offset:I.offset+1,length:0,content:I.children.length===0?s:s+","};else{const p=_===-1||_>I.children.length?I.children.length:_,t=I.children[p-1];o={offset:t.offset+t.length,length:0,content:","+s}}return R(A,o,c)}else{const s=_,o=I.children[s];let p;if(I.children.length===1)p={offset:I.offset+1,length:I.length-2,content:""};else if(I.children.length-1===s){const t=I.children[s-1],a=t.offset+t.length,r=I.offset+I.length;p={offset:a,length:r-2-a,content:""}}else p={offset:o.offset,length:I.children[s+1].offset-o.offset,content:""};return R(A,p,c)}else throw new Error(`Can not add ${typeof _!="number"?"index":"property"} to parent of type ${I.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return R(A,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(P)},c)}}e.setProperty=C;function R(A,n,P){let c=E(A,n),h=n.offset,d=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;h>0&&!(0,L.isEOL)(c,h-1);)h--;for(;d<c.length&&!(0,L.isEOL)(c,d);)d++}const g=(0,L.format)(c,{offset:h,length:d-h},P);for(let I=g.length-1;I>=0;I--){const _=g[I];c=E(c,_),h=Math.min(h,_.offset),d=Math.max(d,_.offset+_.length),d+=_.content.length-_.length}const y=A.length-(c.length-d)-h;return[{offset:h,length:y,content:c.substring(h,d)}]}e.withFormatting=R;function E(A,n){return A.substring(0,n.offset)+n.content+A.substring(n.offset+n.length)}e.applyEdit=E;function S(A,n){let P=n.slice(0).sort((h,d)=>{const g=h.offset-d.offset;return g===0?h.length-d.length:g}),c=A.length;for(let h=P.length-1;h>=0;h--){let d=P[h];if(d.offset+d.length<=c)A=E(A,d);else throw new Error("Overlapping edit");c=d.offset}return A}e.applyEdits=S}),define(me[139],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new m(()=>k(this.getValue()))}}e.Lazy=m}),define(me[6],ge([0,1,75,94]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let C=null;function R(r){C=r}if(e.setDisposableTracker=R,k){const r="__is_disposable_tracked__";R(new class{trackDisposable(i){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[r]||console.log(l)},3e3)}setParent(i,l){if(i&&i!==_.None)try{i[r]=!0}catch{}}markAsDisposed(i){if(i&&i!==_.None)try{i[r]=!0}catch{}}markAsSingleton(i){}})}function E(r){return C?.trackDisposable(r),r}function S(r){C?.markAsDisposed(r)}function A(r,i){C?.setParent(r,i)}function n(r,i){if(!!C)for(const l of r)C.setParent(l,i)}function P(r){return C?.markAsSingleton(r),r}e.markAsSingleton=P;class c extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=c;function h(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=h;function d(r){if(L.Iterable.is(r)){let i=[];for(const l of r)if(l)try{l.dispose()}catch(u){i.push(u)}if(i.length===1)throw i[0];if(i.length>1)throw new c(i);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=d;function g(...r){const i=y(()=>d(r));return n(r,i),i}e.combinedDisposable=g;function y(r){const i=E({dispose:(0,m.once)(()=>{S(i),r()})});return i}e.toDisposable=y;class I{constructor(){this._toDispose=new Set,this._isDisposed=!1,E(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return A(i,this),this._isDisposed?I.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=I,I.DISABLE_DISPOSED_WARNING=!1;class _{constructor(){this._store=new I,E(this),A(this._store,this)}dispose(){S(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=_,_.None=Object.freeze({dispose(){}});class s{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&A(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&A(i,null),i}}e.MutableDisposable=s;class o{constructor(i){this._disposable=i,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class p{constructor(){this.references=new Map}acquire(i,...l){let u=this.references.get(i);u||(u={counter:0,object:this.createReferencedObject(i,...l)},this.references.set(i,u));const{object:f}=u,b=(0,m.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(i,u.object),this.references.delete(i))});return u.counter++,{object:f,dispose:b}}}e.ReferenceCollection=p;class t{constructor(i){this.referenceCollection=i}async acquire(i,...l){const u=this.referenceCollection.acquire(i,...l);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(f){throw u.dispose(),f}}}e.AsyncReferenceCollection=t;class a{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=a}),define(me[95],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(C){this.element=C,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class L{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let C=this._first;for(;C!==m.Undefined;){const R=C.next;C.prev=m.Undefined,C.next=m.Undefined,C=R}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,R){const E=new m(C);if(this._first===m.Undefined)this._first=E,this._last=E;else if(R){const A=this._last;this._last=E,E.prev=A,A.next=E}else{const A=this._first;this._first=E,E.next=A,A.prev=E}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(E))}}shift(){if(this._first!==m.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==m.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==m.Undefined&&C.next!==m.Undefined){const R=C.prev;R.next=C.next,C.next.prev=R}else C.prev===m.Undefined&&C.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):C.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):C.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==m.Undefined;)yield C.element,C=C.next}}e.LinkedList=L}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(J=typeof globalThis!="undefined"?globalThis:J||self,J.marked=e())}(this,function(){"use strict";function J(Le,ye){for(var ke=0;ke<ye.length;ke++){var ne=ye[ke];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(Le,ne.key,ne)}}function e(Le,ye,ke){return ye&&J(Le.prototype,ye),ke&&J(Le,ke),Le}function m(Le,ye){if(!!Le){if(typeof Le=="string")return L(Le,ye);var ke=Object.prototype.toString.call(Le).slice(8,-1);if(ke==="Object"&&Le.constructor&&(ke=Le.constructor.name),ke==="Map"||ke==="Set")return Array.from(Le);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return L(Le,ye)}}function L(Le,ye){(ye==null||ye>Le.length)&&(ye=Le.length);for(var ke=0,ne=new Array(ye);ke<ye;ke++)ne[ke]=Le[ke];return ne}function k(Le,ye){var ke=typeof Symbol!="undefined"&&Le[Symbol.iterator]||Le["@@iterator"];if(ke)return(ke=ke.call(Le)).next.bind(ke);if(Array.isArray(Le)||(ke=m(Le))||ye&&Le&&typeof Le.length=="number"){ke&&(Le=ke);var ne=0;return function(){return ne>=Le.length?{done:!0}:{done:!1,value:Le[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var C={exports:{}};function R(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function E(Le){C.exports.defaults=Le}C.exports={defaults:R(),getDefaults:R,changeDefaults:E};var S=/[&<>"']/,A=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(ye){return c[ye]};function d(Le,ye){if(ye){if(S.test(Le))return Le.replace(A,h)}else if(n.test(Le))return Le.replace(P,h);return Le}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function y(Le){return Le.replace(g,function(ye,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var I=/(^|[^\[])\^/g;function _(Le,ye){Le=Le.source||Le,ye=ye||"";var ke={replace:function(de,be){return be=be.source||be,be=be.replace(I,"$1"),Le=Le.replace(de,be),ke},getRegex:function(){return new RegExp(Le,ye)}};return ke}var s=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(Le,ye,ke){if(Le){var ne;try{ne=decodeURIComponent(y(ke)).replace(s,"").toLowerCase()}catch(de){return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}ye&&!o.test(ke)&&(ke=l(ye,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch(de){return null}return ke}var t={},a=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(Le,ye){t[" "+Le]||(a.test(Le)?t[" "+Le]=Le+"/":t[" "+Le]=D(Le,"/",!0)),Le=t[" "+Le];var ke=Le.indexOf(":")===-1;return ye.substring(0,2)==="//"?ke?ye:Le.replace(r,"$1")+ye:ye.charAt(0)==="/"?ke?ye:Le.replace(i,"$1")+ye:Le+ye}var u={exec:function(){}};function f(Le){for(var ye=1,ke,ne;ye<arguments.length;ye++){ke=arguments[ye];for(ne in ke)Object.prototype.hasOwnProperty.call(ke,ne)&&(Le[ne]=ke[ne])}return Le}function b(Le,ye){var ke=Le.replace(/\|/g,function(be,we,Fe){for(var Ge=!1,He=we;--He>=0&&Fe[He]==="\\";)Ge=!Ge;return Ge?"|":" |"}),ne=ke.split(/ \|/),de=0;if(ne[0].trim()||ne.shift(),ne[ne.length-1].trim()||ne.pop(),ne.length>ye)ne.splice(ye);else for(;ne.length<ye;)ne.push("");for(;de<ne.length;de++)ne[de]=ne[de].trim().replace(/\\\|/g,"|");return ne}function D(Le,ye,ke){var ne=Le.length;if(ne===0)return"";for(var de=0;de<ne;){var be=Le.charAt(ne-de-1);if(be===ye&&!ke)de++;else if(be!==ye&&ke)de++;else break}return Le.substr(0,ne-de)}function w(Le,ye){if(Le.indexOf(ye[1])===-1)return-1;for(var ke=Le.length,ne=0,de=0;de<ke;de++)if(Le[de]==="\\")de++;else if(Le[de]===ye[0])ne++;else if(Le[de]===ye[1]&&(ne--,ne<0))return de;return-1}function T(Le){Le&&Le.sanitize&&!Le.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function v(Le,ye){if(ye<1)return"";for(var ke="";ye>1;)ye&1&&(ke+=Le),ye>>=1,Le+=Le;return ke+Le}var F={escape:d,unescape:y,edit:_,cleanUrl:p,resolveUrl:l,noopTest:u,merge:f,splitCells:b,rtrim:D,findClosingBracket:w,checkSanitizeDeprecation:T,repeatString:v},M=C.exports.defaults,G=F.rtrim,K=F.splitCells,U=F.escape,z=F.findClosingBracket;function N(Le,ye,ke,ne){var de=ye.href,be=ye.title?U(ye.title):null,we=Le[1].replace(/\\([\[\]])/g,"$1");if(Le[0].charAt(0)!=="!"){ne.state.inLink=!0;var Fe={type:"link",raw:ke,href:de,title:be,text:we,tokens:ne.inlineTokens(we,[])};return ne.state.inLink=!1,Fe}else return{type:"image",raw:ke,href:de,title:be,text:U(we)}}function x(Le,ye){var ke=Le.match(/^(\s+)(?:```)/);if(ke===null)return ye;var ne=ke[1];return ye.split(`
`).map(function(de){var be=de.match(/^\s+/);if(be===null)return de;var we=be[0];return we.length>=ne.length?de.slice(ne.length):de}).join(`
`)}var B=function(){function Le(ke){this.options=ke||M}var ye=Le.prototype;return ye.space=function(ne){var de=this.rules.block.newline.exec(ne);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},ye.code=function(ne){var de=this.rules.block.code.exec(ne);if(de){var be=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?be:G(be,`
`)}}},ye.fences=function(ne){var de=this.rules.block.fences.exec(ne);if(de){var be=de[0],we=x(be,de[3]||"");return{type:"code",raw:be,lang:de[2]?de[2].trim():de[2],text:we}}},ye.heading=function(ne){var de=this.rules.block.heading.exec(ne);if(de){var be=de[2].trim();if(/#$/.test(be)){var we=G(be,"#");(this.options.pedantic||!we||/ $/.test(we))&&(be=we.trim())}var Fe={type:"heading",raw:de[0],depth:de[1].length,text:be,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},ye.hr=function(ne){var de=this.rules.block.hr.exec(ne);if(de)return{type:"hr",raw:de[0]}},ye.blockquote=function(ne){var de=this.rules.block.blockquote.exec(ne);if(de){var be=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(be,[]),text:be}}},ye.list=function(ne){var de=this.rules.block.list.exec(ne);if(de){var be,we,Fe,Ge,He,Ye,it,ae,Ee,ce,q=de[1].trim(),Te=q.length>1,Pe={type:"list",raw:"",ordered:Te,start:Te?+q.slice(0,-1):"",loose:!1,items:[]};q=Te?"\\d{1,9}\\"+q.slice(-1):"\\"+q,this.options.pedantic&&(q=Te?q:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+q+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ne&&!(this.rules.block.hr.test(ne)||!(de=Ze.exec(ne)));){Ee=de[2].split(`
`),this.options.pedantic?(Ge=2,ce=Ee[0].trimLeft()):(Ge=de[2].search(/[^ ]/),Ge=de[1].length+(Ge>4?1:Ge),ce=Ee[0].slice(Ge-de[1].length)),Ye=!1,be=de[0],!Ee[0]&&/^ *$/.test(Ee[1])&&(be=de[1]+Ee.slice(0,2).join(`
`)+`
`,Pe.loose=!0,Ee=[]);var Xe=new RegExp("^ {0,"+Math.min(3,Ge-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(He=1;He<Ee.length;He++){if(ae=Ee[He],this.options.pedantic&&(ae=ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Xe.test(ae)){be=de[1]+Ee.slice(0,He).join(`
`)+`
`;break}if(!Ye){ae.trim()||(Ye=!0),ae.search(/[^ ]/)>=Ge?ce+=`
`+ae.slice(Ge):ce+=`
`+ae;continue}if(ae.search(/[^ ]/)>=Ge||!ae.trim()){ce+=`
`+ae.slice(Ge);continue}else{be=de[1]+Ee.slice(0,He).join(`
`)+`
`;break}}Pe.loose||(it?Pe.loose=!0:/\n *\n *$/.test(be)&&(it=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(ce),we&&(Fe=we[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),Pe.items.push({type:"list_item",raw:be,task:!!we,checked:Fe,loose:!1,text:ce}),Pe.raw+=be,ne=ne.slice(be.length)}Pe.items[Pe.items.length-1].raw=be.trimRight(),Pe.items[Pe.items.length-1].text=ce.trimRight(),Pe.raw=Pe.raw.trimRight();var st=Pe.items.length;for(He=0;He<st;He++)this.lexer.state.top=!1,Pe.items[He].tokens=this.lexer.blockTokens(Pe.items[He].text,[]),Pe.items[He].tokens.some(function(wt){return wt.type==="space"})&&(Pe.loose=!0,Pe.items[He].loose=!0);return Pe}},ye.html=function(ne){var de=this.rules.block.html.exec(ne);if(de){var be={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};return this.options.sanitize&&(be.type="paragraph",be.text=this.options.sanitizer?this.options.sanitizer(de[0]):U(de[0]),be.tokens=[],this.lexer.inline(be.text,be.tokens)),be}},ye.def=function(ne){var de=this.rules.block.def.exec(ne);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var be=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:be,raw:de[0],href:de[2],title:de[3]}}},ye.table=function(ne){var de=this.rules.block.table.exec(ne);if(de){var be={type:"table",header:K(de[1]).map(function(it){return{text:it}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(be.header.length===be.align.length){be.raw=de[0];var we=be.align.length,Fe,Ge,He,Ye;for(Fe=0;Fe<we;Fe++)/^ *-+: *$/.test(be.align[Fe])?be.align[Fe]="right":/^ *:-+: *$/.test(be.align[Fe])?be.align[Fe]="center":/^ *:-+ *$/.test(be.align[Fe])?be.align[Fe]="left":be.align[Fe]=null;for(we=be.rows.length,Fe=0;Fe<we;Fe++)be.rows[Fe]=K(be.rows[Fe],be.header.length).map(function(it){return{text:it}});for(we=be.header.length,Ge=0;Ge<we;Ge++)be.header[Ge].tokens=[],this.lexer.inlineTokens(be.header[Ge].text,be.header[Ge].tokens);for(we=be.rows.length,Ge=0;Ge<we;Ge++)for(Ye=be.rows[Ge],He=0;He<Ye.length;He++)Ye[He].tokens=[],this.lexer.inlineTokens(Ye[He].text,Ye[He].tokens);return be}}},ye.lheading=function(ne){var de=this.rules.block.lheading.exec(ne);if(de){var be={type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},ye.paragraph=function(ne){var de=this.rules.block.paragraph.exec(ne);if(de){var be={type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},ye.text=function(ne){var de=this.rules.block.text.exec(ne);if(de){var be={type:"text",raw:de[0],text:de[0],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},ye.escape=function(ne){var de=this.rules.inline.escape.exec(ne);if(de)return{type:"escape",raw:de[0],text:U(de[1])}},ye.tag=function(ne){var de=this.rules.inline.tag.exec(ne);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):U(de[0]):de[0]}},ye.link=function(ne){var de=this.rules.inline.link.exec(ne);if(de){var be=de[2].trim();if(!this.options.pedantic&&/^</.test(be)){if(!/>$/.test(be))return;var we=G(be.slice(0,-1),"\\");if((be.length-we.length)%2==0)return}else{var Fe=z(de[2],"()");if(Fe>-1){var Ge=de[0].indexOf("!")===0?5:4,He=Ge+de[1].length+Fe;de[2]=de[2].substring(0,Fe),de[0]=de[0].substring(0,He).trim(),de[3]=""}}var Ye=de[2],it="";if(this.options.pedantic){var ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ye);ae&&(Ye=ae[1],it=ae[3])}else it=de[3]?de[3].slice(1,-1):"";return Ye=Ye.trim(),/^</.test(Ye)&&(this.options.pedantic&&!/>$/.test(be)?Ye=Ye.slice(1):Ye=Ye.slice(1,-1)),N(de,{href:Ye&&Ye.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},ye.reflink=function(ne,de){var be;if((be=this.rules.inline.reflink.exec(ne))||(be=this.rules.inline.nolink.exec(ne))){var we=(be[2]||be[1]).replace(/\s+/g," ");if(we=de[we.toLowerCase()],!we||!we.href){var Fe=be[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return N(be,we,be[0],this.lexer)}},ye.emStrong=function(ne,de,be){be===void 0&&(be="");var we=this.rules.inline.emStrong.lDelim.exec(ne);if(!!we&&!(we[3]&&be.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=we[1]||we[2]||"";if(!Fe||Fe&&(be===""||this.rules.inline.punctuation.exec(be))){var Ge=we[0].length-1,He,Ye,it=Ge,ae=0,Ee=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ee.lastIndex=0,de=de.slice(-1*ne.length+Ge);(we=Ee.exec(de))!=null;)if(He=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!He){if(Ye=He.length,we[3]||we[4]){it+=Ye;continue}else if((we[5]||we[6])&&Ge%3&&!((Ge+Ye)%3)){ae+=Ye;continue}if(it-=Ye,!(it>0)){if(Ye=Math.min(Ye,Ye+it+ae),Math.min(Ge,Ye)%2){var ce=ne.slice(1,Ge+we.index+Ye);return{type:"em",raw:ne.slice(0,Ge+we.index+Ye+1),text:ce,tokens:this.lexer.inlineTokens(ce,[])}}var q=ne.slice(2,Ge+we.index+Ye-1);return{type:"strong",raw:ne.slice(0,Ge+we.index+Ye+1),text:q,tokens:this.lexer.inlineTokens(q,[])}}}}}},ye.codespan=function(ne){var de=this.rules.inline.code.exec(ne);if(de){var be=de[2].replace(/\n/g," "),we=/[^ ]/.test(be),Fe=/^ /.test(be)&&/ $/.test(be);return we&&Fe&&(be=be.substring(1,be.length-1)),be=U(be,!0),{type:"codespan",raw:de[0],text:be}}},ye.br=function(ne){var de=this.rules.inline.br.exec(ne);if(de)return{type:"br",raw:de[0]}},ye.del=function(ne){var de=this.rules.inline.del.exec(ne);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2],[])}},ye.autolink=function(ne,de){var be=this.rules.inline.autolink.exec(ne);if(be){var we,Fe;return be[2]==="@"?(we=U(this.options.mangle?de(be[1]):be[1]),Fe="mailto:"+we):(we=U(be[1]),Fe=we),{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},ye.url=function(ne,de){var be;if(be=this.rules.inline.url.exec(ne)){var we,Fe;if(be[2]==="@")we=U(this.options.mangle?de(be[0]):be[0]),Fe="mailto:"+we;else{var Ge;do Ge=be[0],be[0]=this.rules.inline._backpedal.exec(be[0])[0];while(Ge!==be[0]);we=U(be[0]),be[1]==="www."?Fe="http://"+we:Fe=we}return{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},ye.inlineText=function(ne,de){var be=this.rules.inline.text.exec(ne);if(be){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):U(be[0]):be[0]:we=U(this.options.smartypants?de(be[0]):be[0]),{type:"text",raw:be[0],text:we}}},Le}(),O=F.noopTest,H=F.edit,W=F.merge,Q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:O,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};Q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,Q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Q.def=H(Q.def).replace("label",Q._label).replace("title",Q._title).getRegex(),Q.bullet=/(?:[*+-]|\d{1,9}[.)])/,Q.listItemStart=H(/^( *)(bull) */).replace("bull",Q.bullet).getRegex(),Q.list=H(Q.list).replace(/bull/g,Q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Q.def.source+")").getRegex(),Q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Q.html=H(Q.html,"i").replace("comment",Q._comment).replace("tag",Q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Q.paragraph=H(Q._paragraph).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.blockquote=H(Q.blockquote).replace("paragraph",Q.paragraph).getRegex(),Q.normal=W({},Q),Q.gfm=W({},Q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Q.gfm.table=H(Q.gfm.table).replace("hr",Q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Q._tag).getRegex(),Q.pedantic=W({},Q.normal,{html:H(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:O,paragraph:H(Q.normal._paragraph).replace("hr",Q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Y={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:O,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:O,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Y._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Y.punctuation=H(Y.punctuation).replace(/punctuation/g,Y._punctuation).getRegex(),Y.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Y.escapedEmSt=/\\\*|\\_/g,Y._comment=H(Q._comment).replace("(?:-->|$)","-->").getRegex(),Y.emStrong.lDelim=H(Y.emStrong.lDelim).replace(/punct/g,Y._punctuation).getRegex(),Y.emStrong.rDelimAst=H(Y.emStrong.rDelimAst,"g").replace(/punct/g,Y._punctuation).getRegex(),Y.emStrong.rDelimUnd=H(Y.emStrong.rDelimUnd,"g").replace(/punct/g,Y._punctuation).getRegex(),Y._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Y._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Y._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Y.autolink=H(Y.autolink).replace("scheme",Y._scheme).replace("email",Y._email).getRegex(),Y._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Y.tag=H(Y.tag).replace("comment",Y._comment).replace("attribute",Y._attribute).getRegex(),Y._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Y._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Y._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Y.link=H(Y.link).replace("label",Y._label).replace("href",Y._href).replace("title",Y._title).getRegex(),Y.reflink=H(Y.reflink).replace("label",Y._label).getRegex(),Y.reflinkSearch=H(Y.reflinkSearch,"g").replace("reflink",Y.reflink).replace("nolink",Y.nolink).getRegex(),Y.normal=W({},Y),Y.pedantic=W({},Y.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:H(/^!?\[(label)\]\((.*?)\)/).replace("label",Y._label).getRegex(),reflink:H(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Y._label).getRegex()}),Y.gfm=W({},Y.normal,{escape:H(Y.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),Y.gfm.url=H(Y.gfm.url,"i").replace("email",Y.gfm._extended_email).getRegex(),Y.breaks=W({},Y.gfm,{br:H(Y.br).replace("{2,}","*").getRegex(),text:H(Y.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var he={block:Q,inline:Y},_e=B,Se=C.exports.defaults,Re=he.block,xe=he.inline,Ue=F.repeatString;function je(Le){return Le.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(Le){var ye="",ke,ne,de=Le.length;for(ke=0;ke<de;ke++)ne=Le.charCodeAt(ke),Math.random()>.5&&(ne="x"+ne.toString(16)),ye+="&#"+ne+";";return ye}var ee=function(){function Le(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||Se,this.options.tokenizer=this.options.tokenizer||new _e,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:Re.normal,inline:xe.normal};this.options.pedantic?(ne.block=Re.pedantic,ne.inline=xe.pedantic):this.options.gfm&&(ne.block=Re.gfm,this.options.breaks?ne.inline=xe.breaks:ne.inline=xe.gfm),this.tokenizer.rules=ne}Le.lex=function(ne,de){var be=new Le(de);return be.lex(ne)},Le.lexInline=function(ne,de){var be=new Le(de);return be.inlineTokens(ne)};var ye=Le.prototype;return ye.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ne,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},ye.blockTokens=function(ne,de){var be=this;de===void 0&&(de=[]),this.options.pedantic&&(ne=ne.replace(/^ +$/gm,""));for(var we,Fe,Ge,He;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(we=it.call({lexer:be},ne,de))?(ne=ne.substring(we.raw.length),de.push(we),!0):!1}))){if(we=this.tokenizer.space(ne)){ne=ne.substring(we.raw.length),we.type&&de.push(we);continue}if(we=this.tokenizer.code(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(we);continue}if(we=this.tokenizer.fences(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.heading(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.hr(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.blockquote(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.list(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.html(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.def(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.lheading(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(Ge=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=Infinity,ae=ne.slice(1),Ee=void 0;be.options.extensions.startBlock.forEach(function(ce){Ee=ce.call({lexer:this},ae),typeof Ee=="number"&&Ee>=0&&(it=Math.min(it,Ee))}),it<Infinity&&it>=0&&(Ge=ne.substring(0,it+1))}(),this.state.top&&(we=this.tokenizer.paragraph(Ge))){Fe=de[de.length-1],He&&Fe.type==="paragraph"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(we),He=Ge.length!==ne.length,ne=ne.substring(we.raw.length);continue}if(we=this.tokenizer.text(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):de.push(we);continue}if(ne){var Ye="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(Ye);break}else throw new Error(Ye)}}return this.state.top=!0,de},ye.inline=function(ne,de){this.inlineQueue.push({src:ne,tokens:de})},ye.inlineTokens=function(ne,de){var be=this;de===void 0&&(de=[]);var we,Fe,Ge,He=ne,Ye,it,ae;if(this.tokens.links){var Ee=Object.keys(this.tokens.links);if(Ee.length>0)for(;(Ye=this.tokenizer.rules.inline.reflinkSearch.exec(He))!=null;)Ee.includes(Ye[0].slice(Ye[0].lastIndexOf("[")+1,-1))&&(He=He.slice(0,Ye.index)+"["+Ue("a",Ye[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ye=this.tokenizer.rules.inline.blockSkip.exec(He))!=null;)He=He.slice(0,Ye.index)+"["+Ue("a",Ye[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ye=this.tokenizer.rules.inline.escapedEmSt.exec(He))!=null;)He=He.slice(0,Ye.index)+"++"+He.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(it||(ae=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(q){return(we=q.call({lexer:be},ne,de))?(ne=ne.substring(we.raw.length),de.push(we),!0):!1}))){if(we=this.tokenizer.escape(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.tag(ne)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):de.push(we);continue}if(we=this.tokenizer.link(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(we.raw.length),Fe=de[de.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):de.push(we);continue}if(we=this.tokenizer.emStrong(ne,He,ae)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.codespan(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.br(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.del(ne)){ne=ne.substring(we.raw.length),de.push(we);continue}if(we=this.tokenizer.autolink(ne,V)){ne=ne.substring(we.raw.length),de.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(ne,V))){ne=ne.substring(we.raw.length),de.push(we);continue}if(Ge=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var q=Infinity,Te=ne.slice(1),Pe=void 0;be.options.extensions.startInline.forEach(function(Ze){Pe=Ze.call({lexer:this},Te),typeof Pe=="number"&&Pe>=0&&(q=Math.min(q,Pe))}),q<Infinity&&q>=0&&(Ge=ne.substring(0,q+1))}(),we=this.tokenizer.inlineText(Ge,je)){ne=ne.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(ae=we.raw.slice(-1)),it=!0,Fe=de[de.length-1],Fe&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):de.push(we);continue}if(ne){var ce="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(ce);break}else throw new Error(ce)}}return de},e(Le,null,[{key:"rules",get:function(){return{block:Re,inline:xe}}}]),Le}(),re=C.exports.defaults,le=F.cleanUrl,Z=F.escape,oe=function(){function Le(ke){this.options=ke||re}var ye=Le.prototype;return ye.code=function(ne,de,be){var we=(de||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(ne,we);Fe!=null&&Fe!==ne&&(be=!0,ne=Fe)}return ne=ne.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+Z(we,!0)+'">'+(be?ne:Z(ne,!0))+`</code></pre>
`:"<pre><code>"+(be?ne:Z(ne,!0))+`</code></pre>
`},ye.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},ye.html=function(ne){return ne},ye.heading=function(ne,de,be,we){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+we.slug(be)+'">'+ne+"</h"+de+`>
`:"<h"+de+">"+ne+"</h"+de+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(ne,de,be){var we=de?"ol":"ul",Fe=de&&be!==1?' start="'+be+'"':"";return"<"+we+Fe+`>
`+ne+"</"+we+`>
`},ye.listitem=function(ne){return"<li>"+ne+`</li>
`},ye.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(ne){return"<p>"+ne+`</p>
`},ye.table=function(ne,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+de+`</table>
`},ye.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},ye.tablecell=function(ne,de){var be=de.header?"th":"td",we=de.align?"<"+be+' align="'+de.align+'">':"<"+be+">";return we+ne+"</"+be+`>
`},ye.strong=function(ne){return"<strong>"+ne+"</strong>"},ye.em=function(ne){return"<em>"+ne+"</em>"},ye.codespan=function(ne){return"<code>"+ne+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(ne){return"<del>"+ne+"</del>"},ye.link=function(ne,de,be){if(ne=le(this.options.sanitize,this.options.baseUrl,ne),ne===null)return be;var we='<a href="'+Z(ne)+'"';return de&&(we+=' title="'+de+'"'),we+=">"+be+"</a>",we},ye.image=function(ne,de,be){if(ne=le(this.options.sanitize,this.options.baseUrl,ne),ne===null)return be;var we='<img src="'+ne+'" alt="'+be+'"';return de&&(we+=' title="'+de+'"'),we+=this.options.xhtml?"/>":">",we},ye.text=function(ne){return ne},Le}(),ve=function(){function Le(){}var ye=Le.prototype;return ye.strong=function(ne){return ne},ye.em=function(ne){return ne},ye.codespan=function(ne){return ne},ye.del=function(ne){return ne},ye.html=function(ne){return ne},ye.text=function(ne){return ne},ye.link=function(ne,de,be){return""+be},ye.image=function(ne,de,be){return""+be},ye.br=function(){return""},Le}(),Me=function(){function Le(){this.seen={}}var ye=Le.prototype;return ye.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(ne,de){var be=ne,we=0;if(this.seen.hasOwnProperty(be)){we=this.seen[ne];do we++,be=ne+"-"+we;while(this.seen.hasOwnProperty(be))}return de||(this.seen[ne]=we,this.seen[be]=0),be},ye.slug=function(ne,de){de===void 0&&(de={});var be=this.serialize(ne);return this.getNextSafeSlug(be,de.dryrun)},Le}(),qe=oe,Qe=ve,Je=Me,Ce=C.exports.defaults,at=F.unescape,X=function(){function Le(ke){this.options=ke||Ce,this.options.renderer=this.options.renderer||new qe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Qe,this.slugger=new Je}Le.parse=function(ne,de){var be=new Le(de);return be.parse(ne)},Le.parseInline=function(ne,de){var be=new Le(de);return be.parseInline(ne)};var ye=Le.prototype;return ye.parse=function(ne,de){de===void 0&&(de=!0);var be="",we,Fe,Ge,He,Ye,it,ae,Ee,ce,q,Te,Pe,Ze,Xe,st,wt,_t,dt,gt,ft=ne.length;for(we=0;we<ft;we++){if(q=ne[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[q.type]&&(gt=this.options.extensions.renderers[q.type].call({parser:this},q),gt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(q.type))){be+=gt||"";continue}switch(q.type){case"space":continue;case"hr":{be+=this.renderer.hr();continue}case"heading":{be+=this.renderer.heading(this.parseInline(q.tokens),q.depth,at(this.parseInline(q.tokens,this.textRenderer)),this.slugger);continue}case"code":{be+=this.renderer.code(q.text,q.lang,q.escaped);continue}case"table":{for(Ee="",ae="",He=q.header.length,Fe=0;Fe<He;Fe++)ae+=this.renderer.tablecell(this.parseInline(q.header[Fe].tokens),{header:!0,align:q.align[Fe]});for(Ee+=this.renderer.tablerow(ae),ce="",He=q.rows.length,Fe=0;Fe<He;Fe++){for(it=q.rows[Fe],ae="",Ye=it.length,Ge=0;Ge<Ye;Ge++)ae+=this.renderer.tablecell(this.parseInline(it[Ge].tokens),{header:!1,align:q.align[Ge]});ce+=this.renderer.tablerow(ae)}be+=this.renderer.table(Ee,ce);continue}case"blockquote":{ce=this.parse(q.tokens),be+=this.renderer.blockquote(ce);continue}case"list":{for(Te=q.ordered,Pe=q.start,Ze=q.loose,He=q.items.length,ce="",Fe=0;Fe<He;Fe++)st=q.items[Fe],wt=st.checked,_t=st.task,Xe="",st.task&&(dt=this.renderer.checkbox(wt),Ze?st.tokens.length>0&&st.tokens[0].type==="paragraph"?(st.tokens[0].text=dt+" "+st.tokens[0].text,st.tokens[0].tokens&&st.tokens[0].tokens.length>0&&st.tokens[0].tokens[0].type==="text"&&(st.tokens[0].tokens[0].text=dt+" "+st.tokens[0].tokens[0].text)):st.tokens.unshift({type:"text",text:dt}):Xe+=dt),Xe+=this.parse(st.tokens,Ze),ce+=this.renderer.listitem(Xe,_t,wt);be+=this.renderer.list(ce,Te,Pe);continue}case"html":{be+=this.renderer.html(q.text);continue}case"paragraph":{be+=this.renderer.paragraph(this.parseInline(q.tokens));continue}case"text":{for(ce=q.tokens?this.parseInline(q.tokens):q.text;we+1<ft&&ne[we+1].type==="text";)q=ne[++we],ce+=`
`+(q.tokens?this.parseInline(q.tokens):q.text);be+=de?this.renderer.paragraph(ce):ce;continue}default:{var Tt='Token with "'+q.type+'" type was not found.';if(this.options.silent){console.error(Tt);return}else throw new Error(Tt)}}}return be},ye.parseInline=function(ne,de){de=de||this.renderer;var be="",we,Fe,Ge,He=ne.length;for(we=0;we<He;we++){if(Fe=ne[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(Ge=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),Ge!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){be+=Ge||"";continue}switch(Fe.type){case"escape":{be+=de.text(Fe.text);break}case"html":{be+=de.html(Fe.text);break}case"link":{be+=de.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,de));break}case"image":{be+=de.image(Fe.href,Fe.title,Fe.text);break}case"strong":{be+=de.strong(this.parseInline(Fe.tokens,de));break}case"em":{be+=de.em(this.parseInline(Fe.tokens,de));break}case"codespan":{be+=de.codespan(Fe.text);break}case"br":{be+=de.br();break}case"del":{be+=de.del(this.parseInline(Fe.tokens,de));break}case"text":{be+=de.text(Fe.text);break}default:{var Ye='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Ye);return}else throw new Error(Ye)}}}return be},Le}(),te=ee,pe=X,ze=B,tt=oe,ut=ve,lt=Me,vt=F.merge,Dt=F.checkSanitizeDeprecation,ue=F.escape,Ie=C.exports.getDefaults,Be=C.exports.changeDefaults,Ke=C.exports.defaults;function We(Le,ye,ke){if(typeof Le=="undefined"||Le===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Le!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Le)+", string expected");if(typeof ye=="function"&&(ke=ye,ye=null),ye=vt({},We.defaults,ye||{}),Dt(ye),ke){var ne=ye.highlight,de;try{de=te.lex(Le,ye)}catch(Ge){return ke(Ge)}var be=function(He){var Ye;if(!He)try{ye.walkTokens&&We.walkTokens(de,ye.walkTokens),Ye=pe.parse(de,ye)}catch(it){He=it}return ye.highlight=ne,He?ke(He):ke(null,Ye)};if(!ne||ne.length<3||(delete ye.highlight,!de.length))return be();var we=0;We.walkTokens(de,function(Ge){Ge.type==="code"&&(we++,setTimeout(function(){ne(Ge.text,Ge.lang,function(He,Ye){if(He)return be(He);Ye!=null&&Ye!==Ge.text&&(Ge.text=Ye,Ge.escaped=!0),we--,we===0&&be()})},0))}),we===0&&be();return}try{var Fe=te.lex(Le,ye);return ye.walkTokens&&We.walkTokens(Fe,ye.walkTokens),pe.parse(Fe,ye)}catch(Ge){if(Ge.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ue(Ge.message+"",!0)+"</pre>";throw Ge}}We.options=We.setOptions=function(Le){return vt(We.defaults,Le),Be(We.defaults),We},We.getDefaults=Ie,We.defaults=Ke,We.use=function(){for(var Le=this,ye=arguments.length,ke=new Array(ye),ne=0;ne<ye;ne++)ke[ne]=arguments[ne];var de=vt.apply(void 0,[{}].concat(ke)),be=We.defaults.extensions||{renderers:{},childTokens:{}},we;ke.forEach(function(Fe){if(Fe.extensions&&(we=!0,Fe.extensions.forEach(function(He){if(!He.name)throw new Error("extension name required");if(He.renderer){var Ye=be.renderers?be.renderers[He.name]:null;Ye?be.renderers[He.name]=function(){for(var it=arguments.length,ae=new Array(it),Ee=0;Ee<it;Ee++)ae[Ee]=arguments[Ee];var ce=He.renderer.apply(this,ae);return ce===!1&&(ce=Ye.apply(this,ae)),ce}:be.renderers[He.name]=He.renderer}if(He.tokenizer){if(!He.level||He.level!=="block"&&He.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");be[He.level]?be[He.level].unshift(He.tokenizer):be[He.level]=[He.tokenizer],He.start&&(He.level==="block"?be.startBlock?be.startBlock.push(He.start):be.startBlock=[He.start]:He.level==="inline"&&(be.startInline?be.startInline.push(He.start):be.startInline=[He.start]))}He.childTokens&&(be.childTokens[He.name]=He.childTokens)})),Fe.renderer&&function(){var He=We.defaults.renderer||new tt,Ye=function(Ee){var ce=He[Ee];He[Ee]=function(){for(var q=arguments.length,Te=new Array(q),Pe=0;Pe<q;Pe++)Te[Pe]=arguments[Pe];var Ze=Fe.renderer[Ee].apply(He,Te);return Ze===!1&&(Ze=ce.apply(He,Te)),Ze}};for(var it in Fe.renderer)Ye(it);de.renderer=He}(),Fe.tokenizer&&function(){var He=We.defaults.tokenizer||new ze,Ye=function(Ee){var ce=He[Ee];He[Ee]=function(){for(var q=arguments.length,Te=new Array(q),Pe=0;Pe<q;Pe++)Te[Pe]=arguments[Pe];var Ze=Fe.tokenizer[Ee].apply(He,Te);return Ze===!1&&(Ze=ce.apply(He,Te)),Ze}};for(var it in Fe.tokenizer)Ye(it);de.tokenizer=He}(),Fe.walkTokens){var Ge=We.defaults.walkTokens;de.walkTokens=function(He){Fe.walkTokens.call(Le,He),Ge&&Ge(He)}}we&&(de.extensions=be),We.setOptions(de)})},We.walkTokens=function(Le,ye){for(var ke=function(){var we=de.value;switch(ye(we),we.type){case"table":{for(var Fe=k(we.header),Ge;!(Ge=Fe()).done;){var He=Ge.value;We.walkTokens(He.tokens,ye)}for(var Ye=k(we.rows),it;!(it=Ye()).done;)for(var ae=it.value,Ee=k(ae),ce;!(ce=Ee()).done;){var q=ce.value;We.walkTokens(q.tokens,ye)}break}case"list":{We.walkTokens(we.items,ye);break}default:We.defaults.extensions&&We.defaults.extensions.childTokens&&We.defaults.extensions.childTokens[we.type]?We.defaults.extensions.childTokens[we.type].forEach(function(Te){We.walkTokens(we[Te],ye)}):we.tokens&&We.walkTokens(we.tokens,ye)}},ne=k(Le),de;!(de=ne()).done;)ke()},We.parseInline=function(Le,ye){if(typeof Le=="undefined"||Le===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Le!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Le)+", string expected");ye=vt({},We.defaults,ye||{}),Dt(ye);try{var ke=te.lexInline(Le,ye);return ye.walkTokens&&We.walkTokens(ke,ye.walkTokens),pe.parseInline(ke,ye)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ue(ne.message+"",!0)+"</pre>";throw ne}},We.Parser=pe,We.parser=pe.parse,We.Renderer=tt,We.TextRenderer=ut,We.Lexer=te,We.lexer=te.lex,We.Tokenizer=ze,We.Slugger=lt,We.parse=We;var ot=We;return ot}),define(me[77],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function m(R,E,S){return Math.min(Math.max(R,E),S)}e.clamp=m;function L(R,E){return(E+R%E)%E}e.rot=L;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class C{constructor(){this._n=1,this._val=0}update(E){return this._val=this._val+(E-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=C}),function(){function J(k){const C=[];typeof k=="number"&&C.push("code/timeOrigin",k);function R(S){C.push(S,Date.now())}function E(){const S=[];for(let A=0;A<C.length;A+=2)S.push({name:C[A],startTime:C[A+1]});return S}return{mark:R,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const R of performance.getEntriesByType("mark"))C.push({name:R.name,startTime:Math.round(k+R.startTime)});return C}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function m(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=m(L))}(),define(me[11],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const m="en";let L=!1,k=!1,C=!1,R=!1,E=!1,S=!1,A=!1,n,P=m,c,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const g=typeof d?.versions?.electron=="string"&&d.type==="renderer";if(e.isElectronSandboxed=g&&d?.sandboxed,typeof navigator=="object"&&!g)h=navigator.userAgent,L=h.indexOf("Windows")>=0,k=h.indexOf("Macintosh")>=0,A=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=h.indexOf("Linux")>=0,S=!0,n=navigator.language,P=n;else if(typeof d=="object"){L=d.platform==="win32",k=d.platform==="darwin",C=d.platform==="linux",R=C&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,n=m,P=m;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const i=JSON.parse(r),l=i.availableLanguages["*"];n=i.locale,P=l||m,c=i._translationsConfigFile}catch(i){}E=!0}else console.error("Unable to resolve platform.");var y;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(y=e.Platform||(e.Platform={}));function I(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=I;let _=0;k?_=1:L?_=3:C&&(_=2),e.isWindows=L,e.isMacintosh=k,e.isLinux=C,e.isLinuxSnap=R,e.isNative=E,e.isWeb=S,e.isIOS=A,e.platform=_,e.userAgent=h,e.language=P;var s;(function(r){function i(){return e.language}r.value=i;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=l;function u(){return e.language==="en"}r.isDefault=u})(s=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=c,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeSetImmediateId)for(let b=0,D=l.length;b<D;b++){const w=l[b];if(w.id===f.data.vscodeSetImmediateId){l.splice(b,1),w.callback();return}}});let u=0;return f=>{const b=++u;l.push({id:b,callback:f}),e.globals.postMessage({vscodeSetImmediateId:b},"*")}}if(typeof d?.nextTick=="function")return d.nextTick.bind(d);const i=Promise.resolve();return l=>i.then(l)}();var o;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||A?2:L?1:3;let p=!0,t=!1;function a(){if(!t){t=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,p=new Uint16Array(r.buffer)[0]===(2<<8)+1}return p}e.isLittleEndian=a}),define(me[38],ge([0,1,11]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const k=m.globals.vscode.process;L={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()},nextTick(C){return(0,m.setImmediate)(C)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:L={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},get arch(){},nextTick(k){return(0,m.setImmediate)(k)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(me[8],ge([0,1,38]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,k=97,C=90,R=122,E=46,S=47,A=92,n=58,P=63;class c extends Error{constructor(o,p,t){let a;typeof p=="string"&&p.indexOf("not ")===0?(a="must not be",p=p.replace(/^not /,"")):a="must be";const r=o.indexOf(".")!==-1?"property":"argument";let i=`The "${o}" ${r} ${a} of type ${p}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function h(s,o){if(typeof s!="string")throw new c(o,"string",s)}function d(s){return s===S||s===A}function g(s){return s===S}function y(s){return s>=L&&s<=C||s>=k&&s<=R}function I(s,o,p,t){let a="",r=0,i=-1,l=0,u=0;for(let f=0;f<=s.length;++f){if(f<s.length)u=s.charCodeAt(f);else{if(t(u))break;u=S}if(t(u)){if(!(i===f-1||l===1))if(l===2){if(a.length<2||r!==2||a.charCodeAt(a.length-1)!==E||a.charCodeAt(a.length-2)!==E){if(a.length>2){const b=a.lastIndexOf(p);b===-1?(a="",r=0):(a=a.slice(0,b),r=a.length-1-a.lastIndexOf(p)),i=f,l=0;continue}else if(a.length!==0){a="",r=0,i=f,l=0;continue}}o&&(a+=a.length>0?`${p}..`:"..",r=2)}else a.length>0?a+=`${p}${s.slice(i+1,f)}`:a=s.slice(i+1,f),r=f-i-1;i=f,l=0}else u===E&&l!==-1?++l:l=-1}return a}function _(s,o){if(o===null||typeof o!="object")throw new c("pathObject","Object",o);const p=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return p?p===o.root?`${p}${t}`:`${p}${s}${t}`:t}e.win32={resolve(...s){let o="",p="",t=!1;for(let a=s.length-1;a>=-1;a--){let r;if(a>=0){if(r=s[a],h(r,"path"),r.length===0)continue}else o.length===0?r=m.cwd():(r=m.env[`=${o}`]||m.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===A)&&(r=`${o}\\`));const i=r.length;let l=0,u="",f=!1;const b=r.charCodeAt(0);if(i===1)d(b)&&(l=1,f=!0);else if(d(b))if(f=!0,d(r.charCodeAt(1))){let D=2,w=D;for(;D<i&&!d(r.charCodeAt(D));)D++;if(D<i&&D!==w){const T=r.slice(w,D);for(w=D;D<i&&d(r.charCodeAt(D));)D++;if(D<i&&D!==w){for(w=D;D<i&&!d(r.charCodeAt(D));)D++;(D===i||D!==w)&&(u=`\\\\${T}\\${r.slice(w,D)}`,l=D)}}}else l=1;else y(b)&&r.charCodeAt(1)===n&&(u=r.slice(0,2),l=2,i>2&&d(r.charCodeAt(2))&&(f=!0,l=3));if(u.length>0)if(o.length>0){if(u.toLowerCase()!==o.toLowerCase())continue}else o=u;if(t){if(o.length>0)break}else if(p=`${r.slice(l)}\\${p}`,t=f,f&&o.length>0)break}return p=I(p,!t,"\\",d),t?`${o}\\${p}`:`${o}${p}`||"."},normalize(s){h(s,"path");const o=s.length;if(o===0)return".";let p=0,t,a=!1;const r=s.charCodeAt(0);if(o===1)return g(r)?"\\":s;if(d(r))if(a=!0,d(s.charCodeAt(1))){let l=2,u=l;for(;l<o&&!d(s.charCodeAt(l));)l++;if(l<o&&l!==u){const f=s.slice(u,l);for(u=l;l<o&&d(s.charCodeAt(l));)l++;if(l<o&&l!==u){for(u=l;l<o&&!d(s.charCodeAt(l));)l++;if(l===o)return`\\\\${f}\\${s.slice(u)}\\`;l!==u&&(t=`\\\\${f}\\${s.slice(u,l)}`,p=l)}}}else p=1;else y(r)&&s.charCodeAt(1)===n&&(t=s.slice(0,2),p=2,o>2&&d(s.charCodeAt(2))&&(a=!0,p=3));let i=p<o?I(s.slice(p),!a,"\\",d):"";return i.length===0&&!a&&(i="."),i.length>0&&d(s.charCodeAt(o-1))&&(i+="\\"),t===void 0?a?`\\${i}`:i:a?`${t}\\${i}`:`${t}${i}`},isAbsolute(s){h(s,"path");const o=s.length;if(o===0)return!1;const p=s.charCodeAt(0);return d(p)||o>2&&y(p)&&s.charCodeAt(1)===n&&d(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let o,p;for(let r=0;r<s.length;++r){const i=s[r];h(i,"path"),i.length>0&&(o===void 0?o=p=i:o+=`\\${i}`)}if(o===void 0)return".";let t=!0,a=0;if(typeof p=="string"&&d(p.charCodeAt(0))){++a;const r=p.length;r>1&&d(p.charCodeAt(1))&&(++a,r>2&&(d(p.charCodeAt(2))?++a:t=!1))}if(t){for(;a<o.length&&d(o.charCodeAt(a));)a++;a>=2&&(o=`\\${o.slice(a)}`)}return e.win32.normalize(o)},relative(s,o){if(h(s,"from"),h(o,"to"),s===o)return"";const p=e.win32.resolve(s),t=e.win32.resolve(o);if(p===t||(s=p.toLowerCase(),o=t.toLowerCase(),s===o))return"";let a=0;for(;a<s.length&&s.charCodeAt(a)===A;)a++;let r=s.length;for(;r-1>a&&s.charCodeAt(r-1)===A;)r--;const i=r-a;let l=0;for(;l<o.length&&o.charCodeAt(l)===A;)l++;let u=o.length;for(;u-1>l&&o.charCodeAt(u-1)===A;)u--;const f=u-l,b=i<f?i:f;let D=-1,w=0;for(;w<b;w++){const v=s.charCodeAt(a+w);if(v!==o.charCodeAt(l+w))break;v===A&&(D=w)}if(w!==b){if(D===-1)return t}else{if(f>b){if(o.charCodeAt(l+w)===A)return t.slice(l+w+1);if(w===2)return t.slice(l+w)}i>b&&(s.charCodeAt(a+w)===A?D=w:w===2&&(D=3)),D===-1&&(D=0)}let T="";for(w=a+D+1;w<=r;++w)(w===r||s.charCodeAt(w)===A)&&(T+=T.length===0?"..":"\\..");return l+=D,T.length>0?`${T}${t.slice(l,u)}`:(t.charCodeAt(l)===A&&++l,t.slice(l,u))},toNamespacedPath(s){if(typeof s!="string")return s;if(s.length===0)return"";const o=e.win32.resolve(s);if(o.length<=2)return s;if(o.charCodeAt(0)===A){if(o.charCodeAt(1)===A){const p=o.charCodeAt(2);if(p!==P&&p!==E)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(y(o.charCodeAt(0))&&o.charCodeAt(1)===n&&o.charCodeAt(2)===A)return`\\\\?\\${o}`;return s},dirname(s){h(s,"path");const o=s.length;if(o===0)return".";let p=-1,t=0;const a=s.charCodeAt(0);if(o===1)return d(a)?s:".";if(d(a)){if(p=t=1,d(s.charCodeAt(1))){let l=2,u=l;for(;l<o&&!d(s.charCodeAt(l));)l++;if(l<o&&l!==u){for(u=l;l<o&&d(s.charCodeAt(l));)l++;if(l<o&&l!==u){for(u=l;l<o&&!d(s.charCodeAt(l));)l++;if(l===o)return s;l!==u&&(p=t=l+1)}}}}else y(a)&&s.charCodeAt(1)===n&&(p=o>2&&d(s.charCodeAt(2))?3:2,t=p);let r=-1,i=!0;for(let l=o-1;l>=t;--l)if(d(s.charCodeAt(l))){if(!i){r=l;break}}else i=!1;if(r===-1){if(p===-1)return".";r=p}return s.slice(0,r)},basename(s,o){o!==void 0&&h(o,"ext"),h(s,"path");let p=0,t=-1,a=!0,r;if(s.length>=2&&y(s.charCodeAt(0))&&s.charCodeAt(1)===n&&(p=2),o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let i=o.length-1,l=-1;for(r=s.length-1;r>=p;--r){const u=s.charCodeAt(r);if(d(u)){if(!a){p=r+1;break}}else l===-1&&(a=!1,l=r+1),i>=0&&(u===o.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=l))}return p===t?t=l:t===-1&&(t=s.length),s.slice(p,t)}for(r=s.length-1;r>=p;--r)if(d(s.charCodeAt(r))){if(!a){p=r+1;break}}else t===-1&&(a=!1,t=r+1);return t===-1?"":s.slice(p,t)},extname(s){h(s,"path");let o=0,p=-1,t=0,a=-1,r=!0,i=0;s.length>=2&&s.charCodeAt(1)===n&&y(s.charCodeAt(0))&&(o=t=2);for(let l=s.length-1;l>=o;--l){const u=s.charCodeAt(l);if(d(u)){if(!r){t=l+1;break}continue}a===-1&&(r=!1,a=l+1),u===E?p===-1?p=l:i!==1&&(i=1):p!==-1&&(i=-1)}return p===-1||a===-1||i===0||i===1&&p===a-1&&p===t+1?"":s.slice(p,a)},format:_.bind(null,"\\"),parse(s){h(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const p=s.length;let t=0,a=s.charCodeAt(0);if(p===1)return d(a)?(o.root=o.dir=s,o):(o.base=o.name=s,o);if(d(a)){if(t=1,d(s.charCodeAt(1))){let D=2,w=D;for(;D<p&&!d(s.charCodeAt(D));)D++;if(D<p&&D!==w){for(w=D;D<p&&d(s.charCodeAt(D));)D++;if(D<p&&D!==w){for(w=D;D<p&&!d(s.charCodeAt(D));)D++;D===p?t=D:D!==w&&(t=D+1)}}}}else if(y(a)&&s.charCodeAt(1)===n){if(p<=2)return o.root=o.dir=s,o;if(t=2,d(s.charCodeAt(2))){if(p===3)return o.root=o.dir=s,o;t=3}}t>0&&(o.root=s.slice(0,t));let r=-1,i=t,l=-1,u=!0,f=s.length-1,b=0;for(;f>=t;--f){if(a=s.charCodeAt(f),d(a)){if(!u){i=f+1;break}continue}l===-1&&(u=!1,l=f+1),a===E?r===-1?r=f:b!==1&&(b=1):r!==-1&&(b=-1)}return l!==-1&&(r===-1||b===0||b===1&&r===l-1&&r===i+1?o.base=o.name=s.slice(i,l):(o.name=s.slice(i,r),o.base=s.slice(i,l),o.ext=s.slice(r,l))),i>0&&i!==t?o.dir=s.slice(0,i-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...s){let o="",p=!1;for(let t=s.length-1;t>=-1&&!p;t--){const a=t>=0?s[t]:m.cwd();h(a,"path"),a.length!==0&&(o=`${a}/${o}`,p=a.charCodeAt(0)===S)}return o=I(o,!p,"/",g),p?`/${o}`:o.length>0?o:"."},normalize(s){if(h(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===S,p=s.charCodeAt(s.length-1)===S;return s=I(s,!o,"/",g),s.length===0?o?"/":p?"./":".":(p&&(s+="/"),o?`/${s}`:s)},isAbsolute(s){return h(s,"path"),s.length>0&&s.charCodeAt(0)===S},join(...s){if(s.length===0)return".";let o;for(let p=0;p<s.length;++p){const t=s[p];h(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(s,o){if(h(s,"from"),h(o,"to"),s===o||(s=e.posix.resolve(s),o=e.posix.resolve(o),s===o))return"";const p=1,t=s.length,a=t-p,r=1,i=o.length-r,l=a<i?a:i;let u=-1,f=0;for(;f<l;f++){const D=s.charCodeAt(p+f);if(D!==o.charCodeAt(r+f))break;D===S&&(u=f)}if(f===l)if(i>l){if(o.charCodeAt(r+f)===S)return o.slice(r+f+1);if(f===0)return o.slice(r+f)}else a>l&&(s.charCodeAt(p+f)===S?u=f:f===0&&(u=0));let b="";for(f=p+u+1;f<=t;++f)(f===t||s.charCodeAt(f)===S)&&(b+=b.length===0?"..":"/..");return`${b}${o.slice(r+u)}`},toNamespacedPath(s){return s},dirname(s){if(h(s,"path"),s.length===0)return".";const o=s.charCodeAt(0)===S;let p=-1,t=!0;for(let a=s.length-1;a>=1;--a)if(s.charCodeAt(a)===S){if(!t){p=a;break}}else t=!1;return p===-1?o?"/":".":o&&p===1?"//":s.slice(0,p)},basename(s,o){o!==void 0&&h(o,"ext"),h(s,"path");let p=0,t=-1,a=!0,r;if(o!==void 0&&o.length>0&&o.length<=s.length){if(o===s)return"";let i=o.length-1,l=-1;for(r=s.length-1;r>=0;--r){const u=s.charCodeAt(r);if(u===S){if(!a){p=r+1;break}}else l===-1&&(a=!1,l=r+1),i>=0&&(u===o.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=l))}return p===t?t=l:t===-1&&(t=s.length),s.slice(p,t)}for(r=s.length-1;r>=0;--r)if(s.charCodeAt(r)===S){if(!a){p=r+1;break}}else t===-1&&(a=!1,t=r+1);return t===-1?"":s.slice(p,t)},extname(s){h(s,"path");let o=-1,p=0,t=-1,a=!0,r=0;for(let i=s.length-1;i>=0;--i){const l=s.charCodeAt(i);if(l===S){if(!a){p=i+1;break}continue}t===-1&&(a=!1,t=i+1),l===E?o===-1?o=i:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||t===-1||r===0||r===1&&o===t-1&&o===p+1?"":s.slice(o,t)},format:_.bind(null,"/"),parse(s){h(s,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return o;const p=s.charCodeAt(0)===S;let t;p?(o.root="/",t=1):t=0;let a=-1,r=0,i=-1,l=!0,u=s.length-1,f=0;for(;u>=t;--u){const b=s.charCodeAt(u);if(b===S){if(!l){r=u+1;break}continue}i===-1&&(l=!1,i=u+1),b===E?a===-1?a=u:f!==1&&(f=1):a!==-1&&(f=-1)}if(i!==-1){const b=r===0&&p?1:r;a===-1||f===0||f===1&&a===i-1&&a===r+1?o.base=o.name=s.slice(b,i):(o.name=s.slice(b,a),o.base=s.slice(b,i),o.ext=s.slice(a,i))}return r>0?o.dir=s.slice(0,r-1):p&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[140],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var L;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(C,...R){const E=R.reduce((n,P)=>(n[P]=!0,n),{}),S=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(n=>!E[n]).forEach(n=>{for(let P=0;P<S.length;P++)if(n.search(S[P])!==-1){delete C[n];break}})}e.sanitizeProcessEnvironment=k}),define(me[141],ge([0,1]),function(J,e){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(E,S,A){this.level=E,this.key=S,this.value=A,this.forward=[]}}const k=void 0;class C{constructor(E,S=2**16){this.comparator=E,this[m]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(S)|0),this._header=new L(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new L(this._maxLevel,k,k)}has(E){return Boolean(C._search(this,E,this.comparator))}get(E){return C._search(this,E,this.comparator)?.value}set(E,S){return C._insert(this,E,S,this.comparator)&&(this._size+=1),this}delete(E){const S=C._delete(this,E,this.comparator);return S&&(this._size-=1),S}forEach(E,S){let A=this._header.forward[0];for(;A;)E.call(S,A.value,A.key,this),A=A.forward[0]}[(m=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this._header.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this._header.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this._header.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",S=this._header.forward[0];for(;S;)E+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return E}static _search(E,S,A){let n=E._header;for(let P=E._level-1;P>=0;P--)for(;n.forward[P]&&A(n.forward[P].key,S)<0;)n=n.forward[P];if(n=n.forward[0],n&&A(n.key,S)===0)return n}static _insert(E,S,A,n){let P=[],c=E._header;for(let h=E._level-1;h>=0;h--){for(;c.forward[h]&&n(c.forward[h].key,S)<0;)c=c.forward[h];P[h]=c}if(c=c.forward[0],c&&n(c.key,S)===0)return c.value=A,!1;{let h=C._randomLevel(E);if(h>E._level){for(let d=E._level;d<h;d++)P[d]=E._header;E._level=h}c=new L(h,S,A);for(let d=0;d<h;d++)c.forward[d]=P[d].forward[d],P[d].forward[d]=c;return!0}}static _randomLevel(E,S=.5){let A=1;for(;Math.random()<S&&A<E._maxLevel;)A+=1;return A}static _delete(E,S,A){let n=[],P=E._header;for(let c=E._level-1;c>=0;c--){for(;P.forward[c]&&A(P.forward[c].key,S)<0;)P=P.forward[c];n[c]=P}if(P=P.forward[0],!P||A(P.key,S)!==0)return!1;for(let c=0;c<E._level&&n[c].forward[c]===P;c++)n[c].forward[c]=P.forward[c];for(;E._level>0&&E._header.forward[E._level-1]===k;)E._level-=1;return!0}}e.SkipList=C}),define(me[46],ge([0,1,11]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=m.globals.performance&&typeof m.globals.performance.now=="function";class k{constructor(R){this._highResolution=L&&R,this._startTime=this._now(),this._stopTime=-1}static create(R=!0){return new k(R)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=k}),define(me[3],ge([0,1,16,75,6,95,46]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var E;(function(s){s.None=()=>k.Disposable.None;function o(K){return(U,z=null,N)=>{let x=!1,B;return B=K(O=>{if(!x)return B?B.dispose():x=!0,U.call(z,O)},null,N),x&&B.dispose(),B}}s.once=o;function p(K,U){return u((z,N=null,x)=>K(B=>z.call(N,U(B)),null,x))}s.map=p;function t(K,U){return u((z,N=null,x)=>K(B=>{U(B),z.call(N,B)},null,x))}s.forEach=t;function a(K,U){return u((z,N=null,x)=>K(B=>U(B)&&z.call(N,B),null,x))}s.filter=a;function r(K){return K}s.signal=r;function i(...K){return(U,z=null,N)=>(0,k.combinedDisposable)(...K.map(x=>x(B=>U.call(z,B),null,N)))}s.any=i;function l(K,U,z){let N=z;return p(K,x=>(N=U(N,x),N))}s.reduce=l;function u(K){let U;const z=new c({onFirstListenerAdd(){U=K(z.fire,z)},onLastListenerRemove(){U.dispose()}});return z.event}function f(K,U,z=100,N=!1,x){let B,O,H,W=0;const Q=new c({leakWarningThreshold:x,onFirstListenerAdd(){B=K(Y=>{W++,O=U(O,Y),N&&!H&&(Q.fire(O),O=void 0),clearTimeout(H),H=setTimeout(()=>{const he=O;O=void 0,H=void 0,(!N||W>1)&&Q.fire(he),W=0},z)})},onLastListenerRemove(){B.dispose()}});return Q.event}s.debounce=f;function b(K,U=(z,N)=>z===N){let z=!0,N;return a(K,x=>{const B=z||!U(x,N);return z=!1,N=x,B})}s.latch=b;function D(K,U){return[s.filter(K,U),s.filter(K,z=>!U(z))]}s.split=D;function w(K,U=!1,z=[]){let N=z.slice(),x=K(H=>{N?N.push(H):O.fire(H)});const B=()=>{N&&N.forEach(H=>O.fire(H)),N=null},O=new c({onFirstListenerAdd(){x||(x=K(H=>O.fire(H)))},onFirstListenerDidAdd(){N&&(U?setTimeout(B):B())},onLastListenerRemove(){x&&x.dispose(),x=null}});return O.event}s.buffer=w;class T{constructor(U){this.event=U}map(U){return new T(p(this.event,U))}forEach(U){return new T(t(this.event,U))}filter(U){return new T(a(this.event,U))}reduce(U,z){return new T(l(this.event,U,z))}latch(){return new T(b(this.event))}debounce(U,z=100,N=!1,x){return new T(f(this.event,U,z,N,x))}on(U,z,N){return this.event(U,z,N)}once(U,z,N){return o(this.event)(U,z,N)}}function v(K){return new T(K)}s.chain=v;function F(K,U,z=N=>N){const N=(...H)=>O.fire(z(...H)),x=()=>K.on(U,N),B=()=>K.removeListener(U,N),O=new c({onFirstListenerAdd:x,onLastListenerRemove:B});return O.event}s.fromNodeEventEmitter=F;function M(K,U,z=N=>N){const N=(...H)=>O.fire(z(...H)),x=()=>K.addEventListener(U,N),B=()=>K.removeEventListener(U,N),O=new c({onFirstListenerAdd:x,onLastListenerRemove:B});return O.event}s.fromDOMEventEmitter=M;function G(K){return new Promise(U=>o(K)(U))}s.toPromise=G})(E=e.Event||(e.Event={}));class S{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${S._idPool++}`}start(o){this._stopWatch=new R.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let A=-1;function n(s){const o=A;return A=s,{dispose(){A=o}}}e.setGlobalLeakWarningThreshold=n;class P{constructor(o,p=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=p,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o){let p=A;if(typeof this.customThreshold=="number"&&(p=this.customThreshold),p<=0||o<p)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),a=this._stacks.get(t)||0;if(this._stacks.set(t,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=p*.5;let r,i=0;for(const[l,u]of this._stacks)(!r||i<u)&&(r=l,i=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${i}):`),console.warn(r)}return()=>{const r=this._stacks.get(t)||0;this._stacks.set(t,r-1)}}}class c{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=A>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(o,p,t)=>{this._listeners||(this._listeners=new C.LinkedList);const a=this._listeners.isEmpty();a&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(p?[o,p]:o);a&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,p);const i=this._leakageMon?.check(this._listeners.size),l=(0,k.toDisposable)(()=>{i&&i(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof k.DisposableStore?t.add(l):Array.isArray(t)&&t.push(l),l}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let p of this._listeners)this._deliveryQueue.push([p,o]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[p,t]=this._deliveryQueue.shift();try{typeof p=="function"?p.call(void 0,t):p[0].call(p[1],t)}catch(a){(0,m.onUnexpectedError)(a)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=c;class h extends c{async fireAsync(o,p,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const a of this._listeners)this._asyncDeliveryQueue.push([a,o]);for(;this._asyncDeliveryQueue.size>0&&!p.isCancellationRequested;){const[a,r]=this._asyncDeliveryQueue.shift(),i=[],l={...r,waitUntil:u=>{if(Object.isFrozen(i))throw new Error("waitUntil can NOT be called asynchronous");t&&(u=t(u,typeof a=="function"?a:a[0])),i.push(u)}};try{typeof a=="function"?a.call(void 0,l):a[0].call(a[1],l)}catch(u){(0,m.onUnexpectedError)(u);continue}Object.freeze(i),await Promise.allSettled(i).then(u=>{for(const f of u)f.status==="rejected"&&(0,m.onUnexpectedError)(f.reason)})}}}}e.AsyncEmitter=h;class d extends c{constructor(o){super(o);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=d;class g extends d{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=g;class y{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const p={event:o,listener:null};this.events.push(p),this.hasListeners&&this.hook(p);const t=()=>{this.hasListeners&&this.unhook(p);const a=this.events.indexOf(p);this.events.splice(a,1)};return(0,k.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(p=>this.emitter.fire(p))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=y;class I{constructor(){this.buffers=[]}wrapEvent(o){return(p,t,a)=>o(r=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>p.call(t,r)):p.call(t,r)},void 0,a)}bufferEvents(o){const p=[];this.buffers.push(p);const t=o();return this.buffers.pop(),p.forEach(a=>a()),t}}e.EventBufferer=I;class _{constructor(){this.listening=!1,this.inputEvent=E.None,this.inputEventListener=k.Disposable.None,this.emitter=new c({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=_}),define(me[21],ge([0,1,3]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(E,S){const A=setTimeout(E.bind(S),0);return{dispose(){clearTimeout(A)}}});var k;(function(E){function S(A){return A===E.None||A===E.Cancelled||A instanceof C?!0:!A||typeof A!="object"?!1:typeof A.isCancellationRequested=="boolean"&&typeof A.onCancellationRequested=="function"}E.isCancellationToken=S,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(k=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class R{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=k.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=R}),define(me[47],ge([0,1,3]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(P){const c=this._icons.get(P.id);c?P.description?c.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new L;e.iconRegistry=k;function C(n,P){return new E(n,P)}e.registerCodicon=C;function R(n){return n?n.replace(/\$\((.*?)\)/g,(P,c)=>` ${c} `).trim():""}e.getCodiconAriaLabel=R;class E{constructor(P,c,h){this.id=P,this.definition=c,this.description=h,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=E;function S(n,P){const c=["codicon","codicon-"+n];return P&&c.push("codicon-modifier-"+P),c}e.getClassNamesArray=S;var A;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function c(g){if(g instanceof E)return["codicon","codicon-"+g.id];const y=P.exec(g.id);if(!y)return c(E.error);let[,I,_]=y;const s=["codicon","codicon-"+I];return _&&s.push("codicon-modifier-"+_.substr(1)),s}n.asClassNameArray=c;function h(g){return c(g).join(" ")}n.asClassName=h;function d(g){return"."+c(g).join(".")}n.asCSSSelector=d})(A=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(E=e.Codicon||(e.Codicon={}))}),define(me[96],ge([0,1,16,6]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(s){const o=s;return o?[o.on,o.pause,o.resume,o.destroy].every(p=>typeof p=="function"):!1}e.isReadableStream=k;function C(s){const o=s;return o?k(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=C;function R(s,o){return new E(s,o)}e.newWriteableStream=R;class E{constructor(o,p){this.reducer=o,this.options=p,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(p=>this.pendingWritePromises.push(p))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(p=>p(o))}emitError(o){this.listeners.error.length===0?(0,m.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(p=>p(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,p){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(p),this.resume();break;case"end":this.listeners.end.push(p),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(p),this.state.flowing&&this.flowErrors();break}}removeListener(o,p){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const a=t.indexOf(p);a>=0&&t.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const p=[...this.pendingWritePromises];this.pendingWritePromises.length=0,p.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(s,o){const p=[];let t;for(;(t=s.read())!==null;)p.push(t);return o(p)}e.consumeReadable=S;function A(s,o,p){const t=[];let a;for(;(a=s.read())!==null&&t.length<p;)t.push(a);return a===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof a!="undefined"){const r=a;return a=void 0,r}return s.read()}}}e.peekReadable=A;function n(s,o){return new Promise((p,t)=>{const a=[];P(s,{onData:r=>{o&&a.push(r)},onError:r=>{o?t(r):p(void 0)},onEnd:()=>{p(o?o(a):void 0)}})})}e.consumeStream=n;function P(s,o){s.on("error",p=>o.onError(p)),s.on("end",()=>o.onEnd()),s.on("data",p=>o.onData(p))}e.listenStream=P;function c(s,o){return new Promise((p,t)=>{const a=new L.DisposableStore,r=[],i=f=>{if(r.push(f),r.length>o)return a.dispose(),s.pause(),p({stream:s,buffer:r,ended:!1})},l=f=>t(f),u=()=>p({stream:s,buffer:r,ended:!0});a.add((0,L.toDisposable)(()=>s.removeListener("error",l))),s.on("error",l),a.add((0,L.toDisposable)(()=>s.removeListener("end",u))),s.on("end",u),a.add((0,L.toDisposable)(()=>s.removeListener("data",i))),s.on("data",i)})}e.peekStream=c;function h(s,o){const p=R(o);return p.end(s),p}e.toStream=h;function d(){const s=R(()=>{throw new Error("not supported")});return s.end(),s}e.emptyStream=d;function g(s){let o=!1;return{read:()=>o?null:(o=!0,s)}}e.toReadable=g;function y(s,o,p){const t=R(p);return P(s,{onData:a=>t.write(o.data(a)),onError:a=>t.error(o.error?o.error(a):a),onEnd:()=>t.end()}),t}e.transform=y;function I(s,o,p){let t=!1;return{read:()=>{const a=o.read();return t?a:(t=!0,a!==null?p([s,a]):s)}}}e.prefixedReadable=I;function _(s,o,p){let t=!1;const a=R(p);return P(o,{onData:r=>t?a.write(r):(t=!0,a.write(p([s,r]))),onError:r=>a.error(r),onEnd:()=>{t||(t=!0,a.write(s)),a.end()}}),a}e.prefixedStream=_}),define(me[23],ge([0,1,96]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let k,C;class R{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return L?new R(Buffer.allocUnsafe(i)):new R(new Uint8Array(i))}static wrap(i){return L&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new R(i)}static fromString(i,l){return!(l?.dontUseNodeBuffer||!1)&&L?new R(Buffer.from(i)):(k||(k=new TextEncoder),new R(k.encode(i)))}static concat(i,l){if(typeof l=="undefined"){l=0;for(let b=0,D=i.length;b<D;b++)l+=i[b].byteLength}const u=R.alloc(l);let f=0;for(let b=0,D=i.length;b<D;b++){const w=i[b];u.set(w,f),f+=w.byteLength}return u}toString(){return L?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(i,l){return new R(this.buffer.subarray(i,l))}set(i,l){i instanceof R?this.buffer.set(i.buffer,l):this.buffer.set(i,l)}readUInt32BE(i){return A(this.buffer,i)}writeUInt32BE(i,l){n(this.buffer,i,l)}readUInt32LE(i){return P(this.buffer,i)}writeUInt32LE(i,l){c(this.buffer,i,l)}readUInt8(i){return h(this.buffer,i)}writeUInt8(i,l){d(this.buffer,i,l)}}e.VSBuffer=R;function E(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0}e.readUInt16LE=E;function S(r,i,l){r[l+0]=i&255,i=i>>>8,r[l+1]=i&255}e.writeUInt16LE=S;function A(r,i){return r[i]*2**24+r[i+1]*2**16+r[i+2]*2**8+r[i+3]}e.readUInt32BE=A;function n(r,i,l){r[l+3]=i,i=i>>>8,r[l+2]=i,i=i>>>8,r[l+1]=i,i=i>>>8,r[l]=i}e.writeUInt32BE=n;function P(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0|r[i+2]<<16>>>0|r[i+3]<<24>>>0}e.readUInt32LE=P;function c(r,i,l){r[l+0]=i&255,i=i>>>8,r[l+1]=i&255,i=i>>>8,r[l+2]=i&255,i=i>>>8,r[l+3]=i&255}e.writeUInt32LE=c;function h(r,i){return r[i]}e.readUInt8=h;function d(r,i,l){r[l]=i}e.writeUInt8=d;function g(r){return m.consumeReadable(r,i=>R.concat(i))}e.readableToBuffer=g;function y(r){return m.toReadable(r)}e.bufferToReadable=y;function I(r){return m.consumeStream(r,i=>R.concat(i))}e.streamToBuffer=I;async function _(r){return r.ended?R.concat(r.buffer):R.concat([...r.buffer,await I(r.stream)])}e.bufferedStreamToBuffer=_;function s(r){return m.toStream(r,i=>R.concat(i))}e.bufferToStream=s;function o(r){return m.transform(r,{data:i=>typeof i=="string"?R.fromString(i):R.wrap(i)},i=>R.concat(i))}e.streamToBufferReadableStream=o;function p(r){return m.newWriteableStream(i=>R.concat(i),r)}e.newWriteableBufferStream=p;function t(r,i){return m.prefixedReadable(r,i,l=>R.concat(l))}e.prefixedBufferReadable=t;function a(r,i){return m.prefixedStream(r,i,l=>R.concat(l))}e.prefixedBufferStream=a}),define(me[9],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function m(ue){return!ue||typeof ue!="string"?!0:ue.trim().length===0}e.isFalsyOrWhitespace=m;const L=/{(\d+)}/g;function k(ue,...Ie){return Ie.length===0?ue:ue.replace(L,function(Be,Ke){const We=parseInt(Ke,10);return isNaN(We)||We<0||We>=Ie.length?Be:Ie[We]})}e.format=k;const C=/{([^}]+)}/g;function R(ue,Ie){return ue.replace(C,(Be,Ke)=>Ie[Ke]??Be)}e.format2=R;function E(ue){return ue.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=E;function S(ue){return ue.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function A(ue,Ie){let Be=0;const Ke=Ie.charCodeAt(0);for(let We=ue.length-1;We>=0;We--)ue.charCodeAt(We)===Ke&&Be++;return Be}e.count=A;function n(ue,Ie,Be="\u2026"){return ue.length<=Ie?ue:`${ue.substr(0,Ie)}${Be}`}e.truncate=n;function P(ue,Ie=" "){const Be=c(ue,Ie);return h(Be,Ie)}e.trim=P;function c(ue,Ie){if(!ue||!Ie)return ue;const Be=Ie.length;if(Be===0||ue.length===0)return ue;let Ke=0;for(;ue.indexOf(Ie,Ke)===Ke;)Ke=Ke+Be;return ue.substring(Ke)}e.ltrim=c;function h(ue,Ie){if(!ue||!Ie)return ue;const Be=Ie.length,Ke=ue.length;if(Be===0||Ke===0)return ue;let We=Ke,ot=-1;for(;ot=ue.lastIndexOf(Ie,We-1),!(ot===-1||ot+Be!==We);){if(ot===0)return"";We=ot}return ue.substring(0,We)}e.rtrim=h;function d(ue){return ue.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function g(ue){return ue.replace(/\*/g,"")}e.stripWildcards=g;function y(ue,Ie,Be={}){if(!ue)throw new Error("Cannot create regex from empty string");Ie||(ue=S(ue)),Be.wholeWord&&(/\B/.test(ue.charAt(0))||(ue="\\b"+ue),/\B/.test(ue.charAt(ue.length-1))||(ue=ue+"\\b"));let Ke="";return Be.global&&(Ke+="g"),Be.matchCase||(Ke+="i"),Be.multiline&&(Ke+="m"),Be.unicode&&(Ke+="u"),new RegExp(ue,Ke)}e.createRegExp=y;function I(ue){return ue.source==="^"||ue.source==="^$"||ue.source==="$"||ue.source==="^\\s*$"?!1:!!(ue.exec("")&&ue.lastIndex===0)}e.regExpLeadsToEndlessLoop=I;function _(ue){return!!ue.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=_;function s(ue){return(ue.global?"g":"")+(ue.ignoreCase?"i":"")+(ue.multiline?"m":"")+(ue.unicode?"u":"")}e.regExpFlags=s;function o(ue){return ue.split(/\r\n|\r|\n/)}e.splitLines=o;function p(ue){for(let Ie=0,Be=ue.length;Ie<Be;Ie++){const Ke=ue.charCodeAt(Ie);if(Ke!==32&&Ke!==9)return Ie}return-1}e.firstNonWhitespaceIndex=p;function t(ue,Ie=0,Be=ue.length){for(let Ke=Ie;Ke<Be;Ke++){const We=ue.charCodeAt(Ke);if(We!==32&&We!==9)return ue.substring(Ie,Ke)}return ue.substring(Ie,Be)}e.getLeadingWhitespace=t;function a(ue,Ie=ue.length-1){for(let Be=Ie;Be>=0;Be--){const Ke=ue.charCodeAt(Be);if(Ke!==32&&Ke!==9)return Be}return-1}e.lastNonWhitespaceIndex=a;function r(ue,Ie){return ue<Ie?-1:ue>Ie?1:0}e.compare=r;function i(ue,Ie,Be=0,Ke=ue.length,We=0,ot=Ie.length){for(;Be<Ke&&We<ot;Be++,We++){let ke=ue.charCodeAt(Be),ne=Ie.charCodeAt(We);if(ke<ne)return-1;if(ke>ne)return 1}const Le=Ke-Be,ye=ot-We;return Le<ye?-1:Le>ye?1:0}e.compareSubstring=i;function l(ue,Ie){return u(ue,Ie,0,ue.length,0,Ie.length)}e.compareIgnoreCase=l;function u(ue,Ie,Be=0,Ke=ue.length,We=0,ot=Ie.length){for(;Be<Ke&&We<ot;Be++,We++){let ke=ue.charCodeAt(Be),ne=Ie.charCodeAt(We);if(ke===ne)continue;const de=ke-ne;if(!(de===32&&b(ne))&&!(de===-32&&b(ke)))return f(ke)&&f(ne)?de:i(ue.toLowerCase(),Ie.toLowerCase(),Be,Ke,We,ot)}const Le=Ke-Be,ye=ot-We;return Le<ye?-1:Le>ye?1:0}e.compareSubstringIgnoreCase=u;function f(ue){return ue>=97&&ue<=122}e.isLowerAsciiLetter=f;function b(ue){return ue>=65&&ue<=90}e.isUpperAsciiLetter=b;function D(ue){return f(ue)||b(ue)}function w(ue,Ie){return ue.length===Ie.length&&T(ue,Ie)}e.equalsIgnoreCase=w;function T(ue,Ie,Be=ue.length){for(let Ke=0;Ke<Be;Ke++){const We=ue.charCodeAt(Ke),ot=Ie.charCodeAt(Ke);if(We!==ot){if(D(We)&&D(ot)){const Le=Math.abs(We-ot);if(Le!==0&&Le!==32)return!1}else if(String.fromCharCode(We).toLowerCase()!==String.fromCharCode(ot).toLowerCase())return!1}}return!0}function v(ue,Ie){const Be=Ie.length;return Ie.length>ue.length?!1:T(ue,Ie,Be)}e.startsWithIgnoreCase=v;function F(ue,Ie){let Be,Ke=Math.min(ue.length,Ie.length);for(Be=0;Be<Ke;Be++)if(ue.charCodeAt(Be)!==Ie.charCodeAt(Be))return Be;return Ke}e.commonPrefixLength=F;function M(ue,Ie){let Be,Ke=Math.min(ue.length,Ie.length);const We=ue.length-1,ot=Ie.length-1;for(Be=0;Be<Ke;Be++)if(ue.charCodeAt(We-Be)!==Ie.charCodeAt(ot-Be))return Be;return Ke}e.commonSuffixLength=M;function G(ue){return 55296<=ue&&ue<=56319}e.isHighSurrogate=G;function K(ue){return 56320<=ue&&ue<=57343}e.isLowSurrogate=K;function U(ue,Ie){return(ue-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=U;function z(ue,Ie,Be){const Ke=ue.charCodeAt(Be);if(G(Ke)&&Be+1<Ie){const We=ue.charCodeAt(Be+1);if(K(We))return U(Ke,We)}return Ke}e.getNextCodePoint=z;function N(ue,Ie){const Be=ue.charCodeAt(Ie-1);if(K(Be)&&Ie>1){const Ke=ue.charCodeAt(Ie-2);if(G(Ke))return U(Ke,Be)}return Be}function x(ue,Ie){const Be=pe.getInstance(),Ke=Ie,We=ue.length,ot=z(ue,We,Ie);Ie+=ot>=65536?2:1;let Le=Be.getGraphemeBreakType(ot);for(;Ie<We;){const ye=z(ue,We,Ie),ke=Be.getGraphemeBreakType(ye);if(X(Le,ke))break;Ie+=ye>=65536?2:1,Le=ke}return Ie-Ke}e.nextCharLength=x;function B(ue,Ie){const Be=pe.getInstance(),Ke=Ie,We=N(ue,Ie);Ie-=We>=65536?2:1;let ot=Be.getGraphemeBreakType(We);for(;Ie>0;){const Le=N(ue,Ie),ye=Be.getGraphemeBreakType(Le);if(X(ye,ot))break;Ie-=Le>=65536?2:1,ot=ye}return Ke-Ie}e.prevCharLength=B;function O(ue,Ie){const Be=pe.getInstance(),Ke=ue.length,We=Ie,ot=z(ue,Ke,Ie),Le=Be.getGraphemeBreakType(ot);Ie+=ot>=65536?2:1;let ye=Le;for(;Ie<Ke;){const ne=z(ue,Ke,Ie),de=Be.getGraphemeBreakType(ne);if(X(ye,de))break;Ie+=ne>=65536?2:1,ye=de}const ke=Ie;for(Ie=We,ye=Le;Ie>0;){const ne=N(ue,Ie),de=Be.getGraphemeBreakType(ne);if(X(de,ye))break;Ie-=ne>=65536?2:1,ye=de}return[Ie,ke]}function H(ue,Ie){return Ie>0&&K(ue.charCodeAt(Ie))?O(ue,Ie-1):O(ue,Ie)}e.getCharContainingOffset=H;const W=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(ue){return W.test(ue)}e.containsRTL=Q;const Y=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function he(ue){return Y.test(ue)}e.containsEmoji=he;const _e=/^[\t\n\r\x20-\x7E]*$/;function Se(ue){return _e.test(ue)}e.isBasicASCII=Se,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Re(ue){return e.UNUSUAL_LINE_TERMINATORS.test(ue)}e.containsUnusualLineTerminators=Re;function xe(ue){for(let Ie=0,Be=ue.length;Ie<Be;Ie++)if(Ue(ue.charCodeAt(Ie)))return!0;return!1}e.containsFullWidthCharacter=xe;function Ue(ue){return ue=+ue,ue>=11904&&ue<=55215||ue>=63744&&ue<=64255||ue>=65281&&ue<=65374}e.isFullWidthCharacter=Ue;function je(ue){return ue>=127462&&ue<=127487||ue===8986||ue===8987||ue===9200||ue===9203||ue>=9728&&ue<=10175||ue===11088||ue===11093||ue>=127744&&ue<=128591||ue>=128640&&ue<=128764||ue>=128992&&ue<=129003||ue>=129280&&ue<=129535||ue>=129648&&ue<=129750}e.isEmojiImprecise=je;function V(ue,Ie){if(ue.length<Ie)return ue;const Be=/\b/g;let Ke=0;for(;Be.test(ue)&&!(ue.length-Be.lastIndex<Ie);)Ke=Be.lastIndex,Be.lastIndex+=1;return ue.substring(Ke).replace(/^\s/,"")}e.lcut=V;const ee=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,le=/\x1b\[0?m/g;function Z(ue){return ue&&(ue=ue.replace(ee,""),ue=ue.replace(re,""),ue=ue.replace(le,"")),ue}e.removeAnsiEscapeCodes=Z,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function oe(ue){return!!(ue&&ue.length>0&&ue.charCodeAt(0)===65279)}e.startsWithUTF8BOM=oe;function ve(ue){return oe(ue)?ue.substr(1):ue}e.stripUTF8BOM=ve;function Me(ue,Ie){if(!ue||!Ie||ue.length<Ie.length)return!1;const Be=Ie.length,Ke=ue.toLowerCase();let We=0,ot=-1;for(;We<Be;){const Le=Ke.indexOf(Ie[We],ot+1);if(Le<0)return!1;ot=Le,We++}return!0}e.fuzzyContains=Me;function qe(ue,Ie=!1){return ue?(Ie&&(ue=ue.replace(/\\./g,"")),ue.toLowerCase()!==ue):!1}e.containsUppercaseCharacter=qe;function Qe(ue){return ue.charAt(0).toUpperCase()+ue.slice(1)}e.uppercaseFirstLetter=Qe;function Je(ue,Ie=1){if(Ie===0)return"";let Be=-1;do Be=ue.indexOf(`
`,Be+1),Ie--;while(Ie>0&&Be>=0);return Be===-1?ue:(ue[Be-1]==="\r"&&Be--,ue.substr(0,Be))}e.getNLines=Je;function Ce(ue){const Ie=90-65+1;return ue=ue%(2*Ie),ue<Ie?String.fromCharCode(97+ue):String.fromCharCode(65+ue-Ie)}e.singleLetterHash=Ce;function at(ue){return pe.getInstance().getGraphemeBreakType(ue)}e.getGraphemeBreakType=at;function X(ue,Ie){return ue===0?Ie!==5&&Ie!==7:ue===2&&Ie===3?!1:ue===4||ue===2||ue===3||Ie===4||Ie===2||Ie===3?!0:!(ue===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(ue===11||ue===9)&&(Ie===9||Ie===10)||(ue===12||ue===10)&&Ie===10||Ie===5||Ie===13||Ie===7||ue===1||ue===13&&Ie===14||ue===6&&Ie===6)}e.breakBetweenGraphemeBreakType=X;var te;(function(ue){ue[ue.Other=0]="Other",ue[ue.Prepend=1]="Prepend",ue[ue.CR=2]="CR",ue[ue.LF=3]="LF",ue[ue.Control=4]="Control",ue[ue.Extend=5]="Extend",ue[ue.Regional_Indicator=6]="Regional_Indicator",ue[ue.SpacingMark=7]="SpacingMark",ue[ue.L=8]="L",ue[ue.V=9]="V",ue[ue.T=10]="T",ue[ue.LV=11]="LV",ue[ue.LVT=12]="LVT",ue[ue.ZWJ=13]="ZWJ",ue[ue.Extended_Pictographic=14]="Extended_Pictographic"})(te=e.GraphemeBreakType||(e.GraphemeBreakType={}));class pe{constructor(){this._data=ze()}static getInstance(){return pe._INSTANCE||(pe._INSTANCE=new pe),pe._INSTANCE}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Be=this._data,Ke=Be.length/3;let We=1;for(;We<=Ke;)if(Ie<Be[3*We])We=2*We;else if(Ie>Be[3*We+1])We=2*We+1;else return Be[3*We+2];return 0}}pe._INSTANCE=null;function ze(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function tt(ue,Ie){if(ue===0)return 0;const Be=ut(ue,Ie);if(Be!==void 0)return Be;const Ke=N(Ie,ue);return ue-=lt(Ke),ue}e.getLeftDeleteOffset=tt;function ut(ue,Ie){let Be=N(Ie,ue);for(ue-=lt(Be);vt(Be)||Be===65039||Be===8419;){if(ue===0)return;Be=N(Ie,ue),ue-=lt(Be)}if(!!je(Be)){if(ue>=0){const Ke=N(Ie,ue);Ke===8205&&(ue-=lt(Ke))}return ue}}function lt(ue){return ue>=65536?2:1}function vt(ue){return 127995<=ue&&ue<=127999}var Dt;(function(ue){ue[ue.zwj=8205]="zwj",ue[ue.emojiVariantSelector=65039]="emojiVariantSelector",ue[ue.enclosingKeyCap=8419]="enclosingKeyCap"})(Dt||(Dt={}))}),define(me[48],ge([0,1,9]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(I){return k(I,0)}e.hash=L;function k(I,_){switch(typeof I){case"object":return I===null?C(349,_):Array.isArray(I)?S(I,_):A(I,_);case"string":return E(I,_);case"boolean":return R(I,_);case"number":return C(I,_);case"undefined":return C(937,_);default:return C(617,_)}}e.doHash=k;function C(I,_){return(_<<5)-_+I|0}function R(I,_){return C(I?433:863,_)}function E(I,_){_=C(149417,_);for(let s=0,o=I.length;s<o;s++)_=C(I.charCodeAt(s),_);return _}e.stringHash=E;function S(I,_){return _=C(104579,_),I.reduce((s,o)=>k(o,s),_)}function A(I,_){return _=C(181387,_),Object.keys(I).sort().reduce((s,o)=>(s=E(o,s),k(I[o],s)),_)}class n{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=k(_,this._value),this._value}}e.Hasher=n;var P;(function(I){I[I.BLOCK_SIZE=64]="BLOCK_SIZE",I[I.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function c(I,_,s=32){const o=s-_,p=~((1<<o)-1);return(I<<_|(p&I)>>>o)>>>0}function h(I,_=0,s=I.byteLength,o=0){for(let p=0;p<s;p++)I[_+p]=o}function d(I,_,s="0"){for(;I.length<_;)I=s+I;return I}function g(I,_=32){return I instanceof ArrayBuffer?Array.from(new Uint8Array(I)).map(s=>s.toString(16).padStart(2,"0")).join(""):d((I>>>0).toString(16),_/4)}e.toHexString=g;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const s=_.length;if(s===0)return;const o=this._buff;let p=this._buffLen,t=this._leftoverHighSurrogate,a,r;for(t!==0?(a=t,r=-1,t=0):(a=_.charCodeAt(0),r=0);;){let i=a;if(m.isHighSurrogate(a))if(r+1<s){const l=_.charCodeAt(r+1);m.isLowSurrogate(l)?(r++,i=m.computeCodePoint(a,l)):i=65533}else{t=a;break}else m.isLowSurrogate(a)&&(i=65533);if(p=this._push(o,p,i),r++,r<s)a=_.charCodeAt(r);else break}this._buffLen=p,this._leftoverHighSurrogate=t}_push(_,s,o){return o<128?_[s++]=o:o<2048?(_[s++]=192|(o&1984)>>>6,_[s++]=128|(o&63)>>>0):o<65536?(_[s++]=224|(o&61440)>>>12,_[s++]=128|(o&4032)>>>6,_[s++]=128|(o&63)>>>0):(_[s++]=240|(o&1835008)>>>18,_[s++]=128|(o&258048)>>>12,_[s++]=128|(o&4032)>>>6,_[s++]=128|(o&63)>>>0),s>=64&&(this._step(),s-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),s}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=y._bigBlock32,s=this._buffDV;for(let f=0;f<64;f+=4)_.setUint32(f,s.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)_.setUint32(f,c(_.getUint32(f-12,!1)^_.getUint32(f-32,!1)^_.getUint32(f-56,!1)^_.getUint32(f-64,!1),1),!1);let o=this._h0,p=this._h1,t=this._h2,a=this._h3,r=this._h4,i,l,u;for(let f=0;f<80;f++)f<20?(i=p&t|~p&a,l=1518500249):f<40?(i=p^t^a,l=1859775393):f<60?(i=p&t|p&a|t&a,l=2400959708):(i=p^t^a,l=3395469782),u=c(o,5)+i+r+l+_.getUint32(f*4,!1)&4294967295,r=a,a=t,t=c(p,30),p=o,o=u;this._h0=this._h0+o&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[49],ge([0,1,9]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(L||(L={})),function(k){const C="error",R="warning",E="warn",S="info",A="ignore";function n(c){return c?m.equalsIgnoreCase(C,c)?k.Error:m.equalsIgnoreCase(R,c)||m.equalsIgnoreCase(E,c)?k.Warning:m.equalsIgnoreCase(S,c)?k.Info:k.Ignore:k.Ignore}k.fromValue=n;function P(c){switch(c){case k.Error:return C;case k.Warning:return R;case k.Info:return S;default:return A}}k.toString=P}(L||(L={})),e.default=L}),define(me[13],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(b){return Array.isArray(b)}e.isArray=m;function L(b){return typeof b=="string"}e.isString=L;function k(b){return Array.isArray(b)&&b.every(D=>L(D))}e.isStringArray=k;function C(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}e.isObject=C;function R(b){return typeof b=="number"&&!isNaN(b)}e.isNumber=R;function E(b){return!!b&&typeof b[Symbol.iterator]=="function"}e.isIterable=E;function S(b){return b===!0||b===!1}e.isBoolean=S;function A(b){return typeof b=="undefined"}e.isUndefined=A;function n(b){return!P(b)}e.isDefined=n;function P(b){return A(b)||b===null}e.isUndefinedOrNull=P;function c(b,D){if(!b)throw new Error(D?`Unexpected type, expected '${D}'`:"Unexpected type")}e.assertType=c;function h(b){if(P(b))throw new Error("Assertion Failed: argument is undefined or null");return b}e.assertIsDefined=h;function d(...b){const D=[];for(let w=0;w<b.length;w++){const T=b[w];if(P(T))throw new Error(`Assertion Failed: argument at index ${w} is undefined or null`);D.push(T)}return D}e.assertAllDefined=d;const g=Object.prototype.hasOwnProperty;function y(b){if(!C(b))return!1;for(let D in b)if(g.call(b,D))return!1;return!0}e.isEmptyObject=y;function I(b){return typeof b=="function"}e.isFunction=I;function _(...b){return b.length>0&&b.every(I)}e.areFunctions=_;function s(b,D){const w=Math.min(b.length,D.length);for(let T=0;T<w;T++)o(b[T],D[T])}e.validateConstraints=s;function o(b,D){if(L(D)){if(typeof b!==D)throw new Error(`argument does not match constraint: typeof ${D}`)}else if(I(D)){try{if(b instanceof D)return}catch{}if(!P(b)&&b.constructor===D||D.length===1&&D.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function p(b){let D=[],w=Object.getPrototypeOf(b);for(;Object.prototype!==w;)D=D.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return D}e.getAllPropertyNames=p;function t(b){const D=[];for(const w of p(b))typeof b[w]=="function"&&D.push(w);return D}e.getAllMethodNames=t;function a(b,D){const w=v=>function(){const F=Array.prototype.slice.call(arguments,0);return D(v,F)};let T={};for(const v of b)T[v]=w(v);return T}e.createProxyObject=a;function r(b){return b===null?void 0:b}e.withNullAsUndefined=r;function i(b){return typeof b=="undefined"?null:b}e.withUndefinedAsNull=i;function l(b){return class{constructor(){return new Proxy({},{get(D,w){if(D[w])return D[w];throw new Error(`Not Implemented: ${b}->${String(w)}`)}})}}}e.NotImplementedProxy=l;function u(b,D="Unreachable"){throw new Error(D)}e.assertNever=u;function f(b){return!!b&&typeof b.then=="function"&&typeof b.catch=="function"}e.isPromise=f}),define(me[29],ge([0,1,8,11,9,13]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(r){return r===47||r===92}e.isPathSeparator=R;function E(r){return r.replace(/[\\/]/g,m.posix.sep)}e.toSlashes=E;function S(r){return r.indexOf("/")===-1&&(r=E(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=S;function A(r,i=m.posix.sep){if(!r)return"";const l=r.length,u=r.charCodeAt(0);if(R(u)){if(R(r.charCodeAt(1))&&!R(r.charCodeAt(2))){let b=3;const D=b;for(;b<l&&!R(r.charCodeAt(b));b++);if(D!==b&&!R(r.charCodeAt(b+1))){for(b+=1;b<l;b++)if(R(r.charCodeAt(b)))return r.slice(0,b+1).replace(/[\\/]/g,i)}}return i}else if(I(u)&&r.charCodeAt(1)===58)return R(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<l;f++)if(R(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.getRoot=A;function n(r){if(!L.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let l=2;const u=l;for(;l<r.length&&(i=r.charCodeAt(l),i!==92);l++);return!(u===l||(i=r.charCodeAt(l+1),isNaN(i)||i===92))}e.isUNC=n;const P=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,i=L.isWindows){const l=i?P:c;return!(!r||r.length===0||/^\s+$/.test(r)||(l.lastIndex=0,l.test(r))||i&&h.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=d;function g(r,i,l){const u=r===i;return!l||u?u:!r||!i?!1:(0,k.equalsIgnoreCase)(r,i)}e.isEqual=g;function y(r,i,l,u=m.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(l){if(!(0,k.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let b=i.length;return i.charAt(i.length-1)===u&&b--,r.charAt(b)===u}return i.charAt(i.length-1)!==u&&(i+=u),r.indexOf(i)===0}e.isEqualOrParent=y;function I(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=I;function _(r,i){return L.isWindows&&r.endsWith(":")&&(r+=m.sep),(0,m.isAbsolute)(r)||(r=(0,m.join)(i,r)),r=(0,m.normalize)(r),L.isWindows?(r=(0,k.rtrim)(r,m.sep),r.endsWith(":")&&(r+=m.sep)):(r=(0,k.rtrim)(r,m.sep),r||(r=m.sep)),r}e.sanitizeFilePath=_;function s(r){const i=(0,m.normalize)(r);return L.isWindows?r.length>3?!1:o(i)&&(r.length===2||i.charCodeAt(2)===92):i===m.posix.sep}e.isRootOrDriveLetter=s;function o(r){return L.isWindows?I(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function p(r){return o(r)?r[0]:void 0}e.getDriveLetter=p;function t(r,i,l){return i.length>r.length?-1:r===i?0:(l&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=t;function a(r){const i=r.split(":");let l,u,f;if(i.forEach(b=>{const D=Number(b);(0,C.isNumber)(D)?u===void 0?u=D:f===void 0&&(f=D):l=l?[l,b].join(":"):b}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:u!==void 0?u:void 0,column:f!==void 0?f:u!==void 0?1:void 0}}e.parseLineAndColumnAware=a}),define(me[25],ge([0,1,13]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const y=Array.isArray(g)?[]:{};return Object.keys(g).forEach(I=>{g[I]&&typeof g[I]=="object"?y[I]=L(g[I]):y[I]=g[I]}),y}e.deepClone=L;function k(g){if(!g||typeof g!="object")return g;const y=[g];for(;y.length>0;){const I=y.shift();Object.freeze(I);for(const _ in I)if(C.call(I,_)){const s=I[_];typeof s=="object"&&!Object.isFrozen(s)&&y.push(s)}}return g}e.deepFreeze=k;const C=Object.prototype.hasOwnProperty;function R(g,y){return E(g,y,new Set)}e.cloneAndChange=R;function E(g,y,I){if((0,m.isUndefinedOrNull)(g))return g;const _=y(g);if(typeof _!="undefined")return _;if((0,m.isArray)(g)){const s=[];for(const o of g)s.push(E(o,y,I));return s}if((0,m.isObject)(g)){if(I.has(g))throw new Error("Cannot clone recursive data-structure");I.add(g);const s={};for(let o in g)C.call(g,o)&&(s[o]=E(g[o],y,I));return I.delete(g),s}return g}function S(g,y,I=!0){return(0,m.isObject)(g)?((0,m.isObject)(y)&&Object.keys(y).forEach(_=>{_ in g?I&&((0,m.isObject)(g[_])&&(0,m.isObject)(y[_])?S(g[_],y[_],I):g[_]=y[_]):g[_]=y[_]}),g):y}e.mixin=S;function A(g,y){if(g===y)return!0;if(g==null||y===null||y===void 0||typeof g!=typeof y||typeof g!="object"||Array.isArray(g)!==Array.isArray(y))return!1;let I,_;if(Array.isArray(g)){if(g.length!==y.length)return!1;for(I=0;I<g.length;I++)if(!A(g[I],y[I]))return!1}else{const s=[];for(_ in g)s.push(_);s.sort();const o=[];for(_ in y)o.push(_);if(o.sort(),!A(s,o))return!1;for(I=0;I<s.length;I++)if(!A(g[s[I]],y[s[I]]))return!1}return!0}e.equals=A;function n(g){const y=new Set;return JSON.stringify(g,(I,_)=>{if((0,m.isObject)(_)||Array.isArray(_)){if(y.has(_))return"[Circular]";y.add(_)}return _})}e.safeStringify=n;function P(g,y,I){const _=y(g);return typeof _=="undefined"?I:_}e.getOrDefault=P;function c(g,y){const I=Object.create(null);return!g||!y||Object.keys(y).forEach(s=>{const o=g[s],p=y[s];A(o,p)||(I[s]=p)}),I}e.distinct=c;function h(g,y){const I=y.toLowerCase(),_=Object.keys(g).find(s=>s.toLowerCase()===I);return _?g[_]:g[y]}e.getCaseInsensitive=h;function d(g,y){const I=Object.create(null);for(const _ of Object.keys(g))y(_,g[_])&&(I[_]=g[_]);return I}e.filter=d}),define(me[97],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var m;(function(C){C[C.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",C[C.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",C[C.MAX_UINT_8=255]="MAX_UINT_8",C[C.MAX_UINT_16=65535]="MAX_UINT_16",C[C.MAX_UINT_32=4294967295]="MAX_UINT_32",C[C.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m=e.Constants||(e.Constants={}));function L(C){return C<0?0:C>255?255:C|0}e.toUint8=L;function k(C){return C<0?0:C>4294967295?4294967295:C|0}e.toUint32=k}),define(me[2],ge([0,1,8,11]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,C=/^\//,R=/^\/\//;function E(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!k.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!C.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(r,i){return!r&&!i?"file":r}function A(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==P&&(i=P+i):i=P;break}return i}const n="",P="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(i,l,u,f,b,D=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=S(i,D),this.authority=l||n,this.path=A(this.scheme,u||n),this.query=f||n,this.fragment=b||n,E(this,D))}static isUri(i){return i instanceof h?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return s(this,!1)}with(i){if(!i)return this;let{scheme:l,authority:u,path:f,query:b,fragment:D}=i;return l===void 0?l=this.scheme:l===null&&(l=n),u===void 0?u=this.authority:u===null&&(u=n),f===void 0?f=this.path:f===null&&(f=n),b===void 0?b=this.query:b===null&&(b=n),D===void 0?D=this.fragment:D===null&&(D=n),l===this.scheme&&u===this.authority&&f===this.path&&b===this.query&&D===this.fragment?this:new g(l,u,f,b,D)}static parse(i,l=!1){const u=c.exec(i);return u?new g(u[2]||n,a(u[4]||n),a(u[5]||n),a(u[7]||n),a(u[9]||n),l):new g(n,n,n,n,n)}static file(i){let l=n;if(L.isWindows&&(i=i.replace(/\\/g,P)),i[0]===P&&i[1]===P){const u=i.indexOf(P,2);u===-1?(l=i.substring(2),i=P):(l=i.substring(2,u),i=i.substring(u)||P)}return new g("file",l,i,n,n)}static from(i){const l=new g(i.scheme,i.authority,i.path,i.query,i.fragment);return E(l,!0),l}static joinPath(i,...l){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return L.isWindows&&i.scheme==="file"?u=h.file(m.win32.join(s(i,!0),...l)).path:u=m.posix.join(i.path,...l),i.with({path:u})}toString(i=!1){return o(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof h)return i;{const l=new g(i);return l._formatted=i.external,l._fsPath=i._sep===d?i.fsPath:null,l}}else return i}}e.URI=h;const d=L.isWindows?1:void 0;class g extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(i=!1){return i?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=d),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function I(r,i){let l,u=-1;for(let f=0;f<r.length;f++){const b=r.charCodeAt(f);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||i&&b===47)u!==-1&&(l+=encodeURIComponent(r.substring(u,f)),u=-1),l!==void 0&&(l+=r.charAt(f));else{l===void 0&&(l=r.substr(0,f));const D=y[b];D!==void 0?(u!==-1&&(l+=encodeURIComponent(r.substring(u,f)),u=-1),l+=D):u===-1&&(u=f)}}return u!==-1&&(l+=encodeURIComponent(r.substring(u))),l!==void 0?l:r}function _(r){let i;for(let l=0;l<r.length;l++){const u=r.charCodeAt(l);u===35||u===63?(i===void 0&&(i=r.substr(0,l)),i+=y[u]):i!==void 0&&(i+=r[l])}return i!==void 0?i:r}function s(r,i){let l;return r.authority&&r.path.length>1&&r.scheme==="file"?l=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?l=r.path.substr(1):l=r.path[1].toLowerCase()+r.path.substr(2):l=r.path,L.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=s;function o(r,i){const l=i?_:I;let u="",{scheme:f,authority:b,path:D,query:w,fragment:T}=r;if(f&&(u+=f,u+=":"),(b||f==="file")&&(u+=P,u+=P),b){let v=b.indexOf("@");if(v!==-1){const F=b.substr(0,v);b=b.substr(v+1),v=F.indexOf(":"),v===-1?u+=l(F,!1):(u+=l(F.substr(0,v),!1),u+=":",u+=l(F.substr(v+1),!1)),u+="@"}b=b.toLowerCase(),v=b.indexOf(":"),v===-1?u+=l(b,!1):(u+=l(b.substr(0,v),!1),u+=b.substr(v))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const v=D.charCodeAt(1);v>=65&&v<=90&&(D=`/${String.fromCharCode(v+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const v=D.charCodeAt(0);v>=65&&v<=90&&(D=`${String.fromCharCode(v+32)}:${D.substr(2)}`)}u+=l(D,!0)}return w&&(u+="?",u+=l(w,!1)),T&&(u+="#",u+=i?T:I(T,!1)),u}function p(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+p(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(r){return r.match(t)?r.replace(t,i=>p(i)):r}});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,m):k?k.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[24],ge([0,1,17,9,2]),function(J,e,m,L,k){"use strict";var C,R,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(a,r,i){let l=a.get(r);return l===void 0&&(l=i,a.set(r,l)),l}e.getOrSet=S;function A(a){const r=[];return a.forEach((i,l)=>{r.push(`${l} => ${i}`)}),`Map(${a.size}) {${r.join(", ")}}`}e.mapToString=A;function n(a){const r=[];return a.forEach(i=>{r.push(i)}),`Set(${a.size}) {${r.join(", ")}}`}e.setToString=n;class P{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),l=this._value.charCodeAt(this._pos);return i-l}value(){return this._value[this._pos]}}e.StringIterator=P;class c{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=c;class h{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=h;var d;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(d||(d={}));class g{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new h(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class y{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class I{constructor(r){this._iter=r}static forUris(r=()=>!1){return new I(new g(r))}static forPaths(){return new I(new h)}static forStrings(){return new I(new P)}static forConfigKeys(){return new I(new c)}clear(){this._root=void 0}set(r,i){const l=this._iter.reset(r);let u;for(this._root||(this._root=new y,this._root.segment=l.value()),u=this._root;;){const b=l.cmp(u.segment);if(b>0)u.left||(u.left=new y,u.left.segment=l.value()),u=u.left;else if(b<0)u.right||(u.right=new y,u.right.segment=l.value()),u=u.right;else if(l.hasNext())l.next(),u.mid||(u.mid=new y,u.mid.segment=l.value()),u=u.mid;else break}const f=u.value;return u.value=i,u.key=r,f}fill(r,i){const l=i.slice(0);(0,m.shuffle)(l);for(let u of l)this.set(u,r)}get(r){return this._getNode(r)?.value}_getNode(r){const i=this._iter.reset(r);let l=this._root;for(;l;){const u=i.cmp(l.segment);if(u>0)l=l.left;else if(u<0)l=l.right;else if(i.hasNext())i.next(),l=l.mid;else break}return l}has(r){const i=this._getNode(r);return!(i?.value===void 0&&i?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const l=this._iter.reset(r),u=[];let f=this._root;for(;f;){const b=l.cmp(f.segment);if(b>0)u.push([1,f]),f=f.left;else if(b<0)u.push([-1,f]),f=f.right;else if(l.hasNext())l.next(),u.push([0,f]),f=f.mid;else{for(i?(f.left=void 0,f.mid=void 0,f.right=void 0):f.value=void 0;u.length>0&&f.isEmpty();){let[D,w]=u.pop();switch(D){case 1:w.left=void 0;break;case 0:w.mid=void 0;break;case-1:w.right=void 0;break}f=w}break}}}findSubstr(r){const i=this._iter.reset(r);let l=this._root,u;for(;l;){const f=i.cmp(l.segment);if(f>0)l=l.left;else if(f<0)l=l.right;else if(i.hasNext())i.next(),u=l.value||u,l=l.mid;else break}return l&&l.value||u}findSuperstr(r){const i=this._iter.reset(r);let l=this._root;for(;l;){const u=i.cmp(l.segment);if(u>0)l=l.left;else if(u<0)l=l.right;else if(i.hasNext())i.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(r){for(const[i,l]of this)r(l,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const i=[r];for(;i.length>0;){const l=i.pop();l&&(l.value&&(yield[l.key,l.value]),l.left&&i.push(l.left),l.mid&&i.push(l.mid),l.right&&i.push(l.right))}}}e.TernarySearchTree=I;class _{constructor(r,i){this[C]="ResourceMap",r instanceof _?(this.map=new Map(r.map),this.toKey=i??_.defaultToKey):(this.map=new Map,this.toKey=r??_.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[l,u]of this.map)r(u,k.URI.parse(l),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield k.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[k.URI.parse(r[0]),r[1]]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[k.URI.parse(r[0]),r[1]]}}e.ResourceMap=_,_.defaultToKey=a=>a.toString();var s;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(s=e.Touch||(e.Touch={}));class o{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,i=0){const l=this._map.get(r);if(!!l)return i!==0&&this.touch(l,i),l.value}set(r,i,l=0){let u=this._map.get(r);if(u)u.value=i,l!==0&&this.touch(u,l);else{switch(u={key:r,value:i,next:void 0,previous:void 0},l){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(r,u),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const l=this._state;let u=this._head;for(;u;){if(i?r.bind(i)(u.value,u.key,this):r(u.value,u.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,i=this._state;let l=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(l){const f={value:l.key,done:!1};return l=l.next,f}else return{value:void 0,done:!0}}};return u}values(){const r=this,i=this._state;let l=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(l){const f={value:l.value,done:!1};return l=l.next,f}else return{value:void 0,done:!0}}};return u}entries(){const r=this,i=this._state;let l=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(l){const f={value:[l.key,l.value],done:!1};return l=l.next,f}else return{value:void 0,done:!0}}};return u}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,l=this.size;for(;i&&l>r;)this._map.delete(i.key),i=i.next,l--;this._head=i,this._size=l,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,l=r.previous;if(!i||!l)throw new Error("Invalid list");i.previous=l,l.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const l=r.next,u=r.previous;r===this._tail?(u.next=void 0,this._tail=u):(l.previous=u,u.next=l),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const l=r.next,u=r.previous;r===this._head?(l.previous=void 0,this._head=l):(l.previous=u,u.next=l),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,l)=>{r.push([l,i])}),r}fromJSON(r){this.clear();for(const[i,l]of r)this.set(i,l)}}e.LinkedMap=o;class p extends o{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=p;class t{constructor(r){E.set(this,void 0),nt(this,E,r,"f")}get size(){return Oe(this,E,"f").size}forEach(r,i){Oe(this,E,"f").forEach(r,i)}get(r){return Oe(this,E,"f").get(r)}has(r){return Oe(this,E,"f").has(r)}entries(){return Oe(this,E,"f").entries()}keys(){return Oe(this,E,"f").keys()}values(){return Oe(this,E,"f").values()}[(E=new WeakMap,Symbol.iterator)](){return Oe(this,E,"f").entries()}}e.ReadonlyMapView=t}),define(me[98],ge([0,1,24,9]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...Z){return function(oe,ve){for(let Me=0,qe=Z.length;Me<qe;Me++){const Qe=Z[Me](oe,ve);if(Qe)return Qe}return null}}e.or=k,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(Z,oe,ve){if(!ve||ve.length<oe.length)return null;let Me;return Z?Me=L.startsWithIgnoreCase(ve,oe):Me=ve.indexOf(oe)===0,Me?oe.length>0?[{start:0,end:oe.length}]:[]:null}function R(Z,oe){const ve=oe.toLowerCase().indexOf(Z.toLowerCase());return ve===-1?null:[{start:ve,end:ve+Z.length}]}e.matchesContiguousSubString=R;function E(Z,oe){return S(Z.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=E;function S(Z,oe,ve,Me){if(ve===Z.length)return[];if(Me===oe.length)return null;if(Z[ve]===oe[Me]){let qe=null;return(qe=S(Z,oe,ve+1,Me+1))?I({start:Me,end:Me+1},qe):null}return S(Z,oe,ve,Me+1)}function A(Z){return 97<=Z&&Z<=122}function n(Z){return 65<=Z&&Z<=90}e.isUpper=n;function P(Z){return 48<=Z&&Z<=57}function c(Z){return Z===32||Z===9||Z===10||Z===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Z=>h.add(Z.charCodeAt(0)));function d(Z){return c(Z)||h.has(Z)}function g(Z,oe){return Z===oe||d(Z)&&d(oe)}function y(Z){return A(Z)||n(Z)||P(Z)}function I(Z,oe){return oe.length===0?oe=[Z]:Z.end===oe[0].start?oe[0].start=Z.start:oe.unshift(Z),oe}function _(Z,oe){for(let ve=oe;ve<Z.length;ve++){const Me=Z.charCodeAt(ve);if(n(Me)||P(Me)||ve>0&&!y(Z.charCodeAt(ve-1)))return ve}return Z.length}function s(Z,oe,ve,Me){if(ve===Z.length)return[];if(Me===oe.length)return null;if(Z[ve]!==oe[Me].toLowerCase())return null;{let qe=null,Qe=Me+1;for(qe=s(Z,oe,ve+1,Me+1);!qe&&(Qe=_(oe,Qe))<oe.length;)qe=s(Z,oe,ve+1,Qe),Qe++;return qe===null?null:I({start:Me,end:Me+1},qe)}}function o(Z){let oe=0,ve=0,Me=0,qe=0,Qe=0;for(let te=0;te<Z.length;te++)Qe=Z.charCodeAt(te),n(Qe)&&oe++,A(Qe)&&ve++,y(Qe)&&Me++,P(Qe)&&qe++;const Je=oe/Z.length,Ce=ve/Z.length,at=Me/Z.length,X=qe/Z.length;return{upperPercent:Je,lowerPercent:Ce,alphaPercent:at,numericPercent:X}}function p(Z){const{upperPercent:oe,lowerPercent:ve}=Z;return ve===0&&oe>.6}function t(Z){const{upperPercent:oe,lowerPercent:ve,alphaPercent:Me,numericPercent:qe}=Z;return ve>.2&&oe<.8&&Me>.6&&qe<.2}function a(Z){let oe=0,ve=0,Me=0,qe=0;for(let Qe=0;Qe<Z.length;Qe++)Me=Z.charCodeAt(Qe),n(Me)&&oe++,A(Me)&&ve++,c(Me)&&qe++;return(oe===0||ve===0)&&qe===0?Z.length<=30:oe<=5}function r(Z,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!a(Z)||oe.length>60)return null;const ve=o(oe);if(!t(ve)){if(!p(ve))return null;oe=oe.toLowerCase()}let Me=null,qe=0;for(Z=Z.toLowerCase();qe<oe.length&&(Me=s(Z,oe,0,qe))===null;)qe=_(oe,qe+1);return Me}e.matchesCamelCase=r;function i(Z,oe,ve=!1){if(!oe||oe.length===0)return null;let Me=null,qe=0;for(Z=Z.toLowerCase(),oe=oe.toLowerCase();qe<oe.length&&(Me=l(Z,oe,0,qe,ve))===null;)qe=u(oe,qe+1);return Me}e.matchesWords=i;function l(Z,oe,ve,Me,qe){if(ve===Z.length)return[];if(Me===oe.length)return null;if(g(Z.charCodeAt(ve),oe.charCodeAt(Me))){let Qe=null,Je=Me+1;if(Qe=l(Z,oe,ve+1,Me+1,qe),!qe)for(;!Qe&&(Je=u(oe,Je))<oe.length;)Qe=l(Z,oe,ve+1,Je,qe),Je++;return Qe===null?null:I({start:Me,end:Me+1},Qe)}else return null}function u(Z,oe){for(let ve=oe;ve<Z.length;ve++)if(d(Z.charCodeAt(ve))||ve>0&&d(Z.charCodeAt(ve-1)))return ve;return Z.length}const f=k(e.matchesPrefix,r,R),b=k(e.matchesPrefix,r,E),D=new m.LRUCache(1e4);function w(Z,oe,ve=!1){if(typeof Z!="string"||typeof oe!="string")return null;let Me=D.get(Z);Me||(Me=new RegExp(L.convertSimple2RegExpPattern(Z),"i"),D.set(Z,Me));const qe=Me.exec(oe);return qe?[{start:qe.index,end:qe.index+qe[0].length}]:ve?b(Z,oe):f(Z,oe)}e.matchesFuzzy=w;function T(Z,oe){const ve=xe(Z,Z.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return ve?F(ve):null}e.matchesFuzzy2=T;function v(Z,oe,ve,Me,qe,Qe){const Je=Math.min(13,Z.length);for(;ve<Je;ve++){const Ce=xe(Z,oe,ve,Me,qe,Qe,!1);if(Ce)return Ce}return[0,Qe]}e.anyScore=v;function F(Z){if(typeof Z=="undefined")return[];const oe=[],ve=Z[1];for(let Me=Z.length-1;Me>1;Me--){const qe=Z[Me]+ve,Qe=oe[oe.length-1];Qe&&Qe.end===qe?Qe.end=qe+1:oe.push({start:qe,end:qe+1})}return oe}e.createMatches=F;const M=128;function G(){const Z=[],oe=[];for(let ve=0;ve<=M;ve++)oe[ve]=0;for(let ve=0;ve<=M;ve++)Z.push(oe.slice(0));return Z}function K(Z){const oe=[];for(let ve=0;ve<=Z;ve++)oe[ve]=0;return oe}const U=K(2*M),z=K(2*M),N=G(),x=G(),B=G(),O=!1;function H(Z,oe,ve,Me,qe){function Qe(Ce,at,X=" "){for(;Ce.length<at;)Ce=X+Ce;return Ce}let Je=` |   |${Me.split("").map(Ce=>Qe(Ce,3)).join("|")}
`;for(let Ce=0;Ce<=ve;Ce++)Ce===0?Je+=" |":Je+=`${oe[Ce-1]}|`,Je+=Z[Ce].slice(0,qe+1).map(at=>Qe(at.toString(),3)).join("|")+`
`;return Je}function W(Z,oe,ve,Me){Z=Z.substr(oe),ve=ve.substr(Me),console.log(H(x,Z,Z.length,ve,ve.length)),console.log(H(B,Z,Z.length,ve,ve.length)),console.log(H(N,Z,Z.length,ve,ve.length))}function Q(Z,oe){if(oe<0||oe>=Z.length)return!1;const ve=Z.codePointAt(oe);switch(ve){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(ve)}}function Y(Z,oe){if(oe<0||oe>=Z.length)return!1;switch(Z.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function he(Z,oe,ve){return oe[Z]!==ve[Z]}function _e(Z,oe,ve,Me,qe,Qe,Je=!1){for(;oe<ve&&qe<Qe;)Z[oe]===Me[qe]&&(Je&&(U[oe]=qe),oe+=1),qe+=1;return oe===ve}e.isPatternInWord=_e;var Se;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(Se||(Se={}));var Re;(function(Z){Z.Default=[-100,0];function oe(ve){return!ve||ve.length===2&&ve[0]===-100&&ve[1]===0}Z.isDefault=oe})(Re=e.FuzzyScore||(e.FuzzyScore={}));function xe(Z,oe,ve,Me,qe,Qe,Je){const Ce=Z.length>M?M:Z.length,at=Me.length>M?M:Me.length;if(ve>=Ce||Qe>=at||Ce-ve>at-Qe||!_e(oe,ve,Ce,qe,Qe,at,!0))return;Ue(Ce,at,ve,Qe,oe,qe);let X=1,te=1,pe=ve,ze=Qe;const tt=[!1];for(X=1,pe=ve;pe<Ce;X++,pe++){const ue=U[pe],Ie=z[pe],Be=pe+1<Ce?z[pe+1]:at;for(te=ue-Qe+1,ze=ue;ze<Be;te++,ze++){let Ke=Number.MIN_SAFE_INTEGER,We=!1;ze<=Ie&&(Ke=je(Z,oe,pe,ve,Me,qe,ze,at,Qe,N[X-1][te-1]===0,tt));let ot=0;Ke!==Number.MAX_SAFE_INTEGER&&(We=!0,ot=Ke+x[X-1][te-1]);const Le=ze>ue,ye=Le?x[X][te-1]+(N[X][te-1]>0?-5:0):0,ke=ze>ue+1&&N[X][te-1]>0,ne=ke?x[X][te-2]+(N[X][te-2]>0?-5:0):0;if(ke&&(!Le||ne>=ye)&&(!We||ne>=ot))x[X][te]=ne,B[X][te]=3,N[X][te]=0;else if(Le&&(!We||ye>=ot))x[X][te]=ye,B[X][te]=2,N[X][te]=0;else if(We)x[X][te]=ot,B[X][te]=1,N[X][te]=N[X-1][te-1]+1;else throw new Error("not possible")}}if(O&&W(Z,ve,Me,Qe),!tt[0]&&!Je)return;X--,te--;const ut=[x[X][te],Qe];let lt=0,vt=0;for(;X>=1;){let ue=te;do{const Ie=B[X][ue];if(Ie===3)ue=ue-2;else if(Ie===2)ue=ue-1;else break}while(ue>=1);lt>1&&oe[ve+X-1]===qe[Qe+te-1]&&!he(ue+Qe-1,Me,qe)&&lt+1>N[X][ue]&&(ue=te),ue===te?lt++:lt=1,vt||(vt=ue),X--,te=ue-1,ut.push(te)}at===Ce&&(ut[0]+=2);const Dt=vt-Ce;return ut[0]-=Dt,ut}e.fuzzyScore=xe;function Ue(Z,oe,ve,Me,qe,Qe){let Je=Z-1,Ce=oe-1;for(;Je>=ve&&Ce>=Me;)qe[Je]===Qe[Ce]&&(z[Je]=Ce,Je--),Ce--}function je(Z,oe,ve,Me,qe,Qe,Je,Ce,at,X,te){if(oe[ve]!==Qe[Je])return Number.MIN_SAFE_INTEGER;let pe=1,ze=!1;return Je===ve-Me?pe=Z[ve]===qe[Je]?7:5:he(Je,qe,Qe)&&(Je===0||!he(Je-1,qe,Qe))?(pe=Z[ve]===qe[Je]?7:5,ze=!0):Q(Qe,Je)&&(Je===0||!Q(Qe,Je-1))?pe=5:(Q(Qe,Je-1)||Y(Qe,Je-1))&&(pe=5,ze=!0),pe>1&&ve===Me&&(te[0]=!0),ze||(ze=he(Je,qe,Qe)||Q(Qe,Je-1)||Y(Qe,Je-1)),ve===Me?Je>at&&(pe-=ze?3:5):X?pe+=ze?2:0:pe+=ze?0:1,Je+1===Ce&&(pe-=ze?3:5),pe}function V(Z,oe,ve,Me,qe,Qe,Je){return re(Z,oe,ve,Me,qe,Qe,!0,Je)}e.fuzzyScoreGracefulAggressive=V;function ee(Z,oe,ve,Me,qe,Qe,Je){return re(Z,oe,ve,Me,qe,Qe,!1,Je)}e.fuzzyScoreGraceful=ee;function re(Z,oe,ve,Me,qe,Qe,Je,Ce){let at=xe(Z,oe,ve,Me,qe,Qe,Ce);if(at&&!Je)return at;if(Z.length>=3){const X=Math.min(7,Z.length-1);for(let te=ve+1;te<X;te++){const pe=le(Z,te);if(pe){const ze=xe(pe,pe.toLowerCase(),ve,Me,qe,Qe,Ce);ze&&(ze[0]-=3,(!at||ze[0]>at[0])&&(at=ze))}}}return at}function le(Z,oe){if(oe+1>=Z.length)return;const ve=Z[oe],Me=Z[oe+1];if(ve!==Me)return Z.slice(0,oe)+Me+ve+Z.slice(oe+2)}}),define(me[142],ge([0,1,47,98,9]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${C.source}`,"g");function E(g){return g.replace(R,(y,I)=>I?y:`\\${y}`)}e.escapeIcons=E;const S=new RegExp(`\\\\${C.source}`,"g");function A(g){return g.replace(S,y=>`\\${y}`)}e.markdownEscapeEscapedIcons=A;const n=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function P(g){return g.indexOf(e.iconStartMarker)===-1?g:g.replace(n,(y,I,_,s)=>_?y:I||s||"")}e.stripIcons=P;function c(g){const y=g.indexOf(e.iconStartMarker);return y===-1?{text:g}:h(g,y)}e.parseLabelWithIcons=c;function h(g,y){const I=[];let _="";function s(u){if(u){_+=u;for(const f of u)I.push(t)}}let o=-1,p="",t=0,a,r,i=y;const l=g.length;for(s(g.substr(0,y));i<l;)a=g[i],r=g[i+1],a===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(o=i,s(p),p=e.iconStartMarker,i++):a===")"&&o!==-1?(t+=i-o+1,o=-1,p=""):o!==-1?/^[a-z0-9\-]$/i.test(a)?p+=a:(s(p),o=-1,p=""):s(a),i++;return s(p),{text:_,iconOffsets:I}}function d(g,y,I=!1){const{text:_,iconOffsets:s}=y;if(!s||s.length===0)return(0,L.matchesFuzzy)(g,_,I);const o=(0,k.ltrim)(_," "),p=_.length-o.length,t=(0,L.matchesFuzzy)(g,o,I);if(t)for(const a of t){const r=s[a.start+p]+p;a.start+=r,a.end+=r}return t}e.matchesFuzzyIconAware=d}),define(me[99],ge([0,1,16,142]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(h="",d=!1){if(this.value=h,typeof this.value!="string")throw(0,m.illegalArgument)("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=d.isTrusted??void 0,this.supportThemeIcons=d.supportThemeIcons??!1,this.supportHtml=d.supportHtml??!1)}appendText(h,d=0){return this.value+=A(this.supportThemeIcons?(0,L.escapeIcons)(h):h).replace(/([ \t]+)/g,(g,y)=>"&nbsp;".repeat(y.length)).replace(/\>/gm,"\\>").replace(/\n/g,d===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,d){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=d,this.value+="\n```\n",this}}e.MarkdownString=C;function R(c){return E(c)?!c.value:Array.isArray(c)?c.every(R):!0}e.isEmptyMarkdownString=R;function E(c){return c instanceof C?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=E;function S(c,h){return c===h?!0:!c||!h?!1:c.value===h.value&&c.isTrusted===h.isTrusted&&c.supportThemeIcons===h.supportThemeIcons}e.markdownStringEqual=S;function A(c){return c.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=A;function n(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function P(c){const h=[],d=c.split("|").map(y=>y.trim());c=d[0];const g=d[1];if(g){const y=/height=(\d+)/.exec(g),I=/width=(\d+)/.exec(g),_=y?y[1]:"",s=I?I[1]:"",o=isFinite(parseInt(s)),p=isFinite(parseInt(_));o&&h.push(`width="${s}"`),p&&h.push(`height="${_}"`)}return{href:c,dimensions:h}}e.parseHrefAndDimensions=P}),define(me[60],ge([0,1,23,9,2]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(n){return JSON.stringify(n,S)}e.stringify=C;function R(n){let P=JSON.parse(n);return P=A(P),P}e.parse=R;var E;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(E=e.MarshalledId||(e.MarshalledId={}));function S(n,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,L.regExpFlags)(P)}:P}function A(n,P=0){if(!n||P>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return k.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof m.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let c=0;c<n.length;++c)n[c]=A(n[c],P+1);else for(const c in n)Object.hasOwnProperty.call(n,c)&&(n[c]=A(n[c],P+1))}return n}e.revive=A}),define(me[10],ge([0,1,11,2]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.userData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,A,n){this._hosts[S]=A,this._ports[S]=n}setConnectionToken(S,A){this._connectionTokens[S]=A}rewrite(S){if(this._delegate)return this._delegate(S);const A=S.authority;let n=this._hosts[A];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const P=this._ports[A],c=this._connectionTokens[A];let h=`path=${encodeURIComponent(S.path)}`;return typeof c=="string"&&(h+=`&tkn=${encodeURIComponent(c)}`),L.URI.from({scheme:m.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${n}:${P}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new C;class R{asBrowserUri(S,A){const n=this.toUri(S,A);return n.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===k.file&&(m.isNative||typeof m.globals.importScripts=="function"&&m.globals.origin===`${k.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`)?n.with({scheme:k.vscodeFileResource,authority:n.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(S,A){const n=this.toUri(S,A);return n.scheme===k.vscodeFileResource?n.with({scheme:k.file,authority:n.authority!==R.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(S,A){return L.URI.isUri(S)?S:L.URI.parse(A.toUrl(S))}}R.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new R}),define(me[78],ge([0,1,24]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new m.LRUCache(1e4);function k(A){return S(A,"NFC",L)}e.normalizeNFC=k;const C=new m.LRUCache(1e4);function R(A){return S(A,"NFD",C)}e.normalizeNFD=R;const E=/[^\u0000-\u0080]/;function S(A,n,P){if(!A)return A;const c=P.get(A);if(c)return c;let h;return E.test(A)?h=A.normalize(n):h=A,P.set(A,h),h}e.removeAccents=function(){const A=/[\u0300-\u036f]/g;return function(n){return R(n).replace(A,"")}}()}),define(me[22],ge([0,1,29,10,8,11,9,2]),function(J,e,m,L,k,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(h){return(0,E.uriToFsPath)(h,!0)}e.originalFSPath=S;class A{constructor(d){this._ignorePathCasing=d}compare(d,g,y=!1){return d===g?0:(0,R.compare)(this.getComparisonKey(d,y),this.getComparisonKey(g,y))}isEqual(d,g,y=!1){return d===g?!0:!d||!g?!1:this.getComparisonKey(d,y)===this.getComparisonKey(g,y)}getComparisonKey(d,g=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,g,y=!1){if(d.scheme===g.scheme){if(d.scheme===L.Schemas.file)return m.isEqualOrParent(S(d),S(g),this._ignorePathCasing(d))&&d.query===g.query&&(y||d.fragment===g.fragment);if((0,e.isEqualAuthority)(d.authority,g.authority))return m.isEqualOrParent(d.path,g.path,this._ignorePathCasing(d),"/")&&d.query===g.query&&(y||d.fragment===g.fragment)}return!1}joinPath(d,...g){return E.URI.joinPath(d,...g)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return k.posix.basename(d.path)}extname(d){return k.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let g;return d.scheme===L.Schemas.file?g=E.URI.file(k.dirname(S(d))).path:(g=k.posix.dirname(d.path),d.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),g="/")),d.with({path:g})}normalizePath(d){if(!d.path.length)return d;let g;return d.scheme===L.Schemas.file?g=E.URI.file(k.normalize(S(d))).path:g=k.posix.normalize(d.path),d.with({path:g})}relativePath(d,g){if(d.scheme!==g.scheme||!(0,e.isEqualAuthority)(d.authority,g.authority))return;if(d.scheme===L.Schemas.file){const _=k.relative(S(d),S(g));return C.isWindows?m.toSlashes(_):_}let y=d.path||"/",I=g.path||"/";if(this._ignorePathCasing(d)){let _=0;for(const s=Math.min(y.length,I.length);_<s&&!(y.charCodeAt(_)!==I.charCodeAt(_)&&y.charAt(_).toLowerCase()!==I.charAt(_).toLowerCase());_++);y=I.substr(0,_)+y.substr(_)}return k.posix.relative(y,I)}resolvePath(d,g){if(d.scheme===L.Schemas.file){const y=E.URI.file(k.resolve(S(d),g));return d.with({authority:y.authority,path:y.path})}return g=m.toPosixPath(g),d.with({path:k.posix.resolve(d.path,g)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,g){return d===g||(0,R.equalsIgnoreCase)(d,g)}hasTrailingPathSeparator(d,g=k.sep){if(d.scheme===L.Schemas.file){const y=S(d);return y.length>m.getRoot(y).length&&y[y.length-1]===g}else{const y=d.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,g=k.sep){return(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,g=k.sep){let y=!1;if(d.scheme===L.Schemas.file){const I=S(d);y=I!==void 0&&I.length===m.getRoot(I).length&&I[I.length-1]===g}else{g="/";const I=d.path;y=I.length===1&&I.charCodeAt(I.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path+"/"}):d}}e.ExtUri=A,e.extUri=new A(()=>!1),e.extUriBiasedIgnorePathCase=new A(h=>h.scheme===L.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new A(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(h,d){const g=[];for(let y=0;y<h.length;y++){const I=d(h[y]);h.some((_,s)=>s===y?!1:(0,e.isEqualOrParent)(I,d(_)))||g.push(h[y])}return g}e.distinctParents=n;var P;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function d(g){const y=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(s=>{const[o,p]=s.split(":");o&&p&&y.set(o,p)});const _=g.path.substring(0,g.path.indexOf(";"));return _&&y.set(h.META_DATA_MIME,_),y}h.parseMetaData=d})(P=e.DataUri||(e.DataUri={}));function c(h,d,g){if(d){let y=h.path;return y&&y[0]!==k.posix.sep&&(y=k.posix.sep+y),h.with({scheme:g,authority:d,path:y})}return h.with({scheme:g})}e.toLocalResource=c}),define(me[18],ge([0,1,21,16,3,6,22]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(N){return!!N&&typeof N.then=="function"}e.isThenable=E;function S(N){const x=new m.CancellationTokenSource,B=N(x.token),O=new Promise((H,W)=>{const Q=x.token.onCancellationRequested(()=>{Q.dispose(),x.dispose(),W((0,L.canceled)())});Promise.resolve(B).then(Y=>{Q.dispose(),x.dispose(),H(Y)},Y=>{Q.dispose(),x.dispose(),W(Y)})});return new class{cancel(){x.cancel()}then(H,W){return O.then(H,W)}catch(H){return this.then(void 0,H)}finally(H){return O.finally(H)}}}e.createCancelablePromise=S;function A(N,x,B){return Promise.race([N,new Promise(O=>x.onCancellationRequested(()=>O(B)))])}e.raceCancellation=A;async function n(N){let x=-1;const B=N.map((H,W)=>H.then(Q=>(x=W,Q))),O=await Promise.race(B);return N.forEach((H,W)=>{W!==x&&H.cancel()}),O}e.raceCancellablePromises=n;function P(N,x,B){let O;const H=setTimeout(()=>{O?.(void 0),B?.()},x);return Promise.race([N.finally(()=>clearTimeout(H)),new Promise(W=>O=W)])}e.raceTimeout=P;function c(N){return new Promise((x,B)=>{const O=N();E(O)?O.then(x,B):x(O)})}e.asPromise=c;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(x){if(this.activePromise){if(this.queuedPromiseFactory=x,!this.queuedPromise){const B=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(B,B).then(O)})}return new Promise((B,O)=>{this.queuedPromise.then(B,O)})}return this.activePromise=x(),new Promise((B,O)=>{this.activePromise.then(H=>{this.activePromise=null,B(H)},H=>{this.activePromise=null,O(H)})})}}e.Throttler=h;class d{constructor(){this.current=Promise.resolve(null)}queue(x){return this.current=this.current.then(()=>x(),()=>x())}}e.Sequencer=d;class g{constructor(){this.promiseMap=new Map}queue(x,B){const H=(this.promiseMap.get(x)??Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.promiseMap.get(x)===H&&this.promiseMap.delete(x)});return this.promiseMap.set(x,H),H}}e.SequencerByKey=g;class y{constructor(x){this.defaultDelay=x,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(x,B=this.defaultDelay){return this.task=x,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,H)=>{this.doResolve=O,this.doReject=H}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},B),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=y;class I{constructor(x){this.delayer=new y(x),this.throttler=new h}trigger(x,B){return this.delayer.trigger(()=>this.throttler.queue(x),B)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=I;class _{constructor(){this._isOpen=!1,this._promise=new Promise((x,B)=>{this._completePromise=x})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=_;class s extends _{constructor(x){super();this._timeout=setTimeout(()=>this.open(),x)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function o(N,x){return x?new Promise((B,O)=>{const H=setTimeout(()=>{W.dispose(),B()},N),W=x.onCancellationRequested(()=>{clearTimeout(H),W.dispose(),O((0,L.canceled)())})}):S(B=>o(N,B))}e.timeout=o;function p(N,x=0){const B=setTimeout(N,x);return(0,C.toDisposable)(()=>clearTimeout(B))}e.disposableTimeout=p;function t(N){const x=[];let B=0;const O=N.length;function H(){return B<O?N[B++]():null}function W(Q){Q!=null&&x.push(Q);const Y=H();return Y?Y.then(W):Promise.resolve(x)}return Promise.resolve(null).then(W)}e.sequence=t;function a(N,x=O=>!!O,B=null){let O=0;const H=N.length,W=()=>{if(O>=H)return Promise.resolve(B);const Q=N[O++];return Promise.resolve(Q()).then(he=>x(he)?Promise.resolve(he):W())};return W()}e.first=a;function r(N,x=O=>!!O,B=null){if(N.length===0)return Promise.resolve(B);let O=N.length;const H=()=>{O=-1;for(const W of N)W.cancel?.()};return new Promise((W,Q)=>{for(const Y of N)Y.then(he=>{--O>=0&&x(he)?(H(),W(he)):O===0&&W(B)}).catch(he=>{--O>=0&&(H(),Q(he))})})}e.firstParallel=r;class i{constructor(x){this._size=0,this.maxDegreeOfParalellism=x,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(x){return this._size++,new Promise((B,O)=>{this.outstandingPromises.push({factory:x,c:B,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const x=this.outstandingPromises.shift();this.runningPromises++;const B=x.factory();B.then(x.c,x.e),B.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class l extends i{constructor(){super(1)}}e.Queue=l;class u{constructor(){this.queues=new Map}queueFor(x,B=R.extUri){const O=B.getComparisonKey(x);let H=this.queues.get(O);return H||(H=new l,k.Event.once(H.onFinished)(()=>{H?.dispose(),this.queues.delete(O)}),this.queues.set(O,H)),H}dispose(){this.queues.forEach(x=>x.dispose()),this.queues.clear()}}e.ResourceQueue=u;class f{constructor(x,B){this._token=-1,typeof x=="function"&&typeof B=="number"&&this.setIfNotSet(x,B)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(x,B){this.cancel(),this._token=setTimeout(()=>{this._token=-1,x()},B)}setIfNotSet(x,B){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,x()},B))}}e.TimeoutTimer=f;class b{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(x,B){this.cancel(),this._token=setInterval(()=>{x()},B)}}e.IntervalTimer=b;class D{constructor(x,B){this.timeoutToken=-1,this.runner=x,this.timeout=B,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(x=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,x)}get delay(){return this.timeout}set delay(x){this.timeout=x}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=D;class w{constructor(x,B){B%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.runner=x,this.timeout=B,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(x=this.timeout){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(x/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=w;class T extends D{constructor(x,B){super(x,B);this.units=[]}work(x){this.units.push(x),this.isScheduled()||this.schedule()}doRun(){const x=this.units;this.units=[],this.runner&&this.runner(x)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=T;class v extends C.Disposable{constructor(x,B,O,H){super();this.maxWorkChunkSize=x,this.maxPendingWork=B,this.throttleDelay=O,this.handler=H,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(x){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+x.length>this.maxPendingWork)return!1}else if(this.pending+x.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...x),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new D(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=v,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const N=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=x=>{const B=setTimeout(()=>x(N));let O=!1;return{dispose(){O||(O=!0,clearTimeout(B))}}}}else e.runWhenIdle=(N,x)=>{const B=requestIdleCallback(N,typeof x=="number"?{timeout:x}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(B))}}}}();class F{constructor(x){this._didRun=!1,this._executor=()=>{try{this._value=x()}catch(B){this._error=B}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=F;async function M(N,x,B){let O;for(let H=0;H<B;H++)try{return await N()}catch(W){O=W,await o(x)}throw O}e.retry=M;class G{hasPending(x){return this._pending?typeof x=="number"?this._pending.taskId===x:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(x,B,O){return this._pending={taskId:x,cancel:()=>O?.(),promise:B},B.then(()=>this.donePending(x),()=>this.donePending(x)),B}donePending(x){this._pending&&x===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const x=this._next;this._next=void 0,x.run().then(x.promiseResolve,x.promiseReject)}}setNext(x){if(this._next)this._next.run=x;else{let B,O;const H=new Promise((W,Q)=>{B=W,O=Q});this._next={run:x,promise:H,promiseResolve:B,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=G;class K{constructor(x){this.interval=x,this.lastIncrementTime=0,this.value=0}increment(){const x=Date.now();return x-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=x,this.value=0),this.value++,this.value}}e.IntervalCounter=K;class U{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((x,B)=>{this.completeCallback=x,this.errorCallback=B})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(x){return new Promise(B=>{this.completeCallback(x),this.resolved=!0,B()})}error(x){return new Promise(B=>{this.errorCallback(x),this.rejected=!0,B()})}cancel(){new Promise(x=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,x()})}}e.DeferredPromise=U;var z;(function(N){async function x(B){let O;const H=await Promise.all(B.map(W=>W.then(Q=>Q,Q=>{O||(O=Q)})));if(typeof O!="undefined")throw O;return H}N.settled=x})(z=e.Promises||(e.Promises={}))}),define(me[100],ge([0,1,18,8]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new m.IdleValue(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),C=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function E(D,w,T=!1){const v=D||"",F=w||"",M=k.value.collator.compare(v,F);return k.value.collatorIsNumeric&&M===0&&v!==F?v<F?-1:1:M}e.compareFileNames=E;function S(D,w){const T=C.value.collator;return D=D||"",w=w||"",p(T,D,w)}e.compareFileNamesDefault=S;function A(D,w){const T=C.value.collator;return D=D||"",w=w||"",i(D,w)||p(T,D,w)}e.compareFileNamesUpper=A;function n(D,w){const T=C.value.collator;return D=D||"",w=w||"",r(D,w)||p(T,D,w)}e.compareFileNamesLower=n;function P(D,w){return D=D||"",w=w||"",D===w?0:D<w?-1:1}e.compareFileNamesUnicode=P;function c(D,w,T=!1){T||(D=D&&D.toLowerCase(),w=w&&w.toLowerCase());const[v,F]=s(D),[M,G]=s(w);return v!==M?v<M?-1:1:F===G?0:F<G?-1:1}e.noIntlCompareFileNames=c;function h(D,w){const[T,v]=s(D),[F,M]=s(w);let G=k.value.collator.compare(v,M);if(G===0){if(k.value.collatorIsNumeric&&v!==M)return v<M?-1:1;if(G=k.value.collator.compare(T,F),k.value.collatorIsNumeric&&G===0&&T!==F)return T<F?-1:1}return G}e.compareFileExtensions=h;function d(D,w){D=D||"",w=w||"";const T=o(D),v=o(w),F=C.value.collator,M=R.value.collator;return p(M,T,v)||p(F,D,w)}e.compareFileExtensionsDefault=d;function g(D,w){D=D||"",w=w||"";const T=o(D),v=o(w),F=C.value.collator,M=R.value.collator;return p(M,T,v)||i(D,w)||p(F,D,w)}e.compareFileExtensionsUpper=g;function y(D,w){D=D||"",w=w||"";const T=o(D),v=o(w),F=C.value.collator,M=R.value.collator;return p(M,T,v)||r(D,w)||p(F,D,w)}e.compareFileExtensionsLower=y;function I(D,w){D=D||"",w=w||"";const T=o(D).toLowerCase(),v=o(w).toLowerCase();return T!==v?T<v?-1:1:D!==w?D<w?-1:1:0}e.compareFileExtensionsUnicode=I;const _=/^(.*?)(\.([^.]*))?$/;function s(D,w=!1){const T=D?_.exec(D):[];let v=[T&&T[1]||"",T&&T[3]||""];return w&&(!v[0]&&v[1]||v[0]&&v[0].charAt(0)===".")&&(v=[v[0]+"."+v[1],""]),v}function o(D){const w=D?_.exec(D):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function p(D,w,T){let v=D.compare(w,T);return v!==0?v:w.length!==T.length?w.length<T.length?-1:1:0}function t(D){const w=D.charAt(0);return w.toLocaleUpperCase()!==w}function a(D){const w=D.charAt(0);return w.toLocaleLowerCase()!==w}function r(D,w){return t(D)&&a(w)?-1:a(D)&&t(w)?1:0}function i(D,w){return a(D)&&t(w)?-1:t(D)&&a(w)?1:0}function l(D,w,T=!1){return T||(D=D&&D.toLowerCase(),w=w&&w.toLowerCase()),D===w?0:D<w?-1:1}function u(D,w,T=!1){const v=D.split(L.sep),F=w.split(L.sep),M=v.length-1,G=F.length-1;let K,U;for(let z=0;;z++){if(K=M===z,U=G===z,K&&U)return E(v[z],F[z],T);if(K)return-1;if(U)return 1;const N=l(v[z],F[z],T);if(N!==0)return N}}e.comparePaths=u;function f(D,w,T){const v=D.toLowerCase(),F=w.toLowerCase(),M=b(D,w,T);if(M)return M;const G=v.endsWith(T),K=F.endsWith(T);if(G!==K)return G?-1:1;const U=E(v,F);return U!==0?U:v.localeCompare(F)}e.compareAnything=f;function b(D,w,T){const v=D.toLowerCase(),F=w.toLowerCase(),M=v.startsWith(T),G=F.startsWith(T);if(M!==G)return M?-1:1;if(M&&G){if(v.length<F.length)return-1;if(v.length>F.length)return 1}return 0}e.compareByPrefix=b}),define(me[101],ge([0,1,100,98,48,8,11,9]),function(J,e,m,L,k,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,A=[S,[]];function n(N,x,B,O){if(!N||!x)return A;const H=N.length,W=x.length;if(H<W)return A;const Q=N.toLowerCase();return P(x,B,W,N,Q,H,O)}e.scoreFuzzy=n;function P(N,x,B,O,H,W,Q){const Y=[],he=[];for(let xe=0;xe<B;xe++){const Ue=xe*W,je=Ue-W,V=xe>0,ee=N[xe],re=x[xe];for(let le=0;le<W;le++){const Z=le>0,oe=Ue+le,ve=oe-1,Me=je+le-1,qe=Z?Y[ve]:0,Qe=V&&Z?Y[Me]:0,Je=V&&Z?he[Me]:0;let Ce;!Qe&&V?Ce=0:Ce=c(ee,re,O,H,le,Je),Ce&&Qe+Ce>=qe&&(Q||V||H.startsWith(x,le))?(he[oe]=Je+1,Y[oe]=Qe+Ce):(he[oe]=S,Y[oe]=qe)}}const _e=[];let Se=B-1,Re=W-1;for(;Se>=0&&Re>=0;){const xe=Se*W+Re;he[xe]===S||(_e.push(Re),Se--),Re--}return[Y[B*W-1],_e.reverse()]}function c(N,x,B,O,H,W){let Q=0;if(!h(x,O[H]))return Q;if(Q+=1,W>0&&(Q+=W*5),N===B[H]&&(Q+=1),H===0)Q+=8;else{const Y=d(B.charCodeAt(H-1));Y?Q+=Y:(0,L.isUpper)(B.charCodeAt(H))&&(Q+=2)}return Q}function h(N,x){return N===x?!0:N==="/"||N==="\\"?x==="/"||x==="\\":!1}function d(N){switch(N){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const g=[void 0,[]];function y(N,x,B=0,O=0){const H=x;return H.values&&H.values.length>1?I(N,H.values,B,O):_(N,x,B,O)}e.scoreFuzzy2=y;function I(N,x,B,O){let H=0;const W=[];for(const Q of x){const[Y,he]=_(N,Q,B,O);if(typeof Y!="number")return g;H+=Y,W.push(...he)}return[H,b(W)]}function _(N,x,B,O){const H=(0,L.fuzzyScore)(x.original,x.originalLowercase,B,N,N.toLowerCase(),O,!0);return H?[H[0],(0,L.createMatches)(H)]:g}const s=Object.freeze({score:0}),o=1<<18,p=1<<17,t=1<<16;function a(N,x,B,O){const H=O.values?O.values:[O];return(0,k.hash)({[O.normalized]:{values:H.map(Q=>({value:Q.normalized,expectContiguousMatch:Q.expectContiguousMatch})),label:N,description:x,allowNonContiguousMatches:B}})}function r(N,x,B,O,H){if(!N||!x.normalized)return s;const W=O.getItemLabel(N);if(!W)return s;const Q=O.getItemDescription(N),Y=a(W,Q,B,x),he=H[Y];if(he)return he;const _e=i(W,Q,O.getItemPath(N),x,B);return H[Y]=_e,_e}e.scoreItemFuzzy=r;function i(N,x,B,O,H){const W=!B||!O.containsPathSeparator;return B&&(R.isLinux?O.pathNormalized===B:(0,E.equalsIgnoreCase)(O.pathNormalized,B))?{score:o,labelMatch:[{start:0,end:N.length}],descriptionMatch:x?[{start:0,end:x.length}]:void 0}:O.values&&O.values.length>1?l(N,x,B,O.values,W,H):u(N,x,B,O,W,H)}function l(N,x,B,O,H,W){let Q=0;const Y=[],he=[];for(const _e of O){const{score:Se,labelMatch:Re,descriptionMatch:xe}=u(N,x,B,_e,H,W);if(Se===S)return s;Q+=Se,Re&&Y.push(...Re),xe&&he.push(...xe)}return{score:Q,labelMatch:b(Y),descriptionMatch:b(he)}}function u(N,x,B,O,H,W){if(H||!x){const[Q,Y]=n(N,O.normalized,O.normalizedLowercase,W&&!O.expectContiguousMatch);if(Q){const he=(0,L.matchesPrefix)(O.normalized,N);let _e;return he?(_e=p,_e+=Math.round(O.normalized.length/N.length*100)):_e=t,{score:_e+Q,labelMatch:he||f(Y)}}}if(x){let Q=x;B&&(Q=`${x}${C.sep}`);const Y=Q.length,he=`${Q}${N}`,[_e,Se]=n(he,O.normalized,O.normalizedLowercase,W&&!O.expectContiguousMatch);if(_e){const Re=f(Se),xe=[],Ue=[];return Re.forEach(je=>{je.start<Y&&je.end>Y?(xe.push({start:0,end:je.end-Y}),Ue.push({start:je.start,end:Y})):je.start>=Y?xe.push({start:je.start-Y,end:je.end-Y}):Ue.push(je)}),{score:_e,labelMatch:xe,descriptionMatch:Ue}}}return s}function f(N){const x=[];if(!N)return x;let B;for(const O of N)B&&B.end===O?B.end+=1:(B={start:O,end:O+1},x.push(B));return x}function b(N){const x=N.sort((H,W)=>H.start-W.start),B=[];let O;for(const H of x)!O||!D(O,H)?(O=H,B.push(H)):(O.start=Math.min(O.start,H.start),O.end=Math.max(O.end,H.end));return B}function D(N,x){return!(N.end<x.start||x.end<N.start)}function w(N,x,B,O,H,W){const Q=r(N,B,O,H,W),Y=r(x,B,O,H,W),he=Q.score,_e=Y.score;if((he===o||_e===o)&&he!==_e)return he===o?-1:1;if(he>t||_e>t){if(he!==_e)return he>_e?-1:1;if(he<p&&_e<p){const ee=v(Q.labelMatch,Y.labelMatch);if(ee!==0)return ee}const je=H.getItemLabel(N)||"",V=H.getItemLabel(x)||"";if(je.length!==V.length)return je.length-V.length}if(he!==_e)return he>_e?-1:1;const Se=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0,Re=Array.isArray(Y.labelMatch)&&Y.labelMatch.length>0;if(Se&&!Re)return-1;if(Re&&!Se)return 1;const xe=T(N,Q,H),Ue=T(x,Y,H);return xe&&Ue&&xe!==Ue?Ue>xe?-1:1:F(N,x,B,H)}e.compareItemsByFuzzyScore=w;function T(N,x,B){let O=-1,H=-1;if(x.descriptionMatch&&x.descriptionMatch.length?O=x.descriptionMatch[0].start:x.labelMatch&&x.labelMatch.length&&(O=x.labelMatch[0].start),x.labelMatch&&x.labelMatch.length){if(H=x.labelMatch[x.labelMatch.length-1].end,x.descriptionMatch&&x.descriptionMatch.length){const W=B.getItemDescription(N);W&&(H+=W.length)}}else x.descriptionMatch&&x.descriptionMatch.length&&(H=x.descriptionMatch[x.descriptionMatch.length-1].end);return H-O}function v(N,x){if(!N&&!x||(!N||!N.length)&&(!x||!x.length))return 0;if(!x||!x.length)return-1;if(!N||!N.length)return 1;const B=N[0].start,H=N[N.length-1].end-B,W=x[0].start,Y=x[x.length-1].end-W;return H===Y?0:Y<H?1:-1}function F(N,x,B,O){const H=O.getItemLabel(N)||"",W=O.getItemLabel(x)||"",Q=O.getItemDescription(N),Y=O.getItemDescription(x),he=H.length+(Q?Q.length:0),_e=W.length+(Y?Y.length:0);if(he!==_e)return he-_e;const Se=O.getItemPath(N),Re=O.getItemPath(x);return Se&&Re&&Se.length!==Re.length?Se.length-Re.length:H!==W?(0,m.compareAnything)(H,W,B.normalized):Q&&Y&&Q!==Y?(0,m.compareAnything)(Q,Y,B.normalized):Se&&Re&&Se!==Re?(0,m.compareAnything)(Se,Re,B.normalized):0}function M(N){return N.startsWith('"')&&N.endsWith('"')}const G=" ";function K(N){typeof N!="string"&&(N="");const x=N.toLowerCase(),{pathNormalized:B,normalized:O,normalizedLowercase:H}=U(N),W=B.indexOf(C.sep)>=0,Q=M(N);let Y;const he=N.split(G);if(he.length>1)for(const _e of he){const Se=M(_e),{pathNormalized:Re,normalized:xe,normalizedLowercase:Ue}=U(_e);xe&&(Y||(Y=[]),Y.push({original:_e,originalLowercase:_e.toLowerCase(),pathNormalized:Re,normalized:xe,normalizedLowercase:Ue,expectContiguousMatch:Se}))}return{original:N,originalLowercase:x,pathNormalized:B,normalized:O,normalizedLowercase:H,values:Y,containsPathSeparator:W,expectContiguousMatch:Q}}e.prepareQuery=K;function U(N){let x;R.isWindows?x=N.replace(/\//g,C.sep):x=N.replace(/\\/g,C.sep);const B=(0,E.stripWildcards)(x).replace(/\s|"/g,"");return{pathNormalized:x,normalized:B,normalizedLowercase:B.toLowerCase()}}function z(N){return Array.isArray(N)?K(N.map(x=>x.original).join(G)):K(N.original)}e.pieceToQuery=z}),define(me[30],ge([0,1,18,29,24,8,9]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function E(){return Object.create(null)}e.getEmptyExpression=E;const S="**",A="/",n="[/\\\\]",P="[^/\\\\]",c=/\//g;function h(O){switch(O){case 0:return"";case 1:return`${P}*?`;default:return`(?:${n}|${P}+${n}|${n}${P}+)*?`}}function d(O,H){if(!O)return[];const W=[];let Q=!1,Y=!1,he="";for(const _e of O){switch(_e){case H:if(!Q&&!Y){W.push(he),he="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":Y=!0;break;case"]":Y=!1;break}he+=_e}return he&&W.push(he),W}e.splitGlobAware=d;function g(O){if(!O)return"";let H="";const W=d(O,A);if(W.every(Q=>Q===S))H=".*";else{let Q=!1;W.forEach((Y,he)=>{if(Y===S){Q||(H+=h(2),Q=!0);return}let _e=!1,Se="",Re=!1,xe="";for(const Ue of Y){if(Ue!=="}"&&_e){Se+=Ue;continue}if(Re&&(Ue!=="]"||!xe)){let je;Ue==="-"?je=Ue:(Ue==="^"||Ue==="!")&&!xe?je="^":Ue===A?je="":je=R.escapeRegExpCharacters(Ue),xe+=je;continue}switch(Ue){case"{":_e=!0;continue;case"[":Re=!0;continue;case"}":H+=`(?:${d(Se,",").map(ee=>g(ee)).join("|")})`,_e=!1,Se="";break;case"]":H+="["+xe+"]",Re=!1,xe="";break;case"?":H+=P;continue;case"*":H+=h(1);continue;default:H+=R.escapeRegExpCharacters(Ue)}}he<W.length-1&&(W[he+1]!==S||he+2<W.length)&&(H+=n),Q=!1})}return H}const y=/^\*\*\/\*\.[\w\.-]+$/,I=/^\*\*\/([\w\.-]+)\/?$/,_=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,s=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new k.LRUCache(1e4),a=function(){return!1},r=function(){return null};function i(O,H){if(!O)return r;let W;typeof O!="string"?W=O.pattern:W=O,W=W.trim();const Q=`${W}_${!!H.trimForExclusions}`;let Y=t.get(Q);if(Y)return l(Y,O);let he;if(y.test(W)){const _e=W.substr(4);Y=function(Se,Re){return typeof Se=="string"&&Se.endsWith(_e)?W:null}}else(he=I.exec(u(W,H)))?Y=f(he[1],W):(H.trimForExclusions?s:_).test(W)?Y=b(W,H):(he=o.exec(u(W,H)))?Y=D(he[1].substr(1),W,!0):(he=p.exec(u(W,H)))?Y=D(he[1],W,!1):Y=w(W);return t.set(Q,Y),l(Y,O)}function l(O,H){return typeof H=="string"?O:function(W,Q){return L.isEqualOrParent(W,H.base)?O(C.relative(H.base,W),Q):null}}function u(O,H){return H.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function f(O,H){const W=`/${O}`,Q=`\\${O}`,Y=function(_e,Se){return typeof _e!="string"?null:Se?Se===O?H:null:_e===O||_e.endsWith(W)||_e.endsWith(Q)?H:null},he=[O];return Y.basenames=he,Y.patterns=[H],Y.allBasenames=he,Y}function b(O,H){const W=B(O.slice(1,-1).split(",").map(Se=>i(Se,H)).filter(Se=>Se!==r),O),Q=W.length;if(!Q)return r;if(Q===1)return W[0];const Y=function(Se,Re){for(let xe=0,Ue=W.length;xe<Ue;xe++)if(W[xe](Se,Re))return O;return null},he=W.find(Se=>!!Se.allBasenames);he&&(Y.allBasenames=he.allBasenames);const _e=W.reduce((Se,Re)=>Re.allPaths?Se.concat(Re.allPaths):Se,[]);return _e.length&&(Y.allPaths=_e),Y}function D(O,H,W){const Q=C.sep===C.posix.sep,Y=Q?O:O.replace(c,C.sep),he=C.sep+Y,_e=C.posix.sep+O,Se=W?function(Re,xe){return typeof Re=="string"&&(Re===Y||Re.endsWith(he)||!Q&&(Re===O||Re.endsWith(_e)))?H:null}:function(Re,xe){return typeof Re=="string"&&(Re===Y||!Q&&Re===O)?H:null};return Se.allPaths=[(W?"*/":"./")+O],Se}function w(O){try{const H=new RegExp(`^${g(O)}$`);return function(W){return H.lastIndex=0,typeof W=="string"&&H.test(W)?O:null}}catch(H){return r}}function T(O,H,W){return!O||typeof H!="string"?!1:v(O)(H,void 0,W)}e.match=T;function v(O,H={}){if(!O)return a;if(typeof O=="string"||K(O)){const W=i(O,H);if(W===r)return a;const Q=function(Y,he){return!!W(Y,he)};return W.allBasenames&&(Q.allBasenames=W.allBasenames),W.allPaths&&(Q.allPaths=W.allPaths),Q}return N(O,H)}e.parse=v;function F(O){if(!O)return;let H;return W=>(H||(H=(O()||Promise.resolve([])).then(Q=>Q?G(Q):{})),H.then(Q=>!!Q[W]))}e.hasSiblingPromiseFn=F;function M(O){if(!O)return;let H;return W=>{if(!H){const Q=O();H=Q?G(Q):{}}return!!H[W]}}e.hasSiblingFn=M;function G(O){const H={};for(const W of O)H[W]=!0;return H}function K(O){const H=O;return H&&typeof H.base=="string"&&typeof H.pattern=="string"}e.isRelativePattern=K;function U(O){return O.allBasenames||[]}e.getBasenameTerms=U;function z(O){return O.allPaths||[]}e.getPathTerms=z;function N(O,H){const W=B(Object.getOwnPropertyNames(O).map(Se=>x(Se,O[Se],H)).filter(Se=>Se!==r)),Q=W.length;if(!Q)return r;if(!W.some(Se=>!!Se.requiresSiblings)){if(Q===1)return W[0];const Se=function(Ue,je){for(let V=0,ee=W.length;V<ee;V++){const re=W[V](Ue,je);if(re)return re}return null},Re=W.find(Ue=>!!Ue.allBasenames);Re&&(Se.allBasenames=Re.allBasenames);const xe=W.reduce((Ue,je)=>je.allPaths?Ue.concat(je.allPaths):Ue,[]);return xe.length&&(Se.allPaths=xe),Se}const Y=function(Se,Re,xe){let Ue;for(let je=0,V=W.length;je<V;je++){const ee=W[je];ee.requiresSiblings&&xe&&(Re||(Re=C.basename(Se)),Ue||(Ue=Re.substr(0,Re.length-C.extname(Se).length)));const re=ee(Se,Re,Ue,xe);if(re)return re}return null},he=W.find(Se=>!!Se.allBasenames);he&&(Y.allBasenames=he.allBasenames);const _e=W.reduce((Se,Re)=>Re.allPaths?Se.concat(Re.allPaths):Se,[]);return _e.length&&(Y.allPaths=_e),Y}function x(O,H,W){if(H===!1)return r;const Q=i(O,W);if(Q===r)return r;if(typeof H=="boolean")return Q;if(H){const Y=H.when;if(typeof Y=="string"){const he=(_e,Se,Re,xe)=>{if(!xe||!Q(_e,Se))return null;const Ue=Y.replace("$(basename)",Re),je=xe(Ue);return(0,m.isThenable)(je)?je.then(V=>V?O:null):je?O:null};return he.requiresSiblings=!0,he}}return Q}function B(O,H){const W=O.filter(Se=>!!Se.basenames);if(W.length<2)return O;const Q=W.reduce((Se,Re)=>{const xe=Re.basenames;return xe?Se.concat(xe):Se},[]);let Y;if(H){Y=[];for(let Se=0,Re=Q.length;Se<Re;Se++)Y.push(H)}else Y=W.reduce((Se,Re)=>{const xe=Re.patterns;return xe?Se.concat(xe):Se},[]);const he=function(Se,Re){if(typeof Se!="string")return null;if(!Re){let Ue;for(Ue=Se.length;Ue>0;Ue--){const je=Se.charCodeAt(Ue-1);if(je===47||je===92)break}Re=Se.substr(Ue)}const xe=Q.indexOf(Re);return xe!==-1?Y[xe]:null};he.basenames=Q,he.patterns=Y,he.allBasenames=Q;const _e=O.filter(Se=>!Se.basenames);return _e.push(he),_e}}),define(me[79],ge([0,1,29,10,8,11,22,9,2]),function(J,e,m,L,k,C,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function A(i,l,u){if(typeof i=="string"&&(i=S.URI.file(i)),u){const b=u.getWorkspaceFolder(i);if(b){const D=u.getWorkspace().folders.length>1;let w;if((0,R.isEqual)(b.uri,i)?w="":w=(0,R.relativePath)(b.uri,i),D){const T=b.name?b.name:(0,R.basename)(b.uri);w=w?T+" \u2022 "+w:T}return w}}if(i.scheme!==L.Schemas.file&&i.scheme!==L.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,m.hasDriveLetter)(i.fsPath))return(0,k.normalize)(P(i.fsPath));let f=(0,k.normalize)(i.fsPath);return!C.isWindows&&l?.userHome&&(f=h(f,l.userHome.fsPath)),f}e.getPathLabel=A;function n(i){if(!i)return;typeof i=="string"&&(i=S.URI.file(i));const l=(0,R.basename)(i)||(i.scheme===L.Schemas.file?i.fsPath:i.path);return C.isWindows&&(0,m.isRootOrDriveLetter)(l)?P(l):l}e.getBaseLabel=n;function P(i){return(0,m.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=P;let c=Object.create(null);function h(i,l){if(C.isWindows||!i||!l)return i;let u=c.original===l?c.normalized:void 0;return u||(u=`${(0,E.rtrim)(l,k.posix.sep)}${k.posix.sep}`,c={original:l,normalized:u}),(C.isLinux?i.startsWith(u):(0,E.startsWithIgnoreCase)(i,u))&&(i=`~/${i.substr(u.length)}`),i}e.tildify=h;function d(i,l){return i.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=d;const g="\u2026",y="\\\\",I="~";function _(i,l=k.sep){const u=new Array(i.length);let f=!1;for(let b=0;b<i.length;b++){let D=i[b];if(D===""){u[b]=`.${l}`;continue}if(!D){u[b]=D;continue}f=!0;let w="";D.indexOf(y)===0?(w=D.substr(0,D.indexOf(y)+y.length),D=D.substr(D.indexOf(y)+y.length)):D.indexOf(l)===0?(w=D.substr(0,D.indexOf(l)+l.length),D=D.substr(D.indexOf(l)+l.length)):D.indexOf(I)===0&&(w=D.substr(0,D.indexOf(I)+I.length),D=D.substr(D.indexOf(I)+I.length));const T=D.split(l);for(let v=1;f&&v<=T.length;v++)for(let F=T.length-v;f&&F>=0;F--){f=!1;let M=T.slice(F,F+v).join(l);for(let G=0;!f&&G<i.length;G++)if(G!==b&&i[G]&&i[G].indexOf(M)>-1){const K=F+v===T.length,U=F>0&&i[G].indexOf(l)>-1?l+M:M,z=i[G].endsWith(U);f=!K||z}if(!f){let G="";(T[0].endsWith(":")||w!=="")&&(F===1&&(F=0,v++,M=T[0]+l+M),F>0&&(G=T[0]+l),G=w+G),F>0&&(G=G+g+l),G=G+M,F+v<T.length&&(G=G+l+g),u[b]=G}}f&&(u[b]=D)}return u}e.shorten=_;var s;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(s||(s={}));function o(i,l=Object.create(null)){const u=[];let f=!1,b="";for(const D of i)if(D==="$"||f&&D==="{")b&&u.push({value:b,type:s.TEXT}),b="",f=!0;else if(D==="}"&&f){const w=l[b];if(typeof w=="string")w.length&&u.push({value:w,type:s.VARIABLE});else if(w){const T=u[u.length-1];(!T||T.type!==s.SEPARATOR)&&u.push({value:w.label,type:s.SEPARATOR})}b="",f=!1}else b+=D;return b&&!f&&u.push({value:b,type:s.TEXT}),u.filter((D,w)=>{if(D.type===s.SEPARATOR){const T=u[w-1],v=u[w+1];return[T,v].every(F=>F&&(F.type===s.VARIABLE||F.type===s.TEXT)&&F.value.length>0)}return!0}).map(D=>D.value).join("")}e.template=o;function p(i,l){return C.isMacintosh||l?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):i.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function t(i,l){return C.isMacintosh||l?i.replace(/\(&&\w\)|&&/g,""):C.isWindows?i.replace(/&&|&/g,u=>u==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function a(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=a;function r(i){const l=i.indexOf("/")!==-1?k.posix:k.win32,u=l.basename(i),f=l.dirname(i);return u.length?{name:u,parentPath:f}:{name:f,parentPath:""}}e.splitName=r}),define(me[102],ge([0,1,30,10,8,22,9]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var E;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown"})(E=e.Mimes||(e.Mimes={}));let S=[],A=[],n=[];function P(i,l=!1){const u=c(i);S.push(u),u.userConfigured?n.push(u):A.push(u),l&&!u.userConfigured&&S.forEach(f=>{f.mime===u.mime||f.userConfigured||(u.extension&&f.extension===u.extension&&console.warn(`Overwriting extension <<${u.extension}>> to now point to mime <<${u.mime}>>`),u.filename&&f.filename===u.filename&&console.warn(`Overwriting filename <<${u.filename}>> to now point to mime <<${u.mime}>>`),u.filepattern&&f.filepattern===u.filepattern&&console.warn(`Overwriting filepattern <<${u.filepattern}>> to now point to mime <<${u.mime}>>`),u.firstline&&f.firstline===u.firstline&&console.warn(`Overwriting firstline <<${u.firstline}>> to now point to mime <<${u.mime}>>`))})}e.registerTextMime=P;function c(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,m.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(k.posix.sep)>=0:!1}}function h(i){i?(S=S.filter(l=>!l.userConfigured),n=[]):(S=[],A=[],n=[])}e.clearTextMimes=h;function d(i,l){let u;if(i)switch(i.scheme){case L.Schemas.file:u=i.fsPath;break;case L.Schemas.data:u=C.DataUri.parseMetaData(i).get(C.DataUri.META_DATA_LABEL);break;default:u=i.path}if(!u)return[E.unknown];u=u.toLowerCase();const f=(0,k.basename)(u),b=g(u,f,n);if(b)return[b,E.text];const D=g(u,f,A);if(D)return[D,E.text];if(l){const w=y(l);if(w)return[w,E.text]}return[E.unknown]}e.guessMimeTypes=d;function g(i,l,u){let f=null,b=null,D=null;for(let w=u.length-1;w>=0;w--){const T=u[w];if(l===T.filenameLowercase){f=T;break}if(T.filepattern&&(!b||T.filepattern.length>b.filepattern.length)){const v=T.filepatternOnPath?i:l;T.filepatternLowercase?.(v)&&(b=T)}T.extension&&(!D||T.extension.length>D.extension.length)&&l.endsWith(T.extensionLowercase)&&(D=T)}return f?f.mime:b?b.mime:D?D.mime:null}function y(i){if((0,R.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let l=S.length-1;l>=0;l--){const u=S[l];if(!u.firstline)continue;const f=i.match(u.firstline);if(f&&f.length>0)return u.mime}return null}function I(i){return i?typeof i=="string"?i===E.binary||i===E.text||i===E.unknown:i.length===1&&I(i[0]):!0}e.isUnspecific=I;const _={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},s={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function o(i){const l=(0,k.extname)(i),u=_[l.toLowerCase()];return u!==void 0?u:p(i)}e.getMediaOrTextMime=o;function p(i){const l=(0,k.extname)(i);return s[l.toLowerCase()]}e.getMediaMime=p;function t(i){for(const l in s)if(s[l]===i)return l}e.getExtensionForMimeType=t;const a=/^(.+)\/(.+?)(;.+)?$/;function r(i,l){const u=a.exec(i);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:l?void 0:i}e.normalizeMimeType=r}),define(me[103],ge([0,1,2]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(n){return n.toJSON()}class k{constructor(P){this._uriTransformer=P}transformIncoming(P){const c=this._uriTransformer.transformIncoming(P);return c===P?P:L(m.URI.from(c))}transformOutgoing(P){const c=this._uriTransformer.transformOutgoing(P);return c===P?P:L(m.URI.from(c))}transformOutgoingURI(P){const c=this._uriTransformer.transformOutgoing(P);return c===P?P:m.URI.from(c)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function C(n,P,c){if(!n||c>200)return null;if(typeof n=="object"){if(n instanceof m.URI)return P.transformOutgoing(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const d=C(n[h],P,c+1);d!==null&&(n[h]=d)}}return null}function R(n,P){const c=C(n,P,0);return c===null?n:c}e.transformOutgoingURIs=R;function E(n,P,c,h){if(!n||h>200)return null;if(typeof n=="object"){if(n.$mid===1)return c?m.URI.revive(P.transformIncoming(n)):P.transformIncoming(n);for(let d in n)if(Object.hasOwnProperty.call(n,d)){const g=E(n[d],P,c,h+1);g!==null&&(n[d]=g)}}return null}function S(n,P){const c=E(n,P,!1,0);return c===null?n:c}e.transformIncomingURIs=S;function A(n,P){const c=E(n,P,!0,0);return c===null?n:c}e.transformAndReviveIncomingURIs=A}),define(me[32],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(S){return m.test(S)}e.isUUID=L;const k=new Uint8Array(16),C=[];for(let S=0;S<256;S++)C.push(S.toString(16).padStart(2,"0"));let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(S){for(let A=0;A<S.length;A++)S[A]=Math.floor(Math.random()*256);return S};function E(){R(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let S=0,A="";return A+=C[k[S++]],A+=C[k[S++]],A+=C[k[S++]],A+=C[k[S++]],A+="-",A+=C[k[S++]],A+=C[k[S++]],A+="-",A+=C[k[S++]],A+=C[k[S++]],A+="-",A+=C[k[S++]],A+=C[k[S++]],A+="-",A+=C[k[S++]],A+=C[k[S++]],A+=C[k[S++]],A+=C[k[S++]],A+=C[k[S++]],A+=C[k[S++]],A}e.generateUuid=E}),define(me[143],ge([0,1,104]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(C="utf8"){this.stringDecoder=new m.StringDecoder(C),this.remaining=null}write(C){const R=[],E=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(E.length<1)return R;let S=0,A,n=S;for(;n<E.length;)if(A=E.charCodeAt(n),A===13||A===10){if(R.push(E.substring(S,n)),n++,n<E.length){const P=A;A=E.charCodeAt(n),(P===13&&A===10||P===10&&A===13)&&n++}S=n}else n++;return this.remaining=S<E.length?E.substr(S):null,R}end(){return this.remaining}}e.LineDecoder=L}),define(me[28],ge([0,1,50,80,291,18,29,78,8,11,22,2,32]),function(J,e,m,L,k,C,R,E,S,A,n,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var h;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(h=e.RimRafMode||(e.RimRafMode={}));async function d(U,z=h.UNLINK){if((0,R.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return z===h.UNLINK?y(U):g(U)}async function g(U){try{const z=(0,S.join)((0,L.tmpdir)(),(0,c.generateUuid)());try{await e.Promises.rename(U,z)}catch(N){return y(U)}y(z).catch(N=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function y(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function I(U){if((0,R.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(U,{recursive:!0})}e.rimrafSync=I;async function _(U,z){return p(await(z?s(U):(0,k.promisify)(m.readdir)(U)))}async function s(U){try{return await(0,k.promisify)(m.readdir)(U,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const z=[],N=await _(U);for(const x of N){let B=!1,O=!1,H=!1;try{const W=await e.Promises.lstat((0,S.join)(U,x));B=W.isFile(),O=W.isDirectory(),H=W.isSymbolicLink()}catch(W){console.warn("[node.js fs] unexpected error from lstat after readdir: ",W)}z.push({name:x,isFile:()=>B,isDirectory:()=>O,isSymbolicLink:()=>H})}return z}function o(U){return p(m.readdirSync(U))}e.readdirSync=o;function p(U){return U.map(z=>typeof z=="string"?A.isMacintosh?(0,E.normalizeNFC)(z):z:(z.name=A.isMacintosh?(0,E.normalizeNFC)(z.name):z.name,z))}async function t(U){const z=await _(U),N=[];for(const x of z)await r.existsDirectory((0,S.join)(U,x))&&N.push(x);return N}function a(U,z=1e3){return new Promise(N=>{let x=!1;const B=setInterval(()=>{x||(x=!0,m.access(U,O=>{x=!1,O&&(clearInterval(B),N(void 0))}))},z)})}e.whenDeleted=a;var r;(function(U){async function z(B){let O;try{if(O=await e.Promises.lstat(B),!O.isSymbolicLink())return{stat:O}}catch(H){}try{return{stat:await e.Promises.stat(B),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(A.isWindows&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(W){if(W.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw W}throw H}}U.stat=z;async function N(B){try{const{stat:O,symbolicLink:H}=await U.stat(B);return O.isFile()&&H?.dangling!==!0}catch(O){}return!1}U.existsFile=N;async function x(B){try{const{stat:O,symbolicLink:H}=await U.stat(B);return O.isDirectory()&&H?.dangling!==!0}catch(O){}return!1}U.existsDirectory=x})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new C.ResourceQueue;function l(U,z,N){return i.queueFor(P.URI.file(U),n.extUriBiasedIgnorePathCase).queue(()=>{const x=D(N);return new Promise((B,O)=>f(U,z,x,H=>H?O(H):B()))})}let u=!0;function f(U,z,N,x){if(!u)return m.writeFile(U,z,{mode:N.mode,flag:N.flag},x);m.open(U,N.flag,N.mode,(B,O)=>{if(B)return x(B);m.writeFile(O,z,H=>{if(H)return m.close(O,()=>x(H));m.fdatasync(O,W=>(W&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",W),u=!1),m.close(O,Q=>x(Q))))})})}function b(U,z,N){const x=D(N);if(!u)return m.writeFileSync(U,z,{mode:x.mode,flag:x.flag});const B=m.openSync(U,x.flag,x.mode);try{m.writeFileSync(B,z);try{m.fdatasyncSync(B)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),u=!1}}finally{m.closeSync(B)}}e.writeFileSync=b;function D(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function w(U,z){if(U===z)return;async function N(x){try{const B=await e.Promises.lstat(x);if(B.isDirectory()||B.isSymbolicLink())return;await e.Promises.utimes(x,B.atime,new Date)}catch(B){}}try{await e.Promises.rename(U,z),await N(z)}catch(x){if(U.toLowerCase()!==z.toLowerCase()&&x.code==="EXDEV"||U.endsWith("."))await T(U,z,{preserveSymlinks:!1}),await d(U,h.MOVE),await N(z);else throw x}}async function T(U,z,N){return F(U,z,{root:{source:U,target:z},options:N,handledSourcePaths:new Set})}const v=511;async function F(U,z,N){if(N.handledSourcePaths.has(U))return;N.handledSourcePaths.add(U);const{stat:x,symbolicLink:B}=await r.stat(U);if(B){if(N.options.preserveSymlinks)try{return await K(U,z,N)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(B.dangling)return}return x.isDirectory()?M(U,z,x.mode&v,N):G(U,z,x.mode&v)}async function M(U,z,N,x){await e.Promises.mkdir(z,{recursive:!0,mode:N});const B=await _(U);for(const O of B)await F((0,S.join)(U,O),(0,S.join)(z,O),x)}async function G(U,z,N){await e.Promises.copyFile(U,z),await e.Promises.chmod(z,N)}async function K(U,z,N){let x=await e.Promises.readlink(U);(0,R.isEqualOrParent)(x,N.root.source,!A.isLinux)&&(x=(0,S.join)(N.root.target,x.substr(N.root.source.length+1))),await e.Promises.symlink(x,z)}e.Promises=new class{get access(){return(0,k.promisify)(m.access)}get stat(){return(0,k.promisify)(m.stat)}get lstat(){return(0,k.promisify)(m.lstat)}get utimes(){return(0,k.promisify)(m.utimes)}get read(){return(0,k.promisify)(m.read)}get readFile(){return(0,k.promisify)(m.readFile)}get write(){return(0,k.promisify)(m.write)}get appendFile(){return(0,k.promisify)(m.appendFile)}get fdatasync(){return(0,k.promisify)(m.fdatasync)}get truncate(){return(0,k.promisify)(m.truncate)}get rename(){return(0,k.promisify)(m.rename)}get copyFile(){return(0,k.promisify)(m.copyFile)}get open(){return(0,k.promisify)(m.open)}get close(){return(0,k.promisify)(m.close)}get symlink(){return(0,k.promisify)(m.symlink)}get readlink(){return(0,k.promisify)(m.readlink)}get chmod(){return(0,k.promisify)(m.chmod)}get mkdir(){return(0,k.promisify)(m.mkdir)}get unlink(){return(0,k.promisify)(m.unlink)}get rmdir(){return(0,k.promisify)(m.rmdir)}get realpath(){return(0,k.promisify)(m.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return _}get readDirsInDir(){return t}get writeFile(){return l}get rm(){return d}get move(){return w}get copy(){return T}}}),define(me[105],ge([0,1,50,8,9,28]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function R(n){const P=(0,L.dirname)(n);if(n===P)return n;const c=((0,L.basename)(n)||n).toLowerCase();try{const d=(0,C.readdirSync)(P).filter(g=>g.toLowerCase()===c);if(d.length===1){const g=R(P);if(g)return(0,L.join)(g,d[0])}else if(d.length>1){const g=d.indexOf(c);if(g>=0){const y=R(P);if(y)return(0,L.join)(y,d[g])}}}catch(h){}return null}e.realcaseSync=R;async function E(n){try{return await C.Promises.realpath(n)}catch(P){const c=A(n);return await C.Promises.access(c,m.constants.R_OK),c}}e.realpath=E;function S(n){try{return m.realpathSync(n)}catch(P){const c=A(n);return m.accessSync(c,m.constants.R_OK),c}}e.realpathSync=S;function A(n){return(0,k.rtrim)((0,L.normalize)(n),L.sep)}});var Ve=this&&this.__decorate||function(J,e,m,L){var k=arguments.length,C=k<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,m):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(J,e,m,L);else for(var E=J.length-1;E>=0;E--)(R=J[E])&&(C=(k<3?R(C):k>3?R(e,m,C):R(e,m))||C);return k>3&&C&&Object.defineProperty(e,m,C),C};define(me[106],ge([0,1,17,18,23,21,58,16,3,6,60,9,13]),function(J,e,m,L,k,C,R,E,S,A,n,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var h;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(h=e.RequestType||(e.RequestType={}));function d(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function y(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var I;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(I||(I={}));class _{constructor(O){this.buffer=O,this.pos=0}read(O){const H=this.buffer.slice(this.pos,this.pos+O);return this.pos+=H.byteLength,H}}class s{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var o;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(o||(o={}));function p(B){const O=k.VSBuffer.alloc(4);return O.writeUInt32BE(B,0),O}function t(B){return B.read(4).readUInt32BE(0)}function a(B){const O=k.VSBuffer.alloc(1);return O.writeUInt8(B,0),O}const r={Undefined:a(o.Undefined),String:a(o.String),Buffer:a(o.Buffer),VSBuffer:a(o.VSBuffer),Array:a(o.Array),Object:a(o.Object)},i=typeof Buffer!="undefined";function l(B,O){if(typeof O=="undefined")B.write(r.Undefined);else if(typeof O=="string"){const H=k.VSBuffer.fromString(O);B.write(r.String),B.write(p(H.byteLength)),B.write(H)}else if(i&&Buffer.isBuffer(O)){const H=k.VSBuffer.wrap(O);B.write(r.Buffer),B.write(p(H.byteLength)),B.write(H)}else if(O instanceof k.VSBuffer)B.write(r.VSBuffer),B.write(p(O.byteLength)),B.write(O);else if(Array.isArray(O)){B.write(r.Array),B.write(p(O.length));for(const H of O)l(B,H)}else{const H=k.VSBuffer.fromString(JSON.stringify(O));B.write(r.Object),B.write(p(H.byteLength)),B.write(H)}}function u(B){switch(B.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return B.read(t(B)).toString();case o.Buffer:return B.read(t(B)).buffer;case o.VSBuffer:return B.read(t(B));case o.Array:{const H=t(B),W=[];for(let Q=0;Q<H;Q++)W.push(u(B));return W}case o.Object:return JSON.parse(B.read(t(B)).toString())}}class f{constructor(O,H,W=null,Q=1e3){this.protocol=O,this.ctx=H,this.logger=W,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Y=>this.onRawMessage(Y)),this.sendResponse({type:200})}registerChannel(O,H){this.channels.set(O,H),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const H=this.send([O.type]);this.logger&&this.logger.logOutgoing(H,0,1,y(O.type));return}case 201:case 202:case 204:case 203:{const H=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(H,O.id,1,y(O.type),O.data);return}}}send(O,H=void 0){const W=new s;return l(W,O),l(W,H),this.sendBuffer(W.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(H){return 0}}onRawMessage(O){const H=new _(O),W=u(H),Q=u(H),Y=W[0];switch(Y){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],1,`${d(Y)}: ${W[2]}.${W[3]}`,Q),this.onPromise({type:Y,id:W[1],channelName:W[2],name:W[3],arg:Q});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],1,`${d(Y)}: ${W[2]}.${W[3]}`,Q),this.onEventListen({type:Y,id:W[1],channelName:W[2],name:W[3],arg:Q});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],1,`${d(Y)}`),this.disposeActiveRequest({type:Y,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],1,`${d(Y)}`),this.disposeActiveRequest({type:Y,id:W[1]})}}onPromise(O){const H=this.channels.get(O.channelName);if(!H){this.collectPendingRequest(O);return}const W=new C.CancellationTokenSource;let Q;try{Q=H.call(this.ctx,O.name,O.arg,W.token)}catch(_e){Q=Promise.reject(_e)}const Y=O.id;Q.then(_e=>{this.sendResponse({id:Y,data:_e,type:201}),this.activeRequests.delete(O.id)},_e=>{_e instanceof Error?this.sendResponse({id:Y,data:{message:_e.message,name:_e.name,stack:_e.stack?_e.stack.split?_e.stack.split(`
`):_e.stack:void 0},type:202}):this.sendResponse({id:Y,data:_e,type:203}),this.activeRequests.delete(O.id)});const he=(0,A.toDisposable)(()=>W.cancel());this.activeRequests.set(O.id,he)}onEventListen(O){const H=this.channels.get(O.channelName);if(!H){this.collectPendingRequest(O);return}const W=O.id,Y=H.listen(this.ctx,O.name,O.arg)(he=>this.sendResponse({id:W,data:he,type:204}));this.activeRequests.set(O.id,Y)}disposeActiveRequest(O){const H=this.activeRequests.get(O.id);H&&(H.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let H=this.pendingRequests.get(O.channelName);H||(H=[],this.pendingRequests.set(O.channelName,H));const W=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);H.push({request:O,timeoutTimer:W})}flushPendingRequests(O){const H=this.pendingRequests.get(O);if(H){for(const W of H)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var b;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(b=e.RequestInitiator||(e.RequestInitiator={}));class D{constructor(O,H=null){this.protocol=O,this.isDisposed=!1,this.state=I.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=H}getChannel(O){const H=this;return{call(W,Q,Y){return H.isDisposed?Promise.reject(E.canceled()):H.requestPromise(O,W,Q,Y)},listen(W,Q){return H.isDisposed?Promise.reject(E.canceled()):H.requestEvent(O,W,Q)}}}requestPromise(O,H,W,Q=C.CancellationToken.None){const Y=this.lastRequestId++,_e={id:Y,type:100,channelName:O,name:H,arg:W};if(Q.isCancellationRequested)return Promise.reject(E.canceled());let Se;return new Promise((xe,Ue)=>{if(Q.isCancellationRequested)return Ue(E.canceled());const je=()=>{const le=Z=>{switch(Z.type){case 201:this.handlers.delete(Y),xe(Z.data);break;case 202:this.handlers.delete(Y);const oe=new Error(Z.data.message);oe.stack=Z.data.stack,oe.name=Z.data.name,Ue(oe);break;case 203:this.handlers.delete(Y),Ue(Z.data);break}};this.handlers.set(Y,le),this.sendRequest(_e)};let V=null;this.state===I.Idle?je():(V=(0,L.createCancelablePromise)(le=>this.whenInitialized()),V.then(()=>{V=null,je()}));const ee=()=>{V?(V.cancel(),V=null):this.sendRequest({id:Y,type:101}),Ue(E.canceled())},re=Q.onCancellationRequested(ee);Se=(0,A.combinedDisposable)((0,A.toDisposable)(ee),re),this.activeRequests.add(Se)}).finally(()=>{this.activeRequests.delete(Se)})}requestEvent(O,H,W){const Q=this.lastRequestId++,he={id:Q,type:102,channelName:O,name:H,arg:W};let _e=null;const Se=new S.Emitter({onFirstListenerAdd:()=>{_e=(0,L.createCancelablePromise)(xe=>this.whenInitialized()),_e.then(()=>{_e=null,this.activeRequests.add(Se),this.sendRequest(he)})},onLastListenerRemove:()=>{_e?(_e.cancel(),_e=null):(this.activeRequests.delete(Se),this.sendRequest({id:Q,type:103}))}}),Re=xe=>Se.fire(xe.data);return this.handlers.set(Q,Re),Se.event}sendRequest(O){switch(O.type){case 100:case 102:{const H=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(H,O.id,0,`${d(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const H=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(H,O.id,0,d(O.type));return}}}send(O,H=void 0){const W=new s;return l(W,O),l(W,H),this.sendBuffer(W.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(H){return 0}}onBuffer(O){const H=new _(O),W=u(H),Q=u(H),Y=W[0];switch(Y){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,y(Y)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,W[1],0,y(Y),Q),this.onResponse({type:W[0],id:W[1],data:Q})}}onResponse(O){if(O.type===200){this.state=I.Idle,this._onDidInitialize.fire();return}const H=this.handlers.get(O.id);H&&H(O)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===I.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}Ve([R.memoize],D.prototype,"onDidInitializePromise",null),e.ChannelClient=D;class w{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:H,onDidClientDisconnect:W})=>{S.Event.once(H.onMessage)(Y=>{const he=new _(Y),_e=u(he),Se=new f(H,_e),Re=new D(H);this.channels.forEach((Ue,je)=>Se.registerChannel(je,Ue));const xe={channelServer:Se,channelClient:Re,ctx:_e};this._connections.add(xe),this._onDidAddConnection.fire(xe),W(()=>{Se.dispose(),Re.dispose(),this._connections.delete(xe),this._onDidRemoveConnection.fire(xe)})})})}get connections(){const O=[];return this._connections.forEach(H=>O.push(H)),O}getChannel(O,H){const W=this;return{call(Q,Y,he){let _e;if((0,c.isFunction)(H)){let Re=(0,m.getRandomElement)(W.connections.filter(H));_e=Re?Promise.resolve(Re):S.Event.toPromise(S.Event.filter(W.onDidAddConnection,H))}else _e=H.routeCall(W,Q,Y);const Se=_e.then(Re=>Re.channelClient.getChannel(O));return v(Se).call(Q,Y,he)},listen(Q,Y){if((0,c.isFunction)(H))return W.getMulticastEvent(O,H,Q,Y);const he=H.routeEvent(W,Q,Y).then(_e=>_e.channelClient.getChannel(O));return v(he).listen(Q,Y)}}}getMulticastEvent(O,H,W,Q){const Y=this;let he=new A.DisposableStore;const _e=new S.Emitter({onFirstListenerAdd:()=>{he=new A.DisposableStore;const Se=new S.EventMultiplexer,Re=new Map,xe=je=>{const ee=je.channelClient.getChannel(O).listen(W,Q),re=Se.add(ee);Re.set(je,re)},Ue=je=>{const V=Re.get(je);!V||(V.dispose(),Re.delete(je))};Y.connections.filter(H).forEach(xe),S.Event.filter(Y.onDidAddConnection,H)(xe,void 0,he),Y.onDidRemoveConnection(Ue,void 0,he),Se.event(_e.fire,_e,he),he.add(Se)},onLastListenerRemove:()=>{he.dispose()}});return _e.event}registerChannel(O,H){this.channels.set(O,H),this._connections.forEach(W=>{W.channelServer.registerChannel(O,H)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=w;class T{constructor(O,H,W=null){const Q=new s;l(Q,H),O.send(Q.buffer),this.channelClient=new D(O,W),this.channelServer=new f(O,H,W)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,H){this.channelServer.registerChannel(O,H)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function v(B){return{call(O,H,W){return B.then(Q=>Q.call(O,H,W))},listen(O,H){const W=new S.Relay;return B.then(Q=>W.input=Q.listen(O,H)),W.event}}}e.getDelayedChannel=v;function F(B){let O=!1;return{call(H,W,Q){return O?B.call(H,W,Q):(0,L.timeout)(0).then(()=>O=!0).then(()=>B.call(H,W,Q))},listen(H,W){if(O)return B.listen(H,W);const Q=new S.Relay;return(0,L.timeout)(0).then(()=>O=!0).then(()=>Q.input=B.listen(H,W)),Q.event}}}e.getNextTickChannel=F;class M{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const H of O.connections)if(await Promise.resolve(this.fn(H.ctx)))return Promise.resolve(H);return await S.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=M;var G;(function(B){function O(Q,Y){const he=Q,_e=Y&&Y.disableMarshalling,Se=new Map;for(const Re in he)W(Re)&&Se.set(Re,S.Event.buffer(he[Re],!0));return new class{listen(Re,xe){const Ue=Se.get(xe);if(Ue)return Ue;throw new Error(`Event not found: ${xe}`)}call(Re,xe,Ue){const je=he[xe];if(typeof je=="function"){if(!_e&&Array.isArray(Ue))for(let V=0;V<Ue.length;V++)Ue[V]=(0,n.revive)(Ue[V]);return je.apply(he,Ue)}throw new Error(`Method not found: ${xe}`)}}}B.fromService=O;function H(Q,Y){const he=Y&&Y.disableMarshalling;return new Proxy({},{get(_e,Se){if(typeof Se=="string")return Y?.properties?.has(Se)?Y.properties.get(Se):W(Se)?Q.listen(Se):async function(...Re){let xe;Y&&!(0,c.isUndefinedOrNull)(Y.context)?xe=[Y.context,...Re]:xe=Re;const Ue=await Q.call(Se,xe);return he?Ue:(0,n.revive)(Ue)};throw new Error(`Property not found: ${String(Se)}`)}})}B.toService=H;function W(Q){return Q[0]==="o"&&Q[1]==="n"&&P.isUpperAsciiLetter(Q.charCodeAt(2))}})(G=e.ProxyChannel||(e.ProxyChannel={}));const K=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){let O=B.toString();if(O!=="[object Object]")return O}return B}function z(B){return Array.isArray(B)?B.map(U):U(B)}function N(B,O,H,W,Q,Y,he){he=z(he);const _e=K[Q],Se=_e[W%_e.length];let Re=[`%c[${B}]%c[${String(O).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${Se}`];/\($/.test(Y)?(Re=Re.concat(he),Re.push(")")):Re.push(he),console.log.apply(console,Re)}e.logWithColors=N;class x{constructor(O,H){this._outgoingPrefix=O,this._incomingPrefix=H,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,H,W,Q,Y){this._totalOutgoing+=O,N(this._outgoingPrefix,this._totalOutgoing,O,H,W,Q,Y)}logIncoming(O,H,W,Q,Y){this._totalIncoming+=O,N(this._incomingPrefix,this._totalIncoming,O,H,W,Q,Y)}}e.IPCLogger=x}),define(me[107],ge([0,1,23,3,6,11,38,106]),function(J,e,m,L,k,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var S;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let A=null;function n(){return A||(A=m.VSBuffer.alloc(0)),A}class P{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,l){if(i===0)return n();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const D=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=i),D}if(this._chunks[0].byteLength>i){const D=this._chunks[0].slice(0,i);return l&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),D}let u=m.VSBuffer.alloc(i),f=0,b=0;for(;i>0;){const D=this._chunks[b];if(D.byteLength>i){const w=D.slice(0,i);u.set(w,f),f+=i,l&&(this._chunks[b]=D.slice(i),this._totalLength-=i),i-=i}else u.set(D,f),f+=D.byteLength,l?(this._chunks.shift(),this._totalLength-=D.byteLength):b++,i-=D.byteLength}return u}}e.ChunkStream=P;var c;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(c||(c={}));var h;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(i,l,u,f){this.type=i,this.id=l,this.ack=u,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends k.Disposable{constructor(i){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5);else{const u=this._state.messageType,f=this._state.id,b=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(u,f,b,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class y{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=m.VSBuffer.alloc(13);l.writeUInt8(i.type,0),l.writeUInt32BE(i.id,1),l.writeUInt32BE(i.ack,5),l.writeUInt32BE(i.data.byteLength,9),this._writeSoon(l,i.data)}_bufferAdd(i,l){const u=this._totalLength===0;return this._data.push(i,l),this._totalLength+=i.byteLength+l.byteLength,u}_bufferTake(){const i=m.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,l){this._bufferAdd(i,l)&&C.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class I extends k.Disposable{constructor(i){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new y(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new d(1,0,0,i))}}e.Protocol=I;class _ extends E.IPCClient{constructor(i,l,u=null){super(i,l,u);this.protocol=i}static fromSocket(i,l){return new _(new I(i),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=_;class s{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,R.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=s;class o{constructor(i){this.data=i,this.next=null}}class p{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],l=0,u=this._first;for(;u;)i[l++]=u.data,u=u.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const l=new o(i);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class t{constructor(){this.lastRuns=[];const i=Date.now();for(let l=0;l<t._HISTORY_LENGTH;l++)this.lastRuns[l]=i-1e3*l;setInterval(()=>{for(let l=t._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const i=Date.now(),l=(1+t._HISTORY_LENGTH)*1e3;let u=0;for(let f=0;f<t._HISTORY_LENGTH;f++)i-this.lastRuns[f]<=l&&u++;return 1-u/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class a{constructor(i,l=null,u=t.getInstance()){this._onControlMessage=new s,this.onControlMessage=this._onControlMessage.event,this._onMessage=new s,this.onMessage=this._onMessage.event,this._onDidDispose=new s,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new s,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new s,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=u,this._isReconnecting=!1,this._outgoingUnackMsg=new p,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),l&&this._socketReader.acceptChunk(l),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new d(5,0,0,n());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const l=new d(4,0,0,n());this._socketWriter.write(l),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,l){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let l=0,u=i.length;l<u;l++)this._socketWriter.write(i[l]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new d(6,0,0,n())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const l=this._outgoingUnackMsg.toArray();for(let u=0,f=l.length;u<f;u++)this._socketWriter.write(l[u]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const u=new d(1,l,this._incomingAckId,i);this._outgoingUnackMsg.push(u),this._isReconnecting||(this._socketWriter.write(u),this._recvAckCheck())}sendControl(i){const l=new d(2,0,0,i);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const i=this._outgoingUnackMsg.peek(),l=Date.now()-i.writtenTime;if(l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-l,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new d(3,0,this._incomingAckId,n());this._socketWriter.write(i)}}e.PersistentProtocol=a}),define(me[108],ge([0,1,97]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(E){let S=(0,m.toUint8)(E);this._defaultValue=S,this._asciiMap=L._createAsciiMap(S),this._map=new Map}static _createAsciiMap(E){let S=new Uint8Array(256);for(let A=0;A<256;A++)S[A]=E;return S}set(E,S){let A=(0,m.toUint8)(S);E>=0&&E<256?this._asciiMap[E]=A:this._map.set(E,A)}get(E){return E>=0&&E<256?this._asciiMap[E]:this._map.get(E)||this._defaultValue}}e.CharacterClassifier=L;var k;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(k||(k={}));class C{constructor(){this._actual=new L(0)}add(E){this._actual.set(E,1)}has(E){return this._actual.get(E)===1}}e.CharacterSet=C}),define(me[144],ge([0,1,108]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends m.CharacterClassifier{constructor(E){super(0);for(let S=0,A=E.length;S<A;S++)this.set(E.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function C(R){let E={};return S=>(E.hasOwnProperty(S)||(E[S]=R(S)),E[S])}e.getMapForWordSeparators=C(R=>new k(R))}),define(me[51],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class m{constructor(k,C){this.lineNumber=k,this.column=C}with(k=this.lineNumber,C=this.column){return k===this.lineNumber&&C===this.column?this:new m(k,C)}delta(k=0,C=0){return this.with(this.lineNumber+k,this.column+C)}equals(k){return m.equals(this,k)}static equals(k,C){return!k&&!C?!0:!!k&&!!C&&k.lineNumber===C.lineNumber&&k.column===C.column}isBefore(k){return m.isBefore(this,k)}static isBefore(k,C){return k.lineNumber<C.lineNumber?!0:C.lineNumber<k.lineNumber?!1:k.column<C.column}isBeforeOrEqual(k){return m.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,C){return k.lineNumber<C.lineNumber?!0:C.lineNumber<k.lineNumber?!1:k.column<=C.column}static compare(k,C){let R=k.lineNumber|0,E=C.lineNumber|0;if(R===E){let S=k.column|0,A=C.column|0;return S-A}return R-E}clone(){return new m(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new m(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=m}),define(me[41],ge([0,1,51]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(C,R,E,S){C>E||C===E&&R>S?(this.startLineNumber=E,this.startColumn=S,this.endLineNumber=C,this.endColumn=R):(this.startLineNumber=C,this.startColumn=R,this.endLineNumber=E,this.endColumn=S)}isEmpty(){return L.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return L.containsPosition(this,C)}static containsPosition(C,R){return!(R.lineNumber<C.startLineNumber||R.lineNumber>C.endLineNumber||R.lineNumber===C.startLineNumber&&R.column<C.startColumn||R.lineNumber===C.endLineNumber&&R.column>C.endColumn)}containsRange(C){return L.containsRange(this,C)}static containsRange(C,R){return!(R.startLineNumber<C.startLineNumber||R.endLineNumber<C.startLineNumber||R.startLineNumber>C.endLineNumber||R.endLineNumber>C.endLineNumber||R.startLineNumber===C.startLineNumber&&R.startColumn<C.startColumn||R.endLineNumber===C.endLineNumber&&R.endColumn>C.endColumn)}strictContainsRange(C){return L.strictContainsRange(this,C)}static strictContainsRange(C,R){return!(R.startLineNumber<C.startLineNumber||R.endLineNumber<C.startLineNumber||R.startLineNumber>C.endLineNumber||R.endLineNumber>C.endLineNumber||R.startLineNumber===C.startLineNumber&&R.startColumn<=C.startColumn||R.endLineNumber===C.endLineNumber&&R.endColumn>=C.endColumn)}plusRange(C){return L.plusRange(this,C)}static plusRange(C,R){let E,S,A,n;return R.startLineNumber<C.startLineNumber?(E=R.startLineNumber,S=R.startColumn):R.startLineNumber===C.startLineNumber?(E=R.startLineNumber,S=Math.min(R.startColumn,C.startColumn)):(E=C.startLineNumber,S=C.startColumn),R.endLineNumber>C.endLineNumber?(A=R.endLineNumber,n=R.endColumn):R.endLineNumber===C.endLineNumber?(A=R.endLineNumber,n=Math.max(R.endColumn,C.endColumn)):(A=C.endLineNumber,n=C.endColumn),new L(E,S,A,n)}intersectRanges(C){return L.intersectRanges(this,C)}static intersectRanges(C,R){let E=C.startLineNumber,S=C.startColumn,A=C.endLineNumber,n=C.endColumn,P=R.startLineNumber,c=R.startColumn,h=R.endLineNumber,d=R.endColumn;return E<P?(E=P,S=c):E===P&&(S=Math.max(S,c)),A>h?(A=h,n=d):A===h&&(n=Math.min(n,d)),E>A||E===A&&S>n?null:new L(E,S,A,n)}equalsRange(C){return L.equalsRange(this,C)}static equalsRange(C,R){return!!C&&!!R&&C.startLineNumber===R.startLineNumber&&C.startColumn===R.startColumn&&C.endLineNumber===R.endLineNumber&&C.endColumn===R.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(C){return new m.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(C){return new m.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,R){return new L(this.startLineNumber,this.startColumn,C,R)}setStartPosition(C,R){return new L(C,R,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(C){return new L(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,R=C){return new L(C.lineNumber,C.column,R.lineNumber,R.column)}static lift(C){return C?new L(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,R){return!(C.endLineNumber<R.startLineNumber||C.endLineNumber===R.startLineNumber&&C.endColumn<R.startColumn||R.endLineNumber<C.startLineNumber||R.endLineNumber===C.startLineNumber&&R.endColumn<C.startColumn)}static areIntersecting(C,R){return!(C.endLineNumber<R.startLineNumber||C.endLineNumber===R.startLineNumber&&C.endColumn<=R.startColumn||R.endLineNumber<C.startLineNumber||R.endLineNumber===C.startLineNumber&&R.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,R){if(C&&R){const A=C.startLineNumber|0,n=R.startLineNumber|0;if(A===n){const P=C.startColumn|0,c=R.startColumn|0;if(P===c){const h=C.endLineNumber|0,d=R.endLineNumber|0;if(h===d){const g=C.endColumn|0,y=R.endColumn|0;return g-y}return h-d}return P-c}return A-n}return(C?1:0)-(R?1:0)}static compareRangesUsingEnds(C,R){return C.endLineNumber===R.endLineNumber?C.endColumn===R.endColumn?C.startLineNumber===R.startLineNumber?C.startColumn-R.startColumn:C.startLineNumber-R.startLineNumber:C.endColumn-R.endColumn:C.endLineNumber-R.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}}e.Range=L}),define(me[145],ge([0,1,51,41]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class C extends L.Range{constructor(E,S,A,n){super(E,S,A,n);this.selectionStartLineNumber=E,this.selectionStartColumn=S,this.positionLineNumber=A,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(E){return C.selectionsEqual(this,E)}static selectionsEqual(E,S){return E.selectionStartLineNumber===S.selectionStartLineNumber&&E.selectionStartColumn===S.selectionStartColumn&&E.positionLineNumber===S.positionLineNumber&&E.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(E,S){return this.getDirection()===0?new C(this.startLineNumber,this.startColumn,E,S):new C(E,S,this.startLineNumber,this.startColumn)}getPosition(){return new m.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(E,S){return this.getDirection()===0?new C(E,S,this.endLineNumber,this.endColumn):new C(this.endLineNumber,this.endColumn,E,S)}static fromPositions(E,S=E){return new C(E.lineNumber,E.column,S.lineNumber,S.column)}static liftSelection(E){return new C(E.selectionStartLineNumber,E.selectionStartColumn,E.positionLineNumber,E.positionColumn)}static selectionsArrEqual(E,S){if(E&&!S||!E&&S)return!1;if(!E&&!S)return!0;if(E.length!==S.length)return!1;for(let A=0,n=E.length;A<n;A++)if(!this.selectionsEqual(E[A],S[A]))return!1;return!0}static isISelection(E){return E&&typeof E.selectionStartLineNumber=="number"&&typeof E.selectionStartColumn=="number"&&typeof E.positionLineNumber=="number"&&typeof E.positionColumn=="number"}static createWithDirection(E,S,A,n,P){return P===0?new C(E,S,A,n):new C(A,n,E,S)}}e.Selection=C}),define(me[109],ge([0,1,25]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var L;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(L=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var R;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(R=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var E;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(E=e.EndOfLineSequence||(e.EndOfLineSequence={}));class S{constructor(y){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,y.tabSize|0),this.indentSize=y.tabSize|0,this.insertSpaces=Boolean(y.insertSpaces),this.defaultEOL=y.defaultEOL|0,this.trimAutoWhitespace=Boolean(y.trimAutoWhitespace),this.bracketPairColorizationOptions=y.bracketPairColorizationOptions}equals(y){return this.tabSize===y.tabSize&&this.indentSize===y.indentSize&&this.insertSpaces===y.insertSpaces&&this.defaultEOL===y.defaultEOL&&this.trimAutoWhitespace===y.trimAutoWhitespace&&(0,m.equals)(this.bracketPairColorizationOptions,y.bracketPairColorizationOptions)}createChangeEvent(y){return{tabSize:this.tabSize!==y.tabSize,indentSize:this.indentSize!==y.indentSize,insertSpaces:this.insertSpaces!==y.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==y.trimAutoWhitespace}}}e.TextModelResolvedOptions=S;class A{constructor(y,I){this._findMatchBrand=void 0,this.range=y,this.matches=I}}e.FindMatch=A;var n;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var P;(function(g){g[g.Left=0]="Left",g[g.Right=1]="Right",g[g.None=2]="None"})(P=e.PositionAffinity||(e.PositionAffinity={}));var c;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(c=e.ModelConstants||(e.ModelConstants={}));class h{constructor(y,I,_,s,o,p){this.identifier=y,this.range=I,this.text=_,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=o,this._isTracked=p}}e.ValidAnnotatedEditOperation=h;class d{constructor(y,I,_){this.reverseEdits=y,this.changes=I,this.trimAutoWhitespaceLineNumbers=_}}e.ApplyEditsResult=d}),define(me[146],ge([0,1,9,144,51,41,109]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const E=999;class S{constructor(s,o,p,t){this.searchString=s,this.isRegex=o,this.matchCase=p,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let s;this.isRegex?s=A(this.searchString):s=this.searchString.indexOf(`
`)>=0;let o=null;try{o=m.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:s,global:!0,unicode:!0})}catch(t){return null}if(!o)return null;let p=!this.isRegex&&!s;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new n(o,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,p?this.searchString:null)}}e.SearchParams=S;function A(_){if(!_||_.length===0)return!1;for(let s=0,o=_.length;s<o;s++)if(_.charCodeAt(s)===92){if(s++,s>=o)break;const t=_.charCodeAt(s);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=A;class n{constructor(s,o,p){this.regex=s,this.wordSeparators=o,this.simpleSearch=p}}e.SearchData=n;function P(_,s,o){if(!o)return new R.FindMatch(_,null);let p=[];for(let t=0,a=s.length;t<a;t++)p[t]=s[t];return new R.FindMatch(_,p)}e.createFindMatch=P;class c{constructor(s){let o=[],p=0;for(let t=0,a=s.length;t<a;t++)s.charCodeAt(t)===10&&(o[p++]=t);this._lineFeedsOffsets=o}findLineFeedCountBeforeOffset(s){const o=this._lineFeedsOffsets;let p=0,t=o.length-1;if(t===-1||s<=o[0])return 0;for(;p<t;){const a=p+((t-p)/2>>0);o[a]>=s?t=a-1:o[a+1]>=s?(p=a,t=a):p=a+1}return p+1}}class h{static findMatches(s,o,p,t,a){const r=o.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(s,p,new I(r.wordSeparators,r.regex),t,a):this._doFindMatchesLineByLine(s,p,r,t,a):[]}static _getMultilineMatchRange(s,o,p,t,a,r){let i,l=0;t?(l=t.findLineFeedCountBeforeOffset(a),i=o+a+l):i=o+a;let u;if(t){let w=t.findLineFeedCountBeforeOffset(a+r.length)-l;u=i+r.length+w}else u=i+r.length;const f=s.getPositionAt(i),b=s.getPositionAt(u);return new C.Range(f.lineNumber,f.column,b.lineNumber,b.column)}static _doFindMatchesMultiline(s,o,p,t,a){const r=s.getOffsetAt(o.getStartPosition()),i=s.getValueInRange(o,1),l=s.getEOL()===`\r
`?new c(i):null,u=[];let f=0,b;for(p.reset(0);b=p.next(i);)if(u[f++]=P(this._getMultilineMatchRange(s,r,i,l,b.index,b[0]),b,t),f>=a)return u;return u}static _doFindMatchesLineByLine(s,o,p,t,a){const r=[];let i=0;if(o.startLineNumber===o.endLineNumber){const u=s.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return i=this._findMatchesInLine(p,u,o.startLineNumber,o.startColumn-1,i,r,t,a),r}const l=s.getLineContent(o.startLineNumber).substring(o.startColumn-1);i=this._findMatchesInLine(p,l,o.startLineNumber,o.startColumn-1,i,r,t,a);for(let u=o.startLineNumber+1;u<o.endLineNumber&&i<a;u++)i=this._findMatchesInLine(p,s.getLineContent(u),u,0,i,r,t,a);if(i<a){const u=s.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);i=this._findMatchesInLine(p,u,o.endLineNumber,0,i,r,t,a)}return r}static _findMatchesInLine(s,o,p,t,a,r,i,l){const u=s.wordSeparators;if(!i&&s.simpleSearch){const D=s.simpleSearch,w=D.length,T=o.length;let v=-w;for(;(v=o.indexOf(D,v+w))!==-1;)if((!u||y(u,o,T,v,w))&&(r[a++]=new R.FindMatch(new C.Range(p,v+1+t,p,v+1+w+t),null),a>=l))return a;return a}const f=new I(s.wordSeparators,s.regex);let b;f.reset(0);do if(b=f.next(o),b&&(r[a++]=P(new C.Range(p,b.index+1+t,p,b.index+1+b[0].length+t),b,i),a>=l))return a;while(b);return a}static findNextMatch(s,o,p,t){const a=o.parseSearchRequest();if(!a)return null;const r=new I(a.wordSeparators,a.regex);return a.regex.multiline?this._doFindNextMatchMultiline(s,p,r,t):this._doFindNextMatchLineByLine(s,p,r,t)}static _doFindNextMatchMultiline(s,o,p,t){const a=new k.Position(o.lineNumber,1),r=s.getOffsetAt(a),i=s.getLineCount(),l=s.getValueInRange(new C.Range(a.lineNumber,a.column,i,s.getLineMaxColumn(i)),1),u=s.getEOL()===`\r
`?new c(l):null;p.reset(o.column-1);let f=p.next(l);return f?P(this._getMultilineMatchRange(s,r,l,u,f.index,f[0]),f,t):o.lineNumber!==1||o.column!==1?this._doFindNextMatchMultiline(s,new k.Position(1,1),p,t):null}static _doFindNextMatchLineByLine(s,o,p,t){const a=s.getLineCount(),r=o.lineNumber,i=s.getLineContent(r),l=this._findFirstMatchInLine(p,i,r,o.column,t);if(l)return l;for(let u=1;u<=a;u++){const f=(r+u-1)%a,b=s.getLineContent(f+1),D=this._findFirstMatchInLine(p,b,f+1,1,t);if(D)return D}return null}static _findFirstMatchInLine(s,o,p,t,a){s.reset(t-1);const r=s.next(o);return r?P(new C.Range(p,r.index+1,p,r.index+1+r[0].length),r,a):null}static findPreviousMatch(s,o,p,t){const a=o.parseSearchRequest();if(!a)return null;const r=new I(a.wordSeparators,a.regex);return a.regex.multiline?this._doFindPreviousMatchMultiline(s,p,r,t):this._doFindPreviousMatchLineByLine(s,p,r,t)}static _doFindPreviousMatchMultiline(s,o,p,t){const a=this._doFindMatchesMultiline(s,new C.Range(1,1,o.lineNumber,o.column),p,t,10*E);if(a.length>0)return a[a.length-1];const r=s.getLineCount();return o.lineNumber!==r||o.column!==s.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(s,new k.Position(r,s.getLineMaxColumn(r)),p,t):null}static _doFindPreviousMatchLineByLine(s,o,p,t){const a=s.getLineCount(),r=o.lineNumber,i=s.getLineContent(r).substring(0,o.column-1),l=this._findLastMatchInLine(p,i,r,t);if(l)return l;for(let u=1;u<=a;u++){const f=(a+r-u-1)%a,b=s.getLineContent(f+1),D=this._findLastMatchInLine(p,b,f+1,t);if(D)return D}return null}static _findLastMatchInLine(s,o,p,t){let a=null,r;for(s.reset(0);r=s.next(o);)a=P(new C.Range(p,r.index+1,p,r.index+1+r[0].length),r,t);return a}}e.TextModelSearch=h;function d(_,s,o,p,t){if(p===0)return!0;const a=s.charCodeAt(p-1);if(_.get(a)!==0||a===13||a===10)return!0;if(t>0){const r=s.charCodeAt(p);if(_.get(r)!==0)return!0}return!1}function g(_,s,o,p,t){if(p+t===o)return!0;const a=s.charCodeAt(p+t);if(_.get(a)!==0||a===13||a===10)return!0;if(t>0){const r=s.charCodeAt(p+t-1);if(_.get(r)!==0)return!0}return!1}function y(_,s,o,p,t){return d(_,s,o,p,t)&&g(_,s,o,p,t)}e.isValidMatch=y;class I{constructor(s,o){this._wordSeparators=s,this._searchRegex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(s){this._searchRegex.lastIndex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(s){const o=s.length;let p;do{if(this._prevMatchStartIndex+this._prevMatchLength===o||(p=this._searchRegex.exec(s),!p))return null;const t=p.index,a=p[0].length;if(t===this._prevMatchStartIndex&&a===this._prevMatchLength){if(a===0){m.getNextCodePoint(s,o,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=a,!this._wordSeparators||y(this._wordSeparators,s,o,t,a))return p}while(p);return null}}e.Searcher=I}),define(me[110],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(E=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const A of e.USUAL_WORD_SEPARATORS)E.indexOf(A)>=0||(S+="\\"+A);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=m();function L(E){let S=e.DEFAULT_WORD_REGEXP;if(E&&E instanceof RegExp)if(E.global)S=E;else{let A="g";E.ignoreCase&&(A+="i"),E.multiline&&(A+="m"),E.unicode&&(A+="u"),S=new RegExp(E.source,A)}return S.lastIndex=0,S}e.ensureValidWordDefinition=L;const k={maxLen:1e3,windowSize:15,timeBudget:150};function C(E,S,A,n,P=k){if(A.length>P.maxLen){let y=E-P.maxLen/2;return y<0?y=0:n+=y,A=A.substring(y,E+P.maxLen/2),C(E,S,A,n,P)}const c=Date.now(),h=E-1-n;let d=-1,g=null;for(let y=1;!(Date.now()-c>=P.timeBudget);y++){const I=h-P.windowSize*y;S.lastIndex=Math.max(0,I);const _=R(S,A,h,d);if(!_&&g||(g=_,I<=0))break;d=I}if(g){let y={word:g[0],startColumn:n+1+g.index,endColumn:n+1+g.index+g[0].length};return S.lastIndex=0,y}return null}e.getWordAtText=C;function R(E,S,A,n){let P;for(;P=E.exec(S);){const c=P.index||0;if(c<=A&&E.lastIndex>=A)return P;if(n>0&&c>n)return null}return null}}),define(me[147],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var m;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(m=e.IndentAction||(e.IndentAction={}));class L{constructor(E){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=E.open,this.close=E.close,this._standardTokenMask=0,Array.isArray(E.notIn))for(let S=0,A=E.notIn.length;S<A;S++)switch(E.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(E){return(this._standardTokenMask&E)==0}}e.StandardAutoClosingPairConditional=L;class k{constructor(E){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of E)C(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),C(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),C(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),C(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&C(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=k;function C(R,E,S){R.has(E)?R.get(E).push(S):R.set(E,[S])}}),define(me[81],ge([0,1,30,8]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(C,R,E,S){if(Array.isArray(C)){let A=0;for(const n of C){const P=k(n,R,E,S);if(P===10)return P;P>A&&(A=P)}return A}else{if(typeof C=="string")return S?C==="*"?5:C===E?10:0:0;if(C){const{language:A,pattern:n,scheme:P,hasAccessToAllModels:c}=C;if(!S&&!c)return 0;let h=0;if(P)if(P===R.scheme)h=10;else if(P==="*")h=5;else return 0;if(A)if(A===E)h=10;else if(A==="*")h=Math.max(h,5);else return 0;if(n){let d;if(typeof n=="string"?d=n:d={...n,base:(0,L.normalize)(n.base)},d===R.fsPath||(0,m.match)(d,R.fsPath))h=10;else return 0}return h}else return 0}}e.score=k}),define(me[148],ge([0,1,108]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class k{constructor(d,g,y){const I=new Uint8Array(d*g);for(let _=0,s=d*g;_<s;_++)I[_]=y;this._data=I,this.rows=d,this.cols=g}get(d,g){return this._data[d*this.cols+g]}set(d,g,y){this._data[d*this.cols+g]=y}}e.Uint8Matrix=k;class C{constructor(d){let g=0,y=0;for(let _=0,s=d.length;_<s;_++){let[o,p,t]=d[_];p>g&&(g=p),o>y&&(y=o),t>y&&(y=t)}g++,y++;let I=new k(y,g,0);for(let _=0,s=d.length;_<s;_++){let[o,p,t]=d[_];I.set(o,p,t)}this._states=I,this._maxCharCode=g}nextState(d,g){return g<0||g>=this._maxCharCode?0:this._states.get(d,g)}}e.StateMachine=C;let R=null;function E(){return R===null&&(R=new C([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var S;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let A=null;function n(){if(A===null){A=new m.CharacterClassifier(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<h.length;g++)A.set(h.charCodeAt(g),1);const d=".,;";for(let g=0;g<d.length;g++)A.set(d.charCodeAt(g),2)}return A}class P{static _createLink(d,g,y,I,_){let s=_-1;do{const o=g.charCodeAt(s);if(d.get(o)!==2)break;s--}while(s>I);if(I>0){const o=g.charCodeAt(I-1),p=g.charCodeAt(s);(o===40&&p===41||o===91&&p===93||o===123&&p===125)&&s--}return{range:{startLineNumber:y,startColumn:I+1,endLineNumber:y,endColumn:s+2},url:g.substring(I,s+1)}}static computeLinks(d,g=E()){const y=n();let I=[];for(let _=1,s=d.getLineCount();_<=s;_++){const o=d.getLineContent(_),p=o.length;let t=0,a=0,r=0,i=1,l=!1,u=!1,f=!1,b=!1;for(;t<p;){let D=!1;const w=o.charCodeAt(t);if(i===13){let T;switch(w){case 40:l=!0,T=0;break;case 41:T=l?0:1;break;case 91:f=!0,u=!0,T=0;break;case 93:f=!1,T=u?0:1;break;case 123:b=!0,T=0;break;case 125:T=b?0:1;break;case 39:T=r===34||r===96?0:1;break;case 34:T=r===39||r===96?0:1;break;case 96:T=r===39||r===34?0:1;break;case 42:T=r===42?1:0;break;case 124:T=r===124?1:0;break;case 32:T=f?0:1;break;default:T=y.get(w)}T===1&&(I.push(P._createLink(y,o,_,a,t)),D=!0)}else if(i===12){let T;w===91?(u=!0,T=0):T=y.get(w),T===1?D=!0:i=13}else i=g.nextState(i,w),i===0&&(D=!0);D&&(i=1,l=!1,u=!1,b=!1,a=t+1,r=w),t++}i===13&&I.push(P._createLink(y,o,_,a,p))}return I}}e.LinkComputer=P;function c(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:P.computeLinks(h)}e.computeLinks=c}),define(me[149],ge([0,1,3,6]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class k{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new m.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(R){this._onDidChange.fire({changedLanguages:R,changedColorMap:!1})}register(R,E){return this._map.set(R,E),this.fire([R]),(0,L.toDisposable)(()=>{this._map.get(R)===E&&(this._map.delete(R),this.fire([R]))})}registerPromise(R,E){let S=null,A=!1;return this._promises.set(R,E.then(n=>{this._promises.delete(R),!(A||!n)&&(S=this.register(R,n))})),(0,L.toDisposable)(()=>{A=!0,S&&S.dispose()})}getPromise(R){const E=this.get(R);if(E)return Promise.resolve(E);const S=this._promises.get(R);return S?S.then(A=>this.get(R)):null}get(R){return this._map.get(R)||null}setColorMap(R){this._colorMap=R,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=k}),define(me[111],ge([0,1,23,11]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(k||(k={}));function C(P){for(let c=0,h=P.length;c<h;c+=4){const d=P[c+0],g=P[c+1],y=P[c+2],I=P[c+3];P[c+0]=I,P[c+1]=y,P[c+2]=g,P[c+3]=d}}function R(P){const c=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return L.isLittleEndian()||C(c),m.VSBuffer.wrap(c)}function E(P){const c=P.buffer;if(L.isLittleEndian()||C(c),c.byteOffset%4==0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const h=new Uint8Array(c.byteLength);return h.set(c),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function S(P){const c=new Uint32Array(A(P));let h=0;if(c[h++]=P.id,P.type==="full")c[h++]=1,c[h++]=P.data.length,c.set(P.data,h),h+=P.data.length;else{c[h++]=2,c[h++]=P.deltas.length;for(const d of P.deltas)c[h++]=d.start,c[h++]=d.deleteCount,d.data?(c[h++]=d.data.length,c.set(d.data,h),h+=d.data.length):c[h++]=0}return R(c)}e.encodeSemanticTokensDto=S;function A(P){let c=0;if(c+=1+1,P.type==="full")c+=1+P.data.length;else{c+=1,c+=(1+1+1)*P.deltas.length;for(const h of P.deltas)h.data&&(c+=h.data.length)}return c}function n(P){const c=E(P);let h=0;const d=c[h++];if(c[h++]===1){const _=c[h++],s=c.subarray(h,h+_);return h+=_,{id:d,type:"full",data:s}}const y=c[h++];let I=[];for(let _=0;_<y;_++){const s=c[h++],o=c[h++],p=c[h++];let t;p>0&&(t=c.subarray(h,h+p),h+=p),I[_]={start:s,deleteCount:o,data:t}}return{id:d,type:"delta",deltas:I}}e.decodeSemanticTokensDto=n}),define(me[112],ge([0,1,97]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class L{constructor(R,E){this._prefixSumIndexOfResultBrand=void 0,this.index=R,this.remainder=E}}e.PrefixSumIndexOfResult=L;class k{constructor(R){this.values=R,this.prefixSum=new Uint32Array(R.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(R,E){R=(0,m.toUint32)(R);const S=this.values,A=this.prefixSum,n=E.length;return n===0?!1:(this.values=new Uint32Array(S.length+n),this.values.set(S.subarray(0,R),0),this.values.set(S.subarray(R),R+n),this.values.set(E,R),R-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=R-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(A.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(R,E){return R=(0,m.toUint32)(R),E=(0,m.toUint32)(E),this.values[R]===E?!1:(this.values[R]=E,R-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=R-1),!0)}removeValues(R,E){R=(0,m.toUint32)(R),E=(0,m.toUint32)(E);const S=this.values,A=this.prefixSum;if(R>=S.length)return!1;let n=S.length-R;return E>=n&&(E=n),E===0?!1:(this.values=new Uint32Array(S.length-E),this.values.set(S.subarray(0,R),0),this.values.set(S.subarray(R+E),R),this.prefixSum=new Uint32Array(this.values.length),R-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=R-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(A.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(R){return R<0?0:(R=(0,m.toUint32)(R),this._getPrefixSum(R))}_getPrefixSum(R){if(R<=this.prefixSumValidIndex[0])return this.prefixSum[R];let E=this.prefixSumValidIndex[0]+1;E===0&&(this.prefixSum[0]=this.values[0],E++),R>=this.values.length&&(R=this.values.length-1);for(let S=E;S<=R;S++)this.prefixSum[S]=this.prefixSum[S-1]+this.values[S];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],R),this.prefixSum[R]}getIndexOf(R){R=Math.floor(R),this.getTotalSum();let E=0,S=this.values.length-1,A=0,n=0,P=0;for(;E<=S;)if(A=E+(S-E)/2|0,n=this.prefixSum[A],P=n-this.values[A],R<P)S=A-1;else if(R>=n)E=A+1;else break;return new L(A,R-P)}}e.PrefixSumComputer=k}),define(me[150],ge([0,1,9,51,112]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class C{constructor(E,S,A,n){this._uri=E,this._lines=S,this._eol=A,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(E){E.eol&&E.eol!==this._eol&&(this._eol=E.eol,this._lineStarts=null);const S=E.changes;for(const A of S)this._acceptDeleteRange(A.range),this._acceptInsertText(new L.Position(A.range.startLineNumber,A.range.startColumn),A.text);this._versionId=E.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const E=this._eol.length,S=this._lines.length,A=new Uint32Array(S);for(let n=0;n<S;n++)A[n]=this._lines[n].length+E;this._lineStarts=new k.PrefixSumComputer(A)}}_setLineText(E,S){this._lines[E]=S,this._lineStarts&&this._lineStarts.changeValue(E,this._lines[E].length+this._eol.length)}_acceptDeleteRange(E){if(E.startLineNumber===E.endLineNumber){if(E.startColumn===E.endColumn)return;this._setLineText(E.startLineNumber-1,this._lines[E.startLineNumber-1].substring(0,E.startColumn-1)+this._lines[E.startLineNumber-1].substring(E.endColumn-1));return}this._setLineText(E.startLineNumber-1,this._lines[E.startLineNumber-1].substring(0,E.startColumn-1)+this._lines[E.endLineNumber-1].substring(E.endColumn-1)),this._lines.splice(E.startLineNumber,E.endLineNumber-E.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(E.startLineNumber,E.endLineNumber-E.startLineNumber)}_acceptInsertText(E,S){if(S.length===0)return;let A=(0,m.splitLines)(S);if(A.length===1){this._setLineText(E.lineNumber-1,this._lines[E.lineNumber-1].substring(0,E.column-1)+A[0]+this._lines[E.lineNumber-1].substring(E.column-1));return}A[A.length-1]+=this._lines[E.lineNumber-1].substring(E.column-1),this._setLineText(E.lineNumber-1,this._lines[E.lineNumber-1].substring(0,E.column-1)+A[0]);let n=new Uint32Array(A.length-1);for(let P=1;P<A.length;P++)this._lines.splice(E.lineNumber+P-1,0,A[P]),n[P-1]=A[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(E.lineNumber,n)}}e.MirrorTextModel=C}),define(me[151],ge([19,20]),function(J,e){return J.create("vs/base/common/date",e)}),define(me[152],ge([0,1,151]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,k=L*60,C=k*24,R=C*7,E=C*30,S=C*365;function A(P,c){typeof P!="number"&&(P=P.getTime());const h=Math.round((new Date().getTime()-P)/1e3);if(h<-30)return(0,m.localize)(0,null,A(new Date().getTime()+h*1e3,!1));if(h<30)return(0,m.localize)(1,null);let d;return h<L?(d=h,c?d===1?(0,m.localize)(2,null,d):(0,m.localize)(3,null,d):d===1?(0,m.localize)(4,null,d):(0,m.localize)(5,null,d)):h<k?(d=Math.floor(h/L),c?d===1?(0,m.localize)(6,null,d):(0,m.localize)(7,null,d):d===1?(0,m.localize)(8,null,d):(0,m.localize)(9,null,d)):h<C?(d=Math.floor(h/k),c?d===1?(0,m.localize)(10,null,d):(0,m.localize)(11,null,d):d===1?(0,m.localize)(12,null,d):(0,m.localize)(13,null,d)):h<R?(d=Math.floor(h/C),c?d===1?(0,m.localize)(14,null,d):(0,m.localize)(15,null,d):d===1?(0,m.localize)(16,null,d):(0,m.localize)(17,null,d)):h<E?(d=Math.floor(h/R),c?d===1?(0,m.localize)(18,null,d):(0,m.localize)(19,null,d):d===1?(0,m.localize)(20,null,d):(0,m.localize)(21,null,d)):h<S?(d=Math.floor(h/E),c?d===1?(0,m.localize)(22,null,d):(0,m.localize)(23,null,d):d===1?(0,m.localize)(24,null,d):(0,m.localize)(25,null,d)):(d=Math.floor(h/S),c?d===1?(0,m.localize)(26,null,d):(0,m.localize)(27,null,d):d===1?(0,m.localize)(28,null,d):(0,m.localize)(29,null,d))}e.fromNow=A;function n(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(me[153],ge([19,20]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(me[61],ge([0,1,17,13,153]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(A,n){return n&&(A.stack||A.stacktrace)?k.localize(0,null,E(A),R(A.stack)||R(A.stacktrace)):E(A)}function R(A){return Array.isArray(A)?A.join(`
`):A}function E(A){return typeof A.code=="string"&&typeof A.errno=="number"&&typeof A.syscall=="string"?k.localize(1,null,A.message):A.message||k.localize(2,null)}function S(A=null,n=!1){if(!A)return k.localize(3,null);if(Array.isArray(A)){const P=m.coalesce(A),c=S(P[0],n);return P.length>1?k.localize(4,null,c,P.length):c}if(L.isString(A))return A;if(A.detail){const P=A.detail;if(P.error)return C(P.error,n);if(P.exception)return C(P.exception,n)}return A.stack?C(A,n):A.message?A.message:k.localize(5,null)}e.toErrorMessage=S}),define(me[154],ge([19,20]),function(J,e){return J.create("vs/base/node/processes",e)}),define(me[113],ge([0,1,39,29,10,25,8,11,38,13,143,28,154]),function(J,e,m,L,k,C,R,E,S,A,n,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function h(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(o,p){if(E.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};p&&(t.cwd=p);const a=m.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],t);return new Promise(r=>{a.once("error",i=>{r({success:!1,error:i})}),a.once("exit",(i,l)=>{r(i===0?{success:!0}:{success:!1,code:i!==null?i:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?h(t.status):1})}else if(E.isLinux||E.isMacintosh)try{const t=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(a=>{m.execFile(t,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,i,l)=>{a(r?{success:!1,error:r}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function g(o=S.env){return o.comspec||"cmd.exe"}e.getWindowsShell=g;class y{constructor(p,t,a,r){if(t!==void 0&&a!==void 0&&r!==void 0)this.cmd=p,this.args=t,this.shell=a,this.options=r;else{const i=p;this.cmd=i.command,this.shell=i.isShellCommand,this.args=i.args.slice(0),this.options=i.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const i=Object.create(null);Object.keys(S.env).forEach(l=>{i[l]=S.env[l]}),Object.keys(this.options.env).forEach(l=>{i[l]=this.options.env[l]}),this.options.env=i}}getSanitizedCommand(){let p=this.cmd.toLowerCase();const t=p.lastIndexOf(R.sep);return t!==-1&&(p=p.substring(t+1)),y.WellKnowCommands[p]?p:"other"}start(p){return E.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(S.cwd()))?Promise.reject(new Error(c.localize(0,null))):this.useExec().then(t=>{let a,r;const i=new Promise((l,u)=>{a=l,r=u});if(t){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=m.exec(l,this.options,(u,f,b)=>{this.childProcess=null;const D=u;D&&D.killed?r({killed:this.terminateRequested,stdout:f.toString(),stderr:b.toString()}):this.handleExec(a,p,u,f,b)})}else{let l=null;const u=f=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(f,a,p,r);const b={terminated:this.terminateRequested};A.isNumber(f)&&(b.cmdCode=f),a(b)};if(this.shell&&E.isWindows){const f=C.deepClone(this.options);f.windowsVerbatimArguments=!0,f.detached=!1;let b=!1,D=!1;const w=[];let T=this.ensureQuotes(this.cmd);w.push(T.value),b=T.quoted,this.args&&this.args.forEach(F=>{T=this.ensureQuotes(F),w.push(T.value),D=D&&T.quoted});const v=["/s","/c"];b?D?v.push('"'+w.join(" ")+'"'):w.length>1?v.push('"'+w[0]+'" '+w.slice(1).join(" ")):v.push('"'+w[0]+'"'):v.push(w.join(" ")),l=m.spawn(g(),v,f)}else this.cmd&&(l=m.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(A.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",f=>{this.childProcess=null,r({terminated:this.terminateRequested,error:f})}),l.pid&&(this.childProcess.on("close",u),this.handleSpawn(l,a,p,r,!0)))}return i})}handleClose(p,t,a,r){}ensureQuotes(p){return y.regexp.test(p)?{value:'"'+p+'"',quoted:!0}:{value:p,quoted:p.length>0&&p[0]==='"'&&p[p.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(p=>p.pid,p=>-1):new Promise(p=>{this.pidResolve=p})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(p=>(this.terminateRequested=!0,d(p,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),p=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(p=>{if(!this.shell||!E.isWindows)return p(!1);const t=m.spawn(g(),["/s","/c"]);t.on("error",a=>p(!0)),t.on("exit",a=>p(!1))})}}e.AbstractProcess=y,y.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},y.regexp=/^[^"].* .*[^"]/;class I extends y{constructor(p,t,a,r){super(p,t,a,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(p,t,a,r,i){[r,i].forEach((l,u)=>{const f=new n.LineDecoder;f.write(l).forEach(w=>{t({line:w,source:u===0?0:1})});const D=f.end();D&&t({line:D,source:u===0?0:1})}),p({terminated:this.terminateRequested,error:a})}handleSpawn(p,t,a,r,i){const l=new n.LineDecoder,u=new n.LineDecoder;p.stdout.on("data",f=>{l.write(f).forEach(D=>a({line:D,source:0}))}),p.stderr.on("data",f=>{u.write(f).forEach(D=>a({line:D,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=u}handleClose(p,t,a,r){const i=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;i&&a({line:i,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&a({line:l,source:1})}}e.LineProcess=I;function _(o){let p=[],t=!1;const a=function(r){if(t){p.push(r);return}(!o.send(r,l=>{if(l&&console.error(l),t=!1,p.length>0){const u=p.slice(0);p=[],u.forEach(f=>a(f))}})||E.isWindows)&&(t=!0)};return{send:a}}e.createQueuedSender=_;var s;(function(o){async function p(t,a,r){if(R.isAbsolute(t))return t;if(a===void 0&&(a=S.cwd()),R.dirname(t)!=="."||(r===void 0&&A.isString(S.env.PATH)&&(r=S.env.PATH.split(R.delimiter)),r===void 0||r.length===0))return R.join(a,t);async function l(u){if(await P.Promises.exists(u)){let f;try{f=await P.Promises.stat(u)}catch(b){b.message.startsWith("EACCES")&&(f=await P.Promises.lstat(u))}return f?!f.isDirectory():!1}return!1}for(let u of r){let f;if(R.isAbsolute(u)?f=R.join(u,t):f=R.join(a,u,t),await l(f))return f;let b=f+".com";if(await l(b)||(b=f+".exe",await l(b)))return b}return R.join(a,t)}o.findExecutable=p})(s=e.win32||(e.win32={}))}),define(me[155],ge([19,20]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(me[114],ge([0,1,155,11,110]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var C;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(C=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class R{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=R;class E{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,pe){this._values[te]=pe}}e.ValidatedEditorOptions=E;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class A{constructor(te,pe,ze,tt){this.id=te,this.name=pe,this.defaultValue=ze,this.schema=tt}compute(te,pe,ze){return ze}}class n{constructor(te,pe=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(te){return this.defaultValue}}class P{constructor(te,pe,ze,tt){this.id=te,this.name=pe,this.defaultValue=ze,this.schema=tt}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,pe,ze){return ze}}function c(X,te){return typeof X=="undefined"?te:X==="false"?!1:Boolean(X)}e.boolean=c;class h extends P{constructor(te,pe,ze,tt=void 0){typeof tt!="undefined"&&(tt.type="boolean",tt.default=ze),super(te,pe,ze,tt)}validate(te){return c(te,this.defaultValue)}}function d(X,te,pe,ze){if(typeof X=="undefined")return te;let tt=parseInt(X,10);return isNaN(tt)?te:(tt=Math.max(pe,tt),tt=Math.min(ze,tt),tt|0)}e.clampedInt=d;class g extends P{constructor(te,pe,ze,tt,ut,lt=void 0){typeof lt!="undefined"&&(lt.type="integer",lt.default=ze,lt.minimum=tt,lt.maximum=ut),super(te,pe,ze,lt),this.minimum=tt,this.maximum=ut}static clampedInt(te,pe,ze,tt){return d(te,pe,ze,tt)}validate(te){return g.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class y extends P{constructor(te,pe,ze,tt,ut){typeof ut!="undefined"&&(ut.type="number",ut.default=ze),super(te,pe,ze,ut),this.validationFn=tt}static clamp(te,pe,ze){return te<pe?pe:te>ze?ze:te}static float(te,pe){if(typeof te=="number")return te;if(typeof te=="undefined")return pe;const ze=parseFloat(te);return isNaN(ze)?pe:ze}validate(te){return this.validationFn(y.float(te,this.defaultValue))}}class I extends P{static string(te,pe){return typeof te!="string"?pe:te}constructor(te,pe,ze,tt=void 0){typeof tt!="undefined"&&(tt.type="string",tt.default=ze),super(te,pe,ze,tt)}validate(te){return I.string(te,this.defaultValue)}}function _(X,te,pe){return typeof X!="string"||pe.indexOf(X)===-1?te:X}e.stringSet=_;class s extends P{constructor(te,pe,ze,tt,ut=void 0){typeof ut!="undefined"&&(ut.type="string",ut.enum=tt,ut.default=ze),super(te,pe,ze,ut),this._allowedValues=tt}validate(te){return _(te,this.defaultValue,this._allowedValues)}}class o extends A{constructor(te,pe,ze,tt,ut,lt,vt=void 0){typeof vt!="undefined"&&(vt.type="string",vt.enum=ut,vt.default=tt),super(te,pe,ze,vt),this._allowedValues=ut,this._convert=lt}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function p(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class t extends A{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",description:m.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,pe,ze){return ze===0?te.accessibilitySupport:ze}}class a extends A{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(18,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:m.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{insertSpace:c(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var l;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(l=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function u(X){switch(X){case l.Line:return"line";case l.Block:return"block";case l.Underline:return"underline";case l.LineThin:return"line-thin";case l.BlockOutline:return"block-outline";case l.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=u;function f(X){switch(X){case"line":return l.Line;case"block":return l.Block;case"underline":return l.Underline;case"line-thin":return l.LineThin;case"block-outline":return l.BlockOutline;case"underline-thin":return l.UnderlineThin}}class b extends n{constructor(){super(127,[65,32])}compute(te,pe,ze){const tt=["monaco-editor"];return pe.get(32)&&tt.push(pe.get(32)),te.extraEditorClassName&&tt.push(te.extraEditorClassName),pe.get(65)==="default"?tt.push("mouse-default"):pe.get(65)==="copy"&&tt.push("mouse-copy"),pe.get(100)&&tt.push("showUnused"),pe.get(125)&&tt.push("showDeprecated"),tt.join(" ")}}class D extends h{constructor(){super(31,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(te,pe,ze){return ze&&te.emptySelectionClipboard}}class w extends A{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(34,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:te.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:m.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:m.localize(18,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{cursorMoveOnType:c(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof te.seedSearchStringFromSelection=="boolean"?te.seedSearchStringFromSelection?"always":"never":_(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":_(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(pe.loop,this.defaultValue.loop)}}}class T extends A{constructor(){super(43,"fontLigatures",T.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?T.OFF:te==="true"?T.ON:te:Boolean(te)?T.ON:T.OFF}}e.EditorFontLigatures=T,T.OFF='"liga" off, "calt" off',T.ON='"liga" on, "calt" on';class v extends n{constructor(){super(42)}compute(te,pe,ze){return te.fontInfo}}class F extends P{constructor(){super(44,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(22,null)})}validate(te){let pe=y.float(te,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:y.clamp(pe,6,100)}compute(te,pe,ze){return te.fontInfo.fontSize}}class M extends A{constructor(){super(45,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:M.MINIMUM_VALUE,maximum:M.MAXIMUM_VALUE,errorMessage:m.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:M.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(24,null)})}validate(te){return te==="normal"||te==="bold"?te:String(g.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,M.MINIMUM_VALUE,M.MAXIMUM_VALUE))}}M.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],M.MINIMUM_VALUE=1,M.MAXIMUM_VALUE=1e3;class G extends A{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[m.localize(25,null),m.localize(26,null),m.localize(27,null)]},ze=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(49,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(29,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(30,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:m.localize(31,null),...pe},"editor.gotoLocation.multipleImplementations":{description:m.localize(32,null),...pe},"editor.gotoLocation.multipleReferences":{description:m.localize(33,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,enum:ze,description:m.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,enum:ze,description:m.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,enum:ze,description:m.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,enum:ze,description:m.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,enum:ze,description:m.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{multiple:_(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??_(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??_(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??_(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??_(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??_(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:I.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:I.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:I.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:I.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:I.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class K extends A{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(52,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:m.localize(39,null)},"editor.hover.delay":{type:"number",default:te.delay,description:m.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:m.localize(41,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:c(pe.enabled,this.defaultValue.enabled),delay:g.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:c(pe.sticky,this.defaultValue.sticky)}}}var U;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(U=e.RenderMinimap||(e.RenderMinimap={}));class z extends n{constructor(){super(130,[48,57,36,64,92,59,60,94,117,120,121,122,2])}compute(te,pe,ze){return z.computeLayout(pe,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const pe=te.height/te.lineHeight,ze=te.scrollBeyondLastLine?pe-1:0,tt=(te.viewLineCount+ze)/(te.pixelRatio*te.height),ut=Math.floor(te.viewLineCount/tt);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:ze,desiredRatio:tt,minimapLineCount:ut}}static _computeMinimapLayout(te,pe){const ze=te.outerWidth,tt=te.outerHeight,ut=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ut*tt),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:tt};const lt=pe.stableMinimapLayoutInput,vt=lt&&te.outerHeight===lt.outerHeight&&te.lineHeight===lt.lineHeight&&te.typicalHalfwidthCharacterWidth===lt.typicalHalfwidthCharacterWidth&&te.pixelRatio===lt.pixelRatio&&te.scrollBeyondLastLine===lt.scrollBeyondLastLine&&te.minimap.enabled===lt.minimap.enabled&&te.minimap.side===lt.minimap.side&&te.minimap.size===lt.minimap.size&&te.minimap.showSlider===lt.minimap.showSlider&&te.minimap.renderCharacters===lt.minimap.renderCharacters&&te.minimap.maxColumn===lt.minimap.maxColumn&&te.minimap.scale===lt.minimap.scale&&te.verticalScrollbarWidth===lt.verticalScrollbarWidth&&te.isViewportWrapping===lt.isViewportWrapping,Dt=te.lineHeight,ue=te.typicalHalfwidthCharacterWidth,Ie=te.scrollBeyondLastLine,Be=te.minimap.renderCharacters;let Ke=ut>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const We=te.minimap.maxColumn,ot=te.minimap.size,Le=te.minimap.side,ye=te.verticalScrollbarWidth,ke=te.viewLineCount,ne=te.remainingWidth,de=te.isViewportWrapping,be=Be?2:3;let we=Math.floor(ut*tt);const Fe=we/ut;let Ge=!1,He=!1,Ye=be*Ke,it=Ke/ut,ae=1;if(ot==="fill"||ot==="fit"){const{typicalViewportLineCount:Xe,extraLinesBeyondLastLine:st,desiredRatio:wt,minimapLineCount:_t}=z.computeContainedMinimapLineCount({viewLineCount:ke,scrollBeyondLastLine:Ie,height:tt,lineHeight:Dt,pixelRatio:ut});if(ke/_t>1)Ge=!0,He=!0,Ke=1,Ye=1,it=Ke/ut;else{let gt=!1,ft=Ke+1;if(ot==="fit"){const Tt=Math.ceil((ke+st)*Ye);de&&vt&&ne<=pe.stableFitRemainingWidth?(gt=!0,ft=pe.stableFitMaxMinimapScale):gt=Tt>we}if(ot==="fill"||gt){Ge=!0;const Tt=Ke;Ye=Math.min(Dt*ut,Math.max(1,Math.floor(1/wt))),de&&vt&&ne<=pe.stableFitRemainingWidth&&(ft=pe.stableFitMaxMinimapScale),Ke=Math.min(ft,Math.max(1,Math.floor(Ye/be))),Ke>Tt&&(ae=Math.min(2,Ke/Tt)),it=Ke/ut/ae,we=Math.ceil(Math.max(Xe,ke+st)*Ye),de?(pe.stableMinimapLayoutInput=te,pe.stableFitRemainingWidth=ne,pe.stableFitMaxMinimapScale=Ke):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const Ee=Math.floor(We*it),ce=Math.min(Ee,Math.max(0,Math.floor((ne-ye-2)*it/(ue+it)))+e.MINIMAP_GUTTER_WIDTH);let q=Math.floor(ut*ce);const Te=q/ut;q=Math.floor(q*ae);const Pe=Be?1:2,Ze=Le==="left"?0:ze-ce-ye;return{renderMinimap:Pe,minimapLeft:Ze,minimapWidth:ce,minimapHeightIsEditorHeight:Ge,minimapIsSampling:He,minimapScale:Ke,minimapLineHeight:Ye,minimapCanvasInnerWidth:q,minimapCanvasInnerHeight:we,minimapCanvasOuterWidth:Te,minimapCanvasOuterHeight:Fe}}static computeLayout(te,pe){const ze=pe.outerWidth|0,tt=pe.outerHeight|0,ut=pe.lineHeight|0,lt=pe.lineNumbersDigitCount|0,vt=pe.typicalHalfwidthCharacterWidth,Dt=pe.maxDigitWidth,ue=pe.pixelRatio,Ie=pe.viewLineCount,Be=te.get(122),Ke=Be==="inherit"?te.get(121):Be,We=Ke==="inherit"?te.get(117):Ke,ot=te.get(120),Le=te.get(2),ye=pe.isDominatedByLongLines,ke=te.get(48),ne=te.get(59).renderType!==0,de=te.get(60),be=te.get(94),we=te.get(64),Fe=te.get(92),Ge=Fe.verticalScrollbarSize,He=Fe.verticalHasArrows,Ye=Fe.arrowSize,it=Fe.horizontalScrollbarSize,ae=te.get(57),Ee=te.get(36);let ce;if(typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)){const $t=parseFloat(ae.substr(0,ae.length-2));ce=g.clampedInt($t*vt,0,0,1e3)}else ce=g.clampedInt(ae,0,0,1e3);Ee&&(ce+=16);let q=0;if(ne){const $t=Math.max(lt,de);q=Math.round($t*Dt)}let Te=0;ke&&(Te=ut);let Pe=0,Ze=Pe+Te,Xe=Ze+q,st=Xe+ce;const wt=ze-Te-q-ce;let _t=!1,dt=!1,gt=-1;Le!==2&&(Ke==="inherit"&&ye?(_t=!0,dt=!0):We==="on"||We==="bounded"?dt=!0:We==="wordWrapColumn"&&(gt=ot));const ft=z._computeMinimapLayout({outerWidth:ze,outerHeight:tt,lineHeight:ut,typicalHalfwidthCharacterWidth:vt,pixelRatio:ue,scrollBeyondLastLine:be,minimap:we,verticalScrollbarWidth:Ge,viewLineCount:Ie,remainingWidth:wt,isViewportWrapping:dt},pe.memory||new S);ft.renderMinimap!==0&&ft.minimapLeft===0&&(Pe+=ft.minimapWidth,Ze+=ft.minimapWidth,Xe+=ft.minimapWidth,st+=ft.minimapWidth);const Tt=wt-ft.minimapWidth,yt=Math.max(1,Math.floor((Tt-Ge-2)/vt)),Bt=He?Ye:0;return dt&&(gt=Math.max(1,yt),We==="bounded"&&(gt=Math.min(gt,ot))),{width:ze,height:tt,glyphMarginLeft:Pe,glyphMarginWidth:Te,lineNumbersLeft:Ze,lineNumbersWidth:q,decorationsLeft:Xe,decorationsWidth:ce,contentLeft:st,contentWidth:Tt,minimap:ft,viewportColumn:yt,isWordWrapMinified:_t,isViewportWrapping:dt,wrappingColumn:gt,verticalScrollbarWidth:Ge,horizontalScrollbarHeight:it,overviewRuler:{top:Bt,width:Ge,height:tt-2*Bt,right:0}}}}e.EditorLayoutInfoComputer=z;class N extends A{constructor(){const te={enabled:!0};super(56,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:m.localize(42,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:c(te.enabled,this.defaultValue.enabled)}}}class x extends A{constructor(){const te={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",te,{"editor.inlayHints.enabled":{type:"boolean",default:te.enabled,description:m.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:te.fontSize,markdownDescription:m.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:te.fontFamily,markdownDescription:m.localize(45,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:c(pe.enabled,this.defaultValue.enabled),fontSize:g.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:I.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class B extends y{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,te=>y.clamp(te,0,150),{markdownDescription:m.localize(46,null)})}compute(te,pe,ze){return te.fontInfo.lineHeight}}class O extends A{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:m.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(48,null),m.localize(49,null),m.localize(50,null)],default:te.size,description:m.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:m.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:m.localize(53,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:m.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:m.localize(56,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:c(pe.enabled,this.defaultValue.enabled),size:_(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:_(pe.side,this.defaultValue.side,["right","left"]),showSlider:_(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(pe.renderCharacters,this.defaultValue.renderCharacters),scale:g.clampedInt(pe.scale,1,1,3),maxColumn:g.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function H(X){return X==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class W extends A{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(58,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{top:g.clampedInt(pe.top,0,0,1e3),bottom:g.clampedInt(pe.bottom,0,0,1e3)}}}class Q extends A{constructor(){const te={enabled:!0,cycle:!1};super(75,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:m.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:m.localize(60,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:c(pe.enabled,this.defaultValue.enabled),cycle:c(pe.cycle,this.defaultValue.cycle)}}}class Y extends n{constructor(){super(128)}compute(te,pe,ze){return te.pixelRatio}}class he extends A{constructor(){const te={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:m.localize(61,null)},comments:{type:"boolean",default:te.comments,description:m.localize(62,null)},other:{type:"boolean",default:te.other,description:m.localize(63,null)}}}],default:te,description:m.localize(64,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const pe=te,ze={other:c(pe.other,this.defaultValue.other),comments:c(pe.comments,this.defaultValue.comments),strings:c(pe.strings,this.defaultValue.strings)};return ze.other&&ze.comments&&ze.strings?!0:!ze.other&&!ze.comments&&!ze.strings?!1:ze}return this.defaultValue}}var _e;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(_e=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Se extends A{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(65,null),m.localize(66,null),m.localize(67,null),m.localize(68,null)],default:"on",description:m.localize(69,null)})}validate(te){let pe=this.defaultValue.renderType,ze=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(pe=4,ze=te):te==="interval"?pe=3:te==="relative"?pe=2:te==="on"?pe=1:pe=0),{renderType:pe,renderFn:ze}}}function Re(X){const te=X.get(87);return te==="editable"?X.get(80):te!=="on"}e.filterValidationDecorations=Re;class xe extends A{constructor(){const te=[],pe={type:"number",description:m.localize(70,null)};super(91,"rulers",te,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:m.localize(71,null),format:"color-hex"}}}]},default:te,description:m.localize(72,null)})}validate(te){if(Array.isArray(te)){let pe=[];for(let ze of te)if(typeof ze=="number")pe.push({column:g.clampedInt(ze,0,0,1e4),color:null});else if(ze&&typeof ze=="object"){const tt=ze;pe.push({column:g.clampedInt(tt.column,0,0,1e4),color:tt.color})}return pe.sort((ze,tt)=>ze.column-tt.column),pe}return this.defaultValue}}function Ue(X,te){if(typeof X!="string")return te;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class je extends A{constructor(){const te={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",te,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(73,null),m.localize(74,null),m.localize(75,null)],default:"auto",description:m.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(77,null),m.localize(78,null),m.localize(79,null)],default:"auto",description:m.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:te.verticalScrollbarSize,description:m.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:te.horizontalScrollbarSize,description:m.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:te.scrollByPage,description:m.localize(83,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te,ze=g.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),tt=g.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:g.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ue(pe.vertical,this.defaultValue.vertical),horizontal:Ue(pe.horizontal,this.defaultValue.horizontal),useShadows:c(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:ze,horizontalSliderSize:g.clampedInt(pe.horizontalSliderSize,ze,0,1e3),verticalScrollbarSize:tt,verticalSliderSize:g.clampedInt(pe.verticalSliderSize,tt,0,1e3),scrollByPage:c(pe.scrollByPage,this.defaultValue.scrollByPage)}}}class V extends A{constructor(){const te={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",te,{"editor.inlineSuggest.enabled":{type:"boolean",default:te.enabled,description:m.localize(84,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:c(pe.enabled,this.defaultValue.enabled),mode:_(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ee extends A{constructor(){const te={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",te,{"editor.bracketPairColorization.enabled":{type:"boolean",default:te.enabled,description:m.localize(85,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:c(te.enabled,this.defaultValue.enabled)}}}class re extends A{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(86,null),m.localize(87,null)],default:te.insertMode,description:m.localize(88,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:m.localize(89,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:m.localize(90,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:m.localize(91,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:m.localize(92,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:m.localize(93,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:m.localize(94,null)},"editor.suggest.preview":{type:"boolean",default:te.preview,description:m.localize(95,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:m.localize(96,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(97,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(98,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(99,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(100,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(101,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(102,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(103,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(104,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(105,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(106,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(107,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(108,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(109,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(110,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(111,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(112,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(113,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(114,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(115,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(116,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(117,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(118,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(119,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(120,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(121,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(122,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(123,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(124,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(125,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(126,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(127,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{insertMode:_(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:c(pe.showIcons,this.defaultValue.showIcons),showStatusBar:c(pe.showStatusBar,this.defaultValue.showStatusBar),preview:c(pe.preview,this.defaultValue.preview),previewMode:_(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(pe.showMethods,this.defaultValue.showMethods),showFunctions:c(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:c(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:c(pe.showFields,this.defaultValue.showFields),showVariables:c(pe.showVariables,this.defaultValue.showVariables),showClasses:c(pe.showClasses,this.defaultValue.showClasses),showStructs:c(pe.showStructs,this.defaultValue.showStructs),showInterfaces:c(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:c(pe.showModules,this.defaultValue.showModules),showProperties:c(pe.showProperties,this.defaultValue.showProperties),showEvents:c(pe.showEvents,this.defaultValue.showEvents),showOperators:c(pe.showOperators,this.defaultValue.showOperators),showUnits:c(pe.showUnits,this.defaultValue.showUnits),showValues:c(pe.showValues,this.defaultValue.showValues),showConstants:c(pe.showConstants,this.defaultValue.showConstants),showEnums:c(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:c(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(pe.showKeywords,this.defaultValue.showKeywords),showWords:c(pe.showWords,this.defaultValue.showWords),showColors:c(pe.showColors,this.defaultValue.showColors),showFiles:c(pe.showFiles,this.defaultValue.showFiles),showReferences:c(pe.showReferences,this.defaultValue.showReferences),showFolders:c(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:c(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(pe.showSnippets,this.defaultValue.showSnippets),showUsers:c(pe.showUsers,this.defaultValue.showUsers),showIssues:c(pe.showIssues,this.defaultValue.showIssues)}}}class le extends A{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(128,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Z extends n{constructor(){super(129,[80])}compute(te,pe,ze){return pe.get(80)?!0:te.tabFocusMode}}var oe;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(oe=e.WrappingIndent||(e.WrappingIndent={}));function ve(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Me extends n{constructor(){super(131,[130])}compute(te,pe,ze){const tt=pe.get(130);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:tt.isWordWrapMinified,isViewportWrapping:tt.isViewportWrapping,wrappingColumn:tt.wrappingColumn}}}const qe="Consolas, 'Courier New', monospace",Qe="Menlo, Monaco, 'Courier New', monospace",Je="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?Qe:L.isLinux?Je:qe,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Ce(X){return e.editorOptionsRegistry[X.id]=X,X}var at;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.bracketPairColorization=12]="bracketPairColorization",X[X.codeLens=13]="codeLens",X[X.codeLensFontFamily=14]="codeLensFontFamily",X[X.codeLensFontSize=15]="codeLensFontSize",X[X.colorDecorators=16]="colorDecorators",X[X.columnSelection=17]="columnSelection",X[X.comments=18]="comments",X[X.contextmenu=19]="contextmenu",X[X.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",X[X.cursorBlinking=21]="cursorBlinking",X[X.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",X[X.cursorStyle=23]="cursorStyle",X[X.cursorSurroundingLines=24]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",X[X.cursorWidth=26]="cursorWidth",X[X.disableLayerHinting=27]="disableLayerHinting",X[X.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",X[X.domReadOnly=29]="domReadOnly",X[X.dragAndDrop=30]="dragAndDrop",X[X.emptySelectionClipboard=31]="emptySelectionClipboard",X[X.extraEditorClassName=32]="extraEditorClassName",X[X.fastScrollSensitivity=33]="fastScrollSensitivity",X[X.find=34]="find",X[X.fixedOverflowWidgets=35]="fixedOverflowWidgets",X[X.folding=36]="folding",X[X.foldingStrategy=37]="foldingStrategy",X[X.foldingHighlight=38]="foldingHighlight",X[X.foldingImportsByDefault=39]="foldingImportsByDefault",X[X.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=41]="fontFamily",X[X.fontInfo=42]="fontInfo",X[X.fontLigatures=43]="fontLigatures",X[X.fontSize=44]="fontSize",X[X.fontWeight=45]="fontWeight",X[X.formatOnPaste=46]="formatOnPaste",X[X.formatOnType=47]="formatOnType",X[X.glyphMargin=48]="glyphMargin",X[X.gotoLocation=49]="gotoLocation",X[X.hideCursorInOverviewRuler=50]="hideCursorInOverviewRuler",X[X.highlightActiveIndentGuide=51]="highlightActiveIndentGuide",X[X.hover=52]="hover",X[X.inDiffEditor=53]="inDiffEditor",X[X.inlineSuggest=54]="inlineSuggest",X[X.letterSpacing=55]="letterSpacing",X[X.lightbulb=56]="lightbulb",X[X.lineDecorationsWidth=57]="lineDecorationsWidth",X[X.lineHeight=58]="lineHeight",X[X.lineNumbers=59]="lineNumbers",X[X.lineNumbersMinChars=60]="lineNumbersMinChars",X[X.linkedEditing=61]="linkedEditing",X[X.links=62]="links",X[X.matchBrackets=63]="matchBrackets",X[X.minimap=64]="minimap",X[X.mouseStyle=65]="mouseStyle",X[X.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=67]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",X[X.multiCursorModifier=69]="multiCursorModifier",X[X.multiCursorPaste=70]="multiCursorPaste",X[X.occurrencesHighlight=71]="occurrencesHighlight",X[X.overviewRulerBorder=72]="overviewRulerBorder",X[X.overviewRulerLanes=73]="overviewRulerLanes",X[X.padding=74]="padding",X[X.parameterHints=75]="parameterHints",X[X.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",X[X.quickSuggestions=78]="quickSuggestions",X[X.quickSuggestionsDelay=79]="quickSuggestionsDelay",X[X.readOnly=80]="readOnly",X[X.renameOnType=81]="renameOnType",X[X.renderControlCharacters=82]="renderControlCharacters",X[X.renderIndentGuides=83]="renderIndentGuides",X[X.renderFinalNewline=84]="renderFinalNewline",X[X.renderLineHighlight=85]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=87]="renderValidationDecorations",X[X.renderWhitespace=88]="renderWhitespace",X[X.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",X[X.roundedSelection=90]="roundedSelection",X[X.rulers=91]="rulers",X[X.scrollbar=92]="scrollbar",X[X.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=94]="scrollBeyondLastLine",X[X.scrollPredominantAxis=95]="scrollPredominantAxis",X[X.selectionClipboard=96]="selectionClipboard",X[X.selectionHighlight=97]="selectionHighlight",X[X.selectOnLineNumbers=98]="selectOnLineNumbers",X[X.showFoldingControls=99]="showFoldingControls",X[X.showUnused=100]="showUnused",X[X.snippetSuggestions=101]="snippetSuggestions",X[X.smartSelect=102]="smartSelect",X[X.smoothScrolling=103]="smoothScrolling",X[X.stickyTabStops=104]="stickyTabStops",X[X.stopRenderingLineAfter=105]="stopRenderingLineAfter",X[X.suggest=106]="suggest",X[X.suggestFontSize=107]="suggestFontSize",X[X.suggestLineHeight=108]="suggestLineHeight",X[X.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",X[X.suggestSelection=110]="suggestSelection",X[X.tabCompletion=111]="tabCompletion",X[X.tabIndex=112]="tabIndex",X[X.unusualLineTerminators=113]="unusualLineTerminators",X[X.useShadowDOM=114]="useShadowDOM",X[X.useTabStops=115]="useTabStops",X[X.wordSeparators=116]="wordSeparators",X[X.wordWrap=117]="wordWrap",X[X.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=120]="wordWrapColumn",X[X.wordWrapOverride1=121]="wordWrapOverride1",X[X.wordWrapOverride2=122]="wordWrapOverride2",X[X.wrappingIndent=123]="wrappingIndent",X[X.wrappingStrategy=124]="wrappingStrategy",X[X.showDeprecated=125]="showDeprecated",X[X.inlayHints=126]="inlayHints",X[X.editorClassName=127]="editorClassName",X[X.pixelRatio=128]="pixelRatio",X[X.tabFocusMode=129]="tabFocusMode",X[X.layoutInfo=130]="layoutInfo",X[X.wrappingInfo=131]="wrappingInfo"})(at=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ce(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(129,null)})),acceptSuggestionOnEnter:Ce(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(130,null),""],markdownDescription:m.localize(131,null)})),accessibilitySupport:Ce(new t),accessibilityPageSize:Ce(new g(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(132,null)})),ariaLabel:Ce(new I(4,"ariaLabel",m.localize(133,null))),autoClosingBrackets:Ce(new s(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(134,null),m.localize(135,null),""],description:m.localize(136,null)})),autoClosingDelete:Ce(new s(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(137,null),""],description:m.localize(138,null)})),autoClosingOvertype:Ce(new s(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(139,null),""],description:m.localize(140,null)})),autoClosingQuotes:Ce(new s(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(141,null),m.localize(142,null),""],description:m.localize(143,null)})),autoIndent:Ce(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],p,{enumDescriptions:[m.localize(144,null),m.localize(145,null),m.localize(146,null),m.localize(147,null),m.localize(148,null)],description:m.localize(149,null)})),automaticLayout:Ce(new h(10,"automaticLayout",!1)),autoSurround:Ce(new s(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(150,null),m.localize(151,null),m.localize(152,null),""],description:m.localize(153,null)})),bracketPairColorization:Ce(new ee),stickyTabStops:Ce(new h(104,"stickyTabStops",!1,{description:m.localize(154,null)})),codeLens:Ce(new h(13,"codeLens",!0,{description:m.localize(155,null)})),codeLensFontFamily:Ce(new I(14,"codeLensFontFamily","",{description:m.localize(156,null)})),codeLensFontSize:Ce(new g(15,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(157,null)})),colorDecorators:Ce(new h(16,"colorDecorators",!0,{description:m.localize(158,null)})),columnSelection:Ce(new h(17,"columnSelection",!1,{description:m.localize(159,null)})),comments:Ce(new a),contextmenu:Ce(new h(19,"contextmenu",!0)),copyWithSyntaxHighlighting:Ce(new h(20,"copyWithSyntaxHighlighting",!0,{description:m.localize(160,null)})),cursorBlinking:Ce(new o(21,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:m.localize(161,null)})),cursorSmoothCaretAnimation:Ce(new h(22,"cursorSmoothCaretAnimation",!1,{description:m.localize(162,null)})),cursorStyle:Ce(new o(23,"cursorStyle",l.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],f,{description:m.localize(163,null)})),cursorSurroundingLines:Ce(new g(24,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(164,null)})),cursorSurroundingLinesStyle:Ce(new s(25,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(165,null),m.localize(166,null)],description:m.localize(167,null)})),cursorWidth:Ce(new g(26,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(168,null)})),disableLayerHinting:Ce(new h(27,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ce(new h(28,"disableMonospaceOptimizations",!1)),domReadOnly:Ce(new h(29,"domReadOnly",!1)),dragAndDrop:Ce(new h(30,"dragAndDrop",!0,{description:m.localize(169,null)})),emptySelectionClipboard:Ce(new D),extraEditorClassName:Ce(new I(32,"extraEditorClassName","")),fastScrollSensitivity:Ce(new y(33,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:m.localize(170,null)})),find:Ce(new w),fixedOverflowWidgets:Ce(new h(35,"fixedOverflowWidgets",!1)),folding:Ce(new h(36,"folding",!0,{description:m.localize(171,null)})),foldingStrategy:Ce(new s(37,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(172,null),m.localize(173,null)],description:m.localize(174,null)})),foldingHighlight:Ce(new h(38,"foldingHighlight",!0,{description:m.localize(175,null)})),foldingImportsByDefault:Ce(new h(39,"foldingImportsByDefault",!1,{description:m.localize(176,null)})),unfoldOnClickAfterEndOfLine:Ce(new h(40,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(177,null)})),fontFamily:Ce(new I(41,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(178,null)})),fontInfo:Ce(new v),fontLigatures2:Ce(new T),fontSize:Ce(new F),fontWeight:Ce(new M),formatOnPaste:Ce(new h(46,"formatOnPaste",!1,{description:m.localize(179,null)})),formatOnType:Ce(new h(47,"formatOnType",!1,{description:m.localize(180,null)})),glyphMargin:Ce(new h(48,"glyphMargin",!0,{description:m.localize(181,null)})),gotoLocation:Ce(new G),hideCursorInOverviewRuler:Ce(new h(50,"hideCursorInOverviewRuler",!1,{description:m.localize(182,null)})),highlightActiveIndentGuide:Ce(new h(51,"highlightActiveIndentGuide",!0,{description:m.localize(183,null)})),hover:Ce(new K),inDiffEditor:Ce(new h(53,"inDiffEditor",!1)),letterSpacing:Ce(new y(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>y.clamp(X,-5,20),{description:m.localize(184,null)})),lightbulb:Ce(new N),lineDecorationsWidth:Ce(new P(57,"lineDecorationsWidth",10)),lineHeight:Ce(new B),lineNumbers:Ce(new Se),lineNumbersMinChars:Ce(new g(60,"lineNumbersMinChars",5,1,300)),linkedEditing:Ce(new h(61,"linkedEditing",!1,{description:m.localize(185,null)})),links:Ce(new h(62,"links",!0,{description:m.localize(186,null)})),matchBrackets:Ce(new s(63,"matchBrackets","always",["always","near","never"],{description:m.localize(187,null)})),minimap:Ce(new O),mouseStyle:Ce(new s(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ce(new y(66,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:m.localize(188,null)})),mouseWheelZoom:Ce(new h(67,"mouseWheelZoom",!1,{markdownDescription:m.localize(189,null)})),multiCursorMergeOverlapping:Ce(new h(68,"multiCursorMergeOverlapping",!0,{description:m.localize(190,null)})),multiCursorModifier:Ce(new o(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],H,{markdownEnumDescriptions:[m.localize(191,null),m.localize(192,null)],markdownDescription:m.localize(193,null)})),multiCursorPaste:Ce(new s(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(194,null),m.localize(195,null)],markdownDescription:m.localize(196,null)})),occurrencesHighlight:Ce(new h(71,"occurrencesHighlight",!0,{description:m.localize(197,null)})),overviewRulerBorder:Ce(new h(72,"overviewRulerBorder",!0,{description:m.localize(198,null)})),overviewRulerLanes:Ce(new g(73,"overviewRulerLanes",3,0,3)),padding:Ce(new W),parameterHints:Ce(new Q),peekWidgetDefaultFocus:Ce(new s(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(199,null),m.localize(200,null)],description:m.localize(201,null)})),definitionLinkOpensInPeek:Ce(new h(77,"definitionLinkOpensInPeek",!1,{description:m.localize(202,null)})),quickSuggestions:Ce(new he),quickSuggestionsDelay:Ce(new g(79,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(203,null)})),readOnly:Ce(new h(80,"readOnly",!1)),renameOnType:Ce(new h(81,"renameOnType",!1,{description:m.localize(204,null),markdownDeprecationMessage:m.localize(205,null)})),renderControlCharacters:Ce(new h(82,"renderControlCharacters",!1,{description:m.localize(206,null)})),renderIndentGuides:Ce(new h(83,"renderIndentGuides",!0,{description:m.localize(207,null)})),renderFinalNewline:Ce(new h(84,"renderFinalNewline",!0,{description:m.localize(208,null)})),renderLineHighlight:Ce(new s(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(209,null)],description:m.localize(210,null)})),renderLineHighlightOnlyWhenFocus:Ce(new h(86,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(211,null)})),renderValidationDecorations:Ce(new s(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ce(new s(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(212,null),m.localize(213,null),m.localize(214,null),""],description:m.localize(215,null)})),revealHorizontalRightPadding:Ce(new g(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ce(new h(90,"roundedSelection",!0,{description:m.localize(216,null)})),rulers:Ce(new xe),scrollbar:Ce(new je),scrollBeyondLastColumn:Ce(new g(93,"scrollBeyondLastColumn",5,0,1073741824,{description:m.localize(217,null)})),scrollBeyondLastLine:Ce(new h(94,"scrollBeyondLastLine",!0,{description:m.localize(218,null)})),scrollPredominantAxis:Ce(new h(95,"scrollPredominantAxis",!0,{description:m.localize(219,null)})),selectionClipboard:Ce(new h(96,"selectionClipboard",!0,{description:m.localize(220,null),included:L.isLinux})),selectionHighlight:Ce(new h(97,"selectionHighlight",!0,{description:m.localize(221,null)})),selectOnLineNumbers:Ce(new h(98,"selectOnLineNumbers",!0)),showFoldingControls:Ce(new s(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[m.localize(222,null),m.localize(223,null)],description:m.localize(224,null)})),showUnused:Ce(new h(100,"showUnused",!0,{description:m.localize(225,null)})),showDeprecated:Ce(new h(125,"showDeprecated",!0,{description:m.localize(226,null)})),inlayHints:Ce(new x),snippetSuggestions:Ce(new s(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(227,null),m.localize(228,null),m.localize(229,null),m.localize(230,null)],description:m.localize(231,null)})),smartSelect:Ce(new le),smoothScrolling:Ce(new h(103,"smoothScrolling",!1,{description:m.localize(232,null)})),stopRenderingLineAfter:Ce(new g(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ce(new re),inlineSuggest:Ce(new V),suggestFontSize:Ce(new g(107,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(233,null)})),suggestLineHeight:Ce(new g(108,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(234,null)})),suggestOnTriggerCharacters:Ce(new h(109,"suggestOnTriggerCharacters",!0,{description:m.localize(235,null)})),suggestSelection:Ce(new s(110,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(236,null),m.localize(237,null),m.localize(238,null)],description:m.localize(239,null)})),tabCompletion:Ce(new s(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(240,null),m.localize(241,null),m.localize(242,null)],description:m.localize(243,null)})),tabIndex:Ce(new g(112,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Ce(new s(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(244,null),m.localize(245,null),m.localize(246,null)],description:m.localize(247,null)})),useShadowDOM:Ce(new h(114,"useShadowDOM",!0)),useTabStops:Ce(new h(115,"useTabStops",!0,{description:m.localize(248,null)})),wordSeparators:Ce(new I(116,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:m.localize(249,null)})),wordWrap:Ce(new s(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(250,null),m.localize(251,null),m.localize(252,null),m.localize(253,null)],description:m.localize(254,null)})),wordWrapBreakAfterCharacters:Ce(new I(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ce(new I(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ce(new g(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(255,null)})),wordWrapOverride1:Ce(new s(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ce(new s(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ce(new o(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],ve,{enumDescriptions:[m.localize(256,null),m.localize(257,null),m.localize(258,null),m.localize(259,null)],description:m.localize(260,null)})),wrappingStrategy:Ce(new s(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[m.localize(261,null),m.localize(262,null)],description:m.localize(263,null)})),editorClassName:Ce(new b),pixelRatio:Ce(new Y),tabFocusMode:Ce(new Z),layoutInfo:Ce(new z),wrappingInfo:Ce(new Me)}}),define(me[156],ge([19,20]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[157],ge([19,20]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[158],ge([19,20]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[159],ge([19,20]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(me[160],ge([19,20]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(me[161],ge([19,20]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(me[162],ge([19,20]),function(J,e){return J.create("vs/platform/theme/common/iconRegistry",e)}),define(me[163],ge([19,20]),function(J,e){return J.create("vs/platform/workspaces/common/workspaces",e)}),define(me[164],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[165],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[166],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(me[167],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[168],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[169],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[170],ge([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[171],ge([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[172],ge([19,20]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(me[173],ge([19,20]),function(J,e){return J.create("vs/workbench/common/views",e)}),define(me[174],ge([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[175],ge([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[176],ge([19,20]),function(J,e){return J.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[177],ge([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[178],ge([19,20]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[179],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var m;(function(R){R[R.ACTIVATE=1]="ACTIVATE",R[R.RESTORE=2]="RESTORE",R[R.PRESERVE=3]="PRESERVE"})(m=e.EditorActivation||(e.EditorActivation={}));var L;(function(R){R[R.PICK=0]="PICK",R[R.DISABLED=1]="DISABLED",R[R.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var k;(function(R){R[R.API=0]="API",R[R.USER=1]="USER"})(k=e.EditorOpenContext||(e.EditorOpenContext={}));var C;(function(R){R[R.Center=0]="Center",R[R.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",R[R.NearTop=2]="NearTop",R[R.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[180],ge([0,1,158]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function C(c){return c=c.trim(),c==="*"||L.test(c)}e.isValidVersionStr=C;function R(c){if(!C(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=c.match(L);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=R;function E(c){if(!c)return null;let h=c.majorBase,d=c.majorMustEqual,g=c.minorBase,y=c.minorMustEqual,I=c.patchBase,_=c.patchMustEqual;c.hasCaret&&(h===0||(y=!1),_=!1);let s=0;if(c.preRelease){const o=k.exec(c.preRelease);if(o){const[,p,t,a]=o;s=Date.UTC(Number(p),Number(t)-1,Number(a))}}return{majorBase:h,majorMustEqual:d,minorBase:g,minorMustEqual:y,patchBase:I,patchMustEqual:_,isMinimum:c.hasGreaterEquals,notBefore:s}}e.normalizeVersion=E;function S(c,h,d){let g;typeof c=="string"?g=E(R(c)):g=c;let y;h instanceof Date?y=h.getTime():typeof h=="string"&&(y=new Date(h).getTime());let I;if(typeof d=="string"?I=E(R(d)):I=d,!g||!I)return!1;let _=g.majorBase,s=g.minorBase,o=g.patchBase,p=I.majorBase,t=I.minorBase,a=I.patchBase,r=I.notBefore,i=I.majorMustEqual,l=I.minorMustEqual,u=I.patchMustEqual;return I.isMinimum?_>p?!0:_<p?!1:s>t?!0:s<t||y&&y<r?!1:o>=a:(_===1&&p===0&&(!i||!l||!u)&&(p=1,t=0,a=0,i=!0,l=!1,u=!1),_<p?!1:_>p?!i:s<t?!1:s>t?!l:o<a?!1:o>a?!u:!(y&&y<r))}e.isValidVersion=S;function A(c,h,d,g){return d.isBuiltin||typeof d.main=="undefined"?!0:P(c,h,d.engines.vscode,g)}e.isValidExtensionVersion=A;function n(c,h,d){return c==="*"||P(h,d,c)}e.isEngineValid=n;function P(c,h,d,g=[]){let y=E(R(d));if(!y)return g.push(m.localize(0,null,d)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return g.push(m.localize(1,null,d)),!1}else if(!y.majorMustEqual)return g.push(m.localize(2,null,d)),!1;return S(c,h,y)?!0:(g.push(m.localize(3,null,c,d)),!1)}}),define(me[115],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class m{constructor(k,C=[],R=!1){this.ctor=k,this.staticArguments=C,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=m}),define(me[82],ge([0,1,115]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function k(R,E,S){E instanceof m.SyncDescriptor||(E=new m.SyncDescriptor(E,[],S)),L.push([R,E])}e.registerSingleton=k;function C(){return L}e.getSingletonServiceDescriptors=C}),define(me[181],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=m;class L{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let R of this._nodes.values())R.outgoing.size===0&&C.push(R);return C}insertEdge(C,R){const E=this.lookupOrInsertNode(C),S=this.lookupOrInsertNode(R);E.outgoing.set(this._hashFn(R),S),S.incoming.set(this._hashFn(C),E)}removeNode(C){const R=this._hashFn(C);this._nodes.delete(R);for(let E of this._nodes.values())E.outgoing.delete(R),E.incoming.delete(R)}lookupOrInsertNode(C){const R=this._hashFn(C);let E=this._nodes.get(R);return E||(E=new m(C),this._nodes.set(R,E)),E}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[R,E]of this._nodes)C.push(`${R}, (incoming)[${[...E.incoming.keys()].join(", ")}], (outgoing)[${[...E.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,R]of this._nodes){const E=new Set([C]),S=this._findCycle(R,E);if(S)return S}}_findCycle(C,R){for(let[E,S]of C.outgoing){if(R.has(E))return[...R,E].join(" -> ");R.add(E);const A=this._findCycle(S,R);if(A)return A;R.delete(E)}}}e.Graph=L}),define(me[4],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(E){E.serviceIds=new Map,E.DI_TARGET="$di$target",E.DI_DEPENDENCIES="$di$dependencies";function S(A){return A[E.DI_DEPENDENCIES]||[]}E.getServiceDependencies=S})(m=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function L(E,S,A,n){S[m.DI_TARGET]===S?S[m.DI_DEPENDENCIES].push({id:E,index:A,optional:n}):(S[m.DI_DEPENDENCIES]=[{id:E,index:A,optional:n}],S[m.DI_TARGET]=S)}function k(E){if(m.serviceIds.has(E))return m.serviceIds.get(E);const S=function(A,n,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(S,A,P,!1)};return S.toString=()=>E,m.serviceIds.set(E,S),S}e.createDecorator=k;function C(E){return E}e.refineServiceDecorator=C;function R(E){return function(S,A,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(E,S,n,!0)}}e.optional=R}),define(me[182],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,m.createDecorator)("modelService");function L(k){return!k.isTooLargeForSyncing()&&!k.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(me[183],ge([0,1,3,48,6,24,77,81,182]),function(J,e,m,L,k,C,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function A(g){return typeof g=="string"?!1:Array.isArray(g)?g.every(A):!!g.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new m.Emitter}get onDidChange(){return this._onDidChange.event}register(y,I){let _={selector:y,provider:I,_score:-1,_time:this._clock++};return this._entries.push(_),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,k.toDisposable)(()=>{if(_){let s=this._entries.indexOf(_);s>=0&&(this._entries.splice(s,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),_=void 0)}})}has(y){return this.all(y).length>0}all(y){if(!y)return[];this._updateScores(y);const I=[];for(let _ of this._entries)_._score>0&&I.push(_.provider);return I}ordered(y){const I=[];return this._orderedForEach(y,_=>I.push(_.provider)),I}orderedGroups(y){const I=[];let _,s;return this._orderedForEach(y,o=>{_&&s===o._score?_.push(o.provider):(s=o._score,_=[o.provider],I.push(_))}),I}_orderedForEach(y,I){if(!!y){this._updateScores(y);for(const _ of this._entries)_._score>0&&I(_)}}_updateScores(y){let I={uri:y.uri.toString(),language:y.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===I.language&&this._lastCandidate.uri===I.uri)){this._lastCandidate=I;for(let _ of this._entries)if(_._score=(0,E.score)(_.selector,y.uri,y.getLanguageIdentifier().language,(0,S.shouldSynchronizeModel)(y)),A(_.selector)&&_._score>0){for(let s of this._entries)s._score=0;_._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(y,I){return y._score<I._score?1:y._score>I._score?-1:y._time<I._time?1:y._time>I._time?-1:0}}e.LanguageFeatureRegistry=n;const P=new WeakMap;let c=0;function h(g){let y=P.get(g);return y===void 0&&(y=++c,P.set(g,y)),y}class d{constructor(y,I,_=Number.MAX_SAFE_INTEGER){this._registry=y,this.min=I,this.max=_,this._cache=new C.LRUCache(50,.7)}_key(y){return y.id+this._registry.all(y).reduce((I,_)=>(0,L.doHash)(h(_),I),0)}_clamp(y){return y===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(y*1.3)))}get(y){const I=this._key(y),_=this._cache.get(I);return this._clamp(_?.value)}update(y,I){const _=this._key(y);let s=this._cache.get(_);return s||(s=new R.MovingAverage,this._cache.set(_,s)),s.update(I),this.get(y)}}e.LanguageFeatureRequestDelays=d}),define(me[83],ge([0,1,2,41,183,149,47]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var E;(function(w){w[w.Null=0]="Null",w[w.PlainText=1]="PlainText"})(E=e.LanguageId||(e.LanguageId={}));class S{constructor(T,v){this.language=T,this.id=v}}e.LanguageIdentifier=S;var A;(function(w){w[w.NotSet=-1]="NotSet",w[w.None=0]="None",w[w.Italic=1]="Italic",w[w.Bold=2]="Bold",w[w.Underline=4]="Underline"})(A=e.FontStyle||(e.FontStyle={}));var n;(function(w){w[w.None=0]="None",w[w.DefaultForeground=1]="DefaultForeground",w[w.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var P;(function(w){w[w.Other=0]="Other",w[w.Comment=1]="Comment",w[w.String=2]="String",w[w.RegEx=4]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var c;(function(w){w[w.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",w[w.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",w[w.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",w[w.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",w[w.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",w[w.ITALIC_MASK=2048]="ITALIC_MASK",w[w.BOLD_MASK=4096]="BOLD_MASK",w[w.UNDERLINE_MASK=8192]="UNDERLINE_MASK",w[w.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",w[w.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",w[w.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",w[w.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",w[w.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",w[w.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",w[w.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",w[w.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",w[w.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",w[w.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(c=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(T){return(T&255)>>>0}static getTokenType(T){return(T&1792)>>>8}static getFontStyle(T){return(T&14336)>>>11}static getForeground(T){return(T&8372224)>>>14}static getBackground(T){return(T&4286578688)>>>23}static getClassNameFromMetadata(T){let v=this.getForeground(T),F="mtk"+v,M=this.getFontStyle(T);return M&1&&(F+=" mtki"),M&2&&(F+=" mtkb"),M&4&&(F+=" mtku"),F}static getInlineStyleFromMetadata(T,v){const F=this.getForeground(T),M=this.getFontStyle(T);let G=`color: ${v[F]};`;return M&1&&(G+="font-style: italic;"),M&2&&(G+="font-weight: bold;"),M&4&&(G+="text-decoration: underline;"),G}}e.TokenMetadata=h;var d;(function(w){w[w.Method=0]="Method",w[w.Function=1]="Function",w[w.Constructor=2]="Constructor",w[w.Field=3]="Field",w[w.Variable=4]="Variable",w[w.Class=5]="Class",w[w.Struct=6]="Struct",w[w.Interface=7]="Interface",w[w.Module=8]="Module",w[w.Property=9]="Property",w[w.Event=10]="Event",w[w.Operator=11]="Operator",w[w.Unit=12]="Unit",w[w.Value=13]="Value",w[w.Constant=14]="Constant",w[w.Enum=15]="Enum",w[w.EnumMember=16]="EnumMember",w[w.Keyword=17]="Keyword",w[w.Text=18]="Text",w[w.Color=19]="Color",w[w.File=20]="File",w[w.Reference=21]="Reference",w[w.Customcolor=22]="Customcolor",w[w.Folder=23]="Folder",w[w.TypeParameter=24]="TypeParameter",w[w.User=25]="User",w[w.Issue=26]="Issue",w[w.Snippet=27]="Snippet"})(d=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let w=Object.create(null);return w[0]="symbol-method",w[1]="symbol-function",w[2]="symbol-constructor",w[3]="symbol-field",w[4]="symbol-variable",w[5]="symbol-class",w[6]="symbol-struct",w[7]="symbol-interface",w[8]="symbol-module",w[9]="symbol-property",w[10]="symbol-event",w[11]="symbol-operator",w[12]="symbol-unit",w[13]="symbol-value",w[14]="symbol-constant",w[15]="symbol-enum",w[16]="symbol-enum-member",w[17]="symbol-keyword",w[27]="symbol-snippet",w[18]="symbol-text",w[19]="symbol-color",w[20]="symbol-file",w[21]="symbol-reference",w[22]="symbol-customcolor",w[23]="symbol-folder",w[24]="symbol-type-parameter",w[25]="account",w[26]="issues",function(T){const v=w[T];let F=v&&R.iconRegistry.get(v);return F||(console.info("No codicon found for CompletionItemKind "+T),F=R.Codicon.symbolProperty),F.classNames}}(),e.completionKindFromString=function(){let w=Object.create(null);return w.method=0,w.function=1,w.constructor=2,w.field=3,w.variable=4,w.class=5,w.struct=6,w.interface=7,w.module=8,w.property=9,w.event=10,w.operator=11,w.unit=12,w.value=13,w.constant=14,w.enum=15,w["enum-member"]=16,w.enumMember=16,w.keyword=17,w.snippet=27,w.text=18,w.color=19,w.file=20,w.reference=21,w.customcolor=22,w.folder=23,w["type-parameter"]=24,w.typeParameter=24,w.account=25,w.issue=26,function(T,v){let F=w[T];return typeof F=="undefined"&&!v&&(F=9),F}}();var g;(function(w){w[w.Deprecated=1]="Deprecated"})(g=e.CompletionItemTag||(e.CompletionItemTag={}));var y;(function(w){w[w.KeepWhitespace=1]="KeepWhitespace",w[w.InsertAsSnippet=4]="InsertAsSnippet"})(y=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var I;(function(w){w[w.Invoke=0]="Invoke",w[w.TriggerCharacter=1]="TriggerCharacter",w[w.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(I=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _;(function(w){w[w.Automatic=0]="Automatic",w[w.Explicit=1]="Explicit"})(_=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var s;(function(w){w[w.Invoke=1]="Invoke",w[w.Auto=2]="Auto"})(s=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(w){w[w.Invoke=1]="Invoke",w[w.TriggerCharacter=2]="TriggerCharacter",w[w.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var p;(function(w){w[w.Text=0]="Text",w[w.Read=1]="Read",w[w.Write=2]="Write"})(p=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(w){return w&&m.URI.isUri(w.uri)&&L.Range.isIRange(w.range)&&(L.Range.isIRange(w.originSelectionRange)||L.Range.isIRange(w.targetSelectionRange))}e.isLocationLink=t;var a;(function(w){w[w.File=0]="File",w[w.Module=1]="Module",w[w.Namespace=2]="Namespace",w[w.Package=3]="Package",w[w.Class=4]="Class",w[w.Method=5]="Method",w[w.Property=6]="Property",w[w.Field=7]="Field",w[w.Constructor=8]="Constructor",w[w.Enum=9]="Enum",w[w.Interface=10]="Interface",w[w.Function=11]="Function",w[w.Variable=12]="Variable",w[w.Constant=13]="Constant",w[w.String=14]="String",w[w.Number=15]="Number",w[w.Boolean=16]="Boolean",w[w.Array=17]="Array",w[w.Object=18]="Object",w[w.Key=19]="Key",w[w.Null=20]="Null",w[w.EnumMember=21]="EnumMember",w[w.Struct=22]="Struct",w[w.Event=23]="Event",w[w.Operator=24]="Operator",w[w.TypeParameter=25]="TypeParameter"})(a=e.SymbolKind||(e.SymbolKind={}));var r;(function(w){w[w.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var i;(function(w){const T=new Map;T.set("file",0),T.set("module",1),T.set("namespace",2),T.set("package",3),T.set("class",4),T.set("method",5),T.set("property",6),T.set("field",7),T.set("constructor",8),T.set("enum",9),T.set("interface",10),T.set("function",11),T.set("variable",12),T.set("constant",13),T.set("string",14),T.set("number",15),T.set("boolean",16),T.set("array",17),T.set("object",18),T.set("key",19),T.set("null",20),T.set("enum-member",21),T.set("struct",22),T.set("event",23),T.set("operator",24),T.set("type-parameter",25);const v=new Map;v.set(0,"file"),v.set(1,"module"),v.set(2,"namespace"),v.set(3,"package"),v.set(4,"class"),v.set(5,"method"),v.set(6,"property"),v.set(7,"field"),v.set(8,"constructor"),v.set(9,"enum"),v.set(10,"interface"),v.set(11,"function"),v.set(12,"variable"),v.set(13,"constant"),v.set(14,"string"),v.set(15,"number"),v.set(16,"boolean"),v.set(17,"array"),v.set(18,"object"),v.set(19,"key"),v.set(20,"null"),v.set(21,"enum-member"),v.set(22,"struct"),v.set(23,"event"),v.set(24,"operator"),v.set(25,"type-parameter");function F(K){return T.get(K)}w.fromString=F;function M(K){return v.get(K)}w.toString=M;function G(K,U){const z=v.get(K);let N=z&&R.iconRegistry.get("symbol-"+z);return N||(console.info("No codicon found for SymbolKind "+K),N=R.Codicon.symbolProperty),`${U?"inline":"block"} ${N.classNames}`}w.toCssClassName=G})(i=e.SymbolKinds||(e.SymbolKinds={}));class l{constructor(T){this.value=T}}e.FoldingRangeKind=l,l.Comment=new l("comment"),l.Imports=new l("imports"),l.Region=new l("region");var u;(function(w){w[w.Collapsed=0]="Collapsed",w[w.Expanded=1]="Expanded"})(u=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var f;(function(w){w[w.Editing=0]="Editing",w[w.Preview=1]="Preview"})(f=e.CommentMode||(e.CommentMode={}));var b;(function(w){w[w.Other=0]="Other",w[w.Type=1]="Type",w[w.Parameter=2]="Parameter"})(b=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new k.LanguageFeatureRegistry,e.RenameProviderRegistry=new k.LanguageFeatureRegistry,e.CompletionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new k.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new k.LanguageFeatureRegistry,e.HoverProviderRegistry=new k.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new k.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new k.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new k.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new k.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new k.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.LinkProviderRegistry=new k.LanguageFeatureRegistry,e.ColorProviderRegistry=new k.LanguageFeatureRegistry,e.SelectionRangeRegistry=new k.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.TokenizationRegistry=new C.TokenizationRegistryImpl;var D;(function(w){w[w.None=0]="None",w[w.Option=1]="Option",w[w.Default=2]="Default",w[w.Preferred=3]="Preferred"})(D=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[62],ge([0,1,11,9,4]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let C=m.userAgent||"";const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",m.isMacintosh),R.set("isLinux",m.isLinux),R.set("isWindows",m.isWindows),R.set("isWeb",m.isWeb),R.set("isMacNative",m.isMacintosh&&!m.isWeb),R.set("isEdge",C.indexOf("Edg/")>=0),R.set("isFirefox",C.indexOf("Firefox")>=0),R.set("isChrome",C.indexOf("Chrome")>=0),R.set("isSafari",C.indexOf("Safari")>=0);const E=Object.prototype.hasOwnProperty;var S;(function(T){T[T.False=0]="False",T[T.True=1]="True",T[T.Defined=2]="Defined",T[T.Not=3]="Not",T[T.Equals=4]="Equals",T[T.NotEquals=5]="NotEquals",T[T.And=6]="And",T[T.Regex=7]="Regex",T[T.NotRegex=8]="NotRegex",T[T.Or=9]="Or",T[T.In=10]="In",T[T.NotIn=11]="NotIn",T[T.Greater=12]="Greater",T[T.GreaterEquals=13]="GreaterEquals",T[T.Smaller=14]="Smaller",T[T.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class A{static false(){return P.INSTANCE}static true(){return c.INSTANCE}static has(v){return h.create(v)}static equals(v,F){return d.create(v,F)}static notEquals(v,F){return I.create(v,F)}static regex(v,F){return a.create(v,F)}static in(v,F){return g.create(v,F)}static not(v){return _.create(v)}static and(...v){return i.create(v,null)}static or(...v){return l.create(v,null,!0)}static greater(v,F){return s.create(v,F)}static less(v,F){return p.create(v,F)}static deserialize(v,F=!1){if(!!v)return this._deserializeOrExpression(v,F)}static _deserializeOrExpression(v,F){let M=v.split("||");return l.create(M.map(G=>this._deserializeAndExpression(G,F)),null,!0)}static _deserializeAndExpression(v,F){let M=v.split("&&");return i.create(M.map(G=>this._deserializeOne(G,F)),null)}static _deserializeOne(v,F){if(v=v.trim(),v.indexOf("!=")>=0){let M=v.split("!=");return I.create(M[0].trim(),this._deserializeValue(M[1],F))}if(v.indexOf("==")>=0){let M=v.split("==");return d.create(M[0].trim(),this._deserializeValue(M[1],F))}if(v.indexOf("=~")>=0){let M=v.split("=~");return a.create(M[0].trim(),this._deserializeRegexValue(M[1],F))}if(v.indexOf(" in ")>=0){let M=v.split(" in ");return g.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(v)){const M=v.split(">=");return o.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(v)){const M=v.split(">");return s.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(v)){const M=v.split("<=");return t.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(v)){const M=v.split("<");return p.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(v)?_.create(v.substr(1).trim()):h.create(v)}static _deserializeValue(v,F){if(v=v.trim(),v==="true")return!0;if(v==="false")return!1;let M=/^'([^']*)'$/.exec(v);return M?M[1].trim():v}static _deserializeRegexValue(v,F){if((0,L.isFalsyOrWhitespace)(v)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=v.indexOf("/"),G=v.lastIndexOf("/");if(M===G||M<0){if(F)throw new Error(`bad regexp-value '${v}', missing /-enclosure`);return console.warn(`bad regexp-value '${v}', missing /-enclosure`),null}let K=v.slice(M+1,G),U=v[G+1]==="i"?"i":"";try{return new RegExp(K,U)}catch(z){if(F)throw new Error(`bad regexp-value '${v}', parse error: ${z}`);return console.warn(`bad regexp-value '${v}', parse error: ${z}`),null}}}e.ContextKeyExpr=A;function n(T,v){return T.cmp(v)}class P{constructor(){this.type=0}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}evaluate(v){return!1}serialize(){return"false"}keys(){return[]}map(v){return this}negate(){return c.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class c{constructor(){this.type=1}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}evaluate(v){return!0}serialize(){return"true"}keys(){return[]}map(v){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=c,c.INSTANCE=new c;class h{constructor(v,F){this.key=v,this.negated=F,this.type=2}static create(v,F=null){const M=R.get(v);return typeof M=="boolean"?M?c.INSTANCE:P.INSTANCE:new h(v,F)}cmp(v){return v.type!==this.type?this.type-v.type:f(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}evaluate(v){return!!v.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(v){return v.mapDefined(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class d{constructor(v,F,M){this.key=v,this.value=F,this.negated=M,this.type=4}static create(v,F,M=null){if(typeof F=="boolean")return F?h.create(v,M):_.create(v,M);const G=R.get(v);return typeof G=="boolean"?F===(G?"true":"false")?c.INSTANCE:P.INSTANCE:new d(v,F,M)}cmp(v){return v.type!==this.type?this.type-v.type:b(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return v.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(v){return v.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=I.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=d;class g{constructor(v,F){this.key=v,this.valueKey=F,this.type=10,this.negated=null}static create(v,F){return new g(v,F)}cmp(v){return v.type!==this.type?this.type-v.type:b(this.key,this.valueKey,v.key,v.valueKey)}equals(v){return v.type===this.type?this.key===v.key&&this.valueKey===v.valueKey:!1}evaluate(v){const F=v.getValue(this.valueKey),M=v.getValue(this.key);return Array.isArray(F)?F.indexOf(M)>=0:typeof M=="string"&&typeof F=="object"&&F!==null?E.call(F,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(v){return v.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=y.create(this)),this.negated}}e.ContextKeyInExpr=g;class y{constructor(v){this._actual=v,this.type=11}static create(v){return new y(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new y(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotInExpr=y;class I{constructor(v,F,M){this.key=v,this.value=F,this.negated=M,this.type=5}static create(v,F,M=null){if(typeof F=="boolean")return F?_.create(v,M):h.create(v,M);const G=R.get(v);return typeof G=="boolean"?F===(G?"true":"false")?P.INSTANCE:c.INSTANCE:new I(v,F,M)}cmp(v){return v.type!==this.type?this.type-v.type:b(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return v.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(v){return v.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=I;class _{constructor(v,F){this.key=v,this.negated=F,this.type=3}static create(v,F=null){const M=R.get(v);return typeof M=="boolean"?M?P.INSTANCE:c.INSTANCE:new _(v,F)}cmp(v){return v.type!==this.type?this.type-v.type:f(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}evaluate(v){return!v.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(v){return v.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=_;class s{constructor(v,F,M){this.key=v,this.value=F,this.negated=M,this.type=12}static create(v,F,M=null){return new s(v,F,M)}cmp(v){return v.type!==this.type?this.type-v.type:b(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=s;class o{constructor(v,F,M){this.key=v,this.value=F,this.negated=M,this.type=13}static create(v,F,M=null){return new o(v,F,M)}cmp(v){return v.type!==this.type?this.type-v.type:b(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=o;class p{constructor(v,F,M){this.key=v,this.value=F,this.negated=M,this.type=14}static create(v,F,M=null){return new p(v,F,M)}cmp(v){return v.type!==this.type?this.type-v.type:b(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=p;class t{constructor(v,F,M){this.key=v,this.value=F,this.negated=M,this.type=15}static create(v,F,M=null){return new t(v,F,M)}cmp(v){return v.type!==this.type?this.type-v.type:b(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=t;class a{constructor(v,F){this.key=v,this.regexp=F,this.type=7,this.negated=null}static create(v,F){return new a(v,F)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.key<v.key)return-1;if(this.key>v.key)return 1;const F=this.regexp?this.regexp.source:"",M=v.regexp?v.regexp.source:"";return F<M?-1:F>M?1:0}equals(v){if(v.type===this.type){const F=this.regexp?this.regexp.source:"",M=v.regexp?v.regexp.source:"";return this.key===v.key&&F===M}return!1}evaluate(v){let F=v.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const v=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${v}`}keys(){return[this.key]}map(v){return v.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=a;class r{constructor(v){this._actual=v,this.type=8}static create(v){return new r(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new r(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class i{constructor(v,F){this.expr=v,this.negated=F,this.type=6}static create(v,F){return i._normalizeArr(v,F)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let F=0,M=this.expr.length;F<M;F++){const G=n(this.expr[F],v.expr[F]);if(G!==0)return G}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let F=0,M=this.expr.length;F<M;F++)if(!this.expr[F].equals(v.expr[F]))return!1;return!0}return!1}evaluate(v){for(let F=0,M=this.expr.length;F<M;F++)if(!this.expr[F].evaluate(v))return!1;return!0}static _normalizeArr(v,F){const M=[];let G=!1;for(const K of v)if(!!K){if(K.type===1){G=!0;continue}if(K.type===0)return P.INSTANCE;if(K.type===6){M.push(...K.expr);continue}M.push(K)}if(M.length===0&&G)return c.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(n);for(let K=1;K<M.length;K++)M[K-1].equals(M[K])&&(M.splice(K,1),K--);if(M.length===1)return M[0];for(;M.length>1;){const K=M[M.length-1];if(K.type!==9)break;M.pop();const U=M.pop(),z=M.length===0,N=l.create(K.expr.map(x=>i.create([x,U],null)),null,z);N&&(M.push(N),M.sort(n))}return M.length===1?M[0]:new i(M,F)}}serialize(){return this.expr.map(v=>v.serialize()).join(" && ")}keys(){const v=[];for(let F of this.expr)v.push(...F.keys());return v}map(v){return new i(this.expr.map(F=>F.map(v)),null)}negate(){if(!this.negated){const v=[];for(let F of this.expr)v.push(F.negate());this.negated=l.create(v,this,!0)}return this.negated}}class l{constructor(v,F){this.expr=v,this.negated=F,this.type=9}static create(v,F,M){return l._normalizeArr(v,F,M)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let F=0,M=this.expr.length;F<M;F++){const G=n(this.expr[F],v.expr[F]);if(G!==0)return G}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let F=0,M=this.expr.length;F<M;F++)if(!this.expr[F].equals(v.expr[F]))return!1;return!0}return!1}evaluate(v){for(let F=0,M=this.expr.length;F<M;F++)if(this.expr[F].evaluate(v))return!0;return!1}static _normalizeArr(v,F,M){let G=[],K=!1;if(v){for(let U=0,z=v.length;U<z;U++){const N=v[U];if(!!N){if(N.type===0){K=!0;continue}if(N.type===1)return c.INSTANCE;if(N.type===9){G=G.concat(N.expr);continue}G.push(N)}}if(G.length===0&&K)return P.INSTANCE;G.sort(n)}if(G.length!==0){if(G.length===1)return G[0];for(let U=1;U<G.length;U++)G[U-1].equals(G[U])&&(G.splice(U,1),U--);if(G.length===1)return G[0];if(M){for(let U=0;U<G.length;U++)for(let z=U+1;z<G.length;z++)D(G[U],G[z])&&(G.splice(z,1),z--);if(G.length===1)return G[0]}return new l(G,F)}}serialize(){return this.expr.map(v=>v.serialize()).join(" || ")}keys(){const v=[];for(let F of this.expr)v.push(...F.keys());return v}map(v){return new l(this.expr.map(F=>F.map(v)),null)}negate(){if(!this.negated){let v=[];for(let F of this.expr)v.push(F.negate());for(;v.length>1;){const F=v.shift(),M=v.shift(),G=[];for(const U of w(F))for(const z of w(M))G.push(i.create([U,z],null));const K=v.length===0;v.unshift(l.create(G,null,K))}this.negated=v[0]}return this.negated}}class u extends h{constructor(v,F,M){super(v,null);this._defaultValue=F,typeof M=="object"?u._info.push({...M,key:v}):M!==!0&&u._info.push({key:v,description:M,type:F!=null?typeof F:void 0})}static all(){return u._info.values()}bindTo(v){return v.createKey(this.key,this._defaultValue)}getValue(v){return v.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(v){return d.create(this.key,v)}notEqualsTo(v){return I.create(this.key,v)}}e.RawContextKey=u,u._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function f(T,v){return T<v?-1:T>v?1:0}function b(T,v,F,M){return T<F?-1:T>F?1:v<M?-1:v>M?1:0}function D(T,v){if(v.type===6&&T.type!==9&&T.type!==6){for(const G of v.expr)if(T.equals(G))return!0}const F=T.negate(),M=w(F).concat(w(v));M.sort(n);for(let G=0;G<M.length;G++){const U=M[G].negate();for(let z=G+1;z<M.length;z++){const N=M[z];if(U.equals(N))return!0}}return!1}e.implies=D;function w(T){return T.type===9?T.expr:[T]}}),define(me[184],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(me[185],ge([0,1,10,157,4]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(I){I.WIN32_X64="win32-x64",I.WIN32_IA32="win32-ia32",I.WIN32_ARM64="win32-arm64",I.LINUX_X64="linux-x64",I.LINUX_ARM64="linux-arm64",I.LINUX_ARMHF="linux-armhf",I.ALPINE_X64="alpine-x64",I.DARWIN_X64="darwin-x64",I.DARWIN_ARM64="darwin-arm64",I.WEB="web",I.UNIVERSAL="universal",I.UNKNOWN="unknown",I.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function R(I){switch(I){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=R;function E(I){switch(I){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=E;function S(I,_){switch(I){case 3:return _==="x64"?"win32-x64":_==="ia32"?"win32-ia32":_==="arm64"?"win32-arm64":"unknown";case 2:return _==="x64"?"linux-x64":_==="arm64"?"linux-arm64":_==="arm"?"linux-armhf":"unknown";case"alpine":return _==="x64"?"alpine-x64":"unknown";case 1:return _==="x64"?"darwin-x64":_==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function A(I,_){return _==="web"&&!I.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function n(I,_,s){if(A(_,s))return!1;if(I==="undefined"||I==="universal")return!0;if(I==="unknown")return!1;if(I===s)return!0;switch(s){case"win32-x64":return I==="win32-ia32";case"win32-arm64":return I==="win32-ia32";default:return!1}}e.isTargetPlatformCompatible=n;function P(I){return I&&typeof I=="object"&&typeof I.id=="string"&&(!I.uuid||typeof I.uuid=="string")}e.isIExtensionIdentifier=P;var c;(function(I){I[I.NoneOrRelevance=0]="NoneOrRelevance",I[I.LastUpdatedDate=1]="LastUpdatedDate",I[I.Title=2]="Title",I[I.PublisherName=3]="PublisherName",I[I.InstallCount=4]="InstallCount",I[I.PublishedDate=5]="PublishedDate",I[I.AverageRating=6]="AverageRating",I[I.WeightedRating=12]="WeightedRating"})(c=e.SortBy||(e.SortBy={}));var h;(function(I){I[I.Default=0]="Default",I[I.Ascending=1]="Ascending",I[I.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var d;(function(I){I.Install="install",I.Uninstall="uninstall"})(d=e.StatisticType||(e.StatisticType={}));var g;(function(I){I[I.None=0]="None",I[I.Install=1]="Install",I[I.Update=2]="Update"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class y extends Error{constructor(_,s){super(_);this.code=s,this.name=s}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=m.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(me[26],ge([0,1,9,4]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=k;function C(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class E{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,c){if(typeof P=="undefined"||P===null)return typeof c=="undefined"||c===null;if(typeof c=="undefined"||c===null)return!1;if(typeof P=="string"||typeof c=="string"){let h=typeof P=="string"?P:P.value,d=typeof c=="string"?c:c.value;return m.equalsIgnoreCase(h,d)}return P._lower===c._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=E;function S(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function A(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=A,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[186],ge([0,1,9,26]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(d,g){return d.uuid&&g.uuid?d.uuid===g.uuid:d.id===g.id?!0:(0,m.compareIgnoreCase)(d.id,g.id)===0}e.areSameExtensions=k;class C{constructor(g,y){this.version=y,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof C?k(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=C;function R(d,g){return`${d}.${g}`}e.getExtensionId=R;function E(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=E;function S(d,g){return E(R(d,g))}e.getGalleryExtensionId=S;function A(d,g){const y=[],I=_=>{for(const s of y)if(s.some(o=>k(g(o),g(_))))return s;return null};for(const _ of d){const s=I(_);s?s.push(_):y.push([_])}return y}e.groupByExtension=A;function n(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function P(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function c(d){const g=new Set;for(const y of d)y.malicious&&g.add(y.id.id);return g}e.getMaliciousExtensionsSet=c;function h(d,g){const y=[],I=g.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const _=I.shift();if(_&&y.every(s=>!k(s.identifier,{id:_}))){const s=d.filter(o=>k(o.identifier,{id:_}));s.length===1&&(y.push(s[0]),I.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return y}e.getExtensionDependencies=h}),define(me[187],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,m.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,m.createDecorator)("externalTerminal")}),define(me[188],ge([0,1,39,10,8,11,140,28,113,159,187]),function(J,e,m,L,k,C,R,E,S,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=A.localize(0,null);class c{async getDefaultTerminalForPlatforms(){return{windows:h.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class h extends c{openTerminal(o,p){return this.spawnTerminal(m,o,S.getWindowsShell(),p)}spawnTerminal(o,p,t,a){const r=p.windowsExec||h.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const i=k.basename(r).toLowerCase();if(i==="cmder"||i==="cmder.exe")return o.spawn(r,a?[a]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return r.indexOf(" ")>=0&&l.push('""'),l.push(r),(i==="wt"||i==="wt.exe")&&l.push("-d ."),new Promise((u,f)=>{const b=y(process),D=o.spawn(t,l,{cwd:a,env:b});D.on("error",f),D.on("exit",()=>u())})}runInTerminal(o,p,t,a,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:h.getDefaultTerminalWindows();return new Promise((l,u)=>{const f=`"${p} - ${P}"`,b=`""${t.join('" "')}" & pause"`,D=["/c","start",f,"/wait",i,"/c",b],w=Object.assign({},y(process),a);Object.keys(w).filter(F=>w[F]===null).forEach(F=>delete w[F]);const T={cwd:p,env:w,windowsVerbatimArguments:!0};m.spawn(h.CMD,D,T).on("error",F=>{u(I(F))}),l(void 0)})}static getDefaultTerminalWindows(){if(!h._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return h._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=h,h.CMD="cmd.exe";class d extends c{openTerminal(o,p){return this.spawnTerminal(m,o,p)}runInTerminal(o,p,t,a,r){const i=r.osxExec||n.DEFAULT_TERMINAL_OSX;return new Promise((l,u)=>{if(i===n.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const f=i===n.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",D=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${f}.scpt`,J).fsPath,"-t",o||P,"-w",p];for(let v of t)D.push("-a"),D.push(v);if(a){const v=Object.assign({},y(process),a);for(let F in v){const M=v[F];M===null?(D.push("-u"),D.push(F)):(D.push("-e"),D.push(`${F}=${M}`))}}let w="";const T=m.spawn(d.OSASCRIPT,D);T.on("error",v=>{u(I(v))}),T.stderr.on("data",v=>{w+=v.toString()}),T.on("exit",v=>{if(v===0)l(void 0);else if(w){const F=w.split(`
`,1);u(new Error(F[0]))}else u(new Error(A.localize(1,null,f,v)))})}else u(new Error(A.localize(2,null,i)))})}spawnTerminal(o,p,t){const a=p.osxExec||n.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{const l=["-a",a];t&&l.push(t);const u=y(process),f=o.spawn("/usr/bin/open",l,{cwd:t,env:u});f.on("error",i),f.on("exit",()=>r())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class g extends c{openTerminal(o,p){return this.spawnTerminal(m,o,p)}runInTerminal(o,p,t,a,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((l,u)=>{let f=[];i.then(b=>{b.indexOf("gnome-terminal")>=0?f.push("-x"):f.push("-e"),f.push("bash"),f.push("-c");const D=`${_(t)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;f.push(`''${D}''`);const w=Object.assign({},y(process),a);Object.keys(w).filter(M=>w[M]===null).forEach(M=>delete w[M]);const T={cwd:p,env:w};let v="";const F=m.spawn(b,f,T);F.on("error",M=>{u(I(M))}),F.stderr.on("data",M=>{v+=M.toString()}),F.on("exit",M=>{if(M===0)l(void 0);else if(v){const G=v.split(`
`,1);u(new Error(G[0]))}else u(new Error(A.localize(4,null,b,M)))})})})}static async getDefaultTerminalLinuxReady(){return g._DEFAULT_TERMINAL_LINUX_READY||(g._DEFAULT_TERMINAL_LINUX_READY=new Promise(async o=>{C.isLinux?await E.Promises.exists("/etc/debian_version")?o("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?o("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?o("konsole"):process.env.COLORTERM?o(process.env.COLORTERM):process.env.TERM?o(process.env.TERM):o("xterm"):o("xterm")})),g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,p,t){const a=p.linuxExec?Promise.resolve(p.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{a.then(l=>{const u=y(process),f=o.spawn(l,[],{cwd:t,env:u});f.on("error",i),f.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=A.localize(3,null);function y(s){const o={...s.env};return(0,R.sanitizeProcessEnvironment)(o),o}function I(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(A.localize(5,null,s.path)):s}function _(s){let o="";for(let p of s)p.indexOf(" ")>=0?o+='"'+p+'"':o+=p,o+=" ";return o}}),define(me[42],ge([0,1,24,8,9,13,2,160,4]),function(J,e,m,L,k,C,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function A(U){return U.create===!0}e.isFileOpenForWriteOptions=A;var n;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var P;(function(U){U[U.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var c;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(c=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=h;function d(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=d;function g(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function y(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=y;var I;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(I=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class _ extends Error{constructor(z,N){super(z);this.code=N}}e.FileSystemProviderError=_;function s(U,z){const N=new _(U.toString(),z);return p(N,z),N}e.createFileSystemProviderError=s;function o(U){return U||s((0,E.localize)(0,null),I.Unknown)}e.ensureFileSystemProviderError=o;function p(U,z){return U.name=z?`${z} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=p;function t(U){if(!U)return I.Unknown;if(U instanceof _)return U.code;const z=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!z)return I.Unknown;switch(z[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileExceedsMemoryLimit:return I.FileExceedsMemoryLimit;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}e.toFileSystemProviderErrorCode=t;function a(U){if(U instanceof b)return U.fileOperationResult;switch(t(U)){case I.FileNotFound:return 1;case I.FileIsADirectory:return 0;case I.FileNotADirectory:return 10;case I.FileWriteLocked:return 5;case I.NoPermissions:return 6;case I.FileExists:return 4;case I.FileExceedsMemoryLimit:return 9;case I.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var r;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(z,N,x){this.resource=z,this.operation=N,this.target=x}isOperation(z){return this.operation===z}}e.FileOperationEvent=i;var l;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class u{constructor(z,N){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const x of z)switch(x.type){case 1:this.added||(this.added=m.TernarySearchTree.forUris(()=>N)),this.added.set(x.resource,x);break;case 0:this.updated||(this.updated=m.TernarySearchTree.forUris(()=>N)),this.updated.set(x.resource,x);break;case 2:this.deleted||(this.deleted=m.TernarySearchTree.forUris(()=>N)),this.deleted.set(x.resource,x);break}}contains(z,...N){return this.doContains(z,{includeChildren:!1},...N)}affects(z,...N){return this.doContains(z,{includeChildren:!0},...N)}doContains(z,N,...x){if(!z)return!1;const B=x.length>0;return!!((!B||x.includes(1))&&(this.added?.get(z)||N.includeChildren&&this.added?.findSuperstr(z))||(!B||x.includes(0))&&(this.updated?.get(z)||N.includeChildren&&this.updated?.findSuperstr(z))||(!B||x.includes(2))&&(this.deleted?.findSubstr(z)||N.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=u;function f(U,z,N){return!U||!z||U===z||z.length>U.length?!1:(z.charAt(z.length-1)!==L.sep&&(z+=L.sep),N?(0,k.startsWithIgnoreCase)(U,z):U.indexOf(z)===0)}e.isParent=f;class b extends Error{constructor(z,N,x){super(z);this.fileOperationResult=N,this.options=x}}e.FileOperationError=b;class D extends b{constructor(z,N,x){super(z,2,x);this.stat=N}}e.NotModifiedSinceFileOperationError=D;var w;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(w=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function v(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=v;async function F(U,z){if(!z.canHandleResource(R.URI.from({scheme:U.scheme})))return new Promise(N=>{const x=z.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===U.scheme&&B.added&&(x.dispose(),N())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(z){return(0,C.isNumber)(z)||(z=0),z<M.KB?(0,E.localize)(1,null,z.toFixed(0)):z<M.MB?(0,E.localize)(2,null,(z/M.KB).toFixed(2)):z<M.GB?(0,E.localize)(3,null,(z/M.MB).toFixed(2)):z<M.TB?(0,E.localize)(4,null,(z/M.GB).toFixed(2)):(0,E.localize)(5,null,(z/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var G;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(G=e.Arch||(e.Arch={}));function K(U){return{maxFileSize:U===0?300*M.MB:16*M.GB,maxHeapSize:U===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=K}),define(me[84],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...k){this._entries=new Map;for(let[C,R]of k)this.set(C,R)}set(k,C){const R=this._entries.get(k);return this._entries.set(k,C),R}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=m}),define(me[189],ge([0,1,18,16,115,181,4,84]),function(J,e,m,L,k,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class A extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class n{constructor(d=new E.ServiceCollection,g=!1,y){this._activeInstantiations=new Set,this._services=d,this._strict=g,this._parent=y,this._services.set(R.IInstantiationService,this)}createChild(d){return new n(d,this._strict,this)}invokeFunction(d,...g){let y=c.traceInvocation(d),I=!1;try{return d({get:(s,o)=>{if(I)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(s,y);if(!p&&o!==R.optional)throw new Error(`[invokeFunction] unknown service '${s}'`);return p}},...g)}finally{I=!0,y.stop()}}createInstance(d,...g){let y,I;return d instanceof k.SyncDescriptor?(y=c.traceCreation(d.ctor),I=this._createInstance(d.ctor,d.staticArguments.concat(g),y)):(y=c.traceCreation(d),I=this._createInstance(d,g,y)),y.stop(),I}_createInstance(d,g=[],y){let I=R._util.getServiceDependencies(d).sort((o,p)=>o.index-p.index),_=[];for(const o of I){let p=this._getOrCreateServiceInstance(o.id,y);if(!p&&this._strict&&!o.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${o.id}.`);_.push(p)}let s=I.length>0?I[0].index:g.length;if(g.length!==s){console.warn(`[createInstance] First service dependency of ${d.name} at position ${s+1} conflicts with ${g.length} static arguments`);let o=s-g.length;o>0?g=g.concat(new Array(o)):g=g.slice(0,s)}return new d(...[...g,..._])}_setServiceInstance(d,g){if(this._services.get(d)instanceof k.SyncDescriptor)this._services.set(d,g);else if(this._parent)this._parent._setServiceInstance(d,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let g=this._services.get(d);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):g}_getOrCreateServiceInstance(d,g){let y=this._getServiceInstanceOrDescriptor(d);return y instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,y,g.branch(d,!0)):(g.branch(d,!1),y)}_safeCreateAndCacheServiceInstance(d,g,y){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,g,y)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,g,y){const I=new C.Graph(o=>o.id.toString());let _=0;const s=[{id:d,desc:g,_trace:y}];for(;s.length;){const o=s.pop();if(I.lookupOrInsertNode(o),_++>1e3)throw new A(I);for(let p of R._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(p.id);if(!t&&!p.optional&&console.warn(`[createInstance] ${d} depends on ${p.id} which is NOT registered.`),t instanceof k.SyncDescriptor){const a={id:p.id,desc:t,_trace:o._trace.branch(p.id,!0)};I.insertEdge(o,a),s.push(a)}}}for(;;){const o=I.roots();if(o.length===0){if(!I.isEmpty())throw new A(I);break}for(const{data:p}of o){if(this._getServiceInstanceOrDescriptor(p.id)instanceof k.SyncDescriptor){const a=this._createServiceInstanceWithOwner(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this._setServiceInstance(p.id,a)}I.removeNode(p)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,g,y=[],I,_){if(this._services.get(d)instanceof k.SyncDescriptor)return this._createServiceInstance(g,y,I,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,g,y,I,_);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(d,g=[],y,I){if(y){const _=new m.IdleValue(()=>this._createInstance(d,g,I));return new Proxy(Object.create(null),{get(s,o){if(o in s)return s[o];let p=_.value,t=p[o];return typeof t!="function"||(t=t.bind(p),s[o]=t),t},set(s,o,p){return _.value[o]=p,!0}})}else return this._createInstance(d,g,I)}}e.InstantiationService=n;var P;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(P||(P={}));class c{constructor(d,g){this.type=d,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return S?new c(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(d){return S?new c(0,d.name):c._None}branch(d,g){let y=new c(2,d.toString());return this._dep.push([d,g,y]),y}stop(){let d=Date.now()-this._start;c._totals+=d;let g=!1;function y(_,s){let o=[],p=new Array(_+1).join("	");for(const[t,a,r]of s._dep)if(a&&r){g=!0,o.push(`${p}CREATES -> ${t}`);let i=y(_+1,r);i&&o.push(i)}else o.push(`${p}uses -> ${t}`);return o.join(`
`)}let I=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(d>2||g)&&console.log(I.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(me[12],ge([0,1,61,3,6,11,4]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,R.createDecorator)("logService"),e.ILoggerService=(0,R.createDecorator)("loggerService");function E(){return new Date().toISOString()}var S;(function(p){p[p.Trace=0]="Trace",p[p.Debug=1]="Debug",p[p.Info=2]="Info",p[p.Warning=3]="Warning",p[p.Error=4]="Error",p[p.Critical=5]="Critical",p[p.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class A extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=A;class n extends A{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...a){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...a]))}debug(t,...a){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...a]))}info(t,...a){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...a]))}warn(t,...a){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...a]))}error(t,...a){if(this.checkLogLevel(S.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(S.Error,this.format(r))}else this.log(S.Error,this.format([t,...a]))}critical(t,...a){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...a]))}flush(){}format(t){let a="";for(let r=0;r<t.length;r++){let i=t[r];if(typeof i=="object")try{i=JSON.stringify(i)}catch(l){}a+=(r>0?" ":"")+i}return a}}e.AbstractMessageLogger=n;class P extends A{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!C.isWindows}trace(t,...a){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${E()}][0m`,t,...a):console.log(`[main ${E()}]`,t,...a))}debug(t,...a){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${E()}][0m`,t,...a):console.log(`[main ${E()}]`,t,...a))}info(t,...a){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${E()}][0m`,t,...a):console.log(`[main ${E()}]`,t,...a))}warn(t,...a){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${E()}][0m`,t,...a):console.warn(`[main ${E()}]`,t,...a))}error(t,...a){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${E()}][0m`,t,...a):console.error(`[main ${E()}]`,t,...a))}critical(t,...a){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${E()}][0m`,t,...a):console.error(`[main ${E()}]`,t,...a))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class c extends A{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...a){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...a)}debug(t,...a){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...a)}info(t,...a){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...a)}warn(t,...a){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...a)}error(t,...a){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...a)}critical(t,...a){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...a)}dispose(){}flush(){}}e.ConsoleLogger=c;class h extends A{constructor(t,a=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(a)}trace(t,...a){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...a])}debug(t,...a){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...a])}info(t,...a){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...a])}warn(t,...a){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...a])}error(t,...a){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...a])}critical(t,...a){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...a])}extractMessage(t){return typeof t=="string"?t:(0,m.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class d extends A{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const a of this.logServices)a.setLevel(t);super.setLevel(t)}trace(t,...a){for(const r of this.logServices)r.trace(t,...a)}debug(t,...a){for(const r of this.logServices)r.debug(t,...a)}info(t,...a){for(const r of this.logServices)r.info(t,...a)}warn(t,...a){for(const r of this.logServices)r.warn(t,...a)}error(t,...a){for(const r of this.logServices)r.error(t,...a)}critical(t,...a){for(const r of this.logServices)r.critical(t,...a)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=d;class g extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...a){this.logger.trace(t,...a)}debug(t,...a){this.logger.debug(t,...a)}info(t,...a){this.logger.info(t,...a)}warn(t,...a){this.logger.warn(t,...a)}error(t,...a){this.logger.error(t,...a)}critical(t,...a){this.logger.critical(t,...a)}flush(){this.logger.flush()}}e.LogService=g;class y extends k.Disposable{constructor(t,a){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(a(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(r))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,a){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,a?.always?S.Trace:this.logLevel,a),this.loggers.set(t.toString(),r),a?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=y;class I{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...a){}debug(t,...a){}info(t,...a){}warn(t,...a){}error(t,...a){}critical(t,...a){}dispose(){}flush(){}}e.NullLogService=I;function _(p){if(p.verbose)return S.Trace;if(typeof p.logLevel=="string"){const t=s(p.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=_;function s(p){switch(p){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=s;function o(p){switch(p){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=o}),define(me[116],ge([0,1,42,12]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(S,A,n,P){try{const c=await new Promise((h,d)=>{J(["spdlog"],h,d)});return c.setFlushOn(L.LogLevel.Trace),c.createAsyncRotatingLogger(S,A,n,P)}catch(c){console.error(c)}return null}function C(S,A,n,P){const c=J.__$__nodeRequire("spdlog");return c.setFlushOn(L.LogLevel.Trace),c.createRotatingLogger(S,A,n,P)}e.createRotatingLogger=C;function R(S,A,n){switch(A){case L.LogLevel.Trace:S.trace(n);break;case L.LogLevel.Debug:S.debug(n);break;case L.LogLevel.Info:S.info(n);break;case L.LogLevel.Warning:S.warn(n);break;case L.LogLevel.Error:S.error(n);break;case L.LogLevel.Critical:S.critical(n);break;default:throw new Error("Invalid log level")}}class E extends L.AbstractMessageLogger{constructor(A,n,P,c){super();this.name=A,this.filepath=n,this.rotating=P,this.buffer=[],this.setLevel(c),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(h=>{this._logger&&this._logger.setLevel(h)}))}_createSpdLogLogger(){const A=this.rotating?6:1,n=30/A*m.ByteSize.MB;return k(this.name,this.filepath,n,A).then(P=>{if(P){this._logger=P,this._logger.setLevel(this.getLevel());for(const{level:c,message:h}of this.buffer)R(this._logger,c,h);this.buffer=[]}})}log(A,n){this._logger?R(this._logger,A,n):this.getLevel()<=A&&this.buffer.push({level:A,message:n})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=E}),define(me[117],ge([0,1,49,161,4]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var R;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(R=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function A(d,g){return g-d}S.compare=A;const n=Object.create(null);n[S.Error]=(0,L.localize)(0,null),n[S.Warning]=(0,L.localize)(1,null),n[S.Info]=(0,L.localize)(2,null);function P(d){return n[d]||""}S.toString=P;function c(d){switch(d){case m.default.Error:return S.Error;case m.default.Warning:return S.Warning;case m.default.Info:return S.Info;case m.default.Ignore:return S.Hint}}S.fromSeverity=c;function h(d){switch(d){case S.Error:return m.default.Error;case S.Warning:return m.default.Warning;case S.Info:return m.default.Info;case S.Hint:return m.default.Ignore}}S.toSeverity=h}(R=e.MarkerSeverity||(e.MarkerSeverity={}));var E;(function(S){const A="";function n(c){return P(c,!0)}S.makeKey=n;function P(c,h){let d=[A];return c.source?d.push(c.source.replace("\xA6","\\\xA6")):d.push(A),c.code?typeof c.code=="string"?d.push(c.code.replace("\xA6","\\\xA6")):d.push(c.code.value.replace("\xA6","\\\xA6")):d.push(A),c.severity!==void 0&&c.severity!==null?d.push(R.toString(c.severity)):d.push(A),c.message&&h?d.push(c.message.replace("\xA6","\\\xA6")):d.push(A),c.startLineNumber!==void 0&&c.startLineNumber!==null?d.push(c.startLineNumber.toString()):d.push(A),c.startColumn!==void 0&&c.startColumn!==null?d.push(c.startColumn.toString()):d.push(A),c.endLineNumber!==void 0&&c.endLineNumber!==null?d.push(c.endLineNumber.toString()):d.push(A),c.endColumn!==void 0&&c.endColumn!==null?d.push(c.endColumn.toString()):d.push(A),d.push(A),d.join("\xA6")}S.makeKeyOptionalMessage=P})(E=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,k.createDecorator)("markerService")}),define(me[190],ge([0,1,3,49,4]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,k.createDecorator)("notificationService");var C;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var R;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(R=e.NotificationsFilter||(e.NotificationsFilter={}));class E{constructor(){this.progress=new S,this.onDidClose=m.Event.None,this.onDidChangeVisibility=m.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=E;class S{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=S}),define(me[191],ge([0,1,6,9,2,4]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return m.Disposable.None},registerValidator(){return m.Disposable.None},registerExternalUriResolver(){return m.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return m.Disposable.None},async open(){return!1},async resolveExternalUri(E){return{resolved:E,dispose(){}}}});function R(E,S){return k.URI.isUri(E)?(0,L.equalsIgnoreCase)(E.scheme,S):(0,L.startsWithIgnoreCase)(E,S+":")}e.matchesScheme=R}),define(me[192],ge([0,1,10,11,38,22]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let R;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const E=L.globals.vscode.context.configuration();if(E)R=E.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const E=(0,C.dirname)(m.FileAccess.asFileUri("",J));R=J.__$__nodeRequire((0,C.joinPath)(E,"product.json").fsPath);const S=J.__$__nodeRequire((0,C.joinPath)(E,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(R,{nameShort:`${R.nameShort} Dev`,nameLong:`${R.nameLong} Dev`,dataFolderName:`${R.dataFolderName}-dev`}),Object.assign(R,{version:S.version})}else R={},Object.keys(R).length===0&&Object.assign(R,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=R});var $e=this&&this.__param||function(J,e){return function(m,L){e(m,L,J)}};define(me[118],ge([0,1,18,21,6,4]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,C.createDecorator)("progressService");var R;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(R=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class E{constructor(P){this.callback=P}get value(){return this._value}report(P){this._value=P,this.callback(this._value)}}e.Progress=E,E.None=Object.freeze({report(){}});let S=class extends k.Disposable{constructor(P,c){super();this.deferred=new m.DeferredPromise,c.withProgress(P,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,k.toDisposable)(()=>this.deferred.complete()))}report(P){this.reporter?this.reporter.report(P):this.lastStep=P}};S=Ve([$e(1,e.IProgressService)],S),e.UnmanagedProgress=S;class A extends k.Disposable{constructor(P){super();this.progressIndicator=P,this.currentOperationId=0,this.currentOperationDisposables=this._register(new k.DisposableStore)}start(P){this.stop();const c=++this.currentOperationId,h=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},P),this.currentOperationDisposables.add((0,k.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,k.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,k.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:h.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(P){this.currentOperationId===P&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=A,e.IEditorProgressService=(0,C.createDecorator)("editorProgressService")}),define(me[34],ge([0,1,56,13]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(R,E){m.ok(L.isString(R)),m.ok(L.isObject(E)),m.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,E)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new k}),define(me[119],ge([0,1,3,34]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class C{constructor(){this._onDidChangeSchema=new m.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,A){this.schemasById[k(S)]=A,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new C;L.Registry.add(e.Extensions.JSONContribution,R)}),define(me[85],ge([0,1,3,13,156,119,34]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var E;(function(I){I.Multiline="multilineText",I.Singleline="singlelineText"})(E=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var S;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const A=R.Registry.as(C.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new m.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new m.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(_,s=!0){this.registerConfigurations([_],s)}registerConfigurations(_,s=!0){const o=[];_.forEach(p=>{o.push(...this.validateAndRegisterProperties(p,s,p.extensionInfo)),this.configurationContributors.push(p),this.registerJSONConfiguration(p)}),A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(_){const s=[],o=p=>{if(p.properties)for(const t in p.properties)s.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,p.properties[t]);p.allOf&&p.allOf.forEach(t=>o(t))};for(const p of _){o(p);const t=this.configurationContributors.indexOf(p);t!==-1&&this.configurationContributors.splice(t,1)}A.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}registerDefaultConfigurations(_){const s=[],o=[];for(const p of _)for(const t in p)if(s.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...p[t]};const a={type:"object",default:this.defaultValues[t],description:k.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};o.push(c(t)),this.configurationProperties[t]=a,this.defaultLanguageConfigurationOverridesNode.properties[t]=a}else{this.defaultValues[t]=p[t];const a=this.configurationProperties[t];a&&(this.updatePropertyDefaultValue(t,a),this.updateSchema(t,a))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterDefaultConfigurations(_){const s=[];for(const o of _)for(const p in o)if(s.push(p),delete this.defaultValues[p],e.OVERRIDE_PROPERTY_PATTERN.test(p))delete this.configurationProperties[p],delete this.defaultLanguageConfigurationOverridesNode.properties[p];else{const t=this.configurationProperties[p];t&&(this.updatePropertyDefaultValue(p,t),this.updateSchema(p,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}notifyConfigurationSchemaUpdated(..._){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(_){for(const s of _)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(_,s=!0,o,p=3){p=L.isUndefinedOrNull(_.scope)?p:_.scope;let t=[],a=_.properties;if(a)for(let i in a){if(s&&g(i)){delete a[i];continue}const l=a[i];if(this.updatePropertyDefaultValue(i,l),e.OVERRIDE_PROPERTY_PATTERN.test(i)?l.scope=void 0:(l.scope=L.isUndefinedOrNull(l.scope)?p:l.scope,l.restricted=L.isUndefinedOrNull(l.restricted)?!!o?.restrictedConfigurations?.includes(i):l.restricted),a[i].hasOwnProperty("included")&&!a[i].included){this.excludedConfigurationProperties[i]=a[i],delete a[i];continue}else this.configurationProperties[i]=a[i];!a[i].deprecationMessage&&a[i].markdownDeprecationMessage&&(a[i].deprecationMessage=a[i].markdownDeprecationMessage),t.push(i)}let r=_.allOf;if(r)for(let i of r)t.push(...this.validateAndRegisterProperties(i,s,o,p));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(_){const s=o=>{let p=o.properties;if(p)for(const a in p)this.updateSchema(a,p[a]);let t=o.allOf;t&&t.forEach(s)};s(_)}updateSchema(_,s){switch(e.allSettings.properties[_]=s,s.scope){case 1:e.applicationSettings.properties[_]=s;break;case 2:e.machineSettings.properties[_]=s;break;case 6:e.machineOverridableSettings.properties[_]=s;break;case 3:e.windowSettings.properties[_]=s;break;case 4:e.resourceSettings.properties[_]=s;break;case 5:e.resourceSettings.properties[_]=s,this.resourceLanguageSettingsSchema.properties[_]=s;break}}removeFromSchema(_,s){switch(delete e.allSettings.properties[_],s.scope){case 1:delete e.applicationSettings.properties[_];break;case 2:delete e.machineSettings.properties[_];break;case 6:delete e.machineOverridableSettings.properties[_];break;case 3:delete e.windowSettings.properties[_];break;case 4:case 5:delete e.resourceSettings.properties[_];break}}updateOverridePropertyPatternKey(){for(const _ of this.overrideIdentifiers.values()){const s=`[${_}]`,o={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,o),e.allSettings.properties[s]=o,e.applicationSettings.properties[s]=o,e.machineSettings.properties[s]=o,e.machineOverridableSettings.properties[s]=o,e.windowSettings.properties[s]=o,e.resourceSettings.properties[s]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(_,s){let o=this.defaultValues[_];L.isUndefined(o)&&(o=s.default),L.isUndefined(o)&&(o=h(s.type)),s.default=o}}const P="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(P);function c(I){return I.substring(1,I.length-1)}e.overrideIdentifierFromKey=c;function h(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const d=new n;R.Registry.add(e.Extensions.Configuration,d);function g(I){return I.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(I)?k.localize(5,null,I):d.getConfigurationProperties()[I]!==void 0?k.localize(6,null,I):null:k.localize(4,null)}e.validateProperty=g;function y(){const I=[],_=d.getConfigurationProperties();for(const s of Object.keys(_))I.push([s,_[s].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.getScopes=y}),define(me[120],ge([0,1,25,13,2,85,4,34]),function(J,e,m,L,k,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function S(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof k.URI)}e.isConfigurationOverrides=S;var A;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function P(a,r){const i=r?a?r.keys.filter(T=>a.keys.indexOf(T)===-1):[...r.keys]:[],l=a?r?a.keys.filter(T=>r.keys.indexOf(T)===-1):[...a.keys]:[],u=[];if(r&&a){for(const T of a.keys)if(r.keys.indexOf(T)!==-1){const v=I(a.contents,T),F=I(r.contents,T);m.equals(v,F)||u.push(T)}}const f=[],b=T=>{const v={};for(const F of T)for(const M of F.identifiers)v[p(M)]=F;return v},D=r?b(r.overrides):{},w=a?b(a.overrides):{};if(Object.keys(D).length)for(const T of i){const v=D[T];v&&f.push([(0,C.overrideIdentifierFromKey)(T),v.keys])}if(Object.keys(w).length)for(const T of l){const v=w[T];v&&f.push([(0,C.overrideIdentifierFromKey)(T),v.keys])}if(Object.keys(D).length&&Object.keys(w).length)for(const T of u){const v=w[T],F=D[T];if(v&&F){const M=P({contents:v.contents,keys:v.keys,overrides:[]},{contents:F.contents,keys:F.keys,overrides:[]});f.push([(0,C.overrideIdentifierFromKey)(T),[...M.added,...M.removed,...M.updated]])}}return{added:i,removed:l,updated:u,overrides:f}}e.compare=P;function c(a,r){const i=[];for(const l of Object.keys(a))if(C.OVERRIDE_PROPERTY_PATTERN.test(l)){const u={};for(const f in a[l])u[f]=a[l][f];i.push({identifiers:[(0,C.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(u),contents:h(u,r)})}return i}e.toOverrides=c;function h(a,r){const i=Object.create(null);for(let l in a)d(i,l,a[l],r);return i}e.toValuesTree=h;function d(a,r,i,l){const u=r.split("."),f=u.pop();let b=a;for(let D=0;D<u.length;D++){let w=u[D],T=b[w];switch(typeof T){case"undefined":T=b[w]=Object.create(null);break;case"object":break;default:l(`Ignoring ${r} as ${u.slice(0,D+1).join(".")} is ${JSON.stringify(T)}`);return}b=T}if(typeof b=="object"&&b!==null)try{b[f]=i}catch(D){l(`Ignoring ${r} as ${u.join(".")} is ${JSON.stringify(b)}`)}else l(`Ignoring ${r} as ${u.join(".")} is ${JSON.stringify(b)}`)}e.addToValueTree=d;function g(a,r){const i=r.split(".");y(a,i)}e.removeFromValueTree=g;function y(a,r){const i=r.shift();if(r.length===0){delete a[i];return}if(Object.keys(a).indexOf(i)!==-1){const l=a[i];typeof l=="object"&&!Array.isArray(l)&&(y(l,r),Object.keys(l).length===0&&delete a[i])}}function I(a,r,i){function l(b,D){let w=b;for(const T of D){if(typeof w!="object"||w===null)return;w=w[T]}return w}const u=r.split("."),f=l(a,u);return typeof f=="undefined"?i:f}e.getConfigurationValue=I;function _(a,r,i){Object.keys(r).forEach(l=>{l!=="__proto__"&&(l in a?L.isObject(a[l])&&L.isObject(r[l])?_(a[l],r[l],i):i&&(a[l]=r[l]):a[l]=r[l])})}e.merge=_;function s(){const a=E.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(a)}e.getConfigurationKeys=s;function o(){const a=Object.create(null),r=E.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let i in r){let l=r[i].default;d(a,i,l,u=>console.error(`Conflict in default settings: ${u}`))}return a}e.getDefaultValues=o;function p(a){return`[${a}]`}e.keyFromOverrideIdentifier=p;function t(a,r,i){const l=a.inspect(r),u=a.inspect(i);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:l.defaultValue}e.getMigratedSettingValue=t}),define(me[193],ge([0,1,17,3,59,6,24,25,13,2,120,85,34]),function(J,e,m,L,k,C,R,E,S,A,n,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(t={},a=[],r=[]){this._contents=t,this._keys=a,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,a){const r=this.getContentsForOverrideIdentifer(a);return r?t?(0,n.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const a of this.overrides)if(a.identifiers.indexOf(t)!==-1)return a.keys;return[]}override(t){const a=this.getContentsForOverrideIdentifer(t);if(!a||typeof a!="object"||!Object.keys(a).length)return this;let r={};for(const i of m.distinct([...Object.keys(this.contents),...Object.keys(a)])){let l=this.contents[i],u=a[i];u&&(typeof l=="object"&&typeof u=="object"?(l=E.deepClone(l),this.mergeContents(l,u)):l=u),r[i]=l}return new h(r,this.keys,this.overrides)}merge(...t){const a=E.deepClone(this.contents),r=E.deepClone(this.overrides),i=[...this.keys];for(const l of t){this.mergeContents(a,l.contents);for(const u of l.overrides){const[f]=r.filter(b=>m.equals(b.identifiers,u.identifiers));f?this.mergeContents(f.contents,u.contents):r.push(E.deepClone(u))}for(const u of l.keys)i.indexOf(u)===-1&&i.push(u)}return new h(a,i,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,a){for(const r of Object.keys(a)){if(r in t&&S.isObject(t[r])&&S.isObject(a[r])){this.mergeContents(t[r],a[r]);continue}t[r]=E.deepClone(a[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?E.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const a of this.overrides)if(a.identifiers.indexOf(t)!==-1)return a.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,a){this.addKey(t),(0,n.addToValueTree)(this.contents,t,a,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let a=this.keys.length;for(let r=0;r<a;r++)t.indexOf(this.keys[r])===0&&(a=r);this.keys.splice(a,1,t)}removeKey(t){let a=this.keys.indexOf(t);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=h;class d extends h{constructor(){const t=(0,n.getDefaultValues)(),a=(0,n.getConfigurationKeys)(),r=[];for(const i of Object.keys(t))P.OVERRIDE_PROPERTY_PATTERN.test(i)&&r.push({identifiers:[(0,P.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,n.toValuesTree)(t[i],l=>console.error(`Conflict in default settings file: ${l}`))});super(t,a,r)}}e.DefaultConfigurationModel=d;class g{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,a){if(!S.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,a)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,a){this._raw=t;const{contents:r,keys:i,overrides:l,restricted:u}=this.doParseRaw(t,a);this._configurationModel=new h(r,i,l),this._restrictedConfigurations=u||[]}doParseContent(t){let a={},r=null,i=[],l=[],u=[];function f(D){Array.isArray(i)?i.push(D):r!==null&&(i[r]=D)}let b={onObjectBegin:()=>{let D={};f(D),l.push(i),i=D,r=null},onObjectProperty:D=>{r=D},onObjectEnd:()=>{i=l.pop()},onArrayBegin:()=>{let D=[];f(D),l.push(i),i=D,r=null},onArrayEnd:()=>{i=l.pop()},onLiteralValue:f,onError:(D,w,T)=>{u.push({error:D,offset:w,length:T})}};if(t)try{k.visit(t,b),a=i[0]||{}}catch(D){console.error(`Error while parsing settings file ${this._name}: ${D}`),this._parseErrors=[D]}return a}doParseRaw(t,a){const r=c.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,r,!0,a);t=i.raw;const l=(0,n.toValuesTree)(t,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),u=Object.keys(t),f=(0,n.toOverrides)(t,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:l,keys:u,overrides:f,restricted:i.restricted}}filter(t,a,r,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const l={},u=[];for(let f in t)if(P.OVERRIDE_PROPERTY_PATTERN.test(f)&&r){const b=this.filter(t[f],a,!1,i);l[f]=b.raw,u.push(...b.restricted)}else{const b=a[f],D=b?typeof b.scope!="undefined"?b.scope:3:void 0;b?.restricted&&u.push(f),(D===void 0||i.scopes===void 0||i.scopes.includes(D))&&(i.skipRestricted&&b?.restricted||(l[f]=t[f]))}return{raw:l,restricted:u}}}e.ConfigurationModelParser=g;class y extends C.Disposable{constructor(t,a,r,i){super();this.userSettingsResource=t,this.scopes=a,this.fileService=i,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=y;class I{constructor(t,a,r=new h,i=new h,l=new R.ResourceMap,u=new h,f=new R.ResourceMap,b=!0){this._defaultConfiguration=t,this._localUserConfiguration=a,this._remoteUserConfiguration=r,this._workspaceConfiguration=i,this._folderConfigurations=l,this._memoryConfiguration=u,this._memoryConfigurationByResource=f,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,a,r){return this.getConsolidateConfigurationModel(a,r).getValue(t)}updateValue(t,a,r={}){let i;r.resource?(i=this._memoryConfigurationByResource.get(r.resource),i||(i=new h,this._memoryConfigurationByResource.set(r.resource,i))):i=this._memoryConfiguration,a===void 0?i.removeValue(t):i.setValue(t,a),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,a,r){const i=this.getConsolidateConfigurationModel(a,r),l=this.getFolderConfigurationModelForResource(a.resource,r),u=a.resource?this._memoryConfigurationByResource.get(a.resource)||this._memoryConfiguration:this._memoryConfiguration,f=a.overrideIdentifier?this._defaultConfiguration.freeze().override(a.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),b=a.overrideIdentifier?this.userConfiguration.freeze().override(a.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),D=a.overrideIdentifier?this.localUserConfiguration.freeze().override(a.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),w=a.overrideIdentifier?this.remoteUserConfiguration.freeze().override(a.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),T=r?a.overrideIdentifier?this._workspaceConfiguration.freeze().override(a.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,v=l?a.overrideIdentifier?l.freeze().override(a.overrideIdentifier).getValue(t):l.freeze().getValue(t):void 0,F=a.overrideIdentifier?u.override(a.overrideIdentifier).getValue(t):u.getValue(t),M=i.getValue(t),G=m.distinct(m.flatten(i.overrides.map(K=>K.identifiers))).filter(K=>i.getOverrideValue(t,K)!==void 0);return{defaultValue:f,userValue:b,userLocalValue:D,userRemoteValue:w,workspaceValue:T,workspaceFolderValue:v,memoryValue:F,value:M,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:a.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:a.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,userLocal:D!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:a.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,userRemote:w!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:a.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:a.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,workspaceFolder:v!==void 0?{value:l?.freeze().getValue(t),override:a.overrideIdentifier?l?.freeze().getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:u.getValue(t),override:a.overrideIdentifier?u.getOverrideValue(t,a.overrideIdentifier):void 0}:void 0,overrideIdentifiers:G.length?G:void 0}}keys(t){const a=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,a){this._folderConfigurations.set(t,a),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,a){const r=a.filter(i=>P.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const l=(0,P.overrideIdentifierFromKey)(i),u=this._defaultConfiguration.getKeysForOverrideIdentifier(l),f=t.getKeysForOverrideIdentifier(l),b=[...f.filter(D=>u.indexOf(D)===-1),...u.filter(D=>f.indexOf(D)===-1),...u.filter(D=>!E.equals(this._defaultConfiguration.override(l).getValue(D),t.override(l).getValue(D)))];return[l,b]});return this.updateDefaultConfiguration(t),{keys:a,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:a,updated:r,removed:i,overrides:l}=(0,n.compare)(this.localUserConfiguration,t),u=[...a,...r,...i];return u.length&&this.updateLocalUserConfiguration(t),{keys:u,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:a,updated:r,removed:i,overrides:l}=(0,n.compare)(this.remoteUserConfiguration,t);let u=[...a,...r,...i];return u.length&&this.updateRemoteUserConfiguration(t),{keys:u,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:a,updated:r,removed:i,overrides:l}=(0,n.compare)(this.workspaceConfiguration,t);let u=[...a,...r,...i];return u.length&&this.updateWorkspaceConfiguration(t),{keys:u,overrides:l}}compareAndUpdateFolderConfiguration(t,a){const r=this.folderConfigurations.get(t),{added:i,updated:l,removed:u,overrides:f}=(0,n.compare)(r,a);let b=[...i,...l,...u];return(b.length||!r)&&this.updateFolderConfiguration(t,a),{keys:b,overrides:f}}compareAndDeleteFolderConfiguration(t){const a=this.folderConfigurations.get(t);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:i,removed:l,overrides:u}=(0,n.compare)(a,void 0);return{keys:[...r,...i,...l],overrides:u}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,a){let r=this.getConsolidatedConfigurationModelForResource(t,a);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},a){let r=this.getWorkspaceConsolidatedConfiguration();if(a&&t){const i=a.getFolder(t);i&&(r=this.getFolderConsolidatedConfiguration(i.uri)||r);const l=this._memoryConfigurationByResource.get(t);l&&(r=r.merge(l))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let a=this._foldersConsolidatedConfigurations.get(t);if(!a){const r=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(a=r.merge(i),this._freeze&&(a=a.freeze()),this._foldersConsolidatedConfigurations.set(t,a)):a=r}return a}getFolderConfigurationModelForResource(t,a){if(a&&t){const r=a.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,a)=>{const{contents:r,overrides:i,keys:l}=this._folderConfigurations.get(a);return t.push([a,{contents:r,overrides:i,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(a=>t.add(a)),this.userConfiguration.freeze().keys.forEach(a=>t.add(a)),this._workspaceConfiguration.freeze().keys.forEach(a=>t.add(a)),this._folderConfigurations.forEach(a=>a.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const a=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>a.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>a.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>a.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(i=>a.add(i))),[...a.values()]}static parse(t){const a=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),l=t.folders.reduce((u,f)=>(u.set(A.URI.revive(f[0]),this.parseConfigurationModel(f[1])),u),new R.ResourceMap);return new I(a,r,new h,i,l,new h,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new h(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=I;function _(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const t=new Set,a=new Map;for(const i of p)i.keys.forEach(l=>t.add(l)),i.overrides.forEach(([l,u])=>{const f=(0,R.getOrSet)(a,l,new Set);u.forEach(b=>f.add(b))});const r=[];return a.forEach((i,l)=>r.push([l,[...i.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=_;class s{constructor(t,a,r,i){this.change=t,this.previous=a,this.currentConfiguraiton=r,this.currentWorkspace=i,this._previousConfiguration=void 0;const l=new Set;t.keys.forEach(f=>l.add(f)),t.overrides.forEach(([,f])=>f.forEach(b=>l.add(b))),this.affectedKeys=[...l.values()];const u=new h;this.affectedKeys.forEach(f=>u.setValue(f,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=I.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,a){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(a){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,a,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,a,this.currentWorkspace);return!E.equals(r,i)}return!0}return!1}doesAffectedKeysTreeContains(t,a){let r=(0,n.toValuesTree)({[a]:!0},()=>{}),i;for(;typeof r=="object"&&(i=Object.keys(r)[0]);){if(t=t[i],!t)return!1;r=r[i]}return!0}}e.ConfigurationChangeEvent=s;class o extends s{constructor(t,a,r,i){super({keys:t.allKeys(),overrides:[]},void 0,t,a);this.source=r,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=o}),define(me[121],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var L;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(R,E=L.Unknown,S){super(R);this._message=R,this._code=E,this._detail=S,this.isHandled=E===L.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(R){return R instanceof k&&R._code===L.TemporarilyNotAvailable}static isNoResolverFound(R){return R instanceof k&&R._code===L.NoResolverFound}static isHandled(R){return R instanceof k&&R.isHandled}}e.RemoteAuthorityResolverError=k}),define(me[86],ge([0,1,10]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(A){return A.scheme===m.Schemas.vscodeRemote?A.authority:void 0}e.getRemoteAuthority=L;function k(A){if(!A)return;const n=A.indexOf("+");return n<0?A:A.substr(0,n)}e.getRemoteName=k;function C(A){return A.scheme!==m.Schemas.file&&A.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=C;function R(A){if(A.folders.length)return A.folders.every(n=>C(n.uri))?A.folders[0].uri:void 0;if(A.configuration&&C(A.configuration))return A.configuration}e.getVirtualWorkspaceLocation=R;function E(A){return R(A)?.scheme}e.getVirtualWorkspaceScheme=E;function S(A){return R(A)!==void 0}e.isVirtualWorkspace=S}),define(me[194],ge([0,1,3,11,4,12]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService");var R;(function(h){h.Http="http",h.Https="https"})(R=e.TunnelProtocol||(e.TunnelProtocol={}));var E;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function S(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=S,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function A(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=A,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function n(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=n;function P(h,d){return d?d!==1&&h<1024:!L.isWindows&&h<1024}e.isPortPrivileged=P;let c=class{constructor(d){this.logService=d,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new m.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d,g){return this._tunnelProvider=d,d?(this._canElevate=g.elevation,this._canMakePublic=g.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async d=>{const g=[],y=Array.from(this._tunnels.values());for(let I of y){const _=Array.from(I.values());for(let s of _){const o=await s.value;o&&g.push(o)}}d(g)})}async dispose(){for(const d of this._tunnels.values()){for(const{value:g}of d.values())await g.then(y=>y?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,g,y,I,_=!1,s=!1,o){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${y} on local port ${I}.`),!d)return;g||(g="localhost");const p=this.retainOrCreateTunnel(d,g,y,I,_,s,o);return p?p.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,y);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(t);return(t.tunnelRemoteHost!==g||t.tunnelRemotePort!==y)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),p)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,public:d.public,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const g=this._tunnels.get(d.tunnelRemoteHost);if(g){const y=g.get(d.tunnelRemotePort);y&&(y.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,y))}}}}async tryDisposeTunnel(d,g,y){if(y.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${g}.`);const I=y.value.then(async _=>{_&&(await _.dispose(!0),this._onTunnelClosed.fire({host:_.tunnelRemoteHost,port:_.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(g),I}}async closeTunnel(d,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${g} `);const y=this._tunnels.get(d);if(y&&y.has(g)){const I=y.get(g);I.refcount=0,await this.tryDisposeTunnel(d,g,I)}}addTunnelToMap(d,g,y){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(g,{refcount:1,value:y})}async removeEmptyTunnelFromMap(d,g){const y=this._tunnels.get(d);y&&(await y.get(g)||y.delete(g),y.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,g){let y=[d];A(d)?(y.push(...e.LOCALHOST_ADDRESSES),y.push(...e.ALL_INTERFACES_ADDRESSES)):n(d)&&y.push(...e.ALL_INTERFACES_ADDRESSES);const I=y.map(_=>this._tunnels.get(_));for(const _ of I){const s=_?.get(g);if(s)return s}}canTunnel(d){return!!S(d)}createWithProvider(d,g,y,I,_,s,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${y} on local port ${I}.`);const t={elevationRequired:_?P(I===void 0?y:I):!1},a={remoteAddress:{host:g,port:y},localAddressPort:I,public:s,protocol:o},r=d.forwardPort(a,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(g,y,r),r}};c=Ve([$e(0,C.ILogService)],c),e.AbstractTunnelService=c}),define(me[195],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{vsda(){return new Promise((k,C)=>J(["vsda"],k,C))}async sign(k){try{const C=await this.vsda(),R=new C.signer;if(R)return R.sign(k)}catch(C){}return k}}e.SignService=m}),define(me[196],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class m{constructor(k){this._callback=k,this._terminalBufferMap=new Map}dispose(){for(const k of this._terminalBufferMap.values())k.dispose()}startBuffering(k,C,R=5){let E;return E=C(S=>{const A=typeof S=="string"?S:S.data;let n=this._terminalBufferMap.get(k);if(n){n.data.push(A);return}const P=setTimeout(()=>this.flushBuffer(k),R);n={data:[A],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(k),E.dispose()}},this._terminalBufferMap.set(k,n)}),E}stopBuffering(k){const C=this._terminalBufferMap.get(k);C&&C.dispose()}flushBuffer(k){const C=this._terminalBufferMap.get(k);C&&(this._terminalBufferMap.delete(k),this._callback(k,C.data.join("")))}}e.TerminalDataBufferer=m}),define(me[197],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(me[63],ge([0,1,47,3,6,4,34,197]),function(J,e,m,L,k,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var S;(function(y){function I(_){return _&&typeof _=="object"&&typeof _.id=="string"}y.isThemeColor=I})(S=e.ThemeColor||(e.ThemeColor={}));function A(y){return{id:y}}e.themeColorFromId=A;var n;(function(y){function I(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color=="undefined"||S.isThemeColor(a.color))}y.isThemeIcon=I;const _=new RegExp(`^\\$\\((${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?)\\)$`);function s(a){const r=_.exec(a);if(!r)return;let[,i]=r;return{id:i}}y.fromString=s;function o(a,r){let i=a.id;const l=i.lastIndexOf("~");return l!==-1&&(i=i.substring(0,l)),r&&(i=`${i}~${r}`),{id:i}}y.modify=o;function p(a,r){return a.id===r.id&&a.color?.id===r.color?.id}y.isEqual=p;function t(a,r){return{id:a.id,color:r?A(r):void 0}}y.asThemeIcon=t,y.asClassNameArray=m.CSSIcon.asClassNameArray,y.asClassName=m.CSSIcon.asClassName,y.asCSSSelector=m.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=m.Codicon.file,e.FolderThemeIcon=m.Codicon.folder;function P(y){switch(y){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class c{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(I){return this.themingParticipants.push(I),this.onThemingParticipantAddedEmitter.fire(I),(0,k.toDisposable)(()=>{const _=this.themingParticipants.indexOf(I);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let h=new c;R.Registry.add(e.Extensions.ThemingContribution,h);function d(y){return h.onColorThemeChange(y)}e.registerThemingParticipant=d;class g extends k.Disposable{constructor(I){super();this.themeService=I,this.theme=I.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(I){this.theme=I,this.updateStyles()}updateStyles(){}getColor(I,_){let s=this.theme.getColor(I);return s&&_&&(s=_(s,this.theme)),s?s.toString():null}}e.Themable=g}),define(me[198],ge([0,1,18,47,3,162,119,34,63]),function(J,e,m,L,k,C,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class A{constructor(){this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,C.localize)(0,null)},fontCharacter:{type:"string",description:(0,C.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${L.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(I,_,s,o){const p=this.iconsById[I];if(p){if(s&&!p.description){p.description=s,this.iconSchema.properties[I].markdownDescription=`${s} $(${I})`;const r=this.iconReferenceSchema.enum.indexOf(I);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=s),this._onDidChange.fire()}return p}let t={id:I,description:s,defaults:_,deprecationMessage:o};this.iconsById[I]=t;let a={$ref:"#/definitions/icons"};return o&&(a.deprecationMessage=o),s&&(a.markdownDescription=`${s}: $(${I})`),this.iconSchema.properties[I]=a,this.iconReferenceSchema.enum.push(I),this.iconReferenceSchema.enumDescriptions.push(s||""),this._onDidChange.fire(),{id:I}}deregisterIcon(I){delete this.iconsById[I],delete this.iconSchema.properties[I];const _=this.iconReferenceSchema.enum.indexOf(I);_!==-1&&(this.iconReferenceSchema.enum.splice(_,1),this.iconReferenceSchema.enumDescriptions.splice(_,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(I=>this.iconsById[I])}getIcon(I){return this.iconsById[I]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(I,_){const s=this.iconFontsById[I];if(s)return s;let o={id:I,definition:_};return this.iconFontsById[I]=o,this._onDidChange.fire(),o}deregisterIconFont(I){delete this.iconFontsById[I]}getIconFonts(){return Object.keys(this.iconFontsById).map(I=>this.iconFontsById[I])}getIconFont(I){return this.iconFontsById[I]}toString(){const I=(p,t)=>p.id.localeCompare(t.id),_=p=>{for(;S.ThemeIcon.isThemeIcon(p.defaults);)p=this.iconsById[p.defaults.id];return`codicon codicon-${p?p.id:""}`};let s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const o=Object.keys(this.iconsById).map(p=>this.iconsById[p]);for(const p of o.filter(t=>!!t.description).sort(I))s.push(`|<i class="${_(p)}"></i>|${p.id}|${S.ThemeIcon.isThemeIcon(p.defaults)?p.defaults.id:p.id}|${p.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const p of o.filter(t=>!S.ThemeIcon.isThemeIcon(t.defaults)).sort(I))s.push(`|<i class="${_(p)}"></i>|${p.id}|`);return s.join(`
`)}}const n=new A;E.Registry.add(e.Extensions.IconContribution,n);function P(y,I,_,s){return n.registerIcon(y,I,_,s)}e.registerIcon=P;function c(){return n}e.getIconRegistry=c;function h(){for(const y of L.iconRegistry.all)n.registerIcon(y.id,y.definition,y.description);L.iconRegistry.onDidRegister(y=>n.registerIcon(y.id,y.definition,y.description))}h(),e.iconsSchemaId="vscode://schemas/icons";let d=E.Registry.as(R.Extensions.JSONContribution);d.registerSchema(e.iconsSchemaId,n.getIconSchema());const g=new m.RunOnceScheduler(()=>d.notifySchemaChanged(e.iconsSchemaId),200);n.onDidChange(()=>{g.isScheduled()||g.schedule()}),e.widgetClose=P("widget-close",L.Codicon.close,(0,C.localize)(2,null)),e.gotoPreviousLocation=P("goto-previous-location",L.Codicon.arrowUp,(0,C.localize)(3,null)),e.gotoNextLocation=P("goto-next-location",L.Codicon.arrowDown,(0,C.localize)(4,null)),e.syncing=S.ThemeIcon.modify(L.Codicon.sync,"spin")}),define(me[43],ge([0,1,24,22,2,4]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var R;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(R=e.WorkbenchState||(e.WorkbenchState={}));function E(c){const h=c;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=E;function S(c){const h=c;return!!(h&&typeof h=="object"&&k.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=S;class A{constructor(h,d,g,y){this._id=h,this._configuration=g,this._ignorePathCasing=y,this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=A;class n{constructor(h,d){this.raw=d,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,L.joinPath)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function P(c){return new n({uri:c,index:0,name:(0,L.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=P}),define(me[199],ge([0,1,29,59,138,79,10,8,11,22,2,163,4,86,43]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function y(U){return(typeof U=="string"?(0,E.extname)(U):(0,A.extname)(U))===g}e.hasWorkspaceFileExtension=y,e.IWorkspacesService=(0,c.createDecorator)("workspacesService");function I(U){return U.hasOwnProperty("workspace")}e.isRecentWorkspace=I;function _(U){return U.hasOwnProperty("folderUri")}e.isRecentFolder=_;function s(U){return U.hasOwnProperty("fileUri")}e.isRecentFile=s;function o(U){const z=U;return typeof z?.id=="string"&&n.URI.isUri(z.uri)}e.isSingleFolderWorkspaceIdentifier=o;function p(U){if(U.configuration)return{id:U.id,configPath:U.configuration};if(U.folders.length===1)return{id:U.id,uri:U.folders[0].uri}}e.toWorkspaceIdentifier=p;function t(U){const z=U;return typeof z?.id=="string"&&n.URI.isUri(z.configPath)}e.isWorkspaceIdentifier=t;function a(U){const z=U;if(z?.uri)return{id:z.id,uri:n.URI.revive(z.uri)};const N=U;if(N?.configPath)return{id:N.id,configPath:n.URI.revive(N.configPath)};if(U?.id)return{id:U.id}}e.reviveIdentifier=a;function r(U,z){return A.extUriBiasedIgnorePathCase.isEqualOrParent(U,z.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function i(U){return l(U)||u(U)}e.isStoredWorkspaceFolder=i;function l(U){const z=U;return typeof z?.path=="string"&&(!z.name||typeof z.name=="string")}e.isRawFileWorkspaceFolder=l;function u(U){const z=U;return typeof z?.uri=="string"&&(!z.name||typeof z.name=="string")}e.isRawUriWorkspaceFolder=u;function f(U,z,N,x,B=!S.isWindows,O){if(U.scheme!==x.scheme)return{name:N,uri:U.toString(!0)};let H=z?void 0:O.relativePath(x,U);if(H!==void 0)H.length===0?H=".":S.isWindows&&U.scheme===R.Schemas.file&&!B&&(H=H.replace(/\//g,"\\"));else if(U.scheme===R.Schemas.file)H=U.fsPath,S.isWindows&&(H=(0,C.normalizeDriveLetter)(H),B&&(H=(0,m.toSlashes)(H)));else{if(!O.isEqualAuthority(U.authority,x.authority))return{name:N,uri:U.toString(!0)};H=U.path}return{name:N,path:H}}e.getStoredWorkspaceFolder=f;function b(U,z,N){let x=[],B=new Set;const O=N.dirname(z);for(let H of U){let W;if(l(H))H.path&&(W=N.resolvePath(O,H.path));else if(u(H))try{W=n.URI.parse(H.uri),W.path[0]!=="/"&&(W=W.with({path:"/"+W.path}))}catch(Q){console.warn(Q)}if(W){let Q=N.getComparisonKey(W);if(!B.has(Q)){B.add(Q);const Y=H.name||N.basenameOrAuthority(W);x.push(new d.WorkspaceFolder({uri:W,name:Y,index:x.length},H))}}}return x}e.toWorkspaceFolders=b;function D(U,z,N,x,B){let O=w(z,U);const H=B.dirname(z),W=B.dirname(x),Q=[],Y=T(O.folders);for(const Re of O.folders){const xe=l(Re)?B.resolvePath(H,Re.path):n.URI.parse(Re.uri);let Ue;N?Ue=!1:Ue=!l(Re)||(0,E.isAbsolute)(Re.path),Q.push(f(xe,Ue,Re.name,W,Y,B))}const he={insertSpaces:!1,tabSize:4,eol:S.isLinux||S.isMacintosh?`
`:`\r
`},_e=k.setProperty(U,["folders"],Q,he);let Se=k.applyEdits(U,_e);return O.remoteAuthority===(0,h.getRemoteAuthority)(x)&&(Se=k.applyEdits(Se,k.removeProperty(Se,["remoteAuthority"],he))),Se}e.rewriteWorkspaceFileForNewLocation=D;function w(U,z){let N=L.parse(z);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(x=>i(x));else throw new Error(`${U} looks like an invalid workspace file.`);return N}function T(U){return S.isWindows?U.some(z=>l(z)&&z.path.indexOf("/")>=0):!0}e.useSlashForPath=T;function v(U){return U.workspace&&typeof U.workspace=="object"&&typeof U.workspace.id=="string"&&typeof U.workspace.configPath=="string"}function F(U){return typeof U.folderUri=="string"}function M(U){return typeof U.fileUri=="string"}function G(U,z){const N={workspaces:[],files:[]};if(U){const x=function(O,H){for(let W=0;W<O.length;W++)try{H(O[W],W)}catch(Q){z.warn(`Error restoring recent entry ${JSON.stringify(O[W])}: ${Q.toString()}. Skip entry.`)}},B=U;if(Array.isArray(B.entries))x(B.entries,O=>{const H=O.label,W=O.remoteAuthority;v(O)?N.workspaces.push({label:H,remoteAuthority:W,workspace:{id:O.workspace.id,configPath:n.URI.parse(O.workspace.configPath)}}):F(O)?N.workspaces.push({label:H,remoteAuthority:W,folderUri:n.URI.parse(O.folderUri)}):M(O)&&N.files.push({label:H,remoteAuthority:W,fileUri:n.URI.parse(O.fileUri)})});else{const O=U;Array.isArray(O.workspaces3)&&x(O.workspaces3,(H,W)=>{const Q=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[W]||void 0;typeof H=="object"&&typeof H.id=="string"&&typeof H.configURIPath=="string"?N.workspaces.push({label:Q,workspace:{id:H.id,configPath:n.URI.parse(H.configURIPath)}}):typeof H=="string"&&N.workspaces.push({label:Q,folderUri:n.URI.parse(H)})}),Array.isArray(O.files2)&&x(O.files2,(H,W)=>{const Q=Array.isArray(O.fileLabels)&&O.fileLabels[W]||void 0;typeof H=="string"&&N.files.push({label:Q,fileUri:n.URI.parse(H)})})}}return N}e.restoreRecentlyOpened=G;function K(U){const z={entries:[]};for(const N of U.workspaces)_(N)?z.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):z.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of U.files)z.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return z}e.toStoreData=K}),define(me[87],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class m{constructor(k){this.id=k,this._data=new Map,this._idPool=1}add(k){const C=this._idPool++;return this._data.set(C,k),this.logDebugInfo(),C}get(k,C){return this._data.has(k)?this._data.get(k)[C]:void 0}delete(k){this._data.delete(k),this.logDebugInfo()}logDebugInfo(){!m.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=m,m.enableDebugLogging=!1}),define(me[52],ge([0,1,10,22,4]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(m.Schemas)),this._providerInfo=new Map,this.extUri=new L.ExtUri(E=>{const S=this._providerInfo.get(E.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(E,S){S===null?this._providerInfo.delete(E):this._providerInfo.set(E,S)}isFreeScheme(E){return!this._providerInfo.has(E)&&!this._systemSchemes.has(E)}getCapabilities(E){return this._providerInfo.get(E)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(me[27],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,m.createDecorator)("IExtHostInitDataService")}),define(me[200],ge([0,1,18]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(R,E,S){this._deferredPromises=new Map,this._id=R,this._shared=E,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(A=>(this._value=A,this)),this._storageListener=this._storage.onDidChangeStorage(A=>{A.shared===this._shared&&A.key===this._id&&(this._value=A.value)}),this._scheduler=new m.RunOnceScheduler(()=>{const A=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of A.values())n.complete()}catch(n){for(const P of A.values())P.error(n)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this._init}get(R,E){let S=this._value[R];return typeof S=="undefined"&&(S=E),S}update(R,E){this._value[R]=E;let S=this._deferredPromises.get(R);if(S!==void 0)return S.p;const A=new m.DeferredPromise;return this._deferredPromises.set(R,A),this._scheduler.isScheduled()||this._scheduler.schedule(),A.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class k extends L{constructor(R,E){super(R.identifier.value,!0,E);this._extension=R}setKeysForSync(R){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},R)}}e.ExtensionGlobalMemento=k}),define(me[201],ge([0,1,3,2,12]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let C=class{constructor(E,S){this._logService=E,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new m.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new m.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(E,S,A){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(E)).acceptModelChanged(S.value,A)}$acceptDirtyStateChanged(E,S){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(E)).acceptDirty(S)}$acceptModelSaved(E){const S=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(E));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(E,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",E.path,S);const A=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(E));A.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:A.apiNotebook})}};C=Ve([$e(0,k.ILogService)],C),e.ExtHostNotebookDocuments=C}),define(me[14],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,m.createDecorator)("IExtHostRpcService");class L{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=L});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,m):k?k.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[202],ge([0,1,26,3]),function(J,e,m,L){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class C{constructor(E,S){k.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=m.ExtensionIdentifier.toKey(E.identifier),nt(this,k,S,"f"),Oe(this,k,"f").onDidChangePassword(A=>{A.extensionId===this._id&&this._onDidChange.fire({key:A.key})})}get(E){return Oe(this,k,"f").get(this._id,E)}store(E,S){return Oe(this,k,"f").store(this._id,E,S)}delete(E){return Oe(this,k,"f").delete(this._id,E)}}e.ExtensionSecrets=C,k=new WeakMap}),define(me[122],ge([0,1,4,3]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class k{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(R){this._enabled=R}$onDidChangeTelemetryEnabled(R){this._enabled=R,this._onDidChangeTelemetryEnabled.fire(R)}}e.ExtHostTelemetry=k,e.IExtHostTelemetry=(0,m.createDecorator)("IExtHostTelemetry")}),define(me[64],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var m;(function(_){_[_.Upsert=0]="Upsert",_[_.RemoveChild=1]="RemoveChild",_[_.Invalidated=2]="Invalidated",_[_.SetProp=3]="SetProp",_[_.Bulk=4]="Bulk"})(m=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,k=(_,s)=>{const o={controllerId:s};return L.set(_,o),o};e.createPrivateApiFor=k;const C=_=>L.get(_);e.getPrivateApiFor=C;const R=(_,s,o,p)=>{let t=o;return{enumerable:!0,configurable:!1,get(){return t},set(a){if(!p(t,a)){const r=t;t=a,_.listener?.({op:3,key:s,value:a,previous:r})}}}},E=(_,s)=>_===s,S={range:(_,s)=>_===s?!0:!_||!s?!1:_.isEqual(s),label:E,description:E,busy:E,error:E,canResolveChildren:E,tags:(_,s)=>!(_.length!==s.length||_.some(o=>!s.find(p=>o.id===p.id)))},A=Object.keys(S),n=(_,s)=>({range:R(_,"range",void 0,S.range),label:R(_,"label",s,S.label),description:R(_,"description",void 0,S.description),canResolveChildren:R(_,"canResolveChildren",!1,S.canResolveChildren),busy:R(_,"busy",!1,S.busy),error:R(_,"error",void 0,S.error),tags:R(_,"tags",[],S.tags)}),P=(_,s)=>{const o=new Map;for(const p of A)S[p](_[p],s[p])||o.set(p,s[p]);return o};e.diffTestItems=P;class c extends Error{constructor(s){super(`Attempted to insert a duplicate test item ID ${s}`)}}e.DuplicateTestItemError=c;class h extends Error{constructor(s){super(`TestItem with ID "${s}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=h;class d extends Error{constructor(s,o,p){super(`TestItem with ID "${s}" is from controller "${o}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=d;const g=_=>{const s=(0,e.getPrivateApiFor)(_);let o=new Map;return{get size(){return o.size},forEach(p,t){for(const a of o.values())p.call(t,a,this)},replace(p){const t=new Map,a=new Set(o.keys()),r={op:4,ops:[]};for(const i of p){if(!(i instanceof y))throw new h(i.id);const l=(0,e.getPrivateApiFor)(i).controllerId;if(l!==s.controllerId)throw new d(i.id,l,s.controllerId);if(t.has(i.id))throw new c(i.id);t.set(i.id,i),a.delete(i.id),r.ops.push({op:0,item:i})}for(const i of a.keys())r.ops.push({op:1,id:i});s.listener?.(r),o=t},add(p){if(!(p instanceof y))throw new h(p.id);o.set(p.id,p),s.listener?.({op:0,item:p})},delete(p){o.delete(p)&&s.listener?.({op:1,id:p})},get(p){return o.get(p)},toJSON(){return Array.from(o.values())},[Symbol.iterator](){return o.values()}}};class y{constructor(s,o,p,t){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const a=(0,e.createPrivateApiFor)(this,s);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof I?void 0:a.parent}},children:{value:g(this),enumerable:!0,writable:!1},...n(a,p)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=y;class I extends y{constructor(s,o){super(s,s,o,void 0)}}e.TestItemRootImpl=I}),define(me[53],ge([0,1,4,3,14]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var C;(function(E){function S(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,protocol:n.protocol}}E.fromApiTunnel=S;function A(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public,protocol:n.protocol}}E.fromServiceTunnel=A})(C=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,m.createDecorator)("IExtHostTunnelService");let R=class{constructor(S){this.onDidChangeTunnels=new L.Emitter().event}async $applyCandidateFilter(S){return S}async openTunnel(S,A){}async getTunnels(){return[]}async setTunnelExtensionFunctions(S){return{dispose:()=>{}}}registerPortsAttributesProvider(S,A){return{dispose:()=>{}}}async $providePortAttributes(S,A,n,P,c){return[]}async $forwardPort(S,A){}async $closeTunnel(S){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=Ve([$e(0,k.IExtHostRpcService)],R),e.ExtHostTunnelService=R});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,m):k?k.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[7],ge([0,1,17,16,99,24,102,13,2,32,42,121]),function(J,e,m,L,k,C,R,E,S,A,n,P){"use strict";var c,h,d,g,y,I,_,s,o,p,t,a,r,i,l,u,f,b,D,w;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function T(j){function $(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty($,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf($,j),Object.setPrototypeOf($.prototype,j.prototype),$}let v=y=class{constructor($){c.set(this,void 0),nt(this,c,$,"f")}static from(...$){let se=$;return new y(function(){if(se){for(const De of se)De&&typeof De.dispose=="function"&&De.dispose();se=void 0}})}dispose(){typeof Oe(this,c,"f")=="function"&&(Oe(this,c,"f").call(this),nt(this,c,void 0,"f"))}};c=new WeakMap,v=y=Ve([T],v),e.Disposable=v;let F=I=class{constructor($,se){if($<0)throw(0,L.illegalArgument)("line must be non-negative");if(se<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=$,this._character=se}static Min(...$){if($.length===0)throw new TypeError;let se=$[0];for(let De=1;De<$.length;De++){const et=$[De];et.isBefore(se)&&(se=et)}return se}static Max(...$){if($.length===0)throw new TypeError;let se=$[0];for(let De=1;De<$.length;De++){const et=$[De];et.isAfter(se)&&(se=et)}return se}static isPosition($){if(!$)return!1;if($ instanceof I)return!0;let{line:se,character:De}=$;return typeof se=="number"&&typeof De=="number"}get line(){return this._line}get character(){return this._character}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,se=0){if($===null||se===null)throw(0,L.illegalArgument)();let De;return typeof $=="undefined"?De=0:typeof $=="number"?De=$:(De=typeof $.lineDelta=="number"?$.lineDelta:0,se=typeof $.characterDelta=="number"?$.characterDelta:0),De===0&&se===0?this:new I(this.line+De,this.character+se)}with($,se=this.character){if($===null||se===null)throw(0,L.illegalArgument)();let De;return typeof $=="undefined"?De=this.line:typeof $=="number"?De=$:(De=typeof $.line=="number"?$.line:this.line,se=typeof $.character=="number"?$.character:this.character),De===this.line&&se===this.character?this:new I(De,se)}toJSON(){return{line:this.line,character:this.character}}};F=I=Ve([T],F),e.Position=F;let M=_=class{constructor($,se,De,et){let rt,ht;if(typeof $=="number"&&typeof se=="number"&&typeof De=="number"&&typeof et=="number"?(rt=new F($,se),ht=new F(De,et)):$ instanceof F&&se instanceof F&&(rt=$,ht=se),!rt||!ht)throw new Error("Invalid arguments");rt.isBefore(ht)?(this._start=rt,this._end=ht):(this._start=ht,this._end=rt)}static isRange($){return $ instanceof _?!0:$?F.isPosition($.start)&&F.isPosition($.end):!1}get start(){return this._start}get end(){return this._end}contains($){return $ instanceof _?this.contains($._start)&&this.contains($._end):$ instanceof F?!($.isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const se=F.Max($.start,this._start),De=F.Min($.end,this._end);if(!se.isAfter(De))return new _(se,De)}union($){if(this.contains($))return this;if($.contains(this))return $;const se=F.Min($.start,this._start),De=F.Max($.end,this.end);return new _(se,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,se=this.end){if($===null||se===null)throw(0,L.illegalArgument)();let De;return $?F.isPosition($)?De=$:(De=$.start||this.start,se=$.end||this.end):De=this.start,De.isEqual(this._start)&&se.isEqual(this.end)?this:new _(De,se)}toJSON(){return[this.start,this.end]}};M=_=Ve([T],M),e.Range=M;let G=s=class extends M{constructor($,se,De,et){let rt,ht;if(typeof $=="number"&&typeof se=="number"&&typeof De=="number"&&typeof et=="number"?(rt=new F($,se),ht=new F(De,et)):$ instanceof F&&se instanceof F&&(rt=$,ht=se),!rt||!ht)throw new Error("Invalid arguments");super(rt,ht);this._anchor=rt,this._active=ht}static isSelection($){return $ instanceof s?!0:$?M.isRange($)&&F.isPosition($.anchor)&&F.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};G=s=Ve([T],G),e.Selection=G;class K{constructor($,se,De){if(typeof $!="string"||$.length===0)throw(0,L.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,L.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,L.illegalArgument)("connectionToken");this.host=$,this.port=Math.round(se),this.connectionToken=De}}e.ResolvedAuthority=K;class U extends Error{constructor($,se=P.RemoteAuthorityResolverErrorCode.Unknown,De){super($);this._message=$,this._code=se,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,U.prototype)}static NotAvailable($,se){return new U($,P.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable($){return new U($,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=U;var z;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(z=e.EndOfLine||(e.EndOfLine={}));var N;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(N=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let x=o=class{constructor($,se){this._range=$,this._newText=se}static isTextEdit($){return $ instanceof o?!0:$?M.isRange($)&&typeof $.newText=="string":!1}static replace($,se){return new o($,se)}static insert($,se){return o.replace(new M($,$),se)}static delete($){return o.replace($,"")}static setEndOfLine($){const se=new o(new M(new F(0,0),new F(0,0)),"");return se.newEol=$,se}get range(){return this._range}set range($){if($&&!M.isRange($))throw(0,L.illegalArgument)("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw(0,L.illegalArgument)("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw(0,L.illegalArgument)("newEol");this._newEol=$}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};x=o=Ve([T],x),e.TextEdit=x;var B;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace"})(B=e.FileEditType||(e.FileEditType={}));let O=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,se,De,et){this._edits.push({_type:1,from:$,to:se,options:De,metadata:et})}createFile($,se,De){this._edits.push({_type:1,from:void 0,to:$,options:se,metadata:De})}deleteFile($,se,De){this._edits.push({_type:1,from:$,to:void 0,options:se,metadata:De})}replaceNotebookMetadata($,se,De){this._edits.push({_type:3,metadata:De,uri:$,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells($,se,De,et,rt){let ht,mt,Ct=[],At;if(Vt.isNotebookRange(se)&&Ft.isNotebookCellDataArray(De)&&!Ft.isNotebookCellDataArray(et)?(ht=se.start,mt=se.end,Ct=De,At=et):typeof se=="number"&&typeof De=="number"&&Ft.isNotebookCellDataArray(et)&&(ht=se,mt=De,Ct=et,At=rt),ht===void 0||mt===void 0)throw new Error("Invalid arguments");(ht!==mt||Ct.length>0)&&this._edits.push({_type:5,uri:$,index:ht,count:mt-ht,cells:Ct,metadata:At})}replaceNotebookCellMetadata($,se,De,et){this._edits.push({_type:3,metadata:et,uri:$,edit:{editType:8,index:se,metadata:De}})}replace($,se,De,et){this._edits.push({_type:2,uri:$,edit:new x(se,De),metadata:et})}insert($,se,De,et){this.replace($,new M(se,se),De,et)}delete($,se,De){this.replace($,se,"",De)}has($){return this._edits.some(se=>se._type===2&&se.uri.toString()===$.toString())}set($,se){if(se)for(const De of se)De&&this._edits.push({_type:2,uri:$,edit:De});else{for(let De=0;De<this._edits.length;De++){const et=this._edits[De];et._type===2&&et.uri.toString()===$.toString()&&(this._edits[De]=void 0)}(0,m.coalesceInPlace)(this._edits)}}get($){const se=[];for(let De of this._edits)De._type===2&&De.uri.toString()===$.toString()&&se.push(De.edit);return se}entries(){const $=new C.ResourceMap;for(let se of this._edits)if(se._type===2){let De=$.get(se.uri);De||(De=[se.uri,[]],$.set(se.uri,De)),De[1].push(se.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};O=Ve([T],O),e.WorkspaceEdit=O;let H=p=class{constructor($){this._tabstop=1,this.value=$||""}static isSnippetString($){return $ instanceof p?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}appendText($){return this.value+=p._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,se=this._tabstop++){if(typeof $=="function"){const De=new p;De._tabstop=this._tabstop,$(De),this._tabstop=De._tabstop,$=De.value}else $=p._escape($);return this.value+="${",this.value+=se,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,se=this._tabstop++){const De=$.map(et=>et.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable($,se){if(typeof se=="function"){const De=new p;De._tabstop=this._tabstop,se(De),this._tabstop=De._tabstop,se=De.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,se&&(this.value+=":",this.value+=se),this.value+="}",this}};H=p=Ve([T],H),e.SnippetString=H;var W;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(W=e.DiagnosticTag||(e.DiagnosticTag={}));var Q;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(Q=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Y=t=class{constructor($,se){if(this.uri=$,se)if(se instanceof M)this.range=se;else if(se instanceof F)this.range=new M(se,se);else throw new Error("Illegal argument")}static isLocation($){return $ instanceof t?!0:$?M.isRange($.range)&&S.URI.isUri($.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Y=t=Ve([T],Y),e.Location=Y;let he=class{constructor($,se){this.location=$,this.message=se}static is($){return $?typeof $.message=="string"&&$.location&&M.isRange($.location.range)&&S.URI.isUri($.location.uri):!1}static isEqual($,se){return $===se?!0:!$||!se?!1:$.message===se.message&&$.location.range.isEqual(se.location.range)&&$.location.uri.toString()===se.location.uri.toString()}};he=Ve([T],he),e.DiagnosticRelatedInformation=he;let _e=class{constructor($,se,De=Q.Error){if(!M.isRange($))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=$,this.message=se,this.severity=De}toJSON(){return{severity:Q[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,se){return $===se?!0:!$||!se?!1:$.message===se.message&&$.severity===se.severity&&$.code===se.code&&$.severity===se.severity&&$.source===se.source&&$.range.isEqual(se.range)&&(0,m.equals)($.tags,se.tags)&&(0,m.equals)($.relatedInformation,se.relatedInformation,he.isEqual)}};_e=Ve([T],_e),e.Diagnostic=_e;let Se=class{constructor($,se){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:this.contents=[$],this.range=se}};Se=Ve([T],Se),e.Hover=Se;var Re;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(Re=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let xe=class{constructor($,se=Re.Text){this.range=$,this.kind=se}toJSON(){return{range:this.range,kind:Re[this.kind]}}};xe=Ve([T],xe),e.DocumentHighlight=xe;var Ue;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Ue=e.SymbolKind||(e.SymbolKind={}));var je;(function(j){j[j.Deprecated=1]="Deprecated"})(je=e.SymbolTag||(e.SymbolTag={}));let V=a=class{constructor($,se,De,et,rt){this.name=$,this.kind=se,this.containerName=rt,typeof De=="string"&&(this.containerName=De),et instanceof Y?this.location=et:De instanceof M&&(this.location=new Y(et,De)),a.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ue[this.kind],location:this.location,containerName:this.containerName}}};V=a=Ve([T],V),e.SymbolInformation=V;let ee=r=class{constructor($,se,De,et,rt){this.name=$,this.detail=se,this.kind=De,this.range=et,this.selectionRange=rt,this.children=[],r.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children&&$.children.forEach(r.validate)}};ee=r=Ve([T],ee),e.DocumentSymbol=ee;var re;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(re=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor($,se){this.title=$,this.kind=se}};le=Ve([T],le),e.CodeAction=le;let Z=i=class{constructor($){this.value=$}append($){return new i(this.value?this.value+i.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+i.sep)}};Z.sep=".",Z=i=Ve([T],Z),e.CodeActionKind=Z,Z.Empty=new Z(""),Z.QuickFix=Z.Empty.append("quickfix"),Z.Refactor=Z.Empty.append("refactor"),Z.RefactorExtract=Z.Refactor.append("extract"),Z.RefactorInline=Z.Refactor.append("inline"),Z.RefactorRewrite=Z.Refactor.append("rewrite"),Z.Source=Z.Empty.append("source"),Z.SourceOrganizeImports=Z.Source.append("organizeImports"),Z.SourceFixAll=Z.Source.append("fixAll");let oe=class{constructor($,se){if(this.range=$,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};oe=Ve([T],oe),e.SelectionRange=oe;class ve{constructor($,se,De,et,rt,ht){this.kind=$,this.name=se,this.detail=De,this.uri=et,this.range=rt,this.selectionRange=ht}}e.CallHierarchyItem=ve;class Me{constructor($,se){this.fromRanges=se,this.from=$}}e.CallHierarchyIncomingCall=Me;class qe{constructor($,se){this.fromRanges=se,this.to=$}}e.CallHierarchyOutgoingCall=qe;var Qe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Je=class{constructor($,se){this.range=$,this.command=se}get isResolved(){return!!this.command}};Je=Ve([T],Je),e.CodeLens=Je;let Ce=l=class{constructor($,se=!1){h.set(this,void 0),nt(this,h,new k.MarkdownString($,{supportThemeIcons:se}),"f")}static isMarkdownString($){return $ instanceof l?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}get value(){return Oe(this,h,"f").value}set value($){Oe(this,h,"f").value=$}get isTrusted(){return Oe(this,h,"f").isTrusted}set isTrusted($){Oe(this,h,"f").isTrusted=$}get supportThemeIcons(){return Oe(this,h,"f").supportThemeIcons}set supportThemeIcons($){Oe(this,h,"f").supportThemeIcons=$}get supportHtml(){return Oe(this,h,"f").supportHtml}set supportHtml($){Oe(this,h,"f").supportHtml=$}appendText($){return Oe(this,h,"f").appendText($),this}appendMarkdown($){return Oe(this,h,"f").appendMarkdown($),this}appendCodeblock($,se){return Oe(this,h,"f").appendCodeblock(se??"",$),this}};h=new WeakMap,Ce=l=Ve([T],Ce),e.MarkdownString=Ce;let at=class{constructor($,se){this.label=$,this.documentation=se}};at=Ve([T],at),e.ParameterInformation=at;let X=class{constructor($,se){this.label=$,this.documentation=se,this.parameters=[]}};X=Ve([T],X),e.SignatureInformation=X;let te=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};te=Ve([T],te),e.SignatureHelp=te;var pe;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(pe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ze;(function(j){j[j.Other=0]="Other",j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(ze=e.InlayHintKind||(e.InlayHintKind={}));let tt=class{constructor($,se,De){this.text=$,this.position=se,this.kind=De}};tt=Ve([T],tt),e.InlayHint=tt;var ut;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ut=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var lt;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(lt=e.CompletionItemKind||(e.CompletionItemKind={}));var vt;(function(j){j[j.Deprecated=1]="Deprecated"})(vt=e.CompletionItemTag||(e.CompletionItemTag={}));let Dt=class{constructor($,se){this.label=$,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&lt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Dt=Ve([T],Dt),e.CompletionItem=Dt;let ue=class{constructor($=[],se=!1){this.items=$,this.isIncomplete=se}};ue=Ve([T],ue),e.CompletionList=ue;let Ie=class{constructor($,se,De){this.text=$,this.range=se,this.command=De}};Ie=Ve([T],Ie),e.InlineSuggestion=Ie;let Be=class{constructor($){this.items=$}};Be=Ve([T],Be),e.InlineSuggestions=Be;var Ke;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(Ke=e.ViewColumn||(e.ViewColumn={}));var We;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(We=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ot;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(ot=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Le;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Le=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ye;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(ye=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ke;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(ke=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ne;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(ne=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var de;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(de=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function $(se){switch(se){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=$}(ke=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let be=class{constructor($,se){if(se&&!S.URI.isUri(se))throw(0,L.illegalArgument)("target");if(!M.isRange($)||$.isEmpty)throw(0,L.illegalArgument)("range");this.range=$,this.target=se}};be=Ve([T],be),e.DocumentLink=be;let we=class{constructor($,se,De,et){this.red=$,this.green=se,this.blue=De,this.alpha=et}};we=Ve([T],we),e.Color=we;let Fe=class{constructor($,se){if(se&&!(se instanceof we))throw(0,L.illegalArgument)("color");if(!M.isRange($)||$.isEmpty)throw(0,L.illegalArgument)("range");this.range=$,this.color=se}};Fe=Ve([T],Fe),e.ColorInformation=Fe;let Ge=class{constructor($){if(!$||typeof $!="string")throw(0,L.illegalArgument)("label");this.label=$}};Ge=Ve([T],Ge),e.ColorPresentation=Ge;var He;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(He=e.ColorFormat||(e.ColorFormat={}));var Ye;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Ye=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class it{constructor($,se,De){if(this.startIndex=$,this.length=se,this.tooltip=De,typeof $!="number"||$<0)throw(0,L.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,L.illegalArgument)("length");if(De!==void 0&&typeof De!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=it;var ae;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(ae=e.TerminalLocation||(e.TerminalLocation={}));class Ee{constructor($){this.options=$,typeof $!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=Ee;var ce;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(ce=e.TaskRevealKind||(e.TaskRevealKind={}));var q;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(q=e.TaskPanelKind||(e.TaskPanelKind={}));let Te=u=class{constructor($,se){if(this.label=se,typeof $!="string"||typeof se!="string")throw(0,L.illegalArgument)("name");this._id=$}static from($){switch($){case"clean":return u.Clean;case"build":return u.Build;case"rebuild":return u.Rebuild;case"test":return u.Test;default:return}}get id(){return this._id}};Te.Clean=new u("clean","Clean"),Te.Build=new u("build","Build"),Te.Rebuild=new u("rebuild","Rebuild"),Te.Test=new u("test","Test"),Te=u=Ve([T],Te),e.TaskGroup=Te;function Pe(j){let $="";for(let se=0;se<j.length;se++)$+=j[se].replace(/,/g,",,")+",";return $}let Ze=class{constructor($,se,De){if(typeof $!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=$,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=De):this._options=se)}get process(){return this._process}set process($){if(typeof $!="string")throw(0,L.illegalArgument)("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(let se of this._args)$.push(se);return Pe($)}};Ze=Ve([T],Ze),e.ProcessExecution=Ze;let Xe=class{constructor($,se,De){if(this._args=[],Array.isArray(se)){if(!$)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw(0,L.illegalArgument)("command");this._command=$,this._args=se,this._options=De}else{if(typeof $!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=$,this._options=se}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw(0,L.illegalArgument)("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)$.push(typeof se=="string"?se:se.value);return Pe($)}};Xe=Ve([T],Xe),e.ShellExecution=Xe;var st;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(st=e.ShellQuoting||(e.ShellQuoting={}));var wt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(wt=e.TaskScope||(e.TaskScope={}));class _t{constructor($){this._callback=$}computeId(){return"customExecution"+(0,A.generateUuid)()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=_t;let dt=f=class{constructor($,se,De,et,rt,ht){this.__deprecated=!1,this._definition=this.definition=$;let mt;typeof se=="string"?(this._name=this.name=se,this._source=this.source=De,this.execution=et,mt=rt,this.__deprecated=!0):se===wt.Global||se===wt.Workspace?(this.target=se,this._name=this.name=De,this._source=this.source=et,this.execution=rt,mt=ht):(this.target=se,this._name=this.name=De,this._source=this.source=et,this.execution=rt,mt=ht),typeof mt=="string"?(this._problemMatchers=[mt],this._hasDefinedMatchers=!0):Array.isArray(mt)?(this._problemMatchers=mt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ze?this._definition={type:f.ProcessType,id:this._execution.computeId()}:this._execution instanceof Xe?this._definition={type:f.ShellType,id:this._execution.computeId()}:this._execution instanceof _t?this._definition={type:f.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:f.EmptyType,id:(0,A.generateUuid)()}}get definition(){return this._definition}set definition($){if($==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const se=this._definition.type;(f.EmptyType===se||f.ProcessType===se||f.ShellType===se||f.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};dt.ExtensionCallbackType="customExecution",dt.ProcessType="process",dt.ShellType="shell",dt.EmptyType="$empty",dt=f=Ve([T],dt),e.Task=dt;var gt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(gt=e.ProgressLocation||(e.ProgressLocation={}));let ft=class{constructor($,se=Tt.None){this.collapsibleState=se,S.URI.isUri($)?this.resourceUri=$:this.label=$}};ft=Ve([T],ft),e.TreeItem=ft;var Tt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Tt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let yt=class{constructor($,se){this.id=$,this.color=se}};yt=Ve([T],yt),e.ThemeIcon=yt,yt.File=new yt("file"),yt.Folder=new yt("folder");let Bt=class{constructor($){this.id=$}};Bt=Ve([T],Bt),e.ThemeColor=Bt;var $t;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})($t=e.ConfigurationTarget||(e.ConfigurationTarget={}));let It=class{constructor($,se){if(typeof $!="string"&&(!$||!S.URI.isUri($)&&!S.URI.isUri($.uri)))throw(0,L.illegalArgument)("base");if(typeof se!="string")throw(0,L.illegalArgument)("pattern");typeof $=="string"?(this.baseFolder=S.URI.file($),this.base=$):S.URI.isUri($)?(this.baseFolder=$,this.base=$.fsPath):(this.baseFolder=$.uri,this.base=$.uri.fsPath),this.pattern=se}};It=Ve([T],It),e.RelativePattern=It;let Wt=class{constructor($,se,De,et){this.enabled=typeof $=="boolean"?$:!0,typeof se=="string"&&(this.condition=se),typeof De=="string"&&(this.hitCondition=De),typeof et=="string"&&(this.logMessage=et)}get id(){return this._id||(this._id=(0,A.generateUuid)()),this._id}};Wt=Ve([T],Wt),e.Breakpoint=Wt;let en=class extends Wt{constructor($,se,De,et,rt){super(se,De,et,rt);if($===null)throw(0,L.illegalArgument)("location");this.location=$}};en=Ve([T],en),e.SourceBreakpoint=en;let bt=class extends Wt{constructor($,se,De,et,rt){super(se,De,et,rt);this.functionName=$}};bt=Ve([T],bt),e.FunctionBreakpoint=bt;let Qt=class extends Wt{constructor($,se,De,et,rt,ht,mt){super(et,rt,ht,mt);if(!se)throw(0,L.illegalArgument)("dataId");this.label=$,this.dataId=se,this.canPersist=De}};Qt=Ve([T],Qt),e.DataBreakpoint=Qt;let jt=class{constructor($,se,De){this.command=$,this.args=se||[],this.options=De}};jt=Ve([T],jt),e.DebugAdapterExecutable=jt;let tn=class{constructor($,se){this.port=$,this.host=se}};tn=Ve([T],tn),e.DebugAdapterServer=tn;let nn=class{constructor($){this.path=$}};nn=Ve([T],nn),e.DebugAdapterNamedPipeServer=nn;let Pt=class{constructor($){this.implementation=$}};Pt=Ve([T],Pt),e.DebugAdapterInlineImplementation=Pt;let Xt=class{constructor($,se){this.range=$,this.expression=se}};Xt=Ve([T],Xt),e.EvaluatableExpression=Xt;var bn;(function(j){j[j.Automatic=0]="Automatic",j[j.Explicit=1]="Explicit"})(bn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Ht=class{constructor($,se){this.range=$,this.text=se}};Ht=Ve([T],Ht),e.InlineValueText=Ht;let zt=class{constructor($,se,De=!0){this.range=$,this.variableName=se,this.caseSensitiveLookup=De}};zt=Ve([T],zt),e.InlineValueVariableLookup=zt;let pt=class{constructor($,se){this.range=$,this.expression=se}};pt=Ve([T],pt),e.InlineValueEvaluatableExpression=pt;let rn=class{constructor($,se){this.frameId=$,this.stoppedLocation=se}};rn=Ve([T],rn),e.InlineValueContext=rn;var Ot;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Ot=e.FileChangeType||(e.FileChangeType={}));let Nt=b=class extends Error{constructor($,se=n.FileSystemProviderErrorCode.Unknown,De){super(S.URI.isUri($)?$.toString(!0):$);this.code=De?.name??"Unknown",(0,n.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists($){return new b($,n.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound($){return new b($,n.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory($){return new b($,n.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory($){return new b($,n.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions($){return new b($,n.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable($){return new b($,n.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}};Nt=b=Ve([T],Nt),e.FileSystemError=Nt;let Yt=class{constructor($,se,De){this.start=$,this.end=se,this.kind=De}};Yt=Ve([T],Yt),e.FoldingRange=Yt;var En;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(En=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fn;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(fn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _n;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(_n=e.CommentMode||(e.CommentMode={}));class mn{constructor($,se=[]){this.tokenTypes=$,this.tokenModifiers=se}}e.SemanticTokensLegend=mn;function sn(j){return typeof j=="undefined"||(0,E.isStringArray)(j)}class on{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let se=0,De=$.tokenTypes.length;se<De;se++)this._tokenTypeStrToInt.set($.tokenTypes[se],se);for(let se=0,De=$.tokenModifiers.length;se<De;se++)this._tokenModifierStrToInt.set($.tokenModifiers[se],se)}}push($,se,De,et,rt){if(typeof $=="number"&&typeof se=="number"&&typeof De=="number"&&typeof et=="number"&&(typeof rt=="number"||typeof rt=="undefined"))return typeof rt=="undefined"&&(rt=0),this._pushEncoded($,se,De,et,rt);if(M.isRange($)&&typeof se=="string"&&sn(De))return this._push($,se,De);throw(0,L.illegalArgument)()}_push($,se,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const et=$.start.line,rt=$.start.character,ht=$.end.character-$.start.character,mt=this._tokenTypeStrToInt.get(se);let Ct=0;if(De)for(const At of De){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Lt=this._tokenModifierStrToInt.get(At);Ct|=1<<Lt>>>0}this._pushEncoded(et,rt,ht,mt,Ct)}_pushEncoded($,se,De,et,rt){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ct=this._data.length/5|0;let At=0,Lt=0;for(let Mt=0;Mt<Ct;Mt++){let Ut=this._data[5*Mt],dn=this._data[5*Mt+1];Ut===0?(Ut=At,dn+=Lt):Ut+=At,this._data[5*Mt]=Ut,this._data[5*Mt+1]=dn,At=Ut,Lt=dn}}let ht=$,mt=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ht-=this._prevLine,ht===0&&(mt-=this._prevChar)),this._data[this._dataLen++]=ht,this._data[this._dataLen++]=mt,this._data[this._dataLen++]=De,this._data[this._dataLen++]=et,this._data[this._dataLen++]=rt,this._prevLine=$,this._prevChar=se}static _sortAndDeltaEncode($){let se=[];const De=$.length/5|0;for(let mt=0;mt<De;mt++)se[mt]=mt;se.sort((mt,Ct)=>{const At=$[5*mt],Lt=$[5*Ct];if(At===Lt){const Mt=$[5*mt+1],Ut=$[5*Ct+1];return Mt-Ut}return At-Lt});const et=new Uint32Array($.length);let rt=0,ht=0;for(let mt=0;mt<De;mt++){const Ct=5*se[mt],At=$[Ct+0],Lt=$[Ct+1],Mt=$[Ct+2],Ut=$[Ct+3],dn=$[Ct+4],xn=At-rt,Gn=xn===0?Lt-ht:Lt,hn=5*mt;et[hn+0]=xn,et[hn+1]=Gn,et[hn+2]=Mt,et[hn+3]=Ut,et[hn+4]=dn,rt=At,ht=Lt}return et}build($){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),$):new qt(on._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=on;class qt{constructor($,se){this.resultId=se,this.data=$}}e.SemanticTokens=qt;class an{constructor($,se,De){this.start=$,this.deleteCount=se,this.data=De}}e.SemanticTokensEdit=an;class Sn{constructor($,se){this.resultId=se,this.edits=$}}e.SemanticTokensEdits=Sn;var yn;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(yn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Gt;(function(j){j[j.Initial=1]="Initial",j[j.Dynamic=2]="Dynamic"})(Gt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Jt=class{constructor(){}};Jt.Back={iconPath:new yt("arrow-left")},Jt=Ve([T],Jt),e.QuickInputButtons=Jt;var Dn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor($,se,De){this.badge=$,this.tooltip=se,this.color=De}static validate($){if($.badge&&$.badge.length!==1&&$.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Cn;let ln=class{constructor($){this.kind=$}};ln=Ve([T],ln),e.ColorTheme=ln;var cn;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast"})(cn=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{constructor($,se){if($<0)throw(0,L.illegalArgument)("start must be positive");if(se<0)throw(0,L.illegalArgument)("end must be positive");$<=se?(this._start=$,this._end=se):(this._start=se,this._end=$)}static isNotebookRange($){return $ instanceof Vt?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with($){let se=this._start,De=this._end;return $.start!==void 0&&(se=$.start),$.end!==void 0&&(De=$.end),se===this._start&&De===this._end?this:new Vt(se,De)}}e.NotebookRange=Vt;class Ft{constructor($,se,De,et,rt,ht,mt){this.kind=$,this.value=se,this.languageId=De,this.mime=et,this.outputs=rt??[],this.metadata=ht,this.executionSummary=mt,Ft.validate(this)}static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(se=>Ft.isNotebookCellData(se))}static isNotebookCellData($){return!0}}e.NotebookCellData=Ft;class Ne{constructor($){this.cells=$}}e.NotebookData=Ne;class Rt{constructor($,se){this.data=$,this.mime=se;const De=(0,R.normalizeMimeType)(se,!0);if(!De)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}static isNotebookCellOutputItem($){return $ instanceof Rt?!0:$?typeof $.mime=="string"&&$.data instanceof Uint8Array:!1}static error($){const se={name:$.name,message:$.message,stack:$.stack};return Rt.json(se,"application/vnd.code.notebook.error")}static stdout($){return Rt.text($,"application/vnd.code.notebook.stdout")}static stderr($){return Rt.text($,"application/vnd.code.notebook.stderr")}static bytes($,se="application/octet-stream"){return new Rt($,se)}static text($,se=R.Mimes.text){const De=Oe(Rt,d,"f",g).encode(String($));return new Rt(De,se)}static json($,se="application/json"){const De=JSON.stringify($,void 0,"	");return Rt.text(De,se)}}e.NotebookCellOutputItem=Rt,d=Rt,g={value:new TextEncoder};class Kt{constructor($,se,De){this.items=Kt.ensureUniqueMimeTypes($,!0),typeof se=="string"?(this.id=se,this.metadata=De):(this.id=(0,A.generateUuid)(),this.metadata=se??De)}static isNotebookCellOutput($){return $ instanceof Kt?!0:!$||typeof $!="object"?!1:typeof $.id=="string"&&(0,E.isArray)($.items)}static ensureUniqueMimeTypes($,se=!1){const De=new Set,et=new Set;for(let rt=0;rt<$.length;rt++){const ht=$[rt],mt=(0,R.normalizeMimeType)(ht.mime);if(!De.has(mt)){De.add(mt);continue}et.add(rt),se&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return et.size===0?$:$.filter((rt,ht)=>!et.has(ht))}}e.NotebookCellOutput=Kt;var Et;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Et=e.NotebookCellKind||(e.NotebookCellKind={}));var kn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(kn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var In;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(In=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var gn;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(gn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class pn{constructor($,se){this.text=$,this.alignment=se}}e.NotebookCellStatusBarItem=pn;var Pn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Pn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Tn{constructor($,se=[]){this.uri=$,this.provides=(0,m.asArray)(se)}}e.NotebookRendererScript=Tn;let un=class{constructor($,se){this.label=$,this.timestamp=se}};un=Ve([T],un),e.TimelineItem=un;var An;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(An=e.ExtensionMode||(e.ExtensionMode={}));var vn;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(vn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Rn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=4]="RegEx"})(Rn=e.StandardTokenType||(e.StandardTokenType={}));class Ln{constructor($,se){this.ranges=$,this.wordPattern=se}}e.LinkedEditingRanges=Ln;class Fn{constructor($,se){this._port=$,this._autoForwardAction=se}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fn;var Mn;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Mn=e.TestResultState||(e.TestResultState={}));var On;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(On=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ie=class{constructor($,se,De){this.include=$,this.exclude=se,this.profile=De}};ie=Ve([T],ie),e.TestRunRequest=ie;let fe=D=class{constructor($){this.message=$}static diff($,se,De){const et=new D($);return et.expectedOutput=se,et.actualOutput=De,et}};fe=D=Ve([T],fe),e.TestMessage=fe;let Ae=class{constructor($){this.id=$}};Ae=Ve([T],Ae),e.TestTag=Ae;let ct=class{constructor($,se){this.covered=$,this.total=se}};ct=Ve([T],ct),e.CoveredCount=ct;let St=w=class{constructor($,se,De,et){this.uri=$,this.statementCoverage=se,this.branchCoverage=De,this.functionCoverage=et}static fromDetails($,se){const De=new ct(0,0),et=new ct(0,0),rt=new ct(0,0);for(const mt of se)if("branches"in mt){De.total+=1,De.covered+=mt.executionCount>0?1:0;for(const Ct of mt.branches)et.total+=1,et.covered+=Ct.executionCount>0?1:0}else rt.total+=1,rt.covered+=mt.executionCount>0?1:0;const ht=new w($,De,et.total>0?et:void 0,rt.total>0?rt:void 0);return ht.detailedCoverage=se,ht}};St=w=Ve([T],St),e.FileCoverage=St;let kt=class{constructor($,se,De=[]){this.executionCount=$,this.location=se,this.branches=De}};kt=Ve([T],kt),e.StatementCoverage=kt;let Nn=class{constructor($,se){this.executionCount=$,this.location=se}};Nn=Ve([T],Nn),e.BranchCoverage=Nn;let Un=class{constructor($,se){this.executionCount=$,this.location=se}};Un=Ve([T],Un),e.FunctionCoverage=Un;var zn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(zn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Vn;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var jn;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(jn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qn{constructor($,se,De,et,rt,ht){this.kind=$,this.name=se,this.detail=De,this.uri=et,this.range=rt,this.selectionRange=ht}}e.TypeHierarchyItem=qn}),define(me[123],ge([0,1,56,10,9,150,110,7,17]),function(J,e,m,L,k,C,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const A=new Map;function n(d,g){g?A.set(d,g):A.delete(d)}e.setWordDefinitionFor=n;function P(d){return A.get(d)}e.getWordDefinitionFor=P;class c extends C.MirrorTextModel{constructor(g,y,I,_,s,o,p,t){super(y,I,_,s);this._proxy=g,this._languageId=o,this._isDirty=p,this._notebook=t,this._isDisposed=!1}dispose(){(0,m.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(g){return(0,S.equals)(this._lines,g)}get document(){if(!this._document){const g=this;this._document={get uri(){return g._uri},get fileName(){return g._uri.fsPath},get isUntitled(){return g._uri.scheme===L.Schemas.untitled},get languageId(){return g._languageId},get version(){return g._versionId},get isClosed(){return g._isDisposed},get isDirty(){return g._isDirty},get notebook(){return g._notebook},save(){return g._save()},getText(y){return y?g._getTextInRange(y):g.getText()},get eol(){return g._eol===`
`?E.EndOfLine.LF:E.EndOfLine.CRLF},get lineCount(){return g._lines.length},lineAt(y){return g._lineAt(y)},offsetAt(y){return g._offsetAt(y)},positionAt(y){return g._positionAt(y)},validateRange(y){return g._validateRange(y)},validatePosition(y){return g._validatePosition(y)},getWordRangeAtPosition(y,I){return g._getWordRangeAtPosition(y,I)}}}return Object.freeze(this._document)}_acceptLanguageId(g){(0,m.ok)(!this._isDisposed),this._languageId=g}_acceptIsDirty(g){(0,m.ok)(!this._isDisposed),this._isDirty=g}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(g){const y=this._validateRange(g);if(y.isEmpty)return"";if(y.isSingleLine)return this._lines[y.start.line].substring(y.start.character,y.end.character);const I=this._eol,_=y.start.line,s=y.end.line,o=[];o.push(this._lines[_].substring(y.start.character));for(let p=_+1;p<s;p++)o.push(this._lines[p]);return o.push(this._lines[s].substring(0,y.end.character)),o.join(I)}_lineAt(g){let y;if(g instanceof E.Position?y=g.line:typeof g=="number"&&(y=g),typeof y!="number"||y<0||y>=this._lines.length||Math.floor(y)!==y)throw new Error("Illegal value for `line`");return new h(y,this._lines[y],y===this._lines.length-1)}_offsetAt(g){return g=this._validatePosition(g),this._ensureLineStarts(),this._lineStarts.getPrefixSum(g.line-1)+g.character}_positionAt(g){g=Math.floor(g),g=Math.max(0,g),this._ensureLineStarts();const y=this._lineStarts.getIndexOf(g),I=this._lines[y.index].length;return new E.Position(y.index,Math.min(y.remainder,I))}_validateRange(g){if(!(g instanceof E.Range))throw new Error("Invalid argument");const y=this._validatePosition(g.start),I=this._validatePosition(g.end);return y===g.start&&I===g.end?g:new E.Range(y.line,y.character,I.line,I.character)}_validatePosition(g){if(!(g instanceof E.Position))throw new Error("Invalid argument");if(this._lines.length===0)return g.with(0,0);let{line:y,character:I}=g,_=!1;if(y<0)y=0,I=0,_=!0;else if(y>=this._lines.length)y=this._lines.length-1,I=this._lines[y].length,_=!0;else{const s=this._lines[y].length;I<0?(I=0,_=!0):I>s&&(I=s,_=!0)}return _?new E.Position(y,I):g}_getWordRangeAtPosition(g,y){const I=this._validatePosition(g);if(!y)y=P(this._languageId);else if((0,k.regExpLeadsToEndlessLoop)(y))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${y.source}' because it matches the empty string.`);const _=(0,R.getWordAtText)(I.character+1,(0,R.ensureValidWordDefinition)(y),this._lines[I.line],0);if(_)return new E.Range(I.line,_.startColumn-1,I.line,_.endColumn-1)}}e.ExtHostDocumentData=c;class h{constructor(g,y,I){this._line=g,this._text=y,this._isLastLine=I}get lineNumber(){return this._line}get text(){return this._text}get range(){return new E.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new E.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(me[203],ge([0,1,7,3,112,6,81,24,2,32]),function(J,e,m,L,k,C,R,E,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(c,h,d,g){this._notebook=d,this._selector=g,this._disposables=new C.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,A.generateUuid)()}),this._init(),this._disposables.add(h.onDidChangeDocument(I=>{const _=this._cellUris.get(I.document.uri);_!==void 0&&(this._cellLengths.changeValue(_,this._cells[_].document.getText().length+1),this._cellLines.changeValue(_,this._cells[_].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const y=I=>{I===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(c.onDidChangeNotebookCells(I=>y(I.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new E.ResourceMap;const c=[],h=[];for(const d of this._notebook.getCells())d.kind===m.NotebookCellKind.Code&&(!this._selector||(0,R.score)(this._selector,d.document.uri,d.document.languageId,!0))&&(this._cellUris.set(d.document.uri,this._cells.length),this._cells.push(d),c.push(d.document.getText().length+1),h.push(d.document.lineCount));this._cellLengths=new k.PrefixSumComputer(new Uint32Array(c)),this._cellLines=new k.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(c){if(!c){let _="";for(const s of this._cells)_+=s.document.getText()+`
`;return _=_.slice(0,-1),_}if(c.isEmpty)return"";const h=this.locationAt(c.start),d=this.locationAt(c.end),g=this._cellUris.get(h.uri),y=this._cellUris.get(d.uri);if(g===void 0||y===void 0)return"";if(g===y)return this._cells[g].document.getText(new m.Range(h.range.start,d.range.end));const I=[this._cells[g].document.getText(new m.Range(h.range.start,new m.Position(this._cells[g].document.lineCount,0)))];for(let _=g+1;_<y;_++)I.push(this._cells[_].document.getText());return I.push(this._cells[y].document.getText(new m.Range(new m.Position(0,0),d.range.end))),I.join(`
`)}offsetAt(c){const h=this._cellLines.getIndexOf(c.line),d=this._cellLengths.getPrefixSum(h.index-1),g=this._cells[h.index].document.offsetAt(c.with(h.remainder));return d+g}positionAt(c){if(typeof c=="number"){const d=this._cellLengths.getIndexOf(c),g=this._cellLines.getPrefixSum(d.index-1);return this._cells[d.index].document.positionAt(d.remainder).translate(g)}const h=this._cellUris.get(c.uri);if(h!==void 0){const d=this._cellLines.getPrefixSum(h-1);return new m.Position(d+c.range.start.line,c.range.start.character)}return new m.Position(0,0)}locationAt(c){m.Range.isRange(c)||(c=new m.Range(c,c));const h=this._cellLines.getIndexOf(c.start.line);let d=h;c.isEmpty||(d=this._cellLines.getIndexOf(c.end.line));const g=new m.Position(h.remainder,c.start.character),y=new m.Position(d.remainder,c.end.character),I=new m.Range(g,y),_=this._cells[h.index];return new m.Location(_.document.uri,_.document.validateRange(I))}contains(c){return this._cellUris.has(c)}validateRange(c){const h=this.validatePosition(c.start),d=this.validatePosition(c.end);return c.with(h,d)}validatePosition(c){const h=this._cellLines.getIndexOf(c.line),d=new m.Position(h.remainder,c.character),g=this._cells[h.index].document.validatePosition(d),y=this._cellLines.getPrefixSum(h.index-1);return new m.Position(y+g.line,g.character)}}e.ExtHostNotebookConcatDocument=n}),define(me[204],ge([0,1,7,14,3]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let C=class{constructor(E){this._actual=new m.ColorTheme(m.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new k.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(E){let S=E==="light"?m.ColorThemeKind.Light:E==="dark"?m.ColorThemeKind.Dark:m.ColorThemeKind.HighContrast;this._actual=new m.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};C=Ve([$e(0,L.IExtHostRpcService)],C),e.ExtHostTheming=C}),define(me[65],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,m.createDecorator)("IURITransformerService");class L{constructor(C){C?(this.transformIncoming=C.transformIncoming.bind(C),this.transformOutgoing=C.transformOutgoing.bind(C),this.transformOutgoingURI=C.transformOutgoingURI.bind(C),this.transformOutgoingScheme=C.transformOutgoingScheme.bind(C)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=L}),define(me[205],ge([0,1,23]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(S){let A=this.buffers.indexOf(S);return A<0&&(A=this.buffers.length,this.buffers.push(S)),A}}function k(E,S){if(S.serializeBuffersForPostMessage){const A=new L,n=(h,d)=>{if(d instanceof ArrayBuffer){const g=A.add(d);return{$$vscode_array_buffer_reference$$:!0,index:g}}else if(ArrayBuffer.isView(d)){const g=C(d);if(g){const y=A.add(d.buffer);return{$$vscode_array_buffer_reference$$:!0,index:y,view:{type:g,byteLength:d.byteLength,byteOffset:d.byteOffset}}}}return d},P=JSON.stringify(E,n),c=A.buffers.map(h=>{const d=new Uint8Array(h);return m.VSBuffer.wrap(d)});return{message:P,buffers:c}}else return{message:JSON.stringify(E),buffers:[]}}e.serializeWebviewMessage=k;function C(E){switch(E.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(E,S){const A=S.map(c=>{const h=new ArrayBuffer(c.byteLength);return new Uint8Array(h).set(c.buffer),h}),n=S.length?(c,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const d=h,{index:g}=d,y=A[g];if(d.view)switch(d.view.type){case 1:return new Int8Array(y,d.view.byteOffset,d.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(y,d.view.byteOffset,d.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(y,d.view.byteOffset,d.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(y,d.view.byteOffset,d.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(y,d.view.byteOffset,d.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(y,d.view.byteOffset,d.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(y,d.view.byteOffset,d.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(y,d.view.byteOffset,d.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(y,d.view.byteOffset,d.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(y,d.view.byteOffset,d.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(y,d.view.byteOffset,d.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return y}return h}:void 0;return{message:JSON.parse(E,n),arrayBuffers:A}}e.deserializeWebviewMessage=R}),define(me[206],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var m;(function(L){function k(R){const E={items:new Map};return R.types.forEach((S,A)=>{E.items.set(S,{asString:async()=>R.items[A].asString})}),E}L.toITreeDataTransfer=k;async function C(R){const E={types:[],items:[]},S=Array.from(R.items.entries());for(const A of S)E.types.push(A[0]),E.items.push({asString:await A[1].asString()});return E}L.toTreeDataTransferDTO=C})(m=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(me[88],ge([0,1,10,2]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function k(E,S){return E.scheme===m.Schemas.http||E.scheme===m.Schemas.https?E:(S&&S.authority&&S.isRemote&&E.scheme===m.Schemas.file&&(E=L.URI.from({scheme:m.Schemas.vscodeRemote,authority:S.authority,path:E.path})),L.URI.from({scheme:m.Schemas.https,authority:`${E.scheme}+${C(E.authority)}.${e.webviewRootResourceAuthority}`,path:E.path,fragment:E.fragment,query:E.query}))}e.asWebviewUri=k;function C(E){return E.replace(/./g,S=>{const A=S.charCodeAt(0);return A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57?S:"-"+A.toString(16).padStart(4,"0")})}function R(E){return E.replace(/-([0-9a-f]{4})/g,(S,A)=>String.fromCharCode(parseInt(A,16)))}e.decodeAuthority=R}),define(me[207],ge([0,1,3,6,88]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(E,S,A){this._proxy=E,this._editors=S,this._initData=A,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const n=S.getVisibleTextEditors();for(const P of this._insets.values())n.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this._insets.forEach(E=>E.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(E,S,A,n,P){let c;for(const s of this._editors.getVisibleTextEditors(!0))if(s.value===E){c=s;break}if(!c)throw new Error("not a visible editor");const h=this,d=this._handlePool++,g=new m.Emitter,y=new m.Emitter,I=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(s){return(0,k.asWebviewUri)(s,h._initData.remote)}get cspSource(){return k.webviewGenericCspSource}set options(s){this._options=s,h._proxy.$setOptions(d,s)}get options(){return this._options}set html(s){this._html=s,h._proxy.$setHtml(d,s)}get html(){return this._html}get onDidReceiveMessage(){return g.event}postMessage(s){return h._proxy.$postMessage(d,s)}},_=new class{constructor(){this.editor=E,this.line=S,this.height=A,this.webview=I,this.onDidDispose=y.event}dispose(){h._insets.has(d)&&(h._insets.delete(d),h._proxy.$disposeEditorInset(d),y.fire(),y.dispose(),g.dispose())}};return this._proxy.$createEditorInset(d,c.id,c.value.document.uri,S+1,A,n||{},P.identifier,P.extensionLocation),this._insets.set(d,{editor:E,inset:_,onDidReceiveMessage:g}),_}$onDidDispose(E){const S=this._insets.get(E);S&&S.inset.dispose()}$onDidReceiveMessage(E,S){const A=this._insets.get(E);A&&A.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=C}),define(me[208],ge([0,1,172,13,2,6,4,62,34,17,10]),function(J,e,m,L,k,C,R,E,S,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,m.localize)(0,null),providerDisplayName:(0,m.localize)(1,null)},e.ActiveEditorDirtyContext=new E.RawContextKey("activeEditorIsDirty",!1,(0,m.localize)(2,null)),e.ActiveEditorPinnedContext=new E.RawContextKey("activeEditorIsNotPreview",!1,(0,m.localize)(3,null)),e.ActiveEditorStickyContext=new E.RawContextKey("activeEditorIsPinned",!1,(0,m.localize)(4,null)),e.ActiveEditorReadonlyContext=new E.RawContextKey("activeEditorIsReadonly",!1,(0,m.localize)(5,null)),e.ActiveEditorCanRevertContext=new E.RawContextKey("activeEditorCanRevert",!1,(0,m.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new E.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new E.RawContextKey("activeEditor",null,{type:"string",description:(0,m.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new E.RawContextKey("activeEditorAvailableEditorIds","",(0,m.localize)(8,null)),e.TextCompareEditorVisibleContext=new E.RawContextKey("textCompareEditorVisible",!1,(0,m.localize)(9,null)),e.TextCompareEditorActiveContext=new E.RawContextKey("textCompareEditorActive",!1,(0,m.localize)(10,null)),e.SideBySideEditorActiveContext=new E.RawContextKey("sideBySideEditorActive",!1,(0,m.localize)(11,null)),e.EditorGroupEditorsCountContext=new E.RawContextKey("groupEditorsCount",0,(0,m.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new E.RawContextKey("activeEditorGroupEmpty",!1,(0,m.localize)(13,null)),e.ActiveEditorGroupIndexContext=new E.RawContextKey("activeEditorGroupIndex",0,(0,m.localize)(14,null)),e.ActiveEditorGroupLastContext=new E.RawContextKey("activeEditorGroupLast",!1,(0,m.localize)(15,null)),e.ActiveEditorGroupLockedContext=new E.RawContextKey("activeEditorGroupLocked",!1,(0,m.localize)(16,null)),e.MultipleEditorGroupsContext=new E.RawContextKey("multipleEditorGroups",!1,(0,m.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new E.RawContextKey("editorIsOpen",!1,(0,m.localize)(18,null)),e.InEditorZenModeContext=new E.RawContextKey("inZenMode",!1,(0,m.localize)(19,null)),e.IsCenteredLayoutContext=new E.RawContextKey("isCenteredLayout",!1,(0,m.localize)(20,null)),e.SplitEditorsVertically=new E.RawContextKey("splitEditorsVertically",!1,(0,m.localize)(21,null)),e.EditorAreaVisibleContext=new E.RawContextKey("editorAreaVisible",!0,(0,m.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function P(v,F,M){for(const G of M.visibleEditorPanes)if(G.group.id===F&&v.matches(G.input))return G.getViewState()}e.findViewStateForEditor=P;function c(v){if(o(v))return!1;const F=v;return k.URI.isUri(F?.resource)}e.isResourceEditorInput=c;function h(v){if(o(v))return!1;const F=v;return F?.original!==void 0&&F.modified!==void 0}e.isResourceDiffEditorInput=h;function d(v){if(o(v)||h(v))return!1;const F=v;return F?.primary!==void 0&&F.secondary!==void 0}e.isResourceSideBySideEditorInput=d;function g(v){if(o(v))return!1;const F=v;return F?F.resource===void 0||F.resource.scheme===n.Schemas.untitled||F.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=g;var y;(function(v){v[v.SHORT=0]="SHORT",v[v.MEDIUM=1]="MEDIUM",v[v.LONG=2]="LONG"})(y=e.Verbosity||(e.Verbosity={}));var I;(function(v){v[v.EXPLICIT=1]="EXPLICIT",v[v.AUTO=2]="AUTO",v[v.FOCUS_CHANGE=3]="FOCUS_CHANGE",v[v.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(I=e.SaveReason||(e.SaveReason={}));var _;(function(v){v[v.None=0]="None",v[v.Readonly=2]="Readonly",v[v.Untitled=4]="Untitled",v[v.Singleton=8]="Singleton",v[v.RequiresTrust=16]="RequiresTrust",v[v.CanSplitInGroup=32]="CanSplitInGroup"})(_=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class s extends C.Disposable{}e.AbstractEditorInput=s;function o(v){return v instanceof s}e.isEditorInput=o;function p(v){const F=v;return k.URI.isUri(F?.preferredResource)}function t(v){const F=v;return o(F?.primary)&&o(F?.secondary)}e.isSideBySideEditorInput=t;function a(v){const F=v;return o(F?.modified)&&o(F?.original)}e.isDiffEditorInput=a;function r(v){return o(v?.editor)}e.isEditorInputWithOptions=r;function i(v){const F=v;return r(v)&&F?.group!==void 0}e.isEditorInputWithOptionsAndGroup=i;function l(v){const F=v;return typeof F?.groupId=="number"&&o(F.editor)}e.isEditorIdentifier=l;var u;(function(v){v[v.PRIMARY=1]="PRIMARY",v[v.SECONDARY=2]="SECONDARY",v[v.BOTH=3]="BOTH",v[v.ANY=4]="ANY"})(u=e.SideBySideEditor||(e.SideBySideEditor={}));class f{getOriginalUri(F,M){if(!F)return;if(M?.supportSideBySide){const{primary:K,secondary:U}=this.getSideEditors(F);if(K&&U){if(M?.supportSideBySide===u.BOTH)return{primary:this.getOriginalUri(K,{filterByScheme:M.filterByScheme}),secondary:this.getOriginalUri(U,{filterByScheme:M.filterByScheme})};if(M?.supportSideBySide===u.ANY)return this.getOriginalUri(K,{filterByScheme:M.filterByScheme})??this.getOriginalUri(U,{filterByScheme:M.filterByScheme});F=M.supportSideBySide===u.PRIMARY?K:U}}if(h(F)||d(F))return;const G=p(F)?F.preferredResource:F.resource;return!G||!M||!M.filterByScheme?G:this.filterUri(G,M.filterByScheme)}getSideEditors(F){return t(F)||d(F)?{primary:F.primary,secondary:F.secondary}:a(F)||h(F)?{primary:F.modified,secondary:F.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(F,M){if(!F)return;if(M?.supportSideBySide){const{primary:K,secondary:U}=this.getSideEditors(F);if(K&&U){if(M?.supportSideBySide===u.BOTH)return{primary:this.getCanonicalUri(K,{filterByScheme:M.filterByScheme}),secondary:this.getCanonicalUri(U,{filterByScheme:M.filterByScheme})};if(M?.supportSideBySide===u.ANY)return this.getCanonicalUri(K,{filterByScheme:M.filterByScheme})??this.getCanonicalUri(U,{filterByScheme:M.filterByScheme});F=M.supportSideBySide===u.PRIMARY?K:U}}if(h(F)||d(F))return;const G=F.resource;return!G||!M||!M.filterByScheme?G:this.filterUri(G,M.filterByScheme)}filterUri(F,M){if(Array.isArray(M)){if(M.some(G=>F.scheme===G))return F}else if(M===F.scheme)return F}}e.EditorResourceAccessor=new f;var b;(function(v){v[v.LEFT=0]="LEFT",v[v.RIGHT=1]="RIGHT"})(b=e.CloseDirection||(e.CloseDirection={}));class D{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(F){const M=this.instantiationService=F.get(R.IInstantiationService);for(const[G,K]of this.editorSerializerConstructors)this.createEditorSerializer(G,K,M);this.editorSerializerConstructors.clear()}createEditorSerializer(F,M,G){const K=G.createInstance(M);this.editorSerializerInstances.set(F,K)}registerFileEditorFactory(F){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=F}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(F,M){if(this.editorSerializerConstructors.has(F)||this.editorSerializerInstances.has(F))throw new Error(`A editor serializer with type ID '${F}' was already registered.`);return this.instantiationService?this.createEditorSerializer(F,M,this.instantiationService):this.editorSerializerConstructors.set(F,M),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(F),this.editorSerializerInstances.delete(F)})}getEditorSerializer(F){return this.editorSerializerInstances.get(typeof F=="string"?F:F.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new D);async function w(v,F){if(!v||!v.length)return[];const M=await Promise.all(v.map(async G=>{const K=k.URI.revive(G.fileUri);if(!K||(await F.activateProvider(K.scheme),!F.canHandleResource(K)))return;const U=typeof G.exists=="boolean"?G.exists:await F.exists(K);if(!U&&G.openOnlyIfExists)return;const z={selection:U?G.selection:void 0,pinned:!0,override:G.editorOverrideId};let N;return U?N={resource:K,options:z}:N={resource:K,options:z,forceUntitled:!0},N}));return(0,A.coalesce)(M)}e.pathsToEditors=w;var T;(function(v){v[v.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",v[v.SEQUENTIAL=1]="SEQUENTIAL"})(T=e.EditorsOrder||(e.EditorsOrder={}))}),define(me[209],ge([0,1,3,62,173,4,6,24,34,17,57,25,47,198]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",c.Codicon.window,(0,k.localize)(0,null));var d;(function(l){l.ViewContainersRegistry="workbench.registry.view.containers",l.ViewsRegistry="workbench.registry.view"})(d=e.Extensions||(e.Extensions={}));var g;(function(l){l[l.Sidebar=0]="Sidebar",l[l.Panel=1]="Panel"})(g=e.ViewContainerLocation||(e.ViewContainerLocation={}));function y(l){switch(l){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=y;function I(l){return`viewContainer.${l}.enabled`}e.getEnabledViewContainerContextKey=I;class _ extends R.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new m.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new m.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,A.flatten)([...this.viewContainers.values()])}registerViewContainer(u,f,b){const D=this.get(u.id);if(D)return D;const w=u;return w.openCommandActionDescriptor=b?.donotRegisterOpenCommand?void 0:w.openCommandActionDescriptor??{id:w.id},(0,E.getOrSet)(this.viewContainers,f,[]).push(w),b?.isDefault&&this.defaultViewContainers.push(w),this._onDidRegister.fire({viewContainer:w,viewContainerLocation:f}),w}deregisterViewContainer(u){for(const f of this.viewContainers.keys()){const b=this.viewContainers.get(f),D=b?.indexOf(u);if(D!==-1){b?.splice(D,1),b.length===0&&this.viewContainers.delete(f),this._onDidDeregister.fire({viewContainer:u,viewContainerLocation:f});return}}}get(u){return this.all.filter(f=>f.id===u)[0]}getViewContainers(u){return[...this.viewContainers.get(u)||[]]}getViewContainerLocation(u){return[...this.viewContainers.keys()].filter(f=>this.getViewContainers(f).filter(b=>b?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.defaultViewContainers.find(f=>this.getViewContainerLocation(f)===u)}}S.Registry.add(d.ViewContainersRegistry,new _);var s;(function(l){l.Open="2_open",l.Debug="4_debug",l.SCM="5_scm",l.More="9_more"})(s=e.ViewContentGroups||(e.ViewContentGroups={}));function o(l,u){const f=l.group??s.More,b=u.group??s.More;return f!==b?f.localeCompare(b):(l.order??5)-(u.order??5)}class p extends R.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new m.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new m.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new m.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new m.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new n.SetMap}registerViews(u,f){this.registerViews2([{views:u,viewContainer:f}])}registerViews2(u){u.forEach(({views:f,viewContainer:b})=>this.addViews(f,b)),this._onViewsRegistered.fire(u)}deregisterViews(u,f){const b=this.removeViews(u,f);b.length&&this._onViewsDeregistered.fire({views:b,viewContainer:f})}moveViews(u,f){for(const b of this._views.keys())if(b!==f){const D=this.removeViews(u,b);D.length&&(this.addViews(D,f),this._onDidChangeContainer.fire({views:D,from:b,to:f}))}}getViews(u){return this._views.get(u)||[]}getView(u){for(const f of this._viewContainers){const b=(this._views.get(f)||[]).filter(D=>D.id===u)[0];if(b)return b}return null}getViewContainer(u){for(const f of this._viewContainers)if((this._views.get(f)||[]).filter(D=>D.id===u)[0])return f;return null}registerViewWelcomeContent(u,f){return this._viewWelcomeContents.add(u,f),this._onDidChangeViewWelcomeContent.fire(u),(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(u,f),this._onDidChangeViewWelcomeContent.fire(u)})}registerViewWelcomeContent2(u,f){const b=new Map;for(const[D,w]of f)this._viewWelcomeContents.add(u,w),b.set(D,(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(u,w),this._onDidChangeViewWelcomeContent.fire(u)}));return this._onDidChangeViewWelcomeContent.fire(u),b}getViewWelcomeContent(u){const f=[];return this._viewWelcomeContents.forEach(u,b=>f.push(b)),f.sort(o)}addViews(u,f){let b=this._views.get(f);b||(b=[],this._views.set(f,b),this._viewContainers.push(f));for(const D of u){if(this.getView(D.id)!==null)throw new Error((0,k.localize)(1,null,D.id));b.push(D)}}removeViews(u,f){const b=this._views.get(f);if(!b)return[];const D=[],w=[];for(const T of b)u.includes(T)?D.push(T):w.push(T);return D.length&&(w.length?this._views.set(f,w):(this._views.delete(f),this._viewContainers.splice(this._viewContainers.indexOf(f),1))),D}}S.Registry.add(d.ViewsRegistry,new p),e.IViewsService=(0,C.createDecorator)("viewsService"),e.FocusedViewContext=new L.RawContextKey("focusedView","",(0,k.localize)(2,null));function t(l){return`view.${l}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,C.createDecorator)("viewDescriptorService");var a;(function(l){l[l.Default=0]="Default",l[l.Expand=1]="Expand"})(a=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(l){l[l.None=0]="None",l[l.Collapsed=1]="Collapsed",l[l.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(u,f){this.resolved=!1,this._hasResolve=!1,(0,P.mixin)(this,u),this._hasResolve=!!f,this.resolve=async b=>{if(f&&!this.resolved){const D=await f(b);D&&(this.tooltip=this.tooltip??D.tooltip,this.command=this.command??D.command)}b.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(me[124],ge([0,1,3,18,174]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class C{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new m.Emitter,this._onExit=new m.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(E){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=E}onEvent(E){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=E}onRequest(E){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=E}sendResponse(E){E.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${E.command}`)):this.internalSend("response",E)}sendRequest(E,S,A,n){const P={command:E};if(S&&Object.keys(S).length>0&&(P.arguments=S),this.internalSend("request",P),typeof n=="number"){const c=setTimeout(()=>{clearTimeout(c);const h=this.pendingRequests.get(P.seq);if(h){this.pendingRequests.delete(P.seq);const d={type:"response",seq:0,request_seq:P.seq,success:!1,command:E,message:(0,k.localize)(0,null,n,E)};h(d)}},n)}return A&&this.pendingRequests.set(P.seq,A),P.seq}acceptMessage(E){this.messageCallback?this.messageCallback(E):(this.queue.push(E),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(E,S){return E.type!=="event"||S.type!=="event"}async processQueue(){let E;for(;this.queue.length;){if((!E||this.needsTaskBoundaryBetween(this.queue[0],E))&&await(0,L.timeout)(0),E=this.queue.shift(),!E)return;switch(E.type){case"event":this.eventCallback&&this.eventCallback(E);break;case"request":this.requestCallback&&this.requestCallback(E);break;case"response":const S=E,A=this.pendingRequests.get(S.request_seq);A&&(this.pendingRequests.delete(S.request_seq),A(S));break}}}internalSend(E,S){S.type=E,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const E=new Map;this.pendingRequests.forEach((S,A)=>E.set(A,S)),await(0,L.timeout)(500),E.forEach((S,A)=>{S({type:"response",seq:0,request_seq:A,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(A)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=C}),define(me[210],ge([0,1,9,2,8,25,10]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const E=/{([^}]+)}/g;function S(r,i,l){return r.replace(E,function(u,f){return i&&f.length>0&&f[0]!=="_"?u:l&&l.hasOwnProperty(f)?l[f]:u})}e.formatPII=S;function A(r){const i={};for(const l of Object.keys(r))l.startsWith("!")||(i[l]=r[l]);return i}e.filterExceptionsFromTelemetry=A;function n(r){return r.configuration.request==="attach"&&!P(r)&&(!r.parentSession||n(r.parentSession))}e.isSessionAttach=n;function P(r){let i=r.configuration.type;if(!!i)return i==="vslsShare"&&(i=r.configuration.adapterProxy.configuration.type),(0,m.equalsIgnoreCase)(i,"extensionhost")||(0,m.equalsIgnoreCase)(i,"pwa-extensionhost")?r:r.parentSession?P(r.parentSession):void 0}e.getExtensionHostDebugSession=P;function c(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=c;function h(r,i,l){let u,f=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,D=null;for(;D=b.exec(r);){let w=D.index+1,T=w+D[0].length;if(w<=i&&T>=l){u=D[0],f=w;break}}if(u){let w=/\w+/g,T=null;for(;(T=w.exec(u))&&!(T.index+1+f+T[0].length>=l););T&&(u=u.substring(0,w.lastIndex))}return u?{start:f,end:f+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const d=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(r){return!!(r&&r.match(d))}e.isUri=g;function y(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(g(r.path))return L.URI.parse(r.path);if((0,k.isAbsolute)(r.path))return L.URI.file(r.path)}return r.path}function I(r){if(typeof r.path=="object"){const i=L.URI.revive(r.path);if(i)return i.scheme===R.Schemas.file?i.fsPath:i.toString()}return r.path}function _(r,i){const l=i?y:I,u=(0,C.deepClone)(r);return o(u,(f,b)=>{f&&b&&(b.path=l(b))}),u}e.convertToDAPaths=_;function s(r,i){const l=i?y:I,u=(0,C.deepClone)(r);return o(u,(f,b)=>{!f&&b&&(b.path=l(b))}),u}e.convertToVSCPaths=s;function o(r,i){switch(r.type){case"event":const l=r;switch(l.event){case"output":i(!1,l.body.source);break;case"loadedSource":i(!1,l.body.source);break;case"breakpoint":i(!1,l.body.breakpoint.source);break;default:break}break;case"request":const u=r;switch(u.command){case"setBreakpoints":i(!0,u.arguments.source);break;case"breakpointLocations":i(!0,u.arguments.source);break;case"source":i(!0,u.arguments.source);break;case"gotoTargets":i(!0,u.arguments.source);break;case"launchVSCode":u.arguments.args.forEach(b=>i(!1,b));break;default:break}break;case"response":const f=r;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(b=>i(!1,b.source));break;case"loadedSources":f.body.sources.forEach(b=>i(!1,b));break;case"scopes":f.body.scopes.forEach(b=>i(!1,b.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(b=>i(!1,b.source));break;case"setBreakpoints":f.body.breakpoints.forEach(b=>i(!1,b.source));break;default:break}break}}function p(r){return r.filter(i=>!i.presentation?.hidden).sort((i,l)=>i.presentation?l.presentation?i.presentation.group?l.presentation.group?i.presentation.group!==l.presentation.group?i.presentation.group.localeCompare(l.presentation.group):t(i.presentation.order,l.presentation.order):-1:l.presentation.group?1:t(i.presentation.order,l.presentation.order):-1:l.presentation?1:0)}e.getVisibleAndSorted=p;function t(r,i){return typeof r!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:r-i}async function a(r,i){const l=r.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(l!=="none"&&(await i.saveAll(),l==="allEditorsInActiveGroup")){const u=i.activeEditorPane;u&&await i.save({editor:u.input,groupId:u.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=a}),define(me[211],ge([0,1,28,39,175,125,8,9,25,11,185,124]),function(J,e,m,L,k,C,R,E,S,A,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class c extends P.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(_,s){this.outputStream=s,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,_.on("data",o=>this.handleData(o))}sendMessage(_){if(this.outputStream){const s=JSON.stringify(_);this.outputStream.write(`Content-Length: ${Buffer.byteLength(s,"utf8")}${c.TWO_CRLF}${s}`,"utf8")}}handleData(_){for(this.rawData=Buffer.concat([this.rawData,_]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const s=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,s.length>0)try{this.acceptMessage(JSON.parse(s))}catch(o){this._onError.fire(new Error((o.message||o)+`
`+s))}continue}}else{const s=this.rawData.indexOf(c.TWO_CRLF);if(s!==-1){const p=this.rawData.toString("utf8",0,s).split(c.HEADER_LINESEPARATOR);for(const t of p){const a=t.split(c.HEADER_FIELDSEPARATOR);a[0]==="Content-Length"&&(this.contentLength=Number(a[1]))}this.rawData=this.rawData.slice(s+c.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=c,c.TWO_CRLF=`\r
\r
`,c.HEADER_LINESEPARATOR=/\r?\n/,c.HEADER_FIELDSEPARATOR=/: */;class h extends c{startSession(){return new Promise((_,s)=>{let o=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),_(),o=!0}),this.socket.on("close",()=>{o?this._onError.fire(new Error("connection closed")):s(new Error("connection closed"))}),this.socket.on("error",p=>{o?this._onError.fire(p):s(p)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=h;class d extends h{constructor(_){super();this.adapterServer=_}createConnection(_){return C.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",_)}}e.SocketDebugAdapter=d;class g extends h{constructor(_){super();this.adapterServer=_}createConnection(_){return C.createConnection(this.adapterServer.path,_)}}e.NamedPipeDebugAdapter=g;class y extends c{constructor(_,s,o){super();this.adapterExecutable=_,this.debugType=s,this.outputService=o}async startSession(){const _=this.adapterExecutable.command,s=this.adapterExecutable.args,o=this.adapterExecutable.options||{};try{if(_)if(R.isAbsolute(_)){if(!await m.Promises.exists(_))throw new Error(k.localize(0,null,_))}else _.indexOf("/")<0&&_.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.debugType));let p=process.env;if(o.env&&Object.keys(o.env).length>0&&(p=S.mixin(S.deepClone(process.env),o.env)),_==="node")if(Array.isArray(s)&&s.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:p,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};o.cwd&&(r.cwd=o.cwd);const i=L.fork(s[0],s.slice(1),r);if(!i.pid)throw new Error(k.localize(2,null,s[0]));this.serverProcess=i}else throw new Error(k.localize(3,null));else{const a={env:p};o.cwd&&(a.cwd=o.cwd),this.serverProcess=L.spawn(_,s,a)}this.serverProcess.on("error",a=>{this._onError.fire(a)}),this.serverProcess.on("exit",(a,r)=>{this._onExit.fire(a)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",a=>{this._onError.fire(a)}),this.serverProcess.stdin.on("error",a=>{this._onError.fire(a)});const t=this.outputService;if(t){const a=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const i=t.getChannel(n.ExtensionsChannelId);i&&i.append(a(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(p){this._onError.fire(p)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),A.isWindows?new Promise((_,s)=>{const o=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(p,t,a){if(p)return s(p)});o.on("exit",_),o.on("error",s)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(_,s){if(!_)return;const o=Object.create(null);_.runtime&&(_.runtime.indexOf("./")===0?o.runtime=R.join(s,_.runtime):o.runtime=_.runtime),_.runtimeArgs&&(o.runtimeArgs=_.runtimeArgs),_.program&&(R.isAbsolute(_.program)?o.program=_.program:o.program=R.join(s,_.program)),_.args&&(o.args=_.args);const p=_;return p.win&&(o.win=y.extract(p.win,s)),p.winx86&&(o.winx86=y.extract(p.winx86,s)),p.windows&&(o.windows=y.extract(p.windows,s)),p.osx&&(o.osx=y.extract(p.osx,s)),p.linux&&(o.linux=y.extract(p.linux,s)),o}static platformAdapterExecutable(_,s){let o=Object.create(null);s=s.toLowerCase();for(const l of _)if(l.contributes){const u=l.contributes.debuggers;u&&u.length>0&&u.filter(f=>typeof f.type=="string"&&E.equalsIgnoreCase(f.type,s)).forEach(f=>{const b=y.extract(f,l.extensionLocation.fsPath);o=S.mixin(o,b,l.isBuiltin)})}let p;A.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?p=o.winx86||o.win||o.windows:A.isWindows?p=o.win||o.windows:A.isMacintosh?p=o.osx:A.isLinux&&(p=o.linux),p=p||o;let t=p.program||o.program;const a=p.args||o.args;let r=p.runtime||o.runtime;const i=p.runtimeArgs||o.runtimeArgs;if(r)return{type:"executable",command:r,args:(i||[]).concat(typeof t=="string"?[t]:[]).concat(a||[])};if(t)return{type:"executable",command:t,args:a||[]}}}e.ExecutableDebugAdapter=y}),define(me[212],ge([0,1,39,11,29,188]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function R(c,h){return new Promise((d,g)=>{let y="";const I=m.spawn(c,h);I.pid&&I.stdout.on("data",_=>{y+=_.toString()}),I.on("error",_=>{g(_)}),I.on("close",_=>{d(y)})})}let E;function S(c,h){if(!E)if(L.isWindows)E=new C.WindowsExternalTerminalService;else if(L.isMacintosh)E=new C.MacExternalTerminalService;else if(L.isLinux)E=new C.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const d=h.getConfiguration("terminal");return E.runInTerminal(c.title,c.cwd,c.args,c.env||{},d.external||{})}e.runInExternalTerminal=S;function A(c){return c?L.isWindows?new Promise(async h=>{(await new Promise((g,y)=>{J(["windows-process-tree"],g,y)})).getProcessTree(c,g=>{h(g.children.length>0)})}):R("/usr/bin/pgrep",["-lP",String(c)]).then(h=>{const d=h.trim();return!(d.length===0||d.indexOf(" tmux")>=0)},h=>!0):Promise.resolve(!0)}e.hasChildProcesses=A;var n;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(n||(n={}));function P(c,h,d,g){c=c.trim().toLowerCase();let y;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?y=1:c.indexOf("cmd.exe")>=0?y=0:c.indexOf("bash")>=0?y=2:L.isWindows?y=0:y=2;let I,_=" ";switch(y){case 1:if(I=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),d){const o=(0,k.getDriveLetter)(d);o&&(_+=`${o}:; `),_+=`cd ${I(d)}; `}if(g)for(let o in g){const p=g[o];p===null?_+=`Remove-Item env:${o}; `:_+=`\${env:${o}}='${p}'; `}if(h.length>0){const o=I(h.shift());_+=o[0]==="'"?`& ${o} `:`${o} `;for(let p of h)_+=`${I(p)} `}break;case 0:if(I=o=>(o=o.replace(/\"/g,'""'),o.indexOf(" ")>=0||o.indexOf('"')>=0||o.length===0?`"${o}"`:o),d){const o=(0,k.getDriveLetter)(d);o&&(_+=`${o}: && `),_+=`cd ${I(d)} && `}if(g){_+='cmd /C "';for(let o in g){let p=g[o];p===null?_+=`set "${o}=" && `:(p=p.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),_+=`set "${o}=${p}" && `)}}for(let o of h)_+=`${I(o)} `;g&&(_+='"');break;case 2:I=o=>(o=o.replace(/(["'\\\$])/g,"\\$1"),o.indexOf(" ")>=0||o.indexOf(";")>=0||o.length===0?`"${o}"`:o);const s=o=>/[^\w@%\/+=,.:^-]/.test(o)?`'${o.replace(/'/g,"'\\''")}'`:o;if(d&&(_+=`cd ${I(d)} ; `),g){_+="/usr/bin/env";for(let o in g){const p=g[o];p===null?_+=` -u ${s(o)}`:_+=` ${s(`${o}=${p}`)}`}_+=" "}for(let o of h)_+=`${I(o)} `;break}return _}e.prepareCommand=P}),define(me[126],ge([0,1,30,102,10,8,11,62]),function(J,e,m,L,k,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var S;(function(w){w[w.Markup=1]="Markup",w[w.Code=2]="Code"})(S=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var A;(function(w){w[w.Running=1]="Running",w[w.Idle=2]="Idle"})(A=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(w){w[w.Pending=2]="Pending",w[w.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var P;(function(w){w[w.WithHardKernelDependency=0]="WithHardKernelDependency",w[w.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",w[w.Pure=2]="Pure",w[w.Never=3]="Never"})(P=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var c;(function(w){w.Always="always",w.Never="never",w.Optional="optional"})(c=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(w){w[w.ModelChange=1]="ModelChange",w[w.Move=2]="Move",w[w.ChangeLanguage=5]="ChangeLanguage",w[w.Initialize=6]="Initialize",w[w.ChangeCellMetadata=7]="ChangeCellMetadata",w[w.Output=8]="Output",w[w.OutputItem=9]="OutputItem",w[w.ChangeCellContent=10]="ChangeCellContent",w[w.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",w[w.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",w[w.ChangeCellMime=13]="ChangeCellMime",w[w.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(w){w[w.Handle=0]="Handle",w[w.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(w){w[w.Replace=1]="Replace",w[w.Output=2]="Output",w[w.Metadata=3]="Metadata",w[w.CellLanguage=4]="CellLanguage",w[w.DocumentMetadata=5]="DocumentMetadata",w[w.Move=6]="Move",w[w.OutputItems=7]="OutputItems",w[w.PartialMetadata=8]="PartialMetadata",w[w.PartialInternalMetadata=9]="PartialInternalMetadata"})(g=e.CellEditType||(e.CellEditType={}));var y;(function(w){w.scheme=k.Schemas.vscodeNotebookCell;const T=/^ch(\d{7,})/;function v(U,z){return U.with({scheme:w.scheme,fragment:`ch${z.toString().padStart(7,"0")}${U.scheme!==k.Schemas.file?U.scheme:""}`})}w.generate=v;function F(U){if(U.scheme!==w.scheme)return;const z=T.exec(U.fragment);return z?{handle:Number(z[1]),notebook:U.with({scheme:U.fragment.substr(z[0].length)||k.Schemas.file,fragment:null})}:void 0}w.parse=F;function M(U){if(U.scheme!==k.Schemas.vscodeNotebookCellMetadata)return;const z=T.exec(U.fragment);return z?{handle:Number(z[1]),notebook:U.with({scheme:U.fragment.substr(z[0].length)||k.Schemas.file,fragment:null})}:void 0}w.parseCellMetadataUri=M;function G(U,z,N){return U.with({scheme:N,fragment:`ch${z.toString().padStart(7,"0")}${U.scheme!==k.Schemas.file?U.scheme:""}`})}w.generateCellUri=G;function K(U,z){if(U.scheme!==z)return;const N=T.exec(U.fragment);return N?{handle:Number(N[1]),notebook:U.with({scheme:U.fragment.substr(N[0].length)||k.Schemas.file,fragment:null})}:void 0}w.parseCellUri=K})(y=e.CellUri||(e.CellUri={}));const I=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[L.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function _(w){return I.get(w)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=_;function s(w){return I.get(w)?.supportedByCore??!1}e.mimeTypeSupportedByCore=s;function o(w){return I.get(w)?.mergeable??!1}e.mimeTypeIsMergeable=o;function p(w,T){return R.isWindows&&(w=w.replace(/\//g,"\\"),T=T.replace(/\//g,"\\")),m.match(w,T)}function t(w,T,v){let F=0;for(let M=0;M<T.length;M++){if(p(T[M],w))return F;F++}for(let M=0;M<v.length;M++){if(p(v[M],w))return F;F++}return F}function a(w,T,v){return w.sort((F,M)=>t(F,T,v)-t(M,T,v))}e.sortMimeTypes=a;function r(w,T,v,F=(M,G)=>M===G){const M=[];function G(z,N,x){if(N===0&&x.length===0)return;const B=M[M.length-1];B&&B.start+B.deleteCount===z?(B.deleteCount+=N,B.toInsert.push(...x)):M.push({start:z,deleteCount:N,toInsert:x})}let K=0,U=0;for(;;){if(K===w.length){G(K,0,T.slice(U));break}if(U===T.length){G(K,w.length-K,[]);break}const z=w[K],N=T[U];if(F(z,N)){K+=1,U+=1;continue}v(N)?(G(K,1,[]),K+=1):(G(K,0,[N]),U+=1)}return M}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new E.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(w){w.default="default",w.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function l(w){const T=w;return!!((typeof T.include=="string"||m.isRelativePattern(T.include))&&(typeof T.exclude=="string"||m.isRelativePattern(T.exclude)))}e.isDocumentExcludePattern=l;function u(w,T,v){if(Array.isArray(w.viewType)&&w.viewType.indexOf(T)>=0||w.viewType===T)return!0;if(w.filenamePattern){let F=l(w.filenamePattern)?w.filenamePattern.include:w.filenamePattern,M=l(w.filenamePattern)?w.filenamePattern.exclude:void 0;if(m.match(F,(0,C.basename)(v.fsPath).toLowerCase()))return!(M&&m.match(M,(0,C.basename)(v.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=u;class f{constructor(T){this.textModel=T}getElements(){const T=new Int32Array(this.textModel.cells.length);for(let v=0;v<this.textModel.cells.length;v++)T[v]=this.textModel.cells[v].getHashValue();return T}}e.CellSequence=f,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var b;(function(w){w[w.Left=1]="Left",w[w.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class D{static create(T){return`${D._prefix}${T}`}static parse(T){if(T.startsWith(D._prefix))return T.substr(D._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=D,D._prefix="notebook/"}),define(me[213],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(k){k[k.Output=1]="Output",k[k.OutputItems=2]="OutputItems",k[k.ExecutionState=3]="ExecutionState",k[k.Complete=4]="Complete"})(L=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,m.createDecorator)("INotebookExecutionService")}),define(me[214],ge([0,1,177,4,62]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new k.RawContextKey("customExecutionSupported",!0,m.localize(0,null)),e.ShellExecutionSupportedContext=new k.RawContextKey("shellExecutionSupported",!1,m.localize(1,null)),e.ProcessExecutionSupportedContext=new k.RawContextKey("processExecutionSupported",!1,m.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[215],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function m(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=m;function L(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=L}),define(me[127],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var m;(function(P){P[P.Unset=0]="Unset",P[P.Queued=1]="Queued",P[P.Running=2]="Running",P[P.Passed=3]="Passed",P[P.Failed=4]="Failed",P[P.Skipped=5]="Skipped",P[P.Errored=6]="Errored"})(m=e.TestResultState||(e.TestResultState={}));var L;(function(P){P[P.Run=2]="Run",P[P.Debug=4]="Debug",P[P.Coverage=8]="Coverage",P[P.HasNonDefaultProfile=16]="HasNonDefaultProfile",P[P.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var k;(function(P){P[P.Error=0]="Error",P[P.Info=1]="Info"})(k=e.TestMessageType||(e.TestMessageType={}));var C;(function(P){P[P.NotExpandable=0]="NotExpandable",P[P.Expandable=1]="Expandable",P[P.BusyExpanding=2]="BusyExpanding",P[P.Expanded=3]="Expanded"})(C=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(P,c)=>{c.expand!==void 0&&(P.expand=c.expand),c.item!==void 0&&(P.item=P.item?Object.assign(P.item,c.item):c.item)};e.applyTestItemUpdate=R;var E;(function(P){P[P.Function=0]="Function",P[P.Statement=1]="Statement"})(E=e.DetailType||(e.DetailType={}));var S;(function(P){P[P.Add=0]="Add",P[P.Update=1]="Update",P[P.Remove=2]="Remove",P[P.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",P[P.Retire=4]="Retire",P[P.AddTag=5]="AddTag",P[P.RemoveTag=6]="RemoveTag"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));class A{add(c){}update(c){}remove(c,h){}complete(){}}e.IncrementalChangeCollector=A;class n{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(c){const h=this.createChangeCollector();for(const d of c)switch(d[0]){case 0:{const g=d[1];if(g.parent){if(this.items.has(g.parent)){const y=this.items.get(g.parent);y.children.add(g.item.extId);const I=this.createItem(g,y);this.items.set(g.item.extId,I),h.add(I)}}else{const y=this.createItem(g);this.roots.add(y),this.items.set(g.item.extId,y),h.add(y)}g.expand===2&&this.busyControllerCount++;break}case 1:{const g=d[1],y=this.items.get(g.extId);if(!y)break;g.expand!==void 0&&(y.expand===2&&this.busyControllerCount--,g.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(y,g),h.update(y);break}case 2:{const g=this.items.get(d[1]);if(!g)break;g.parent?this.items.get(g.parent).children.delete(g.item.extId):this.roots.delete(g);const y=[[d[1]]];for(;y.length;)for(const I of y.pop()){const _=this.items.get(I);_&&(y.push(_.children),this.items.delete(I),h.remove(_,_!==g),_.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(d[1]);break;case 3:this.updatePendingRoots(d[1]);break;case 5:this._tags.set(d[1].id,d[1]);break;case 6:this._tags.delete(d[1]);break}h.complete()}retireTest(c){}updatePendingRoots(c){this.pendingRootCount+=c}createChangeCollector(){return new A}}e.AbstractIncrementalTestCollection=n}),define(me[89],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var m;(function(C){C.Delimiter="\0"})(m=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class k{constructor(R,E=R.length){if(this.path=R,this.viewEnd=E,R.length===0||E<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(R,E,S=R.parent){if(R.id===E)return new k([E]);let A=[R.id];for(let n=S;n&&n.id!==E;n=n.parent)A.push(n.id);return A.push(E),new k(A.reverse())}static isRoot(R){return!R.includes("\0")}static fromString(R){return new k(R.split("\0"))}static join(R,E){return new k([...R.path,E])}static joinToString(R,E){return R.toString()+"\0"+E}static compare(R,E){return R===E?0:E.startsWith(R+"\0")?2:R.startsWith(E+"\0")?3:1}get parentId(){return this.viewEnd>1?new k(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let R=1;R<=this.viewEnd;R++)yield new k(this.path,R)}compare(R){if(typeof R=="string")return k.compare(this.toString(),R);for(let E=0;E<R.viewEnd&&E<this.viewEnd;E++)if(R.path[E]!==this.path[E])return 1;return R.viewEnd>this.viewEnd?2:R.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let R=1;R<this.viewEnd;R++)this.stringifed+="\0",this.stringifed+=this.path[R]}return this.stringifed}}e.TestId=k}),define(me[216],ge([0,1,8,38,13,25,11,79,178]),function(J,e,m,L,k,C,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class A{constructor(P,c,h){this._contributedVariables=new Map,this._context=P,this._labelService=c,h&&(this._envVariablesPromise=h.then(d=>this.prepareEnv(d)))}prepareEnv(P){if(R.isWindows){const c=Object.create(null);return Object.keys(P).forEach(h=>{c[h.toLowerCase()]=P[h]}),c}return P}resolveWithEnvironment(P,c,h){return this.recursiveResolve(this.prepareEnv(P),c?c.uri:void 0,h)}async resolveAsync(P,c){return this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,c)}async resolveAnyBase(P,c,h,d){const g=C.deepClone(c);return R.isWindows&&g.windows?Object.keys(g.windows).forEach(y=>g[y]=g.windows[y]):R.isMacintosh&&g.osx?Object.keys(g.osx).forEach(y=>g[y]=g.osx[y]):R.isLinux&&g.linux&&Object.keys(g.linux).forEach(y=>g[y]=g.linux[y]),delete g.windows,delete g.osx,delete g.linux,this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,g,h,d)}async resolveAnyAsync(P,c,h){return this.resolveAnyBase(P,c,h)}async resolveAnyMap(P,c,h){const d=new Map;return{newConfig:await this.resolveAnyBase(P,c,h,d),resolvedVariables:d}}resolveWithInteractionReplace(P,c,h,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,c,h,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,c){if(this._contributedVariables.has(P))throw new Error("Variable "+P+" is contributed twice.");this._contributedVariables.set(P,c)}recursiveResolve(P,c,h,d,g){if(k.isString(h))return this.resolveString(P,c,h,d,g);if(k.isArray(h))return h.map(y=>this.recursiveResolve(P,c,y,d,g));if(k.isObject(h)){let y=Object.create(null);return Object.keys(h).forEach(I=>{const _=this.resolveString(P,c,I,d,g);y[_]=this.recursiveResolve(P,c,h[I],d,g)}),y}return h}resolveString(P,c,h,d,g){return h.replace(A.VARIABLE_REGEXP,(I,_)=>{if(_.includes(A.VARIABLE_LHS))return I;let s=this.evaluateSingleVariable(P,I,_,c,d);return g&&g.set(_,s),s!==I&&k.isString(s)&&s.match(A.VARIABLE_REGEXP)&&(s=this.resolveString(P,c,s,d,g)),s})}fsPath(P){return this._labelService?this._labelService.getUriLabel(P,{noPrefix:!0}):P.fsPath}evaluateSingleVariable(P,c,h,d,g){let y;const I=h.split(":");I.length>1&&(h=I[0],y=I[1]);const _=()=>{const p=this._context.getFilePath();if(p)return p;throw new Error((0,S.localize)(0,null,c))},s=()=>{const p=_();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,S.localize)(1,null,c,m.basename(p)))},o=()=>{if(y){const p=this._context.getFolderUri(y);if(p)return p;throw new Error((0,S.localize)(2,null,c,y))}if(d)return d;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,c)):new Error((0,S.localize)(4,null,c))};switch(h){case"env":if(y){if(P){const p=P[R.isWindows?y.toLowerCase():y];if(k.isString(p))return p}return""}throw new Error((0,S.localize)(5,null,c));case"config":if(y){const p=this._context.getConfigurationValue(d,y);if(k.isUndefinedOrNull(p))throw new Error((0,S.localize)(6,null,c,y));if(k.isObject(p))throw new Error((0,S.localize)(7,null,c,y));return p}throw new Error((0,S.localize)(8,null,c));case"command":return this.resolveFromMap(c,y,g,"command");case"input":return this.resolveFromMap(c,y,g,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,E.normalizeDriveLetter)(this.fsPath(o()));case"cwd":return d||y?(0,E.normalizeDriveLetter)(this.fsPath(o())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return m.basename(this.fsPath(o()));case"lineNumber":const p=this._context.getLineNumber();if(p)return p;throw new Error((0,S.localize)(9,null,c));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,S.localize)(10,null,c));case"file":return _();case"fileWorkspaceFolder":return s();case"relativeFile":return d||y?m.relative(this.fsPath(o()),_()):_();case"relativeFileDirname":const a=m.dirname(_());if(d||y){const u=m.relative(this.fsPath(o()),a);return u.length===0?".":u}return a;case"fileDirname":return m.dirname(_());case"fileExtname":return m.extname(_());case"fileBasename":return m.basename(_());case"fileBasenameNoExtension":const r=m.basename(_());return r.slice(0,r.length-m.extname(r).length);case"fileDirnameBasename":return m.basename(m.dirname(_()));case"execPath":const i=this._context.getExecPath();return i||c;case"execInstallFolder":const l=this._context.getAppRoot();return l||c;case"pathSeparator":return m.sep;default:try{const u=y?`${h}:${y}`:h;return this.resolveFromMap(c,u,g,void 0)}catch(u){return c}}}}resolveFromMap(P,c,h,d){if(c&&h){const g=d===void 0?h[c]:h[d+":"+c];if(typeof g=="string")return g;throw new Error((0,S.localize)(11,null,P))}return P}}e.AbstractVariableResolverService=A,A.VARIABLE_LHS="${",A.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[128],ge([0,1,4,208]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,m.createDecorator)("editorGroupsService");var k;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var C;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var R;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(R=e.GroupLocation||(e.GroupLocation={}));var E;(function(g){g[g.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(E=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function A(g){const y=g;return(0,L.isEditorInput)(y?.editor)&&(0,L.isEditorInput)(y?.replacement)}e.isEditorReplacement=A;var n;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(n=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(g){g[g.GROUP_ACTIVE=0]="GROUP_ACTIVE",g[g.GROUP_INDEX=1]="GROUP_INDEX",g[g.GROUP_LOCKED=2]="GROUP_LOCKED",g[g.EDITOR_OPEN=3]="EDITOR_OPEN",g[g.EDITOR_CLOSE=4]="EDITOR_CLOSE",g[g.EDITOR_MOVE=5]="EDITOR_MOVE",g[g.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",g[g.EDITOR_LABEL=7]="EDITOR_LABEL",g[g.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",g[g.EDITOR_PIN=9]="EDITOR_PIN",g[g.EDITOR_STICKY=10]="EDITOR_STICKY",g[g.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(P=e.GroupChangeKind||(e.GroupChangeKind={}));var c;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(c=e.OpenEditorContext||(e.OpenEditorContext={}));function h(g){const y=g;return!!y&&typeof y.id=="number"&&Array.isArray(y.editors)}e.isEditorGroup=h;function d(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=d}),define(me[217],ge([0,1,4,128]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,m.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(C){const R=C;return typeof C=="number"||(0,L.isEditorGroup)(R)}e.isPreferredGroup=k}),define(me[15],ge([0,1,17,23,99,292,60,25,13,2,41,83,179,117,64,126,89,217,7]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g,y,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(ae){function Ee(q){const{selectionStartLineNumber:Te,selectionStartColumn:Pe,positionLineNumber:Ze,positionColumn:Xe}=q,st=new _.Position(Te-1,Pe-1),wt=new _.Position(Ze-1,Xe-1);return new _.Selection(st,wt)}ae.to=Ee;function ce(q){const{anchor:Te,active:Pe}=q;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:Pe.line+1,positionColumn:Pe.character+1}}ae.from=ce})(s=e.Selection||(e.Selection={}));var o;(function(ae){function Ee(q){if(!q)return;const{start:Te,end:Pe}=q;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:Pe.line+1,endColumn:Pe.character+1}}ae.from=Ee;function ce(q){if(!q)return;const{startLineNumber:Te,startColumn:Pe,endLineNumber:Ze,endColumn:Xe}=q;return new _.Range(Te-1,Pe-1,Ze-1,Xe-1)}ae.to=ce})(o=e.Range||(e.Range={}));var p;(function(ae){function Ee(ce){switch(ce){case 1:return _.StandardTokenType.Comment;case 0:return _.StandardTokenType.Other;case 4:return _.StandardTokenType.RegEx;case 2:return _.StandardTokenType.String}}ae.to=Ee})(p=e.TokenType||(e.TokenType={}));var t;(function(ae){function Ee(q){return new _.Position(q.lineNumber-1,q.column-1)}ae.to=Ee;function ce(q){return{lineNumber:q.line+1,column:q.character+1}}ae.from=ce})(t=e.Position||(e.Position={}));var a;(function(ae){function Ee(q){switch(q){case _.DiagnosticTag.Unnecessary:return 1;case _.DiagnosticTag.Deprecated:return 2}}ae.from=Ee;function ce(q){switch(q){case 1:return _.DiagnosticTag.Unnecessary;case 2:return _.DiagnosticTag.Deprecated;default:return}}ae.to=ce})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(ae){function Ee(q){let Te;return q.code&&((0,S.isString)(q.code)||(0,S.isNumber)(q.code)?Te=String(q.code):Te={value:String(q.code.value),target:q.code.target}),{...o.from(q.range),message:q.message,source:q.source,code:Te,severity:l.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(i.from),tags:Array.isArray(q.tags)?(0,m.coalesce)(q.tags.map(a.from)):void 0}}ae.from=Ee;function ce(q){const Te=new _.Diagnostic(o.to(q),q.message,l.to(q.severity));return Te.source=q.source,Te.code=(0,S.isString)(q.code)?q.code:q.code?.value,Te.relatedInformation=q.relatedInformation&&q.relatedInformation.map(i.to),Te.tags=q.tags&&(0,m.coalesce)(q.tags.map(a.to)),Te}ae.to=ce})(r=e.Diagnostic||(e.Diagnostic={}));var i;(function(ae){function Ee(q){return{...o.from(q.location.range),message:q.message,resource:q.location.uri}}ae.from=Ee;function ce(q){return new _.DiagnosticRelatedInformation(new _.Location(q.resource,o.to(q)),q.message)}ae.to=ce})(i=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var l;(function(ae){function Ee(q){switch(q){case _.DiagnosticSeverity.Error:return h.MarkerSeverity.Error;case _.DiagnosticSeverity.Warning:return h.MarkerSeverity.Warning;case _.DiagnosticSeverity.Information:return h.MarkerSeverity.Info;case _.DiagnosticSeverity.Hint:return h.MarkerSeverity.Hint}return h.MarkerSeverity.Error}ae.from=Ee;function ce(q){switch(q){case h.MarkerSeverity.Info:return _.DiagnosticSeverity.Information;case h.MarkerSeverity.Warning:return _.DiagnosticSeverity.Warning;case h.MarkerSeverity.Error:return _.DiagnosticSeverity.Error;case h.MarkerSeverity.Hint:return _.DiagnosticSeverity.Hint;default:return _.DiagnosticSeverity.Error}}ae.to=ce})(l=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var u;(function(ae){function Ee(q){return typeof q=="number"&&q>=_.ViewColumn.One?q-1:q===_.ViewColumn.Beside?I.SIDE_GROUP:I.ACTIVE_GROUP}ae.from=Ee;function ce(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}ae.to=ce})(u=e.ViewColumn||(e.ViewColumn={}));function f(ae){return typeof ae.range!="undefined"}function b(ae){return ae.length===0?!0:!!f(ae[0])}e.isDecorationOptionsArr=b;var D;(function(ae){function Ee(Xe){return Xe.map(ae.from)}ae.fromMany=Ee;function ce(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function q(Xe){let st;if(ce(Xe)){const{language:gt,value:ft}=Xe;st={value:"```"+gt+`
`+ft+"\n```\n"}}else _.MarkdownString.isMarkdownString(Xe)?st={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons,supportHtml:Xe.supportHtml}:typeof Xe=="string"?st={value:Xe}:st={value:""};const wt=Object.create(null);st.uris=wt;const _t=gt=>{try{let ft=A.URI.parse(gt,!0);ft=ft.with({query:Te(ft.query,wt)}),wt[gt]=ft}catch(ft){}return""},dt=new C.Renderer;return dt.link=_t,dt.image=gt=>_t(k.parseHrefAndDimensions(gt).href),C(st.value,{renderer:dt}),st}ae.from=q;function Te(Xe,st){if(!Xe)return Xe;let wt;try{wt=(0,R.parse)(Xe)}catch(dt){}if(!wt)return Xe;let _t=!1;return wt=(0,E.cloneAndChange)(wt,dt=>{if(A.URI.isUri(dt)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return st[gt]=dt,_t=!0,gt}else return}),_t?JSON.stringify(wt):Xe}function Pe(Xe){const st=new _.MarkdownString(Xe.value,Xe.supportThemeIcons);return st.isTrusted=Xe.isTrusted,st.supportHtml=Xe.supportHtml,st}ae.to=Pe;function Ze(Xe){if(!!Xe)return typeof Xe=="string"?Xe:ae.from(Xe)}ae.fromStrict=Ze})(D=e.MarkdownString||(e.MarkdownString={}));function w(ae){return b(ae)?ae.map(Ee=>({range:o.from(Ee.range),hoverMessage:Array.isArray(Ee.hoverMessage)?D.fromMany(Ee.hoverMessage):Ee.hoverMessage?D.from(Ee.hoverMessage):void 0,renderOptions:Ee.renderOptions})):ae.map(Ee=>({range:o.from(Ee)}))}e.fromRangeOrRangeWithMessage=w;function T(ae){return typeof ae=="undefined"?ae:typeof ae=="string"?A.URI.file(ae):ae}e.pathOrURIToURI=T;var v;(function(ae){function Ee(ce){return typeof ce=="undefined"?ce:{contentText:ce.contentText,contentIconPath:ce.contentIconPath?T(ce.contentIconPath):void 0,border:ce.border,borderColor:ce.borderColor,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,color:ce.color,backgroundColor:ce.backgroundColor,margin:ce.margin,width:ce.width,height:ce.height}}ae.from=Ee})(v=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(ae){function Ee(ce){return typeof ce=="undefined"?ce:{backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?T(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?v.from(ce.before):void 0,after:ce.after?v.from(ce.after):void 0}}ae.from=Ee})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var M;(function(ae){function Ee(ce){if(typeof ce=="undefined")return ce;switch(ce){case _.DecorationRangeBehavior.OpenOpen:return 0;case _.DecorationRangeBehavior.ClosedClosed:return 1;case _.DecorationRangeBehavior.OpenClosed:return 2;case _.DecorationRangeBehavior.ClosedOpen:return 3}}ae.from=Ee})(M=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var G;(function(ae){function Ee(ce){return{isWholeLine:ce.isWholeLine,rangeBehavior:ce.rangeBehavior?M.from(ce.rangeBehavior):void 0,overviewRulerLane:ce.overviewRulerLane,light:ce.light?F.from(ce.light):void 0,dark:ce.dark?F.from(ce.dark):void 0,backgroundColor:ce.backgroundColor,outline:ce.outline,outlineColor:ce.outlineColor,outlineStyle:ce.outlineStyle,outlineWidth:ce.outlineWidth,border:ce.border,borderColor:ce.borderColor,borderRadius:ce.borderRadius,borderSpacing:ce.borderSpacing,borderStyle:ce.borderStyle,borderWidth:ce.borderWidth,fontStyle:ce.fontStyle,fontWeight:ce.fontWeight,textDecoration:ce.textDecoration,cursor:ce.cursor,color:ce.color,opacity:ce.opacity,letterSpacing:ce.letterSpacing,gutterIconPath:ce.gutterIconPath?T(ce.gutterIconPath):void 0,gutterIconSize:ce.gutterIconSize,overviewRulerColor:ce.overviewRulerColor,before:ce.before?v.from(ce.before):void 0,after:ce.after?v.from(ce.after):void 0}}ae.from=Ee})(G=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var K;(function(ae){function Ee(q){return{text:q.newText,eol:q.newEol&&te.from(q.newEol),range:o.from(q.range)}}ae.from=Ee;function ce(q){const Te=new _.TextEdit(o.to(q.range),q.text);return Te.newEol=typeof q.eol=="undefined"?void 0:te.to(q.eol),Te}ae.to=ce})(K=e.TextEdit||(e.TextEdit={}));var U;(function(ae){function Ee(q,Te,Pe){const Ze={edits:[]};if(q instanceof _.WorkspaceEdit)for(let Xe of q._allEntries())if(Xe._type===1)Ze.edits.push({_type:1,oldUri:Xe.from,newUri:Xe.to,options:Xe.options,metadata:Xe.metadata});else if(Xe._type===2){const st=Te?.getDocument(Xe.uri);Ze.edits.push({_type:2,resource:Xe.uri,edit:K.from(Xe.edit),modelVersionId:st?.version,metadata:Xe.metadata})}else Xe._type===3?Ze.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:Pe?.getNotebookDocument(Xe.uri,!0)?.apiNotebook.version}):Xe._type===5&&Ze.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:Pe?.getNotebookDocument(Xe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(Ke.from)}});return Ze}ae.from=Ee;function ce(q){const Te=new _.WorkspaceEdit;for(const Pe of q.edits)Pe.edit?Te.replace(A.URI.revive(Pe.resource),o.to(Pe.edit.range),Pe.edit.text):Te.renameFile(A.URI.revive(Pe.oldUri),A.URI.revive(Pe.newUri),Pe.options);return Te}ae.to=ce})(U=e.WorkspaceEdit||(e.WorkspaceEdit={}));var z;(function(ae){const Ee=Object.create(null);Ee[_.SymbolKind.File]=0,Ee[_.SymbolKind.Module]=1,Ee[_.SymbolKind.Namespace]=2,Ee[_.SymbolKind.Package]=3,Ee[_.SymbolKind.Class]=4,Ee[_.SymbolKind.Method]=5,Ee[_.SymbolKind.Property]=6,Ee[_.SymbolKind.Field]=7,Ee[_.SymbolKind.Constructor]=8,Ee[_.SymbolKind.Enum]=9,Ee[_.SymbolKind.Interface]=10,Ee[_.SymbolKind.Function]=11,Ee[_.SymbolKind.Variable]=12,Ee[_.SymbolKind.Constant]=13,Ee[_.SymbolKind.String]=14,Ee[_.SymbolKind.Number]=15,Ee[_.SymbolKind.Boolean]=16,Ee[_.SymbolKind.Array]=17,Ee[_.SymbolKind.Object]=18,Ee[_.SymbolKind.Key]=19,Ee[_.SymbolKind.Null]=20,Ee[_.SymbolKind.EnumMember]=21,Ee[_.SymbolKind.Struct]=22,Ee[_.SymbolKind.Event]=23,Ee[_.SymbolKind.Operator]=24,Ee[_.SymbolKind.TypeParameter]=25;function ce(Te){return typeof Ee[Te]=="number"?Ee[Te]:6}ae.from=ce;function q(Te){for(const Pe in Ee)if(Ee[Pe]===Te)return Number(Pe);return _.SymbolKind.Property}ae.to=q})(z=e.SymbolKind||(e.SymbolKind={}));var N;(function(ae){function Ee(q){switch(q){case _.SymbolTag.Deprecated:return 1}}ae.from=Ee;function ce(q){switch(q){case 1:return _.SymbolTag.Deprecated}}ae.to=ce})(N=e.SymbolTag||(e.SymbolTag={}));var x;(function(ae){function Ee(q){return{name:q.name,kind:z.from(q.kind),tags:q.tags&&q.tags.map(N.from),containerName:q.containerName,location:Q.from(q.location)}}ae.from=Ee;function ce(q){const Te=new _.SymbolInformation(q.name,z.to(q.kind),q.containerName,Q.to(q.location));return Te.tags=q.tags&&q.tags.map(N.to),Te}ae.to=ce})(x=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var B;(function(ae){function Ee(q){const Te={name:q.name||"!!MISSING: name!!",detail:q.detail,range:o.from(q.range),selectionRange:o.from(q.selectionRange),kind:z.from(q.kind),tags:q.tags?.map(N.from)??[]};return q.children&&(Te.children=q.children.map(Ee)),Te}ae.from=Ee;function ce(q){const Te=new _.DocumentSymbol(q.name,q.detail,z.to(q.kind),o.to(q.range),o.to(q.selectionRange));return(0,m.isNonEmptyArray)(q.tags)&&(Te.tags=q.tags.map(N.to)),q.children&&(Te.children=q.children.map(ce)),Te}ae.to=ce})(B=e.DocumentSymbol||(e.DocumentSymbol={}));var O;(function(ae){function Ee(q){const Te=new _.CallHierarchyItem(z.to(q.kind),q.name,q.detail||"",A.URI.revive(q.uri),o.to(q.range),o.to(q.selectionRange));return Te._sessionId=q._sessionId,Te._itemId=q._itemId,Te}ae.to=Ee;function ce(q,Te,Pe){if(Te=Te??q._sessionId,Pe=Pe??q._itemId,Te===void 0||Pe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Pe,name:q.name,detail:q.detail,kind:z.from(q.kind),uri:q.uri,range:o.from(q.range),selectionRange:o.from(q.selectionRange),tags:q.tags?.map(N.from)}}ae.from=ce})(O=e.CallHierarchyItem||(e.CallHierarchyItem={}));var H;(function(ae){function Ee(ce){return new _.CallHierarchyIncomingCall(O.to(ce.from),ce.fromRanges.map(q=>o.to(q)))}ae.to=Ee})(H=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var W;(function(ae){function Ee(ce){return new _.CallHierarchyOutgoingCall(O.to(ce.to),ce.fromRanges.map(q=>o.to(q)))}ae.to=Ee})(W=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Q;(function(ae){function Ee(q){return{range:q.range&&o.from(q.range),uri:q.uri}}ae.from=Ee;function ce(q){return new _.Location(A.URI.revive(q.uri),o.to(q.range))}ae.to=ce})(Q=e.location||(e.location={}));var Y;(function(ae){function Ee(q){const Te=q,Pe=q;return{originSelectionRange:Te.originSelectionRange?o.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:Pe.uri,range:o.from(Te.targetRange?Te.targetRange:Pe.range),targetSelectionRange:Te.targetSelectionRange?o.from(Te.targetSelectionRange):void 0}}ae.from=Ee;function ce(q){return{targetUri:A.URI.revive(q.uri),targetRange:o.to(q.range),targetSelectionRange:q.targetSelectionRange?o.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?o.to(q.originSelectionRange):void 0}}ae.to=ce})(Y=e.DefinitionLink||(e.DefinitionLink={}));var he;(function(ae){function Ee(q){return{range:o.from(q.range),contents:D.fromMany(q.contents)}}ae.from=Ee;function ce(q){return new _.Hover(q.contents.map(D.to),o.to(q.range))}ae.to=ce})(he=e.Hover||(e.Hover={}));var _e;(function(ae){function Ee(q){return{range:o.from(q.range),expression:q.expression}}ae.from=Ee;function ce(q){return new _.EvaluatableExpression(o.to(q.range),q.expression)}ae.to=ce})(_e=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Se;(function(ae){function Ee(q){if(q instanceof _.InlineValueText)return{type:"text",range:o.from(q.range),text:q.text};if(q instanceof _.InlineValueVariableLookup)return{type:"variable",range:o.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof _.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}ae.from=Ee;function ce(q){switch(q.type){case"text":return{range:o.to(q.range),text:q.text};case"variable":return{range:o.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:o.to(q.range),expression:q.expression}}}ae.to=ce})(Se=e.InlineValue||(e.InlineValue={}));var Re;(function(ae){function Ee(q){return{frameId:q.frameId,stoppedLocation:o.from(q.stoppedLocation)}}ae.from=Ee;function ce(q){return new _.InlineValueContext(q.frameId,o.to(q.stoppedLocation))}ae.to=ce})(Re=e.InlineValueContext||(e.InlineValueContext={}));var xe;(function(ae){function Ee(q){return{range:o.from(q.range),kind:q.kind}}ae.from=Ee;function ce(q){return new _.DocumentHighlight(o.to(q.range),q.kind)}ae.to=ce})(xe=e.DocumentHighlight||(e.DocumentHighlight={}));var Ue;(function(ae){function Ee(ce){switch(ce){case 1:return _.CompletionTriggerKind.TriggerCharacter;case 2:return _.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return _.CompletionTriggerKind.Invoke}}ae.to=Ee})(Ue=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var je;(function(ae){function Ee(ce){return{triggerKind:Ue.to(ce.triggerKind),triggerCharacter:ce.triggerCharacter}}ae.to=Ee})(je=e.CompletionContext||(e.CompletionContext={}));var V;(function(ae){function Ee(q){switch(q){case _.CompletionItemTag.Deprecated:return 1}}ae.from=Ee;function ce(q){switch(q){case 1:return _.CompletionItemTag.Deprecated}}ae.to=ce})(V=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(ae){const Ee=new Map([[_.CompletionItemKind.Method,0],[_.CompletionItemKind.Function,1],[_.CompletionItemKind.Constructor,2],[_.CompletionItemKind.Field,3],[_.CompletionItemKind.Variable,4],[_.CompletionItemKind.Class,5],[_.CompletionItemKind.Interface,7],[_.CompletionItemKind.Struct,6],[_.CompletionItemKind.Module,8],[_.CompletionItemKind.Property,9],[_.CompletionItemKind.Unit,12],[_.CompletionItemKind.Value,13],[_.CompletionItemKind.Constant,14],[_.CompletionItemKind.Enum,15],[_.CompletionItemKind.EnumMember,16],[_.CompletionItemKind.Keyword,17],[_.CompletionItemKind.Snippet,27],[_.CompletionItemKind.Text,18],[_.CompletionItemKind.Color,19],[_.CompletionItemKind.File,20],[_.CompletionItemKind.Reference,21],[_.CompletionItemKind.Folder,23],[_.CompletionItemKind.Event,10],[_.CompletionItemKind.Operator,11],[_.CompletionItemKind.TypeParameter,24],[_.CompletionItemKind.Issue,26],[_.CompletionItemKind.User,25]]);function ce(Pe){return Ee.get(Pe)??9}ae.from=ce;const q=new Map([[0,_.CompletionItemKind.Method],[1,_.CompletionItemKind.Function],[2,_.CompletionItemKind.Constructor],[3,_.CompletionItemKind.Field],[4,_.CompletionItemKind.Variable],[5,_.CompletionItemKind.Class],[7,_.CompletionItemKind.Interface],[6,_.CompletionItemKind.Struct],[8,_.CompletionItemKind.Module],[9,_.CompletionItemKind.Property],[12,_.CompletionItemKind.Unit],[13,_.CompletionItemKind.Value],[14,_.CompletionItemKind.Constant],[15,_.CompletionItemKind.Enum],[16,_.CompletionItemKind.EnumMember],[17,_.CompletionItemKind.Keyword],[27,_.CompletionItemKind.Snippet],[18,_.CompletionItemKind.Text],[19,_.CompletionItemKind.Color],[20,_.CompletionItemKind.File],[21,_.CompletionItemKind.Reference],[23,_.CompletionItemKind.Folder],[10,_.CompletionItemKind.Event],[11,_.CompletionItemKind.Operator],[24,_.CompletionItemKind.TypeParameter],[25,_.CompletionItemKind.User],[26,_.CompletionItemKind.Issue]]);function Te(Pe){return q.get(Pe)??_.CompletionItemKind.Property}ae.to=Te})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var re;(function(ae){function Ee(ce,q){const Te=new _.CompletionItem(ce.label);return Te.insertText=ce.insertText,Te.kind=ee.to(ce.kind),Te.tags=ce.tags?.map(V.to),Te.detail=ce.detail,Te.documentation=k.isMarkdownString(ce.documentation)?D.to(ce.documentation):ce.documentation,Te.sortText=ce.sortText,Te.filterText=ce.filterText,Te.preselect=ce.preselect,Te.commitCharacters=ce.commitCharacters,n.Range.isIRange(ce.range)?Te.range=o.to(ce.range):typeof ce.range=="object"&&(Te.range={inserting:o.to(ce.range.insert),replacing:o.to(ce.range.replace)}),Te.keepWhitespace=typeof ce.insertTextRules=="undefined"?!1:Boolean(ce.insertTextRules&1),typeof ce.insertTextRules!="undefined"&&ce.insertTextRules&4?Te.insertText=new _.SnippetString(ce.insertText):(Te.insertText=ce.insertText,Te.textEdit=Te.range instanceof _.Range?new _.TextEdit(Te.range,Te.insertText):void 0),ce.additionalTextEdits&&ce.additionalTextEdits.length>0&&(Te.additionalTextEdits=ce.additionalTextEdits.map(Pe=>K.to(Pe))),Te.command=q&&ce.command?q.fromInternal(ce.command):void 0,Te}ae.to=Ee})(re=e.CompletionItem||(e.CompletionItem={}));var le;(function(ae){function Ee(q){return{label:q.label,documentation:q.documentation?D.fromStrict(q.documentation):void 0}}ae.from=Ee;function ce(q){return{label:q.label,documentation:k.isMarkdownString(q.documentation)?D.to(q.documentation):q.documentation}}ae.to=ce})(le=e.ParameterInformation||(e.ParameterInformation={}));var Z;(function(ae){function Ee(q){return{label:q.label,documentation:q.documentation?D.fromStrict(q.documentation):void 0,parameters:Array.isArray(q.parameters)?q.parameters.map(le.from):[],activeParameter:q.activeParameter}}ae.from=Ee;function ce(q){return{label:q.label,documentation:k.isMarkdownString(q.documentation)?D.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(le.to):[],activeParameter:q.activeParameter}}ae.to=ce})(Z=e.SignatureInformation||(e.SignatureInformation={}));var oe;(function(ae){function Ee(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(Z.from):[]}}ae.from=Ee;function ce(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(Z.to):[]}}ae.to=ce})(oe=e.SignatureHelp||(e.SignatureHelp={}));var ve;(function(ae){function Ee(q){return{text:q.text,position:t.from(q.position),kind:Me.from(q.kind??_.InlayHintKind.Other),whitespaceBefore:q.whitespaceBefore,whitespaceAfter:q.whitespaceAfter}}ae.from=Ee;function ce(q){const Te=new _.InlayHint(q.text,t.to(q.position),Me.to(q.kind));return Te.whitespaceAfter=q.whitespaceAfter,Te.whitespaceBefore=q.whitespaceBefore,Te}ae.to=ce})(ve=e.InlayHint||(e.InlayHint={}));var Me;(function(ae){function Ee(q){return q}ae.from=Ee;function ce(q){return q}ae.to=ce})(Me=e.InlayHintKind||(e.InlayHintKind={}));var qe;(function(ae){function Ee(q){return{range:o.from(q.range),url:q.target,tooltip:q.tooltip}}ae.from=Ee;function ce(q){let Te;if(q.url)try{Te=typeof q.url=="string"?A.URI.parse(q.url,!0):A.URI.revive(q.url)}catch(Pe){}return new _.DocumentLink(o.to(q.range),Te)}ae.to=ce})(qe=e.DocumentLink||(e.DocumentLink={}));var Qe;(function(ae){function Ee(q){const Te=new _.ColorPresentation(q.label);return q.textEdit&&(Te.textEdit=K.to(q.textEdit)),q.additionalTextEdits&&(Te.additionalTextEdits=q.additionalTextEdits.map(Pe=>K.to(Pe))),Te}ae.to=Ee;function ce(q){return{label:q.label,textEdit:q.textEdit?K.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Te=>K.from(Te)):void 0}}ae.from=ce})(Qe=e.ColorPresentation||(e.ColorPresentation={}));var Je;(function(ae){function Ee(q){return new _.Color(q[0],q[1],q[2],q[3])}ae.to=Ee;function ce(q){return[q.red,q.green,q.blue,q.alpha]}ae.from=ce})(Je=e.Color||(e.Color={}));var Ce;(function(ae){function Ee(q){return{range:o.from(q.range)}}ae.from=Ee;function ce(q){return new _.SelectionRange(o.to(q.range))}ae.to=ce})(Ce=e.SelectionRange||(e.SelectionRange={}));var at;(function(ae){function Ee(ce){switch(ce){case 2:return _.TextDocumentSaveReason.AfterDelay;case 1:return _.TextDocumentSaveReason.Manual;case 3:case 4:return _.TextDocumentSaveReason.FocusOut}}ae.to=Ee})(at=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var X;(function(ae){function Ee(q){switch(q){case _.TextEditorLineNumbersStyle.Off:return 0;case _.TextEditorLineNumbersStyle.Relative:return 2;case _.TextEditorLineNumbersStyle.On:default:return 1}}ae.from=Ee;function ce(q){switch(q){case 0:return _.TextEditorLineNumbersStyle.Off;case 2:return _.TextEditorLineNumbersStyle.Relative;case 1:default:return _.TextEditorLineNumbersStyle.On}}ae.to=ce})(X=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var te;(function(ae){function Ee(q){if(q===_.EndOfLine.CRLF)return 1;if(q===_.EndOfLine.LF)return 0}ae.from=Ee;function ce(q){if(q===1)return _.EndOfLine.CRLF;if(q===0)return _.EndOfLine.LF}ae.to=ce})(te=e.EndOfLine||(e.EndOfLine={}));var pe;(function(ae){function Ee(ce){if(typeof ce=="object")return ce.viewId;switch(ce){case _.ProgressLocation.SourceControl:return 3;case _.ProgressLocation.Window:return 10;case _.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ae.from=Ee})(pe=e.ProgressLocation||(e.ProgressLocation={}));var ze;(function(ae){function Ee(ce){const q={start:ce.start+1,end:ce.end+1};return ce.kind&&(q.kind=tt.from(ce.kind)),q}ae.from=Ee})(ze=e.FoldingRange||(e.FoldingRange={}));var tt;(function(ae){function Ee(ce){if(ce)switch(ce){case _.FoldingRangeKind.Comment:return P.FoldingRangeKind.Comment;case _.FoldingRangeKind.Imports:return P.FoldingRangeKind.Imports;case _.FoldingRangeKind.Region:return P.FoldingRangeKind.Region}}ae.from=Ee})(tt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ut;(function(ae){function Ee(ce){if(ce)return{pinned:typeof ce.preview=="boolean"?!ce.preview:void 0,inactive:ce.background,preserveFocus:ce.preserveFocus,selection:typeof ce.selection=="object"?o.from(ce.selection):void 0,override:typeof ce.override=="boolean"?c.EditorResolution.DISABLED:void 0}}ae.from=Ee})(ut=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var lt;(function(ae){function Ee(q){return q instanceof _.RelativePattern||typeof q=="string"?q:ce(q)?new _.RelativePattern(q.base,q.pattern):q}ae.from=Ee;function ce(q){const Te=q;return Te&&typeof Te.base=="string"&&typeof Te.pattern=="string"}})(lt=e.GlobPattern||(e.GlobPattern={}));var vt;(function(ae){function Ee(ce){if(ce){if(Array.isArray(ce))return ce.map(Ee);if(typeof ce=="string")return ce;{const q=ce;return{language:q.language,scheme:q.scheme,pattern:typeof q.pattern=="undefined"?void 0:lt.from(q.pattern),exclusive:q.exclusive}}}else return}ae.from=Ee})(vt=e.LanguageSelector||(e.LanguageSelector={}));var Dt;(function(ae){function Ee(q){return{start:q.start,end:q.end}}ae.from=Ee;function ce(q){return new _.NotebookRange(q.start,q.end)}ae.to=ce})(Dt=e.NotebookRange||(e.NotebookRange={}));var ue;(function(ae){function Ee(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}ae.to=Ee;function ce(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}ae.from=ce})(ue=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ie;(function(ae){function Ee(q){switch(q){case _.NotebookCellKind.Markup:return g.CellKind.Markup;case _.NotebookCellKind.Code:default:return g.CellKind.Code}}ae.from=Ee;function ce(q){switch(q){case g.CellKind.Markup:return _.NotebookCellKind.Markup;case g.CellKind.Code:default:return _.NotebookCellKind.Code}}ae.to=ce})(Ie=e.NotebookCellKind||(e.NotebookCellKind={}));var Be;(function(ae){function Ee(q){const Te={metadata:q.metadata??Object.create(null),cells:[]};for(let Pe of q.cells)_.NotebookCellData.validate(Pe),Te.cells.push(Ke.from(Pe));return Te}ae.from=Ee;function ce(q){const Te=new _.NotebookData(q.cells.map(Ke.to));return(0,S.isEmptyObject)(q.metadata)||(Te.metadata=q.metadata),Te}ae.to=ce})(Be=e.NotebookData||(e.NotebookData={}));var Ke;(function(ae){function Ee(q){return{cellKind:Ie.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:ue.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(ot.from):[]}}ae.from=Ee;function ce(q){return new _.NotebookCellData(Ie.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(ot.to):void 0,q.metadata,q.internalMetadata?ue.to(q.internalMetadata):void 0)}ae.to=ce})(Ke=e.NotebookCellData||(e.NotebookCellData={}));var We;(function(ae){function Ee(q){return{mime:q.mime,valueBytes:L.VSBuffer.wrap(q.data)}}ae.from=Ee;function ce(q){return new _.NotebookCellOutputItem(q.valueBytes.buffer,q.mime)}ae.to=ce})(We=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ot;(function(ae){function Ee(q){return{outputId:q.id,items:q.items.map(We.from),metadata:q.metadata}}ae.from=Ee;function ce(q){const Te=q.items.map(We.to);return new _.NotebookCellOutput(Te,q.outputId,q.metadata)}ae.to=ce})(ot=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Le;(function(ae){function Ee(Pe){if(Pe!=null){if(Pe instanceof _.RelativePattern||typeof Pe=="string")return Pe;if(Te(Pe))return new _.RelativePattern(Pe.base,Pe.pattern);if(q(Pe))return{include:lt.from(Pe.include)||void 0,exclude:lt.from(Pe.exclude)||void 0}}}ae.from=Ee;function ce(Pe){return typeof Pe=="string"?Pe:Te(Pe)?{base:Pe.base,pattern:Pe.pattern}:{include:Pe.include,exclude:Pe.exclude}}ae.to=ce;function q(Pe){const Ze=Pe,Xe=lt.from(Ze.include);if(!(Xe&&Xe instanceof _.RelativePattern||typeof Xe=="string"))return!1;const st=lt.from(Ze.exclude);return!!(st&&st instanceof _.RelativePattern||typeof st=="string")}function Te(Pe){const Ze=Pe;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(Le=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ye;(function(ae){function Ee(ce){return{backgroundColor:ce.backgroundColor,borderColor:ce.borderColor,top:ce.top?v.from(ce.top):void 0}}ae.from=Ee})(ye=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ke;(function(ae){function Ee(ce,q,Te){const Pe=typeof ce.command=="string"?{title:"",command:ce.command}:ce.command;return{alignment:ce.alignment===_.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Pe,Te),text:ce.text,tooltip:ce.tooltip,accessibilityInformation:ce.accessibilityInformation,priority:ce.priority}}ae.from=Ee})(ke=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ne;(function(ae){function Ee(ce){return{transientOutputs:ce?.transientOutputs??!1,transientCellMetadata:ce?.transientCellMetadata??{},transientDocumentMetadata:ce?.transientDocumentMetadata??{}}}ae.from=Ee})(ne=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var de;(function(ae){function Ee(q){return{uri:q.uri,provides:q.provides}}ae.from=Ee;function ce(q){return new _.NotebookRendererScript(A.URI.revive(q.uri),q.provides)}ae.to=ce})(de=e.NotebookRendererScript||(e.NotebookRendererScript={}));var be;(function(ae){function Ee(q){return{message:D.fromStrict(q.message)||"",type:0,expected:q.expectedOutput,actual:q.actualOutput,location:q.location?Q.from(q.location):void 0}}ae.from=Ee;function ce(q){const Te=new _.TestMessage(typeof q.message=="string"?q.message:D.to(q.message));return Te.actualOutput=q.actual,Te.expectedOutput=q.expected,Te.location=q.location?Q.to(q.location):void 0,Te}ae.to=ce})(be=e.TestMessage||(e.TestMessage={}));var we;(function(ae){let Ee;(function(ce){ce.Delimiter="\0"})(Ee||(Ee={})),ae.namespace=(ce,q)=>ce+"\0"+q,ae.denamespace=ce=>{const q=ce.indexOf("\0");return{ctrlId:ce.slice(0,q),tagId:ce.slice(q+1)}}})(we=e.TestTag||(e.TestTag={}));var Fe;(function(ae){function Ee(Pe){const Ze=(0,d.getPrivateApiFor)(Pe).controllerId;return{extId:y.TestId.fromExtHostTestItem(Pe,Ze).toString(),label:Pe.label,uri:Pe.uri,tags:Pe.tags.map(Xe=>we.namespace(Ze,Xe.id)),range:o.from(Pe.range)||null,description:Pe.description||null,error:Pe.error&&D.fromStrict(Pe.error)||null}}ae.from=Ee;function ce(Pe){return{id:y.TestId.fromString(Pe.extId).localId,label:Pe.label,uri:A.URI.revive(Pe.uri),tags:(Pe.tags||[]).map(Ze=>{const{tagId:Xe}=we.denamespace(Ze);return new _.TestTag(Xe)}),range:o.to(Pe.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Pe.description||void 0}}ae.toPlain=ce;function q(Pe){const Ze=y.TestId.fromString(Pe.extId),Xe=new d.TestItemImpl(Ze.controllerId,Ze.localId,Pe.label,A.URI.revive(Pe.uri));return Xe.range=o.to(Pe.range||void 0),Xe.description=Pe.description||void 0,Xe}function Te(Pe){let Ze;for(const Xe of Pe.tests){const st=q(Xe.item);(0,d.getPrivateApiFor)(st).parent=Ze,Ze=st}return Ze}ae.toItemFromContext=Te})(Fe=e.TestItem||(e.TestItem={})),function(ae){function Ee(q){return{id:q.id}}ae.from=Ee;function ce(q){return new _.TestTag(q.id)}ae.to=ce}(we=e.TestTag||(e.TestTag={}));var Ge;(function(ae){const Ee=(q,Te)=>{const Pe={...Fe.toPlain(q.item),parent:void 0,taskStates:q.tasks.map(Ze=>({state:Ze.state,duration:Ze.duration,messages:Ze.messages.filter(Xe=>Xe.type===0).map(be.to)})),children:q.children.map(Ze=>Te.get(Ze)).filter(S.isDefined).map(Ze=>Ee(Ze,Te))};for(const Ze of Pe.children)Ze.parent=Pe;return Pe};function ce(q){const Te=[],Pe=new Map;for(const Ze of q.items)Pe.set(Ze.item.extId,Ze),q.request.targets.some(Xe=>Xe.controllerId===Ze.controllerId&&Xe.testIds.includes(Ze.item.extId))&&Te.push(Ze);return{completedAt:q.completedAt,results:Te.map(Ze=>Ee(Ze,Pe))}}ae.to=ce})(Ge=e.TestResults||(e.TestResults={}));var He;(function(ae){function Ee(Pe){return{covered:Pe.covered,total:Pe.covered}}function ce(Pe){return"line"in Pe?t.from(Pe):o.from(Pe)}function q(Pe){return"branches"in Pe?{count:Pe.executionCount,location:ce(Pe.location),type:1,branches:Pe.branches.length?Pe.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&ce(Ze.location)})):void 0}:{type:0,count:Pe.executionCount,location:ce(Pe.location)}}ae.fromDetailed=q;function Te(Pe){return{uri:Pe.uri,statement:Ee(Pe.statementCoverage),branch:Pe.branchCoverage&&Ee(Pe.branchCoverage),function:Pe.functionCoverage&&Ee(Pe.functionCoverage),details:Pe.detailedCoverage?.map(q)}}ae.fromFile=Te})(He=e.TestCoverage||(e.TestCoverage={}));var Ye;(function(ae){function Ee(ce){switch(ce){case 1:return _.CodeActionTriggerKind.Invoke;case 2:return _.CodeActionTriggerKind.Automatic}}ae.to=Ee})(Ye=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var it;(function(ae){function Ee(q){const Te=new _.TypeHierarchyItem(z.to(q.kind),q.name,q.detail||"",A.URI.revive(q.uri),o.to(q.range),o.to(q.selectionRange));return Te._sessionId=q._sessionId,Te._itemId=q._itemId,Te}ae.to=Ee;function ce(q,Te,Pe){if(Te=Te??q._sessionId,Pe=Pe??q._itemId,Te===void 0||Pe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Pe,kind:z.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:o.from(q.range),selectionRange:o.from(q.selectionRange),tags:q.tags?.map(N.from)}}ae.from=ce})(it=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(me[218],ge([0,1,2,16,7,15,95]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class E{constructor(A,n,P,c={timeout:1500,errors:3}){this._logService=A,this._documents=n,this._mainThreadBulkEdits=P,this._thresholds=c,this._callbacks=new R.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(A){return(n,P,c)=>{const d={dispose:this._callbacks.push([n,P,A])};return Array.isArray(c)&&c.push(d),d}}async $participateInSave(A,n){const P=m.URI.revive(A);let c=!1;const h=setTimeout(()=>c=!0,this._thresholds.timeout),d=[];try{for(let g of[...this._callbacks]){if(c)break;const y=this._documents.getDocument(P),I=await this._deliverEventAsyncAndBlameBadListeners(g,{document:y,reason:C.TextDocumentSaveReason.to(n)});d.push(I)}}finally{clearTimeout(h)}return d}_deliverEventAsyncAndBlameBadListeners([A,n,P],c){const h=this._badListeners.get(A);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,A,n,c).then(()=>!0,d=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(d),!(d instanceof Error)||d.message!=="concurrent_edits"){const g=this._badListeners.get(A);this._badListeners.set(A,g?g+1:1),typeof g=="number"&&g>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(A,n,P,c){const h=[],d=Date.now(),{document:g,reason:y}=c,{version:I}=g,_=Object.freeze({document:g,reason:y,waitUntil(s){if(Object.isFrozen(h))throw(0,L.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(s))}});try{n.apply(P,[_])}catch(s){return Promise.reject(s)}return Object.freeze(h),new Promise((s,o)=>{const p=setTimeout(()=>o(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' finished after ${Date.now()-d}ms`),clearTimeout(p),s(t)}).catch(t=>{clearTimeout(p),o(t)})}).then(s=>{const o={edits:[]};for(const p of s)if(Array.isArray(p)&&p.every(t=>t instanceof k.TextEdit))for(const{newText:t,newEol:a,range:r}of p)o.edits.push({_type:2,resource:g.uri,edit:{range:r&&C.Range.from(r),text:t,eol:a&&C.EndOfLine.from(a)}});if(o.edits.length!==0)return I===g.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=E}),define(me[54],ge([0,1,15,2,3,4]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class R{constructor(){this._onDidChangeTabs=new k.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new k.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[]}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(S){let A=-1;this._tabs=S.map((P,c)=>(P.isActive&&(A=c),Object.freeze({label:P.label,viewColumn:m.ViewColumn.to(P.viewColumn),resource:L.URI.revive(P.resource),viewId:P.editorId,isActive:P.isActive})));const n=this._activeTab;this._activeTab=A===-1?void 0:this._tabs[A],this._activeTab!==n&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}}e.ExtHostEditorTabs=R}),define(me[219],ge([0,1,3,30,2,15,7]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class E{constructor(n,P,c,h,d){this._onDidCreate=new m.Emitter,this._onDidChange=new m.Emitter,this._onDidDelete=new m.Emitter,this._config=0,c&&(this._config+=1),h&&(this._config+=2),d&&(this._config+=4);const g=(0,L.parse)(P),y=n(I=>{if(!c)for(let _ of I.created){const s=k.URI.revive(_);g(s.fsPath)&&this._onDidCreate.fire(s)}if(!h)for(let _ of I.changed){const s=k.URI.revive(_);g(s.fsPath)&&this._onDidChange.fire(s)}if(!d)for(let _ of I.deleted){const s=k.URI.revive(_);g(s.fsPath)&&this._onDidDelete.fire(s)}});this._disposable=R.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,y)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class S{constructor(n,P,c){this._logService=P,this._extHostDocumentsAndEditors=c,this._onFileSystemEvent=new m.Emitter,this._onDidRenameFile=new m.Emitter,this._onDidCreateFile=new m.Emitter,this._onDidDeleteFile=new m.Emitter,this._onWillRenameFile=new m.AsyncEmitter,this._onWillCreateFile=new m.AsyncEmitter,this._onWillDeleteFile=new m.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(n,P,c,h){return new E(this._onFileSystemEvent.event,n,P,c,h)}$onFileEvent(n){this._onFileSystemEvent.fire(n)}$onDidRunFileOperation(n,P){switch(n){case 2:this._onDidRenameFile.fire(Object.freeze({files:P.map(c=>({oldUri:k.URI.revive(c.source),newUri:k.URI.revive(c.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:P.map(c=>k.URI.revive(c.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:P.map(c=>k.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(n){return this._createWillExecuteEvent(n,this._onWillRenameFile)}getOnWillCreateFileEvent(n){return this._createWillExecuteEvent(n,this._onWillCreateFile)}getOnWillDeleteFileEvent(n){return this._createWillExecuteEvent(n,this._onWillDeleteFile)}_createWillExecuteEvent(n,P){return(c,h,d)=>{const g=function(I){c.call(h,I)};return g.extension=n,P.event(g,void 0,d)}}async $onWillRunFileOperation(n,P,c,h){switch(n){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:P.map(d=>({oldUri:k.URI.revive(d.source),newUri:k.URI.revive(d.target)}))},c,h);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:P.map(d=>k.URI.revive(d.target))},c,h);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:P.map(d=>k.URI.revive(d.target))},c,h)}}async _fireWillEvent(n,P,c,h){const d=new Set,g=[];if(await n.fireAsync(P,h,async(I,_)=>{const s=Date.now(),o=await Promise.resolve(I);o instanceof R.WorkspaceEdit&&(g.push(o),d.add(_.extension.displayName??_.extension.identifier.value)),Date.now()-s>c&&this._logService.warn("SLOW file-participant",_.extension.identifier)}),h.isCancellationRequested||g.length===0)return;const y={edits:[]};for(let I of g){let{edits:_}=C.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);y.edits=y.edits.concat(_)}return{edit:y,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=S}),define(me[220],ge([0,1,10,25,2,15,7,126]),function(J,e,m,L,k,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(c,h,d,g){this.start=c,this.deletedCount=h,this.deletedItems=d,this.items=g}static asApiEvents(c){return c.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(d=>d.apiCell)}))}}class A{constructor(c,h,d){this.notebook=c,this._extHostDocument=h,this._cellData=d,this.handle=d.handle,this.uri=k.URI.revive(d.uri),this.cellKind=d.cellKind,this._outputs=d.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=d.internalMetadata??{},this._metadata=Object.freeze(d.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(d.internalMetadata??{}))}static asModelAddData(c,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:c}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const c=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return c.notebook.getCellIndex(c)},notebook:c.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get mime(){return c._mime},set mime(d){c._mime=d},get outputs(){return c._outputs.slice(0)},get metadata(){return c._metadata},get executionSummary(){return c._previousResult}})}return this._apiCell}setOutputs(c){this._outputs=c.map(C.NotebookCellOutput.to)}setOutputItems(c,h,d){const g=d.map(C.NotebookCellOutputItem.to),y=this._outputs.find(I=>I.id===c);y&&(h||(y.items.length=0),y.items.push(...g))}setMetadata(c){this._metadata=Object.freeze(c)}setInternalMetadata(c){this._internalMetadata=c,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(c))}setMime(c){}}e.ExtHostCell=A;class n{constructor(c,h,d,g,y,I){this._proxy=c,this._textDocumentsAndEditors=h,this._textDocuments=d,this._emitter=g,this.uri=y,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=I.viewType,this._metadata=Object.freeze(I.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,I.cells]],!0),this._versionId=I.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const c=this;this._notebook={get uri(){return c.uri},get version(){return c._versionId},get notebookType(){return c._notebookType},get isDirty(){return c._isDirty},get isUntitled(){return c.uri.scheme===m.Schemas.untitled},get isClosed(){return c._disposed},get metadata(){return c._metadata},get cellCount(){return c._cells.length},cellAt(h){return h=c._validateIndex(h),c._cells[h].apiCell},getCells(h){return(h?c._getCells(h):c._cells).map(g=>g.apiCell)},save(){return c._save()}}}return this._notebook}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(c){c.metadata&&(this._metadata=Object.freeze({...this._metadata,...c.metadata}))}acceptDirty(c){this._isDirty=c}acceptModelChanged(c,h){this._versionId=c.versionId,this._isDirty=h;for(const d of c.rawEvents)d.kind===E.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(d.changes,!1):d.kind===E.NotebookCellsChangeType.Move?this._moveCell(d.index,d.newIdx):d.kind===E.NotebookCellsChangeType.Output?this._setCellOutputs(d.index,d.outputs):d.kind===E.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(d.index,d.outputId,d.append,d.outputItems):d.kind===E.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(d.index,d.language):d.kind===E.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(d.index,d.mime):d.kind===E.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(d.index,d.metadata):d.kind===E.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(d.index,d.internalMetadata)}_validateIndex(c){return c=c|0,c<0?0:c>=this._cells.length?this._cells.length-1:c}_validateRange(c){let h=c.start|0,d=c.end|0;return h<0&&(h=0),d>this._cells.length&&(d=this._cells.length),c.with({start:h,end:d})}_getCells(c){c=this._validateRange(c);const h=[];for(let d=c.start;d<c.end;d++)h.push(this._cells[d]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(c,h){if(this._disposed)return;const d=[],g=[],y=[];c.reverse().forEach(I=>{const s=I[2].map(t=>{const a=new A(this,this._textDocumentsAndEditors,t);return h||g.push(A.asModelAddData(this.apiNotebook,t)),a}),o=new S(I[0],I[1],[],s),p=this._cells.splice(I[0],I[1],...s);for(const t of p)y.push(t.uri),o.deletedItems.push(t.apiCell);d.push(o)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:y}),h||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(d)}))}_moveCell(c,h){const d=this._cells.splice(c,1);this._cells.splice(h,0,...d);const g=[new S(c,1,d.map(y=>y.apiCell),[]),new S(h,0,[],d)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(g)}))}_setCellOutputs(c,h){const d=this._cells[c];d.setOutputs(h),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[d.apiCell]}))}_setCellOutputItems(c,h,d,g){const y=this._cells[c];y.setOutputItems(h,d,g),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[y.apiCell]}))}_changeCellLanguage(c,h){const d=this._cells[c];d.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(d.uri,h)}_changeCellMime(c,h){const d=this._cells[c];d.apiCell.mime=h}_changeCellMetadata(c,h){const d=this._cells[c],g=d.apiCell.metadata;d.setMetadata(h);const y=d.apiCell.metadata;(0,L.equals)(g,y)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:d.apiCell}))}_changeCellInternalMetadata(c,h){const d=this._cells[c],g=d.internalMetadata;if(d.setInternalMetadata(h),g.runState!==h.runState){const y=h.runState??R.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:d.apiCell,state:y}))}}getCellFromApiCell(c){return this._cells.find(h=>h.apiCell===c)}getCellFromIndex(c){return this._cells[c]}getCell(c){return this._cells.find(h=>h.handle===c)}getCellIndex(c){return this._cells.indexOf(c)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(me[129],ge([0,1,7,15,16]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,A){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:A})}replaceCells(S,A,n){this._throwIfFinalized(),!(S===A&&n.length===0)&&this._collectedEdits.push({editType:1,index:S,count:A-S,cells:n.map(L.NotebookCellData.from)})}}class R{constructor(S,A,n,P,c,h){this.id=S,this._proxy=A,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=c,this._visibleRanges=P,this._viewColumn=h}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(A){if(!Array.isArray(A)||!A.every(m.NotebookRange.isNotebookRange))throw(0,k.illegalArgument)("selections");S._selections=A,S._trySetSelections(A)},get visibleRanges(){return S._visibleRanges},revealRange(A,n){S._proxy.$tryRevealRange(S.id,L.NotebookRange.from(A),n??m.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(A){const n=new C(this.document.version);return A(n),S._applyEdit(n.finalize())},setDecorations(A,n){return S.setDecorations(A,n)}},R.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(L.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const A=[];let n=-1;for(let P=0;P<S.cellEdits.length;P++){if(n<0){A.push(S.cellEdits[P]),n++;continue}const h=A[n],d=S.cellEdits[P];if(h.editType===1&&d.editType===1&&h.index===d.index){h.cells.push(...S.cellEdits[P].cells),h.count+=S.cellEdits[P].count;continue}A.push(S.cellEdits[P]),n++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,A)}setDecorations(S,A){if(!(A.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return A.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(A),S.key)}}e.ExtHostNotebookEditor=R,R.apiEditorsToExtHost=new WeakMap}),define(me[221],ge([0,1,15,118,166,21,58]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class E{constructor(P){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=P}withProgress(P,c,h){const d=this._handles++,{title:g,location:y,cancellable:I}=c,_={label:(0,k.localize)(0,null,P.displayName||P.name),id:P.identifier.value};return this._proxy.$startProgress(d,{location:m.ProgressLocation.from(y),title:g,source:_,cancellable:I},P),this._withProgress(d,h,!!I)}_withProgress(P,c,h){let d;h&&(d=new C.CancellationTokenSource,this._mapHandleToCancellationSource.set(P,d));const g=I=>{this._proxy.$progressEnd(I),this._mapHandleToCancellationSource.delete(I),d&&d.dispose()};let y;try{y=c(new A(this._proxy,P),h&&d?d.token:C.CancellationToken.None)}catch(I){throw g(P),I}return y.then(I=>g(P),I=>g(P)),y}$acceptProgressCanceled(P){const c=this._mapHandleToCancellationSource.get(P);c&&(c.cancel(),this._mapHandleToCancellationSource.delete(P))}}e.ExtHostProgress=E;function S(n,P){return n.message=P.message,typeof P.increment=="number"&&(typeof n.increment=="number"?n.increment+=P.increment:n.increment=P.increment),n}class A extends L.Progress{constructor(P,c){super(h=>this.throttledReport(h));this._proxy=P,this._handle=c}throttledReport(P){this._proxy.$progressReport(this._handle,P)}}Ve([(0,R.throttle)(100,(n,P)=>S(n,P),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(me[130],ge([0,1,56,16,76,15,7]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class E{constructor(c,h,d){const g=E._Keys.nextId();c.$registerTextEditorDecorationType(h.identifier,g,C.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:g,dispose(){c.$removeTextEditorDecorationType(g)}})}}e.TextEditorDecorationType=E,E._Keys=new k.IdGenerator("TextEditorDecorationType");class S{constructor(c,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,h){this._throwIfFinalized();let d=null;if(c instanceof R.Position)d=new R.Range(c,c);else if(c instanceof R.Range)d=c;else throw new Error("Unrecognized location");this._pushEdit(d,h,!1)}insert(c,h){this._throwIfFinalized(),this._pushEdit(new R.Range(c,c),h,!0)}delete(c){this._throwIfFinalized();let h=null;if(c instanceof R.Range)h=c;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(c,h,d){const g=this._document.validateRange(c);this._collectedEdits.push({range:g,text:h,forceMoveMarkers:d})}setEndOfLine(c){if(this._throwIfFinalized(),c!==R.EndOfLine.LF&&c!==R.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=c}}e.TextEditorEdit=S;class A{constructor(c,h,d,g){this._proxy=c,this._id=h,this._accept(d),this._logService=g;const y=this;this.value={get tabSize(){return y._tabSize},set tabSize(I){y._setTabSize(I)},get insertSpaces(){return y._insertSpaces},set insertSpaces(I){y._setInsertSpaces(I)},get cursorStyle(){return y._cursorStyle},set cursorStyle(I){y._setCursorStyle(I)},get lineNumbers(){return y._lineNumbers},set lineNumbers(I){y._setLineNumbers(I)}}}_accept(c){this._tabSize=c.tabSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=C.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const h=Math.floor(c);return h>0?h:null}if(typeof c=="string"){const h=parseInt(c,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(c){const h=this._validateTabSize(c);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:Boolean(c)}_setInsertSpaces(c){const h=this._validateInsertSpaces(c);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:C.TextEditorLineNumbersStyle.from(c)})))}assign(c){const h={};let d=!1;if(typeof c.tabSize!="undefined"){const g=this._validateTabSize(c.tabSize);g==="auto"?(d=!0,h.tabSize=g):typeof g=="number"&&this._tabSize!==g&&(this._tabSize=g,d=!0,h.tabSize=g)}if(typeof c.insertSpaces!="undefined"){const g=this._validateInsertSpaces(c.insertSpaces);g==="auto"?(d=!0,h.insertSpaces=g):this._insertSpaces!==g&&(this._insertSpaces=g,d=!0,h.insertSpaces=g)}typeof c.cursorStyle!="undefined"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,d=!0,h.cursorStyle=c.cursorStyle),typeof c.lineNumbers!="undefined"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,d=!0,h.lineNumbers=C.TextEditorLineNumbersStyle.from(c.lineNumbers)),d&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(c){c.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=A;class n{constructor(c,h,d,g,y,I,_,s){this.id=c,this._proxy=h,this._logService=d,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=y,this._options=new A(this._proxy,this.id,I,d),this._visibleRanges=_,this._viewColumn=s;const o=this;this.value=Object.freeze({get document(){return g.getValue()},set document(p){throw(0,L.readonly)("document")},get selection(){return o._selections&&o._selections[0]},set selection(p){if(!(p instanceof R.Selection))throw(0,L.illegalArgument)("selection");o._selections=[p],o._trySetSelection()},get selections(){return o._selections},set selections(p){if(!Array.isArray(p)||p.some(t=>!(t instanceof R.Selection)))throw(0,L.illegalArgument)("selections");o._selections=p,o._trySetSelection()},get visibleRanges(){return o._visibleRanges},set visibleRanges(p){throw(0,L.readonly)("visibleRanges")},get options(){return o._options.value},set options(p){o._disposed||o._options.assign(p)},get viewColumn(){return o._viewColumn},set viewColumn(p){throw(0,L.readonly)("viewColumn")},edit(p,t={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const a=new S(g.getValue(),t);return p(a),o._applyEdit(a)},insertSnippet(p,t,a={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=o._selections.map(i=>C.Range.from(i));else if(t instanceof R.Position){const{lineNumber:i,column:l}=C.Position.from(t);r=[{startLineNumber:i,startColumn:l,endLineNumber:i,endColumn:l}]}else if(t instanceof R.Range)r=[C.Range.from(t)];else{r=[];for(const i of t)if(i instanceof R.Range)r.push(C.Range.from(i));else{const{lineNumber:l,column:u}=C.Position.from(i);r.push({startLineNumber:l,startColumn:u,endLineNumber:l,endColumn:u})}}return h.$tryInsertSnippet(c,p.value,r,a)},setDecorations(p,t){const a=t.length===0;a&&!o._hasDecorationsForKey.has(p.key)||(a?o._hasDecorationsForKey.delete(p.key):o._hasDecorationsForKey.add(p.key),o._runOnProxy(()=>{if(C.isDecorationOptionsArr(t))return h.$trySetDecorations(c,p.key,C.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let i=0,l=t.length;i<l;i++){const u=t[i];r[4*i]=u.start.line+1,r[4*i+1]=u.start.character+1,r[4*i+2]=u.end.line+1,r[4*i+3]=u.end.character+1}return h.$trySetDecorationsFast(c,p.key,r)}}))},revealRange(p,t){o._runOnProxy(()=>h.$tryRevealRange(c,C.Range.from(p),t||R.TextEditorRevealType.Default))},show(p){h.$tryShowEditor(c,C.ViewColumn.from(p))},hide(){h.$tryHideEditor(c)}})}dispose(){(0,m.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,m.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,m.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,m.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,m.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(C.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const h=c.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const d=h.edits.map(y=>y.range);d.sort((y,I)=>y.end.line===I.end.line?y.end.character===I.end.character?y.start.line===I.start.line?y.start.character-I.start.character:y.start.line-I.start.line:y.end.character-I.end.character:y.end.line-I.end.line);for(let y=0,I=d.length-1;y<I;y++){const _=d[y].end;if(d[y+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=h.edits.map(y=>({range:C.Range.from(y.range),text:y.text,forceMoveMarkers:y.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,g,{setEndOfLine:typeof h.setEndOfLine=="number"?C.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=n}),define(me[222],ge([0,1,169,22,2,3,6,209,18,7,13,17,15,21,206]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(_,s){if((0,n.isString)(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let o;return Array.isArray(_.highlights)&&(o=_.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),o=o.length?o:void 0),{label:_.label,highlights:o}}}class y{constructor(s,o,p){this._proxy=s,this.commands=o,this.logService=p,this.treeViews=new Map;function t(a){return a&&a.$treeViewId&&a.$treeItemHandle}o.registerArgumentProcessor({processArgument:a=>t(a)?this.convertArgument(a):Array.isArray(a)&&a.length>0?a.map(r=>t(r)?this.convertArgument(r):r):a})}registerTreeDataProvider(s,o,p){const t=this.createTreeView(s,{treeDataProvider:o},p);return{dispose:()=>t.dispose()}}createTreeView(s,o,p){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=o.dragAndDropController!==void 0,a=this._proxy.$registerTreeViewDataProvider(s,{showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,canDragAndDrop:t}),r=this.createExtHostTreeView(s,o,p);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(i){r.message=i},get title(){return r.title},set title(i){r.title=i},get description(){return r.description},set description(i){r.description=i},reveal:(i,l)=>r.reveal(i,l),dispose:async()=>{await a,this.treeViews.delete(s),r.dispose()}}}$getChildren(s,o){const p=this.treeViews.get(s);return p?p.getChildren(o):Promise.reject(new Error((0,m.localize)(0,null,s)))}async $onDrop(s,o,p){const t=this.treeViews.get(s);if(!t)return Promise.reject(new Error((0,m.localize)(1,null,s)));const a=d.TreeDataTransferConverter.toITreeDataTransfer(o);if(a.items.has(E.TREE_ITEM_DATA_TRANSFER_TYPE)){const i=JSON.parse(await a.items.get(E.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(l=>t.getExtensionElement(l)).filter(l=>!!l);i.length>0?a.items.set(E.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(i)}):a.items.delete(E.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(a,p)}async $hasResolve(s){const o=this.treeViews.get(s);if(!o)throw new Error((0,m.localize)(2,null,s));return o.hasResolve}$resolve(s,o,p){const t=this.treeViews.get(s);if(!t)throw new Error((0,m.localize)(3,null,s));return t.resolveTreeItem(o,p)}$setExpanded(s,o,p){const t=this.treeViews.get(s);if(!t)throw new Error((0,m.localize)(4,null,s));t.setExpanded(o,p)}$setSelection(s,o){const p=this.treeViews.get(s);if(!p)throw new Error((0,m.localize)(5,null,s));p.setSelection(o)}$setVisible(s,o){const p=this.treeViews.get(s);if(!p)throw new Error((0,m.localize)(6,null,s));p.setVisible(o)}createExtHostTreeView(s,o,p){const t=new I(s,o,this._proxy,this.commands.converter,this.logService,p);return this.treeViews.set(s,t),t}convertArgument(s){const o=this.treeViews.get(s.$treeViewId);return o?o.getExtensionElement(s.$treeItemHandle):null}}e.ExtHostTreeViews=y;class I extends R.Disposable{constructor(s,o,p,t,a,r){super();if(this.viewId=s,this.proxy=p,this.commands=t,this.logService=a,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new h.CancellationTokenSource,r.contributes&&r.contributes.views)for(const u in r.contributes.views)for(const f of r.contributes.views[u])f.id===s&&(this._title=f.name);this.dataProvider=o.treeDataProvider,this.dndController=o.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(u=>this._onDidChangeData.fire({message:!1,element:u}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(u=>this._onDidChangeData.fire({message:!1,element:u})));let i,l;this._register(C.Event.debounce(this._onDidChangeData.event,(u,f)=>(u||(u={message:!1,elements:[]}),f.element!==!1&&(i||(i=new Promise(b=>l=b),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(f.element)?u.elements.push(...f.element):u.elements.push(f.element)),f.message&&(u.message=!0),u),200,!0)(({message:u,elements:f})=>{f.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const b=l;return i=null,this.refresh(f).then(()=>b())})),u&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(s=>this.getExtensionElement(s)).filter(s=>!(0,n.isUndefinedOrNull)(s))}async getChildren(s){const o=s?this.getExtensionElement(s):void 0;if(s&&!o)return this.logService.error(`No tree item with id '${s}' found.`),Promise.resolve([]);let p=this.getChildrenNodes(s);return p||(p=await this.fetchChildrenNodes(o)),p?p.map(t=>t.item):void 0}getExtensionElement(s){return this.elements.get(s)}reveal(s,o){o=o||{select:!0,focus:!1};const p=(0,n.isUndefinedOrNull)(o.select)?!0:o.select,t=(0,n.isUndefinedOrNull)(o.focus)?!1:o.focus,a=(0,n.isUndefinedOrNull)(o.expand)?!1:o.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):s?this.refreshPromise.then(()=>this.resolveUnknownParentChain(s)).then(r=>this.resolveTreeNode(s,r[r.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:r.map(l=>l.item)},{select:p,focus:t,expand:a})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:p,focus:t,expand:a})}get message(){return this._message}set message(s){this._message=s,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(s){this._title=s,this.proxy.$setTitle(this.viewId,s,this._description)}get description(){return this._description}set description(s){this._description=s,this.proxy.$setTitle(this.viewId,this._title,s)}setExpanded(s,o){const p=this.getExtensionElement(s);p&&(o?this._onDidExpandElement.fire(Object.freeze({element:p})):this._onDidCollapseElement.fire(Object.freeze({element:p})))}setSelection(s){(0,P.equals)(this._selectedHandles,s)||(this._selectedHandles=s,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(s){s!==this._visible&&(this._visible=s,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(s,o){const p=this.getExtensionElement(o);if(!!p)return(0,S.asPromise)(()=>this.dndController?.onDrop(s,p))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(s,o){if(!this.dataProvider.resolveTreeItem)return;const p=this.elements.get(s);if(p){const t=this.nodes.get(p);if(t){const a=await this.dataProvider.resolveTreeItem(t.extensionItem,p,o)??t.extensionItem;return t.item.tooltip=this.getTooltip(a.tooltip),t.item.command=this.getCommand(t.disposableStore,a.command),t.item}}}resolveUnknownParentChain(s){return this.resolveParent(s).then(o=>o?this.resolveUnknownParentChain(o).then(p=>this.resolveTreeNode(o,p[p.length-1]).then(t=>(p.push(t),p))):Promise.resolve([]))}resolveParent(s){const o=this.nodes.get(s);return o?Promise.resolve(o.parent?this.elements.get(o.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(s))}resolveTreeNode(s,o){const p=this.nodes.get(s);return p?Promise.resolve(p):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(s)).then(t=>this.createHandle(s,t,o,!0)).then(t=>this.getChildren(o?o.item.handle:void 0).then(()=>{const a=this.getExtensionElement(t);if(a){const r=this.nodes.get(a);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(s){if(s){let o;if(typeof s=="string"){const p=this.getExtensionElement(s);o=p?this.nodes.get(p):void 0}else o=s;return o&&o.children||void 0}return this.roots}async fetchChildrenNodes(s){this.clearChildren(s);const o=new h.CancellationTokenSource(this._refreshCancellationSource.token);try{const p=s?this.nodes.get(s):void 0,t=await this.dataProvider.getChildren(s);if(o.token.isCancellationRequested)return;const a=await Promise.all((0,P.coalesce)(t||[]).map(async r=>{const i=await this.dataProvider.getTreeItem(r);return i&&!o.token.isCancellationRequested?this.createAndRegisterTreeNode(r,i,p):null}));return o.token.isCancellationRequested?void 0:(0,P.coalesce)(a)}finally{o.dispose()}}refresh(s){if(s.some(p=>!p))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new h.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const p=this.getHandlesToRefresh(s);if(p.length)return this.refreshHandles(p)}return Promise.resolve(void 0)}getHandlesToRefresh(s){const o=new Set,p=s.map(a=>this.nodes.get(a));for(const a of p)if(a&&!o.has(a.item.handle)){let r=a;for(;r&&r.parent&&p.findIndex(i=>r&&r.parent&&i&&i.item.handle===r.parent.item.handle)===-1;){const i=this.elements.get(r.parent.item.handle);r=i?this.nodes.get(i):void 0}r&&!r.parent&&o.add(a.item.handle)}const t=[];return o.forEach(a=>{const r=this.elements.get(a);if(r){const i=this.nodes.get(r);i&&(!i.parent||!o.has(i.parent.item.handle))&&t.push(a)}}),t}refreshHandles(s){const o={};return Promise.all(s.map(p=>this.refreshNode(p).then(t=>{t&&(o[p]=t.item)}))).then(()=>Object.keys(o).length?this.proxy.$refresh(this.viewId,o):void 0)}refreshNode(s){const o=this.getExtensionElement(s);if(o){const p=this.nodes.get(o);if(p)return this.clearChildren(o),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(t=>{if(t){const a=this.createTreeNode(o,t,p.parent);return this.updateNodeCache(o,a,p,p.parent),p.dispose(),a}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(s,o,p){const t=this.createTreeNode(s,o,p);if(o.id&&this.elements.has(t.item.handle))throw new Error((0,m.localize)(7,null,o.id));return this.addNodeToCache(s,t),this.addNodeToParentCache(t,p),t}getTooltip(s){return A.MarkdownString.isMarkdownString(s)?c.MarkdownString.from(s):s}getCommand(s,o){return o?this.commands.toInternal(o,s):void 0}createTreeNode(s,o,p){const t=new R.DisposableStore,a=this.createHandle(s,o,p),r=this.getLightIconPath(o);return{item:{handle:a,parentHandle:p?p.item.handle:void 0,label:g(o.label,this.extension),description:o.description,resourceUri:o.resourceUri,tooltip:this.getTooltip(o.tooltip),command:this.getCommand(t,o.command),contextValue:o.contextValue,icon:r,iconDark:this.getDarkIconPath(o)||r,themeIcon:this.getThemeIcon(o),collapsibleState:(0,n.isUndefinedOrNull)(o.collapsibleState)?A.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation},extensionItem:o,parent:p,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(s){return s.iconPath instanceof A.ThemeIcon?s.iconPath:void 0}createHandle(s,{id:o,label:p,resourceUri:t},a,r){if(o)return`${I.ID_HANDLE_PREFIX}/${o}`;const i=g(p,this.extension),l=a?a.item.handle:I.LABEL_HANDLE_PREFIX;let u=i?i.label:t?(0,L.basename)(t):"";u=u.indexOf("/")!==-1?u.replace("/","//"):u;const f=this.nodes.has(s)?this.nodes.get(s).item.handle:void 0,b=this.getChildrenNodes(a)||[];let D,w=0;do{if(D=`${l}/${w}:${u}`,r||!this.elements.has(D)||f===D)break;w++}while(w<=b.length);return D}getLightIconPath(s){if(s.iconPath&&!(s.iconPath instanceof A.ThemeIcon))return typeof s.iconPath=="string"||k.URI.isUri(s.iconPath)?this.getIconPath(s.iconPath):this.getIconPath(s.iconPath.light)}getDarkIconPath(s){if(s.iconPath&&!(s.iconPath instanceof A.ThemeIcon)&&s.iconPath.dark)return this.getIconPath(s.iconPath.dark)}getIconPath(s){return k.URI.isUri(s)?s:k.URI.file(s)}addNodeToCache(s,o){this.elements.set(o.item.handle,s),this.nodes.set(s,o)}updateNodeCache(s,o,p,t){this.elements.delete(o.item.handle),this.nodes.delete(s),o.item.handle!==p.item.handle&&this.elements.delete(p.item.handle),this.addNodeToCache(s,o);const a=this.getChildrenNodes(t)||[],r=a.filter(i=>i.item.handle===p.item.handle)[0];r&&a.splice(a.indexOf(r),1,o)}addNodeToParentCache(s,o){o?(o.children||(o.children=[]),o.children.push(s)):(this.roots||(this.roots=[]),this.roots.push(s))}clearChildren(s){if(s){const o=this.nodes.get(s);if(o){if(o.children)for(const p of o.children){const t=this.elements.get(p.item.handle);t&&this.clear(t)}o.children=void 0}}else this.clearAll()}clear(s){const o=this.nodes.get(s);if(o){if(o.children)for(const p of o.children){const t=this.elements.get(p.item.handle);t&&this.clear(t)}this.nodes.delete(s),this.elements.delete(o.item.handle),o.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(s=>s.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}I.LABEL_HANDLE_PREFIX="0",I.ID_HANDLE_PREFIX="1"}),define(me[223],ge([0,1,18,3,6,13,64,15,127,89]),function(J,e,m,L,k,C,R,E,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class n extends k.Disposable{constructor(c){super();this.controllerId=c,this.debounceSendDiff=this._register(new m.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new R.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(c){this._resolveHandler=c;for(const h of this.tree.values())this.updateExpandability(h)}collectDiff(){const c=this.diff;return this.diff=[],c}pushDiff(c){const h=this.diff[this.diff.length-1];if(h&&c[0]===1){if(h[0]===1&&h[1].extId===c[1].extId){(0,S.applyTestItemUpdate)(h[1],c[1]);return}if(h[0]===0&&h[1].item.extId===c[1].extId){(0,S.applyTestItemUpdate)(h[1],c[1]);return}}this.diff.push(c),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(c,h){const d=this.tree.get(c);if(!!d){if((d.expandLevels===void 0||h>d.expandLevels)&&(d.expandLevels=h),d.expand===1){const g=this.resolveChildren(d);return g.isOpen()?this.expandChildren(d,h-1):g.wait().then(()=>this.expandChildren(d,h-1))}else if(d.expand===3)return d.resolveBarrier?.isOpen()===!1?d.resolveBarrier.wait().then(()=>this.expandChildren(d,h-1)):this.expandChildren(d,h-1)}}dispose(){for(const c of this.tree.values())(0,R.getPrivateApiFor)(c.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(c,h){switch(h.op){case 2:this.pushDiff([4,c.fullId.toString()]);break;case 1:this.removeItem(A.TestId.joinToString(c.fullId,h.id));break;case 0:this.upsertItem(h.item,c);break;case 4:for(const _ of h.ops)this.onTestItemEvent(c,_);break;case 3:const{key:d,value:g,previous:y}=h,I=c.fullId.toString();switch(d){case"canResolveChildren":this.updateExpandability(c);break;case"tags":this.diffTagRefs(g,y,I);break;case"range":this.pushDiff([1,{extId:I,item:{range:E.Range.from(g)}}]);break;case"error":this.pushDiff([1,{extId:I,item:{error:E.MarkdownString.fromStrict(g)||null}}]);break;default:this.pushDiff([1,{extId:I,item:{[d]:g??null}}]);break}break;default:(0,C.assertNever)(h)}}upsertItem(c,h){if(!(c instanceof R.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${c.id} did not`);const d=A.TestId.fromExtHostTestItem(c,this.root.id,h?.actual),g=(0,R.getPrivateApiFor)(c);g.parent&&g.parent!==h?.actual&&g.parent.children.delete(c.id);let y=this.tree.get(d.toString());if(!y){y={fullId:d,actual:c,parent:h?d.parentId:null,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},c.tags.forEach(this.incrementTagRefs,this),this.tree.set(y.fullId.toString(),y),this.setItemParent(c,h),this.pushDiff([0,{parent:y.parent&&y.parent.toString(),controllerId:this.controllerId,expand:y.expand,item:E.TestItem.from(c)}]),this.connectItemAndChildren(c,y,h);return}if(y.actual===c){this.connectItem(c,y,h);return}const I=y.actual.children,_=y.actual,s=(0,R.diffTestItems)(_,c);(0,R.getPrivateApiFor)(_).listener=void 0,y.actual=c,y.expand=0;for(const[o,p]of s)this.onTestItemEvent(y,{op:3,key:o,value:p,previous:_[o]});this.connectItemAndChildren(c,y,h);for(const o of I)c.children.get(o.id)||this.removeItem(A.TestId.joinToString(d,o.id))}diffTagRefs(c,h,d){const g=new Set(h.map(y=>y.id));for(const y of c)g.delete(y.id)||this.incrementTagRefs(y);this.pushDiff([1,{extId:d,item:{tags:c.map(y=>E.TestTag.namespace(this.controllerId,y.id))}}]),g.forEach(this.decrementTagRefs,this)}incrementTagRefs(c){const h=this.tags.get(c.id);h?h.refCount++:(this.tags.set(c.id,{refCount:1}),this.pushDiff([5,{id:E.TestTag.namespace(this.controllerId,c.id),ctrlLabel:this.root.label}]))}decrementTagRefs(c){const h=this.tags.get(c);h&&!--h.refCount&&(this.tags.delete(c),this.pushDiff([6,E.TestTag.namespace(this.controllerId,c)]))}setItemParent(c,h){(0,R.getPrivateApiFor)(c).parent=h&&h.actual!==this.root?h.actual:void 0}connectItem(c,h,d){this.setItemParent(c,d);const g=(0,R.getPrivateApiFor)(c);g.parent=d?.actual,g.listener=y=>this.onTestItemEvent(h,y),this.updateExpandability(h)}connectItemAndChildren(c,h,d){this.connectItem(c,h,d);for(const g of c.children)this.upsertItem(g,h)}updateExpandability(c){let h;this._resolveHandler?c.resolveBarrier?h=c.resolveBarrier.isOpen()?3:2:h=c.actual.canResolveChildren?1:0:h=0,h!==c.expand&&(c.expand=h,this.pushDiff([1,{extId:c.fullId.toString(),expand:h}]),h===1&&c.expandLevels!==void 0&&this.resolveChildren(c))}expandChildren(c,h){if(h<0)return;const d=[];for(const g of c.actual.children){const y=this.expand(A.TestId.joinToString(c.fullId,g.id),h);(0,m.isThenable)(y)&&d.push(y)}if(d.length)return Promise.all(d).then(()=>{})}resolveChildren(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this._resolveHandler){const y=new m.Barrier;return y.open(),y}c.expand=2,this.pushExpandStateUpdate(c);const h=c.resolveBarrier=new m.Barrier,d=y=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),c.actual!==this.root&&(c.actual.error=y.stack||y.message||String(y))};let g;try{g=this._resolveHandler(c.actual===this.root?void 0:c.actual)}catch(y){d(y)}return(0,m.isThenable)(g)?g.catch(d).then(()=>{h.open(),this.updateExpandability(c)}):(h.open(),this.updateExpandability(c)),c.resolveBarrier}pushExpandStateUpdate(c){this.pushDiff([1,{extId:c.fullId.toString(),expand:c.expand}])}removeItem(c){const h=this.tree.get(c);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff([2,c]);const d=[h];for(;d.length;){const g=d.pop();if(!!g){(0,R.getPrivateApiFor)(g.actual).listener=void 0;for(const y of g.actual.tags)this.decrementTagRefs(y.id);this.tree.delete(g.fullId.toString());for(const y of g.actual.children)d.push(this.tree.get(A.TestId.joinToString(g.fullId,y.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.diffOpEmitter.fire(c)}}e.SingleUseTestCollection=n}),define(me[224],ge([0,1,4,184]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,m.refineServiceDecorator)(L.IEnvironmentService)}),define(me[225],ge([0,1,26,3,8]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class C{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=C;class R{constructor(n){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(m.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(m.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let P of n.activationEvents)P==="onUri"&&(P=`onUri:${m.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(P)||this._activationMap.set(P,[]),this._activationMap.get(P).push(n)}}keepOnly(n){const P=new Set;n.forEach(c=>P.add(m.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>P.has(m.ExtensionIdentifier.toKey(c.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,P){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const c=R._findLoopingExtensions(this._extensionDescriptions);if(P=P.concat(c.map(h=>h.identifier)),P.length>0){const h=new Set;P.forEach(d=>h.add(m.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>!h.has(m.ExtensionIdentifier.toKey(d.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new C(c)}static _findLoopingExtensions(n){const P=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(y){this._nodesSet.has(y)||(this._nodesSet.add(y),this._nodesArr.push(y))}addArc(y,I){this.addNode(y),this.addNode(I),this._arcs.has(y)?this._arcs.get(y).push(I):this._arcs.set(y,[I])}getArcs(y){return this._arcs.has(y)?this._arcs.get(y):[]}hasOnlyGoodArcs(y,I){const _=P.getArcs(y);for(let s=0;s<_.length;s++)if(!I.has(_[s]))return!1;return!0}getNodes(){return this._nodesArr}};let c=new Map;for(let y of n){const I=m.ExtensionIdentifier.toKey(y.identifier);if(c.set(I,y),y.extensionDependencies)for(let _ of y.extensionDependencies){const s=m.ExtensionIdentifier.toKey(_);P.addArc(I,s)}}let h=new Set;P.getNodes().filter(y=>P.getArcs(y).length===0).forEach(y=>h.add(y));let d=P.getNodes().filter(y=>!h.has(y)),g;do{g=!1;for(let y=0;y<d.length;y++){const I=d[y];P.hasOnlyGoodArcs(I,h)&&(d.splice(y,1),y--,h.add(I),g=!0)}}while(g);return d.map(y=>c.get(y))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(m.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const P=this._activationMap.get(n);return P?P.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const P=this._extensionsMap.get(m.ExtensionIdentifier.toKey(n));return P||void 0}}e.ExtensionDescriptionRegistry=R;var E;(function(A){A[A.Builtin=0]="Builtin",A[A.User=1]="User",A[A.Dev=2]="Dev"})(E||(E={}));function S(A,n){const P=A.isBuiltin?0:A.isUnderDevelopment?2:1,c=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(P!==c)return P-c;const h=k.posix.basename(A.extensionLocation.path),d=k.posix.basename(n.extensionLocation.path);return h<d?-1:h>d?1:0}}),define(me[226],ge([0,1,23]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var k;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(k=e.MessageType||(e.MessageType={}));function C(E){const S=m.VSBuffer.alloc(1);switch(E){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=C;function R(E,S){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=R}),define(me[35],ge([0,1,3,2,4,26,186]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,k.createDecorator)("extensionService");var E;(function(s){s[s.None=0]="None",s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(E=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));class S{constructor(o){this.dependency=o}}e.MissingExtensionDependency=S;var A;(function(s){s[s.LocalProcess=0]="LocalProcess",s[s.LocalWebWorker=1]="LocalWebWorker",s[s.Remote=2]="Remote"})(A=e.ExtensionHostKind||(e.ExtensionHostKind={}));function n(s){switch(s){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=n;class P{constructor(o,p,t,a){this.codeLoadingTime=o,this.activateCallTime=p,this.activateResolvedTime=t,this.activationReason=a}}e.ActivationTimes=P;class c{constructor(o,p){this.description=o,this.value=p}}e.ExtensionPointContribution=c,e.ExtensionHostLogFileName="exthost";var h;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(h=e.ActivationKind||(e.ActivationKind={}));function d(s){s.enableProposedApi||g(s)}e.checkProposedApiEnabled=d;function g(s){throw new Error(`[${s.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.throwProposedApiError=g;function y(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,R.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation}}e.toExtension=y;function I(s,o){return{identifier:new C.ExtensionIdentifier(s.identifier.id),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!o,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid}}e.toExtensionDescription=I;class _{constructor(){this.onDidRegisterExtensions=m.Event.None,this.onDidChangeExtensionsStatus=m.Event.None,this.onDidChangeExtensions=m.Event.None,this.onWillActivateByEvent=m.Event.None,this.onDidChangeResponsiveChange=m.Event.None}activateByEvent(o){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(o){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(o){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(o){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(o,p){return Promise.resolve()}_onWillActivateExtension(o){}_onDidActivateExtension(o,p,t,a,r){}_onDidActivateExtensionError(o,p){}_onExtensionRuntimeError(o,p){}_onExtensionHostExit(o){}}e.NullExtensionService=_}),define(me[227],ge([0,1,26,35,12]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const C=Promise.resolve(void 0);class R{constructor(d,g,y,I){this.startup=d,this.codeLoadingTime=g,this.activateCallTime=y,this.activateResolvedTime=I}}e.ExtensionActivationTimes=R,R.NONE=new R(!1,-1,-1,-1);class E{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,g){return d===-1||g===-1?-1:g-d}build(){return new R(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=E;class S{constructor(d,g,y,I,_,s){this.activationFailed=d,this.activationFailedError=g,this.activationTimes=y,this.module=I,this.exports=_,this.subscriptions=s}}e.ActivatedExtension=S;class A extends S{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=A;class n extends S{constructor(){super(!1,null,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class P extends S{constructor(d){super(!0,d,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=P;let c=class{constructor(d,g,y,I,_){this._logService=_,this._registry=d,this._resolvedExtensionsSet=new Set,g.forEach(s=>this._resolvedExtensionsSet.add(m.ExtensionIdentifier.toKey(s))),this._hostExtensionsMap=new Map,y.forEach(s=>this._hostExtensionsMap.set(m.ExtensionIdentifier.toKey(s),s)),this._host=I,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(d){const g=m.ExtensionIdentifier.toKey(d);return this._activatedExtensions.has(g)}getActivatedExtension(d){const g=m.ExtensionIdentifier.toKey(d),y=this._activatedExtensions.get(g);if(!y)throw new Error("Extension `"+d.value+"` is not known or not activated");return y}activateByEvent(d,g){if(this._alreadyActivatedEvents[d])return C;const y=this._registry.getExtensionDescriptionsForActivationEvent(d);return this._activateExtensions(y.map(I=>({id:I.identifier,reason:{startup:g,extensionId:I.identifier,activationEvent:d}}))).then(()=>{this._alreadyActivatedEvents[d]=!0})}activateById(d,g){const y=this._registry.getExtensionDescription(d);if(!y)throw new Error("Extension `"+d+"` is not known");return this._activateExtensions([{id:y.identifier,reason:g}])}_handleActivateRequest(d,g,y){if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(d.id))){g[m.ExtensionIdentifier.toKey(d.id)]=d;return}const I=this._registry.getExtensionDescription(d.id);if(!I){const o=new Error(`Cannot activate unknown extension '${d.id.value}'`);this._host.onExtensionActivationError(d.id,o,new L.MissingExtensionDependency(d.id.value)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(d.id),new P(o));return}const _=typeof I.extensionDependencies=="undefined"?[]:I.extensionDependencies;let s=!0;for(let o=0,p=_.length;o<p;o++){const t=_[o];if(this._resolvedExtensionsSet.has(m.ExtensionIdentifier.toKey(t)))continue;const a=this._activatedExtensions.get(m.ExtensionIdentifier.toKey(t));if(a&&!a.activationFailed)continue;if(a&&a.activationFailed){const u=I.displayName||I.identifier.value,f=this._registry.getExtensionDescription(t),b=f&&f.displayName||t,D=new Error(`Cannot activate the '${u}' extension because its dependency '${b}' failed to activate`);D.detail=a.activationFailedError,this._host.onExtensionActivationError(I.identifier,D,null),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(I.identifier),new P(D));return}if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(t))){s=!1,g[m.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(m.ExtensionIdentifier.toKey(t)),reason:d.reason};continue}const r=this._registry.getExtensionDescription(t);if(r){s=!1,g[m.ExtensionIdentifier.toKey(t)]={id:r.identifier,reason:d.reason};continue}const i=I.displayName||I.identifier.value,l=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(I.identifier,l,new L.MissingExtensionDependency(t)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(I.identifier),new P(l));return}s?g[m.ExtensionIdentifier.toKey(I.identifier)]=d:y.push(d)}_activateExtensions(d){if(d.length===0||(d=d.filter(_=>!this._activatedExtensions.has(m.ExtensionIdentifier.toKey(_.id))),d.length===0))return Promise.resolve(void 0);const g=Object.create(null),y=[];for(let _=0,s=d.length;_<s;_++)this._handleActivateRequest(d[_],g,y);for(let _=0,s=y.length;_<s;_++){const o=m.ExtensionIdentifier.toKey(y[_].id);g[o]&&delete g[o]}const I=Object.keys(g).map(_=>g[_]);return y.length===0?Promise.all(I.map(_=>this._activateExtension(_.id,_.reason))).then(_=>{}):this._activateExtensions(I).then(_=>this._activateExtensions(y))}_activateExtension(d,g){const y=m.ExtensionIdentifier.toKey(d);if(this._activatedExtensions.has(y))return Promise.resolve(void 0);const I=this._activatingExtensions.get(y);if(I)return I;const _=this._host.actualActivateExtension(d,g).then(void 0,s=>{const o=new Error;return s&&s.name&&(o.name=s.name),s&&s.message?o.message=`Activating extension '${d.value}' failed: ${s.message}.`:o.message=`Activating extension '${d.value}' failed: ${s}.`,s&&s.stack&&(o.stack=s.stack),this._host.onExtensionActivationError(d,o,null),this._logService.error(`Activating extension ${d.value} failed due to an error:`),this._logService.error(s),new P(s)}).then(s=>{this._activatedExtensions.set(y,s),this._activatingExtensions.delete(y)});return this._activatingExtensions.set(y,_),_}};c=Ve([$e(4,k.ILogService)],c),e.ExtensionsActivator=c}),define(me[228],ge([0,1,12,35,27,10,116]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let E=class extends m.LogService{constructor(A){if(A.logFile.scheme!==C.Schemas.file)throw new Error("Only file-logging supported");super(new R.SpdLogLogger(L.ExtensionHostLogFileName,A.logFile.fsPath,!0,A.logLevel))}$setLevel(A){this.setLevel(A)}};E=Ve([$e(0,k.IExtHostInitDataService)],E),e.ExtHostLogService=E}),define(me[229],ge([0,1,16]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,R)=>{this._actualOk=C,this._actualErr=R,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,m.onUnexpectedError)(C))}then(C,R){return this._ensureActual().then(C,R)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=L}),define(me[66],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class m{constructor(A,n){this._proxyIdentifierBrand=void 0,this.isMain=A,this.sid=n,this.nid=++m.count}}e.ProxyIdentifier=m,m.count=0;const L=[];function k(S){const A=new m(!0,S);return L[A.nid]=A,A}e.createMainContextProxyIdentifier=k;function C(S){const A=new m(!1,S);return L[A.nid]=A,A}e.createExtHostContextProxyIdentifier=C;function R(S){return L[S].sid}e.getStringIdentifierForProxy=R;class E{constructor(A){this.value=A}}e.SerializableObjectWithBuffers=E}),define(me[5],ge([0,1,60,2,66]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var C;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var R;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(R=e.TextEditorRevealType||(e.TextEditorRevealType={}));var E;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(E=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var A;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(A=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var P;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(P=e.CandidatePortSource||(e.CandidatePortSource={}));var c;(function(s){s.name="$ident";function o(t,a){return Object.defineProperty(t,s.name,{value:a,enumerable:!0}),t}s.mixin=o;function p(t){return t[s.name]}s.of=p})(c=e.ObjectIdentifier||(e.ObjectIdentifier={}));class h{static mixin(o){return o._id=h._n++,o}}e.IdObject=h,h._n=0;var d;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.command="m",s.kindModifier="n"})(d=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var y;(function(s){s[s.File=1]="File",s[s.Text=2]="Text",s[s.Cell=3]="Cell"})(y=e.WorkspaceEditType||(e.WorkspaceEditType={}));function I(s){if(s&&s.edits)for(const o of s.edits)typeof o.resource=="object"?o.resource=L.URI.revive(o.resource):(o.newUri=L.URI.revive(o.newUri),o.oldUri=L.URI.revive(o.oldUri)),o.metadata&&o.metadata.iconPath&&(o.metadata=(0,m.revive)(o.metadata));return s}e.reviveWorkspaceEditDto=I;var _;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(_=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,k.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,k.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,k.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,k.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,k.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,k.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,k.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,k.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,k.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,k.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,k.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,k.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,k.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,k.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,k.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,k.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,k.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,k.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,k.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,k.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,k.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,k.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,k.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,k.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,k.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,k.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,k.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,k.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,k.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,k.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,k.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,k.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,k.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,k.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,k.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,k.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,k.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,k.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,k.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,k.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,k.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,k.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,k.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,k.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,k.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,k.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,k.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,k.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,k.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,k.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,k.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,k.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,k.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,k.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,k.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,k.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,k.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,k.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,k.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[90],ge([0,1,5,3,4]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class C{constructor(E){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=E.getProxy(m.MainContext.MainThreadSecretState)}async $onDidChangePassword(E){this._onDidChangePassword.fire(E)}get(E,S){return this._proxy.$getPassword(E,S)}store(E,S,A){return this._proxy.$setPassword(E,S,A)}delete(E,S){return this._proxy.$deletePassword(E,S)}}e.ExtHostSecretState=C,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")}),define(me[67],ge([0,1,4,12,5,14]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,m.createDecorator)("IExtHostApiDeprecationService");let R=class{constructor(S,A){this._extHostLogService=A,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(k.MainContext.MainThreadTelemetry)}report(S,A,n){const P=this.getUsageKey(S,A);this._reportedUsages.has(P)||(this._reportedUsages.add(P),A.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:A.identifier.value,apiId:S}))}getUsageKey(S,A){return`${S}-${A.identifier.value}`}};R=Ve([$e(0,C.IExtHostRpcService),$e(1,L.ILogService)],R),e.ExtHostApiDeprecationService=R,e.NullApiDeprecationService=Object.freeze(new class{report(E,S,A){}})}),define(me[230],ge([0,1,3,5,7,26]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class R{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new m.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,A,n,P={}){const c=C.ExtensionIdentifier.toKey(S.identifier),h=this._inFlightRequests.get(c)||[],d=[...n].sort().join(" ");let g=h.find(y=>y.scopes===d);if(g)return g.result;{const y=this._getSession(S,c,A,n,P);g={scopes:d,result:y},h.push(g),this._inFlightRequests.set(c,h);try{await y}finally{const I=h.findIndex(_=>_.scopes===d);I>-1&&(h.splice(I),this._inFlightRequests.set(c,h))}return y}}async _getSession(S,A,n,P,c={}){await this._proxy.$ensureProvider(n);const h=S.displayName||S.name;return this._proxy.$getSession(n,P,A,h,c)}async removeSession(S,A){const n=this._authenticationProviders.get(S);return n?n.provider.removeSession(A):this._proxy.$removeSession(S,A)}registerAuthenticationProvider(S,A,n,P){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:A,provider:n,options:P??{supportsMultipleAccounts:!1}}),this._providers.find(h=>h.id===S)||this._providers.push({id:S,label:A});const c=n.onDidChangeSessions(h=>{this._proxy.$sendDidChangeSessions(S,{added:h.added??[],changed:h.changed??[],removed:h.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,A,P?.supportsMultipleAccounts??!1),new k.Disposable(()=>{c.dispose(),this._authenticationProviders.delete(S);const h=this._providers.findIndex(d=>d.id===S);h>-1&&this._providers.splice(h),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,A){const n=this._authenticationProviders.get(S);if(n)return Promise.resolve(n.provider.createSession(A));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,A){const n=this._authenticationProviders.get(S);if(n)return Promise.resolve(n.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,A){const n=this._authenticationProviders.get(S);if(n)return Promise.resolve(n.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,A){return this._onDidChangeSessions.fire({provider:{id:S,label:A}}),Promise.resolve()}}e.ExtHostAuthentication=R}),define(me[231],ge([0,1,5,14,15]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(E,S){this._extHostDocumentsAndEditors=S,this._proxy=E.getProxy(m.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(E){const S=k.WorkspaceEdit.from(E,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};C=Ve([$e(0,L.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(me[232],ge([0,1,5]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(C){const R=C.getProxy(m.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(E){return R.$writeText(E)}})}}e.ExtHostClipboard=L}),define(me[44],ge([0,1,13,7,15,25,5,17,12,60,41,51,2,6,4,14,64]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let I=class{constructor(a,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=a.getProxy(R.MainContext.MainThreadCommands),this._logService=r,this.converter=new _(this,i=>{const l=this._apiCommands.get(i);return l?.result===o.Void?l:void 0},r),this._argumentProcessors=[{processArgument(i){return(0,A.revive)(i)}},{processArgument(i){return(0,C.cloneAndChange)(i,function(l){if(n.Range.isIRange(l))return k.Range.to(l);if(P.Position.isIPosition(l))return k.Position.to(l);if(n.Range.isIRange(l.range)&&c.URI.isUri(l.uri))return k.location.to(l);if(!Array.isArray(l))return l})}}]}registerArgumentProcessor(a){this._argumentProcessors.push(a)}registerApiCommand(a){const r=this.registerCommand(!1,a.id,async(...i)=>{const l=a.args.map((f,b)=>{if(!f.validate(i[b]))throw new Error(`Invalid argument '${f.name}' when running '${a.id}', received: ${i[b]}`);return f.convert(i[b])}),u=await this.executeCommand(a.internalId,...l);return a.result.convert(u,i,this.converter)},void 0,{description:a.description,args:a.args,returns:a.result.description});return this._apiCommands.set(a.id,a),new L.Disposable(()=>{r.dispose(),this._apiCommands.delete(a.id)})}registerCommand(a,r,i,l,u){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:i,thisArg:l,description:u}),a&&this._proxy.$registerCommand(r),new L.Disposable(()=>{this._commands.delete(r)&&a&&this._proxy.$unregisterCommand(r)})}executeCommand(a,...r){return this._logService.trace("ExtHostCommands#executeCommand",a),this._doExecuteCommand(a,r,!0)}async _doExecuteCommand(a,r,i){if(this._commands.has(a))return this._executeContributedCommand(a,r);{const l=(0,C.cloneAndChange)(r,function(u){if(u instanceof L.Position)return k.Position.from(u);if(u instanceof L.Range)return k.Range.from(u);if(u instanceof L.Location)return k.location.from(u);if(L.NotebookRange.isNotebookRange(u))return k.NotebookRange.from(u);if(!Array.isArray(u))return u});try{const u=await this._proxy.$executeCommand(a,l,i);return(0,A.revive)(u)}catch(u){if(u instanceof Error&&u.message==="$executeCommand:retry")return this._doExecuteCommand(a,r,!1);throw u}}}async _executeContributedCommand(a,r){const i=this._commands.get(a);if(!i)throw new Error("Unknown command");let{callback:l,thisArg:u,description:f}=i;if(f)for(let b=0;b<f.args.length;b++)try{(0,m.validateConstraint)(r[b],f.args[b].constraint)}catch(D){throw new Error(`Running the contributed command: '${a}' failed. Illegal argument '${f.args[b].name}' - ${f.args[b].description}`)}try{return await l.apply(u,r)}catch(b){if(a===this.converter.delegatingCommandId){const D=this.converter.getActualCommand(...r);D&&(a=D.command)}throw this._logService.error(b,a),new Error(`Running the contributed command: '${a}' failed.`)}}$executeContributedCommand(a,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",a),this._commands.has(a)?(r=r.map(i=>this._argumentProcessors.reduce((l,u)=>u.processArgument(l),i)),this._executeContributedCommand(a,r)):Promise.reject(new Error(`Contributed command '${a}' does not exist.`))}getCommands(a=!1){return this._logService.trace("ExtHostCommands#getCommands",a),this._proxy.$getCommands().then(r=>(a&&(r=r.filter(i=>i[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const a=Object.create(null);for(let[r,i]of this._commands){let{description:l}=i;l&&(a[r]=l)}return Promise.resolve(a)}};I=Ve([$e(0,g.IExtHostRpcService),$e(1,S.ILogService)],I),e.ExtHostCommands=I,e.IExtHostCommands=(0,d.createDecorator)("IExtHostCommands");class _{constructor(a,r,i){this._commands=a,this._lookupApiCommand=r,this._logService=i,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(a,r){if(!a)return;const i={$ident:void 0,id:a.command,title:a.title,tooltip:a.tooltip};if(!a.command)return i;const l=this._lookupApiCommand(a.command);if(l)i.id=l.internalId,i.arguments=l.args.map((u,f)=>u.convert(a.arguments&&a.arguments[f]));else if((0,E.isNonEmptyArray)(a.arguments)){const u=++this._cachIdPool;this._cache.set(u,a),r.add((0,h.toDisposable)(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),i.$ident=u,i.id=this.delegatingCommandId,i.arguments=[u],this._logService.trace("CommandsConverter#CREATE",a.command,u)}return i}fromInternal(a){const r=R.ObjectIdentifier.of(a);return typeof r=="number"?this._cache.get(r):{command:a.id,title:a.title,arguments:a.arguments}}getActualCommand(...a){return this._cache.get(a[0])}_executeConvertedCommand(...a){const r=this.getActualCommand(...a);return this._logService.trace("CommandsConverter#EXECUTE",a[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=_;class s{constructor(a,r,i,l){this.name=a,this.description=r,this.validate=i,this.convert=l}optional(){return new s(this.name,`(optional) ${this.description}`,a=>a==null||this.validate(a),a=>a===void 0?void 0:a===null?null:this.convert(a))}with(a,r){return new s(a??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=s,s.Uri=new s("uri","Uri of a text document",t=>c.URI.isUri(t),t=>t),s.Position=new s("position","A position in a text document",t=>L.Position.isPosition(t),k.Position.from),s.Range=new s("range","A range in a text document",t=>L.Range.isRange(t),k.Range.from),s.Selection=new s("selection","A selection in a text document",t=>L.Selection.isSelection(t),k.Selection.from),s.Number=new s("number","",t=>typeof t=="number",t=>t),s.String=new s("string","",t=>typeof t=="string",t=>t),s.CallHierarchyItem=new s("item","A call hierarchy item",t=>t instanceof L.CallHierarchyItem,k.CallHierarchyItem.from),s.TypeHierarchyItem=new s("item","A type hierarchy item",t=>t instanceof L.TypeHierarchyItem,k.TypeHierarchyItem.from),s.TestItem=new s("testItem","A VS Code TestItem",t=>t instanceof y.TestItemImpl,k.TestItem.from);class o{constructor(a,r){this.description=a,this.convert=r}}e.ApiCommandResult=o,o.Void=new o("no result",t=>t);class p{constructor(a,r,i,l,u){this.id=a,this.internalId=r,this.description=i,this.args=l,this.result=u}}e.ApiCommand=p}),define(me[233],ge([0,1,15,7,83,44,17,111]),function(J,e,m,L,k,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(m.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,h)=>{if((0,R.isFalsyOrEmpty)(c))return;class d extends L.SymbolInformation{static to(y){const I=new d(y.name,m.SymbolKind.to(y.kind),y.containerName||"",new L.Location(h[0],m.Range.to(y.range)));return I.detail=y.detail,I.range=I.location.range,I.selectionRange=m.Range.to(y.selectionRange),I.children=y.children?y.children.map(d.to):[],I}}return c.map(d.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",c=>typeof c=="string",c=>c),new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(m.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(m.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(m.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",c=>Array.isArray(c)&&c.every(h=>L.Position.isPosition(h)),c=>c.map(m.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",c=>c.map(h=>{let d;for(const g of h.reverse())d=new L.SelectionRange(m.Range.to(g),d);return d}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",c=>{const h=[];if(Array.isArray(c))for(let d of c)h.push(...d[1].map(m.WorkspaceSymbol.to));return h})),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(m.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(m.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(m.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",c=>{if(!!c){if(c.rejectReason)throw new Error(c.rejectReason);return m.WorkspaceEdit.to(c)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(m.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new L.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const h=(0,E.decodeSemanticTokensDto)(c);if(h.type==="full")return new L.SemanticTokens(h.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new L.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const h=(0,E.decodeSemanticTokensDto)(c);if(h.type==="full")return new L.SemanticTokens(h.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(c,h,d)=>{if(!c)return new L.CompletionList([]);const g=c.suggestions.map(y=>m.CompletionItem.to(y,d));return new L.CompletionList(g,c.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",c=>{if(c)return m.SignatureHelp.to(c)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(c,h,d)=>n(g=>new L.CodeLens(m.Range.to(g.range),g.command&&d.fromInternal(g.command)))(c))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>L.Range.isRange(c),c=>L.Selection.isSelection(c)?m.Selection.from(c):m.Range.from(c)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(c,h,d)=>n(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(g.command)}else{const y=new L.CodeAction(g.title,g.kind?new L.CodeActionKind(g.kind):void 0);return g.edit&&(y.edit=m.WorkspaceEdit.to(g.edit)),g.command&&(y.command=d.fromInternal(g.command)),y.isPreferred=g.isPreferred,y}})(c))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(h=>new L.ColorInformation(m.Range.to(h.range),m.Color.to(h.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",c=>c instanceof L.Color,m.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:m.Range.from(c.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(m.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",c=>c.map(m.InlayHint.to))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(h=>m.NotebookExclusiveDocumentPattern.to(h))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",c=>c.map(m.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[m.ViewColumn.from(c.viewColumn),m.TextEditorOpenOptions.from(c)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[m.ViewColumn.from(c.viewColumn),m.TextEditorOpenOptions.from(c)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[m.ViewColumn.from(c.viewColumn),m.TextEditorOpenOptions.from(c)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class A{static register(h){S.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=A;function n(c){return h=>{if(Array.isArray(h))return h.map(c)}}function P(c){if(!Array.isArray(c))return;const h=[];for(const d of c)k.isLocationLink(d)?h.push(m.DefinitionLink.to(d)):h.push(m.location.to(d));return h}}),define(me[234],ge([0,1,18,58,3,6,2,83,26,15,7,5]),function(J,e,m,L,k,C,R,E,S,A,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function c(h,d,g){const y=h.getProxy(P.MainContext.MainThreadComments);class I{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,d.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const l=this._commentControllers.get(i.handle);return l||i}else if(i&&i.$mid===7){const l=this._commentControllers.get(i.commentControlHandle);if(!l)return i;const u=l.getCommentThread(i.commentThreadHandle);return u||i}else if(i&&i.$mid===8){const l=this._commentControllers.get(i.thread.commentControlHandle);if(!l)return i;const u=l.getCommentThread(i.thread.commentThreadHandle);return u?{thread:u,text:i.text}:i}else if(i&&i.$mid===9){const l=this._commentControllers.get(i.thread.commentControlHandle);if(!l)return i;const u=l.getCommentThread(i.thread.commentThreadHandle);if(!u)return i;let f=i.commentUniqueId,b=u.getCommentByUniqueId(f);return b||i}else if(i&&i.$mid===10){const l=this._commentControllers.get(i.thread.commentControlHandle);if(!l)return i;const u=l.getCommentThread(i.thread.commentThreadHandle);if(!u)return i;let f=i.text,b=i.commentUniqueId,D=u.getCommentByUniqueId(b);return D?(D.body=f,D):i}return i}})}createCommentController(i,l,u){const f=I.handlePool++,b=new s(i,f,l,u);this._commentControllers.set(b.handle,b);const D=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(i.identifier))||[];return D.push(b),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(i.identifier),D),b.value}$createCommentThreadTemplate(i,l,u){const f=this._commentControllers.get(i);!f||f.$createCommentThreadTemplate(l,u)}async $updateCommentThreadTemplate(i,l,u){const f=this._commentControllers.get(i);!f||f.$updateCommentThreadTemplate(l,u)}$deleteCommentThread(i,l){const u=this._commentControllers.get(i);u&&u.$deleteCommentThread(l)}$provideCommentingRanges(i,l,u){const f=this._commentControllers.get(i);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const b=g.getDocument(R.URI.revive(l));return(0,m.asPromise)(()=>f.commentingRangeProvider.provideCommentingRanges(b,u)).then(D=>D?D.map(w=>A.Range.from(w)):void 0)}$toggleReaction(i,l,u,f,b){const D=this._commentControllers.get(i);return!D||!D.reactionHandler?Promise.resolve(void 0):(0,m.asPromise)(()=>{const w=D.getCommentThread(l);if(w){const T=w.getCommentByUniqueId(f.uniqueIdInThread);if(D!==void 0&&T&&D.reactionHandler)return D.reactionHandler(T,t(b))}return Promise.resolve(void 0)})}dispose(){}}I.handlePool=0;class _{constructor(i,l,u,f,b,D,w){this._commentControllerHandle=l,this._id=u,this._uri=f,this._range=b,this._comments=D,this.handle=_._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new k.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputDisposables.value=new C.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),y.$createCommentThread(l,this.handle,this._id,this._uri,A.Range.from(this._range),w),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=D,this._localDisposables.push({dispose:()=>{y.$deleteCommentThread(l,this.handle)}});const T=this;this.value={get uri(){return T.uri},get range(){return T.range},set range(v){T.range=v},get comments(){return T.comments},set comments(v){T.comments=v},get collapsibleState(){return T.collapsibleState},set collapsibleState(v){T.collapsibleState=v},get canReply(){return T.canReply},set canReply(v){T.canReply=v},get contextValue(){return T.contextValue},set contextValue(v){T.contextValue=v},get label(){return T.label},set label(v){T.label=v},dispose:()=>{T.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new C.DisposableStore);const i=u=>Object.prototype.hasOwnProperty.call(this.modifications,u),l={};i("range")&&(l.range=A.Range.from(this._range)),i("label")&&(l.label=this.label),i("contextValue")&&(l.contextValue=this.contextValue),i("comments")&&(l.comments=this._comments.map(u=>o(this,u,this._commentsMap))),i("collapsibleState")&&(l.collapseState=a(this._collapseState)),i("canReply")&&(l.canReply=this.canReply),this.modifications={},y.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,l)}getCommentByUniqueId(i){for(let l of this._commentsMap){let u=l[0],f=l[1];if(i===f)return u}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}_._handlePool=0,Ve([(0,L.debounce)(100)],_.prototype,"eventuallyUpdateCommentThread",null);class s{constructor(i,l,u,f){this._extension=i,this._handle=l,this._id=u,this._label=f,this._threads=new Map,y.$registerCommentController(this.handle,u,f);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(D){b.options=D},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(D){b.commentingRangeProvider=D},get reactionHandler(){return b.reactionHandler},set reactionHandler(D){b.reactionHandler=D},createCommentThread(D,w,T){return b.createCommentThread(D,w,T).value},dispose:()=>{b.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{y.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,y.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,y.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,l,u,f){if(typeof i=="string"){const b=new _(this.id,this.handle,i,l,u,f,this._extension.identifier);return this._threads.set(b.handle,b),b}else{const b=new _(this.id,this.handle,void 0,i,l,u,this._extension.identifier);return this._threads.set(b.handle,b),b}}$createCommentThreadTemplate(i,l){const u=new _(this.id,this.handle,void 0,R.URI.revive(i),A.Range.to(l),[],this._extension.identifier);return u.collapsibleState=E.CommentThreadCollapsibleState.Expanded,this._threads.set(u.handle,u),u}$updateCommentThreadTemplate(i,l){let u=this._threads.get(i);u&&(u.range=A.Range.to(l))}$deleteCommentThread(i){let l=this._threads.get(i);l&&l.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function o(r,i,l){let u=l.get(i);u||(u=++r.commentHandle,l.set(i,u));const f=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:u,body:A.MarkdownString.from(i.body),userName:i.author.name,userIconPath:f,label:i.label,commentReactions:i.reactions?i.reactions.map(b=>p(b)):void 0}}function p(r){return{label:r.label,iconPath:r.iconPath?A.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function t(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?R.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function a(r){if(r!==void 0)switch(r){case n.CommentThreadCollapsibleState.Expanded:return E.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return E.CommentThreadCollapsibleState.Collapsed}return E.CommentThreadCollapsibleState.Collapsed}return new I}e.createExtHostComments=c}),define(me[131],ge([0,1,2,5,7,4,14,12,17,9,8]),function(J,e,m,L,k,C,R,E,S,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let P=class wn{constructor(h,d){this._logService=d,this._provider=new Map,this._proxy=h.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,d){const g=wn._handlePool++;this._provider.set(g,{provider:h,extensionId:d}),this._proxy.$registerDecorationProvider(g,d.value);const y=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(I=>{if(!I){this._proxy.$onDidChange(g,null);return}let _=(0,S.asArray)(I);if(_.length<=wn._maxEventSize){this._proxy.$onDidChange(g,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",d.value,_.length);const s=_.map(t=>({uri:t,rank:(0,A.count)(t.path,"/")})),o=(0,S.groupBy)(s,(t,a)=>t.rank-a.rank||(0,A.compare)(t.uri.path,a.uri.path));let p=[];e:for(let t of o){let a;for(let r of t){let i=(0,n.dirname)(r.uri.path);if(a!==i&&(a=i,p.push(r.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(g,p)});return new k.Disposable(()=>{y?.dispose(),this._proxy.$unregisterDecorationProvider(g),this._provider.delete(g)})}async $provideDecorations(h,d,g){if(!this._provider.has(h))return Object.create(null);const y=Object.create(null),{provider:I,extensionId:_}=this._provider.get(h);return await Promise.all(d.map(async s=>{try{const{uri:o,id:p}=s,t=await Promise.resolve(I.provideFileDecoration(m.URI.revive(o),g));if(!t)return;try{k.FileDecoration.validate(t),y[p]=[t.propagate,t.tooltip,t.badge,t.color]}catch(a){this._logService.warn(`INVALID decoration from extension '${_.value}': ${a}`)}}catch(o){this._logService.error(o)}})),y}};P._handlePool=0,P._maxEventSize=250,P=Ve([$e(0,R.IExtHostRpcService),$e(1,E.ILogService)],P),e.ExtHostDecorations=P,e.IExtHostDecorations=(0,C.createDecorator)("IExtHostDecorations")});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,m):k?k.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[235],ge([0,1,164,117,2,5,7,15,3,12,24,52,141]),function(J,e,m,L,k,C,R,E,S,A,n,P,c){"use strict";var h,d,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class y{constructor(s,o,p,t,a,r){this._name=s,this._owner=o,this._maxDiagnosticsPerFile=p,h.set(this,void 0),d.set(this,void 0),g.set(this,void 0),this._isDisposed=!1,nt(this,g,new c.SkipList((i,l)=>t.compare(i,l)),"f"),nt(this,h,a,"f"),nt(this,d,r,"f")}dispose(){this._isDisposed||(Oe(this,d,"f").fire([...Oe(this,g,"f").keys()]),Oe(this,h,"f")&&Oe(this,h,"f").$clear(this._owner),Oe(this,g,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(s,o){if(!s){this.clear();return}this._checkDisposed();let p=[];if(k.URI.isUri(s)){if(!o){this.delete(s);return}Oe(this,g,"f").set(s,o.slice()),p=[s]}else if(Array.isArray(s)){p=[];let a;s=[...s].sort(y._compareIndexedTuplesByUri);for(const r of s){const[i,l]=r;if((!a||i.toString()!==a.toString())&&(a&&Oe(this,g,"f").get(a).length===0&&Oe(this,g,"f").delete(a),a=i,p.push(i),Oe(this,g,"f").set(i,[])),l){const u=Oe(this,g,"f").get(i);u&&u.push(...l)}else{const u=Oe(this,g,"f").get(i);u&&(u.length=0)}}}if(Oe(this,d,"f").fire(p),!Oe(this,h,"f"))return;const t=[];for(let a of p){let r=[];const i=Oe(this,g,"f").get(a);if(i)if(i.length>this._maxDiagnosticsPerFile){r=[];const l=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(let f of i)if(f.severity===l[u]&&r.push(E.Diagnostic.from(f))===this._maxDiagnosticsPerFile)break e;r.push({severity:L.MarkerSeverity.Info,message:(0,m.localize)(0,null,i.length-this._maxDiagnosticsPerFile),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=i.map(l=>E.Diagnostic.from(l));t.push([a,r])}Oe(this,h,"f").$changeMany(this._owner,t)}delete(s){this._checkDisposed(),Oe(this,d,"f").fire([s]),Oe(this,g,"f").delete(s),Oe(this,h,"f")&&Oe(this,h,"f").$changeMany(this._owner,[[s,void 0]])}clear(){this._checkDisposed(),Oe(this,d,"f").fire([...Oe(this,g,"f").keys()]),Oe(this,g,"f").clear(),Oe(this,h,"f")&&Oe(this,h,"f").$clear(this._owner)}forEach(s,o){this._checkDisposed();for(let p of Oe(this,g,"f").keys())s.apply(o,[p,this.get(p),this])}get(s){this._checkDisposed();const o=Oe(this,g,"f").get(s);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(s){return this._checkDisposed(),Array.isArray(Oe(this,g,"f").get(s))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(s,o){return s[0].toString()<o[0].toString()?-1:s[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=y,h=new WeakMap,d=new WeakMap,g=new WeakMap;let I=class Zt{constructor(s,o,p){this._logService=o,this._fileSystemInfoService=p,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,Zt._mapper),this._proxy=s.getProxy(C.MainContext.MainThreadDiagnostics)}static _mapper(s){const o=new n.ResourceMap;for(const p of s)o.set(p,p);return{uris:Object.freeze(Array.from(o.values()))}}createDiagnosticCollection(s,o){const{_collections:p,_proxy:t,_onDidChangeDiagnostics:a,_logService:r,_fileSystemInfoService:i}=this,l=new class{$changeMany(b,D){t.$changeMany(b,D),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,b,D.length===0?"CLEARING":D)}$clear(b){t.$clear(b),r.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,b)}dispose(){t.dispose()}};let u;if(!o)o="_generated_diagnostic_collection_name_#"+Zt._idPool++,u=o;else if(!p.has(o))u=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do u=o+Zt._idPool++;while(p.has(u))}return new class extends y{constructor(){super(o,u,Zt._maxDiagnosticsPerFile,i.extUri,l,a);p.set(u,this)}dispose(){super.dispose(),p.delete(u)}}}getDiagnostics(s){if(s)return this._getDiagnostics(s);{const o=new Map,p=[];for(const t of this._collections.values())t.forEach((a,r)=>{let i=o.get(a.toString());typeof i=="undefined"&&(i=p.length,o.set(a.toString(),i),p.push([a,[]])),p[i][1]=p[i][1].concat(...r)});return p}}_getDiagnostics(s){let o=[];for(let p of this._collections.values())p.has(s)&&(o=o.concat(p.get(s)));return o}$acceptMarkersChange(s){if(!this._mirrorCollection){const o="_generated_mirror",p=new y(o,o,Zt._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,p),this._mirrorCollection=p}for(const[o,p]of s)this._mirrorCollection.set(k.URI.revive(o),p.map(E.Diagnostic.to))}};I._idPool=0,I._maxDiagnosticsPerFile=1e3,I=Ve([$e(1,A.ILogService),$e(2,P.IExtHostFileSystemInfo)],I),e.ExtHostDiagnostics=I}),define(me[236],ge([0,1,2,5]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(R){this._proxy=R.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(R){return this._proxy.$showOpenDialog(R).then(E=>E?E.map(S=>m.URI.revive(S)):void 0)}showSaveDialog(R){return this._proxy.$showSaveDialog(R).then(E=>E?m.URI.revive(E):void 0)}}e.ExtHostDialogs=k}),define(me[237],ge([0,1,16,2,7,5,10,21,9]),function(J,e,m,L,k,C,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class A{constructor(P,c,h){this._documentsAndEditors=c,this._logService=h,this._documentContentProviders=new Map,this._proxy=P.getProxy(C.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,c){if(Object.keys(R.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const h=A._handlePool++;this._documentContentProviders.set(h,c),this._proxy.$registerTextContentProvider(h,P);let d;return typeof c.onDidChange=="function"&&(d=c.onDidChange(g=>{if(g.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(g)&&this.$provideTextDocumentContent(h,g).then(y=>{if(!y&&typeof y!="string")return;const I=this._documentsAndEditors.getDocument(g);if(!I)return;const _=(0,S.splitLines)(y);if(!I.equalLines(_))return this._proxy.$onVirtualDocumentChange(g,y)},m.onUnexpectedError)})),new k.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(P,c){const h=this._documentContentProviders.get(P);return h?Promise.resolve(h.provideTextDocumentContent(L.URI.revive(c),E.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=A,A._handlePool=0}),define(me[238],ge([0,1,3,6,2,5,123,15,13,25,7]),function(J,e,m,L,k,C,R,E,S,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(h,d){this._onDidAddDocument=new m.Emitter,this._onDidRemoveDocument=new m.Emitter,this._onDidChangeDocument=new m.Emitter,this._onDidSaveDocument=new m.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=h.getProxy(C.MainContext.MainThreadDocuments),this._documentsAndEditors=d,this._documentsAndEditors.onDidRemoveDocuments(g=>{for(const y of g)this._onDidRemoveDocument.fire(y.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(g=>{for(const y of g)this._onDidAddDocument.fire(y.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(h){if(!h)return;const d=this._documentsAndEditors.getDocument(h);if(d)return d}getDocument(h){const d=this.getDocumentData(h);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${h}'`);return d.document}ensureDocumentData(h){const d=this._documentsAndEditors.getDocument(h);if(d)return Promise.resolve(d);let g=this._documentLoader.get(h.toString());return g||(g=this._proxy.$tryOpenDocument(h).then(y=>{this._documentLoader.delete(h.toString());const I=k.URI.revive(y);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(I))},y=>(this._documentLoader.delete(h.toString()),Promise.reject(y))),this._documentLoader.set(h.toString(),g)),g}createDocumentData(h){return this._proxy.$tryCreateDocument(h).then(d=>k.URI.revive(d))}$acceptModelModeChanged(h,d){const g=k.URI.revive(h),y=this._documentsAndEditors.getDocument(g);if(!y)throw new Error("unknown document");this._onDidRemoveDocument.fire(y.document),y._acceptLanguageId(d),this._onDidAddDocument.fire(y.document)}$acceptModelSaved(h){const d=k.URI.revive(h),g=this._documentsAndEditors.getDocument(d);if(!g)throw new Error("unknown document");this.$acceptDirtyStateChanged(h,!1),this._onDidSaveDocument.fire(g.document)}$acceptDirtyStateChanged(h,d){const g=k.URI.revive(h),y=this._documentsAndEditors.getDocument(g);if(!y)throw new Error("unknown document");y._acceptIsDirty(d),this._onDidChangeDocument.fire({document:y.document,contentChanges:[],reason:void 0})}$acceptModelChanged(h,d,g){const y=k.URI.revive(h),I=this._documentsAndEditors.getDocument(y);if(!I)throw new Error("unknown document");I._acceptIsDirty(g),I.onEvents(d);let _;d.isUndoing?_=n.TextDocumentChangeReason.Undo:d.isRedoing&&(_=n.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,A.deepFreeze)({document:I.document,contentChanges:d.changes.map(s=>({range:E.Range.to(s.range),rangeOffset:s.rangeOffset,rangeLength:s.rangeLength,text:s.text})),reason:_}))}setWordDefinitionFor(h,d){(0,R.setWordDefinitionFor)(h,d)}}e.ExtHostDocuments=P}),define(me[45],ge([0,1,56,3,6,2,4,5,123,14,130,15,12,24,10,94,139]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class I{constructor(o){this.value=o,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(o,p){this._extHostRpc=o,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const p=[],t=[],a=[];if(o.removedDocuments)for(const r of o.removedDocuments){const i=C.URI.revive(r),l=this._documents.get(i);l?.unref()&&(this._documents.delete(i),p.push(l.value))}if(o.addedDocuments)for(const r of o.addedDocuments){const i=C.URI.revive(r.uri);let l=this._documents.get(i);if(l&&i.scheme!==d.Schemas.vscodeNotebookCell&&i.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);l||(l=new I(new S.ExtHostDocumentData(this._extHostRpc.getProxy(E.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(i,l),t.push(l.value)),l.ref()}if(o.removedEditors)for(const r of o.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&a.push(i)}if(o.addedEditors)for(const r of o.addedEditors){const i=C.URI.revive(r.documentUri);m.ok(this._documents.has(i),`document '${i}' does not exist`),m.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const l=this._documents.get(i).value,u=new n.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(E.MainContext.MainThreadTextEditors),this._logService,new y.Lazy(()=>l.document),r.selections.map(P.Selection.to),r.options,r.visibleRanges.map(f=>P.Range.to(f)),typeof r.editorPosition=="number"?P.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,u)}o.newActiveEditor!==void 0&&(m.ok(o.newActiveEditor===null||this._editors.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this._activeEditorId=o.newActiveEditor),(0,k.dispose)(p),(0,k.dispose)(a),o.removedDocuments&&this._onDidRemoveDocuments.fire(p),o.addedDocuments&&this._onDidAddDocuments.fire(t),(o.removedEditors||o.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),o.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(o){return this._documents.get(o)?.value}allDocuments(){return g.Iterable.map(this._documents.values(),o=>o.value)}getEditor(o){return this._editors.get(o)}activeEditor(o){if(!this._activeEditorId)return;const p=this._editors.get(this._activeEditorId);return o?p:p?.value}allEditors(){return[...this._editors.values()]}};_=Ve([$e(0,A.IExtHostRpcService),$e(1,c.ILogService)],_),e.ExtHostDocumentsAndEditors=_,e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[239],ge([0,1,2,5,6,7,15,148,9,23]),function(J,e,m,L,k,C,R,E,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const d=this._schemes.indexOf(h);d>=0&&(this._schemes.splice(d,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),d=[];let g,y,I=14,_=14;for(const s of h){let o=g?(0,S.commonPrefixLength)(g,s):0;for(o===0?y=1:y=_;o<s.length;o++)o+1===s.length?(I=_,_=9):_+=1,d.push([y,s.toUpperCase().charCodeAt(o),_]),d.push([y,s.toLowerCase().charCodeAt(o),_]),y=_;g=s,_=I}d.push([9,58,10]),d.push([10,47,12]),this._stateMachine=new E.StateMachine(d)}}provideDocumentLinks(h){this._initStateMachine();const d=[],g=E.LinkComputer.computeLinks({getLineContent(y){return h.lineAt(y-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const y of g){const I=R.DocumentLink.to(y);I.target&&d.push(I)}return d}}class P{constructor(h,d){this._extHostLanguageFeatures=d,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=h.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,d,g,y={}){if(this._registeredSchemes.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const I=this._handlePool++;this._linkProvider.add(d),this._registeredSchemes.add(d),this._fsProvider.set(I,g);let _=2;y.isCaseSensitive&&(_+=1024),y.isReadonly&&(_+=2048),typeof g.copy=="function"&&(_+=8),typeof g.open=="function"&&typeof g.close=="function"&&typeof g.read=="function"&&typeof g.write=="function"&&(_+=4),this._proxy.$registerFileSystemProvider(I,d,_).catch(o=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${d}`),console.error(o)});const s=g.onDidChangeFile(o=>{const p=[];for(const t of o){let{uri:a,type:r}=t;if(a.scheme!==d)continue;let i;switch(r){case C.FileChangeType.Changed:i=0;break;case C.FileChangeType.Created:i=1;break;case C.FileChangeType.Deleted:i=2;break;default:throw new Error("Unknown FileChangeType")}p.push({resource:a,type:i})}this._proxy.$onFileSystemChange(I,p)});return(0,k.toDisposable)(()=>{s.dispose(),this._linkProvider.delete(d),this._registeredSchemes.delete(d),this._fsProvider.delete(I),this._proxy.$unregisterProvider(I)})}static _asIStat(h){const{type:d,ctime:g,mtime:y,size:I,permissions:_}=h;return{type:d,ctime:g,mtime:y,size:I,permissions:_}}$stat(h,d){return Promise.resolve(this._getFsProvider(h).stat(m.URI.revive(d))).then(g=>P._asIStat(g))}$readdir(h,d){return Promise.resolve(this._getFsProvider(h).readDirectory(m.URI.revive(d)))}$readFile(h,d){return Promise.resolve(this._getFsProvider(h).readFile(m.URI.revive(d))).then(g=>A.VSBuffer.wrap(g))}$writeFile(h,d,g,y){return Promise.resolve(this._getFsProvider(h).writeFile(m.URI.revive(d),g.buffer,y))}$delete(h,d,g){return Promise.resolve(this._getFsProvider(h).delete(m.URI.revive(d),g))}$rename(h,d,g,y){return Promise.resolve(this._getFsProvider(h).rename(m.URI.revive(d),m.URI.revive(g),y))}$copy(h,d,g,y){const I=this._getFsProvider(h);if(!I.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(I.copy(m.URI.revive(d),m.URI.revive(g),y))}$mkdir(h,d){return Promise.resolve(this._getFsProvider(h).createDirectory(m.URI.revive(d)))}$watch(h,d,g,y){const I=this._getFsProvider(h).watch(m.URI.revive(g),y);this._watches.set(d,I)}$unwatch(h,d){const g=this._watches.get(d);g&&(g.dispose(),this._watches.delete(d))}$open(h,d,g){const y=this._getFsProvider(h);if(!y.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(y.open(m.URI.revive(d),g))}$close(h,d){const g=this._getFsProvider(h);if(!g.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(g.close(d))}$read(h,d,g,y){const I=this._getFsProvider(h);if(!I.read)throw new Error('FileSystemProvider does not implement "read"');const _=A.VSBuffer.alloc(y);return Promise.resolve(I.read(d,g,_.buffer,0,y)).then(s=>_.slice(0,s))}$write(h,d,g,y){const I=this._getFsProvider(h);if(!I.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(I.write(d,g,y.buffer,0,y.byteLength))}_getFsProvider(h){const d=this._fsProvider.get(h);if(!d){const g=new Error;throw g.name="ENOPRO",g.message="no provider",g}return d}}e.ExtHostFileSystem=P}),define(me[91],ge([0,1,5,42,7,23,4,14,52]),function(J,e,m,L,k,C,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let A=class xt{constructor(P,c){const h=P.getProxy(m.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(d){return h.$stat(d).catch(xt._handleError)},readDirectory(d){return h.$readdir(d).catch(xt._handleError)},createDirectory(d){return h.$mkdir(d).catch(xt._handleError)},async readFile(d){return h.$readFile(d).then(g=>g.buffer).catch(xt._handleError)},writeFile(d,g){return h.$writeFile(d,C.VSBuffer.wrap(g)).catch(xt._handleError)},delete(d,g){return h.$delete(d,{recursive:!1,useTrash:!1,...g}).catch(xt._handleError)},rename(d,g,y){return h.$rename(d,g,{overwrite:!1,...y}).catch(xt._handleError)},copy(d,g,y){return h.$copy(d,g,{overwrite:!1,...y}).catch(xt._handleError)},isWritableFileSystem(d){const g=c.getCapabilities(d);if(typeof g=="number")return!(g&2048)}})}static _handleError(P){if(!(P instanceof Error))throw new k.FileSystemError(String(P));if(P.name==="ENOPRO")throw k.FileSystemError.Unavailable(P.message);switch(P.name){case L.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(P.message);case L.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(P.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(P.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(P.message);case L.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(P.message);case L.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(P.message);default:throw new k.FileSystemError(P.message,P.name)}}};A=Ve([$e(0,E.IExtHostRpcService),$e(1,S.IExtHostFileSystemInfo)],A),e.ExtHostConsumerFileSystem=A,e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(me[240],ge([0,1,2,44]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class k{constructor(R,E,S,A){this._extHostNotebooks=E,this._textDocumentsAndEditors=S,this._commands=A;const n=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",P=>!0,P=>P),new L.ApiCommandArgument("resource","Interactive resource Uri",P=>!0,P=>P),new L.ApiCommandArgument("controllerId","Notebook controller Id",P=>!0,P=>P),new L.ApiCommandArgument("title","Interactive editor title",P=>!0,P=>P)],new L.ApiCommandResult("Notebook and input URI",P=>{if(P.notebookEditorId!==void 0){const c=this._extHostNotebooks.getEditorById(P.notebookEditorId);return{notebookUri:m.URI.revive(P.notebookUri),inputUri:m.URI.revive(P.inputUri),notebookEditor:c.apiEditor}}return{notebookUri:m.URI.revive(P.notebookUri),inputUri:m.URI.revive(P.inputUri)}}));this._commands.registerApiCommand(n)}$willAddInteractiveDocument(R,E,S,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:E,lines:[""],modeId:S,uri:R,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(m.URI.revive(A))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,E){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=k}),define(me[241],ge([0,1,6,5]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(R){this._handlePool=0,this._proxy=R.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const E=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(E,R),(0,m.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(E)})}}e.ExtHostLabelService=k}),define(me[242],ge([0,1,2,25,15,7,5,9,41,17,13,145,6,111,76,87,46,16,3]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g,y,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class s{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentSymbols(V,ee){const re=this._documents.getDocument(V),le=await this._provider.provideDocumentSymbols(re,ee);if(!(0,A.isFalsyOrEmpty)(le))return le[0]instanceof C.DocumentSymbol?le.map(k.DocumentSymbol.from):s._asDocumentSymbolTree(le)}static _asDocumentSymbolTree(V){V=V.slice(0).sort((le,Z)=>{let oe=le.location.range.start.compareTo(Z.location.range.start);return oe===0&&(oe=Z.location.range.end.compareTo(le.location.range.end)),oe});const ee=[],re=[];for(const le of V){const Z={name:le.name||"!!MISSING: name!!",kind:k.SymbolKind.from(le.kind),tags:le.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:le.containerName,range:k.Range.from(le.location.range),selectionRange:k.Range.from(le.location.range),children:[]};for(;;){if(re.length===0){re.push(Z),ee.push(Z);break}const oe=re[re.length-1];if(S.Range.containsRange(oe.range,Z.range)&&!S.Range.equalsRange(oe.range,Z.range)){oe.children&&oe.children.push(Z),re.push(Z);break}re.pop()}}return ee}}class o{constructor(V,ee,re){this._documents=V,this._commands=ee,this._provider=re,this._cache=new g.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(V,ee){const re=this._documents.getDocument(V),le=await this._provider.provideCodeLenses(re,ee);if(!le||ee.isCancellationRequested)return;const Z=this._cache.add(le),oe=new c.DisposableStore;this._disposables.set(Z,oe);const ve={cacheId:Z,lenses:[]};for(let Me=0;Me<le.length;Me++)ve.lenses.push({cacheId:[Z,Me],range:k.Range.from(le[Me].range),command:this._commands.toInternal(le[Me].command,oe)});return ve}async resolveCodeLens(V,ee){const re=V.cacheId&&this._cache.get(...V.cacheId);if(!re)return;let le;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?le=re:le=await this._provider.resolveCodeLens(re,ee),le||(le=re),ee.isCancellationRequested)return;const Z=V.cacheId&&this._disposables.get(V.cacheId[0]);if(!!Z)return V.command=this._commands.toInternal(le.command??o._badCmd,Z),V}releaseCodeLenses(V){this._disposables.get(V)?.dispose(),this._disposables.delete(V),this._cache.delete(V)}}o._badCmd={command:"missing",title:"!!MISSING: command!!"};function p(je){return Array.isArray(je)?je.map(k.DefinitionLink.from):je?[k.DefinitionLink.from(je)]:[]}class t{constructor(V,ee){this._documents=V,this._provider=ee}async provideDefinition(V,ee,re){const le=this._documents.getDocument(V),Z=k.Position.to(ee),oe=await this._provider.provideDefinition(le,Z,re);return p(oe)}}class a{constructor(V,ee){this._documents=V,this._provider=ee}async provideDeclaration(V,ee,re){const le=this._documents.getDocument(V),Z=k.Position.to(ee),oe=await this._provider.provideDeclaration(le,Z,re);return p(oe)}}class r{constructor(V,ee){this._documents=V,this._provider=ee}async provideImplementation(V,ee,re){const le=this._documents.getDocument(V),Z=k.Position.to(ee),oe=await this._provider.provideImplementation(le,Z,re);return p(oe)}}class i{constructor(V,ee){this._documents=V,this._provider=ee}async provideTypeDefinition(V,ee,re){const le=this._documents.getDocument(V),Z=k.Position.to(ee),oe=await this._provider.provideTypeDefinition(le,Z,re);return p(oe)}}class l{constructor(V,ee){this._documents=V,this._provider=ee}async provideHover(V,ee,re){const le=this._documents.getDocument(V),Z=k.Position.to(ee),oe=await this._provider.provideHover(le,Z,re);if(!(!oe||(0,A.isFalsyOrEmpty)(oe.contents)))return oe.range||(oe.range=le.getWordRangeAtPosition(Z)),oe.range||(oe.range=new C.Range(Z,Z)),k.Hover.from(oe)}}class u{constructor(V,ee){this._documents=V,this._provider=ee}async provideEvaluatableExpression(V,ee,re){const le=this._documents.getDocument(V),Z=k.Position.to(ee),oe=await this._provider.provideEvaluatableExpression(le,Z,re);if(oe)return k.EvaluatableExpression.from(oe)}}class f{constructor(V,ee){this._documents=V,this._provider=ee}async provideInlineValues(V,ee,re,le){const Z=this._documents.getDocument(V),oe=await this._provider.provideInlineValues(Z,k.Range.to(ee),k.InlineValueContext.to(re),le);if(Array.isArray(oe))return oe.map(ve=>k.InlineValue.from(ve))}}class b{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentHighlights(V,ee,re){const le=this._documents.getDocument(V),Z=k.Position.to(ee),oe=await this._provider.provideDocumentHighlights(le,Z,re);if(Array.isArray(oe))return oe.map(k.DocumentHighlight.from)}}class D{constructor(V,ee){this._documents=V,this._provider=ee}async provideLinkedEditingRanges(V,ee,re){const le=this._documents.getDocument(V),Z=k.Position.to(ee),oe=await this._provider.provideLinkedEditingRanges(le,Z,re);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,A.coalesce)(oe.ranges.map(k.Range.from)),wordPattern:oe.wordPattern}}}class w{constructor(V,ee){this._documents=V,this._provider=ee}async provideReferences(V,ee,re,le){const Z=this._documents.getDocument(V),oe=k.Position.to(ee),ve=await this._provider.provideReferences(Z,oe,re,le);if(Array.isArray(ve))return ve.map(k.location.from)}}class T{constructor(V,ee,re,le,Z,oe,ve){this._documents=V,this._commands=ee,this._diagnostics=re,this._provider=le,this._logService=Z,this._extension=oe,this._apiDeprecation=ve,this._cache=new g.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(V,ee,re,le){const Z=this._documents.getDocument(V),oe=P.Selection.isISelection(ee)?k.Selection.to(ee):k.Range.to(ee),ve=[];for(const at of this._diagnostics.getDiagnostics(V))if(oe.intersection(at.range)&&ve.push(at)>T._maxCodeActionsPerFile)break;const Me={diagnostics:ve,only:re.only?new C.CodeActionKind(re.only):void 0,triggerKind:k.CodeActionTriggerKind.to(re.trigger)},qe=await this._provider.provideCodeActions(Z,oe,Me,le);if(!(0,A.isNonEmptyArray)(qe)||le.isCancellationRequested)return;const Qe=this._cache.add(qe),Je=new c.DisposableStore;this._disposables.set(Qe,Je);const Ce=[];for(let at=0;at<qe.length;at++){const X=qe[at];!X||(T._isCommand(X)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ce.push({_isSynthetic:!0,title:X.title,command:this._commands.toInternal(X,Je)})):(Me.only&&(X.kind?Me.only.contains(X.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${X.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ce.push({cacheId:[Qe,at],title:X.title,command:X.command&&this._commands.toInternal(X.command,Je),diagnostics:X.diagnostics&&X.diagnostics.map(k.Diagnostic.from),edit:X.edit&&k.WorkspaceEdit.from(X.edit),kind:X.kind&&X.kind.value,isPreferred:X.isPreferred,disabled:X.disabled?.reason})))}return{cacheId:Qe,actions:Ce}}async resolveCodeAction(V,ee){const[re,le]=V,Z=this._cache.get(re,le);if(!Z||T._isCommand(Z)||!this._provider.resolveCodeAction)return;const oe=await this._provider.resolveCodeAction(Z,ee)??Z;return oe?.edit?k.WorkspaceEdit.from(oe.edit):void 0}releaseCodeActions(V){this._disposables.get(V)?.dispose(),this._disposables.delete(V),this._cache.delete(V)}static _isCommand(V){return typeof V.command=="string"&&typeof V.title=="string"}}T._maxCodeActionsPerFile=1e3;class v{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentFormattingEdits(V,ee,re){const le=this._documents.getDocument(V),Z=await this._provider.provideDocumentFormattingEdits(le,ee,re);if(Array.isArray(Z))return Z.map(k.TextEdit.from)}}class F{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentRangeFormattingEdits(V,ee,re,le){const Z=this._documents.getDocument(V),oe=k.Range.to(ee),ve=await this._provider.provideDocumentRangeFormattingEdits(Z,oe,re,le);if(Array.isArray(ve))return ve.map(k.TextEdit.from)}}class M{constructor(V,ee){this._documents=V,this._provider=ee,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(V,ee,re,le,Z){const oe=this._documents.getDocument(V),ve=k.Position.to(ee),Me=await this._provider.provideOnTypeFormattingEdits(oe,ve,re,le,Z);if(Array.isArray(Me))return Me.map(k.TextEdit.from)}}class G{constructor(V,ee){this._provider=V,this._logService=ee,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(V,ee){const re=R.IdObject.mixin({symbols:[]}),le=await this._provider.provideWorkspaceSymbols(V,ee);if((0,A.isNonEmptyArray)(le))for(const Z of le){if(!Z)continue;if(!Z.name){this._logService.warn("INVALID SymbolInformation, lacks name",Z);continue}const oe=R.IdObject.mixin(k.WorkspaceSymbol.from(Z));this._symbolCache.set(oe._id,Z),re.symbols.push(oe)}return re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re}async resolveWorkspaceSymbol(V,ee){if(typeof this._provider.resolveWorkspaceSymbol!="function")return V;const re=this._symbolCache.get(V._id);if(re){const le=await this._provider.resolveWorkspaceSymbol(re,ee);return le&&(0,L.mixin)(V,k.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(V){const ee=this._resultCache.get(V);if(ee){for(let[re,le]=ee;re<=le;re++)this._symbolCache.delete(re);this._resultCache.delete(V)}}}class K{constructor(V,ee,re){this._documents=V,this._provider=ee,this._logService=re}static supportsResolving(V){return typeof V.prepareRename=="function"}async provideRenameEdits(V,ee,re,le){const Z=this._documents.getDocument(V),oe=k.Position.to(ee);try{const ve=await this._provider.provideRenameEdits(Z,oe,re,le);return ve?k.WorkspaceEdit.from(ve):void 0}catch(ve){const Me=K._asMessage(ve);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(ve)}}async resolveRenameLocation(V,ee,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(V),Z=k.Position.to(ee);try{const oe=await this._provider.prepareRename(le,Z,re);let ve,Me;if(C.Range.isRange(oe)?(ve=oe,Me=le.getText(oe)):(0,n.isObject)(oe)&&(ve=oe.range,Me=oe.placeholder),!ve||!Me)return;if(ve.start.line>Z.line||ve.end.line<Z.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(ve),text:Me}}catch(oe){const ve=K._asMessage(oe);return ve?{rejectReason:ve,range:void 0,text:void 0}:Promise.reject(oe)}}static _asMessage(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class U{constructor(V,ee){this.resultId=V,this.tokens=ee}}class z{constructor(V,ee){this._documents=V,this._provider=ee,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(V,ee,re){const le=this._documents.getDocument(V),Z=ee!==0?this._previousResults.get(ee):null;let oe=typeof Z?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(le,Z.resultId,re):await this._provider.provideDocumentSemanticTokens(le,re);return Z&&this._previousResults.delete(ee),oe?(oe=z._fixProvidedSemanticTokens(oe),this._send(z._convertToEdits(Z,oe),oe)):null}async releaseDocumentSemanticColoring(V){this._previousResults.delete(V)}static _fixProvidedSemanticTokens(V){return z._isSemanticTokens(V)?z._isCorrectSemanticTokens(V)?V:new C.SemanticTokens(new Uint32Array(V.data),V.resultId):z._isSemanticTokensEdits(V)?z._isCorrectSemanticTokensEdits(V)?V:new C.SemanticTokensEdits(V.edits.map(ee=>new C.SemanticTokensEdit(ee.start,ee.deleteCount,ee.data?new Uint32Array(ee.data):ee.data)),V.resultId):V}static _isSemanticTokens(V){return V&&!!V.data}static _isCorrectSemanticTokens(V){return V.data instanceof Uint32Array}static _isSemanticTokensEdits(V){return V&&Array.isArray(V.edits)}static _isCorrectSemanticTokensEdits(V){for(const ee of V.edits)if(!(ee.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(V,ee){if(!z._isSemanticTokens(ee)||!V||!V.tokens)return ee;const re=V.tokens,le=re.length,Z=ee.data,oe=Z.length;let ve=0;const Me=Math.min(le,oe);for(;ve<Me&&re[ve]===Z[ve];)ve++;if(ve===le&&ve===oe)return new C.SemanticTokensEdits([],ee.resultId);let qe=0;const Qe=Me-ve;for(;qe<Qe&&re[le-qe-1]===Z[oe-qe-1];)qe++;return new C.SemanticTokensEdits([{start:ve,deleteCount:le-ve-qe,data:Z.subarray(ve,oe-qe)}],ee.resultId)}_send(V,ee){if(z._isSemanticTokens(V)){const re=this._nextResultId++;return this._previousResults.set(re,new U(V.resultId,V.data)),(0,h.encodeSemanticTokensDto)({id:re,type:"full",data:V.data})}if(z._isSemanticTokensEdits(V)){const re=this._nextResultId++;return z._isSemanticTokens(ee)?this._previousResults.set(re,new U(ee.resultId,ee.data)):this._previousResults.set(re,new U(V.resultId)),(0,h.encodeSemanticTokensDto)({id:re,type:"delta",deltas:(V.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=z;class N{constructor(V,ee){this._documents=V,this._provider=ee}async provideDocumentRangeSemanticTokens(V,ee,re){const le=this._documents.getDocument(V),Z=await this._provider.provideDocumentRangeSemanticTokens(le,k.Range.to(ee),re);return Z?this._send(Z):null}_send(V){return(0,h.encodeSemanticTokensDto)({id:0,type:"full",data:V.data})}}e.DocumentRangeSemanticTokensAdapter=N;class x{constructor(V,ee,re,le,Z){this._documents=V,this._commands=ee,this._provider=re,this._apiDeprecation=le,this._extension=Z,this._cache=new g.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}async provideCompletionItems(V,ee,re,le){const Z=this._documents.getDocument(V),oe=k.Position.to(ee),ve=Z.getWordRangeAtPosition(oe)||new C.Range(oe,oe),Me=ve.with({end:oe}),qe=new y.StopWatch(!0),Qe=await this._provider.provideCompletionItems(Z,oe,le,k.CompletionContext.to(re));if(!Qe||le.isCancellationRequested)return;const Je=Array.isArray(Qe)?new C.CompletionList(Qe):Qe,Ce=x.supportsResolving(this._provider)?this._cache.add(Je.items):this._cache.add([]),at=new c.DisposableStore;this._disposables.set(Ce,at);const X=[],te={x:Ce,b:X,a:{replace:k.Range.from(ve),insert:k.Range.from(Me)},c:Je.isIncomplete||void 0,d:qe.elapsed()};for(let pe=0;pe<Je.items.length;pe++){const ze=Je.items[pe],tt=this._convertCompletionItem(ze,[Ce,pe],Me,ve);X.push(tt)}return te}async resolveCompletionItem(V,ee){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...V);if(!re)return;const le=await this._provider.resolveCompletionItem(re,ee);if(!!le)return this._convertCompletionItem(le,V)}releaseCompletionItems(V){this._disposables.get(V)?.dispose(),this._disposables.delete(V),this._cache.delete(V)}_convertCompletionItem(V,ee,re,le){const Z=this._disposables.get(ee[0]);if(!Z)throw Error("DisposableStore is missing...");const oe={x:ee,a:V.label,b:V.kind!==void 0?k.CompletionItemKind.from(V.kind):void 0,n:V.tags&&V.tags.map(k.CompletionItemTag.from),c:V.detail,d:typeof V.documentation=="undefined"?void 0:k.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters,l:V.additionalTextEdits&&V.additionalTextEdits.map(k.TextEdit.from),m:this._commands.toInternal(V.command,Z)};V.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),oe.h=V.textEdit.newText):typeof V.insertText=="string"?oe.h=V.insertText:V.insertText instanceof C.SnippetString&&(oe.h=V.insertText.value,oe.i|=4);let ve;return V.textEdit?ve=V.textEdit.range:V.range&&(ve=V.range),C.Range.isRange(ve)?oe.j=k.Range.from(ve):ve&&(!re?.isEqual(ve.inserting)||!le?.isEqual(ve.replacing))&&(oe.j={insert:k.Range.from(ve.inserting),replace:k.Range.from(ve.replacing)}),oe}}class B{constructor(V,ee,re){this._documents=V,this._provider=ee,this._commands=re,this._cache=new g.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(V,ee,re,le){const Z=this._documents.getDocument(V),oe=k.Position.to(ee),ve=await this._provider.provideInlineCompletionItems(Z,oe,{selectedCompletionInfo:re.selectedSuggestionInfo?{range:k.Range.to(re.selectedSuggestionInfo.range),text:re.selectedSuggestionInfo.text}:void 0,triggerKind:re.triggerKind},le);if(!ve||le.isCancellationRequested)return;const Me=(0,n.isArray)(ve)?{items:ve}:ve,qe=this._cache.add(Me.items);let Qe;return{pid:qe,items:Me.items.map((Je,Ce)=>{let at;return Je.command&&(Qe||(Qe=new c.DisposableStore,this._disposables.set(qe,Qe)),at=this._commands.toInternal(Je.command,Qe)),{text:Je.text,range:Je.range?k.Range.from(Je.range):void 0,command:at,idx:Ce}})}}disposeCompletions(V){this._cache.delete(V);const ee=this._disposables.get(V);ee&&ee.clear(),this._disposables.delete(V)}handleDidShowCompletionItem(V,ee){const re=this._cache.get(V,ee);re&&O.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class O{constructor(){this._onDidShowCompletionItemEmitter=new _.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(V){let ee=O.map.get(V);return ee||(ee=new O,O.map.set(V,ee)),ee}fireOnDidShowCompletionItem(V){this._onDidShowCompletionItemEmitter.fire(V)}}e.InlineCompletionController=O,O.map=new WeakMap;class H{constructor(V,ee){this._documents=V,this._provider=ee,this._cache=new g.Cache("SignatureHelp")}async provideSignatureHelp(V,ee,re,le){const Z=this._documents.getDocument(V),oe=k.Position.to(ee),ve=this.reviveContext(re),Me=await this._provider.provideSignatureHelp(Z,oe,le,ve);if(Me){const qe=this._cache.add([Me]);return{...k.SignatureHelp.from(Me),id:qe}}}reviveContext(V){let ee;if(V.activeSignatureHelp){const re=k.SignatureHelp.to(V.activeSignatureHelp),le=this._cache.get(V.activeSignatureHelp.id,0);le?(ee=le,ee.activeSignature=re.activeSignature,ee.activeParameter=re.activeParameter):ee=re}return{...V,activeSignatureHelp:ee}}releaseSignatureHelp(V){this._cache.delete(V)}}class W{constructor(V,ee){this._documents=V,this._provider=ee}async provideInlayHints(V,ee,re){const le=this._documents.getDocument(V),Z=await this._provider.provideInlayHints(le,k.Range.to(ee),re);return Z?{hints:Z.map(k.InlayHint.from)}:void 0}}class Q{constructor(V,ee){this._documents=V,this._provider=ee,this._cache=new g.Cache("DocumentLink")}async provideLinks(V,ee){const re=this._documents.getDocument(V),le=await this._provider.provideDocumentLinks(re,ee);if(!(!Array.isArray(le)||le.length===0)&&!ee.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.filter(Q._validateLink).map(k.DocumentLink.from)};{const Z=this._cache.add(le),oe={links:[],id:Z};for(let ve=0;ve<le.length;ve++){if(!Q._validateLink(le[ve]))continue;const Me=k.DocumentLink.from(le[ve]);Me.cacheId=[Z,ve],oe.links.push(Me)}return oe}}}static _validateLink(V){return V.target&&V.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(V,ee){if(typeof this._provider.resolveDocumentLink!="function")return;const re=this._cache.get(...V);if(!re)return;const le=await this._provider.resolveDocumentLink(re,ee);if(!(!le||!Q._validateLink(le)))return k.DocumentLink.from(le)}releaseLinks(V){this._cache.delete(V)}}class Y{constructor(V,ee){this._documents=V,this._provider=ee}async provideColors(V,ee){const re=this._documents.getDocument(V),le=await this._provider.provideDocumentColors(re,ee);return Array.isArray(le)?le.map(oe=>({color:k.Color.from(oe.color),range:k.Range.from(oe.range)})):[]}async provideColorPresentations(V,ee,re){const le=this._documents.getDocument(V),Z=k.Range.to(ee.range),oe=k.Color.to(ee.color),ve=await this._provider.provideColorPresentations(oe,{document:le,range:Z},re);if(!!Array.isArray(ve))return ve.map(k.ColorPresentation.from)}}class he{constructor(V,ee){this._documents=V,this._provider=ee}async provideFoldingRanges(V,ee,re){const le=this._documents.getDocument(V),Z=await this._provider.provideFoldingRanges(le,ee,re);if(!!Array.isArray(Z))return Z.map(k.FoldingRange.from)}}class _e{constructor(V,ee,re){this._documents=V,this._provider=ee,this._logService=re}async provideSelectionRanges(V,ee,re){const le=this._documents.getDocument(V),Z=ee.map(k.Position.to),oe=await this._provider.provideSelectionRanges(le,Z,re);if(!(0,A.isNonEmptyArray)(oe))return[];if(oe.length!==Z.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ve=[];for(let Me=0;Me<Z.length;Me++){const qe=[];ve.push(qe);let Qe=Z[Me],Je=oe[Me];for(;;){if(!Je.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(qe.push(k.SelectionRange.from(Je)),!Je.parent)break;Qe=Je.range,Je=Je.parent}}return ve}}class Se{constructor(V,ee){this._documents=V,this._provider=ee,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(V,ee,re){const le=this._documents.getDocument(V),Z=k.Position.to(ee),oe=await this._provider.prepareCallHierarchy(le,Z,re);if(!oe)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(oe)?oe.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,oe)]}async provideCallsTo(V,ee,re){const le=this._itemFromCache(V,ee);if(!le)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyIncomingCalls(le,re);if(!!Z)return Z.map(oe=>({from:this._cacheAndConvertItem(V,oe.from),fromRanges:oe.fromRanges.map(ve=>k.Range.from(ve))}))}async provideCallsFrom(V,ee,re){const le=this._itemFromCache(V,ee);if(!le)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyOutgoingCalls(le,re);if(!!Z)return Z.map(oe=>({to:this._cacheAndConvertItem(V,oe.to),fromRanges:oe.fromRanges.map(ve=>k.Range.from(ve))}))}releaseSession(V){this._cache.delete(V)}_cacheAndConvertItem(V,ee){const re=this._cache.get(V),le=k.CallHierarchyItem.from(ee,V,re.size.toString(36));return re.set(le._itemId,ee),le}_itemFromCache(V,ee){return this._cache.get(V)?.get(ee)}}class Re{constructor(V,ee){this._documents=V,this._provider=ee,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(V,ee,re){const le=this._documents.getDocument(V),Z=k.Position.to(ee),oe=await this._provider.prepareTypeHierarchy(le,Z,re);if(!oe)return;const ve=this._idPool.nextId();return this._cache.set(ve,new Map),Array.isArray(oe)?oe.map(Me=>this._cacheAndConvertItem(ve,Me)):[this._cacheAndConvertItem(ve,oe)]}async provideSupertypes(V,ee,re){const le=this._itemFromCache(V,ee);if(!le)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySupertypes(le,re);if(!!Z)return Z.map(oe=>this._cacheAndConvertItem(V,oe))}async provideSubtypes(V,ee,re){const le=this._itemFromCache(V,ee);if(!le)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySubtypes(le,re);if(!!Z)return Z.map(oe=>this._cacheAndConvertItem(V,oe))}releaseSession(V){this._cache.delete(V)}_cacheAndConvertItem(V,ee){const re=this._cache.get(V),le=k.TypeHierarchyItem.from(ee,V,re.size.toString(36));return re.set(le._itemId,ee),le}_itemFromCache(V,ee){return this._cache.get(V)?.get(ee)}}class xe{constructor(V,ee){this.adapter=V,this.extension=ee}}class Ue{constructor(V,ee,re,le,Z,oe,ve){this._adapter=new Map,this._uriTransformer=ee,this._proxy=V.getProxy(R.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=le,this._diagnostics=Z,this._logService=oe,this._apiDeprecation=ve}_transformDocumentSelector(V){return(0,A.coalesce)((0,A.asArray)(V).map(ee=>this._doTransformDocumentSelector(ee)))}_doTransformDocumentSelector(V){if(typeof V=="string")return{$serialized:!0,language:V};if(V)return{$serialized:!0,language:V.language,scheme:this._transformScheme(V.scheme),pattern:typeof V.pattern=="undefined"?void 0:k.GlobPattern.from(V.pattern),exclusive:V.exclusive}}_transformScheme(V){return this._uriTransformer&&typeof V=="string"?this._uriTransformer.transformOutgoingScheme(V):V}_createDisposable(V){return new C.Disposable(()=>{this._adapter.delete(V),this._proxy.$unregister(V)})}_nextHandle(){return Ue._handlePool++}_withAdapter(V,ee,re,le,Z=!1){const oe=this._adapter.get(V);if(!oe)return Promise.resolve(le);if(oe.adapter instanceof ee){let ve;oe.extension&&(ve=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${ee.name}'`));const Me=re(oe.adapter,oe.extension),qe=oe.extension;return qe&&Promise.resolve(Me).then(()=>this._logService.trace(`[${qe.identifier.value}] provider DONE after ${Date.now()-ve}ms`),Qe=>{Z&&Qe instanceof I.CancellationError||(this._logService.error(`[${qe.identifier.value}] provider FAILED`),this._logService.error(Qe))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(V,ee){const re=this._nextHandle();return this._adapter.set(re,new xe(V,ee)),re}static _extLabel(V){return V.displayName||V.name}registerDocumentSymbolProvider(V,ee,re,le){const Z=this._addNewAdapter(new s(this._documents,re),V),oe=le&&le.label||Ue._extLabel(V);return this._proxy.$registerDocumentSymbolProvider(Z,this._transformDocumentSelector(ee),oe),this._createDisposable(Z)}$provideDocumentSymbols(V,ee,re){return this._withAdapter(V,s,le=>le.provideDocumentSymbols(m.URI.revive(ee),re),void 0)}registerCodeLensProvider(V,ee,re){const le=this._nextHandle(),Z=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new xe(new o(this._documents,this._commands.converter,re),V)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(ee),Z);let oe=this._createDisposable(le);if(Z!==void 0){const ve=re.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Z));oe=C.Disposable.from(oe,ve)}return oe}$provideCodeLenses(V,ee,re){return this._withAdapter(V,o,le=>le.provideCodeLenses(m.URI.revive(ee),re),void 0)}$resolveCodeLens(V,ee,re){return this._withAdapter(V,o,le=>le.resolveCodeLens(ee,re),void 0)}$releaseCodeLenses(V,ee){this._withAdapter(V,o,re=>Promise.resolve(re.releaseCodeLenses(ee)),void 0)}registerDefinitionProvider(V,ee,re){const le=this._addNewAdapter(new t(this._documents,re),V);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDefinition(V,ee,re,le){return this._withAdapter(V,t,Z=>Z.provideDefinition(m.URI.revive(ee),re,le),[])}registerDeclarationProvider(V,ee,re){const le=this._addNewAdapter(new a(this._documents,re),V);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDeclaration(V,ee,re,le){return this._withAdapter(V,a,Z=>Z.provideDeclaration(m.URI.revive(ee),re,le),[])}registerImplementationProvider(V,ee,re){const le=this._addNewAdapter(new r(this._documents,re),V);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideImplementation(V,ee,re,le){return this._withAdapter(V,r,Z=>Z.provideImplementation(m.URI.revive(ee),re,le),[])}registerTypeDefinitionProvider(V,ee,re){const le=this._addNewAdapter(new i(this._documents,re),V);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideTypeDefinition(V,ee,re,le){return this._withAdapter(V,i,Z=>Z.provideTypeDefinition(m.URI.revive(ee),re,le),[])}registerHoverProvider(V,ee,re,le){const Z=this._addNewAdapter(new l(this._documents,re),V);return this._proxy.$registerHoverProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideHover(V,ee,re,le){return this._withAdapter(V,l,Z=>Z.provideHover(m.URI.revive(ee),re,le),void 0)}registerEvaluatableExpressionProvider(V,ee,re,le){const Z=this._addNewAdapter(new u(this._documents,re),V);return this._proxy.$registerEvaluatableExpressionProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideEvaluatableExpression(V,ee,re,le){return this._withAdapter(V,u,Z=>Z.provideEvaluatableExpression(m.URI.revive(ee),re,le),void 0)}registerInlineValuesProvider(V,ee,re,le){const Z=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new f(this._documents,re),V);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(ee),Z);let ve=this._createDisposable(oe);if(Z!==void 0){const Me=re.onDidChangeInlineValues(qe=>this._proxy.$emitInlineValuesEvent(Z));ve=C.Disposable.from(ve,Me)}return ve}$provideInlineValues(V,ee,re,le,Z){return this._withAdapter(V,f,oe=>oe.provideInlineValues(m.URI.revive(ee),re,le,Z),void 0)}registerDocumentHighlightProvider(V,ee,re){const le=this._addNewAdapter(new b(this._documents,re),V);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDocumentHighlights(V,ee,re,le){return this._withAdapter(V,b,Z=>Z.provideDocumentHighlights(m.URI.revive(ee),re,le),void 0)}registerLinkedEditingRangeProvider(V,ee,re){const le=this._addNewAdapter(new D(this._documents,re),V);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideLinkedEditingRanges(V,ee,re,le){return this._withAdapter(V,D,async Z=>{const oe=await Z.provideLinkedEditingRanges(m.URI.revive(ee),re,le);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?Ue._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider(V,ee,re){const le=this._addNewAdapter(new w(this._documents,re),V);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideReferences(V,ee,re,le,Z){return this._withAdapter(V,w,oe=>oe.provideReferences(m.URI.revive(ee),re,le,Z),void 0)}registerCodeActionProvider(V,ee,re,le){const Z=new c.DisposableStore,oe=this._addNewAdapter(new T(this._documents,this._commands.converter,this._diagnostics,re,this._logService,V,this._apiDeprecation),V);return this._proxy.$registerQuickFixSupport(oe,this._transformDocumentSelector(ee),{providedKinds:le?.providedCodeActionKinds?.map(ve=>ve.value),documentation:le?.documentation?.map(ve=>({kind:ve.kind.value,command:this._commands.converter.toInternal(ve.command,Z)}))},Ue._extLabel(V),Boolean(re.resolveCodeAction)),Z.add(this._createDisposable(oe)),Z}$provideCodeActions(V,ee,re,le,Z){return this._withAdapter(V,T,oe=>oe.provideCodeActions(m.URI.revive(ee),re,le,Z),void 0)}$resolveCodeAction(V,ee,re){return this._withAdapter(V,T,le=>le.resolveCodeAction(ee,re),void 0)}$releaseCodeActions(V,ee){this._withAdapter(V,T,re=>Promise.resolve(re.releaseCodeActions(ee)),void 0)}registerDocumentFormattingEditProvider(V,ee,re){const le=this._addNewAdapter(new v(this._documents,re),V);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(ee),V.identifier,V.displayName||V.name),this._createDisposable(le)}$provideDocumentFormattingEdits(V,ee,re,le){return this._withAdapter(V,v,Z=>Z.provideDocumentFormattingEdits(m.URI.revive(ee),re,le),void 0)}registerDocumentRangeFormattingEditProvider(V,ee,re){const le=this._addNewAdapter(new F(this._documents,re),V);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(ee),V.identifier,V.displayName||V.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(V,ee,re,le,Z){return this._withAdapter(V,F,oe=>oe.provideDocumentRangeFormattingEdits(m.URI.revive(ee),re,le,Z),void 0)}registerOnTypeFormattingEditProvider(V,ee,re,le){const Z=this._addNewAdapter(new M(this._documents,re),V);return this._proxy.$registerOnTypeFormattingSupport(Z,this._transformDocumentSelector(ee),le,V.identifier),this._createDisposable(Z)}$provideOnTypeFormattingEdits(V,ee,re,le,Z,oe){return this._withAdapter(V,M,ve=>ve.provideOnTypeFormattingEdits(m.URI.revive(ee),re,le,Z,oe),void 0)}registerWorkspaceSymbolProvider(V,ee){const re=this._addNewAdapter(new G(ee,this._logService),V);return this._proxy.$registerNavigateTypeSupport(re),this._createDisposable(re)}$provideWorkspaceSymbols(V,ee,re){return this._withAdapter(V,G,le=>le.provideWorkspaceSymbols(ee,re),{symbols:[]})}$resolveWorkspaceSymbol(V,ee,re){return this._withAdapter(V,G,le=>le.resolveWorkspaceSymbol(ee,re),void 0)}$releaseWorkspaceSymbols(V,ee){this._withAdapter(V,G,re=>re.releaseWorkspaceSymbols(ee),void 0)}registerRenameProvider(V,ee,re){const le=this._addNewAdapter(new K(this._documents,re,this._logService),V);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(ee),K.supportsResolving(re)),this._createDisposable(le)}$provideRenameEdits(V,ee,re,le,Z){return this._withAdapter(V,K,oe=>oe.provideRenameEdits(m.URI.revive(ee),re,le,Z),void 0)}$resolveRenameLocation(V,ee,re,le){return this._withAdapter(V,K,Z=>Z.resolveRenameLocation(m.URI.revive(ee),re,le),void 0)}registerDocumentSemanticTokensProvider(V,ee,re,le){const Z=this._nextHandle(),oe=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Z,new xe(new z(this._documents,re),V)),this._proxy.$registerDocumentSemanticTokensProvider(Z,this._transformDocumentSelector(ee),le,oe);let ve=this._createDisposable(Z);if(oe){const Me=re.onDidChangeSemanticTokens(qe=>this._proxy.$emitDocumentSemanticTokensEvent(oe));ve=C.Disposable.from(ve,Me)}return ve}$provideDocumentSemanticTokens(V,ee,re,le){return this._withAdapter(V,z,Z=>Z.provideDocumentSemanticTokens(m.URI.revive(ee),re,le),null,!0)}$releaseDocumentSemanticTokens(V,ee){this._withAdapter(V,z,re=>re.releaseDocumentSemanticColoring(ee),void 0)}registerDocumentRangeSemanticTokensProvider(V,ee,re,le){const Z=this._addNewAdapter(new N(this._documents,re),V);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Z,this._transformDocumentSelector(ee),le),this._createDisposable(Z)}$provideDocumentRangeSemanticTokens(V,ee,re,le){return this._withAdapter(V,N,Z=>Z.provideDocumentRangeSemanticTokens(m.URI.revive(ee),re,le),null,!0)}registerCompletionItemProvider(V,ee,re,le){const Z=this._addNewAdapter(new x(this._documents,this._commands.converter,re,this._apiDeprecation,V),V);return this._proxy.$registerSuggestSupport(Z,this._transformDocumentSelector(ee),le,x.supportsResolving(re),`${V.identifier.value}(${le.join("")})`),this._createDisposable(Z)}$provideCompletionItems(V,ee,re,le,Z){return this._withAdapter(V,x,oe=>oe.provideCompletionItems(m.URI.revive(ee),re,le,Z),void 0)}$resolveCompletionItem(V,ee,re){return this._withAdapter(V,x,le=>le.resolveCompletionItem(ee,re),void 0)}$releaseCompletionItems(V,ee){this._withAdapter(V,x,re=>re.releaseCompletionItems(ee),void 0)}registerInlineCompletionsProvider(V,ee,re){const le=this._addNewAdapter(new B(this._documents,re,this._commands.converter),V);return this._proxy.$registerInlineCompletionsSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideInlineCompletions(V,ee,re,le,Z){return this._withAdapter(V,B,oe=>oe.provideInlineCompletions(m.URI.revive(ee),re,le,Z),void 0)}$handleInlineCompletionDidShow(V,ee,re){this._withAdapter(V,B,async le=>{le.handleDidShowCompletionItem(ee,re)},void 0)}$freeInlineCompletionsList(V,ee){this._withAdapter(V,B,async re=>{re.disposeCompletions(ee)},void 0)}registerSignatureHelpProvider(V,ee,re,le){const Z=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,oe=this._addNewAdapter(new H(this._documents,re),V);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(ee),Z),this._createDisposable(oe)}$provideSignatureHelp(V,ee,re,le,Z){return this._withAdapter(V,H,oe=>oe.provideSignatureHelp(m.URI.revive(ee),re,le,Z),void 0)}$releaseSignatureHelp(V,ee){this._withAdapter(V,H,re=>re.releaseSignatureHelp(ee),void 0)}registerInlayHintsProvider(V,ee,re){const le=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new W(this._documents,re),V);this._proxy.$registerInlayHintsProvider(Z,this._transformDocumentSelector(ee),le);let oe=this._createDisposable(Z);if(le!==void 0){const ve=re.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(le));oe=C.Disposable.from(oe,ve)}return oe}$provideInlayHints(V,ee,re,le){return this._withAdapter(V,W,Z=>Z.provideInlayHints(m.URI.revive(ee),re,le),void 0)}registerDocumentLinkProvider(V,ee,re){const le=this._addNewAdapter(new Q(this._documents,re),V);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(ee),typeof re.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(V,ee,re){return this._withAdapter(V,Q,le=>le.provideLinks(m.URI.revive(ee),re),void 0)}$resolveDocumentLink(V,ee,re){return this._withAdapter(V,Q,le=>le.resolveLink(ee,re),void 0)}$releaseDocumentLinks(V,ee){this._withAdapter(V,Q,re=>re.releaseLinks(ee),void 0)}registerColorProvider(V,ee,re){const le=this._addNewAdapter(new Y(this._documents,re),V);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDocumentColors(V,ee,re){return this._withAdapter(V,Y,le=>le.provideColors(m.URI.revive(ee),re),[])}$provideColorPresentations(V,ee,re,le){return this._withAdapter(V,Y,Z=>Z.provideColorPresentations(m.URI.revive(ee),re,le),void 0)}registerFoldingRangeProvider(V,ee,re){const le=this._nextHandle(),Z=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new xe(new he(this._documents,re),V)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(ee),Z);let oe=this._createDisposable(le);if(Z!==void 0){const ve=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Z));oe=C.Disposable.from(oe,ve)}return oe}$provideFoldingRanges(V,ee,re,le){return this._withAdapter(V,he,Z=>Z.provideFoldingRanges(m.URI.revive(ee),re,le),void 0)}registerSelectionRangeProvider(V,ee,re){const le=this._addNewAdapter(new _e(this._documents,re,this._logService),V);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideSelectionRanges(V,ee,re,le){return this._withAdapter(V,_e,Z=>Z.provideSelectionRanges(m.URI.revive(ee),re,le),[])}registerCallHierarchyProvider(V,ee,re){const le=this._addNewAdapter(new Se(this._documents,re),V);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$prepareCallHierarchy(V,ee,re,le){return this._withAdapter(V,Se,Z=>Promise.resolve(Z.prepareSession(m.URI.revive(ee),re,le)),void 0)}$provideCallHierarchyIncomingCalls(V,ee,re,le){return this._withAdapter(V,Se,Z=>Z.provideCallsTo(ee,re,le),void 0)}$provideCallHierarchyOutgoingCalls(V,ee,re,le){return this._withAdapter(V,Se,Z=>Z.provideCallsFrom(ee,re,le),void 0)}$releaseCallHierarchy(V,ee){this._withAdapter(V,Se,re=>Promise.resolve(re.releaseSession(ee)),void 0)}registerTypeHierarchyProvider(V,ee,re){const le=this._addNewAdapter(new Re(this._documents,re),V);return this._proxy.$registerTypeHierarchyProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$prepareTypeHierarchy(V,ee,re,le){return this._withAdapter(V,Re,Z=>Promise.resolve(Z.prepareSession(m.URI.revive(ee),re,le)),void 0)}$provideTypeHierarchySupertypes(V,ee,re,le){return this._withAdapter(V,Re,Z=>Z.provideSupertypes(ee,re,le),void 0)}$provideTypeHierarchySubtypes(V,ee,re,le){return this._withAdapter(V,Re,Z=>Z.provideSubtypes(ee,re,le),void 0)}$releaseTypeHierarchy(V,ee){this._withAdapter(V,Re,re=>Promise.resolve(re.releaseSession(ee)),void 0)}static _serializeRegExp(V){return{pattern:V.source,flags:(0,E.regExpFlags)(V)}}static _serializeIndentationRule(V){return{decreaseIndentPattern:Ue._serializeRegExp(V.decreaseIndentPattern),increaseIndentPattern:Ue._serializeRegExp(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?Ue._serializeRegExp(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?Ue._serializeRegExp(V.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(V){return{beforeText:Ue._serializeRegExp(V.beforeText),afterText:V.afterText?Ue._serializeRegExp(V.afterText):void 0,previousLineText:V.previousLineText?Ue._serializeRegExp(V.previousLineText):void 0,action:V.action}}static _serializeOnEnterRules(V){return V.map(Ue._serializeOnEnterRule)}setLanguageConfiguration(V,ee,re){let{wordPattern:le}=re;if(le&&(0,E.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(ee,le):this._documents.setWordDefinitionFor(ee,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const Z=this._nextHandle(),oe={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?Ue._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?Ue._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?Ue._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Z,ee,oe),this._createDisposable(Z)}$setWordDefinitions(V){for(const ee of V)this._documents.setWordDefinitionFor(ee.languageId,new RegExp(ee.regexSource,ee.regexFlags))}}e.ExtHostLanguageFeatures=Ue,Ue._handlePool=0}),define(me[243],ge([0,1,5,15,7,49,18,6]),function(J,e,m,L,k,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(n,P,c){this._documents=P,this._commands=c,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=n.getProxy(m.MainContext.MainThreadLanguages)}$acceptLanguageIds(n){this._languageIds=n}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(n,P){await this._proxy.$changeLanguage(n,P);const c=this._documents.getDocumentData(n);if(!c)throw new Error(`document '${n.toString}' NOT found`);return c.document}async tokenAtPosition(n,P){const c=n.version,h=L.Position.from(P),d=await this._proxy.$tokensAtPosition(n.uri,h),g={type:k.StandardTokenType.Other,range:n.getWordRangeAtPosition(P)??new k.Range(P.line,P.character,P.line,P.character)};if(!d)return g;const y={range:L.Range.to(d.range),type:L.TokenType.to(d.type)};return!y.range.contains(P)||c!==n.version?g:y}createLanguageStatusItem(n,P,c){const h=this._handlePool++,d=this._proxy,g=this._ids,y=`${n.identifier.value}/${P}`;if(g.has(y))throw new Error(`LanguageStatusItem with id '${P}' ALREADY exists`);g.add(y);const I={selector:c,id:P,name:n.displayName??n.name,severity:k.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let _,s=new E.DisposableStore;const o=()=>{_?.dispose(),_=(0,R.disposableTimeout)(()=>{s.clear(),this._proxy.$setLanguageStatus(h,{id:y,name:I.name??n.displayName??n.name,source:n.displayName??n.name,selector:I.selector,label:I.text,detail:I.detail??"",severity:I.severity===k.LanguageStatusSeverity.Error?C.default.Error:I.severity===k.LanguageStatusSeverity.Warning?C.default.Warning:C.default.Info,command:I.command&&this._commands.toInternal(I.command,s),accessibilityInfo:I.accessibilityInformation})},0)},p={dispose(){s.dispose(),_?.dispose(),d.$removeLanguageStatus(h),g.delete(y)},get id(){return I.id},get name(){return I.name},set name(t){I.name=t,o()},get selector(){return I.selector},set selector(t){I.selector=t,o()},get text(){return I.text},set text(t){I.text=t,o()},get detail(){return I.detail},set detail(t){I.detail=t,o()},get severity(){return I.severity},set severity(t){I.severity=t,o()},get accessibilityInformation(){return I.accessibilityInformation},set accessibilityInformation(t){I.accessibilityInformation=t,o()},get command(){return I.command},set command(t){I.command=t,o()}};return o(),p}}e.ExtHostLanguages=S}),define(me[244],ge([0,1,5,12,35]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function C(E){return E&&E.title}let R=class{constructor(S,A){this._logService=A,this._proxy=S.getProxy(m.MainContext.MainThreadMessageService)}showMessage(S,A,n,P,c){const h={extension:S};let d;typeof P=="string"||C(P)?d=[P,...c]:(h.modal=P?.modal,h.useCustom=P?.useCustom,h.detail=P?.detail,d=c),h.useCustom&&(0,k.checkProposedApiEnabled)(S);const g=[];for(let y=0;y<d.length;y++){const I=d[y];if(typeof I=="string")g.push({title:I,handle:y,isCloseAffordance:!1});else if(typeof I=="object"){let{title:_,isCloseAffordance:s}=I;g.push({title:_,isCloseAffordance:!!s,handle:y})}else this._logService.warn("Invalid message item:",I)}return this._proxy.$showMessage(A,n,h,g).then(y=>{if(typeof y=="number")return d[y]})}};R=Ve([$e(1,L.ILogService)],R),e.ExtHostMessageService=R}),define(me[245],ge([0,1,23,3,48,6,24,9,13,2,87,5,15,7,66,220,129]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class I{constructor(s,o,p,t,a){this._textDocumentsAndEditors=p,this._textDocuments=t,this._extensionStoragePaths=a,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new R.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=s.getProxy(P.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(P.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(P.MainContext.MainThreadNotebookEditors),this._commandsConverter=o.converter,o.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const i=r.notebookEditor?.notebookUri,l=r.cell.handle,f=this._documents.get(i)?.getCell(l);if(f)return f.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}getEditorById(s){const o=this._editors.get(s);if(!o)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);return o}getIdByEditor(s){for(const[o,p]of this._editors)if(p.apiEditor===s)return o}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(s,o){const p=this._documents.get(s);if(!p&&!o)throw new Error(`NO notebook document for '${s}'`);return p}_getProviderData(s){const o=this._notebookContentProviders.get(s);if(!o)throw new Error(`NO provider for '${s}'`);return o}registerNotebookContentProvider(s,o,p,t,a){if((0,E.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(o))throw new Error(`Notebook provider for '${o}' already registered`);this._notebookContentProviders.set(o,{extension:s,provider:p});let r;return p.onDidChangeNotebookContentOptions&&(r=p.onDidChangeNotebookContentOptions(()=>{const i=c.NotebookDocumentContentOptions.from(p.options);this._notebookProxy.$updateNotebookProviderOptions(o,i)})),this._notebookProxy.$registerNotebookProvider({id:s.identifier,location:s.extensionLocation},o,c.NotebookDocumentContentOptions.from(t),I._convertNotebookRegistrationData(s,a)),new h.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(o),this._notebookProxy.$unregisterNotebookProvider(o)})}static _convertNotebookRegistrationData(s,o){if(!o)return;const p=o.filenamePattern.map(t=>c.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(o.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:o.displayName,filenamePattern:p,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,o,p){const t=I._notebookStatusBarItemProviderHandlePool++,a=typeof p.onDidChangeCellStatusBarItems=="function"?I._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(t,p),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(t,a,o);let r;return a!==void 0&&(r=p.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(a))),new h.Disposable(()=>{this._notebookStatusBarItemProviders.delete(t),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(t,a),r&&r.dispose()})}async createNotebookDocument(s){const o=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:s.viewType,content:s.content&&c.NotebookData.from(s.content)});return A.URI.revive(o)}async openNotebookDocument(s){const o=this._documents.get(s);if(o)return o.apiNotebook;const p=await this._notebookDocumentsProxy.$tryOpenNotebook(s),t=this._documents.get(A.URI.revive(p));return(0,S.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(s,o){A.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let p;typeof o=="object"?p={position:c.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(c.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:p={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.notebookType,p),a=t&&this._editors.get(t)?.apiEditor;if(a)return a;throw t?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,o,p,t){const a=this._notebookStatusBarItemProviders.get(s),r=A.URI.revive(o),i=this._documents.get(r);if(!i||!a)return;const l=i.getCellFromIndex(p);if(!l)return;const u=await a.provideCellStatusBarItems(l.apiCell,t);if(!u)return;const f=new C.DisposableStore,b=this._statusBarCache.add([f]),w=(Array.isArray(u)?u:[u]).map(T=>c.NotebookStatusBarItem.from(T,this._commandsConverter,f));return{cacheId:b,items:w}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,o,p,t,a){if((0,E.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,p),this._notebookProxy.$registerNotebookSerializer(r,{id:s.identifier,location:s.extensionLocation},o,c.NotebookDocumentContentOptions.from(t),I._convertNotebookRegistrationData(s,a)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(s,o,p){const t=this._notebookSerializer.get(s);if(!t)throw new Error("NO serializer found");const a=await t.deserializeNotebook(o.buffer,p);return new d.SerializableObjectWithBuffers(c.NotebookData.from(a))}async $notebookToData(s,o,p){const t=this._notebookSerializer.get(s);if(!t)throw new Error("NO serializer found");const a=await t.serializeNotebook(c.NotebookData.to(o.value),p);return m.VSBuffer.wrap(a)}async $openNotebook(s,o,p,t,a){const{provider:r}=this._getProviderData(s),i=await r.openNotebook(A.URI.revive(o),{backupId:p,untitledDocumentData:t?.buffer},a);return new d.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(c.NotebookCellData.from)})}async $saveNotebook(s,o,p){const t=this.getNotebookDocument(A.URI.revive(o)),{provider:a}=this._getProviderData(s);return await a.saveNotebook(t.apiNotebook,p),!0}async $saveNotebookAs(s,o,p,t){const a=this.getNotebookDocument(A.URI.revive(o)),{provider:r}=this._getProviderData(s);return await r.saveNotebookAs(A.URI.revive(p),a.apiNotebook,t),!0}async $backupNotebook(s,o,p){const t=this.getNotebookDocument(A.URI.revive(o)),a=this._getProviderData(s),r=this._extensionStoragePaths.workspaceValue(a.extension)??this._extensionStoragePaths.globalValue(a.extension),i=String((0,k.hash)([t.uri.toString(),this._backupIdPool++])),l=A.URI.joinPath(r,i),u=await a.provider.backupNotebook(t.apiNotebook,{destination:l},p);return t.updateBackup(u),u.id}_createExtHostEditor(s,o,p){if(this._editors.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const t=new y.ExtHostNotebookEditor(o,this._notebookEditorsProxy,s,p.visibleRanges.map(c.NotebookRange.to),p.selections.map(c.NotebookRange.to),typeof p.viewColumn=="number"?c.ViewColumn.to(p.viewColumn):void 0);this._editors.set(o,t)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const p of s.value.removedDocuments){const t=A.URI.revive(p),a=this._documents.get(t);a&&(a.dispose(),this._documents.delete(t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:a.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(a.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===t.toString()&&this._editors.delete(r.id)}if(s.value.addedDocuments){const p=[];for(const t of s.value.addedDocuments){const a=A.URI.revive(t.uri);if(this._documents.has(a))throw new Error(`adding EXISTING notebook ${a} `);const r=this,i=new g.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(l){r._onDidChangeNotebookCells.fire(l)},emitCellOutputsChange(l){r._onDidChangeCellOutputs.fire(l)},emitCellMetadataChange(l){r._onDidChangeCellMetadata.fire(l)},emitCellExecutionStateChange(l){r._onDidChangeCellExecutionState.fire(l)}},a,t);p.push(...t.cells.map(l=>g.ExtHostCell.asModelAddData(i.apiNotebook,l))),this._documents.get(a)?.dispose(),this._documents.set(a,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(s.value.addedEditors)for(const p of s.value.addedEditors){if(this._editors.has(p.id))return;const t=A.URI.revive(p.documentUri),a=this._documents.get(t);a&&this._createExtHostEditor(a,p.id,p)}const o=[];if(s.value.removedEditors)for(const p of s.value.removedEditors){const t=this._editors.get(p);t&&(this._editors.delete(p),this._activeNotebookEditor?.id===t.id&&(this._activeNotebookEditor=void 0),o.push(t))}if(s.value.visibleEditors){this._visibleNotebookEditors=s.value.visibleEditors.map(t=>this._editors.get(t)).filter(t=>!!t);const p=new Set;this._visibleNotebookEditors.forEach(t=>p.add(t.id));for(const t of this._editors.values()){const a=p.has(t.id);t._acceptVisibility(a)}this._visibleNotebookEditors=[...this._editors.values()].map(t=>t).filter(t=>t.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this._activeNotebookEditor=void 0:s.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=I,I._notebookStatusBarItemProviderHandlePool=0}),define(me[246],ge([0,1,3,76,12,5,14,15]),function(J,e,m,L,k,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(P,c){const h=S._Keys.nextId();P.$registerNotebookEditorDecorationType(h,E.NotebookDecorationRenderOptions.from(c)),this.value={key:h,dispose(){P.$removeNotebookEditorDecorationType(h)}}}}S._Keys=new L.IdGenerator("NotebookEditorDecorationType");let A=class{constructor(P,c,h){this._logService=P,this._extHostRpc=c,this._notebooksAndEditors=h,this._onDidChangeNotebookEditorSelection=new m.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new m.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(P){return new S(this._extHostRpc.getProxy(C.MainContext.MainThreadNotebookEditors),P).value}$acceptEditorPropertiesChanged(P,c){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",P,c);const h=this._notebooksAndEditors.getEditorById(P);c.visibleRanges&&h._acceptVisibleRanges(c.visibleRanges.ranges.map(E.NotebookRange.to)),c.selections&&h._acceptSelections(c.selections.selections.map(E.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.apiEditor,visibleRanges:h.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.apiEditor,selections:h.apiEditor.selections}))}$acceptEditorViewColumns(P){for(const c in P)this._notebooksAndEditors.getEditorById(c)._acceptViewColumn(E.ViewColumn.to(P[c]))}};A=Ve([$e(0,k.ILogService),$e(1,R.IExtHostRpcService)],A),e.ExtHostNotebookEditors=A}),define(me[247],ge([0,1,17,18,21,3,6,24,2,26,12,5,15,7,88,213,35,66]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let _=class{constructor(a,r,i,l){this._initData=r,this._extHostNotebook=i,this._logService=l,this._activeExecutions=new E.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=a.getProxy(P.MainContext.MainThreadNotebookKernels)}createNotebookController(a,r,i,l,u,f){for(let O of this._kernelData.values())if(O.controller.id===r&&A.ExtensionIdentifier.equals(a.identifier,O.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const b=this._handlePool++,D=this;this._logService.trace(`NotebookController[${b}], CREATED by ${a.identifier.value}, ${r}`);const w=()=>console.warn(`NO execute handler from notebook controller '${G.id}' of extension: '${a.identifier}'`);let T=!1;const v=new R.DisposableStore,F=new C.Emitter,M=new C.Emitter,G={id:`${a.identifier.value}/${r}`,notebookType:i,extensionId:a.identifier,extensionLocation:a.extensionLocation,label:l||a.identifier.value,preloads:f?f.map(c.NotebookRendererScript.from):[]};let K=u??w,U;this._proxy.$addKernel(b,G).catch(O=>{console.log(O),T=!0});let z=0;const N=()=>{if(T)return;const O=++z;Promise.resolve().then(()=>{O===z&&this._proxy.$updateKernel(b,G)})},x=new E.ResourceMap,B={get id(){return r},get notebookType(){return G.notebookType},onDidChangeSelectedNotebooks:F.event,get label(){return G.label},set label(O){G.label=O??a.displayName??a.name,N()},get detail(){return G.detail??""},set detail(O){G.detail=O,N()},get description(){return G.description??""},set description(O){G.description=O,N()},get supportedLanguages(){return G.supportedLanguages},set supportedLanguages(O){G.supportedLanguages=O,N()},get supportsExecutionOrder(){return G.supportsExecutionOrder??!1},set supportsExecutionOrder(O){G.supportsExecutionOrder=O,N()},get rendererScripts(){return G.preloads?G.preloads.map(c.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(O){K=O??w},get interruptHandler(){return U},set interruptHandler(O){U=O,G.supportsInterrupt=Boolean(O),N()},createNotebookCellExecution(O){if(T)throw new Error("notebook controller is DISPOSED");if(!x.has(O.notebook.uri))throw D._logService.trace(`NotebookController[${b}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(H=>H.toString())),new Error(`notebook controller is NOT associated to notebook: ${O.notebook.uri.toString()}`);return D._createNotebookCellExecution(O)},dispose:()=>{T||(this._logService.trace(`NotebookController[${b}], DISPOSED`),T=!0,this._kernelData.delete(b),v.dispose(),F.dispose(),M.dispose(),this._proxy.$removeKernel(b))},updateNotebookAffinity(O,H){D._proxy.$updateNotebookPriority(b,O.uri,H)},onDidReceiveMessage:M.event,postMessage(O,H){return(0,y.checkProposedApiEnabled)(a),D._proxy.$postMessage(b,H&&D._extHostNotebook.getIdByEditor(H),O)},asWebviewUri(O){return(0,y.checkProposedApiEnabled)(a),(0,d.asWebviewUri)(O,D._initData.remote)}};return this._kernelData.set(b,{extensionId:a.identifier,controller:B,onDidReceiveMessage:M,onDidChangeSelection:F,associatedNotebooks:x}),B}$acceptNotebookAssociation(a,r,i){const l=this._kernelData.get(a);if(l){const u=this._extHostNotebook.getNotebookDocument(S.URI.revive(r));i?l.associatedNotebooks.set(u.uri,!0):l.associatedNotebooks.delete(u.uri),this._logService.trace(`NotebookController[${a}] ASSOCIATE notebook`,u.uri.toString(),i),l.onDidChangeSelection.fire({selected:i,notebook:u.apiNotebook})}}async $executeCells(a,r,i){const l=this._kernelData.get(a);if(!l)return;const u=this._extHostNotebook.getNotebookDocument(S.URI.revive(r)),f=[];for(let b of i){const D=u.getCell(b);D&&f.push(D.apiCell)}try{this._logService.trace(`NotebookController[${a}] EXECUTE cells`,u.uri.toString(),f.length),await l.controller.executeHandler.call(l.controller,f,u.apiNotebook,l.controller)}catch(b){this._logService.error(`NotebookController[${a}] execute cells FAILED`,b),console.error(b)}}async $cancelCells(a,r,i){const l=this._kernelData.get(a);if(!l)return;const u=this._extHostNotebook.getNotebookDocument(S.URI.revive(r));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,u.apiNotebook);else for(let f of i){const b=u.getCell(f);b&&this._activeExecutions.get(b.uri)?.cancel()}}$acceptKernelMessageFromRenderer(a,r,i){const l=this._kernelData.get(a);if(!l)return;const u=this._extHostNotebook.getEditorById(r);l.onDidReceiveMessage.fire(Object.freeze({editor:u.apiEditor,message:i}))}_createNotebookCellExecution(a){if(a.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const i=this._extHostNotebook.getNotebookDocument(a.notebook.uri).getCellFromApiCell(a);if(!i)throw new Error("invalid cell");if(this._activeExecutions.has(i.uri))throw new Error(`duplicate execution for ${i.uri}`);const l=new o(i.notebook,i,this._proxy);this._activeExecutions.set(i.uri,l);const u=l.onDidChangeState(()=>{l.state===s.Resolved&&(l.dispose(),u.dispose(),this._activeExecutions.delete(i.uri))});return l.asApiObject()}};_=Ve([$e(3,n.ILogService)],_),e.ExtHostNotebookKernels=_;var s;(function(t){t[t.Init=0]="Init",t[t.Started=1]="Started",t[t.Resolved=2]="Resolved"})(s||(s={}));class o extends R.Disposable{constructor(a,r,i){super();this._document=a,this._cell=r,this._proxy=i,this._handle=o.HANDLE++,this._onDidChangeState=new C.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=s.Init,this._tokenSource=this._register(new k.CancellationTokenSource),this._collector=new p(10,l=>this.update(l)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(a){await this._collector.addItem(a)}async update(a){const r=Array.isArray(a)?a:[a];return this._proxy.$updateExecutions(new I.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===s.Init)throw new Error("Must call start before modifying cell output");if(this._state===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(a){let r=this._cell;if(a&&(r=this._document.getCellFromApiCell(a)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(a){return a.map(r=>{const i=h.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return i===r.items?c.NotebookCellOutput.from(r):c.NotebookCellOutput.from({items:i,id:r.id,metadata:r.metadata})})}async updateOutputs(a,r,i){const l=this.cellIndexToHandle(r),u=this.validateAndConvertOutputs((0,m.asArray)(a));return this.updateSoon({editType:g.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:l,append:i,outputs:u})}async updateOutputItems(a,r,i){return a=h.NotebookCellOutput.ensureUniqueMimeTypes((0,m.asArray)(a),!0),this.updateSoon({editType:g.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:a.map(c.NotebookCellOutputItem.from),outputId:r.id,append:i})}asApiObject(){const a=this;return Object.freeze({get token(){return a._tokenSource.token},get cell(){return a._cell.apiCell},get executionOrder(){return a._executionOrder},set executionOrder(i){a._executionOrder=i,a.update([{editType:g.CellExecutionUpdateType.ExecutionState,executionHandle:a._handle,executionOrder:a._executionOrder}])},start(i){if(a._state===s.Resolved||a._state===s.Started)throw new Error("Cannot call start again");a._state=s.Started,a._onDidChangeState.fire(),a.update({editType:g.CellExecutionUpdateType.ExecutionState,executionHandle:a._handle,runStartTime:i})},end(i,l){if(a._state===s.Resolved)throw new Error("Cannot call resolve twice");a._state=s.Resolved,a._onDidChangeState.fire(),a.updateSoon({editType:g.CellExecutionUpdateType.Complete,executionHandle:a._handle,runEndTime:l,lastRunSuccess:i}),a._collector.flush(),a._proxy.$removeExecution(a._handle)},clearOutput(i){return a.verifyStateForOutput(),a.updateOutputs([],i,!1)},appendOutput(i,l){return a.verifyStateForOutput(),a.updateOutputs(i,l,!0)},replaceOutput(i,l){return a.verifyStateForOutput(),a.updateOutputs(i,l,!1)},appendOutputItems(i,l){return a.verifyStateForOutput(),a.updateOutputItems(i,l,!0)},replaceOutputItems(i,l){return a.verifyStateForOutput(),a.updateOutputItems(i,l,!1)}})}}o.HANDLE=0;class p{constructor(a,r){this.delay=a,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(a){return this.batch.push(a),this.currentDeferred||(this.currentDeferred=new L.DeferredPromise,this.startedTimer=Date.now(),(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const a=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>a.complete())}}}),define(me[248],ge([0,1,3,5,129]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class C{constructor(E,S){this._extHostNotebook=S,this._rendererMessageEmitters=new Map,this.proxy=E.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(E,S,A){const n=this._extHostNotebook.getEditorById(E);this._rendererMessageEmitters.get(S)?.fire({editor:n.apiEditor,message:A})}createRendererMessaging(E,S){if(!E.contributes?.notebookRenderer?.some(c=>c.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);const A=!!E.enableProposedApi,n=new WeakMap;return{onDidReceiveMessage:(c,h,d)=>{const g=A?c:y=>{const I={};n.set(I,y.editor),c({editor:I,message:y.message})};return this.getOrCreateEmitterFor(S).event(g,h,d)},postMessage:(c,h)=>{k.ExtHostNotebookEditor.apiEditorsToExtHost.has(c)&&([c,h]=[h,c]);const d=A?h:n.get(h),g=d&&k.ExtHostNotebookEditor.apiEditorsToExtHost.get(d);return this.proxy.$postMessage(g?.id,S,c)}}}getOrCreateEmitterFor(E){let S=this._rendererMessageEmitters.get(E);return S||(S=new m.Emitter({onLastListenerRemove:()=>{S?.dispose(),this._rendererMessageEmitters.delete(E)}}),this._rendererMessageEmitters.set(E,S),S)}}e.ExtHostNotebookRenderers=C}),define(me[68],ge([0,1,5,3,6,23,4,14]),function(J,e,m,L,k,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class S extends k.Disposable{constructor(d,g,y,I,_){super();this._onDidAppend=this._register(new L.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=d,this._proxy=_,this._id=_.$register(this.name,g,y,I),this._disposed=!1,this._offset=0}get name(){return this._name}append(d){this.validate(),this._offset+=d?C.VSBuffer.fromString(d).byteLength:0}update(){this._id.then(d=>this._proxy.$update(d))}appendLine(d){this.validate(),this.append(d+`
`)}clear(){this.validate();const d=this._offset;this._id.then(g=>this._proxy.$clear(g,d))}show(d,g){this.validate(),this._id.then(y=>this._proxy.$reveal(y,!!(typeof d=="boolean"?d:g)))}hide(){this.validate(),this._id.then(d=>this._proxy.$close(d))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(d=>this._proxy.$dispose(d)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=S;class A extends S{constructor(d,g,y){super(d,!1,void 0,g,y)}append(d){super.append(d),this._id.then(g=>this._proxy.$append(g,d)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=A;class n extends S{constructor(d,g,y){super(d,!0,g,void 0,y)}append(d){throw new Error("Not supported")}}class P{constructor(d,g){this.name=d,this._channel=g}append(d){this._channel.then(g=>g.append(d))}appendLine(d){this._channel.then(g=>g.appendLine(d))}clear(){this._channel.then(d=>d.clear())}show(d,g){this._channel.then(y=>y.show(d,g))}hide(){this._channel.then(d=>d.hide())}dispose(){this._channel.then(d=>d.dispose())}}e.LazyOutputChannel=P;let c=class{constructor(d){this._proxy=d.getProxy(m.MainContext.MainThreadOutputService)}$setVisibleChannel(d){}createOutputChannel(d,g){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");return new A(d,g.identifier.value,this._proxy)}createOutputChannelFromLogFile(d,g){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");if(!g)throw new Error("illegal argument `file`. must not be falsy");return new n(d,g,this._proxy)}};c=Ve([$e(0,E.IExtHostRpcService)],c),e.ExtHostOutputService=c,e.IExtHostOutputService=(0,R.createDecorator)("IExtHostOutputService")}),define(me[249],ge([0,1,18,21,3,6,5,2,7,16,17,49,63]),function(J,e,m,L,k,C,R,E,S,A,n,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function h(d,g,y){const I=d.getProxy(R.MainContext.MainThreadQuickOpen);class _{constructor(u,f){this._sessions=new Map,this._instances=0,this._workspace=u,this._commands=f}showQuickPick(u,f,b,D=L.CancellationToken.None){this._onDidSelectItem=void 0;const w=Promise.resolve(u),T=++this._instances,v=I.$show(T,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},D),F={},M=v.then(()=>F);return Promise.race([M,w]).then(G=>{if(G!==F)return w.then(K=>{const U=[];for(let z=0;z<K.length;z++){const N=K[z];let x,B,O,H,W;typeof N=="string"?x=N:(x=N.label,B=N.description,O=N.detail,H=N.picked,W=N.alwaysShow),U.push({label:x,description:B,handle:z,detail:O,picked:H,alwaysShow:W})}return b&&typeof b.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{b.onDidSelectItem(K[z])}),I.$setItems(T,U),v.then(z=>{if(typeof z=="number")return K[z];if(Array.isArray(z))return z.map(N=>K[N])})})}).then(void 0,G=>{if(!(0,A.isPromiseCanceledError)(G))return I.$setError(T,G),Promise.reject(G)})}$onItemSelected(u){this._onDidSelectItem&&this._onDidSelectItem(u)}showInput(u,f=L.CancellationToken.None){return this._validateInput=u?u.validateInput:void 0,I.$input(u,typeof this._validateInput=="function",f).then(void 0,b=>{if(!(0,A.isPromiseCanceledError)(b))return Promise.reject(b)})}$validateInput(u){return this._validateInput?(0,m.asPromise)(()=>this._validateInput(u)):Promise.resolve(void 0)}async showWorkspaceFolderPick(u,f=L.CancellationToken.None){const b=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[u]);if(!b)return;const D=await this._workspace.getWorkspaceFolders2();if(!!D)return D.find(w=>w.uri.toString()===b.uri.toString())}createQuickPick(u,f){const b=new r(u,f,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}createInputBox(u){const f=new i(u,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}$onDidChangeValue(u,f){const b=this._sessions.get(u);b&&b._fireDidChangeValue(f)}$onDidAccept(u){const f=this._sessions.get(u);f&&f._fireDidAccept()}$onDidChangeActive(u,f){const b=this._sessions.get(u);b instanceof r&&b._fireDidChangeActive(f)}$onDidChangeSelection(u,f){const b=this._sessions.get(u);b instanceof r&&b._fireDidChangeSelection(f)}$onDidTriggerButton(u,f){const b=this._sessions.get(u);b&&b._fireDidTriggerButton(f)}$onDidTriggerItemButton(u,f,b){const D=this._sessions.get(u);D instanceof r&&D._fireDidTriggerItemButton(f,b)}$onDidHide(u){const f=this._sessions.get(u);f&&f._fireDidHide()}}class s{constructor(u,f){this._extensionId=u,this._onDidDispose=f,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(u){this._title=u,this.update({title:u})}get step(){return this._steps}set step(u){this._steps=u,this.update({step:u})}get totalSteps(){return this._totalSteps}set totalSteps(u){this._totalSteps=u,this.update({totalSteps:u})}get enabled(){return this._enabled}set enabled(u){this._enabled=u,this.update({enabled:u})}get busy(){return this._busy}set busy(u){this._busy=u,this.update({busy:u})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(u){this._ignoreFocusOut=u,this.update({ignoreFocusOut:u})}get value(){return this._value}set value(u){this._value=u,this.update({value:u})}get placeholder(){return this._placeholder}set placeholder(u){this._placeholder=u,this.update({placeholder:u})}get buttons(){return this._buttons}set buttons(u){this._buttons=u.slice(),this._handlesToButtons.clear(),u.forEach((f,b)=>{const D=f===S.QuickInputButtons.Back?-1:b;this._handlesToButtons.set(D,f)}),this.update({buttons:u.map((f,b)=>({...a(f),tooltip:f.tooltip,handle:f===S.QuickInputButtons.Back?-1:b}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(u){this._value=u,this._onDidChangeValueEmitter.fire(u)}_fireDidTriggerButton(u){const f=this._handlesToButtons.get(u);f&&this._onDidTriggerButtonEmitter.fire(f)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),I.$dispose(this._id))}update(u){if(!this._disposed){for(const f of Object.keys(u)){const b=u[f];this._pendingUpdate[f]=b===void 0?null:b}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){I.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}s._nextId=1;function o(l){if(l instanceof S.ThemeIcon)return{id:l.id};const u=t(l),f=p(l);return{dark:typeof u=="string"?E.URI.file(u):u,light:typeof f=="string"?E.URI.file(f):f}}function p(l){return typeof l=="object"&&"light"in l?l.light:l}function t(l){return typeof l=="object"&&"dark"in l?l.dark:l}function a(l){const u=o(l.iconPath);let f,b;return"id"in u?b=c.ThemeIcon.asClassName(u):f=u,{iconPath:f,iconClass:b}}class r extends s{constructor(u,f,b){super(u,b);this.enableProposedApi=f,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this._onDidTriggerItemButtonEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(u){this._items=u.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),u.forEach((f,b)=>{this._handlesToItems.set(b,f),this._itemsToHandles.set(f,b)}),this.update({items:u.map((f,b)=>({label:f.label,description:f.description,handle:b,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,buttons:f.buttons&&this.enableProposedApi?f.buttons.map((D,w)=>({...a(D),tooltip:D.tooltip,handle:w})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(u){this._canSelectMany=u,this.update({canSelectMany:u})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(u){this._matchOnDescription=u,this.update({matchOnDescription:u})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(u){this._matchOnDetail=u,this.update({matchOnDetail:u})}get sortByLabel(){return this._sortByLabel}set sortByLabel(u){this._sortByLabel=u,this.update({sortByLabel:u})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(u){this._keepScrollPosition=u,this.update({keepScrollPosition:u})}get activeItems(){return this._activeItems}set activeItems(u){this._activeItems=u.filter(f=>this._itemsToHandles.has(f)),this.update({activeItems:this._activeItems.map(f=>this._itemsToHandles.get(f))})}get selectedItems(){return this._selectedItems}set selectedItems(u){this._selectedItems=u.filter(f=>this._itemsToHandles.has(f)),this.update({selectedItems:this._selectedItems.map(f=>this._itemsToHandles.get(f))})}_fireDidChangeActive(u){const f=(0,n.coalesce)(u.map(b=>this._handlesToItems.get(b)));this._activeItems=f,this._onDidChangeActiveEmitter.fire(f)}_fireDidChangeSelection(u){const f=(0,n.coalesce)(u.map(b=>this._handlesToItems.get(b)));this._selectedItems=f,this._onDidChangeSelectionEmitter.fire(f)}_fireDidTriggerItemButton(u,f){const b=this._handlesToItems.get(u);if(!b||!b.buttons||!b.buttons.length)return;const D=b.buttons[f];D&&this._onDidTriggerItemButtonEmitter.fire({button:D,item:b})}}class i extends s{constructor(u,f){super(u,f);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(u){this._password=u,this.update({password:u})}get prompt(){return this._prompt}set prompt(u){this._prompt=u,this.update({prompt:u})}get validationMessage(){return this._validationMessage}set validationMessage(u){this._validationMessage=u,this.update({validationMessage:u,severity:u?P.default.Error:P.default.Ignore})}}return new _(g,y)}e.createExtHostQuickOpen=h}),define(me[250],ge([0,1,2,3,58,6,18,5,17,100,12,26,35,63,15]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(u){if(u)return typeof u.iconPath=="string"?m.URI.file(u.iconPath):m.URI.isUri(u.iconPath)||h.ThemeIcon.isThemeIcon(u.iconPath)?u.iconPath:void 0}function y(u,f){if(!u.iconPath&&!f.iconPath)return 0;if(u.iconPath){if(!f.iconPath)return 1}else return-1;const b=typeof u.iconPath=="string"?u.iconPath:m.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id,D=typeof f.iconPath=="string"?f.iconPath:m.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,A.comparePaths)(b,D)}function I(u,f){let b=0;if(u.strikeThrough!==f.strikeThrough)return u.strikeThrough?1:-1;if(u.faded!==f.faded)return u.faded?1:-1;if(u.tooltip!==f.tooltip)return(u.tooltip||"").localeCompare(f.tooltip||"");if(b=y(u,f),b!==0)return b;if(u.light&&f.light)b=y(u.light,f.light);else{if(u.light)return 1;if(f.light)return-1}if(b!==0)return b;if(u.dark&&f.dark)b=y(u.dark,f.dark);else{if(u.dark)return 1;if(f.dark)return-1}return b}function _(u,f){if(u.command!==f.command)return u.command<f.command?-1:1;if(u.title!==f.title)return u.title<f.title?-1:1;if(u.tooltip!==f.tooltip){if(u.tooltip!==void 0&&f.tooltip!==void 0)return u.tooltip<f.tooltip?-1:1;if(u.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(u.arguments===f.arguments)return 0;if(u.arguments)if(f.arguments){if(u.arguments.length!==f.arguments.length)return u.arguments.length-f.arguments.length}else return 1;else return-1;for(let b=0;b<u.arguments.length;b++){const D=u.arguments[b],w=f.arguments[b];if(D!==w)return D<w?-1:1}return 0}function s(u,f){let b=(0,A.comparePaths)(u.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(b!==0)return b;if(u.command&&f.command)b=_(u.command,f.command);else{if(u.command)return 1;if(f.command)return-1}if(b!==0)return b;if(u.decorations&&f.decorations)b=I(u.decorations,f.decorations);else{if(u.decorations)return 1;if(f.decorations)return-1}return b}function o(u,f){for(let b=0;b<u.length;b++)if(u[b]!==f[b])return!1;return!0}function p(u,f){return u.command===f.command&&u.title===f.title&&u.tooltip===f.tooltip&&(u.arguments&&f.arguments?o(u.arguments,f.arguments):u.arguments===f.arguments)}function t(u,f){return(0,S.equals)(u,f,p)}class a{constructor(f,b,D){this._extension=f,this._proxy=b,this._sourceControlHandle=D,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(f){this._proxy.$setInputBoxValue(this._sourceControlHandle,f),this.updateValue(f)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(f){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,f),this._placeholder=f}get validateInput(){return(0,c.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(f){if((0,c.checkProposedApiEnabled)(this._extension),f&&typeof f!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=f,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!f)}get visible(){return this._visible}set visible(f){f=!!f,this._visible!==f&&(this._visible=f,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,f))}focus(){(0,c.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(f,b){(0,c.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,f,b)}$onInputBoxValueChange(f){this.updateValue(f)}updateValue(f){this._value=f,this._onDidChange.fire(f)}}e.ExtHostSCMInputBox=a;class r{constructor(f,b,D,w,T){this._proxy=f,this._commands=b,this._sourceControlHandle=D,this._id=w,this._label=T,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(f){this._label=f,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,f)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(f){this._hideWhenEmpty=f,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(f){this._resourceStates=[...f],this._onDidUpdateResourceStates.fire()}getResourceState(f){return this._resourceStatesMap.get(f)}$executeResourceCommand(f,b){const D=this._resourceStatesCommandsMap.get(f);return D?(0,R.asPromise)(()=>this._commands.executeCommand(D.command,...D.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this._resourceStates].sort(s),D=(0,S.sortedDiff)(this._resourceSnapshot,f,s).map(v=>{const F=v.toInsert.map(M=>{const G=this._resourceHandlePool++;this._resourceStatesMap.set(G,M);const K=M.resourceUri;let U;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const he=new C.DisposableStore;U=this._commands.converter.toInternal(M.command,he),this._resourceStatesDisposablesMap.set(G,he)}else this._resourceStatesCommandsMap.set(G,M.command);const z=g(M.decorations),N=M.decorations&&g(M.decorations.light)||z,x=M.decorations&&g(M.decorations.dark)||z,B=[N,x],O=M.decorations&&M.decorations.tooltip||"",H=M.decorations&&!!M.decorations.strikeThrough,W=M.decorations&&!!M.decorations.faded,Q=M.contextValue||"";return{rawResource:[G,K,B,O,H,W,Q,U],handle:G}});return{start:v.start,deleteCount:v.deleteCount,toInsert:F}}),w=D.map(({start:v,deleteCount:F,toInsert:M})=>[v,F,M.map(G=>G.rawResource)]),T=D.reverse();for(const{start:v,deleteCount:F,toInsert:M}of T){const G=M.map(U=>U.handle),K=this._handlesSnapshot.splice(v,F,...G);for(const U of K)this._resourceStatesMap.delete(U),this._resourceStatesCommandsMap.delete(U),this._resourceStatesDisposablesMap.get(U)?.dispose(),this._resourceStatesDisposablesMap.delete(U)}return this._resourceSnapshot=f,w}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class i{constructor(f,b,D,w,T,v){this._proxy=b,this._commands=D,this._id=w,this._label=T,this._rootUri=v,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new C.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new a(f,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,w,T,v)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(f){this._count!==f&&(this._count=f,this._proxy.$updateSourceControl(this.handle,{count:f}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(f){this._quickDiffProvider=f,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!f})}get commitTemplate(){return this._commitTemplate}set commitTemplate(f){f!==this._commitTemplate&&(this._commitTemplate=f,this._proxy.$updateSourceControl(this.handle,{commitTemplate:f}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(f){this._acceptInputDisposables.value=new C.DisposableStore,this._acceptInputCommand=f;const b=this._commands.converter.toInternal(f,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:b})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(f){if(this._statusBarCommands&&f&&t(this._statusBarCommands,f))return;this._statusBarDisposables.value=new C.DisposableStore,this._statusBarCommands=f;const b=(f||[]).map(D=>this._commands.converter.toInternal(D,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:b})}get selected(){return this._selected}createResourceGroup(f,b){const D=new r(this._proxy,this._commands,this.handle,f,b),w=L.Event.once(D.onDidDispose)(()=>this.createdResourceGroups.delete(D));return this.createdResourceGroups.set(D,w),this.eventuallyAddResourceGroups(),D}eventuallyAddResourceGroups(){const f=[],b=[];for(const[D,w]of this.createdResourceGroups){w.dispose();const T=D.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(D),this.eventuallyUpdateResourceStates()});L.Event.once(D.onDidDispose)(()=>{this.updatedResourceGroups.delete(D),T.dispose(),this._groups.delete(D.handle),this._proxy.$unregisterGroup(this.handle,D.handle)}),f.push([D.handle,D.id,D.label,D.features]);const v=D._takeResourceStateSnapshot();v.length>0&&b.push([D.handle,v]),this._groups.set(D.handle,D)}this._proxy.$registerGroups(this.handle,f,b),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const f=[];this.updatedResourceGroups.forEach(b=>{const D=b._takeResourceStateSnapshot();D.length!==0&&f.push([b.handle,D])}),f.length>0&&this._proxy.$spliceResourceStates(this.handle,f),this.updatedResourceGroups.clear()}getResourceGroup(f){return this._groups.get(f)}setSelectionState(f){this._selected=f,this._onDidChangeSelection.fire(f)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(f=>f.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,Ve([(0,k.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),Ve([(0,k.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let l=class Bn{constructor(f,b,D){this._commands=b,this.logService=D,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=f.getProxy(E.MainContext.MainThreadSCM),this._telemetry=f.getProxy(E.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===3){const T=this._sourceControls.get(w.sourceControlHandle);if(!T)return w;const v=T.getResourceGroup(w.groupHandle);return v?v.getResourceState(w.handle):w}else if(w&&w.$mid===4){const T=this._sourceControls.get(w.sourceControlHandle);return T?T.getResourceGroup(w.groupHandle):w}else if(w&&w.$mid===5){const T=this._sourceControls.get(w.handle);return T||w}return w}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(f,b,D,w){this.logService.trace("ExtHostSCM#createSourceControl",f.identifier.value,b,D,w),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const T=Bn._handlePool++,v=new i(f,this._proxy,this._commands,b,D,w);this._sourceControls.set(T,v);const F=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(f.identifier))||[];return F.push(v),this._sourceControlsByExtension.set(P.ExtensionIdentifier.toKey(f.identifier),F),v}getLastInputBox(f){this.logService.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const b=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(f.identifier)),D=b&&b[b.length-1];return D&&D.inputBox}$provideOriginalResource(f,b,D){const w=m.URI.revive(b);this.logService.trace("ExtHostSCM#$provideOriginalResource",f,w.toString());const T=this._sourceControls.get(f);return!T||!T.quickDiffProvider||!T.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>T.quickDiffProvider.provideOriginalResource(w,D)).then(v=>v||null)}$onInputBoxValueChange(f,b){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",f);const D=this._sourceControls.get(f);return D&&D.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(f,b,D,w){this.logService.trace("ExtHostSCM#$executeResourceCommand",f,b,D);const T=this._sourceControls.get(f);if(!T)return Promise.resolve(void 0);const v=T.getResourceGroup(b);return v?v.$executeResourceCommand(D,w):Promise.resolve(void 0)}$validateInput(f,b,D){this.logService.trace("ExtHostSCM#$validateInput",f);const w=this._sourceControls.get(f);return!w||!w.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>w.inputBox.validateInput(b,D)).then(T=>{if(!T)return Promise.resolve(void 0);const v=d.MarkdownString.fromStrict(T.message);return v?Promise.resolve([v,T.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this._sourceControls.get(f)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=f,Promise.resolve(void 0)}};l._handlePool=0,l=Ve([$e(2,n.ILogService)],l),e.ExtHostSCM=l});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,m):k?k.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[251],ge([0,1,7,5,167,6,15]),function(J,e,m,L,k,C,R){"use strict";var E,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class A{constructor(h,d,g,y,I=m.StatusBarAlignment.Left,_){E.set(this,void 0),S.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new C.DisposableStore,nt(this,E,h,"f"),nt(this,S,d,"f"),this._entryId=A.ID_GEN++,this._extension=g,this._id=y,this._alignment=I,this._priority=_}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!A.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){this._command?.fromApi!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Oe(this,S,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Oe(this,S,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,E,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let d;this._name?d=this._name:d=(0,k.localize)(0,null,this._extension.displayName||this._extension.name);let g=this._color;this._backgroundColor&&(g=A.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const y=this._tooltip?R.MarkdownString.fromStrict(this._tooltip):void 0;Oe(this,E,"f").$setEntry(this._entryId,h,d,this._text,y,this._command?.internal,g,this._backgroundColor,this._alignment===m.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=A,E=new WeakMap,S=new WeakMap,A.ID_GEN=0,A.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new m.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new m.ThemeColor("statusBarItem.warningForeground")]]);class n{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",m.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,k.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const d={message:h};return this._messages.unshift(d),this._update(),new m.Disposable(()=>{const g=this._messages.indexOf(d);g>=0&&(this._messages.splice(g,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class P{constructor(h,d){this._proxy=h.getProxy(L.MainContext.MainThreadStatusBar),this._commands=d,this._statusMessage=new n(this)}createStatusBarEntry(h,d,g,y){return new A(this._proxy,this._commands,h,d,g,y)}setStatusBarMessage(h,d){const g=this._statusMessage.setMessage(h);let y;return typeof d=="number"?y=setTimeout(()=>g.dispose(),d):typeof d!="undefined"&&d.then(()=>g.dispose(),()=>g.dispose()),new m.Disposable(()=>{g.dispose(),clearTimeout(y)})}}e.ExtHostStatusBar=P}),define(me[92],ge([0,1,5,3,4]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class C{constructor(E){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=E.getProxy(m.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(E,S){this._proxy.$registerExtensionStorageKeysToSync(E,S)}getValue(E,S,A){return this._proxy.$getValue(E,S).then(n=>n||A)}setValue(E,S,A){return this._proxy.$setValue(E,S,A)}$acceptValue(E,S,A){this._onDidChangeStorage.fire({shared:E,key:S,value:A})}}e.ExtHostStorage=C,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(me[69],ge([0,1,4,27,12,91,2]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,m.createDecorator)("IExtensionStoragePaths");let E=class{constructor(A,n,P){this._logService=n,this._extHostFileSystem=P,this._workspace=A.workspace??void 0,this._environment=A.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(c=>this._value=c)}async _getWorkspaceStorageURI(A){return R.URI.joinPath(this._environment.workspaceStorageHome,A)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const A=this._workspace.id,n=await this._getWorkspaceStorageURI(A);try{return await this._extHostFileSystem.value.stat(n),this._logService.trace("[ExtHostStorage] storage dir already exists",n),n}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",n),await this._extHostFileSystem.value.createDirectory(n),await this._extHostFileSystem.value.writeFile(R.URI.joinPath(n,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:R.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),n}catch(P){this._logService.error("[ExtHostStorage]",P);return}}workspaceValue(A){if(this._value)return R.URI.joinPath(this._value,A.identifier.value)}globalValue(A){return R.URI.joinPath(this._environment.globalStorageHome,A.identifier.value.toLowerCase())}onWillDeactivateAll(){}};E=Ve([$e(0,L.IExtHostInitDataService),$e(1,k.ILogService),$e(2,C.IExtHostConsumerFileSystem)],E),e.ExtensionStoragePaths=E}),define(me[33],ge([0,1,3,5,4,2,14,6,7,168,16,215,21,32,196,63,13]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class I{constructor(l,u,f,b){this._proxy=l,this._id=u,this._creationOptions=f,this._name=b,this._disposed=!1,this._state={interactedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(w=>this._pidPromiseComplete=w);const D=this;this.value={get name(){return D._name||""},get processId(){return D._pidPromise},get creationOptions(){return D._creationOptions},get exitStatus(){return D._exitStatus},get state(){return D._state},sendText(w,T=!0){D._checkDisposed(),D._proxy.$sendText(D._id,w,T)},show(w){D._checkDisposed(),D._proxy.$show(D._id,w)},hide(){D._checkDisposed(),D._proxy.$hide(D._id)},dispose(){D._disposed||(D._disposed=!0,D._proxy.$dispose(D._id))},get dimensions(){if(!(D._cols===void 0||D._rows===void 0))return{columns:D._cols,rows:D._rows}}}}async create(l,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:l.name,shellPath:(0,y.withNullAsUndefined)(l.shellPath),shellArgs:(0,y.withNullAsUndefined)(l.shellArgs),cwd:(0,y.withNullAsUndefined)(l.cwd),env:(0,y.withNullAsUndefined)(l.env),icon:(0,y.withNullAsUndefined)(a(l.iconPath)),color:g.ThemeColor.isThemeColor(l.color)?l.color.id:void 0,initialText:(0,y.withNullAsUndefined)(l.message),strictEnv:(0,y.withNullAsUndefined)(l.strictEnv),hideFromUser:(0,y.withNullAsUndefined)(l.hideFromUser),isFeatureTerminal:(0,y.withNullAsUndefined)(u?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,y.withNullAsUndefined)(u?.useShellEnvironment),location:u?.location||this._serializeParentTerminal(l.location,u?.resolvedExtHostIdentifier)})}async createExtensionTerminal(l,u,f,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:f,color:g.ThemeColor.isThemeColor(b)?b.id:void 0,location:this._serializeParentTerminal(l,u)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(l,u){return typeof l=="object"?"parentTerminal"in l&&l.parentTerminal&&u?{parentTerminal:u}:"viewColumn"in l?{viewColumn:l.viewColumn,preserveFocus:l.preserveFocus}:void 0:l}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(l){this._name=l}setExitCode(l){this._exitStatus=Object.freeze({code:l})}setDimensions(l,u){return l===this._cols&&u===this._rows||l===0||u===0?!1:(this._cols=l,this._rows=u,!0)}setInteractedWith(){return this._state.interactedWith?!1:(this._state={interactedWith:!0},!0)}_setProcessId(l){this._pidPromiseComplete?(this._pidPromiseComplete(l),this._pidPromiseComplete=void 0):this._pidPromise.then(u=>{u!==l&&(this._pidPromise=Promise.resolve(l))})}}e.ExtHostTerminal=I;class _{constructor(l){this._pty=l,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new m.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new m.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new m.Emitter,this._onProcessTitleChanged=new m.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new m.Emitter,this._onProcessShellTypeChanged=new m.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onDidChangeProperty=new m.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}refreshProperty(l){return Promise.resolve("")}async start(){}shutdown(){this._pty.close()}input(l){this._pty.handleInput&&this._pty.handleInput(l)}resize(l,u){this._pty.setDimensions&&this._pty.setDimensions({columns:l,rows:u})}async processBinary(l){}acknowledgeDataEvent(l){}async setUnicodeVersion(l){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(l){this._pty.onDidWrite(u=>this._onProcessData.fire(u)),this._pty.onDidClose&&this._pty.onDidClose((u=void 0)=>{this._onProcessExit.fire(u===void 0?void 0:u)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(u=>this._onProcessOverrideDimensions.fire(u&&{cols:u.columns,rows:u.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(u=>this._onProcessTitleChanged.fire(u)),this._pty.open(l||void 0),this._pty.setDimensions&&l&&this._pty.setDimensions(l),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=_;let s=1,o=class extends E.Disposable{constructor(l,u){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new m.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new m.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new m.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new m.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new m.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=u.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new d.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new m.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(l),this._register({dispose:()=>{for(const[f,b]of this._terminalProcesses)b.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(l=>l.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(l){return(l?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(l,u){const f=new I(this._proxy,(0,h.generateUuid)(),l,l.name),b=new _(l.pty);return f.createExtensionTerminal(l.location,this._serializeParentTerminal(l,u).resolvedExtHostIdentifier,a(l.iconPath),r(l.color)).then(D=>{const w=this._setupExtHostProcessListeners(D,b);this._terminalProcessDisposables[D]=w}),this._terminals.push(f),f.value}_serializeParentTerminal(l,u){if(u=u||{},l.location&&typeof l.location=="object"&&"parentTerminal"in l.location){const f=l.location.parentTerminal;if(f){const b=this._terminals.find(D=>D.value===f);b&&(u.resolvedExtHostIdentifier=b._id)}}else l.location&&typeof l.location!="object"?u.location=l.location:u.location&&typeof u.location=="object"&&"splitActiveTerminal"in u.location&&(u.location={splitActiveTerminal:!0});return u}attachPtyToTerminal(l,u){if(!this._getTerminalById(l))throw new Error(`Cannot resolve terminal with id ${l} for virtual process`);const b=new _(u),D=this._setupExtHostProcessListeners(l,b);this._terminalProcessDisposables[l]=D}async $acceptActiveTerminalChanged(l){const u=this._activeTerminal;if(l===null){this._activeTerminal=void 0,u!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const f=this._getTerminalById(l);f&&(this._activeTerminal=f,u!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(l,u){const f=this._getTerminalById(l);f&&this._onDidWriteTerminalData.fire({terminal:f.value,data:u})}async $acceptTerminalDimensions(l,u,f){const b=this._getTerminalById(l);b&&b.setDimensions(u,f)&&this._onDidChangeTerminalDimensions.fire({terminal:b.value,dimensions:b.value.dimensions})}async $acceptTerminalMaximumDimensions(l,u,f){this._terminalProcesses.get(l)?.resize(u,f)}async $acceptTerminalTitleChange(l,u){const f=this._getTerminalById(l);f&&(f.name=u)}async $acceptTerminalClosed(l,u){const f=this._getTerminalObjectIndexById(this._terminals,l);if(f!==null){const b=this._terminals.splice(f,1)[0];b.setExitCode(u),this._onDidCloseTerminal.fire(b.value)}}$acceptTerminalOpened(l,u,f,b){if(u){const T=this._getTerminalObjectIndexById(this._terminals,u);if(T!==null){this._terminals[T]._id=l,this._onDidOpenTerminal.fire(this.terminals[T]),this._terminals[T].isOpen=!0;return}}const D={name:b.name,shellPath:b.executable,shellArgs:b.args,cwd:typeof b.cwd=="string"?b.cwd:C.URI.revive(b.cwd),env:b.env,hideFromUser:b.hideFromUser},w=new I(this._proxy,l,D,f);this._terminals.push(w),this._onDidOpenTerminal.fire(w.value),w.isOpen=!0}async $acceptTerminalProcessId(l,u){const f=this._getTerminalById(l);f&&f._setProcessId(u)}async $startExtensionTerminal(l,u){const f=this._getTerminalById(l);if(!f)return{message:(0,A.localize)(0,null,l)};f.isOpen||await new Promise(D=>{const w=this.onDidOpenTerminal(async T=>{T===f.value&&(w.dispose(),D())})});const b=this._terminalProcesses.get(l);b?b.startSendingEvents(u):this._extensionTerminalAwaitingStart[l]={initialDimensions:u}}_setupExtHostProcessListeners(l,u){const f=new E.DisposableStore;f.add(u.onProcessReady(D=>this._proxy.$sendProcessReady(l,D.pid,D.cwd))),f.add(u.onProcessTitleChanged(D=>this._proxy.$sendProcessTitle(l,D))),this._bufferer.startBuffering(l,u.onProcessData),f.add(u.onProcessExit(D=>this._onProcessExit(l,D))),u.onProcessOverrideDimensions&&f.add(u.onProcessOverrideDimensions(D=>this._proxy.$sendOverrideDimensions(l,D))),this._terminalProcesses.set(l,u);const b=this._extensionTerminalAwaitingStart[l];return b&&u instanceof _&&(u.startSendingEvents(b.initialDimensions),delete this._extensionTerminalAwaitingStart[l]),f}$acceptProcessAckDataEvent(l,u){this._terminalProcesses.get(l)?.acknowledgeDataEvent(u)}$acceptProcessInput(l,u){this._terminalProcesses.get(l)?.input(u)}$acceptTerminalInteraction(l){const u=this._getTerminalById(l);u?.setInteractedWith()&&this._onDidChangeTerminalState.fire(u.value)}$acceptProcessResize(l,u,f){try{this._terminalProcesses.get(l)?.resize(u,f)}catch(b){if(b.code!=="EPIPE"&&b.code!=="ERR_IPC_CHANNEL_CLOSED")throw b}}$acceptProcessShutdown(l,u){this._terminalProcesses.get(l)?.shutdown(u)}$acceptProcessRequestInitialCwd(l){this._terminalProcesses.get(l)?.getInitialCwd().then(u=>this._proxy.$sendProcessInitialCwd(l,u))}$acceptProcessRequestCwd(l){this._terminalProcesses.get(l)?.getCwd().then(u=>this._proxy.$sendProcessCwd(l,u))}$acceptProcessRequestLatency(l){return l}registerLinkProvider(l){return this._linkProviders.add(l),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(l),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(l,u,f){if(this._profileProviders.has(u))throw new Error(`Terminal profile provider "${u}" already registered`);return this._profileProviders.set(u,f),this._proxy.$registerProfileProvider(u,l.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(u),this._proxy.$unregisterProfileProvider(u)})}async $createContributedProfileTerminal(l,u){const f=new c.CancellationTokenSource().token,b=await this._profileProviders.get(l)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(!b||!("options"in b))throw new Error(`No terminal profile options provided for id "${l}"`);if("pty"in b.options){this.createExtensionTerminal(b.options,u);return}this.createTerminalFromOptions(b.options,u)}}async $provideLinks(l,u){const f=this._getTerminalById(l);if(!f)return[];this._terminalLinkCache.delete(l);const b=this._terminalLinkCancellationSource.get(l);b&&b.dispose(!0);const D=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(l,D);const w=[],T={terminal:f.value,line:u},v=[];for(const G of this._linkProviders)v.push(new Promise(async K=>{D.token.onCancellationRequested(()=>K({provider:G,links:[]}));const U=await G.provideTerminalLinks(T,D.token)||[];D.token.isCancellationRequested||K({provider:G,links:U})}));const F=await Promise.all(v);if(D.token.isCancellationRequested)return[];const M=new Map;for(const G of F)G&&G.links.length>0&&w.push(...G.links.map(K=>{const U={id:s++,startIndex:K.startIndex,length:K.length,label:K.tooltip};return M.set(U.id,{provider:G.provider,link:K}),U}));return this._terminalLinkCache.set(l,M),w}$activateLink(l,u){const f=this._terminalLinkCache.get(l)?.get(u);!f||f.provider.handleTerminalLink(f.link)}_onProcessExit(l,u){this._bufferer.stopBuffering(l),this._terminalProcesses.delete(l),delete this._extensionTerminalAwaitingStart[l];const f=this._terminalProcessDisposables[l];f&&(f.dispose(),delete this._terminalProcessDisposables[l]),this._proxy.$sendProcessExit(l,u)}_getTerminalById(l){return this._getTerminalObjectById(this._terminals,l)}_getTerminalObjectById(l,u){const f=this._getTerminalObjectIndexById(l,u);return f!==null?l[f]:null}_getTerminalObjectIndexById(l,u){let f=null;return l.some((b,D)=>b._id===u?(f=D,!0):!1),f}getEnvironmentVariableCollection(l){let u=this._environmentVariableCollections.get(l.identifier.value);return u||(u=new p,this._setEnvironmentVariableCollection(l.identifier.value,u)),u}_syncEnvironmentVariableCollection(l,u){const f=(0,P.serializeEnvironmentVariableCollection)(u.map);this._proxy.$setEnvironmentVariableCollection(l,u.persistent,f.length===0?void 0:f)}$initEnvironmentVariableCollections(l){l.forEach(u=>{const f=u[0],b=new p(u[1]);this._setEnvironmentVariableCollection(f,b)})}$acceptDefaultProfile(l,u){this._defaultProfile=l,this._defaultAutomationProfile=u}_setEnvironmentVariableCollection(l,u){this._environmentVariableCollections.set(l,u),u.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(l,u)})}};o=Ve([$e(1,R.IExtHostRpcService)],o),e.BaseExtHostTerminalService=o;class p{constructor(l){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new m.Emitter,this.map=new Map(l)}get persistent(){return this._persistent}set persistent(l){this._persistent=l,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(l,u){this._setIfDiffers(l,{value:u,type:S.EnvironmentVariableMutatorType.Replace})}append(l,u){this._setIfDiffers(l,{value:u,type:S.EnvironmentVariableMutatorType.Append})}prepend(l,u){this._setIfDiffers(l,{value:u,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(l,u){const f=this.map.get(l);(!f||f.value!==u.value||f.type!==u.type)&&(this.map.set(l,u),this._onDidChangeCollection.fire())}get(l){return this.map.get(l)}forEach(l,u){this.map.forEach((f,b)=>l.call(u,b,f,this))}delete(l){this.map.delete(l),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=p;let t=class extends o{constructor(l){super(!1,l)}createTerminal(l,u,f){throw new n.NotSupportedError}createTerminalFromOptions(l,u){throw new n.NotSupportedError}};t=Ve([$e(0,R.IExtHostRpcService)],t),e.WorkerExtHostTerminalService=t;function a(i){if(!(!i||typeof i=="string"))return"id"in i?{id:i.id,color:i.color}:i}function r(i){return g.ThemeColor.isThemeColor(i)?i:void 0}});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,m):k?k.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[252],ge([0,1,17,23,21,3,75,48,6,25,13,32,5,14,64,15,7,223,127,89]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g,y,I,_,s){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let p=class{constructor(v,F){this.resultsChangedEmitter=new C.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=v.getProxy(c.MainContext.MainThreadTesting),this.observer=new b(this.proxy),this.runTracker=new a(this.proxy),F.registerArgumentProcessor({processArgument:M=>M?.$mid===13?g.TestItem.toItemFromContext(M):M})}createTestController(v,F){if(this.controllers.has(v))throw new Error(`Attempt to insert a duplicate controller with ID "${v}"`);const M=new S.DisposableStore,G=M.add(new I.SingleUseTestCollection(v));G.root.label=F;const K=new Map,U=this.proxy,z={items:G.root.children,get label(){return F},set label(x){F=x,G.root.label=x,U.$updateControllerLabel(v,F)},get id(){return v},createRunProfile:(x,B,O,H,W)=>{let Q=(0,E.hash)(x);for(;K.has(Q);)Q++;const Y=new D(this.proxy,v,Q,x,B,O,H,W);return K.set(Q,Y),Y},createTestItem(x,B,O){return new d.TestItemImpl(v,x,B,O)},createTestRun:(x,B,O=!0)=>this.runTracker.createTestRun(v,G,x,B,O),set resolveHandler(x){G.resolveHandler=x},get resolveHandler(){return G.resolveHandler},dispose:()=>{M.dispose()}};z.createRunConfiguration=z.createRunProfile,U.$registerTestController(v,F),M.add((0,S.toDisposable)(()=>U.$unregisterTestController(v)));const N={controller:z,collection:G,profiles:K};return this.controllers.set(v,N),M.add((0,S.toDisposable)(()=>this.controllers.delete(v))),M.add(G.onDidGenerateDiff(x=>U.$publishDiff(v,x))),z}createTestObserver(){return this.observer.checkout()}async runTests(v,F=k.CancellationToken.None){const M=r(v);if(!M)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const G=this.controllers.get(M.controllerId);if(!G)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:v.include?.map(K=>K.id)??[G.collection.root.id],profileGroup:w[M.kind],profileId:M.profileId,controllerId:M.controllerId}],exclude:v.exclude?.map(K=>K.id)},F)}$provideFileCoverage(v,F,M){return(0,m.mapFind)(this.runTracker.trackers,K=>K.id===v?K.getCoverage(F):void 0)?.provideFileCoverage(M)??Promise.resolve([])}$resolveFileCoverage(v,F,M,G){return(0,m.mapFind)(this.runTracker.trackers,U=>U.id===v?U.getCoverage(F):void 0)?.resolveFileCoverage(M,G)??Promise.resolve([])}$configureRunProfile(v,F){this.controllers.get(v)?.profiles.get(F)?.configureHandler?.()}$publishTestResults(v){this.results=Object.freeze(v.map(F=>(0,A.deepFreeze)(g.TestResults.to(F))).concat(this.results).sort((F,M)=>M.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(v,F){const M=this.controllers.get(s.TestId.fromString(v).controllerId)?.collection;M&&(await M.expand(v,F<0?Infinity:F),M.flushDiff())}$acceptDiff(v){this.observer.applyDiff(v)}async $runControllerTests(v,F){const M=this.controllers.get(v.controllerId);if(!M)return;const{collection:G,profiles:K}=M,U=K.get(v.profileId);if(!U)return;const z=v.testIds.map(O=>G.tree.get(O)).filter(n.isDefined),N=v.excludeExtIds.map(O=>M.collection.tree.get(O)).filter(n.isDefined).filter(O=>z.some(H=>H.fullId.compare(O.fullId)===2));if(!z.length)return;const x=new y.TestRunRequest(z.some(O=>O.actual instanceof d.TestItemRootImpl)?void 0:z.map(O=>O.actual),N.map(O=>O.actual),U),B=this.runTracker.prepareForMainThreadTestRun(x,i.fromInternal(v,M.collection),F);try{await U.runHandler(x,F)}finally{B.isRunning&&!F.isCancellationRequested&&await C.Event.toPromise(B.onEnd),B.dispose()}}$cancelExtensionTestRun(v){v===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(v)}};p=Ve([$e(0,h.IExtHostRpcService)],p),e.ExtHostTesting=p;class t extends S.Disposable{constructor(v,F,M){super();this.dto=v,this.proxy=F,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new C.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new k.CancellationTokenSource(M)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:G}of this.tasks.values())G.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(v){return this.tasks.get(v)?.coverage}createRun(v){const F=this.dto.id,M=this.dto.controllerId,G=(0,P.generateUuid)(),K=new l(this.proxy,F,G),U=B=>(O,...H)=>{if(N){console.warn(`Setting the state of test "${O.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(O)||(this.ensureTestIsKnown(O),B(O,...H))},z=(B,O)=>{const H=O instanceof Array?O.map(g.TestMessage.from):[g.TestMessage.from(O)];if(B.uri&&B.range){const W={range:g.Range.from(B.range),uri:B.uri};for(const Q of H)Q.location=Q.location||W}this.proxy.$appendTestMessagesInRun(F,G,s.TestId.fromExtHostTestItem(B,M).toString(),H)};let N=!1;const x={isPersisted:this.dto.isPersisted,token:this.cts.token,name:v,get coverageProvider(){return K.coverageProvider},set coverageProvider(B){K.coverageProvider=B},enqueued:U(B=>{this.proxy.$updateTestStateInRun(F,G,s.TestId.fromExtHostTestItem(B,M).toString(),1)}),skipped:U(B=>{this.proxy.$updateTestStateInRun(F,G,s.TestId.fromExtHostTestItem(B,M).toString(),5)}),started:U(B=>{this.proxy.$updateTestStateInRun(F,G,s.TestId.fromExtHostTestItem(B,M).toString(),2)}),errored:U((B,O,H)=>{z(B,O),this.proxy.$updateTestStateInRun(F,G,s.TestId.fromExtHostTestItem(B,M).toString(),6,H)}),failed:U((B,O,H)=>{z(B,O),this.proxy.$updateTestStateInRun(F,G,s.TestId.fromExtHostTestItem(B,M).toString(),4,H)}),passed:U((B,O)=>{this.proxy.$updateTestStateInRun(F,G,s.TestId.fromExtHostTestItem(B,this.dto.controllerId).toString(),3,O)}),appendOutput:(B,O,H)=>{N||(H&&(this.dto.isIncluded(H)?this.ensureTestIsKnown(H):H=void 0),this.proxy.$appendOutputToRun(F,G,L.VSBuffer.fromString(B),O&&g.location.from(O),H&&s.TestId.fromExtHostTestItem(H,M).toString()))},end:()=>{N||(N=!0,this.proxy.$finishedTestRunTask(F,G),this.tasks.delete(G),this.isRunning||this.dispose())}};return this.tasks.set(G,{run:x,coverage:K}),this.proxy.$startedTestRunTask(F,{id:G,name:v,running:!0}),x}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(v){if(!(v instanceof d.TestItemImpl))throw new d.InvalidTestItemError(v.id);if(this.sharedTestIds.has(s.TestId.fromExtHostTestItem(v,this.dto.controllerId).toString()))return;const F=[],M=this.dto.colllection.root;for(;;){const G=g.TestItem.from(v);if(F.unshift(G),this.sharedTestIds.has(G.extId)||(this.sharedTestIds.add(G.extId),v===M))break;v=v.parent||M}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,F)}}class a{constructor(v){this.proxy=v,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(v,F,M){return this.getTracker(v,F,M)}cancelRunById(v){for(const F of this.tracked.values())if(F.id===v){F.dispose();return}}cancelAllRuns(){for(const v of this.tracked.values())v.dispose()}createTestRun(v,F,M,G,K){const U=this.tracked.get(M);if(U)return U.createRun(G);const z=i.fromPublic(v,F,M,K),N=r(M);this.proxy.$startedExtensionTestRun({controllerId:v,profile:N&&{group:w[N.kind],id:N.profileId},exclude:M.exclude?.map(B=>B.id)??[],id:z.id,include:M.include?.map(B=>B.id)??[F.root.id],persist:K});const x=this.getTracker(M,z);return x.onEnd(()=>this.proxy.$finishedExtensionTestRun(z.id)),x.createRun(G)}getTracker(v,F,M){const G=new t(F,this.proxy,M);return this.tracked.set(v,G),G.onEnd(()=>this.tracked.delete(v)),G}}e.TestRunCoordinator=a;const r=T=>{if(!!T.profile){if(!(T.profile instanceof D))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return T.profile}};class i{constructor(v,F,M,G,K,U){this.controllerId=v,this.id=F,this.isPersisted=K,this.colllection=U,this.includePrefix=M.map(z=>z+"\0"),this.excludePrefix=G.map(z=>z+"\0")}static fromPublic(v,F,M,G){return new i(v,(0,P.generateUuid)(),M.include?.map(K=>s.TestId.fromExtHostTestItem(K,v).toString())??[v],M.exclude?.map(K=>s.TestId.fromExtHostTestItem(K,v).toString())??[],G,F)}static fromInternal(v,F){return new i(v.controllerId,v.runId,v.testIds,v.excludeExtIds,!0,F)}isIncluded(v){const F=s.TestId.fromExtHostTestItem(v,this.controllerId).toString()+"\0";for(const M of this.excludePrefix)if(F===M||F.startsWith(M))return!1;for(const M of this.includePrefix)if(F===M||F.startsWith(M))return!0;return!1}}e.TestRunDto=i;class l{constructor(v,F,M){this.proxy=v,this.runId=F,this.taskId=M}set coverageProvider(v){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!v||(this._coverageProvider=v,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(v){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(v))());try{return(await this.fileCoverage)?.map(g.TestCoverage.fromFile)??[]}catch(F){throw this.fileCoverage=void 0,F}}async resolveFileCoverage(v,F){const M=await this.fileCoverage;let G=M?.[v];return!this._coverageProvider||!M||!G?[]:(G.detailedCoverage||(G=M[v]=await this._coverageProvider.resolveFileCoverage?.(G,F)??G),G.detailedCoverage?.map(g.TestCoverage.fromDetailed)??[])}}class u extends _.IncrementalChangeCollector{constructor(v){super();this.emitter=v,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(v){this.added.add(v)}update(v){Object.assign(v.revived,g.TestItem.toPlain(v.item)),this.added.has(v)||this.updated.add(v)}remove(v){if(this.added.has(v)){this.added.delete(v);return}if(this.updated.delete(v),v.parent&&this.alreadyRemoved.has(v.parent)){this.alreadyRemoved.add(v.item.extId);return}this.removed.add(v)}getChangeEvent(){const{added:v,updated:F,removed:M}=this;return{get added(){return[...v].map(G=>G.revived)},get updated(){return[...F].map(G=>G.revived)},get removed(){return[...M].map(G=>G.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class f extends _.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new C.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(v){return this.items.get(v)}getMirroredTestDataByReference(v){return this.items.get(v.id)}createItem(v,F){return{...v,revived:g.TestItem.toPlain(v.item),depth:F?F.depth+1:0,children:new Set}}createChangeCollector(){return new u(this.changeEmitter)}}e.MirroredTestCollection=f;class b{constructor(v){this.proxy=v}checkout(){this.current||(this.current=this.createObserverData());const v=this.current;return v.observers++,{onDidChangeTest:v.tests.onDidChangeTests,get tests(){return[...v.tests.rootTests].map(F=>F.revived)},dispose:(0,R.once)(()=>{--v.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(v){return this.current?.tests.getMirroredTestDataByReference(v)}applyDiff(v){this.current?.tests.apply(v)}createObserverData(){const v=new f;return this.proxy.$subscribeToDiffs(),{observers:0,tests:v}}}class D{constructor(v,F,M,G,K,U,z=!1,N=void 0){this.controllerId=F,this.profileId=M,this._label=G,this.kind=K,this.runHandler=U,this._isDefault=z,this._tag=N,o.set(this,void 0),nt(this,o,v,"f");const x=w[K];if(typeof x!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Oe(this,o,"f").$publishTestRunProfile({profileId:M,controllerId:F,tag:N?g.TestTag.namespace(this.controllerId,N.id):null,label:G,group:x,isDefault:z,hasConfigurationHandler:!1})}get label(){return this._label}set label(v){v!==this._label&&(this._label=v,Oe(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:v}))}get isDefault(){return this._isDefault}set isDefault(v){v!==this._isDefault&&(this._isDefault=v,Oe(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:v}))}get tag(){return this._tag}set tag(v){v?.id!==this._tag?.id&&(this._tag=v,Oe(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:v?g.TestTag.namespace(this.controllerId,v.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(v){v!==this._configureHandler&&(this._configureHandler=v,Oe(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!v}))}dispose(){Oe(this,o,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=D,o=new WeakMap;const w={[y.TestRunProfileKind.Coverage]:8,[y.TestRunProfileKind.Debug]:4,[y.TestRunProfileKind.Run]:2}}),define(me[253],ge([0,1,3,17,5,130,15,7]),function(J,e,m,L,k,C,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(n,P){this._extHostDocumentsAndEditors=P,this._onDidChangeTextEditorSelection=new m.Emitter,this._onDidChangeTextEditorOptions=new m.Emitter,this._onDidChangeTextEditorVisibleRanges=new m.Emitter,this._onDidChangeTextEditorViewColumn=new m.Emitter,this._onDidChangeActiveTextEditor=new m.Emitter,this._onDidChangeVisibleTextEditors=new m.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(k.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(c=>this._onDidChangeVisibleTextEditors.fire(c)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(c=>this._onDidChangeActiveTextEditor.fire(c))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const P=this._extHostDocumentsAndEditors.allEditors();return n?P:P.map(c=>c.value)}async showTextDocument(n,P,c){let h;typeof P=="number"?h={position:R.ViewColumn.from(P),preserveFocus:c}:typeof P=="object"?h={position:R.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?R.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:h={preserveFocus:!1};const d=await this._proxy.$tryShowTextDocument(n.uri,h),g=d&&this._extHostDocumentsAndEditors.getEditor(d);if(g)return g.value;throw d?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,P){return new C.TextEditorDecorationType(this._proxy,n,P).value}$acceptEditorPropertiesChanged(n,P){const c=this._extHostDocumentsAndEditors.getEditor(n);if(!c)throw new Error("unknown text editor");if(P.options&&c._acceptOptions(P.options),P.selections){const h=P.selections.selections.map(R.Selection.to);c._acceptSelections(h)}if(P.visibleRanges){const h=L.coalesce(P.visibleRanges.map(R.Range.to));c._acceptVisibleRanges(h)}if(P.options&&this._onDidChangeTextEditorOptions.fire({textEditor:c.value,options:{...P.options,lineNumbers:R.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const h=E.TextEditorSelectionChangeKind.fromValue(P.selections.source),d=P.selections.selections.map(R.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:c.value,selections:d,kind:h})}if(P.visibleRanges){const h=L.coalesce(P.visibleRanges.map(R.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:c.value,visibleRanges:h})}}$acceptEditorPositionData(n){for(const P in n){const c=this._extHostDocumentsAndEditors.getEditor(P);if(!c)throw new Error("Unknown text editor");const h=R.ViewColumn.to(n[P]);c.value.viewColumn!==h&&(c._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:c.value,viewColumn:h}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=S}),define(me[254],ge([0,1,2,4,5,6,7]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class E{constructor(n,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(k.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===11){const h=c.uri===void 0?void 0:m.URI.revive(c.uri);return this._itemsBySourceAndUriMap.get(c.source)?.get(S(h))?.get(c.handle)}return c}})}async $getTimeline(n,P,c,h,d){return this._providers.get(n)?.provideTimeline(m.URI.revive(P),c,h,d)}registerTimelineProvider(n,P,c,h){const d=new C.DisposableStore,g=this.convertTimelineItem(P.id,h,d).bind(this);let y;P.onDidChange&&(y=P.onDidChange(_=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,..._,id:P.id}),this));const I=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...P,scheme:n,onDidChange:void 0,async provideTimeline(_,s,o,p){p?.resetCache&&(d.clear(),I.get(P.id)?.clear());const t=await P.provideTimeline(_,s,o);if(t==null)return;const a=g(_,p);return{...t,source:P.id,items:t.items.map(a)}},dispose(){for(const _ of I.values())_.get(P.id)?.clear();y?.dispose(),d.dispose()}})}convertTimelineItem(n,P,c){return(h,d)=>{let g;if(d?.cacheResults){let y=this._itemsBySourceAndUriMap.get(n);y===void 0&&(y=new Map,this._itemsBySourceAndUriMap.set(n,y));const I=S(h);g=y.get(I),g===void 0&&(g=new Map,y.set(I,g))}return y=>{const{iconPath:I,..._}=y,s=`${n}|${y.id??y.timestamp}`;g?.set(s,y);let o,p,t;return y.iconPath&&(I instanceof R.ThemeIcon?t={id:I.id,color:I.color}:m.URI.isUri(I)?(o=I,p=I):{light:o,dark:p}=I),{..._,id:_.id??void 0,handle:s,source:n,command:y.command?P.toInternal(y.command,c):void 0,icon:o,iconDark:p,themeIcon:t,accessibilityInformation:y.accessibilityInformation}}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,C.toDisposable)(()=>{for(const c of this._itemsBySourceAndUriMap.values())c.get(n.id)?.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=E;function S(A){return A?.toString()}}),define(me[255],ge([0,1,6,10,2,5]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{constructor(S){this._openers=new Map,this._proxy=S.getProxy(C.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,A,n,P){if(this._openers.has(A))throw new Error(`Opener with id '${A}' already registered`);const c=P.schemes.find(h=>!R.supportedSchemes.has(h));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(A,n),this._proxy.$registerUriOpener(A,P.schemes,S,P.label),(0,m.toDisposable)(()=>{this._openers.delete(A),this._proxy.$unregisterUriOpener(A)})}async $canOpenUri(S,A,n){const P=this._openers.get(S);if(!P)throw new Error(`Unknown opener with id: ${S}`);const c=k.URI.revive(A);return P.canOpenExternalUri(c,n)}async $openUri(S,A,n){const P=this._openers.get(S);if(!P)throw new Error(`Unknown opener id: '${S}'`);return P.openExternalUri(k.URI.revive(A.resolvedUri),{sourceUri:k.URI.revive(A.sourceUri)},n)}}e.ExtHostUriOpeners=R,R.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(me[256],ge([0,1,5,2,6,16,26]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class E{constructor(A){this.handles=new Set,this.handlers=new Map,this._proxy=A.getProxy(m.MainContext.MainThreadUrls)}registerUriHandler(A,n){if(this.handles.has(R.ExtensionIdentifier.toKey(A)))throw new Error(`Protocol handler already registered for extension ${A}`);const P=E.HandlePool++;return this.handles.add(R.ExtensionIdentifier.toKey(A)),this.handlers.set(P,n),this._proxy.$registerUriHandler(P,A),(0,k.toDisposable)(()=>{this.handles.delete(R.ExtensionIdentifier.toKey(A)),this.handlers.delete(P),this._proxy.$unregisterUriHandler(P)})}$handleExternalUri(A,n){const P=this.handlers.get(A);if(!P)return Promise.resolve(void 0);try{P.handleUri(L.URI.revive(n))}catch(c){(0,C.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(A){return L.URI.revive(await this._proxy.$createAppUri(A))}}e.ExtHostUrls=E,E.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,m):k?k.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[70],ge([0,1,3,2,180,205,88,5]),function(J,e,m,L,k,C,R,E){"use strict";var S,A,n,P,c,h,d,g,y,I,_,s;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class o{constructor(f,b,D,w,T,v,F){S.set(this,void 0),A.set(this,void 0),n.set(this,void 0),P.set(this,void 0),c.set(this,void 0),h.set(this,void 0),d.set(this,""),g.set(this,void 0),y.set(this,!1),I.set(this,!1),_.set(this,!1),this._onMessageEmitter=new m.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new m.Emitter),this._onDidDispose=Oe(this,s,"f").event,nt(this,S,f,"f"),nt(this,A,b,"f"),nt(this,g,D,"f"),nt(this,P,w,"f"),nt(this,c,T,"f"),nt(this,h,v,"f"),nt(this,_,p(v),"f"),nt(this,n,F,"f")}dispose(){nt(this,y,!0,"f"),Oe(this,s,"f").fire(),Oe(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return nt(this,I,!0,"f"),(0,R.asWebviewUri)(f,Oe(this,P,"f").remote)}get cspSource(){return R.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,d,"f")}set html(f){this.assertNotDisposed(),Oe(this,d,"f")!==f&&(nt(this,d,f,"f"),!Oe(this,I,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(nt(this,I,!0,"f"),Oe(this,n,"f").report("Webview vscode-resource: uris",Oe(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,A,"f").$setHtml(Oe(this,S,"f"),f))}get options(){return this.assertNotDisposed(),Oe(this,g,"f")}set options(f){this.assertNotDisposed(),Oe(this,A,"f").$setOptions(Oe(this,S,"f"),r(Oe(this,h,"f"),Oe(this,c,"f"),f)),nt(this,g,f,"f")}async postMessage(f){if(Oe(this,y,"f"))return!1;const b=(0,C.serializeWebviewMessage)(f,{serializeBuffersForPostMessage:Oe(this,_,"f")});return Oe(this,A,"f").$postMessage(Oe(this,S,"f"),b.message,...b.buffers)}assertNotDisposed(){if(Oe(this,y,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=o,S=new WeakMap,A=new WeakMap,n=new WeakMap,P=new WeakMap,c=new WeakMap,h=new WeakMap,d=new WeakMap,g=new WeakMap,y=new WeakMap,I=new WeakMap,_=new WeakMap,s=new WeakMap;function p(u){try{const f=(0,k.normalizeVersion)((0,k.parseVersion)(u.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=p;class t{constructor(f,b,D,w,T){this.initData=b,this.workspace=D,this._logService=w,this._deprecationService=T,this._webviews=new Map,this._webviewProxy=f.getProxy(E.MainContext.MainThreadWebviews)}$onMessage(f,b,...D){const w=this.getWebview(f);if(w){const{message:T}=(0,C.deserializeWebviewMessage)(b,D);w._onMessageEmitter.fire(T)}}$onMissingCsp(f,b){this._logService.warn(`${b} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,b,D){const w=new o(f,this._webviewProxy,i(b),this.initData,this.workspace,D,this._deprecationService);return this._webviews.set(f,w),w._onDidDispose(()=>{this._webviews.delete(f)}),w}deleteWebview(f){this._webviews.delete(f)}getWebview(f){return this._webviews.get(f)}}e.ExtHostWebviews=t;function a(u){return{id:u.identifier,location:u.extensionLocation}}e.toExtensionData=a;function r(u,f,b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots||l(u,f)}}e.serializeWebviewOptions=r;function i(u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots?.map(f=>L.URI.from(f))}}e.reviveOptions=i;function l(u,f){return[...(f?.getWorkspaceFolders()||[]).map(b=>b.uri),u.extensionLocation]}}),define(me[257],ge([0,1,21,48,6,10,22,2,15,70,87,5,7]),function(J,e,m,L,k,C,R,E,S,A,n,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(t,a){this.document=t,this._storagePath=a,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,a){await this.getEdit(t).undo(),a||this.disposeBackup()}async redo(t,a){await this.getEdit(t).redo(),a||this.disposeBackup()}disposeEdits(t){for(const a of t)this._edits.delete(a)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=o(this.document.uri)+this._backupCounter++;return(0,R.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const a=this._edits.get(t,0);if(!a)throw new Error("No edit found");return a}}class d{constructor(){this._documents=new Map}get(t,a){return this._documents.get(this.key(t,a))}add(t,a,r){const i=this.key(t,a.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${a.uri}`);const l=new h(a,r);return this._documents.set(i,l),l}delete(t,a){const r=this.key(t,a.uri);this._documents.delete(r)}key(t,a){return`${t}@@@${a}`}}var g;(function(p){p[p.Text=0]="Text",p[p.Custom=1]="Custom"})(g||(g={}));class y{constructor(){this._providers=new Map}addTextProvider(t,a,r){return this.add(0,t,a,r)}addCustomProvider(t,a,r){return this.add(1,t,a,r)}get(t){return this._providers.get(t)}add(t,a,r,i){if(this._providers.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this._providers.set(a,{type:t,extension:r,provider:i}),new c.Disposable(()=>this._providers.delete(a))}}class I{constructor(t,a,r,i,l){this._extHostDocuments=a,this._extensionStoragePaths=r,this._extHostWebview=i,this._extHostWebviewPanels=l,this._editorProviders=new y,this._documents=new d,this._proxy=t.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,a,r,i){const l=new k.DisposableStore;return _(r)?(l.add(this._editorProviders.addTextProvider(a,t,r)),this._proxy.$registerTextEditorProvider((0,A.toExtensionData)(t),a,i.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,A.shouldSerializeBuffersForPostMessage)(t))):(l.add(this._editorProviders.addCustomProvider(a,t,r)),this.supportEditing(r)&&l.add(r.onDidChangeCustomDocument(u=>{const f=this.getCustomDocumentEntry(a,u.document.uri);if(s(u)){const b=f.addEdit(u);this._proxy.$onDidEdit(u.document.uri,a,b,u.label)}else this._proxy.$onContentChange(u.document.uri,a)})),this._proxy.$registerCustomEditorProvider((0,A.toExtensionData)(t),a,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,A.shouldSerializeBuffersForPostMessage)(t))),c.Disposable.from(l,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(a)}))}async $createCustomDocument(t,a,r,i,l){const u=this._editorProviders.get(a);if(!u)throw new Error(`No provider found for '${a}'`);if(u.type!==1)throw new Error(`Invalid provide type for '${a}'`);const f=E.URI.revive(t),b=await u.provider.openCustomDocument(f,{backupId:r,untitledDocumentData:i?.buffer},l);let D;return this.supportEditing(u.provider)&&this._extensionStoragePaths&&(D=this._extensionStoragePaths.workspaceValue(u.extension)??this._extensionStoragePaths.globalValue(u.extension)),this._documents.add(a,b,D),{editable:this.supportEditing(u.provider)}}async $disposeCustomDocument(t,a){const r=this._editorProviders.get(a);if(!r)throw new Error(`No provider found for '${a}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${a}'`);const i=E.URI.revive(t),{document:l}=this.getCustomDocumentEntry(a,i);this._documents.delete(a,l),l.dispose()}async $resolveWebviewEditor(t,a,r,i,l,u){const f=this._editorProviders.get(r);if(!f)throw new Error(`No provider found for '${r}'`);const b=S.ViewColumn.to(l),D=this._extHostWebview.createNewWebview(a,i.webviewOptions,f.extension),w=this._extHostWebviewPanels.createNewWebviewPanel(a,r,i.title,b,i.panelOptions,D),T=E.URI.revive(t);switch(f.type){case 1:{const{document:v}=this.getCustomDocumentEntry(r,T);return f.provider.resolveCustomEditor(v,w,u)}case 0:{const v=this._extHostDocuments.getDocument(T);return f.provider.resolveCustomTextEditor(v,w,u)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,a,r){this.getCustomDocumentEntry(a,t).disposeEdits(r)}async $onMoveCustomEditor(t,a,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const l=this._extHostWebviewPanels.getWebviewPanel(t);if(!l)throw new Error("No webview found");const u=E.URI.revive(a),f=this._extHostDocuments.getDocument(u);await i.provider.moveCustomTextEditor(f,l,m.CancellationToken.None)}async $undo(t,a,r,i){return this.getCustomDocumentEntry(a,t).undo(r,i)}async $redo(t,a,r,i){return this.getCustomDocumentEntry(a,t).redo(r,i)}async $revert(t,a,r){const i=this.getCustomDocumentEntry(a,t);await this.getCustomEditorProvider(a).revertCustomDocument(i.document,r),i.disposeBackup()}async $onSave(t,a,r){const i=this.getCustomDocumentEntry(a,t);await this.getCustomEditorProvider(a).saveCustomDocument(i.document,r),i.disposeBackup()}async $onSaveAs(t,a,r,i){const l=this.getCustomDocumentEntry(a,t);return this.getCustomEditorProvider(a).saveCustomDocumentAs(l.document,E.URI.revive(r),i)}async $backup(t,a,r){const i=this.getCustomDocumentEntry(a,t),u=await this.getCustomEditorProvider(a).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},r);return i.updateBackup(u),u.id}getCustomDocumentEntry(t,a){const r=this._documents.get(t,E.URI.revive(a));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(t){const r=this._editorProviders.get(t)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=I;function _(p){return typeof p.resolveCustomTextEditor=="function"}function s(p){return typeof p.undo=="function"&&typeof p.redo=="function"}function o(p){const t=p.scheme===C.Schemas.file||p.scheme===C.Schemas.untitled?p.fsPath:p.toString();return(0,L.hash)(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,m):k?k.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[258],ge([0,1,3,6,2,32,15,70,5,7]),function(J,e,m,L,k,C,R,E,S,A){"use strict";var n,P,c,h,d,g,y,I,_,s,o,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class a extends L.Disposable{constructor(u,f,b,D,w,T,v){super();n.set(this,void 0),P.set(this,void 0),c.set(this,void 0),h.set(this,void 0),d.set(this,void 0),g.set(this,void 0),y.set(this,void 0),I.set(this,void 0),_.set(this,!0),s.set(this,!0),o.set(this,!1),p.set(this,this._register(new m.Emitter)),this.onDidDispose=Oe(this,p,"f").event,t.set(this,this._register(new m.Emitter)),this.onDidChangeViewState=Oe(this,t,"f").event,nt(this,n,u,"f"),nt(this,P,f,"f"),nt(this,c,b,"f"),nt(this,d,T,"f"),nt(this,I,w,"f"),nt(this,g,D,"f"),nt(this,h,v,"f")}dispose(){Oe(this,o,"f")||(nt(this,o,!0,"f"),Oe(this,p,"f").fire(),Oe(this,P,"f").$disposeWebview(Oe(this,n,"f")),Oe(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,h,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,c,"f")}get title(){return this.assertNotDisposed(),Oe(this,g,"f")}set title(u){this.assertNotDisposed(),Oe(this,g,"f")!==u&&(nt(this,g,u,"f"),Oe(this,P,"f").$setTitle(Oe(this,n,"f"),u))}get iconPath(){return this.assertNotDisposed(),Oe(this,y,"f")}set iconPath(u){this.assertNotDisposed(),Oe(this,y,"f")!==u&&(nt(this,y,u,"f"),Oe(this,P,"f").$setIconPath(Oe(this,n,"f"),k.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return Oe(this,d,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,I,"f")=="number"&&Oe(this,I,"f")<0))return Oe(this,I,"f")}get active(){return this.assertNotDisposed(),Oe(this,s,"f")}get visible(){return this.assertNotDisposed(),Oe(this,_,"f")}_updateViewState(u){Oe(this,o,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(nt(this,s,u.active,"f"),nt(this,_,u.visible,"f"),nt(this,I,u.viewColumn,"f"),Oe(this,t,"f").fire({webviewPanel:this}))}reveal(u,f){this.assertNotDisposed(),Oe(this,P,"f").$reveal(Oe(this,n,"f"),{viewColumn:u?R.ViewColumn.from(u):void 0,preserveFocus:!!f})}assertNotDisposed(){if(Oe(this,o,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,P=new WeakMap,c=new WeakMap,h=new WeakMap,d=new WeakMap,g=new WeakMap,y=new WeakMap,I=new WeakMap,_=new WeakMap,s=new WeakMap,o=new WeakMap,p=new WeakMap,t=new WeakMap;class r{constructor(u,f,b){this.webviews=f,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=u.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,C.generateUuid)()}createWebviewPanel(u,f,b,D,w={}){const T=typeof D=="object"?D.viewColumn:D,v={viewColumn:R.ViewColumn.from(T),preserveFocus:typeof D=="object"&&!!D.preserveFocus},F=(0,E.shouldSerializeBuffersForPostMessage)(u),M=r.newHandle();this._proxy.$createWebviewPanel((0,E.toExtensionData)(u),M,f,{title:b,panelOptions:i(w),webviewOptions:(0,E.serializeWebviewOptions)(u,this.workspace,w),serializeBuffersForPostMessage:F},v);const G=this.webviews.createNewWebview(M,w,u);return this.createNewWebviewPanel(M,f,b,T,w,G)}$onDidChangeWebviewPanelViewStates(u){const f=Object.keys(u);f.sort((b,D)=>{const w=u[b],T=u[D];return w.active?1:T.active?-1:+w.visible-+T.visible});for(const b of f){const D=this.getWebviewPanel(b);if(!D)continue;const w=u[b];D._updateViewState({active:w.active,visible:w.visible,viewColumn:R.ViewColumn.to(w.position)})}}async $onDidDisposeWebviewPanel(u){this.getWebviewPanel(u)?.dispose(),this._webviewPanels.delete(u),this.webviews.deleteWebview(u)}registerWebviewPanelSerializer(u,f,b){if(this._serializers.has(f))throw new Error(`Serializer for '${f}' already registered`);return this._serializers.set(f,{serializer:b,extension:u}),this._proxy.$registerSerializer(f,{serializeBuffersForPostMessage:(0,E.shouldSerializeBuffersForPostMessage)(u)}),new A.Disposable(()=>{this._serializers.delete(f),this._proxy.$unregisterSerializer(f)})}async $deserializeWebviewPanel(u,f,b,D){const w=this._serializers.get(f);if(!w)throw new Error(`No serializer found for '${f}'`);const{serializer:T,extension:v}=w,F=this.webviews.createNewWebview(u,b.webviewOptions,v),M=this.createNewWebviewPanel(u,f,b.title,D,b.panelOptions,F);await T.deserializeWebviewPanel(M,b.state)}createNewWebviewPanel(u,f,b,D,w,T){const v=new a(u,this._proxy,f,b,D,w,T);return this._webviewPanels.set(u,v),v}getWebviewPanel(u){return this._webviewPanels.get(u)}}e.ExtHostWebviewPanels=r;function i(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,m):k?k.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[259],ge([0,1,3,6,70,5,7]),function(J,e,m,L,k,C,R){"use strict";var E,S,A,n,P,c,h,d,g,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class I extends L.Disposable{constructor(o,p,t,a,r,i){super();E.set(this,void 0),S.set(this,void 0),A.set(this,void 0),n.set(this,void 0),P.set(this,!1),c.set(this,void 0),h.set(this,void 0),d.set(this,void 0),g.set(this,this._register(new m.Emitter)),this.onDidChangeVisibility=Oe(this,g,"f").event,y.set(this,this._register(new m.Emitter)),this.onDidDispose=Oe(this,y,"f").event,nt(this,A,t,"f"),nt(this,h,a,"f"),nt(this,E,o,"f"),nt(this,S,p,"f"),nt(this,n,r,"f"),nt(this,c,i,"f")}dispose(){Oe(this,P,"f")||(nt(this,P,!0,"f"),Oe(this,y,"f").fire(),Oe(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,h,"f")}set title(o){this.assertNotDisposed(),Oe(this,h,"f")!==o&&(nt(this,h,o,"f"),Oe(this,S,"f").$setWebviewViewTitle(Oe(this,E,"f"),o))}get description(){return this.assertNotDisposed(),Oe(this,d,"f")}set description(o){this.assertNotDisposed(),Oe(this,d,"f")!==o&&(nt(this,d,o,"f"),Oe(this,S,"f").$setWebviewViewDescription(Oe(this,E,"f"),o))}get visible(){return Oe(this,c,"f")}get webview(){return Oe(this,n,"f")}get viewType(){return Oe(this,A,"f")}_setVisible(o){o===Oe(this,c,"f")||Oe(this,P,"f")||(nt(this,c,o,"f"),Oe(this,g,"f").fire())}show(o){this.assertNotDisposed(),Oe(this,S,"f").$show(Oe(this,E,"f"),!!o)}assertNotDisposed(){if(Oe(this,P,"f"))throw new Error("Webview is disposed")}}E=new WeakMap,S=new WeakMap,A=new WeakMap,n=new WeakMap,P=new WeakMap,c=new WeakMap,h=new WeakMap,d=new WeakMap,g=new WeakMap,y=new WeakMap;class _{constructor(o,p){this._extHostWebview=p,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=o.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(o,p,t,a){if(this._viewProviders.has(p))throw new Error(`View provider for '${p}' already registered`);return this._viewProviders.set(p,{provider:t,extension:o}),this._proxy.$registerWebviewViewProvider((0,k.toExtensionData)(o),p,{retainContextWhenHidden:a?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new R.Disposable(()=>{this._viewProviders.delete(p),this._proxy.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(o,p,t,a,r){const i=this._viewProviders.get(p);if(!i)throw new Error(`No view provider found for '${p}'`);const{provider:l,extension:u}=i,f=this._extHostWebview.createNewWebview(o,{},u),b=new I(o,this._proxy,p,t,f,!0);this._webviewViews.set(o,b),await l.resolveWebviewView(b,{state:a},r)}async $onDidChangeWebviewViewVisibility(o,p){this.getWebviewView(o)._setVisible(p)}async $disposeWebviewView(o){const p=this.getWebviewView(o);this._webviewViews.delete(o),p.dispose(),this._extHostWebview.deleteWebview(o)}getWebviewView(o){const p=this._webviewViews.get(o);if(!p)throw new Error("No webview found");return p}}e.ExtHostWebviewViews=_}),define(me[132],ge([0,1,3,5,2,10,9,4,14]),function(J,e,m,L,k,C,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let A=class $n{constructor(P){this._onDidChangeWindowState=new m.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=$n.InitialState,this._proxy=P.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(c=>this.$onDidChangeWindowFocus(c))}get state(){return this._state}$onDidChangeWindowFocus(P){P!==this._state.focused&&(this._state={...this._state,focused:P},this._onDidChangeWindowState.fire(this._state))}openUri(P,c){let h;if(typeof P=="string"){h=P;try{P=k.URI.parse(P)}catch(d){return Promise.reject(`Invalid uri - '${P}'`)}}return(0,R.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this._proxy.$openUri(P,h,c)}async asExternalUri(P,c){if((0,R.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(P,c);return k.URI.from(h)}};A.InitialState={focused:!0},A=Ve([$e(0,S.IExtHostRpcService)],A),e.ExtHostWindow=A,e.IExtHostWindow=(0,E.createDecorator)("IExtHostWindow")}),define(me[260],ge([0,1,8,80,32,44,6,5,2,14]),function(J,e,m,L,k,C,R,E,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let n=class extends R.Disposable{constructor(c,h){super();const d=c.getProxy(E.MainContext.MainThreadDownloadService);h.registerCommand(!1,"_workbench.downloadResource",async g=>{const y=S.URI.file((0,m.join)((0,L.tmpdir)(),(0,k.generateUuid)()));return await d.$download(g,y),y})}};n=Ve([$e(0,A.IExtHostRpcService),$e(1,C.IExtHostCommands)],n),e.ExtHostDownloadService=n}),define(me[261],ge([0,1,2,8,152,28,68,27,14,6,12,116,42]),function(J,e,m,L,k,C,R,E,S,A,n,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class h{constructor(I,_,s){this.name=I,this.file=_,this.appender=s}static async create(I,_){const s=await(0,P.createRotatingLogger)(I,_,30*c.ByteSize.MB,1);return s.clearFormatters(),new h(I,_,s)}append(I){this.appender.critical(I)}flush(){this.appender.flush()}}class d extends R.AbstractExtHostOutputChannel{constructor(I,_,s,o){super(I,!1,m.URI.file(_.file),s,o);this._appender=_}append(I){super.append(I),this._appender.append(I),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(I,_){this._appender.flush(),super.show(I,_)}clear(){this._appender.flush(),super.clear()}}let g=class extends R.ExtHostOutputService{constructor(I,_,s){super(I);this.logService=_,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new A.MutableDisposable,this._logsLocation=s.logsLocation}$setVisibleChannel(I){if(I){const _=this._channels.get(I);_&&(this._visibleChannelDisposable.value=_.onDidAppend(()=>_.update()))}}createOutputChannel(I,_){if(I=I.trim(),!I)throw new Error("illegal argument `name`. must not be falsy");const s=this._doCreateOutChannel(I,_);return s.then(o=>o._id.then(p=>this._channels.set(p,o))),new R.LazyOutputChannel(I,s)}async _doCreateOutChannel(I,_){try{const s=(0,L.join)(this._logsLocation.fsPath,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await C.SymlinkSupport.existsDirectory(s)||await C.Promises.mkdir(s,{recursive:!0});const p=`${this._namePool++}-${I.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=m.URI.file((0,L.join)(s,`${p}.log`)),a=await h.create(p,t.fsPath);return new d(I,a,_.identifier.value,this._proxy)}catch(s){return this.logService.error(s),new R.ExtHostPushOutputChannel(I,_.identifier.value,this._proxy)}}};g=Ve([$e(0,S.IExtHostRpcService),$e(1,n.ILogService),$e(2,E.IExtHostInitDataService)],g),e.ExtHostOutputService2=g}),define(me[262],ge([0,1,50,293,2,69,6,10,18]),function(J,e,m,L,k,C,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class A extends C.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(p){const t=await super._getWorkspaceStorageURI(p);if(t.scheme!==E.Schemas.file)return t;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${t.fsPath}.`),t;const a=t.fsPath;let r=0;do{let i;r===0?i=a:i=/[/\\]$/.test(a)?`${a.substr(0,a.length-1)}-${r}`:`${a}-${r}`,await n(i);const l=L.join(i,"vscode.lock"),u=await d(this._logService,l,!1);if(u)return this._workspaceStorageLock=u,process.on("exit",()=>{u.dispose()}),k.URI.file(i);r++}while(r<10);return t}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=A;async function n(o){try{await m.promises.stat(o);return}catch{}try{await m.promises.mkdir(o,{recursive:!0})}catch{}}const P=1e3,c=10*60*1e3;class h extends R.Disposable{constructor(p,t){super();this.logService=p,this.filename=t,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const a=await g(p,t);(!a||a.pid!==process.pid)&&(p.info(`Lock '${t}': The lock was lost unexpectedly.`),this._timer.cancel());try{await m.promises.utimes(t,new Date,new Date)}catch(r){p.error(r),p.info(`Lock '${t}': Could not update mtime.`)}},P)}dispose(){super.dispose();try{m.unlinkSync(this.filename)}catch(p){}}async setWillRelease(p){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${p} ms.`);try{const t={pid:process.pid,willReleaseAt:Date.now()+p};await m.promises.writeFile(this.filename,JSON.stringify(t),{flag:"w"})}catch(t){this.logService.error(t)}}}async function d(o,p,t){try{const r={pid:process.pid,willReleaseAt:0};await m.promises.writeFile(p,JSON.stringify(r),{flag:"wx"})}catch(r){o.error(r)}const a=await g(o,p);return!a||a.pid!==process.pid?t?(o.info(`Lock '${p}': Could not acquire lock, giving up.`),null):(o.info(`Lock '${p}': Could not acquire lock, checking if the file is stale.`),_(o,p)):(o.info(`Lock '${p}': Lock acquired.`),new h(o,p))}async function g(o,p){let t;try{t=await m.promises.readFile(p)}catch(a){return o.error(a),null}try{return JSON.parse(String(t))}catch(a){return o.error(a),null}}async function y(o,p){let t;try{t=await m.promises.stat(p)}catch(a){return o.error(a),0}return t.mtime.getTime()}function I(o){try{return process.kill(o,0),!0}catch(p){return!1}}async function _(o,p){const t=await g(o,p);if(!t)return o.info(`Lock '${p}': Could not read pid of lock holder.`),s(o,p);if(t.willReleaseAt){let u=t.willReleaseAt-Date.now();if(u<5e3){for(u>0?o.info(`Lock '${p}': The lockfile is scheduled to be released in ${u} ms.`):o.info(`Lock '${p}': The lockfile is scheduled to have been released.`);u>0;){if(await(0,S.timeout)(Math.min(100,u)),await y(o,p)===0)return s(o,p);u=t.willReleaseAt-Date.now()}return s(o,p)}}if(!I(t.pid))return o.info(`Lock '${p}': The pid ${t.pid} appears to be gone.`),s(o,p);const a=await y(o,p),r=Date.now()-a;if(r<=c)return o.info(`Lock '${p}': The lock does not look stale, elapsed: ${r} ms, giving up.`),null;o.info(`Lock '${p}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const i=await y(o,p),l=Date.now()-i;return l<=c?(o.info(`Lock '${p}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null):(o.info(`Lock '${p}': The lock looks stale even after waiting for 2s.`),s(o,p))}async function s(o,p){o.info(`Lock '${p}': Deleting a stale lock.`);try{await m.promises.unlink(p)}catch(t){}return d(o,p,!0)}}),define(me[263],ge([0,1,32,14,33]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let C=class extends k.BaseExtHostTerminalService{constructor(E){super(!0,E)}createTerminal(E,S,A){return this.createTerminalFromOptions({name:E,shellPath:S,shellArgs:A})}createTerminalFromOptions(E,S){const A=new k.ExtHostTerminal(this._proxy,(0,m.generateUuid)(),E,E.name);return this._terminals.push(A),A.create(E,this._serializeParentTerminal(E,S)),A.value}};C=Ve([$e(0,L.IExtHostRpcService)],C),e.ExtHostTerminalService=C}),define(me[264],ge([0,1,5,14,6,27,2,39,22,28,7,11,53,3,194,77,12]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class I{constructor(f,b,D){this.remoteAddress=f,this.localAddress=b,this._dispose=D,this._onDispose=new h.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function _(u){const f=u.trim().split(`
`),b=[];return f.forEach(w=>{const T=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(w);T&&T.length>=3&&b.push({pid:parseInt(T[1],10),socket:parseInt(T[2],10)})}),b.reduce((w,T)=>(w[T.socket]=T,w),{})}e.getSockets=_;function s(...u){const f=[].concat(...u.map(p));return[...new Map(f.filter(b=>b.st==="0A").map(b=>{const D=b.local_address.split(":");return{socket:parseInt(b.inode,10),ip:o(D[0]),port:parseInt(D[1],16)}}).map(b=>[b.ip+":"+b.port,b])).values()]}e.loadListeningPorts=s;function o(u){let f="";if(u.length===8)for(let b=u.length-2;b>=0;b-=2)f+=parseInt(u.substr(b,2),16),b!==0&&(f+=".");else for(let b=u.length-4;b>=0;b-=4)f+=parseInt(u.substr(b,4),16).toString(16),b!==0&&(f+=":");return f}e.parseIpAddress=o;function p(u){const f=u.trim().split(`
`),b=f.shift().trim().split(/\s+/).filter(w=>w!=="rx_queue"&&w!=="tm->when");return f.map(w=>w.trim().split(/\s+/).reduce((T,v,F)=>(T[b[F]||F]=v,T),{}))}e.loadConnectionTable=p;function t(u){return!!u.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||u.indexOf("out/vs/server/main.js")!==-1||u.indexOf("_productName=VSCode")!==-1}function a(u){const f=u.trim().split(`
`),b=[];return f.forEach(D=>{const w=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(D);w&&w.length>=4&&b.push({pid:parseInt(w[1],10),ppid:parseInt(w[2]),cmd:w[3]})}),b}e.getRootProcesses=a;async function r(u,f,b){const D=b.reduce((T,v)=>(T[v.pid]=v,T),{}),w=[];return u.forEach(({socket:T,ip:v,port:F})=>{const M=f[T]?f[T].pid:void 0,G=M?D[M]?.cmd:void 0;M&&G&&!t(G)&&w.push({host:v,port:F,detail:G,pid:M})}),w}e.findPorts=r;function i(u,f,b){const D=new Map,w=a(f);for(const T of u){const v=b.get(T.port);if(v){D.set(T.port,v);continue}const F=w.find(M=>M.cmd.includes(`${T.port}`));if(F){let M=F,G;do G=w.find(K=>K.ppid===M.pid),G&&(M=G);while(G);D.set(T.port,{host:T.ip,port:T.port,pid:M.pid,detail:M.cmd,ppid:M.ppid})}else D.set(T.port,{host:T.ip,port:T.port,ppid:Number.MAX_VALUE})}return D}e.tryFindRootPorts=i;let l=class extends k.Disposable{constructor(f,b,D){super();this.logService=D,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new h.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=f.getProxy(m.MainContext.MainThreadTunnelService),P.isLinux&&b.remote.isRemote&&b.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(f,b){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${f.identifier.value} called openTunnel API for ${b.remoteAddress.host}:${b.remoteAddress.port}.`);const D=await this._proxy.$openTunnel(b,f.displayName);if(D){const w=new I(D.remoteAddress,D.localAddress,()=>this._proxy.$closeTunnel(D.remoteAddress));return this._register(w),w}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(f){return Math.max(f*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(f,b){const D=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(D,{selector:f,provider:b}),this._proxy.$registerPortsAttributesProvider(f,D),new n.Disposable(()=>{this._portAttributesProviders.delete(D),this._proxy.$unregisterPortsAttributesProvider(D)})}async $providePortAttributes(f,b,D,w,T){const v=[];for(const M of f){const G=this._portAttributesProviders.get(M);if(!G)return[];v.push(...await Promise.all(b.map(async K=>G.provider.providePortAttributes(K,D,w,T))))}const F=v.filter(M=>!!M);return F.length>0?F.map(M=>({autoForwardAction:M.autoForwardAction,port:M.port})):[]}async $registerCandidateFinder(f){if(f&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=f;let b=new g.MovingAverage,D;for(;this._candidateFindingEnabled;){const w=new Date().getTime(),T=(await this.findCandidatePorts()).filter(F=>(0,d.isLocalhost)(F.host)||(0,d.isAllInterfaces)(F.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${T.map(F=>F.port).join(", ")}`);const v=new Date().getTime()-w;b.update(v),(!D||JSON.stringify(D)!==JSON.stringify(T))&&(D=T,await this._proxy.$onFoundNewCandidates(D)),await new Promise(F=>setTimeout(()=>F(),this.calculateDelay(b.value)))}}async setTunnelExtensionFunctions(f){return f?(f.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(f.candidatePortSource),f.showCandidatePort&&(this._showCandidatePort=f.showCandidatePort,this._proxy.$setCandidateFilter()),f.tunnelFactory&&(this._forwardPortProvider=f.tunnelFactory,this._proxy.$setTunnelProvider(f.tunnelFeatures??{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,k.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(f,b){if(this._extensionTunnels.has(f.host)){const D=this._extensionTunnels.get(f.host);D.has(f.port)&&(b&&D.get(f.port).disposeListener.dispose(),await D.get(f.port).tunnel.dispose(),D.delete(f.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(f,b){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const D=this._forwardPortProvider(f,b);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),D!==void 0){const w=await D;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(f.remoteAddress.host)||this._extensionTunnels.set(f.remoteAddress.host,new Map);const T=this._register(w.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(w.remoteAddress))));return this._extensionTunnels.get(f.remoteAddress.host).set(f.remoteAddress.port,{tunnel:w,disposeListener:T}),c.TunnelDto.fromApiTunnel(w)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(D){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(f){const b=await Promise.all(f.map(w=>this._showCandidatePort(w.host,w.port,w.detail??""))),D=f.filter((w,T)=>b[T]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${f.map(w=>w.port).join(", ")} to ${D.map(w=>w.port).join(", ")}`),D}async findCandidatePorts(){let f="",b="";try{f=await A.Promises.readFile("/proc/net/tcp","utf8"),b=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch(z){}const D=s(f,b),w=await new Promise(z=>{(0,E.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(N,x,B)=>{z(x)})}),T=_(w),v=await A.Promises.readdir("/proc"),F=[];for(let z of v)try{const N=Number(z),x=S.joinPath(R.URI.file("/proc"),z);if((await A.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(N)){const O=await A.Promises.readlink(S.joinPath(x,"cwd").fsPath),H=await A.Promises.readFile(S.joinPath(x,"cmdline").fsPath,"utf8");F.push({pid:N,cwd:O,cmd:H})}}catch(N){}const M=[],G=D.filter(z=>{const N=T[z.socket];return N||M.push(z),N}),K=r(G,T,F);let U;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${M.length}`),M.length>0){const z=await new Promise(N=>{(0,E.exec)("ps -F -A -l | grep root",(x,B,O)=>{N(B)})});this._foundRootPorts=i(M,z,this._foundRootPorts),U=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${U.join(", ")}`)}return K.then(z=>U?z.concat(U):z)}};l=Ve([$e(0,L.IExtHostRpcService),$e(1,C.IExtHostInitDataService),$e(2,y.ILogService)],l),e.ExtHostTunnelService=l}),define(me[265],ge([0,1,18,23,21,16,3,6,103,229,66]),function(J,e,m,L,k,C,R,E,S,A,n){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function c(w,T){try{return JSON.stringify(w,T)}catch(v){return"null"}}const h="$$ref$$",d={[h]:-1};class g{constructor(T,v){this.jsonString=T,this.referencedBuffers=v}}function y(w,T=null,v=!1){const F=[];return{jsonString:(v?c:JSON.stringify)(w,(G,K)=>{if(typeof K=="undefined")return d;if(typeof K=="object"){if(K instanceof L.VSBuffer){const U=F.push(K)-1;return{[h]:U}}if(T)return T(G,K)}return K}),referencedBuffers:F}}e.stringifyJsonWithBufferRefs=y;function I(w,T,v){return JSON.parse(w,(F,M)=>{if(M){const G=M[h];if(typeof G=="number")return T[G];if(v&&M.$mid===1)return v.transformIncoming(M)}return M})}e.parseJsonAndRestoreBufferRefs=I;function _(w,T){return JSON.stringify(w,T)}function s(w){return w?(T,v)=>v&&v.$mid===1?w.transformOutgoing(v):v:null}var o;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(o=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},a=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class i extends E.Disposable{constructor(T,v=null,F=null){super();this[P]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=T,this._logger=v,this._uriTransformer=F,this._uriReplacer=s(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let M=0,G=n.ProxyIdentifier.count;M<G;M++)this._locals[M]=null,this._proxies[M]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new m.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(M=>this._receiveOneMessage(M))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(T=>{this._pendingRPCReplies[T].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(T){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(T){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(T){this._responsiveState!==T&&(this._responsiveState=T,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(T){return this._uriTransformer?(0,S.transformIncomingURIs)(T,this._uriTransformer):T}getProxy(T){const{nid:v,sid:F}=T;return this._proxies[v]||(this._proxies[v]=this._createProxy(v,F)),this._proxies[v]}_createProxy(T,v){let F={get:(M,G)=>(typeof G=="string"&&!M[G]&&G.charCodeAt(0)===36&&(M[G]=(...K)=>this._remoteCall(T,G,K)),G===r?v:M[G])};return new Proxy(Object.create(null),F)}set(T,v){return this._locals[T.nid]=v,v}assertRegistered(T){for(let v=0,F=T.length;v<F;v++){const M=T[v];if(!this._locals[M.nid])throw new Error(`Missing actor ${M.sid} (isMain: ${M.isMain})`)}}_receiveOneMessage(T){if(this._isDisposed)return;const v=T.byteLength,F=l.read(T,0),M=F.readUInt8(),G=F.readUInt32();switch(M){case 1:case 2:{let{rpcId:K,method:U,args:z}=f.deserializeRequestJSONArgs(F);this._uriTransformer&&(z=(0,S.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(v,G,K,U,z,M===2);break}case 3:case 4:{let{rpcId:K,method:U,args:z}=f.deserializeRequestMixedArgs(F);this._uriTransformer&&(z=(0,S.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(v,G,K,U,z,M===4);break}case 5:{this._logger&&this._logger.logIncoming(v,G,0,"ack"),this._onDidReceiveAcknowledge(G);break}case 6:{this._receiveCancel(v,G);break}case 7:{this._receiveReply(v,G,void 0);break}case 9:{let K=f.deserializeReplyOKJSON(F);this._uriTransformer&&(K=(0,S.transformIncomingURIs)(K,this._uriTransformer)),this._receiveReply(v,G,K);break}case 10:{const K=f.deserializeReplyOKJSONWithBuffers(F,this._uriTransformer);this._receiveReply(v,G,K);break}case 8:{let K=f.deserializeReplyOKVSBuffer(F);this._receiveReply(v,G,K);break}case 11:{let K=f.deserializeReplyErrError(F);this._uriTransformer&&(K=(0,S.transformIncomingURIs)(K,this._uriTransformer)),this._receiveReplyErr(v,G,K);break}case 12:{this._receiveReplyErr(v,G,void 0);break}default:console.error("received unexpected message"),console.error(T)}}_receiveRequest(T,v,F,M,G,K){this._logger&&this._logger.logIncoming(T,v,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(F)}.${M}(`,G);const U=String(v);let z,N;if(K){const B=new k.CancellationTokenSource;G.push(B.token),z=this._invokeHandler(F,M,G),N=()=>B.cancel()}else z=this._invokeHandler(F,M,G),N=t;this._cancelInvokedHandlers[U]=N;const x=f.serializeAcknowledged(v);this._logger&&this._logger.logOutgoing(x.byteLength,v,1,"ack"),this._protocol.send(x),z.then(B=>{delete this._cancelInvokedHandlers[U];const O=f.serializeReplyOK(v,B,this._uriReplacer);this._logger&&this._logger.logOutgoing(O.byteLength,v,1,"reply:",B),this._protocol.send(O)},B=>{delete this._cancelInvokedHandlers[U];const O=f.serializeReplyErr(v,B);this._logger&&this._logger.logOutgoing(O.byteLength,v,1,"replyErr:",B),this._protocol.send(O)})}_receiveCancel(T,v){this._logger&&this._logger.logIncoming(T,v,1,"receiveCancel");const F=String(v);this._cancelInvokedHandlers[F]&&this._cancelInvokedHandlers[F]()}_receiveReply(T,v,F){this._logger&&this._logger.logIncoming(T,v,0,"receiveReply:",F);const M=String(v);if(!this._pendingRPCReplies.hasOwnProperty(M))return;const G=this._pendingRPCReplies[M];delete this._pendingRPCReplies[M],G.resolveOk(F)}_receiveReplyErr(T,v,F){this._logger&&this._logger.logIncoming(T,v,0,"receiveReplyErr:",F);const M=String(v);if(!this._pendingRPCReplies.hasOwnProperty(M))return;const G=this._pendingRPCReplies[M];delete this._pendingRPCReplies[M];let K;F&&(F.$isError?(K=new Error,K.name=F.name,K.message=F.message,K.stack=F.stack):K=F),G.resolveErr(K)}_invokeHandler(T,v,F){try{return Promise.resolve(this._doInvokeHandler(T,v,F))}catch(M){return Promise.reject(M)}}_doInvokeHandler(T,v,F){const M=this._locals[T];if(!M)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(T));let G=M[v];if(typeof G!="function")throw new Error("Unknown method "+v+" on actor "+(0,n.getStringIdentifierForProxy)(T));return G.apply(M,F)}_remoteCall(T,v,F){if(this._isDisposed)return Promise.reject(C.canceled());let M=null;if(F.length>0&&k.CancellationToken.isCancellationToken(F[F.length-1])&&(M=F.pop()),M&&M.isCancellationRequested)return Promise.reject(C.canceled());const G=f.serializeRequestArguments(F,this._uriReplacer),K=++this._lastMessageId,U=String(K),z=new A.LazyPromise;M&&M.onCancellationRequested(()=>{const x=f.serializeCancel(K);this._logger&&this._logger.logOutgoing(x.byteLength,K,0,"cancel"),this._protocol.send(f.serializeCancel(K))}),this._pendingRPCReplies[U]=z,this._onWillSendRequest(K);const N=f.serializeRequest(K,T,v,G,!!M);return this._logger&&this._logger.logOutgoing(N.byteLength,K,0,`request: ${(0,n.getStringIdentifierForProxy)(T)}.${v}(`,F),this._protocol.send(N),z}}e.RPCProtocol=i,P=a,i.UNRESPONSIVE_TIME=3*1e3;class l{constructor(T,v){this._buff=T,this._offset=v}static alloc(T,v,F){let M=new l(L.VSBuffer.alloc(F+1+4),0);return M.writeUInt8(T),M.writeUInt32(v),M}static read(T,v){return new l(T,v)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(T){this._buff.writeUInt8(T,this._offset),this._offset+=1}readUInt8(){const T=this._buff.readUInt8(this._offset);return this._offset+=1,T}writeUInt32(T){this._buff.writeUInt32BE(T,this._offset),this._offset+=4}readUInt32(){const T=this._buff.readUInt32BE(this._offset);return this._offset+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this._buff.writeUInt8(T.byteLength,this._offset),this._offset+=1,this._buff.set(T,this._offset),this._offset+=T.byteLength}readShortString(){const T=this._buff.readUInt8(this._offset);this._offset+=1;const F=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,F}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readLongString(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,F}writeBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readVSBuffer(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const v=this._buff.slice(this._offset,this._offset+T);return this._offset+=T,v}static sizeMixedArray(T){let v=0;v+=1;for(let F=0,M=T.length;F<M;F++){const G=T[F];switch(v+=1,G.type){case 1:v+=this.sizeLongString(G.value);break;case 2:v+=this.sizeVSBuffer(G.value);break;case 3:v+=this.sizeUInt32,v+=this.sizeLongString(G.value);for(let K=0;K<G.buffers.length;++K)v+=this.sizeVSBuffer(G.buffers[K]);break;case 4:break}}return v}writeMixedArray(T){this._buff.writeUInt8(T.length,this._offset),this._offset+=1;for(let v=0,F=T.length;v<F;v++){const M=T[v];switch(M.type){case 1:this.writeUInt8(1),this.writeLongString(M.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(M.value);break;case 3:this.writeUInt8(3),this.writeUInt32(M.buffers.length),this.writeLongString(M.value);for(let G=0;G<M.buffers.length;++G)this.writeBuffer(M.buffers[G]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this._buff.readUInt8(this._offset);this._offset+=1;let v=new Array(T);for(let F=0;F<T;F++)switch(this.readUInt8()){case 1:v[F]=this.readLongString();break;case 2:v[F]=this.readVSBuffer();break;case 3:const G=this.readUInt32(),K=this.readLongString(),U=[];for(let z=0;z<G;++z)U.push(this.readVSBuffer());v[F]=new n.SerializableObjectWithBuffers(I(K,U,null));break;case 4:v[F]=void 0;break}return v}}l.sizeUInt32=4;var u;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(u||(u={}));class f{static _useMixedArgSerialization(T){for(let v=0,F=T.length;v<F;v++)if(T[v]instanceof L.VSBuffer||T[v]instanceof n.SerializableObjectWithBuffers||typeof T[v]=="undefined")return!0;return!1}static serializeRequestArguments(T,v){if(this._useMixedArgSerialization(T)){const F=[];for(let M=0,G=T.length;M<G;M++){const K=T[M];if(K instanceof L.VSBuffer)F[M]={type:2,value:K};else if(typeof K=="undefined")F[M]={type:4};else if(K instanceof n.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:z}=y(K.value,v);F[M]={type:3,value:L.VSBuffer.fromString(U),buffers:z}}else F[M]={type:1,value:L.VSBuffer.fromString(_(K,v))}}return{type:1,args:F}}return{type:0,args:_(T,v)}}static serializeRequest(T,v,F,M,G){switch(M.type){case 0:return this._requestJSONArgs(T,v,F,M.args,G);case 1:return this._requestMixedArgs(T,v,F,M.args,G)}}static _requestJSONArgs(T,v,F,M,G){const K=L.VSBuffer.fromString(F),U=L.VSBuffer.fromString(M);let z=0;z+=l.sizeUInt8(),z+=l.sizeShortString(K),z+=l.sizeLongString(U);let N=l.alloc(G?2:1,T,z);return N.writeUInt8(v),N.writeShortString(K),N.writeLongString(U),N.buffer}static deserializeRequestJSONArgs(T){const v=T.readUInt8(),F=T.readShortString(),M=T.readLongString();return{rpcId:v,method:F,args:JSON.parse(M)}}static _requestMixedArgs(T,v,F,M,G){const K=L.VSBuffer.fromString(F);let U=0;U+=l.sizeUInt8(),U+=l.sizeShortString(K),U+=l.sizeMixedArray(M);let z=l.alloc(G?4:3,T,U);return z.writeUInt8(v),z.writeShortString(K),z.writeMixedArray(M),z.buffer}static deserializeRequestMixedArgs(T){const v=T.readUInt8(),F=T.readShortString(),M=T.readMixedArray(),G=new Array(M.length);for(let K=0,U=M.length;K<U;K++){const z=M[K];typeof z=="string"?G[K]=JSON.parse(z):G[K]=z}return{rpcId:v,method:F,args:G}}static serializeAcknowledged(T){return l.alloc(5,T,0).buffer}static serializeCancel(T){return l.alloc(6,T,0).buffer}static serializeReplyOK(T,v,F){if(typeof v=="undefined")return this._serializeReplyOKEmpty(T);if(v instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(T,v);if(v instanceof n.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:G}=y(v.value,F,!0);return this._serializeReplyOKJSONWithBuffers(T,M,G)}else return this._serializeReplyOKJSON(T,c(v,F))}static _serializeReplyOKEmpty(T){return l.alloc(7,T,0).buffer}static _serializeReplyOKVSBuffer(T,v){let F=0;F+=l.sizeVSBuffer(v);let M=l.alloc(8,T,F);return M.writeVSBuffer(v),M.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static _serializeReplyOKJSON(T,v){const F=L.VSBuffer.fromString(v);let M=0;M+=l.sizeLongString(F);let G=l.alloc(9,T,M);return G.writeLongString(F),G.buffer}static _serializeReplyOKJSONWithBuffers(T,v,F){const M=L.VSBuffer.fromString(v);let G=0;G+=l.sizeUInt32,G+=l.sizeLongString(M);for(const U of F)G+=l.sizeVSBuffer(U);let K=l.alloc(10,T,G);K.writeUInt32(F.length),K.writeLongString(M);for(const U of F)K.writeBuffer(U);return K.buffer}static deserializeReplyOKJSON(T){const v=T.readLongString();return JSON.parse(v)}static deserializeReplyOKJSONWithBuffers(T,v){const F=T.readUInt32(),M=T.readLongString(),G=[];for(let K=0;K<F;++K)G.push(T.readVSBuffer());return new n.SerializableObjectWithBuffers(I(M,G,v))}static serializeReplyErr(T,v){return v?this._serializeReplyErrEror(T,v):this._serializeReplyErrEmpty(T)}static _serializeReplyErrEror(T,v){const F=L.VSBuffer.fromString(c(C.transformErrorForSerialization(v),null));let M=0;M+=l.sizeLongString(F);let G=l.alloc(11,T,M);return G.writeLongString(F),G.buffer}static deserializeReplyErrError(T){const v=T.readLongString();return JSON.parse(v)}static _serializeReplyErrEmpty(T){return l.alloc(12,T,0).buffer}}var b;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var D;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(D||(D={}))}),define(me[266],ge([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,m.createDecorator)("remoteAgentService")}),define(me[267],ge([0,1,10,8,11,2,4,86,43,224,266]),function(J,e,m,L,k,C,R,E,S,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,R.createDecorator)("pathService");let P=class Wn{constructor(h,d,g,y){this.localUserHome=h,this.remoteAgentService=d,this.environmentService=g,this.contextService=y,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||k.OS)(),this.resolveUserHome=(async()=>{const I=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=I?.userHome||h})()}get defaultUriScheme(){return Wn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,d){if(h.remoteAuthority)return m.Schemas.vscodeRemote;const g=(0,E.getVirtualWorkspaceScheme)(d.getWorkspace());if(g)return g;const y=d.getWorkspace().folders[0];if(y)return y.uri.scheme;const I=d.getWorkspace().configuration;return I?I.scheme:m.Schemas.file}async userHome(h){return h?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?L.win32:L.posix)}async fileURI(h){let d="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const y=h.indexOf("/",2);y===-1?(d=h.substring(2),h="/"):(d=h.substring(2,y),h=h.substring(y)||"/")}return C.URI.from({scheme:m.Schemas.file,authority:d,path:h,query:"",fragment:""})}};P=Ve([$e(1,n.IRemoteAgentService),$e(2,A.IWorkbenchEnvironmentService),$e(3,S.IWorkspaceContextService)],P),e.AbstractPathService=P}),define(me[71],ge([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class m{constructor(R,E){this.line=R,this.character=E}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,E){return new m(0,0)}with(R){return new m(0,0)}}e.Position=m;class L{constructor(R,E,S,A){this.isEmpty=!1,this.isSingleLine=!1,this.start=new m(R,E),this.end=new m(S,A)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new L(0,0,0,0)}with(R){return new L(0,0,0,0)}}e.Range=L;var k;(function(C){C[C.Information=1]="Information",C[C.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(me[31],ge([0,1,17,30,25,29,9,4,8,16,71,13]),function(J,e,m,L,k,C,R,E,S,A,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const c="\u27EA ",h=" characters skipped \u27EB",d=(c.length+h.length+5)*2;e.ISearchService=(0,E.createDecorator)("searchService");var g;(function(x){x[x.file=0]="file",x[x.text=1]="text"})(g=e.SearchProviderType||(e.SearchProviderType={}));var y;(function(x){x[x.File=1]="File",x[x.Text=2]="Text"})(y=e.QueryType||(e.QueryType={}));function I(x){return!!x.preview}e.resultIsMatch=I;function _(x){return!!x.resource}e.isFileMatch=_;function s(x){return!!x.message}e.isProgressMessage=s;var o;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(o=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(B){this.resource=B,this.results=[]}}e.FileMatch=p;class t{constructor(B,O,H){this.ranges=O;const W=Array.isArray(O)?O:[O];if(H&&H.matchLines===1&&a(W)){B=(0,R.getNLines)(B,H.matchLines);let Q="",Y=0,he=0;const _e=Math.floor(H.charsPerLine/5),Se=[];for(const Re of W){const xe=Math.max(Re.startColumn-_e,0),Ue=Re.startColumn+H.charsPerLine;if(xe>he+_e+d){const je=c+(xe-he)+h;Q+=je+B.slice(xe,Ue),Y+=xe-(he+je.length)}else Q+=B.slice(he,Ue);Se.push(new i(0,Re.startColumn-Y,Re.endColumn-Y)),he=Ue}this.preview={text:Q,matches:Array.isArray(this.ranges)?Se:Se[0]}}else{const Q=Array.isArray(O)?O[0].startLineNumber:O.startLineNumber;this.preview={text:B,matches:(0,m.mapArrayOrNot)(O,Y=>new r(Y.startLineNumber-Q,Y.startColumn,Y.endLineNumber-Q,Y.endColumn))}}}}e.TextSearchMatch=t;function a(x){const B=x[0].startLineNumber;for(const O of x)if(O.startLineNumber!==B||O.endLineNumber!==B)return!1;return!0}class r{constructor(B,O,H,W){this.startLineNumber=B,this.startColumn=O,this.endLineNumber=H,this.endColumn=W}}e.SearchRange=r;class i extends r{constructor(B,O,H){super(B,O,B,H)}}e.OneLineRange=i;var l;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(l=e.SearchSortOrder||(e.SearchSortOrder={}));function u(x,B=!0){const O=x&&x.files&&x.files.exclude,H=B&&x&&x.search&&x.search.exclude;if(!O&&!H)return;if(!O||!H)return O||H;let W=Object.create(null);return W=k.mixin(W,k.deepClone(O)),W=k.mixin(W,k.deepClone(H),!0),W}e.getExcludes=u;function f(x,B){return x.excludePattern&&L.match(x.excludePattern,B)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&L.match(x.includePattern,B)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(O=>{const H=O.folder.fsPath;if(C.isEqualOrParent(B,H)){const W=S.relative(H,B);return!O.includePattern||!!L.match(O.includePattern,W)}else return!1}):!1:!0}e.pathIncludedInQuery=f;var b;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class D extends Error{constructor(B,O){super(B);this.code=O}}e.SearchError=D;function w(x){const B=x.message;if((0,A.isPromiseCanceledError)(x))return new D(B,b.canceled);try{const O=JSON.parse(B);return new D(O.message,O.code)}catch(O){return new D(B,b.other)}}e.deserializeSearchError=w;function T(x){const B={message:x.message,code:x.code};return new Error(JSON.stringify(B))}e.serializeSearchError=T;function v(x){return x.type==="error"?!0:x.type==="success"}e.isSerializedSearchComplete=v;function F(x){return x.type==="success"}e.isSerializedSearchSuccess=F;function M(x){return!!x.path}e.isSerializedFileMatch=M;function G(x,B){const O=x.searchPath?x.searchPath:x.relativePath;return(0,R.fuzzyContains)(O,B)}e.isFilePatternMatch=G;class K{constructor(B){this.path=B,this.results=[]}addMatch(B){this.results.push(B)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=K;function U(x,B){const O={...x||{},...B||{}};return Object.keys(O).filter(H=>{const W=O[H];return typeof W=="boolean"&&W})}e.resolvePatternsForProvider=U;class z{constructor(B,O){this._parsedIncludeExpression=null,this._excludeExpression={...B.excludePattern||{},...O.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let H=B.includePattern;O.includePattern&&(H?H={...H,...O.includePattern}:H=O.includePattern),H&&(this._parsedIncludeExpression=L.parse(H))}includedInQuerySync(B,O,H){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(B,O,H)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(B,O,H))}includedInQuery(B,O,H){const W=this._parsedExcludeExpression(B,O,H),Q=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(B,O,H):!0;return(0,P.isPromise)(W)?W.then(Y=>Y?!1:Q()):Q()}hasSiblingExcludeClauses(){return N(this._excludeExpression)}}e.QueryGlobTester=z;function N(x){for(const B in x)if(typeof x[B]!="boolean")return!0;return!1}}),define(me[36],ge([0,1,17,18,21,3,24,10,77,22,9,13,2,170,4,12,190,43,52,27,14,7,31,5]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g,y,I,_,s,o,p,t,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(T,v,F){return new A.ExtUri(M=>f(M,F)).isEqual(T,v)}function i(T,v,F){return r(T.uri,v.uri,F)?0:(0,n.compare)(T.uri.toString(),v.uri.toString())}function l(T,v,F){return T.index!==v.index?T.index<v.index?-1:1:r(T.uri,v.uri,F)?(0,n.compare)(T.name,v.name):(0,n.compare)(T.uri.toString(),v.uri.toString())}function u(T,v,F,M){const G=T.slice(0).sort((U,z)=>F(U,z,M)),K=v.slice(0).sort((U,z)=>F(U,z,M));return(0,m.delta)(G,K,(U,z)=>F(U,z,M))}function f(T,v){const F=v.getCapabilities(T.scheme);return!(F&&F&1024)}class b extends I.Workspace{constructor(v,F,M,G,K,U){super(v,M.map(z=>new I.WorkspaceFolder(z)),G,U);this._name=F,this._isUntitled=K,this._workspaceFolders=[],this._structure=R.TernarySearchTree.forUris(U),M.forEach(z=>{this._workspaceFolders.push(z),this._structure.set(z.uri,z)})}static toExtHostWorkspace(v,F,M,G){if(!v)return{workspace:null,added:[],removed:[]};const{id:K,name:U,folders:z,configuration:N,isUntitled:x}=v,B=[],O=F;F?z.forEach((Y,he)=>{const _e=c.URI.revive(Y.uri),Se=b._findFolder(M||F,_e,G);Se?(Se.name=Y.name,Se.index=Y.index,B.push(Se)):B.push({uri:_e,name:Y.name,index:he})}):B.push(...z.map(({uri:Y,name:he,index:_e})=>({uri:c.URI.revive(Y),name:he,index:_e}))),B.sort((Y,he)=>Y.index<he.index?-1:1);const H=new b(K,U,B,N?c.URI.revive(N):null,!!x,Y=>f(Y,G)),{added:W,removed:Q}=u(O?O.workspaceFolders:[],H.workspaceFolders,i,G);return{workspace:H,added:W,removed:Q}}static _findFolder(v,F,M){for(let G=0;G<v.folders.length;G++){const K=v.workspaceFolders[G];if(r(K.uri,F,M))return K}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(v,F){return F&&this._structure.get(v)&&(v=(0,A.dirname)(v)),this._structure.findSubstr(v)}resolveWorkspaceFolder(v){return this._structure.get(v)}}let D=class{constructor(v,F,M,G){this._onDidChangeWorkspace=new C.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new C.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=G,this._extHostFileSystemInfo=M,this._requestIdProvider=new S.Counter,this._barrier=new L.Barrier,this._proxy=v.getProxy(a.MainContext.MainThreadWorkspace),this._messageService=v.getProxy(a.MainContext.MainThreadMessageService);const K=F.workspace;this._confirmedWorkspace=K?new b(K.id,K.name,[],K.configuration?c.URI.revive(K.configuration):null,!!K.isUntitled,U=>f(U,M)):void 0}$initializeWorkspace(v,F){this._trusted=F,this.$acceptWorkspaceData(v),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:E.Schemas.untitled,path:(0,A.basename)((0,A.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(v,F,M,...G){const K=[];if(Array.isArray(G)&&G.forEach(B=>{c.URI.isUri(B.uri)&&!K.some(O=>r(O.uri,B.uri,this._extHostFileSystemInfo))&&K.push({uri:B.uri,name:B.name||(0,A.basenameOrAuthority)(B.uri)})}),this._unconfirmedWorkspace||[F,M].some(B=>typeof B!="number"||B<0)||M===0&&K.length===0)return!1;const U=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(F+M>U.length)return!1;const z=U.slice(0);z.splice(F,M,...K.map(B=>({uri:B.uri,name:B.name||(0,A.basenameOrAuthority)(B.uri),index:void 0})));for(let B=0;B<z.length;B++){const O=z[B];if(z.some((H,W)=>W!==B&&r(O.uri,H.uri,this._extHostFileSystemInfo)))return!1}z.forEach((B,O)=>B.index=O);const{added:N,removed:x}=u(U,z,l,this._extHostFileSystemInfo);if(N.length===0&&x.length===0)return!1;if(this._proxy){const B=v.displayName||v.name;this._proxy.$updateWorkspaceFolders(B,F,M,K).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(y.Severity.Error,(0,h.localize)(0,null,B,O.toString()),{extension:v},[])})}return this.trySetWorkspaceFolders(z),!0}getWorkspaceFolder(v,F){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(v,F)}async getWorkspaceFolder2(v,F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(v,F)}async resolveWorkspaceFolder(v){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(v)}getPath(){if(!this._actualWorkspace)return;const{folders:v}=this._actualWorkspace;if(v.length!==0)return v[0].uri.fsPath}getRelativePath(v,F){let M,G="";if(typeof v=="string"?(M=c.URI.file(v),G=v):typeof v!="undefined"&&(M=v,G=v.fsPath),!M)return G;const K=this.getWorkspaceFolder(M,!0);if(!K)return G;typeof F=="undefined"&&this._actualWorkspace&&(F=this._actualWorkspace.folders.length>1);let U=(0,A.relativePath)(K.uri,M);return F&&K.name&&(U=`${K.name}/${U}`),U}trySetWorkspaceFolders(v){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:v,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(v){const{workspace:F,added:M,removed:G}=b.toExtHostWorkspace(v,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=F||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:M,removed:G}))}findFiles(v,F,M,G,K=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${G.value}, entryPoint: findFiles`);let U;if(F===null?U=!1:F&&(typeof F=="string"?U=F:U=F.pattern),K&&K.isCancellationRequested)return Promise.resolve([]);const{includePattern:z,folder:N}=w(v);return this._proxy.$startFileSearch((0,P.withUndefinedAsNull)(z),(0,P.withUndefinedAsNull)(N),(0,P.withUndefinedAsNull)(U),(0,P.withUndefinedAsNull)(M),K).then(x=>Array.isArray(x)?x.map(B=>c.URI.revive(B)):[])}async findTextInFiles(v,F,M,G,K=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${G.value}, entryPoint: findTextInFiles`);const U=this._requestIdProvider.getNext(),z=typeof F.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:N,folder:x}=w(F.include),B=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,O={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:z,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:N,excludePattern:B},H=!1;if(this._activeSearchCallbacks[U]=W=>{if(H)return;const Q=c.URI.revive(W.resource);W.results.forEach(Y=>{(0,t.resultIsMatch)(Y)?M({uri:Q,preview:{text:Y.preview.text,matches:(0,m.mapArrayOrNot)(Y.preview.matches,he=>new p.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))},ranges:(0,m.mapArrayOrNot)(Y.ranges,he=>new p.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))}):M({uri:Q,text:Y.text,lineNumber:Y.lineNumber})})},K.isCancellationRequested)return{};try{const W=await this._proxy.$startTextSearch(v,(0,P.withUndefinedAsNull)(x),O,U,K);return delete this._activeSearchCallbacks[U],W||{}}catch(W){throw delete this._activeSearchCallbacks[U],W}}$handleTextSearchResult(v,F){this._activeSearchCallbacks[F]&&this._activeSearchCallbacks[F](v)}saveAll(v){return this._proxy.$saveAll(v)}resolveProxy(v){return this._proxy.$resolveProxy(v)}get trusted(){return this._trusted}requestWorkspaceTrust(v){return this._proxy.$requestWorkspaceTrust(v)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};D=Ve([$e(0,o.IExtHostRpcService),$e(1,s.IExtHostInitDataService),$e(2,_.IExtHostFileSystemInfo),$e(3,g.ILogService)],D),e.ExtHostWorkspace=D,e.IExtHostWorkspace=(0,d.createDecorator)("IExtHostWorkspace");function w(T){let v,F;return T&&(typeof T=="string"?v=T:(v=T.pattern,F=T.baseFolder||c.URI.file(T.base))),{includePattern:v,folder:F}}}),define(me[37],ge([0,1,25,3,36,5,7,193,85,13,18,4,14,12,2]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function g(a,r){if(r){const i=r.split(".");let l=a;for(let u=0;l&&u<i.length;u++)l=l[i[u]];return l}}function y(a){return a instanceof d.URI}function I(a){return a&&a.uri instanceof d.URI&&a.languageId&&typeof a.languageId=="string"}function _(a){return a&&!a.uri&&a.languageId&&typeof a.languageId=="string"}function s(a){return a&&a.uri instanceof d.URI&&(!a.name||typeof a.name=="string")&&(!a.index||typeof a.index=="number")}function o(a){if(y(a))return{resource:a};if(I(a))return{resource:a.uri,overrideIdentifier:a.languageId};if(_(a))return{overrideIdentifier:a.languageId};if(s(a))return{resource:a.uri};if(a===null)return{resource:null}}let p=class{constructor(r,i,l){this._proxy=r.getProxy(C.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=l,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(r,i))}};p=Ve([$e(0,c.IExtHostRpcService),$e(1,k.IExtHostWorkspace),$e(2,h.ILogService)],p),e.ExtHostConfiguration=p;class t{constructor(r,i,l,u){this._onDidChangeConfiguration=new L.Emitter,this._proxy=r,this._logService=u,this._extHostWorkspace=i,this._configuration=E.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=E.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,l))}getConfiguration(r,i,l){const u=o(i)||{},f=this._toReadonlyValue(r?g(this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,u,l?.identifier);function b(w){if(w==null)return null;if(typeof w=="boolean")return w?1:4;switch(w){case R.ConfigurationTarget.Global:return 1;case R.ConfigurationTarget.Workspace:return 4;case R.ConfigurationTarget.WorkspaceFolder:return 5}}const D={has(w){return typeof g(f,w)!="undefined"},get:(w,T)=>{this._validateConfigurationAccess(r?`${r}.${w}`:w,u,l?.identifier);let v=g(f,w);if(typeof v=="undefined")v=T;else{let F;const M=(G,K)=>{let U;const z=()=>{F=F||(0,m.deepClone)(f),U=U||g(F,K)};return(0,A.isObject)(G)?new Proxy(G,{get:(N,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return z(),()=>U;if(F)return U=U||g(F,K),U[x];const B=N[x];return typeof x=="string"?M(B,`${K}.${x}`):B},set:(N,x,B)=>(z(),U&&(U[x]=B),!0),deleteProperty:(N,x)=>(z(),U&&delete U[x],!0),defineProperty:(N,x,B)=>(z(),U&&Object.defineProperty(U,x,B),!0)}):G};v=M(v,w)}return v},update:(w,T,v,F)=>{w=r?`${r}.${w}`:w;const M=b(v);return T!==void 0?this._proxy.$updateConfigurationOption(M,w,T,u,F):this._proxy.$removeConfigurationOption(M,w,u,F)},inspect:w=>{w=r?`${r}.${w}`:w;const T=(0,m.deepClone)(this._configuration.inspect(w,u,this._extHostWorkspace.workspace));if(T)return{key:w,defaultValue:T.default?.value,globalValue:T.user?.value,workspaceValue:T.workspace?.value,workspaceFolderValue:T.workspaceFolder?.value,defaultLanguageValue:T.default?.override,globalLanguageValue:T.user?.override,workspaceLanguageValue:T.workspace?.override,workspaceFolderLanguageValue:T.workspaceFolder?.override,languageIds:T.overrideIdentifiers}}};return typeof f=="object"&&(0,m.mixin)(D,f,!1),Object.freeze(D)}_toReadonlyValue(r){const i=l=>(0,A.isObject)(l)?new Proxy(l,{get:(u,f)=>i(u[f]),set:(u,f,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(f)}' of object`)},deleteProperty:(u,f)=>{throw new Error(`TypeError: Cannot delete read only property '${String(f)}' of object`)},defineProperty:(u,f)=>{throw new Error(`TypeError: Cannot define property '${String(f)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return i(r)}_validateConfigurationAccess(r,i,l){const u=S.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),f=l?`[${l.value}] `:"";if(u===4){typeof i?.resource=="undefined"&&this._logService.warn(`${f}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){i?.resource&&this._logService.warn(`${f}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const l=new E.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(u,f)=>l.affectsConfiguration(u,o(f))})}_toMap(r){return r.reduce((i,l)=>(i.set(l[0],l[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,m):k?k.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[72],ge([0,1,2,18,3,5,7,36,45,37,21,33,14,27,4,10,11,12,67,214,16]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g,y,I,_,s,o){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(K){function U(N){if(N!=null)return N}K.from=U;function z(N){if(N!=null)return N}K.to=z})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var a;(function(K){function U(N){if(N!=null)return N}K.from=U;function z(N){if(N!=null)return N}K.to=z})(a=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(K){function U(N){if(N!=null)return N}K.from=U;function z(N){if(N!=null)return N}K.to=z})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(K){function U(x){if(x){const B=x;return B&&!!B.process}else return!1}K.is=U;function z(x){if(x==null)return;const B={process:x.process,args:x.args};return x.options&&(B.options=r.from(x.options)),B}K.from=z;function N(x){if(x!=null)return new R.ProcessExecution(x.process,x.args,x.options)}K.to=N})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var l;(function(K){function U(N){if(N!=null)return N}K.from=U;function z(N){if(N!=null)return N}K.to=z})(l=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var u;(function(K){function U(x){if(x){const B=x;return B&&(!!B.commandLine||!!B.command)}else return!1}K.is=U;function z(x){if(x==null)return;const B={};return x.commandLine!==void 0?B.commandLine=x.commandLine:(B.command=x.command,B.args=x.args),x.options&&(B.options=l.from(x.options)),B}K.from=z;function N(x){if(!(x==null||x.command===void 0&&x.commandLine===void 0))return x.commandLine?new R.ShellExecution(x.commandLine,x.options):new R.ShellExecution(x.command,x.args?x.args:[],x.options)}K.to=N})(u=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var f;(function(K){function U(x){if(x){let B=x;return B&&B.customExecution==="customExecution"}else return!1}K.is=U;function z(x){return{customExecution:"customExecution"}}K.from=z;function N(x,B){return B.get(x)}K.to=N})(f=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var b;(function(K){function U(z,N){let x;return z.scope!==void 0&&typeof z.scope!="number"?x=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===R.TaskScope.Workspace&&N&&N.workspaceFile?x=N.workspaceFile:x=s.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:x}}K.from=U})(b=e.TaskHandleDTO||(e.TaskHandleDTO={}));var D;(function(K){function U(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}K.from=U})(D=e.TaskGroupDTO||(e.TaskGroupDTO={}));var w;(function(K){function U(x,B){if(x==null)return[];const O=[];for(let H of x){const W=z(H,B);W&&O.push(W)}return O}K.fromMany=U;function z(x,B){if(x==null)return;let O;x.execution instanceof R.ProcessExecution?O=i.from(x.execution):x.execution instanceof R.ShellExecution?O=u.from(x.execution):x.execution&&x.execution instanceof R.CustomExecution&&(O=f.from(x.execution));const H=t.from(x.definition);let W;return x.scope?typeof x.scope=="number"?W=x.scope:W=x.scope.uri:W=R.TaskScope.Workspace,!H||!W?void 0:{_id:x._id,definition:H,name:x.name,source:{extensionId:B.identifier.value,label:x.source,scope:W},execution:O,isBackground:x.isBackground,group:D.from(x.group),presentationOptions:a.from(x.presentationOptions),problemMatchers:x.problemMatchers,hasDefinedMatchers:x.hasDefinedMatchers,runOptions:x.runOptions?x.runOptions:{reevaluateOnRerun:!0},detail:x.detail}}K.from=z;async function N(x,B,O){if(x==null)return;let H;i.is(x.execution)?H=i.to(x.execution):u.is(x.execution)?H=u.to(x.execution):f.is(x.execution)&&(H=f.to(x._id,O));const W=t.to(x.definition);let Q;if(x.source&&(x.source.scope!==void 0?typeof x.source.scope=="number"?Q=x.source.scope:Q=await B.resolveWorkspaceFolder(m.URI.revive(x.source.scope)):Q=R.TaskScope.Workspace),!W||!Q)return;const Y=new R.Task(W,Q,x.name,x.source.label,H,x.problemMatchers);return x.isBackground!==void 0&&(Y.isBackground=x.isBackground),x.group!==void 0&&(Y.group=R.TaskGroup.from(x.group._id),Y.group&&(Y.group=new R.TaskGroup(Y.group.id,Y.group.label),x.group.isDefault&&(Y.group.isDefault=x.group.isDefault))),x.presentationOptions&&(Y.presentationOptions=a.to(x.presentationOptions)),x._id&&(Y._id=x._id),x.detail&&(Y.detail=x.detail),Y}K.to=N})(w=e.TaskDTO||(e.TaskDTO={}));var T;(function(K){function U(N){return N}K.from=U;function z(N){if(!!N)return Object.assign(Object.create(null),N)}K.to=z})(T=e.TaskFilterDTO||(e.TaskFilterDTO={}));class v{constructor(U,z,N){this._id=z,this._task=N,p.set(this,void 0),nt(this,p,U,"f")}get task(){return this._task}terminate(){Oe(this,p,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}p=new WeakMap;var F;(function(K){function U(z){return{id:z._id,task:void 0}}K.from=U})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let M=class{constructor(U,z,N,x,B,O,H,W){this._onDidExecuteTask=new k.Emitter,this._onDidTerminateTask=new k.Emitter,this._onDidTaskProcessStarted=new k.Emitter,this._onDidTaskProcessEnded=new k.Emitter,this._proxy=U.getProxy(C.MainContext.MainThreadTask),this._workspaceProvider=N,this._editorService=x,this._configurationService=B,this._terminalService=O,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=H,this._deprecationService=W,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(U,z,N){if(!N)return new R.Disposable(()=>{});const x=this.nextHandle();return this._handlers.set(x,{type:z,provider:N,extension:U}),this._proxy.$registerTaskProvider(x,z),new R.Disposable(()=>{this._handlers.delete(x),this._proxy.$unregisterTaskProvider(x)})}registerTaskSystem(U,z){this._proxy.$registerTaskSystem(U,z)}fetchTasks(U){return this._proxy.$fetchTasks(T.from(U)).then(async z=>{const N=[];for(let x of z){const B=await w.to(x,this._workspaceProvider,this._providedCustomExecutions2);B&&N.push(B)}return N})}get taskExecutions(){const U=[];return this._taskExecutions.forEach(z=>U.push(z)),U}terminateTask(U){if(!(U instanceof v))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(U._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(U,z,N){const x=this._providedCustomExecutions2.get(U.id);if(x){if(this._activeCustomExecutions2.get(U.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(U.id,x),this._terminalService.attachPtyToTerminal(z,await x.callback(N))}this._lastStartedTask=U.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(U)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(U){const z=await this.getTaskExecution(U);this._taskExecutionPromises.delete(U.id),this._taskExecutions.delete(U.id),this.customExecutionComplete(U),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(U){const z=await this.getTaskExecution(U.id);this._onDidTaskProcessStarted.fire({execution:z,processId:U.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(U){const z=await this.getTaskExecution(U.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:U.exitCode})}$provideTasks(U,z){const N=this._handlers.get(U);if(!N)return Promise.reject(new Error("no handler found"));const x=[],B=(0,L.asPromise)(()=>N.provider.provideTasks(n.CancellationToken.None)).then(O=>this.provideTasksInternal(z,x,N,O));return new Promise(O=>{B.then(H=>{Promise.all(x).then(()=>{O(H)})})})}async $resolveTask(U,z){const N=this._handlers.get(U);if(!N)return Promise.reject(new Error("no handler found"));if(z.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${N.type}].`);const x=await w.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!x)throw new Error("Unexpected: Task cannot be resolved.");const B=await N.provider.resolveTask(x,n.CancellationToken.None);if(!B)return;this.checkDeprecation(B,N);const O=w.from(B,N.extension);if(!O)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==x.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(O.execution)&&await this.addCustomExecution(O,B,!0),await this.resolveTaskInternal(O)}nextHandle(){return this._handleCounter++}async addCustomExecution(U,z,N){const x=await this._proxy.$createTaskId(U);!N&&!this._providedCustomExecutions2.has(x)&&this._notProvidedCustomExecutions.add(x),this._providedCustomExecutions2.set(x,z.execution)}async getTaskExecution(U,z){if(typeof U=="string"){const B=this._taskExecutionPromises.get(U);if(!B)throw new Error("Unexpected: The specified task is missing an execution");return B}let N=this._taskExecutionPromises.get(U.id);if(N)return N;const x=new Promise(async(B,O)=>{const H=z||await w.to(U.task,this._workspaceProvider,this._providedCustomExecutions2);H?B(new v(this,U.id,H)):O("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(U.id,x),x.then(B=>(this._taskExecutions.set(U.id,B),B),B=>Promise.reject(B))}checkDeprecation(U,z){U._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(U){this._activeCustomExecutions2.get(U.id)&&this._activeCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.has(U.id)&&this._lastStartedTask!==U.id&&(this._providedCustomExecutions2.delete(U.id),this._notProvidedCustomExecutions.delete(U.id));let N=this._notProvidedCustomExecutions.values(),x=N.next();for(;!x.done;)!this._activeCustomExecutions2.has(x.value)&&this._lastStartedTask!==x.value&&(this._providedCustomExecutions2.delete(x.value),this._notProvidedCustomExecutions.delete(x.value)),x=N.next()}};M=Ve([$e(0,c.IExtHostRpcService),$e(1,h.IExtHostInitDataService),$e(2,E.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,A.IExtHostConfiguration),$e(5,P.IExtHostTerminalService),$e(6,I.ILogService),$e(7,_.IExtHostApiDeprecationService)],M),e.ExtHostTaskBase=M;let G=class extends M{constructor(U,z,N,x,B,O,H,W){super(U,z,N,x,B,O,H,W);this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:y.PlatformToString(0)})}async executeTask(U,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const N=w.from(z,U);if(N===void 0)throw new Error("Task is not valid");if(f.is(N.execution))await this.addCustomExecution(N,z,!1);else throw new o.NotSupportedError;const x=await this.getTaskExecution(await this._proxy.$getTaskExecution(N),z);return this._proxy.$executeTask(N).catch(B=>{throw new Error(B)}),x}provideTasksInternal(U,z,N,x){const B=[];if(x)for(let O of x){this.checkDeprecation(O,N),(!O.definition||!U[O.definition.type])&&this._logService.warn(`The task [${O.source}, ${O.name}] uses an undefined task type. The task will be ignored in the future.`);const H=w.from(O,N.extension);H&&f.is(H.execution)?(B.push(H),z.push(this.addCustomExecution(H,O,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:B,extension:N.extension}}async resolveTaskInternal(U){if(f.is(U.execution))return U;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(U,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,z,N){}};G=Ve([$e(0,c.IExtHostRpcService),$e(1,h.IExtHostInitDataService),$e(2,E.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,A.IExtHostConfiguration),$e(5,P.IExtHostTerminalService),$e(6,I.ILogService),$e(7,_.IExtHostApiDeprecationService)],G),e.WorkerExtHostTask=G,e.IExtHostTask=(0,d.createDecorator)("IExtHostTask")}),define(me[268],ge([0,1,17,57,30,79,24,10,8,22,9,13,2,146,176,120,43,128,267,31]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g,y,I,_,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let o=class{constructor(b,D,w,T){this.configurationService=b,this.workspaceContextService=D,this.editorGroupsService=w,this.pathService=T}text(b,D,w={}){b=this.getContentPattern(b,w);const T=this.configurationService.getValue(),v=D&&D.some(M=>!this.configurationService.getValue({resource:M}).search.useRipgrep);return{...this.commonQuery(D?.map(y.toWorkspaceFolder),w),type:2,contentPattern:b,previewOptions:w.previewOptions,maxFileSize:w.maxFileSize,usePCRE2:T.search.usePCRE2||v||!1,beforeContext:w.beforeContext,afterContext:w.afterContext,userDisabledExcludesAndIgnoreFiles:w.disregardExcludeSettings&&w.disregardIgnoreFiles}}getContentPattern(b,D){const w=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const T={...b,wordSeparators:w.editor.wordSeparators};return this.isCaseSensitive(b,D)&&(T.isCaseSensitive=!0),this.isMultiline(b)&&(T.isMultiline=!0),T}file(b,D={}){return{...this.commonQuery(b,D),type:1,filePattern:D.filePattern?D.filePattern.trim():D.filePattern,exists:D.exists,sortByScore:D.sortByScore,cacheKey:D.cacheKey}}handleIncludeExclude(b,D){return b?(b=Array.isArray(b)?b.map(i):i(b),D?this.parseSearchPaths(b):{pattern:t(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],D={}){const w=this.handleIncludeExclude(D.includePattern,D.expandPatterns),T=this.handleIncludeExclude(D.excludePattern,D.expandPatterns),v=b.length>1,F=(w.searchPaths&&w.searchPaths.length?w.searchPaths.map(K=>this.getFolderQueryForSearchPath(K,D,T)):b.map(K=>this.getFolderQueryForRoot(K,D,T,v))).filter(K=>!!K),M={_reason:D._reason,folderQueries:F,usingSearchPaths:!!(w.searchPaths&&w.searchPaths.length),extraFileResources:D.extraFileResources,excludePattern:T.pattern,includePattern:w.pattern,onlyOpenEditors:D.onlyOpenEditors,maxResults:D.maxResults};if(D.onlyOpenEditors){const U=m.coalesce(m.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(x=>x.resource)))).filter(N=>(0,s.pathIncludedInQuery)(M,N.fsPath)),z=this.commonQueryFromFileList(U);return{...M,...z}}const G=D.extraFileResources&&D.extraFileResources.filter(K=>(0,s.pathIncludedInQuery)(M,K.fsPath));return M.extraFileResources=G&&G.length?G:void 0,M}commonQueryFromFileList(b){const D=[],w=new R.ResourceMap,T={};let v=!1;return b.forEach(F=>{if(F.scheme===E.Schemas.walkThrough)return;if((0,A.isAbsolutePath)(F)){const G=this.workspaceContextService.getWorkspaceFolder(F)?.uri??F.with({path:S.dirname(F.fsPath)});let K=w.get(G);K||(v=!0,K={folder:G,includePattern:{}},D.push(K),w.set(G,K));const U=S.relative(G.fsPath,F.fsPath);(0,P.assertIsDefined)(K.includePattern)[U.replace(/\\/g,"/")]=!0}else F.fsPath&&(v=!0,T[F.fsPath]=!0)}),{folderQueries:D,includePattern:T,usingSearchPaths:!0,excludePattern:v?void 0:{"**/*":!0}}}isCaseSensitive(b,D){if(D.isSmartCase){if(b.isRegExp){if(n.containsUppercaseCharacter(b.pattern,!0))return!0}else if(n.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&(0,h.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const D=z=>S.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),T=(Array.isArray(b)?b:a(b)).map(z=>{const N=this.pathService.resolvedUserHome;return N?(0,C.untildify)(z,N.scheme===E.Schemas.file?N.fsPath:N.path):z}),v=L.groupBy(T,z=>D(z)?"searchPaths":"exprSegments"),F=(v.exprSegments||[]).map(z=>n.rtrim(z,"/")).map(z=>n.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),r(z))),M={},G=this.expandSearchPathPatterns(v.searchPaths||[]);G&&G.length&&(M.searchPaths=G);const K=m.flatten(F),U=t(...K);return U&&(M.pattern=U),M}getExcludesForFolder(b,D){return D.disregardExcludeSettings?void 0:(0,s.getExcludes)(b,!D.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const D=m.flatten(b.map(T=>{let{pathPortion:v,globPortion:F}=p(T);F&&(F=l(F));const M=this.expandOneSearchPath(v);return m.flatten(M.map(G=>this.resolveOneSearchPathPattern(G,F)))})),w=new Map;return D.forEach(T=>{const v=T.searchPath.toString(),F=w.get(v);F?T.pattern&&(F.pattern=F.pattern||{},F.pattern[T.pattern]=!0):w.set(v,{searchPath:T.searchPath,pattern:T.pattern?t(T.pattern):void 0})}),Array.from(w.values())}expandOneSearchPath(b){if(S.isAbsolute(b)){const D=this.workspaceContextService.getWorkspace().folders;return D[0]&&D[0].uri.scheme!==E.Schemas.file?[{searchPath:D[0].uri.with({path:b})}]:[{searchPath:c.URI.file(S.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const D=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=i(b),b.startsWith("../")||b===".."){const T=S.posix.resolve(D.path,b);return[{searchPath:D.with({path:T})}]}const w=l(b);return[{searchPath:D,pattern:w}]}else{if(b==="./"||b===".\\")return[];{const D=b.replace(/^\.[\/\\]/,""),T=this.workspaceContextService.getWorkspace().folders.map(v=>{const F=D.match(new RegExp(`^${n.escapeRegExpCharacters(v.name)}(?:/(.*)|$)`));return F?{match:F,folder:v}:null}).filter(P.isDefined);if(T.length)return T.map(v=>{const F=v.match[1];return{searchPath:v.folder.uri,pattern:F&&l(F)}});{const v=b.match(/\.[\/\\](.+)[\/\\]?/),F=v?v[1]:b,M=d.localize(0,null,F);throw new Error(M)}}}}resolveOneSearchPathPattern(b,D){const w=b.pattern&&D?`${b.pattern}/${D}`:b.pattern||D,T=[{searchPath:b.searchPath,pattern:w}];return w&&!w.endsWith("**")&&T.push({searchPath:b.searchPath,pattern:w+"/**"}),T}getFolderQueryForSearchPath(b,D,w){const T=this.getFolderQueryForRoot((0,y.toWorkspaceFolder)(b.searchPath),D,w,!1);return T?{...T,includePattern:b.pattern}:null}getFolderQueryForRoot(b,D,w,T){let v;const F=c.URI.isUri(b)?b:b.uri;if(w.searchPaths){const z=w.searchPaths.filter(N=>(0,A.isEqual)(N.searchPath,F))[0];if(z&&!z.pattern)return null;z&&(v=z.pattern)}const M=this.configurationService.getValue({resource:F}),K={...this.getExcludesForFolder(M,D)||{},...v||{}},U=c.URI.isUri(b)?(0,A.basename)(b):b.name;return{folder:F,folderName:T?U:void 0,excludePattern:Object.keys(K).length>0?K:void 0,fileEncoding:M.files&&M.files.encoding,disregardIgnoreFiles:typeof D.disregardIgnoreFiles=="boolean"?D.disregardIgnoreFiles:!M.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof D.disregardGlobalIgnoreFiles=="boolean"?D.disregardGlobalIgnoreFiles:!M.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof D.ignoreSymlinks=="boolean"?D.ignoreSymlinks:!M.search.followSymlinks}}};o=Ve([$e(0,g.IConfigurationService),$e(1,y.IWorkspaceContextService),$e(2,I.IEditorGroupsService),$e(3,_.IPathService)],o),e.QueryBuilder=o;function p(f){const b=f.match(/[\*\{\}\(\)\[\]\?]/);if(b){const D=b.index,w=f.substr(0,D).match(/[/|\\][^/\\]*$/);if(w){let T=f.substr(0,w.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:f.substr((w.index||0)+1)}}}return{pathPortion:f}}function t(...f){return f.length?f.reduce((b,D)=>(b[D]=!0,b),Object.create(null)):void 0}function a(f){return k.splitGlobAware(f,",").map(b=>b.trim()).filter(b=>!!b.length)}function r(f){return[`**/${f}/**`,`**/${f}`].map(D=>D.replace(/\*\*\/\*\*/g,"**"))}function i(f){return f.replace(/\\/g,"/")}function l(f){return i(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function u(f,b){f=m.distinct(f,T=>T.toString());const D=[],w=b.getWorkspace();return f&&f.forEach(T=>{let v;if(b.getWorkbenchState()===2)v=(0,A.relativePath)(w.folders[0].uri,T),v&&v!=="."&&(v="./"+v);else{const F=b.getWorkspaceFolder(T);if(F){const M=F.name;if(w.folders.filter(K=>K.name===M).length===1){const K=(0,A.relativePath)(F.uri,T);K===""?v=`./${F.name}`:v=`./${F.name}/${K}`}else v=T.fsPath}}v&&D.push(v)}),D}e.resolveResourcesForSearchIncludes=u}),define(me[269],ge([0,1,22,2,21,16,4,268,31,43]),function(J,e,m,L,k,C,R,E,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function P(g,y){const I=y.activationEvents;if(!I)return Promise.resolve(void 0);const _=[],s=[];for(const i of I)if(/^workspaceContains:/.test(i)){const l=i.substr("workspaceContains:".length);l.indexOf("*")>=0||l.indexOf("?")>=0||g.forceUsingSearch?s.push(l):_.push(l)}if(_.length===0&&s.length===0)return Promise.resolve(void 0);let o;const p=new Promise((i,l)=>{o=i}),t=i=>o({activationEvent:i}),a=Promise.all(_.map(i=>c(g,i,t))).then(()=>{}),r=h(g,y.identifier,s,t);return Promise.all([a,r]).then(()=>{o(void 0)}),p}e.checkActivateWorkspaceContainsExtension=P;async function c(g,y,I){for(const _ of g.folders)if(await g.exists(m.joinPath(L.URI.revive(_),y))){I(`workspaceContains:${y}`);return}}async function h(g,y,I,_){if(I.length===0)return Promise.resolve(void 0);const s=new k.CancellationTokenSource,o=g.checkExists(g.folders,I,s.token),p=setTimeout(async()=>{s.cancel(),_(`workspaceContainsTimeout:${I.join(",")}`)},n);let t=!1;try{t=await o}catch(a){C.isPromiseCanceledError(a)||C.onUnexpectedError(a)}s.dispose(),clearTimeout(p),t&&_(`workspaceContains:${I.join(",")}`)}function d(g,y,I,_){const s=g.get(R.IInstantiationService),o=g.get(S.ISearchService),t=s.createInstance(E.QueryBuilder).file(y.map(a=>(0,A.toWorkspaceFolder)(L.URI.revive(a))),{_reason:"checkExists",includePattern:I,exists:!0});return o.fileSearch(t,_).then(a=>!!a.limitHit,a=>C.isPromiseCanceledError(a)?!1:Promise.reject(a))}e.checkGlobFileExists=d});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(J,m):k?k.value=m:e.set(J,m),m},Oe=this&&this.__classPrivateFieldGet||function(J,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(J):L?L.value:e.get(J)};define(me[40],ge([0,1,165,8,73,22,18,6,24,2,12,5,37,227,92,36,35,225,16,26,23,200,7,121,4,27,69,14,84,53,33,3,269,90,202]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g,y,I,_,s,o,p,t,a,r,i,l,u,f,b,D,w,T,v,F){"use strict";var M,G,K;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let U=class Hn extends E.Disposable{constructor(B,O,H,W,Q,Y,he,_e,Se,Re){super();this._onDidChangeRemoteConnectionData=this._register(new w.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=O,this._extHostContext=H,this._initData=he,this._extHostWorkspace=W,this._extHostConfiguration=Q,this._logService=Y,this._extHostTunnelService=Se,this._extHostTerminalService=Re,this._disposables=new E.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new R.Barrier,this._readyToStartExtensionHost=new R.Barrier,this._readyToRunExtensions=new R.Barrier,this._eagerExtensionsActivated=new R.Barrier,this._registry=new I.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new d.ExtHostStorage(this._extHostContext),this._secretState=new v.ExtHostSecretState(this._extHostContext),this._storagePath=_e,this._instaService=B.createChild(new f.ServiceCollection([d.IExtHostStorage,this._storage],[v.IExtHostSecretState,this._secretState]));const xe=new Set;this._initData.hostExtensions.forEach(Ue=>xe.add(s.ExtensionIdentifier.toKey(Ue))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ue,je,V)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ue,_.transformErrorForSerialization(je),V)},actualActivateExtension:async(Ue,je)=>{if(xe.has(s.ExtensionIdentifier.toKey(Ue)))return await this._mainThreadExtensionsProxy.$activateExtension(Ue,je),new h.HostExtension;const V=this._registry.getExtensionDescription(Ue);return this._activateExtension(V,je)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),k.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(B){_.onUnexpectedError(B)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let B=[];try{B=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch(O){}await Promise.all(B)}isActivated(B){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(B):!1}_activateByEvent(B,O){return this._activator.activateByEvent(B,O)}_activateById(B,O){return this._activator.activateById(B,O)}activateByIdWithErrors(B,O){return this._activateById(B,O).then(()=>{const H=this._activator.getActivatedExtension(B);if(H.activationFailed)return Promise.reject(H.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(B=>this._registry)}getExtensionExports(B){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(B).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const B=S.TernarySearchTree.forPaths(),O=this._registry.getAllExtensionDescriptions().map(H=>{if(!!this._getEntryPoint(H))return this._hostUtils.realpath(H.extensionLocation.fsPath).then(W=>B.set(A.URI.file(W).fsPath,H))});this._extensionPathIndex=Promise.all(O).then(()=>B)}return this._extensionPathIndex}_deactivate(B){let O=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(B))return O;const H=this._activator.getActivatedExtension(B);if(!H)return O;try{typeof H.module.deactivate=="function"&&(O=Promise.resolve(H.module.deactivate()).then(void 0,W=>(this._logService.error(W),Promise.resolve(void 0))))}catch(W){this._logService.error(W)}try{(0,E.dispose)(H.subscriptions)}catch(W){this._logService.error(W)}return O}async _activateExtension(B,O){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(B.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(B.identifier),this._doActivateExtension(B,O).then(H=>{const W=H.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(B.identifier,W.codeLoadingTime,W.activateCallTime,W.activateResolvedTime,O),this._logExtensionActivationTimes(B,O,"success",W),H},H=>{throw this._logExtensionActivationTimes(B,O,"failure"),H})}_logExtensionActivationTimes(B,O,H,W){const Q=z(B,O);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Q,...W||{},outcome:H})}_doActivateExtension(B,O){const H=z(B,O);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",H);const W=this._getEntryPoint(B);if(!W)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${B.identifier.value} ${JSON.stringify(O)}`),this._logService.flush();const Q=new h.ExtensionActivationTimesBuilder(O.startup);return Promise.all([this._loadCommonJSModule(B.identifier,(0,C.joinPath)(B.extensionLocation,W),Q),this._loadExtensionContext(B)]).then(Y=>(k.mark(`code/extHost/willActivateExtension/${B.identifier.value}`),Hn._callActivate(this._logService,B.identifier,Y[0],Y[1],Q))).then(Y=>(k.mark(`code/extHost/didActivateExtension/${B.identifier.value}`),Y))}_loadExtensionContext(B){const O=new p.ExtensionGlobalMemento(B,this._storage),H=new p.ExtensionMemento(B.identifier.value,!1,this._storage),W=new F.ExtensionSecrets(B,this._secretState),Q=B.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Y=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${B.identifier.value}`),Promise.all([O.whenReady,H.whenReady,this._storagePath.whenReady]).then(()=>{const he=this;let _e;return Object.freeze({globalState:O,workspaceState:H,secrets:W,subscriptions:[],get extensionUri(){return B.extensionLocation},get extensionPath(){return B.extensionLocation.fsPath},asAbsolutePath(Se){return L.join(B.extensionLocation.fsPath,Se)},get storagePath(){return he._storagePath.workspaceValue(B)?.fsPath},get globalStoragePath(){return he._storagePath.globalValue(B).fsPath},get logPath(){return L.join(he._initData.logsLocation.fsPath,B.identifier.value)},get logUri(){return A.URI.joinPath(he._initData.logsLocation,B.identifier.value)},get storageUri(){return he._storagePath.workspaceValue(B)},get globalStorageUri(){return he._storagePath.globalValue(B)},get extensionMode(){return Q},get extension(){return _e===void 0&&(_e=new N(he,B.identifier,B,Y)),_e},get extensionRuntime(){return(0,y.checkProposedApiEnabled)(B),he.extensionRuntime},get environmentVariableCollection(){return he._extHostTerminalService.getEnvironmentVariableCollection(B)}})})}static _callActivate(B,O,H,W,Q){return H=H||{activate:void 0,deactivate:void 0},this._callActivateOptional(B,O,H,W,Q).then(Y=>new h.ActivatedExtension(!1,null,Q.build(),H,Y,W.subscriptions))}static _callActivateOptional(B,O,H,W,Q){if(typeof H.activate=="function")try{Q.activateCallStart(),B.trace(`ExtensionService#_callActivateOptional ${O.value}`);const Y=typeof global=="object"?global:self,he=H.activate.apply(Y,[W]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(he).then(_e=>(Q.activateResolveStop(),_e))}catch(Y){return Promise.reject(Y)}else return Promise.resolve(H)}_activateOneStartupFinished(B,O){this._activateById(B.identifier,{startup:!1,extensionId:B.identifier,activationEvent:O}).then(void 0,H=>{this._logService.error(H)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(k.getMarks());for(const B of this._registry.getAllExtensionDescriptions())if(B.activationEvents)for(const O of B.activationEvents)O==="onStartupFinished"&&this._activateOneStartupFinished(B,O)}_handleEagerExtensions(){const B=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const O=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],H=this._handleWorkspaceContainsEagerExtensions(O),W=Promise.all([B,H]).then(()=>{});return Promise.race([W,(0,R.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),W}_handleWorkspaceContainsEagerExtensions(B){return B.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(O=>this._handleWorkspaceContainsEagerExtension(B,O))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(B,O){if(this.isActivated(O.identifier))return;const H=!this._initData.remote.isRemote&&!!this._initData.remote.authority,W={folders:B.map(Y=>Y.uri),forceUsingSearch:H,exists:Y=>this._hostUtils.exists(Y.fsPath),checkExists:(Y,he,_e)=>this._mainThreadWorkspaceProxy.$checkExists(Y,he,_e)},Q=await(0,T.checkActivateWorkspaceContainsExtension)(W,O);if(!!Q)return this._activateById(O.identifier,{startup:!0,extensionId:O.identifier,activationEvent:Q.activationEvent}).then(void 0,Y=>this._logService.error(Y))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(B){throw console.error(B),B}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:B,extensionTestsLocationURI:O}=this._initData.environment;if(!B||!O)throw new Error(m.localize(0,null));const H=await this._loadCommonJSModule(null,O,new h.ExtensionActivationTimesBuilder(!1));if(!H||typeof H.run!="function")throw new Error(m.localize(1,null,O.toString()));return new Promise((W,Q)=>{const Y=(Se,Re)=>{Se?Q(Se):W(typeof Re=="number"&&Re>0?1:0)},he=(0,C.originalFSPath)(O),_e=H.run(he,Y);_e&&_e.then&&_e.then(()=>{W(0)}).catch(Se=>{Q(Se.toString())})})}async $extensionTestsExit(B){this._logService.info(`extension host terminating: test runner requested exit with code ${B}`),this._logService.info(`exiting with code ${B}`),this._logService.flush(),this._hostUtils.exit(B)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(B,O){return this._resolvers[B]=O,(0,E.toDisposable)(()=>{delete this._resolvers[B]})}async _activateAndGetResolver(B){const O=B.indexOf("+");if(O===-1)throw new Error("Not an authority that can be resolved!");const H=B.substr(0,O);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${H}`,!1),{authorityPrefix:H,resolver:this._resolvers[H]}}async $resolveAuthority(B,O){const{authorityPrefix:H,resolver:W}=await this._activateAndGetResolver(B);if(!W)return{type:"error",error:{code:a.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${H}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(W)),k.mark(`code/extHost/willResolveAuthority/${H}`);const Q=await W.resolve(B,{resolveAttempt:O});k.mark(`code/extHost/didResolveAuthorityOK/${H}`);const Y={authority:B,host:Q.host,port:Q.port,connectionToken:Q.connectionToken},he={extensionHostEnv:Q.extensionHostEnv,isTrusted:Q.isTrusted};return{type:"ok",value:{authority:Y,options:he,tunnelInformation:{environmentTunnels:Q.environmentTunnels}}}}catch(Q){if(k.mark(`code/extHost/didResolveAuthorityError/${H}`),Q instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q}}async $getCanonicalURI(B,O){const{authorityPrefix:H,resolver:W}=await this._activateAndGetResolver(B);if(!W)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${H}`);const Q=A.URI.revive(O);if(typeof W.getCanonicalURI=="undefined")return Q;const Y=await(0,R.asPromise)(()=>W.getCanonicalURI(Q));return Y||Q}$startExtensionHost(B){return this._registry.keepOnly(B),this._startExtensionHost()}$activateByEvent(B,O){return O===1?this._activateByEvent(B,!1):this._readyToRunExtensions.wait().then(H=>this._activateByEvent(B,!1))}async $activate(B,O){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(B)?(await this._activateById(B,O),!0):!1}async $deltaExtensions(B,O){B.forEach(W=>W.extensionLocation=A.URI.revive(W.extensionLocation));const H=await this.getExtensionPathIndex();return await Promise.all(O.map(async W=>{const Q=this._registry.getExtensionDescription(W);if(!Q)return;const Y=await this._hostUtils.realpath(Q.extensionLocation.fsPath);H.delete(A.URI.file(Y).fsPath)})),await Promise.all(B.map(async W=>{const Q=await this._hostUtils.realpath(W.extensionLocation.fsPath);H.set(A.URI.file(Q).fsPath,W)})),this._registry.deltaExtensions(B,O),Promise.resolve(void 0)}async $test_latency(B){return B}async $test_up(B){return B.byteLength}async $test_down(B){let O=o.VSBuffer.alloc(B),H=Math.random()%256;for(let W=0;W<B;W++)O.writeUInt8(H,W);return O}async $updateRemoteConnectionData(B){this._remoteConnectionData=B,this._onDidChangeRemoteConnectionData.fire()}};U=Ve([$e(0,r.IInstantiationService),$e(1,e.IHostUtils),$e(2,u.IExtHostRpcService),$e(3,g.IExtHostWorkspace),$e(4,c.IExtHostConfiguration),$e(5,n.ILogService),$e(6,i.IExtHostInitDataService),$e(7,l.IExtensionStoragePaths),$e(8,b.IExtHostTunnelService),$e(9,D.IExtHostTerminalService)],U),e.AbstractExtHostExtensionService=U;function z(x,B){return{id:x.identifier.value,name:x.name,extensionVersion:x.version,publisherDisplayName:x.publisher,activationEvents:x.activationEvents?x.activationEvents.join(","):null,isBuiltin:x.isBuiltin,reason:B.activationEvent,reasonId:B.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class N{constructor(B,O,H,W){M.set(this,void 0),G.set(this,void 0),K.set(this,void 0),nt(this,M,B,"f"),nt(this,G,O,"f"),nt(this,K,H.identifier,"f"),this.id=H.identifier.value,this.extensionUri=H.extensionLocation,this.extensionPath=L.normalize((0,C.originalFSPath)(H.extensionLocation)),this.packageJSON=H,this.extensionKind=W}get isActive(){return Oe(this,M,"f").isActivated(Oe(this,K,"f"))}get exports(){if(this.packageJSON.api!=="none")return Oe(this,M,"f").getExtensionExports(Oe(this,K,"f"))}activate(){return Oe(this,M,"f").activateByIdWithErrors(Oe(this,K,"f"),{startup:!1,extensionId:Oe(this,G,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=N,M=new WeakMap,G=new WeakMap,K=new WeakMap}),define(me[55],ge([0,1,8,2,3,18,5,7,124,36,40,45,216,37,210,14,4,13,38,54]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g,y,I,_,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,y.createDecorator)("IExtHostDebugService");let o=class{constructor(f,b,D,w,T,v){this._workspaceService=b,this._extensionService=D,this._editorsService=w,this._configurationService=T,this._editorTabs=v,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new k.Emitter,this._onDidTerminateDebugSession=new k.Emitter,this._onDidChangeActiveDebugSession=new k.Emitter,this._onDidReceiveDebugSessionCustomEvent=new k.Emitter,this._debugServiceProxy=f.getProxy(R.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new k.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(F=>{F.onDidChange(M=>{this.registerAllDebugTypes(F)}),this.registerAllDebugTypes(F)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(f,b){const D=f;if(typeof D.sourceReference=="number"&&D.sourceReference>0){let w=`debug:${encodeURIComponent(D.path||"")}`,T="?";return b&&(w+=`${T}session=${encodeURIComponent(b.id)}`,T="&"),w+=`${T}ref=${D.sourceReference}`,L.URI.parse(w)}else{if(D.path)return L.URI.file(D.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(f){const b=[];for(const D of f.getAllExtensionDescriptions())if(D.contributes){const w=D.contributes.debuggers;if(w&&w.length>0)for(const T of w)(0,d.isDebuggerMainContribution)(T)&&b.push(T.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const f=[];return this._breakpoints.forEach(b=>f.push(b)),f}addBreakpoints(f){this.startBreakpoints();const b=f.filter(T=>{const v=T.id;return this._breakpoints.has(v)?!1:(this._breakpoints.set(v,T),!0)});this.fireBreakpointChanges(b,[],[]);const D=[],w=new Map;for(const T of b)if(T instanceof E.SourceBreakpoint){let v=w.get(T.location.uri.toString());v||(v={type:"sourceMulti",uri:T.location.uri,lines:[]},w.set(T.location.uri.toString(),v),D.push(v)),v.lines.push({id:T.id,enabled:T.enabled,condition:T.condition,hitCondition:T.hitCondition,logMessage:T.logMessage,line:T.location.range.start.line,character:T.location.range.start.character})}else T instanceof E.FunctionBreakpoint&&D.push({type:"function",id:T.id,enabled:T.enabled,hitCondition:T.hitCondition,logMessage:T.logMessage,condition:T.condition,functionName:T.functionName});return this._debugServiceProxy.$registerBreakpoints(D)}removeBreakpoints(f){this.startBreakpoints();const b=f.filter(v=>this._breakpoints.delete(v.id));this.fireBreakpointChanges([],b,[]);const D=b.filter(v=>v instanceof E.SourceBreakpoint).map(v=>v.id),w=b.filter(v=>v instanceof E.FunctionBreakpoint).map(v=>v.id),T=b.filter(v=>v instanceof E.DataBreakpoint).map(v=>v.id);return this._debugServiceProxy.$unregisterBreakpoints(D,w,T)}startDebugging(f,b,D){return this._debugServiceProxy.$startDebugging(f?f.uri:void 0,b,{parentSessionID:D.parentSession?D.parentSession.id:void 0,lifecycleManagedByParent:D.lifecycleManagedByParent,repl:D.consoleMode===E.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:D.noDebug,compact:D.compact,debugUI:D.debugUI,suppressSaveBeforeStart:D.suppressSaveBeforeStart})}stopDebugging(f){return this._debugServiceProxy.$stopDebugging(f?f.id:void 0)}registerDebugConfigurationProvider(f,b,D){if(!b)return new E.Disposable(()=>{});const w=this._configProviderHandleCounter++;return this._configProviders.push({type:f,handle:w,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(f,D,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,w),new E.Disposable(()=>{this._configProviders=this._configProviders.filter(T=>T.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(f,b,D){if(!D)return new E.Disposable(()=>{});if(!this.definesDebugType(f,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:w,factory:D}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,w),new E.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(T=>T.factory!==D),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(f,b){if(!b)return new E.Disposable(()=>{});const D=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:f,handle:D,factory:b}),new E.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(w=>w.factory!==b)})}async $runInTerminal(f,b){return Promise.resolve(void 0)}async $substituteVariables(f,b){if(!this._variableResolver){const[T,v]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(T||[],this._editorsService,v)}let D;const w=await this.getFolder(f);return w&&(D={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(D,b)}createDebugAdapter(f,b){if(f.type==="implementation")return new i(f.implementation)}createSignService(){}async $startDASession(f,b){const D=this,w=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(w.type),w).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const v=this.convertToDto(T),F=this.createDebugAdapter(v,w);if(!F)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const M=F;return this._debugAdapters.set(f,M),this.getDebugAdapterTrackers(w).then(G=>(G&&this._debugAdaptersTrackers.set(f,G),M.onMessage(async K=>{if(K.type==="request"&&K.command==="handshake"){const U=K,z={type:"response",seq:0,command:U.command,request_seq:U.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const N=await this._signService.sign(U.arguments.value);z.body={signature:N},M.sendResponse(z)}else throw new Error("no signer")}catch(N){z.success=!1,z.message=N.message,M.sendResponse(z)}}else G&&G.onDidSendMessage&&G.onDidSendMessage(K),K=(0,d.convertToVSCPaths)(K,!0),D._debugServiceProxy.$acceptDAMessage(f,K)}),M.onError(K=>{G&&G.onError&&G.onError(K),this._debugServiceProxy.$acceptDAError(f,K.name,K.message,K.stack)}),M.onExit(K=>{G&&G.onExit&&G.onExit((0,I.withNullAsUndefined)(K),void 0),this._debugServiceProxy.$acceptDAExit(f,(0,I.withNullAsUndefined)(K),void 0)}),G&&G.onWillStartSession&&G.onWillStartSession(),M.startSession()))})}$sendDAMessage(f,b){b=(0,d.convertToDAPaths)(b,!1);const D=this._debugAdaptersTrackers.get(f);D&&D.onWillReceiveMessage&&D.onWillReceiveMessage(b);const w=this._debugAdapters.get(f);w&&w.sendMessage(b)}$stopDASession(f){const b=this._debugAdaptersTrackers.get(f);this._debugAdaptersTrackers.delete(f),b&&b.onWillStopSession&&b.onWillStopSession();const D=this._debugAdapters.get(f);return this._debugAdapters.delete(f),D?D.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(f){const b=[],D=[],w=[];if(f.added)for(const T of f.added){const v=T.id;if(v&&!this._breakpoints.has(v)){let F;if(T.type==="function")F=new E.FunctionBreakpoint(T.functionName,T.enabled,T.condition,T.hitCondition,T.logMessage);else if(T.type==="data")F=new E.DataBreakpoint(T.label,T.dataId,T.canPersist,T.enabled,T.hitCondition,T.condition,T.logMessage);else{const M=L.URI.revive(T.uri);F=new E.SourceBreakpoint(new E.Location(M,new E.Position(T.line,T.character)),T.enabled,T.condition,T.hitCondition,T.logMessage)}F._id=v,this._breakpoints.set(v,F),b.push(F)}}if(f.removed)for(const T of f.removed){const v=this._breakpoints.get(T);v&&(this._breakpoints.delete(T),D.push(v))}if(f.changed){for(const T of f.changed)if(T.id){const v=this._breakpoints.get(T.id);if(v){if(v instanceof E.FunctionBreakpoint&&T.type==="function"){const F=v;F.enabled=T.enabled,F.condition=T.condition,F.hitCondition=T.hitCondition,F.logMessage=T.logMessage,F.functionName=T.functionName}else if(v instanceof E.SourceBreakpoint&&T.type==="source"){const F=v;F.enabled=T.enabled,F.condition=T.condition,F.hitCondition=T.hitCondition,F.logMessage=T.logMessage,F.location=new E.Location(L.URI.revive(T.uri),new E.Position(T.line,T.character))}w.push(v)}}}this.fireBreakpointChanges(b,D,w)}$provideDebugConfigurations(f,b,D){return(0,C.asPromise)(async()=>{const w=this.getConfigProviderByHandle(f);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const T=await this.getFolder(b);return w.provideDebugConfigurations(T,D)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(f,b,D,w){return(0,C.asPromise)(async()=>{const T=this.getConfigProviderByHandle(f);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const v=await this.getFolder(b);return T.resolveDebugConfiguration(v,D,w)})}$resolveDebugConfigurationWithSubstitutedVariables(f,b,D,w){return(0,C.asPromise)(async()=>{const T=this.getConfigProviderByHandle(f);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const v=await this.getFolder(b);return T.resolveDebugConfigurationWithSubstitutedVariables(v,D,w)})}async $provideDebugAdapter(f,b){const D=this.getAdapterDescriptorFactoryByHandle(f);if(!D)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.getSession(b);return this.getAdapterDescriptor(D,w).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.convertToDto(T)})}async $acceptDebugSessionStarted(f){const b=await this.getSession(f);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(f){const b=await this.getSession(f);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(f){this._activeDebugSession=f?await this.getSession(f):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(f,b){const D=await this.getSession(f);D&&D._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(f,b){const w={session:await this.getSession(f),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(w)}convertToDto(f){if(f instanceof E.DebugAdapterExecutable)return{type:"executable",command:f.command,args:f.args,options:f.options};if(f instanceof E.DebugAdapterServer)return{type:"server",port:f.port,host:f.host};if(f instanceof E.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:f.path};if(f instanceof E.DebugAdapterInlineImplementation)return{type:"implementation",implementation:f.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(f){const b=this._adapterFactories.filter(D=>D.type===f);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(f){const b=this._adapterFactories.filter(D=>D.handle===f);if(b.length>0)return b[0].factory}getConfigProviderByHandle(f){const b=this._configProviders.filter(D=>D.handle===f);if(b.length>0)return b[0].provider}definesDebugType(f,b){if(f.contributes){const D=f.contributes.debuggers;if(D&&D.length>0){for(const w of D)if(w.label&&w.type&&w.type===b)return!0}}return!1}getDebugAdapterTrackers(f){const D=f.configuration.type,w=this._trackerFactories.filter(T=>T.type===D||T.type==="*").map(T=>(0,C.asPromise)(()=>T.factory.createDebugAdapterTracker(f)).then(v=>v,v=>null));return Promise.race([Promise.all(w).then(T=>{const v=T.filter(F=>!!F);if(v.length>0)return new r(v)}),new Promise((T,v)=>{const F=setTimeout(()=>{clearTimeout(F),v(new Error("timeout"))},1e3)})]).catch(T=>{})}async getAdapterDescriptor(f,b){const D=b.configuration.debugServer;if(typeof D=="number")return Promise.resolve(new E.DebugAdapterServer(D));if(f){const T=await this._extensionService.getExtensionRegistry();return(0,C.asPromise)(()=>f.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,T))).then(v=>{if(v)return v})}const w=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,w))}daExecutableFromPackage(f,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(f,b,D){(f.length>0||b.length>0||D.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:f,removed:b,changed:D}))}async getSession(f){if(f)if(typeof f=="string"){const b=this._debugSessions.get(f);if(b)return b}else{let b=this._debugSessions.get(f.id);if(!b){const D=await this.getFolder(f.folderUri),w=f.parent?this._debugSessions.get(f.parent):void 0;b=new p(this._debugServiceProxy,f.id,f.type,f.name,D,f.configuration,w),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(f){if(f){const b=L.URI.revive(f);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};o=Ve([$e(0,g.IExtHostRpcService),$e(1,A.IExtHostWorkspace),$e(2,n.IExtHostExtensionService),$e(3,P.IExtHostDocumentsAndEditors),$e(4,h.IExtHostConfiguration),$e(5,s.IExtHostEditorTabs)],o),e.ExtHostDebugServiceBase=o;class p{constructor(f,b,D,w,T,v,F){this._debugServiceProxy=f,this._id=b,this._type=D,this._name=w,this._workspaceFolder=T,this._configuration=v,this._parentSession=F}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(f){this._name=f,this._debugServiceProxy.$setDebugSessionName(this._id,f)}get parentSession(){return this._parentSession}_acceptNameChanged(f){this._name=f}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(f,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,f,b)}getDebugProtocolBreakpoint(f){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,f.id)}}e.ExtHostDebugSession=p;class t{constructor(f){this.value=Object.freeze({append(b){f.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=t;class a extends c.AbstractVariableResolverService{constructor(f,b,D,w,T){function v(){if(b){const F=b.activeEditor();if(F)return F.document.uri;const M=w.tabs.filter(G=>G.isActive);if(M.length>0){const G=M[0].resource;return G&&(G.primary||G.secondary)?G.primary??G.secondary:M[0].resource}}}super({getFolderUri:F=>{const M=f.filter(G=>G.name===F);if(M&&M.length>0)return M[0].uri},getWorkspaceFolderCount:()=>f.length,getConfigurationValue:(F,M)=>D.getConfiguration(void 0,F).get(M),getAppRoot:()=>_.cwd(),getExecPath:()=>_.env.VSCODE_EXEC_PATH,getFilePath:()=>{const F=v();if(F)return m.normalize(F.fsPath)},getWorkspaceFolderPathForFile:()=>{if(T){const F=v();if(F){const M=T.getWorkspaceFolder(F);if(M)return m.normalize(M.uri.fsPath)}}},getSelectedText:()=>{if(b){const F=b.activeEditor();if(F&&!F.selection.isEmpty)return F.document.getText(F.selection)}},getLineNumber:()=>{if(b){const F=b.activeEditor();if(F)return String(F.selection.end.line+1)}}},void 0,Promise.resolve(_.env))}}e.ExtHostVariableResolverService=a;class r{constructor(f){this.trackers=f}onWillStartSession(){this.trackers.forEach(f=>f.onWillStartSession?f.onWillStartSession():void 0)}onWillReceiveMessage(f){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(f):void 0)}onDidSendMessage(f){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(f):void 0)}onWillStopSession(){this.trackers.forEach(f=>f.onWillStopSession?f.onWillStopSession():void 0)}onError(f){this.trackers.forEach(b=>b.onError?b.onError(f):void 0)}onExit(f,b){this.trackers.forEach(D=>D.onExit?D.onExit(f,b):void 0)}}class i extends S.AbstractDebugAdapter{constructor(f){super();this.implementation=f,f.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(f){this.implementation.handleMessage(f)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let l=class extends o{constructor(f,b,D,w,T,v){super(f,b,D,w,T,v)}createVariableResolver(f,b,D){return new a(f,b,D,this._editorTabs)}};l=Ve([$e(0,g.IExtHostRpcService),$e(1,A.IExtHostWorkspace),$e(2,n.IExtHostExtensionService),$e(3,P.IExtHostDocumentsAndEditors),$e(4,h.IExtHostConfiguration),$e(5,s.IExtHostEditorTabs)],l),e.WorkerExtHostDebugService=l}),define(me[270],ge([0,1,73,2,5,37,35,26,14,27,4,40,38,12]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(s,o,p,t,a,r,i){this._apiFactory=s,this._extensionRegistry=o,this._instaService=p,this._extHostConfiguration=t,this._extHostExtensionService=a,this._initData=r,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),m.mark("code/extHost/willWaitForConfig");const s=await this._extHostConfiguration.getConfigProvider();m.mark("code/extHost/didWaitForConfig");const o=await this._extHostExtensionService.getExtensionPathIndex();this.register(new g(this._apiFactory,o,this._extensionRegistry,s,this._logService)),this.register(this._instaService.createInstance(y)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(I,o,this._initData.environment.appUriScheme))}register(s){if(Array.isArray(s.nodeModuleName))for(let o of s.nodeModuleName)this._factories.set(o,s);else this._factories.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this._alternatives.push(o=>s.alternativeModuleName(o))}};d=Ve([$e(2,n.IInstantiationService),$e(3,C.IExtHostConfiguration),$e(4,P.IExtHostExtensionService),$e(5,A.IExtHostInitDataService),$e(6,h.ILogService)],d),e.RequireInterceptor=d;class g{constructor(s,o,p,t,a){this._apiFactory=s,this._extensionPaths=o,this._extensionRegistry=p,this._configProvider=t,this._logService=a,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(s,o){const p=this._extensionPaths.findSubstr(o.fsPath);if(p){let t=this._extApiImpl.get(E.ExtensionIdentifier.toKey(p.identifier));return t||(t=this._apiFactory(p,this._extensionRegistry,this._configProvider),this._extApiImpl.set(E.ExtensionIdentifier.toKey(p.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((a,r)=>t+=`	${r} -> ${a.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${o.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(R.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let y=class{constructor(s,o){this.nodeModuleName="keytar";const{environment:p}=o,t=s.getProxy(k.MainContext.MainThreadKeytar);if(p.appRoot){let a=p.appRoot.fsPath;c.platform==="win32"&&(a=a.replace(/\\/g,"/")),a[a.length-1]==="/"&&(a=a.substr(0,a.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${a}/node_modules.asar/keytar`),this.alternativeNames.add(`${a}/node_modules/keytar`)}this._impl={getPassword:(a,r)=>t.$getPassword(a,r),setPassword:(a,r,i)=>t.$setPassword(a,r,i),deletePassword:(a,r)=>t.$deletePassword(a,r),findPassword:a=>t.$findPassword(a),findCredentials(a){return t.$findCredentials(a)}}}load(s,o){return this._impl}alternativeModuleName(s){const o=s.length;if(o<=7||!this.alternativeNames)return;const p=o-7;if((s.charAt(p)==="/"||s.charAt(p)==="\\")&&s.endsWith("keytar")&&(s=s.replace(/\\/g,"/"),this.alternativeNames.has(s)))return"keytar"}};y=Ve([$e(0,S.IExtHostRpcService),$e(1,A.IExtHostInitDataService)],y);let I=class{constructor(s,o,p){this._extensionPaths=s,this._appUriScheme=o,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=p.getProxy(k.MainContext.MainThreadTelemetry);const t=p.getProxy(k.MainContext.MainThreadWindow);this._impl=(a,r)=>{const i=L.URI.parse(a);return r?this.callOriginal(a,r):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,a,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,a,{}):this.callOriginal(a,r)}}load(s,o,p){const t=this._extensionPaths.findSubstr(o.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=p(s),this._impl}callOriginal(s,o){return this.sendNoForwardTelemetry(),this._original(s,o)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};I=Ve([$e(2,S.IExtHostRpcService)],I)}),define(me[271],ge([0,1,171,11,7,211,36,40,45,37,33,14,55,195,18,212,54]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let I=class extends c.ExtHostDebugServiceBase{constructor(o,p,t,a,r,i,l){super(o,p,t,a,r,l);this._terminalService=i,this._integratedTerminalInstances=new _}createDebugAdapter(o,p){switch(o.type){case"server":return new C.SocketDebugAdapter(o);case"pipeServer":return new C.NamedPipeDebugAdapter(o);case"executable":return new C.ExecutableDebugAdapter(o,p.type)}return super.createDebugAdapter(o,p)}daExecutableFromPackage(o,p){const t=C.ExecutableDebugAdapter.platformAdapterExecutable(p.getAllExtensionDescriptions(),o.type);if(t)return new k.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new h.SignService}async $runInTerminal(o,p){if(o.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(v=>{this._integratedTerminalInstances.onTerminalClosed(v)}));const t=await this._configurationService.getConfigProvider(),a=this._terminalService.getDefaultShell(!0),r=this._terminalService.getDefaultShellArgs(!0),i=o.title||m.localize(0,null),l=JSON.stringify({shell:a,shellArgs:r});let u=await this._integratedTerminalInstances.checkout(l,i),f,b=!1;if(u)f=o.cwd;else{const v={shellPath:a,shellArgs:r,cwd:o.cwd,name:i,iconPath:new k.ThemeIcon("debug")};b=!0,u=this._terminalService.createTerminalFromOptions(v,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(u,l)}u.show(!0);const D=await u.processId;b?await new Promise(v=>setTimeout(v,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0||a.indexOf("cmd.exe")>=0?u.sendText("cls"):a.indexOf("bash")>=0?u.sendText("clear"):L.isWindows?u.sendText("cls"):u.sendText("clear"));const w=(0,g.prepareCommand)(a,o.args,f,o.env);u.sendText(w);const T=this.onDidTerminateDebugSession(v=>{v.id===p&&(this._integratedTerminalInstances.free(u),T.dispose())});return D}else if(o.kind==="external")return(0,g.runInExternalTerminal)(o,await this._configurationService.getConfigProvider());return super.$runInTerminal(o,p)}createVariableResolver(o,p,t){return new c.ExtHostVariableResolverService(o,p,t,this._editorTabs,this._workspaceService)}};I=Ve([$e(0,P.IExtHostRpcService),$e(1,R.IExtHostWorkspace),$e(2,E.IExtHostExtensionService),$e(3,S.IExtHostDocumentsAndEditors),$e(4,A.IExtHostConfiguration),$e(5,n.IExtHostTerminalService),$e(6,y.IExtHostEditorTabs)],I),e.ExtHostDebugService=I;class _{constructor(){this._terminalInstances=new Map}async checkout(o,p){const a=[...this._terminalInstances.entries()].map(([r,i])=>(0,d.createCancelablePromise)(async l=>{if(r.name!==p||i.lastUsedAt!==-1&&await(0,g.hasChildProcesses)(await r.processId))return null;const u=Date.now();return i.lastUsedAt+_.minUseDelay>u||l.isCancellationRequested||i.config!==o?null:(i.lastUsedAt=u,r)}));return await(0,d.firstParallel)(a,r=>!!r)}insert(o,p){this._terminalInstances.set(o,{lastUsedAt:Date.now(),config:p})}free(o){const p=this._terminalInstances.get(o);p&&(p.lastUsedAt=-1)}onTerminalClosed(o){this._terminalInstances.delete(o)}}_.minUseDelay=1e3}),define(me[272],ge([0,1,8,2,113,36,55,45,37,43,33,14,27,72,10,12,67,54,22,80]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g,y,I,_,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let o=class extends h.ExtHostTaskBase{constructor(t,a,r,i,l,u,f,b,D){super(t,a,r,i,l,u,f,b);this.workspaceService=r,this.editorTabs=D,a.remote.isRemote&&a.remote.authority?this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:a.remote.authority,platform:process.platform}):this.registerTaskSystem(d.Schemas.file,{scheme:d.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,a){const r=a;if(!a.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const i=h.TaskHandleDTO.from(r,this.workspaceService),l=await this._proxy.$getTaskExecution(i);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const u=await this.getTaskExecution(l,a);return this._proxy.$executeTask(i).catch(()=>{}),u}else{const i=h.TaskDTO.from(a,t);if(i===void 0)return Promise.reject(new Error("Task is not valid"));h.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,a,!1);const l=await this.getTaskExecution(await this._proxy.$getTaskExecution(i),a);return this._proxy.$executeTask(i).catch(()=>{}),l}}provideTasksInternal(t,a,r,i){const l=[];if(i)for(let u of i){this.checkDeprecation(u,r),(!u.definition||!t[u.definition.type])&&this._logService.warn(`The task [${u.source}, ${u.name}] uses an undefined task type. The task will be ignored in the future.`);const f=h.TaskDTO.from(u,r.extension);f&&(l.push(f),h.CustomExecutionDTO.is(f.execution)&&a.push(this.addCustomExecution(f,u,!0)))}return{tasks:l,extension:r.extension}}async resolveTaskInternal(t){return t}async getVariableResolver(t){if(this._variableResolver===void 0){const a=await this._configurationService.getConfigProvider();this._variableResolver=new R.ExtHostVariableResolverService(t,this._editorService,a,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(t){let a=t&&t.length>0?t[0]:void 0;if(!a){const r=L.URI.file((0,s.homedir)());a=new A.WorkspaceFolder({uri:r,name:_.basename(r),index:0})}return{uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,a){const r=L.URI.revive(t),i={process:void 0,variables:Object.create(null)},l=await this._workspaceProvider.resolveWorkspaceFolder(r),u=await this._workspaceProvider.getWorkspaceFolders2()??[],f=await this.getVariableResolver(u),b=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(u);for(let D of a.variables)i.variables[D]=await f.resolveAsync(b,D);if(a.process!==void 0){let D;if(a.process.path!==void 0){D=a.process.path.split(m.delimiter);for(let w=0;w<D.length;w++)D[w]=await f.resolveAsync(b,D[w])}i.process=await k.win32.findExecutable(await f.resolveAsync(b,a.process.name),a.process.cwd!==void 0?await f.resolveAsync(b,a.process.cwd):void 0,D)}return i}async $jsonTasksSupported(){return!0}async $findExecutable(t,a,r){return k.win32.findExecutable(t,a,r)}};o=Ve([$e(0,P.IExtHostRpcService),$e(1,c.IExtHostInitDataService),$e(2,C.IExtHostWorkspace),$e(3,E.IExtHostDocumentsAndEditors),$e(4,S.IExtHostConfiguration),$e(5,n.IExtHostTerminalService),$e(6,g.ILogService),$e(7,y.IExtHostApiDeprecationService),$e(8,I.IExtHostEditorTabs)],o),e.ExtHostTask=o}),define(me[273],ge([0,1,18,16,73,6,2,5,265,12,82,84,27,189,14,65,40,33]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class _{constructor(o,p,t,a){this._disposables=new C.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new S.RPCProtocol(o,null,a),p=_._transform(p,this._rpcProtocol);const r=new P.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());r.set(c.IExtHostInitDataService,{_serviceBrand:void 0,...p}),r.set(d.IExtHostRpcService,new d.ExtHostRpcService(this._rpcProtocol)),r.set(g.IURITransformerService,new g.URITransformerService(a)),r.set(y.IHostUtils,t);const i=new h.InstantiationService(r,!0),l=i.invokeFunction(D=>D.get(I.IExtHostTerminalService));this._disposables.add(l),this._logService=i.invokeFunction(D=>D.get(A.ILogService)),k.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",p),this._extensionService=i.invokeFunction(D=>D.get(y.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const u=new WeakMap;this._extensionService.getExtensionPathIndex().then(D=>{Error.prepareStackTrace=(w,T)=>{let v="",F,M;for(const G of T)v+=`
	at ${G.toString()}`,M=G.getFileName(),!F&&M&&(F=D.findSubstr(M));return u.set(w,F),`${w.name||"Error"}: ${w.message||""}${v}`}});const f=this._rpcProtocol.getProxy(E.MainContext.MainThreadExtensionService),b=this._rpcProtocol.getProxy(E.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(D=>{const w=L.transformErrorForSerialization(D),T=u.get(D);T?f.$onExtensionRuntimeError(T.identifier,w):b.$onUnexpectedError(w)})}terminate(o){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${o}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const p=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,m.timeout)(4e3),p]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(o,p){o.extensions.forEach(a=>a.extensionLocation=R.URI.revive(p.transformIncomingURIs(a.extensionLocation))),o.environment.appRoot=R.URI.revive(p.transformIncomingURIs(o.environment.appRoot));const t=o.environment.extensionDevelopmentLocationURI;return t&&(o.environment.extensionDevelopmentLocationURI=t.map(a=>R.URI.revive(p.transformIncomingURIs(a)))),o.environment.extensionTestsLocationURI=R.URI.revive(p.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=R.URI.revive(p.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=R.URI.revive(p.transformIncomingURIs(o.environment.workspaceStorageHome)),o.logsLocation=R.URI.revive(p.transformIncomingURIs(o.logsLocation)),o.logFile=R.URI.revive(p.transformIncomingURIs(o.logFile)),o.workspace=p.transformIncomingURIs(o.workspace),o}}e.ExtensionHostMain=_}),define(me[274],ge([0,1,8,21,61,30,22,46,31]),function(J,e,m,L,k,C,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class A{constructor(c,h,d){this.config=c,this.provider=h,this.sessionToken=d,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&C.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&C.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const h=this.config.folderQueries||[];return new Promise((d,g)=>{const y=I=>{this.resultCount++,c(I)};if(this.isCanceled)return d({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(I=>{const _=I.toString(),s=m.basename(_);this.globalExcludePattern&&this.globalExcludePattern(_,s)||this.matchFile(y,{base:I,basename:s})}),Promise.all(h.map(I=>this.searchInFolder(I,y))).then(I=>{d({limitHit:this.isLimitHit,stats:I[0]||void 0})},I=>{g(new Error((0,k.toErrorMessage)(I)))})})}async searchInFolder(c,h){const d=new L.CancellationTokenSource,g=this.getSearchOptionsForFolder(c),y=this.initDirectoryTree(),I=new S.QueryGlobTester(this.config,c),_=!I.hasSiblingExcludeClauses();let s;try{this.activeCancellationTokens.add(d),s=E.StopWatch.create();const o=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},g,d.token),p=s.elapsed(),t=E.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(o&&o.forEach(a=>{const r=m.posix.relative(c.folder.path,a.path);if(_){const i=m.basename(a.path);this.matchFile(h,{base:c.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(y,c.folder,r,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(y,I,h),{providerTime:p,postProcessTime:t.elapsed()})}finally{d.dispose(),this.activeCancellationTokens.delete(d)}}getSearchOptionsForFolder(c){const h=(0,S.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),d=(0,S.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:d,includes:h,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},h,d,g){if(d===this.filePattern){const I=m.basename(this.filePattern);this.matchFile(g,{base:h,relativePath:this.filePattern,basename:I})}function y(I){const _=m.basename(I),s=m.dirname(I);let o=c[s];o||(o=c[s]=[],y(s)),o.push({base:h,relativePath:I,basename:_})}y(d)}matchDirectoryTree({rootEntries:c,pathToEntries:h},d,g){const y=this,I=this.filePattern;function _(s){const o=C.hasSiblingFn(()=>s.map(p=>p.basename));for(let p=0,t=s.length;p<t;p++){const a=s[p],{relativePath:r,basename:i}=a;if(!d.includedInQuerySync(r,i,I!==i?o:void 0))continue;const l=h[r];if(l)_(l);else{if(r===I)continue;y.matchFile(g,a)}if(y.isLimitHit)break}}_(c)}matchFile(c,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(h))}}class n{constructor(){this.sessions=new Map}fileSearch(c,h,d,g){const y=this.getSessionTokenSource(c.cacheKey),I=new A(c,h,y&&y.token);let _=0;const s=o=>{_+=o.length,d(o.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(I,n.BATCH_SIZE,s,g).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:_,detailStats:o.stats}}))}clearCache(c){const h=this.getSessionTokenSource(c);h&&h.cancel()}getSessionTokenSource(c){if(!!c)return this.sessions.has(c)||this.sessions.set(c,new L.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:R.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,h,d,g){g.onCancellationRequested(()=>{c.cancel()});const y=_=>{_&&(I.push(_),h>0&&I.length>=h&&(d(I),I=[]))};let I=[];return c.search(y).then(_=>(I.length&&d(I),_),_=>(I.length&&d(I),Promise.reject(_)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(me[133],ge([0,1,17,21,61,30,10,8,22,13,2,31]),function(J,e,m,L,k,C,R,E,S,A,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class c{constructor(s,o,p,t){this.query=s,this.provider=o,this.fileUtils=p,this.processType=t,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(s,o){const p=this.query.folderQueries||[],t=new L.CancellationTokenSource;return o.onCancellationRequested(()=>t.cancel()),new Promise((a,r)=>{this.collector=new d(s);let i=!1;const l=(u,f)=>{if(!i&&!this.isLimitHit){const b=this.resultSize(u);y(u)&&typeof this.query.maxResults=="number"&&this.resultCount+b>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),u=this.trimResultToSize(u,this.query.maxResults-this.resultCount));const D=this.resultSize(u);this.resultCount+=D,(D>0||!y(u))&&this.collector.add(u,f)}};Promise.all(p.map((u,f)=>this.searchInFolder(u,b=>l(b,f),t.token))).then(u=>{t.dispose(),this.collector.flush();const f=u.some(b=>!!b&&!!b.limitHit);a({limitHit:this.isLimitHit||f,messages:(0,m.flatten)(u.map(b=>b?.message?(0,A.isArray)(b.message)?b.message:[b.message]:[])),stats:{type:this.processType}})},u=>{t.dispose();const f=(0,k.toErrorMessage)(u);r(new Error(f))})})}resultSize(s){return y(s)?Array.isArray(s.ranges)?s.ranges.length:1:0}trimResultToSize(s,o){const p=Array.isArray(s.ranges)?s.ranges:[s.ranges],t=Array.isArray(s.preview.matches)?s.preview.matches:[s.preview.matches];return{ranges:p.slice(0,o),preview:{matches:t.slice(0,o),text:s.preview.text},uri:s.uri}}async searchInFolder(s,o,p){const t=new P.QueryGlobTester(this.query,s),a=[],r={report:u=>{if(!this.validateProviderResult(u))return;const f=s.folder.scheme===R.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(u.uri))):void 0,b=S.relativePath(s.folder,u.uri);if(b){const D=t.includedInQuery(b,E.basename(b),f);(0,A.isPromise)(D)?a.push(D.then(w=>{w&&o(u)})):D&&o(u)}}},i=this.getSearchOptionsForFolder(s),l=await this.provider.provideTextSearchResults(h(this.query.contentPattern),i,r,p);return a.length&&await Promise.all(a),l}validateProviderResult(s){if(y(s)){if(Array.isArray(s.ranges)){if(!Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(s.preview.matches.length!==s.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(s){const o=(0,P.resolvePatternsForProvider)(this.query.includePattern,s.includePattern),p=(0,P.resolvePatternsForProvider)(this.query.excludePattern,s.excludePattern),t={folder:n.URI.from(s.folder),excludes:p,includes:o,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,followSymlinks:!s.ignoreSymlinks,encoding:s.fileEncoding&&this.fileUtils.toCanonicalName(s.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=c;function h(_){return{isCaseSensitive:_.isCaseSensitive||!1,isRegExp:_.isRegExp||!1,isWordMatch:_.isWordMatch||!1,isMultiline:_.isMultiline||!1,pattern:_.pattern}}class d{constructor(s){this._onResult=s,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new I(512,o=>this.sendItems(o))}add(s,o){this._currentFileMatch&&(this._currentFolderIdx!==o||!S.isEqual(this._currentUri,s.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=o,this._currentFileMatch={resource:s.uri,results:[]}),this._currentFileMatch.results.push(g(s))}pushToCollector(){const s=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,s)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(s){this._onResult(s)}}e.TextSearchResultsCollector=d;function g(_){return y(_)?{preview:{matches:(0,m.mapArrayOrNot)(_.preview.matches,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character})),text:_.preview.text},ranges:(0,m.mapArrayOrNot)(_.ranges,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character}))}:{text:_.text,lineNumber:_.lineNumber}}function y(_){return!!_.preview}e.extensionResultIsMatch=y;class I{constructor(s,o){this.maxBatchSize=s,this.cb=o,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(s,o){!s||this.addItemToBatch(s,o)}addItems(s,o){!s||this.addItemsToBatch(s,o)}addItemToBatch(s,o){this.batch.push(s),this.batchSize+=o,this.onUpdate()}addItemsToBatch(s,o){this.batch=this.batch.concat(s),this.batchSize+=o,this.onUpdate()}onUpdate(){this.totalNumberCompleted<I.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},I.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=I,I.TIMEOUT=4e3,I.START_BATCH_AFTER_COUNT=50}),define(me[74],ge([0,1,6,5,4,274,14,65,12,2,133]),function(J,e,m,L,k,C,R,E,S,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let P=class{constructor(g,y,I){this.extHostRpc=g,this._uriTransformer=y,this._logService=I,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new C.FileSearchManager}_transformScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}registerTextSearchProvider(g,y){if(this._textSearchUsedSchemes.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this._textSearchUsedSchemes.add(g);const I=this._handlePool++;return this._textSearchProvider.set(I,y),this._proxy.$registerTextSearchProvider(I,this._transformScheme(g)),(0,m.toDisposable)(()=>{this._textSearchUsedSchemes.delete(g),this._textSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}registerFileSearchProvider(g,y){if(this._fileSearchUsedSchemes.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this._fileSearchUsedSchemes.add(g);const I=this._handlePool++;return this._fileSearchProvider.set(I,y),this._proxy.$registerFileSearchProvider(I,this._transformScheme(g)),(0,m.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(g),this._fileSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}$provideFileSearchResults(g,y,I,_){const s=c(I),o=this._fileSearchProvider.get(g);if(o)return this._fileSearchManager.fileSearch(s,o,p=>{this._proxy.$handleFileMatch(g,y,p.map(t=>t.resource))},_);throw new Error("unknown provider: "+g)}$clearCache(g){return this._fileSearchManager.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,y,I,_){const s=this._textSearchProvider.get(g);if(!s||!s.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const o=c(I);return this.createTextSearchManager(o,s).search(t=>this._proxy.$handleTextMatch(g,y,t),_)}$enableExtensionHostSearch(){}createTextSearchManager(g,y){return new n.TextSearchManager(g,y,{readdir:I=>Promise.resolve([]),toCanonicalName:I=>I},"textSearchProvider")}};P=Ve([$e(0,R.IExtHostRpcService),$e(1,E.IURITransformerService),$e(2,S.ILogService)],P),e.ExtHostSearch=P;function c(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(h),extraFileResources:d.extraFileResources&&d.extraFileResources.map(g=>A.URI.revive(g))}}e.reviveQuery=c;function h(d){return{...d,folder:A.URI.revive(d.folder)}}}),define(me[275],ge([0,1,21,16,3,49,2,114,109,147,81,42,5,233,232,44,234,37,235,236,237,218,238,45,40,239,219,242,243,244,68,221,249,250,251,92,33,253,222,15,7,256,70,132,36,35,57,207,241,86,131,72,55,74,12,65,14,27,245,204,53,67,230,254,203,69,91,259,257,258,231,52,252,255,90,54,122,247,71,248,10,191,246,201,240]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g,y,I,_,s,o,p,t,a,r,i,l,u,f,b,D,w,T,v,F,M,G,K,U,z,N,x,B,O,H,W,Q,Y,he,_e,Se,Re,xe,Ue,je,V,ee,re,le,Z,oe,ve,Me,qe,Qe,Je,Ce,at,X,te,pe,ze,tt,ut,lt,vt,Dt,ue,Ie,Be,Ke,We,ot,Le,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ke(ne){const de=ne.get(re.IExtHostInitDataService),be=ne.get(ze.IExtHostFileSystemInfo),we=ne.get(Ce.IExtHostConsumerFileSystem),Fe=ne.get(r.IExtHostExtensionService),Ge=ne.get(H.IExtHostWorkspace),He=ne.get(Dt.IExtHostTelemetry),Ye=ne.get(I.IExtHostConfiguration),it=ne.get(V.IURITransformerService),ae=ne.get(ee.IExtHostRpcService),Ee=ne.get(M.IExtHostStorage),ce=ne.get(Je.IExtensionStoragePaths),q=ne.get(je.ILogService),Te=ne.get(oe.IExtHostTunnelService),Pe=ne.get(ve.IExtHostApiDeprecationService),Ze=ne.get(O.IExtHostWindow),Xe=ne.get(lt.IExtHostSecretState),st=ne.get(vt.IExtHostEditorTabs);ae.set(c.ExtHostContext.ExtHostFileSystemInfo,be),ae.set(c.ExtHostContext.ExtHostLogService,q),ae.set(c.ExtHostContext.ExtHostWorkspace,Ge),ae.set(c.ExtHostContext.ExtHostConfiguration,Ye),ae.set(c.ExtHostContext.ExtHostExtensionService,Fe),ae.set(c.ExtHostContext.ExtHostStorage,Ee),ae.set(c.ExtHostContext.ExtHostTunnelService,Te),ae.set(c.ExtHostContext.ExtHostWindow,Ze),ae.set(c.ExtHostContext.ExtHostSecretState,Xe),ae.set(c.ExtHostContext.ExtHostTelemetry,He),ae.set(c.ExtHostContext.ExtHostEditorTabs,st);const wt=ae.set(c.ExtHostContext.ExtHostDecorations,ne.get(Se.IExtHostDecorations)),_t=ae.set(c.ExtHostContext.ExtHostDocumentsAndEditors,ne.get(a.IExtHostDocumentsAndEditors)),dt=ae.set(c.ExtHostContext.ExtHostCommands,ne.get(g.IExtHostCommands)),gt=ae.set(c.ExtHostContext.ExtHostTerminalService,ne.get(G.IExtHostTerminalService)),ft=ae.set(c.ExtHostContext.ExtHostDebugService,ne.get(xe.IExtHostDebugService)),Tt=ae.set(c.ExtHostContext.ExtHostSearch,ne.get(Ue.IExtHostSearch)),yt=ae.set(c.ExtHostContext.ExtHostTask,ne.get(Re.IExtHostTask)),Bt=ae.set(c.ExtHostContext.ExtHostOutputService,ne.get(D.IExtHostOutputService)),$t=ae.set(c.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(ae)),It=ae.set(c.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(ae,_t)),Wt=ae.set(c.ExtHostContext.ExtHostDocumentContentProviders,new o.ExtHostDocumentContentProvider(ae,_t,q)),en=ae.set(c.ExtHostContext.ExtHostDocumentSaveParticipant,new p.ExtHostDocumentSaveParticipant(q,It,ae.getProxy(c.MainContext.MainThreadBulkEdits))),bt=ae.set(c.ExtHostContext.ExtHostNotebook,new le.ExtHostNotebookController(ae,dt,_t,It,ce)),Qt=ae.set(c.ExtHostContext.ExtHostNotebookDocuments,new Le.ExtHostNotebookDocuments(q,bt)),jt=ae.set(c.ExtHostContext.ExtHostNotebookEditors,new ot.ExtHostNotebookEditors(q,ae,bt)),tn=ae.set(c.ExtHostContext.ExtHostNotebookKernels,new ue.ExtHostNotebookKernels(ae,de,bt,q)),nn=ae.set(c.ExtHostContext.ExtHostNotebookRenderers,new Be.ExtHostNotebookRenderers(ae,bt)),Pt=ae.set(c.ExtHostContext.ExtHostEditors,new K.ExtHostEditors(ae,_t)),Xt=ae.set(c.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(ae.getProxy(c.MainContext.MainThreadTreeViews),dt,q)),bn=ae.set(c.ExtHostContext.ExtHostEditorInsets,new Y.ExtHostEditorInsets(ae.getProxy(c.MainContext.MainThreadEditorInsets),Pt,de)),Ht=ae.set(c.ExtHostContext.ExtHostDiagnostics,new _.ExtHostDiagnostics(ae,q,be)),zt=ae.set(c.ExtHostContext.ExtHostLanguages,new f.ExtHostLanguages(ae,It,dt.converter)),pt=ae.set(c.ExtHostContext.ExtHostLanguageFeatures,new u.ExtHostLanguageFeatures(ae,it,It,dt,Ht,q,Pe)),rn=ae.set(c.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(ae,pt)),Ot=ae.set(c.ExtHostContext.ExtHostFileSystemEventService,new l.ExtHostFileSystemEventService(ae,q,_t)),Nt=ae.set(c.ExtHostContext.ExtHostQuickOpen,(0,T.createExtHostQuickOpen)(ae,Ge,dt)),Yt=ae.set(c.ExtHostContext.ExtHostSCM,new v.ExtHostSCM(ae,dt,q)),En=ae.set(c.ExtHostContext.ExtHostComments,(0,y.createExtHostComments)(ae,dt,It)),fn=ae.set(c.ExtHostContext.ExtHostProgress,new w.ExtHostProgress(ae.getProxy(c.MainContext.MainThreadProgress))),_n=ae.set(c.ExtHostContext.ExtHosLabelService,new he.ExtHostLabelService(ae)),mn=ae.set(c.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(ae)),sn=ae.set(c.ExtHostContext.ExtHostAuthentication,new Me.ExtHostAuthentication(ae)),on=ae.set(c.ExtHostContext.ExtHostTimeline,new qe.ExtHostTimeline(ae,dt)),qt=ae.set(c.ExtHostContext.ExtHostWebviews,new B.ExtHostWebviews(ae,{remote:de.remote},Ge,q,Pe)),an=ae.set(c.ExtHostContext.ExtHostWebviewPanels,new te.ExtHostWebviewPanels(ae,qt,Ge)),Sn=ae.set(c.ExtHostContext.ExtHostCustomEditors,new X.ExtHostCustomEditors(ae,It,ce,qt,an)),yn=ae.set(c.ExtHostContext.ExtHostWebviewViews,new at.ExtHostWebviewViews(ae,qt)),Gt=ae.set(c.ExtHostContext.ExtHostTesting,new tt.ExtHostTesting(ae,dt)),Jt=ae.set(c.ExtHostContext.ExtHostUriOpeners,new ut.ExtHostUriOpeners(ae));ae.set(c.ExtHostContext.ExtHostInteractive,new ye.ExtHostInteractive(ae,bt,_t,dt));const Dn=(0,Q.values)(c.ExtHostContext);ae.assertRegistered(Dn);const Cn=new pe.ExtHostBulkEdits(ae,_t),ln=new d.ExtHostClipboard(ae),cn=new b.ExtHostMessageService(ae,q),Vt=new s.ExtHostDialogs(ae),Ft=new F.ExtHostStatusBar(ae,dt.converter);return h.ExtHostApiCommands.register(dt),function(Ne,Rt,Kt){const Et=function(){let ie=!Ne.isUnderDevelopment;function fe(Ae){ie||(q.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Ae(ct){if(Array.isArray(ct))ct.forEach(Ae);else if(typeof ct=="string")fe(ct);else{const St=ct;typeof St.scheme=="undefined"&&fe(ct),!Ne.enableProposedApi&&typeof St.exclusive=="boolean"&&(0,W.throwProposedApiError)(Ne)}return ct}}(),kn={getSession(ie,fe,Ae){return Ae?.forceNewSession&&(0,W.checkProposedApiEnabled)(Ne),sn.getSession(Ne,ie,fe,Ae)},get onDidChangeSessions(){return sn.onDidChangeSessions},registerAuthenticationProvider(ie,fe,Ae,ct){return sn.registerAuthenticationProvider(ie,fe,Ae,ct)}},In={registerCommand(ie,fe,Ae){return dt.registerCommand(!0,ie,fe,Ae)},registerTextEditorCommand(ie,fe,Ae){return dt.registerCommand(!0,ie,(...ct)=>{const St=Pt.getActiveTextEditor();if(!St){q.warn("Cannot execute "+ie+" because there is no active text editor.");return}return St.edit(kt=>{fe.apply(Ae,[St,kt,...ct])}).then(kt=>{kt||q.warn("Edits from command "+ie+" were not applied.")},kt=>{q.warn("An error occurred while running command "+ie,kt)})})},registerDiffInformationCommand:(ie,fe,Ae)=>((0,W.checkProposedApiEnabled)(Ne),dt.registerCommand(!0,ie,async(...ct)=>{const St=_t.activeEditor(!0);if(!St){q.warn("Cannot execute "+ie+" because there is no active text editor.");return}const kt=await Pt.getDiffInformation(St.id);fe.apply(Ae,[kt,...ct])})),executeCommand(ie,...fe){return dt.executeCommand(ie,...fe)},getCommands(ie=!1){return dt.getCommands(ie)}},gn={get machineId(){return de.telemetryInfo.machineId},get sessionId(){return de.telemetryInfo.sessionId},get language(){return de.environment.appLanguage},get appName(){return de.environment.appName},get appRoot(){return de.environment.appRoot?.fsPath??""},get appHost(){return de.environment.appHost},get uriScheme(){return de.environment.appUriScheme},get clipboard(){return ln.value},get shell(){return gt.getDefaultShell(!1)},get isTelemetryEnabled(){return He.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return He.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ie=Date.now()-new Date(de.telemetryInfo.firstSessionDate).getTime();return isNaN(ie)?!1:ie<1e3*60*60*24},openExternal(ie,fe){return Ze.openUri(ie,{allowTunneling:!!de.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===de.environment.appUriScheme)return $t.createAppUri(ie);try{return await Ze.asExternalUri(ie,{allowTunneling:!!de.remote.authority})}catch(fe){if((0,We.matchesScheme)(ie,Ke.Schemas.http)||(0,We.matchesScheme)(ie,Ke.Schemas.https))return ie;throw fe}},get remoteName(){return(0,_e.getRemoteName)(de.remote.authority)},get remoteAuthority(){return(0,W.checkProposedApiEnabled)(Ne),de.remote.authority},get uiKind(){return de.uiKind}};de.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=de.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,Pn={createTestController(ie,fe){return Gt.createTestController(ie,fe)},createTestObserver(){return(0,W.checkProposedApiEnabled)(Ne),Gt.createTestObserver()},runTests(ie){return(0,W.checkProposedApiEnabled)(Ne),Gt.runTests(ie)},get onDidChangeTestResults(){return(0,W.checkProposedApiEnabled)(Ne),Gt.onResultsChanged},get testResults(){return(0,W.checkProposedApiEnabled)(Ne),Gt.results}},Tn={getExtension(ie){const fe=Rt.getExtensionDescription(ie);if(fe)return new r.Extension(Fe,Ne.identifier,fe,pn)},get all(){return Rt.getAllExtensionDescriptions().map(ie=>new r.Extension(Fe,Ne.identifier,ie,pn))},get onDidChange(){return Rt.onDidChange}},un={createDiagnosticCollection(ie){return Ht.createDiagnosticCollection(Ne.identifier,ie)},get onDidChangeDiagnostics(){return Ht.onDidChangeDiagnostics},getDiagnostics:ie=>Ht.getDiagnostics(ie),getLanguages(){return zt.getLanguages()},setTextDocumentLanguage(ie,fe){return zt.changeLanguage(ie.uri,fe)},match(ie,fe){return(0,n.score)(z.LanguageSelector.from(ie),fe.uri,fe.languageId,!0)},registerCodeActionsProvider(ie,fe,Ae){return pt.registerCodeActionProvider(Ne,Et(ie),fe,Ae)},registerCodeLensProvider(ie,fe){return pt.registerCodeLensProvider(Ne,Et(ie),fe)},registerDefinitionProvider(ie,fe){return pt.registerDefinitionProvider(Ne,Et(ie),fe)},registerDeclarationProvider(ie,fe){return pt.registerDeclarationProvider(Ne,Et(ie),fe)},registerImplementationProvider(ie,fe){return pt.registerImplementationProvider(Ne,Et(ie),fe)},registerTypeDefinitionProvider(ie,fe){return pt.registerTypeDefinitionProvider(Ne,Et(ie),fe)},registerHoverProvider(ie,fe){return pt.registerHoverProvider(Ne,Et(ie),fe,Ne.identifier)},registerEvaluatableExpressionProvider(ie,fe){return pt.registerEvaluatableExpressionProvider(Ne,Et(ie),fe,Ne.identifier)},registerInlineValuesProvider(ie,fe){return pt.registerInlineValuesProvider(Ne,Et(ie),fe,Ne.identifier)},registerDocumentHighlightProvider(ie,fe){return pt.registerDocumentHighlightProvider(Ne,Et(ie),fe)},registerLinkedEditingRangeProvider(ie,fe){return pt.registerLinkedEditingRangeProvider(Ne,Et(ie),fe)},registerReferenceProvider(ie,fe){return pt.registerReferenceProvider(Ne,Et(ie),fe)},registerRenameProvider(ie,fe){return pt.registerRenameProvider(Ne,Et(ie),fe)},registerDocumentSymbolProvider(ie,fe,Ae){return pt.registerDocumentSymbolProvider(Ne,Et(ie),fe,Ae)},registerWorkspaceSymbolProvider(ie){return pt.registerWorkspaceSymbolProvider(Ne,ie)},registerDocumentFormattingEditProvider(ie,fe){return pt.registerDocumentFormattingEditProvider(Ne,Et(ie),fe)},registerDocumentRangeFormattingEditProvider(ie,fe){return pt.registerDocumentRangeFormattingEditProvider(Ne,Et(ie),fe)},registerOnTypeFormattingEditProvider(ie,fe,Ae,...ct){return pt.registerOnTypeFormattingEditProvider(Ne,Et(ie),fe,[Ae].concat(ct))},registerDocumentSemanticTokensProvider(ie,fe,Ae){return pt.registerDocumentSemanticTokensProvider(Ne,Et(ie),fe,Ae)},registerDocumentRangeSemanticTokensProvider(ie,fe,Ae){return pt.registerDocumentRangeSemanticTokensProvider(Ne,Et(ie),fe,Ae)},registerSignatureHelpProvider(ie,fe,Ae,...ct){return typeof Ae=="object"?pt.registerSignatureHelpProvider(Ne,Et(ie),fe,Ae):pt.registerSignatureHelpProvider(Ne,Et(ie),fe,typeof Ae=="undefined"?[]:[Ae,...ct])},registerCompletionItemProvider(ie,fe,...Ae){return pt.registerCompletionItemProvider(Ne,Et(ie),fe,Ae)},registerInlineCompletionItemProvider(ie,fe){return(0,W.checkProposedApiEnabled)(Ne),pt.registerInlineCompletionsProvider(Ne,Et(ie),fe)},registerDocumentLinkProvider(ie,fe){return pt.registerDocumentLinkProvider(Ne,Et(ie),fe)},registerColorProvider(ie,fe){return pt.registerColorProvider(Ne,Et(ie),fe)},registerFoldingRangeProvider(ie,fe){return pt.registerFoldingRangeProvider(Ne,Et(ie),fe)},registerSelectionRangeProvider(ie,fe){return pt.registerSelectionRangeProvider(Ne,ie,fe)},registerCallHierarchyProvider(ie,fe){return pt.registerCallHierarchyProvider(Ne,ie,fe)},registerTypeHierarchyProvider(ie,fe){return pt.registerTypeHierarchyProvider(Ne,ie,fe)},setLanguageConfiguration:(ie,fe)=>pt.setLanguageConfiguration(Ne,ie,fe),getTokenInformationAtPosition(ie,fe){return(0,W.checkProposedApiEnabled)(Ne),zt.tokenAtPosition(ie,fe)},registerInlayHintsProvider(ie,fe){return(0,W.checkProposedApiEnabled)(Ne),pt.registerInlayHintsProvider(Ne,ie,fe)},createLanguageStatusItem(ie,fe){return(0,W.checkProposedApiEnabled)(Ne),zt.createLanguageStatusItem(Ne,ie,fe)}},An={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(ie,fe,Ae){const ct=await(R.URI.isUri(ie)?Promise.resolve(vn.openTextDocument(ie)):Promise.resolve(ie));return Pt.showTextDocument(ct,fe,Ae)},createTextEditorDecorationType(ie){return Pt.createTextEditorDecorationType(Ne,ie)},onDidChangeActiveTextEditor(ie,fe,Ae){return Pt.onDidChangeActiveTextEditor(ie,fe,Ae)},onDidChangeVisibleTextEditors(ie,fe,Ae){return Pt.onDidChangeVisibleTextEditors(ie,fe,Ae)},onDidChangeTextEditorSelection(ie,fe,Ae){return Pt.onDidChangeTextEditorSelection(ie,fe,Ae)},onDidChangeTextEditorOptions(ie,fe,Ae){return Pt.onDidChangeTextEditorOptions(ie,fe,Ae)},onDidChangeTextEditorVisibleRanges(ie,fe,Ae){return Pt.onDidChangeTextEditorVisibleRanges(ie,fe,Ae)},onDidChangeTextEditorViewColumn(ie,fe,Ae){return Pt.onDidChangeTextEditorViewColumn(ie,fe,Ae)},onDidCloseTerminal(ie,fe,Ae){return gt.onDidCloseTerminal(ie,fe,Ae)},onDidOpenTerminal(ie,fe,Ae){return gt.onDidOpenTerminal(ie,fe,Ae)},onDidChangeActiveTerminal(ie,fe,Ae){return gt.onDidChangeActiveTerminal(ie,fe,Ae)},onDidChangeTerminalDimensions(ie,fe,Ae){return(0,W.checkProposedApiEnabled)(Ne),gt.onDidChangeTerminalDimensions(ie,fe,Ae)},onDidChangeTerminalState(ie,fe,Ae){return(0,W.checkProposedApiEnabled)(Ne),gt.onDidChangeTerminalState(ie,fe,Ae)},onDidWriteTerminalData(ie,fe,Ae){return(0,W.checkProposedApiEnabled)(Ne),gt.onDidWriteTerminalData(ie,fe,Ae)},get state(){return Ze.state},onDidChangeWindowState(ie,fe,Ae){return Ze.onDidChangeWindowState(ie,fe,Ae)},showInformationMessage(ie,...fe){return cn.showMessage(Ne,C.default.Info,ie,fe[0],fe.slice(1))},showWarningMessage(ie,...fe){return cn.showMessage(Ne,C.default.Warning,ie,fe[0],fe.slice(1))},showErrorMessage(ie,...fe){return cn.showMessage(Ne,C.default.Error,ie,fe[0],fe.slice(1))},showQuickPick(ie,fe,Ae){return Nt.showQuickPick(ie,!!Ne.enableProposedApi,fe,Ae)},showWorkspaceFolderPick(ie){return Nt.showWorkspaceFolderPick(ie)},showInputBox(ie,fe){return Nt.showInput(ie,fe)},showOpenDialog(ie){return Vt.showOpenDialog(ie)},showSaveDialog(ie){return Vt.showSaveDialog(ie)},createStatusBarItem(ie,fe,Ae){let ct,St,kt;return typeof ie=="string"?(ct=ie,St=fe,kt=Ae):(St=ie,kt=fe),Ft.createStatusBarEntry(Ne,ct,St,kt)},setStatusBarMessage(ie,fe){return Ft.setStatusBarMessage(ie,fe)},withScmProgress(ie){return Pe.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),fn.withProgress(Ne,{location:N.ProgressLocation.SourceControl},(fe,Ae)=>ie({report(ct){}}))},withProgress(ie,fe){return fn.withProgress(Ne,ie,fe)},createOutputChannel(ie){return Bt.createOutputChannel(ie,Ne)},createWebviewPanel(ie,fe,Ae,ct){return an.createWebviewPanel(Ne,ie,fe,Ae,ct)},createWebviewTextEditorInset(ie,fe,Ae,ct){return(0,W.checkProposedApiEnabled)(Ne),bn.createWebviewEditorInset(ie,fe,Ae,ct,Ne)},createTerminal(ie,fe,Ae){return typeof ie=="object"?("location"in ie&&(0,W.checkProposedApiEnabled)(Ne),"pty"in ie?gt.createExtensionTerminal(ie):gt.createTerminalFromOptions(ie)):gt.createTerminal(ie,fe,Ae)},registerTerminalLinkProvider(ie){return gt.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,fe){return gt.registerProfileProvider(Ne,ie,fe)},registerTreeDataProvider(ie,fe){return Xt.registerTreeDataProvider(ie,fe,Ne)},createTreeView(ie,fe){return Xt.createTreeView(ie,fe,Ne)},registerWebviewPanelSerializer:(ie,fe)=>an.registerWebviewPanelSerializer(Ne,ie,fe),registerCustomEditorProvider:(ie,fe,Ae={})=>Sn.registerCustomEditorProvider(Ne,ie,fe,Ae),registerFileDecorationProvider(ie){return wt.registerFileDecorationProvider(ie,Ne.identifier)},registerUriHandler(ie){return $t.registerUriHandler(Ne.identifier,ie)},createQuickPick(){return Nt.createQuickPick(Ne.identifier,!!Ne.enableProposedApi)},createInputBox(){return Nt.createInputBox(Ne.identifier)},get activeColorTheme(){return mn.activeColorTheme},onDidChangeActiveColorTheme(ie,fe,Ae){return mn.onDidChangeActiveColorTheme(ie,fe,Ae)},registerWebviewViewProvider(ie,fe,Ae){return yn.registerWebviewViewProvider(Ne,ie,fe,Ae?.webviewOptions)},get activeNotebookEditor(){return(0,W.checkProposedApiEnabled)(Ne),bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,fe,Ae){return(0,W.checkProposedApiEnabled)(Ne),bt.onDidChangeActiveNotebookEditor(ie,fe,Ae)},get visibleNotebookEditors(){return(0,W.checkProposedApiEnabled)(Ne),bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,W.checkProposedApiEnabled)(Ne),bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,fe,Ae){return(0,W.checkProposedApiEnabled)(Ne),jt.onDidChangeNotebookEditorSelection(ie,fe,Ae)},onDidChangeNotebookEditorVisibleRanges(ie,fe,Ae){return(0,W.checkProposedApiEnabled)(Ne),jt.onDidChangeNotebookEditorVisibleRanges(ie,fe,Ae)},showNotebookDocument(ie,fe){return(0,W.checkProposedApiEnabled)(Ne),bt.showNotebookDocument(ie,fe)},registerExternalUriOpener(ie,fe,Ae){return(0,W.checkProposedApiEnabled)(Ne),Jt.registerExternalUriOpener(Ne.identifier,ie,fe,Ae)},get tabs(){return(0,W.checkProposedApiEnabled)(Ne),st.tabs},get activeTab(){return(0,W.checkProposedApiEnabled)(Ne),st.activeTab},get onDidChangeTabs(){return(0,W.checkProposedApiEnabled)(Ne),st.onDidChangeTabs},get onDidChangeActiveTab(){return(0,W.checkProposedApiEnabled)(Ne),st.onDidChangeActiveTab},getInlineCompletionItemController(ie){return(0,W.checkProposedApiEnabled)(Ne),u.InlineCompletionController.get(ie)}},vn={get rootPath(){return Pe.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ge.getPath()},set rootPath(ie){throw L.readonly()},getWorkspaceFolder(ie){return Ge.getWorkspaceFolder(ie)},get workspaceFolders(){return Ge.getWorkspaceFolders()},get name(){return Ge.name},set name(ie){throw L.readonly()},get workspaceFile(){return Ge.workspaceFile},set workspaceFile(ie){throw L.readonly()},updateWorkspaceFolders:(ie,fe,...Ae)=>Ge.updateWorkspaceFolders(Ne,ie,fe||0,...Ae),onDidChangeWorkspaceFolders:function(ie,fe,Ae){return Ge.onDidChangeWorkspace(ie,fe,Ae)},asRelativePath:(ie,fe)=>Ge.getRelativePath(ie,fe),findFiles:(ie,fe,Ae,ct)=>Ge.findFiles(z.GlobPattern.from(ie),z.GlobPattern.from(fe),Ae,Ne.identifier,ct),findTextInFiles:(ie,fe,Ae,ct)=>{let St,kt;return typeof fe=="object"?(St=fe,kt=Ae):(St={},kt=fe,ct=Ae),Ge.findTextInFiles(ie,St||{},kt,Ne.identifier,ct)},saveAll:ie=>Ge.saveAll(ie),applyEdit(ie){return Cn.applyWorkspaceEdit(ie)},createFileSystemWatcher:(ie,fe,Ae,ct)=>Ot.createFileSystemWatcher(z.GlobPattern.from(ie),fe,Ae,ct),get textDocuments(){return It.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw L.readonly()},openTextDocument(ie){let fe;const Ae=ie;if(typeof ie=="string")fe=Promise.resolve(R.URI.file(ie));else if(R.URI.isUri(ie))fe=Promise.resolve(ie);else if(!Ae||typeof Ae=="object")fe=It.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(ct=>It.ensureDocumentData(ct).then(St=>St.document))},onDidOpenTextDocument:(ie,fe,Ae)=>It.onDidAddDocument(ie,fe,Ae),onDidCloseTextDocument:(ie,fe,Ae)=>It.onDidRemoveDocument(ie,fe,Ae),onDidChangeTextDocument:(ie,fe,Ae)=>It.onDidChangeDocument(ie,fe,Ae),onDidSaveTextDocument:(ie,fe,Ae)=>It.onDidSaveDocument(ie,fe,Ae),onWillSaveTextDocument:(ie,fe,Ae)=>en.getOnWillSaveTextDocumentEvent(Ne)(ie,fe,Ae),get notebookDocuments(){return bt.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,fe){let Ae;if(R.URI.isUri(ie))Ae=ie,await bt.openNotebookDocument(ie);else if(typeof ie=="string")Ae=R.URI.revive(await bt.createNotebookDocument({viewType:ie,content:fe}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(ie,fe,Ae,ct){return bt.registerNotebookSerializer(Ne,ie,fe,Ae,Ne.enableProposedApi?ct:void 0)},registerNotebookContentProvider:(ie,fe,Ae,ct)=>((0,W.checkProposedApiEnabled)(Ne),bt.registerNotebookContentProvider(Ne,ie,fe,Ae,Ne.enableProposedApi?ct:void 0)),onDidChangeConfiguration:(ie,fe,Ae)=>Kt.onDidChangeConfiguration(ie,fe,Ae),getConfiguration(ie,fe){return fe=arguments.length===1?void 0:fe,Kt.getConfiguration(ie,fe,Ne)},registerTextDocumentContentProvider(ie,fe){return Wt.registerTextDocumentContentProvider(ie,fe)},registerTaskProvider:(ie,fe)=>(Pe.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Ne,ie,fe)),registerFileSystemProvider(ie,fe,Ae){return rn.registerFileSystemProvider(Ne.identifier,ie,fe,Ae)},get fs(){return we.value},registerFileSearchProvider:(ie,fe)=>((0,W.checkProposedApiEnabled)(Ne),Tt.registerFileSearchProvider(ie,fe)),registerTextSearchProvider:(ie,fe)=>((0,W.checkProposedApiEnabled)(Ne),Tt.registerTextSearchProvider(ie,fe)),registerRemoteAuthorityResolver:(ie,fe)=>((0,W.checkProposedApiEnabled)(Ne),Fe.registerRemoteAuthorityResolver(ie,fe)),registerResourceLabelFormatter:ie=>((0,W.checkProposedApiEnabled)(Ne),_n.$registerResourceLabelFormatter(ie)),onDidCreateFiles:(ie,fe,Ae)=>Ot.onDidCreateFile(ie,fe,Ae),onDidDeleteFiles:(ie,fe,Ae)=>Ot.onDidDeleteFile(ie,fe,Ae),onDidRenameFiles:(ie,fe,Ae)=>Ot.onDidRenameFile(ie,fe,Ae),onWillCreateFiles:(ie,fe,Ae)=>Ot.getOnWillCreateFileEvent(Ne)(ie,fe,Ae),onWillDeleteFiles:(ie,fe,Ae)=>Ot.getOnWillDeleteFileEvent(Ne)(ie,fe,Ae),onWillRenameFiles:(ie,fe,Ae)=>Ot.getOnWillRenameFileEvent(Ne)(ie,fe,Ae),openTunnel:ie=>((0,W.checkProposedApiEnabled)(Ne),Te.openTunnel(Ne,ie).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,W.checkProposedApiEnabled)(Ne),Te.getTunnels()},onDidChangeTunnels:(ie,fe,Ae)=>((0,W.checkProposedApiEnabled)(Ne),Te.onDidChangeTunnels(ie,fe,Ae)),registerPortAttributesProvider:(ie,fe)=>((0,W.checkProposedApiEnabled)(Ne),Te.registerPortsAttributesProvider(ie,fe)),registerTimelineProvider:(ie,fe)=>((0,W.checkProposedApiEnabled)(Ne),on.registerTimelineProvider(ie,fe,Ne.identifier,dt.converter)),get isTrusted(){return Ge.trusted},requestWorkspaceTrust:ie=>((0,W.checkProposedApiEnabled)(Ne),Ge.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,fe,Ae)=>Ge.onDidGrantWorkspaceTrust(ie,fe,Ae)},Rn={get inputBox(){return Pe.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),Yt.getLastInputBox(Ne)},createSourceControl(ie,fe,Ae){return Yt.createSourceControl(Ne,ie,fe,Ae)}},Ln={createCommentController(ie,fe){return En.createCommentController(Ne,ie,fe)}},Fn={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},onDidStartDebugSession(ie,fe,Ae){return ft.onDidStartDebugSession(ie,fe,Ae)},onDidTerminateDebugSession(ie,fe,Ae){return ft.onDidTerminateDebugSession(ie,fe,Ae)},onDidChangeActiveDebugSession(ie,fe,Ae){return ft.onDidChangeActiveDebugSession(ie,fe,Ae)},onDidReceiveDebugSessionCustomEvent(ie,fe,Ae){return ft.onDidReceiveDebugSessionCustomEvent(ie,fe,Ae)},onDidChangeBreakpoints(ie,fe,Ae){return ft.onDidChangeBreakpoints(ie,fe,Ae)},registerDebugConfigurationProvider(ie,fe,Ae){return ft.registerDebugConfigurationProvider(ie,fe,Ae||N.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,fe){return ft.registerDebugAdapterDescriptorFactory(Ne,ie,fe)},registerDebugAdapterTrackerFactory(ie,fe){return ft.registerDebugAdapterTrackerFactory(ie,fe)},startDebugging(ie,fe,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?ft.startDebugging(ie,fe,{parentSession:Ae}):ft.startDebugging(ie,fe,Ae||{})},stopDebugging(ie){return ft.stopDebugging(ie)},addBreakpoints(ie){return ft.addBreakpoints(ie)},removeBreakpoints(ie){return ft.removeBreakpoints(ie)},asDebugSourceUri(ie,fe){return ft.asDebugSourceUri(ie,fe)}},Mn={registerTaskProvider:(ie,fe)=>yt.registerTaskProvider(Ne,ie,fe),fetchTasks:ie=>yt.fetchTasks(ie),executeTask:ie=>yt.executeTask(Ne,ie),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(ie,fe,Ae)=>yt.onDidStartTask(ie,fe,Ae),onDidEndTask:(ie,fe,Ae)=>yt.onDidEndTask(ie,fe,Ae),onDidStartTaskProcess:(ie,fe,Ae)=>yt.onDidStartTaskProcess(ie,fe,Ae),onDidEndTaskProcess:(ie,fe,Ae)=>yt.onDidEndTaskProcess(ie,fe,Ae)},On={createNotebookController(ie,fe,Ae,ct,St){return tn.createNotebookController(Ne,ie,fe,Ae,ct,Ne.enableProposedApi?St:void 0)},registerNotebookCellStatusBarItemProvider:(ie,fe)=>bt.registerNotebookCellStatusBarItemProvider(Ne,ie,fe),get onDidSaveNotebookDocument(){return(0,W.checkProposedApiEnabled)(Ne),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ie){return(0,W.checkProposedApiEnabled)(Ne),jt.createNotebookEditorDecorationType(ie)},createRendererMessaging(ie){return nn.createRendererMessaging(Ne,ie)},onDidChangeNotebookDocumentMetadata(ie,fe,Ae){return(0,W.checkProposedApiEnabled)(Ne),Qt.onDidChangeNotebookDocumentMetadata(ie,fe,Ae)},onDidChangeNotebookCells(ie,fe,Ae){return(0,W.checkProposedApiEnabled)(Ne),bt.onDidChangeNotebookCells(ie,fe,Ae)},onDidChangeNotebookCellExecutionState(ie,fe,Ae){return(0,W.checkProposedApiEnabled)(Ne),bt.onDidChangeNotebookCellExecutionState(ie,fe,Ae)},onDidChangeCellOutputs(ie,fe,Ae){return(0,W.checkProposedApiEnabled)(Ne),bt.onDidChangeCellOutputs(ie,fe,Ae)},onDidChangeCellMetadata(ie,fe,Ae){return(0,W.checkProposedApiEnabled)(Ne),bt.onDidChangeCellMetadata(ie,fe,Ae)},createConcatTextDocument(ie,fe){return(0,W.checkProposedApiEnabled)(Ne),new Qe.ExtHostNotebookConcatDocument(bt,It,ie,fe)}};return{version:de.version,authentication:kn,commands:In,comments:Ln,debug:Fn,env:gn,extensions:Tn,languages:un,notebooks:On,scm:Rn,tasks:Mn,tests:Pn,window:An,workspace:vn,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:m.CancellationTokenSource,CandidatePortSource:c.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:N.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:N.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,InlineCompletionItem:N.InlineSuggestion,InlineCompletionList:N.InlineSuggestions,Hover:N.Hover,IndentAction:A.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TerminalLink:N.TerminalLink,TerminalLocation:N.TerminalLocation,TerminalProfile:N.TerminalProfile,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,TextDocumentChangeReason:N.TextDocumentChangeReason,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,TypeHierarchyItem:N.TypeHierarchyItem,UIKind:c.UIKind,Uri:R.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,InlayHint:N.InlayHint,InlayHintKind:N.InlayHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookRendererScript:N.NotebookRendererScript,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,NotebookControllerAffinity:N.NotebookControllerAffinity,PortAttributes:N.PortAttributes,LinkedEditingRanges:N.LinkedEditingRanges,TestResultState:N.TestResultState,TestRunRequest:N.TestRunRequest,TestMessage:N.TestMessage,TestTag:N.TestTag,TestRunProfileKind:N.TestRunProfileKind,TextSearchCompleteMessageType:Ie.TextSearchCompleteMessageType,CoveredCount:N.CoveredCount,FileCoverage:N.FileCoverage,StatementCoverage:N.StatementCoverage,BranchCoverage:N.BranchCoverage,FunctionCoverage:N.FunctionCoverage,WorkspaceTrustState:N.WorkspaceTrustState,LanguageStatusSeverity:N.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=ke}),define(me[276],ge([0,1,82,68,36,131,37,44,45,33,72,55,74,92,53,67,132,91,52,90,122,54]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g,y,I,_,s,o,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(g.IExtHostApiDeprecationService,g.ExtHostApiDeprecationService),(0,m.registerSingleton)(E.IExtHostCommands,E.ExtHostCommands),(0,m.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration),(0,m.registerSingleton)(I.IExtHostConsumerFileSystem,I.ExtHostConsumerFileSystem),(0,m.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService),(0,m.registerSingleton)(C.IExtHostDecorations,C.ExtHostDecorations),(0,m.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,m.registerSingleton)(_.IExtHostFileSystemInfo,_.ExtHostFileSystemInfo),(0,m.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,m.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch),(0,m.registerSingleton)(h.IExtHostStorage,h.ExtHostStorage),(0,m.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,m.registerSingleton)(A.IExtHostTerminalService,A.WorkerExtHostTerminalService),(0,m.registerSingleton)(d.IExtHostTunnelService,d.ExtHostTunnelService),(0,m.registerSingleton)(y.IExtHostWindow,y.ExtHostWindow),(0,m.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace),(0,m.registerSingleton)(s.IExtHostSecretState,s.ExtHostSecretState),(0,m.registerSingleton)(o.IExtHostTelemetry,o.ExtHostTelemetry),(0,m.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs)}),define(me[93],ge([0,1,17,12,31,71]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function R(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=R;function E(P,c,h,d){const g=(0,m.mapArrayOrNot)(h,S),y=new k.TextSearchMatch(c,g,d),I=y.preview.matches;return{ranges:(0,m.mapArrayOrNot)(g,A),uri:P,preview:{text:y.preview.text,matches:(0,m.mapArrayOrNot)(I,A)}}}e.createTextSearchResult=E;function S(P){return new k.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function A(P){return new C.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let n=class{constructor(c,h){this.prefix=c,this.logService=h}appendLine(c){this.logService.debug(`${this.prefix}#search`,c)}};n=Ve([$e(1,L.ILogService)],n),e.OutputChannel=n}),define(me[277],ge([0,1,96,23]),function(J,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(a=>a===t)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const C=512,R=512,E=512*8,S=512*128;class A{constructor(a){this.iconvLiteDecoder=a}static async create(a){let r;if(a!==e.UTF8)r=(await new Promise((l,u)=>{J(["iconv-lite-umd"],l,u)})).getDecoder(h(a));else{const i=new TextDecoder;r={write(l){return i.decode(l,{stream:!0})},end(){return i.decode()}}}return new A(r)}write(a){return this.iconvLiteDecoder.write(a)}end(){return this.iconvLiteDecoder.end()}}function n(t,a){const r=a.minBytesRequiredForDetection??a.guessEncoding?E:R;return new Promise((i,l)=>{const u=(0,m.newWriteableStream)(T=>T.join("")),f=[];let b=0,D;const w=async()=>{try{const T=await p({buffer:L.VSBuffer.concat(f),bytesRead:b},a.guessEncoding);T.encoding=await a.overwriteEncoding(T.encoding),D=await A.create(T.encoding);const v=D.write(L.VSBuffer.concat(f).buffer);u.write(v),f.length=0,b=0,i({stream:u,detected:T})}catch(T){l(T)}};(0,m.listenStream)(t,{onData:async T=>{D?u.write(D.write(T.buffer)):(f.push(T),b+=T.byteLength,b>=r&&(t.pause(),await w(),setTimeout(()=>t.resume())))},onError:T=>u.error(T),onEnd:async()=>{D||await w(),u.end(D?.end())}})})}e.toDecodeStream=n;async function P(t,a,r){const l=(await new Promise((b,D)=>{J(["iconv-lite-umd"],b,D)})).getEncoder(h(a),r);let u=!1,f=!1;return{read(){if(f)return null;const b=t.read();if(typeof b!="string"){if(f=!0,!u&&r?.addBOM)switch(a){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const D=l.end();return D&&D.length>0?(u=!0,L.VSBuffer.wrap(D)):null}return u=!0,L.VSBuffer.wrap(l.write(b))}}}e.toEncodeReadable=P;async function c(t){return(await new Promise((r,i)=>{J(["iconv-lite-umd"],r,i)})).encodingExists(h(t))}e.encodingExists=c;function h(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=h;function d(t,a){if(!t||a<e.UTF16be_BOM.length)return null;const r=t.readUInt8(0),i=t.readUInt8(1);if(r===e.UTF16be_BOM[0]&&i===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&i===e.UTF16le_BOM[1])return e.UTF16le;if(a<e.UTF8_BOM.length)return null;const l=t.readUInt8(2);return r===e.UTF8_BOM[0]&&i===e.UTF8_BOM[1]&&l===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=d;const g=["ascii","utf-16","utf-32"];async function y(t){const a=await new Promise((f,b)=>{J(["jschardet"],f,b)}),r=t.slice(0,S),i=s(r.buffer),l=a.detect(i);if(!l||!l.encoding)return null;const u=l.encoding.toLowerCase();return 0<=g.indexOf(u)?null:_(l.encoding)}const I={ibm866:"cp866",big5:"cp950"};function _(t){const a=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return I[a]||a}function s(t){let a="";for(let r=0;r<t.length;r++)a+=String.fromCharCode(t[r]);return a}function o(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const a=t.match(/windows(\d+)/);return a?"windows-"+a[1]:t}}e.toCanonicalName=o;function p({buffer:t,bytesRead:a},r){let i=d(t,a),l=!1;if(i!==e.UTF16be&&i!==e.UTF16le&&t){let u=!0,f=!0,b=!1;for(let D=0;D<a&&D<C;D++){const w=D%2==1,T=t.readUInt8(D)===0;if(T&&(b=!0),u&&(w&&!T||!w&&T)&&(u=!1),f&&(w&&T||!w&&!T)&&(f=!1),T&&!u&&!f)break}b&&(u?i=e.UTF16le:f?i=e.UTF16be:l=!0)}return r&&!l&&!i&&t?y(t.slice(0,a)).then(u=>({seemsBinary:!1,encoding:u})):{seemsBinary:l,encoding:i}}e.detectEncodingFromBuffer=p,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[134],ge([0,1,277,28,133]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class C extends k.TextSearchManager{constructor(E,S,A=L,n="searchProcess"){super(E,S,{readdir:P=>A.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,m.toCanonicalName)(P)},n)}}e.NativeTextSearchManager=C}),define(me[278],ge([0,1,279,294,295,2,296]),function(J,e,m,L,k,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function E(P,c,h,d,g,y){const I=y.environment.useHostProxy,_=typeof I=="boolean"?I:!y.remote.isRemote,s=(0,R.createProxyResolver)({resolveProxy:p=>P.resolveProxy(p),getHttpProxySetting:()=>c.getConfiguration("http").get("proxy"),log:(p,t,...a)=>{switch(p){case R.LogLevel.Trace:d.trace(t,...a);break;case R.LogLevel.Debug:d.debug(t,...a);break;case R.LogLevel.Info:d.info(t,...a);break;case R.LogLevel.Warning:d.warn(t,...a);break;case R.LogLevel.Error:d.error(t,...a);break;case R.LogLevel.Critical:d.critical(t,...a);break;case R.LogLevel.Off:break;default:r(p,t,a);break}function r(i,l,...u){d.error("Unknown log level",i),d.error(l,...u)}},getLogLevel:()=>d.getLevel(),proxyResolveTelemetry:p=>{g.$publicLog2("resolveProxy",p)},useHostProxy:_,env:process.env}),o=S(c,s);return n(h,o)}e.connectProxyResolver=E;function S(P,c){const h={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(g=>{h.config=P.getConfiguration("http").get("proxySupport")||"off"});const d={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(g=>{d.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},m,(0,R.createHttpPatch)(m,c,{config:"off"},d,!0)),on:Object.assign({},m,(0,R.createHttpPatch)(m,c,{config:"on"},d,!0)),override:Object.assign({},m,(0,R.createHttpPatch)(m,c,{config:"override"},d,!0)),onRequest:Object.assign({},m,(0,R.createHttpPatch)(m,c,h,d,!0)),default:Object.assign(m,(0,R.createHttpPatch)(m,c,h,d,!1))},https:{off:Object.assign({},L,(0,R.createHttpPatch)(L,c,{config:"off"},d,!0)),on:Object.assign({},L,(0,R.createHttpPatch)(L,c,{config:"on"},d,!0)),override:Object.assign({},L,(0,R.createHttpPatch)(L,c,{config:"override"},d,!0)),onRequest:Object.assign({},L,(0,R.createHttpPatch)(L,c,h,d,!0)),default:Object.assign(L,(0,R.createHttpPatch)(L,c,h,d,!1))},tls:Object.assign(k,(0,R.createTlsPatch)(k))}}const A=new Map;function n(P,c){return P.getExtensionPathIndex().then(h=>{const d=J.__$__nodeRequire("module"),g=d._load;d._load=function(I,_,s){if(I==="tls")return c.tls;if(I!=="http"&&I!=="https")return g.apply(this,arguments);const o=c[I],p=h.findSubstr(C.URI.file(_.filename).fsPath);let t=A.get(p);if(t||A.set(p,t={}),!t[I]){let a=o.default;p&&p.enableProposedApi&&(a=o[p.proxySupport]||o.onRequest),t[I]={...a}}return t[I]}})}}),define(me[280],ge([0,1,39,8,78,29,11,9,93,281]),function(J,e,m,L,k,C,R,E,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const n=A.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(s,o,p,t){const a=c(s,o,p,t),r=o.folder.fsPath;return{cmd:m.spawn(n,a.args,{cwd:r}),rgDiskPath:n,siblingClauses:a.siblingClauses,rgArgs:a,cwd:r}}e.spawnRipgrepCmd=P;function c(s,o,p,t){const a=["--files","--hidden","--case-sensitive"];d([o],p,!1).forEach(i=>{const l=(0,S.anchorGlob)(i);if(a.push("-g",l),R.isMacintosh){const u=(0,k.normalizeNFD)(l);u!==l&&a.push("-g",u)}});const r=h([o],t,void 0,!1);return r.globArgs.forEach(i=>{const l=`!${(0,S.anchorGlob)(i)}`;if(a.push("-g",l),R.isMacintosh){const u=(0,k.normalizeNFD)(l);u!==l&&a.push("-g",u)}}),o.disregardIgnoreFiles!==!1?a.push("--no-ignore"):a.push("--no-ignore-parent"),o.ignoreSymlinks||a.push("--follow"),s.exists&&a.push("--quiet"),a.push("--no-config"),o.disregardGlobalIgnoreFiles&&a.push("--no-ignore-global"),{args:a,siblingClauses:r.siblingClauses}}function h(s,o,p,t=!0){const a=[];let r={};return s.forEach(i=>{const l=Object.assign({},i.excludePattern||{},o||{}),u=g(l,t?i.folder.fsPath:void 0,p);a.push(...u.globArgs),u.siblingClauses&&(r=Object.assign(r,u.siblingClauses))}),{globArgs:a,siblingClauses:r}}e.foldersToRgExcludeGlobs=h;function d(s,o,p=!0){const t=[];return s.forEach(a=>{const r=Object.assign({},o||{},a.includePattern||{}),i=g(r,p?a.folder.fsPath:void 0);t.push(...i.globArgs)}),t}e.foldersToIncludeGlobs=d;function g(s,o,p){const t=[],a={};return Object.keys(s).forEach(r=>{if(p&&p.has(r)||!r)return;const i=s[r];r=I(o?y(o,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof i=="boolean"&&i?(r.startsWith("\\\\")&&(r+="**"),t.push(_(r))):i&&i.when&&(a[r]=i)}),{globArgs:t,siblingClauses:a}}function y(s,o){return L.isAbsolute(o)?o:L.join(s,o)}e.getAbsoluteGlob=y;function I(s){return s=E.rtrim(s,"\\"),E.rtrim(s,"/")}function _(s){return C.getRoot(s).toLowerCase()==="c:/"?s.replace(/^c:[/\\]/i,"/"):s}e.fixDriveC=_}),define(me[282],ge([0,1,39,50,8,104,17,61,30,78,29,11,46,9,13,28,31,280,101]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g,y,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const s=new Set;process.on("exit",()=>{s.forEach(r=>r())});class o{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&S.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,_.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&S.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(l=>{const u=Object.assign({},l.excludePattern||{},this.config.excludePattern||{}),f=l.folder.fsPath;i.folderQueries.map(b=>b.folder.fsPath).filter(b=>b!==f).forEach(b=>{(0,n.isEqualOrParent)(b,f)&&(u[k.relative(f,b)]=!0)}),this.folderExcludePatterns.set(f,new t(u,f))})}cancel(){this.isCanceled=!0}walk(i,l,u,f,b){if(this.fileWalkSW=c.StopWatch.create(!1),this.isCanceled)return b(null,this.isLimitHit);l.forEach(D=>{const w=k.basename(D.fsPath);this.globalExcludePattern&&this.globalExcludePattern(D.fsPath,w)||this.matchFile(u,{relativePath:D.fsPath,searchPath:void 0})}),this.cmdSW=c.StopWatch.create(!1),this.parallel(i,(D,w)=>{this.call(this.cmdTraversal,this,D,u,f,T=>{if(T){const v=(0,E.toErrorMessage)(T);console.error(v),this.errors.push(v),w(T,void 0)}else w(null,void 0)})},(D,w)=>{this.fileWalkSW.stop();const T=D?R.coalesce(D)[0]:null;b(T,this.isLimitHit)})}parallel(i,l,u){const f=new Array(i.length),b=new Array(i.length);let D=!1,w=0;if(i.length===0)return u(null,[]);i.forEach((T,v)=>{l(T,(F,M)=>{if(F?(D=!0,f[v]=null,b[v]=F):(f[v]=M,b[v]=null),++w===i.length)return u(D?b:null,f)})})}call(i,l,...u){try{i.apply(l,u)}catch(f){u[u.length-1](f)}}cmdTraversal(i,l,u,f){const b=i.folder.fsPath,D=P.isMacintosh;let w;const T=()=>w&&w.kill();s.add(T);let v=N=>{s.delete(T),v=()=>{},f(N)},F="";const M=this.initDirectoryTree();let G;const K=(0,I.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);w=K.cmd,G=!Object.keys(K.siblingClauses).length;const U=K.rgArgs.args.map(N=>N.match(/^-/)?N:`'${N}'`).join(" ");let z=`${K.rgDiskPath} ${U}
 - cwd: ${K.cwd}`;K.rgArgs.siblingClauses&&(z+=`
 - Sibling clauses: ${JSON.stringify(K.rgArgs.siblingClauses)}`),u({message:z}),this.cmdResultCount=0,this.collectStdout(w,"utf8",u,(N,x,B)=>{if(N){v(N);return}if(this.isLimitHit){v();return}const H=(F+(D?A.normalizeNFC(x||""):x)).split(`
`);if(B){const W=H.length;H[W-1]=H[W-1].trim(),H[W-1]||H.pop()}else F=H.pop()||"";if(H.length&&H[0].indexOf(`
`)!==-1){v(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=H.length,G){for(const W of H)if(this.matchFile(l,{base:b,relativePath:W,searchPath:this.getSearchPath(i,W)}),this.isLimitHit){T();break}(B||this.isLimitHit)&&v();return}this.addDirectoryEntries(i,M,b,H,l),B&&(this.matchDirectoryTree(M,b,l),v())})}spawnFindCmd(i){const l=this.folderExcludePatterns.get(i.folder.fsPath),u=l.getBasenameTerms(),f=l.getPathTerms(),b=["-L","."];if(u.length||f.length){b.push("-not","(","(");for(const D of u)b.push("-name",D),b.push("-o");for(const D of f)b.push("-path",D),b.push("-o");b.pop(),b.push(")","-prune",")")}return b.push("-type","f"),m.spawn("find",b,{cwd:i.folder.fsPath})}readStdout(i,l,u){let f="";this.collectStdout(i,l,()=>{},(b,D,w)=>{if(b){u(b);return}f+=D,w&&u(null,f)})}collectStdout(i,l,u,f){let b=(T,v,F)=>{(T||F)&&(b=()=>{},this.cmdSW&&this.cmdSW.stop()),f(T,v,F)},D=!1;i.stdout?(this.forwardData(i.stdout,l,b),i.stdout.once("data",()=>D=!0)):u({message:"stdout is null"});let w;i.stderr?w=this.collectData(i.stderr):u({message:"stderr is null"}),i.on("error",T=>{b(T)}),i.on("close",T=>{let v;!D&&(v=this.decodeData(w,l))&&a(v)?b(new Error(`command failed with error code ${T}: ${this.decodeData(w,l)}`)):(this.exists&&T===0&&(this.isLimitHit=!0),b(null,"",!0))})}forwardData(i,l,u){const f=new C.StringDecoder(l);return i.on("data",b=>{u(null,f.write(b))}),f}collectData(i){const l=[];return i.on("data",u=>{l.push(u)}),l}decodeData(i,l){const u=new C.StringDecoder(l);return i.map(f=>u.write(f)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:l},u,f,b){f.indexOf(this.filePattern)!==-1&&this.matchFile(b,{base:u,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const D=w=>{const T=k.basename(w),v=k.dirname(w);let F=l[v];F||(F=l[v]=[],D(v)),F.push({base:u,relativePath:w,basename:T,searchPath:this.getSearchPath(i,w)})};f.forEach(D)}matchDirectoryTree({rootEntries:i,pathToEntries:l},u,f){const b=this,D=this.folderExcludePatterns.get(u),w=this.filePattern;function T(v){b.directoriesWalked++;const F=S.hasSiblingFn(()=>v.map(M=>M.basename));for(let M=0,G=v.length;M<G;M++){const K=v[M],{relativePath:U,basename:z}=K;if(D.test(U,z,w!==z?F:void 0))continue;const N=l[U];if(N)T(N);else{if(b.filesWalked++,U===w)continue;b.matchFile(f,K)}if(b.isLimitHit)break}}T(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,l,u,f,b){const D=i.folder,w=S.hasSiblingFn(()=>u);this.parallel(u,(T,v)=>{if(this.isCanceled||this.isLimitHit)return v(null);const F=l?[l,T].join(k.sep):T;if(this.folderExcludePatterns.get(i.folder.fsPath).test(F,T,this.config.filePattern!==T?w:void 0))return v(null);const M=[D.fsPath,F].join(k.sep);L.lstat(M,(G,K)=>{if(G||this.isCanceled||this.isLimitHit)return v(null);this.statLinkIfNeeded(M,K,(U,z)=>U||this.isCanceled||this.isLimitHit?v(null):z.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(M,K,(N,x)=>N||this.isCanceled||this.isLimitHit||(x=x||"",this.walkedPaths[x])?v(null):(this.walkedPaths[x]=!0,g.Promises.readdir(M).then(B=>{if(this.isCanceled||this.isLimitHit)return v(null);this.doWalk(i,F,B,f,O=>v(O||null))},B=>{v(null)})))):(this.filesWalked++,F===this.filePattern||this.maxFilesize&&d.isNumber(z.size)&&z.size>this.maxFilesize||this.matchFile(f,{base:D.fsPath,relativePath:F,searchPath:this.getSearchPath(i,F)}),v(null,void 0)))})},T=>{const v=T&&R.coalesce(T);return b(v&&v.length>0?v[0]:void 0)})}matchFile(i,l){this.isFileMatch(l)&&(!this.includePattern||this.includePattern(l.relativePath,k.basename(l.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(l))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,y.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,l,u){return l.isSymbolicLink()?L.stat(i,u):u(null,l)}realPathIfNeeded(i,l,u){return l.isSymbolicLink()?L.realpath(i,(f,b)=>f?u(f):u(null,b)):u(null,i)}getSearchPath(i,l){return i.folderName?k.join(i.folderName,l):l}}e.FileWalker=o;class p{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new o(i)}search(i,l,u){this.walker.walk(this.folderQueries,this.extraFiles,i,l,(f,b)=>{u(f,{limitHit:b,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=p;class t{constructor(i,l){this.expression=i,this.root=l,this.init(i)}init(i){let l,u;Object.keys(i).filter(f=>i[f]).forEach(f=>{k.isAbsolute(f)?(l=l||S.getEmptyExpression(),l[f]=i[f]):(u=u||S.getEmptyExpression(),u[f]=i[f])}),this.absoluteParsedExpr=l&&S.parse(l,{trimForExclusions:!0}),this.relativeParsedExpr=u&&S.parse(u,{trimForExclusions:!0})}test(i,l,u){return this.relativeParsedExpr&&this.relativeParsedExpr(i,l,u)||this.absoluteParsedExpr&&this.absoluteParsedExpr(k.join(this.root,i),l,u)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...S.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...S.getPathTerms(this.relativeParsedExpr)),i}}function a(r){const i=r.trim().split(`
`),l=i[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return h.uppercaseFirstLetter(i[i.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}e.rgErrorMsgForDisplay=a}),define(me[135],ge([0,1,39,297,104,17,57,30,8,9,2,31,71,298,281,93]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const y=d.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class I{constructor(D){this.outputChannel=D}provideTextSearchResults(D,w,T,v){return this.outputChannel.appendLine(`provideTextSearchResults ${D.pattern}, ${JSON.stringify({...w,folder:w.folder.toString()})}`),new Promise((F,M)=>{v.onCancellationRequested(()=>O());const G=a(D,w),K=w.folder.fsPath,U=G.map(he=>he.match(/^-/)?he:`'${he}'`).join(" ");this.outputChannel.appendLine(`${y} ${U}
 - cwd: ${K}`);let z=m.spawn(y,G,{cwd:K});z.on("error",he=>{console.error(he),this.outputChannel.appendLine("Error: "+(he&&he.message)),M((0,P.serializeSearchError)(new P.SearchError(he&&he.message,P.SearchErrorCode.rgProcessError)))});let N=!1;const x=new o(w.maxResults,K,w.previewOptions);x.on("result",he=>{N=!0,W="",T.report(he)});let B=!1;const O=()=>{B=!0,z&&z.kill(),x&&x.cancel()};let H=!1;x.on("hitLimit",()=>{H=!0,O()});let W="";z.stdout.on("data",he=>{x.handleData(he),N||(W+=he)});let Q=!1;z.stdout.once("data",()=>Q=!0);let Y="";z.stderr.on("data",he=>{const _e=he.toString();this.outputChannel.appendLine(_e),Y+=_e}),z.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(N?"Got result from parser":"No result from parser"),W&&this.outputChannel.appendLine(`Got data without result: ${W}`),this.outputChannel.appendLine(""),B)F({limitHit:H});else{x.flush(),z=null;let he;Y&&!Q&&(he=_(Y))?M((0,P.serializeSearchError)(new P.SearchError(he.message,he.code))):F({limitHit:H})}})})}}e.RipgrepTextSearchEngine=I;function _(b){const D=b.split(`
`),w=D[0].trim();if(D.some(v=>v.startsWith("regex parse error")))return new P.SearchError(s(D),P.SearchErrorCode.regexParseError);const T=w.match(/grep config error: unknown encoding: (.*)/);if(T)return new P.SearchError(`Unknown encoding: ${T[1]}`,P.SearchErrorCode.unknownEncoding);if(w.startsWith("error parsing glob"))return new P.SearchError(w.charAt(0).toUpperCase()+w.substr(1),P.SearchErrorCode.globParseError);if(w.startsWith("the literal"))return new P.SearchError(w.charAt(0).toUpperCase()+w.substr(1),P.SearchErrorCode.invalidLiteral);if(w.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(w,P.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=_;function s(b){const D=["Regex parse error"],w=b.filter(T=>T.startsWith("PCRE2:"));if(w.length>=1){const T=w[0].replace("PCRE2:","");if(T.indexOf(":")!==-1&&T.split(":").length>=2){const v=T.split(":")[1];D.push(":"+v)}}return D.join("")}e.buildRegexParseError=s;class o extends L.EventEmitter{constructor(D,w,T){super();this.maxResults=D,this.rootFolder=w,this.previewOptions=T,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new k.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(D,w){return super.on(D,w),this}handleData(D){if(this.isDone)return;const w=typeof D=="string"?D:this.stringDecoder.write(D);this.handleDecodedData(w)}handleDecodedData(D){let w=D.indexOf(`
`);const T=this.remainder+D;if(w>=0)w+=this.remainder.length;else{this.remainder=T;return}let v=0;for(;w>=0;)this.handleLine(T.substring(v,w).trim()),v=w+1,w=T.indexOf(`
`,v);this.remainder=T.substring(v)}handleLine(D){if(this.isDone||!D)return;let w;try{w=JSON.parse(D)}catch(T){throw new Error(`malformed line from rg: ${D}`)}if(w.type==="match"){const T=p(w.data.path),v=n.URI.file(S.join(this.rootFolder,T)),F=this.createTextSearchMatch(w.data,v);this.onResult(F),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(w.type==="context"){const T=p(w.data.path),v=n.URI.file(S.join(this.rootFolder,T));this.createTextSearchContext(w.data,v).forEach(M=>this.onResult(M))}}createTextSearchMatch(D,w){const T=D.line_number-1,v=p(D.lines),F=Buffer.from(v);let M=0,G=0,K=T;D.submatches.length===0&&D.submatches.push(v.length?{start:0,end:1,match:{text:v[0]}}:{start:0,end:0,match:{text:""}});const U=(0,C.coalesce)(D.submatches.map((z,N)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const x=p(z.match),B=F.slice(M,z.start).toString().length,O=G+B,H=t(x),W=K,Q=H.numLines+W,Y=H.numLines>0?H.lastLineLength:H.lastLineLength+O;return M=z.end,G=Y,K=Q,new c.Range(W,O,Q,Y)}));return(0,g.createTextSearchResult)(w,v,U,this.previewOptions)}createTextSearchContext(D,w){const T=p(D.lines),v=D.line_number;return T.replace(/\r?\n$/,"").split(`
`).map((F,M)=>({text:F,uri:w,lineNumber:v+M}))}onResult(D){this.emit("result",D)}}e.RipgrepParser=o;function p(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function t(b){const D=/\n/g;let w=0,T=-1,v;for(;v=D.exec(b);)w++,T=v.index;const F=T>=0?b.length-T-1:b.length;return{numLines:w,lastLineLength:F}}function a(b,D){const w=["--hidden"];w.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:T,otherIncludes:v}=(0,R.groupBy)(D.includes,M=>M.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(v&&v.length){const M=new Set;v.forEach(G=>{M.add(G)}),w.push("-g","!*"),M.forEach(G=>{r(G).map(g.anchorGlob).forEach(K=>{w.push("-g",K)})})}T&&T.length&&T.forEach(M=>{w.push("-g",M)}),D.excludes.map(g.anchorGlob).forEach(M=>w.push("-g",`!${M}`)),D.maxFileSize&&w.push("--max-filesize",D.maxFileSize+""),D.useIgnoreFiles?w.push("--no-ignore-parent"):w.push("--no-ignore"),D.followSymlinks&&w.push("--follow"),D.encoding&&D.encoding!=="utf8"&&w.push("--encoding",D.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,A.escapeRegExpCharacters)(b.pattern),b.isRegExp=!0),D.usePCRE2&&w.push("--pcre2"),w.push("--crlf"),b.isRegExp&&(b.pattern=i(b.pattern),w.push("--auto-hybrid-regex"));let F;if(b.isWordMatch){const G=(0,A.createRegExp)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");w.push("--regexp",G)}else if(b.isRegExp){let M=u(b.pattern);M=f(M),w.push("--regexp",M)}else F=b.pattern,w.push("--fixed-strings");return w.push("--no-config"),D.useGlobalIgnoreFiles||w.push("--no-ignore-global"),w.push("--json"),b.isMultiline&&w.push("--multiline"),D.beforeContext&&w.push("--before-context",D.beforeContext+""),D.afterContext&&w.push("--after-context",D.afterContext+""),w.push("--"),F&&w.push(F),w.push("."),w}function r(b){const D=(0,E.splitGlobAware)(b,"/");return D.map((w,T)=>D.slice(0,T+1).join("/"))}e.spreadGlobComponents=r;function i(b){const D=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(D);)b=b.replace(D,"$1\\x{$2}");const w=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(w);)b=b.replace(w,"$1\\x{$2}");return b}e.unicodeEscapesToPCRE2=i;const l=b=>b.type==="Assertion"&&b.kind==="lookbehind";function u(b){let D;try{D=new h.RegExpParser().parsePattern(b)}catch{return b}let w="",T=0;const v=(G,K,U)=>{w+=b.slice(T,G)+U,T=K},F=[];return new h.RegExpVisitor({onCharacterEnter(G){if(G.raw!=="\\n")return;const K=F[0];if(!K)v(G.start,G.end,"\\r?\\n");else if(!F.some(l))if(K.type==="CharacterClass")if(K.negate){const U=b.slice(K.start+2,G.start)+b.slice(G.end,K.end-1);v(K.start,K.end,"(?!\\r?\\n"+(U?`|[${U}]`:"")+")")}else{const U=b.slice(K.start+1,G.start)+b.slice(G.end,K.end-1);v(K.start,K.end,U===""?"\\r?\\n":`(?:[${U}]|\\r?\\n)`)}else K.type==="Quantifier"&&v(G.start,G.end,"(?:\\r?\\n)")},onQuantifierEnter(G){F.unshift(G)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(G){F.unshift(G)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(G){F.unshift(G)},onCharacterClassLeave(){F.shift()},onAssertionEnter(G){l(G)&&F.push(G)},onAssertionLeave(G){F[0]===G&&F.shift()}}).visit(D),w+=b.slice(T),w}e.fixRegexNewline=u;function f(b){return b.replace(/\n/g,"\\r?\\n")}e.fixNewline=f}),define(me[283],ge([0,1,21,135,118,10]),function(J,e,m,L,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class R{constructor(A){this.outputChannel=A,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(A,n,P,c){const h=new L.RipgrepTextSearchEngine(this.outputChannel);if(n.folder.scheme===C.Schemas.userData){const d={...n,folder:n.folder.with({scheme:C.Schemas.file})},g=new k.Progress(y=>P.report({...y,uri:y.uri.with({scheme:n.folder.scheme})}));return this.withToken(c,y=>h.provideTextSearchResults(A,d,g,y))}else return this.withToken(c,d=>h.provideTextSearchResults(A,n,P,d))}async withToken(A,n){const P=E(A);this.inProgress.add(P);const c=await n(P.token);return this.inProgress.delete(P),c}dispose(){this.inProgress.forEach(A=>A.cancel())}}e.RipgrepSearchProvider=R;function E(S){const A=new m.CancellationTokenSource;return S.onCancellationRequested(()=>A.cancel()),A}}),define(me[284],ge([0,1,28,135,134]),function(J,e,m,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class C{constructor(S){this.query=S}search(S,A,n){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(h){n({message:h})}},c=new k.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(P),m);return new Promise((h,d)=>c.search(g=>{A(g.map(R))},S).then(g=>h({limitHit:g.limitHit,type:"success",stats:g.stats}),d))}}e.TextSearchEngineAdapter=C;function R(E){return{path:E.resource&&E.resource.fsPath,results:E.results,numMatches:(E.results||[]).reduce((S,A)=>{if(A.ranges){const n=A;return S+(Array.isArray(n.ranges)?n.ranges.length:1)}else return S+1},0)}}}),define(me[285],ge([0,1,50,299,17,18,16,3,101,8,46,2,42,31,282,284]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,L.gracefulify(m);class y{constructor(t="searchProcess"){this.processType=t,this.caches=Object.create(null)}fileSearch(t){let a;const r=s(t),i=new E.Emitter({onFirstListenerDidAdd:()=>{a=(0,C.createCancelablePromise)(l=>this.doFileSearchWithEngine(d.Engine,r,u=>i.fire(u),l)),a.then(l=>i.fire(l),l=>i.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onLastListenerRemove:()=>{a.cancel()}});return i.event}textSearch(t){let a;const r=s(t),i=new E.Emitter({onFirstListenerDidAdd:()=>{a=(0,C.createCancelablePromise)(l=>this.ripgrepTextSearch(r,u=>i.fire(u),l)),a.then(l=>i.fire(l),l=>i.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onLastListenerRemove:()=>{a.cancel()}});return i.event}ripgrepTextSearch(t,a,r){return t.maxFileSize=(0,c.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new g.TextSearchEngineAdapter(t).search(r,a,a)}doFileSearch(t,a,r){return this.doFileSearchWithEngine(d.Engine,t,a,r)}doFileSearchWithEngine(t,a,r,i,l=y.BATCH_SIZE){let u=0;const f=D=>{Array.isArray(D)?(u+=D.length,r(D.map(w=>this.rawMatchToSearchItem(w)))):D.relativePath?(u++,r(this.rawMatchToSearchItem(D))):r(D)};if(a.sortByScore){let D=this.trySortedSearchFromCache(a,f,i);if(!D){const w=a.maxResults?Object.assign({},a,{maxResults:null}):a,T=new t(w);D=this.doSortedSearch(T,a,r,f,i)}return new Promise((w,T)=>{D.then(([v,F])=>{const M=F.map(G=>this.rawMatchToSearchItem(G));this.sendProgress(M,r,l),w(v)},T)})}const b=new t(a);return this.doSearch(b,f,l,i).then(D=>({limitHit:D.limitHit,type:"success",stats:{detailStats:D.stats,type:this.processType,fromCache:!1,resultCount:u,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,A.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,a,r,i,l){const u=new E.Emitter;let f=(0,C.createCancelablePromise)(D=>{let w=[];const T=v=>{Array.isArray(v)?w=v:(i(v),u.fire(v))};return this.doSearch(t,T,-1,D).then(v=>[v,w])}),b;if(a.cacheKey){b=this.getOrCreateCache(a.cacheKey);const D={promise:f,event:u.event,resolved:!1};b.resultsToSearchCache[a.filePattern||""]=D,f.then(()=>{D.resolved=!0},w=>{delete b.resultsToSearchCache[a.filePattern||""]}),f=this.preventCancellation(f)}return f.then(([D,w])=>{const T=b?b.scorerCache:Object.create(null),v=(typeof a.maxResults!="number"||a.maxResults>0)&&n.StopWatch.create(!1);return this.sortResults(a,w,T,l).then(F=>{const M=v?v.elapsed():-1;return[{type:"success",stats:{detailStats:D.stats,sortingTime:M,fromCache:!1,type:this.processType,workspaceFolderCount:a.folderQueries.length,resultCount:F.length},messages:D.messages,limitHit:D.limitHit||typeof a.maxResults=="number"&&w.length>a.maxResults},F]})})}getOrCreateCache(t){const a=this.caches[t];return a||(this.caches[t]=new I)}trySortedSearchFromCache(t,a,r){const i=t.cacheKey&&this.caches[t.cacheKey];if(!i)return;const l=this.getResultsFromCache(i,t.filePattern||"",a,r);if(l)return l.then(([u,f,b])=>{const D=n.StopWatch.create(!1);return this.sortResults(t,f,i.scorerCache,r).then(w=>{const T=D.elapsed(),v={fromCache:!0,detailStats:b,type:this.processType,resultCount:f.length,sortingTime:T};return[{type:"success",limitHit:u.limitHit||typeof t.maxResults=="number"&&f.length>t.maxResults,stats:v},w]})})}sortResults(t,a,r,i){const l=(0,S.prepareQuery)(t.filePattern||""),u=(b,D)=>(0,S.compareItemsByFuzzyScore)(b,D,l,!0,_,r),f=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return k.topAsync(a,u,f,1e4,i)}sendProgress(t,a,r){if(r&&r>0)for(let i=0;i<t.length;i+=r)a(t.slice(i,i+r));else a(t)}getResultsFromCache(t,a,r,i){const l=n.StopWatch.create(!1),u=a.indexOf(A.sep)>=0;let f;for(const T in t.resultsToSearchCache)if(a.startsWith(T)){if(u&&T.indexOf(A.sep)<0&&T!=="")continue;const v=t.resultsToSearchCache[T];f={promise:this.preventCancellation(v.promise),event:v.event,resolved:v.resolved};break}if(!f)return null;const b=l.elapsed(),D=n.StopWatch.create(!1),w=f.event(r);return i&&i.onCancellationRequested(()=>{w.dispose()}),f.promise.then(([T,v])=>{if(i&&i.isCancellationRequested)throw(0,R.canceled)();const F=[],M=(0,S.prepareQuery)(a).normalizedLowercase;for(const G of v)!(0,h.isFilePatternMatch)(G,M)||F.push(G);return[T,F,{cacheWasResolved:f.resolved,cacheLookupTime:b,cacheFilterTime:D.elapsed(),cacheEntryCount:v.length}]})}doSearch(t,a,r,i){return new Promise((l,u)=>{let f=[];i&&i.onCancellationRequested(()=>t.cancel()),t.search(b=>{b&&(r?(f.push(b),r>0&&f.length>=r&&(a(f),f=[])):a(b))},b=>{a(b)},(b,D)=>{f.length&&a(f),b?u(b):l(D)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,r){return t.then(a,r)}catch(a){return this.then(void 0,a)}finally(a){return t.finally(a)}}}}e.SearchService=y,y.BATCH_SIZE=512;class I{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const _=new class{getItemLabel(p){return(0,A.basename)(p.relativePath)}getItemDescription(p){return(0,A.dirname)(p.relativePath)}getItemPath(p){return p.relativePath}};function s(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(o),extraFileResources:p.extraFileResources&&p.extraFileResources.map(t=>P.URI.revive(t))}}function o(p){return{...p,folder:P.URI.revive(p.folder)}}}),define(me[286],ge([0,1,6,10,2,28,12,27,14,74,65,31,285,283,93,134]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let y=class extends A.ExtHostSearch{constructor(_,s,o,p){super(_,o,p);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const t=new d.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(L.Schemas.userData,new h.RipgrepSearchProvider(t)),s.remote.isRemote&&s.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const _=new d.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(L.Schemas.file,new h.RipgrepSearchProvider(_)),this.registerInternalFileSearchProvider(L.Schemas.file,new c.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(_,s){const o=this._handlePool++;return this._internalFileSearchProvider=s,this._internalFileSearchHandle=o,this._proxy.$registerFileSearchProvider(o,this._transformScheme(_)),(0,m.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(_,s,o,p){const t=(0,A.reviveQuery)(o);return _===this._internalFileSearchHandle?this.doInternalFileSearch(_,s,t,p):super.$provideFileSearchResults(_,s,o,p)}doInternalFileSearch(_,s,o,p){const t=a=>{if((0,P.isSerializedFileMatch)(a)&&(a=[a]),Array.isArray(a)){this._proxy.$handleFileMatch(_,s,a.map(r=>k.URI.file(r.path)));return}a.message&&this._logService.debug("ExtHostSearch",a.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(o,t,p)}$clearCache(_){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(_),super.$clearCache(_)}createTextSearchManager(_,s){return new g.NativeTextSearchManager(_,s,void 0,"textSearchProvider")}};y=Ve([$e(0,S.IExtHostRpcService),$e(1,E.IExtHostInitDataService),$e(2,n.IURITransformerService),$e(3,R.ILogService)],y),e.NativeExtHostSearch=y}),define(me[136],ge([0,1,300,125,80,23,16,3,6,8,11,32,106,107,301]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(f){this.socket=f,this._errorListener=b=>{if(b){if(b.code==="EPIPE")return;(0,R.onUnexpectedError)(b)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(f){const b=D=>f(C.VSBuffer.wrap(D));return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(f){const b=D=>{f({type:0,hadError:D,error:void 0})};return this.socket.on("close",b),{dispose:()=>this.socket.off("close",b)}}onEnd(f){return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(f){if(!this.socket.destroyed)try{this.socket.write(f.buffer,b=>{if(b){if(b.code==="EPIPE")return;(0,R.onUnexpectedError)(b)}})}catch(b){if(b.code==="EPIPE")return;(0,R.onUnexpectedError)(b)}}end(){this.socket.end()}drain(){return new Promise((f,b)=>{if(this.socket.bufferSize===0){f();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),f()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=g;var y;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var I;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(I||(I={}));class _ extends S.Disposable{constructor(f,b,D,w){super();this._onDidZlibFlush=this._register(new E.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new E.Emitter),this._onClose=this._register(new E.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=f,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=b,this._recordInflateBytes=w,b?(this._zlibInflate=d.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",T=>{console.error(T),(0,R.onUnexpectedError)(T),this._onClose.fire({type:0,hadError:!0,error:T})}),this._zlibInflate.on("data",T=>{this._pendingInflateData.push(T)}),D&&(this._zlibInflate.write(D.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",T=>{console.error(T),(0,R.onUnexpectedError)(T),this._onClose.fire({type:0,hadError:!0,error:T})}),this._zlibDeflate.on("data",T=>{this._pendingDeflateData.push(T)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new h.ChunkStream,this._register(this.socket.onData(T=>this._acceptChunk(T))),this._register(this.socket.onClose(T=>this._onClose.fire(T)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this._onData.event(f)}onClose(f){return this._onClose.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){this._totalOutgoingDataBytes+=f.byteLength,this._zlibDeflate?(this._zlibDeflate.write(f.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let b=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,b=b.slice(0,b.length-4),this._isEnded||this._write(C.VSBuffer.wrap(b),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(f,!1)}_write(f,b){let D=2;f.byteLength<126?D+=0:f.byteLength<2**16?D+=2:D+=8;const w=C.VSBuffer.alloc(D);if(b?w.writeUInt8(194,0):w.writeUInt8(130,0),f.byteLength<126)w.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){w.writeUInt8(126,1);let T=1;w.writeUInt8(f.byteLength>>>8&255,++T),w.writeUInt8(f.byteLength>>>0&255,++T)}else{w.writeUInt8(127,1);let T=1;w.writeUInt8(0,++T),w.writeUInt8(0,++T),w.writeUInt8(0,++T),w.writeUInt8(0,++T),w.writeUInt8(f.byteLength>>>24&255,++T),w.writeUInt8(f.byteLength>>>16&255,++T),w.writeUInt8(f.byteLength>>>8&255,++T),w.writeUInt8(f.byteLength>>>0&255,++T)}this._totalOutgoingWireBytes+=w.byteLength+f.byteLength,this.socket.write(C.VSBuffer.concat([w,f]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(f){if(f.byteLength!==0){for(this._totalIncomingWireBytes+=f.byteLength,this._incomingData.acceptChunk(f);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const b=this._incomingData.peek(this._state.readLen),w=(b.readUInt8(0)&128)>>>7,T=b.readUInt8(1),v=(T&128)>>>7,F=T&127;this._state.state=2,this._state.readLen=2+(v?4:0)+(F===126?2:0)+(F===127?8:0),this._state.fin=w,this._state.mask=0}else if(this._state.state===2){const b=this._incomingData.read(this._state.readLen),D=b.readUInt8(1),w=(D&128)>>>7;let T=D&127,v=1;T===126?T=b.readUInt8(++v)*2**8+b.readUInt8(++v):T===127&&(T=b.readUInt8(++v)*0+b.readUInt8(++v)*0+b.readUInt8(++v)*0+b.readUInt8(++v)*0+b.readUInt8(++v)*2**24+b.readUInt8(++v)*2**16+b.readUInt8(++v)*2**8+b.readUInt8(++v));let F=0;w&&(F=b.readUInt8(++v)*2**24+b.readUInt8(++v)*2**16+b.readUInt8(++v)*2**8+b.readUInt8(++v)),this._state.state=3,this._state.readLen=T,this._state.mask=F}else if(this._state.state===3){const b=this._incomingData.read(this._state.readLen);s(b,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(b.buffer)),this._zlibInflate.write(b.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const D=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=D.length,this._onData.fire(C.VSBuffer.wrap(D))})):(this._totalIncomingDataBytes+=b.byteLength,this._onData.fire(b))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await E.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=_;function s(u,f){if(f===0)return;let b=u.byteLength>>>2;for(let M=0;M<b;M++){const G=u.readUInt32BE(M*4);u.writeUInt32BE(G^f,M*4)}let D=b*4,w=u.byteLength-D;const T=f>>>24&255,v=f>>>16&255,F=f>>>8&255;w>=1&&u.writeUInt8(u.readUInt8(D)^T,D),w>=2&&u.writeUInt8(u.readUInt8(D+1)^v,D+1),w>=3&&u.writeUInt8(u.readUInt8(D+2)^F,D+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function p(){const u=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;let f;return e.XDG_RUNTIME_DIR?f=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${u}.sock`):f=(0,A.join)((0,k.tmpdir)(),`vscode-ipc-${u}.sock`),a(f),f}e.createRandomIPCHandle=p;function t(u,f,b){const D=(0,m.createHash)("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${b}-${f}-sock`;let w;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?w=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${D.substr(0,8)}-${b}-${f}.sock`):w=(0,A.join)(u,`${b}-${f}.sock`),a(w),w}e.createStaticIPCHandle=t;function a(u){const f=o[n.platform];typeof f=="number"&&u.length>=f&&console.warn(`WARNING: IPC handle "${u}" is longer than ${f} chars, try a shorter --user-data-dir`)}class r extends c.IPCServer{constructor(f){super(r.toClientConnectionEvent(f));this.server=f}static toClientConnectionEvent(f){const b=E.Event.fromNodeEventEmitter(f,"connection");return E.Event.map(b,D=>({protocol:new h.Protocol(new g(D)),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(D,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function i(u){return new Promise((f,b)=>{const D=(0,L.createServer)();D.on("error",b),D.listen(u,()=>{D.removeListener("error",b),f(new r(D))})})}e.serve=i;function l(u,f){return new Promise((b,D)=>{const w=(0,L.createConnection)(u,()=>{w.removeListener("error",D),b(h.Client.fromSocket(new g(w),f))});w.once("error",D)})}e.connect=l}),define(me[287],ge([0,1,136,279,50,44,2,199,12]),function(J,e,m,L,k,C,R,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class A{constructor(c,h,d){this._commands=c,this.logService=h,this._ipcHandlePath=d,this._server=L.createServer((g,y)=>this.onRequest(g,y)),this.setup().catch(g=>(h.error(g),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",c=>this.logService.error(c))}catch(c){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(c,h){const d=[];c.setEncoding("utf8"),c.on("data",g=>d.push(g)),c.on("end",()=>{const g=JSON.parse(d.join(""));switch(g.type){case"open":this.open(g,h);break;case"openExternal":this.openExternal(g,h);break;case"status":this.getStatus(g,h);break;case"extensionManagement":this.manageExtensions(g,h).catch(this.logService.error);break;default:h.writeHead(404),h.write(`Unknown message type: ${g.type}`,y=>{y&&this.logService.error(y)}),h.end();break}})}open(c,h){let{fileURIs:d,folderURIs:g,forceNewWindow:y,diffMode:I,addMode:_,forceReuseWindow:s,gotoLineMode:o,waitMarkerFilePath:p}=c;const t=[];if(Array.isArray(g))for(const a of g)try{t.push({folderUri:R.URI.parse(a)})}catch(r){}if(Array.isArray(d))for(const a of d)try{(0,E.hasWorkspaceFileExtension)(a)?t.push({workspaceUri:R.URI.parse(a)}):t.push({fileUri:R.URI.parse(a)})}catch(r){}if(t.length){const a=p?R.URI.file(p):void 0,i={forceNewWindow:y,diffMode:I,addMode:_,gotoLineMode:o,forceReuseWindow:s,preferNewWindow:!s&&!a&&!_,waitMarkerFileURI:a};this._commands.executeCommand("_remoteCLI.windowOpen",t,i)}h.writeHead(200),h.end()}async openExternal(c,h){for(const d of c.uris){const g=R.URI.parse(d),y=g.scheme==="file"?g:d;await this._commands.executeCommand("_remoteCLI.openExternal",y)}h.writeHead(200),h.end()}async manageExtensions(c,h){try{const d=I=>I?.map(_=>/\.vsix$/i.test(_)?R.URI.parse(_):_),g={list:c.list,install:d(c.install),uninstall:d(c.uninstall),force:c.force},y=await this._commands.executeCommand("_remoteCLI.manageExtensions",g);h.writeHead(200),h.write(y)}catch(d){h.writeHead(500),h.write(String(d),g=>{g&&this.logService.error(g)})}h.end()}async getStatus(c,h){try{const d=await this._commands.executeCommand("_remoteCLI.getSystemStatus");h.writeHead(200),h.write(d),h.end()}catch(d){h.writeHead(500),h.write(String(d),g=>{g&&this.logService.error(g)}),h.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&k.existsSync(this._ipcHandlePath)&&k.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=A;let n=class extends A{constructor(c,h){super(c,h,(0,m.createRandomIPCHandle)())}};n=Ve([$e(0,C.IExtHostCommands),$e(1,S.ILogService)],n),e.CLIServer=n}),define(me[288],ge([0,1,73,275,270,5,278,40,260,2,10,7,287,105]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class d extends k.RequireInterceptor{_installInterceptor(){const I=this,_=J.__$__nodeRequire("module"),s=_._load;_._load=function(p,t,a){for(let r of I._alternatives){let i=r(p);if(i){p=i;break}}return I._factories.has(p)?I._factories.get(p).load(p,A.URI.file((0,h.realpathSync)(t.filename)),r=>s.apply(this,[r,t,a])):s.apply(this,arguments)}}}class g extends E.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const I=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(S.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(c.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(d,I,this._registry).install(),m.mark("code/extHost/didInitAPI");const s=await this._extHostConfiguration.getConfigProvider();await(0,R.connectProxyResolver)(this._extHostWorkspace,s,this,this._logService,this._mainThreadTelemetryProxy,this._initData),m.mark("code/extHost/didInitProxyResolver");const o=process.send,p=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?o.apply(process,t):(p.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(I){return I.main}_loadCommonJSModule(I,_,s){if(_.scheme!==n.Schemas.file)throw new Error(`Cannot load URI: '${_}', must be of file-scheme`);let o=null;s.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${_.toString(!0)}`),this._logService.flush();try{I&&m.mark(`code/extHost/willLoadExtensionCode/${I.value}`),o=J.__$__nodeRequire(_.fsPath)}catch(p){return Promise.reject(p)}finally{I&&m.mark(`code/extHost/didLoadExtensionCode/${I.value}`),s.codeLoadingStop()}return Promise.resolve(o)}async $setRemoteEnvironment(I){if(!!this._initData.remote.isRemote)for(const _ in I){const s=I[_];s===null?delete process.env[_]:process.env[_]=s}}}e.ExtHostExtensionService=g}),define(me[289],ge([0,1,82,261,263,272,271,286,288,228,264,55,40,68,74,72,33,53,12,69,262]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g,y,I,_,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(c.IExtHostExtensionService,S.ExtHostExtensionService),(0,m.registerSingleton)(_.ILogService,A.ExtHostLogService),(0,m.registerSingleton)(s.IExtensionStoragePaths,o.ExtensionStoragePaths),(0,m.registerSingleton)(P.IExtHostDebugService,R.ExtHostDebugService),(0,m.registerSingleton)(h.IExtHostOutputService,L.ExtHostOutputService2),(0,m.registerSingleton)(d.IExtHostSearch,E.NativeExtHostSearch),(0,m.registerSingleton)(g.IExtHostTask,C.ExtHostTask),(0,m.registerSingleton)(y.IExtHostTerminalService,k.ExtHostTerminalService),(0,m.registerSingleton)(I.IExtHostTunnelService,n.ExtHostTunnelService)}),define(me[290],ge([0,1,125,302,73,16,107,136,192,226,273,23,103,28,105,18,114,276,289]),function(J,e,m,L,k,C,R,E,S,A,n,P,c,h,d,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let l=0;l<process.execArgv.length;l++)process.execArgv[l]==="--inspect-port=0"&&(process.execArgv.splice(l,1),l--)}();const I=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const i=J.__$__nodeRequire("module"),l=i._load;i._load=function(u){if(u==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return l.apply(this,arguments)}})();const _=process.exit.bind(process);function s(i){process.exit=function(l){if(i)_(l);else{const u=new Error("An extension called process.exit() and this was prevented.");console.warn(u.stack)}},process.crash=function(){const l=new Error("An extension called process.crash() and this was prevented.");console.warn(l.stack)}}let o=function(i){_()};function p(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,l)=>{let u=null,f=setTimeout(()=>{o("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const b=108e5,D=3e5,w=new g.ProcessTimeRunOnceScheduler(()=>o("renderer disconnected for too long (1)"),b),T=new g.ProcessTimeRunOnceScheduler(()=>o("renderer disconnected for too long (2)"),D);process.on("message",(F,M)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){const G=P.VSBuffer.wrap(Buffer.from(F.initialDataChunk,"base64"));let K;if(F.skipWebSocketFrames)K=new E.NodeSocket(M);else{const U=P.VSBuffer.wrap(Buffer.from(F.inflateBytes,"base64"));K=new E.WebSocketNodeSocket(new E.NodeSocket(M),F.permessageDeflate,U,!1)}u?(w.cancel(),T.cancel(),u.beginAcceptReconnection(K,G),u.endAcceptReconnection()):(clearTimeout(f),u=new R.PersistentProtocol(K,G),u.onDidDispose(()=>o("renderer disconnected")),i(u),u.onSocketClose(()=>{w.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(T.isScheduled())return;w.isScheduled()&&T.schedule()}});const v={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(v)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((l,u)=>{const f=m.createConnection(i,()=>{f.removeListener("error",u),l(new R.PersistentProtocol(new E.NodeSocket(f)))});f.once("error",u),f.on("close",()=>{o("renderer closed the socket")})})}}async function t(){const i=await p();return new class{constructor(){this._onMessage=new R.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(l=>{(0,A.isMessageOfType)(l,2)?(this._terminating=!0,o("received terminate message from renderer")):this._onMessage.fire(l)})}send(l){this._terminating||i.send(l)}drain(){return i.drain()}}}function a(i){return new Promise(l=>{const u=i.onMessage(f=>{u.dispose();const b=JSON.parse(f.toString()),D=b.commit,w=S.default.commit;D&&w&&D!==w&&_(55);const T=[];process.on("unhandledRejection",(M,G)=>{T.push(G),setTimeout(()=>{const K=T.indexOf(G);K>=0&&G.catch(U=>{T.splice(K,1),(0,C.isPromiseCanceledError)(U)||(console.warn(`rejected promise not handled within 1 second: ${U}`),U&&U.stack&&console.warn(`stack trace: ${U.stack}`),(0,C.onUnexpectedError)(M))})},1e3)}),process.on("rejectionHandled",M=>{const G=T.indexOf(M);G>=0&&T.splice(G,1)}),process.on("uncaughtException",function(M){(0,C.onUnexpectedError)(M)});let v=0;setInterval(function(){try{process.kill(b.parentPid,0),v=0}catch(M){M&&M.code==="EPERM"?(v++,v>=3&&o(`parent process ${b.parentPid} does not exist anymore (3 x EPERM): ${M.message} (code: ${M.code}) (errno: ${M.errno})`)):o(`parent process ${b.parentPid} does not exist anymore: ${M.message} (code: ${M.code}) (errno: ${M.errno})`)}},1e3);let F;try{F=J.__$__nodeRequire("native-watchdog"),F.start(b.parentPid)}catch(M){(0,C.onUnexpectedError)(M)}i.send((0,A.createMessageOfType)(0)),l({protocol:i,initData:b})});i.send((0,A.createMessageOfType)(1))})}async function r(){k.mark("code/extHost/willConnectToRenderer");const i=await t();k.mark("code/extHost/didConnectToRenderer");const l=await a(i);k.mark("code/extHost/didWaitForInitData");const{initData:u}=l;s(!!u.environment.extensionTestsLocationURI),u.environment.useHostProxy=I.useHostProxy!==void 0?I.useHostProxy!=="false":void 0,u.environment.skipWorkspaceStorageLock=(0,y.boolean)(I.skipWorkspaceStorageLock,!1);const f=new class{exit(T){_(T)}exists(T){return h.Promises.exists(T)}realpath(T){return(0,d.realpath)(T)}};let b=null;if(u.remote.authority&&I.uriTransformerPath)try{const T=J.__$__nodeRequire(I.uriTransformerPath)(u.remote.authority);b=new c.URITransformer(T)}catch(w){console.error(w)}const D=new n.ExtensionHostMain(l.protocol,u,f,b);o=w=>D.terminate(w)}e.startExtensionHostProcess=r}),define(me[303],ge([0,1,290]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0c83ca1ced83259971d80890d93abbe19cbfc992/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
