/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/skipList","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/base/common/iterator","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],be=function(ne){for(var e=[],h=0,M=ne.length;h<M;h++)e[h]=we[ne[h]];return e};define(we[40],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function h(M,b){if(!M)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=h}),define(we[51],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const h=Object.prototype.hasOwnProperty;function M(t){const E=[];for(let n in t)h.call(t,n)&&E.push(t[n]);return E}e.values=M;function b(t,E){for(let n in t)if(h.call(t,n)&&E({key:n,value:t[n]},function(){delete t[n]})===!1)return}e.forEach=b;function T(t,E){const n=Object.create(null);for(const d of t){const c=E(d);let l=n[c];l||(l=n[c]=[]),l.push(d)}return n}e.groupBy=T;function F(t){const E=Object.create(null);return t&&t.forEach((n,d)=>{E[d]=n}),E}e.fromMap=F;function D(t,E){const n=[],d=[];for(let c of t)E.has(c)||n.push(c);for(let c of E)t.has(c)||d.push(c);return{removed:n,added:d}}e.diffSets=D;function _(t,E){const n=[],d=[];for(let[c,l]of t)E.has(c)||n.push(l);for(let[c,l]of E)t.has(c)||d.push(l);return{removed:n,added:d}}e.diffMaps=_;class P{constructor(){this.map=new Map}add(E,n){let d=this.map.get(E);d||(d=new Set,this.map.set(E,d)),d.add(n)}delete(E,n){const d=this.map.get(E);!d||(d.delete(n),d.size===0&&this.map.delete(E))}forEach(E,n){const d=this.map.get(E);!d||d.forEach(n)}}e.SetMap=P}),define(we[52],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function h(F){return(D,_,P)=>{let t=null,E=null;if(typeof P.value=="function"?(t="value",E=P.value):typeof P.get=="function"&&(t="get",E=P.get),!E)throw new Error("not supported");P[t]=F(E,_)}}e.createDecorator=h;function M(F,D,_){let P=null,t=null;if(typeof _.value=="function"?(P="value",t=_.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(P="get",t=_.get),!t)throw new Error("not supported");const E=`$memoize$${D}`;_[P]=function(...n){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,n)}),this[E]}}e.memoize=M;function b(F,D,_){return h((P,t)=>{const E=`$debounce$${t}`,n=`$debounce$result$${t}`;return function(...d){this[n]||(this[n]=_?_():void 0),clearTimeout(this[E]),D&&(this[n]=D(this[n],...d),d=[this[n]]),this[E]=setTimeout(()=>{P.apply(this,d),this[n]=_?_():void 0},F)}})}e.debounce=b;function T(F,D,_){return h((P,t)=>{const E=`$throttle$timer$${t}`,n=`$throttle$result$${t}`,d=`$throttle$lastRun$${t}`,c=`$throttle$pending$${t}`;return function(...l){if(this[n]||(this[n]=_?_():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),D&&(this[n]=D(this[n],...l)),this[c])return;const w=this[d]+F;w<=Date.now()?(this[d]=Date.now(),P.apply(this,[this[n]]),this[n]=_?_():void 0):(this[c]=!0,this[E]=setTimeout(()=>{this[c]=!1,this[d]=Date.now(),P.apply(this,[this[n]]),this[n]=_?_():void 0},w-Date.now()))}})}e.throttle=T}),define(we[13],be([0,1,16]),function(ne,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function M(q,le=0){return q[q.length-(1+le)]}e.tail=M;function b(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=b;function T(q,le,se=(ve,Fe)=>ve===Fe){if(q===le)return!0;if(!q||!le||q.length!==le.length)return!1;for(let ve=0,Fe=q.length;ve<Fe;ve++)if(!se(q[ve],le[ve]))return!1;return!0}e.equals=T;function F(q,le,se){let ve=0,Fe=q.length-1;for(;ve<=Fe;){const Me=(ve+Fe)/2|0,Oe=se(q[Me],le);if(Oe<0)ve=Me+1;else if(Oe>0)Fe=Me-1;else return Me}return-(ve+1)}e.binarySearch=F;function D(q,le){let se=0,ve=q.length;if(ve===0)return 0;for(;se<ve;){const Fe=Math.floor((se+ve)/2);le(q[Fe])?ve=Fe:se=Fe+1}return se}e.findFirstInSorted=D;function _(q,le,se){if(q=q|0,q>=le.length)throw new TypeError("invalid index");let ve=le[Math.floor(le.length*Math.random())],Fe=[],Me=[],Oe=[];for(let Ye of le){const ze=se(Ye,ve);ze<0?Fe.push(Ye):ze>0?Me.push(Ye):Oe.push(Ye)}return q<Fe.length?_(q,Fe,se):q<Fe.length+Oe.length?Oe[0]:_(q-(Fe.length+Oe.length),Me,se)}e.quickSelect=_;function P(q,le){const se=[];let ve;for(const Fe of q.slice(0).sort(le))!ve||le(ve[0],Fe)!==0?(ve=[Fe],se.push(ve)):ve.push(Fe);return se}e.groupBy=P;function t(q,le,se){const ve=[];function Fe(Ye,ze,je){if(ze===0&&je.length===0)return;const x=ve[ve.length-1];x&&x.start+x.deleteCount===Ye?(x.deleteCount+=ze,x.toInsert.push(...je)):ve.push({start:Ye,deleteCount:ze,toInsert:je})}let Me=0,Oe=0;for(;;){if(Me===q.length){Fe(Me,0,le.slice(Oe));break}if(Oe===le.length){Fe(Me,q.length-Me,[]);break}const Ye=q[Me],ze=le[Oe],je=se(Ye,ze);je===0?(Me+=1,Oe+=1):je<0?(Fe(Me,1,[]),Me+=1):je>0&&(Fe(Me,0,[ze]),Oe+=1)}return ve}e.sortedDiff=t;function E(q,le,se){const ve=t(q,le,se),Fe=[],Me=[];for(const Oe of ve)Fe.push(...q.slice(Oe.start,Oe.start+Oe.deleteCount)),Me.push(...Oe.toInsert);return{removed:Fe,added:Me}}e.delta=E;function n(q,le,se){if(se===0)return[];const ve=q.slice(0,se).sort(le);return c(q,le,ve,se,q.length),ve}e.top=n;function d(q,le,se,ve,Fe){return se===0?Promise.resolve([]):new Promise((Me,Oe)=>{(async()=>{const Ye=q.length,ze=q.slice(0,se).sort(le);for(let je=se,x=Math.min(se+ve,Ye);je<Ye;je=x,x=Math.min(x+ve,Ye)){if(je>se&&await new Promise(Y=>setTimeout(Y)),Fe&&Fe.isCancellationRequested)throw(0,h.canceled)();c(q,le,ze,je,x)}return ze})().then(Me,Oe)})}e.topAsync=d;function c(q,le,se,ve,Fe){for(const Me=se.length;ve<Fe;ve++){const Oe=q[ve];if(le(Oe,se[Me-1])<0){se.pop();const Ye=D(se,ze=>le(Oe,ze)<0);se.splice(Ye,0,Oe)}}}function l(q){return q.filter(le=>!!le)}e.coalesce=l;function w(q){let le=0;for(let se=0;se<q.length;se++)q[se]&&(q[le]=q[se],le+=1);q.length=le}e.coalesceInPlace=w;function I(q,le,se){q.splice(se,0,q.splice(le,1)[0])}e.move=I;function y(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=y;function s(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=s;function g(q,le){if(!le)return q.filter((ve,Fe)=>q.indexOf(ve)===Fe);const se=Object.create(null);return q.filter(ve=>{const Fe=le(ve);return se[Fe]?!1:(se[Fe]=!0,!0)})}e.distinct=g;function k(q){const le=new Set;return q.filter(se=>le.has(se)?!1:(le.add(se),!0))}e.distinctES6=k;function i(q){const le=Object.create(null);return se=>{const ve=q(se);return le[ve]?!1:(le[ve]=!0,!0)}}e.uniqueFilter=i;function a(q,le){for(let se=q.length-1;se>=0;se--){const ve=q[se];if(le(ve))return se}return-1}e.lastIndex=a;function r(q,le){return q.length>0?q[0]:le}e.firstOrDefault=r;function o(q,le,se=(ve,Fe)=>ve===Fe){let ve=0;for(let Fe=0,Me=Math.min(q.length,le.length);Fe<Me&&se(q[Fe],le[Fe]);Fe++)ve++;return ve}e.commonPrefixLength=o;function f(q){return[].concat(...q)}e.flatten=f;function m(q,le){let se=typeof le=="number"?q:0;typeof le=="number"?se=q:(se=0,le=q);const ve=[];if(se<=le)for(let Fe=se;Fe<le;Fe++)ve.push(Fe);else for(let Fe=se;Fe>le;Fe--)ve.push(Fe);return ve}e.range=m;function v(q,le,se){return q.reduce((ve,Fe)=>(ve[le(Fe)]=se?se(Fe):Fe,ve),Object.create(null))}e.index=v;function C(q,le){return q.push(le),()=>R(q,le)}e.insert=C;function R(q,le){const se=q.indexOf(le);if(se>-1)return q.splice(se,1),le}e.remove=R;function p(q,le,se){const ve=q.slice(0,le),Fe=q.slice(le);return ve.concat(se,Fe)}e.arrayInsert=p;function S(q,le){let se;if(typeof le=="number"){let ve=le;se=()=>{const Fe=Math.sin(ve++)*179426549;return Fe-Math.floor(Fe)}}else se=Math.random;for(let ve=q.length-1;ve>0;ve-=1){const Fe=Math.floor(se()*(ve+1)),Me=q[ve];q[ve]=q[Fe],q[Fe]=Me}}e.shuffle=S;function u(q,le){const se=q.indexOf(le);se>-1&&(q.splice(se,1),q.unshift(le))}e.pushToStart=u;function A(q,le){const se=q.indexOf(le);se>-1&&(q.splice(se,1),q.push(le))}e.pushToEnd=A;function L(q,le){return Array.isArray(q)?q.map(le):le(q)}e.mapArrayOrNot=L;function V(q){return Array.isArray(q)?q:[q]}e.asArray=V;function K(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=K;function W(q,le){for(const se of q){const ve=le(se);if(ve!==void 0)return ve}}e.mapFind=W;function Q(q,le,se){const ve=U(q,le),Fe=q.length,Me=se.length;q.length=Fe+Me;for(let Oe=Fe-1;Oe>=ve;Oe--)q[Oe+Me]=q[Oe];for(let Oe=0;Oe<Me;Oe++)q[Oe+ve]=se[Oe]}e.insertInto=Q;function $(q,le,se,ve){const Fe=U(q,le),Me=q.splice(Fe,se);return Q(q,Fe,ve),Me}e.splice=$;function U(q,le){return le<0?Math.max(le+q.length,0):Math.min(le,q.length)}function z(q,le){let se=Number.MAX_SAFE_INTEGER,ve=0;return q.forEach((Fe,Me)=>{const Oe=le(Fe);Oe<se&&(se=Oe,ve=Me)}),ve}e.minIndex=z;function G(q,le){let se=Number.MIN_SAFE_INTEGER,ve=0;return q.forEach((Fe,Me)=>{const Oe=le(Fe);Oe>se&&(se=Oe,ve=Me)}),ve}e.maxIndex=G;class ue{constructor(le){this.items=le,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(le){let se=this.firstIdx;for(;se<this.items.length&&le(this.items[se]);)se++;const ve=se===this.firstIdx?null:this.items.slice(this.firstIdx,se);return this.firstIdx=se,ve}takeFromEndWhile(le){let se=this.lastIdx;for(;se>=0&&le(this.items[se]);)se--;const ve=se===this.lastIdx?null:this.items.slice(se+1,this.lastIdx+1);return this.lastIdx=se,ve}}e.ArrayQueue=ue}),define(we[53],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class h{constructor(b){this._prefix=b,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=h,e.defaultGenerator=new h("id#")}),define(we[102],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var h;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(h=e.ScanError||(e.ScanError={}));var M;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var b;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(b=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(i){i.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function F(i,a=!1){let r=0,o=i.length,f="",m=0,v=16,C=0;function R(K){let W=0,Q=0;for(;W<K;){const $=i.charCodeAt(r);if($>=48&&$<=57)Q=Q*16+$-48;else if($>=65&&$<=70)Q=Q*16+$-65+10;else if($>=97&&$<=102)Q=Q*16+$-97+10;else break;r++,W++}return W<K&&(Q=-1),Q}function p(K){r=K,f="",m=0,v=16,C=0}function S(){const K=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&P(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&P(i.charCodeAt(r)))for(r++;r<i.length&&P(i.charCodeAt(r));)r++;else return C=3,i.substring(K,r);let W=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&P(i.charCodeAt(r))){for(r++;r<i.length&&P(i.charCodeAt(r));)r++;W=r}else C=3;return i.substring(K,W)}function u(){let K="",W=r;for(;;){if(r>=o){K+=i.substring(W,r),C=2;break}const Q=i.charCodeAt(r);if(Q===34){K+=i.substring(W,r),r++;break}if(Q===92){if(K+=i.substring(W,r),r++,r>=o){C=2;break}switch(i.charCodeAt(r++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:const U=R(4);U>=0?K+=String.fromCharCode(U):C=4;break;default:C=5}W=r;continue}if(Q>=0&&Q<=31)if(_(Q)){K+=i.substring(W,r),C=2;break}else C=6;r++}return K}function A(){if(f="",C=0,m=r,r>=o)return m=o,v=17;let K=i.charCodeAt(r);if(D(K)){do r++,f+=String.fromCharCode(K),K=i.charCodeAt(r);while(D(K));return v=15}if(_(K))return r++,f+=String.fromCharCode(K),K===13&&i.charCodeAt(r)===10&&(r++,f+=`
`),v=14;switch(K){case 123:return r++,v=1;case 125:return r++,v=2;case 91:return r++,v=3;case 93:return r++,v=4;case 58:return r++,v=6;case 44:return r++,v=5;case 34:return r++,f=u(),v=10;case 47:const W=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<o&&!_(i.charCodeAt(r));)r++;return f=i.substring(W,r),v=12}if(i.charCodeAt(r+1)===42){r+=2;const Q=o-1;let $=!1;for(;r<Q;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,$=!0;break}r++}return $||(r++,C=1),f=i.substring(W,r),v=13}return f+=String.fromCharCode(K),r++,v=16;case 45:if(f+=String.fromCharCode(K),r++,r===o||!P(i.charCodeAt(r)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return f+=S(),v=11;default:for(;r<o&&L(K);)r++,K=i.charCodeAt(r);if(m!==r){switch(f=i.substring(m,r),f){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return f+=String.fromCharCode(K),r++,v=16}}function L(K){if(D(K)||_(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let K;do K=A();while(K>=12&&K<=15);return K}return{setPosition:p,getPosition:()=>r,scan:a?V:A,getToken:()=>v,getTokenValue:()=>f,getTokenOffset:()=>m,getTokenLength:()=>r-m,getTokenError:()=>C}}e.createScanner=F;function D(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function _(i){return i===10||i===13||i===8232||i===8233}function P(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function E(i,a){const r=[],o=new Object;let f;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function C(R,p,S,u){m.value=R,m.offset=p,m.length=S,m.type=u,m.colonOffset=void 0,f=m}try{s(i,{onObjectBegin:(R,p)=>{if(a<=R)throw o;f=void 0,v=a>R,r.push("")},onObjectProperty:(R,p,S)=>{if(a<p||(C(R,p,S,"property"),r[r.length-1]=R,a<=p+S))throw o},onObjectEnd:(R,p)=>{if(a<=R)throw o;f=void 0,r.pop()},onArrayBegin:(R,p)=>{if(a<=R)throw o;f=void 0,r.push(0)},onArrayEnd:(R,p)=>{if(a<=R)throw o;f=void 0,r.pop()},onLiteralValue:(R,p,S)=>{if(a<p||(C(R,p,S,k(R)),a<=p+S))throw o},onSeparator:(R,p,S)=>{if(a<=p)throw o;if(R===":"&&f&&f.type==="property")f.colonOffset=p,v=!1,f=void 0;else if(R===","){const u=r[r.length-1];typeof u=="number"?r[r.length-1]=u+1:(v=!0,r[r.length-1]=""),f=void 0}}})}catch(R){if(R!==o)throw R}return{path:r,previousNode:f,isAtPropertyKey:v,matches:R=>{let p=0;for(let S=0;p<R.length&&S<r.length;S++)if(R[p]===r[S]||R[p]==="*")p++;else if(R[p]!=="**")return!1;return p===R.length}}}e.getLocation=E;function n(i,a=[],r=T.DEFAULT){let o=null,f=[];const m=[];function v(R){Array.isArray(f)?f.push(R):o!==null&&(f[o]=R)}return s(i,{onObjectBegin:()=>{const R={};v(R),m.push(f),f=R,o=null},onObjectProperty:R=>{o=R},onObjectEnd:()=>{f=m.pop()},onArrayBegin:()=>{const R=[];v(R),m.push(f),f=R,o=null},onArrayEnd:()=>{f=m.pop()},onLiteralValue:v,onError:(R,p,S)=>{a.push({error:R,offset:p,length:S})}},r),f[0]}e.parse=n;function d(i,a=[],r=T.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function f(R){o.type==="property"&&(o.length=R-o.offset,o=o.parent)}function m(R){return o.children.push(R),R}s(i,{onObjectBegin:R=>{o=m({type:"object",offset:R,length:-1,parent:o,children:[]})},onObjectProperty:(R,p,S)=>{o=m({type:"property",offset:p,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:R,offset:p,length:S,parent:o})},onObjectEnd:(R,p)=>{o.length=R+p-o.offset,o=o.parent,f(R+p)},onArrayBegin:(R,p)=>{o=m({type:"array",offset:R,length:-1,parent:o,children:[]})},onArrayEnd:(R,p)=>{o.length=R+p-o.offset,o=o.parent,f(R+p)},onLiteralValue:(R,p,S)=>{m({type:k(R),offset:p,length:S,parent:o,value:R}),f(p+S)},onSeparator:(R,p,S)=>{o.type==="property"&&(R===":"?o.colonOffset=p:R===","&&f(p))},onError:(R,p,S)=>{a.push({error:R,offset:p,length:S})}},r);const C=o.children[0];return C&&delete C.parent,C}e.parseTree=d;function c(i,a){if(!i)return;let r=i;for(let o of a)if(typeof o=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let f=!1;for(const m of r.children)if(Array.isArray(m.children)&&m.children[0].value===o){r=m.children[1],f=!0;break}if(!f)return}else{const f=o;if(r.type!=="array"||f<0||!Array.isArray(r.children)||f>=r.children.length)return;r=r.children[f]}return r}e.findNodeAtLocation=c;function l(i){if(!i.parent||!i.parent.children)return[];const a=l(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;a.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&a.push(r)}return a}e.getNodePath=l;function w(i){switch(i.type){case"array":return i.children.map(w);case"object":const a=Object.create(null);for(let r of i.children){const o=r.children[1];o&&(a[r.children[0].value]=w(o))}return a;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=w;function I(i,a,r=!1){return a>=i.offset&&a<i.offset+i.length||r&&a===i.offset+i.length}e.contains=I;function y(i,a,r=!1){if(I(i,a,r)){const o=i.children;if(Array.isArray(o))for(let f=0;f<o.length&&o[f].offset<=a;f++){const m=y(o[f],a,r);if(m)return m}return i}}e.findNodeAtOffset=y;function s(i,a,r=T.DEFAULT){const o=F(i,!1);function f(se){return se?()=>se(o.getTokenOffset(),o.getTokenLength()):()=>!0}function m(se){return se?ve=>se(ve,o.getTokenOffset(),o.getTokenLength()):()=>!0}const v=f(a.onObjectBegin),C=m(a.onObjectProperty),R=f(a.onObjectEnd),p=f(a.onArrayBegin),S=f(a.onArrayEnd),u=m(a.onLiteralValue),A=m(a.onSeparator),L=f(a.onComment),V=m(a.onError),K=r&&r.disallowComments,W=r&&r.allowTrailingComma;function Q(){for(;;){const se=o.scan();switch(o.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:K||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(se){case 12:case 13:K?$(10):L();break;case 16:$(1);break;case 15:case 14:break;default:return se}}}function $(se,ve=[],Fe=[]){if(V(se),ve.length+Fe.length>0){let Me=o.getToken();for(;Me!==17;){if(ve.indexOf(Me)!==-1){Q();break}else if(Fe.indexOf(Me)!==-1)break;Me=Q()}}}function U(se){const ve=o.getTokenValue();return se?u(ve):C(ve),Q(),!0}function z(){switch(o.getToken()){case 11:let se=0;try{se=JSON.parse(o.getTokenValue()),typeof se!="number"&&($(2),se=0)}catch(ve){$(2)}u(se);break;case 7:u(null);break;case 8:u(!0);break;case 9:u(!1);break;default:return!1}return Q(),!0}function G(){return o.getToken()!==10?($(3,[],[2,5]),!1):(U(!1),o.getToken()===6?(A(":"),Q(),le()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function ue(){v(),Q();let se=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(se||$(4,[],[]),A(","),Q(),o.getToken()===2&&W)break}else se&&$(6,[],[]);G()||$(4,[],[2,5]),se=!0}return R(),o.getToken()!==2?$(7,[2],[]):Q(),!0}function q(){p(),Q();let se=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(se||$(4,[],[]),A(","),Q(),o.getToken()===4&&W)break}else se&&$(6,[],[]);le()||$(4,[],[4,5]),se=!0}return S(),o.getToken()!==4?$(8,[4],[]):Q(),!0}function le(){switch(o.getToken()){case 3:return q();case 1:return ue();case 10:return U(!0);default:return z()}}return Q(),o.getToken()===17?r.allowEmptyContent?!0:($(4,[],[]),!1):le()?(o.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=s;function g(i,a){let r=F(i),o=[],f,m=0,v;do switch(v=r.getPosition(),f=r.scan(),f){case 12:case 13:case 17:m!==v&&o.push(i.substring(m,v)),a!==void 0&&o.push(r.getTokenValue().replace(/[^\r\n]/g,a)),m=r.getPosition();break}while(f!==17);return o.join("")}e.stripComments=g;function k(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=k}),define(we[103],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class h{constructor(b){this.executor=b,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(b){this._error=b}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(b){return new h(()=>b(this.getValue()))}}e.Lazy=h}),function(ne,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ne=typeof globalThis!="undefined"?globalThis:ne||self,ne.marked=e())}(this,function(){"use strict";function ne(Pe,ye){for(var Ce=0;Ce<ye.length;Ce++){var Z=ye[Ce];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(Pe,Z.key,Z)}}function e(Pe,ye,Ce){return ye&&ne(Pe.prototype,ye),Ce&&ne(Pe,Ce),Pe}function h(Pe,ye){if(!!Pe){if(typeof Pe=="string")return M(Pe,ye);var Ce=Object.prototype.toString.call(Pe).slice(8,-1);if(Ce==="Object"&&Pe.constructor&&(Ce=Pe.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(Pe);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return M(Pe,ye)}}function M(Pe,ye){(ye==null||ye>Pe.length)&&(ye=Pe.length);for(var Ce=0,Z=new Array(ye);Ce<ye;Ce++)Z[Ce]=Pe[Ce];return Z}function b(Pe,ye){var Ce=typeof Symbol!="undefined"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(Ce)return(Ce=Ce.call(Pe)).next.bind(Ce);if(Array.isArray(Pe)||(Ce=h(Pe))||ye&&Pe&&typeof Pe.length=="number"){Ce&&(Pe=Ce);var Z=0;return function(){return Z>=Pe.length?{done:!0}:{done:!1,value:Pe[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var T={exports:{}};function F(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function D(Pe){T.exports.defaults=Pe}T.exports={defaults:F(),getDefaults:F,changeDefaults:D};var _=/[&<>"']/,P=/[&<>"']/g,t=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(ye){return n[ye]};function c(Pe,ye){if(ye){if(_.test(Pe))return Pe.replace(P,d)}else if(t.test(Pe))return Pe.replace(E,d);return Pe}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function w(Pe){return Pe.replace(l,function(ye,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var I=/(^|[^\[])\^/g;function y(Pe,ye){Pe=Pe.source||Pe,ye=ye||"";var Ce={replace:function(ce,ge){return ge=ge.source||ge,ge=ge.replace(I,"$1"),Pe=Pe.replace(ce,ge),Ce},getRegex:function(){return new RegExp(Pe,ye)}};return Ce}var s=/[^\w:]/g,g=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function k(Pe,ye,Ce){if(Pe){var Z;try{Z=decodeURIComponent(w(Ce)).replace(s,"").toLowerCase()}catch(ce){return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}ye&&!g.test(Ce)&&(Ce=f(ye,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(ce){return null}return Ce}var i={},a=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function f(Pe,ye){i[" "+Pe]||(a.test(Pe)?i[" "+Pe]=Pe+"/":i[" "+Pe]=R(Pe,"/",!0)),Pe=i[" "+Pe];var Ce=Pe.indexOf(":")===-1;return ye.substring(0,2)==="//"?Ce?ye:Pe.replace(r,"$1")+ye:ye.charAt(0)==="/"?Ce?ye:Pe.replace(o,"$1")+ye:Pe+ye}var m={exec:function(){}};function v(Pe){for(var ye=1,Ce,Z;ye<arguments.length;ye++){Ce=arguments[ye];for(Z in Ce)Object.prototype.hasOwnProperty.call(Ce,Z)&&(Pe[Z]=Ce[Z])}return Pe}function C(Pe,ye){var Ce=Pe.replace(/\|/g,function(ge,fe,Ie){for(var xe=!1,Le=fe;--Le>=0&&Ie[Le]==="\\";)xe=!xe;return xe?"|":" |"}),Z=Ce.split(/ \|/),ce=0;if(Z[0].trim()||Z.shift(),Z[Z.length-1].trim()||Z.pop(),Z.length>ye)Z.splice(ye);else for(;Z.length<ye;)Z.push("");for(;ce<Z.length;ce++)Z[ce]=Z[ce].trim().replace(/\\\|/g,"|");return Z}function R(Pe,ye,Ce){var Z=Pe.length;if(Z===0)return"";for(var ce=0;ce<Z;){var ge=Pe.charAt(Z-ce-1);if(ge===ye&&!Ce)ce++;else if(ge!==ye&&Ce)ce++;else break}return Pe.substr(0,Z-ce)}function p(Pe,ye){if(Pe.indexOf(ye[1])===-1)return-1;for(var Ce=Pe.length,Z=0,ce=0;ce<Ce;ce++)if(Pe[ce]==="\\")ce++;else if(Pe[ce]===ye[0])Z++;else if(Pe[ce]===ye[1]&&(Z--,Z<0))return ce;return-1}function S(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function u(Pe,ye){if(ye<1)return"";for(var Ce="";ye>1;)ye&1&&(Ce+=Pe),ye>>=1,Pe+=Pe;return Ce+Pe}var A={escape:c,unescape:w,edit:y,cleanUrl:k,resolveUrl:f,noopTest:m,merge:v,splitCells:C,rtrim:R,findClosingBracket:p,checkSanitizeDeprecation:S,repeatString:u},L=T.exports.defaults,V=A.rtrim,K=A.splitCells,W=A.escape,Q=A.findClosingBracket;function $(Pe,ye,Ce,Z){var ce=ye.href,ge=ye.title?W(ye.title):null,fe=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){Z.state.inLink=!0;var Ie={type:"link",raw:Ce,href:ce,title:ge,text:fe,tokens:Z.inlineTokens(fe,[])};return Z.state.inLink=!1,Ie}else return{type:"image",raw:Ce,href:ce,title:ge,text:W(fe)}}function U(Pe,ye){var Ce=Pe.match(/^(\s+)(?:```)/);if(Ce===null)return ye;var Z=Ce[1];return ye.split(`
`).map(function(ce){var ge=ce.match(/^\s+/);if(ge===null)return ce;var fe=ge[0];return fe.length>=Z.length?ce.slice(Z.length):ce}).join(`
`)}var z=function(){function Pe(Ce){this.options=Ce||L}var ye=Pe.prototype;return ye.space=function(Z){var ce=this.rules.block.newline.exec(Z);if(ce)return ce[0].length>1?{type:"space",raw:ce[0]}:{raw:`
`}},ye.code=function(Z){var ce=this.rules.block.code.exec(Z);if(ce){var ge=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?ge:V(ge,`
`)}}},ye.fences=function(Z){var ce=this.rules.block.fences.exec(Z);if(ce){var ge=ce[0],fe=U(ge,ce[3]||"");return{type:"code",raw:ge,lang:ce[2]?ce[2].trim():ce[2],text:fe}}},ye.heading=function(Z){var ce=this.rules.block.heading.exec(Z);if(ce){var ge=ce[2].trim();if(/#$/.test(ge)){var fe=V(ge,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(ge=fe.trim())}var Ie={type:"heading",raw:ce[0],depth:ce[1].length,text:ge,tokens:[]};return this.lexer.inline(Ie.text,Ie.tokens),Ie}},ye.hr=function(Z){var ce=this.rules.block.hr.exec(Z);if(ce)return{type:"hr",raw:ce[0]}},ye.blockquote=function(Z){var ce=this.rules.block.blockquote.exec(Z);if(ce){var ge=ce[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(ge,[]),text:ge}}},ye.list=function(Z){var ce=this.rules.block.list.exec(Z);if(ce){var ge,fe,Ie,xe,Le,Ve,Ze,ie,pe,re,B=ce[1].trim(),De=B.length>1,Se={type:"list",raw:"",ordered:De,start:De?+B.slice(0,-1):"",loose:!1,items:[]};B=De?"\\d{1,9}\\"+B.slice(-1):"\\"+B,this.options.pedantic&&(B=De?B:"[*+-]");for(var qe=new RegExp("^( {0,3}"+B+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");Z&&!(this.rules.block.hr.test(Z)||!(ce=qe.exec(Z)));){pe=ce[2].split(`
`),this.options.pedantic?(xe=2,re=pe[0].trimLeft()):(xe=ce[2].search(/[^ ]/),xe=ce[1].length+(xe>4?1:xe),re=pe[0].slice(xe-ce[1].length)),Ve=!1,ge=ce[0],!pe[0]&&/^ *$/.test(pe[1])&&(ge=ce[1]+pe.slice(0,2).join(`
`)+`
`,Se.loose=!0,pe=[]);var We=new RegExp("^ {0,"+Math.min(3,xe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Le=1;Le<pe.length;Le++){if(ie=pe[Le],this.options.pedantic&&(ie=ie.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),We.test(ie)){ge=ce[1]+pe.slice(0,Le).join(`
`)+`
`;break}if(!Ve){ie.trim()||(Ve=!0),ie.search(/[^ ]/)>=xe?re+=`
`+ie.slice(xe):re+=`
`+ie;continue}if(ie.search(/[^ ]/)>=xe||!ie.trim()){re+=`
`+ie.slice(xe);continue}else{ge=ce[1]+pe.slice(0,Le).join(`
`)+`
`;break}}Se.loose||(Ze?Se.loose=!0:/\n *\n *$/.test(ge)&&(Ze=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(re),fe&&(Ie=fe[0]!=="[ ] ",re=re.replace(/^\[[ xX]\] +/,""))),Se.items.push({type:"list_item",raw:ge,task:!!fe,checked:Ie,loose:!1,text:re}),Se.raw+=ge,Z=Z.slice(ge.length)}Se.items[Se.items.length-1].raw=ge.trimRight(),Se.items[Se.items.length-1].text=re.trimRight(),Se.raw=Se.raw.trimRight();var tt=Se.items.length;for(Le=0;Le<tt;Le++)this.lexer.state.top=!1,Se.items[Le].tokens=this.lexer.blockTokens(Se.items[Le].text,[]),Se.items[Le].tokens.some(function(mt){return mt.type==="space"})&&(Se.loose=!0,Se.items[Le].loose=!0);return Se}},ye.html=function(Z){var ce=this.rules.block.html.exec(Z);if(ce){var ge={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};return this.options.sanitize&&(ge.type="paragraph",ge.text=this.options.sanitizer?this.options.sanitizer(ce[0]):W(ce[0]),ge.tokens=[],this.lexer.inline(ge.text,ge.tokens)),ge}},ye.def=function(Z){var ce=this.rules.block.def.exec(Z);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var ge=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ge,raw:ce[0],href:ce[2],title:ce[3]}}},ye.table=function(Z){var ce=this.rules.block.table.exec(Z);if(ce){var ge={type:"table",header:K(ce[1]).map(function(Ze){return{text:Ze}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]?ce[3].replace(/\n$/,"").split(`
`):[]};if(ge.header.length===ge.align.length){ge.raw=ce[0];var fe=ge.align.length,Ie,xe,Le,Ve;for(Ie=0;Ie<fe;Ie++)/^ *-+: *$/.test(ge.align[Ie])?ge.align[Ie]="right":/^ *:-+: *$/.test(ge.align[Ie])?ge.align[Ie]="center":/^ *:-+ *$/.test(ge.align[Ie])?ge.align[Ie]="left":ge.align[Ie]=null;for(fe=ge.rows.length,Ie=0;Ie<fe;Ie++)ge.rows[Ie]=K(ge.rows[Ie],ge.header.length).map(function(Ze){return{text:Ze}});for(fe=ge.header.length,xe=0;xe<fe;xe++)ge.header[xe].tokens=[],this.lexer.inlineTokens(ge.header[xe].text,ge.header[xe].tokens);for(fe=ge.rows.length,xe=0;xe<fe;xe++)for(Ve=ge.rows[xe],Le=0;Le<Ve.length;Le++)Ve[Le].tokens=[],this.lexer.inlineTokens(Ve[Le].text,Ve[Le].tokens);return ge}}},ye.lheading=function(Z){var ce=this.rules.block.lheading.exec(Z);if(ce){var ge={type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.paragraph=function(Z){var ce=this.rules.block.paragraph.exec(Z);if(ce){var ge={type:"paragraph",raw:ce[0],text:ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.text=function(Z){var ce=this.rules.block.text.exec(Z);if(ce){var ge={type:"text",raw:ce[0],text:ce[0],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.escape=function(Z){var ce=this.rules.inline.escape.exec(Z);if(ce)return{type:"escape",raw:ce[0],text:W(ce[1])}},ye.tag=function(Z){var ce=this.rules.inline.tag.exec(Z);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):W(ce[0]):ce[0]}},ye.link=function(Z){var ce=this.rules.inline.link.exec(Z);if(ce){var ge=ce[2].trim();if(!this.options.pedantic&&/^</.test(ge)){if(!/>$/.test(ge))return;var fe=V(ge.slice(0,-1),"\\");if((ge.length-fe.length)%2==0)return}else{var Ie=Q(ce[2],"()");if(Ie>-1){var xe=ce[0].indexOf("!")===0?5:4,Le=xe+ce[1].length+Ie;ce[2]=ce[2].substring(0,Ie),ce[0]=ce[0].substring(0,Le).trim(),ce[3]=""}}var Ve=ce[2],Ze="";if(this.options.pedantic){var ie=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ve);ie&&(Ve=ie[1],Ze=ie[3])}else Ze=ce[3]?ce[3].slice(1,-1):"";return Ve=Ve.trim(),/^</.test(Ve)&&(this.options.pedantic&&!/>$/.test(ge)?Ve=Ve.slice(1):Ve=Ve.slice(1,-1)),$(ce,{href:Ve&&Ve.replace(this.rules.inline._escapes,"$1"),title:Ze&&Ze.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},ye.reflink=function(Z,ce){var ge;if((ge=this.rules.inline.reflink.exec(Z))||(ge=this.rules.inline.nolink.exec(Z))){var fe=(ge[2]||ge[1]).replace(/\s+/g," ");if(fe=ce[fe.toLowerCase()],!fe||!fe.href){var Ie=ge[0].charAt(0);return{type:"text",raw:Ie,text:Ie}}return $(ge,fe,ge[0],this.lexer)}},ye.emStrong=function(Z,ce,ge){ge===void 0&&(ge="");var fe=this.rules.inline.emStrong.lDelim.exec(Z);if(!!fe&&!(fe[3]&&ge.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ie=fe[1]||fe[2]||"";if(!Ie||Ie&&(ge===""||this.rules.inline.punctuation.exec(ge))){var xe=fe[0].length-1,Le,Ve,Ze=xe,ie=0,pe=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,ce=ce.slice(-1*Z.length+xe);(fe=pe.exec(ce))!=null;)if(Le=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Le){if(Ve=Le.length,fe[3]||fe[4]){Ze+=Ve;continue}else if((fe[5]||fe[6])&&xe%3&&!((xe+Ve)%3)){ie+=Ve;continue}if(Ze-=Ve,!(Ze>0)){if(Ve=Math.min(Ve,Ve+Ze+ie),Math.min(xe,Ve)%2){var re=Z.slice(1,xe+fe.index+Ve);return{type:"em",raw:Z.slice(0,xe+fe.index+Ve+1),text:re,tokens:this.lexer.inlineTokens(re,[])}}var B=Z.slice(2,xe+fe.index+Ve-1);return{type:"strong",raw:Z.slice(0,xe+fe.index+Ve+1),text:B,tokens:this.lexer.inlineTokens(B,[])}}}}}},ye.codespan=function(Z){var ce=this.rules.inline.code.exec(Z);if(ce){var ge=ce[2].replace(/\n/g," "),fe=/[^ ]/.test(ge),Ie=/^ /.test(ge)&&/ $/.test(ge);return fe&&Ie&&(ge=ge.substring(1,ge.length-1)),ge=W(ge,!0),{type:"codespan",raw:ce[0],text:ge}}},ye.br=function(Z){var ce=this.rules.inline.br.exec(Z);if(ce)return{type:"br",raw:ce[0]}},ye.del=function(Z){var ce=this.rules.inline.del.exec(Z);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2],[])}},ye.autolink=function(Z,ce){var ge=this.rules.inline.autolink.exec(Z);if(ge){var fe,Ie;return ge[2]==="@"?(fe=W(this.options.mangle?ce(ge[1]):ge[1]),Ie="mailto:"+fe):(fe=W(ge[1]),Ie=fe),{type:"link",raw:ge[0],text:fe,href:Ie,tokens:[{type:"text",raw:fe,text:fe}]}}},ye.url=function(Z,ce){var ge;if(ge=this.rules.inline.url.exec(Z)){var fe,Ie;if(ge[2]==="@")fe=W(this.options.mangle?ce(ge[0]):ge[0]),Ie="mailto:"+fe;else{var xe;do xe=ge[0],ge[0]=this.rules.inline._backpedal.exec(ge[0])[0];while(xe!==ge[0]);fe=W(ge[0]),ge[1]==="www."?Ie="http://"+fe:Ie=fe}return{type:"link",raw:ge[0],text:fe,href:Ie,tokens:[{type:"text",raw:fe,text:fe}]}}},ye.inlineText=function(Z,ce){var ge=this.rules.inline.text.exec(Z);if(ge){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):W(ge[0]):ge[0]:fe=W(this.options.smartypants?ce(ge[0]):ge[0]),{type:"text",raw:ge[0],text:fe}}},Pe}(),G=A.noopTest,ue=A.edit,q=A.merge,le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:G,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=ue(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=ue(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=ue(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=ue(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=ue(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=ue(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=q({},le),le.gfm=q({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=ue(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=q({},le.normal,{html:ue(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:G,paragraph:ue(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var se={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:G,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:G,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};se._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",se.punctuation=ue(se.punctuation).replace(/punctuation/g,se._punctuation).getRegex(),se.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,se.escapedEmSt=/\\\*|\\_/g,se._comment=ue(le._comment).replace("(?:-->|$)","-->").getRegex(),se.emStrong.lDelim=ue(se.emStrong.lDelim).replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimAst=ue(se.emStrong.rDelimAst,"g").replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimUnd=ue(se.emStrong.rDelimUnd,"g").replace(/punct/g,se._punctuation).getRegex(),se._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,se._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,se._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,se.autolink=ue(se.autolink).replace("scheme",se._scheme).replace("email",se._email).getRegex(),se._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,se.tag=ue(se.tag).replace("comment",se._comment).replace("attribute",se._attribute).getRegex(),se._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,se._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,se._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,se.link=ue(se.link).replace("label",se._label).replace("href",se._href).replace("title",se._title).getRegex(),se.reflink=ue(se.reflink).replace("label",se._label).getRegex(),se.reflinkSearch=ue(se.reflinkSearch,"g").replace("reflink",se.reflink).replace("nolink",se.nolink).getRegex(),se.normal=q({},se),se.pedantic=q({},se.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:ue(/^!?\[(label)\]\((.*?)\)/).replace("label",se._label).getRegex(),reflink:ue(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",se._label).getRegex()}),se.gfm=q({},se.normal,{escape:ue(se.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),se.gfm.url=ue(se.gfm.url,"i").replace("email",se.gfm._extended_email).getRegex(),se.breaks=q({},se.gfm,{br:ue(se.br).replace("{2,}","*").getRegex(),text:ue(se.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ve={block:le,inline:se},Fe=z,Me=T.exports.defaults,Oe=ve.block,Ye=ve.inline,ze=A.repeatString;function je(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function x(Pe){var ye="",Ce,Z,ce=Pe.length;for(Ce=0;Ce<ce;Ce++)Z=Pe.charCodeAt(Ce),Math.random()>.5&&(Z="x"+Z.toString(16)),ye+="&#"+Z+";";return ye}var Y=function(){function Pe(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||Me,this.options.tokenizer=this.options.tokenizer||new Fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:Oe.normal,inline:Ye.normal};this.options.pedantic?(Z.block=Oe.pedantic,Z.inline=Ye.pedantic):this.options.gfm&&(Z.block=Oe.gfm,this.options.breaks?Z.inline=Ye.breaks:Z.inline=Ye.gfm),this.tokenizer.rules=Z}Pe.lex=function(Z,ce){var ge=new Pe(ce);return ge.lex(Z)},Pe.lexInline=function(Z,ce){var ge=new Pe(ce);return ge.inlineTokens(Z)};var ye=Pe.prototype;return ye.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(Z,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},ye.blockTokens=function(Z,ce){var ge=this;ce===void 0&&(ce=[]),this.options.pedantic&&(Z=Z.replace(/^ +$/gm,""));for(var fe,Ie,xe,Le;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ze){return(fe=Ze.call({lexer:ge},Z,ce))?(Z=Z.substring(fe.raw.length),ce.push(fe),!0):!1}))){if(fe=this.tokenizer.space(Z)){Z=Z.substring(fe.raw.length),fe.type&&ce.push(fe);continue}if(fe=this.tokenizer.code(Z)){Z=Z.substring(fe.raw.length),Ie=ce[ce.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ce.push(fe);continue}if(fe=this.tokenizer.fences(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.heading(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.hr(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.blockquote(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.list(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.html(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.def(Z)){Z=Z.substring(fe.raw.length),Ie=ce[ce.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.lheading(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(xe=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ze=Infinity,ie=Z.slice(1),pe=void 0;ge.options.extensions.startBlock.forEach(function(re){pe=re.call({lexer:this},ie),typeof pe=="number"&&pe>=0&&(Ze=Math.min(Ze,pe))}),Ze<Infinity&&Ze>=0&&(xe=Z.substring(0,Ze+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(xe))){Ie=ce[ce.length-1],Le&&Ie.type==="paragraph"?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ce.push(fe),Le=xe.length!==Z.length,Z=Z.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(Z)){Z=Z.substring(fe.raw.length),Ie=ce[ce.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+fe.raw,Ie.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ce.push(fe);continue}if(Z){var Ve="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Ve);break}else throw new Error(Ve)}}return this.state.top=!0,ce},ye.inline=function(Z,ce){this.inlineQueue.push({src:Z,tokens:ce})},ye.inlineTokens=function(Z,ce){var ge=this;ce===void 0&&(ce=[]);var fe,Ie,xe,Le=Z,Ve,Ze,ie;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(Ve=this.tokenizer.rules.inline.reflinkSearch.exec(Le))!=null;)pe.includes(Ve[0].slice(Ve[0].lastIndexOf("[")+1,-1))&&(Le=Le.slice(0,Ve.index)+"["+ze("a",Ve[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ve=this.tokenizer.rules.inline.blockSkip.exec(Le))!=null;)Le=Le.slice(0,Ve.index)+"["+ze("a",Ve[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ve=this.tokenizer.rules.inline.escapedEmSt.exec(Le))!=null;)Le=Le.slice(0,Ve.index)+"++"+Le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(Ze||(ie=""),Ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(B){return(fe=B.call({lexer:ge},Z,ce))?(Z=Z.substring(fe.raw.length),ce.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.tag(Z)){Z=Z.substring(fe.raw.length),Ie=ce[ce.length-1],Ie&&fe.type==="text"&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):ce.push(fe);continue}if(fe=this.tokenizer.link(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(fe.raw.length),Ie=ce[ce.length-1],Ie&&fe.type==="text"&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):ce.push(fe);continue}if(fe=this.tokenizer.emStrong(Z,Le,ie)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.codespan(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.br(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.del(Z)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(fe=this.tokenizer.autolink(Z,x)){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(Z,x))){Z=Z.substring(fe.raw.length),ce.push(fe);continue}if(xe=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var B=Infinity,De=Z.slice(1),Se=void 0;ge.options.extensions.startInline.forEach(function(qe){Se=qe.call({lexer:this},De),typeof Se=="number"&&Se>=0&&(B=Math.min(B,Se))}),B<Infinity&&B>=0&&(xe=Z.substring(0,B+1))}(),fe=this.tokenizer.inlineText(xe,je)){Z=Z.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(ie=fe.raw.slice(-1)),Ze=!0,Ie=ce[ce.length-1],Ie&&Ie.type==="text"?(Ie.raw+=fe.raw,Ie.text+=fe.text):ce.push(fe);continue}if(Z){var re="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(re);break}else throw new Error(re)}}return ce},e(Pe,null,[{key:"rules",get:function(){return{block:Oe,inline:Ye}}}]),Pe}(),ee=T.exports.defaults,ae=A.cleanUrl,j=A.escape,oe=function(){function Pe(Ce){this.options=Ce||ee}var ye=Pe.prototype;return ye.code=function(Z,ce,ge){var fe=(ce||"").match(/\S*/)[0];if(this.options.highlight){var Ie=this.options.highlight(Z,fe);Ie!=null&&Ie!==Z&&(ge=!0,Z=Ie)}return Z=Z.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+j(fe,!0)+'">'+(ge?Z:j(Z,!0))+`</code></pre>
`:"<pre><code>"+(ge?Z:j(Z,!0))+`</code></pre>
`},ye.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},ye.html=function(Z){return Z},ye.heading=function(Z,ce,ge,fe){return this.options.headerIds?"<h"+ce+' id="'+this.options.headerPrefix+fe.slug(ge)+'">'+Z+"</h"+ce+`>
`:"<h"+ce+">"+Z+"</h"+ce+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(Z,ce,ge){var fe=ce?"ol":"ul",Ie=ce&&ge!==1?' start="'+ge+'"':"";return"<"+fe+Ie+`>
`+Z+"</"+fe+`>
`},ye.listitem=function(Z){return"<li>"+Z+`</li>
`},ye.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(Z){return"<p>"+Z+`</p>
`},ye.table=function(Z,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ce+`</table>
`},ye.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},ye.tablecell=function(Z,ce){var ge=ce.header?"th":"td",fe=ce.align?"<"+ge+' align="'+ce.align+'">':"<"+ge+">";return fe+Z+"</"+ge+`>
`},ye.strong=function(Z){return"<strong>"+Z+"</strong>"},ye.em=function(Z){return"<em>"+Z+"</em>"},ye.codespan=function(Z){return"<code>"+Z+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(Z){return"<del>"+Z+"</del>"},ye.link=function(Z,ce,ge){if(Z=ae(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ge;var fe='<a href="'+j(Z)+'"';return ce&&(fe+=' title="'+ce+'"'),fe+=">"+ge+"</a>",fe},ye.image=function(Z,ce,ge){if(Z=ae(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ge;var fe='<img src="'+Z+'" alt="'+ge+'"';return ce&&(fe+=' title="'+ce+'"'),fe+=this.options.xhtml?"/>":">",fe},ye.text=function(Z){return Z},Pe}(),he=function(){function Pe(){}var ye=Pe.prototype;return ye.strong=function(Z){return Z},ye.em=function(Z){return Z},ye.codespan=function(Z){return Z},ye.del=function(Z){return Z},ye.html=function(Z){return Z},ye.text=function(Z){return Z},ye.link=function(Z,ce,ge){return""+ge},ye.image=function(Z,ce,ge){return""+ge},ye.br=function(){return""},Pe}(),Te=function(){function Pe(){this.seen={}}var ye=Pe.prototype;return ye.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(Z,ce){var ge=Z,fe=0;if(this.seen.hasOwnProperty(ge)){fe=this.seen[Z];do fe++,ge=Z+"-"+fe;while(this.seen.hasOwnProperty(ge))}return ce||(this.seen[Z]=fe,this.seen[ge]=0),ge},ye.slug=function(Z,ce){ce===void 0&&(ce={});var ge=this.serialize(Z);return this.getNextSafeSlug(ge,ce.dryrun)},Pe}(),Be=oe,$e=he,Qe=Te,_e=T.exports.defaults,nt=A.unescape,H=function(){function Pe(Ce){this.options=Ce||_e,this.options.renderer=this.options.renderer||new Be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new $e,this.slugger=new Qe}Pe.parse=function(Z,ce){var ge=new Pe(ce);return ge.parse(Z)},Pe.parseInline=function(Z,ce){var ge=new Pe(ce);return ge.parseInline(Z)};var ye=Pe.prototype;return ye.parse=function(Z,ce){ce===void 0&&(ce=!0);var ge="",fe,Ie,xe,Le,Ve,Ze,ie,pe,re,B,De,Se,qe,We,tt,mt,wt,rt,ct,lt=Z.length;for(fe=0;fe<lt;fe++){if(B=Z[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[B.type]&&(ct=this.options.extensions.renderers[B.type].call({parser:this},B),ct!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(B.type))){ge+=ct||"";continue}switch(B.type){case"space":continue;case"hr":{ge+=this.renderer.hr();continue}case"heading":{ge+=this.renderer.heading(this.parseInline(B.tokens),B.depth,nt(this.parseInline(B.tokens,this.textRenderer)),this.slugger);continue}case"code":{ge+=this.renderer.code(B.text,B.lang,B.escaped);continue}case"table":{for(pe="",ie="",Le=B.header.length,Ie=0;Ie<Le;Ie++)ie+=this.renderer.tablecell(this.parseInline(B.header[Ie].tokens),{header:!0,align:B.align[Ie]});for(pe+=this.renderer.tablerow(ie),re="",Le=B.rows.length,Ie=0;Ie<Le;Ie++){for(Ze=B.rows[Ie],ie="",Ve=Ze.length,xe=0;xe<Ve;xe++)ie+=this.renderer.tablecell(this.parseInline(Ze[xe].tokens),{header:!1,align:B.align[xe]});re+=this.renderer.tablerow(ie)}ge+=this.renderer.table(pe,re);continue}case"blockquote":{re=this.parse(B.tokens),ge+=this.renderer.blockquote(re);continue}case"list":{for(De=B.ordered,Se=B.start,qe=B.loose,Le=B.items.length,re="",Ie=0;Ie<Le;Ie++)tt=B.items[Ie],mt=tt.checked,wt=tt.task,We="",tt.task&&(rt=this.renderer.checkbox(mt),qe?tt.tokens.length>0&&tt.tokens[0].type==="paragraph"?(tt.tokens[0].text=rt+" "+tt.tokens[0].text,tt.tokens[0].tokens&&tt.tokens[0].tokens.length>0&&tt.tokens[0].tokens[0].type==="text"&&(tt.tokens[0].tokens[0].text=rt+" "+tt.tokens[0].tokens[0].text)):tt.tokens.unshift({type:"text",text:rt}):We+=rt),We+=this.parse(tt.tokens,qe),re+=this.renderer.listitem(We,wt,mt);ge+=this.renderer.list(re,De,Se);continue}case"html":{ge+=this.renderer.html(B.text);continue}case"paragraph":{ge+=this.renderer.paragraph(this.parseInline(B.tokens));continue}case"text":{for(re=B.tokens?this.parseInline(B.tokens):B.text;fe+1<lt&&Z[fe+1].type==="text";)B=Z[++fe],re+=`
`+(B.tokens?this.parseInline(B.tokens):B.text);ge+=ce?this.renderer.paragraph(re):re;continue}default:{var Tt='Token with "'+B.type+'" type was not found.';if(this.options.silent){console.error(Tt);return}else throw new Error(Tt)}}}return ge},ye.parseInline=function(Z,ce){ce=ce||this.renderer;var ge="",fe,Ie,xe,Le=Z.length;for(fe=0;fe<Le;fe++){if(Ie=Z[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(xe=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),xe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ie.type))){ge+=xe||"";continue}switch(Ie.type){case"escape":{ge+=ce.text(Ie.text);break}case"html":{ge+=ce.html(Ie.text);break}case"link":{ge+=ce.link(Ie.href,Ie.title,this.parseInline(Ie.tokens,ce));break}case"image":{ge+=ce.image(Ie.href,Ie.title,Ie.text);break}case"strong":{ge+=ce.strong(this.parseInline(Ie.tokens,ce));break}case"em":{ge+=ce.em(this.parseInline(Ie.tokens,ce));break}case"codespan":{ge+=ce.codespan(Ie.text);break}case"br":{ge+=ce.br();break}case"del":{ge+=ce.del(this.parseInline(Ie.tokens,ce));break}case"text":{ge+=ce.text(Ie.text);break}default:{var Ve='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(Ve);return}else throw new Error(Ve)}}}return ge},Pe}(),J=Y,me=H,Ne=z,Ke=oe,ot=he,at=Te,vt=A.merge,kt=A.checkSanitizeDeprecation,ht=A.escape,yt=T.exports.getDefaults,It=T.exports.changeDefaults,ft=T.exports.defaults;function Je(Pe,ye,Ce){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof ye=="function"&&(Ce=ye,ye=null),ye=vt({},Je.defaults,ye||{}),kt(ye),Ce){var Z=ye.highlight,ce;try{ce=J.lex(Pe,ye)}catch(xe){return Ce(xe)}var ge=function(Le){var Ve;if(!Le)try{ye.walkTokens&&Je.walkTokens(ce,ye.walkTokens),Ve=me.parse(ce,ye)}catch(Ze){Le=Ze}return ye.highlight=Z,Le?Ce(Le):Ce(null,Ve)};if(!Z||Z.length<3||(delete ye.highlight,!ce.length))return ge();var fe=0;Je.walkTokens(ce,function(xe){xe.type==="code"&&(fe++,setTimeout(function(){Z(xe.text,xe.lang,function(Le,Ve){if(Le)return ge(Le);Ve!=null&&Ve!==xe.text&&(xe.text=Ve,xe.escaped=!0),fe--,fe===0&&ge()})},0))}),fe===0&&ge();return}try{var Ie=J.lex(Pe,ye);return ye.walkTokens&&Je.walkTokens(Ie,ye.walkTokens),me.parse(Ie,ye)}catch(xe){if(xe.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ht(xe.message+"",!0)+"</pre>";throw xe}}Je.options=Je.setOptions=function(Pe){return vt(Je.defaults,Pe),It(Je.defaults),Je},Je.getDefaults=yt,Je.defaults=ft,Je.use=function(){for(var Pe=this,ye=arguments.length,Ce=new Array(ye),Z=0;Z<ye;Z++)Ce[Z]=arguments[Z];var ce=vt.apply(void 0,[{}].concat(Ce)),ge=Je.defaults.extensions||{renderers:{},childTokens:{}},fe;Ce.forEach(function(Ie){if(Ie.extensions&&(fe=!0,Ie.extensions.forEach(function(Le){if(!Le.name)throw new Error("extension name required");if(Le.renderer){var Ve=ge.renderers?ge.renderers[Le.name]:null;Ve?ge.renderers[Le.name]=function(){for(var Ze=arguments.length,ie=new Array(Ze),pe=0;pe<Ze;pe++)ie[pe]=arguments[pe];var re=Le.renderer.apply(this,ie);return re===!1&&(re=Ve.apply(this,ie)),re}:ge.renderers[Le.name]=Le.renderer}if(Le.tokenizer){if(!Le.level||Le.level!=="block"&&Le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ge[Le.level]?ge[Le.level].unshift(Le.tokenizer):ge[Le.level]=[Le.tokenizer],Le.start&&(Le.level==="block"?ge.startBlock?ge.startBlock.push(Le.start):ge.startBlock=[Le.start]:Le.level==="inline"&&(ge.startInline?ge.startInline.push(Le.start):ge.startInline=[Le.start]))}Le.childTokens&&(ge.childTokens[Le.name]=Le.childTokens)})),Ie.renderer&&function(){var Le=Je.defaults.renderer||new Ke,Ve=function(pe){var re=Le[pe];Le[pe]=function(){for(var B=arguments.length,De=new Array(B),Se=0;Se<B;Se++)De[Se]=arguments[Se];var qe=Ie.renderer[pe].apply(Le,De);return qe===!1&&(qe=re.apply(Le,De)),qe}};for(var Ze in Ie.renderer)Ve(Ze);ce.renderer=Le}(),Ie.tokenizer&&function(){var Le=Je.defaults.tokenizer||new Ne,Ve=function(pe){var re=Le[pe];Le[pe]=function(){for(var B=arguments.length,De=new Array(B),Se=0;Se<B;Se++)De[Se]=arguments[Se];var qe=Ie.tokenizer[pe].apply(Le,De);return qe===!1&&(qe=re.apply(Le,De)),qe}};for(var Ze in Ie.tokenizer)Ve(Ze);ce.tokenizer=Le}(),Ie.walkTokens){var xe=Je.defaults.walkTokens;ce.walkTokens=function(Le){Ie.walkTokens.call(Pe,Le),xe&&xe(Le)}}fe&&(ce.extensions=ge),Je.setOptions(ce)})},Je.walkTokens=function(Pe,ye){for(var Ce=function(){var fe=ce.value;switch(ye(fe),fe.type){case"table":{for(var Ie=b(fe.header),xe;!(xe=Ie()).done;){var Le=xe.value;Je.walkTokens(Le.tokens,ye)}for(var Ve=b(fe.rows),Ze;!(Ze=Ve()).done;)for(var ie=Ze.value,pe=b(ie),re;!(re=pe()).done;){var B=re.value;Je.walkTokens(B.tokens,ye)}break}case"list":{Je.walkTokens(fe.items,ye);break}default:Je.defaults.extensions&&Je.defaults.extensions.childTokens&&Je.defaults.extensions.childTokens[fe.type]?Je.defaults.extensions.childTokens[fe.type].forEach(function(De){Je.walkTokens(fe[De],ye)}):fe.tokens&&Je.walkTokens(fe.tokens,ye)}},Z=b(Pe),ce;!(ce=Z()).done;)Ce()},Je.parseInline=function(Pe,ye){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");ye=vt({},Je.defaults,ye||{}),kt(ye);try{var Ce=J.lexInline(Pe,ye);return ye.walkTokens&&Je.walkTokens(Ce,ye.walkTokens),me.parseInline(Ce,ye)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ht(Z.message+"",!0)+"</pre>";throw Z}},Je.Parser=me,Je.parser=me.parse,Je.Renderer=Ke,Je.TextRenderer=ot,Je.Lexer=J,Je.lexer=J.lex,Je.Tokenizer=Ne,Je.Slugger=at,Je.parse=Je;var Et=Je;return Et}),define(we[75],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function h(F,D,_){return Math.min(Math.max(F,D),_)}e.clamp=h;function M(F,D){return(D+F%D)%D}e.rot=M;class b{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=b;class T{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T}),function(){function ne(b){const T=[];typeof b=="number"&&T.push("code/timeOrigin",b);function F(_){T.push(_,Date.now())}function D(){const _=[];for(let P=0;P<T.length;P+=2)_.push({name:T[P],startTime:T[P+1]});return _}return{mark:F,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const F of performance.getEntriesByType("mark"))T.push({name:F.name,startTime:Math.round(b+F.startTime)});return T}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function h(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=e()),b.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return h(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=h(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=h(M))}(),define(we[104],be([0,1]),function(ne,e){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class M{constructor(D,_,P){this.level=D,this.key=_,this.value=P,this.forward=[]}}const b=void 0;class T{constructor(D,_=2**16){this.comparator=D,this[h]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(_)|0),this._header=new M(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new M(this._maxLevel,b,b)}has(D){return Boolean(T._search(this,D,this.comparator))}get(D){return T._search(this,D,this.comparator)?.value}set(D,_){return T._insert(this,D,_,this.comparator)&&(this._size+=1),this}delete(D){const _=T._delete(this,D,this.comparator);return _&&(this._size-=1),_}forEach(D,_){let P=this._header.forward[0];for(;P;)D.call(_,P.value,P.key,this),P=P.forward[0]}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let D=this._header.forward[0];for(;D;)yield[D.key,D.value],D=D.forward[0]}*keys(){let D=this._header.forward[0];for(;D;)yield D.key,D=D.forward[0]}*values(){let D=this._header.forward[0];for(;D;)yield D.value,D=D.forward[0]}toString(){let D="[SkipList]:",_=this._header.forward[0];for(;_;)D+=`node(${_.key}, ${_.value}, lvl:${_.level})`,_=_.forward[0];return D}static _search(D,_,P){let t=D._header;for(let E=D._level-1;E>=0;E--)for(;t.forward[E]&&P(t.forward[E].key,_)<0;)t=t.forward[E];if(t=t.forward[0],t&&P(t.key,_)===0)return t}static _insert(D,_,P,t){let E=[],n=D._header;for(let d=D._level-1;d>=0;d--){for(;n.forward[d]&&t(n.forward[d].key,_)<0;)n=n.forward[d];E[d]=n}if(n=n.forward[0],n&&t(n.key,_)===0)return n.value=P,!1;{let d=T._randomLevel(D);if(d>D._level){for(let c=D._level;c<d;c++)E[c]=D._header;D._level=d}n=new M(d,_,P);for(let c=0;c<d;c++)n.forward[c]=E[c].forward[c],E[c].forward[c]=n;return!0}}static _randomLevel(D,_=.5){let P=1;for(;Math.random()<_&&P<D._maxLevel;)P+=1;return P}static _delete(D,_,P){let t=[],E=D._header;for(let n=D._level-1;n>=0;n--){for(;E.forward[n]&&P(E.forward[n].key,_)<0;)E=E.forward[n];t[n]=E}if(E=E.forward[0],!E||P(E.key,_)!==0)return!1;for(let n=0;n<D._level&&t[n].forward[n]===E;n++)t[n].forward[n]=E.forward[n];for(;D._level>0&&D._header.forward[D._level-1]===b;)D._level-=1;return!0}}e.SkipList=T}),define(we[34],be([0,1,3]),function(ne,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new h.Emitter}add(E){const n=this._icons.get(E.id);n?E.description?n.description=E.description:console.error(`Duplicate registration of codicon ${E.id}`):(this._icons.set(E.id,E),this._onDidRegister.fire(E))}get(E){return this._icons.get(E)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const b=new M;e.iconRegistry=b;function T(t,E){return new D(t,E)}e.registerCodicon=T;function F(t){return t?t.replace(/\$\((.*?)\)/g,(E,n)=>` ${n} `).trim():""}e.getCodiconAriaLabel=F;class D{constructor(E,n,d){this.id=E,this.definition=n,this.description=d,b.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function _(t,E){const n=["codicon","codicon-"+t];return E&&n.push("codicon-modifier-"+E),n}e.getClassNamesArray=_;var P;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const E=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function n(l){if(l instanceof D)return["codicon","codicon-"+l.id];const w=E.exec(l.id);if(!w)return n(D.error);let[,I,y]=w;const s=["codicon","codicon-"+I];return y&&s.push("codicon-modifier-"+y.substr(1)),s}t.asClassNameArray=n;function d(l){return n(l).join(" ")}t.asClassName=d;function c(l){return"."+n(l).join(".")}t.asCSSSelector=c})(P=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(we[105],be([0,1,16,6]),function(ne,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function b(s){const g=s;return g?[g.on,g.pause,g.resume,g.destroy].every(k=>typeof k=="function"):!1}e.isReadableStream=b;function T(s){const g=s;return g?b(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.isReadableBufferedStream=T;function F(s,g){return new D(s,g)}e.newWriteableStream=F;class D{constructor(g,k){this.reducer=g,this.options=k,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(g){if(!this.state.destroyed){if(this.state.flowing)this.emitData(g);else if(this.buffer.data.push(g),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(k=>this.pendingWritePromises.push(k))}}error(g){this.state.destroyed||(this.state.flowing?this.emitError(g):this.buffer.error.push(g))}end(g){this.state.destroyed||(typeof g!="undefined"&&this.write(g),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(g){this.listeners.data.slice(0).forEach(k=>k(g))}emitError(g){this.listeners.error.length===0?(0,h.onUnexpectedError)(g):this.listeners.error.slice(0).forEach(k=>k(g))}emitEnd(){this.listeners.end.slice(0).forEach(g=>g())}on(g,k){if(!this.state.destroyed)switch(g){case"data":this.listeners.data.push(k),this.resume();break;case"end":this.listeners.end.push(k),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(k),this.state.flowing&&this.flowErrors();break}}removeListener(g,k){if(this.state.destroyed)return;let i;switch(g){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const a=i.indexOf(k);a>=0&&i.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const g=this.reducer(this.buffer.data);this.emitData(g),this.buffer.data.length=0;const k=[...this.pendingWritePromises];this.pendingWritePromises.length=0,k.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const g of this.buffer.error)this.emitError(g);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(s,g){const k=[];let i;for(;(i=s.read())!==null;)k.push(i);return g(k)}e.consumeReadable=_;function P(s,g,k){const i=[];let a;for(;(a=s.read())!==null&&i.length<k;)i.push(a);return a===null&&i.length>0?g(i):{read:()=>{if(i.length>0)return i.shift();if(typeof a!="undefined"){const r=a;return a=void 0,r}return s.read()}}}e.peekReadable=P;function t(s,g){return new Promise((k,i)=>{const a=[];E(s,{onData:r=>{g&&a.push(r)},onError:r=>{g?i(r):k(void 0)},onEnd:()=>{k(g?g(a):void 0)}})})}e.consumeStream=t;function E(s,g){s.on("error",k=>g.onError(k)),s.on("end",()=>g.onEnd()),s.on("data",k=>g.onData(k))}e.listenStream=E;function n(s,g){return new Promise((k,i)=>{const a=new M.DisposableStore,r=[],o=v=>{if(r.push(v),r.length>g)return a.dispose(),s.pause(),k({stream:s,buffer:r,ended:!1})},f=v=>i(v),m=()=>k({stream:s,buffer:r,ended:!0});a.add((0,M.toDisposable)(()=>s.removeListener("error",f))),s.on("error",f),a.add((0,M.toDisposable)(()=>s.removeListener("end",m))),s.on("end",m),a.add((0,M.toDisposable)(()=>s.removeListener("data",o))),s.on("data",o)})}e.peekStream=n;function d(s,g){const k=F(g);return k.end(s),k}e.toStream=d;function c(){const s=F(()=>{throw new Error("not supported")});return s.end(),s}e.emptyStream=c;function l(s){let g=!1;return{read:()=>g?null:(g=!0,s)}}e.toReadable=l;function w(s,g,k){const i=F(k);return E(s,{onData:a=>i.write(g.data(a)),onError:a=>i.error(g.error?g.error(a):a),onEnd:()=>i.end()}),i}e.transform=w;function I(s,g,k){let i=!1;return{read:()=>{const a=g.read();return i?a:(i=!0,a!==null?k([s,a]):s)}}}e.prefixedReadable=I;function y(s,g,k){let i=!1;const a=F(k);return E(g,{onData:r=>i?a.write(r):(i=!0,a.write(k([s,r]))),onError:r=>a.error(r),onEnd:()=>{i||(i=!0,a.write(s)),a.end()}}),a}e.prefixedStream=y}),define(we[23],be([0,1,105]),function(ne,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer!="undefined";let b,T;class F{constructor(o){this.buffer=o,this.byteLength=this.buffer.byteLength}static alloc(o){return M?new F(Buffer.allocUnsafe(o)):new F(new Uint8Array(o))}static wrap(o){return M&&!Buffer.isBuffer(o)&&(o=Buffer.from(o.buffer,o.byteOffset,o.byteLength)),new F(o)}static fromString(o,f){return!(f?.dontUseNodeBuffer||!1)&&M?new F(Buffer.from(o)):(b||(b=new TextEncoder),new F(b.encode(o)))}static concat(o,f){if(typeof f=="undefined"){f=0;for(let C=0,R=o.length;C<R;C++)f+=o[C].byteLength}const m=F.alloc(f);let v=0;for(let C=0,R=o.length;C<R;C++){const p=o[C];m.set(p,v),v+=p.byteLength}return m}toString(){return M?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(o,f){return new F(this.buffer.subarray(o,f))}set(o,f){o instanceof F?this.buffer.set(o.buffer,f):this.buffer.set(o,f)}readUInt32BE(o){return P(this.buffer,o)}writeUInt32BE(o,f){t(this.buffer,o,f)}readUInt32LE(o){return E(this.buffer,o)}writeUInt32LE(o,f){n(this.buffer,o,f)}readUInt8(o){return d(this.buffer,o)}writeUInt8(o,f){c(this.buffer,o,f)}}e.VSBuffer=F;function D(r,o){return r[o+0]<<0>>>0|r[o+1]<<8>>>0}e.readUInt16LE=D;function _(r,o,f){r[f+0]=o&255,o=o>>>8,r[f+1]=o&255}e.writeUInt16LE=_;function P(r,o){return r[o]*2**24+r[o+1]*2**16+r[o+2]*2**8+r[o+3]}e.readUInt32BE=P;function t(r,o,f){r[f+3]=o,o=o>>>8,r[f+2]=o,o=o>>>8,r[f+1]=o,o=o>>>8,r[f]=o}e.writeUInt32BE=t;function E(r,o){return r[o+0]<<0>>>0|r[o+1]<<8>>>0|r[o+2]<<16>>>0|r[o+3]<<24>>>0}e.readUInt32LE=E;function n(r,o,f){r[f+0]=o&255,o=o>>>8,r[f+1]=o&255,o=o>>>8,r[f+2]=o&255,o=o>>>8,r[f+3]=o&255}e.writeUInt32LE=n;function d(r,o){return r[o]}e.readUInt8=d;function c(r,o,f){r[f]=o}e.writeUInt8=c;function l(r){return h.consumeReadable(r,o=>F.concat(o))}e.readableToBuffer=l;function w(r){return h.toReadable(r)}e.bufferToReadable=w;function I(r){return h.consumeStream(r,o=>F.concat(o))}e.streamToBuffer=I;async function y(r){return r.ended?F.concat(r.buffer):F.concat([...r.buffer,await I(r.stream)])}e.bufferedStreamToBuffer=y;function s(r){return h.toStream(r,o=>F.concat(o))}e.bufferToStream=s;function g(r){return h.transform(r,{data:o=>typeof o=="string"?F.fromString(o):F.wrap(o)},o=>F.concat(o))}e.streamToBufferReadableStream=g;function k(r){return h.newWriteableStream(o=>F.concat(o),r)}e.newWriteableBufferStream=k;function i(r,o){return h.prefixedReadable(r,o,f=>F.concat(f))}e.prefixedBufferReadable=i;function a(r,o){return h.prefixedStream(r,o,f=>F.concat(f))}e.prefixedBufferStream=a}),define(we[35],be([0,1,9]),function(ne,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(M||(M={})),function(b){const T="error",F="warning",D="warn",_="info",P="ignore";function t(n){return n?h.equalsIgnoreCase(T,n)?b.Error:h.equalsIgnoreCase(F,n)||h.equalsIgnoreCase(D,n)?b.Warning:h.equalsIgnoreCase(_,n)?b.Info:b.Ignore:b.Ignore}b.fromValue=t;function E(n){switch(n){case b.Error:return T;case b.Warning:return F;case b.Info:return _;default:return P}}b.toString=E}(M||(M={})),e.default=M}),define(we[41],be([0,1,17,26,9,10]),function(ne,e,h,M,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function F(r){return r===47||r===92}e.isPathSeparator=F;function D(r){return r.replace(/[\\/]/g,h.posix.sep)}e.toSlashes=D;function _(r){return r.indexOf("/")===-1&&(r=D(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=_;function P(r,o=h.posix.sep){if(!r)return"";const f=r.length,m=r.charCodeAt(0);if(F(m)){if(F(r.charCodeAt(1))&&!F(r.charCodeAt(2))){let C=3;const R=C;for(;C<f&&!F(r.charCodeAt(C));C++);if(R!==C&&!F(r.charCodeAt(C+1))){for(C+=1;C<f;C++)if(F(r.charCodeAt(C)))return r.slice(0,C+1).replace(/[\\/]/g,o)}}return o}else if(I(m)&&r.charCodeAt(1)===58)return F(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let v=r.indexOf("://");if(v!==-1){for(v+=3;v<f;v++)if(F(r.charCodeAt(v)))return r.slice(0,v+1)}return""}e.getRoot=P;function t(r){if(!M.isWindows||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let f=2;const m=f;for(;f<r.length&&(o=r.charCodeAt(f),o!==92);f++);return!(m===f||(o=r.charCodeAt(f+1),isNaN(o)||o===92))}e.isUNC=t;const E=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(r,o=M.isWindows){const f=o?E:n;return!(!r||r.length===0||/^\s+$/.test(r)||(f.lastIndex=0,f.test(r))||o&&d.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=c;function l(r,o,f){const m=r===o;return!f||m?m:!r||!o?!1:(0,b.equalsIgnoreCase)(r,o)}e.isEqual=l;function w(r,o,f,m=h.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(f){if(!(0,b.startsWithIgnoreCase)(r,o))return!1;if(o.length===r.length)return!0;let C=o.length;return o.charAt(o.length-1)===m&&C--,r.charAt(C)===m}return o.charAt(o.length-1)!==m&&(o+=m),r.indexOf(o)===0}e.isEqualOrParent=w;function I(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=I;function y(r,o){return M.isWindows&&r.endsWith(":")&&(r+=h.sep),(0,h.isAbsolute)(r)||(r=(0,h.join)(o,r)),r=(0,h.normalize)(r),M.isWindows?(r=(0,b.rtrim)(r,h.sep),r.endsWith(":")&&(r+=h.sep)):(r=(0,b.rtrim)(r,h.sep),r||(r=h.sep)),r}e.sanitizeFilePath=y;function s(r){const o=(0,h.normalize)(r);return M.isWindows?r.length>3?!1:g(o)&&(r.length===2||o.charCodeAt(2)===92):o===h.posix.sep}e.isRootOrDriveLetter=s;function g(r){return M.isWindows?I(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function k(r){return g(r)?r[0]:void 0}e.getDriveLetter=k;function i(r,o,f){return o.length>r.length?-1:r===o?0:(f&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.indexOfPath=i;function a(r){const o=r.split(":");let f,m,v;if(o.forEach(C=>{const R=Number(C);(0,T.isNumber)(R)?m===void 0?m=R:v===void 0&&(v=R):f=f?[f,C].join(":"):C}),!f)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:f,line:m!==void 0?m:void 0,column:v!==void 0?v:m!==void 0?1:void 0}}e.parseLineAndColumnAware=a}),define(we[22],be([0,1,10]),function(ne,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const w=Array.isArray(l)?[]:{};return Object.keys(l).forEach(I=>{l[I]&&typeof l[I]=="object"?w[I]=M(l[I]):w[I]=l[I]}),w}e.deepClone=M;function b(l){if(!l||typeof l!="object")return l;const w=[l];for(;w.length>0;){const I=w.shift();Object.freeze(I);for(const y in I)if(T.call(I,y)){const s=I[y];typeof s=="object"&&!Object.isFrozen(s)&&w.push(s)}}return l}e.deepFreeze=b;const T=Object.prototype.hasOwnProperty;function F(l,w){return D(l,w,new Set)}e.cloneAndChange=F;function D(l,w,I){if((0,h.isUndefinedOrNull)(l))return l;const y=w(l);if(typeof y!="undefined")return y;if((0,h.isArray)(l)){const s=[];for(const g of l)s.push(D(g,w,I));return s}if((0,h.isObject)(l)){if(I.has(l))throw new Error("Cannot clone recursive data-structure");I.add(l);const s={};for(let g in l)T.call(l,g)&&(s[g]=D(l[g],w,I));return I.delete(l),s}return l}function _(l,w,I=!0){return(0,h.isObject)(l)?((0,h.isObject)(w)&&Object.keys(w).forEach(y=>{y in l?I&&((0,h.isObject)(l[y])&&(0,h.isObject)(w[y])?_(l[y],w[y],I):l[y]=w[y]):l[y]=w[y]}),l):w}e.mixin=_;function P(l,w){if(l===w)return!0;if(l==null||w===null||w===void 0||typeof l!=typeof w||typeof l!="object"||Array.isArray(l)!==Array.isArray(w))return!1;let I,y;if(Array.isArray(l)){if(l.length!==w.length)return!1;for(I=0;I<l.length;I++)if(!P(l[I],w[I]))return!1}else{const s=[];for(y in l)s.push(y);s.sort();const g=[];for(y in w)g.push(y);if(g.sort(),!P(s,g))return!1;for(I=0;I<s.length;I++)if(!P(l[s[I]],w[s[I]]))return!1}return!0}e.equals=P;function t(l){const w=new Set;return JSON.stringify(l,(I,y)=>{if((0,h.isObject)(y)||Array.isArray(y)){if(w.has(y))return"[Circular]";w.add(y)}return y})}e.safeStringify=t;function E(l,w,I){const y=w(l);return typeof y=="undefined"?I:y}e.getOrDefault=E;function n(l,w){const I=Object.create(null);return!l||!w||Object.keys(w).forEach(s=>{const g=l[s],k=w[s];P(g,k)||(I[s]=k)}),I}e.distinct=n;function d(l,w){const I=w.toLowerCase(),y=Object.keys(l).find(s=>s.toLowerCase()===I);return y?l[y]:l[w]}e.getCaseInsensitive=d;function c(l,w){const I=Object.create(null);for(const y of Object.keys(l))w(y,l[y])&&(I[y]=l[y]);return I}e.filter=c});var Xe=this&&this.__classPrivateFieldSet||function(ne,e,h,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ne,h):b?b.value=h:e.set(ne,h),h},Ae=this&&this.__classPrivateFieldGet||function(ne,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[20],be([0,1,13,9,2]),function(ne,e,h,M,b){"use strict";var T,F,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function _(a,r,o){let f=a.get(r);return f===void 0&&(f=o,a.set(r,f)),f}e.getOrSet=_;function P(a){const r=[];return a.forEach((o,f)=>{r.push(`${f} => ${o}`)}),`Map(${a.size}) {${r.join(", ")}}`}e.mapToString=P;function t(a){const r=[];return a.forEach(o=>{r.push(o)}),`Set(${a.size}) {${r.join(", ")}}`}e.setToString=t;class E{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const o=r.charCodeAt(0),f=this._value.charCodeAt(this._pos);return o-f}value(){return this._value[this._pos]}}e.StringIterator=E;class n{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=n;class d{constructor(r=!0,o=!0){this._splitOnBackslash=r,this._caseSensitive=o}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var c;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(c||(c={}));class l{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,M.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=l;class w{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class I{constructor(r){this._iter=r}static forUris(r=()=>!1){return new I(new l(r))}static forPaths(){return new I(new d)}static forStrings(){return new I(new E)}static forConfigKeys(){return new I(new n)}clear(){this._root=void 0}set(r,o){const f=this._iter.reset(r);let m;for(this._root||(this._root=new w,this._root.segment=f.value()),m=this._root;;){const C=f.cmp(m.segment);if(C>0)m.left||(m.left=new w,m.left.segment=f.value()),m=m.left;else if(C<0)m.right||(m.right=new w,m.right.segment=f.value()),m=m.right;else if(f.hasNext())f.next(),m.mid||(m.mid=new w,m.mid.segment=f.value()),m=m.mid;else break}const v=m.value;return m.value=o,m.key=r,v}fill(r,o){const f=o.slice(0);(0,h.shuffle)(f);for(let m of f)this.set(m,r)}get(r){return this._getNode(r)?.value}_getNode(r){const o=this._iter.reset(r);let f=this._root;for(;f;){const m=o.cmp(f.segment);if(m>0)f=f.left;else if(m<0)f=f.right;else if(o.hasNext())o.next(),f=f.mid;else break}return f}has(r){const o=this._getNode(r);return!(o?.value===void 0&&o?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,o){const f=this._iter.reset(r),m=[];let v=this._root;for(;v;){const C=f.cmp(v.segment);if(C>0)m.push([1,v]),v=v.left;else if(C<0)m.push([-1,v]),v=v.right;else if(f.hasNext())f.next(),m.push([0,v]),v=v.mid;else{for(o?(v.left=void 0,v.mid=void 0,v.right=void 0):v.value=void 0;m.length>0&&v.isEmpty();){let[R,p]=m.pop();switch(R){case 1:p.left=void 0;break;case 0:p.mid=void 0;break;case-1:p.right=void 0;break}v=p}break}}}findSubstr(r){const o=this._iter.reset(r);let f=this._root,m;for(;f;){const v=o.cmp(f.segment);if(v>0)f=f.left;else if(v<0)f=f.right;else if(o.hasNext())o.next(),m=f.value||m,f=f.mid;else break}return f&&f.value||m}findSuperstr(r){const o=this._iter.reset(r);let f=this._root;for(;f;){const m=o.cmp(f.segment);if(m>0)f=f.left;else if(m<0)f=f.right;else if(o.hasNext())o.next(),f=f.mid;else return f.mid?this._entries(f.mid):void 0}}forEach(r){for(const[o,f]of this)r(f,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const o=[r];for(;o.length>0;){const f=o.pop();f&&(f.value&&(yield[f.key,f.value]),f.left&&o.push(f.left),f.mid&&o.push(f.mid),f.right&&o.push(f.right))}}}e.TernarySearchTree=I;class y{constructor(r,o){this[T]="ResourceMap",r instanceof y?(this.map=new Map(r.map),this.toKey=o??y.defaultToKey):(this.map=new Map,this.toKey=r??y.defaultToKey)}set(r,o){return this.map.set(this.toKey(r),o),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,o){typeof o!="undefined"&&(r=r.bind(o));for(let[f,m]of this.map)r(m,b.URI.parse(f),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield b.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[b.URI.parse(r[0]),r[1]]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[b.URI.parse(r[0]),r[1]]}}e.ResourceMap=y,y.defaultToKey=a=>a.toString();var s;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(s=e.Touch||(e.Touch={}));class g{constructor(){this[F]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,o=0){const f=this._map.get(r);if(!!f)return o!==0&&this.touch(f,o),f.value}set(r,o,f=0){let m=this._map.get(r);if(m)m.value=o,f!==0&&this.touch(m,f);else{switch(m={key:r,value:o,next:void 0,previous:void 0},f){case 0:this.addItemLast(m);break;case 1:this.addItemFirst(m);break;case 2:this.addItemLast(m);break;default:this.addItemLast(m);break}this._map.set(r,m),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const o=this._map.get(r);if(!!o)return this._map.delete(r),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,o){const f=this._state;let m=this._head;for(;m;){if(o?r.bind(o)(m.value,m.key,this):r(m.value,m.key,this),this._state!==f)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const r=this,o=this._state;let f=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(f){const v={value:f.key,done:!1};return f=f.next,v}else return{value:void 0,done:!0}}};return m}values(){const r=this,o=this._state;let f=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(f){const v={value:f.value,done:!1};return f=f.next,v}else return{value:void 0,done:!0}}};return m}entries(){const r=this,o=this._state;let f=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(f){const v={value:[f.key,f.value],done:!1};return f=f.next,v}else return{value:void 0,done:!0}}};return m}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let o=this._head,f=this.size;for(;o&&f>r;)this._map.delete(o.key),o=o.next,f--;this._head=o,this._size=f,o&&(o.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const o=r.next,f=r.previous;if(!o||!f)throw new Error("Invalid list");o.previous=f,f.next=o}r.next=void 0,r.previous=void 0,this._state++}touch(r,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(r===this._head)return;const f=r.next,m=r.previous;r===this._tail?(m.next=void 0,this._tail=m):(f.previous=m,m.next=f),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(o===2){if(r===this._tail)return;const f=r.next,m=r.previous;r===this._head?(f.previous=void 0,this._head=f):(f.previous=m,m.next=f),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((o,f)=>{r.push([f,o])}),r}fromJSON(r){this.clear();for(const[o,f]of r)this.set(o,f)}}e.LinkedMap=g;class k extends g{constructor(r,o=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,o=2){return super.get(r,o)}peek(r){return super.get(r,0)}set(r,o){return super.set(r,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=k;class i{constructor(r){D.set(this,void 0),Xe(this,D,r,"f")}get size(){return Ae(this,D,"f").size}forEach(r,o){Ae(this,D,"f").forEach(r,o)}get(r){return Ae(this,D,"f").get(r)}has(r){return Ae(this,D,"f").has(r)}entries(){return Ae(this,D,"f").entries()}keys(){return Ae(this,D,"f").keys()}values(){return Ae(this,D,"f").values()}[(D=new WeakMap,Symbol.iterator)](){return Ae(this,D,"f").entries()}}e.ReadonlyMapView=i}),define(we[106],be([0,1,20,9]),function(ne,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function b(...j){return function(oe,he){for(let Te=0,Be=j.length;Te<Be;Te++){const $e=j[Te](oe,he);if($e)return $e}return null}}e.or=b,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(j,oe,he){if(!he||he.length<oe.length)return null;let Te;return j?Te=M.startsWithIgnoreCase(he,oe):Te=he.indexOf(oe)===0,Te?oe.length>0?[{start:0,end:oe.length}]:[]:null}function F(j,oe){const he=oe.toLowerCase().indexOf(j.toLowerCase());return he===-1?null:[{start:he,end:he+j.length}]}e.matchesContiguousSubString=F;function D(j,oe){return _(j.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=D;function _(j,oe,he,Te){if(he===j.length)return[];if(Te===oe.length)return null;if(j[he]===oe[Te]){let Be=null;return(Be=_(j,oe,he+1,Te+1))?I({start:Te,end:Te+1},Be):null}return _(j,oe,he,Te+1)}function P(j){return 97<=j&&j<=122}function t(j){return 65<=j&&j<=90}e.isUpper=t;function E(j){return 48<=j&&j<=57}function n(j){return j===32||j===9||j===10||j===13}const d=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(j=>d.add(j.charCodeAt(0)));function c(j){return n(j)||d.has(j)}function l(j,oe){return j===oe||c(j)&&c(oe)}function w(j){return P(j)||t(j)||E(j)}function I(j,oe){return oe.length===0?oe=[j]:j.end===oe[0].start?oe[0].start=j.start:oe.unshift(j),oe}function y(j,oe){for(let he=oe;he<j.length;he++){const Te=j.charCodeAt(he);if(t(Te)||E(Te)||he>0&&!w(j.charCodeAt(he-1)))return he}return j.length}function s(j,oe,he,Te){if(he===j.length)return[];if(Te===oe.length)return null;if(j[he]!==oe[Te].toLowerCase())return null;{let Be=null,$e=Te+1;for(Be=s(j,oe,he+1,Te+1);!Be&&($e=y(oe,$e))<oe.length;)Be=s(j,oe,he+1,$e),$e++;return Be===null?null:I({start:Te,end:Te+1},Be)}}function g(j){let oe=0,he=0,Te=0,Be=0,$e=0;for(let J=0;J<j.length;J++)$e=j.charCodeAt(J),t($e)&&oe++,P($e)&&he++,w($e)&&Te++,E($e)&&Be++;const Qe=oe/j.length,_e=he/j.length,nt=Te/j.length,H=Be/j.length;return{upperPercent:Qe,lowerPercent:_e,alphaPercent:nt,numericPercent:H}}function k(j){const{upperPercent:oe,lowerPercent:he}=j;return he===0&&oe>.6}function i(j){const{upperPercent:oe,lowerPercent:he,alphaPercent:Te,numericPercent:Be}=j;return he>.2&&oe<.8&&Te>.6&&Be<.2}function a(j){let oe=0,he=0,Te=0,Be=0;for(let $e=0;$e<j.length;$e++)Te=j.charCodeAt($e),t(Te)&&oe++,P(Te)&&he++,n(Te)&&Be++;return(oe===0||he===0)&&Be===0?j.length<=30:oe<=5}function r(j,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!a(j)||oe.length>60)return null;const he=g(oe);if(!i(he)){if(!k(he))return null;oe=oe.toLowerCase()}let Te=null,Be=0;for(j=j.toLowerCase();Be<oe.length&&(Te=s(j,oe,0,Be))===null;)Be=y(oe,Be+1);return Te}e.matchesCamelCase=r;function o(j,oe,he=!1){if(!oe||oe.length===0)return null;let Te=null,Be=0;for(j=j.toLowerCase(),oe=oe.toLowerCase();Be<oe.length&&(Te=f(j,oe,0,Be,he))===null;)Be=m(oe,Be+1);return Te}e.matchesWords=o;function f(j,oe,he,Te,Be){if(he===j.length)return[];if(Te===oe.length)return null;if(l(j.charCodeAt(he),oe.charCodeAt(Te))){let $e=null,Qe=Te+1;if($e=f(j,oe,he+1,Te+1,Be),!Be)for(;!$e&&(Qe=m(oe,Qe))<oe.length;)$e=f(j,oe,he+1,Qe,Be),Qe++;return $e===null?null:I({start:Te,end:Te+1},$e)}else return null}function m(j,oe){for(let he=oe;he<j.length;he++)if(c(j.charCodeAt(he))||he>0&&c(j.charCodeAt(he-1)))return he;return j.length}const v=b(e.matchesPrefix,r,F),C=b(e.matchesPrefix,r,D),R=new h.LRUCache(1e4);function p(j,oe,he=!1){if(typeof j!="string"||typeof oe!="string")return null;let Te=R.get(j);Te||(Te=new RegExp(M.convertSimple2RegExpPattern(j),"i"),R.set(j,Te));const Be=Te.exec(oe);return Be?[{start:Be.index,end:Be.index+Be[0].length}]:he?C(j,oe):v(j,oe)}e.matchesFuzzy=p;function S(j,oe){const he=Ye(j,j.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return he?A(he):null}e.matchesFuzzy2=S;function u(j,oe,he,Te,Be,$e){const Qe=Math.min(13,j.length);for(;he<Qe;he++){const _e=Ye(j,oe,he,Te,Be,$e,!1);if(_e)return _e}return[0,$e]}e.anyScore=u;function A(j){if(typeof j=="undefined")return[];const oe=[],he=j[1];for(let Te=j.length-1;Te>1;Te--){const Be=j[Te]+he,$e=oe[oe.length-1];$e&&$e.end===Be?$e.end=Be+1:oe.push({start:Be,end:Be+1})}return oe}e.createMatches=A;const L=128;function V(){const j=[],oe=[];for(let he=0;he<=L;he++)oe[he]=0;for(let he=0;he<=L;he++)j.push(oe.slice(0));return j}function K(j){const oe=[];for(let he=0;he<=j;he++)oe[he]=0;return oe}const W=K(2*L),Q=K(2*L),$=V(),U=V(),z=V(),G=!1;function ue(j,oe,he,Te,Be){function $e(_e,nt,H=" "){for(;_e.length<nt;)_e=H+_e;return _e}let Qe=` |   |${Te.split("").map(_e=>$e(_e,3)).join("|")}
`;for(let _e=0;_e<=he;_e++)_e===0?Qe+=" |":Qe+=`${oe[_e-1]}|`,Qe+=j[_e].slice(0,Be+1).map(nt=>$e(nt.toString(),3)).join("|")+`
`;return Qe}function q(j,oe,he,Te){j=j.substr(oe),he=he.substr(Te),console.log(ue(U,j,j.length,he,he.length)),console.log(ue(z,j,j.length,he,he.length)),console.log(ue($,j,j.length,he,he.length))}function le(j,oe){if(oe<0||oe>=j.length)return!1;const he=j.codePointAt(oe);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise(he)}}function se(j,oe){if(oe<0||oe>=j.length)return!1;switch(j.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function ve(j,oe,he){return oe[j]!==he[j]}function Fe(j,oe,he,Te,Be,$e,Qe=!1){for(;oe<he&&Be<$e;)j[oe]===Te[Be]&&(Qe&&(W[oe]=Be),oe+=1),Be+=1;return oe===he}e.isPatternInWord=Fe;var Me;(function(j){j[j.Diag=1]="Diag",j[j.Left=2]="Left",j[j.LeftLeft=3]="LeftLeft"})(Me||(Me={}));var Oe;(function(j){j.Default=[-100,0];function oe(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}j.isDefault=oe})(Oe=e.FuzzyScore||(e.FuzzyScore={}));function Ye(j,oe,he,Te,Be,$e,Qe){const _e=j.length>L?L:j.length,nt=Te.length>L?L:Te.length;if(he>=_e||$e>=nt||_e-he>nt-$e||!Fe(oe,he,_e,Be,$e,nt,!0))return;ze(_e,nt,he,$e,oe,Be);let H=1,J=1,me=he,Ne=$e;const Ke=[!1];for(H=1,me=he;me<_e;H++,me++){const ht=W[me],yt=Q[me],It=me+1<_e?Q[me+1]:nt;for(J=ht-$e+1,Ne=ht;Ne<It;J++,Ne++){let ft=Number.MIN_SAFE_INTEGER,Je=!1;Ne<=yt&&(ft=je(j,oe,me,he,Te,Be,Ne,nt,$e,$[H-1][J-1]===0,Ke));let Et=0;ft!==Number.MAX_SAFE_INTEGER&&(Je=!0,Et=ft+U[H-1][J-1]);const Pe=Ne>ht,ye=Pe?U[H][J-1]+($[H][J-1]>0?-5:0):0,Ce=Ne>ht+1&&$[H][J-1]>0,Z=Ce?U[H][J-2]+($[H][J-2]>0?-5:0):0;if(Ce&&(!Pe||Z>=ye)&&(!Je||Z>=Et))U[H][J]=Z,z[H][J]=3,$[H][J]=0;else if(Pe&&(!Je||ye>=Et))U[H][J]=ye,z[H][J]=2,$[H][J]=0;else if(Je)U[H][J]=Et,z[H][J]=1,$[H][J]=$[H-1][J-1]+1;else throw new Error("not possible")}}if(G&&q(j,he,Te,$e),!Ke[0]&&!Qe)return;H--,J--;const ot=[U[H][J],$e];let at=0,vt=0;for(;H>=1;){let ht=J;do{const yt=z[H][ht];if(yt===3)ht=ht-2;else if(yt===2)ht=ht-1;else break}while(ht>=1);at>1&&oe[he+H-1]===Be[$e+J-1]&&!ve(ht+$e-1,Te,Be)&&at+1>$[H][ht]&&(ht=J),ht===J?at++:at=1,vt||(vt=ht),H--,J=ht-1,ot.push(J)}nt===_e&&(ot[0]+=2);const kt=vt-_e;return ot[0]-=kt,ot}e.fuzzyScore=Ye;function ze(j,oe,he,Te,Be,$e){let Qe=j-1,_e=oe-1;for(;Qe>=he&&_e>=Te;)Be[Qe]===$e[_e]&&(Q[Qe]=_e,Qe--),_e--}function je(j,oe,he,Te,Be,$e,Qe,_e,nt,H,J){if(oe[he]!==$e[Qe])return Number.MIN_SAFE_INTEGER;let me=1,Ne=!1;return Qe===he-Te?me=j[he]===Be[Qe]?7:5:ve(Qe,Be,$e)&&(Qe===0||!ve(Qe-1,Be,$e))?(me=j[he]===Be[Qe]?7:5,Ne=!0):le($e,Qe)&&(Qe===0||!le($e,Qe-1))?me=5:(le($e,Qe-1)||se($e,Qe-1))&&(me=5,Ne=!0),me>1&&he===Te&&(J[0]=!0),Ne||(Ne=ve(Qe,Be,$e)||le($e,Qe-1)||se($e,Qe-1)),he===Te?Qe>nt&&(me-=Ne?3:5):H?me+=Ne?2:0:me+=Ne?0:1,Qe+1===_e&&(me-=Ne?3:5),me}function x(j,oe,he,Te,Be,$e,Qe){return ee(j,oe,he,Te,Be,$e,!0,Qe)}e.fuzzyScoreGracefulAggressive=x;function Y(j,oe,he,Te,Be,$e,Qe){return ee(j,oe,he,Te,Be,$e,!1,Qe)}e.fuzzyScoreGraceful=Y;function ee(j,oe,he,Te,Be,$e,Qe,_e){let nt=Ye(j,oe,he,Te,Be,$e,_e);if(nt&&!Qe)return nt;if(j.length>=3){const H=Math.min(7,j.length-1);for(let J=he+1;J<H;J++){const me=ae(j,J);if(me){const Ne=Ye(me,me.toLowerCase(),he,Te,Be,$e,_e);Ne&&(Ne[0]-=3,(!nt||Ne[0]>nt[0])&&(nt=Ne))}}}return nt}function ae(j,oe){if(oe+1>=j.length)return;const he=j[oe],Te=j[oe+1];if(he!==Te)return j.slice(0,oe)+Te+he+j.slice(oe+2)}}),define(we[107],be([0,1,34,106,9]),function(ne,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${h.CSSIcon.iconNameExpression}(?:${h.CSSIcon.iconModifierExpression})?\\)`,"g"),F=new RegExp(`(\\\\)?${T.source}`,"g");function D(l){return l.replace(F,(w,I)=>I?w:`\\${w}`)}e.escapeIcons=D;const _=new RegExp(`\\\\${T.source}`,"g");function P(l){return l.replace(_,w=>`\\${w}`)}e.markdownEscapeEscapedIcons=P;const t=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function E(l){return l.indexOf(e.iconStartMarker)===-1?l:l.replace(t,(w,I,y,s)=>y?w:I||s||"")}e.stripIcons=E;function n(l){const w=l.indexOf(e.iconStartMarker);return w===-1?{text:l}:d(l,w)}e.parseLabelWithIcons=n;function d(l,w){const I=[];let y="";function s(m){if(m){y+=m;for(const v of m)I.push(i)}}let g=-1,k="",i=0,a,r,o=w;const f=l.length;for(s(l.substr(0,w));o<f;)a=l[o],r=l[o+1],a===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(g=o,s(k),k=e.iconStartMarker,o++):a===")"&&g!==-1?(i+=o-g+1,g=-1,k=""):g!==-1?/^[a-z0-9\-]$/i.test(a)?k+=a:(s(k),g=-1,k=""):s(a),o++;return s(k),{text:y,iconOffsets:I}}function c(l,w,I=!1){const{text:y,iconOffsets:s}=w;if(!s||s.length===0)return(0,M.matchesFuzzy)(l,y,I);const g=(0,b.ltrim)(y," "),k=y.length-g.length,i=(0,M.matchesFuzzy)(l,g,I);if(i)for(const a of i){const r=s[a.start+k]+k;a.start+=r,a.end+=r}return i}e.matchesFuzzyIconAware=c}),define(we[76],be([0,1,16,107]),function(ne,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var b;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(b=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class T{constructor(d="",c=!1){if(this.value=d,typeof this.value!="string")throw(0,h.illegalArgument)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(d,c=0){return this.value+=P(this.supportThemeIcons?(0,M.escapeIcons)(d):d).replace(/([ \t]+)/g,(l,w)=>"&nbsp;".repeat(w.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,c){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}}e.MarkdownString=T;function F(n){return D(n)?!n.value:Array.isArray(n)?n.every(F):!0}e.isEmptyMarkdownString=F;function D(n){return n instanceof T?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function _(n,d){return n===d?!0:!n||!d?!1:n.value===d.value&&n.isTrusted===d.isTrusted&&n.supportThemeIcons===d.supportThemeIcons}e.markdownStringEqual=_;function P(n){return n.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function t(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=t;function E(n){const d=[],c=n.split("|").map(w=>w.trim());n=c[0];const l=c[1];if(l){const w=/height=(\d+)/.exec(l),I=/width=(\d+)/.exec(l),y=w?w[1]:"",s=I?I[1]:"",g=isFinite(parseInt(s)),k=isFinite(parseInt(y));g&&d.push(`width="${s}"`),k&&d.push(`height="${y}"`)}return{href:n,dimensions:d}}e.parseHrefAndDimensions=E}),define(we[54],be([0,1,23,9,2]),function(ne,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(t){return JSON.stringify(t,_)}e.stringify=T;function F(t){let E=JSON.parse(t);return E=P(E),E}e.parse=F;var D;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(D=e.MarshalledId||(e.MarshalledId={}));function _(t,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,M.regExpFlags)(E)}:E}function P(t,E=0){if(!t||E>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return b.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof h.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let n=0;n<t.length;++n)t[n]=P(t[n],E+1);else for(const n in t)Object.hasOwnProperty.call(t,n)&&(t[n]=P(t[n],E+1))}return t}e.revive=P}),define(we[11],be([0,1,26,2]),function(ne,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var b;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp"})(b=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,P,t){this._hosts[_]=P,this._ports[_]=t}setConnectionToken(_,P){this._connectionTokens[_]=P}rewrite(_){if(this._delegate)return this._delegate(_);const P=_.authority;let t=this._hosts[P];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const E=this._ports[P],n=this._connectionTokens[P];let d=`path=${encodeURIComponent(_.path)}`;return typeof n=="string"&&(d+=`&tkn=${encodeURIComponent(n)}`),M.URI.from({scheme:h.isWeb?this._preferredWebSchema:b.vscodeRemoteResource,authority:`${t}:${E}`,path:"/vscode-remote-resource",query:d})}}e.RemoteAuthorities=new T;class F{asBrowserUri(_,P){const t=this.toUri(_,P);return t.scheme===b.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===b.file&&(h.isNative||typeof h.globals.importScripts=="function"&&h.globals.origin===`${b.vscodeFileResource}://${F.FALLBACK_AUTHORITY}`)?t.with({scheme:b.vscodeFileResource,authority:t.authority||F.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(_,P){const t=this.toUri(_,P);return t.scheme===b.vscodeFileResource?t.with({scheme:b.file,authority:t.authority!==F.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(_,P){return M.URI.isUri(_)?_:M.URI.parse(P.toUrl(_))}}F.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new F}),define(we[24],be([0,1,41,11,17,26,9,2]),function(ne,e,h,M,b,T,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(d){return(0,D.uriToFsPath)(d,!0)}e.originalFSPath=_;class P{constructor(c){this._ignorePathCasing=c}compare(c,l,w=!1){return c===l?0:(0,F.compare)(this.getComparisonKey(c,w),this.getComparisonKey(l,w))}isEqual(c,l,w=!1){return c===l?!0:!c||!l?!1:this.getComparisonKey(c,w)===this.getComparisonKey(l,w)}getComparisonKey(c,l=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,l,w=!1){if(c.scheme===l.scheme){if(c.scheme===M.Schemas.file)return h.isEqualOrParent(_(c),_(l),this._ignorePathCasing(c))&&c.query===l.query&&(w||c.fragment===l.fragment);if((0,e.isEqualAuthority)(c.authority,l.authority))return h.isEqualOrParent(c.path,l.path,this._ignorePathCasing(c),"/")&&c.query===l.query&&(w||c.fragment===l.fragment)}return!1}joinPath(c,...l){return D.URI.joinPath(c,...l)}basenameOrAuthority(c){return(0,e.basename)(c)||c.authority}basename(c){return b.posix.basename(c.path)}extname(c){return b.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let l;return c.scheme===M.Schemas.file?l=D.URI.file(b.dirname(_(c))).path:(l=b.posix.dirname(c.path),c.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),l="/")),c.with({path:l})}normalizePath(c){if(!c.path.length)return c;let l;return c.scheme===M.Schemas.file?l=D.URI.file(b.normalize(_(c))).path:l=b.posix.normalize(c.path),c.with({path:l})}relativePath(c,l){if(c.scheme!==l.scheme||!(0,e.isEqualAuthority)(c.authority,l.authority))return;if(c.scheme===M.Schemas.file){const y=b.relative(_(c),_(l));return T.isWindows?h.toSlashes(y):y}let w=c.path||"/",I=l.path||"/";if(this._ignorePathCasing(c)){let y=0;for(const s=Math.min(w.length,I.length);y<s&&!(w.charCodeAt(y)!==I.charCodeAt(y)&&w.charAt(y).toLowerCase()!==I.charAt(y).toLowerCase());y++);w=I.substr(0,y)+w.substr(y)}return b.posix.relative(w,I)}resolvePath(c,l){if(c.scheme===M.Schemas.file){const w=D.URI.file(b.resolve(_(c),l));return c.with({authority:w.authority,path:w.path})}return l=h.toPosixPath(l),c.with({path:b.posix.resolve(c.path,l)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,l){return c===l||(0,F.equalsIgnoreCase)(c,l)}hasTrailingPathSeparator(c,l=b.sep){if(c.scheme===M.Schemas.file){const w=_(c);return w.length>h.getRoot(w).length&&w[w.length-1]===l}else{const w=c.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,l=b.sep){return(0,e.hasTrailingPathSeparator)(c,l)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,l=b.sep){let w=!1;if(c.scheme===M.Schemas.file){const I=_(c);w=I!==void 0&&I.length===h.getRoot(I).length&&I[I.length-1]===l}else{l="/";const I=c.path;w=I.length===1&&I.charCodeAt(I.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(c,l)?c.with({path:c.path+"/"}):c}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(d=>d.scheme===M.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new P(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(d,c){const l=[];for(let w=0;w<d.length;w++){const I=c(d[w]);d.some((y,s)=>s===w?!1:(0,e.isEqualOrParent)(I,c(y)))||l.push(d[w])}return l}e.distinctParents=t;var E;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function c(l){const w=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(s=>{const[g,k]=s.split(":");g&&k&&w.set(g,k)});const y=l.path.substring(0,l.path.indexOf(";"));return y&&w.set(d.META_DATA_MIME,y),w}d.parseMetaData=c})(E=e.DataUri||(e.DataUri={}));function n(d,c,l){if(c){let w=d.path;return w&&w[0]!==b.posix.sep&&(w=b.posix.sep+w),d.with({scheme:l,authority:c,path:w})}return d.with({scheme:l})}e.toLocalResource=n}),define(we[14],be([0,1,21,16,3,6,24]),function(ne,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D($){return!!$&&typeof $.then=="function"}e.isThenable=D;function _($){const U=new h.CancellationTokenSource,z=$(U.token),G=new Promise((ue,q)=>{const le=U.token.onCancellationRequested(()=>{le.dispose(),U.dispose(),q((0,M.canceled)())});Promise.resolve(z).then(se=>{le.dispose(),U.dispose(),ue(se)},se=>{le.dispose(),U.dispose(),q(se)})});return new class{cancel(){U.cancel()}then(ue,q){return G.then(ue,q)}catch(ue){return this.then(void 0,ue)}finally(ue){return G.finally(ue)}}}e.createCancelablePromise=_;function P($,U,z){return Promise.race([$,new Promise(G=>U.onCancellationRequested(()=>G(z)))])}e.raceCancellation=P;async function t($){let U=-1;const z=$.map((ue,q)=>ue.then(le=>(U=q,le))),G=await Promise.race(z);return $.forEach((ue,q)=>{q!==U&&ue.cancel()}),G}e.raceCancellablePromises=t;function E($,U,z){let G;const ue=setTimeout(()=>{G?.(void 0),z?.()},U);return Promise.race([$.finally(()=>clearTimeout(ue)),new Promise(q=>G=q)])}e.raceTimeout=E;function n($){return new Promise((U,z)=>{const G=$();D(G)?G.then(U,z):U(G)})}e.asPromise=n;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const z=()=>{this.queuedPromise=null;const G=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,G};this.queuedPromise=new Promise(G=>{this.activePromise.then(z,z).then(G)})}return new Promise((z,G)=>{this.queuedPromise.then(z,G)})}return this.activePromise=U(),new Promise((z,G)=>{this.activePromise.then(ue=>{this.activePromise=null,z(ue)},ue=>{this.activePromise=null,G(ue)})})}}e.Throttler=d;class c{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=c;class l{constructor(){this.promiseMap=new Map}queue(U,z){const ue=(this.promiseMap.get(U)??Promise.resolve()).catch(()=>{}).then(z).finally(()=>{this.promiseMap.get(U)===ue&&this.promiseMap.delete(U)});return this.promiseMap.set(U,ue),ue}}e.SequencerByKey=l;class w{constructor(U){this.defaultDelay=U,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,z=this.defaultDelay){return this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((G,ue)=>{this.doResolve=G,this.doReject=ue}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const G=this.task;return this.task=null,G()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},z),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=w;class I{constructor(U){this.delayer=new w(U),this.throttler=new d}trigger(U,z){return this.delayer.trigger(()=>this.throttler.queue(U),z)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=I;class y{constructor(){this._isOpen=!1,this._promise=new Promise((U,z)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=y;class s extends y{constructor(U){super();this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function g($,U){return U?new Promise((z,G)=>{const ue=setTimeout(()=>{q.dispose(),z()},$),q=U.onCancellationRequested(()=>{clearTimeout(ue),q.dispose(),G((0,M.canceled)())})}):_(z=>g($,z))}e.timeout=g;function k($,U=0){const z=setTimeout($,U);return(0,T.toDisposable)(()=>clearTimeout(z))}e.disposableTimeout=k;function i($){const U=[];let z=0;const G=$.length;function ue(){return z<G?$[z++]():null}function q(le){le!=null&&U.push(le);const se=ue();return se?se.then(q):Promise.resolve(U)}return Promise.resolve(null).then(q)}e.sequence=i;function a($,U=G=>!!G,z=null){let G=0;const ue=$.length,q=()=>{if(G>=ue)return Promise.resolve(z);const le=$[G++];return Promise.resolve(le()).then(ve=>U(ve)?Promise.resolve(ve):q())};return q()}e.first=a;function r($,U=G=>!!G,z=null){if($.length===0)return Promise.resolve(z);let G=$.length;const ue=()=>{G=-1;for(const q of $)q.cancel?.()};return new Promise((q,le)=>{for(const se of $)se.then(ve=>{--G>=0&&U(ve)?(ue(),q(ve)):G===0&&q(z)}).catch(ve=>{--G>=0&&(ue(),le(ve))})})}e.firstParallel=r;class o{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new b.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(U){return this._size++,new Promise((z,G)=>{this.outstandingPromises.push({factory:U,c:z,e:G}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const z=U.factory();z.then(U.c,U.e),z.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class f extends o{constructor(){super(1)}}e.Queue=f;class m{constructor(){this.queues=new Map}queueFor(U,z=F.extUri){const G=z.getComparisonKey(U);let ue=this.queues.get(G);return ue||(ue=new f,b.Event.once(ue.onFinished)(()=>{ue?.dispose(),this.queues.delete(G)}),this.queues.set(G,ue)),ue}dispose(){this.queues.forEach(U=>U.dispose()),this.queues.clear()}}e.ResourceQueue=m;class v{constructor(U,z){this._token=-1,typeof U=="function"&&typeof z=="number"&&this.setIfNotSet(U,z)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,z){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},z)}setIfNotSet(U,z){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},z))}}e.TimeoutTimer=v;class C{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,z){this.cancel(),this._token=setInterval(()=>{U()},z)}}e.IntervalTimer=C;class R{constructor(U,z){this.timeoutToken=-1,this.runner=U,this.timeout=z,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class p{constructor(U,z){z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.runner=U,this.timeout=z,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(U=this.timeout){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(U/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=p;class S extends R{constructor(U,z){super(U,z);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner&&this.runner(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=S;class u extends T.Disposable{constructor(U,z,G,ue){super();this.maxWorkChunkSize=U,this.maxPendingWork=z,this.throttleDelay=G,this.handler=ue,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(U){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+U.length>this.maxPendingWork)return!1}else if(this.pending+U.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...U),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=u,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const $=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=U=>{const z=setTimeout(()=>U($));let G=!1;return{dispose(){G||(G=!0,clearTimeout(z))}}}}else e.runWhenIdle=($,U)=>{const z=requestIdleCallback($,typeof U=="number"?{timeout:U}:void 0);let G=!1;return{dispose(){G||(G=!0,cancelIdleCallback(z))}}}}();class A{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(z){this._error=z}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=A;async function L($,U,z){let G;for(let ue=0;ue<z;ue++)try{return await $()}catch(q){G=q,await g(U)}throw G}e.retry=L;class V{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(U,z,G){return this._pending={taskId:U,cancel:()=>G?.(),promise:z},z.then(()=>this.donePending(U),()=>this.donePending(U)),z}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let z,G;const ue=new Promise((q,le)=>{z=q,G=le});this._next={run:U,promise:ue,promiseResolve:z,promiseReject:G}}return this._next.promise}}e.TaskSequentializer=V;class K{constructor(U){this.interval=U,this.lastIncrementTime=0,this.value=0}increment(){const U=Date.now();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=K;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,z)=>{this.completeCallback=U,this.errorCallback=z})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(z=>{this.completeCallback(U),this.resolved=!0,z()})}error(U){return new Promise(z=>{this.errorCallback(U),this.rejected=!0,z()})}cancel(){new Promise(U=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,U()})}}e.DeferredPromise=W;var Q;(function($){async function U(z){let G;const ue=await Promise.all(z.map(q=>q.then(le=>le,le=>{G||(G=le)})));if(typeof G!="undefined")throw G;return ue}$.settled=U})(Q=e.Promises||(e.Promises={}))}),define(we[108],be([0,1,14,17]),function(ne,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const b=new h.IdleValue(()=>{const R=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:R,collatorIsNumeric:R.resolvedOptions().numeric}}),T=new h.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),F=new h.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(R,p,S=!1){const u=R||"",A=p||"",L=b.value.collator.compare(u,A);return b.value.collatorIsNumeric&&L===0&&u!==A?u<A?-1:1:L}e.compareFileNames=D;function _(R,p){const S=T.value.collator;return R=R||"",p=p||"",k(S,R,p)}e.compareFileNamesDefault=_;function P(R,p){const S=T.value.collator;return R=R||"",p=p||"",o(R,p)||k(S,R,p)}e.compareFileNamesUpper=P;function t(R,p){const S=T.value.collator;return R=R||"",p=p||"",r(R,p)||k(S,R,p)}e.compareFileNamesLower=t;function E(R,p){return R=R||"",p=p||"",R===p?0:R<p?-1:1}e.compareFileNamesUnicode=E;function n(R,p,S=!1){S||(R=R&&R.toLowerCase(),p=p&&p.toLowerCase());const[u,A]=s(R),[L,V]=s(p);return u!==L?u<L?-1:1:A===V?0:A<V?-1:1}e.noIntlCompareFileNames=n;function d(R,p){const[S,u]=s(R),[A,L]=s(p);let V=b.value.collator.compare(u,L);if(V===0){if(b.value.collatorIsNumeric&&u!==L)return u<L?-1:1;if(V=b.value.collator.compare(S,A),b.value.collatorIsNumeric&&V===0&&S!==A)return S<A?-1:1}return V}e.compareFileExtensions=d;function c(R,p){R=R||"",p=p||"";const S=g(R),u=g(p),A=T.value.collator,L=F.value.collator;return k(L,S,u)||k(A,R,p)}e.compareFileExtensionsDefault=c;function l(R,p){R=R||"",p=p||"";const S=g(R),u=g(p),A=T.value.collator,L=F.value.collator;return k(L,S,u)||o(R,p)||k(A,R,p)}e.compareFileExtensionsUpper=l;function w(R,p){R=R||"",p=p||"";const S=g(R),u=g(p),A=T.value.collator,L=F.value.collator;return k(L,S,u)||r(R,p)||k(A,R,p)}e.compareFileExtensionsLower=w;function I(R,p){R=R||"",p=p||"";const S=g(R).toLowerCase(),u=g(p).toLowerCase();return S!==u?S<u?-1:1:R!==p?R<p?-1:1:0}e.compareFileExtensionsUnicode=I;const y=/^(.*?)(\.([^.]*))?$/;function s(R,p=!1){const S=R?y.exec(R):[];let u=[S&&S[1]||"",S&&S[3]||""];return p&&(!u[0]&&u[1]||u[0]&&u[0].charAt(0)===".")&&(u=[u[0]+"."+u[1],""]),u}function g(R){const p=R?y.exec(R):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function k(R,p,S){let u=R.compare(p,S);return u!==0?u:p.length!==S.length?p.length<S.length?-1:1:0}function i(R){const p=R.charAt(0);return p.toLocaleUpperCase()!==p}function a(R){const p=R.charAt(0);return p.toLocaleLowerCase()!==p}function r(R,p){return i(R)&&a(p)?-1:a(R)&&i(p)?1:0}function o(R,p){return a(R)&&i(p)?-1:i(R)&&a(p)?1:0}function f(R,p,S=!1){return S||(R=R&&R.toLowerCase(),p=p&&p.toLowerCase()),R===p?0:R<p?-1:1}function m(R,p,S=!1){const u=R.split(M.sep),A=p.split(M.sep),L=u.length-1,V=A.length-1;let K,W;for(let Q=0;;Q++){if(K=L===Q,W=V===Q,K&&W)return D(u[Q],A[Q],S);if(K)return-1;if(W)return 1;const $=f(u[Q],A[Q],S);if($!==0)return $}}e.comparePaths=m;function v(R,p,S){const u=R.toLowerCase(),A=p.toLowerCase(),L=C(R,p,S);if(L)return L;const V=u.endsWith(S),K=A.endsWith(S);if(V!==K)return V?-1:1;const W=D(u,A);return W!==0?W:u.localeCompare(A)}e.compareAnything=v;function C(R,p,S){const u=R.toLowerCase(),A=p.toLowerCase(),L=u.startsWith(S),V=A.startsWith(S);if(L!==V)return L?-1:1;if(L&&V){if(u.length<A.length)return-1;if(u.length>A.length)return 1}return 0}e.compareByPrefix=C}),define(we[27],be([0,1,14,41,20,17,9]),function(ne,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const _="**",P="/",t="[/\\\\]",E="[^/\\\\]",n=/\//g;function d(G){switch(G){case 0:return"";case 1:return`${E}*?`;default:return`(?:${t}|${E}+${t}|${t}${E}+)*?`}}function c(G,ue){if(!G)return[];const q=[];let le=!1,se=!1,ve="";for(const Fe of G){switch(Fe){case ue:if(!le&&!se){q.push(ve),ve="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":se=!0;break;case"]":se=!1;break}ve+=Fe}return ve&&q.push(ve),q}e.splitGlobAware=c;function l(G){if(!G)return"";let ue="";const q=c(G,P);if(q.every(le=>le===_))ue=".*";else{let le=!1;q.forEach((se,ve)=>{if(se===_){le||(ue+=d(2),le=!0);return}let Fe=!1,Me="",Oe=!1,Ye="";for(const ze of se){if(ze!=="}"&&Fe){Me+=ze;continue}if(Oe&&(ze!=="]"||!Ye)){let je;ze==="-"?je=ze:(ze==="^"||ze==="!")&&!Ye?je="^":ze===P?je="":je=F.escapeRegExpCharacters(ze),Ye+=je;continue}switch(ze){case"{":Fe=!0;continue;case"[":Oe=!0;continue;case"}":ue+=`(?:${c(Me,",").map(Y=>l(Y)).join("|")})`,Fe=!1,Me="";break;case"]":ue+="["+Ye+"]",Oe=!1,Ye="";break;case"?":ue+=E;continue;case"*":ue+=d(1);continue;default:ue+=F.escapeRegExpCharacters(ze)}}ve<q.length-1&&(q[ve+1]!==_||ve+2<q.length)&&(ue+=t),le=!1})}return ue}const w=/^\*\*\/\*\.[\w\.-]+$/,I=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,s=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,k=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new b.LRUCache(1e4),a=function(){return!1},r=function(){return null};function o(G,ue){if(!G)return r;let q;typeof G!="string"?q=G.pattern:q=G,q=q.trim();const le=`${q}_${!!ue.trimForExclusions}`;let se=i.get(le);if(se)return f(se,G);let ve;if(w.test(q)){const Fe=q.substr(4);se=function(Me,Oe){return typeof Me=="string"&&Me.endsWith(Fe)?q:null}}else(ve=I.exec(m(q,ue)))?se=v(ve[1],q):(ue.trimForExclusions?s:y).test(q)?se=C(q,ue):(ve=g.exec(m(q,ue)))?se=R(ve[1].substr(1),q,!0):(ve=k.exec(m(q,ue)))?se=R(ve[1],q,!1):se=p(q);return i.set(le,se),f(se,G)}function f(G,ue){return typeof ue=="string"?G:function(q,le){return M.isEqualOrParent(q,ue.base)?G(T.relative(ue.base,q),le):null}}function m(G,ue){return ue.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function v(G,ue){const q=`/${G}`,le=`\\${G}`,se=function(Fe,Me){return typeof Fe!="string"?null:Me?Me===G?ue:null:Fe===G||Fe.endsWith(q)||Fe.endsWith(le)?ue:null},ve=[G];return se.basenames=ve,se.patterns=[ue],se.allBasenames=ve,se}function C(G,ue){const q=z(G.slice(1,-1).split(",").map(Me=>o(Me,ue)).filter(Me=>Me!==r),G),le=q.length;if(!le)return r;if(le===1)return q[0];const se=function(Me,Oe){for(let Ye=0,ze=q.length;Ye<ze;Ye++)if(q[Ye](Me,Oe))return G;return null},ve=q.find(Me=>!!Me.allBasenames);ve&&(se.allBasenames=ve.allBasenames);const Fe=q.reduce((Me,Oe)=>Oe.allPaths?Me.concat(Oe.allPaths):Me,[]);return Fe.length&&(se.allPaths=Fe),se}function R(G,ue,q){const le=T.sep===T.posix.sep,se=le?G:G.replace(n,T.sep),ve=T.sep+se,Fe=T.posix.sep+G,Me=q?function(Oe,Ye){return typeof Oe=="string"&&(Oe===se||Oe.endsWith(ve)||!le&&(Oe===G||Oe.endsWith(Fe)))?ue:null}:function(Oe,Ye){return typeof Oe=="string"&&(Oe===se||!le&&Oe===G)?ue:null};return Me.allPaths=[(q?"*/":"./")+G],Me}function p(G){try{const ue=new RegExp(`^${l(G)}$`);return function(q){return ue.lastIndex=0,typeof q=="string"&&ue.test(q)?G:null}}catch(ue){return r}}function S(G,ue,q){return!G||typeof ue!="string"?!1:u(G)(ue,void 0,q)}e.match=S;function u(G,ue={}){if(!G)return a;if(typeof G=="string"||K(G)){const q=o(G,ue);if(q===r)return a;const le=function(se,ve){return!!q(se,ve)};return q.allBasenames&&(le.allBasenames=q.allBasenames),q.allPaths&&(le.allPaths=q.allPaths),le}return $(G,ue)}e.parse=u;function A(G){if(!G)return;let ue;return q=>(ue||(ue=(G()||Promise.resolve([])).then(le=>le?V(le):{})),ue.then(le=>!!le[q]))}e.hasSiblingPromiseFn=A;function L(G){if(!G)return;let ue;return q=>{if(!ue){const le=G();ue=le?V(le):{}}return!!ue[q]}}e.hasSiblingFn=L;function V(G){const ue={};for(const q of G)ue[q]=!0;return ue}function K(G){const ue=G;return ue&&typeof ue.base=="string"&&typeof ue.pattern=="string"}e.isRelativePattern=K;function W(G){return G.allBasenames||[]}e.getBasenameTerms=W;function Q(G){return G.allPaths||[]}e.getPathTerms=Q;function $(G,ue){const q=z(Object.getOwnPropertyNames(G).map(Me=>U(Me,G[Me],ue)).filter(Me=>Me!==r)),le=q.length;if(!le)return r;if(!q.some(Me=>!!Me.requiresSiblings)){if(le===1)return q[0];const Me=function(ze,je){for(let x=0,Y=q.length;x<Y;x++){const ee=q[x](ze,je);if(ee)return ee}return null},Oe=q.find(ze=>!!ze.allBasenames);Oe&&(Me.allBasenames=Oe.allBasenames);const Ye=q.reduce((ze,je)=>je.allPaths?ze.concat(je.allPaths):ze,[]);return Ye.length&&(Me.allPaths=Ye),Me}const se=function(Me,Oe,Ye){let ze;for(let je=0,x=q.length;je<x;je++){const Y=q[je];Y.requiresSiblings&&Ye&&(Oe||(Oe=T.basename(Me)),ze||(ze=Oe.substr(0,Oe.length-T.extname(Me).length)));const ee=Y(Me,Oe,ze,Ye);if(ee)return ee}return null},ve=q.find(Me=>!!Me.allBasenames);ve&&(se.allBasenames=ve.allBasenames);const Fe=q.reduce((Me,Oe)=>Oe.allPaths?Me.concat(Oe.allPaths):Me,[]);return Fe.length&&(se.allPaths=Fe),se}function U(G,ue,q){if(ue===!1)return r;const le=o(G,q);if(le===r)return r;if(typeof ue=="boolean")return le;if(ue){const se=ue.when;if(typeof se=="string"){const ve=(Fe,Me,Oe,Ye)=>{if(!Ye||!le(Fe,Me))return null;const ze=se.replace("$(basename)",Oe),je=Ye(ze);return(0,h.isThenable)(je)?je.then(x=>x?G:null):je?G:null};return ve.requiresSiblings=!0,ve}}return le}function z(G,ue){const q=G.filter(Me=>!!Me.basenames);if(q.length<2)return G;const le=q.reduce((Me,Oe)=>{const Ye=Oe.basenames;return Ye?Me.concat(Ye):Me},[]);let se;if(ue){se=[];for(let Me=0,Oe=le.length;Me<Oe;Me++)se.push(ue)}else se=q.reduce((Me,Oe)=>{const Ye=Oe.patterns;return Ye?Me.concat(Ye):Me},[]);const ve=function(Me,Oe){if(typeof Me!="string")return null;if(!Oe){let ze;for(ze=Me.length;ze>0;ze--){const je=Me.charCodeAt(ze-1);if(je===47||je===92)break}Oe=Me.substr(ze)}const Ye=le.indexOf(Oe);return Ye!==-1?se[Ye]:null};ve.basenames=le,ve.patterns=se,ve.allBasenames=le;const Fe=G.filter(Me=>!Me.basenames);return Fe.push(ve),Fe}}),define(we[77],be([0,1,41,11,17,26,24,9,2]),function(ne,e,h,M,b,T,F,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(o,f,m){if(typeof o=="string"&&(o=_.URI.file(o)),m){const C=m.getWorkspaceFolder(o);if(C){const R=m.getWorkspace().folders.length>1;let p;if((0,F.isEqual)(C.uri,o)?p="":p=(0,F.relativePath)(C.uri,o),R){const S=C.name?C.name:(0,F.basename)(C.uri);p=p?S+" \u2022 "+p:S}return p}}if(o.scheme!==M.Schemas.file&&o.scheme!==M.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,h.hasDriveLetter)(o.fsPath))return(0,b.normalize)(E(o.fsPath));let v=(0,b.normalize)(o.fsPath);return!T.isWindows&&f?.userHome&&(v=d(v,f.userHome.fsPath)),v}e.getPathLabel=P;function t(o){if(!o)return;typeof o=="string"&&(o=_.URI.file(o));const f=(0,F.basename)(o)||(o.scheme===M.Schemas.file?o.fsPath:o.path);return T.isWindows&&(0,h.isRootOrDriveLetter)(f)?E(f):f}e.getBaseLabel=t;function E(o){return(0,h.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=E;let n=Object.create(null);function d(o,f){if(T.isWindows||!o||!f)return o;let m=n.original===f?n.normalized:void 0;return m||(m=`${(0,D.rtrim)(f,b.posix.sep)}${b.posix.sep}`,n={original:f,normalized:m}),(T.isLinux?o.startsWith(m):(0,D.startsWithIgnoreCase)(o,m))&&(o=`~/${o.substr(m.length)}`),o}e.tildify=d;function c(o,f){return o.replace(/^~($|\/|\\)/,`${f}$1`)}e.untildify=c;const l="\u2026",w="\\\\",I="~";function y(o,f=b.sep){const m=new Array(o.length);let v=!1;for(let C=0;C<o.length;C++){let R=o[C];if(R===""){m[C]=`.${f}`;continue}if(!R){m[C]=R;continue}v=!0;let p="";R.indexOf(w)===0?(p=R.substr(0,R.indexOf(w)+w.length),R=R.substr(R.indexOf(w)+w.length)):R.indexOf(f)===0?(p=R.substr(0,R.indexOf(f)+f.length),R=R.substr(R.indexOf(f)+f.length)):R.indexOf(I)===0&&(p=R.substr(0,R.indexOf(I)+I.length),R=R.substr(R.indexOf(I)+I.length));const S=R.split(f);for(let u=1;v&&u<=S.length;u++)for(let A=S.length-u;v&&A>=0;A--){v=!1;let L=S.slice(A,A+u).join(f);for(let V=0;!v&&V<o.length;V++)if(V!==C&&o[V]&&o[V].indexOf(L)>-1){const K=A+u===S.length,W=A>0&&o[V].indexOf(f)>-1?f+L:L,Q=o[V].endsWith(W);v=!K||Q}if(!v){let V="";(S[0].endsWith(":")||p!=="")&&(A===1&&(A=0,u++,L=S[0]+f+L),A>0&&(V=S[0]+f),V=p+V),A>0&&(V=V+l+f),V=V+L,A+u<S.length&&(V=V+f+l),m[C]=V}}v&&(m[C]=R)}return m}e.shorten=y;var s;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(s||(s={}));function g(o,f=Object.create(null)){const m=[];let v=!1,C="";for(const R of o)if(R==="$"||v&&R==="{")C&&m.push({value:C,type:s.TEXT}),C="",v=!0;else if(R==="}"&&v){const p=f[C];if(typeof p=="string")p.length&&m.push({value:p,type:s.VARIABLE});else if(p){const S=m[m.length-1];(!S||S.type!==s.SEPARATOR)&&m.push({value:p.label,type:s.SEPARATOR})}C="",v=!1}else C+=R;return C&&!v&&m.push({value:C,type:s.TEXT}),m.filter((R,p)=>{if(R.type===s.SEPARATOR){const S=m[p-1],u=m[p+1];return[S,u].every(A=>A&&(A.type===s.VARIABLE||A.type===s.TEXT)&&A.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=g;function k(o,f){return T.isMacintosh||f?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):o.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=k;function i(o,f){return T.isMacintosh||f?o.replace(/\(&&\w\)|&&/g,""):T.isWindows?o.replace(/&&|&/g,m=>m==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function a(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=a;function r(o){const f=o.indexOf("/")!==-1?b.posix:b.win32,m=f.basename(o),v=f.dirname(o);return m.length?{name:m,parentPath:v}:{name:v,parentPath:""}}e.splitName=r}),define(we[78],be([0,1,27,11,17,24,9]),function(ne,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var D;(function(o){o.text="text/plain",o.binary="application/octet-stream",o.unknown="application/unknown",o.markdown="text/markdown"})(D=e.Mimes||(e.Mimes={}));let _=[],P=[],t=[];function E(o,f=!1){const m=n(o);_.push(m),m.userConfigured?t.push(m):P.push(m),f&&!m.userConfigured&&_.forEach(v=>{v.mime===m.mime||v.userConfigured||(m.extension&&v.extension===m.extension&&console.warn(`Overwriting extension <<${m.extension}>> to now point to mime <<${m.mime}>>`),m.filename&&v.filename===m.filename&&console.warn(`Overwriting filename <<${m.filename}>> to now point to mime <<${m.mime}>>`),m.filepattern&&v.filepattern===m.filepattern&&console.warn(`Overwriting filepattern <<${m.filepattern}>> to now point to mime <<${m.mime}>>`),m.firstline&&v.firstline===m.firstline&&console.warn(`Overwriting firstline <<${m.firstline}>> to now point to mime <<${m.mime}>>`))})}e.registerTextMime=E;function n(o){return{id:o.id,mime:o.mime,filename:o.filename,extension:o.extension,filepattern:o.filepattern,firstline:o.firstline,userConfigured:o.userConfigured,filenameLowercase:o.filename?o.filename.toLowerCase():void 0,extensionLowercase:o.extension?o.extension.toLowerCase():void 0,filepatternLowercase:o.filepattern?(0,h.parse)(o.filepattern.toLowerCase()):void 0,filepatternOnPath:o.filepattern?o.filepattern.indexOf(b.posix.sep)>=0:!1}}function d(o){o?(_=_.filter(f=>!f.userConfigured),t=[]):(_=[],P=[],t=[])}e.clearTextMimes=d;function c(o,f){let m;if(o)switch(o.scheme){case M.Schemas.file:m=o.fsPath;break;case M.Schemas.data:m=T.DataUri.parseMetaData(o).get(T.DataUri.META_DATA_LABEL);break;default:m=o.path}if(!m)return[D.unknown];m=m.toLowerCase();const v=(0,b.basename)(m),C=l(m,v,t);if(C)return[C,D.text];const R=l(m,v,P);if(R)return[R,D.text];if(f){const p=w(f);if(p)return[p,D.text]}return[D.unknown]}e.guessMimeTypes=c;function l(o,f,m){let v=null,C=null,R=null;for(let p=m.length-1;p>=0;p--){const S=m[p];if(f===S.filenameLowercase){v=S;break}if(S.filepattern&&(!C||S.filepattern.length>C.filepattern.length)){const u=S.filepatternOnPath?o:f;S.filepatternLowercase?.(u)&&(C=S)}S.extension&&(!R||S.extension.length>R.extension.length)&&f.endsWith(S.extensionLowercase)&&(R=S)}return v?v.mime:C?C.mime:R?R.mime:null}function w(o){if((0,F.startsWithUTF8BOM)(o)&&(o=o.substr(1)),o.length>0)for(let f=_.length-1;f>=0;f--){const m=_[f];if(!m.firstline)continue;const v=o.match(m.firstline);if(v&&v.length>0)return m.mime}return null}function I(o){return o?typeof o=="string"?o===D.binary||o===D.text||o===D.unknown:o.length===1&&I(o[0]):!0}e.isUnspecific=I;const y={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},s={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function g(o){const f=(0,b.extname)(o),m=y[f.toLowerCase()];return m!==void 0?m:k(o)}e.getMediaOrTextMime=g;function k(o){const f=(0,b.extname)(o);return s[f.toLowerCase()]}e.getMediaMime=k;function i(o){for(const f in s)if(s[f]===o)return f}e.getExtensionForMimeType=i;const a=/^(.+)\/(.+?)(;.+)?$/;function r(o,f){const m=a.exec(o);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:f?void 0:o}e.normalizeMimeType=r}),define(we[109],be([0,1,2]),function(ne,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function M(t){return t.toJSON()}class b{constructor(E){this._uriTransformer=E}transformIncoming(E){const n=this._uriTransformer.transformIncoming(E);return n===E?E:M(h.URI.from(n))}transformOutgoing(E){const n=this._uriTransformer.transformOutgoing(E);return n===E?E:M(h.URI.from(n))}transformOutgoingURI(E){const n=this._uriTransformer.transformOutgoing(E);return n===E?E:h.URI.from(n)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=b,e.DefaultURITransformer=new class{transformIncoming(t){return t}transformOutgoing(t){return t}transformOutgoingURI(t){return t}transformOutgoingScheme(t){return t}};function T(t,E,n){if(!t||n>200)return null;if(typeof t=="object"){if(t instanceof h.URI)return E.transformOutgoing(t);for(let d in t)if(Object.hasOwnProperty.call(t,d)){const c=T(t[d],E,n+1);c!==null&&(t[d]=c)}}return null}function F(t,E){const n=T(t,E,0);return n===null?t:n}e.transformOutgoingURIs=F;function D(t,E,n,d){if(!t||d>200)return null;if(typeof t=="object"){if(t.$mid===1)return n?h.URI.revive(E.transformIncoming(t)):E.transformIncoming(t);for(let c in t)if(Object.hasOwnProperty.call(t,c)){const l=D(t[c],E,n,d+1);l!==null&&(t[c]=l)}}return null}function _(t,E){const n=D(t,E,!1,0);return n===null?t:n}e.transformIncomingURIs=_;function P(t,E){const n=D(t,E,!0,0);return n===null?t:n}e.transformAndReviveIncomingURIs=P}),define(we[36],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const h=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(_){return h.test(_)}e.isUUID=M;const b=new Uint8Array(16),T=[];for(let _=0;_<256;_++)T.push(_.toString(16).padStart(2,"0"));let F;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?F=crypto.getRandomValues.bind(crypto):F=function(_){for(let P=0;P<_.length;P++)_[P]=Math.floor(Math.random()*256);return _};function D(){F(b),b[6]=b[6]&15|64,b[8]=b[8]&63|128;let _=0,P="";return P+=T[b[_++]],P+=T[b[_++]],P+=T[b[_++]],P+=T[b[_++]],P+="-",P+=T[b[_++]],P+=T[b[_++]],P+="-",P+=T[b[_++]],P+=T[b[_++]],P+="-",P+=T[b[_++]],P+=T[b[_++]],P+="-",P+=T[b[_++]],P+=T[b[_++]],P+=T[b[_++]],P+=T[b[_++]],P+=T[b[_++]],P+=T[b[_++]],P}e.generateUuid=D}),define(we[110],be([0,1,226]),function(ne,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var M;(function(F){F[F.Regular=0]="Regular",F[F.Whitespace=1]="Whitespace",F[F.WordSeparator=2]="WordSeparator"})(M=e.WordCharacterClass||(e.WordCharacterClass={}));class b extends h.CharacterClassifier{constructor(D){super(0);for(let _=0,P=D.length;_<P;_++)this.set(D.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=b;function T(F){let D={};return _=>(D.hasOwnProperty(_)||(D[_]=F(_)),D[_])}e.getMapForWordSeparators=T(F=>new b(F))}),define(we[79],be([0,1,22]),function(ne,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var M;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=4]="Right",l[l.Full=7]="Full"})(M=e.OverviewRulerLane||(e.OverviewRulerLane={}));var b;(function(l){l[l.Inline=1]="Inline",l[l.Gutter=2]="Gutter"})(b=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(l){l[l.TextDefined=0]="TextDefined",l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var F;(function(l){l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(F=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var D;(function(l){l[l.LF=0]="LF",l[l.CRLF=1]="CRLF"})(D=e.EndOfLineSequence||(e.EndOfLineSequence={}));class _{constructor(w){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,w.tabSize|0),this.indentSize=w.tabSize|0,this.insertSpaces=Boolean(w.insertSpaces),this.defaultEOL=w.defaultEOL|0,this.trimAutoWhitespace=Boolean(w.trimAutoWhitespace),this.bracketPairColorizationOptions=w.bracketPairColorizationOptions}equals(w){return this.tabSize===w.tabSize&&this.indentSize===w.indentSize&&this.insertSpaces===w.insertSpaces&&this.defaultEOL===w.defaultEOL&&this.trimAutoWhitespace===w.trimAutoWhitespace&&(0,h.equals)(this.bracketPairColorizationOptions,w.bracketPairColorizationOptions)}createChangeEvent(w){return{tabSize:this.tabSize!==w.tabSize,indentSize:this.indentSize!==w.indentSize,insertSpaces:this.insertSpaces!==w.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==w.trimAutoWhitespace}}}e.TextModelResolvedOptions=_;class P{constructor(w,I){this._findMatchBrand=void 0,this.range=w,this.matches=I}}e.FindMatch=P;var t;(function(l){l[l.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",l[l.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",l[l.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",l[l.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(t=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var E;(function(l){l[l.Left=0]="Left",l[l.Right=1]="Right",l[l.None=2]="None"})(E=e.PositionAffinity||(e.PositionAffinity={}));var n;(function(l){l[l.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(n=e.ModelConstants||(e.ModelConstants={}));class d{constructor(w,I,y,s,g,k){this.identifier=w,this.range=I,this.text=y,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=g,this._isTracked=k}}e.ValidAnnotatedEditOperation=d;class c{constructor(w,I,y){this.reverseEdits=w,this.changes=I,this.trimAutoWhitespaceLineNumbers=y}}e.ApplyEditsResult=c}),define(we[111],be([0,1,9,110,112,42,79]),function(ne,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class _{constructor(s,g,k,i){this.searchString=s,this.isRegex=g,this.matchCase=k,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let s;this.isRegex?s=P(this.searchString):s=this.searchString.indexOf(`
`)>=0;let g=null;try{g=h.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:s,global:!0,unicode:!0})}catch(i){return null}if(!g)return null;let k=!this.isRegex&&!s;return k&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(k=this.matchCase),new t(g,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,k?this.searchString:null)}}e.SearchParams=_;function P(y){if(!y||y.length===0)return!1;for(let s=0,g=y.length;s<g;s++)if(y.charCodeAt(s)===92){if(s++,s>=g)break;const i=y.charCodeAt(s);if(i===110||i===114||i===87||i===119)return!0}return!1}e.isMultilineRegexSource=P;class t{constructor(s,g,k){this.regex=s,this.wordSeparators=g,this.simpleSearch=k}}e.SearchData=t;function E(y,s,g){if(!g)return new F.FindMatch(y,null);let k=[];for(let i=0,a=s.length;i<a;i++)k[i]=s[i];return new F.FindMatch(y,k)}e.createFindMatch=E;class n{constructor(s){let g=[],k=0;for(let i=0,a=s.length;i<a;i++)s.charCodeAt(i)===10&&(g[k++]=i);this._lineFeedsOffsets=g}findLineFeedCountBeforeOffset(s){const g=this._lineFeedsOffsets;let k=0,i=g.length-1;if(i===-1||s<=g[0])return 0;for(;k<i;){const a=k+((i-k)/2>>0);g[a]>=s?i=a-1:g[a+1]>=s?(k=a,i=a):k=a+1}return k+1}}class d{static findMatches(s,g,k,i,a){const r=g.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(s,k,new I(r.wordSeparators,r.regex),i,a):this._doFindMatchesLineByLine(s,k,r,i,a):[]}static _getMultilineMatchRange(s,g,k,i,a,r){let o,f=0;i?(f=i.findLineFeedCountBeforeOffset(a),o=g+a+f):o=g+a;let m;if(i){let p=i.findLineFeedCountBeforeOffset(a+r.length)-f;m=o+r.length+p}else m=o+r.length;const v=s.getPositionAt(o),C=s.getPositionAt(m);return new T.Range(v.lineNumber,v.column,C.lineNumber,C.column)}static _doFindMatchesMultiline(s,g,k,i,a){const r=s.getOffsetAt(g.getStartPosition()),o=s.getValueInRange(g,1),f=s.getEOL()===`\r
`?new n(o):null,m=[];let v=0,C;for(k.reset(0);C=k.next(o);)if(m[v++]=E(this._getMultilineMatchRange(s,r,o,f,C.index,C[0]),C,i),v>=a)return m;return m}static _doFindMatchesLineByLine(s,g,k,i,a){const r=[];let o=0;if(g.startLineNumber===g.endLineNumber){const m=s.getLineContent(g.startLineNumber).substring(g.startColumn-1,g.endColumn-1);return o=this._findMatchesInLine(k,m,g.startLineNumber,g.startColumn-1,o,r,i,a),r}const f=s.getLineContent(g.startLineNumber).substring(g.startColumn-1);o=this._findMatchesInLine(k,f,g.startLineNumber,g.startColumn-1,o,r,i,a);for(let m=g.startLineNumber+1;m<g.endLineNumber&&o<a;m++)o=this._findMatchesInLine(k,s.getLineContent(m),m,0,o,r,i,a);if(o<a){const m=s.getLineContent(g.endLineNumber).substring(0,g.endColumn-1);o=this._findMatchesInLine(k,m,g.endLineNumber,0,o,r,i,a)}return r}static _findMatchesInLine(s,g,k,i,a,r,o,f){const m=s.wordSeparators;if(!o&&s.simpleSearch){const R=s.simpleSearch,p=R.length,S=g.length;let u=-p;for(;(u=g.indexOf(R,u+p))!==-1;)if((!m||w(m,g,S,u,p))&&(r[a++]=new F.FindMatch(new T.Range(k,u+1+i,k,u+1+p+i),null),a>=f))return a;return a}const v=new I(s.wordSeparators,s.regex);let C;v.reset(0);do if(C=v.next(g),C&&(r[a++]=E(new T.Range(k,C.index+1+i,k,C.index+1+C[0].length+i),C,o),a>=f))return a;while(C);return a}static findNextMatch(s,g,k,i){const a=g.parseSearchRequest();if(!a)return null;const r=new I(a.wordSeparators,a.regex);return a.regex.multiline?this._doFindNextMatchMultiline(s,k,r,i):this._doFindNextMatchLineByLine(s,k,r,i)}static _doFindNextMatchMultiline(s,g,k,i){const a=new b.Position(g.lineNumber,1),r=s.getOffsetAt(a),o=s.getLineCount(),f=s.getValueInRange(new T.Range(a.lineNumber,a.column,o,s.getLineMaxColumn(o)),1),m=s.getEOL()===`\r
`?new n(f):null;k.reset(g.column-1);let v=k.next(f);return v?E(this._getMultilineMatchRange(s,r,f,m,v.index,v[0]),v,i):g.lineNumber!==1||g.column!==1?this._doFindNextMatchMultiline(s,new b.Position(1,1),k,i):null}static _doFindNextMatchLineByLine(s,g,k,i){const a=s.getLineCount(),r=g.lineNumber,o=s.getLineContent(r),f=this._findFirstMatchInLine(k,o,r,g.column,i);if(f)return f;for(let m=1;m<=a;m++){const v=(r+m-1)%a,C=s.getLineContent(v+1),R=this._findFirstMatchInLine(k,C,v+1,1,i);if(R)return R}return null}static _findFirstMatchInLine(s,g,k,i,a){s.reset(i-1);const r=s.next(g);return r?E(new T.Range(k,r.index+1,k,r.index+1+r[0].length),r,a):null}static findPreviousMatch(s,g,k,i){const a=g.parseSearchRequest();if(!a)return null;const r=new I(a.wordSeparators,a.regex);return a.regex.multiline?this._doFindPreviousMatchMultiline(s,k,r,i):this._doFindPreviousMatchLineByLine(s,k,r,i)}static _doFindPreviousMatchMultiline(s,g,k,i){const a=this._doFindMatchesMultiline(s,new T.Range(1,1,g.lineNumber,g.column),k,i,10*D);if(a.length>0)return a[a.length-1];const r=s.getLineCount();return g.lineNumber!==r||g.column!==s.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(s,new b.Position(r,s.getLineMaxColumn(r)),k,i):null}static _doFindPreviousMatchLineByLine(s,g,k,i){const a=s.getLineCount(),r=g.lineNumber,o=s.getLineContent(r).substring(0,g.column-1),f=this._findLastMatchInLine(k,o,r,i);if(f)return f;for(let m=1;m<=a;m++){const v=(a+r-m-1)%a,C=s.getLineContent(v+1),R=this._findLastMatchInLine(k,C,v+1,i);if(R)return R}return null}static _findLastMatchInLine(s,g,k,i){let a=null,r;for(s.reset(0);r=s.next(g);)a=E(new T.Range(k,r.index+1,k,r.index+1+r[0].length),r,i);return a}}e.TextModelSearch=d;function c(y,s,g,k,i){if(k===0)return!0;const a=s.charCodeAt(k-1);if(y.get(a)!==0||a===13||a===10)return!0;if(i>0){const r=s.charCodeAt(k);if(y.get(r)!==0)return!0}return!1}function l(y,s,g,k,i){if(k+i===g)return!0;const a=s.charCodeAt(k+i);if(y.get(a)!==0||a===13||a===10)return!0;if(i>0){const r=s.charCodeAt(k+i-1);if(y.get(r)!==0)return!0}return!1}function w(y,s,g,k,i){return c(y,s,g,k,i)&&l(y,s,g,k,i)}e.isValidMatch=w;class I{constructor(s,g){this._wordSeparators=s,this._searchRegex=g,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(s){this._searchRegex.lastIndex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(s){const g=s.length;let k;do{if(this._prevMatchStartIndex+this._prevMatchLength===g||(k=this._searchRegex.exec(s),!k))return null;const i=k.index,a=k[0].length;if(i===this._prevMatchStartIndex&&a===this._prevMatchLength){if(a===0){h.getNextCodePoint(s,g,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=i,this._prevMatchLength=a,!this._wordSeparators||w(this._wordSeparators,s,g,i,a))return k}while(k);return null}}e.Searcher=I}),define(we[113],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var h;(function(F){F[F.None=0]="None",F[F.Indent=1]="Indent",F[F.IndentOutdent=2]="IndentOutdent",F[F.Outdent=3]="Outdent"})(h=e.IndentAction||(e.IndentAction={}));class M{constructor(D){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=D.open,this.close=D.close,this._standardTokenMask=0,Array.isArray(D.notIn))for(let _=0,P=D.notIn.length;_<P;_++)switch(D.notIn[_]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(D){return(this._standardTokenMask&D)==0}}e.StandardAutoClosingPairConditional=M;class b{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of D)T(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),T(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),T(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),T(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&T(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=b;function T(F,D,_){F.has(D)?F.get(D).push(_):F.set(D,[_])}}),define(we[55],be([0,1,27,17]),function(ne,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function b(T,F,D,_){if(Array.isArray(T)){let P=0;for(const t of T){const E=b(t,F,D,_);if(E===10)return E;E>P&&(P=E)}return P}else{if(typeof T=="string")return _?T==="*"?5:T===D?10:0:0;if(T){const{language:P,pattern:t,scheme:E,hasAccessToAllModels:n}=T;if(!_&&!n)return 0;let d=0;if(E)if(E===F.scheme)d=10;else if(E==="*")d=5;else return 0;if(P)if(P===D)d=10;else if(P==="*")d=Math.max(d,5);else return 0;if(t){let c;if(typeof t=="string"?c=t:c={...t,base:(0,M.normalize)(t.base)},c===F.fsPath||(0,h.match)(c,F.fsPath))d=10;else return 0}return d}else return 0}}e.score=b}),define(we[114],be([0,1,3,6]),function(ne,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class b{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new h.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(F){this._onDidChange.fire({changedLanguages:F,changedColorMap:!1})}register(F,D){return this._map.set(F,D),this.fire([F]),(0,M.toDisposable)(()=>{this._map.get(F)===D&&(this._map.delete(F),this.fire([F]))})}registerPromise(F,D){let _=null,P=!1;return this._promises.set(F,D.then(t=>{this._promises.delete(F),!(P||!t)&&(_=this.register(F,t))})),(0,M.toDisposable)(()=>{P=!0,_&&_.dispose()})}getPromise(F){const D=this.get(F);if(D)return Promise.resolve(D);const _=this._promises.get(F);return _?_.then(P=>this.get(F)):null}get(F){return this._map.get(F)||null}setColorMap(F){this._colorMap=F,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=b}),define(we[80],be([0,1,23,26]),function(ne,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var b;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(b||(b={}));function T(E){for(let n=0,d=E.length;n<d;n+=4){const c=E[n+0],l=E[n+1],w=E[n+2],I=E[n+3];E[n+0]=I,E[n+1]=w,E[n+2]=l,E[n+3]=c}}function F(E){const n=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return M.isLittleEndian()||T(n),h.VSBuffer.wrap(n)}function D(E){const n=E.buffer;if(M.isLittleEndian()||T(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const d=new Uint8Array(n.byteLength);return d.set(n),new Uint32Array(d.buffer,d.byteOffset,d.length/4)}}function _(E){const n=new Uint32Array(P(E));let d=0;if(n[d++]=E.id,E.type==="full")n[d++]=1,n[d++]=E.data.length,n.set(E.data,d),d+=E.data.length;else{n[d++]=2,n[d++]=E.deltas.length;for(const c of E.deltas)n[d++]=c.start,n[d++]=c.deleteCount,c.data?(n[d++]=c.data.length,n.set(c.data,d),d+=c.data.length):n[d++]=0}return F(n)}e.encodeSemanticTokensDto=_;function P(E){let n=0;if(n+=1+1,E.type==="full")n+=1+E.data.length;else{n+=1,n+=(1+1+1)*E.deltas.length;for(const d of E.deltas)d.data&&(n+=d.data.length)}return n}function t(E){const n=D(E);let d=0;const c=n[d++];if(n[d++]===1){const y=n[d++],s=n.subarray(d,d+y);return d+=y,{id:c,type:"full",data:s}}const w=n[d++];let I=[];for(let y=0;y<w;y++){const s=n[d++],g=n[d++],k=n[d++];let i;k>0&&(i=n.subarray(d,d+k),d+=k),I[y]={start:s,deleteCount:g,data:i}}return{id:c,type:"delta",deltas:I}}e.decodeSemanticTokensDto=t}),define(we[115],be([18,19]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(we[56],be([0,1,13,10,115]),function(ne,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(P,t){return t&&(P.stack||P.stacktrace)?b.localize(0,null,D(P),F(P.stack)||F(P.stacktrace)):D(P)}function F(P){return Array.isArray(P)?P.join(`
`):P}function D(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?b.localize(1,null,P.message):P.message||b.localize(2,null)}function _(P=null,t=!1){if(!P)return b.localize(3,null);if(Array.isArray(P)){const E=h.coalesce(P),n=_(E[0],t);return E.length>1?b.localize(4,null,n,E.length):n}if(M.isString(P))return P;if(P.detail){const E=P.detail;if(E.error)return T(E.error,t);if(E.exception)return T(E.exception,t)}return P.stack?T(P,t):P.message?P.message:b.localize(5,null)}e.toErrorMessage=_}),define(we[116],be([18,19]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(we[117],be([0,1,116,26,118]),function(ne,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(H){H[H.None=0]="None",H[H.Keep=1]="Keep",H[H.Brackets=2]="Brackets",H[H.Advanced=3]="Advanced",H[H.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class F{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=F;class D{constructor(){this._values=[]}_read(J){return this._values[J]}get(J){return this._values[J]}_write(J,me){this._values[J]=me}}e.ValidatedEditorOptions=D;class _{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=_;class P{constructor(J,me,Ne,Ke){this.id=J,this.name=me,this.defaultValue=Ne,this.schema=Ke}compute(J,me,Ne){return Ne}}class t{constructor(J,me=null){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0,this.deps=me}validate(J){return this.defaultValue}}class E{constructor(J,me,Ne,Ke){this.id=J,this.name=me,this.defaultValue=Ne,this.schema=Ke}validate(J){return typeof J=="undefined"?this.defaultValue:J}compute(J,me,Ne){return Ne}}function n(H,J){return typeof H=="undefined"?J:H==="false"?!1:Boolean(H)}e.boolean=n;class d extends E{constructor(J,me,Ne,Ke=void 0){typeof Ke!="undefined"&&(Ke.type="boolean",Ke.default=Ne),super(J,me,Ne,Ke)}validate(J){return n(J,this.defaultValue)}}function c(H,J,me,Ne){if(typeof H=="undefined")return J;let Ke=parseInt(H,10);return isNaN(Ke)?J:(Ke=Math.max(me,Ke),Ke=Math.min(Ne,Ke),Ke|0)}e.clampedInt=c;class l extends E{constructor(J,me,Ne,Ke,ot,at=void 0){typeof at!="undefined"&&(at.type="integer",at.default=Ne,at.minimum=Ke,at.maximum=ot),super(J,me,Ne,at),this.minimum=Ke,this.maximum=ot}static clampedInt(J,me,Ne,Ke){return c(J,me,Ne,Ke)}validate(J){return l.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}class w extends E{constructor(J,me,Ne,Ke,ot){typeof ot!="undefined"&&(ot.type="number",ot.default=Ne),super(J,me,Ne,ot),this.validationFn=Ke}static clamp(J,me,Ne){return J<me?me:J>Ne?Ne:J}static float(J,me){if(typeof J=="number")return J;if(typeof J=="undefined")return me;const Ne=parseFloat(J);return isNaN(Ne)?me:Ne}validate(J){return this.validationFn(w.float(J,this.defaultValue))}}class I extends E{static string(J,me){return typeof J!="string"?me:J}constructor(J,me,Ne,Ke=void 0){typeof Ke!="undefined"&&(Ke.type="string",Ke.default=Ne),super(J,me,Ne,Ke)}validate(J){return I.string(J,this.defaultValue)}}function y(H,J,me){return typeof H!="string"||me.indexOf(H)===-1?J:H}e.stringSet=y;class s extends E{constructor(J,me,Ne,Ke,ot=void 0){typeof ot!="undefined"&&(ot.type="string",ot.enum=Ke,ot.default=Ne),super(J,me,Ne,ot),this._allowedValues=Ke}validate(J){return y(J,this.defaultValue,this._allowedValues)}}class g extends P{constructor(J,me,Ne,Ke,ot,at,vt=void 0){typeof vt!="undefined"&&(vt.type="string",vt.enum=ot,vt.default=Ke),super(J,me,Ne,vt),this._allowedValues=ot,this._convert=at}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function k(H){switch(H){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[h.localize(0,null),h.localize(1,null),h.localize(2,null)],default:"auto",description:h.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,me,Ne){return Ne===0?J.accessibilitySupport:Ne}}class a extends P{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(18,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:h.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:h.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{insertSpace:n(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(H){H[H.Hidden=0]="Hidden",H[H.Blink=1]="Blink",H[H.Smooth=2]="Smooth",H[H.Phase=3]="Phase",H[H.Expand=4]="Expand",H[H.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function o(H){switch(H){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(H){H[H.Line=1]="Line",H[H.Block=2]="Block",H[H.Underline=3]="Underline",H[H.LineThin=4]="LineThin",H[H.BlockOutline=5]="BlockOutline",H[H.UnderlineThin=6]="UnderlineThin"})(f=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function m(H){switch(H){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=m;function v(H){switch(H){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class C extends t{constructor(){super(127,[65,32])}compute(J,me,Ne){const Ke=["monaco-editor"];return me.get(32)&&Ke.push(me.get(32)),J.extraEditorClassName&&Ke.push(J.extraEditorClassName),me.get(65)==="default"?Ke.push("mouse-default"):me.get(65)==="copy"&&Ke.push("mouse-copy"),me.get(100)&&Ke.push("showUnused"),me.get(125)&&Ke.push("showDeprecated"),Ke.join(" ")}}class R extends d{constructor(){super(31,"emptySelectionClipboard",!0,{description:h.localize(6,null)})}compute(J,me,Ne){return Ne&&J.emptySelectionClipboard}}class p extends P{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(34,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:h.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[h.localize(8,null),h.localize(9,null),h.localize(10,null)],description:h.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[h.localize(12,null),h.localize(13,null),h.localize(14,null)],description:h.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:h.localize(16,null),included:M.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:h.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:h.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{cursorMoveOnType:n(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":y(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":y(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(me.loop,this.defaultValue.loop)}}}class S extends P{constructor(){super(43,"fontLigatures",S.OFF,{anyOf:[{type:"boolean",description:h.localize(19,null)},{type:"string",description:h.localize(20,null)}],description:h.localize(21,null),default:!1})}validate(J){return typeof J=="undefined"?this.defaultValue:typeof J=="string"?J==="false"?S.OFF:J==="true"?S.ON:J:Boolean(J)?S.ON:S.OFF}}e.EditorFontLigatures=S,S.OFF='"liga" off, "calt" off',S.ON='"liga" on, "calt" on';class u extends t{constructor(){super(42)}compute(J,me,Ne){return J.fontInfo}}class A extends E{constructor(){super(44,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:h.localize(22,null)})}validate(J){let me=w.float(J,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:w.clamp(me,6,100)}compute(J,me,Ne){return J.fontInfo.fontSize}}class L extends P{constructor(){super(45,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:L.MINIMUM_VALUE,maximum:L.MAXIMUM_VALUE,errorMessage:h.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:L.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:h.localize(24,null)})}validate(J){return J==="normal"||J==="bold"?J:String(l.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,L.MINIMUM_VALUE,L.MAXIMUM_VALUE))}}L.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],L.MINIMUM_VALUE=1,L.MAXIMUM_VALUE=1e3;class V extends P{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[h.localize(25,null),h.localize(26,null),h.localize(27,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(49,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:h.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:h.localize(29,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:h.localize(30,null),...me},"editor.gotoLocation.multipleDeclarations":{description:h.localize(31,null),...me},"editor.gotoLocation.multipleImplementations":{description:h.localize(32,null),...me},"editor.gotoLocation.multipleReferences":{description:h.localize(33,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:Ne,description:h.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:Ne,description:h.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:Ne,description:h.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:Ne,description:h.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:Ne,description:h.localize(38,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{multiple:y(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??y(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??y(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??y(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??y(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??y(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:I.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:I.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:I.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:I.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:I.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class K extends P{constructor(){const J={enabled:!0,delay:300,sticky:!0};super(52,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:h.localize(39,null)},"editor.hover.delay":{type:"number",default:J.delay,description:h.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:h.localize(41,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),delay:l.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:n(me.sticky,this.defaultValue.sticky)}}}var W;(function(H){H[H.None=0]="None",H[H.Text=1]="Text",H[H.Blocks=2]="Blocks"})(W=e.RenderMinimap||(e.RenderMinimap={}));class Q extends t{constructor(){super(130,[48,57,36,64,92,59,60,94,117,120,121,122,2])}compute(J,me,Ne){return Q.computeLayout(me,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio})}static computeContainedMinimapLineCount(J){const me=J.height/J.lineHeight,Ne=J.scrollBeyondLastLine?me-1:0,Ke=(J.viewLineCount+Ne)/(J.pixelRatio*J.height),ot=Math.floor(J.viewLineCount/Ke);return{typicalViewportLineCount:me,extraLinesBeyondLastLine:Ne,desiredRatio:Ke,minimapLineCount:ot}}static _computeMinimapLayout(J,me){const Ne=J.outerWidth,Ke=J.outerHeight,ot=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*Ke),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ke};const at=me.stableMinimapLayoutInput,vt=at&&J.outerHeight===at.outerHeight&&J.lineHeight===at.lineHeight&&J.typicalHalfwidthCharacterWidth===at.typicalHalfwidthCharacterWidth&&J.pixelRatio===at.pixelRatio&&J.scrollBeyondLastLine===at.scrollBeyondLastLine&&J.minimap.enabled===at.minimap.enabled&&J.minimap.side===at.minimap.side&&J.minimap.size===at.minimap.size&&J.minimap.showSlider===at.minimap.showSlider&&J.minimap.renderCharacters===at.minimap.renderCharacters&&J.minimap.maxColumn===at.minimap.maxColumn&&J.minimap.scale===at.minimap.scale&&J.verticalScrollbarWidth===at.verticalScrollbarWidth&&J.isViewportWrapping===at.isViewportWrapping,kt=J.lineHeight,ht=J.typicalHalfwidthCharacterWidth,yt=J.scrollBeyondLastLine,It=J.minimap.renderCharacters;let ft=ot>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const Je=J.minimap.maxColumn,Et=J.minimap.size,Pe=J.minimap.side,ye=J.verticalScrollbarWidth,Ce=J.viewLineCount,Z=J.remainingWidth,ce=J.isViewportWrapping,ge=It?2:3;let fe=Math.floor(ot*Ke);const Ie=fe/ot;let xe=!1,Le=!1,Ve=ge*ft,Ze=ft/ot,ie=1;if(Et==="fill"||Et==="fit"){const{typicalViewportLineCount:We,extraLinesBeyondLastLine:tt,desiredRatio:mt,minimapLineCount:wt}=Q.computeContainedMinimapLineCount({viewLineCount:Ce,scrollBeyondLastLine:yt,height:Ke,lineHeight:kt,pixelRatio:ot});if(Ce/wt>1)xe=!0,Le=!0,ft=1,Ve=1,Ze=ft/ot;else{let ct=!1,lt=ft+1;if(Et==="fit"){const Tt=Math.ceil((Ce+tt)*Ve);ce&&vt&&Z<=me.stableFitRemainingWidth?(ct=!0,lt=me.stableFitMaxMinimapScale):ct=Tt>fe}if(Et==="fill"||ct){xe=!0;const Tt=ft;Ve=Math.min(kt*ot,Math.max(1,Math.floor(1/mt))),ce&&vt&&Z<=me.stableFitRemainingWidth&&(lt=me.stableFitMaxMinimapScale),ft=Math.min(lt,Math.max(1,Math.floor(Ve/ge))),ft>Tt&&(ie=Math.min(2,ft/Tt)),Ze=ft/ot/ie,fe=Math.ceil(Math.max(We,Ce+tt)*Ve),ce?(me.stableMinimapLayoutInput=J,me.stableFitRemainingWidth=Z,me.stableFitMaxMinimapScale=ft):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const pe=Math.floor(Je*Ze),re=Math.min(pe,Math.max(0,Math.floor((Z-ye-2)*Ze/(ht+Ze)))+e.MINIMAP_GUTTER_WIDTH);let B=Math.floor(ot*re);const De=B/ot;B=Math.floor(B*ie);const Se=It?1:2,qe=Pe==="left"?0:Ne-re-ye;return{renderMinimap:Se,minimapLeft:qe,minimapWidth:re,minimapHeightIsEditorHeight:xe,minimapIsSampling:Le,minimapScale:ft,minimapLineHeight:Ve,minimapCanvasInnerWidth:B,minimapCanvasInnerHeight:fe,minimapCanvasOuterWidth:De,minimapCanvasOuterHeight:Ie}}static computeLayout(J,me){const Ne=me.outerWidth|0,Ke=me.outerHeight|0,ot=me.lineHeight|0,at=me.lineNumbersDigitCount|0,vt=me.typicalHalfwidthCharacterWidth,kt=me.maxDigitWidth,ht=me.pixelRatio,yt=me.viewLineCount,It=J.get(122),ft=It==="inherit"?J.get(121):It,Je=ft==="inherit"?J.get(117):ft,Et=J.get(120),Pe=J.get(2),ye=me.isDominatedByLongLines,Ce=J.get(48),Z=J.get(59).renderType!==0,ce=J.get(60),ge=J.get(94),fe=J.get(64),Ie=J.get(92),xe=Ie.verticalScrollbarSize,Le=Ie.verticalHasArrows,Ve=Ie.arrowSize,Ze=Ie.horizontalScrollbarSize,ie=J.get(57),pe=J.get(36);let re;if(typeof ie=="string"&&/^\d+(\.\d+)?ch$/.test(ie)){const $t=parseFloat(ie.substr(0,ie.length-2));re=l.clampedInt($t*vt,0,0,1e3)}else re=l.clampedInt(ie,0,0,1e3);pe&&(re+=16);let B=0;if(Z){const $t=Math.max(at,ce);B=Math.round($t*kt)}let De=0;Ce&&(De=ot);let Se=0,qe=Se+De,We=qe+B,tt=We+re;const mt=Ne-De-B-re;let wt=!1,rt=!1,ct=-1;Pe!==2&&(ft==="inherit"&&ye?(wt=!0,rt=!0):Je==="on"||Je==="bounded"?rt=!0:Je==="wordWrapColumn"&&(ct=Et));const lt=Q._computeMinimapLayout({outerWidth:Ne,outerHeight:Ke,lineHeight:ot,typicalHalfwidthCharacterWidth:vt,pixelRatio:ht,scrollBeyondLastLine:ge,minimap:fe,verticalScrollbarWidth:xe,viewLineCount:yt,remainingWidth:mt,isViewportWrapping:rt},me.memory||new _);lt.renderMinimap!==0&&lt.minimapLeft===0&&(Se+=lt.minimapWidth,qe+=lt.minimapWidth,We+=lt.minimapWidth,tt+=lt.minimapWidth);const Tt=mt-lt.minimapWidth,_t=Math.max(1,Math.floor((Tt-xe-2)/vt)),Ut=Le?Ve:0;return rt&&(ct=Math.max(1,_t),Je==="bounded"&&(ct=Math.min(ct,Et))),{width:Ne,height:Ke,glyphMarginLeft:Se,glyphMarginWidth:De,lineNumbersLeft:qe,lineNumbersWidth:B,decorationsLeft:We,decorationsWidth:re,contentLeft:tt,contentWidth:Tt,minimap:lt,viewportColumn:_t,isWordWrapMinified:wt,isViewportWrapping:rt,wrappingColumn:ct,verticalScrollbarWidth:xe,horizontalScrollbarHeight:Ze,overviewRuler:{top:Ut,width:xe,height:Ke-2*Ut,right:0}}}}e.EditorLayoutInfoComputer=Q;class $ extends P{constructor(){const J={enabled:!0};super(56,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:h.localize(42,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class U extends P{constructor(){const J={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",J,{"editor.inlayHints.enabled":{type:"boolean",default:J.enabled,description:h.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:h.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:h.localize(45,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),fontSize:l.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:I.string(me.fontFamily,this.defaultValue.fontFamily)}}}class z extends w{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>w.clamp(J,0,150),{markdownDescription:h.localize(46,null)})}compute(J,me,Ne){return J.fontInfo.lineHeight}}class G extends P{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:h.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[h.localize(48,null),h.localize(49,null),h.localize(50,null)],default:J.size,description:h.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:h.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:h.localize(53,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:h.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:h.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:h.localize(56,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),size:y(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:y(me.side,this.defaultValue.side,["right","left"]),showSlider:y(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(me.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(me.scale,1,1,3),maxColumn:l.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ue(H){return H==="ctrlCmd"?M.isMacintosh?"metaKey":"ctrlKey":"altKey"}class q extends P{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(58,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{top:l.clampedInt(me.top,0,0,1e3),bottom:l.clampedInt(me.bottom,0,0,1e3)}}}class le extends P{constructor(){const J={enabled:!0,cycle:!1};super(75,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:h.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:h.localize(60,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),cycle:n(me.cycle,this.defaultValue.cycle)}}}class se extends t{constructor(){super(128)}compute(J,me,Ne){return J.pixelRatio}}class ve extends P{constructor(){const J={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",J,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:J.strings,description:h.localize(61,null)},comments:{type:"boolean",default:J.comments,description:h.localize(62,null)},other:{type:"boolean",default:J.other,description:h.localize(63,null)}}}],default:J,description:h.localize(64,null)});this.defaultValue=J}validate(J){if(typeof J=="boolean")return J;if(J&&typeof J=="object"){const me=J,Ne={other:n(me.other,this.defaultValue.other),comments:n(me.comments,this.defaultValue.comments),strings:n(me.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var Fe;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval",H[H.Custom=4]="Custom"})(Fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Me extends P{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[h.localize(65,null),h.localize(66,null),h.localize(67,null),h.localize(68,null)],default:"on",description:h.localize(69,null)})}validate(J){let me=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof J!="undefined"&&(typeof J=="function"?(me=4,Ne=J):J==="interval"?me=3:J==="relative"?me=2:J==="on"?me=1:me=0),{renderType:me,renderFn:Ne}}}function Oe(H){const J=H.get(87);return J==="editable"?H.get(80):J!=="on"}e.filterValidationDecorations=Oe;class Ye extends P{constructor(){const J=[],me={type:"number",description:h.localize(70,null)};super(91,"rulers",J,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:h.localize(71,null),format:"color-hex"}}}]},default:J,description:h.localize(72,null)})}validate(J){if(Array.isArray(J)){let me=[];for(let Ne of J)if(typeof Ne=="number")me.push({column:l.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const Ke=Ne;me.push({column:l.clampedInt(Ke.column,0,0,1e4),color:Ke.color})}return me.sort((Ne,Ke)=>Ne.column-Ke.column),me}return this.defaultValue}}function ze(H,J){if(typeof H!="string")return J;switch(H){case"hidden":return 2;case"visible":return 3;default:return 1}}class je extends P{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(73,null),h.localize(74,null),h.localize(75,null)],default:"auto",description:h.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(77,null),h.localize(78,null),h.localize(79,null)],default:"auto",description:h.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:h.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:h.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:h.localize(83,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J,Ne=l.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ke=l.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ze(me.vertical,this.defaultValue.vertical),horizontal:ze(me.horizontal,this.defaultValue.horizontal),useShadows:n(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:l.clampedInt(me.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:Ke,verticalSliderSize:l.clampedInt(me.verticalSliderSize,Ke,0,1e3),scrollByPage:n(me.scrollByPage,this.defaultValue.scrollByPage)}}}class x extends P{constructor(){const J={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:h.localize(84,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),mode:y(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class Y extends P{constructor(){const J={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,description:h.localize(85,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class ee extends P{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[h.localize(86,null),h.localize(87,null)],default:J.insertMode,description:h.localize(88,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:h.localize(89,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:h.localize(90,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:h.localize(91,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:h.localize(92,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:h.localize(93,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:h.localize(94,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:h.localize(95,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:h.localize(96,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:h.localize(97,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:h.localize(98,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:h.localize(99,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:h.localize(100,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:h.localize(101,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:h.localize(102,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:h.localize(103,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:h.localize(104,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:h.localize(105,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:h.localize(106,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:h.localize(107,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:h.localize(108,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:h.localize(109,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:h.localize(110,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:h.localize(111,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:h.localize(112,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:h.localize(113,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:h.localize(114,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:h.localize(115,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:h.localize(116,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:h.localize(117,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:h.localize(118,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:h.localize(119,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:h.localize(120,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:h.localize(121,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:h.localize(122,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:h.localize(123,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:h.localize(124,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:h.localize(125,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:h.localize(126,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:h.localize(127,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{insertMode:y(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:n(me.showIcons,this.defaultValue.showIcons),showStatusBar:n(me.showStatusBar,this.defaultValue.showStatusBar),preview:n(me.preview,this.defaultValue.preview),previewMode:y(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(me.showMethods,this.defaultValue.showMethods),showFunctions:n(me.showFunctions,this.defaultValue.showFunctions),showConstructors:n(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(me.showDeprecated,this.defaultValue.showDeprecated),showFields:n(me.showFields,this.defaultValue.showFields),showVariables:n(me.showVariables,this.defaultValue.showVariables),showClasses:n(me.showClasses,this.defaultValue.showClasses),showStructs:n(me.showStructs,this.defaultValue.showStructs),showInterfaces:n(me.showInterfaces,this.defaultValue.showInterfaces),showModules:n(me.showModules,this.defaultValue.showModules),showProperties:n(me.showProperties,this.defaultValue.showProperties),showEvents:n(me.showEvents,this.defaultValue.showEvents),showOperators:n(me.showOperators,this.defaultValue.showOperators),showUnits:n(me.showUnits,this.defaultValue.showUnits),showValues:n(me.showValues,this.defaultValue.showValues),showConstants:n(me.showConstants,this.defaultValue.showConstants),showEnums:n(me.showEnums,this.defaultValue.showEnums),showEnumMembers:n(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(me.showKeywords,this.defaultValue.showKeywords),showWords:n(me.showWords,this.defaultValue.showWords),showColors:n(me.showColors,this.defaultValue.showColors),showFiles:n(me.showFiles,this.defaultValue.showFiles),showReferences:n(me.showReferences,this.defaultValue.showReferences),showFolders:n(me.showFolders,this.defaultValue.showFolders),showTypeParameters:n(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(me.showSnippets,this.defaultValue.showSnippets),showUsers:n(me.showUsers,this.defaultValue.showUsers),showIssues:n(me.showIssues,this.defaultValue.showIssues)}}}class ae extends P{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:h.localize(128,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class j extends t{constructor(){super(129,[80])}compute(J,me,Ne){return me.get(80)?!0:J.tabFocusMode}}var oe;(function(H){H[H.None=0]="None",H[H.Same=1]="Same",H[H.Indent=2]="Indent",H[H.DeepIndent=3]="DeepIndent"})(oe=e.WrappingIndent||(e.WrappingIndent={}));function he(H){switch(H){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Te extends t{constructor(){super(131,[130])}compute(J,me,Ne){const Ke=me.get(130);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:Ke.isWordWrapMinified,isViewportWrapping:Ke.isViewportWrapping,wrappingColumn:Ke.wrappingColumn}}}const Be="Consolas, 'Courier New', monospace",$e="Menlo, Monaco, 'Courier New', monospace",Qe="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:M.isMacintosh?$e:M.isLinux?Qe:Be,fontWeight:"normal",fontSize:M.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function _e(H){return e.editorOptionsRegistry[H.id]=H,H}var nt;(function(H){H[H.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",H[H.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",H[H.accessibilitySupport=2]="accessibilitySupport",H[H.accessibilityPageSize=3]="accessibilityPageSize",H[H.ariaLabel=4]="ariaLabel",H[H.autoClosingBrackets=5]="autoClosingBrackets",H[H.autoClosingDelete=6]="autoClosingDelete",H[H.autoClosingOvertype=7]="autoClosingOvertype",H[H.autoClosingQuotes=8]="autoClosingQuotes",H[H.autoIndent=9]="autoIndent",H[H.automaticLayout=10]="automaticLayout",H[H.autoSurround=11]="autoSurround",H[H.bracketPairColorization=12]="bracketPairColorization",H[H.codeLens=13]="codeLens",H[H.codeLensFontFamily=14]="codeLensFontFamily",H[H.codeLensFontSize=15]="codeLensFontSize",H[H.colorDecorators=16]="colorDecorators",H[H.columnSelection=17]="columnSelection",H[H.comments=18]="comments",H[H.contextmenu=19]="contextmenu",H[H.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",H[H.cursorBlinking=21]="cursorBlinking",H[H.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",H[H.cursorStyle=23]="cursorStyle",H[H.cursorSurroundingLines=24]="cursorSurroundingLines",H[H.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",H[H.cursorWidth=26]="cursorWidth",H[H.disableLayerHinting=27]="disableLayerHinting",H[H.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",H[H.domReadOnly=29]="domReadOnly",H[H.dragAndDrop=30]="dragAndDrop",H[H.emptySelectionClipboard=31]="emptySelectionClipboard",H[H.extraEditorClassName=32]="extraEditorClassName",H[H.fastScrollSensitivity=33]="fastScrollSensitivity",H[H.find=34]="find",H[H.fixedOverflowWidgets=35]="fixedOverflowWidgets",H[H.folding=36]="folding",H[H.foldingStrategy=37]="foldingStrategy",H[H.foldingHighlight=38]="foldingHighlight",H[H.foldingImportsByDefault=39]="foldingImportsByDefault",H[H.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",H[H.fontFamily=41]="fontFamily",H[H.fontInfo=42]="fontInfo",H[H.fontLigatures=43]="fontLigatures",H[H.fontSize=44]="fontSize",H[H.fontWeight=45]="fontWeight",H[H.formatOnPaste=46]="formatOnPaste",H[H.formatOnType=47]="formatOnType",H[H.glyphMargin=48]="glyphMargin",H[H.gotoLocation=49]="gotoLocation",H[H.hideCursorInOverviewRuler=50]="hideCursorInOverviewRuler",H[H.highlightActiveIndentGuide=51]="highlightActiveIndentGuide",H[H.hover=52]="hover",H[H.inDiffEditor=53]="inDiffEditor",H[H.inlineSuggest=54]="inlineSuggest",H[H.letterSpacing=55]="letterSpacing",H[H.lightbulb=56]="lightbulb",H[H.lineDecorationsWidth=57]="lineDecorationsWidth",H[H.lineHeight=58]="lineHeight",H[H.lineNumbers=59]="lineNumbers",H[H.lineNumbersMinChars=60]="lineNumbersMinChars",H[H.linkedEditing=61]="linkedEditing",H[H.links=62]="links",H[H.matchBrackets=63]="matchBrackets",H[H.minimap=64]="minimap",H[H.mouseStyle=65]="mouseStyle",H[H.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",H[H.mouseWheelZoom=67]="mouseWheelZoom",H[H.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",H[H.multiCursorModifier=69]="multiCursorModifier",H[H.multiCursorPaste=70]="multiCursorPaste",H[H.occurrencesHighlight=71]="occurrencesHighlight",H[H.overviewRulerBorder=72]="overviewRulerBorder",H[H.overviewRulerLanes=73]="overviewRulerLanes",H[H.padding=74]="padding",H[H.parameterHints=75]="parameterHints",H[H.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",H[H.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",H[H.quickSuggestions=78]="quickSuggestions",H[H.quickSuggestionsDelay=79]="quickSuggestionsDelay",H[H.readOnly=80]="readOnly",H[H.renameOnType=81]="renameOnType",H[H.renderControlCharacters=82]="renderControlCharacters",H[H.renderIndentGuides=83]="renderIndentGuides",H[H.renderFinalNewline=84]="renderFinalNewline",H[H.renderLineHighlight=85]="renderLineHighlight",H[H.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",H[H.renderValidationDecorations=87]="renderValidationDecorations",H[H.renderWhitespace=88]="renderWhitespace",H[H.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",H[H.roundedSelection=90]="roundedSelection",H[H.rulers=91]="rulers",H[H.scrollbar=92]="scrollbar",H[H.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",H[H.scrollBeyondLastLine=94]="scrollBeyondLastLine",H[H.scrollPredominantAxis=95]="scrollPredominantAxis",H[H.selectionClipboard=96]="selectionClipboard",H[H.selectionHighlight=97]="selectionHighlight",H[H.selectOnLineNumbers=98]="selectOnLineNumbers",H[H.showFoldingControls=99]="showFoldingControls",H[H.showUnused=100]="showUnused",H[H.snippetSuggestions=101]="snippetSuggestions",H[H.smartSelect=102]="smartSelect",H[H.smoothScrolling=103]="smoothScrolling",H[H.stickyTabStops=104]="stickyTabStops",H[H.stopRenderingLineAfter=105]="stopRenderingLineAfter",H[H.suggest=106]="suggest",H[H.suggestFontSize=107]="suggestFontSize",H[H.suggestLineHeight=108]="suggestLineHeight",H[H.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",H[H.suggestSelection=110]="suggestSelection",H[H.tabCompletion=111]="tabCompletion",H[H.tabIndex=112]="tabIndex",H[H.unusualLineTerminators=113]="unusualLineTerminators",H[H.useShadowDOM=114]="useShadowDOM",H[H.useTabStops=115]="useTabStops",H[H.wordSeparators=116]="wordSeparators",H[H.wordWrap=117]="wordWrap",H[H.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",H[H.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",H[H.wordWrapColumn=120]="wordWrapColumn",H[H.wordWrapOverride1=121]="wordWrapOverride1",H[H.wordWrapOverride2=122]="wordWrapOverride2",H[H.wrappingIndent=123]="wrappingIndent",H[H.wrappingStrategy=124]="wrappingStrategy",H[H.showDeprecated=125]="showDeprecated",H[H.inlayHints=126]="inlayHints",H[H.editorClassName=127]="editorClassName",H[H.pixelRatio=128]="pixelRatio",H[H.tabFocusMode=129]="tabFocusMode",H[H.layoutInfo=130]="layoutInfo",H[H.wrappingInfo=131]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:_e(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:h.localize(129,null)})),acceptSuggestionOnEnter:_e(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",h.localize(130,null),""],markdownDescription:h.localize(131,null)})),accessibilitySupport:_e(new i),accessibilityPageSize:_e(new l(3,"accessibilityPageSize",10,1,1073741824,{description:h.localize(132,null)})),ariaLabel:_e(new I(4,"ariaLabel",h.localize(133,null))),autoClosingBrackets:_e(new s(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(134,null),h.localize(135,null),""],description:h.localize(136,null)})),autoClosingDelete:_e(new s(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",h.localize(137,null),""],description:h.localize(138,null)})),autoClosingOvertype:_e(new s(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",h.localize(139,null),""],description:h.localize(140,null)})),autoClosingQuotes:_e(new s(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(141,null),h.localize(142,null),""],description:h.localize(143,null)})),autoIndent:_e(new g(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],k,{enumDescriptions:[h.localize(144,null),h.localize(145,null),h.localize(146,null),h.localize(147,null),h.localize(148,null)],description:h.localize(149,null)})),automaticLayout:_e(new d(10,"automaticLayout",!1)),autoSurround:_e(new s(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[h.localize(150,null),h.localize(151,null),h.localize(152,null),""],description:h.localize(153,null)})),bracketPairColorization:_e(new Y),stickyTabStops:_e(new d(104,"stickyTabStops",!1,{description:h.localize(154,null)})),codeLens:_e(new d(13,"codeLens",!0,{description:h.localize(155,null)})),codeLensFontFamily:_e(new I(14,"codeLensFontFamily","",{description:h.localize(156,null)})),codeLensFontSize:_e(new l(15,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:h.localize(157,null)})),colorDecorators:_e(new d(16,"colorDecorators",!0,{description:h.localize(158,null)})),columnSelection:_e(new d(17,"columnSelection",!1,{description:h.localize(159,null)})),comments:_e(new a),contextmenu:_e(new d(19,"contextmenu",!0)),copyWithSyntaxHighlighting:_e(new d(20,"copyWithSyntaxHighlighting",!0,{description:h.localize(160,null)})),cursorBlinking:_e(new g(21,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],o,{description:h.localize(161,null)})),cursorSmoothCaretAnimation:_e(new d(22,"cursorSmoothCaretAnimation",!1,{description:h.localize(162,null)})),cursorStyle:_e(new g(23,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],v,{description:h.localize(163,null)})),cursorSurroundingLines:_e(new l(24,"cursorSurroundingLines",0,0,1073741824,{description:h.localize(164,null)})),cursorSurroundingLinesStyle:_e(new s(25,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[h.localize(165,null),h.localize(166,null)],description:h.localize(167,null)})),cursorWidth:_e(new l(26,"cursorWidth",0,0,1073741824,{markdownDescription:h.localize(168,null)})),disableLayerHinting:_e(new d(27,"disableLayerHinting",!1)),disableMonospaceOptimizations:_e(new d(28,"disableMonospaceOptimizations",!1)),domReadOnly:_e(new d(29,"domReadOnly",!1)),dragAndDrop:_e(new d(30,"dragAndDrop",!0,{description:h.localize(169,null)})),emptySelectionClipboard:_e(new R),extraEditorClassName:_e(new I(32,"extraEditorClassName","")),fastScrollSensitivity:_e(new w(33,"fastScrollSensitivity",5,H=>H<=0?5:H,{markdownDescription:h.localize(170,null)})),find:_e(new p),fixedOverflowWidgets:_e(new d(35,"fixedOverflowWidgets",!1)),folding:_e(new d(36,"folding",!0,{description:h.localize(171,null)})),foldingStrategy:_e(new s(37,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[h.localize(172,null),h.localize(173,null)],description:h.localize(174,null)})),foldingHighlight:_e(new d(38,"foldingHighlight",!0,{description:h.localize(175,null)})),foldingImportsByDefault:_e(new d(39,"foldingImportsByDefault",!1,{description:h.localize(176,null)})),unfoldOnClickAfterEndOfLine:_e(new d(40,"unfoldOnClickAfterEndOfLine",!1,{description:h.localize(177,null)})),fontFamily:_e(new I(41,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:h.localize(178,null)})),fontInfo:_e(new u),fontLigatures2:_e(new S),fontSize:_e(new A),fontWeight:_e(new L),formatOnPaste:_e(new d(46,"formatOnPaste",!1,{description:h.localize(179,null)})),formatOnType:_e(new d(47,"formatOnType",!1,{description:h.localize(180,null)})),glyphMargin:_e(new d(48,"glyphMargin",!0,{description:h.localize(181,null)})),gotoLocation:_e(new V),hideCursorInOverviewRuler:_e(new d(50,"hideCursorInOverviewRuler",!1,{description:h.localize(182,null)})),highlightActiveIndentGuide:_e(new d(51,"highlightActiveIndentGuide",!0,{description:h.localize(183,null)})),hover:_e(new K),inDiffEditor:_e(new d(53,"inDiffEditor",!1)),letterSpacing:_e(new w(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,H=>w.clamp(H,-5,20),{description:h.localize(184,null)})),lightbulb:_e(new $),lineDecorationsWidth:_e(new E(57,"lineDecorationsWidth",10)),lineHeight:_e(new z),lineNumbers:_e(new Me),lineNumbersMinChars:_e(new l(60,"lineNumbersMinChars",5,1,300)),linkedEditing:_e(new d(61,"linkedEditing",!1,{description:h.localize(185,null)})),links:_e(new d(62,"links",!0,{description:h.localize(186,null)})),matchBrackets:_e(new s(63,"matchBrackets","always",["always","near","never"],{description:h.localize(187,null)})),minimap:_e(new G),mouseStyle:_e(new s(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:_e(new w(66,"mouseWheelScrollSensitivity",1,H=>H===0?1:H,{markdownDescription:h.localize(188,null)})),mouseWheelZoom:_e(new d(67,"mouseWheelZoom",!1,{markdownDescription:h.localize(189,null)})),multiCursorMergeOverlapping:_e(new d(68,"multiCursorMergeOverlapping",!0,{description:h.localize(190,null)})),multiCursorModifier:_e(new g(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[h.localize(191,null),h.localize(192,null)],markdownDescription:h.localize(193,null)})),multiCursorPaste:_e(new s(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[h.localize(194,null),h.localize(195,null)],markdownDescription:h.localize(196,null)})),occurrencesHighlight:_e(new d(71,"occurrencesHighlight",!0,{description:h.localize(197,null)})),overviewRulerBorder:_e(new d(72,"overviewRulerBorder",!0,{description:h.localize(198,null)})),overviewRulerLanes:_e(new l(73,"overviewRulerLanes",3,0,3)),padding:_e(new q),parameterHints:_e(new le),peekWidgetDefaultFocus:_e(new s(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[h.localize(199,null),h.localize(200,null)],description:h.localize(201,null)})),definitionLinkOpensInPeek:_e(new d(77,"definitionLinkOpensInPeek",!1,{description:h.localize(202,null)})),quickSuggestions:_e(new ve),quickSuggestionsDelay:_e(new l(79,"quickSuggestionsDelay",10,0,1073741824,{description:h.localize(203,null)})),readOnly:_e(new d(80,"readOnly",!1)),renameOnType:_e(new d(81,"renameOnType",!1,{description:h.localize(204,null),markdownDeprecationMessage:h.localize(205,null)})),renderControlCharacters:_e(new d(82,"renderControlCharacters",!1,{description:h.localize(206,null)})),renderIndentGuides:_e(new d(83,"renderIndentGuides",!0,{description:h.localize(207,null)})),renderFinalNewline:_e(new d(84,"renderFinalNewline",!0,{description:h.localize(208,null)})),renderLineHighlight:_e(new s(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",h.localize(209,null)],description:h.localize(210,null)})),renderLineHighlightOnlyWhenFocus:_e(new d(86,"renderLineHighlightOnlyWhenFocus",!1,{description:h.localize(211,null)})),renderValidationDecorations:_e(new s(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:_e(new s(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",h.localize(212,null),h.localize(213,null),h.localize(214,null),""],description:h.localize(215,null)})),revealHorizontalRightPadding:_e(new l(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:_e(new d(90,"roundedSelection",!0,{description:h.localize(216,null)})),rulers:_e(new Ye),scrollbar:_e(new je),scrollBeyondLastColumn:_e(new l(93,"scrollBeyondLastColumn",5,0,1073741824,{description:h.localize(217,null)})),scrollBeyondLastLine:_e(new d(94,"scrollBeyondLastLine",!0,{description:h.localize(218,null)})),scrollPredominantAxis:_e(new d(95,"scrollPredominantAxis",!0,{description:h.localize(219,null)})),selectionClipboard:_e(new d(96,"selectionClipboard",!0,{description:h.localize(220,null),included:M.isLinux})),selectionHighlight:_e(new d(97,"selectionHighlight",!0,{description:h.localize(221,null)})),selectOnLineNumbers:_e(new d(98,"selectOnLineNumbers",!0)),showFoldingControls:_e(new s(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[h.localize(222,null),h.localize(223,null)],description:h.localize(224,null)})),showUnused:_e(new d(100,"showUnused",!0,{description:h.localize(225,null)})),showDeprecated:_e(new d(125,"showDeprecated",!0,{description:h.localize(226,null)})),inlayHints:_e(new U),snippetSuggestions:_e(new s(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[h.localize(227,null),h.localize(228,null),h.localize(229,null),h.localize(230,null)],description:h.localize(231,null)})),smartSelect:_e(new ae),smoothScrolling:_e(new d(103,"smoothScrolling",!1,{description:h.localize(232,null)})),stopRenderingLineAfter:_e(new l(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:_e(new ee),inlineSuggest:_e(new x),suggestFontSize:_e(new l(107,"suggestFontSize",0,0,1e3,{markdownDescription:h.localize(233,null)})),suggestLineHeight:_e(new l(108,"suggestLineHeight",0,0,1e3,{markdownDescription:h.localize(234,null)})),suggestOnTriggerCharacters:_e(new d(109,"suggestOnTriggerCharacters",!0,{description:h.localize(235,null)})),suggestSelection:_e(new s(110,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[h.localize(236,null),h.localize(237,null),h.localize(238,null)],description:h.localize(239,null)})),tabCompletion:_e(new s(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[h.localize(240,null),h.localize(241,null),h.localize(242,null)],description:h.localize(243,null)})),tabIndex:_e(new l(112,"tabIndex",0,-1,1073741824)),unusualLineTerminators:_e(new s(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[h.localize(244,null),h.localize(245,null),h.localize(246,null)],description:h.localize(247,null)})),useShadowDOM:_e(new d(114,"useShadowDOM",!0)),useTabStops:_e(new d(115,"useTabStops",!0,{description:h.localize(248,null)})),wordSeparators:_e(new I(116,"wordSeparators",b.USUAL_WORD_SEPARATORS,{description:h.localize(249,null)})),wordWrap:_e(new s(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[h.localize(250,null),h.localize(251,null),h.localize(252,null),h.localize(253,null)],description:h.localize(254,null)})),wordWrapBreakAfterCharacters:_e(new I(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:_e(new I(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:_e(new l(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:h.localize(255,null)})),wordWrapOverride1:_e(new s(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:_e(new s(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:_e(new g(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],he,{enumDescriptions:[h.localize(256,null),h.localize(257,null),h.localize(258,null),h.localize(259,null)],description:h.localize(260,null)})),wrappingStrategy:_e(new s(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[h.localize(261,null),h.localize(262,null)],description:h.localize(263,null)})),editorClassName:_e(new C),pixelRatio:_e(new se),tabFocusMode:_e(new j),layoutInfo:_e(new Q),wrappingInfo:_e(new Te)}}),define(we[119],be([18,19]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[120],be([18,19]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[121],be([18,19]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(we[122],be([18,19]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(we[123],be([18,19]),function(ne,e){return ne.create("vs/platform/theme/common/iconRegistry",e)}),define(we[124],be([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[125],be([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[126],be([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(we[127],be([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[128],be([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[129],be([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[130],be([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[131],be([18,19]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(we[132],be([18,19]),function(ne,e){return ne.create("vs/workbench/common/views",e)}),define(we[133],be([18,19]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[134],be([18,19]),function(ne,e){return ne.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[135],be([18,19]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[136],be([18,19]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[137],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var h;(function(F){F[F.ACTIVATE=1]="ACTIVATE",F[F.RESTORE=2]="RESTORE",F[F.PRESERVE=3]="PRESERVE"})(h=e.EditorActivation||(e.EditorActivation={}));var M;(function(F){F[F.PICK=0]="PICK",F[F.DISABLED=1]="DISABLED",F[F.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(M=e.EditorResolution||(e.EditorResolution={}));var b;(function(F){F[F.API=0]="API",F[F.USER=1]="USER"})(b=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(F){F[F.Center=0]="Center",F[F.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",F[F.NearTop=2]="NearTop",F[F.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[138],be([0,1,120]),function(ne,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function T(n){return n=n.trim(),n==="*"||M.test(n)}e.isValidVersionStr=T;function F(n){if(!T(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let d=n.match(M);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=F;function D(n){if(!n)return null;let d=n.majorBase,c=n.majorMustEqual,l=n.minorBase,w=n.minorMustEqual,I=n.patchBase,y=n.patchMustEqual;n.hasCaret&&(d===0||(w=!1),y=!1);let s=0;if(n.preRelease){const g=b.exec(n.preRelease);if(g){const[,k,i,a]=g;s=Date.UTC(Number(k),Number(i)-1,Number(a))}}return{majorBase:d,majorMustEqual:c,minorBase:l,minorMustEqual:w,patchBase:I,patchMustEqual:y,isMinimum:n.hasGreaterEquals,notBefore:s}}e.normalizeVersion=D;function _(n,d,c){let l;typeof n=="string"?l=D(F(n)):l=n;let w;d instanceof Date?w=d.getTime():typeof d=="string"&&(w=new Date(d).getTime());let I;if(typeof c=="string"?I=D(F(c)):I=c,!l||!I)return!1;let y=l.majorBase,s=l.minorBase,g=l.patchBase,k=I.majorBase,i=I.minorBase,a=I.patchBase,r=I.notBefore,o=I.majorMustEqual,f=I.minorMustEqual,m=I.patchMustEqual;return I.isMinimum?y>k?!0:y<k?!1:s>i?!0:s<i||w&&w<r?!1:g>=a:(y===1&&k===0&&(!o||!f||!m)&&(k=1,i=0,a=0,o=!0,f=!1,m=!1),y<k?!1:y>k?!o:s<i?!1:s>i?!f:g<a?!1:g>a?!m:!(w&&w<r))}e.isValidVersion=_;function P(n,d,c,l){return c.isBuiltin||typeof c.main=="undefined"?!0:E(n,d,c.engines.vscode,l)}e.isValidExtensionVersion=P;function t(n,d,c){return n==="*"||E(d,c,n)}e.isEngineValid=t;function E(n,d,c,l=[]){let w=D(F(c));if(!w)return l.push(h.localize(0,null,c)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return l.push(h.localize(1,null,c)),!1}else if(!w.majorMustEqual)return l.push(h.localize(2,null,c)),!1;return _(n,d,w)?!0:(l.push(h.localize(3,null,n,c)),!1)}}),define(we[81],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class h{constructor(b,T=[],F=!1){this.ctor=b,this.staticArguments=T,this.supportsDelayedInstantiation=F}}e.SyncDescriptor=h}),define(we[57],be([0,1,81]),function(ne,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const M=[];function b(F,D,_){D instanceof h.SyncDescriptor||(D=new h.SyncDescriptor(D,[],_)),M.push([F,D])}e.registerSingleton=b;function T(){return M}e.getSingletonServiceDescriptors=T}),define(we[139],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class h{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=h;class M{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let F of this._nodes.values())F.outgoing.size===0&&T.push(F);return T}insertEdge(T,F){const D=this.lookupOrInsertNode(T),_=this.lookupOrInsertNode(F);D.outgoing.set(this._hashFn(F),_),_.incoming.set(this._hashFn(T),D)}removeNode(T){const F=this._hashFn(T);this._nodes.delete(F);for(let D of this._nodes.values())D.outgoing.delete(F),D.incoming.delete(F)}lookupOrInsertNode(T){const F=this._hashFn(T);let D=this._nodes.get(F);return D||(D=new h(T),this._nodes.set(F,D)),D}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[F,D]of this._nodes)T.push(`${F}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,F]of this._nodes){const D=new Set([T]),_=this._findCycle(F,D);if(_)return _}}_findCycle(T,F){for(let[D,_]of T.outgoing){if(F.has(D))return[...F,D].join(" -> ");F.add(D);const P=this._findCycle(_,F);if(P)return P;F.delete(D)}}}e.Graph=M}),define(we[4],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var h;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function _(P){return P[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=_})(h=e._util||(e._util={})),e.IInstantiationService=b("instantiationService");function M(D,_,P,t){_[h.DI_TARGET]===_?_[h.DI_DEPENDENCIES].push({id:D,index:P,optional:t}):(_[h.DI_DEPENDENCIES]=[{id:D,index:P,optional:t}],_[h.DI_TARGET]=_)}function b(D){if(h.serviceIds.has(D))return h.serviceIds.get(D);const _=function(P,t,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(_,P,E,!1)};return _.toString=()=>D,h.serviceIds.set(D,_),_}e.createDecorator=b;function T(D){return D}e.refineServiceDecorator=T;function F(D){return function(_,P,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");M(D,_,t,!0)}}e.optional=F}),define(we[140],be([0,1,4]),function(ne,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,h.createDecorator)("modelService");function M(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}e.shouldSynchronizeModel=M}),define(we[141],be([0,1,3,58,6,20,75,55,140]),function(ne,e,h,M,b,T,F,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(l){return typeof l=="string"?!1:Array.isArray(l)?l.every(P):!!l.exclusive}class t{constructor(){this._clock=0,this._entries=[],this._onDidChange=new h.Emitter}get onDidChange(){return this._onDidChange.event}register(w,I){let y={selector:w,provider:I,_score:-1,_time:this._clock++};return this._entries.push(y),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,b.toDisposable)(()=>{if(y){let s=this._entries.indexOf(y);s>=0&&(this._entries.splice(s,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),y=void 0)}})}has(w){return this.all(w).length>0}all(w){if(!w)return[];this._updateScores(w);const I=[];for(let y of this._entries)y._score>0&&I.push(y.provider);return I}ordered(w){const I=[];return this._orderedForEach(w,y=>I.push(y.provider)),I}orderedGroups(w){const I=[];let y,s;return this._orderedForEach(w,g=>{y&&s===g._score?y.push(g.provider):(s=g._score,y=[g.provider],I.push(y))}),I}_orderedForEach(w,I){if(!!w){this._updateScores(w);for(const y of this._entries)y._score>0&&I(y)}}_updateScores(w){let I={uri:w.uri.toString(),language:w.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===I.language&&this._lastCandidate.uri===I.uri)){this._lastCandidate=I;for(let y of this._entries)if(y._score=(0,D.score)(y.selector,w.uri,w.getLanguageIdentifier().language,(0,_.shouldSynchronizeModel)(w)),P(y.selector)&&y._score>0){for(let s of this._entries)s._score=0;y._score=1e3;break}this._entries.sort(t._compareByScoreAndTime)}}static _compareByScoreAndTime(w,I){return w._score<I._score?1:w._score>I._score?-1:w._time<I._time?1:w._time>I._time?-1:0}}e.LanguageFeatureRegistry=t;const E=new WeakMap;let n=0;function d(l){let w=E.get(l);return w===void 0&&(w=++n,E.set(l,w)),w}class c{constructor(w,I,y=Number.MAX_SAFE_INTEGER){this._registry=w,this.min=I,this.max=y,this._cache=new T.LRUCache(50,.7)}_key(w){return w.id+this._registry.all(w).reduce((I,y)=>(0,M.doHash)(d(y),I),0)}_clamp(w){return w===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(w*1.3)))}get(w){const I=this._key(w),y=this._cache.get(I);return this._clamp(y?.value)}update(w,I){const y=this._key(w);let s=this._cache.get(y);return s||(s=new F.MovingAverage,this._cache.set(y,s)),s.update(I),this.get(w)}}e.LanguageFeatureRequestDelays=c}),define(we[59],be([0,1,2,42,141,114,34]),function(ne,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var D;(function(p){p[p.Null=0]="Null",p[p.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));class _{constructor(S,u){this.language=S,this.id=u}}e.LanguageIdentifier=_;var P;(function(p){p[p.NotSet=-1]="NotSet",p[p.None=0]="None",p[p.Italic=1]="Italic",p[p.Bold=2]="Bold",p[p.Underline=4]="Underline"})(P=e.FontStyle||(e.FontStyle={}));var t;(function(p){p[p.None=0]="None",p[p.DefaultForeground=1]="DefaultForeground",p[p.DefaultBackground=2]="DefaultBackground"})(t=e.ColorId||(e.ColorId={}));var E;(function(p){p[p.Other=0]="Other",p[p.Comment=1]="Comment",p[p.String=2]="String",p[p.RegEx=4]="RegEx"})(E=e.StandardTokenType||(e.StandardTokenType={}));var n;(function(p){p[p.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",p[p.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",p[p.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",p[p.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",p[p.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",p[p.ITALIC_MASK=2048]="ITALIC_MASK",p[p.BOLD_MASK=4096]="BOLD_MASK",p[p.UNDERLINE_MASK=8192]="UNDERLINE_MASK",p[p.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",p[p.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",p[p.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",p[p.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",p[p.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",p[p.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",p[p.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",p[p.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",p[p.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",p[p.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(n=e.MetadataConsts||(e.MetadataConsts={}));class d{static getLanguageId(S){return(S&255)>>>0}static getTokenType(S){return(S&1792)>>>8}static getFontStyle(S){return(S&14336)>>>11}static getForeground(S){return(S&8372224)>>>14}static getBackground(S){return(S&4286578688)>>>23}static getClassNameFromMetadata(S){let u=this.getForeground(S),A="mtk"+u,L=this.getFontStyle(S);return L&1&&(A+=" mtki"),L&2&&(A+=" mtkb"),L&4&&(A+=" mtku"),A}static getInlineStyleFromMetadata(S,u){const A=this.getForeground(S),L=this.getFontStyle(S);let V=`color: ${u[A]};`;return L&1&&(V+="font-style: italic;"),L&2&&(V+="font-weight: bold;"),L&4&&(V+="text-decoration: underline;"),V}}e.TokenMetadata=d;var c;(function(p){p[p.Method=0]="Method",p[p.Function=1]="Function",p[p.Constructor=2]="Constructor",p[p.Field=3]="Field",p[p.Variable=4]="Variable",p[p.Class=5]="Class",p[p.Struct=6]="Struct",p[p.Interface=7]="Interface",p[p.Module=8]="Module",p[p.Property=9]="Property",p[p.Event=10]="Event",p[p.Operator=11]="Operator",p[p.Unit=12]="Unit",p[p.Value=13]="Value",p[p.Constant=14]="Constant",p[p.Enum=15]="Enum",p[p.EnumMember=16]="EnumMember",p[p.Keyword=17]="Keyword",p[p.Text=18]="Text",p[p.Color=19]="Color",p[p.File=20]="File",p[p.Reference=21]="Reference",p[p.Customcolor=22]="Customcolor",p[p.Folder=23]="Folder",p[p.TypeParameter=24]="TypeParameter",p[p.User=25]="User",p[p.Issue=26]="Issue",p[p.Snippet=27]="Snippet"})(c=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let p=Object.create(null);return p[0]="symbol-method",p[1]="symbol-function",p[2]="symbol-constructor",p[3]="symbol-field",p[4]="symbol-variable",p[5]="symbol-class",p[6]="symbol-struct",p[7]="symbol-interface",p[8]="symbol-module",p[9]="symbol-property",p[10]="symbol-event",p[11]="symbol-operator",p[12]="symbol-unit",p[13]="symbol-value",p[14]="symbol-constant",p[15]="symbol-enum",p[16]="symbol-enum-member",p[17]="symbol-keyword",p[27]="symbol-snippet",p[18]="symbol-text",p[19]="symbol-color",p[20]="symbol-file",p[21]="symbol-reference",p[22]="symbol-customcolor",p[23]="symbol-folder",p[24]="symbol-type-parameter",p[25]="account",p[26]="issues",function(S){const u=p[S];let A=u&&F.iconRegistry.get(u);return A||(console.info("No codicon found for CompletionItemKind "+S),A=F.Codicon.symbolProperty),A.classNames}}(),e.completionKindFromString=function(){let p=Object.create(null);return p.method=0,p.function=1,p.constructor=2,p.field=3,p.variable=4,p.class=5,p.struct=6,p.interface=7,p.module=8,p.property=9,p.event=10,p.operator=11,p.unit=12,p.value=13,p.constant=14,p.enum=15,p["enum-member"]=16,p.enumMember=16,p.keyword=17,p.snippet=27,p.text=18,p.color=19,p.file=20,p.reference=21,p.customcolor=22,p.folder=23,p["type-parameter"]=24,p.typeParameter=24,p.account=25,p.issue=26,function(S,u){let A=p[S];return typeof A=="undefined"&&!u&&(A=9),A}}();var l;(function(p){p[p.Deprecated=1]="Deprecated"})(l=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(p){p[p.KeepWhitespace=1]="KeepWhitespace",p[p.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var I;(function(p){p[p.Invoke=0]="Invoke",p[p.TriggerCharacter=1]="TriggerCharacter",p[p.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(I=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var y;(function(p){p[p.Automatic=0]="Automatic",p[p.Explicit=1]="Explicit"})(y=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var s;(function(p){p[p.Invoke=1]="Invoke",p[p.Auto=2]="Auto"})(s=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var g;(function(p){p[p.Invoke=1]="Invoke",p[p.TriggerCharacter=2]="TriggerCharacter",p[p.ContentChange=3]="ContentChange"})(g=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var k;(function(p){p[p.Text=0]="Text",p[p.Read=1]="Read",p[p.Write=2]="Write"})(k=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function i(p){return p&&h.URI.isUri(p.uri)&&M.Range.isIRange(p.range)&&(M.Range.isIRange(p.originSelectionRange)||M.Range.isIRange(p.targetSelectionRange))}e.isLocationLink=i;var a;(function(p){p[p.File=0]="File",p[p.Module=1]="Module",p[p.Namespace=2]="Namespace",p[p.Package=3]="Package",p[p.Class=4]="Class",p[p.Method=5]="Method",p[p.Property=6]="Property",p[p.Field=7]="Field",p[p.Constructor=8]="Constructor",p[p.Enum=9]="Enum",p[p.Interface=10]="Interface",p[p.Function=11]="Function",p[p.Variable=12]="Variable",p[p.Constant=13]="Constant",p[p.String=14]="String",p[p.Number=15]="Number",p[p.Boolean=16]="Boolean",p[p.Array=17]="Array",p[p.Object=18]="Object",p[p.Key=19]="Key",p[p.Null=20]="Null",p[p.EnumMember=21]="EnumMember",p[p.Struct=22]="Struct",p[p.Event=23]="Event",p[p.Operator=24]="Operator",p[p.TypeParameter=25]="TypeParameter"})(a=e.SymbolKind||(e.SymbolKind={}));var r;(function(p){p[p.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var o;(function(p){const S=new Map;S.set("file",0),S.set("module",1),S.set("namespace",2),S.set("package",3),S.set("class",4),S.set("method",5),S.set("property",6),S.set("field",7),S.set("constructor",8),S.set("enum",9),S.set("interface",10),S.set("function",11),S.set("variable",12),S.set("constant",13),S.set("string",14),S.set("number",15),S.set("boolean",16),S.set("array",17),S.set("object",18),S.set("key",19),S.set("null",20),S.set("enum-member",21),S.set("struct",22),S.set("event",23),S.set("operator",24),S.set("type-parameter",25);const u=new Map;u.set(0,"file"),u.set(1,"module"),u.set(2,"namespace"),u.set(3,"package"),u.set(4,"class"),u.set(5,"method"),u.set(6,"property"),u.set(7,"field"),u.set(8,"constructor"),u.set(9,"enum"),u.set(10,"interface"),u.set(11,"function"),u.set(12,"variable"),u.set(13,"constant"),u.set(14,"string"),u.set(15,"number"),u.set(16,"boolean"),u.set(17,"array"),u.set(18,"object"),u.set(19,"key"),u.set(20,"null"),u.set(21,"enum-member"),u.set(22,"struct"),u.set(23,"event"),u.set(24,"operator"),u.set(25,"type-parameter");function A(K){return S.get(K)}p.fromString=A;function L(K){return u.get(K)}p.toString=L;function V(K,W){const Q=u.get(K);let $=Q&&F.iconRegistry.get("symbol-"+Q);return $||(console.info("No codicon found for SymbolKind "+K),$=F.Codicon.symbolProperty),`${W?"inline":"block"} ${$.classNames}`}p.toCssClassName=V})(o=e.SymbolKinds||(e.SymbolKinds={}));class f{constructor(S){this.value=S}}e.FoldingRangeKind=f,f.Comment=new f("comment"),f.Imports=new f("imports"),f.Region=new f("region");var m;(function(p){p[p.Collapsed=0]="Collapsed",p[p.Expanded=1]="Expanded"})(m=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var v;(function(p){p[p.Editing=0]="Editing",p[p.Preview=1]="Preview"})(v=e.CommentMode||(e.CommentMode={}));var C;(function(p){p[p.Other=0]="Other",p[p.Type=1]="Type",p[p.Parameter=2]="Parameter"})(C=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new b.LanguageFeatureRegistry,e.RenameProviderRegistry=new b.LanguageFeatureRegistry,e.CompletionProviderRegistry=new b.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new b.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new b.LanguageFeatureRegistry,e.HoverProviderRegistry=new b.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new b.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new b.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new b.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new b.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new b.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new b.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new b.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new b.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new b.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new b.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new b.LanguageFeatureRegistry,e.LinkProviderRegistry=new b.LanguageFeatureRegistry,e.ColorProviderRegistry=new b.LanguageFeatureRegistry,e.SelectionRangeRegistry=new b.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new b.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new b.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var R;(function(p){p[p.None=0]="None",p[p.Option=1]="Option",p[p.Default=2]="Default",p[p.Preferred=3]="Preferred"})(R=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[43],be([0,1,26,9,4]),function(ne,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=h.userAgent||"";const F=new Map;F.set("false",!1),F.set("true",!0),F.set("isMac",h.isMacintosh),F.set("isLinux",h.isLinux),F.set("isWindows",h.isWindows),F.set("isWeb",h.isWeb),F.set("isMacNative",h.isMacintosh&&!h.isWeb),F.set("isEdge",T.indexOf("Edg/")>=0),F.set("isFirefox",T.indexOf("Firefox")>=0),F.set("isChrome",T.indexOf("Chrome")>=0),F.set("isSafari",T.indexOf("Safari")>=0);const D=Object.prototype.hasOwnProperty;var _;(function(S){S[S.False=0]="False",S[S.True=1]="True",S[S.Defined=2]="Defined",S[S.Not=3]="Not",S[S.Equals=4]="Equals",S[S.NotEquals=5]="NotEquals",S[S.And=6]="And",S[S.Regex=7]="Regex",S[S.NotRegex=8]="NotRegex",S[S.Or=9]="Or",S[S.In=10]="In",S[S.NotIn=11]="NotIn",S[S.Greater=12]="Greater",S[S.GreaterEquals=13]="GreaterEquals",S[S.Smaller=14]="Smaller",S[S.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return E.INSTANCE}static true(){return n.INSTANCE}static has(u){return d.create(u)}static equals(u,A){return c.create(u,A)}static notEquals(u,A){return I.create(u,A)}static regex(u,A){return a.create(u,A)}static in(u,A){return l.create(u,A)}static not(u){return y.create(u)}static and(...u){return o.create(u,null)}static or(...u){return f.create(u,null,!0)}static greater(u,A){return s.create(u,A)}static less(u,A){return k.create(u,A)}static deserialize(u,A=!1){if(!!u)return this._deserializeOrExpression(u,A)}static _deserializeOrExpression(u,A){let L=u.split("||");return f.create(L.map(V=>this._deserializeAndExpression(V,A)),null,!0)}static _deserializeAndExpression(u,A){let L=u.split("&&");return o.create(L.map(V=>this._deserializeOne(V,A)),null)}static _deserializeOne(u,A){if(u=u.trim(),u.indexOf("!=")>=0){let L=u.split("!=");return I.create(L[0].trim(),this._deserializeValue(L[1],A))}if(u.indexOf("==")>=0){let L=u.split("==");return c.create(L[0].trim(),this._deserializeValue(L[1],A))}if(u.indexOf("=~")>=0){let L=u.split("=~");return a.create(L[0].trim(),this._deserializeRegexValue(L[1],A))}if(u.indexOf(" in ")>=0){let L=u.split(" in ");return l.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(u)){const L=u.split(">=");return g.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(u)){const L=u.split(">");return s.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(u)){const L=u.split("<=");return i.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(u)){const L=u.split("<");return k.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(u)?y.create(u.substr(1).trim()):d.create(u)}static _deserializeValue(u,A){if(u=u.trim(),u==="true")return!0;if(u==="false")return!1;let L=/^'([^']*)'$/.exec(u);return L?L[1].trim():u}static _deserializeRegexValue(u,A){if((0,M.isFalsyOrWhitespace)(u)){if(A)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=u.indexOf("/"),V=u.lastIndexOf("/");if(L===V||L<0){if(A)throw new Error(`bad regexp-value '${u}', missing /-enclosure`);return console.warn(`bad regexp-value '${u}', missing /-enclosure`),null}let K=u.slice(L+1,V),W=u[V+1]==="i"?"i":"";try{return new RegExp(K,W)}catch(Q){if(A)throw new Error(`bad regexp-value '${u}', parse error: ${Q}`);return console.warn(`bad regexp-value '${u}', parse error: ${Q}`),null}}}e.ContextKeyExpr=P;function t(S,u){return S.cmp(u)}class E{constructor(){this.type=0}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}evaluate(u){return!1}serialize(){return"false"}keys(){return[]}map(u){return this}negate(){return n.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class n{constructor(){this.type=1}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}evaluate(u){return!0}serialize(){return"true"}keys(){return[]}map(u){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=n,n.INSTANCE=new n;class d{constructor(u,A){this.key=u,this.negated=A,this.type=2}static create(u,A=null){const L=F.get(u);return typeof L=="boolean"?L?n.INSTANCE:E.INSTANCE:new d(u,A)}cmp(u){return u.type!==this.type?this.type-u.type:v(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}evaluate(u){return!!u.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(u){return u.mapDefined(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=d;class c{constructor(u,A,L){this.key=u,this.value=A,this.negated=L,this.type=4}static create(u,A,L=null){if(typeof A=="boolean")return A?d.create(u,L):y.create(u,L);const V=F.get(u);return typeof V=="boolean"?A===(V?"true":"false")?n.INSTANCE:E.INSTANCE:new c(u,A,L)}cmp(u){return u.type!==this.type?this.type-u.type:C(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return u.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(u){return u.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=I.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=c;class l{constructor(u,A){this.key=u,this.valueKey=A,this.type=10,this.negated=null}static create(u,A){return new l(u,A)}cmp(u){return u.type!==this.type?this.type-u.type:C(this.key,this.valueKey,u.key,u.valueKey)}equals(u){return u.type===this.type?this.key===u.key&&this.valueKey===u.valueKey:!1}evaluate(u){const A=u.getValue(this.valueKey),L=u.getValue(this.key);return Array.isArray(A)?A.indexOf(L)>=0:typeof L=="string"&&typeof A=="object"&&A!==null?D.call(A,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(u){return u.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=w.create(this)),this.negated}}e.ContextKeyInExpr=l;class w{constructor(u){this._actual=u,this.type=11}static create(u){return new w(u)}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}evaluate(u){return!this._actual.evaluate(u)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(u){return new w(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotInExpr=w;class I{constructor(u,A,L){this.key=u,this.value=A,this.negated=L,this.type=5}static create(u,A,L=null){if(typeof A=="boolean")return A?y.create(u,L):d.create(u,L);const V=F.get(u);return typeof V=="boolean"?A===(V?"true":"false")?E.INSTANCE:n.INSTANCE:new I(u,A,L)}cmp(u){return u.type!==this.type?this.type-u.type:C(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return u.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(u){return u.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=I;class y{constructor(u,A){this.key=u,this.negated=A,this.type=3}static create(u,A=null){const L=F.get(u);return typeof L=="boolean"?L?E.INSTANCE:n.INSTANCE:new y(u,A)}cmp(u){return u.type!==this.type?this.type-u.type:v(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}evaluate(u){return!u.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(u){return u.mapNot(this.key)}negate(){return this.negated||(this.negated=d.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=y;class s{constructor(u,A,L){this.key=u,this.value=A,this.negated=L,this.type=12}static create(u,A,L=null){return new s(u,A,L)}cmp(u){return u.type!==this.type?this.type-u.type:C(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=s;class g{constructor(u,A,L){this.key=u,this.value=A,this.negated=L,this.type=13}static create(u,A,L=null){return new g(u,A,L)}cmp(u){return u.type!==this.type?this.type-u.type:C(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=g;class k{constructor(u,A,L){this.key=u,this.value=A,this.negated=L,this.type=14}static create(u,A,L=null){return new k(u,A,L)}cmp(u){return u.type!==this.type?this.type-u.type:C(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=k;class i{constructor(u,A,L){this.key=u,this.value=A,this.negated=L,this.type=15}static create(u,A,L=null){return new i(u,A,L)}cmp(u){return u.type!==this.type?this.type-u.type:C(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}evaluate(u){return parseFloat(u.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=i;class a{constructor(u,A){this.key=u,this.regexp=A,this.type=7,this.negated=null}static create(u,A){return new a(u,A)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.key<u.key)return-1;if(this.key>u.key)return 1;const A=this.regexp?this.regexp.source:"",L=u.regexp?u.regexp.source:"";return A<L?-1:A>L?1:0}equals(u){if(u.type===this.type){const A=this.regexp?this.regexp.source:"",L=u.regexp?u.regexp.source:"";return this.key===u.key&&A===L}return!1}evaluate(u){let A=u.getValue(this.key);return this.regexp?this.regexp.test(A):!1}serialize(){const u=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${u}`}keys(){return[this.key]}map(u){return u.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=a;class r{constructor(u){this._actual=u,this.type=8}static create(u){return new r(u)}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}evaluate(u){return!this._actual.evaluate(u)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(u){return new r(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class o{constructor(u,A){this.expr=u,this.negated=A,this.type=6}static create(u,A){return o._normalizeArr(u,A)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let A=0,L=this.expr.length;A<L;A++){const V=t(this.expr[A],u.expr[A]);if(V!==0)return V}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].equals(u.expr[A]))return!1;return!0}return!1}evaluate(u){for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].evaluate(u))return!1;return!0}static _normalizeArr(u,A){const L=[];let V=!1;for(const K of u)if(!!K){if(K.type===1){V=!0;continue}if(K.type===0)return E.INSTANCE;if(K.type===6){L.push(...K.expr);continue}L.push(K)}if(L.length===0&&V)return n.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];L.sort(t);for(let K=1;K<L.length;K++)L[K-1].equals(L[K])&&(L.splice(K,1),K--);if(L.length===1)return L[0];for(;L.length>1;){const K=L[L.length-1];if(K.type!==9)break;L.pop();const W=L.pop(),Q=L.length===0,$=f.create(K.expr.map(U=>o.create([U,W],null)),null,Q);$&&(L.push($),L.sort(t))}return L.length===1?L[0]:new o(L,A)}}serialize(){return this.expr.map(u=>u.serialize()).join(" && ")}keys(){const u=[];for(let A of this.expr)u.push(...A.keys());return u}map(u){return new o(this.expr.map(A=>A.map(u)),null)}negate(){if(!this.negated){const u=[];for(let A of this.expr)u.push(A.negate());this.negated=f.create(u,this,!0)}return this.negated}}class f{constructor(u,A){this.expr=u,this.negated=A,this.type=9}static create(u,A,L){return f._normalizeArr(u,A,L)}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let A=0,L=this.expr.length;A<L;A++){const V=t(this.expr[A],u.expr[A]);if(V!==0)return V}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let A=0,L=this.expr.length;A<L;A++)if(!this.expr[A].equals(u.expr[A]))return!1;return!0}return!1}evaluate(u){for(let A=0,L=this.expr.length;A<L;A++)if(this.expr[A].evaluate(u))return!0;return!1}static _normalizeArr(u,A,L){let V=[],K=!1;if(u){for(let W=0,Q=u.length;W<Q;W++){const $=u[W];if(!!$){if($.type===0){K=!0;continue}if($.type===1)return n.INSTANCE;if($.type===9){V=V.concat($.expr);continue}V.push($)}}if(V.length===0&&K)return E.INSTANCE;V.sort(t)}if(V.length!==0){if(V.length===1)return V[0];for(let W=1;W<V.length;W++)V[W-1].equals(V[W])&&(V.splice(W,1),W--);if(V.length===1)return V[0];if(L){for(let W=0;W<V.length;W++)for(let Q=W+1;Q<V.length;Q++)R(V[W],V[Q])&&(V.splice(Q,1),Q--);if(V.length===1)return V[0]}return new f(V,A)}}serialize(){return this.expr.map(u=>u.serialize()).join(" || ")}keys(){const u=[];for(let A of this.expr)u.push(...A.keys());return u}map(u){return new f(this.expr.map(A=>A.map(u)),null)}negate(){if(!this.negated){let u=[];for(let A of this.expr)u.push(A.negate());for(;u.length>1;){const A=u.shift(),L=u.shift(),V=[];for(const W of p(A))for(const Q of p(L))V.push(o.create([W,Q],null));const K=u.length===0;u.unshift(f.create(V,null,K))}this.negated=u[0]}return this.negated}}class m extends d{constructor(u,A,L){super(u,null);this._defaultValue=A,typeof L=="object"?m._info.push({...L,key:u}):L!==!0&&m._info.push({key:u,description:L,type:A!=null?typeof A:void 0})}static all(){return m._info.values()}bindTo(u){return u.createKey(this.key,this._defaultValue)}getValue(u){return u.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(u){return c.create(this.key,u)}notEqualsTo(u){return I.create(this.key,u)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=(0,b.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(S,u){return S<u?-1:S>u?1:0}function C(S,u,A,L){return S<A?-1:S>A?1:u<L?-1:u>L?1:0}function R(S,u){if(u.type===6&&S.type!==9&&S.type!==6){for(const V of u.expr)if(S.equals(V))return!0}const A=S.negate(),L=p(A).concat(p(u));L.sort(t);for(let V=0;V<L.length;V++){const W=L[V].negate();for(let Q=V+1;Q<L.length;Q++){const $=L[Q];if(W.equals($))return!0}}return!1}e.implies=R;function p(S){return S.type===9?S.expr:[S]}}),define(we[142],be([0,1,4]),function(ne,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,h.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,h.refineServiceDecorator)(e.IEnvironmentService)}),define(we[25],be([0,1,9,4]),function(ne,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function b(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=b;function T(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var F;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(F=e.ExtensionType||(e.ExtensionType={}));class D{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,n){if(typeof E=="undefined"||E===null)return typeof n=="undefined"||n===null;if(typeof n=="undefined"||n===null)return!1;if(typeof E=="string"||typeof n=="string"){let d=typeof E=="string"?E:E.value,c=typeof n=="string"?n:n.value;return h.equalsIgnoreCase(d,c)}return E._lower===n._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=D;function _(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=_;function P(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=P,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[143],be([0,1,9,25]),function(ne,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function b(c,l){return c.uuid&&l.uuid?c.uuid===l.uuid:c.id===l.id?!0:(0,h.compareIgnoreCase)(c.id,l.id)===0}e.areSameExtensions=b;class T{constructor(l,w){this.version=w,this.id=l.id,this.uuid=l.uuid}key(){return`${this.id}-${this.version}`}equals(l){return l instanceof T?b(this,l)&&this.version===l.version:!1}}e.ExtensionIdentifierWithVersion=T;function F(c,l){return`${c}.${l}`}e.getExtensionId=F;function D(c){return c.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function _(c,l){return D(F(c,l))}e.getGalleryExtensionId=_;function P(c,l){const w=[],I=y=>{for(const s of w)if(s.some(g=>b(l(g),l(y))))return s;return null};for(const y of c){const s=I(y);s?s.push(y):w.push([y])}return w}e.groupByExtension=P;function t(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function E(c){return{id:c.identifier.id,name:c.name,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),...c.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function n(c){const l=new Set;for(const w of c)w.malicious&&l.add(w.id.id);return l}e.getMaliciousExtensionsSet=n;function d(c,l){const w=[],I=l.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const y=I.shift();if(y&&w.every(s=>!b(s.identifier,{id:y}))){const s=c.filter(g=>b(g.identifier,{id:y}));s.length===1&&(w.push(s[0]),I.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.getExtensionDependencies=d}),define(we[60],be([0,1,20,17,9,10,2,121,4]),function(ne,e,h,M,b,T,F,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function P(W){return W.create===!0}e.isFileOpenForWriteOptions=P;var t;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var E;(function(W){W[W.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var n;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=d;function c(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=c;function l(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function w(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=w;var I;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(I=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class y extends Error{constructor(Q,$){super(Q);this.code=$}}e.FileSystemProviderError=y;function s(W,Q){const $=new y(W.toString(),Q);return k($,Q),$}e.createFileSystemProviderError=s;function g(W){return W||s((0,D.localize)(0,null),I.Unknown)}e.ensureFileSystemProviderError=g;function k(W,Q){return W.name=Q?`${Q} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=k;function i(W){if(!W)return I.Unknown;if(W instanceof y)return W.code;const Q=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!Q)return I.Unknown;switch(Q[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileExceedsMemoryLimit:return I.FileExceedsMemoryLimit;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}e.toFileSystemProviderErrorCode=i;function a(W){if(W instanceof C)return W.fileOperationResult;switch(i(W)){case I.FileNotFound:return 1;case I.FileIsADirectory:return 0;case I.FileNotADirectory:return 10;case I.FileWriteLocked:return 5;case I.NoPermissions:return 6;case I.FileExists:return 4;case I.FileExceedsMemoryLimit:return 9;case I.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var r;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class o{constructor(Q,$,U){this.resource=Q,this.operation=$,this.target=U}isOperation(Q){return this.operation===Q}}e.FileOperationEvent=o;var f;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(f=e.FileChangeType||(e.FileChangeType={}));class m{constructor(Q,$){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const U of Q)switch(U.type){case 1:this.added||(this.added=h.TernarySearchTree.forUris(()=>$)),this.added.set(U.resource,U);break;case 0:this.updated||(this.updated=h.TernarySearchTree.forUris(()=>$)),this.updated.set(U.resource,U);break;case 2:this.deleted||(this.deleted=h.TernarySearchTree.forUris(()=>$)),this.deleted.set(U.resource,U);break}}contains(Q,...$){return this.doContains(Q,{includeChildren:!1},...$)}affects(Q,...$){return this.doContains(Q,{includeChildren:!0},...$)}doContains(Q,$,...U){if(!Q)return!1;const z=U.length>0;return!!((!z||U.includes(1))&&(this.added?.get(Q)||$.includeChildren&&this.added?.findSuperstr(Q))||(!z||U.includes(0))&&(this.updated?.get(Q)||$.includeChildren&&this.updated?.findSuperstr(Q))||(!z||U.includes(2))&&(this.deleted?.findSubstr(Q)||$.includeChildren&&this.deleted?.findSuperstr(Q)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=m;function v(W,Q,$){return!W||!Q||W===Q||Q.length>W.length?!1:(Q.charAt(Q.length-1)!==M.sep&&(Q+=M.sep),$?(0,b.startsWithIgnoreCase)(W,Q):W.indexOf(Q)===0)}e.isParent=v;class C extends Error{constructor(Q,$,U){super(Q);this.fileOperationResult=$,this.options=U}}e.FileOperationError=C;class R extends C{constructor(Q,$,U){super(Q,2,U);this.stat=$}}e.NotModifiedSinceFileOperationError=R;var p;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(p=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var S;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(S=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function u(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=u;async function A(W,Q){if(!Q.canHandleResource(F.URI.from({scheme:W.scheme})))return new Promise($=>{const U=Q.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===W.scheme&&z.added&&(U.dispose(),$())})})}e.whenProviderRegistered=A,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(Q){return(0,T.isNumber)(Q)||(Q=0),Q<L.KB?(0,D.localize)(1,null,Q.toFixed(0)):Q<L.MB?(0,D.localize)(2,null,(Q/L.KB).toFixed(2)):Q<L.GB?(0,D.localize)(3,null,(Q/L.MB).toFixed(2)):Q<L.TB?(0,D.localize)(4,null,(Q/L.GB).toFixed(2)):(0,D.localize)(5,null,(Q/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var V;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function K(W){return{maxFileSize:W===0?300*L.MB:16*L.GB,maxHeapSize:W===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=K}),define(we[61],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class h{constructor(...b){this._entries=new Map;for(let[T,F]of b)this.set(T,F)}set(b,T){const F=this._entries.get(b);return this._entries.set(b,T),F}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}e.ServiceCollection=h}),define(we[144],be([0,1,14,16,81,139,4,61]),function(ne,e,h,M,b,T,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class P extends Error{constructor(c){super("cyclic dependency between services");this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class t{constructor(c=new D.ServiceCollection,l=!1,w){this._activeInstantiations=new Set,this._services=c,this._strict=l,this._parent=w,this._services.set(F.IInstantiationService,this)}createChild(c){return new t(c,this._strict,this)}invokeFunction(c,...l){let w=n.traceInvocation(c),I=!1;try{return c({get:(s,g)=>{if(I)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const k=this._getOrCreateServiceInstance(s,w);if(!k&&g!==F.optional)throw new Error(`[invokeFunction] unknown service '${s}'`);return k}},...l)}finally{I=!0,w.stop()}}createInstance(c,...l){let w,I;return c instanceof b.SyncDescriptor?(w=n.traceCreation(c.ctor),I=this._createInstance(c.ctor,c.staticArguments.concat(l),w)):(w=n.traceCreation(c),I=this._createInstance(c,l,w)),w.stop(),I}_createInstance(c,l=[],w){let I=F._util.getServiceDependencies(c).sort((g,k)=>g.index-k.index),y=[];for(const g of I){let k=this._getOrCreateServiceInstance(g.id,w);if(!k&&this._strict&&!g.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${g.id}.`);y.push(k)}let s=I.length>0?I[0].index:l.length;if(l.length!==s){console.warn(`[createInstance] First service dependency of ${c.name} at position ${s+1} conflicts with ${l.length} static arguments`);let g=s-l.length;g>0?l=l.concat(new Array(g)):l=l.slice(0,s)}return new c(...[...l,...y])}_setServiceInstance(c,l){if(this._services.get(c)instanceof b.SyncDescriptor)this._services.set(c,l);else if(this._parent)this._parent._setServiceInstance(c,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let l=this._services.get(c);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):l}_getOrCreateServiceInstance(c,l){let w=this._getServiceInstanceOrDescriptor(c);return w instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,w,l.branch(c,!0)):(l.branch(c,!1),w)}_safeCreateAndCacheServiceInstance(c,l,w){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,l,w)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,l,w){const I=new T.Graph(g=>g.id.toString());let y=0;const s=[{id:c,desc:l,_trace:w}];for(;s.length;){const g=s.pop();if(I.lookupOrInsertNode(g),y++>1e3)throw new P(I);for(let k of F._util.getServiceDependencies(g.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(k.id);if(!i&&!k.optional&&console.warn(`[createInstance] ${c} depends on ${k.id} which is NOT registered.`),i instanceof b.SyncDescriptor){const a={id:k.id,desc:i,_trace:g._trace.branch(k.id,!0)};I.insertEdge(g,a),s.push(a)}}}for(;;){const g=I.roots();if(g.length===0){if(!I.isEmpty())throw new P(I);break}for(const{data:k}of g){if(this._getServiceInstanceOrDescriptor(k.id)instanceof b.SyncDescriptor){const a=this._createServiceInstanceWithOwner(k.id,k.desc.ctor,k.desc.staticArguments,k.desc.supportsDelayedInstantiation,k._trace);this._setServiceInstance(k.id,a)}I.removeNode(k)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,l,w=[],I,y){if(this._services.get(c)instanceof b.SyncDescriptor)return this._createServiceInstance(l,w,I,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,l,w,I,y);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(c,l=[],w,I){if(w){const y=new h.IdleValue(()=>this._createInstance(c,l,I));return new Proxy(Object.create(null),{get(s,g){if(g in s)return s[g];let k=y.value,i=k[g];return typeof i!="function"||(i=i.bind(k),s[g]=i),i},set(s,g,k){return y.value[g]=k,!0}})}else return this._createInstance(c,l,I)}}e.InstantiationService=t;var E;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(E||(E={}));class n{constructor(c,l){this.type=c,this.name=l,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return _?new n(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(c){return _?new n(0,c.name):n._None}branch(c,l){let w=new n(2,c.toString());return this._dep.push([c,l,w]),w}stop(){let c=Date.now()-this._start;n._totals+=c;let l=!1;function w(y,s){let g=[],k=new Array(y+1).join("	");for(const[i,a,r]of s._dep)if(a&&r){l=!0,g.push(`${k}CREATES -> ${i}`);let o=w(y+1,r);o&&g.push(o)}else g.push(`${k}uses -> ${i}`);return g.join(`
`)}let I=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(c>2||l)&&console.log(I.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(we[15],be([0,1,56,3,6,26,4]),function(ne,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,F.createDecorator)("logService"),e.ILoggerService=(0,F.createDecorator)("loggerService");function D(){return new Date().toISOString()}var _;(function(k){k[k.Trace=0]="Trace",k[k.Debug=1]="Debug",k[k.Info=2]="Info",k[k.Warning=3]="Warning",k[k.Error=4]="Error",k[k.Critical=5]="Critical",k[k.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;class P extends b.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class t extends P{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...a){this.checkLogLevel(_.Trace)&&this.log(_.Trace,this.format([i,...a]))}debug(i,...a){this.checkLogLevel(_.Debug)&&this.log(_.Debug,this.format([i,...a]))}info(i,...a){this.checkLogLevel(_.Info)&&this.log(_.Info,this.format([i,...a]))}warn(i,...a){this.checkLogLevel(_.Warning)&&this.log(_.Warning,this.format([i,...a]))}error(i,...a){if(this.checkLogLevel(_.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(_.Error,this.format(r))}else this.log(_.Error,this.format([i,...a]))}critical(i,...a){this.checkLogLevel(_.Critical)&&this.log(_.Critical,this.format([i,...a]))}flush(){}format(i){let a="";for(let r=0;r<i.length;r++){let o=i[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch(f){}a+=(r>0?" ":"")+o}return a}}e.AbstractMessageLogger=t;class E extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!T.isWindows}trace(i,...a){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,i,...a):console.log(`[main ${D()}]`,i,...a))}debug(i,...a){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,i,...a):console.log(`[main ${D()}]`,i,...a))}info(i,...a){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,i,...a):console.log(`[main ${D()}]`,i,...a))}warn(i,...a){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,i,...a):console.warn(`[main ${D()}]`,i,...a))}error(i,...a){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,i,...a):console.error(`[main ${D()}]`,i,...a))}critical(i,...a){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,i,...a):console.error(`[main ${D()}]`,i,...a))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class n extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...a){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",i,...a)}debug(i,...a){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...a)}info(i,...a){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",i,...a)}warn(i,...a){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",i,...a)}error(i,...a){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",i,...a)}critical(i,...a){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...a)}dispose(){}flush(){}}e.ConsoleLogger=n;class d extends P{constructor(i,a=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(a)}trace(i,...a){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(i),...a])}debug(i,...a){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(i),...a])}info(i,...a){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(i),...a])}warn(i,...a){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(i),...a])}error(i,...a){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(i),...a])}critical(i,...a){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(i),...a])}extractMessage(i){return typeof i=="string"?i:(0,h.toErrorMessage)(i,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class c extends P{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const a of this.logServices)a.setLevel(i);super.setLevel(i)}trace(i,...a){for(const r of this.logServices)r.trace(i,...a)}debug(i,...a){for(const r of this.logServices)r.debug(i,...a)}info(i,...a){for(const r of this.logServices)r.info(i,...a)}warn(i,...a){for(const r of this.logServices)r.warn(i,...a)}error(i,...a){for(const r of this.logServices)r.error(i,...a)}critical(i,...a){for(const r of this.logServices)r.critical(i,...a)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=c;class l extends b.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...a){this.logger.trace(i,...a)}debug(i,...a){this.logger.debug(i,...a)}info(i,...a){this.logger.info(i,...a)}warn(i,...a){this.logger.warn(i,...a)}error(i,...a){this.logger.error(i,...a)}critical(i,...a){this.logger.critical(i,...a)}flush(){this.logger.flush()}}e.LogService=l;class w extends b.Disposable{constructor(i,a){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(a(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,a){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,a?.always?_.Trace:this.logLevel,a),this.loggers.set(i.toString(),r),a?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class I{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(i){}getLevel(){return _.Info}trace(i,...a){}debug(i,...a){}info(i,...a){}warn(i,...a){}error(i,...a){}critical(i,...a){}dispose(){}flush(){}}e.NullLogService=I;function y(k){if(k.verbose)return _.Trace;if(typeof k.logLevel=="string"){const i=s(k.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=y;function s(k){switch(k){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=s;function g(k){switch(k){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=g}),define(we[82],be([0,1,35,122,4]),function(ne,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var F;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(F=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function P(c,l){return l-c}_.compare=P;const t=Object.create(null);t[_.Error]=(0,M.localize)(0,null),t[_.Warning]=(0,M.localize)(1,null),t[_.Info]=(0,M.localize)(2,null);function E(c){return t[c]||""}_.toString=E;function n(c){switch(c){case h.default.Error:return _.Error;case h.default.Warning:return _.Warning;case h.default.Info:return _.Info;case h.default.Ignore:return _.Hint}}_.fromSeverity=n;function d(c){switch(c){case _.Error:return h.default.Error;case _.Warning:return h.default.Warning;case _.Info:return h.default.Info;case _.Hint:return h.default.Ignore}}_.toSeverity=d}(F=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(_){const P="";function t(n){return E(n,!0)}_.makeKey=t;function E(n,d){let c=[P];return n.source?c.push(n.source.replace("\xA6","\\\xA6")):c.push(P),n.code?typeof n.code=="string"?c.push(n.code.replace("\xA6","\\\xA6")):c.push(n.code.value.replace("\xA6","\\\xA6")):c.push(P),n.severity!==void 0&&n.severity!==null?c.push(F.toString(n.severity)):c.push(P),n.message&&d?c.push(n.message.replace("\xA6","\\\xA6")):c.push(P),n.startLineNumber!==void 0&&n.startLineNumber!==null?c.push(n.startLineNumber.toString()):c.push(P),n.startColumn!==void 0&&n.startColumn!==null?c.push(n.startColumn.toString()):c.push(P),n.endLineNumber!==void 0&&n.endLineNumber!==null?c.push(n.endLineNumber.toString()):c.push(P),n.endColumn!==void 0&&n.endColumn!==null?c.push(n.endColumn.toString()):c.push(P),c.push(P),c.join("\xA6")}_.makeKeyOptionalMessage=E})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(we[145],be([0,1,3,35,4]),function(ne,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=M.default,e.INotificationService=(0,b.createDecorator)("notificationService");var T;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var F;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(F=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new _,this.onDidClose=h.Event.None,this.onDidChangeVisibility=h.Event.None}updateSeverity(t){}updateMessage(t){}updateActions(t){}close(){}}e.NoOpNotification=D;class _{infinite(){}done(){}total(t){}worked(t){}}e.NoOpProgress=_}),define(we[146],be([0,1,6,9,2,4]),function(ne,e,h,M,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return h.Disposable.None},registerValidator(){return h.Disposable.None},registerExternalUriResolver(){return h.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return h.Disposable.None},async open(){return!1},async resolveExternalUri(D){return{resolved:D,dispose(){}}}});function F(D,_){return b.URI.isUri(D)?(0,M.equalsIgnoreCase)(D.scheme,_):(0,M.startsWithIgnoreCase)(D,_+":")}e.matchesScheme=F});var Ue=this&&this.__decorate||function(ne,e,h,M){var b=arguments.length,T=b<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,h):M,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(ne,e,h,M);else for(var D=ne.length-1;D>=0;D--)(F=ne[D])&&(T=(b<3?F(T):b>3?F(e,h,T):F(e,h))||T);return b>3&&T&&Object.defineProperty(e,h,T),T},He=this&&this.__param||function(ne,e){return function(h,M){e(h,M,ne)}};define(we[147],be([0,1,14,21,6,4]),function(ne,e,h,M,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,T.createDecorator)("progressService");var F;(function(t){t[t.Explorer=1]="Explorer",t[t.Scm=3]="Scm",t[t.Extensions=5]="Extensions",t[t.Window=10]="Window",t[t.Notification=15]="Notification",t[t.Dialog=20]="Dialog"})(F=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(E){this.callback=E}get value(){return this._value}report(E){this._value=E,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let _=class extends b.Disposable{constructor(E,n){super();this.deferred=new h.DeferredPromise,n.withProgress(E,d=>(this.reporter=d,this.lastStep&&d.report(this.lastStep),this.deferred.p)),this._register((0,b.toDisposable)(()=>this.deferred.complete()))}report(E){this.reporter?this.reporter.report(E):this.lastStep=E}};_=Ue([He(1,e.IProgressService)],_),e.UnmanagedProgress=_;class P extends b.Disposable{constructor(E){super();this.progressIndicator=E,this.currentOperationId=0,this.currentOperationDisposables=this._register(new b.DisposableStore)}start(E){this.stop();const n=++this.currentOperationId,d=new M.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},E),this.currentOperationDisposables.add((0,b.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,b.toDisposable)(()=>d.cancel())),this.currentOperationDisposables.add((0,b.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:d.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(E){this.currentOperationId===E&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,T.createDecorator)("editorProgressService")}),define(we[28],be([0,1,40,10]),function(ne,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class b{constructor(){this.data=new Map}add(F,D){h.ok(M.isString(F)),h.ok(M.isObject(D)),h.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,D)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}e.Registry=new b}),define(we[83],be([0,1,3,28]),function(ne,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function b(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class T{constructor(){this._onDidChangeSchema=new h.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,P){this.schemasById[b(_)]=P,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new T;M.Registry.add(e.Extensions.JSONContribution,F)}),define(we[62],be([0,1,3,10,119,83,28]),function(ne,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(I){I.Multiline="multilineText",I.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var _;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(_=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const P=F.Registry.as(T.Extensions.JSONContribution);class t{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new h.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new h.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:b.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(y,s=!0){this.registerConfigurations([y],s)}registerConfigurations(y,s=!0){const g=[];y.forEach(k=>{g.push(...this.validateAndRegisterProperties(k,s,k.extensionInfo)),this.configurationContributors.push(k),this.registerJSONConfiguration(k)}),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(g)}deregisterConfigurations(y){const s=[],g=k=>{if(k.properties)for(const i in k.properties)s.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,k.properties[i]);k.allOf&&k.allOf.forEach(i=>g(i))};for(const k of y){g(k);const i=this.configurationContributors.indexOf(k);i!==-1&&this.configurationContributors.splice(i,1)}P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}registerDefaultConfigurations(y){const s=[],g=[];for(const k of y)for(const i in k)if(s.push(i),e.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...k[i]};const a={type:"object",default:this.defaultValues[i],description:b.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};g.push(n(i)),this.configurationProperties[i]=a,this.defaultLanguageConfigurationOverridesNode.properties[i]=a}else{this.defaultValues[i]=k[i];const a=this.configurationProperties[i];a&&(this.updatePropertyDefaultValue(i,a),this.updateSchema(i,a))}this.registerOverrideIdentifiers(g),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterDefaultConfigurations(y){const s=[];for(const g of y)for(const k in g)if(s.push(k),delete this.defaultValues[k],e.OVERRIDE_PROPERTY_PATTERN.test(k))delete this.configurationProperties[k],delete this.defaultLanguageConfigurationOverridesNode.properties[k];else{const i=this.configurationProperties[k];i&&(this.updatePropertyDefaultValue(k,i),this.updateSchema(k,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}notifyConfigurationSchemaUpdated(...y){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(y){for(const s of y)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(y,s=!0,g,k=3){k=M.isUndefinedOrNull(y.scope)?k:y.scope;let i=[],a=y.properties;if(a)for(let o in a){if(s&&l(o)){delete a[o];continue}const f=a[o];if(this.updatePropertyDefaultValue(o,f),e.OVERRIDE_PROPERTY_PATTERN.test(o)?f.scope=void 0:(f.scope=M.isUndefinedOrNull(f.scope)?k:f.scope,f.restricted=M.isUndefinedOrNull(f.restricted)?!!g?.restrictedConfigurations?.includes(o):f.restricted),a[o].hasOwnProperty("included")&&!a[o].included){this.excludedConfigurationProperties[o]=a[o],delete a[o];continue}else this.configurationProperties[o]=a[o];!a[o].deprecationMessage&&a[o].markdownDeprecationMessage&&(a[o].deprecationMessage=a[o].markdownDeprecationMessage),i.push(o)}let r=y.allOf;if(r)for(let o of r)i.push(...this.validateAndRegisterProperties(o,s,g,k));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(y){const s=g=>{let k=g.properties;if(k)for(const a in k)this.updateSchema(a,k[a]);let i=g.allOf;i&&i.forEach(s)};s(y)}updateSchema(y,s){switch(e.allSettings.properties[y]=s,s.scope){case 1:e.applicationSettings.properties[y]=s;break;case 2:e.machineSettings.properties[y]=s;break;case 6:e.machineOverridableSettings.properties[y]=s;break;case 3:e.windowSettings.properties[y]=s;break;case 4:e.resourceSettings.properties[y]=s;break;case 5:e.resourceSettings.properties[y]=s,this.resourceLanguageSettingsSchema.properties[y]=s;break}}removeFromSchema(y,s){switch(delete e.allSettings.properties[y],s.scope){case 1:delete e.applicationSettings.properties[y];break;case 2:delete e.machineSettings.properties[y];break;case 6:delete e.machineOverridableSettings.properties[y];break;case 3:delete e.windowSettings.properties[y];break;case 4:case 5:delete e.resourceSettings.properties[y];break}}updateOverridePropertyPatternKey(){for(const y of this.overrideIdentifiers.values()){const s=`[${y}]`,g={type:"object",description:b.localize(2,null),errorMessage:b.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,g),e.allSettings.properties[s]=g,e.applicationSettings.properties[s]=g,e.machineSettings.properties[s]=g,e.machineOverridableSettings.properties[s]=g,e.windowSettings.properties[s]=g,e.resourceSettings.properties[s]=g}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(y,s){let g=this.defaultValues[y];M.isUndefined(g)&&(g=s.default),M.isUndefined(g)&&(g=d(s.type)),s.default=g}}const E="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(E);function n(I){return I.substring(1,I.length-1)}e.overrideIdentifierFromKey=n;function d(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const c=new t;F.Registry.add(e.Extensions.Configuration,c);function l(I){return I.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(I)?b.localize(5,null,I):c.getConfigurationProperties()[I]!==void 0?b.localize(6,null,I):null:b.localize(4,null)}e.validateProperty=l;function w(){const I=[],y=c.getConfigurationProperties();for(const s of Object.keys(y))I.push([s,y[s].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.getScopes=w}),define(we[84],be([0,1,22,10,2,62,4,28]),function(ne,e,h,M,b,T,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,F.createDecorator)("configurationService");function _(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof b.URI)}e.isConfigurationOverrides=_;var P;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function E(a,r){const o=r?a?r.keys.filter(S=>a.keys.indexOf(S)===-1):[...r.keys]:[],f=a?r?a.keys.filter(S=>r.keys.indexOf(S)===-1):[...a.keys]:[],m=[];if(r&&a){for(const S of a.keys)if(r.keys.indexOf(S)!==-1){const u=I(a.contents,S),A=I(r.contents,S);h.equals(u,A)||m.push(S)}}const v=[],C=S=>{const u={};for(const A of S)for(const L of A.identifiers)u[k(L)]=A;return u},R=r?C(r.overrides):{},p=a?C(a.overrides):{};if(Object.keys(R).length)for(const S of o){const u=R[S];u&&v.push([(0,T.overrideIdentifierFromKey)(S),u.keys])}if(Object.keys(p).length)for(const S of f){const u=p[S];u&&v.push([(0,T.overrideIdentifierFromKey)(S),u.keys])}if(Object.keys(R).length&&Object.keys(p).length)for(const S of m){const u=p[S],A=R[S];if(u&&A){const L=E({contents:u.contents,keys:u.keys,overrides:[]},{contents:A.contents,keys:A.keys,overrides:[]});v.push([(0,T.overrideIdentifierFromKey)(S),[...L.added,...L.removed,...L.updated]])}}return{added:o,removed:f,updated:m,overrides:v}}e.compare=E;function n(a,r){const o=[];for(const f of Object.keys(a))if(T.OVERRIDE_PROPERTY_PATTERN.test(f)){const m={};for(const v in a[f])m[v]=a[f][v];o.push({identifiers:[(0,T.overrideIdentifierFromKey)(f).trim()],keys:Object.keys(m),contents:d(m,r)})}return o}e.toOverrides=n;function d(a,r){const o=Object.create(null);for(let f in a)c(o,f,a[f],r);return o}e.toValuesTree=d;function c(a,r,o,f){const m=r.split("."),v=m.pop();let C=a;for(let R=0;R<m.length;R++){let p=m[R],S=C[p];switch(typeof S){case"undefined":S=C[p]=Object.create(null);break;case"object":break;default:f(`Ignoring ${r} as ${m.slice(0,R+1).join(".")} is ${JSON.stringify(S)}`);return}C=S}if(typeof C=="object"&&C!==null)try{C[v]=o}catch(R){f(`Ignoring ${r} as ${m.join(".")} is ${JSON.stringify(C)}`)}else f(`Ignoring ${r} as ${m.join(".")} is ${JSON.stringify(C)}`)}e.addToValueTree=c;function l(a,r){const o=r.split(".");w(a,o)}e.removeFromValueTree=l;function w(a,r){const o=r.shift();if(r.length===0){delete a[o];return}if(Object.keys(a).indexOf(o)!==-1){const f=a[o];typeof f=="object"&&!Array.isArray(f)&&(w(f,r),Object.keys(f).length===0&&delete a[o])}}function I(a,r,o){function f(C,R){let p=C;for(const S of R){if(typeof p!="object"||p===null)return;p=p[S]}return p}const m=r.split("."),v=f(a,m);return typeof v=="undefined"?o:v}e.getConfigurationValue=I;function y(a,r,o){Object.keys(r).forEach(f=>{f!=="__proto__"&&(f in a?M.isObject(a[f])&&M.isObject(r[f])?y(a[f],r[f],o):o&&(a[f]=r[f]):a[f]=r[f])})}e.merge=y;function s(){const a=D.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(a)}e.getConfigurationKeys=s;function g(){const a=Object.create(null),r=D.Registry.as(T.Extensions.Configuration).getConfigurationProperties();for(let o in r){let f=r[o].default;c(a,o,f,m=>console.error(`Conflict in default settings: ${m}`))}return a}e.getDefaultValues=g;function k(a){return`[${a}]`}e.keyFromOverrideIdentifier=k;function i(a,r,o){const f=a.inspect(r),m=a.inspect(o);return typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:f.defaultValue}e.getMigratedSettingValue=i}),define(we[148],be([0,1,13,3,102,6,20,22,10,2,84,62,28]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class d{constructor(i={},a=[],r=[]){this._contents=i,this._keys=a,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,a){const r=this.getContentsForOverrideIdentifer(a);return r?i?(0,t.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){for(const a of this.overrides)if(a.identifiers.indexOf(i)!==-1)return a.keys;return[]}override(i){const a=this.getContentsForOverrideIdentifer(i);if(!a||typeof a!="object"||!Object.keys(a).length)return this;let r={};for(const o of h.distinct([...Object.keys(this.contents),...Object.keys(a)])){let f=this.contents[o],m=a[o];m&&(typeof f=="object"&&typeof m=="object"?(f=D.deepClone(f),this.mergeContents(f,m)):f=m),r[o]=f}return new d(r,this.keys,this.overrides)}merge(...i){const a=D.deepClone(this.contents),r=D.deepClone(this.overrides),o=[...this.keys];for(const f of i){this.mergeContents(a,f.contents);for(const m of f.overrides){const[v]=r.filter(C=>h.equals(C.identifiers,m.identifiers));v?this.mergeContents(v.contents,m.contents):r.push(D.deepClone(m))}for(const m of f.keys)o.indexOf(m)===-1&&o.push(m)}return new d(a,o,r)}freeze(){return this.isFrozen=!0,this}mergeContents(i,a){for(const r of Object.keys(a)){if(r in i&&_.isObject(i[r])&&_.isObject(a[r])){this.mergeContents(i[r],a[r]);continue}i[r]=D.deepClone(a[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?D.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const a of this.overrides)if(a.identifiers.indexOf(i)!==-1)return a.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,a){this.addKey(i),(0,t.addToValueTree)(this.contents,i,a,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let a=this.keys.length;for(let r=0;r<a;r++)i.indexOf(this.keys[r])===0&&(a=r);this.keys.splice(a,1,i)}removeKey(i){let a=this.keys.indexOf(i);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=d;class c extends d{constructor(){const i=(0,t.getDefaultValues)(),a=(0,t.getConfigurationKeys)(),r=[];for(const o of Object.keys(i))E.OVERRIDE_PROPERTY_PATTERN.test(o)&&r.push({identifiers:[(0,E.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(i[o]),contents:(0,t.toValuesTree)(i[o],f=>console.error(`Conflict in default settings file: ${f}`))});super(i,a,r)}}e.DefaultConfigurationModel=c;class l{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,a){if(!_.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,a)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,a){this._raw=i;const{contents:r,keys:o,overrides:f,restricted:m}=this.doParseRaw(i,a);this._configurationModel=new d(r,o,f),this._restrictedConfigurations=m||[]}doParseContent(i){let a={},r=null,o=[],f=[],m=[];function v(R){Array.isArray(o)?o.push(R):r!==null&&(o[r]=R)}let C={onObjectBegin:()=>{let R={};v(R),f.push(o),o=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{o=f.pop()},onArrayBegin:()=>{let R=[];v(R),f.push(o),o=R,r=null},onArrayEnd:()=>{o=f.pop()},onLiteralValue:v,onError:(R,p,S)=>{m.push({error:R,offset:p,length:S})}};if(i)try{b.visit(i,C),a=o[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return a}doParseRaw(i,a){const r=n.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=this.filter(i,r,!0,a);i=o.raw;const f=(0,t.toValuesTree)(i,C=>console.error(`Conflict in settings file ${this._name}: ${C}`)),m=Object.keys(i),v=(0,t.toOverrides)(i,C=>console.error(`Conflict in settings file ${this._name}: ${C}`));return{contents:f,keys:m,overrides:v,restricted:o.restricted}}filter(i,a,r,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[]};const f={},m=[];for(let v in i)if(E.OVERRIDE_PROPERTY_PATTERN.test(v)&&r){const C=this.filter(i[v],a,!1,o);f[v]=C.raw,m.push(...C.restricted)}else{const C=a[v],R=C?typeof C.scope!="undefined"?C.scope:3:void 0;C?.restricted&&m.push(v),(R===void 0||o.scopes===void 0||o.scopes.includes(R))&&(o.skipRestricted&&C?.restricted||(f[v]=i[v]))}return{raw:f,restricted:m}}}e.ConfigurationModelParser=l;class w extends T.Disposable{constructor(i,a,r,o){super();this.userSettingsResource=i,this.scopes=a,this.fileService=o,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new l(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,f=>f.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new d}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class I{constructor(i,a,r=new d,o=new d,f=new F.ResourceMap,m=new d,v=new F.ResourceMap,C=!0){this._defaultConfiguration=i,this._localUserConfiguration=a,this._remoteUserConfiguration=r,this._workspaceConfiguration=o,this._folderConfigurations=f,this._memoryConfiguration=m,this._memoryConfigurationByResource=v,this._freeze=C,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new F.ResourceMap,this._userConfiguration=null}getValue(i,a,r){return this.getConsolidateConfigurationModel(a,r).getValue(i)}updateValue(i,a,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new d,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,a===void 0?o.removeValue(i):o.setValue(i,a),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,a,r){const o=this.getConsolidateConfigurationModel(a,r),f=this.getFolderConfigurationModelForResource(a.resource,r),m=a.resource?this._memoryConfigurationByResource.get(a.resource)||this._memoryConfiguration:this._memoryConfiguration,v=a.overrideIdentifier?this._defaultConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),C=a.overrideIdentifier?this.userConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),R=a.overrideIdentifier?this.localUserConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),p=a.overrideIdentifier?this.remoteUserConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),S=r?a.overrideIdentifier?this._workspaceConfiguration.freeze().override(a.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,u=f?a.overrideIdentifier?f.freeze().override(a.overrideIdentifier).getValue(i):f.freeze().getValue(i):void 0,A=a.overrideIdentifier?m.override(a.overrideIdentifier).getValue(i):m.getValue(i),L=o.getValue(i),V=h.distinct(h.flatten(o.overrides.map(K=>K.identifiers))).filter(K=>o.getOverrideValue(i,K)!==void 0);return{defaultValue:v,userValue:C,userLocalValue:R,userRemoteValue:p,workspaceValue:S,workspaceFolderValue:u,memoryValue:A,value:L,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,user:C!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,userRemote:p!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,workspace:S!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:a.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,workspaceFolder:u!==void 0?{value:f?.freeze().getValue(i),override:a.overrideIdentifier?f?.freeze().getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,memory:A!==void 0?{value:m.getValue(i),override:a.overrideIdentifier?m.getOverrideValue(i,a.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(i){const a=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,a){this._folderConfigurations.set(i,a),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,a){const r=a.filter(o=>E.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const f=(0,E.overrideIdentifierFromKey)(o),m=this._defaultConfiguration.getKeysForOverrideIdentifier(f),v=i.getKeysForOverrideIdentifier(f),C=[...v.filter(R=>m.indexOf(R)===-1),...m.filter(R=>v.indexOf(R)===-1),...m.filter(R=>!D.equals(this._defaultConfiguration.override(f).getValue(R),i.override(f).getValue(R)))];return[f,C]});return this.updateDefaultConfiguration(i),{keys:a,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:a,updated:r,removed:o,overrides:f}=(0,t.compare)(this.localUserConfiguration,i),m=[...a,...r,...o];return m.length&&this.updateLocalUserConfiguration(i),{keys:m,overrides:f}}compareAndUpdateRemoteUserConfiguration(i){const{added:a,updated:r,removed:o,overrides:f}=(0,t.compare)(this.remoteUserConfiguration,i);let m=[...a,...r,...o];return m.length&&this.updateRemoteUserConfiguration(i),{keys:m,overrides:f}}compareAndUpdateWorkspaceConfiguration(i){const{added:a,updated:r,removed:o,overrides:f}=(0,t.compare)(this.workspaceConfiguration,i);let m=[...a,...r,...o];return m.length&&this.updateWorkspaceConfiguration(i),{keys:m,overrides:f}}compareAndUpdateFolderConfiguration(i,a){const r=this.folderConfigurations.get(i),{added:o,updated:f,removed:m,overrides:v}=(0,t.compare)(r,a);let C=[...o,...f,...m];return(C.length||!r)&&this.updateFolderConfiguration(i,a),{keys:C,overrides:v}}compareAndDeleteFolderConfiguration(i){const a=this.folderConfigurations.get(i);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:o,removed:f,overrides:m}=(0,t.compare)(a,void 0);return{keys:[...r,...o,...f],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,a){let r=this.getConsolidatedConfigurationModelForResource(i,a);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},a){let r=this.getWorkspaceConsolidatedConfiguration();if(a&&i){const o=a.getFolder(i);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const f=this._memoryConfigurationByResource.get(i);f&&(r=r.merge(f))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let a=this._foldersConsolidatedConfigurations.get(i);if(!a){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(i);o?(a=r.merge(o),this._freeze&&(a=a.freeze()),this._foldersConsolidatedConfigurations.set(i,a)):a=r}return a}getFolderConfigurationModelForResource(i,a){if(a&&i){const r=a.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,a)=>{const{contents:r,overrides:o,keys:f}=this._folderConfigurations.get(a);return i.push([a,{contents:r,overrides:o,keys:f}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(a=>i.add(a)),this.userConfiguration.freeze().keys.forEach(a=>i.add(a)),this._workspaceConfiguration.freeze().keys.forEach(a=>i.add(a)),this._folderConfigurations.forEach(a=>a.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const a=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>a.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>a.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>a.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(o=>a.add(o))),[...a.values()]}static parse(i){const a=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),o=this.parseConfigurationModel(i.workspace),f=i.folders.reduce((m,v)=>(m.set(P.URI.revive(v[0]),this.parseConfigurationModel(v[1])),m),new F.ResourceMap);return new I(a,r,new d,o,f,new d,new F.ResourceMap,!1)}static parseConfigurationModel(i){return new d(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=I;function y(...k){if(k.length===0)return{keys:[],overrides:[]};if(k.length===1)return k[0];const i=new Set,a=new Map;for(const o of k)o.keys.forEach(f=>i.add(f)),o.overrides.forEach(([f,m])=>{const v=(0,F.getOrSet)(a,f,new Set);m.forEach(C=>v.add(C))});const r=[];return a.forEach((o,f)=>r.push([f,[...o.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=y;class s{constructor(i,a,r,o){this.change=i,this.previous=a,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const f=new Set;i.keys.forEach(v=>f.add(v)),i.overrides.forEach(([,v])=>v.forEach(C=>f.add(C))),this.affectedKeys=[...f.values()];const m=new d;this.affectedKeys.forEach(v=>m.setValue(v,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=I.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,a){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(a){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,a,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(i,a,this.currentWorkspace);return!D.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(i,a){let r=(0,t.toValuesTree)({[a]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(i=i[o],!i)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=s;class g extends s{constructor(i,a,r,o){super({keys:i.allKeys(),overrides:[]},void 0,i,a);this.source=r,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=g}),define(we[85],be([0,1,4]),function(ne,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,h.createDecorator)("remoteAuthorityResolverService");var M;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class b extends Error{constructor(F,D=M.Unknown,_){super(F);this._message=F,this._code=D,this._detail=_,this.isHandled=D===M.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype)}static isTemporarilyNotAvailable(F){return F instanceof b&&F._code===M.TemporarilyNotAvailable}static isNoResolverFound(F){return F instanceof b&&F._code===M.NoResolverFound}static isHandled(F){return F instanceof b&&F.isHandled}}e.RemoteAuthorityResolverError=b}),define(we[86],be([0,1,11]),function(ne,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(P){return P.scheme===h.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=M;function b(P){if(!P)return;const t=P.indexOf("+");return t<0?P:P.substr(0,t)}e.getRemoteName=b;function T(P){return P.scheme!==h.Schemas.file&&P.scheme!==h.Schemas.vscodeRemote}e.isVirtualResource=T;function F(P){if(P.folders.length)return P.folders.every(t=>T(t.uri))?P.folders[0].uri:void 0;if(P.configuration&&T(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=F;function D(P){return F(P)?.scheme}e.getVirtualWorkspaceScheme=D;function _(P){return F(P)!==void 0}e.isVirtualWorkspace=_}),define(we[149],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class h{constructor(b){this._callback=b,this._terminalBufferMap=new Map}dispose(){for(const b of this._terminalBufferMap.values())b.dispose()}startBuffering(b,T,F=5){let D;return D=T(_=>{const P=typeof _=="string"?_:_.data;let t=this._terminalBufferMap.get(b);if(t){t.data.push(P);return}const E=setTimeout(()=>this.flushBuffer(b),F);t={data:[P],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(b),D.dispose()}},this._terminalBufferMap.set(b,t)}),D}stopBuffering(b){const T=this._terminalBufferMap.get(b);T&&T.dispose()}flushBuffer(b){const T=this._terminalBufferMap.get(b);T&&(this._terminalBufferMap.delete(b),this._callback(b,T.data.join("")))}}e.TerminalDataBufferer=h}),define(we[150],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var h;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(h=e.ColorScheme||(e.ColorScheme={}))}),define(we[44],be([0,1,34,3,6,4,28,150]),function(ne,e,h,M,b,T,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var _;(function(w){function I(y){return y&&typeof y=="object"&&typeof y.id=="string"}w.isThemeColor=I})(_=e.ThemeColor||(e.ThemeColor={}));function P(w){return{id:w}}e.themeColorFromId=P;var t;(function(w){function I(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color=="undefined"||_.isThemeColor(a.color))}w.isThemeIcon=I;const y=new RegExp(`^\\$\\((${h.CSSIcon.iconNameExpression}(?:${h.CSSIcon.iconModifierExpression})?)\\)$`);function s(a){const r=y.exec(a);if(!r)return;let[,o]=r;return{id:o}}w.fromString=s;function g(a,r){let o=a.id;const f=o.lastIndexOf("~");return f!==-1&&(o=o.substring(0,f)),r&&(o=`${o}~${r}`),{id:o}}w.modify=g;function k(a,r){return a.id===r.id&&a.color?.id===r.color?.id}w.isEqual=k;function i(a,r){return{id:a.id,color:r?P(r):void 0}}w.asThemeIcon=i,w.asClassNameArray=h.CSSIcon.asClassNameArray,w.asClassName=h.CSSIcon.asClassName,w.asCSSSelector=h.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=h.Codicon.file,e.FolderThemeIcon=h.Codicon.folder;function E(w){switch(w){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new M.Emitter}onColorThemeChange(I){return this.themingParticipants.push(I),this.onThemingParticipantAddedEmitter.fire(I),(0,b.toDisposable)(()=>{const y=this.themingParticipants.indexOf(I);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let d=new n;F.Registry.add(e.Extensions.ThemingContribution,d);function c(w){return d.onColorThemeChange(w)}e.registerThemingParticipant=c;class l extends b.Disposable{constructor(I){super();this.themeService=I,this.theme=I.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(I){this.theme=I,this.updateStyles()}updateStyles(){}getColor(I,y){let s=this.theme.getColor(I);return s&&y&&(s=y(s,this.theme)),s?s.toString():null}}e.Themable=l}),define(we[151],be([0,1,14,34,3,123,83,28,44]),function(ne,e,h,M,b,T,F,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class P{constructor(){this._onDidChange=new b.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${M.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(I,y,s,g){const k=this.iconsById[I];if(k){if(s&&!k.description){k.description=s,this.iconSchema.properties[I].markdownDescription=`${s} $(${I})`;const r=this.iconReferenceSchema.enum.indexOf(I);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=s),this._onDidChange.fire()}return k}let i={id:I,description:s,defaults:y,deprecationMessage:g};this.iconsById[I]=i;let a={$ref:"#/definitions/icons"};return g&&(a.deprecationMessage=g),s&&(a.markdownDescription=`${s}: $(${I})`),this.iconSchema.properties[I]=a,this.iconReferenceSchema.enum.push(I),this.iconReferenceSchema.enumDescriptions.push(s||""),this._onDidChange.fire(),{id:I}}deregisterIcon(I){delete this.iconsById[I],delete this.iconSchema.properties[I];const y=this.iconReferenceSchema.enum.indexOf(I);y!==-1&&(this.iconReferenceSchema.enum.splice(y,1),this.iconReferenceSchema.enumDescriptions.splice(y,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(I=>this.iconsById[I])}getIcon(I){return this.iconsById[I]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(I,y){const s=this.iconFontsById[I];if(s)return s;let g={id:I,definition:y};return this.iconFontsById[I]=g,this._onDidChange.fire(),g}deregisterIconFont(I){delete this.iconFontsById[I]}getIconFonts(){return Object.keys(this.iconFontsById).map(I=>this.iconFontsById[I])}getIconFont(I){return this.iconFontsById[I]}toString(){const I=(k,i)=>k.id.localeCompare(i.id),y=k=>{for(;_.ThemeIcon.isThemeIcon(k.defaults);)k=this.iconsById[k.defaults.id];return`codicon codicon-${k?k.id:""}`};let s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const g=Object.keys(this.iconsById).map(k=>this.iconsById[k]);for(const k of g.filter(i=>!!i.description).sort(I))s.push(`|<i class="${y(k)}"></i>|${k.id}|${_.ThemeIcon.isThemeIcon(k.defaults)?k.defaults.id:k.id}|${k.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const k of g.filter(i=>!_.ThemeIcon.isThemeIcon(i.defaults)).sort(I))s.push(`|<i class="${y(k)}"></i>|${k.id}|`);return s.join(`
`)}}const t=new P;D.Registry.add(e.Extensions.IconContribution,t);function E(w,I,y,s){return t.registerIcon(w,I,y,s)}e.registerIcon=E;function n(){return t}e.getIconRegistry=n;function d(){for(const w of M.iconRegistry.all)t.registerIcon(w.id,w.definition,w.description);M.iconRegistry.onDidRegister(w=>t.registerIcon(w.id,w.definition,w.description))}d(),e.iconsSchemaId="vscode://schemas/icons";let c=D.Registry.as(F.Extensions.JSONContribution);c.registerSchema(e.iconsSchemaId,t.getIconSchema());const l=new h.RunOnceScheduler(()=>c.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{l.isScheduled()||l.schedule()}),e.widgetClose=E("widget-close",M.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=E("goto-previous-location",M.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=E("goto-next-location",M.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=_.ThemeIcon.modify(M.Codicon.sync,"spin")}),define(we[45],be([0,1,20,24,2,4]),function(ne,e,h,M,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var F;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(F=e.WorkbenchState||(e.WorkbenchState={}));function D(n){const d=n;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}e.isWorkspace=D;function _(n){const d=n;return!!(d&&typeof d=="object"&&b.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}e.isWorkspaceFolder=_;class P{constructor(d,c,l,w){this._id=d,this._configuration=l,this._ignorePathCasing=w,this._foldersMap=h.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(d){this._id=d.id,this._configuration=d.configuration,this._ignorePathCasing=d._ignorePathCasing,this.folders=d.folders}get folders(){return this._folders}set folders(d){this._folders=d,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(d){this._configuration=d}getFolder(d){return d&&this._foldersMap.findSubstr(d.with({scheme:d.scheme,authority:d.authority,path:d.path}))||null}updateFoldersMap(){this._foldersMap=h.TernarySearchTree.forUris(this._ignorePathCasing);for(const d of this.folders)this._foldersMap.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=P;class t{constructor(d,c){this.raw=c,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,M.joinPath)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function E(n){return new t({uri:n,index:0,name:(0,M.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=E}),define(we[63],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class h{constructor(b){this.id=b,this._data=new Map,this._idPool=1}add(b){const T=this._idPool++;return this._data.set(T,b),this.logDebugInfo(),T}get(b,T){return this._data.has(b)?this._data.get(b)[T]:void 0}delete(b){this._data.delete(b),this.logDebugInfo()}logDebugInfo(){!h.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=h,h.enableDebugLogging=!1}),define(we[37],be([0,1,11,24,4]),function(ne,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(h.Schemas)),this._providerInfo=new Map,this.extUri=new M.ExtUri(D=>{const _=this._providerInfo.get(D.scheme);return!(_===void 0||_&1024)})}$acceptProviderInfos(D,_){_===null?this._providerInfo.delete(D):this._providerInfo.set(D,_)}isFreeScheme(D){return!this._providerInfo.has(D)&&!this._systemSchemes.has(D)}getCapabilities(D){return this._providerInfo.get(D)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,b.createDecorator)("IExtHostFileSystemInfo")}),define(we[29],be([0,1,4]),function(ne,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,h.createDecorator)("IExtHostInitDataService")}),define(we[152],be([0,1,14]),function(ne,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class M{constructor(F,D,_){this._deferredPromises=new Map,this._id=F,this._shared=D,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new h.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const t of P.values())t.complete()}catch(t){for(const E of P.values())E.error(t)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,F])=>F!==void 0).map(([F])=>F)}get whenReady(){return this._init}get(F,D){let _=this._value[F];return typeof _=="undefined"&&(_=D),_}update(F,D){this._value[F]=D;let _=this._deferredPromises.get(F);if(_!==void 0)return _.p;const P=new h.DeferredPromise;return this._deferredPromises.set(F,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=M;class b extends M{constructor(F,D){super(F.identifier.value,!0,D);this._extension=F}setKeysForSync(F){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},F)}}e.ExtensionGlobalMemento=b}),define(we[153],be([0,1,3,2,15]),function(ne,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let T=class{constructor(D,_){this._logService=D,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new h.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new h.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(D,_,P){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(D)).acceptModelChanged(_.value,P)}$acceptDirtyStateChanged(D,_){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(D)).acceptDirty(_)}$acceptModelSaved(D){const _=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(D));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(D,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",D.path,_);const P=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(D));P.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};T=Ue([He(0,b.ILogService)],T),e.ExtHostNotebookDocuments=T}),define(we[12],be([0,1,4]),function(ne,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,h.createDecorator)("IExtHostRpcService");class M{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=M});var Xe=this&&this.__classPrivateFieldSet||function(ne,e,h,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ne,h):b?b.value=h:e.set(ne,h),h},Ae=this&&this.__classPrivateFieldGet||function(ne,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[154],be([0,1,25,3]),function(ne,e,h,M){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(D,_){b.set(this,void 0),this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._id=h.ExtensionIdentifier.toKey(D.identifier),Xe(this,b,_,"f"),Ae(this,b,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(D){return Ae(this,b,"f").get(this._id,D)}store(D,_){return Ae(this,b,"f").store(this._id,D,_)}delete(D){return Ae(this,b,"f").delete(this._id,D)}}e.ExtensionSecrets=T,b=new WeakMap}),define(we[87],be([0,1,4,3]),function(ne,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class b{constructor(){this._onDidChangeTelemetryEnabled=new M.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(F){this._enabled=F}$onDidChangeTelemetryEnabled(F){this._enabled=F,this._onDidChangeTelemetryEnabled.fire(F)}}e.ExtHostTelemetry=b,e.IExtHostTelemetry=(0,h.createDecorator)("IExtHostTelemetry")}),define(we[46],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var h;(function(y){y[y.Upsert=0]="Upsert",y[y.RemoveChild=1]="RemoveChild",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp",y[y.Bulk=4]="Bulk"})(h=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const M=new WeakMap,b=(y,s)=>{const g={controllerId:s};return M.set(y,g),g};e.createPrivateApiFor=b;const T=y=>M.get(y);e.getPrivateApiFor=T;const F=(y,s,g,k)=>{let i=g;return{enumerable:!0,configurable:!1,get(){return i},set(a){if(!k(i,a)){const r=i;i=a,y.listener?.({op:3,key:s,value:a,previous:r})}}}},D=(y,s)=>y===s,_={range:(y,s)=>y===s?!0:!y||!s?!1:y.isEqual(s),label:D,description:D,busy:D,error:D,canResolveChildren:D,tags:(y,s)=>!(y.length!==s.length||y.some(g=>!s.find(k=>g.id===k.id)))},P=Object.keys(_),t=(y,s)=>({range:F(y,"range",void 0,_.range),label:F(y,"label",s,_.label),description:F(y,"description",void 0,_.description),canResolveChildren:F(y,"canResolveChildren",!1,_.canResolveChildren),busy:F(y,"busy",!1,_.busy),error:F(y,"error",void 0,_.error),tags:F(y,"tags",[],_.tags)}),E=(y,s)=>{const g=new Map;for(const k of P)_[k](y[k],s[k])||g.set(k,s[k]);return g};e.diffTestItems=E;class n extends Error{constructor(s){super(`Attempted to insert a duplicate test item ID ${s}`)}}e.DuplicateTestItemError=n;class d extends Error{constructor(s){super(`TestItem with ID "${s}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class c extends Error{constructor(s,g,k){super(`TestItem with ID "${s}" is from controller "${g}" and cannot be added as a child of an item from controller "${k}".`)}}e.MixedTestItemController=c;const l=y=>{const s=(0,e.getPrivateApiFor)(y);let g=new Map;return{get size(){return g.size},forEach(k,i){for(const a of g.values())k.call(i,a,this)},replace(k){const i=new Map,a=new Set(g.keys()),r={op:4,ops:[]};for(const o of k){if(!(o instanceof w))throw new d(o.id);const f=(0,e.getPrivateApiFor)(o).controllerId;if(f!==s.controllerId)throw new c(o.id,f,s.controllerId);if(i.has(o.id))throw new n(o.id);i.set(o.id,o),a.delete(o.id),r.ops.push({op:0,item:o})}for(const o of a.keys())r.ops.push({op:1,id:o});s.listener?.(r),g=i},add(k){if(!(k instanceof w))throw new d(k.id);g.set(k.id,k),s.listener?.({op:0,item:k})},delete(k){g.delete(k)&&s.listener?.({op:1,id:k})},get(k){return g.get(k)},toJSON(){return Array.from(g.values())},[Symbol.iterator](){return g.values()}}};class w{constructor(s,g,k,i){if(g.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(g)} symbol`);const a=(0,e.createPrivateApiFor)(this,s);Object.defineProperties(this,{id:{value:g,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof I?void 0:a.parent}},children:{value:l(this),enumerable:!0,writable:!1},...t(a,k)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=w;class I extends w{constructor(s,g){super(s,s,g,void 0)}}e.TestItemRootImpl=I}),define(we[64],be([0,1,4,3,12]),function(ne,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(D){function _(t){return{remoteAddress:t.remoteAddress,localAddress:t.localAddress,public:!!t.public,protocol:t.protocol}}D.fromApiTunnel=_;function P(t){return{remoteAddress:{host:t.tunnelRemoteHost,port:t.tunnelRemotePort},localAddress:t.localAddress,public:t.public,protocol:t.protocol}}D.fromServiceTunnel=P})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,h.createDecorator)("IExtHostTunnelService");let F=class{constructor(_){this.onDidChangeTunnels=new M.Emitter().event}async $applyCandidateFilter(_){return _}async openTunnel(_,P){}async getTunnels(){return[]}async setTunnelExtensionFunctions(_){return{dispose:()=>{}}}registerPortsAttributesProvider(_,P){return{dispose:()=>{}}}async $providePortAttributes(_,P,t,E,n){return[]}async $forwardPort(_,P){}async $closeTunnel(_){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};F=Ue([He(0,b.IExtHostRpcService)],F),e.ExtHostTunnelService=F});var Xe=this&&this.__classPrivateFieldSet||function(ne,e,h,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ne,h):b?b.value=h:e.set(ne,h),h},Ae=this&&this.__classPrivateFieldGet||function(ne,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[7],be([0,1,13,16,76,20,78,10,2,36,60,85]),function(ne,e,h,M,b,T,F,D,_,P,t,E){"use strict";var n,d,c,l,w,I,y,s,g,k,i,a,r,o,f,m,v,C,R,p;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function S(N){function O(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(O,N),Object.setPrototypeOf(O.prototype,N.prototype),O}let u=w=class{constructor(O){n.set(this,void 0),Xe(this,n,O,"f")}static from(...O){let te=O;return new w(function(){if(te){for(const Ee of te)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();te=void 0}})}dispose(){typeof Ae(this,n,"f")=="function"&&(Ae(this,n,"f").call(this),Xe(this,n,void 0,"f"))}};n=new WeakMap,u=w=Ue([S],u),e.Disposable=u;let A=I=class{constructor(O,te){if(O<0)throw(0,M.illegalArgument)("line must be non-negative");if(te<0)throw(0,M.illegalArgument)("character must be non-negative");this._line=O,this._character=te}static Min(...O){if(O.length===0)throw new TypeError;let te=O[0];for(let Ee=1;Ee<O.length;Ee++){const Ge=O[Ee];Ge.isBefore(te)&&(te=Ge)}return te}static Max(...O){if(O.length===0)throw new TypeError;let te=O[0];for(let Ee=1;Ee<O.length;Ee++){const Ge=O[Ee];Ge.isAfter(te)&&(te=Ge)}return te}static isPosition(O){if(!O)return!1;if(O instanceof I)return!0;let{line:te,character:Ee}=O;return typeof te=="number"&&typeof Ee=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,te=0){if(O===null||te===null)throw(0,M.illegalArgument)();let Ee;return typeof O=="undefined"?Ee=0:typeof O=="number"?Ee=O:(Ee=typeof O.lineDelta=="number"?O.lineDelta:0,te=typeof O.characterDelta=="number"?O.characterDelta:0),Ee===0&&te===0?this:new I(this.line+Ee,this.character+te)}with(O,te=this.character){if(O===null||te===null)throw(0,M.illegalArgument)();let Ee;return typeof O=="undefined"?Ee=this.line:typeof O=="number"?Ee=O:(Ee=typeof O.line=="number"?O.line:this.line,te=typeof O.character=="number"?O.character:this.character),Ee===this.line&&te===this.character?this:new I(Ee,te)}toJSON(){return{line:this.line,character:this.character}}};A=I=Ue([S],A),e.Position=A;let L=y=class{constructor(O,te,Ee,Ge){let et,st;if(typeof O=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ge=="number"?(et=new A(O,te),st=new A(Ee,Ge)):O instanceof A&&te instanceof A&&(et=O,st=te),!et||!st)throw new Error("Invalid arguments");et.isBefore(st)?(this._start=et,this._end=st):(this._start=st,this._end=et)}static isRange(O){return O instanceof y?!0:O?A.isPosition(O.start)&&A.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof y?this.contains(O._start)&&this.contains(O._end):O instanceof A?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const te=A.Max(O.start,this._start),Ee=A.Min(O.end,this._end);if(!te.isAfter(Ee))return new y(te,Ee)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const te=A.Min(O.start,this._start),Ee=A.Max(O.end,this.end);return new y(te,Ee)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,te=this.end){if(O===null||te===null)throw(0,M.illegalArgument)();let Ee;return O?A.isPosition(O)?Ee=O:(Ee=O.start||this.start,te=O.end||this.end):Ee=this.start,Ee.isEqual(this._start)&&te.isEqual(this.end)?this:new y(Ee,te)}toJSON(){return[this.start,this.end]}};L=y=Ue([S],L),e.Range=L;let V=s=class extends L{constructor(O,te,Ee,Ge){let et,st;if(typeof O=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ge=="number"?(et=new A(O,te),st=new A(Ee,Ge)):O instanceof A&&te instanceof A&&(et=O,st=te),!et||!st)throw new Error("Invalid arguments");super(et,st);this._anchor=et,this._active=st}static isSelection(O){return O instanceof s?!0:O?L.isRange(O)&&A.isPosition(O.anchor)&&A.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};V=s=Ue([S],V),e.Selection=V;class K{constructor(O,te,Ee){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,M.illegalArgument)("port");if(typeof Ee!="undefined"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z\-]+$/.test(Ee)))throw(0,M.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(te),this.connectionToken=Ee}}e.ResolvedAuthority=K;class W extends Error{constructor(O,te=E.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(O);this._message=O,this._code=te,this._detail=Ee,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,W.prototype)}static NotAvailable(O,te){return new W(O,E.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(O){return new W(O,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=W;var Q;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(Q=e.EndOfLine||(e.EndOfLine={}));var $;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})($=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let U=g=class{constructor(O,te){this._range=O,this._newText=te}static isTextEdit(O){return O instanceof g?!0:O?L.isRange(O)&&typeof O.newText=="string":!1}static replace(O,te){return new g(O,te)}static insert(O,te){return g.replace(new L(O,O),te)}static delete(O){return g.replace(O,"")}static setEndOfLine(O){const te=new g(new L(new A(0,0),new A(0,0)),"");return te.newEol=O,te}get range(){return this._range}set range(O){if(O&&!L.isRange(O))throw(0,M.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,M.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,M.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};U=g=Ue([S],U),e.TextEdit=U;var z;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(z=e.FileEditType||(e.FileEditType={}));let G=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,te,Ee,Ge){this._edits.push({_type:1,from:O,to:te,options:Ee,metadata:Ge})}createFile(O,te,Ee){this._edits.push({_type:1,from:void 0,to:O,options:te,metadata:Ee})}deleteFile(O,te,Ee){this._edits.push({_type:1,from:O,to:void 0,options:te,metadata:Ee})}replaceNotebookMetadata(O,te,Ee){this._edits.push({_type:3,metadata:Ee,uri:O,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(O,te,Ee,Ge,et){let st,ut,St=[],At;if(Vt.isNotebookRange(te)&&Mt.isNotebookCellDataArray(Ee)&&!Mt.isNotebookCellDataArray(Ge)?(st=te.start,ut=te.end,St=Ee,At=Ge):typeof te=="number"&&typeof Ee=="number"&&Mt.isNotebookCellDataArray(Ge)&&(st=te,ut=Ee,St=Ge,At=et),st===void 0||ut===void 0)throw new Error("Invalid arguments");(st!==ut||St.length>0)&&this._edits.push({_type:5,uri:O,index:st,count:ut-st,cells:St,metadata:At})}replaceNotebookCellMetadata(O,te,Ee,Ge){this._edits.push({_type:3,metadata:Ge,uri:O,edit:{editType:8,index:te,metadata:Ee}})}replace(O,te,Ee,Ge){this._edits.push({_type:2,uri:O,edit:new U(te,Ee),metadata:Ge})}insert(O,te,Ee,Ge){this.replace(O,new L(te,te),Ee,Ge)}delete(O,te,Ee){this.replace(O,te,"",Ee)}has(O){return this._edits.some(te=>te._type===2&&te.uri.toString()===O.toString())}set(O,te){if(te)for(const Ee of te)Ee&&this._edits.push({_type:2,uri:O,edit:Ee});else{for(let Ee=0;Ee<this._edits.length;Ee++){const Ge=this._edits[Ee];Ge._type===2&&Ge.uri.toString()===O.toString()&&(this._edits[Ee]=void 0)}(0,h.coalesceInPlace)(this._edits)}}get(O){const te=[];for(let Ee of this._edits)Ee._type===2&&Ee.uri.toString()===O.toString()&&te.push(Ee.edit);return te}entries(){const O=new T.ResourceMap;for(let te of this._edits)if(te._type===2){let Ee=O.get(te.uri);Ee||(Ee=[te.uri,[]],O.set(te.uri,Ee)),Ee[1].push(te.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};G=Ue([S],G),e.WorkspaceEdit=G;let ue=k=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof k?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=k._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,te=this._tabstop++){if(typeof O=="function"){const Ee=new k;Ee._tabstop=this._tabstop,O(Ee),this._tabstop=Ee._tabstop,O=Ee.value}else O=k._escape(O);return this.value+="${",this.value+=te,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,te=this._tabstop++){const Ee=O.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(O,te){if(typeof te=="function"){const Ee=new k;Ee._tabstop=this._tabstop,te(Ee),this._tabstop=Ee._tabstop,te=Ee.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,te&&(this.value+=":",this.value+=te),this.value+="}",this}};ue=k=Ue([S],ue),e.SnippetString=ue;var q;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(q=e.DiagnosticTag||(e.DiagnosticTag={}));var le;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(le=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let se=i=class{constructor(O,te){if(this.uri=O,te)if(te instanceof L)this.range=te;else if(te instanceof A)this.range=new L(te,te);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof i?!0:O?L.isRange(O.range)&&_.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};se=i=Ue([S],se),e.Location=se;let ve=class{constructor(O,te){this.location=O,this.message=te}static is(O){return O?typeof O.message=="string"&&O.location&&L.isRange(O.location.range)&&_.URI.isUri(O.location.uri):!1}static isEqual(O,te){return O===te?!0:!O||!te?!1:O.message===te.message&&O.location.range.isEqual(te.location.range)&&O.location.uri.toString()===te.location.uri.toString()}};ve=Ue([S],ve),e.DiagnosticRelatedInformation=ve;let Fe=class{constructor(O,te,Ee=le.Error){if(!L.isRange(O))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=O,this.message=te,this.severity=Ee}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,te){return O===te?!0:!O||!te?!1:O.message===te.message&&O.severity===te.severity&&O.code===te.code&&O.severity===te.severity&&O.source===te.source&&O.range.isEqual(te.range)&&(0,h.equals)(O.tags,te.tags)&&(0,h.equals)(O.relatedInformation,te.relatedInformation,ve.isEqual)}};Fe=Ue([S],Fe),e.Diagnostic=Fe;let Me=class{constructor(O,te){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=te}};Me=Ue([S],Me),e.Hover=Me;var Oe;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(Oe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ye=class{constructor(O,te=Oe.Text){this.range=O,this.kind=te}toJSON(){return{range:this.range,kind:Oe[this.kind]}}};Ye=Ue([S],Ye),e.DocumentHighlight=Ye;var ze;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(ze=e.SymbolKind||(e.SymbolKind={}));var je;(function(N){N[N.Deprecated=1]="Deprecated"})(je=e.SymbolTag||(e.SymbolTag={}));let x=a=class{constructor(O,te,Ee,Ge,et){this.name=O,this.kind=te,this.containerName=et,typeof Ee=="string"&&(this.containerName=Ee),Ge instanceof se?this.location=Ge:Ee instanceof L&&(this.location=new se(Ge,Ee)),a.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ze[this.kind],location:this.location,containerName:this.containerName}}};x=a=Ue([S],x),e.SymbolInformation=x;let Y=r=class{constructor(O,te,Ee,Ge,et){this.name=O,this.detail=te,this.kind=Ee,this.range=Ge,this.selectionRange=et,this.children=[],r.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(r.validate)}};Y=r=Ue([S],Y),e.DocumentSymbol=Y;var ee;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(ee=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(O,te){this.title=O,this.kind=te}};ae=Ue([S],ae),e.CodeAction=ae;let j=o=class{constructor(O){this.value=O}append(O){return new o(this.value?this.value+o.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+o.sep)}};j.sep=".",j=o=Ue([S],j),e.CodeActionKind=j,j.Empty=new j(""),j.QuickFix=j.Empty.append("quickfix"),j.Refactor=j.Empty.append("refactor"),j.RefactorExtract=j.Refactor.append("extract"),j.RefactorInline=j.Refactor.append("inline"),j.RefactorRewrite=j.Refactor.append("rewrite"),j.Source=j.Empty.append("source"),j.SourceOrganizeImports=j.Source.append("organizeImports"),j.SourceFixAll=j.Source.append("fixAll");let oe=class{constructor(O,te){if(this.range=O,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};oe=Ue([S],oe),e.SelectionRange=oe;class he{constructor(O,te,Ee,Ge,et,st){this.kind=O,this.name=te,this.detail=Ee,this.uri=Ge,this.range=et,this.selectionRange=st}}e.CallHierarchyItem=he;class Te{constructor(O,te){this.fromRanges=te,this.from=O}}e.CallHierarchyIncomingCall=Te;class Be{constructor(O,te){this.fromRanges=te,this.to=O}}e.CallHierarchyOutgoingCall=Be;var $e;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})($e=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Qe=class{constructor(O,te){this.range=O,this.command=te}get isResolved(){return!!this.command}};Qe=Ue([S],Qe),e.CodeLens=Qe;let _e=f=class{constructor(O,te=!1){d.set(this,void 0),Xe(this,d,new b.MarkdownString(O,{supportThemeIcons:te}),"f")}static isMarkdownString(O){return O instanceof f?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Ae(this,d,"f").value}set value(O){Ae(this,d,"f").value=O}get isTrusted(){return Ae(this,d,"f").isTrusted}set isTrusted(O){Ae(this,d,"f").isTrusted=O}get supportThemeIcons(){return Ae(this,d,"f").supportThemeIcons}set supportThemeIcons(O){Ae(this,d,"f").supportThemeIcons=O}get supportHtml(){return Ae(this,d,"f").supportHtml}set supportHtml(O){Ae(this,d,"f").supportHtml=O}appendText(O){return Ae(this,d,"f").appendText(O),this}appendMarkdown(O){return Ae(this,d,"f").appendMarkdown(O),this}appendCodeblock(O,te){return Ae(this,d,"f").appendCodeblock(te??"",O),this}};d=new WeakMap,_e=f=Ue([S],_e),e.MarkdownString=_e;let nt=class{constructor(O,te){this.label=O,this.documentation=te}};nt=Ue([S],nt),e.ParameterInformation=nt;let H=class{constructor(O,te){this.label=O,this.documentation=te,this.parameters=[]}};H=Ue([S],H),e.SignatureInformation=H;let J=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};J=Ue([S],J),e.SignatureHelp=J;var me;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(me=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ne;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(Ne=e.InlayHintKind||(e.InlayHintKind={}));let Ke=class{constructor(O,te,Ee){this.text=O,this.position=te,this.kind=Ee}};Ke=Ue([S],Ke),e.InlayHint=Ke;var ot;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ot=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var at;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(at=e.CompletionItemKind||(e.CompletionItemKind={}));var vt;(function(N){N[N.Deprecated=1]="Deprecated"})(vt=e.CompletionItemTag||(e.CompletionItemTag={}));let kt=class{constructor(O,te){this.label=O,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&at[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};kt=Ue([S],kt),e.CompletionItem=kt;let ht=class{constructor(O=[],te=!1){this.items=O,this.isIncomplete=te}};ht=Ue([S],ht),e.CompletionList=ht;let yt=class{constructor(O,te,Ee){this.text=O,this.range=te,this.command=Ee}};yt=Ue([S],yt),e.InlineSuggestion=yt;let It=class{constructor(O){this.items=O}};It=Ue([S],It),e.InlineSuggestions=It;var ft;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(ft=e.ViewColumn||(e.ViewColumn={}));var Je;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(Je=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Et;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(Et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ye;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(ye=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ce;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(Ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Z;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(Z=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ce;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(ce=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function O(te){switch(te){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=O}(Ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ge=class{constructor(O,te){if(te&&!_.URI.isUri(te))throw(0,M.illegalArgument)("target");if(!L.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.target=te}};ge=Ue([S],ge),e.DocumentLink=ge;let fe=class{constructor(O,te,Ee,Ge){this.red=O,this.green=te,this.blue=Ee,this.alpha=Ge}};fe=Ue([S],fe),e.Color=fe;let Ie=class{constructor(O,te){if(te&&!(te instanceof fe))throw(0,M.illegalArgument)("color");if(!L.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.color=te}};Ie=Ue([S],Ie),e.ColorInformation=Ie;let xe=class{constructor(O){if(!O||typeof O!="string")throw(0,M.illegalArgument)("label");this.label=O}};xe=Ue([S],xe),e.ColorPresentation=xe;var Le;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(Le=e.ColorFormat||(e.ColorFormat={}));var Ve;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(Ve=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Ze{constructor(O,te,Ee){if(this.startIndex=O,this.length=te,this.tooltip=Ee,typeof O!="number"||O<0)throw(0,M.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,M.illegalArgument)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,M.illegalArgument)("tooltip")}}e.TerminalLink=Ze;var ie;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(ie=e.TerminalLocation||(e.TerminalLocation={}));class pe{constructor(O){this.options=O,typeof O!="object"&&(0,M.illegalArgument)("options")}}e.TerminalProfile=pe;var re;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(re=e.TaskRevealKind||(e.TaskRevealKind={}));var B;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(B=e.TaskPanelKind||(e.TaskPanelKind={}));let De=m=class{constructor(O,te){if(this.label=te,typeof O!="string"||typeof te!="string")throw(0,M.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}get id(){return this._id}};De.Clean=new m("clean","Clean"),De.Build=new m("build","Build"),De.Rebuild=new m("rebuild","Rebuild"),De.Test=new m("test","Test"),De=m=Ue([S],De),e.TaskGroup=De;function Se(N){let O="";for(let te=0;te<N.length;te++)O+=N[te].replace(/,/g,",,")+",";return O}let qe=class{constructor(O,te,Ee){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._args=[],this._process=O,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=Ee):this._options=te)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let te of this._args)O.push(te);return Se(O)}};qe=Ue([S],qe),e.ProcessExecution=qe;let We=class{constructor(O,te,Ee){if(this._args=[],Array.isArray(te)){if(!O)throw(0,M.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O,this._args=te,this._options=Ee}else{if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O,this._options=te}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)O.push(typeof te=="string"?te:te.value);return Se(O)}};We=Ue([S],We),e.ShellExecution=We;var tt;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(tt=e.ShellQuoting||(e.ShellQuoting={}));var mt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(mt=e.TaskScope||(e.TaskScope={}));class wt{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=wt;let rt=v=class{constructor(O,te,Ee,Ge,et,st){this.__deprecated=!1,this._definition=this.definition=O;let ut;typeof te=="string"?(this._name=this.name=te,this._source=this.source=Ee,this.execution=Ge,ut=et,this.__deprecated=!0):te===mt.Global||te===mt.Workspace?(this.target=te,this._name=this.name=Ee,this._source=this.source=Ge,this.execution=et,ut=st):(this.target=te,this._name=this.name=Ee,this._source=this.source=Ge,this.execution=et,ut=st),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof qe?this._definition={type:v.ProcessType,id:this._execution.computeId()}:this._execution instanceof We?this._definition={type:v.ShellType,id:this._execution.computeId()}:this._execution instanceof wt?this._definition={type:v.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:v.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,M.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,M.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const te=this._definition.type;(v.EmptyType===te||v.ProcessType===te||v.ShellType===te||v.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};rt.ExtensionCallbackType="customExecution",rt.ProcessType="process",rt.ShellType="shell",rt.EmptyType="$empty",rt=v=Ue([S],rt),e.Task=rt;var ct;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(ct=e.ProgressLocation||(e.ProgressLocation={}));let lt=class{constructor(O,te=Tt.None){this.collapsibleState=te,_.URI.isUri(O)?this.resourceUri=O:this.label=O}};lt=Ue([S],lt),e.TreeItem=lt;var Tt;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(Tt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let _t=class{constructor(O,te){this.id=O,this.color=te}};_t=Ue([S],_t),e.ThemeIcon=_t,_t.File=new _t("file"),_t.Folder=new _t("folder");let Ut=class{constructor(O){this.id=O}};Ut=Ue([S],Ut),e.ThemeColor=Ut;var $t;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})($t=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor(O,te){if(typeof O!="string"&&(!O||!_.URI.isUri(O)&&!_.URI.isUri(O.uri)))throw(0,M.illegalArgument)("base");if(typeof te!="string")throw(0,M.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=_.URI.file(O),this.base=O):_.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=te}};Ct=Ue([S],Ct),e.RelativePattern=Ct;let Wt=class{constructor(O,te,Ee,Ge){this.enabled=typeof O=="boolean"?O:!0,typeof te=="string"&&(this.condition=te),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,P.generateUuid)()),this._id}};Wt=Ue([S],Wt),e.Breakpoint=Wt;let ei=class extends Wt{constructor(O,te,Ee,Ge,et){super(te,Ee,Ge,et);if(O===null)throw(0,M.illegalArgument)("location");this.location=O}};ei=Ue([S],ei),e.SourceBreakpoint=ei;let gt=class extends Wt{constructor(O,te,Ee,Ge,et){super(te,Ee,Ge,et);this.functionName=O}};gt=Ue([S],gt),e.FunctionBreakpoint=gt;let Qt=class extends Wt{constructor(O,te,Ee,Ge,et,st,ut){super(Ge,et,st,ut);if(!te)throw(0,M.illegalArgument)("dataId");this.label=O,this.dataId=te,this.canPersist=Ee}};Qt=Ue([S],Qt),e.DataBreakpoint=Qt;let jt=class{constructor(O,te,Ee){this.command=O,this.args=te||[],this.options=Ee}};jt=Ue([S],jt),e.DebugAdapterExecutable=jt;let ti=class{constructor(O,te){this.port=O,this.host=te}};ti=Ue([S],ti),e.DebugAdapterServer=ti;let ii=class{constructor(O){this.path=O}};ii=Ue([S],ii),e.DebugAdapterNamedPipeServer=ii;let Pt=class{constructor(O){this.implementation=O}};Pt=Ue([S],Pt),e.DebugAdapterInlineImplementation=Pt;let Yt=class{constructor(O,te){this.range=O,this.expression=te}};Yt=Ue([S],Yt),e.EvaluatableExpression=Yt;var wi;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(wi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Ht=class{constructor(O,te){this.range=O,this.text=te}};Ht=Ue([S],Ht),e.InlineValueText=Ht;let zt=class{constructor(O,te,Ee=!0){this.range=O,this.variableName=te,this.caseSensitiveLookup=Ee}};zt=Ue([S],zt),e.InlineValueVariableLookup=zt;let dt=class{constructor(O,te){this.range=O,this.expression=te}};dt=Ue([S],dt),e.InlineValueEvaluatableExpression=dt;let ni=class{constructor(O,te){this.frameId=O,this.stoppedLocation=te}};ni=Ue([S],ni),e.InlineValueContext=ni;var Ot;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Ot=e.FileChangeType||(e.FileChangeType={}));let Nt=C=class extends Error{constructor(O,te=t.FileSystemProviderErrorCode.Unknown,Ee){super(_.URI.isUri(O)?O.toString(!0):O);this.code=Ee?.name??"Unknown",(0,t.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}static FileExists(O){return new C(O,t.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(O){return new C(O,t.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(O){return new C(O,t.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(O){return new C(O,t.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(O){return new C(O,t.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(O){return new C(O,t.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}};Nt=C=Ue([S],Nt),e.FileSystemError=Nt;let Jt=class{constructor(O,te,Ee){this.start=O,this.end=te,this.kind=Ee}};Jt=Ue([S],Jt),e.FoldingRange=Jt;var bi;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(bi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hi;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(hi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ei;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(Ei=e.CommentMode||(e.CommentMode={}));class fi{constructor(O,te=[]){this.tokenTypes=O,this.tokenModifiers=te}}e.SemanticTokensLegend=fi;function ri(N){return typeof N=="undefined"||(0,D.isStringArray)(N)}class si{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let te=0,Ee=O.tokenTypes.length;te<Ee;te++)this._tokenTypeStrToInt.set(O.tokenTypes[te],te);for(let te=0,Ee=O.tokenModifiers.length;te<Ee;te++)this._tokenModifierStrToInt.set(O.tokenModifiers[te],te)}}push(O,te,Ee,Ge,et){if(typeof O=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ge=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(O,te,Ee,Ge,et);if(L.isRange(O)&&typeof te=="string"&&ri(Ee))return this._push(O,te,Ee);throw(0,M.illegalArgument)()}_push(O,te,Ee){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Ge=O.start.line,et=O.start.character,st=O.end.character-O.start.character,ut=this._tokenTypeStrToInt.get(te);let St=0;if(Ee)for(const At of Ee){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Ft=this._tokenModifierStrToInt.get(At);St|=1<<Ft>>>0}this._pushEncoded(Ge,et,st,ut,St)}_pushEncoded(O,te,Ee,Ge,et){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let At=0,Ft=0;for(let Lt=0;Lt<St;Lt++){let xt=this._data[5*Lt],ci=this._data[5*Lt+1];xt===0?(xt=At,ci+=Ft):xt+=At,this._data[5*Lt]=xt,this._data[5*Lt+1]=ci,At=xt,Ft=ci}}let st=O,ut=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=Ee,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=et,this._prevLine=O,this._prevChar=te}static _sortAndDeltaEncode(O){let te=[];const Ee=O.length/5|0;for(let ut=0;ut<Ee;ut++)te[ut]=ut;te.sort((ut,St)=>{const At=O[5*ut],Ft=O[5*St];if(At===Ft){const Lt=O[5*ut+1],xt=O[5*St+1];return Lt-xt}return At-Ft});const Ge=new Uint32Array(O.length);let et=0,st=0;for(let ut=0;ut<Ee;ut++){const St=5*te[ut],At=O[St+0],Ft=O[St+1],Lt=O[St+2],xt=O[St+3],ci=O[St+4],xi=At-et,qi=xi===0?Ft-st:Ft,di=5*ut;Ge[di+0]=xi,Ge[di+1]=qi,Ge[di+2]=Lt,Ge[di+3]=xt,Ge[di+4]=ci,et=At,st=Ft}return Ge}build(O){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),O):new qt(si._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=si;class qt{constructor(O,te){this.resultId=te,this.data=O}}e.SemanticTokens=qt;class oi{constructor(O,te,Ee){this.start=O,this.deleteCount=te,this.data=Ee}}e.SemanticTokensEdit=oi;class _i{constructor(O,te){this.resultId=te,this.edits=O}}e.SemanticTokensEdits=_i;var yi;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(yi=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Gt;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(Gt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Xt=class{constructor(){}};Xt.Back={iconPath:new _t("arrow-left")},Xt=Ue([S],Xt),e.QuickInputButtons=Xt;var Si;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Si=e.ExtensionKind||(e.ExtensionKind={}));class Di{constructor(O,te,Ee){this.badge=O,this.tooltip=te,this.color=Ee}static validate(O){if(O.badge&&O.badge.length!==1&&O.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Di;let ai=class{constructor(O){this.kind=O}};ai=Ue([S],ai),e.ColorTheme=ai;var li;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(li=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{constructor(O,te){if(O<0)throw(0,M.illegalArgument)("start must be positive");if(te<0)throw(0,M.illegalArgument)("end must be positive");O<=te?(this._start=O,this._end=te):(this._start=te,this._end=O)}static isNotebookRange(O){return O instanceof Vt?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let te=this._start,Ee=this._end;return O.start!==void 0&&(te=O.start),O.end!==void 0&&(Ee=O.end),te===this._start&&Ee===this._end?this:new Vt(te,Ee)}}e.NotebookRange=Vt;class Mt{constructor(O,te,Ee,Ge,et,st,ut){this.kind=O,this.value=te,this.languageId=Ee,this.mime=Ge,this.outputs=et??[],this.metadata=st,this.executionSummary=ut,Mt.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(te=>Mt.isNotebookCellData(te))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Mt;class Re{constructor(O){this.cells=O}}e.NotebookData=Re;class Rt{constructor(O,te){this.data=O,this.mime=te;const Ee=(0,F.normalizeMimeType)(te,!0);if(!Ee)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}static isNotebookCellOutputItem(O){return O instanceof Rt?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const te={name:O.name,message:O.message,stack:O.stack};return Rt.json(te,"application/vnd.code.notebook.error")}static stdout(O){return Rt.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return Rt.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,te="application/octet-stream"){return new Rt(O,te)}static text(O,te=F.Mimes.text){const Ee=Ae(Rt,c,"f",l).encode(String(O));return new Rt(Ee,te)}static json(O,te="application/json"){const Ee=JSON.stringify(O,void 0,"	");return Rt.text(Ee,te)}}e.NotebookCellOutputItem=Rt,c=Rt,l={value:new TextEncoder};class Kt{constructor(O,te,Ee){this.items=Kt.ensureUniqueMimeTypes(O,!0),typeof te=="string"?(this.id=te,this.metadata=Ee):(this.id=(0,P.generateUuid)(),this.metadata=te??Ee)}static isNotebookCellOutput(O){return O instanceof Kt?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,D.isArray)(O.items)}static ensureUniqueMimeTypes(O,te=!1){const Ee=new Set,Ge=new Set;for(let et=0;et<O.length;et++){const st=O[et],ut=(0,F.normalizeMimeType)(st.mime);if(!Ee.has(ut)){Ee.add(ut);continue}Ge.add(et),te&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return Ge.size===0?O:O.filter((et,st)=>!Ge.has(st))}}e.NotebookCellOutput=Kt;var pt;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(pt=e.NotebookCellKind||(e.NotebookCellKind={}));var Ci;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(Ci=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ki;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(ki=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var mi;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(mi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gi{constructor(O,te){this.text=O,this.alignment=te}}e.NotebookCellStatusBarItem=gi;var Ii;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Ii=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pi{constructor(O,te=[]){this.uri=O,this.provides=(0,h.asArray)(te)}}e.NotebookRendererScript=Pi;let ui=class{constructor(O,te){this.label=O,this.timestamp=te}};ui=Ue([S],ui),e.TimelineItem=ui;var Ti;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(Ti=e.ExtensionMode||(e.ExtensionMode={}));var pi;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(pi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ai;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(Ai=e.StandardTokenType||(e.StandardTokenType={}));class Ri{constructor(O,te){this.ranges=O,this.wordPattern=te}}e.LinkedEditingRanges=Ri;class Fi{constructor(O,te){this._port=O,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fi;var Mi;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Mi=e.TestResultState||(e.TestResultState={}));var Li;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Li=e.TestRunProfileKind||(e.TestRunProfileKind={}));let X=class{constructor(O,te,Ee){this.include=O,this.exclude=te,this.profile=Ee}};X=Ue([S],X),e.TestRunRequest=X;let de=R=class{constructor(O){this.message=O}static diff(O,te,Ee){const Ge=new R(O);return Ge.expectedOutput=te,Ge.actualOutput=Ee,Ge}};de=R=Ue([S],de),e.TestMessage=de;let ke=class{constructor(O){this.id=O}};ke=Ue([S],ke),e.TestTag=ke;let it=class{constructor(O,te){this.covered=O,this.total=te}};it=Ue([S],it),e.CoveredCount=it;let bt=p=class{constructor(O,te,Ee,Ge){this.uri=O,this.statementCoverage=te,this.branchCoverage=Ee,this.functionCoverage=Ge}static fromDetails(O,te){const Ee=new it(0,0),Ge=new it(0,0),et=new it(0,0);for(const ut of te)if("branches"in ut){Ee.total+=1,Ee.covered+=ut.executionCount>0?1:0;for(const St of ut.branches)Ge.total+=1,Ge.covered+=St.executionCount>0?1:0}else et.total+=1,et.covered+=ut.executionCount>0?1:0;const st=new p(O,Ee,Ge.total>0?Ge:void 0,et.total>0?et:void 0);return st.detailedCoverage=te,st}};bt=p=Ue([S],bt),e.FileCoverage=bt;let Dt=class{constructor(O,te,Ee=[]){this.executionCount=O,this.location=te,this.branches=Ee}};Dt=Ue([S],Dt),e.StatementCoverage=Dt;let Oi=class{constructor(O,te){this.executionCount=O,this.location=te}};Oi=Ue([S],Oi),e.BranchCoverage=Oi;let Ni=class{constructor(O,te){this.executionCount=O,this.location=te}};Ni=Ue([S],Ni),e.FunctionCoverage=Ni;var Hi;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zi;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(zi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vi;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ji{constructor(O,te,Ee,Ge,et,st){this.kind=O,this.name=te,this.detail=Ee,this.uri=Ge,this.range=et,this.selectionRange=st}}e.TypeHierarchyItem=ji}),define(we[88],be([0,1,40,11,9,227,118,7,13]),function(ne,e,h,M,b,T,F,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function t(c,l){l?P.set(c,l):P.delete(c)}e.setWordDefinitionFor=t;function E(c){return P.get(c)}e.getWordDefinitionFor=E;class n extends T.MirrorTextModel{constructor(l,w,I,y,s,g,k,i){super(w,I,y,s);this._proxy=l,this._languageId=g,this._isDirty=k,this._notebook=i,this._isDisposed=!1}dispose(){(0,h.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(l){return(0,_.equals)(this._lines,l)}get document(){if(!this._document){const l=this;this._document={get uri(){return l._uri},get fileName(){return l._uri.fsPath},get isUntitled(){return l._uri.scheme===M.Schemas.untitled},get languageId(){return l._languageId},get version(){return l._versionId},get isClosed(){return l._isDisposed},get isDirty(){return l._isDirty},get notebook(){return l._notebook},save(){return l._save()},getText(w){return w?l._getTextInRange(w):l.getText()},get eol(){return l._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return l._lines.length},lineAt(w){return l._lineAt(w)},offsetAt(w){return l._offsetAt(w)},positionAt(w){return l._positionAt(w)},validateRange(w){return l._validateRange(w)},validatePosition(w){return l._validatePosition(w)},getWordRangeAtPosition(w,I){return l._getWordRangeAtPosition(w,I)}}}return Object.freeze(this._document)}_acceptLanguageId(l){(0,h.ok)(!this._isDisposed),this._languageId=l}_acceptIsDirty(l){(0,h.ok)(!this._isDisposed),this._isDirty=l}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(l){const w=this._validateRange(l);if(w.isEmpty)return"";if(w.isSingleLine)return this._lines[w.start.line].substring(w.start.character,w.end.character);const I=this._eol,y=w.start.line,s=w.end.line,g=[];g.push(this._lines[y].substring(w.start.character));for(let k=y+1;k<s;k++)g.push(this._lines[k]);return g.push(this._lines[s].substring(0,w.end.character)),g.join(I)}_lineAt(l){let w;if(l instanceof D.Position?w=l.line:typeof l=="number"&&(w=l),typeof w!="number"||w<0||w>=this._lines.length||Math.floor(w)!==w)throw new Error("Illegal value for `line`");return new d(w,this._lines[w],w===this._lines.length-1)}_offsetAt(l){return l=this._validatePosition(l),this._ensureLineStarts(),this._lineStarts.getPrefixSum(l.line-1)+l.character}_positionAt(l){l=Math.floor(l),l=Math.max(0,l),this._ensureLineStarts();const w=this._lineStarts.getIndexOf(l),I=this._lines[w.index].length;return new D.Position(w.index,Math.min(w.remainder,I))}_validateRange(l){if(!(l instanceof D.Range))throw new Error("Invalid argument");const w=this._validatePosition(l.start),I=this._validatePosition(l.end);return w===l.start&&I===l.end?l:new D.Range(w.line,w.character,I.line,I.character)}_validatePosition(l){if(!(l instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return l.with(0,0);let{line:w,character:I}=l,y=!1;if(w<0)w=0,I=0,y=!0;else if(w>=this._lines.length)w=this._lines.length-1,I=this._lines[w].length,y=!0;else{const s=this._lines[w].length;I<0?(I=0,y=!0):I>s&&(I=s,y=!0)}return y?new D.Position(w,I):l}_getWordRangeAtPosition(l,w){const I=this._validatePosition(l);if(!w)w=E(this._languageId);else if((0,b.regExpLeadsToEndlessLoop)(w))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${w.source}' because it matches the empty string.`);const y=(0,F.getWordAtText)(I.character+1,(0,F.ensureValidWordDefinition)(w),this._lines[I.line],0);if(y)return new D.Range(I.line,y.startColumn-1,I.line,y.endColumn-1)}}e.ExtHostDocumentData=n;class d{constructor(l,w,I){this._line=l,this._text=w,this._isLastLine=I}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=d}),define(we[155],be([0,1,7,3,228,6,55,20,2,36]),function(ne,e,h,M,b,T,F,D,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class t{constructor(n,d,c,l){this._notebook=c,this._selector=l,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(d.onDidChangeDocument(I=>{const y=this._cellUris.get(I.document.uri);y!==void 0&&(this._cellLengths.changeValue(y,this._cells[y].document.getText().length+1),this._cellLines.changeValue(y,this._cells[y].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const w=I=>{I===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(I=>w(I.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new D.ResourceMap;const n=[],d=[];for(const c of this._notebook.getCells())c.kind===h.NotebookCellKind.Code&&(!this._selector||(0,F.score)(this._selector,c.document.uri,c.document.languageId,!0))&&(this._cellUris.set(c.document.uri,this._cells.length),this._cells.push(c),n.push(c.document.getText().length+1),d.push(c.document.lineCount));this._cellLengths=new b.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new b.PrefixSumComputer(new Uint32Array(d))}get version(){return this._versionId}getText(n){if(!n){let y="";for(const s of this._cells)y+=s.document.getText()+`
`;return y=y.slice(0,-1),y}if(n.isEmpty)return"";const d=this.locationAt(n.start),c=this.locationAt(n.end),l=this._cellUris.get(d.uri),w=this._cellUris.get(c.uri);if(l===void 0||w===void 0)return"";if(l===w)return this._cells[l].document.getText(new h.Range(d.range.start,c.range.end));const I=[this._cells[l].document.getText(new h.Range(d.range.start,new h.Position(this._cells[l].document.lineCount,0)))];for(let y=l+1;y<w;y++)I.push(this._cells[y].document.getText());return I.push(this._cells[w].document.getText(new h.Range(new h.Position(0,0),c.range.end))),I.join(`
`)}offsetAt(n){const d=this._cellLines.getIndexOf(n.line),c=this._cellLengths.getPrefixSum(d.index-1),l=this._cells[d.index].document.offsetAt(n.with(d.remainder));return c+l}positionAt(n){if(typeof n=="number"){const c=this._cellLengths.getIndexOf(n),l=this._cellLines.getPrefixSum(c.index-1);return this._cells[c.index].document.positionAt(c.remainder).translate(l)}const d=this._cellUris.get(n.uri);if(d!==void 0){const c=this._cellLines.getPrefixSum(d-1);return new h.Position(c+n.range.start.line,n.range.start.character)}return new h.Position(0,0)}locationAt(n){h.Range.isRange(n)||(n=new h.Range(n,n));const d=this._cellLines.getIndexOf(n.start.line);let c=d;n.isEmpty||(c=this._cellLines.getIndexOf(n.end.line));const l=new h.Position(d.remainder,n.start.character),w=new h.Position(c.remainder,n.end.character),I=new h.Range(l,w),y=this._cells[d.index];return new h.Location(y.document.uri,y.document.validateRange(I))}contains(n){return this._cellUris.has(n)}validateRange(n){const d=this.validatePosition(n.start),c=this.validatePosition(n.end);return n.with(d,c)}validatePosition(n){const d=this._cellLines.getIndexOf(n.line),c=new h.Position(d.remainder,n.character),l=this._cells[d.index].document.validatePosition(c),w=this._cellLines.getPrefixSum(d.index-1);return new h.Position(w+l.line,l.character)}}e.ExtHostNotebookConcatDocument=t}),define(we[156],be([0,1,7,12,3]),function(ne,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(D){this._actual=new h.ColorTheme(h.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new b.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let _=D==="light"?h.ColorThemeKind.Light:D==="dark"?h.ColorThemeKind.Dark:h.ColorThemeKind.HighContrast;this._actual=new h.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=Ue([He(0,M.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(we[65],be([0,1,4]),function(ne,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,h.createDecorator)("IURITransformerService");class M{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=F=>F,this.transformOutgoing=F=>F,this.transformOutgoingURI=F=>F,this.transformOutgoingScheme=F=>F)}}e.URITransformerService=M}),define(we[157],be([0,1,23]),function(ne,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class M{constructor(){this.buffers=[]}add(_){let P=this.buffers.indexOf(_);return P<0&&(P=this.buffers.length,this.buffers.push(_)),P}}function b(D,_){if(_.serializeBuffersForPostMessage){const P=new M,t=(d,c)=>{if(c instanceof ArrayBuffer){const l=P.add(c);return{$$vscode_array_buffer_reference$$:!0,index:l}}else if(ArrayBuffer.isView(c)){const l=T(c);if(l){const w=P.add(c.buffer);return{$$vscode_array_buffer_reference$$:!0,index:w,view:{type:l,byteLength:c.byteLength,byteOffset:c.byteOffset}}}}return c},E=JSON.stringify(D,t),n=P.buffers.map(d=>{const c=new Uint8Array(d);return h.VSBuffer.wrap(c)});return{message:E,buffers:n}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=b;function T(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function F(D,_){const P=_.map(n=>{const d=new ArrayBuffer(n.byteLength);return new Uint8Array(d).set(n.buffer),d}),t=_.length?(n,d)=>{if(typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const c=d,{index:l}=c,w=P[l];if(c.view)switch(c.view.type){case 1:return new Int8Array(w,c.view.byteOffset,c.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(w,c.view.byteOffset,c.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(w,c.view.byteOffset,c.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(w,c.view.byteOffset,c.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(w,c.view.byteOffset,c.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(w,c.view.byteOffset,c.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(w,c.view.byteOffset,c.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(w,c.view.byteOffset,c.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(w,c.view.byteOffset,c.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(w,c.view.byteOffset,c.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(w,c.view.byteOffset,c.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return w}return d}:void 0;return{message:JSON.parse(D,t),arrayBuffers:P}}e.deserializeWebviewMessage=F}),define(we[158],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var h;(function(M){function b(F){const D={items:new Map};return F.types.forEach((_,P)=>{D.items.set(_,{asString:async()=>F.items[P].asString})}),D}M.toITreeDataTransfer=b;async function T(F){const D={types:[],items:[]},_=Array.from(F.items.entries());for(const P of _)D.types.push(P[0]),D.items.push({asString:await P[1].asString()});return D}M.toTreeDataTransferDTO=T})(h=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(we[66],be([0,1,11,2]),function(ne,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function b(D,_){return D.scheme===h.Schemas.http||D.scheme===h.Schemas.https?D:(_&&_.authority&&_.isRemote&&D.scheme===h.Schemas.file&&(D=M.URI.from({scheme:h.Schemas.vscodeRemote,authority:_.authority,path:D.path})),M.URI.from({scheme:h.Schemas.https,authority:`${D.scheme}+${T(D.authority)}.${e.webviewRootResourceAuthority}`,path:D.path,fragment:D.fragment,query:D.query}))}e.asWebviewUri=b;function T(D){return D.replace(/./g,_=>{const P=_.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?_:"-"+P.toString(16).padStart(4,"0")})}function F(D){return D.replace(/-([0-9a-f]{4})/g,(_,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=F}),define(we[159],be([0,1,3,6,66]),function(ne,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(D,_,P){this._proxy=D,this._editors=_,this._initData=P,this._handlePool=0,this._disposables=new M.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const t=_.getVisibleTextEditors();for(const E of this._insets.values())t.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,_,P,t,E){let n;for(const s of this._editors.getVisibleTextEditors(!0))if(s.value===D){n=s;break}if(!n)throw new Error("not a visible editor");const d=this,c=this._handlePool++,l=new h.Emitter,w=new h.Emitter,I=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(s){return(0,b.asWebviewUri)(s,d._initData.remote)}get cspSource(){return b.webviewGenericCspSource}set options(s){this._options=s,d._proxy.$setOptions(c,s)}get options(){return this._options}set html(s){this._html=s,d._proxy.$setHtml(c,s)}get html(){return this._html}get onDidReceiveMessage(){return l.event}postMessage(s){return d._proxy.$postMessage(c,s)}},y=new class{constructor(){this.editor=D,this.line=_,this.height=P,this.webview=I,this.onDidDispose=w.event}dispose(){d._insets.has(c)&&(d._insets.delete(c),d._proxy.$disposeEditorInset(c),w.fire(),w.dispose(),l.dispose())}};return this._proxy.$createEditorInset(c,n.id,n.value.document.uri,_+1,P,t||{},E.identifier,E.extensionLocation),this._insets.set(c,{editor:D,inset:y,onDidReceiveMessage:l}),y}$onDidDispose(D){const _=this._insets.get(D);_&&_.inset.dispose()}$onDidReceiveMessage(D,_){const P=this._insets.get(D);P&&P.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=T}),define(we[160],be([0,1,131,10,2,6,4,43,28,13,11]),function(ne,e,h,M,b,T,F,D,_,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,h.localize)(0,null),providerDisplayName:(0,h.localize)(1,null)},e.ActiveEditorDirtyContext=new D.RawContextKey("activeEditorIsDirty",!1,(0,h.localize)(2,null)),e.ActiveEditorPinnedContext=new D.RawContextKey("activeEditorIsNotPreview",!1,(0,h.localize)(3,null)),e.ActiveEditorStickyContext=new D.RawContextKey("activeEditorIsPinned",!1,(0,h.localize)(4,null)),e.ActiveEditorReadonlyContext=new D.RawContextKey("activeEditorIsReadonly",!1,(0,h.localize)(5,null)),e.ActiveEditorCanRevertContext=new D.RawContextKey("activeEditorCanRevert",!1,(0,h.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new D.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new D.RawContextKey("activeEditor",null,{type:"string",description:(0,h.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new D.RawContextKey("activeEditorAvailableEditorIds","",(0,h.localize)(8,null)),e.TextCompareEditorVisibleContext=new D.RawContextKey("textCompareEditorVisible",!1,(0,h.localize)(9,null)),e.TextCompareEditorActiveContext=new D.RawContextKey("textCompareEditorActive",!1,(0,h.localize)(10,null)),e.SideBySideEditorActiveContext=new D.RawContextKey("sideBySideEditorActive",!1,(0,h.localize)(11,null)),e.EditorGroupEditorsCountContext=new D.RawContextKey("groupEditorsCount",0,(0,h.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new D.RawContextKey("activeEditorGroupEmpty",!1,(0,h.localize)(13,null)),e.ActiveEditorGroupIndexContext=new D.RawContextKey("activeEditorGroupIndex",0,(0,h.localize)(14,null)),e.ActiveEditorGroupLastContext=new D.RawContextKey("activeEditorGroupLast",!1,(0,h.localize)(15,null)),e.ActiveEditorGroupLockedContext=new D.RawContextKey("activeEditorGroupLocked",!1,(0,h.localize)(16,null)),e.MultipleEditorGroupsContext=new D.RawContextKey("multipleEditorGroups",!1,(0,h.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new D.RawContextKey("editorIsOpen",!1,(0,h.localize)(18,null)),e.InEditorZenModeContext=new D.RawContextKey("inZenMode",!1,(0,h.localize)(19,null)),e.IsCenteredLayoutContext=new D.RawContextKey("isCenteredLayout",!1,(0,h.localize)(20,null)),e.SplitEditorsVertically=new D.RawContextKey("splitEditorsVertically",!1,(0,h.localize)(21,null)),e.EditorAreaVisibleContext=new D.RawContextKey("editorAreaVisible",!0,(0,h.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function E(u,A,L){for(const V of L.visibleEditorPanes)if(V.group.id===A&&u.matches(V.input))return V.getViewState()}e.findViewStateForEditor=E;function n(u){if(g(u))return!1;const A=u;return b.URI.isUri(A?.resource)}e.isResourceEditorInput=n;function d(u){if(g(u))return!1;const A=u;return A?.original!==void 0&&A.modified!==void 0}e.isResourceDiffEditorInput=d;function c(u){if(g(u)||d(u))return!1;const A=u;return A?.primary!==void 0&&A.secondary!==void 0}e.isResourceSideBySideEditorInput=c;function l(u){if(g(u))return!1;const A=u;return A?A.resource===void 0||A.resource.scheme===t.Schemas.untitled||A.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=l;var w;(function(u){u[u.SHORT=0]="SHORT",u[u.MEDIUM=1]="MEDIUM",u[u.LONG=2]="LONG"})(w=e.Verbosity||(e.Verbosity={}));var I;(function(u){u[u.EXPLICIT=1]="EXPLICIT",u[u.AUTO=2]="AUTO",u[u.FOCUS_CHANGE=3]="FOCUS_CHANGE",u[u.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(I=e.SaveReason||(e.SaveReason={}));var y;(function(u){u[u.None=0]="None",u[u.Readonly=2]="Readonly",u[u.Untitled=4]="Untitled",u[u.Singleton=8]="Singleton",u[u.RequiresTrust=16]="RequiresTrust",u[u.CanSplitInGroup=32]="CanSplitInGroup"})(y=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class s extends T.Disposable{}e.AbstractEditorInput=s;function g(u){return u instanceof s}e.isEditorInput=g;function k(u){const A=u;return b.URI.isUri(A?.preferredResource)}function i(u){const A=u;return g(A?.primary)&&g(A?.secondary)}e.isSideBySideEditorInput=i;function a(u){const A=u;return g(A?.modified)&&g(A?.original)}e.isDiffEditorInput=a;function r(u){return g(u?.editor)}e.isEditorInputWithOptions=r;function o(u){const A=u;return r(u)&&A?.group!==void 0}e.isEditorInputWithOptionsAndGroup=o;function f(u){const A=u;return typeof A?.groupId=="number"&&g(A.editor)}e.isEditorIdentifier=f;var m;(function(u){u[u.PRIMARY=1]="PRIMARY",u[u.SECONDARY=2]="SECONDARY",u[u.BOTH=3]="BOTH",u[u.ANY=4]="ANY"})(m=e.SideBySideEditor||(e.SideBySideEditor={}));class v{getOriginalUri(A,L){if(!A)return;if(L?.supportSideBySide){const{primary:K,secondary:W}=this.getSideEditors(A);if(K&&W){if(L?.supportSideBySide===m.BOTH)return{primary:this.getOriginalUri(K,{filterByScheme:L.filterByScheme}),secondary:this.getOriginalUri(W,{filterByScheme:L.filterByScheme})};if(L?.supportSideBySide===m.ANY)return this.getOriginalUri(K,{filterByScheme:L.filterByScheme})??this.getOriginalUri(W,{filterByScheme:L.filterByScheme});A=L.supportSideBySide===m.PRIMARY?K:W}}if(d(A)||c(A))return;const V=k(A)?A.preferredResource:A.resource;return!V||!L||!L.filterByScheme?V:this.filterUri(V,L.filterByScheme)}getSideEditors(A){return i(A)||c(A)?{primary:A.primary,secondary:A.secondary}:a(A)||d(A)?{primary:A.modified,secondary:A.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(A,L){if(!A)return;if(L?.supportSideBySide){const{primary:K,secondary:W}=this.getSideEditors(A);if(K&&W){if(L?.supportSideBySide===m.BOTH)return{primary:this.getCanonicalUri(K,{filterByScheme:L.filterByScheme}),secondary:this.getCanonicalUri(W,{filterByScheme:L.filterByScheme})};if(L?.supportSideBySide===m.ANY)return this.getCanonicalUri(K,{filterByScheme:L.filterByScheme})??this.getCanonicalUri(W,{filterByScheme:L.filterByScheme});A=L.supportSideBySide===m.PRIMARY?K:W}}if(d(A)||c(A))return;const V=A.resource;return!V||!L||!L.filterByScheme?V:this.filterUri(V,L.filterByScheme)}filterUri(A,L){if(Array.isArray(L)){if(L.some(V=>A.scheme===V))return A}else if(L===A.scheme)return A}}e.EditorResourceAccessor=new v;var C;(function(u){u[u.LEFT=0]="LEFT",u[u.RIGHT=1]="RIGHT"})(C=e.CloseDirection||(e.CloseDirection={}));class R{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(A){const L=this.instantiationService=A.get(F.IInstantiationService);for(const[V,K]of this.editorSerializerConstructors)this.createEditorSerializer(V,K,L);this.editorSerializerConstructors.clear()}createEditorSerializer(A,L,V){const K=V.createInstance(L);this.editorSerializerInstances.set(A,K)}registerFileEditorFactory(A){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=A}getFileEditorFactory(){return(0,M.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(A,L){if(this.editorSerializerConstructors.has(A)||this.editorSerializerInstances.has(A))throw new Error(`A editor serializer with type ID '${A}' was already registered.`);return this.instantiationService?this.createEditorSerializer(A,L,this.instantiationService):this.editorSerializerConstructors.set(A,L),(0,T.toDisposable)(()=>{this.editorSerializerConstructors.delete(A),this.editorSerializerInstances.delete(A)})}getEditorSerializer(A){return this.editorSerializerInstances.get(typeof A=="string"?A:A.typeId)}}_.Registry.add(e.EditorExtensions.EditorFactory,new R);async function p(u,A){if(!u||!u.length)return[];const L=await Promise.all(u.map(async V=>{const K=b.URI.revive(V.fileUri);if(!K||(await A.activateProvider(K.scheme),!A.canHandleResource(K)))return;const W=typeof V.exists=="boolean"?V.exists:await A.exists(K);if(!W&&V.openOnlyIfExists)return;const Q={selection:W?V.selection:void 0,pinned:!0,override:V.editorOverrideId};let $;return W?$={resource:K,options:Q}:$={resource:K,options:Q,forceUntitled:!0},$}));return(0,P.coalesce)(L)}e.pathsToEditors=p;var S;(function(u){u[u.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",u[u.SEQUENTIAL=1]="SEQUENTIAL"})(S=e.EditorsOrder||(e.EditorsOrder={}))}),define(we[161],be([0,1,3,43,132,4,6,20,28,13,51,22,34,151]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,d.registerIcon)("default-view-icon",n.Codicon.window,(0,b.localize)(0,null));var c;(function(f){f.ViewContainersRegistry="workbench.registry.view.containers",f.ViewsRegistry="workbench.registry.view"})(c=e.Extensions||(e.Extensions={}));var l;(function(f){f[f.Sidebar=0]="Sidebar",f[f.Panel=1]="Panel"})(l=e.ViewContainerLocation||(e.ViewContainerLocation={}));function w(f){switch(f){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=w;function I(f){return`viewContainer.${f}.enabled`}e.getEnabledViewContainerContextKey=I;class y extends F.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new h.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new h.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,P.flatten)([...this.viewContainers.values()])}registerViewContainer(m,v,C){const R=this.get(m.id);if(R)return R;const p=m;return p.openCommandActionDescriptor=C?.donotRegisterOpenCommand?void 0:p.openCommandActionDescriptor??{id:p.id},(0,D.getOrSet)(this.viewContainers,v,[]).push(p),C?.isDefault&&this.defaultViewContainers.push(p),this._onDidRegister.fire({viewContainer:p,viewContainerLocation:v}),p}deregisterViewContainer(m){for(const v of this.viewContainers.keys()){const C=this.viewContainers.get(v),R=C?.indexOf(m);if(R!==-1){C?.splice(R,1),C.length===0&&this.viewContainers.delete(v),this._onDidDeregister.fire({viewContainer:m,viewContainerLocation:v});return}}}get(m){return this.all.filter(v=>v.id===m)[0]}getViewContainers(m){return[...this.viewContainers.get(m)||[]]}getViewContainerLocation(m){return[...this.viewContainers.keys()].filter(v=>this.getViewContainers(v).filter(C=>C?.id===m.id).length>0)[0]}getDefaultViewContainer(m){return this.defaultViewContainers.find(v=>this.getViewContainerLocation(v)===m)}}_.Registry.add(c.ViewContainersRegistry,new y);var s;(function(f){f.Open="2_open",f.Debug="4_debug",f.SCM="5_scm",f.More="9_more"})(s=e.ViewContentGroups||(e.ViewContentGroups={}));function g(f,m){const v=f.group??s.More,C=m.group??s.More;return v!==C?v.localeCompare(C):(f.order??5)-(m.order??5)}class k extends F.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new h.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new h.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new h.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new h.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new t.SetMap}registerViews(m,v){this.registerViews2([{views:m,viewContainer:v}])}registerViews2(m){m.forEach(({views:v,viewContainer:C})=>this.addViews(v,C)),this._onViewsRegistered.fire(m)}deregisterViews(m,v){const C=this.removeViews(m,v);C.length&&this._onViewsDeregistered.fire({views:C,viewContainer:v})}moveViews(m,v){for(const C of this._views.keys())if(C!==v){const R=this.removeViews(m,C);R.length&&(this.addViews(R,v),this._onDidChangeContainer.fire({views:R,from:C,to:v}))}}getViews(m){return this._views.get(m)||[]}getView(m){for(const v of this._viewContainers){const C=(this._views.get(v)||[]).filter(R=>R.id===m)[0];if(C)return C}return null}getViewContainer(m){for(const v of this._viewContainers)if((this._views.get(v)||[]).filter(R=>R.id===m)[0])return v;return null}registerViewWelcomeContent(m,v){return this._viewWelcomeContents.add(m,v),this._onDidChangeViewWelcomeContent.fire(m),(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(m,v),this._onDidChangeViewWelcomeContent.fire(m)})}registerViewWelcomeContent2(m,v){const C=new Map;for(const[R,p]of v)this._viewWelcomeContents.add(m,p),C.set(R,(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(m,p),this._onDidChangeViewWelcomeContent.fire(m)}));return this._onDidChangeViewWelcomeContent.fire(m),C}getViewWelcomeContent(m){const v=[];return this._viewWelcomeContents.forEach(m,C=>v.push(C)),v.sort(g)}addViews(m,v){let C=this._views.get(v);C||(C=[],this._views.set(v,C),this._viewContainers.push(v));for(const R of m){if(this.getView(R.id)!==null)throw new Error((0,b.localize)(1,null,R.id));C.push(R)}}removeViews(m,v){const C=this._views.get(v);if(!C)return[];const R=[],p=[];for(const S of C)m.includes(S)?R.push(S):p.push(S);return R.length&&(p.length?this._views.set(v,p):(this._views.delete(v),this._viewContainers.splice(this._viewContainers.indexOf(v),1))),R}}_.Registry.add(c.ViewsRegistry,new k),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new M.RawContextKey("focusedView","",(0,b.localize)(2,null));function i(f){return`view.${f}.visible`}e.getVisbileViewContextKey=i,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var a;(function(f){f[f.Default=0]="Default",f[f.Expand=1]="Expand"})(a=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(f){f[f.None=0]="None",f[f.Collapsed=1]="Collapsed",f[f.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class o{constructor(m,v){this.resolved=!1,this._hasResolve=!1,(0,E.mixin)(this,m),this._hasResolve=!!v,this.resolve=async C=>{if(v&&!this.resolved){const R=await v(C);R&&(this.tooltip=this.tooltip??R.tooltip,this.command=this.command??R.command)}C.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=o,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(we[162],be([0,1,3,14,133]),function(ne,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new h.Emitter,this._onExit=new h.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,_,P,t){const E={command:D};if(_&&Object.keys(_).length>0&&(E.arguments=_),this.internalSend("request",E),typeof t=="number"){const n=setTimeout(()=>{clearTimeout(n);const d=this.pendingRequests.get(E.seq);if(d){this.pendingRequests.delete(E.seq);const c={type:"response",seq:0,request_seq:E.seq,success:!1,command:D,message:(0,b.localize)(0,null,t,D)};d(c)}},t)}return P&&this.pendingRequests.set(E.seq,P),E.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,_){return D.type!=="event"||_.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await(0,M.timeout)(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":const _=D,P=this.pendingRequests.get(_.request_seq);P&&(this.pendingRequests.delete(_.request_seq),P(_));break}}}internalSend(D,_){_.type=D,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((_,P)=>D.set(P,_)),await(0,M.timeout)(500),D.forEach((_,P)=>{_({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(we[163],be([0,1,9,2,17,22,11]),function(ne,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function _(r,o,f){return r.replace(D,function(m,v){return o&&v.length>0&&v[0]!=="_"?m:f&&f.hasOwnProperty(v)?f[v]:m})}e.formatPII=_;function P(r){const o={};for(const f of Object.keys(r))f.startsWith("!")||(o[f]=r[f]);return o}e.filterExceptionsFromTelemetry=P;function t(r){return r.configuration.request==="attach"&&!E(r)&&(!r.parentSession||t(r.parentSession))}e.isSessionAttach=t;function E(r){let o=r.configuration.type;if(!!o)return o==="vslsShare"&&(o=r.configuration.adapterProxy.configuration.type),(0,h.equalsIgnoreCase)(o,"extensionhost")||(0,h.equalsIgnoreCase)(o,"pwa-extensionhost")?r:r.parentSession?E(r.parentSession):void 0}e.getExtensionHostDebugSession=E;function n(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=n;function d(r,o,f){let m,v=0,C=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,R=null;for(;R=C.exec(r);){let p=R.index+1,S=p+R[0].length;if(p<=o&&S>=f){m=R[0],v=p;break}}if(m){let p=/\w+/g,S=null;for(;(S=p.exec(m))&&!(S.index+1+v+S[0].length>=f););S&&(m=m.substring(0,p.lastIndex))}return m?{start:v,end:v+m.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=d;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function l(r){return!!(r&&r.match(c))}e.isUri=l;function w(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(l(r.path))return M.URI.parse(r.path);if((0,b.isAbsolute)(r.path))return M.URI.file(r.path)}return r.path}function I(r){if(typeof r.path=="object"){const o=M.URI.revive(r.path);if(o)return o.scheme===F.Schemas.file?o.fsPath:o.toString()}return r.path}function y(r,o){const f=o?w:I,m=(0,T.deepClone)(r);return g(m,(v,C)=>{v&&C&&(C.path=f(C))}),m}e.convertToDAPaths=y;function s(r,o){const f=o?w:I,m=(0,T.deepClone)(r);return g(m,(v,C)=>{!v&&C&&(C.path=f(C))}),m}e.convertToVSCPaths=s;function g(r,o){switch(r.type){case"event":const f=r;switch(f.event){case"output":o(!1,f.body.source);break;case"loadedSource":o(!1,f.body.source);break;case"breakpoint":o(!1,f.body.breakpoint.source);break;default:break}break;case"request":const m=r;switch(m.command){case"setBreakpoints":o(!0,m.arguments.source);break;case"breakpointLocations":o(!0,m.arguments.source);break;case"source":o(!0,m.arguments.source);break;case"gotoTargets":o(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(C=>o(!1,C));break;default:break}break;case"response":const v=r;if(v.success&&v.body)switch(v.command){case"stackTrace":v.body.stackFrames.forEach(C=>o(!1,C.source));break;case"loadedSources":v.body.sources.forEach(C=>o(!1,C));break;case"scopes":v.body.scopes.forEach(C=>o(!1,C.source));break;case"setFunctionBreakpoints":v.body.breakpoints.forEach(C=>o(!1,C.source));break;case"setBreakpoints":v.body.breakpoints.forEach(C=>o(!1,C.source));break;default:break}break}}function k(r){return r.filter(o=>!o.presentation?.hidden).sort((o,f)=>o.presentation?f.presentation?o.presentation.group?f.presentation.group?o.presentation.group!==f.presentation.group?o.presentation.group.localeCompare(f.presentation.group):i(o.presentation.order,f.presentation.order):-1:f.presentation.group?1:i(o.presentation.order,f.presentation.order):-1:f.presentation?1:0)}e.getVisibleAndSorted=k;function i(r,o){return typeof r!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:r-o}async function a(r,o){const f=r.getValue("debug.saveBeforeStart",{overrideIdentifier:o.activeTextEditorMode});if(f!=="none"&&(await o.saveAll(),f==="allEditorsInActiveGroup")){const m=o.activeEditorPane;m&&await o.save({editor:m.input,groupId:m.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=a}),define(we[89],be([0,1,27,78,11,17,26,43]),function(ne,e,h,M,b,T,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var _;(function(p){p[p.Markup=1]="Markup",p[p.Code=2]="Code"})(_=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(p){p[p.Running=1]="Running",p[p.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var t;(function(p){p[p.Pending=2]="Pending",p[p.Executing=3]="Executing"})(t=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var E;(function(p){p[p.WithHardKernelDependency=0]="WithHardKernelDependency",p[p.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",p[p.Pure=2]="Pure",p[p.Never=3]="Never"})(E=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var n;(function(p){p.Always="always",p.Never="never",p.Optional="optional"})(n=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var d;(function(p){p[p.ModelChange=1]="ModelChange",p[p.Move=2]="Move",p[p.ChangeLanguage=5]="ChangeLanguage",p[p.Initialize=6]="Initialize",p[p.ChangeCellMetadata=7]="ChangeCellMetadata",p[p.Output=8]="Output",p[p.OutputItem=9]="OutputItem",p[p.ChangeCellContent=10]="ChangeCellContent",p[p.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",p[p.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",p[p.ChangeCellMime=13]="ChangeCellMime",p[p.Unknown=100]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(p){p[p.Handle=0]="Handle",p[p.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var l;(function(p){p[p.Replace=1]="Replace",p[p.Output=2]="Output",p[p.Metadata=3]="Metadata",p[p.CellLanguage=4]="CellLanguage",p[p.DocumentMetadata=5]="DocumentMetadata",p[p.Move=6]="Move",p[p.OutputItems=7]="OutputItems",p[p.PartialMetadata=8]="PartialMetadata",p[p.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var w;(function(p){p.scheme=b.Schemas.vscodeNotebookCell;const S=/^ch(\d{7,})/;function u(W,Q){return W.with({scheme:p.scheme,fragment:`ch${Q.toString().padStart(7,"0")}${W.scheme!==b.Schemas.file?W.scheme:""}`})}p.generate=u;function A(W){if(W.scheme!==p.scheme)return;const Q=S.exec(W.fragment);return Q?{handle:Number(Q[1]),notebook:W.with({scheme:W.fragment.substr(Q[0].length)||b.Schemas.file,fragment:null})}:void 0}p.parse=A;function L(W){if(W.scheme!==b.Schemas.vscodeNotebookCellMetadata)return;const Q=S.exec(W.fragment);return Q?{handle:Number(Q[1]),notebook:W.with({scheme:W.fragment.substr(Q[0].length)||b.Schemas.file,fragment:null})}:void 0}p.parseCellMetadataUri=L;function V(W,Q,$){return W.with({scheme:$,fragment:`ch${Q.toString().padStart(7,"0")}${W.scheme!==b.Schemas.file?W.scheme:""}`})}p.generateCellUri=V;function K(W,Q){if(W.scheme!==Q)return;const $=S.exec(W.fragment);return $?{handle:Number($[1]),notebook:W.with({scheme:W.fragment.substr($[0].length)||b.Schemas.file,fragment:null})}:void 0}p.parseCellUri=K})(w=e.CellUri||(e.CellUri={}));const I=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function y(p){return I.get(p)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=y;function s(p){return I.get(p)?.supportedByCore??!1}e.mimeTypeSupportedByCore=s;function g(p){return I.get(p)?.mergeable??!1}e.mimeTypeIsMergeable=g;function k(p,S){return F.isWindows&&(p=p.replace(/\//g,"\\"),S=S.replace(/\//g,"\\")),h.match(p,S)}function i(p,S,u){let A=0;for(let L=0;L<S.length;L++){if(k(S[L],p))return A;A++}for(let L=0;L<u.length;L++){if(k(u[L],p))return A;A++}return A}function a(p,S,u){return p.sort((A,L)=>i(A,S,u)-i(L,S,u))}e.sortMimeTypes=a;function r(p,S,u,A=(L,V)=>L===V){const L=[];function V(Q,$,U){if($===0&&U.length===0)return;const z=L[L.length-1];z&&z.start+z.deleteCount===Q?(z.deleteCount+=$,z.toInsert.push(...U)):L.push({start:Q,deleteCount:$,toInsert:U})}let K=0,W=0;for(;;){if(K===p.length){V(K,0,S.slice(W));break}if(W===S.length){V(K,p.length-K,[]);break}const Q=p[K],$=S[W];if(A(Q,$)){K+=1,W+=1;continue}u($)?(V(K,1,[]),K+=1):(V(K,0,[$]),W+=1)}return L}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var o;(function(p){p.default="default",p.option="option"})(o=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function f(p){const S=p;return!!((typeof S.include=="string"||h.isRelativePattern(S.include))&&(typeof S.exclude=="string"||h.isRelativePattern(S.exclude)))}e.isDocumentExcludePattern=f;function m(p,S,u){if(Array.isArray(p.viewType)&&p.viewType.indexOf(S)>=0||p.viewType===S)return!0;if(p.filenamePattern){let A=f(p.filenamePattern)?p.filenamePattern.include:p.filenamePattern,L=f(p.filenamePattern)?p.filenamePattern.exclude:void 0;if(h.match(A,(0,T.basename)(u.fsPath).toLowerCase()))return!(L&&h.match(L,(0,T.basename)(u.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=m;class v{constructor(S){this.textModel=S}getElements(){const S=new Int32Array(this.textModel.cells.length);for(let u=0;u<this.textModel.cells.length;u++)S[u]=this.textModel.cells[u].getHashValue();return S}}e.CellSequence=v,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var C;(function(p){p[p.Left=1]="Left",p[p.Right=2]="Right"})(C=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class R{static create(S){return`${R._prefix}${S}`}static parse(S){if(S.startsWith(R._prefix))return S.substr(R._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=R,R._prefix="notebook/"}),define(we[164],be([0,1,4]),function(ne,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var M;(function(b){b[b.Output=1]="Output",b[b.OutputItems=2]="OutputItems",b[b.ExecutionState=3]="ExecutionState",b[b.Complete=4]="Complete"})(M=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,h.createDecorator)("INotebookExecutionService")}),define(we[165],be([0,1,135,4,43]),function(ne,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new b.RawContextKey("customExecutionSupported",!0,h.localize(0,null)),e.ShellExecutionSupportedContext=new b.RawContextKey("shellExecutionSupported",!1,h.localize(1,null)),e.ProcessExecutionSupportedContext=new b.RawContextKey("processExecutionSupported",!1,h.localize(2,null)),e.ITaskService=(0,M.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[166],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function h(b){return[...b.entries()]}e.serializeEnvironmentVariableCollection=h;function M(b){return new Map(b)}e.deserializeEnvironmentVariableCollection=M}),define(we[90],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var h;(function(E){E[E.Unset=0]="Unset",E[E.Queued=1]="Queued",E[E.Running=2]="Running",E[E.Passed=3]="Passed",E[E.Failed=4]="Failed",E[E.Skipped=5]="Skipped",E[E.Errored=6]="Errored"})(h=e.TestResultState||(e.TestResultState={}));var M;(function(E){E[E.Run=2]="Run",E[E.Debug=4]="Debug",E[E.Coverage=8]="Coverage",E[E.HasNonDefaultProfile=16]="HasNonDefaultProfile",E[E.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var b;(function(E){E[E.Error=0]="Error",E[E.Info=1]="Info"})(b=e.TestMessageType||(e.TestMessageType={}));var T;(function(E){E[E.NotExpandable=0]="NotExpandable",E[E.Expandable=1]="Expandable",E[E.BusyExpanding=2]="BusyExpanding",E[E.Expanded=3]="Expanded"})(T=e.TestItemExpandState||(e.TestItemExpandState={}));const F=(E,n)=>{n.expand!==void 0&&(E.expand=n.expand),n.item!==void 0&&(E.item=E.item?Object.assign(E.item,n.item):n.item)};e.applyTestItemUpdate=F;var D;(function(E){E[E.Function=0]="Function",E[E.Statement=1]="Statement"})(D=e.DetailType||(e.DetailType={}));var _;(function(E){E[E.Add=0]="Add",E[E.Update=1]="Update",E[E.Remove=2]="Remove",E[E.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",E[E.Retire=4]="Retire",E[E.AddTag=5]="AddTag",E[E.RemoveTag=6]="RemoveTag"})(_=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(n){}update(n){}remove(n,d){}complete(){}}e.IncrementalChangeCollector=P;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const d=this.createChangeCollector();for(const c of n)switch(c[0]){case 0:{const l=c[1];if(l.parent){if(this.items.has(l.parent)){const w=this.items.get(l.parent);w.children.add(l.item.extId);const I=this.createItem(l,w);this.items.set(l.item.extId,I),d.add(I)}}else{const w=this.createItem(l);this.roots.add(w),this.items.set(l.item.extId,w),d.add(w)}l.expand===2&&this.busyControllerCount++;break}case 1:{const l=c[1],w=this.items.get(l.extId);if(!w)break;l.expand!==void 0&&(w.expand===2&&this.busyControllerCount--,l.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(w,l),d.update(w);break}case 2:{const l=this.items.get(c[1]);if(!l)break;l.parent?this.items.get(l.parent).children.delete(l.item.extId):this.roots.delete(l);const w=[[c[1]]];for(;w.length;)for(const I of w.pop()){const y=this.items.get(I);y&&(w.push(y.children),this.items.delete(I),d.remove(y,y!==l),y.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(c[1]);break;case 3:this.updatePendingRoots(c[1]);break;case 5:this._tags.set(c[1].id,c[1]);break;case 6:this._tags.delete(c[1]);break}d.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=t}),define(we[67],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var h;(function(T){T.Delimiter="\0"})(h=e.TestIdPathParts||(e.TestIdPathParts={}));var M;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(M=e.TestPosition||(e.TestPosition={}));class b{constructor(F,D=F.length){if(this.path=F,this.viewEnd=D,F.length===0||D<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(F,D,_=F.parent){if(F.id===D)return new b([D]);let P=[F.id];for(let t=_;t&&t.id!==D;t=t.parent)P.push(t.id);return P.push(D),new b(P.reverse())}static isRoot(F){return!F.includes("\0")}static fromString(F){return new b(F.split("\0"))}static join(F,D){return new b([...F.path,D])}static joinToString(F,D){return F.toString()+"\0"+D}static compare(F,D){return F===D?0:D.startsWith(F+"\0")?2:F.startsWith(D+"\0")?3:1}get parentId(){return this.viewEnd>1?new b(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let F=1;F<=this.viewEnd;F++)yield new b(this.path,F)}compare(F){if(typeof F=="string")return b.compare(this.toString(),F);for(let D=0;D<F.viewEnd&&D<this.viewEnd;D++)if(F.path[D]!==this.path[D])return 1;return F.viewEnd>this.viewEnd?2:F.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let F=1;F<this.viewEnd;F++)this.stringifed+="\0",this.stringifed+=this.path[F]}return this.stringifed}}e.TestId=b}),define(we[167],be([0,1,17,91,10,22,26,77,136]),function(ne,e,h,M,b,T,F,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(E,n,d){this._contributedVariables=new Map,this._context=E,this._labelService=n,d&&(this._envVariablesPromise=d.then(c=>this.prepareEnv(c)))}prepareEnv(E){if(F.isWindows){const n=Object.create(null);return Object.keys(E).forEach(d=>{n[d.toLowerCase()]=E[d]}),n}return E}resolveWithEnvironment(E,n,d){return this.recursiveResolve(this.prepareEnv(E),n?n.uri:void 0,d)}async resolveAsync(E,n){return this.recursiveResolve(await this._envVariablesPromise,E?E.uri:void 0,n)}async resolveAnyBase(E,n,d,c){const l=T.deepClone(n);return F.isWindows&&l.windows?Object.keys(l.windows).forEach(w=>l[w]=l.windows[w]):F.isMacintosh&&l.osx?Object.keys(l.osx).forEach(w=>l[w]=l.osx[w]):F.isLinux&&l.linux&&Object.keys(l.linux).forEach(w=>l[w]=l.linux[w]),delete l.windows,delete l.osx,delete l.linux,this.recursiveResolve(await this._envVariablesPromise,E?E.uri:void 0,l,d,c)}async resolveAnyAsync(E,n,d){return this.resolveAnyBase(E,n,d)}async resolveAnyMap(E,n,d){const c=new Map;return{newConfig:await this.resolveAnyBase(E,n,d,c),resolvedVariables:c}}resolveWithInteractionReplace(E,n,d,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,n,d,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,n){if(this._contributedVariables.has(E))throw new Error("Variable "+E+" is contributed twice.");this._contributedVariables.set(E,n)}recursiveResolve(E,n,d,c,l){if(b.isString(d))return this.resolveString(E,n,d,c,l);if(b.isArray(d))return d.map(w=>this.recursiveResolve(E,n,w,c,l));if(b.isObject(d)){let w=Object.create(null);return Object.keys(d).forEach(I=>{const y=this.resolveString(E,n,I,c,l);w[y]=this.recursiveResolve(E,n,d[I],c,l)}),w}return d}resolveString(E,n,d,c,l){return d.replace(P.VARIABLE_REGEXP,(I,y)=>{if(y.includes(P.VARIABLE_LHS))return I;let s=this.evaluateSingleVariable(E,I,y,n,c);return l&&l.set(y,s),s!==I&&b.isString(s)&&s.match(P.VARIABLE_REGEXP)&&(s=this.resolveString(E,n,s,c,l)),s})}fsPath(E){return this._labelService?this._labelService.getUriLabel(E,{noPrefix:!0}):E.fsPath}evaluateSingleVariable(E,n,d,c,l){let w;const I=d.split(":");I.length>1&&(d=I[0],w=I[1]);const y=()=>{const k=this._context.getFilePath();if(k)return k;throw new Error((0,_.localize)(0,null,n))},s=()=>{const k=y();if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new Error((0,_.localize)(1,null,n,h.basename(k)))},g=()=>{if(w){const k=this._context.getFolderUri(w);if(k)return k;throw new Error((0,_.localize)(2,null,n,w))}if(c)return c;throw this._context.getWorkspaceFolderCount()>1?new Error((0,_.localize)(3,null,n)):new Error((0,_.localize)(4,null,n))};switch(d){case"env":if(w){if(E){const k=E[F.isWindows?w.toLowerCase():w];if(b.isString(k))return k}return""}throw new Error((0,_.localize)(5,null,n));case"config":if(w){const k=this._context.getConfigurationValue(c,w);if(b.isUndefinedOrNull(k))throw new Error((0,_.localize)(6,null,n,w));if(b.isObject(k))throw new Error((0,_.localize)(7,null,n,w));return k}throw new Error((0,_.localize)(8,null,n));case"command":return this.resolveFromMap(n,w,l,"command");case"input":return this.resolveFromMap(n,w,l,"input");default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(g()));case"cwd":return c||w?(0,D.normalizeDriveLetter)(this.fsPath(g())):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return h.basename(this.fsPath(g()));case"lineNumber":const k=this._context.getLineNumber();if(k)return k;throw new Error((0,_.localize)(9,null,n));case"selectedText":const i=this._context.getSelectedText();if(i)return i;throw new Error((0,_.localize)(10,null,n));case"file":return y();case"fileWorkspaceFolder":return s();case"relativeFile":return c||w?h.relative(this.fsPath(g()),y()):y();case"relativeFileDirname":const a=h.dirname(y());if(c||w){const m=h.relative(this.fsPath(g()),a);return m.length===0?".":m}return a;case"fileDirname":return h.dirname(y());case"fileExtname":return h.extname(y());case"fileBasename":return h.basename(y());case"fileBasenameNoExtension":const r=h.basename(y());return r.slice(0,r.length-h.extname(r).length);case"fileDirnameBasename":return h.basename(h.dirname(y()));case"execPath":const o=this._context.getExecPath();return o||n;case"execInstallFolder":const f=this._context.getAppRoot();return f||n;case"pathSeparator":return h.sep;default:try{const m=w?`${d}:${w}`:d;return this.resolveFromMap(n,m,l,void 0)}catch(m){return n}}}}resolveFromMap(E,n,d,c){if(n&&d){const l=c===void 0?d[n]:d[c+":"+n];if(typeof l=="string")return l;throw new Error((0,_.localize)(11,null,E))}return E}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[92],be([0,1,4,160]),function(ne,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,h.createDecorator)("editorGroupsService");var b;(function(l){l[l.UP=0]="UP",l[l.DOWN=1]="DOWN",l[l.LEFT=2]="LEFT",l[l.RIGHT=3]="RIGHT"})(b=e.GroupDirection||(e.GroupDirection={}));var T;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var F;(function(l){l[l.FIRST=0]="FIRST",l[l.LAST=1]="LAST",l[l.NEXT=2]="NEXT",l[l.PREVIOUS=3]="PREVIOUS"})(F=e.GroupLocation||(e.GroupLocation={}));var D;(function(l){l[l.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",l[l.EVEN=1]="EVEN",l[l.TOGGLE=2]="TOGGLE"})(D=e.GroupsArrangement||(e.GroupsArrangement={}));var _;(function(l){l[l.COPY_EDITORS=0]="COPY_EDITORS",l[l.MOVE_EDITORS=1]="MOVE_EDITORS"})(_=e.MergeGroupMode||(e.MergeGroupMode={}));function P(l){const w=l;return(0,M.isEditorInput)(w?.editor)&&(0,M.isEditorInput)(w?.replacement)}e.isEditorReplacement=P;var t;(function(l){l[l.CREATION_TIME=0]="CREATION_TIME",l[l.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",l[l.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(t=e.GroupsOrder||(e.GroupsOrder={}));var E;(function(l){l[l.GROUP_ACTIVE=0]="GROUP_ACTIVE",l[l.GROUP_INDEX=1]="GROUP_INDEX",l[l.GROUP_LOCKED=2]="GROUP_LOCKED",l[l.EDITOR_OPEN=3]="EDITOR_OPEN",l[l.EDITOR_CLOSE=4]="EDITOR_CLOSE",l[l.EDITOR_MOVE=5]="EDITOR_MOVE",l[l.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",l[l.EDITOR_LABEL=7]="EDITOR_LABEL",l[l.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",l[l.EDITOR_PIN=9]="EDITOR_PIN",l[l.EDITOR_STICKY=10]="EDITOR_STICKY",l[l.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(E=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(l){l[l.NEW_EDITOR=1]="NEW_EDITOR",l[l.MOVE_EDITOR=2]="MOVE_EDITOR",l[l.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function d(l){const w=l;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.isEditorGroup=d;function c(l){return l.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=c}),define(we[168],be([0,1,4,92]),function(ne,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,h.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function b(T){const F=T;return typeof T=="number"||(0,M.isEditorGroup)(F)}e.isPreferredGroup=b}),define(we[8],be([0,1,13,23,76,229,54,22,10,2,42,59,137,82,46,89,67,168,7]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n,d,c,l,w,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(ie){function pe(B){const{selectionStartLineNumber:De,selectionStartColumn:Se,positionLineNumber:qe,positionColumn:We}=B,tt=new y.Position(De-1,Se-1),mt=new y.Position(qe-1,We-1);return new y.Selection(tt,mt)}ie.to=pe;function re(B){const{anchor:De,active:Se}=B;return{selectionStartLineNumber:De.line+1,selectionStartColumn:De.character+1,positionLineNumber:Se.line+1,positionColumn:Se.character+1}}ie.from=re})(s=e.Selection||(e.Selection={}));var g;(function(ie){function pe(B){if(!B)return;const{start:De,end:Se}=B;return{startLineNumber:De.line+1,startColumn:De.character+1,endLineNumber:Se.line+1,endColumn:Se.character+1}}ie.from=pe;function re(B){if(!B)return;const{startLineNumber:De,startColumn:Se,endLineNumber:qe,endColumn:We}=B;return new y.Range(De-1,Se-1,qe-1,We-1)}ie.to=re})(g=e.Range||(e.Range={}));var k;(function(ie){function pe(re){switch(re){case 1:return y.StandardTokenType.Comment;case 0:return y.StandardTokenType.Other;case 4:return y.StandardTokenType.RegEx;case 2:return y.StandardTokenType.String}}ie.to=pe})(k=e.TokenType||(e.TokenType={}));var i;(function(ie){function pe(B){return new y.Position(B.lineNumber-1,B.column-1)}ie.to=pe;function re(B){return{lineNumber:B.line+1,column:B.character+1}}ie.from=re})(i=e.Position||(e.Position={}));var a;(function(ie){function pe(B){switch(B){case y.DiagnosticTag.Unnecessary:return 1;case y.DiagnosticTag.Deprecated:return 2}}ie.from=pe;function re(B){switch(B){case 1:return y.DiagnosticTag.Unnecessary;case 2:return y.DiagnosticTag.Deprecated;default:return}}ie.to=re})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(ie){function pe(B){let De;return B.code&&((0,_.isString)(B.code)||(0,_.isNumber)(B.code)?De=String(B.code):De={value:String(B.code.value),target:B.code.target}),{...g.from(B.range),message:B.message,source:B.source,code:De,severity:f.from(B.severity),relatedInformation:B.relatedInformation&&B.relatedInformation.map(o.from),tags:Array.isArray(B.tags)?(0,h.coalesce)(B.tags.map(a.from)):void 0}}ie.from=pe;function re(B){const De=new y.Diagnostic(g.to(B),B.message,f.to(B.severity));return De.source=B.source,De.code=(0,_.isString)(B.code)?B.code:B.code?.value,De.relatedInformation=B.relatedInformation&&B.relatedInformation.map(o.to),De.tags=B.tags&&(0,h.coalesce)(B.tags.map(a.to)),De}ie.to=re})(r=e.Diagnostic||(e.Diagnostic={}));var o;(function(ie){function pe(B){return{...g.from(B.location.range),message:B.message,resource:B.location.uri}}ie.from=pe;function re(B){return new y.DiagnosticRelatedInformation(new y.Location(B.resource,g.to(B)),B.message)}ie.to=re})(o=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var f;(function(ie){function pe(B){switch(B){case y.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case y.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case y.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case y.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}ie.from=pe;function re(B){switch(B){case d.MarkerSeverity.Info:return y.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return y.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return y.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return y.DiagnosticSeverity.Hint;default:return y.DiagnosticSeverity.Error}}ie.to=re})(f=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var m;(function(ie){function pe(B){return typeof B=="number"&&B>=y.ViewColumn.One?B-1:B===y.ViewColumn.Beside?I.SIDE_GROUP:I.ACTIVE_GROUP}ie.from=pe;function re(B){if(typeof B=="number"&&B>=0)return B+1;throw new Error("invalid 'EditorGroupColumn'")}ie.to=re})(m=e.ViewColumn||(e.ViewColumn={}));function v(ie){return typeof ie.range!="undefined"}function C(ie){return ie.length===0?!0:!!v(ie[0])}e.isDecorationOptionsArr=C;var R;(function(ie){function pe(We){return We.map(ie.from)}ie.fromMany=pe;function re(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function B(We){let tt;if(re(We)){const{language:ct,value:lt}=We;tt={value:"```"+ct+`
`+lt+"\n```\n"}}else y.MarkdownString.isMarkdownString(We)?tt={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml}:typeof We=="string"?tt={value:We}:tt={value:""};const mt=Object.create(null);tt.uris=mt;const wt=ct=>{try{let lt=P.URI.parse(ct,!0);lt=lt.with({query:De(lt.query,mt)}),mt[ct]=lt}catch(lt){}return""},rt=new T.Renderer;return rt.link=wt,rt.image=ct=>wt(b.parseHrefAndDimensions(ct).href),T(tt.value,{renderer:rt}),tt}ie.from=B;function De(We,tt){if(!We)return We;let mt;try{mt=(0,F.parse)(We)}catch(rt){}if(!mt)return We;let wt=!1;return mt=(0,D.cloneAndChange)(mt,rt=>{if(P.URI.isUri(rt)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[ct]=rt,wt=!0,ct}else return}),wt?JSON.stringify(mt):We}function Se(We){const tt=new y.MarkdownString(We.value,We.supportThemeIcons);return tt.isTrusted=We.isTrusted,tt.supportHtml=We.supportHtml,tt}ie.to=Se;function qe(We){if(!!We)return typeof We=="string"?We:ie.from(We)}ie.fromStrict=qe})(R=e.MarkdownString||(e.MarkdownString={}));function p(ie){return C(ie)?ie.map(pe=>({range:g.from(pe.range),hoverMessage:Array.isArray(pe.hoverMessage)?R.fromMany(pe.hoverMessage):pe.hoverMessage?R.from(pe.hoverMessage):void 0,renderOptions:pe.renderOptions})):ie.map(pe=>({range:g.from(pe)}))}e.fromRangeOrRangeWithMessage=p;function S(ie){return typeof ie=="undefined"?ie:typeof ie=="string"?P.URI.file(ie):ie}e.pathOrURIToURI=S;var u;(function(ie){function pe(re){return typeof re=="undefined"?re:{contentText:re.contentText,contentIconPath:re.contentIconPath?S(re.contentIconPath):void 0,border:re.border,borderColor:re.borderColor,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,color:re.color,backgroundColor:re.backgroundColor,margin:re.margin,width:re.width,height:re.height}}ie.from=pe})(u=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var A;(function(ie){function pe(re){return typeof re=="undefined"?re:{backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?S(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?u.from(re.before):void 0,after:re.after?u.from(re.after):void 0}}ie.from=pe})(A=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var L;(function(ie){function pe(re){if(typeof re=="undefined")return re;switch(re){case y.DecorationRangeBehavior.OpenOpen:return 0;case y.DecorationRangeBehavior.ClosedClosed:return 1;case y.DecorationRangeBehavior.OpenClosed:return 2;case y.DecorationRangeBehavior.ClosedOpen:return 3}}ie.from=pe})(L=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var V;(function(ie){function pe(re){return{isWholeLine:re.isWholeLine,rangeBehavior:re.rangeBehavior?L.from(re.rangeBehavior):void 0,overviewRulerLane:re.overviewRulerLane,light:re.light?A.from(re.light):void 0,dark:re.dark?A.from(re.dark):void 0,backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?S(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?u.from(re.before):void 0,after:re.after?u.from(re.after):void 0}}ie.from=pe})(V=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var K;(function(ie){function pe(B){return{text:B.newText,eol:B.newEol&&J.from(B.newEol),range:g.from(B.range)}}ie.from=pe;function re(B){const De=new y.TextEdit(g.to(B.range),B.text);return De.newEol=typeof B.eol=="undefined"?void 0:J.to(B.eol),De}ie.to=re})(K=e.TextEdit||(e.TextEdit={}));var W;(function(ie){function pe(B,De,Se){const qe={edits:[]};if(B instanceof y.WorkspaceEdit)for(let We of B._allEntries())if(We._type===1)qe.edits.push({_type:1,oldUri:We.from,newUri:We.to,options:We.options,metadata:We.metadata});else if(We._type===2){const tt=De?.getDocument(We.uri);qe.edits.push({_type:2,resource:We.uri,edit:K.from(We.edit),modelVersionId:tt?.version,metadata:We.metadata})}else We._type===3?qe.edits.push({_type:3,metadata:We.metadata,resource:We.uri,edit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Se?.getNotebookDocument(We.uri,!0)?.apiNotebook.version}):We._type===5&&qe.edits.push({_type:3,metadata:We.metadata,resource:We.uri,notebookVersionId:Se?.getNotebookDocument(We.uri,!0)?.apiNotebook.version,edit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(ft.from)}});return qe}ie.from=pe;function re(B){const De=new y.WorkspaceEdit;for(const Se of B.edits)Se.edit?De.replace(P.URI.revive(Se.resource),g.to(Se.edit.range),Se.edit.text):De.renameFile(P.URI.revive(Se.oldUri),P.URI.revive(Se.newUri),Se.options);return De}ie.to=re})(W=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Q;(function(ie){const pe=Object.create(null);pe[y.SymbolKind.File]=0,pe[y.SymbolKind.Module]=1,pe[y.SymbolKind.Namespace]=2,pe[y.SymbolKind.Package]=3,pe[y.SymbolKind.Class]=4,pe[y.SymbolKind.Method]=5,pe[y.SymbolKind.Property]=6,pe[y.SymbolKind.Field]=7,pe[y.SymbolKind.Constructor]=8,pe[y.SymbolKind.Enum]=9,pe[y.SymbolKind.Interface]=10,pe[y.SymbolKind.Function]=11,pe[y.SymbolKind.Variable]=12,pe[y.SymbolKind.Constant]=13,pe[y.SymbolKind.String]=14,pe[y.SymbolKind.Number]=15,pe[y.SymbolKind.Boolean]=16,pe[y.SymbolKind.Array]=17,pe[y.SymbolKind.Object]=18,pe[y.SymbolKind.Key]=19,pe[y.SymbolKind.Null]=20,pe[y.SymbolKind.EnumMember]=21,pe[y.SymbolKind.Struct]=22,pe[y.SymbolKind.Event]=23,pe[y.SymbolKind.Operator]=24,pe[y.SymbolKind.TypeParameter]=25;function re(De){return typeof pe[De]=="number"?pe[De]:6}ie.from=re;function B(De){for(const Se in pe)if(pe[Se]===De)return Number(Se);return y.SymbolKind.Property}ie.to=B})(Q=e.SymbolKind||(e.SymbolKind={}));var $;(function(ie){function pe(B){switch(B){case y.SymbolTag.Deprecated:return 1}}ie.from=pe;function re(B){switch(B){case 1:return y.SymbolTag.Deprecated}}ie.to=re})($=e.SymbolTag||(e.SymbolTag={}));var U;(function(ie){function pe(B){return{name:B.name,kind:Q.from(B.kind),tags:B.tags&&B.tags.map($.from),containerName:B.containerName,location:le.from(B.location)}}ie.from=pe;function re(B){const De=new y.SymbolInformation(B.name,Q.to(B.kind),B.containerName,le.to(B.location));return De.tags=B.tags&&B.tags.map($.to),De}ie.to=re})(U=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var z;(function(ie){function pe(B){const De={name:B.name||"!!MISSING: name!!",detail:B.detail,range:g.from(B.range),selectionRange:g.from(B.selectionRange),kind:Q.from(B.kind),tags:B.tags?.map($.from)??[]};return B.children&&(De.children=B.children.map(pe)),De}ie.from=pe;function re(B){const De=new y.DocumentSymbol(B.name,B.detail,Q.to(B.kind),g.to(B.range),g.to(B.selectionRange));return(0,h.isNonEmptyArray)(B.tags)&&(De.tags=B.tags.map($.to)),B.children&&(De.children=B.children.map(re)),De}ie.to=re})(z=e.DocumentSymbol||(e.DocumentSymbol={}));var G;(function(ie){function pe(B){const De=new y.CallHierarchyItem(Q.to(B.kind),B.name,B.detail||"",P.URI.revive(B.uri),g.to(B.range),g.to(B.selectionRange));return De._sessionId=B._sessionId,De._itemId=B._itemId,De}ie.to=pe;function re(B,De,Se){if(De=De??B._sessionId,Se=Se??B._itemId,De===void 0||Se===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Se,name:B.name,detail:B.detail,kind:Q.from(B.kind),uri:B.uri,range:g.from(B.range),selectionRange:g.from(B.selectionRange),tags:B.tags?.map($.from)}}ie.from=re})(G=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ue;(function(ie){function pe(re){return new y.CallHierarchyIncomingCall(G.to(re.from),re.fromRanges.map(B=>g.to(B)))}ie.to=pe})(ue=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var q;(function(ie){function pe(re){return new y.CallHierarchyOutgoingCall(G.to(re.to),re.fromRanges.map(B=>g.to(B)))}ie.to=pe})(q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var le;(function(ie){function pe(B){return{range:B.range&&g.from(B.range),uri:B.uri}}ie.from=pe;function re(B){return new y.Location(P.URI.revive(B.uri),g.to(B.range))}ie.to=re})(le=e.location||(e.location={}));var se;(function(ie){function pe(B){const De=B,Se=B;return{originSelectionRange:De.originSelectionRange?g.from(De.originSelectionRange):void 0,uri:De.targetUri?De.targetUri:Se.uri,range:g.from(De.targetRange?De.targetRange:Se.range),targetSelectionRange:De.targetSelectionRange?g.from(De.targetSelectionRange):void 0}}ie.from=pe;function re(B){return{targetUri:P.URI.revive(B.uri),targetRange:g.to(B.range),targetSelectionRange:B.targetSelectionRange?g.to(B.targetSelectionRange):void 0,originSelectionRange:B.originSelectionRange?g.to(B.originSelectionRange):void 0}}ie.to=re})(se=e.DefinitionLink||(e.DefinitionLink={}));var ve;(function(ie){function pe(B){return{range:g.from(B.range),contents:R.fromMany(B.contents)}}ie.from=pe;function re(B){return new y.Hover(B.contents.map(R.to),g.to(B.range))}ie.to=re})(ve=e.Hover||(e.Hover={}));var Fe;(function(ie){function pe(B){return{range:g.from(B.range),expression:B.expression}}ie.from=pe;function re(B){return new y.EvaluatableExpression(g.to(B.range),B.expression)}ie.to=re})(Fe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Me;(function(ie){function pe(B){if(B instanceof y.InlineValueText)return{type:"text",range:g.from(B.range),text:B.text};if(B instanceof y.InlineValueVariableLookup)return{type:"variable",range:g.from(B.range),variableName:B.variableName,caseSensitiveLookup:B.caseSensitiveLookup};if(B instanceof y.InlineValueEvaluatableExpression)return{type:"expression",range:g.from(B.range),expression:B.expression};throw new Error("Unknown 'InlineValue' type")}ie.from=pe;function re(B){switch(B.type){case"text":return{range:g.to(B.range),text:B.text};case"variable":return{range:g.to(B.range),variableName:B.variableName,caseSensitiveLookup:B.caseSensitiveLookup};case"expression":return{range:g.to(B.range),expression:B.expression}}}ie.to=re})(Me=e.InlineValue||(e.InlineValue={}));var Oe;(function(ie){function pe(B){return{frameId:B.frameId,stoppedLocation:g.from(B.stoppedLocation)}}ie.from=pe;function re(B){return new y.InlineValueContext(B.frameId,g.to(B.stoppedLocation))}ie.to=re})(Oe=e.InlineValueContext||(e.InlineValueContext={}));var Ye;(function(ie){function pe(B){return{range:g.from(B.range),kind:B.kind}}ie.from=pe;function re(B){return new y.DocumentHighlight(g.to(B.range),B.kind)}ie.to=re})(Ye=e.DocumentHighlight||(e.DocumentHighlight={}));var ze;(function(ie){function pe(re){switch(re){case 1:return y.CompletionTriggerKind.TriggerCharacter;case 2:return y.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return y.CompletionTriggerKind.Invoke}}ie.to=pe})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var je;(function(ie){function pe(re){return{triggerKind:ze.to(re.triggerKind),triggerCharacter:re.triggerCharacter}}ie.to=pe})(je=e.CompletionContext||(e.CompletionContext={}));var x;(function(ie){function pe(B){switch(B){case y.CompletionItemTag.Deprecated:return 1}}ie.from=pe;function re(B){switch(B){case 1:return y.CompletionItemTag.Deprecated}}ie.to=re})(x=e.CompletionItemTag||(e.CompletionItemTag={}));var Y;(function(ie){const pe=new Map([[y.CompletionItemKind.Method,0],[y.CompletionItemKind.Function,1],[y.CompletionItemKind.Constructor,2],[y.CompletionItemKind.Field,3],[y.CompletionItemKind.Variable,4],[y.CompletionItemKind.Class,5],[y.CompletionItemKind.Interface,7],[y.CompletionItemKind.Struct,6],[y.CompletionItemKind.Module,8],[y.CompletionItemKind.Property,9],[y.CompletionItemKind.Unit,12],[y.CompletionItemKind.Value,13],[y.CompletionItemKind.Constant,14],[y.CompletionItemKind.Enum,15],[y.CompletionItemKind.EnumMember,16],[y.CompletionItemKind.Keyword,17],[y.CompletionItemKind.Snippet,27],[y.CompletionItemKind.Text,18],[y.CompletionItemKind.Color,19],[y.CompletionItemKind.File,20],[y.CompletionItemKind.Reference,21],[y.CompletionItemKind.Folder,23],[y.CompletionItemKind.Event,10],[y.CompletionItemKind.Operator,11],[y.CompletionItemKind.TypeParameter,24],[y.CompletionItemKind.Issue,26],[y.CompletionItemKind.User,25]]);function re(Se){return pe.get(Se)??9}ie.from=re;const B=new Map([[0,y.CompletionItemKind.Method],[1,y.CompletionItemKind.Function],[2,y.CompletionItemKind.Constructor],[3,y.CompletionItemKind.Field],[4,y.CompletionItemKind.Variable],[5,y.CompletionItemKind.Class],[7,y.CompletionItemKind.Interface],[6,y.CompletionItemKind.Struct],[8,y.CompletionItemKind.Module],[9,y.CompletionItemKind.Property],[12,y.CompletionItemKind.Unit],[13,y.CompletionItemKind.Value],[14,y.CompletionItemKind.Constant],[15,y.CompletionItemKind.Enum],[16,y.CompletionItemKind.EnumMember],[17,y.CompletionItemKind.Keyword],[27,y.CompletionItemKind.Snippet],[18,y.CompletionItemKind.Text],[19,y.CompletionItemKind.Color],[20,y.CompletionItemKind.File],[21,y.CompletionItemKind.Reference],[23,y.CompletionItemKind.Folder],[10,y.CompletionItemKind.Event],[11,y.CompletionItemKind.Operator],[24,y.CompletionItemKind.TypeParameter],[25,y.CompletionItemKind.User],[26,y.CompletionItemKind.Issue]]);function De(Se){return B.get(Se)??y.CompletionItemKind.Property}ie.to=De})(Y=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(ie){function pe(re,B){const De=new y.CompletionItem(re.label);return De.insertText=re.insertText,De.kind=Y.to(re.kind),De.tags=re.tags?.map(x.to),De.detail=re.detail,De.documentation=b.isMarkdownString(re.documentation)?R.to(re.documentation):re.documentation,De.sortText=re.sortText,De.filterText=re.filterText,De.preselect=re.preselect,De.commitCharacters=re.commitCharacters,t.Range.isIRange(re.range)?De.range=g.to(re.range):typeof re.range=="object"&&(De.range={inserting:g.to(re.range.insert),replacing:g.to(re.range.replace)}),De.keepWhitespace=typeof re.insertTextRules=="undefined"?!1:Boolean(re.insertTextRules&1),typeof re.insertTextRules!="undefined"&&re.insertTextRules&4?De.insertText=new y.SnippetString(re.insertText):(De.insertText=re.insertText,De.textEdit=De.range instanceof y.Range?new y.TextEdit(De.range,De.insertText):void 0),re.additionalTextEdits&&re.additionalTextEdits.length>0&&(De.additionalTextEdits=re.additionalTextEdits.map(Se=>K.to(Se))),De.command=B&&re.command?B.fromInternal(re.command):void 0,De}ie.to=pe})(ee=e.CompletionItem||(e.CompletionItem={}));var ae;(function(ie){function pe(B){return{label:B.label,documentation:B.documentation?R.fromStrict(B.documentation):void 0}}ie.from=pe;function re(B){return{label:B.label,documentation:b.isMarkdownString(B.documentation)?R.to(B.documentation):B.documentation}}ie.to=re})(ae=e.ParameterInformation||(e.ParameterInformation={}));var j;(function(ie){function pe(B){return{label:B.label,documentation:B.documentation?R.fromStrict(B.documentation):void 0,parameters:Array.isArray(B.parameters)?B.parameters.map(ae.from):[],activeParameter:B.activeParameter}}ie.from=pe;function re(B){return{label:B.label,documentation:b.isMarkdownString(B.documentation)?R.to(B.documentation):B.documentation,parameters:Array.isArray(B.parameters)?B.parameters.map(ae.to):[],activeParameter:B.activeParameter}}ie.to=re})(j=e.SignatureInformation||(e.SignatureInformation={}));var oe;(function(ie){function pe(B){return{activeSignature:B.activeSignature,activeParameter:B.activeParameter,signatures:Array.isArray(B.signatures)?B.signatures.map(j.from):[]}}ie.from=pe;function re(B){return{activeSignature:B.activeSignature,activeParameter:B.activeParameter,signatures:Array.isArray(B.signatures)?B.signatures.map(j.to):[]}}ie.to=re})(oe=e.SignatureHelp||(e.SignatureHelp={}));var he;(function(ie){function pe(B){return{text:B.text,position:i.from(B.position),kind:Te.from(B.kind??y.InlayHintKind.Other),whitespaceBefore:B.whitespaceBefore,whitespaceAfter:B.whitespaceAfter}}ie.from=pe;function re(B){const De=new y.InlayHint(B.text,i.to(B.position),Te.to(B.kind));return De.whitespaceAfter=B.whitespaceAfter,De.whitespaceBefore=B.whitespaceBefore,De}ie.to=re})(he=e.InlayHint||(e.InlayHint={}));var Te;(function(ie){function pe(B){return B}ie.from=pe;function re(B){return B}ie.to=re})(Te=e.InlayHintKind||(e.InlayHintKind={}));var Be;(function(ie){function pe(B){return{range:g.from(B.range),url:B.target,tooltip:B.tooltip}}ie.from=pe;function re(B){let De;if(B.url)try{De=typeof B.url=="string"?P.URI.parse(B.url,!0):P.URI.revive(B.url)}catch(Se){}return new y.DocumentLink(g.to(B.range),De)}ie.to=re})(Be=e.DocumentLink||(e.DocumentLink={}));var $e;(function(ie){function pe(B){const De=new y.ColorPresentation(B.label);return B.textEdit&&(De.textEdit=K.to(B.textEdit)),B.additionalTextEdits&&(De.additionalTextEdits=B.additionalTextEdits.map(Se=>K.to(Se))),De}ie.to=pe;function re(B){return{label:B.label,textEdit:B.textEdit?K.from(B.textEdit):void 0,additionalTextEdits:B.additionalTextEdits?B.additionalTextEdits.map(De=>K.from(De)):void 0}}ie.from=re})($e=e.ColorPresentation||(e.ColorPresentation={}));var Qe;(function(ie){function pe(B){return new y.Color(B[0],B[1],B[2],B[3])}ie.to=pe;function re(B){return[B.red,B.green,B.blue,B.alpha]}ie.from=re})(Qe=e.Color||(e.Color={}));var _e;(function(ie){function pe(B){return{range:g.from(B.range)}}ie.from=pe;function re(B){return new y.SelectionRange(g.to(B.range))}ie.to=re})(_e=e.SelectionRange||(e.SelectionRange={}));var nt;(function(ie){function pe(re){switch(re){case 2:return y.TextDocumentSaveReason.AfterDelay;case 1:return y.TextDocumentSaveReason.Manual;case 3:case 4:return y.TextDocumentSaveReason.FocusOut}}ie.to=pe})(nt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var H;(function(ie){function pe(B){switch(B){case y.TextEditorLineNumbersStyle.Off:return 0;case y.TextEditorLineNumbersStyle.Relative:return 2;case y.TextEditorLineNumbersStyle.On:default:return 1}}ie.from=pe;function re(B){switch(B){case 0:return y.TextEditorLineNumbersStyle.Off;case 2:return y.TextEditorLineNumbersStyle.Relative;case 1:default:return y.TextEditorLineNumbersStyle.On}}ie.to=re})(H=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var J;(function(ie){function pe(B){if(B===y.EndOfLine.CRLF)return 1;if(B===y.EndOfLine.LF)return 0}ie.from=pe;function re(B){if(B===1)return y.EndOfLine.CRLF;if(B===0)return y.EndOfLine.LF}ie.to=re})(J=e.EndOfLine||(e.EndOfLine={}));var me;(function(ie){function pe(re){if(typeof re=="object")return re.viewId;switch(re){case y.ProgressLocation.SourceControl:return 3;case y.ProgressLocation.Window:return 10;case y.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ie.from=pe})(me=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(ie){function pe(re){const B={start:re.start+1,end:re.end+1};return re.kind&&(B.kind=Ke.from(re.kind)),B}ie.from=pe})(Ne=e.FoldingRange||(e.FoldingRange={}));var Ke;(function(ie){function pe(re){if(re)switch(re){case y.FoldingRangeKind.Comment:return E.FoldingRangeKind.Comment;case y.FoldingRangeKind.Imports:return E.FoldingRangeKind.Imports;case y.FoldingRangeKind.Region:return E.FoldingRangeKind.Region}}ie.from=pe})(Ke=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ot;(function(ie){function pe(re){if(re)return{pinned:typeof re.preview=="boolean"?!re.preview:void 0,inactive:re.background,preserveFocus:re.preserveFocus,selection:typeof re.selection=="object"?g.from(re.selection):void 0,override:typeof re.override=="boolean"?n.EditorResolution.DISABLED:void 0}}ie.from=pe})(ot=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var at;(function(ie){function pe(B){return B instanceof y.RelativePattern||typeof B=="string"?B:re(B)?new y.RelativePattern(B.base,B.pattern):B}ie.from=pe;function re(B){const De=B;return De&&typeof De.base=="string"&&typeof De.pattern=="string"}})(at=e.GlobPattern||(e.GlobPattern={}));var vt;(function(ie){function pe(re){if(re){if(Array.isArray(re))return re.map(pe);if(typeof re=="string")return re;{const B=re;return{language:B.language,scheme:B.scheme,pattern:typeof B.pattern=="undefined"?void 0:at.from(B.pattern),exclusive:B.exclusive}}}else return}ie.from=pe})(vt=e.LanguageSelector||(e.LanguageSelector={}));var kt;(function(ie){function pe(B){return{start:B.start,end:B.end}}ie.from=pe;function re(B){return new y.NotebookRange(B.start,B.end)}ie.to=re})(kt=e.NotebookRange||(e.NotebookRange={}));var ht;(function(ie){function pe(B){return{timing:typeof B.runStartTime=="number"&&typeof B.runEndTime=="number"?{startTime:B.runStartTime,endTime:B.runEndTime}:void 0,executionOrder:B.executionOrder,success:B.lastRunSuccess}}ie.to=pe;function re(B){return{lastRunSuccess:B.success,runStartTime:B.timing?.startTime,runEndTime:B.timing?.endTime,executionOrder:B.executionOrder}}ie.from=re})(ht=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var yt;(function(ie){function pe(B){switch(B){case y.NotebookCellKind.Markup:return l.CellKind.Markup;case y.NotebookCellKind.Code:default:return l.CellKind.Code}}ie.from=pe;function re(B){switch(B){case l.CellKind.Markup:return y.NotebookCellKind.Markup;case l.CellKind.Code:default:return y.NotebookCellKind.Code}}ie.to=re})(yt=e.NotebookCellKind||(e.NotebookCellKind={}));var It;(function(ie){function pe(B){const De={metadata:B.metadata??Object.create(null),cells:[]};for(let Se of B.cells)y.NotebookCellData.validate(Se),De.cells.push(ft.from(Se));return De}ie.from=pe;function re(B){const De=new y.NotebookData(B.cells.map(ft.to));return(0,_.isEmptyObject)(B.metadata)||(De.metadata=B.metadata),De}ie.to=re})(It=e.NotebookData||(e.NotebookData={}));var ft;(function(ie){function pe(B){return{cellKind:yt.from(B.kind),language:B.languageId,mime:B.mime,source:B.value,metadata:B.metadata,internalMetadata:ht.from(B.executionSummary??{}),outputs:B.outputs?B.outputs.map(Et.from):[]}}ie.from=pe;function re(B){return new y.NotebookCellData(yt.to(B.cellKind),B.source,B.language,B.mime,B.outputs?B.outputs.map(Et.to):void 0,B.metadata,B.internalMetadata?ht.to(B.internalMetadata):void 0)}ie.to=re})(ft=e.NotebookCellData||(e.NotebookCellData={}));var Je;(function(ie){function pe(B){return{mime:B.mime,valueBytes:M.VSBuffer.wrap(B.data)}}ie.from=pe;function re(B){return new y.NotebookCellOutputItem(B.valueBytes.buffer,B.mime)}ie.to=re})(Je=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Et;(function(ie){function pe(B){return{outputId:B.id,items:B.items.map(Je.from),metadata:B.metadata}}ie.from=pe;function re(B){const De=B.items.map(Je.to);return new y.NotebookCellOutput(De,B.outputId,B.metadata)}ie.to=re})(Et=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Pe;(function(ie){function pe(Se){if(Se!=null){if(Se instanceof y.RelativePattern||typeof Se=="string")return Se;if(De(Se))return new y.RelativePattern(Se.base,Se.pattern);if(B(Se))return{include:at.from(Se.include)||void 0,exclude:at.from(Se.exclude)||void 0}}}ie.from=pe;function re(Se){return typeof Se=="string"?Se:De(Se)?{base:Se.base,pattern:Se.pattern}:{include:Se.include,exclude:Se.exclude}}ie.to=re;function B(Se){const qe=Se,We=at.from(qe.include);if(!(We&&We instanceof y.RelativePattern||typeof We=="string"))return!1;const tt=at.from(qe.exclude);return!!(tt&&tt instanceof y.RelativePattern||typeof tt=="string")}function De(Se){const qe=Se;return qe&&typeof qe.base=="string"&&typeof qe.pattern=="string"}})(Pe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ye;(function(ie){function pe(re){return{backgroundColor:re.backgroundColor,borderColor:re.borderColor,top:re.top?u.from(re.top):void 0}}ie.from=pe})(ye=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ce;(function(ie){function pe(re,B,De){const Se=typeof re.command=="string"?{title:"",command:re.command}:re.command;return{alignment:re.alignment===y.NotebookCellStatusBarAlignment.Left?1:2,command:B.toInternal(Se,De),text:re.text,tooltip:re.tooltip,accessibilityInformation:re.accessibilityInformation,priority:re.priority}}ie.from=pe})(Ce=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Z;(function(ie){function pe(re){return{transientOutputs:re?.transientOutputs??!1,transientCellMetadata:re?.transientCellMetadata??{},transientDocumentMetadata:re?.transientDocumentMetadata??{}}}ie.from=pe})(Z=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ce;(function(ie){function pe(B){return{uri:B.uri,provides:B.provides}}ie.from=pe;function re(B){return new y.NotebookRendererScript(P.URI.revive(B.uri),B.provides)}ie.to=re})(ce=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ge;(function(ie){function pe(B){return{message:R.fromStrict(B.message)||"",type:0,expected:B.expectedOutput,actual:B.actualOutput,location:B.location?le.from(B.location):void 0}}ie.from=pe;function re(B){const De=new y.TestMessage(typeof B.message=="string"?B.message:R.to(B.message));return De.actualOutput=B.actual,De.expectedOutput=B.expected,De.location=B.location?le.to(B.location):void 0,De}ie.to=re})(ge=e.TestMessage||(e.TestMessage={}));var fe;(function(ie){let pe;(function(re){re.Delimiter="\0"})(pe||(pe={})),ie.namespace=(re,B)=>re+"\0"+B,ie.denamespace=re=>{const B=re.indexOf("\0");return{ctrlId:re.slice(0,B),tagId:re.slice(B+1)}}})(fe=e.TestTag||(e.TestTag={}));var Ie;(function(ie){function pe(Se){const qe=(0,c.getPrivateApiFor)(Se).controllerId;return{extId:w.TestId.fromExtHostTestItem(Se,qe).toString(),label:Se.label,uri:Se.uri,tags:Se.tags.map(We=>fe.namespace(qe,We.id)),range:g.from(Se.range)||null,description:Se.description||null,error:Se.error&&R.fromStrict(Se.error)||null}}ie.from=pe;function re(Se){return{id:w.TestId.fromString(Se.extId).localId,label:Se.label,uri:P.URI.revive(Se.uri),tags:(Se.tags||[]).map(qe=>{const{tagId:We}=fe.denamespace(qe);return new y.TestTag(We)}),range:g.to(Se.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Se.description||void 0}}ie.toPlain=re;function B(Se){const qe=w.TestId.fromString(Se.extId),We=new c.TestItemImpl(qe.controllerId,qe.localId,Se.label,P.URI.revive(Se.uri));return We.range=g.to(Se.range||void 0),We.description=Se.description||void 0,We}function De(Se){let qe;for(const We of Se.tests){const tt=B(We.item);(0,c.getPrivateApiFor)(tt).parent=qe,qe=tt}return qe}ie.toItemFromContext=De})(Ie=e.TestItem||(e.TestItem={})),function(ie){function pe(B){return{id:B.id}}ie.from=pe;function re(B){return new y.TestTag(B.id)}ie.to=re}(fe=e.TestTag||(e.TestTag={}));var xe;(function(ie){const pe=(B,De)=>{const Se={...Ie.toPlain(B.item),parent:void 0,taskStates:B.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(We=>We.type===0).map(ge.to)})),children:B.children.map(qe=>De.get(qe)).filter(_.isDefined).map(qe=>pe(qe,De))};for(const qe of Se.children)qe.parent=Se;return Se};function re(B){const De=[],Se=new Map;for(const qe of B.items)Se.set(qe.item.extId,qe),B.request.targets.some(We=>We.controllerId===qe.controllerId&&We.testIds.includes(qe.item.extId))&&De.push(qe);return{completedAt:B.completedAt,results:De.map(qe=>pe(qe,Se))}}ie.to=re})(xe=e.TestResults||(e.TestResults={}));var Le;(function(ie){function pe(Se){return{covered:Se.covered,total:Se.covered}}function re(Se){return"line"in Se?i.from(Se):g.from(Se)}function B(Se){return"branches"in Se?{count:Se.executionCount,location:re(Se.location),type:1,branches:Se.branches.length?Se.branches.map(qe=>({count:qe.executionCount,location:qe.location&&re(qe.location)})):void 0}:{type:0,count:Se.executionCount,location:re(Se.location)}}ie.fromDetailed=B;function De(Se){return{uri:Se.uri,statement:pe(Se.statementCoverage),branch:Se.branchCoverage&&pe(Se.branchCoverage),function:Se.functionCoverage&&pe(Se.functionCoverage),details:Se.detailedCoverage?.map(B)}}ie.fromFile=De})(Le=e.TestCoverage||(e.TestCoverage={}));var Ve;(function(ie){function pe(re){switch(re){case 1:return y.CodeActionTriggerKind.Invoke;case 2:return y.CodeActionTriggerKind.Automatic}}ie.to=pe})(Ve=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ze;(function(ie){function pe(B){const De=new y.TypeHierarchyItem(Q.to(B.kind),B.name,B.detail||"",P.URI.revive(B.uri),g.to(B.range),g.to(B.selectionRange));return De._sessionId=B._sessionId,De._itemId=B._itemId,De}ie.to=pe;function re(B,De,Se){if(De=De??B._sessionId,Se=Se??B._itemId,De===void 0||Se===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Se,kind:Q.from(B.kind),name:B.name,detail:B.detail??"",uri:B.uri,range:g.from(B.range),selectionRange:g.from(B.selectionRange),tags:B.tags?.map($.from)}}ie.from=re})(Ze=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(we[169],be([0,1,2,16,7,8,230]),function(ne,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(P,t,E,n={timeout:1500,errors:3}){this._logService=P,this._documents=t,this._mainThreadBulkEdits=E,this._thresholds=n,this._callbacks=new F.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(t,E,n)=>{const c={dispose:this._callbacks.push([t,E,P])};return Array.isArray(n)&&n.push(c),c}}async $participateInSave(P,t){const E=h.URI.revive(P);let n=!1;const d=setTimeout(()=>n=!0,this._thresholds.timeout),c=[];try{for(let l of[...this._callbacks]){if(n)break;const w=this._documents.getDocument(E),I=await this._deliverEventAsyncAndBlameBadListeners(l,{document:w,reason:T.TextDocumentSaveReason.to(t)});c.push(I)}}finally{clearTimeout(d)}return c}_deliverEventAsyncAndBlameBadListeners([P,t,E],n){const d=this._badListeners.get(P);return typeof d=="number"&&d>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(E,P,t,n).then(()=>!0,c=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' threw ERROR`),this._logService.error(c),!(c instanceof Error)||c.message!=="concurrent_edits"){const l=this._badListeners.get(P);this._badListeners.set(P,l?l+1:1),typeof l=="number"&&l>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,t,E,n){const d=[],c=Date.now(),{document:l,reason:w}=n,{version:I}=l,y=Object.freeze({document:l,reason:w,waitUntil(s){if(Object.isFrozen(d))throw(0,M.illegalState)("waitUntil can not be called async");d.push(Promise.resolve(s))}});try{t.apply(E,[y])}catch(s){return Promise.reject(s)}return Object.freeze(d),new Promise((s,g)=>{const k=setTimeout(()=>g(new Error("timeout")),this._thresholds.timeout);return Promise.all(d).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(k),s(i)}).catch(i=>{clearTimeout(k),g(i)})}).then(s=>{const g={edits:[]};for(const k of s)if(Array.isArray(k)&&k.every(i=>i instanceof b.TextEdit))for(const{newText:i,newEol:a,range:r}of k)g.edits.push({_type:2,resource:l.uri,edit:{range:r&&T.Range.from(r),text:i,eol:a&&T.EndOfLine.from(a)}});if(g.edits.length!==0)return I===l.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(g):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(we[68],be([0,1,8,2,3,4]),function(ne,e,h,M,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,T.createDecorator)("IExtHostEditorTabs");class F{constructor(){this._onDidChangeTabs=new b.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new b.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[]}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(_){let P=-1;this._tabs=_.map((E,n)=>(E.isActive&&(P=n),Object.freeze({label:E.label,viewColumn:h.ViewColumn.to(E.viewColumn),resource:M.URI.revive(E.resource),viewId:E.editorId,isActive:E.isActive})));const t=this._activeTab;this._activeTab=P===-1?void 0:this._tabs[P],this._activeTab!==t&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}}e.ExtHostEditorTabs=F}),define(we[170],be([0,1,3,27,2,8,7]),function(ne,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(t,E,n,d,c){this._onDidCreate=new h.Emitter,this._onDidChange=new h.Emitter,this._onDidDelete=new h.Emitter,this._config=0,n&&(this._config+=1),d&&(this._config+=2),c&&(this._config+=4);const l=(0,M.parse)(E),w=t(I=>{if(!n)for(let y of I.created){const s=b.URI.revive(y);l(s.fsPath)&&this._onDidCreate.fire(s)}if(!d)for(let y of I.changed){const s=b.URI.revive(y);l(s.fsPath)&&this._onDidChange.fire(s)}if(!c)for(let y of I.deleted){const s=b.URI.revive(y);l(s.fsPath)&&this._onDidDelete.fire(s)}});this._disposable=F.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class _{constructor(t,E,n){this._logService=E,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new h.Emitter,this._onDidRenameFile=new h.Emitter,this._onDidCreateFile=new h.Emitter,this._onDidDeleteFile=new h.Emitter,this._onWillRenameFile=new h.AsyncEmitter,this._onWillCreateFile=new h.AsyncEmitter,this._onWillDeleteFile=new h.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(t,E,n,d){return new D(this._onFileSystemEvent.event,t,E,n,d)}$onFileEvent(t){this._onFileSystemEvent.fire(t)}$onDidRunFileOperation(t,E){switch(t){case 2:this._onDidRenameFile.fire(Object.freeze({files:E.map(n=>({oldUri:b.URI.revive(n.source),newUri:b.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:E.map(n=>b.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:E.map(n=>b.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(t){return this._createWillExecuteEvent(t,this._onWillRenameFile)}getOnWillCreateFileEvent(t){return this._createWillExecuteEvent(t,this._onWillCreateFile)}getOnWillDeleteFileEvent(t){return this._createWillExecuteEvent(t,this._onWillDeleteFile)}_createWillExecuteEvent(t,E){return(n,d,c)=>{const l=function(I){n.call(d,I)};return l.extension=t,E.event(l,void 0,c)}}async $onWillRunFileOperation(t,E,n,d){switch(t){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:E.map(c=>({oldUri:b.URI.revive(c.source),newUri:b.URI.revive(c.target)}))},n,d);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:E.map(c=>b.URI.revive(c.target))},n,d);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:E.map(c=>b.URI.revive(c.target))},n,d)}}async _fireWillEvent(t,E,n,d){const c=new Set,l=[];if(await t.fireAsync(E,d,async(I,y)=>{const s=Date.now(),g=await Promise.resolve(I);g instanceof F.WorkspaceEdit&&(l.push(g),c.add(y.extension.displayName??y.extension.identifier.value)),Date.now()-s>n&&this._logService.warn("SLOW file-participant",y.extension.identifier)}),d.isCancellationRequested||l.length===0)return;const w={edits:[]};for(let I of l){let{edits:y}=T.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(y)}return{edit:w,extensionNames:Array.from(c)}}}e.ExtHostFileSystemEventService=_}),define(we[171],be([0,1,11,22,2,8,7,89]),function(ne,e,h,M,b,T,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(n,d,c,l){this.start=n,this.deletedCount=d,this.deletedItems=c,this.items=l}static asApiEvents(n){return n.map(d=>({start:d.start,deletedCount:d.deletedCount,deletedItems:d.deletedItems,items:d.items.map(c=>c.apiCell)}))}}class P{constructor(n,d,c){this.notebook=n,this._extHostDocument=d,this._cellData=c,this.handle=c.handle,this.uri=b.URI.revive(c.uri),this.cellKind=c.cellKind,this._outputs=c.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=c.internalMetadata??{},this._metadata=Object.freeze(c.metadata??{}),this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(c.internalMetadata??{}))}static asModelAddData(n,d){return{EOL:d.eol,lines:d.source,modeId:d.language,uri:d.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,d=this._extHostDocument.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:d.document,get mime(){return n._mime},set mime(c){n._mime=c},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(T.NotebookCellOutput.to)}setOutputItems(n,d,c){const l=c.map(T.NotebookCellOutputItem.to),w=this._outputs.find(I=>I.id===n);w&&(d||(w.items.length=0),w.items.push(...l))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=P;class t{constructor(n,d,c,l,w,I){this._proxy=n,this._textDocumentsAndEditors=d,this._textDocuments=c,this._emitter=l,this.uri=w,this.handle=t._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=I.viewType,this._metadata=Object.freeze(I.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,I.cells]],!0),this._versionId=I.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===h.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(d){return d=n._validateIndex(d),n._cells[d].apiCell},getCells(d){return(d?n._getCells(d):n._cells).map(l=>l.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,d){this._versionId=n.versionId,this._isDirty=d;for(const c of n.rawEvents)c.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(c.changes,!1):c.kind===D.NotebookCellsChangeType.Move?this._moveCell(c.index,c.newIdx):c.kind===D.NotebookCellsChangeType.Output?this._setCellOutputs(c.index,c.outputs):c.kind===D.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(c.index,c.outputId,c.append,c.outputItems):c.kind===D.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(c.index,c.language):c.kind===D.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(c.index,c.mime):c.kind===D.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(c.index,c.metadata):c.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(c.index,c.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let d=n.start|0,c=n.end|0;return d<0&&(d=0),c>this._cells.length&&(c=this._cells.length),n.with({start:d,end:c})}_getCells(n){n=this._validateRange(n);const d=[];for(let c=n.start;c<n.end;c++)d.push(this._cells[c]);return d}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,d){if(this._disposed)return;const c=[],l=[],w=[];n.reverse().forEach(I=>{const s=I[2].map(i=>{const a=new P(this,this._textDocumentsAndEditors,i);return d||l.push(P.asModelAddData(this.apiNotebook,i)),a}),g=new _(I[0],I[1],[],s),k=this._cells.splice(I[0],I[1],...s);for(const i of k)w.push(i.uri),g.deletedItems.push(i.apiCell);c.push(g)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:w}),d||this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(c)}))}_moveCell(n,d){const c=this._cells.splice(n,1);this._cells.splice(d,0,...c);const l=[new _(n,1,c.map(w=>w.apiCell),[]),new _(d,0,[],c)];this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(l)}))}_setCellOutputs(n,d){const c=this._cells[n];c.setOutputs(d),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[c.apiCell]}))}_setCellOutputItems(n,d,c,l){const w=this._cells[n];w.setOutputItems(d,c,l),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[w.apiCell]}))}_changeCellLanguage(n,d){const c=this._cells[n];c.apiCell.document.languageId!==d&&this._textDocuments.$acceptModelModeChanged(c.uri,d)}_changeCellMime(n,d){const c=this._cells[n];c.apiCell.mime=d}_changeCellMetadata(n,d){const c=this._cells[n],l=c.apiCell.metadata;c.setMetadata(d);const w=c.apiCell.metadata;(0,M.equals)(l,w)||this._emitter.emitCellMetadataChange((0,M.deepFreeze)({document:this.apiNotebook,cell:c.apiCell}))}_changeCellInternalMetadata(n,d){const c=this._cells[n],l=c.internalMetadata;if(c.setInternalMetadata(d),l.runState!==d.runState){const w=d.runState??F.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,M.deepFreeze)({document:this.apiNotebook,cell:c.apiCell,state:w}))}}getCellFromApiCell(n){return this._cells.find(d=>d.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(d=>d.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=t,t._handlePool=0}),define(we[93],be([0,1,7,8,16]),function(ne,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:P})}replaceCells(_,P,t){this._throwIfFinalized(),!(_===P&&t.length===0)&&this._collectedEdits.push({editType:1,index:_,count:P-_,cells:t.map(M.NotebookCellData.from)})}}class F{constructor(_,P,t,E,n,d){this.id=_,this._proxy=P,this.notebookData=t,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=E,this._viewColumn=d}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(P){if(!Array.isArray(P)||!P.every(h.NotebookRange.isNotebookRange))throw(0,b.illegalArgument)("selections");_._selections=P,_._trySetSelections(P)},get visibleRanges(){return _._visibleRanges},revealRange(P,t){_._proxy.$tryRevealRange(_.id,M.NotebookRange.from(P),t??h.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(P){const t=new T(this.document.version);return P(t),_._applyEdit(t.finalize())},setDecorations(P,t){return _.setDecorations(P,t)}},F.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(M.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const P=[];let t=-1;for(let E=0;E<_.cellEdits.length;E++){if(t<0){P.push(_.cellEdits[E]),t++;continue}const d=P[t],c=_.cellEdits[E];if(d.editType===1&&c.editType===1&&d.index===c.index){d.cells.push(..._.cellEdits[E].cells),d.count+=_.cellEdits[E].count;continue}P.push(_.cellEdits[E]),t++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,P)}setDecorations(_,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return P.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,M.NotebookRange.from(P),_.key)}}e.ExtHostNotebookEditor=F,F.apiEditorsToExtHost=new WeakMap}),define(we[172],be([0,1,8,147,126,21,52]),function(ne,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(E){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=E}withProgress(E,n,d){const c=this._handles++,{title:l,location:w,cancellable:I}=n,y={label:(0,b.localize)(0,null,E.displayName||E.name),id:E.identifier.value};return this._proxy.$startProgress(c,{location:h.ProgressLocation.from(w),title:l,source:y,cancellable:I},E),this._withProgress(c,d,!!I)}_withProgress(E,n,d){let c;d&&(c=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(E,c));const l=I=>{this._proxy.$progressEnd(I),this._mapHandleToCancellationSource.delete(I),c&&c.dispose()};let w;try{w=n(new P(this._proxy,E),d&&c?c.token:T.CancellationToken.None)}catch(I){throw l(E),I}return w.then(I=>l(E),I=>l(E)),w}$acceptProgressCanceled(E){const n=this._mapHandleToCancellationSource.get(E);n&&(n.cancel(),this._mapHandleToCancellationSource.delete(E))}}e.ExtHostProgress=D;function _(t,E){return t.message=E.message,typeof E.increment=="number"&&(typeof t.increment=="number"?t.increment+=E.increment:t.increment=E.increment),t}class P extends M.Progress{constructor(E,n){super(d=>this.throttledReport(d));this._proxy=E,this._handle=n}throttledReport(E){this._proxy.$progressReport(this._handle,E)}}Ue([(0,F.throttle)(100,(t,E)=>_(t,E),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(we[94],be([0,1,40,16,53,8,7]),function(ne,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(n,d,c){const l=D._Keys.nextId();n.$registerTextEditorDecorationType(d.identifier,l,T.DecorationRenderOptions.from(c)),this.value=Object.freeze({key:l,dispose(){n.$removeTextEditorDecorationType(l)}})}}e.TextEditorDecorationType=D,D._Keys=new b.IdGenerator("TextEditorDecorationType");class _{constructor(n,d){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=d.undoStopBefore,this._undoStopAfter=d.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,d){this._throwIfFinalized();let c=null;if(n instanceof F.Position)c=new F.Range(n,n);else if(n instanceof F.Range)c=n;else throw new Error("Unrecognized location");this._pushEdit(c,d,!1)}insert(n,d){this._throwIfFinalized(),this._pushEdit(new F.Range(n,n),d,!0)}delete(n){this._throwIfFinalized();let d=null;if(n instanceof F.Range)d=n;else throw new Error("Unrecognized location");this._pushEdit(d,null,!0)}_pushEdit(n,d,c){const l=this._document.validateRange(n);this._collectedEdits.push({range:l,text:d,forceMoveMarkers:c})}setEndOfLine(n){if(this._throwIfFinalized(),n!==F.EndOfLine.LF&&n!==F.EndOfLine.CRLF)throw(0,M.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=_;class P{constructor(n,d,c,l){this._proxy=n,this._id=d,this._accept(c),this._logService=l;const w=this;this.value={get tabSize(){return w._tabSize},set tabSize(I){w._setTabSize(I)},get insertSpaces(){return w._insertSpaces},set insertSpaces(I){w._setInsertSpaces(I)},get cursorStyle(){return w._cursorStyle},set cursorStyle(I){w._setCursorStyle(I)},get lineNumbers(){return w._lineNumbers},set lineNumbers(I){w._setLineNumbers(I)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const d=Math.floor(n);return d>0?d:null}if(typeof n=="string"){const d=parseInt(n,10);return isNaN(d)?null:d>0?d:null}return null}_setTabSize(n){const d=this._validateTabSize(n);if(d!==null){if(typeof d=="number"){if(this._tabSize===d)return;this._tabSize=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:d}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const d=this._validateInsertSpaces(n);if(typeof d=="boolean"){if(this._insertSpaces===d)return;this._insertSpaces=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:d}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(n)})))}assign(n){const d={};let c=!1;if(typeof n.tabSize!="undefined"){const l=this._validateTabSize(n.tabSize);l==="auto"?(c=!0,d.tabSize=l):typeof l=="number"&&this._tabSize!==l&&(this._tabSize=l,c=!0,d.tabSize=l)}if(typeof n.insertSpaces!="undefined"){const l=this._validateInsertSpaces(n.insertSpaces);l==="auto"?(c=!0,d.insertSpaces=l):this._insertSpaces!==l&&(this._insertSpaces=l,c=!0,d.insertSpaces=l)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,c=!0,d.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,c=!0,d.lineNumbers=T.TextEditorLineNumbersStyle.from(n.lineNumbers)),c&&this._warnOnError(this._proxy.$trySetOptions(this._id,d))}_warnOnError(n){n.catch(d=>this._logService.warn(d))}}e.ExtHostTextEditorOptions=P;class t{constructor(n,d,c,l,w,I,y,s){this.id=n,this._proxy=d,this._logService=c,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=w,this._options=new P(this._proxy,this.id,I,c),this._visibleRanges=y,this._viewColumn=s;const g=this;this.value=Object.freeze({get document(){return l.getValue()},set document(k){throw(0,M.readonly)("document")},get selection(){return g._selections&&g._selections[0]},set selection(k){if(!(k instanceof F.Selection))throw(0,M.illegalArgument)("selection");g._selections=[k],g._trySetSelection()},get selections(){return g._selections},set selections(k){if(!Array.isArray(k)||k.some(i=>!(i instanceof F.Selection)))throw(0,M.illegalArgument)("selections");g._selections=k,g._trySetSelection()},get visibleRanges(){return g._visibleRanges},set visibleRanges(k){throw(0,M.readonly)("visibleRanges")},get options(){return g._options.value},set options(k){g._disposed||g._options.assign(k)},get viewColumn(){return g._viewColumn},set viewColumn(k){throw(0,M.readonly)("viewColumn")},edit(k,i={undoStopBefore:!0,undoStopAfter:!0}){if(g._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const a=new _(l.getValue(),i);return k(a),g._applyEdit(a)},insertSnippet(k,i,a={undoStopBefore:!0,undoStopAfter:!0}){if(g._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!i||Array.isArray(i)&&i.length===0)r=g._selections.map(o=>T.Range.from(o));else if(i instanceof F.Position){const{lineNumber:o,column:f}=T.Position.from(i);r=[{startLineNumber:o,startColumn:f,endLineNumber:o,endColumn:f}]}else if(i instanceof F.Range)r=[T.Range.from(i)];else{r=[];for(const o of i)if(o instanceof F.Range)r.push(T.Range.from(o));else{const{lineNumber:f,column:m}=T.Position.from(o);r.push({startLineNumber:f,startColumn:m,endLineNumber:f,endColumn:m})}}return d.$tryInsertSnippet(n,k.value,r,a)},setDecorations(k,i){const a=i.length===0;a&&!g._hasDecorationsForKey.has(k.key)||(a?g._hasDecorationsForKey.delete(k.key):g._hasDecorationsForKey.add(k.key),g._runOnProxy(()=>{if(T.isDecorationOptionsArr(i))return d.$trySetDecorations(n,k.key,T.fromRangeOrRangeWithMessage(i));{const r=new Array(4*i.length);for(let o=0,f=i.length;o<f;o++){const m=i[o];r[4*o]=m.start.line+1,r[4*o+1]=m.start.character+1,r[4*o+2]=m.end.line+1,r[4*o+3]=m.end.character+1}return d.$trySetDecorationsFast(n,k.key,r)}}))},revealRange(k,i){g._runOnProxy(()=>d.$tryRevealRange(n,T.Range.from(k),i||F.TextEditorRevealType.Default))},show(k){d.$tryShowEditor(n,T.ViewColumn.from(k))},hide(){d.$tryHideEditor(n)}})}dispose(){(0,h.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,h.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,h.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,h.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,h.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const d=n.finalize();if(d.edits.length===0&&!d.setEndOfLine)return Promise.resolve(!0);const c=d.edits.map(w=>w.range);c.sort((w,I)=>w.end.line===I.end.line?w.end.character===I.end.character?w.start.line===I.start.line?w.start.character-I.start.character:w.start.line-I.start.line:w.end.character-I.end.character:w.end.line-I.end.line);for(let w=0,I=c.length-1;w<I;w++){const y=c[w].end;if(c[w+1].start.isBefore(y))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=d.edits.map(w=>({range:T.Range.from(w.range),text:w.text,forceMoveMarkers:w.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,d.documentVersionId,l,{setEndOfLine:typeof d.setEndOfLine=="number"?T.EndOfLine.from(d.setEndOfLine):void 0,undoStopBefore:d.undoStopBefore,undoStopAfter:d.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,d=>(d instanceof Error&&d.name==="DISPOSED"||this._logService.warn(d),null))}}e.ExtHostTextEditor=t}),define(we[173],be([0,1,129,24,2,3,6,161,14,7,10,13,8,21,158]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function l(y,s){if((0,t.isString)(y))return{label:y};if(y&&typeof y=="object"&&typeof y.label=="string"){let g;return Array.isArray(y.highlights)&&(g=y.highlights.filter(k=>k.length===2&&typeof k[0]=="number"&&typeof k[1]=="number"),g=g.length?g:void 0),{label:y.label,highlights:g}}}class w{constructor(s,g,k){this._proxy=s,this.commands=g,this.logService=k,this.treeViews=new Map;function i(a){return a&&a.$treeViewId&&a.$treeItemHandle}g.registerArgumentProcessor({processArgument:a=>i(a)?this.convertArgument(a):Array.isArray(a)&&a.length>0?a.map(r=>i(r)?this.convertArgument(r):r):a})}registerTreeDataProvider(s,g,k){const i=this.createTreeView(s,{treeDataProvider:g},k);return{dispose:()=>i.dispose()}}createTreeView(s,g,k){if(!g||!g.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=g.dragAndDropController!==void 0,a=this._proxy.$registerTreeViewDataProvider(s,{showCollapseAll:!!g.showCollapseAll,canSelectMany:!!g.canSelectMany,canDragAndDrop:i}),r=this.createExtHostTreeView(s,g,k);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(o){r.message=o},get title(){return r.title},set title(o){r.title=o},get description(){return r.description},set description(o){r.description=o},reveal:(o,f)=>r.reveal(o,f),dispose:async()=>{await a,this.treeViews.delete(s),r.dispose()}}}$getChildren(s,g){const k=this.treeViews.get(s);return k?k.getChildren(g):Promise.reject(new Error((0,h.localize)(0,null,s)))}async $onDrop(s,g,k){const i=this.treeViews.get(s);if(!i)return Promise.reject(new Error((0,h.localize)(1,null,s)));const a=c.TreeDataTransferConverter.toITreeDataTransfer(g);if(a.items.has(D.TREE_ITEM_DATA_TRANSFER_TYPE)){const o=JSON.parse(await a.items.get(D.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(f=>i.getExtensionElement(f)).filter(f=>!!f);o.length>0?a.items.set(D.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(o)}):a.items.delete(D.TREE_ITEM_DATA_TRANSFER_TYPE)}return i.onDrop(a,k)}async $hasResolve(s){const g=this.treeViews.get(s);if(!g)throw new Error((0,h.localize)(2,null,s));return g.hasResolve}$resolve(s,g,k){const i=this.treeViews.get(s);if(!i)throw new Error((0,h.localize)(3,null,s));return i.resolveTreeItem(g,k)}$setExpanded(s,g,k){const i=this.treeViews.get(s);if(!i)throw new Error((0,h.localize)(4,null,s));i.setExpanded(g,k)}$setSelection(s,g){const k=this.treeViews.get(s);if(!k)throw new Error((0,h.localize)(5,null,s));k.setSelection(g)}$setVisible(s,g){const k=this.treeViews.get(s);if(!k)throw new Error((0,h.localize)(6,null,s));k.setVisible(g)}createExtHostTreeView(s,g,k){const i=new I(s,g,this._proxy,this.commands.converter,this.logService,k);return this.treeViews.set(s,i),i}convertArgument(s){const g=this.treeViews.get(s.$treeViewId);return g?g.getExtensionElement(s.$treeItemHandle):null}}e.ExtHostTreeViews=w;class I extends F.Disposable{constructor(s,g,k,i,a,r){super();if(this.viewId=s,this.proxy=k,this.commands=i,this.logService=a,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new d.CancellationTokenSource,r.contributes&&r.contributes.views)for(const m in r.contributes.views)for(const v of r.contributes.views[m])v.id===s&&(this._title=v.name);this.dataProvider=g.treeDataProvider,this.dndController=g.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(m=>this._onDidChangeData.fire({message:!1,element:m}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(m=>this._onDidChangeData.fire({message:!1,element:m})));let o,f;this._register(T.Event.debounce(this._onDidChangeData.event,(m,v)=>(m||(m={message:!1,elements:[]}),v.element!==!1&&(o||(o=new Promise(C=>f=C),this.refreshPromise=this.refreshPromise.then(()=>o)),Array.isArray(v.element)?m.elements.push(...v.element):m.elements.push(v.element)),v.message&&(m.message=!0),m),200,!0)(({message:m,elements:v})=>{v.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const C=f;return o=null,this.refresh(v).then(()=>C())})),m&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(s=>this.getExtensionElement(s)).filter(s=>!(0,t.isUndefinedOrNull)(s))}async getChildren(s){const g=s?this.getExtensionElement(s):void 0;if(s&&!g)return this.logService.error(`No tree item with id '${s}' found.`),Promise.resolve([]);let k=this.getChildrenNodes(s);return k||(k=await this.fetchChildrenNodes(g)),k?k.map(i=>i.item):void 0}getExtensionElement(s){return this.elements.get(s)}reveal(s,g){g=g||{select:!0,focus:!1};const k=(0,t.isUndefinedOrNull)(g.select)?!0:g.select,i=(0,t.isUndefinedOrNull)(g.focus)?!1:g.focus,a=(0,t.isUndefinedOrNull)(g.expand)?!1:g.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):s?this.refreshPromise.then(()=>this.resolveUnknownParentChain(s)).then(r=>this.resolveTreeNode(s,r[r.length-1]).then(o=>this.proxy.$reveal(this.viewId,{item:o.item,parentChain:r.map(f=>f.item)},{select:k,focus:i,expand:a})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:k,focus:i,expand:a})}get message(){return this._message}set message(s){this._message=s,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(s){this._title=s,this.proxy.$setTitle(this.viewId,s,this._description)}get description(){return this._description}set description(s){this._description=s,this.proxy.$setTitle(this.viewId,this._title,s)}setExpanded(s,g){const k=this.getExtensionElement(s);k&&(g?this._onDidExpandElement.fire(Object.freeze({element:k})):this._onDidCollapseElement.fire(Object.freeze({element:k})))}setSelection(s){(0,E.equals)(this._selectedHandles,s)||(this._selectedHandles=s,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(s){s!==this._visible&&(this._visible=s,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(s,g){const k=this.getExtensionElement(g);if(!!k)return(0,_.asPromise)(()=>this.dndController?.onDrop(s,k))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(s,g){if(!this.dataProvider.resolveTreeItem)return;const k=this.elements.get(s);if(k){const i=this.nodes.get(k);if(i){const a=await this.dataProvider.resolveTreeItem(i.extensionItem,k,g)??i.extensionItem;return i.item.tooltip=this.getTooltip(a.tooltip),i.item.command=this.getCommand(i.disposableStore,a.command),i.item}}}resolveUnknownParentChain(s){return this.resolveParent(s).then(g=>g?this.resolveUnknownParentChain(g).then(k=>this.resolveTreeNode(g,k[k.length-1]).then(i=>(k.push(i),k))):Promise.resolve([]))}resolveParent(s){const g=this.nodes.get(s);return g?Promise.resolve(g.parent?this.elements.get(g.parent.item.handle):void 0):(0,_.asPromise)(()=>this.dataProvider.getParent(s))}resolveTreeNode(s,g){const k=this.nodes.get(s);return k?Promise.resolve(k):(0,_.asPromise)(()=>this.dataProvider.getTreeItem(s)).then(i=>this.createHandle(s,i,g,!0)).then(i=>this.getChildren(g?g.item.handle:void 0).then(()=>{const a=this.getExtensionElement(i);if(a){const r=this.nodes.get(a);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}getChildrenNodes(s){if(s){let g;if(typeof s=="string"){const k=this.getExtensionElement(s);g=k?this.nodes.get(k):void 0}else g=s;return g&&g.children||void 0}return this.roots}async fetchChildrenNodes(s){this.clearChildren(s);const g=new d.CancellationTokenSource(this._refreshCancellationSource.token);try{const k=s?this.nodes.get(s):void 0,i=await this.dataProvider.getChildren(s);if(g.token.isCancellationRequested)return;const a=await Promise.all((0,E.coalesce)(i||[]).map(async r=>{const o=await this.dataProvider.getTreeItem(r);return o&&!g.token.isCancellationRequested?this.createAndRegisterTreeNode(r,o,k):null}));return g.token.isCancellationRequested?void 0:(0,E.coalesce)(a)}finally{g.dispose()}}refresh(s){if(s.some(k=>!k))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new d.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const k=this.getHandlesToRefresh(s);if(k.length)return this.refreshHandles(k)}return Promise.resolve(void 0)}getHandlesToRefresh(s){const g=new Set,k=s.map(a=>this.nodes.get(a));for(const a of k)if(a&&!g.has(a.item.handle)){let r=a;for(;r&&r.parent&&k.findIndex(o=>r&&r.parent&&o&&o.item.handle===r.parent.item.handle)===-1;){const o=this.elements.get(r.parent.item.handle);r=o?this.nodes.get(o):void 0}r&&!r.parent&&g.add(a.item.handle)}const i=[];return g.forEach(a=>{const r=this.elements.get(a);if(r){const o=this.nodes.get(r);o&&(!o.parent||!g.has(o.parent.item.handle))&&i.push(a)}}),i}refreshHandles(s){const g={};return Promise.all(s.map(k=>this.refreshNode(k).then(i=>{i&&(g[k]=i.item)}))).then(()=>Object.keys(g).length?this.proxy.$refresh(this.viewId,g):void 0)}refreshNode(s){const g=this.getExtensionElement(s);if(g){const k=this.nodes.get(g);if(k)return this.clearChildren(g),(0,_.asPromise)(()=>this.dataProvider.getTreeItem(g)).then(i=>{if(i){const a=this.createTreeNode(g,i,k.parent);return this.updateNodeCache(g,a,k,k.parent),k.dispose(),a}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(s,g,k){const i=this.createTreeNode(s,g,k);if(g.id&&this.elements.has(i.item.handle))throw new Error((0,h.localize)(7,null,g.id));return this.addNodeToCache(s,i),this.addNodeToParentCache(i,k),i}getTooltip(s){return P.MarkdownString.isMarkdownString(s)?n.MarkdownString.from(s):s}getCommand(s,g){return g?this.commands.toInternal(g,s):void 0}createTreeNode(s,g,k){const i=new F.DisposableStore,a=this.createHandle(s,g,k),r=this.getLightIconPath(g);return{item:{handle:a,parentHandle:k?k.item.handle:void 0,label:l(g.label,this.extension),description:g.description,resourceUri:g.resourceUri,tooltip:this.getTooltip(g.tooltip),command:this.getCommand(i,g.command),contextValue:g.contextValue,icon:r,iconDark:this.getDarkIconPath(g)||r,themeIcon:this.getThemeIcon(g),collapsibleState:(0,t.isUndefinedOrNull)(g.collapsibleState)?P.TreeItemCollapsibleState.None:g.collapsibleState,accessibilityInformation:g.accessibilityInformation},extensionItem:g,parent:k,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(s){return s.iconPath instanceof P.ThemeIcon?s.iconPath:void 0}createHandle(s,{id:g,label:k,resourceUri:i},a,r){if(g)return`${I.ID_HANDLE_PREFIX}/${g}`;const o=l(k,this.extension),f=a?a.item.handle:I.LABEL_HANDLE_PREFIX;let m=o?o.label:i?(0,M.basename)(i):"";m=m.indexOf("/")!==-1?m.replace("/","//"):m;const v=this.nodes.has(s)?this.nodes.get(s).item.handle:void 0,C=this.getChildrenNodes(a)||[];let R,p=0;do{if(R=`${f}/${p}:${m}`,r||!this.elements.has(R)||v===R)break;p++}while(p<=C.length);return R}getLightIconPath(s){if(s.iconPath&&!(s.iconPath instanceof P.ThemeIcon))return typeof s.iconPath=="string"||b.URI.isUri(s.iconPath)?this.getIconPath(s.iconPath):this.getIconPath(s.iconPath.light)}getDarkIconPath(s){if(s.iconPath&&!(s.iconPath instanceof P.ThemeIcon)&&s.iconPath.dark)return this.getIconPath(s.iconPath.dark)}getIconPath(s){return b.URI.isUri(s)?s:b.URI.file(s)}addNodeToCache(s,g){this.elements.set(g.item.handle,s),this.nodes.set(s,g)}updateNodeCache(s,g,k,i){this.elements.delete(g.item.handle),this.nodes.delete(s),g.item.handle!==k.item.handle&&this.elements.delete(k.item.handle),this.addNodeToCache(s,g);const a=this.getChildrenNodes(i)||[],r=a.filter(o=>o.item.handle===k.item.handle)[0];r&&a.splice(a.indexOf(r),1,g)}addNodeToParentCache(s,g){g?(g.children||(g.children=[]),g.children.push(s)):(this.roots||(this.roots=[]),this.roots.push(s))}clearChildren(s){if(s){const g=this.nodes.get(s);if(g){if(g.children)for(const k of g.children){const i=this.elements.get(k.item.handle);i&&this.clear(i)}g.children=void 0}}else this.clearAll()}clear(s){const g=this.nodes.get(s);if(g){if(g.children)for(const k of g.children){const i=this.elements.get(k.item.handle);i&&this.clear(i)}this.nodes.delete(s),this.elements.delete(g.item.handle),g.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(s=>s.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}I.LABEL_HANDLE_PREFIX="0",I.ID_HANDLE_PREFIX="1"}),define(we[174],be([0,1,14,3,6,10,46,8,90,67]),function(ne,e,h,M,b,T,F,D,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class t extends b.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new h.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new M.Emitter),this.root=new F.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const d of this.tree.values())this.updateExpandability(d)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const d=this.diff[this.diff.length-1];if(d&&n[0]===1){if(d[0]===1&&d[1].extId===n[1].extId){(0,_.applyTestItemUpdate)(d[1],n[1]);return}if(d[0]===0&&d[1].item.extId===n[1].extId){(0,_.applyTestItemUpdate)(d[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,d){const c=this.tree.get(n);if(!!c){if((c.expandLevels===void 0||d>c.expandLevels)&&(c.expandLevels=d),c.expand===1){const l=this.resolveChildren(c);return l.isOpen()?this.expandChildren(c,d-1):l.wait().then(()=>this.expandChildren(c,d-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.expandChildren(c,d-1)):this.expandChildren(c,d-1)}}dispose(){for(const n of this.tree.values())(0,F.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,d){switch(d.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(n.fullId,d.id));break;case 0:this.upsertItem(d.item,n);break;case 4:for(const y of d.ops)this.onTestItemEvent(n,y);break;case 3:const{key:c,value:l,previous:w}=d,I=n.fullId.toString();switch(c){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(l,w,I);break;case"range":this.pushDiff([1,{extId:I,item:{range:D.Range.from(l)}}]);break;case"error":this.pushDiff([1,{extId:I,item:{error:D.MarkdownString.fromStrict(l)||null}}]);break;default:this.pushDiff([1,{extId:I,item:{[c]:l??null}}]);break}break;default:(0,T.assertNever)(d)}}upsertItem(n,d){if(!(n instanceof F.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const c=P.TestId.fromExtHostTestItem(n,this.root.id,d?.actual),l=(0,F.getPrivateApiFor)(n);l.parent&&l.parent!==d?.actual&&l.parent.children.delete(n.id);let w=this.tree.get(c.toString());if(!w){w={fullId:c,actual:n,parent:d?c.parentId:null,expandLevels:d?.expandLevels?d.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(w.fullId.toString(),w),this.setItemParent(n,d),this.pushDiff([0,{parent:w.parent&&w.parent.toString(),controllerId:this.controllerId,expand:w.expand,item:D.TestItem.from(n)}]),this.connectItemAndChildren(n,w,d);return}if(w.actual===n){this.connectItem(n,w,d);return}const I=w.actual.children,y=w.actual,s=(0,F.diffTestItems)(y,n);(0,F.getPrivateApiFor)(y).listener=void 0,w.actual=n,w.expand=0;for(const[g,k]of s)this.onTestItemEvent(w,{op:3,key:g,value:k,previous:y[g]});this.connectItemAndChildren(n,w,d);for(const g of I)n.children.get(g.id)||this.removeItem(P.TestId.joinToString(c,g.id))}diffTagRefs(n,d,c){const l=new Set(d.map(w=>w.id));for(const w of n)l.delete(w.id)||this.incrementTagRefs(w);this.pushDiff([1,{extId:c,item:{tags:n.map(w=>D.TestTag.namespace(this.controllerId,w.id))}}]),l.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const d=this.tags.get(n.id);d?d.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:D.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const d=this.tags.get(n);d&&!--d.refCount&&(this.tags.delete(n),this.pushDiff([6,D.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,d){(0,F.getPrivateApiFor)(n).parent=d&&d.actual!==this.root?d.actual:void 0}connectItem(n,d,c){this.setItemParent(n,c);const l=(0,F.getPrivateApiFor)(n);l.parent=c?.actual,l.listener=w=>this.onTestItemEvent(d,w),this.updateExpandability(d)}connectItemAndChildren(n,d,c){this.connectItem(n,d,c);for(const l of n.children)this.upsertItem(l,d)}updateExpandability(n){let d;this._resolveHandler?n.resolveBarrier?d=n.resolveBarrier.isOpen()?3:2:d=n.actual.canResolveChildren?1:0:d=0,d!==n.expand&&(n.expand=d,this.pushDiff([1,{extId:n.fullId.toString(),expand:d}]),d===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,d){if(d<0)return;const c=[];for(const l of n.actual.children){const w=this.expand(P.TestId.joinToString(n.fullId,l.id),d);(0,h.isThenable)(w)&&c.push(w)}if(c.length)return Promise.all(c).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const w=new h.Barrier;return w.open(),w}n.expand=2,this.pushExpandStateUpdate(n);const d=n.resolveBarrier=new h.Barrier,c=w=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=w.stack||w.message||String(w))};let l;try{l=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(w){c(w)}return(0,h.isThenable)(l)?l.catch(c).then(()=>{d.open(),this.updateExpandability(n)}):(d.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const d=this.tree.get(n);if(!d)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const c=[d];for(;c.length;){const l=c.pop();if(!!l){(0,F.getPrivateApiFor)(l.actual).listener=void 0;for(const w of l.actual.tags)this.decrementTagRefs(w.id);this.tree.delete(l.fullId.toString());for(const w of l.actual.children)c.push(this.tree.get(P.TestId.joinToString(l.fullId,w.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=t}),define(we[175],be([0,1,4,142]),function(ne,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,h.refineServiceDecorator)(M.IEnvironmentService)}),define(we[176],be([0,1,25,3,17]),function(ne,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=T;class F{constructor(t){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(h.ExtensionIdentifier.toKey(t.identifier))){console.error("Extension `"+t.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(h.ExtensionIdentifier.toKey(t.identifier),t),this._extensionsArr.push(t),Array.isArray(t.activationEvents))for(let E of t.activationEvents)E==="onUri"&&(E=`onUri:${h.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(E)||this._activationMap.set(E,[]),this._activationMap.get(E).push(t)}}keepOnly(t){const E=new Set;t.forEach(n=>E.add(h.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>E.has(h.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,E){t.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(t));const n=F._findLoopingExtensions(this._extensionDescriptions);if(E=E.concat(n.map(d=>d.identifier)),E.length>0){const d=new Set;E.forEach(c=>d.add(h.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>!d.has(h.ExtensionIdentifier.toKey(c.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(n)}static _findLoopingExtensions(t){const E=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(w){this._nodesSet.has(w)||(this._nodesSet.add(w),this._nodesArr.push(w))}addArc(w,I){this.addNode(w),this.addNode(I),this._arcs.has(w)?this._arcs.get(w).push(I):this._arcs.set(w,[I])}getArcs(w){return this._arcs.has(w)?this._arcs.get(w):[]}hasOnlyGoodArcs(w,I){const y=E.getArcs(w);for(let s=0;s<y.length;s++)if(!I.has(y[s]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let w of t){const I=h.ExtensionIdentifier.toKey(w.identifier);if(n.set(I,w),w.extensionDependencies)for(let y of w.extensionDependencies){const s=h.ExtensionIdentifier.toKey(y);E.addArc(I,s)}}let d=new Set;E.getNodes().filter(w=>E.getArcs(w).length===0).forEach(w=>d.add(w));let c=E.getNodes().filter(w=>!d.has(w)),l;do{l=!1;for(let w=0;w<c.length;w++){const I=c[w];E.hasOnlyGoodArcs(I,d)&&(c.splice(w,1),w--,d.add(I),l=!0)}}while(l);return c.map(w=>n.get(w))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(h.ExtensionIdentifier.toKey(t))}getExtensionDescriptionsForActivationEvent(t){const E=this._activationMap.get(t);return E?E.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const E=this._extensionsMap.get(h.ExtensionIdentifier.toKey(t));return E||void 0}}e.ExtensionDescriptionRegistry=F;var D;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(D||(D={}));function _(P,t){const E=P.isBuiltin?0:P.isUnderDevelopment?2:1,n=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(E!==n)return E-n;const d=b.posix.basename(P.extensionLocation.path),c=b.posix.basename(t.extensionLocation.path);return d<c?-1:d>c?1:0}}),define(we[177],be([0,1,23]),function(ne,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var M;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(M=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var b;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(b=e.MessageType||(e.MessageType={}));function T(D){const _=h.VSBuffer.alloc(1);switch(D){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=T;function F(D,_){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=F}),define(we[30],be([0,1,3,2,4,25,143]),function(ne,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,b.createDecorator)("extensionService");var D;(function(s){s[s.None=0]="None",s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(D=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));class _{constructor(g){this.dependency=g}}e.MissingExtensionDependency=_;var P;(function(s){s[s.LocalProcess=0]="LocalProcess",s[s.LocalWebWorker=1]="LocalWebWorker",s[s.Remote=2]="Remote"})(P=e.ExtensionHostKind||(e.ExtensionHostKind={}));function t(s){switch(s){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=t;class E{constructor(g,k,i,a){this.codeLoadingTime=g,this.activateCallTime=k,this.activateResolvedTime=i,this.activationReason=a}}e.ActivationTimes=E;class n{constructor(g,k){this.description=g,this.value=k}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var d;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(d=e.ActivationKind||(e.ActivationKind={}));function c(s){s.enableProposedApi||l(s)}e.checkProposedApiEnabled=c;function l(s){throw new Error(`[${s.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.throwProposedApiError=l;function w(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,F.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation}}e.toExtension=w;function I(s,g){return{identifier:new T.ExtensionIdentifier(s.identifier.id),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!g,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid}}e.toExtensionDescription=I;class y{constructor(){this.onDidRegisterExtensions=h.Event.None,this.onDidChangeExtensionsStatus=h.Event.None,this.onDidChangeExtensions=h.Event.None,this.onWillActivateByEvent=h.Event.None,this.onDidChangeResponsiveChange=h.Event.None}activateByEvent(g){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(g){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(g){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(g){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(g,k){return Promise.resolve()}_onWillActivateExtension(g){}_onDidActivateExtension(g,k,i,a,r){}_onDidActivateExtensionError(g,k){}_onExtensionRuntimeError(g,k){}_onExtensionHostExit(g){}}e.NullExtensionService=y}),define(we[178],be([0,1,25,30,15]),function(ne,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class F{constructor(c,l,w,I){this.startup=c,this.codeLoadingTime=l,this.activateCallTime=w,this.activateResolvedTime=I}}e.ExtensionActivationTimes=F,F.NONE=new F(!1,-1,-1,-1);class D{constructor(c){this._startup=c,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(c,l){return c===-1||l===-1?-1:l-c}build(){return new F(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class _{constructor(c,l,w,I,y,s){this.activationFailed=c,this.activationFailedError=l,this.activationTimes=w,this.module=I,this.exports=y,this.subscriptions=s}}e.ActivatedExtension=_;class P extends _{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class t extends _{constructor(){super(!1,null,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=t;class E extends _{constructor(c){super(!0,c,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=E;let n=class{constructor(c,l,w,I,y){this._logService=y,this._registry=c,this._resolvedExtensionsSet=new Set,l.forEach(s=>this._resolvedExtensionsSet.add(h.ExtensionIdentifier.toKey(s))),this._hostExtensionsMap=new Map,w.forEach(s=>this._hostExtensionsMap.set(h.ExtensionIdentifier.toKey(s),s)),this._host=I,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(c){const l=h.ExtensionIdentifier.toKey(c);return this._activatedExtensions.has(l)}getActivatedExtension(c){const l=h.ExtensionIdentifier.toKey(c),w=this._activatedExtensions.get(l);if(!w)throw new Error("Extension `"+c.value+"` is not known or not activated");return w}activateByEvent(c,l){if(this._alreadyActivatedEvents[c])return T;const w=this._registry.getExtensionDescriptionsForActivationEvent(c);return this._activateExtensions(w.map(I=>({id:I.identifier,reason:{startup:l,extensionId:I.identifier,activationEvent:c}}))).then(()=>{this._alreadyActivatedEvents[c]=!0})}activateById(c,l){const w=this._registry.getExtensionDescription(c);if(!w)throw new Error("Extension `"+c+"` is not known");return this._activateExtensions([{id:w.identifier,reason:l}])}_handleActivateRequest(c,l,w){if(this._hostExtensionsMap.has(h.ExtensionIdentifier.toKey(c.id))){l[h.ExtensionIdentifier.toKey(c.id)]=c;return}const I=this._registry.getExtensionDescription(c.id);if(!I){const g=new Error(`Cannot activate unknown extension '${c.id.value}'`);this._host.onExtensionActivationError(c.id,g,new M.MissingExtensionDependency(c.id.value)),this._activatedExtensions.set(h.ExtensionIdentifier.toKey(c.id),new E(g));return}const y=typeof I.extensionDependencies=="undefined"?[]:I.extensionDependencies;let s=!0;for(let g=0,k=y.length;g<k;g++){const i=y[g];if(this._resolvedExtensionsSet.has(h.ExtensionIdentifier.toKey(i)))continue;const a=this._activatedExtensions.get(h.ExtensionIdentifier.toKey(i));if(a&&!a.activationFailed)continue;if(a&&a.activationFailed){const m=I.displayName||I.identifier.value,v=this._registry.getExtensionDescription(i),C=v&&v.displayName||i,R=new Error(`Cannot activate the '${m}' extension because its dependency '${C}' failed to activate`);R.detail=a.activationFailedError,this._host.onExtensionActivationError(I.identifier,R,null),this._activatedExtensions.set(h.ExtensionIdentifier.toKey(I.identifier),new E(R));return}if(this._hostExtensionsMap.has(h.ExtensionIdentifier.toKey(i))){s=!1,l[h.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(h.ExtensionIdentifier.toKey(i)),reason:c.reason};continue}const r=this._registry.getExtensionDescription(i);if(r){s=!1,l[h.ExtensionIdentifier.toKey(i)]={id:r.identifier,reason:c.reason};continue}const o=I.displayName||I.identifier.value,f=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${i}'`);this._host.onExtensionActivationError(I.identifier,f,new M.MissingExtensionDependency(i)),this._activatedExtensions.set(h.ExtensionIdentifier.toKey(I.identifier),new E(f));return}s?l[h.ExtensionIdentifier.toKey(I.identifier)]=c:w.push(c)}_activateExtensions(c){if(c.length===0||(c=c.filter(y=>!this._activatedExtensions.has(h.ExtensionIdentifier.toKey(y.id))),c.length===0))return Promise.resolve(void 0);const l=Object.create(null),w=[];for(let y=0,s=c.length;y<s;y++)this._handleActivateRequest(c[y],l,w);for(let y=0,s=w.length;y<s;y++){const g=h.ExtensionIdentifier.toKey(w[y].id);l[g]&&delete l[g]}const I=Object.keys(l).map(y=>l[y]);return w.length===0?Promise.all(I.map(y=>this._activateExtension(y.id,y.reason))).then(y=>{}):this._activateExtensions(I).then(y=>this._activateExtensions(w))}_activateExtension(c,l){const w=h.ExtensionIdentifier.toKey(c);if(this._activatedExtensions.has(w))return Promise.resolve(void 0);const I=this._activatingExtensions.get(w);if(I)return I;const y=this._host.actualActivateExtension(c,l).then(void 0,s=>{const g=new Error;return s&&s.name&&(g.name=s.name),s&&s.message?g.message=`Activating extension '${c.value}' failed: ${s.message}.`:g.message=`Activating extension '${c.value}' failed: ${s}.`,s&&s.stack&&(g.stack=s.stack),this._host.onExtensionActivationError(c,g,null),this._logService.error(`Activating extension ${c.value} failed due to an error:`),this._logService.error(s),new E(s)}).then(s=>{this._activatedExtensions.set(w,s),this._activatingExtensions.delete(w)});return this._activatingExtensions.set(w,y),y}};n=Ue([He(4,b.ILogService)],n),e.ExtensionsActivator=n}),define(we[179],be([0,1,16]),function(ne,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class M{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,F)=>{this._actualOk=T,this._actualErr=F,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,h.onUnexpectedError)(T))}then(T,F){return this._ensureActual().then(T,F)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=M}),define(we[47],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class h{constructor(P,t){this._proxyIdentifierBrand=void 0,this.isMain=P,this.sid=t,this.nid=++h.count}}e.ProxyIdentifier=h,h.count=0;const M=[];function b(_){const P=new h(!0,_);return M[P.nid]=P,P}e.createMainContextProxyIdentifier=b;function T(_){const P=new h(!1,_);return M[P.nid]=P,P}e.createExtHostContextProxyIdentifier=T;function F(_){return M[_].sid}e.getStringIdentifierForProxy=F;class D{constructor(P){this.value=P}}e.SerializableObjectWithBuffers=D}),define(we[5],be([0,1,54,2,47]),function(ne,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var F;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(F=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var t;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(t=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var E;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(E=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(s){s.name="$ident";function g(i,a){return Object.defineProperty(i,s.name,{value:a,enumerable:!0}),i}s.mixin=g;function k(i){return i[s.name]}s.of=k})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class d{static mixin(g){return g._id=d._n++,g}}e.IdObject=d,d._n=0;var c;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.command="m",s.kindModifier="n"})(c=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var l;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(l=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(s){s[s.File=1]="File",s[s.Text=2]="Text",s[s.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function I(s){if(s&&s.edits)for(const g of s.edits)typeof g.resource=="object"?g.resource=M.URI.revive(g.resource):(g.newUri=M.URI.revive(g.newUri),g.oldUri=M.URI.revive(g.oldUri)),g.metadata&&g.metadata.iconPath&&(g.metadata=(0,h.revive)(g.metadata));return s}e.reviveWorkspaceEditDto=I;var y;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(y=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,b.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,b.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,b.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,b.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,b.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,b.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,b.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,b.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,b.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,b.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,b.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,b.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,b.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,b.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,b.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,b.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,b.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,b.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,b.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,b.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,b.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,b.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,b.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,b.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,b.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,b.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,b.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,b.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,b.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,b.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,b.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,b.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,b.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,b.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,b.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,b.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,b.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,b.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,b.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,b.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,b.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,b.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,b.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,b.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,b.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,b.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,b.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,b.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,b.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,b.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,b.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,b.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,b.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,b.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,b.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,b.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,b.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,b.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,b.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,b.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,b.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,b.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,b.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,b.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,b.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,b.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,b.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,b.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,b.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,b.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,b.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,b.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,b.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,b.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,b.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,b.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,b.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,b.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,b.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,b.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,b.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,b.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,b.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,b.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,b.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,b.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,b.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,b.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,b.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,b.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,b.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,b.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,b.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,b.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,b.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,b.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,b.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,b.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(we[69],be([0,1,5,3,4]),function(ne,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(D){this._onDidChangePassword=new M.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(h.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,_){return this._proxy.$getPassword(D,_)}store(D,_,P){return this._proxy.$setPassword(D,_,P)}delete(D,_){return this._proxy.$deletePassword(D,_)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,b.createDecorator)("IExtHostSecretState")}),define(we[70],be([0,1,4,15,5,12]),function(ne,e,h,M,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,h.createDecorator)("IExtHostApiDeprecationService");let F=class{constructor(_,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(b.MainContext.MainThreadTelemetry)}report(_,P,t){const E=this.getUsageKey(_,P);this._reportedUsages.has(E)||(this._reportedUsages.add(E),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${t}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:_}))}getUsageKey(_,P){return`${_}-${P.identifier.value}`}};F=Ue([He(0,T.IExtHostRpcService),He(1,M.ILogService)],F),e.ExtHostApiDeprecationService=F,e.NullApiDeprecationService=Object.freeze(new class{report(D,_,P){}})}),define(we[180],be([0,1,3,5,7,25]),function(ne,e,h,M,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class F{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new h.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(M.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}async getSession(_,P,t,E={}){const n=T.ExtensionIdentifier.toKey(_.identifier),d=this._inFlightRequests.get(n)||[],c=[...t].sort().join(" ");let l=d.find(w=>w.scopes===c);if(l)return l.result;{const w=this._getSession(_,n,P,t,E);l={scopes:c,result:w},d.push(l),this._inFlightRequests.set(n,d);try{await w}finally{const I=d.findIndex(y=>y.scopes===c);I>-1&&(d.splice(I),this._inFlightRequests.set(n,d))}return w}}async _getSession(_,P,t,E,n={}){await this._proxy.$ensureProvider(t);const d=_.displayName||_.name;return this._proxy.$getSession(t,E,P,d,n)}async removeSession(_,P){const t=this._authenticationProviders.get(_);return t?t.provider.removeSession(P):this._proxy.$removeSession(_,P)}registerAuthenticationProvider(_,P,t,E){if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:P,provider:t,options:E??{supportsMultipleAccounts:!1}}),this._providers.find(d=>d.id===_)||this._providers.push({id:_,label:P});const n=t.onDidChangeSessions(d=>{this._proxy.$sendDidChangeSessions(_,{added:d.added??[],changed:d.changed??[],removed:d.removed??[]})});return this._proxy.$registerAuthenticationProvider(_,P,E?.supportsMultipleAccounts??!1),new b.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(_);const d=this._providers.findIndex(c=>c.id===_);d>-1&&this._providers.splice(d),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,P){const t=this._authenticationProviders.get(_);if(t)return Promise.resolve(t.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,P){const t=this._authenticationProviders.get(_);if(t)return Promise.resolve(t.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,P){const t=this._authenticationProviders.get(_);if(t)return Promise.resolve(t.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,P){return this._onDidChangeSessions.fire({provider:{id:_,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=F}),define(we[181],be([0,1,5,12,8]),function(ne,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(D,_){this._extHostDocumentsAndEditors=_,this._proxy=D.getProxy(h.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(D){const _=b.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};T=Ue([He(0,M.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(we[182],be([0,1,5]),function(ne,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class M{constructor(T){const F=T.getProxy(h.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return F.$readText()},writeText(D){return F.$writeText(D)}})}}e.ExtHostClipboard=M}),define(we[48],be([0,1,10,7,8,22,5,13,15,54,42,112,2,6,4,12,46]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n,d,c,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let I=class{constructor(a,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=a.getProxy(F.MainContext.MainThreadCommands),this._logService=r,this.converter=new y(this,o=>{const f=this._apiCommands.get(o);return f?.result===g.Void?f:void 0},r),this._argumentProcessors=[{processArgument(o){return(0,P.revive)(o)}},{processArgument(o){return(0,T.cloneAndChange)(o,function(f){if(t.Range.isIRange(f))return b.Range.to(f);if(E.Position.isIPosition(f))return b.Position.to(f);if(t.Range.isIRange(f.range)&&n.URI.isUri(f.uri))return b.location.to(f);if(!Array.isArray(f))return f})}}]}registerArgumentProcessor(a){this._argumentProcessors.push(a)}registerApiCommand(a){const r=this.registerCommand(!1,a.id,async(...o)=>{const f=a.args.map((v,C)=>{if(!v.validate(o[C]))throw new Error(`Invalid argument '${v.name}' when running '${a.id}', received: ${o[C]}`);return v.convert(o[C])}),m=await this.executeCommand(a.internalId,...f);return a.result.convert(m,o,this.converter)},void 0,{description:a.description,args:a.args,returns:a.result.description});return this._apiCommands.set(a.id,a),new M.Disposable(()=>{r.dispose(),this._apiCommands.delete(a.id)})}registerCommand(a,r,o,f,m){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:o,thisArg:f,description:m}),a&&this._proxy.$registerCommand(r),new M.Disposable(()=>{this._commands.delete(r)&&a&&this._proxy.$unregisterCommand(r)})}executeCommand(a,...r){return this._logService.trace("ExtHostCommands#executeCommand",a),this._doExecuteCommand(a,r,!0)}async _doExecuteCommand(a,r,o){if(this._commands.has(a))return this._executeContributedCommand(a,r);{const f=(0,T.cloneAndChange)(r,function(m){if(m instanceof M.Position)return b.Position.from(m);if(m instanceof M.Range)return b.Range.from(m);if(m instanceof M.Location)return b.location.from(m);if(M.NotebookRange.isNotebookRange(m))return b.NotebookRange.from(m);if(!Array.isArray(m))return m});try{const m=await this._proxy.$executeCommand(a,f,o);return(0,P.revive)(m)}catch(m){if(m instanceof Error&&m.message==="$executeCommand:retry")return this._doExecuteCommand(a,r,!1);throw m}}}async _executeContributedCommand(a,r){const o=this._commands.get(a);if(!o)throw new Error("Unknown command");let{callback:f,thisArg:m,description:v}=o;if(v)for(let C=0;C<v.args.length;C++)try{(0,h.validateConstraint)(r[C],v.args[C].constraint)}catch(R){throw new Error(`Running the contributed command: '${a}' failed. Illegal argument '${v.args[C].name}' - ${v.args[C].description}`)}try{return await f.apply(m,r)}catch(C){if(a===this.converter.delegatingCommandId){const R=this.converter.getActualCommand(...r);R&&(a=R.command)}throw this._logService.error(C,a),new Error(`Running the contributed command: '${a}' failed.`)}}$executeContributedCommand(a,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",a),this._commands.has(a)?(r=r.map(o=>this._argumentProcessors.reduce((f,m)=>m.processArgument(f),o)),this._executeContributedCommand(a,r)):Promise.reject(new Error(`Contributed command '${a}' does not exist.`))}getCommands(a=!1){return this._logService.trace("ExtHostCommands#getCommands",a),this._proxy.$getCommands().then(r=>(a&&(r=r.filter(o=>o[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const a=Object.create(null);for(let[r,o]of this._commands){let{description:f}=o;f&&(a[r]=f)}return Promise.resolve(a)}};I=Ue([He(0,l.IExtHostRpcService),He(1,_.ILogService)],I),e.ExtHostCommands=I,e.IExtHostCommands=(0,c.createDecorator)("IExtHostCommands");class y{constructor(a,r,o){this._commands=a,this._lookupApiCommand=r,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(a,r){if(!a)return;const o={$ident:void 0,id:a.command,title:a.title,tooltip:a.tooltip};if(!a.command)return o;const f=this._lookupApiCommand(a.command);if(f)o.id=f.internalId,o.arguments=f.args.map((m,v)=>m.convert(a.arguments&&a.arguments[v]));else if((0,D.isNonEmptyArray)(a.arguments)){const m=++this._cachIdPool;this._cache.set(m,a),r.add((0,d.toDisposable)(()=>{this._cache.delete(m),this._logService.trace("CommandsConverter#DISPOSE",m)})),o.$ident=m,o.id=this.delegatingCommandId,o.arguments=[m],this._logService.trace("CommandsConverter#CREATE",a.command,m)}return o}fromInternal(a){const r=F.ObjectIdentifier.of(a);return typeof r=="number"?this._cache.get(r):{command:a.id,title:a.title,arguments:a.arguments}}getActualCommand(...a){return this._cache.get(a[0])}_executeConvertedCommand(...a){const r=this.getActualCommand(...a);return this._logService.trace("CommandsConverter#EXECUTE",a[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=y;class s{constructor(a,r,o,f){this.name=a,this.description=r,this.validate=o,this.convert=f}optional(){return new s(this.name,`(optional) ${this.description}`,a=>a==null||this.validate(a),a=>a===void 0?void 0:a===null?null:this.convert(a))}with(a,r){return new s(a??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=s,s.Uri=new s("uri","Uri of a text document",i=>n.URI.isUri(i),i=>i),s.Position=new s("position","A position in a text document",i=>M.Position.isPosition(i),b.Position.from),s.Range=new s("range","A range in a text document",i=>M.Range.isRange(i),b.Range.from),s.Selection=new s("selection","A selection in a text document",i=>M.Selection.isSelection(i),b.Selection.from),s.Number=new s("number","",i=>typeof i=="number",i=>i),s.String=new s("string","",i=>typeof i=="string",i=>i),s.CallHierarchyItem=new s("item","A call hierarchy item",i=>i instanceof M.CallHierarchyItem,b.CallHierarchyItem.from),s.TypeHierarchyItem=new s("item","A type hierarchy item",i=>i instanceof M.TypeHierarchyItem,b.TypeHierarchyItem.from),s.TestItem=new s("testItem","A VS Code TestItem",i=>i instanceof w.TestItemImpl,b.TestItem.from);class g{constructor(a,r){this.description=a,this.convert=r}}e.ApiCommandResult=g,g.Void=new g("no result",i=>i);class k{constructor(a,r,o,f,m){this.id=a,this.internalId=r,this.description=o,this.args=f,this.result=m}}e.ApiCommand=k}),define(we[183],be([0,1,8,7,59,48,13,80]),function(ne,e,h,M,b,T,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new T.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",t(h.DocumentHighlight.to))),new T.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,d)=>{if((0,F.isFalsyOrEmpty)(n))return;class c extends M.SymbolInformation{static to(w){const I=new c(w.name,h.SymbolKind.to(w.kind),w.containerName||"",new M.Location(d[0],h.Range.to(w.range)));return I.detail=w.detail,I.range=I.location.range,I.selectionRange=h.Range.to(w.selectionRange),I.children=w.children?w.children.map(c.to):[],I}}return n.map(c.to)})),new T.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(h.TextEdit.to))),new T.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range,new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(h.TextEdit.to))),new T.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,new T.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(h.TextEdit.to))),new T.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new T.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new T.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new T.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new T.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location-instances.",t(h.location.to))),new T.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Hover-instances.",t(h.Hover.to))),new T.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(d=>M.Position.isPosition(d)),n=>n.map(h.Position.from))],new T.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(d=>{let c;for(const l of d.reverse())c=new M.SelectionRange(h.Range.to(l),c);return c}))),new T.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[T.ApiCommandArgument.String.with("query","Search string")],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>{const d=[];if(Array.isArray(n))for(let c of n)d.push(...c[1].map(h.WorkspaceSymbol.to));return d})),new T.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(h.CallHierarchyItem.to))),new T.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(h.CallHierarchyIncomingCall.to))),new T.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(h.CallHierarchyOutgoingCall.to))),new T.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("newName","The new symbol name")],new T.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return h.WorkspaceEdit.to(n)}})),new T.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new T.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(h.DocumentLink.to))),new T.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const d=(0,D.decodeSemanticTokensDto)(n);if(d.type==="full")return new M.SemanticTokens(d.data,void 0)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const d=(0,D.decodeSemanticTokensDto)(n);if(d.type==="full")return new M.SemanticTokens(d.data,void 0)})),new T.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new T.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,d,c)=>{if(!n)return new M.CompletionList([]);const l=n.suggestions.map(w=>h.CompletionItem.to(w,c));return new M.CompletionList(l,n.incomplete)})),new T.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new T.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return h.SignatureHelp.to(n)})),new T.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new T.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,d,c)=>t(l=>new M.CodeLens(h.Range.to(l.range),l.command&&c.fromInternal(l.command)))(n))),new T.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>M.Range.isRange(n),n=>M.Selection.isSelection(n)?h.Selection.from(n):h.Range.from(n)),T.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new T.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,d,c)=>t(l=>{if(l._isSynthetic){if(!l.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(l.command)}else{const w=new M.CodeAction(l.title,l.kind?new M.CodeActionKind(l.kind):void 0);return l.edit&&(w.edit=h.WorkspaceEdit.to(l.edit)),l.command&&(w.command=c.fromInternal(l.command)),w.isPreferred=l.isPreferred,w}})(n))),new T.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(d=>new M.ColorInformation(h.Range.to(d.range),h.Color.to(d.color))):[])),new T.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new T.ApiCommandArgument("color","The color to show and insert",n=>n instanceof M.Color,h.Color.from),new T.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:h.Range.from(n.range)}))],new T.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(h.ColorPresentation.to):[])),new T.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(h.InlayHint.to))),new T.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new T.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",t(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(d=>h.NotebookExclusiveDocumentPattern.to(d))})))),new T.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(h.InlineValue.to))),new T.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[h.ViewColumn.from(n.viewColumn),h.TextEditorOpenOptions.from(n)])).optional(),T.ApiCommandArgument.String.with("label","").optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[T.ApiCommandArgument.Uri.with("resource","Resource to open"),T.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[h.ViewColumn.from(n.viewColumn),h.TextEditorOpenOptions.from(n)])).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[T.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),T.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),T.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[h.ViewColumn.from(n.viewColumn),h.TextEditorOpenOptions.from(n)]).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(h.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(h.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(h.TypeHierarchyItem.to))),new T.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[T.ApiCommandArgument.TestItem],T.ApiCommandResult.Void)];class P{static register(d){_.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=P;function t(n){return d=>{if(Array.isArray(d))return d.map(n)}}function E(n){if(!Array.isArray(n))return;const d=[];for(const c of n)b.isLocationLink(c)?d.push(h.DefinitionLink.to(c)):d.push(h.location.to(c));return d}}),define(we[184],be([0,1,14,52,3,6,2,59,25,8,7,5]),function(ne,e,h,M,b,T,F,D,_,P,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(d,c,l){const w=d.getProxy(E.MainContext.MainThreadComments);class I{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,c.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===6){const f=this._commentControllers.get(o.handle);return f||o}else if(o&&o.$mid===7){const f=this._commentControllers.get(o.commentControlHandle);if(!f)return o;const m=f.getCommentThread(o.commentThreadHandle);return m||o}else if(o&&o.$mid===8){const f=this._commentControllers.get(o.thread.commentControlHandle);if(!f)return o;const m=f.getCommentThread(o.thread.commentThreadHandle);return m?{thread:m,text:o.text}:o}else if(o&&o.$mid===9){const f=this._commentControllers.get(o.thread.commentControlHandle);if(!f)return o;const m=f.getCommentThread(o.thread.commentThreadHandle);if(!m)return o;let v=o.commentUniqueId,C=m.getCommentByUniqueId(v);return C||o}else if(o&&o.$mid===10){const f=this._commentControllers.get(o.thread.commentControlHandle);if(!f)return o;const m=f.getCommentThread(o.thread.commentThreadHandle);if(!m)return o;let v=o.text,C=o.commentUniqueId,R=m.getCommentByUniqueId(C);return R?(R.body=v,R):o}return o}})}createCommentController(o,f,m){const v=I.handlePool++,C=new s(o,v,f,m);this._commentControllers.set(C.handle,C);const R=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(o.identifier))||[];return R.push(C),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(o.identifier),R),C.value}$createCommentThreadTemplate(o,f,m){const v=this._commentControllers.get(o);!v||v.$createCommentThreadTemplate(f,m)}async $updateCommentThreadTemplate(o,f,m){const v=this._commentControllers.get(o);!v||v.$updateCommentThreadTemplate(f,m)}$deleteCommentThread(o,f){const m=this._commentControllers.get(o);m&&m.$deleteCommentThread(f)}$provideCommentingRanges(o,f,m){const v=this._commentControllers.get(o);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const C=l.getDocument(F.URI.revive(f));return(0,h.asPromise)(()=>v.commentingRangeProvider.provideCommentingRanges(C,m)).then(R=>R?R.map(p=>P.Range.from(p)):void 0)}$toggleReaction(o,f,m,v,C){const R=this._commentControllers.get(o);return!R||!R.reactionHandler?Promise.resolve(void 0):(0,h.asPromise)(()=>{const p=R.getCommentThread(f);if(p){const S=p.getCommentByUniqueId(v.uniqueIdInThread);if(R!==void 0&&S&&R.reactionHandler)return R.reactionHandler(S,i(C))}return Promise.resolve(void 0)})}dispose(){}}I.handlePool=0;class y{constructor(o,f,m,v,C,R,p){this._commentControllerHandle=f,this._id=m,this._uri=v,this._range=C,this._comments=R,this.handle=y._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new b.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${o}.${this.handle}`),w.$createCommentThread(f,this.handle,this._id,this._uri,P.Range.from(this._range),p),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=R,this._localDisposables.push({dispose:()=>{w.$deleteCommentThread(f,this.handle)}});const S=this;this.value={get uri(){return S.uri},get range(){return S.range},set range(u){S.range=u},get comments(){return S.comments},set comments(u){S.comments=u},get collapsibleState(){return S.collapsibleState},set collapsibleState(u){S.collapsibleState=u},get canReply(){return S.canReply},set canReply(u){S.canReply=u},get contextValue(){return S.contextValue},set contextValue(u){S.contextValue=u},get label(){return S.label},set label(u){S.label=u},dispose:()=>{S.dispose()}}}set threadId(o){this._id=o}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(o){o.isEqual(this._range)||(this._range=o,this.modifications.range=o,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(o){this._canReply!==o&&(this._canReply=o,this.modifications.canReply=o,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(o){this._label=o,this.modifications.label=o,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(o){this._contextValue=o,this.modifications.contextValue=o,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(o){this._comments=o,this.modifications.comments=o,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(o){this._collapseState=o,this.modifications.collapsibleState=o,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const o=m=>Object.prototype.hasOwnProperty.call(this.modifications,m),f={};o("range")&&(f.range=P.Range.from(this._range)),o("label")&&(f.label=this.label),o("contextValue")&&(f.contextValue=this.contextValue),o("comments")&&(f.comments=this._comments.map(m=>g(this,m,this._commentsMap))),o("collapsibleState")&&(f.collapseState=a(this._collapseState)),o("canReply")&&(f.canReply=this.canReply),this.modifications={},w.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,f)}getCommentByUniqueId(o){for(let f of this._commentsMap){let m=f[0],v=f[1];if(o===v)return m}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(o=>o.dispose())}}y._handlePool=0,Ue([(0,M.debounce)(100)],y.prototype,"eventuallyUpdateCommentThread",null);class s{constructor(o,f,m,v){this._extension=o,this._handle=f,this._id=m,this._label=v,this._threads=new Map,w.$registerCommentController(this.handle,m,v);const C=this;this.value=Object.freeze({id:C.id,label:C.label,get options(){return C.options},set options(R){C.options=R},get commentingRangeProvider(){return C.commentingRangeProvider},set commentingRangeProvider(R){C.commentingRangeProvider=R},get reactionHandler(){return C.reactionHandler},set reactionHandler(R){C.reactionHandler=R},createCommentThread(R,p,S){return C.createCommentThread(R,p,S).value},dispose:()=>{C.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{w.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(o){this._reactionHandler=o,w.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!o})}get options(){return this._options}set options(o){this._options=o,w.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(o,f,m,v){if(typeof o=="string"){const C=new y(this.id,this.handle,o,f,m,v,this._extension.identifier);return this._threads.set(C.handle,C),C}else{const C=new y(this.id,this.handle,void 0,o,f,m,this._extension.identifier);return this._threads.set(C.handle,C),C}}$createCommentThreadTemplate(o,f){const m=new y(this.id,this.handle,void 0,F.URI.revive(o),P.Range.to(f),[],this._extension.identifier);return m.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(m.handle,m),m}$updateCommentThreadTemplate(o,f){let m=this._threads.get(o);m&&(m.range=P.Range.to(f))}$deleteCommentThread(o){let f=this._threads.get(o);f&&f.dispose(),this._threads.delete(o)}getCommentThread(o){return this._threads.get(o)}dispose(){this._threads.forEach(o=>{o.dispose()}),this._localDisposables.forEach(o=>o.dispose())}}function g(r,o,f){let m=f.get(o);m||(m=++r.commentHandle,f.set(o,m));const v=o.author&&o.author.iconPath?o.author.iconPath.toString():void 0;return{mode:o.mode,contextValue:o.contextValue,uniqueIdInThread:m,body:P.MarkdownString.from(o.body),userName:o.author.name,userIconPath:v,label:o.label,commentReactions:o.reactions?o.reactions.map(C=>k(C)):void 0}}function k(r){return{label:r.label,iconPath:r.iconPath?P.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function i(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?F.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function a(r){if(r!==void 0)switch(r){case t.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case t.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}return new I}e.createExtHostComments=n}),define(we[95],be([0,1,2,5,7,4,12,15,13,9,17]),function(ne,e,h,M,b,T,F,D,_,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let E=class vi{constructor(d,c){this._logService=c,this._provider=new Map,this._proxy=d.getProxy(M.MainContext.MainThreadDecorations)}registerFileDecorationProvider(d,c){const l=vi._handlePool++;this._provider.set(l,{provider:d,extensionId:c}),this._proxy.$registerDecorationProvider(l,c.value);const w=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(I=>{if(!I){this._proxy.$onDidChange(l,null);return}let y=(0,_.asArray)(I);if(y.length<=vi._maxEventSize){this._proxy.$onDidChange(l,y);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",c.value,y.length);const s=y.map(i=>({uri:i,rank:(0,P.count)(i.path,"/")})),g=(0,_.groupBy)(s,(i,a)=>i.rank-a.rank||(0,P.compare)(i.uri.path,a.uri.path));let k=[];e:for(let i of g){let a;for(let r of i){let o=(0,t.dirname)(r.uri.path);if(a!==o&&(a=o,k.push(r.uri)>=vi._maxEventSize))break e}}this._proxy.$onDidChange(l,k)});return new b.Disposable(()=>{w?.dispose(),this._proxy.$unregisterDecorationProvider(l),this._provider.delete(l)})}async $provideDecorations(d,c,l){if(!this._provider.has(d))return Object.create(null);const w=Object.create(null),{provider:I,extensionId:y}=this._provider.get(d);return await Promise.all(c.map(async s=>{try{const{uri:g,id:k}=s,i=await Promise.resolve(I.provideFileDecoration(h.URI.revive(g),l));if(!i)return;try{b.FileDecoration.validate(i),w[k]=[i.propagate,i.tooltip,i.badge,i.color]}catch(a){this._logService.warn(`INVALID decoration from extension '${y.value}': ${a}`)}}catch(g){this._logService.error(g)}})),w}};E._handlePool=0,E._maxEventSize=250,E=Ue([He(0,F.IExtHostRpcService),He(1,D.ILogService)],E),e.ExtHostDecorations=E,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")});var Xe=this&&this.__classPrivateFieldSet||function(ne,e,h,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ne,h):b?b.value=h:e.set(ne,h),h},Ae=this&&this.__classPrivateFieldGet||function(ne,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[185],be([0,1,124,82,2,5,7,8,3,15,20,37,104]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n){"use strict";var d,c,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class w{constructor(s,g,k,i,a,r){this._name=s,this._owner=g,this._maxDiagnosticsPerFile=k,d.set(this,void 0),c.set(this,void 0),l.set(this,void 0),this._isDisposed=!1,Xe(this,l,new n.SkipList((o,f)=>i.compare(o,f)),"f"),Xe(this,d,a,"f"),Xe(this,c,r,"f")}dispose(){this._isDisposed||(Ae(this,c,"f").fire([...Ae(this,l,"f").keys()]),Ae(this,d,"f")&&Ae(this,d,"f").$clear(this._owner),Ae(this,l,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(s,g){if(!s){this.clear();return}this._checkDisposed();let k=[];if(b.URI.isUri(s)){if(!g){this.delete(s);return}Ae(this,l,"f").set(s,g.slice()),k=[s]}else if(Array.isArray(s)){k=[];let a;s=[...s].sort(w._compareIndexedTuplesByUri);for(const r of s){const[o,f]=r;if((!a||o.toString()!==a.toString())&&(a&&Ae(this,l,"f").get(a).length===0&&Ae(this,l,"f").delete(a),a=o,k.push(o),Ae(this,l,"f").set(o,[])),f){const m=Ae(this,l,"f").get(o);m&&m.push(...f)}else{const m=Ae(this,l,"f").get(o);m&&(m.length=0)}}}if(Ae(this,c,"f").fire(k),!Ae(this,d,"f"))return;const i=[];for(let a of k){let r=[];const o=Ae(this,l,"f").get(a);if(o)if(o.length>this._maxDiagnosticsPerFile){r=[];const f=[F.DiagnosticSeverity.Error,F.DiagnosticSeverity.Warning,F.DiagnosticSeverity.Information,F.DiagnosticSeverity.Hint];e:for(let m=0;m<4;m++)for(let v of o)if(v.severity===f[m]&&r.push(D.Diagnostic.from(v))===this._maxDiagnosticsPerFile)break e;r.push({severity:M.MarkerSeverity.Info,message:(0,h.localize)(0,null,o.length-this._maxDiagnosticsPerFile),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=o.map(f=>D.Diagnostic.from(f));i.push([a,r])}Ae(this,d,"f").$changeMany(this._owner,i)}delete(s){this._checkDisposed(),Ae(this,c,"f").fire([s]),Ae(this,l,"f").delete(s),Ae(this,d,"f")&&Ae(this,d,"f").$changeMany(this._owner,[[s,void 0]])}clear(){this._checkDisposed(),Ae(this,c,"f").fire([...Ae(this,l,"f").keys()]),Ae(this,l,"f").clear(),Ae(this,d,"f")&&Ae(this,d,"f").$clear(this._owner)}forEach(s,g){this._checkDisposed();for(let k of Ae(this,l,"f").keys())s.apply(g,[k,this.get(k),this])}get(s){this._checkDisposed();const g=Ae(this,l,"f").get(s);return Array.isArray(g)?Object.freeze(g.slice(0)):[]}has(s){return this._checkDisposed(),Array.isArray(Ae(this,l,"f").get(s))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(s,g){return s[0].toString()<g[0].toString()?-1:s[0].toString()>g[0].toString()?1:0}}e.DiagnosticCollection=w,d=new WeakMap,c=new WeakMap,l=new WeakMap;let I=class Zt{constructor(s,g,k){this._logService=g,this._fileSystemInfoService=k,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,Zt._mapper),this._proxy=s.getProxy(T.MainContext.MainThreadDiagnostics)}static _mapper(s){const g=new t.ResourceMap;for(const k of s)g.set(k,k);return{uris:Object.freeze(Array.from(g.values()))}}createDiagnosticCollection(s,g){const{_collections:k,_proxy:i,_onDidChangeDiagnostics:a,_logService:r,_fileSystemInfoService:o}=this,f=new class{$changeMany(C,R){i.$changeMany(C,R),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,C,R.length===0?"CLEARING":R)}$clear(C){i.$clear(C),r.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,C)}dispose(){i.dispose()}};let m;if(!g)g="_generated_diagnostic_collection_name_#"+Zt._idPool++,m=g;else if(!k.has(g))m=g;else{this._logService.warn(`DiagnosticCollection with name '${g}' does already exist.`);do m=g+Zt._idPool++;while(k.has(m))}return new class extends w{constructor(){super(g,m,Zt._maxDiagnosticsPerFile,o.extUri,f,a);k.set(m,this)}dispose(){super.dispose(),k.delete(m)}}}getDiagnostics(s){if(s)return this._getDiagnostics(s);{const g=new Map,k=[];for(const i of this._collections.values())i.forEach((a,r)=>{let o=g.get(a.toString());typeof o=="undefined"&&(o=k.length,g.set(a.toString(),o),k.push([a,[]])),k[o][1]=k[o][1].concat(...r)});return k}}_getDiagnostics(s){let g=[];for(let k of this._collections.values())k.has(s)&&(g=g.concat(k.get(s)));return g}$acceptMarkersChange(s){if(!this._mirrorCollection){const g="_generated_mirror",k=new w(g,g,Zt._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(g,k),this._mirrorCollection=k}for(const[g,k]of s)this._mirrorCollection.set(b.URI.revive(g),k.map(D.Diagnostic.to))}};I._idPool=0,I._maxDiagnosticsPerFile=1e3,I=Ue([He(1,P.ILogService),He(2,E.IExtHostFileSystemInfo)],I),e.ExtHostDiagnostics=I}),define(we[186],be([0,1,2,5]),function(ne,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class b{constructor(F){this._proxy=F.getProxy(M.MainContext.MainThreadDialogs)}showOpenDialog(F){return this._proxy.$showOpenDialog(F).then(D=>D?D.map(_=>h.URI.revive(_)):void 0)}showSaveDialog(F){return this._proxy.$showSaveDialog(F).then(D=>D?h.URI.revive(D):void 0)}}e.ExtHostDialogs=b}),define(we[187],be([0,1,16,2,7,5,11,21,9]),function(ne,e,h,M,b,T,F,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(E,n,d){this._documentsAndEditors=n,this._logService=d,this._documentContentProviders=new Map,this._proxy=E.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,n){if(Object.keys(F.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const d=P._handlePool++;this._documentContentProviders.set(d,n),this._proxy.$registerTextContentProvider(d,E);let c;return typeof n.onDidChange=="function"&&(c=n.onDidChange(l=>{if(l.scheme!==E){this._logService.warn(`Provider for scheme '${E}' is firing event for schema '${l.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(l)&&this.$provideTextDocumentContent(d,l).then(w=>{if(!w&&typeof w!="string")return;const I=this._documentsAndEditors.getDocument(l);if(!I)return;const y=(0,_.splitLines)(w);if(!I.equalLines(y))return this._proxy.$onVirtualDocumentChange(l,w)},h.onUnexpectedError)})),new b.Disposable(()=>{this._documentContentProviders.delete(d)&&this._proxy.$unregisterTextContentProvider(d),c&&(c.dispose(),c=void 0)})}$provideTextDocumentContent(E,n){const d=this._documentContentProviders.get(E);return d?Promise.resolve(d.provideTextDocumentContent(M.URI.revive(n),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(we[188],be([0,1,3,6,2,5,88,8,10,22,7]),function(ne,e,h,M,b,T,F,D,_,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class E{constructor(d,c){this._onDidAddDocument=new h.Emitter,this._onDidRemoveDocument=new h.Emitter,this._onDidChangeDocument=new h.Emitter,this._onDidSaveDocument=new h.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new M.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=c,this._documentsAndEditors.onDidRemoveDocuments(l=>{for(const w of l)this._onDidRemoveDocument.fire(w.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(l=>{for(const w of l)this._onDidAddDocument.fire(w.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!d)return;const c=this._documentsAndEditors.getDocument(d);if(c)return c}getDocument(d){const c=this.getDocumentData(d);if(!c?.document)throw new Error(`Unable to retrieve document from URI '${d}'`);return c.document}ensureDocumentData(d){const c=this._documentsAndEditors.getDocument(d);if(c)return Promise.resolve(c);let l=this._documentLoader.get(d.toString());return l||(l=this._proxy.$tryOpenDocument(d).then(w=>{this._documentLoader.delete(d.toString());const I=b.URI.revive(w);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(I))},w=>(this._documentLoader.delete(d.toString()),Promise.reject(w))),this._documentLoader.set(d.toString(),l)),l}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(c=>b.URI.revive(c))}$acceptModelModeChanged(d,c){const l=b.URI.revive(d),w=this._documentsAndEditors.getDocument(l);if(!w)throw new Error("unknown document");this._onDidRemoveDocument.fire(w.document),w._acceptLanguageId(c),this._onDidAddDocument.fire(w.document)}$acceptModelSaved(d){const c=b.URI.revive(d),l=this._documentsAndEditors.getDocument(c);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(l.document)}$acceptDirtyStateChanged(d,c){const l=b.URI.revive(d),w=this._documentsAndEditors.getDocument(l);if(!w)throw new Error("unknown document");w._acceptIsDirty(c),this._onDidChangeDocument.fire({document:w.document,contentChanges:[],reason:void 0})}$acceptModelChanged(d,c,l){const w=b.URI.revive(d),I=this._documentsAndEditors.getDocument(w);if(!I)throw new Error("unknown document");I._acceptIsDirty(l),I.onEvents(c);let y;c.isUndoing?y=t.TextDocumentChangeReason.Undo:c.isRedoing&&(y=t.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:I.document,contentChanges:c.changes.map(s=>({range:D.Range.to(s.range),rangeOffset:s.rangeOffset,rangeLength:s.rangeLength,text:s.text})),reason:y}))}setWordDefinitionFor(d,c){(0,F.setWordDefinitionFor)(d,c)}}e.ExtHostDocuments=E}),define(we[49],be([0,1,40,3,6,2,4,5,88,12,94,8,15,20,11,231,103]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n,d,c,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class I{constructor(g){this.value=g,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let y=class{constructor(g,k){this._extHostRpc=g,this._logService=k,this._activeEditorId=null,this._editors=new Map,this._documents=new d.ResourceMap,this._onDidAddDocuments=new M.Emitter,this._onDidRemoveDocuments=new M.Emitter,this._onDidChangeVisibleTextEditors=new M.Emitter,this._onDidChangeActiveTextEditor=new M.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(g){this.acceptDocumentsAndEditorsDelta(g)}acceptDocumentsAndEditorsDelta(g){const k=[],i=[],a=[];if(g.removedDocuments)for(const r of g.removedDocuments){const o=T.URI.revive(r),f=this._documents.get(o);f?.unref()&&(this._documents.delete(o),k.push(f.value))}if(g.addedDocuments)for(const r of g.addedDocuments){const o=T.URI.revive(r.uri);let f=this._documents.get(o);if(f&&o.scheme!==c.Schemas.vscodeNotebookCell&&o.scheme!==c.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);f||(f=new I(new _.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),o,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(o,f),i.push(f.value)),f.ref()}if(g.removedEditors)for(const r of g.removedEditors){const o=this._editors.get(r);this._editors.delete(r),o&&a.push(o)}if(g.addedEditors)for(const r of g.addedEditors){const o=T.URI.revive(r.documentUri);h.ok(this._documents.has(o),`document '${o}' does not exist`),h.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const f=this._documents.get(o).value,m=new t.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new w.Lazy(()=>f.document),r.selections.map(E.Selection.to),r.options,r.visibleRanges.map(v=>E.Range.to(v)),typeof r.editorPosition=="number"?E.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,m)}g.newActiveEditor!==void 0&&(h.ok(g.newActiveEditor===null||this._editors.has(g.newActiveEditor),`active editor '${g.newActiveEditor}' does not exist`),this._activeEditorId=g.newActiveEditor),(0,b.dispose)(k),(0,b.dispose)(a),g.removedDocuments&&this._onDidRemoveDocuments.fire(k),g.addedDocuments&&this._onDidAddDocuments.fire(i),(g.removedEditors||g.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),g.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(g){return this._documents.get(g)?.value}allDocuments(){return l.Iterable.map(this._documents.values(),g=>g.value)}getEditor(g){return this._editors.get(g)}activeEditor(g){if(!this._activeEditorId)return;const k=this._editors.get(this._activeEditorId);return g?k:k?.value}allEditors(){return[...this._editors.values()]}};y=Ue([He(0,P.IExtHostRpcService),He(1,n.ILogService)],y),e.ExtHostDocumentsAndEditors=y,e.IExtHostDocumentsAndEditors=(0,F.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[189],be([0,1,2,5,6,7,8,232,9,23]),function(ne,e,h,M,b,T,F,D,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class t{constructor(){this._schemes=[]}add(d){this._stateMachine=void 0,this._schemes.push(d)}delete(d){const c=this._schemes.indexOf(d);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const d=this._schemes.sort(),c=[];let l,w,I=14,y=14;for(const s of d){let g=l?(0,_.commonPrefixLength)(l,s):0;for(g===0?w=1:w=y;g<s.length;g++)g+1===s.length?(I=y,y=9):y+=1,c.push([w,s.toUpperCase().charCodeAt(g),y]),c.push([w,s.toLowerCase().charCodeAt(g),y]),w=y;l=s,y=I}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new D.StateMachine(c)}}provideDocumentLinks(d){this._initStateMachine();const c=[],l=D.LinkComputer.computeLinks({getLineContent(w){return d.lineAt(w-1).text},getLineCount(){return d.lineCount}},this._stateMachine);for(const w of l){const I=F.DocumentLink.to(w);I.target&&c.push(I)}return c}}class E{constructor(d,c){this._extHostLanguageFeatures=c,this._linkProvider=new t,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=d.getProxy(M.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(d,c,l,w={}){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const I=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(I,l);let y=2;w.isCaseSensitive&&(y+=1024),w.isReadonly&&(y+=2048),typeof l.copy=="function"&&(y+=8),typeof l.open=="function"&&typeof l.close=="function"&&typeof l.read=="function"&&typeof l.write=="function"&&(y+=4),this._proxy.$registerFileSystemProvider(I,c,y).catch(g=>{console.error(`FAILED to register filesystem provider of ${d.value}-extension for the scheme ${c}`),console.error(g)});const s=l.onDidChangeFile(g=>{const k=[];for(const i of g){let{uri:a,type:r}=i;if(a.scheme!==c)continue;let o;switch(r){case T.FileChangeType.Changed:o=0;break;case T.FileChangeType.Created:o=1;break;case T.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}k.push({resource:a,type:o})}this._proxy.$onFileSystemChange(I,k)});return(0,b.toDisposable)(()=>{s.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(I),this._proxy.$unregisterProvider(I)})}static _asIStat(d){const{type:c,ctime:l,mtime:w,size:I,permissions:y}=d;return{type:c,ctime:l,mtime:w,size:I,permissions:y}}$stat(d,c){return Promise.resolve(this._getFsProvider(d).stat(h.URI.revive(c))).then(l=>E._asIStat(l))}$readdir(d,c){return Promise.resolve(this._getFsProvider(d).readDirectory(h.URI.revive(c)))}$readFile(d,c){return Promise.resolve(this._getFsProvider(d).readFile(h.URI.revive(c))).then(l=>P.VSBuffer.wrap(l))}$writeFile(d,c,l,w){return Promise.resolve(this._getFsProvider(d).writeFile(h.URI.revive(c),l.buffer,w))}$delete(d,c,l){return Promise.resolve(this._getFsProvider(d).delete(h.URI.revive(c),l))}$rename(d,c,l,w){return Promise.resolve(this._getFsProvider(d).rename(h.URI.revive(c),h.URI.revive(l),w))}$copy(d,c,l,w){const I=this._getFsProvider(d);if(!I.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(I.copy(h.URI.revive(c),h.URI.revive(l),w))}$mkdir(d,c){return Promise.resolve(this._getFsProvider(d).createDirectory(h.URI.revive(c)))}$watch(d,c,l,w){const I=this._getFsProvider(d).watch(h.URI.revive(l),w);this._watches.set(c,I)}$unwatch(d,c){const l=this._watches.get(c);l&&(l.dispose(),this._watches.delete(c))}$open(d,c,l){const w=this._getFsProvider(d);if(!w.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(w.open(h.URI.revive(c),l))}$close(d,c){const l=this._getFsProvider(d);if(!l.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(l.close(c))}$read(d,c,l,w){const I=this._getFsProvider(d);if(!I.read)throw new Error('FileSystemProvider does not implement "read"');const y=P.VSBuffer.alloc(w);return Promise.resolve(I.read(c,l,y.buffer,0,w)).then(s=>y.slice(0,s))}$write(d,c,l,w){const I=this._getFsProvider(d);if(!I.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(I.write(c,l,w.buffer,0,w.byteLength))}_getFsProvider(d){const c=this._fsProvider.get(d);if(!c){const l=new Error;throw l.name="ENOPRO",l.message="no provider",l}return c}}e.ExtHostFileSystem=E}),define(we[71],be([0,1,5,60,7,23,4,12,37]),function(ne,e,h,M,b,T,F,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class Bt{constructor(E,n){const d=E.getProxy(h.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(c){return d.$stat(c).catch(Bt._handleError)},readDirectory(c){return d.$readdir(c).catch(Bt._handleError)},createDirectory(c){return d.$mkdir(c).catch(Bt._handleError)},async readFile(c){return d.$readFile(c).then(l=>l.buffer).catch(Bt._handleError)},writeFile(c,l){return d.$writeFile(c,T.VSBuffer.wrap(l)).catch(Bt._handleError)},delete(c,l){return d.$delete(c,{recursive:!1,useTrash:!1,...l}).catch(Bt._handleError)},rename(c,l,w){return d.$rename(c,l,{overwrite:!1,...w}).catch(Bt._handleError)},copy(c,l,w){return d.$copy(c,l,{overwrite:!1,...w}).catch(Bt._handleError)},isWritableFileSystem(c){const l=n.getCapabilities(c);if(typeof l=="number")return!(l&2048)}})}static _handleError(E){if(!(E instanceof Error))throw new b.FileSystemError(String(E));if(E.name==="ENOPRO")throw b.FileSystemError.Unavailable(E.message);switch(E.name){case M.FileSystemProviderErrorCode.FileExists:throw b.FileSystemError.FileExists(E.message);case M.FileSystemProviderErrorCode.FileNotFound:throw b.FileSystemError.FileNotFound(E.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw b.FileSystemError.FileNotADirectory(E.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw b.FileSystemError.FileIsADirectory(E.message);case M.FileSystemProviderErrorCode.NoPermissions:throw b.FileSystemError.NoPermissions(E.message);case M.FileSystemProviderErrorCode.Unavailable:throw b.FileSystemError.Unavailable(E.message);default:throw new b.FileSystemError(E.message,E.name)}}};P=Ue([He(0,D.IExtHostRpcService),He(1,_.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=(0,F.createDecorator)("IExtHostConsumerFileSystem")}),define(we[190],be([0,1,2,48]),function(ne,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class b{constructor(F,D,_,P){this._extHostNotebooks=D,this._textDocumentsAndEditors=_,this._commands=P;const t=new M.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.ApiCommandArgument("showOptions","Show Options",E=>!0,E=>E),new M.ApiCommandArgument("resource","Interactive resource Uri",E=>!0,E=>E),new M.ApiCommandArgument("controllerId","Notebook controller Id",E=>!0,E=>E),new M.ApiCommandArgument("title","Interactive editor title",E=>!0,E=>E)],new M.ApiCommandResult("Notebook and input URI",E=>{if(E.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(E.notebookEditorId);return{notebookUri:h.URI.revive(E.notebookUri),inputUri:h.URI.revive(E.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:h.URI.revive(E.notebookUri),inputUri:h.URI.revive(E.inputUri)}}));this._commands.registerApiCommand(t)}$willAddInteractiveDocument(F,D,_,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:D,lines:[""],modeId:_,uri:F,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(h.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(F,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[F]})}}e.ExtHostInteractive=b}),define(we[191],be([0,1,6,5]),function(ne,e,h,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class b{constructor(F){this._handlePool=0,this._proxy=F.getProxy(M.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(F){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,F),(0,h.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=b}),define(we[192],be([0,1,2,22,8,7,5,9,42,13,10,233,6,80,53,63,193,16,3]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n,d,c,l,w,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class s{constructor(x,Y){this._documents=x,this._provider=Y}async provideDocumentSymbols(x,Y){const ee=this._documents.getDocument(x),ae=await this._provider.provideDocumentSymbols(ee,Y);if(!(0,P.isFalsyOrEmpty)(ae))return ae[0]instanceof T.DocumentSymbol?ae.map(b.DocumentSymbol.from):s._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree(x){x=x.slice(0).sort((ae,j)=>{let oe=ae.location.range.start.compareTo(j.location.range.start);return oe===0&&(oe=j.location.range.end.compareTo(ae.location.range.end)),oe});const Y=[],ee=[];for(const ae of x){const j={name:ae.name||"!!MISSING: name!!",kind:b.SymbolKind.from(ae.kind),tags:ae.tags?.map(b.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:b.Range.from(ae.location.range),selectionRange:b.Range.from(ae.location.range),children:[]};for(;;){if(ee.length===0){ee.push(j),Y.push(j);break}const oe=ee[ee.length-1];if(_.Range.containsRange(oe.range,j.range)&&!_.Range.equalsRange(oe.range,j.range)){oe.children&&oe.children.push(j),ee.push(j);break}ee.pop()}}return Y}}class g{constructor(x,Y,ee){this._documents=x,this._commands=Y,this._provider=ee,this._cache=new l.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(x,Y){const ee=this._documents.getDocument(x),ae=await this._provider.provideCodeLenses(ee,Y);if(!ae||Y.isCancellationRequested)return;const j=this._cache.add(ae),oe=new n.DisposableStore;this._disposables.set(j,oe);const he={cacheId:j,lenses:[]};for(let Te=0;Te<ae.length;Te++)he.lenses.push({cacheId:[j,Te],range:b.Range.from(ae[Te].range),command:this._commands.toInternal(ae[Te].command,oe)});return he}async resolveCodeLens(x,Y){const ee=x.cacheId&&this._cache.get(...x.cacheId);if(!ee)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||ee.isResolved?ae=ee:ae=await this._provider.resolveCodeLens(ee,Y),ae||(ae=ee),Y.isCancellationRequested)return;const j=x.cacheId&&this._disposables.get(x.cacheId[0]);if(!!j)return x.command=this._commands.toInternal(ae.command??g._badCmd,j),x}releaseCodeLenses(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}}g._badCmd={command:"missing",title:"!!MISSING: command!!"};function k(je){return Array.isArray(je)?je.map(b.DefinitionLink.from):je?[b.DefinitionLink.from(je)]:[]}class i{constructor(x,Y){this._documents=x,this._provider=Y}async provideDefinition(x,Y,ee){const ae=this._documents.getDocument(x),j=b.Position.to(Y),oe=await this._provider.provideDefinition(ae,j,ee);return k(oe)}}class a{constructor(x,Y){this._documents=x,this._provider=Y}async provideDeclaration(x,Y,ee){const ae=this._documents.getDocument(x),j=b.Position.to(Y),oe=await this._provider.provideDeclaration(ae,j,ee);return k(oe)}}class r{constructor(x,Y){this._documents=x,this._provider=Y}async provideImplementation(x,Y,ee){const ae=this._documents.getDocument(x),j=b.Position.to(Y),oe=await this._provider.provideImplementation(ae,j,ee);return k(oe)}}class o{constructor(x,Y){this._documents=x,this._provider=Y}async provideTypeDefinition(x,Y,ee){const ae=this._documents.getDocument(x),j=b.Position.to(Y),oe=await this._provider.provideTypeDefinition(ae,j,ee);return k(oe)}}class f{constructor(x,Y){this._documents=x,this._provider=Y}async provideHover(x,Y,ee){const ae=this._documents.getDocument(x),j=b.Position.to(Y),oe=await this._provider.provideHover(ae,j,ee);if(!(!oe||(0,P.isFalsyOrEmpty)(oe.contents)))return oe.range||(oe.range=ae.getWordRangeAtPosition(j)),oe.range||(oe.range=new T.Range(j,j)),b.Hover.from(oe)}}class m{constructor(x,Y){this._documents=x,this._provider=Y}async provideEvaluatableExpression(x,Y,ee){const ae=this._documents.getDocument(x),j=b.Position.to(Y),oe=await this._provider.provideEvaluatableExpression(ae,j,ee);if(oe)return b.EvaluatableExpression.from(oe)}}class v{constructor(x,Y){this._documents=x,this._provider=Y}async provideInlineValues(x,Y,ee,ae){const j=this._documents.getDocument(x),oe=await this._provider.provideInlineValues(j,b.Range.to(Y),b.InlineValueContext.to(ee),ae);if(Array.isArray(oe))return oe.map(he=>b.InlineValue.from(he))}}class C{constructor(x,Y){this._documents=x,this._provider=Y}async provideDocumentHighlights(x,Y,ee){const ae=this._documents.getDocument(x),j=b.Position.to(Y),oe=await this._provider.provideDocumentHighlights(ae,j,ee);if(Array.isArray(oe))return oe.map(b.DocumentHighlight.from)}}class R{constructor(x,Y){this._documents=x,this._provider=Y}async provideLinkedEditingRanges(x,Y,ee){const ae=this._documents.getDocument(x),j=b.Position.to(Y),oe=await this._provider.provideLinkedEditingRanges(ae,j,ee);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,P.coalesce)(oe.ranges.map(b.Range.from)),wordPattern:oe.wordPattern}}}class p{constructor(x,Y){this._documents=x,this._provider=Y}async provideReferences(x,Y,ee,ae){const j=this._documents.getDocument(x),oe=b.Position.to(Y),he=await this._provider.provideReferences(j,oe,ee,ae);if(Array.isArray(he))return he.map(b.location.from)}}class S{constructor(x,Y,ee,ae,j,oe,he){this._documents=x,this._commands=Y,this._diagnostics=ee,this._provider=ae,this._logService=j,this._extension=oe,this._apiDeprecation=he,this._cache=new l.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(x,Y,ee,ae){const j=this._documents.getDocument(x),oe=E.Selection.isISelection(Y)?b.Selection.to(Y):b.Range.to(Y),he=[];for(const nt of this._diagnostics.getDiagnostics(x))if(oe.intersection(nt.range)&&he.push(nt)>S._maxCodeActionsPerFile)break;const Te={diagnostics:he,only:ee.only?new T.CodeActionKind(ee.only):void 0,triggerKind:b.CodeActionTriggerKind.to(ee.trigger)},Be=await this._provider.provideCodeActions(j,oe,Te,ae);if(!(0,P.isNonEmptyArray)(Be)||ae.isCancellationRequested)return;const $e=this._cache.add(Be),Qe=new n.DisposableStore;this._disposables.set($e,Qe);const _e=[];for(let nt=0;nt<Be.length;nt++){const H=Be[nt];!H||(S._isCommand(H)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),_e.push({_isSynthetic:!0,title:H.title,command:this._commands.toInternal(H,Qe)})):(Te.only&&(H.kind?Te.only.contains(H.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${H.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),_e.push({cacheId:[$e,nt],title:H.title,command:H.command&&this._commands.toInternal(H.command,Qe),diagnostics:H.diagnostics&&H.diagnostics.map(b.Diagnostic.from),edit:H.edit&&b.WorkspaceEdit.from(H.edit),kind:H.kind&&H.kind.value,isPreferred:H.isPreferred,disabled:H.disabled?.reason})))}return{cacheId:$e,actions:_e}}async resolveCodeAction(x,Y){const[ee,ae]=x,j=this._cache.get(ee,ae);if(!j||S._isCommand(j)||!this._provider.resolveCodeAction)return;const oe=await this._provider.resolveCodeAction(j,Y)??j;return oe?.edit?b.WorkspaceEdit.from(oe.edit):void 0}releaseCodeActions(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}static _isCommand(x){return typeof x.command=="string"&&typeof x.title=="string"}}S._maxCodeActionsPerFile=1e3;class u{constructor(x,Y){this._documents=x,this._provider=Y}async provideDocumentFormattingEdits(x,Y,ee){const ae=this._documents.getDocument(x),j=await this._provider.provideDocumentFormattingEdits(ae,Y,ee);if(Array.isArray(j))return j.map(b.TextEdit.from)}}class A{constructor(x,Y){this._documents=x,this._provider=Y}async provideDocumentRangeFormattingEdits(x,Y,ee,ae){const j=this._documents.getDocument(x),oe=b.Range.to(Y),he=await this._provider.provideDocumentRangeFormattingEdits(j,oe,ee,ae);if(Array.isArray(he))return he.map(b.TextEdit.from)}}class L{constructor(x,Y){this._documents=x,this._provider=Y,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(x,Y,ee,ae,j){const oe=this._documents.getDocument(x),he=b.Position.to(Y),Te=await this._provider.provideOnTypeFormattingEdits(oe,he,ee,ae,j);if(Array.isArray(Te))return Te.map(b.TextEdit.from)}}class V{constructor(x,Y){this._provider=x,this._logService=Y,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(x,Y){const ee=F.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols(x,Y);if((0,P.isNonEmptyArray)(ae))for(const j of ae){if(!j)continue;if(!j.name){this._logService.warn("INVALID SymbolInformation, lacks name",j);continue}const oe=F.IdObject.mixin(b.WorkspaceSymbol.from(j));this._symbolCache.set(oe._id,j),ee.symbols.push(oe)}return ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee}async resolveWorkspaceSymbol(x,Y){if(typeof this._provider.resolveWorkspaceSymbol!="function")return x;const ee=this._symbolCache.get(x._id);if(ee){const ae=await this._provider.resolveWorkspaceSymbol(ee,Y);return ae&&(0,M.mixin)(x,b.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(x){const Y=this._resultCache.get(x);if(Y){for(let[ee,ae]=Y;ee<=ae;ee++)this._symbolCache.delete(ee);this._resultCache.delete(x)}}}class K{constructor(x,Y,ee){this._documents=x,this._provider=Y,this._logService=ee}static supportsResolving(x){return typeof x.prepareRename=="function"}async provideRenameEdits(x,Y,ee,ae){const j=this._documents.getDocument(x),oe=b.Position.to(Y);try{const he=await this._provider.provideRenameEdits(j,oe,ee,ae);return he?b.WorkspaceEdit.from(he):void 0}catch(he){const Te=K._asMessage(he);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation(x,Y,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(x),j=b.Position.to(Y);try{const oe=await this._provider.prepareRename(ae,j,ee);let he,Te;if(T.Range.isRange(oe)?(he=oe,Te=ae.getText(oe)):(0,t.isObject)(oe)&&(he=oe.range,Te=oe.placeholder),!he||!Te)return;if(he.start.line>j.line||he.end.line<j.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:b.Range.from(he),text:Te}}catch(oe){const he=K._asMessage(oe);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(oe)}}static _asMessage(x){return typeof x=="string"?x:x instanceof Error&&typeof x.message=="string"?x.message:void 0}}class W{constructor(x,Y){this.resultId=x,this.tokens=Y}}class Q{constructor(x,Y){this._documents=x,this._provider=Y,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(x,Y,ee){const ae=this._documents.getDocument(x),j=Y!==0?this._previousResults.get(Y):null;let oe=typeof j?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,j.resultId,ee):await this._provider.provideDocumentSemanticTokens(ae,ee);return j&&this._previousResults.delete(Y),oe?(oe=Q._fixProvidedSemanticTokens(oe),this._send(Q._convertToEdits(j,oe),oe)):null}async releaseDocumentSemanticColoring(x){this._previousResults.delete(x)}static _fixProvidedSemanticTokens(x){return Q._isSemanticTokens(x)?Q._isCorrectSemanticTokens(x)?x:new T.SemanticTokens(new Uint32Array(x.data),x.resultId):Q._isSemanticTokensEdits(x)?Q._isCorrectSemanticTokensEdits(x)?x:new T.SemanticTokensEdits(x.edits.map(Y=>new T.SemanticTokensEdit(Y.start,Y.deleteCount,Y.data?new Uint32Array(Y.data):Y.data)),x.resultId):x}static _isSemanticTokens(x){return x&&!!x.data}static _isCorrectSemanticTokens(x){return x.data instanceof Uint32Array}static _isSemanticTokensEdits(x){return x&&Array.isArray(x.edits)}static _isCorrectSemanticTokensEdits(x){for(const Y of x.edits)if(!(Y.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(x,Y){if(!Q._isSemanticTokens(Y)||!x||!x.tokens)return Y;const ee=x.tokens,ae=ee.length,j=Y.data,oe=j.length;let he=0;const Te=Math.min(ae,oe);for(;he<Te&&ee[he]===j[he];)he++;if(he===ae&&he===oe)return new T.SemanticTokensEdits([],Y.resultId);let Be=0;const $e=Te-he;for(;Be<$e&&ee[ae-Be-1]===j[oe-Be-1];)Be++;return new T.SemanticTokensEdits([{start:he,deleteCount:ae-he-Be,data:j.subarray(he,oe-Be)}],Y.resultId)}_send(x,Y){if(Q._isSemanticTokens(x)){const ee=this._nextResultId++;return this._previousResults.set(ee,new W(x.resultId,x.data)),(0,d.encodeSemanticTokensDto)({id:ee,type:"full",data:x.data})}if(Q._isSemanticTokensEdits(x)){const ee=this._nextResultId++;return Q._isSemanticTokens(Y)?this._previousResults.set(ee,new W(Y.resultId,Y.data)):this._previousResults.set(ee,new W(x.resultId)),(0,d.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(x.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=Q;class ${constructor(x,Y){this._documents=x,this._provider=Y}async provideDocumentRangeSemanticTokens(x,Y,ee){const ae=this._documents.getDocument(x),j=await this._provider.provideDocumentRangeSemanticTokens(ae,b.Range.to(Y),ee);return j?this._send(j):null}_send(x){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:x.data})}}e.DocumentRangeSemanticTokensAdapter=$;class U{constructor(x,Y,ee,ae,j){this._documents=x,this._commands=Y,this._provider=ee,this._apiDeprecation=ae,this._extension=j,this._cache=new l.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(x){return typeof x.resolveCompletionItem=="function"}async provideCompletionItems(x,Y,ee,ae){const j=this._documents.getDocument(x),oe=b.Position.to(Y),he=j.getWordRangeAtPosition(oe)||new T.Range(oe,oe),Te=he.with({end:oe}),Be=new w.StopWatch(!0),$e=await this._provider.provideCompletionItems(j,oe,ae,b.CompletionContext.to(ee));if(!$e||ae.isCancellationRequested)return;const Qe=Array.isArray($e)?new T.CompletionList($e):$e,_e=U.supportsResolving(this._provider)?this._cache.add(Qe.items):this._cache.add([]),nt=new n.DisposableStore;this._disposables.set(_e,nt);const H=[],J={x:_e,b:H,a:{replace:b.Range.from(he),insert:b.Range.from(Te)},c:Qe.isIncomplete||void 0,d:Be.elapsed()};for(let me=0;me<Qe.items.length;me++){const Ne=Qe.items[me],Ke=this._convertCompletionItem(Ne,[_e,me],Te,he);H.push(Ke)}return J}async resolveCompletionItem(x,Y){if(typeof this._provider.resolveCompletionItem!="function")return;const ee=this._cache.get(...x);if(!ee)return;const ae=await this._provider.resolveCompletionItem(ee,Y);if(!!ae)return this._convertCompletionItem(ae,x)}releaseCompletionItems(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}_convertCompletionItem(x,Y,ee,ae){const j=this._disposables.get(Y[0]);if(!j)throw Error("DisposableStore is missing...");const oe={x:Y,a:x.label,b:x.kind!==void 0?b.CompletionItemKind.from(x.kind):void 0,n:x.tags&&x.tags.map(b.CompletionItemTag.from),c:x.detail,d:typeof x.documentation=="undefined"?void 0:b.MarkdownString.fromStrict(x.documentation),e:x.sortText!==x.label?x.sortText:void 0,f:x.filterText!==x.label?x.filterText:void 0,g:x.preselect||void 0,i:x.keepWhitespace?1:0,k:x.commitCharacters,l:x.additionalTextEdits&&x.additionalTextEdits.map(b.TextEdit.from),m:this._commands.toInternal(x.command,j)};x.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),oe.h=x.textEdit.newText):typeof x.insertText=="string"?oe.h=x.insertText:x.insertText instanceof T.SnippetString&&(oe.h=x.insertText.value,oe.i|=4);let he;return x.textEdit?he=x.textEdit.range:x.range&&(he=x.range),T.Range.isRange(he)?oe.j=b.Range.from(he):he&&(!ee?.isEqual(he.inserting)||!ae?.isEqual(he.replacing))&&(oe.j={insert:b.Range.from(he.inserting),replace:b.Range.from(he.replacing)}),oe}}class z{constructor(x,Y,ee){this._documents=x,this._provider=Y,this._commands=ee,this._cache=new l.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(x,Y,ee,ae){const j=this._documents.getDocument(x),oe=b.Position.to(Y),he=await this._provider.provideInlineCompletionItems(j,oe,{selectedCompletionInfo:ee.selectedSuggestionInfo?{range:b.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:ee.triggerKind},ae);if(!he||ae.isCancellationRequested)return;const Te=(0,t.isArray)(he)?{items:he}:he,Be=this._cache.add(Te.items);let $e;return{pid:Be,items:Te.items.map((Qe,_e)=>{let nt;return Qe.command&&($e||($e=new n.DisposableStore,this._disposables.set(Be,$e)),nt=this._commands.toInternal(Qe.command,$e)),{text:Qe.text,range:Qe.range?b.Range.from(Qe.range):void 0,command:nt,idx:_e}})}}disposeCompletions(x){this._cache.delete(x);const Y=this._disposables.get(x);Y&&Y.clear(),this._disposables.delete(x)}handleDidShowCompletionItem(x,Y){const ee=this._cache.get(x,Y);ee&&G.get(this._provider).fireOnDidShowCompletionItem({completionItem:ee})}}class G{constructor(){this._onDidShowCompletionItemEmitter=new y.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(x){let Y=G.map.get(x);return Y||(Y=new G,G.map.set(x,Y)),Y}fireOnDidShowCompletionItem(x){this._onDidShowCompletionItemEmitter.fire(x)}}e.InlineCompletionController=G,G.map=new WeakMap;class ue{constructor(x,Y){this._documents=x,this._provider=Y,this._cache=new l.Cache("SignatureHelp")}async provideSignatureHelp(x,Y,ee,ae){const j=this._documents.getDocument(x),oe=b.Position.to(Y),he=this.reviveContext(ee),Te=await this._provider.provideSignatureHelp(j,oe,ae,he);if(Te){const Be=this._cache.add([Te]);return{...b.SignatureHelp.from(Te),id:Be}}}reviveContext(x){let Y;if(x.activeSignatureHelp){const ee=b.SignatureHelp.to(x.activeSignatureHelp),ae=this._cache.get(x.activeSignatureHelp.id,0);ae?(Y=ae,Y.activeSignature=ee.activeSignature,Y.activeParameter=ee.activeParameter):Y=ee}return{...x,activeSignatureHelp:Y}}releaseSignatureHelp(x){this._cache.delete(x)}}class q{constructor(x,Y){this._documents=x,this._provider=Y}async provideInlayHints(x,Y,ee){const ae=this._documents.getDocument(x),j=await this._provider.provideInlayHints(ae,b.Range.to(Y),ee);return j?{hints:j.map(b.InlayHint.from)}:void 0}}class le{constructor(x,Y){this._documents=x,this._provider=Y,this._cache=new l.Cache("DocumentLink")}async provideLinks(x,Y){const ee=this._documents.getDocument(x),ae=await this._provider.provideDocumentLinks(ee,Y);if(!(!Array.isArray(ae)||ae.length===0)&&!Y.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(le._validateLink).map(b.DocumentLink.from)};{const j=this._cache.add(ae),oe={links:[],id:j};for(let he=0;he<ae.length;he++){if(!le._validateLink(ae[he]))continue;const Te=b.DocumentLink.from(ae[he]);Te.cacheId=[j,he],oe.links.push(Te)}return oe}}}static _validateLink(x){return x.target&&x.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(x,Y){if(typeof this._provider.resolveDocumentLink!="function")return;const ee=this._cache.get(...x);if(!ee)return;const ae=await this._provider.resolveDocumentLink(ee,Y);if(!(!ae||!le._validateLink(ae)))return b.DocumentLink.from(ae)}releaseLinks(x){this._cache.delete(x)}}class se{constructor(x,Y){this._documents=x,this._provider=Y}async provideColors(x,Y){const ee=this._documents.getDocument(x),ae=await this._provider.provideDocumentColors(ee,Y);return Array.isArray(ae)?ae.map(oe=>({color:b.Color.from(oe.color),range:b.Range.from(oe.range)})):[]}async provideColorPresentations(x,Y,ee){const ae=this._documents.getDocument(x),j=b.Range.to(Y.range),oe=b.Color.to(Y.color),he=await this._provider.provideColorPresentations(oe,{document:ae,range:j},ee);if(!!Array.isArray(he))return he.map(b.ColorPresentation.from)}}class ve{constructor(x,Y){this._documents=x,this._provider=Y}async provideFoldingRanges(x,Y,ee){const ae=this._documents.getDocument(x),j=await this._provider.provideFoldingRanges(ae,Y,ee);if(!!Array.isArray(j))return j.map(b.FoldingRange.from)}}class Fe{constructor(x,Y,ee){this._documents=x,this._provider=Y,this._logService=ee}async provideSelectionRanges(x,Y,ee){const ae=this._documents.getDocument(x),j=Y.map(b.Position.to),oe=await this._provider.provideSelectionRanges(ae,j,ee);if(!(0,P.isNonEmptyArray)(oe))return[];if(oe.length!==j.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Te=0;Te<j.length;Te++){const Be=[];he.push(Be);let $e=j[Te],Qe=oe[Te];for(;;){if(!Qe.range.contains($e))throw new Error("INVALID selection range, must contain the previous range");if(Be.push(b.SelectionRange.from(Qe)),!Qe.parent)break;$e=Qe.range,Qe=Qe.parent}}return he}}class Me{constructor(x,Y){this._documents=x,this._provider=Y,this._idPool=new c.IdGenerator(""),this._cache=new Map}async prepareSession(x,Y,ee){const ae=this._documents.getDocument(x),j=b.Position.to(Y),oe=await this._provider.prepareCallHierarchy(ae,j,ee);if(!oe)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(oe)?oe.map(Te=>this._cacheAndConvertItem(he,Te)):[this._cacheAndConvertItem(he,oe)]}async provideCallsTo(x,Y,ee){const ae=this._itemFromCache(x,Y);if(!ae)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyIncomingCalls(ae,ee);if(!!j)return j.map(oe=>({from:this._cacheAndConvertItem(x,oe.from),fromRanges:oe.fromRanges.map(he=>b.Range.from(he))}))}async provideCallsFrom(x,Y,ee){const ae=this._itemFromCache(x,Y);if(!ae)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyOutgoingCalls(ae,ee);if(!!j)return j.map(oe=>({to:this._cacheAndConvertItem(x,oe.to),fromRanges:oe.fromRanges.map(he=>b.Range.from(he))}))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,Y){const ee=this._cache.get(x),ae=b.CallHierarchyItem.from(Y,x,ee.size.toString(36));return ee.set(ae._itemId,Y),ae}_itemFromCache(x,Y){return this._cache.get(x)?.get(Y)}}class Oe{constructor(x,Y){this._documents=x,this._provider=Y,this._idPool=new c.IdGenerator(""),this._cache=new Map}async prepareSession(x,Y,ee){const ae=this._documents.getDocument(x),j=b.Position.to(Y),oe=await this._provider.prepareTypeHierarchy(ae,j,ee);if(!oe)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(oe)?oe.map(Te=>this._cacheAndConvertItem(he,Te)):[this._cacheAndConvertItem(he,oe)]}async provideSupertypes(x,Y,ee){const ae=this._itemFromCache(x,Y);if(!ae)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySupertypes(ae,ee);if(!!j)return j.map(oe=>this._cacheAndConvertItem(x,oe))}async provideSubtypes(x,Y,ee){const ae=this._itemFromCache(x,Y);if(!ae)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySubtypes(ae,ee);if(!!j)return j.map(oe=>this._cacheAndConvertItem(x,oe))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,Y){const ee=this._cache.get(x),ae=b.TypeHierarchyItem.from(Y,x,ee.size.toString(36));return ee.set(ae._itemId,Y),ae}_itemFromCache(x,Y){return this._cache.get(x)?.get(Y)}}class Ye{constructor(x,Y){this.adapter=x,this.extension=Y}}class ze{constructor(x,Y,ee,ae,j,oe,he){this._adapter=new Map,this._uriTransformer=Y,this._proxy=x.getProxy(F.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=ae,this._diagnostics=j,this._logService=oe,this._apiDeprecation=he}_transformDocumentSelector(x){return(0,P.coalesce)((0,P.asArray)(x).map(Y=>this._doTransformDocumentSelector(Y)))}_doTransformDocumentSelector(x){if(typeof x=="string")return{$serialized:!0,language:x};if(x)return{$serialized:!0,language:x.language,scheme:this._transformScheme(x.scheme),pattern:typeof x.pattern=="undefined"?void 0:b.GlobPattern.from(x.pattern),exclusive:x.exclusive}}_transformScheme(x){return this._uriTransformer&&typeof x=="string"?this._uriTransformer.transformOutgoingScheme(x):x}_createDisposable(x){return new T.Disposable(()=>{this._adapter.delete(x),this._proxy.$unregister(x)})}_nextHandle(){return ze._handlePool++}_withAdapter(x,Y,ee,ae,j=!1){const oe=this._adapter.get(x);if(!oe)return Promise.resolve(ae);if(oe.adapter instanceof Y){let he;oe.extension&&(he=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${Y.name}'`));const Te=ee(oe.adapter,oe.extension),Be=oe.extension;return Be&&Promise.resolve(Te).then(()=>this._logService.trace(`[${Be.identifier.value}] provider DONE after ${Date.now()-he}ms`),$e=>{j&&$e instanceof I.CancellationError||(this._logService.error(`[${Be.identifier.value}] provider FAILED`),this._logService.error($e))}),Te}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(x,Y){const ee=this._nextHandle();return this._adapter.set(ee,new Ye(x,Y)),ee}static _extLabel(x){return x.displayName||x.name}registerDocumentSymbolProvider(x,Y,ee,ae){const j=this._addNewAdapter(new s(this._documents,ee),x),oe=ae&&ae.label||ze._extLabel(x);return this._proxy.$registerDocumentSymbolProvider(j,this._transformDocumentSelector(Y),oe),this._createDisposable(j)}$provideDocumentSymbols(x,Y,ee){return this._withAdapter(x,s,ae=>ae.provideDocumentSymbols(h.URI.revive(Y),ee),void 0)}registerCodeLensProvider(x,Y,ee){const ae=this._nextHandle(),j=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ye(new g(this._documents,this._commands.converter,ee),x)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(Y),j);let oe=this._createDisposable(ae);if(j!==void 0){const he=ee.onDidChangeCodeLenses(Te=>this._proxy.$emitCodeLensEvent(j));oe=T.Disposable.from(oe,he)}return oe}$provideCodeLenses(x,Y,ee){return this._withAdapter(x,g,ae=>ae.provideCodeLenses(h.URI.revive(Y),ee),void 0)}$resolveCodeLens(x,Y,ee){return this._withAdapter(x,g,ae=>ae.resolveCodeLens(Y,ee),void 0)}$releaseCodeLenses(x,Y){this._withAdapter(x,g,ee=>Promise.resolve(ee.releaseCodeLenses(Y)),void 0)}registerDefinitionProvider(x,Y,ee){const ae=this._addNewAdapter(new i(this._documents,ee),x);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDefinition(x,Y,ee,ae){return this._withAdapter(x,i,j=>j.provideDefinition(h.URI.revive(Y),ee,ae),[])}registerDeclarationProvider(x,Y,ee){const ae=this._addNewAdapter(new a(this._documents,ee),x);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDeclaration(x,Y,ee,ae){return this._withAdapter(x,a,j=>j.provideDeclaration(h.URI.revive(Y),ee,ae),[])}registerImplementationProvider(x,Y,ee){const ae=this._addNewAdapter(new r(this._documents,ee),x);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideImplementation(x,Y,ee,ae){return this._withAdapter(x,r,j=>j.provideImplementation(h.URI.revive(Y),ee,ae),[])}registerTypeDefinitionProvider(x,Y,ee){const ae=this._addNewAdapter(new o(this._documents,ee),x);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideTypeDefinition(x,Y,ee,ae){return this._withAdapter(x,o,j=>j.provideTypeDefinition(h.URI.revive(Y),ee,ae),[])}registerHoverProvider(x,Y,ee,ae){const j=this._addNewAdapter(new f(this._documents,ee),x);return this._proxy.$registerHoverProvider(j,this._transformDocumentSelector(Y)),this._createDisposable(j)}$provideHover(x,Y,ee,ae){return this._withAdapter(x,f,j=>j.provideHover(h.URI.revive(Y),ee,ae),void 0)}registerEvaluatableExpressionProvider(x,Y,ee,ae){const j=this._addNewAdapter(new m(this._documents,ee),x);return this._proxy.$registerEvaluatableExpressionProvider(j,this._transformDocumentSelector(Y)),this._createDisposable(j)}$provideEvaluatableExpression(x,Y,ee,ae){return this._withAdapter(x,m,j=>j.provideEvaluatableExpression(h.URI.revive(Y),ee,ae),void 0)}registerInlineValuesProvider(x,Y,ee,ae){const j=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new v(this._documents,ee),x);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(Y),j);let he=this._createDisposable(oe);if(j!==void 0){const Te=ee.onDidChangeInlineValues(Be=>this._proxy.$emitInlineValuesEvent(j));he=T.Disposable.from(he,Te)}return he}$provideInlineValues(x,Y,ee,ae,j){return this._withAdapter(x,v,oe=>oe.provideInlineValues(h.URI.revive(Y),ee,ae,j),void 0)}registerDocumentHighlightProvider(x,Y,ee){const ae=this._addNewAdapter(new C(this._documents,ee),x);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDocumentHighlights(x,Y,ee,ae){return this._withAdapter(x,C,j=>j.provideDocumentHighlights(h.URI.revive(Y),ee,ae),void 0)}registerLinkedEditingRangeProvider(x,Y,ee){const ae=this._addNewAdapter(new R(this._documents,ee),x);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideLinkedEditingRanges(x,Y,ee,ae){return this._withAdapter(x,R,async j=>{const oe=await j.provideLinkedEditingRanges(h.URI.revive(Y),ee,ae);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?ze._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider(x,Y,ee){const ae=this._addNewAdapter(new p(this._documents,ee),x);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideReferences(x,Y,ee,ae,j){return this._withAdapter(x,p,oe=>oe.provideReferences(h.URI.revive(Y),ee,ae,j),void 0)}registerCodeActionProvider(x,Y,ee,ae){const j=new n.DisposableStore,oe=this._addNewAdapter(new S(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,x,this._apiDeprecation),x);return this._proxy.$registerQuickFixSupport(oe,this._transformDocumentSelector(Y),{providedKinds:ae?.providedCodeActionKinds?.map(he=>he.value),documentation:ae?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,j)}))},ze._extLabel(x),Boolean(ee.resolveCodeAction)),j.add(this._createDisposable(oe)),j}$provideCodeActions(x,Y,ee,ae,j){return this._withAdapter(x,S,oe=>oe.provideCodeActions(h.URI.revive(Y),ee,ae,j),void 0)}$resolveCodeAction(x,Y,ee){return this._withAdapter(x,S,ae=>ae.resolveCodeAction(Y,ee),void 0)}$releaseCodeActions(x,Y){this._withAdapter(x,S,ee=>Promise.resolve(ee.releaseCodeActions(Y)),void 0)}registerDocumentFormattingEditProvider(x,Y,ee){const ae=this._addNewAdapter(new u(this._documents,ee),x);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(Y),x.identifier,x.displayName||x.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(x,Y,ee,ae){return this._withAdapter(x,u,j=>j.provideDocumentFormattingEdits(h.URI.revive(Y),ee,ae),void 0)}registerDocumentRangeFormattingEditProvider(x,Y,ee){const ae=this._addNewAdapter(new A(this._documents,ee),x);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(Y),x.identifier,x.displayName||x.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(x,Y,ee,ae,j){return this._withAdapter(x,A,oe=>oe.provideDocumentRangeFormattingEdits(h.URI.revive(Y),ee,ae,j),void 0)}registerOnTypeFormattingEditProvider(x,Y,ee,ae){const j=this._addNewAdapter(new L(this._documents,ee),x);return this._proxy.$registerOnTypeFormattingSupport(j,this._transformDocumentSelector(Y),ae,x.identifier),this._createDisposable(j)}$provideOnTypeFormattingEdits(x,Y,ee,ae,j,oe){return this._withAdapter(x,L,he=>he.provideOnTypeFormattingEdits(h.URI.revive(Y),ee,ae,j,oe),void 0)}registerWorkspaceSymbolProvider(x,Y){const ee=this._addNewAdapter(new V(Y,this._logService),x);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(x,Y,ee){return this._withAdapter(x,V,ae=>ae.provideWorkspaceSymbols(Y,ee),{symbols:[]})}$resolveWorkspaceSymbol(x,Y,ee){return this._withAdapter(x,V,ae=>ae.resolveWorkspaceSymbol(Y,ee),void 0)}$releaseWorkspaceSymbols(x,Y){this._withAdapter(x,V,ee=>ee.releaseWorkspaceSymbols(Y),void 0)}registerRenameProvider(x,Y,ee){const ae=this._addNewAdapter(new K(this._documents,ee,this._logService),x);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(Y),K.supportsResolving(ee)),this._createDisposable(ae)}$provideRenameEdits(x,Y,ee,ae,j){return this._withAdapter(x,K,oe=>oe.provideRenameEdits(h.URI.revive(Y),ee,ae,j),void 0)}$resolveRenameLocation(x,Y,ee,ae){return this._withAdapter(x,K,j=>j.resolveRenameLocation(h.URI.revive(Y),ee,ae),void 0)}registerDocumentSemanticTokensProvider(x,Y,ee,ae){const j=this._nextHandle(),oe=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(j,new Ye(new Q(this._documents,ee),x)),this._proxy.$registerDocumentSemanticTokensProvider(j,this._transformDocumentSelector(Y),ae,oe);let he=this._createDisposable(j);if(oe){const Te=ee.onDidChangeSemanticTokens(Be=>this._proxy.$emitDocumentSemanticTokensEvent(oe));he=T.Disposable.from(he,Te)}return he}$provideDocumentSemanticTokens(x,Y,ee,ae){return this._withAdapter(x,Q,j=>j.provideDocumentSemanticTokens(h.URI.revive(Y),ee,ae),null,!0)}$releaseDocumentSemanticTokens(x,Y){this._withAdapter(x,Q,ee=>ee.releaseDocumentSemanticColoring(Y),void 0)}registerDocumentRangeSemanticTokensProvider(x,Y,ee,ae){const j=this._addNewAdapter(new $(this._documents,ee),x);return this._proxy.$registerDocumentRangeSemanticTokensProvider(j,this._transformDocumentSelector(Y),ae),this._createDisposable(j)}$provideDocumentRangeSemanticTokens(x,Y,ee,ae){return this._withAdapter(x,$,j=>j.provideDocumentRangeSemanticTokens(h.URI.revive(Y),ee,ae),null,!0)}registerCompletionItemProvider(x,Y,ee,ae){const j=this._addNewAdapter(new U(this._documents,this._commands.converter,ee,this._apiDeprecation,x),x);return this._proxy.$registerSuggestSupport(j,this._transformDocumentSelector(Y),ae,U.supportsResolving(ee),`${x.identifier.value}(${ae.join("")})`),this._createDisposable(j)}$provideCompletionItems(x,Y,ee,ae,j){return this._withAdapter(x,U,oe=>oe.provideCompletionItems(h.URI.revive(Y),ee,ae,j),void 0)}$resolveCompletionItem(x,Y,ee){return this._withAdapter(x,U,ae=>ae.resolveCompletionItem(Y,ee),void 0)}$releaseCompletionItems(x,Y){this._withAdapter(x,U,ee=>ee.releaseCompletionItems(Y),void 0)}registerInlineCompletionsProvider(x,Y,ee){const ae=this._addNewAdapter(new z(this._documents,ee,this._commands.converter),x);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideInlineCompletions(x,Y,ee,ae,j){return this._withAdapter(x,z,oe=>oe.provideInlineCompletions(h.URI.revive(Y),ee,ae,j),void 0)}$handleInlineCompletionDidShow(x,Y,ee){this._withAdapter(x,z,async ae=>{ae.handleDidShowCompletionItem(Y,ee)},void 0)}$freeInlineCompletionsList(x,Y){this._withAdapter(x,z,async ee=>{ee.disposeCompletions(Y)},void 0)}registerSignatureHelpProvider(x,Y,ee,ae){const j=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,oe=this._addNewAdapter(new ue(this._documents,ee),x);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(Y),j),this._createDisposable(oe)}$provideSignatureHelp(x,Y,ee,ae,j){return this._withAdapter(x,ue,oe=>oe.provideSignatureHelp(h.URI.revive(Y),ee,ae,j),void 0)}$releaseSignatureHelp(x,Y){this._withAdapter(x,ue,ee=>ee.releaseSignatureHelp(Y),void 0)}registerInlayHintsProvider(x,Y,ee){const ae=typeof ee.onDidChangeInlayHints=="function"?this._nextHandle():void 0,j=this._addNewAdapter(new q(this._documents,ee),x);this._proxy.$registerInlayHintsProvider(j,this._transformDocumentSelector(Y),ae);let oe=this._createDisposable(j);if(ae!==void 0){const he=ee.onDidChangeInlayHints(Te=>this._proxy.$emitInlayHintsEvent(ae));oe=T.Disposable.from(oe,he)}return oe}$provideInlayHints(x,Y,ee,ae){return this._withAdapter(x,q,j=>j.provideInlayHints(h.URI.revive(Y),ee,ae),void 0)}registerDocumentLinkProvider(x,Y,ee){const ae=this._addNewAdapter(new le(this._documents,ee),x);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(Y),typeof ee.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(x,Y,ee){return this._withAdapter(x,le,ae=>ae.provideLinks(h.URI.revive(Y),ee),void 0)}$resolveDocumentLink(x,Y,ee){return this._withAdapter(x,le,ae=>ae.resolveLink(Y,ee),void 0)}$releaseDocumentLinks(x,Y){this._withAdapter(x,le,ee=>ee.releaseLinks(Y),void 0)}registerColorProvider(x,Y,ee){const ae=this._addNewAdapter(new se(this._documents,ee),x);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideDocumentColors(x,Y,ee){return this._withAdapter(x,se,ae=>ae.provideColors(h.URI.revive(Y),ee),[])}$provideColorPresentations(x,Y,ee,ae){return this._withAdapter(x,se,j=>j.provideColorPresentations(h.URI.revive(Y),ee,ae),void 0)}registerFoldingRangeProvider(x,Y,ee){const ae=this._nextHandle(),j=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Ye(new ve(this._documents,ee),x)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(Y),j);let oe=this._createDisposable(ae);if(j!==void 0){const he=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(j));oe=T.Disposable.from(oe,he)}return oe}$provideFoldingRanges(x,Y,ee,ae){return this._withAdapter(x,ve,j=>j.provideFoldingRanges(h.URI.revive(Y),ee,ae),void 0)}registerSelectionRangeProvider(x,Y,ee){const ae=this._addNewAdapter(new Fe(this._documents,ee,this._logService),x);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$provideSelectionRanges(x,Y,ee,ae){return this._withAdapter(x,Fe,j=>j.provideSelectionRanges(h.URI.revive(Y),ee,ae),[])}registerCallHierarchyProvider(x,Y,ee){const ae=this._addNewAdapter(new Me(this._documents,ee),x);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$prepareCallHierarchy(x,Y,ee,ae){return this._withAdapter(x,Me,j=>Promise.resolve(j.prepareSession(h.URI.revive(Y),ee,ae)),void 0)}$provideCallHierarchyIncomingCalls(x,Y,ee,ae){return this._withAdapter(x,Me,j=>j.provideCallsTo(Y,ee,ae),void 0)}$provideCallHierarchyOutgoingCalls(x,Y,ee,ae){return this._withAdapter(x,Me,j=>j.provideCallsFrom(Y,ee,ae),void 0)}$releaseCallHierarchy(x,Y){this._withAdapter(x,Me,ee=>Promise.resolve(ee.releaseSession(Y)),void 0)}registerTypeHierarchyProvider(x,Y,ee){const ae=this._addNewAdapter(new Oe(this._documents,ee),x);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(Y)),this._createDisposable(ae)}$prepareTypeHierarchy(x,Y,ee,ae){return this._withAdapter(x,Oe,j=>Promise.resolve(j.prepareSession(h.URI.revive(Y),ee,ae)),void 0)}$provideTypeHierarchySupertypes(x,Y,ee,ae){return this._withAdapter(x,Oe,j=>j.provideSupertypes(Y,ee,ae),void 0)}$provideTypeHierarchySubtypes(x,Y,ee,ae){return this._withAdapter(x,Oe,j=>j.provideSubtypes(Y,ee,ae),void 0)}$releaseTypeHierarchy(x,Y){this._withAdapter(x,Oe,ee=>Promise.resolve(ee.releaseSession(Y)),void 0)}static _serializeRegExp(x){return{pattern:x.source,flags:(0,D.regExpFlags)(x)}}static _serializeIndentationRule(x){return{decreaseIndentPattern:ze._serializeRegExp(x.decreaseIndentPattern),increaseIndentPattern:ze._serializeRegExp(x.increaseIndentPattern),indentNextLinePattern:x.indentNextLinePattern?ze._serializeRegExp(x.indentNextLinePattern):void 0,unIndentedLinePattern:x.unIndentedLinePattern?ze._serializeRegExp(x.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(x){return{beforeText:ze._serializeRegExp(x.beforeText),afterText:x.afterText?ze._serializeRegExp(x.afterText):void 0,previousLineText:x.previousLineText?ze._serializeRegExp(x.previousLineText):void 0,action:x.action}}static _serializeOnEnterRules(x){return x.map(ze._serializeOnEnterRule)}setLanguageConfiguration(x,Y,ee){let{wordPattern:ae}=ee;if(ae&&(0,D.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(Y,ae):this._documents.setWordDefinitionFor(Y,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",x,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",x,"Do not use.");const j=this._nextHandle(),oe={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?ze._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?ze._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?ze._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(j,Y,oe),this._createDisposable(j)}$setWordDefinitions(x){for(const Y of x)this._documents.setWordDefinitionFor(Y.languageId,new RegExp(Y.regexSource,Y.regexFlags))}}e.ExtHostLanguageFeatures=ze,ze._handlePool=0}),define(we[194],be([0,1,5,8,7,35,14,6]),function(ne,e,h,M,b,T,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class _{constructor(t,E,n){this._documents=E,this._commands=n,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=t.getProxy(h.MainContext.MainThreadLanguages)}$acceptLanguageIds(t){this._languageIds=t}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(t,E){await this._proxy.$changeLanguage(t,E);const n=this._documents.getDocumentData(t);if(!n)throw new Error(`document '${t.toString}' NOT found`);return n.document}async tokenAtPosition(t,E){const n=t.version,d=M.Position.from(E),c=await this._proxy.$tokensAtPosition(t.uri,d),l={type:b.StandardTokenType.Other,range:t.getWordRangeAtPosition(E)??new b.Range(E.line,E.character,E.line,E.character)};if(!c)return l;const w={range:M.Range.to(c.range),type:M.TokenType.to(c.type)};return!w.range.contains(E)||n!==t.version?l:w}createLanguageStatusItem(t,E,n){const d=this._handlePool++,c=this._proxy,l=this._ids,w=`${t.identifier.value}/${E}`;if(l.has(w))throw new Error(`LanguageStatusItem with id '${E}' ALREADY exists`);l.add(w);const I={selector:n,id:E,name:t.displayName??t.name,severity:b.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let y,s=new D.DisposableStore;const g=()=>{y?.dispose(),y=(0,F.disposableTimeout)(()=>{s.clear(),this._proxy.$setLanguageStatus(d,{id:w,name:I.name??t.displayName??t.name,source:t.displayName??t.name,selector:I.selector,label:I.text,detail:I.detail??"",severity:I.severity===b.LanguageStatusSeverity.Error?T.default.Error:I.severity===b.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:I.command&&this._commands.toInternal(I.command,s),accessibilityInfo:I.accessibilityInformation})},0)},k={dispose(){s.dispose(),y?.dispose(),c.$removeLanguageStatus(d),l.delete(w)},get id(){return I.id},get name(){return I.name},set name(i){I.name=i,g()},get selector(){return I.selector},set selector(i){I.selector=i,g()},get text(){return I.text},set text(i){I.text=i,g()},get detail(){return I.detail},set detail(i){I.detail=i,g()},get severity(){return I.severity},set severity(i){I.severity=i,g()},get accessibilityInformation(){return I.accessibilityInformation},set accessibilityInformation(i){I.accessibilityInformation=i,g()},get command(){return I.command},set command(i){I.command=i,g()}};return g(),k}}e.ExtHostLanguages=_}),define(we[195],be([0,1,5,15,30]),function(ne,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(D){return D&&D.title}let F=class{constructor(_,P){this._logService=P,this._proxy=_.getProxy(h.MainContext.MainThreadMessageService)}showMessage(_,P,t,E,n){const d={extension:_};let c;typeof E=="string"||T(E)?c=[E,...n]:(d.modal=E?.modal,d.useCustom=E?.useCustom,d.detail=E?.detail,c=n),d.useCustom&&(0,b.checkProposedApiEnabled)(_);const l=[];for(let w=0;w<c.length;w++){const I=c[w];if(typeof I=="string")l.push({title:I,handle:w,isCloseAffordance:!1});else if(typeof I=="object"){let{title:y,isCloseAffordance:s}=I;l.push({title:y,isCloseAffordance:!!s,handle:w})}else this._logService.warn("Invalid message item:",I)}return this._proxy.$showMessage(P,t,d,l).then(w=>{if(typeof w=="number")return c[w]})}};F=Ue([He(1,M.ILogService)],F),e.ExtHostMessageService=F}),define(we[196],be([0,1,23,3,58,6,20,9,10,2,63,5,8,7,47,171,93]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n,d,c,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class I{constructor(s,g,k,i,a){this._textDocumentsAndEditors=k,this._textDocuments=i,this._extensionStoragePaths=a,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new F.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new M.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new M.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new M.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new M.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new M.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new M.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new M.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new t.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=s.getProxy(E.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(E.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(E.MainContext.MainThreadNotebookEditors),this._commandsConverter=g.converter,g.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const o=r.notebookEditor?.notebookUri,f=r.cell.handle,v=this._documents.get(o)?.getCell(f);if(v)return v.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}getEditorById(s){const g=this._editors.get(s);if(!g)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);return g}getIdByEditor(s){for(const[g,k]of this._editors)if(k.apiEditor===s)return g}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(s,g){const k=this._documents.get(s);if(!k&&!g)throw new Error(`NO notebook document for '${s}'`);return k}_getProviderData(s){const g=this._notebookContentProviders.get(s);if(!g)throw new Error(`NO provider for '${s}'`);return g}registerNotebookContentProvider(s,g,k,i,a){if((0,D.isFalsyOrWhitespace)(g))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(g))throw new Error(`Notebook provider for '${g}' already registered`);this._notebookContentProviders.set(g,{extension:s,provider:k});let r;return k.onDidChangeNotebookContentOptions&&(r=k.onDidChangeNotebookContentOptions(()=>{const o=n.NotebookDocumentContentOptions.from(k.options);this._notebookProxy.$updateNotebookProviderOptions(g,o)})),this._notebookProxy.$registerNotebookProvider({id:s.identifier,location:s.extensionLocation},g,n.NotebookDocumentContentOptions.from(i),I._convertNotebookRegistrationData(s,a)),new d.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(g),this._notebookProxy.$unregisterNotebookProvider(g)})}static _convertNotebookRegistrationData(s,g){if(!g)return;const k=g.filenamePattern.map(i=>n.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(g.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${g.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:g.displayName,filenamePattern:k,exclusive:g.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,g,k){const i=I._notebookStatusBarItemProviderHandlePool++,a=typeof k.onDidChangeCellStatusBarItems=="function"?I._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,k),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,a,g);let r;return a!==void 0&&(r=k.onDidChangeCellStatusBarItems(o=>this._notebookProxy.$emitCellStatusBarEvent(a))),new d.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,a),r&&r.dispose()})}async createNotebookDocument(s){const g=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:s.viewType,content:s.content&&n.NotebookData.from(s.content)});return P.URI.revive(g)}async openNotebookDocument(s){const g=this._documents.get(s);if(g)return g.apiNotebook;const k=await this._notebookDocumentsProxy.$tryOpenNotebook(s),i=this._documents.get(P.URI.revive(k));return(0,_.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(s,g){P.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let k;typeof g=="object"?k={position:n.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selections:g.selections&&g.selections.map(n.NotebookRange.from),pinned:typeof g.preview=="boolean"?!g.preview:void 0}:k={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.notebookType,k),a=i&&this._editors.get(i)?.apiEditor;if(a)return a;throw i?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,g,k,i){const a=this._notebookStatusBarItemProviders.get(s),r=P.URI.revive(g),o=this._documents.get(r);if(!o||!a)return;const f=o.getCellFromIndex(k);if(!f)return;const m=await a.provideCellStatusBarItems(f.apiCell,i);if(!m)return;const v=new T.DisposableStore,C=this._statusBarCache.add([v]),p=(Array.isArray(m)?m:[m]).map(S=>n.NotebookStatusBarItem.from(S,this._commandsConverter,v));return{cacheId:C,items:p}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,g,k,i,a){if((0,D.isFalsyOrWhitespace)(g))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,k),this._notebookProxy.$registerNotebookSerializer(r,{id:s.identifier,location:s.extensionLocation},g,n.NotebookDocumentContentOptions.from(i),I._convertNotebookRegistrationData(s,a)),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(s,g,k){const i=this._notebookSerializer.get(s);if(!i)throw new Error("NO serializer found");const a=await i.deserializeNotebook(g.buffer,k);return new c.SerializableObjectWithBuffers(n.NotebookData.from(a))}async $notebookToData(s,g,k){const i=this._notebookSerializer.get(s);if(!i)throw new Error("NO serializer found");const a=await i.serializeNotebook(n.NotebookData.to(g.value),k);return h.VSBuffer.wrap(a)}async $openNotebook(s,g,k,i,a){const{provider:r}=this._getProviderData(s),o=await r.openNotebook(P.URI.revive(g),{backupId:k,untitledDocumentData:i?.buffer},a);return new c.SerializableObjectWithBuffers({metadata:o.metadata??Object.create(null),cells:o.cells.map(n.NotebookCellData.from)})}async $saveNotebook(s,g,k){const i=this.getNotebookDocument(P.URI.revive(g)),{provider:a}=this._getProviderData(s);return await a.saveNotebook(i.apiNotebook,k),!0}async $saveNotebookAs(s,g,k,i){const a=this.getNotebookDocument(P.URI.revive(g)),{provider:r}=this._getProviderData(s);return await r.saveNotebookAs(P.URI.revive(k),a.apiNotebook,i),!0}async $backupNotebook(s,g,k){const i=this.getNotebookDocument(P.URI.revive(g)),a=this._getProviderData(s),r=this._extensionStoragePaths.workspaceValue(a.extension)??this._extensionStoragePaths.globalValue(a.extension),o=String((0,b.hash)([i.uri.toString(),this._backupIdPool++])),f=P.URI.joinPath(r,o),m=await a.provider.backupNotebook(i.apiNotebook,{destination:f},k);return i.updateBackup(m),m.id}_createExtHostEditor(s,g,k){if(this._editors.has(g))throw new Error(`editor with id ALREADY EXSIST: ${g}`);const i=new w.ExtHostNotebookEditor(g,this._notebookEditorsProxy,s,k.visibleRanges.map(n.NotebookRange.to),k.selections.map(n.NotebookRange.to),typeof k.viewColumn=="number"?n.ViewColumn.to(k.viewColumn):void 0);this._editors.set(g,i)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const k of s.value.removedDocuments){const i=P.URI.revive(k),a=this._documents.get(i);a&&(a.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:a.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(a.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===i.toString()&&this._editors.delete(r.id)}if(s.value.addedDocuments){const k=[];for(const i of s.value.addedDocuments){const a=P.URI.revive(i.uri);if(this._documents.has(a))throw new Error(`adding EXISTING notebook ${a} `);const r=this,o=new l.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(f){r._onDidChangeNotebookCells.fire(f)},emitCellOutputsChange(f){r._onDidChangeCellOutputs.fire(f)},emitCellMetadataChange(f){r._onDidChangeCellMetadata.fire(f)},emitCellExecutionStateChange(f){r._onDidChangeCellExecutionState.fire(f)}},a,i);k.push(...i.cells.map(f=>l.ExtHostCell.asModelAddData(o.apiNotebook,f))),this._documents.get(a)?.dispose(),this._documents.set(a,o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this._onDidOpenNotebookDocument.fire(o.apiNotebook)}}if(s.value.addedEditors)for(const k of s.value.addedEditors){if(this._editors.has(k.id))return;const i=P.URI.revive(k.documentUri),a=this._documents.get(i);a&&this._createExtHostEditor(a,k.id,k)}const g=[];if(s.value.removedEditors)for(const k of s.value.removedEditors){const i=this._editors.get(k);i&&(this._editors.delete(k),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),g.push(i))}if(s.value.visibleEditors){this._visibleNotebookEditors=s.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const k=new Set;this._visibleNotebookEditors.forEach(i=>k.add(i.id));for(const i of this._editors.values()){const a=k.has(i.id);i._acceptVisibility(a)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this._activeNotebookEditor=void 0:s.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=I,I._notebookStatusBarItemProviderHandlePool=0}),define(we[197],be([0,1,3,53,15,5,12,8]),function(ne,e,h,M,b,T,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(E,n){const d=_._Keys.nextId();E.$registerNotebookEditorDecorationType(d,D.NotebookDecorationRenderOptions.from(n)),this.value={key:d,dispose(){E.$removeNotebookEditorDecorationType(d)}}}}_._Keys=new M.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(E,n,d){this._logService=E,this._extHostRpc=n,this._notebooksAndEditors=d,this._onDidChangeNotebookEditorSelection=new h.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new h.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(E){return new _(this._extHostRpc.getProxy(T.MainContext.MainThreadNotebookEditors),E).value}$acceptEditorPropertiesChanged(E,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,n);const d=this._notebooksAndEditors.getEditorById(E);n.visibleRanges&&d._acceptVisibleRanges(n.visibleRanges.ranges.map(D.NotebookRange.to)),n.selections&&d._acceptSelections(n.selections.selections.map(D.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:d.apiEditor,visibleRanges:d.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:d.apiEditor,selections:d.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const n in E)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(D.ViewColumn.to(E[n]))}};P=Ue([He(0,b.ILogService),He(1,F.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(we[198],be([0,1,13,14,21,3,6,20,2,25,15,5,8,7,66,164,30,47]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n,d,c,l,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let y=class{constructor(a,r,o,f){this._initData=r,this._extHostNotebook=o,this._logService=f,this._activeExecutions=new D.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=a.getProxy(E.MainContext.MainThreadNotebookKernels)}createNotebookController(a,r,o,f,m,v){for(let G of this._kernelData.values())if(G.controller.id===r&&P.ExtensionIdentifier.equals(a.identifier,G.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const C=this._handlePool++,R=this;this._logService.trace(`NotebookController[${C}], CREATED by ${a.identifier.value}, ${r}`);const p=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${a.identifier}'`);let S=!1;const u=new F.DisposableStore,A=new T.Emitter,L=new T.Emitter,V={id:`${a.identifier.value}/${r}`,notebookType:o,extensionId:a.identifier,extensionLocation:a.extensionLocation,label:f||a.identifier.value,preloads:v?v.map(n.NotebookRendererScript.from):[]};let K=m??p,W;this._proxy.$addKernel(C,V).catch(G=>{console.log(G),S=!0});let Q=0;const $=()=>{if(S)return;const G=++Q;Promise.resolve().then(()=>{G===Q&&this._proxy.$updateKernel(C,V)})},U=new D.ResourceMap,z={get id(){return r},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:A.event,get label(){return V.label},set label(G){V.label=G??a.displayName??a.name,$()},get detail(){return V.detail??""},set detail(G){V.detail=G,$()},get description(){return V.description??""},set description(G){V.description=G,$()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages(G){V.supportedLanguages=G,$()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder(G){V.supportsExecutionOrder=G,$()},get rendererScripts(){return V.preloads?V.preloads.map(n.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(G){K=G??p},get interruptHandler(){return W},set interruptHandler(G){W=G,V.supportsInterrupt=Boolean(G),$()},createNotebookCellExecution(G){if(S)throw new Error("notebook controller is DISPOSED");if(!U.has(G.notebook.uri))throw R._logService.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(U.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${G.notebook.uri.toString()}`);return R._createNotebookCellExecution(G)},dispose:()=>{S||(this._logService.trace(`NotebookController[${C}], DISPOSED`),S=!0,this._kernelData.delete(C),u.dispose(),A.dispose(),L.dispose(),this._proxy.$removeKernel(C))},updateNotebookAffinity(G,ue){R._proxy.$updateNotebookPriority(C,G.uri,ue)},onDidReceiveMessage:L.event,postMessage(G,ue){return(0,w.checkProposedApiEnabled)(a),R._proxy.$postMessage(C,ue&&R._extHostNotebook.getIdByEditor(ue),G)},asWebviewUri(G){return(0,w.checkProposedApiEnabled)(a),(0,c.asWebviewUri)(G,R._initData.remote)}};return this._kernelData.set(C,{extensionId:a.identifier,controller:z,onDidReceiveMessage:L,onDidChangeSelection:A,associatedNotebooks:U}),z}$acceptNotebookAssociation(a,r,o){const f=this._kernelData.get(a);if(f){const m=this._extHostNotebook.getNotebookDocument(_.URI.revive(r));o?f.associatedNotebooks.set(m.uri,!0):f.associatedNotebooks.delete(m.uri),this._logService.trace(`NotebookController[${a}] ASSOCIATE notebook`,m.uri.toString(),o),f.onDidChangeSelection.fire({selected:o,notebook:m.apiNotebook})}}async $executeCells(a,r,o){const f=this._kernelData.get(a);if(!f)return;const m=this._extHostNotebook.getNotebookDocument(_.URI.revive(r)),v=[];for(let C of o){const R=m.getCell(C);R&&v.push(R.apiCell)}try{this._logService.trace(`NotebookController[${a}] EXECUTE cells`,m.uri.toString(),v.length),await f.controller.executeHandler.call(f.controller,v,m.apiNotebook,f.controller)}catch(C){this._logService.error(`NotebookController[${a}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(a,r,o){const f=this._kernelData.get(a);if(!f)return;const m=this._extHostNotebook.getNotebookDocument(_.URI.revive(r));if(f.controller.interruptHandler)await f.controller.interruptHandler.call(f.controller,m.apiNotebook);else for(let v of o){const C=m.getCell(v);C&&this._activeExecutions.get(C.uri)?.cancel()}}$acceptKernelMessageFromRenderer(a,r,o){const f=this._kernelData.get(a);if(!f)return;const m=this._extHostNotebook.getEditorById(r);f.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:o}))}_createNotebookCellExecution(a){if(a.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(a.notebook.uri).getCellFromApiCell(a);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const f=new g(o.notebook,o,this._proxy);this._activeExecutions.set(o.uri,f);const m=f.onDidChangeState(()=>{f.state===s.Resolved&&(f.dispose(),m.dispose(),this._activeExecutions.delete(o.uri))});return f.asApiObject()}};y=Ue([He(3,t.ILogService)],y),e.ExtHostNotebookKernels=y;var s;(function(i){i[i.Init=0]="Init",i[i.Started=1]="Started",i[i.Resolved=2]="Resolved"})(s||(s={}));class g extends F.Disposable{constructor(a,r,o){super();this._document=a,this._cell=r,this._proxy=o,this._handle=g.HANDLE++,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=s.Init,this._tokenSource=this._register(new b.CancellationTokenSource),this._collector=new k(10,f=>this.update(f)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(a){await this._collector.addItem(a)}async update(a){const r=Array.isArray(a)?a:[a];return this._proxy.$updateExecutions(new I.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===s.Init)throw new Error("Must call start before modifying cell output");if(this._state===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(a){let r=this._cell;if(a&&(r=this._document.getCellFromApiCell(a)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(a){return a.map(r=>{const o=d.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return o===r.items?n.NotebookCellOutput.from(r):n.NotebookCellOutput.from({items:o,id:r.id,metadata:r.metadata})})}async updateOutputs(a,r,o){const f=this.cellIndexToHandle(r),m=this.validateAndConvertOutputs((0,h.asArray)(a));return this.updateSoon({editType:l.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:f,append:o,outputs:m})}async updateOutputItems(a,r,o){return a=d.NotebookCellOutput.ensureUniqueMimeTypes((0,h.asArray)(a),!0),this.updateSoon({editType:l.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:a.map(n.NotebookCellOutputItem.from),outputId:r.id,append:o})}asApiObject(){const a=this;return Object.freeze({get token(){return a._tokenSource.token},get cell(){return a._cell.apiCell},get executionOrder(){return a._executionOrder},set executionOrder(o){a._executionOrder=o,a.update([{editType:l.CellExecutionUpdateType.ExecutionState,executionHandle:a._handle,executionOrder:a._executionOrder}])},start(o){if(a._state===s.Resolved||a._state===s.Started)throw new Error("Cannot call start again");a._state=s.Started,a._onDidChangeState.fire(),a.update({editType:l.CellExecutionUpdateType.ExecutionState,executionHandle:a._handle,runStartTime:o})},end(o,f){if(a._state===s.Resolved)throw new Error("Cannot call resolve twice");a._state=s.Resolved,a._onDidChangeState.fire(),a.updateSoon({editType:l.CellExecutionUpdateType.Complete,executionHandle:a._handle,runEndTime:f,lastRunSuccess:o}),a._collector.flush(),a._proxy.$removeExecution(a._handle)},clearOutput(o){return a.verifyStateForOutput(),a.updateOutputs([],o,!1)},appendOutput(o,f){return a.verifyStateForOutput(),a.updateOutputs(o,f,!0)},replaceOutput(o,f){return a.verifyStateForOutput(),a.updateOutputs(o,f,!1)},appendOutputItems(o,f){return a.verifyStateForOutput(),a.updateOutputItems(o,f,!0)},replaceOutputItems(o,f){return a.verifyStateForOutput(),a.updateOutputItems(o,f,!1)}})}}g.HANDLE=0;class k{constructor(a,r){this.delay=a,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(a){return this.batch.push(a),this.currentDeferred||(this.currentDeferred=new M.DeferredPromise,this.startedTimer=Date.now(),(0,M.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const a=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>a.complete())}}}),define(we[199],be([0,1,3,5,93]),function(ne,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class T{constructor(D,_){this._extHostNotebook=_,this._rendererMessageEmitters=new Map,this.proxy=D.getProxy(M.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(D,_,P){const t=this._extHostNotebook.getEditorById(D);this._rendererMessageEmitters.get(_)?.fire({editor:t.apiEditor,message:P})}createRendererMessaging(D,_){if(!D.contributes?.notebookRenderer?.some(n=>n.id===_))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${_})`);const P=!!D.enableProposedApi,t=new WeakMap;return{onDidReceiveMessage:(n,d,c)=>{const l=P?n:w=>{const I={};t.set(I,w.editor),n({editor:I,message:w.message})};return this.getOrCreateEmitterFor(_).event(l,d,c)},postMessage:(n,d)=>{b.ExtHostNotebookEditor.apiEditorsToExtHost.has(n)&&([n,d]=[d,n]);const c=P?d:t.get(d),l=c&&b.ExtHostNotebookEditor.apiEditorsToExtHost.get(c);return this.proxy.$postMessage(l?.id,_,n)}}}getOrCreateEmitterFor(D){let _=this._rendererMessageEmitters.get(D);return _||(_=new h.Emitter({onLastListenerRemove:()=>{_?.dispose(),this._rendererMessageEmitters.delete(D)}}),this._rendererMessageEmitters.set(D,_),_)}}e.ExtHostNotebookRenderers=T}),define(we[96],be([0,1,5,3,6,23,4,12]),function(ne,e,h,M,b,T,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class _ extends b.Disposable{constructor(c,l,w,I,y){super();this._onDidAppend=this._register(new M.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=c,this._proxy=y,this._id=y.$register(this.name,l,w,I),this._disposed=!1,this._offset=0}get name(){return this._name}append(c){this.validate(),this._offset+=c?T.VSBuffer.fromString(c).byteLength:0}update(){this._id.then(c=>this._proxy.$update(c))}appendLine(c){this.validate(),this.append(c+`
`)}clear(){this.validate();const c=this._offset;this._id.then(l=>this._proxy.$clear(l,c))}show(c,l){this.validate(),this._id.then(w=>this._proxy.$reveal(w,!!(typeof c=="boolean"?c:l)))}hide(){this.validate(),this._id.then(c=>this._proxy.$close(c))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(c=>this._proxy.$dispose(c)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=_;class P extends _{constructor(c,l,w){super(c,!1,void 0,l,w)}append(c){super.append(c),this._id.then(l=>this._proxy.$append(l,c)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class t extends _{constructor(c,l,w){super(c,!0,l,void 0,w)}append(c){throw new Error("Not supported")}}class E{constructor(c,l){this.name=c,this._channel=l}append(c){this._channel.then(l=>l.append(c))}appendLine(c){this._channel.then(l=>l.appendLine(c))}clear(){this._channel.then(c=>c.clear())}show(c,l){this._channel.then(w=>w.show(c,l))}hide(){this._channel.then(c=>c.hide())}dispose(){this._channel.then(c=>c.dispose())}}e.LazyOutputChannel=E;let n=class{constructor(c){this._proxy=c.getProxy(h.MainContext.MainThreadOutputService)}$setVisibleChannel(c){}createOutputChannel(c,l){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");return new P(c,l.identifier.value,this._proxy)}createOutputChannelFromLogFile(c,l){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");if(!l)throw new Error("illegal argument `file`. must not be falsy");return new t(c,l,this._proxy)}};n=Ue([He(0,D.IExtHostRpcService)],n),e.ExtHostOutputService=n,e.IExtHostOutputService=(0,F.createDecorator)("IExtHostOutputService")}),define(we[200],be([0,1,14,21,3,6,5,2,7,16,13,35,44]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function d(c,l,w){const I=c.getProxy(F.MainContext.MainThreadQuickOpen);class y{constructor(m,v){this._sessions=new Map,this._instances=0,this._workspace=m,this._commands=v}showQuickPick(m,v,C,R=M.CancellationToken.None){this._onDidSelectItem=void 0;const p=Promise.resolve(m),S=++this._instances,u=I.$show(S,{title:C?.title,placeHolder:C?.placeHolder,matchOnDescription:C?.matchOnDescription,matchOnDetail:C?.matchOnDetail,ignoreFocusLost:C?.ignoreFocusOut,canPickMany:C?.canPickMany},R),A={},L=u.then(()=>A);return Promise.race([L,p]).then(V=>{if(V!==A)return p.then(K=>{const W=[];for(let Q=0;Q<K.length;Q++){const $=K[Q];let U,z,G,ue,q;typeof $=="string"?U=$:(U=$.label,z=$.description,G=$.detail,ue=$.picked,q=$.alwaysShow),W.push({label:U,description:z,handle:Q,detail:G,picked:ue,alwaysShow:q})}return C&&typeof C.onDidSelectItem=="function"&&(this._onDidSelectItem=Q=>{C.onDidSelectItem(K[Q])}),I.$setItems(S,W),u.then(Q=>{if(typeof Q=="number")return K[Q];if(Array.isArray(Q))return Q.map($=>K[$])})})}).then(void 0,V=>{if(!(0,P.isPromiseCanceledError)(V))return I.$setError(S,V),Promise.reject(V)})}$onItemSelected(m){this._onDidSelectItem&&this._onDidSelectItem(m)}showInput(m,v=M.CancellationToken.None){return this._validateInput=m?m.validateInput:void 0,I.$input(m,typeof this._validateInput=="function",v).then(void 0,C=>{if(!(0,P.isPromiseCanceledError)(C))return Promise.reject(C)})}$validateInput(m){return this._validateInput?(0,h.asPromise)(()=>this._validateInput(m)):Promise.resolve(void 0)}async showWorkspaceFolderPick(m,v=M.CancellationToken.None){const C=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[m]);if(!C)return;const R=await this._workspace.getWorkspaceFolders2();if(!!R)return R.find(p=>p.uri.toString()===C.uri.toString())}createQuickPick(m,v){const C=new r(m,v,()=>this._sessions.delete(C._id));return this._sessions.set(C._id,C),C}createInputBox(m){const v=new o(m,()=>this._sessions.delete(v._id));return this._sessions.set(v._id,v),v}$onDidChangeValue(m,v){const C=this._sessions.get(m);C&&C._fireDidChangeValue(v)}$onDidAccept(m){const v=this._sessions.get(m);v&&v._fireDidAccept()}$onDidChangeActive(m,v){const C=this._sessions.get(m);C instanceof r&&C._fireDidChangeActive(v)}$onDidChangeSelection(m,v){const C=this._sessions.get(m);C instanceof r&&C._fireDidChangeSelection(v)}$onDidTriggerButton(m,v){const C=this._sessions.get(m);C&&C._fireDidTriggerButton(v)}$onDidTriggerItemButton(m,v,C){const R=this._sessions.get(m);R instanceof r&&R._fireDidTriggerItemButton(v,C)}$onDidHide(m){const v=this._sessions.get(m);v&&v._fireDidHide()}}class s{constructor(m,v){this._extensionId=m,this._onDidDispose=v,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new b.Emitter,this._onDidChangeValueEmitter=new b.Emitter,this._onDidTriggerButtonEmitter=new b.Emitter,this._onDidHideEmitter=new b.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(m){this._title=m,this.update({title:m})}get step(){return this._steps}set step(m){this._steps=m,this.update({step:m})}get totalSteps(){return this._totalSteps}set totalSteps(m){this._totalSteps=m,this.update({totalSteps:m})}get enabled(){return this._enabled}set enabled(m){this._enabled=m,this.update({enabled:m})}get busy(){return this._busy}set busy(m){this._busy=m,this.update({busy:m})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(m){this._ignoreFocusOut=m,this.update({ignoreFocusOut:m})}get value(){return this._value}set value(m){this._value=m,this.update({value:m})}get placeholder(){return this._placeholder}set placeholder(m){this._placeholder=m,this.update({placeholder:m})}get buttons(){return this._buttons}set buttons(m){this._buttons=m.slice(),this._handlesToButtons.clear(),m.forEach((v,C)=>{const R=v===_.QuickInputButtons.Back?-1:C;this._handlesToButtons.set(R,v)}),this.update({buttons:m.map((v,C)=>({...a(v),tooltip:v.tooltip,handle:v===_.QuickInputButtons.Back?-1:C}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(m){this._value=m,this._onDidChangeValueEmitter.fire(m)}_fireDidTriggerButton(m){const v=this._handlesToButtons.get(m);v&&this._onDidTriggerButtonEmitter.fire(v)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),I.$dispose(this._id))}update(m){if(!this._disposed){for(const v of Object.keys(m)){const C=m[v];this._pendingUpdate[v]=C===void 0?null:C}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){I.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}s._nextId=1;function g(f){if(f instanceof _.ThemeIcon)return{id:f.id};const m=i(f),v=k(f);return{dark:typeof m=="string"?D.URI.file(m):m,light:typeof v=="string"?D.URI.file(v):v}}function k(f){return typeof f=="object"&&"light"in f?f.light:f}function i(f){return typeof f=="object"&&"dark"in f?f.dark:f}function a(f){const m=g(f.iconPath);let v,C;return"id"in m?C=n.ThemeIcon.asClassName(m):v=m,{iconPath:v,iconClass:C}}class r extends s{constructor(m,v,C){super(m,C);this.enableProposedApi=v,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new b.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new b.Emitter,this._onDidTriggerItemButtonEmitter=new b.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(m){this._items=m.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),m.forEach((v,C)=>{this._handlesToItems.set(C,v),this._itemsToHandles.set(v,C)}),this.update({items:m.map((v,C)=>({label:v.label,description:v.description,handle:C,detail:v.detail,picked:v.picked,alwaysShow:v.alwaysShow,buttons:v.buttons&&this.enableProposedApi?v.buttons.map((R,p)=>({...a(R),tooltip:R.tooltip,handle:p})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(m){this._canSelectMany=m,this.update({canSelectMany:m})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(m){this._matchOnDescription=m,this.update({matchOnDescription:m})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(m){this._matchOnDetail=m,this.update({matchOnDetail:m})}get sortByLabel(){return this._sortByLabel}set sortByLabel(m){this._sortByLabel=m,this.update({sortByLabel:m})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(m){this._keepScrollPosition=m,this.update({keepScrollPosition:m})}get activeItems(){return this._activeItems}set activeItems(m){this._activeItems=m.filter(v=>this._itemsToHandles.has(v)),this.update({activeItems:this._activeItems.map(v=>this._itemsToHandles.get(v))})}get selectedItems(){return this._selectedItems}set selectedItems(m){this._selectedItems=m.filter(v=>this._itemsToHandles.has(v)),this.update({selectedItems:this._selectedItems.map(v=>this._itemsToHandles.get(v))})}_fireDidChangeActive(m){const v=(0,t.coalesce)(m.map(C=>this._handlesToItems.get(C)));this._activeItems=v,this._onDidChangeActiveEmitter.fire(v)}_fireDidChangeSelection(m){const v=(0,t.coalesce)(m.map(C=>this._handlesToItems.get(C)));this._selectedItems=v,this._onDidChangeSelectionEmitter.fire(v)}_fireDidTriggerItemButton(m,v){const C=this._handlesToItems.get(m);if(!C||!C.buttons||!C.buttons.length)return;const R=C.buttons[v];R&&this._onDidTriggerItemButtonEmitter.fire({button:R,item:C})}}class o extends s{constructor(m,v){super(m,v);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(m){this._password=m,this.update({password:m})}get prompt(){return this._prompt}set prompt(m){this._prompt=m,this.update({prompt:m})}get validationMessage(){return this._validationMessage}set validationMessage(m){this._validationMessage=m,this.update({validationMessage:m,severity:m?E.default.Error:E.default.Ignore})}}return new y(l,w)}e.createExtHostQuickOpen=d}),define(we[201],be([0,1,2,3,52,6,14,5,13,108,15,25,30,44,8]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(m){if(m)return typeof m.iconPath=="string"?h.URI.file(m.iconPath):h.URI.isUri(m.iconPath)||d.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function w(m,v){if(!m.iconPath&&!v.iconPath)return 0;if(m.iconPath){if(!v.iconPath)return 1}else return-1;const C=typeof m.iconPath=="string"?m.iconPath:h.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,R=typeof v.iconPath=="string"?v.iconPath:h.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id;return(0,P.comparePaths)(C,R)}function I(m,v){let C=0;if(m.strikeThrough!==v.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==v.faded)return m.faded?1:-1;if(m.tooltip!==v.tooltip)return(m.tooltip||"").localeCompare(v.tooltip||"");if(C=w(m,v),C!==0)return C;if(m.light&&v.light)C=w(m.light,v.light);else{if(m.light)return 1;if(v.light)return-1}if(C!==0)return C;if(m.dark&&v.dark)C=w(m.dark,v.dark);else{if(m.dark)return 1;if(v.dark)return-1}return C}function y(m,v){if(m.command!==v.command)return m.command<v.command?-1:1;if(m.title!==v.title)return m.title<v.title?-1:1;if(m.tooltip!==v.tooltip){if(m.tooltip!==void 0&&v.tooltip!==void 0)return m.tooltip<v.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(v.tooltip!==void 0)return-1}if(m.arguments===v.arguments)return 0;if(m.arguments)if(v.arguments){if(m.arguments.length!==v.arguments.length)return m.arguments.length-v.arguments.length}else return 1;else return-1;for(let C=0;C<m.arguments.length;C++){const R=m.arguments[C],p=v.arguments[C];if(R!==p)return R<p?-1:1}return 0}function s(m,v){let C=(0,P.comparePaths)(m.resourceUri.fsPath,v.resourceUri.fsPath,!0);if(C!==0)return C;if(m.command&&v.command)C=y(m.command,v.command);else{if(m.command)return 1;if(v.command)return-1}if(C!==0)return C;if(m.decorations&&v.decorations)C=I(m.decorations,v.decorations);else{if(m.decorations)return 1;if(v.decorations)return-1}return C}function g(m,v){for(let C=0;C<m.length;C++)if(m[C]!==v[C])return!1;return!0}function k(m,v){return m.command===v.command&&m.title===v.title&&m.tooltip===v.tooltip&&(m.arguments&&v.arguments?g(m.arguments,v.arguments):m.arguments===v.arguments)}function i(m,v){return(0,_.equals)(m,v,k)}class a{constructor(v,C,R){this._extension=v,this._proxy=C,this._sourceControlHandle=R,this._value="",this._onDidChange=new M.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(v){this._proxy.$setInputBoxValue(this._sourceControlHandle,v),this.updateValue(v)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(v){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,v),this._placeholder=v}get validateInput(){return(0,n.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(v){if((0,n.checkProposedApiEnabled)(this._extension),v&&typeof v!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=v,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!v)}get visible(){return this._visible}set visible(v){v=!!v,this._visible!==v&&(this._visible=v,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,v))}focus(){(0,n.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(v,C){(0,n.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,v,C)}$onInputBoxValueChange(v){this.updateValue(v)}updateValue(v){this._value=v,this._onDidChange.fire(v)}}e.ExtHostSCMInputBox=a;class r{constructor(v,C,R,p,S){this._proxy=v,this._commands=C,this._sourceControlHandle=R,this._id=p,this._label=S,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new M.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new M.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(v){this._label=v,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,v)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(v){this._hideWhenEmpty=v,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(v){this._resourceStates=[...v],this._onDidUpdateResourceStates.fire()}getResourceState(v){return this._resourceStatesMap.get(v)}$executeResourceCommand(v,C){const R=this._resourceStatesCommandsMap.get(v);return R?(0,F.asPromise)(()=>this._commands.executeCommand(R.command,...R.arguments||[],C)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const v=[...this._resourceStates].sort(s),R=(0,_.sortedDiff)(this._resourceSnapshot,v,s).map(u=>{const A=u.toInsert.map(L=>{const V=this._resourceHandlePool++;this._resourceStatesMap.set(V,L);const K=L.resourceUri;let W;if(L.command)if(L.command.command==="vscode.open"||L.command.command==="vscode.diff"){const ve=new T.DisposableStore;W=this._commands.converter.toInternal(L.command,ve),this._resourceStatesDisposablesMap.set(V,ve)}else this._resourceStatesCommandsMap.set(V,L.command);const Q=l(L.decorations),$=L.decorations&&l(L.decorations.light)||Q,U=L.decorations&&l(L.decorations.dark)||Q,z=[$,U],G=L.decorations&&L.decorations.tooltip||"",ue=L.decorations&&!!L.decorations.strikeThrough,q=L.decorations&&!!L.decorations.faded,le=L.contextValue||"";return{rawResource:[V,K,z,G,ue,q,le,W],handle:V}});return{start:u.start,deleteCount:u.deleteCount,toInsert:A}}),p=R.map(({start:u,deleteCount:A,toInsert:L})=>[u,A,L.map(V=>V.rawResource)]),S=R.reverse();for(const{start:u,deleteCount:A,toInsert:L}of S){const V=L.map(W=>W.handle),K=this._handlesSnapshot.splice(u,A,...V);for(const W of K)this._resourceStatesMap.delete(W),this._resourceStatesCommandsMap.delete(W),this._resourceStatesDisposablesMap.get(W)?.dispose(),this._resourceStatesDisposablesMap.delete(W)}return this._resourceSnapshot=v,p}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class o{constructor(v,C,R,p,S,u){this._proxy=C,this._commands=R,this._id=p,this._label=S,this._rootUri=u,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new M.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=o._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new a(v,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,p,S,u)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(v){this._count!==v&&(this._count=v,this._proxy.$updateSourceControl(this.handle,{count:v}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(v){this._quickDiffProvider=v,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!v})}get commitTemplate(){return this._commitTemplate}set commitTemplate(v){v!==this._commitTemplate&&(this._commitTemplate=v,this._proxy.$updateSourceControl(this.handle,{commitTemplate:v}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(v){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=v;const C=this._commands.converter.toInternal(v,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:C})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(v){if(this._statusBarCommands&&v&&i(this._statusBarCommands,v))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=v;const C=(v||[]).map(R=>this._commands.converter.toInternal(R,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:C})}get selected(){return this._selected}createResourceGroup(v,C){const R=new r(this._proxy,this._commands,this.handle,v,C),p=M.Event.once(R.onDidDispose)(()=>this.createdResourceGroups.delete(R));return this.createdResourceGroups.set(R,p),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const v=[],C=[];for(const[R,p]of this.createdResourceGroups){p.dispose();const S=R.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(R),this.eventuallyUpdateResourceStates()});M.Event.once(R.onDidDispose)(()=>{this.updatedResourceGroups.delete(R),S.dispose(),this._groups.delete(R.handle),this._proxy.$unregisterGroup(this.handle,R.handle)}),v.push([R.handle,R.id,R.label,R.features]);const u=R._takeResourceStateSnapshot();u.length>0&&C.push([R.handle,u]),this._groups.set(R.handle,R)}this._proxy.$registerGroups(this.handle,v,C),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const v=[];this.updatedResourceGroups.forEach(C=>{const R=C._takeResourceStateSnapshot();R.length!==0&&v.push([C.handle,R])}),v.length>0&&this._proxy.$spliceResourceStates(this.handle,v),this.updatedResourceGroups.clear()}getResourceGroup(v){return this._groups.get(v)}setSelectionState(v){this._selected=v,this._onDidChangeSelection.fire(v)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(v=>v.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}o._handlePool=0,Ue([(0,b.debounce)(100)],o.prototype,"eventuallyAddResourceGroups",null),Ue([(0,b.debounce)(100)],o.prototype,"eventuallyUpdateResourceStates",null);let f=class Bi{constructor(v,C,R){this._commands=C,this.logService=R,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new M.Emitter,this._proxy=v.getProxy(D.MainContext.MainThreadSCM),this._telemetry=v.getProxy(D.MainContext.MainThreadTelemetry),C.registerArgumentProcessor({processArgument:p=>{if(p&&p.$mid===3){const S=this._sourceControls.get(p.sourceControlHandle);if(!S)return p;const u=S.getResourceGroup(p.groupHandle);return u?u.getResourceState(p.handle):p}else if(p&&p.$mid===4){const S=this._sourceControls.get(p.sourceControlHandle);return S?S.getResourceGroup(p.groupHandle):p}else if(p&&p.$mid===5){const S=this._sourceControls.get(p.handle);return S||p}return p}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(v,C,R,p){this.logService.trace("ExtHostSCM#createSourceControl",v.identifier.value,C,R,p),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:v.identifier.value});const S=Bi._handlePool++,u=new o(v,this._proxy,this._commands,C,R,p);this._sourceControls.set(S,u);const A=this._sourceControlsByExtension.get(E.ExtensionIdentifier.toKey(v.identifier))||[];return A.push(u),this._sourceControlsByExtension.set(E.ExtensionIdentifier.toKey(v.identifier),A),u}getLastInputBox(v){this.logService.trace("ExtHostSCM#getLastInputBox",v.identifier.value);const C=this._sourceControlsByExtension.get(E.ExtensionIdentifier.toKey(v.identifier)),R=C&&C[C.length-1];return R&&R.inputBox}$provideOriginalResource(v,C,R){const p=h.URI.revive(C);this.logService.trace("ExtHostSCM#$provideOriginalResource",v,p.toString());const S=this._sourceControls.get(v);return!S||!S.quickDiffProvider||!S.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,F.asPromise)(()=>S.quickDiffProvider.provideOriginalResource(p,R)).then(u=>u||null)}$onInputBoxValueChange(v,C){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",v);const R=this._sourceControls.get(v);return R&&R.inputBox.$onInputBoxValueChange(C),Promise.resolve(void 0)}$executeResourceCommand(v,C,R,p){this.logService.trace("ExtHostSCM#$executeResourceCommand",v,C,R);const S=this._sourceControls.get(v);if(!S)return Promise.resolve(void 0);const u=S.getResourceGroup(C);return u?u.$executeResourceCommand(R,p):Promise.resolve(void 0)}$validateInput(v,C,R){this.logService.trace("ExtHostSCM#$validateInput",v);const p=this._sourceControls.get(v);return!p||!p.inputBox.validateInput?Promise.resolve(void 0):(0,F.asPromise)(()=>p.inputBox.validateInput(C,R)).then(S=>{if(!S)return Promise.resolve(void 0);const u=c.MarkdownString.fromStrict(S.message);return u?Promise.resolve([u,S.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(v){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",v),v!==void 0&&this._sourceControls.get(v)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=v,Promise.resolve(void 0)}};f._handlePool=0,f=Ue([He(2,t.ILogService)],f),e.ExtHostSCM=f});var Xe=this&&this.__classPrivateFieldSet||function(ne,e,h,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ne,h):b?b.value=h:e.set(ne,h),h},Ae=this&&this.__classPrivateFieldGet||function(ne,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[202],be([0,1,7,5,127,6,8]),function(ne,e,h,M,b,T,F){"use strict";var D,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class P{constructor(d,c,l,w,I=h.StatusBarAlignment.Left,y){D.set(this,void 0),_.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,Xe(this,D,d,"f"),Xe(this,_,c,"f"),this._entryId=P.ID_GEN++,this._extension=l,this._id=w,this._alignment=I,this._priority=y}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set name(d){this._name=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!P.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){this._command?.fromApi!==d&&(this._internalCommandRegistration.clear(),typeof d=="string"?this._command={fromApi:d,internal:Ae(this,_,"f").toInternal({title:"",command:d},this._internalCommandRegistration)}:d?this._command={fromApi:d,internal:Ae(this,_,"f").toInternal(d,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ae(this,D,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let d;this._extension?this._id?d=`${this._extension.identifier.value}.${this._id}`:d=this._extension.identifier.value:d=this._id;let c;this._name?c=this._name:c=(0,b.localize)(0,null,this._extension.displayName||this._extension.name);let l=this._color;this._backgroundColor&&(l=P.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const w=this._tooltip?F.MarkdownString.fromStrict(this._tooltip):void 0;Ae(this,D,"f").$setEntry(this._entryId,d,c,this._text,w,this._command?.internal,l,this._backgroundColor,this._alignment===h.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=P,D=new WeakMap,_=new WeakMap,P.ID_GEN=0,P.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new h.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new h.ThemeColor("statusBarItem.warningForeground")]]);class t{constructor(d){this._messages=[],this._item=d.createStatusBarEntry(void 0,"status.extensionMessage",h.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,b.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const c={message:d};return this._messages.unshift(c),this._update(),new h.Disposable(()=>{const l=this._messages.indexOf(c);l>=0&&(this._messages.splice(l,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class E{constructor(d,c){this._proxy=d.getProxy(M.MainContext.MainThreadStatusBar),this._commands=c,this._statusMessage=new t(this)}createStatusBarEntry(d,c,l,w){return new P(this._proxy,this._commands,d,c,l,w)}setStatusBarMessage(d,c){const l=this._statusMessage.setMessage(d);let w;return typeof c=="number"?w=setTimeout(()=>l.dispose(),c):typeof c!="undefined"&&c.then(()=>l.dispose(),()=>l.dispose()),new h.Disposable(()=>{l.dispose(),clearTimeout(w)})}}e.ExtHostStatusBar=E}),define(we[72],be([0,1,5,3,4]),function(ne,e,h,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(D){this._onDidChangeStorage=new M.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(h.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,_){this._proxy.$registerExtensionStorageKeysToSync(D,_)}getValue(D,_,P){return this._proxy.$getValue(D,_).then(t=>t||P)}setValue(D,_,P){return this._proxy.$setValue(D,_,P)}$acceptValue(D,_,P){this._onDidChangeStorage.fire({shared:D,key:_,value:P})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,b.createDecorator)("IExtHostStorage")}),define(we[73],be([0,1,4,29,15,71,2]),function(ne,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,h.createDecorator)("IExtensionStoragePaths");let D=class{constructor(P,t,E){this._logService=t,this._extHostFileSystem=E,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(P){return F.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,t=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(t),this._logService.trace("[ExtHostStorage] storage dir already exists",t),t}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",t),await this._extHostFileSystem.value.createDirectory(t),await this._extHostFileSystem.value.writeFile(F.URI.joinPath(t,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:F.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),t}catch(E){this._logService.error("[ExtHostStorage]",E);return}}workspaceValue(P){if(this._value)return F.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return F.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};D=Ue([He(0,M.IExtHostInitDataService),He(1,b.ILogService),He(2,T.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(we[38],be([0,1,3,5,4,2,12,6,7,128,16,166,21,36,149,44,10]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n,d,c,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,b.createDecorator)("IExtHostTerminalService");class I{constructor(f,m,v,C){this._proxy=f,this._id=m,this._creationOptions=v,this._name=C,this._disposed=!1,this._state={interactedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(p=>this._pidPromiseComplete=p);const R=this;this.value={get name(){return R._name||""},get processId(){return R._pidPromise},get creationOptions(){return R._creationOptions},get exitStatus(){return R._exitStatus},get state(){return R._state},sendText(p,S=!0){R._checkDisposed(),R._proxy.$sendText(R._id,p,S)},show(p){R._checkDisposed(),R._proxy.$show(R._id,p)},hide(){R._checkDisposed(),R._proxy.$hide(R._id)},dispose(){R._disposed||(R._disposed=!0,R._proxy.$dispose(R._id))},get dimensions(){if(!(R._cols===void 0||R._rows===void 0))return{columns:R._cols,rows:R._rows}}}}async create(f,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:f.name,shellPath:(0,w.withNullAsUndefined)(f.shellPath),shellArgs:(0,w.withNullAsUndefined)(f.shellArgs),cwd:(0,w.withNullAsUndefined)(f.cwd),env:(0,w.withNullAsUndefined)(f.env),icon:(0,w.withNullAsUndefined)(a(f.iconPath)),color:l.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:(0,w.withNullAsUndefined)(f.message),strictEnv:(0,w.withNullAsUndefined)(f.strictEnv),hideFromUser:(0,w.withNullAsUndefined)(f.hideFromUser),isFeatureTerminal:(0,w.withNullAsUndefined)(m?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,w.withNullAsUndefined)(m?.useShellEnvironment),location:m?.location||this._serializeParentTerminal(f.location,m?.resolvedExtHostIdentifier)})}async createExtensionTerminal(f,m,v,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:v,color:l.ThemeColor.isThemeColor(C)?C.id:void 0,location:this._serializeParentTerminal(f,m)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(f,m){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&m?{parentTerminal:m}:"viewColumn"in f?{viewColumn:f.viewColumn,preserveFocus:f.preserveFocus}:void 0:f}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(f){this._name=f}setExitCode(f){this._exitStatus=Object.freeze({code:f})}setDimensions(f,m){return f===this._cols&&m===this._rows||f===0||m===0?!1:(this._cols=f,this._rows=m,!0)}setInteractedWith(){return this._state.interactedWith?!1:(this._state={interactedWith:!0},!0)}_setProcessId(f){this._pidPromiseComplete?(this._pidPromiseComplete(f),this._pidPromiseComplete=void 0):this._pidPromise.then(m=>{m!==f&&(this._pidPromise=Promise.resolve(f))})}}e.ExtHostTerminal=I;class y{constructor(f){this._pty=f,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new h.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new h.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new h.Emitter,this._onProcessTitleChanged=new h.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new h.Emitter,this._onProcessShellTypeChanged=new h.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onDidChangeProperty=new h.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}refreshProperty(f){return Promise.resolve("")}async start(){}shutdown(){this._pty.close()}input(f){this._pty.handleInput&&this._pty.handleInput(f)}resize(f,m){this._pty.setDimensions&&this._pty.setDimensions({columns:f,rows:m})}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(f){this._pty.onDidWrite(m=>this._onProcessData.fire(m)),this._pty.onDidClose&&this._pty.onDidClose((m=void 0)=>{this._onProcessExit.fire(m===void 0?void 0:m)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(m=>this._onProcessOverrideDimensions.fire(m&&{cols:m.columns,rows:m.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(m=>this._onProcessTitleChanged.fire(m)),this._pty.open(f||void 0),this._pty.setDimensions&&f&&this._pty.setDimensions(f),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=y;let s=1,g=class extends D.Disposable{constructor(f,m){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new h.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new h.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new h.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new h.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new h.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=m.getProxy(M.MainContext.MainThreadTerminalService),this._bufferer=new c.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new h.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(f),this._register({dispose:()=>{for(const[v,C]of this._terminalProcesses)C.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(f=>f.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(f,m){const v=new I(this._proxy,(0,d.generateUuid)(),f,f.name),C=new y(f.pty);return v.createExtensionTerminal(f.location,this._serializeParentTerminal(f,m).resolvedExtHostIdentifier,a(f.iconPath),r(f.color)).then(R=>{const p=this._setupExtHostProcessListeners(R,C);this._terminalProcessDisposables[R]=p}),this._terminals.push(v),v.value}_serializeParentTerminal(f,m){if(m=m||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const v=f.location.parentTerminal;if(v){const C=this._terminals.find(R=>R.value===v);C&&(m.resolvedExtHostIdentifier=C._id)}}else f.location&&typeof f.location!="object"?m.location=f.location:m.location&&typeof m.location=="object"&&"splitActiveTerminal"in m.location&&(m.location={splitActiveTerminal:!0});return m}attachPtyToTerminal(f,m){if(!this._getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const C=new y(m),R=this._setupExtHostProcessListeners(f,C);this._terminalProcessDisposables[f]=R}async $acceptActiveTerminalChanged(f){const m=this._activeTerminal;if(f===null){this._activeTerminal=void 0,m!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const v=this._getTerminalById(f);v&&(this._activeTerminal=v,m!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(f,m){const v=this._getTerminalById(f);v&&this._onDidWriteTerminalData.fire({terminal:v.value,data:m})}async $acceptTerminalDimensions(f,m,v){const C=this._getTerminalById(f);C&&C.setDimensions(m,v)&&this._onDidChangeTerminalDimensions.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptTerminalMaximumDimensions(f,m,v){this._terminalProcesses.get(f)?.resize(m,v)}async $acceptTerminalTitleChange(f,m){const v=this._getTerminalById(f);v&&(v.name=m)}async $acceptTerminalClosed(f,m){const v=this._getTerminalObjectIndexById(this._terminals,f);if(v!==null){const C=this._terminals.splice(v,1)[0];C.setExitCode(m),this._onDidCloseTerminal.fire(C.value)}}$acceptTerminalOpened(f,m,v,C){if(m){const S=this._getTerminalObjectIndexById(this._terminals,m);if(S!==null){this._terminals[S]._id=f,this._onDidOpenTerminal.fire(this.terminals[S]),this._terminals[S].isOpen=!0;return}}const R={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:T.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},p=new I(this._proxy,f,R,v);this._terminals.push(p),this._onDidOpenTerminal.fire(p.value),p.isOpen=!0}async $acceptTerminalProcessId(f,m){const v=this._getTerminalById(f);v&&v._setProcessId(m)}async $startExtensionTerminal(f,m){const v=this._getTerminalById(f);if(!v)return{message:(0,P.localize)(0,null,f)};v.isOpen||await new Promise(R=>{const p=this.onDidOpenTerminal(async S=>{S===v.value&&(p.dispose(),R())})});const C=this._terminalProcesses.get(f);C?C.startSendingEvents(m):this._extensionTerminalAwaitingStart[f]={initialDimensions:m}}_setupExtHostProcessListeners(f,m){const v=new D.DisposableStore;v.add(m.onProcessReady(R=>this._proxy.$sendProcessReady(f,R.pid,R.cwd))),v.add(m.onProcessTitleChanged(R=>this._proxy.$sendProcessTitle(f,R))),this._bufferer.startBuffering(f,m.onProcessData),v.add(m.onProcessExit(R=>this._onProcessExit(f,R))),m.onProcessOverrideDimensions&&v.add(m.onProcessOverrideDimensions(R=>this._proxy.$sendOverrideDimensions(f,R))),this._terminalProcesses.set(f,m);const C=this._extensionTerminalAwaitingStart[f];return C&&m instanceof y&&(m.startSendingEvents(C.initialDimensions),delete this._extensionTerminalAwaitingStart[f]),v}$acceptProcessAckDataEvent(f,m){this._terminalProcesses.get(f)?.acknowledgeDataEvent(m)}$acceptProcessInput(f,m){this._terminalProcesses.get(f)?.input(m)}$acceptTerminalInteraction(f){const m=this._getTerminalById(f);m?.setInteractedWith()&&this._onDidChangeTerminalState.fire(m.value)}$acceptProcessResize(f,m,v){try{this._terminalProcesses.get(f)?.resize(m,v)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(f,m){this._terminalProcesses.get(f)?.shutdown(m)}$acceptProcessRequestInitialCwd(f){this._terminalProcesses.get(f)?.getInitialCwd().then(m=>this._proxy.$sendProcessInitialCwd(f,m))}$acceptProcessRequestCwd(f){this._terminalProcesses.get(f)?.getCwd().then(m=>this._proxy.$sendProcessCwd(f,m))}$acceptProcessRequestLatency(f){return f}registerLinkProvider(f){return this._linkProviders.add(f),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(f),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(f,m,v){if(this._profileProviders.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this._profileProviders.set(m,v),this._proxy.$registerProfileProvider(m,f.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(m),this._proxy.$unregisterProfileProvider(m)})}async $createContributedProfileTerminal(f,m){const v=new n.CancellationTokenSource().token,C=await this._profileProviders.get(f)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,m);return}this.createTerminalFromOptions(C.options,m)}}async $provideLinks(f,m){const v=this._getTerminalById(f);if(!v)return[];this._terminalLinkCache.delete(f);const C=this._terminalLinkCancellationSource.get(f);C&&C.dispose(!0);const R=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(f,R);const p=[],S={terminal:v.value,line:m},u=[];for(const V of this._linkProviders)u.push(new Promise(async K=>{R.token.onCancellationRequested(()=>K({provider:V,links:[]}));const W=await V.provideTerminalLinks(S,R.token)||[];R.token.isCancellationRequested||K({provider:V,links:W})}));const A=await Promise.all(u);if(R.token.isCancellationRequested)return[];const L=new Map;for(const V of A)V&&V.links.length>0&&p.push(...V.links.map(K=>{const W={id:s++,startIndex:K.startIndex,length:K.length,label:K.tooltip};return L.set(W.id,{provider:V.provider,link:K}),W}));return this._terminalLinkCache.set(f,L),p}$activateLink(f,m){const v=this._terminalLinkCache.get(f)?.get(m);!v||v.provider.handleTerminalLink(v.link)}_onProcessExit(f,m){this._bufferer.stopBuffering(f),this._terminalProcesses.delete(f),delete this._extensionTerminalAwaitingStart[f];const v=this._terminalProcessDisposables[f];v&&(v.dispose(),delete this._terminalProcessDisposables[f]),this._proxy.$sendProcessExit(f,m)}_getTerminalById(f){return this._getTerminalObjectById(this._terminals,f)}_getTerminalObjectById(f,m){const v=this._getTerminalObjectIndexById(f,m);return v!==null?f[v]:null}_getTerminalObjectIndexById(f,m){let v=null;return f.some((C,R)=>C._id===m?(v=R,!0):!1),v}getEnvironmentVariableCollection(f){let m=this._environmentVariableCollections.get(f.identifier.value);return m||(m=new k,this._setEnvironmentVariableCollection(f.identifier.value,m)),m}_syncEnvironmentVariableCollection(f,m){const v=(0,E.serializeEnvironmentVariableCollection)(m.map);this._proxy.$setEnvironmentVariableCollection(f,m.persistent,v.length===0?void 0:v)}$initEnvironmentVariableCollections(f){f.forEach(m=>{const v=m[0],C=new k(m[1]);this._setEnvironmentVariableCollection(v,C)})}$acceptDefaultProfile(f,m){this._defaultProfile=f,this._defaultAutomationProfile=m}_setEnvironmentVariableCollection(f,m){this._environmentVariableCollections.set(f,m),m.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(f,m)})}};g=Ue([He(1,F.IExtHostRpcService)],g),e.BaseExtHostTerminalService=g;class k{constructor(f){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new h.Emitter,this.map=new Map(f)}get persistent(){return this._persistent}set persistent(f){this._persistent=f,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(f,m){this._setIfDiffers(f,{value:m,type:_.EnvironmentVariableMutatorType.Replace})}append(f,m){this._setIfDiffers(f,{value:m,type:_.EnvironmentVariableMutatorType.Append})}prepend(f,m){this._setIfDiffers(f,{value:m,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(f,m){const v=this.map.get(f);(!v||v.value!==m.value||v.type!==m.type)&&(this.map.set(f,m),this._onDidChangeCollection.fire())}get(f){return this.map.get(f)}forEach(f,m){this.map.forEach((v,C)=>f.call(m,C,v,this))}delete(f){this.map.delete(f),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=k;let i=class extends g{constructor(f){super(!1,f)}createTerminal(f,m,v){throw new t.NotSupportedError}createTerminalFromOptions(f,m){throw new t.NotSupportedError}};i=Ue([He(0,F.IExtHostRpcService)],i),e.WorkerExtHostTerminalService=i;function a(o){if(!(!o||typeof o=="string"))return"id"in o?{id:o.id,color:o.color}:o}function r(o){return l.ThemeColor.isThemeColor(o)?o:void 0}});var Xe=this&&this.__classPrivateFieldSet||function(ne,e,h,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ne,h):b?b.value=h:e.set(ne,h),h},Ae=this&&this.__classPrivateFieldGet||function(ne,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[203],be([0,1,13,23,21,3,234,58,6,22,10,36,5,12,46,8,7,174,90,67]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n,d,c,l,w,I,y,s){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let k=class{constructor(u,A){this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=u.getProxy(n.MainContext.MainThreadTesting),this.observer=new C(this.proxy),this.runTracker=new a(this.proxy),A.registerArgumentProcessor({processArgument:L=>L?.$mid===13?l.TestItem.toItemFromContext(L):L})}createTestController(u,A){if(this.controllers.has(u))throw new Error(`Attempt to insert a duplicate controller with ID "${u}"`);const L=new _.DisposableStore,V=L.add(new I.SingleUseTestCollection(u));V.root.label=A;const K=new Map,W=this.proxy,Q={items:V.root.children,get label(){return A},set label(U){A=U,V.root.label=U,W.$updateControllerLabel(u,A)},get id(){return u},createRunProfile:(U,z,G,ue,q)=>{let le=(0,D.hash)(U);for(;K.has(le);)le++;const se=new R(this.proxy,u,le,U,z,G,ue,q);return K.set(le,se),se},createTestItem(U,z,G){return new c.TestItemImpl(u,U,z,G)},createTestRun:(U,z,G=!0)=>this.runTracker.createTestRun(u,V,U,z,G),set resolveHandler(U){V.resolveHandler=U},get resolveHandler(){return V.resolveHandler},dispose:()=>{L.dispose()}};Q.createRunConfiguration=Q.createRunProfile,W.$registerTestController(u,A),L.add((0,_.toDisposable)(()=>W.$unregisterTestController(u)));const $={controller:Q,collection:V,profiles:K};return this.controllers.set(u,$),L.add((0,_.toDisposable)(()=>this.controllers.delete(u))),L.add(V.onDidGenerateDiff(U=>W.$publishDiff(u,U))),Q}createTestObserver(){return this.observer.checkout()}async runTests(u,A=b.CancellationToken.None){const L=r(u);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const V=this.controllers.get(L.controllerId);if(!V)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:u.include?.map(K=>K.id)??[V.collection.root.id],profileGroup:p[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:u.exclude?.map(K=>K.id)},A)}$provideFileCoverage(u,A,L){return(0,h.mapFind)(this.runTracker.trackers,K=>K.id===u?K.getCoverage(A):void 0)?.provideFileCoverage(L)??Promise.resolve([])}$resolveFileCoverage(u,A,L,V){return(0,h.mapFind)(this.runTracker.trackers,W=>W.id===u?W.getCoverage(A):void 0)?.resolveFileCoverage(L,V)??Promise.resolve([])}$configureRunProfile(u,A){this.controllers.get(u)?.profiles.get(A)?.configureHandler?.()}$publishTestResults(u){this.results=Object.freeze(u.map(A=>(0,P.deepFreeze)(l.TestResults.to(A))).concat(this.results).sort((A,L)=>L.completedAt-A.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(u,A){const L=this.controllers.get(s.TestId.fromString(u).controllerId)?.collection;L&&(await L.expand(u,A<0?Infinity:A),L.flushDiff())}$acceptDiff(u){this.observer.applyDiff(u)}async $runControllerTests(u,A){const L=this.controllers.get(u.controllerId);if(!L)return;const{collection:V,profiles:K}=L,W=K.get(u.profileId);if(!W)return;const Q=u.testIds.map(G=>V.tree.get(G)).filter(t.isDefined),$=u.excludeExtIds.map(G=>L.collection.tree.get(G)).filter(t.isDefined).filter(G=>Q.some(ue=>ue.fullId.compare(G.fullId)===2));if(!Q.length)return;const U=new w.TestRunRequest(Q.some(G=>G.actual instanceof c.TestItemRootImpl)?void 0:Q.map(G=>G.actual),$.map(G=>G.actual),W),z=this.runTracker.prepareForMainThreadTestRun(U,o.fromInternal(u,L.collection),A);try{await W.runHandler(U,A)}finally{z.isRunning&&!A.isCancellationRequested&&await T.Event.toPromise(z.onEnd),z.dispose()}}$cancelExtensionTestRun(u){u===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(u)}};k=Ue([He(0,d.IExtHostRpcService)],k),e.ExtHostTesting=k;class i extends _.Disposable{constructor(u,A,L){super();this.dto=u,this.proxy=A,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new b.CancellationTokenSource(L)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:V}of this.tasks.values())V.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(u){return this.tasks.get(u)?.coverage}createRun(u){const A=this.dto.id,L=this.dto.controllerId,V=(0,E.generateUuid)(),K=new f(this.proxy,A,V),W=z=>(G,...ue)=>{if($){console.warn(`Setting the state of test "${G.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(G)||(this.ensureTestIsKnown(G),z(G,...ue))},Q=(z,G)=>{const ue=G instanceof Array?G.map(l.TestMessage.from):[l.TestMessage.from(G)];if(z.uri&&z.range){const q={range:l.Range.from(z.range),uri:z.uri};for(const le of ue)le.location=le.location||q}this.proxy.$appendTestMessagesInRun(A,V,s.TestId.fromExtHostTestItem(z,L).toString(),ue)};let $=!1;const U={isPersisted:this.dto.isPersisted,token:this.cts.token,name:u,get coverageProvider(){return K.coverageProvider},set coverageProvider(z){K.coverageProvider=z},enqueued:W(z=>{this.proxy.$updateTestStateInRun(A,V,s.TestId.fromExtHostTestItem(z,L).toString(),1)}),skipped:W(z=>{this.proxy.$updateTestStateInRun(A,V,s.TestId.fromExtHostTestItem(z,L).toString(),5)}),started:W(z=>{this.proxy.$updateTestStateInRun(A,V,s.TestId.fromExtHostTestItem(z,L).toString(),2)}),errored:W((z,G,ue)=>{Q(z,G),this.proxy.$updateTestStateInRun(A,V,s.TestId.fromExtHostTestItem(z,L).toString(),6,ue)}),failed:W((z,G,ue)=>{Q(z,G),this.proxy.$updateTestStateInRun(A,V,s.TestId.fromExtHostTestItem(z,L).toString(),4,ue)}),passed:W((z,G)=>{this.proxy.$updateTestStateInRun(A,V,s.TestId.fromExtHostTestItem(z,this.dto.controllerId).toString(),3,G)}),appendOutput:(z,G,ue)=>{$||(ue&&(this.dto.isIncluded(ue)?this.ensureTestIsKnown(ue):ue=void 0),this.proxy.$appendOutputToRun(A,V,M.VSBuffer.fromString(z),G&&l.location.from(G),ue&&s.TestId.fromExtHostTestItem(ue,L).toString()))},end:()=>{$||($=!0,this.proxy.$finishedTestRunTask(A,V),this.tasks.delete(V),this.isRunning||this.dispose())}};return this.tasks.set(V,{run:U,coverage:K}),this.proxy.$startedTestRunTask(A,{id:V,name:u,running:!0}),U}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(u){if(!(u instanceof c.TestItemImpl))throw new c.InvalidTestItemError(u.id);if(this.sharedTestIds.has(s.TestId.fromExtHostTestItem(u,this.dto.controllerId).toString()))return;const A=[],L=this.dto.colllection.root;for(;;){const V=l.TestItem.from(u);if(A.unshift(V),this.sharedTestIds.has(V.extId)||(this.sharedTestIds.add(V.extId),u===L))break;u=u.parent||L}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,A)}}class a{constructor(u){this.proxy=u,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(u,A,L){return this.getTracker(u,A,L)}cancelRunById(u){for(const A of this.tracked.values())if(A.id===u){A.dispose();return}}cancelAllRuns(){for(const u of this.tracked.values())u.dispose()}createTestRun(u,A,L,V,K){const W=this.tracked.get(L);if(W)return W.createRun(V);const Q=o.fromPublic(u,A,L,K),$=r(L);this.proxy.$startedExtensionTestRun({controllerId:u,profile:$&&{group:p[$.kind],id:$.profileId},exclude:L.exclude?.map(z=>z.id)??[],id:Q.id,include:L.include?.map(z=>z.id)??[A.root.id],persist:K});const U=this.getTracker(L,Q);return U.onEnd(()=>this.proxy.$finishedExtensionTestRun(Q.id)),U.createRun(V)}getTracker(u,A,L){const V=new i(A,this.proxy,L);return this.tracked.set(u,V),V.onEnd(()=>this.tracked.delete(u)),V}}e.TestRunCoordinator=a;const r=S=>{if(!!S.profile){if(!(S.profile instanceof R))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return S.profile}};class o{constructor(u,A,L,V,K,W){this.controllerId=u,this.id=A,this.isPersisted=K,this.colllection=W,this.includePrefix=L.map(Q=>Q+"\0"),this.excludePrefix=V.map(Q=>Q+"\0")}static fromPublic(u,A,L,V){return new o(u,(0,E.generateUuid)(),L.include?.map(K=>s.TestId.fromExtHostTestItem(K,u).toString())??[u],L.exclude?.map(K=>s.TestId.fromExtHostTestItem(K,u).toString())??[],V,A)}static fromInternal(u,A){return new o(u.controllerId,u.runId,u.testIds,u.excludeExtIds,!0,A)}isIncluded(u){const A=s.TestId.fromExtHostTestItem(u,this.controllerId).toString()+"\0";for(const L of this.excludePrefix)if(A===L||A.startsWith(L))return!1;for(const L of this.includePrefix)if(A===L||A.startsWith(L))return!0;return!1}}e.TestRunDto=o;class f{constructor(u,A,L){this.proxy=u,this.runId=A,this.taskId=L}set coverageProvider(u){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!u||(this._coverageProvider=u,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(u){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(u))());try{return(await this.fileCoverage)?.map(l.TestCoverage.fromFile)??[]}catch(A){throw this.fileCoverage=void 0,A}}async resolveFileCoverage(u,A){const L=await this.fileCoverage;let V=L?.[u];return!this._coverageProvider||!L||!V?[]:(V.detailedCoverage||(V=L[u]=await this._coverageProvider.resolveFileCoverage?.(V,A)??V),V.detailedCoverage?.map(l.TestCoverage.fromDetailed)??[])}}class m extends y.IncrementalChangeCollector{constructor(u){super();this.emitter=u,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(u){this.added.add(u)}update(u){Object.assign(u.revived,l.TestItem.toPlain(u.item)),this.added.has(u)||this.updated.add(u)}remove(u){if(this.added.has(u)){this.added.delete(u);return}if(this.updated.delete(u),u.parent&&this.alreadyRemoved.has(u.parent)){this.alreadyRemoved.add(u.item.extId);return}this.removed.add(u)}getChangeEvent(){const{added:u,updated:A,removed:L}=this;return{get added(){return[...u].map(V=>V.revived)},get updated(){return[...A].map(V=>V.revived)},get removed(){return[...L].map(V=>V.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class v extends y.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(u){return this.items.get(u)}getMirroredTestDataByReference(u){return this.items.get(u.id)}createItem(u,A){return{...u,revived:l.TestItem.toPlain(u.item),depth:A?A.depth+1:0,children:new Set}}createChangeCollector(){return new m(this.changeEmitter)}}e.MirroredTestCollection=v;class C{constructor(u){this.proxy=u}checkout(){this.current||(this.current=this.createObserverData());const u=this.current;return u.observers++,{onDidChangeTest:u.tests.onDidChangeTests,get tests(){return[...u.tests.rootTests].map(A=>A.revived)},dispose:(0,F.once)(()=>{--u.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(u){return this.current?.tests.getMirroredTestDataByReference(u)}applyDiff(u){this.current?.tests.apply(u)}createObserverData(){const u=new v;return this.proxy.$subscribeToDiffs(),{observers:0,tests:u}}}class R{constructor(u,A,L,V,K,W,Q=!1,$=void 0){this.controllerId=A,this.profileId=L,this._label=V,this.kind=K,this.runHandler=W,this._isDefault=Q,this._tag=$,g.set(this,void 0),Xe(this,g,u,"f");const U=p[K];if(typeof U!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Ae(this,g,"f").$publishTestRunProfile({profileId:L,controllerId:A,tag:$?l.TestTag.namespace(this.controllerId,$.id):null,label:V,group:U,isDefault:Q,hasConfigurationHandler:!1})}get label(){return this._label}set label(u){u!==this._label&&(this._label=u,Ae(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:u}))}get isDefault(){return this._isDefault}set isDefault(u){u!==this._isDefault&&(this._isDefault=u,Ae(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:u}))}get tag(){return this._tag}set tag(u){u?.id!==this._tag?.id&&(this._tag=u,Ae(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:u?l.TestTag.namespace(this.controllerId,u.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(u){u!==this._configureHandler&&(this._configureHandler=u,Ae(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!u}))}dispose(){Ae(this,g,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=R,g=new WeakMap;const p={[w.TestRunProfileKind.Coverage]:8,[w.TestRunProfileKind.Debug]:4,[w.TestRunProfileKind.Run]:2}}),define(we[204],be([0,1,3,13,5,94,8,7]),function(ne,e,h,M,b,T,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(t,E){this._extHostDocumentsAndEditors=E,this._onDidChangeTextEditorSelection=new h.Emitter,this._onDidChangeTextEditorOptions=new h.Emitter,this._onDidChangeTextEditorVisibleRanges=new h.Emitter,this._onDidChangeTextEditorViewColumn=new h.Emitter,this._onDidChangeActiveTextEditor=new h.Emitter,this._onDidChangeVisibleTextEditors=new h.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=t.getProxy(b.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(t){const E=this._extHostDocumentsAndEditors.allEditors();return t?E:E.map(n=>n.value)}async showTextDocument(t,E,n){let d;typeof E=="number"?d={position:F.ViewColumn.from(E),preserveFocus:n}:typeof E=="object"?d={position:F.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selection:typeof E.selection=="object"?F.Range.from(E.selection):void 0,pinned:typeof E.preview=="boolean"?!E.preview:void 0}:d={preserveFocus:!1};const c=await this._proxy.$tryShowTextDocument(t.uri,d),l=c&&this._extHostDocumentsAndEditors.getEditor(c);if(l)return l.value;throw c?new Error(`Could NOT open editor for "${t.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.uri.toString()}".`)}createTextEditorDecorationType(t,E){return new T.TextEditorDecorationType(this._proxy,t,E).value}$acceptEditorPropertiesChanged(t,E){const n=this._extHostDocumentsAndEditors.getEditor(t);if(!n)throw new Error("unknown text editor");if(E.options&&n._acceptOptions(E.options),E.selections){const d=E.selections.selections.map(F.Selection.to);n._acceptSelections(d)}if(E.visibleRanges){const d=M.coalesce(E.visibleRanges.map(F.Range.to));n._acceptVisibleRanges(d)}if(E.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{...E.options,lineNumbers:F.TextEditorLineNumbersStyle.to(E.options.lineNumbers)}}),E.selections){const d=D.TextEditorSelectionChangeKind.fromValue(E.selections.source),c=E.selections.selections.map(F.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:c,kind:d})}if(E.visibleRanges){const d=M.coalesce(E.visibleRanges.map(F.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:d})}}$acceptEditorPositionData(t){for(const E in t){const n=this._extHostDocumentsAndEditors.getEditor(E);if(!n)throw new Error("Unknown text editor");const d=F.ViewColumn.to(t[E]);n.value.viewColumn!==d&&(n._acceptViewColumn(d),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:d}))}}getDiffInformation(t){return Promise.resolve(this._proxy.$getDiffInformation(t))}}e.ExtHostEditors=_}),define(we[205],be([0,1,2,4,5,6,7]),function(ne,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,M.createDecorator)("IExtHostTimeline");class D{constructor(t,E){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=t.getProxy(b.MainContext.MainThreadTimeline),E.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const d=n.uri===void 0?void 0:h.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(_(d))?.get(n.handle)}return n}})}async $getTimeline(t,E,n,d,c){return this._providers.get(t)?.provideTimeline(h.URI.revive(E),n,d,c)}registerTimelineProvider(t,E,n,d){const c=new T.DisposableStore,l=this.convertTimelineItem(E.id,d,c).bind(this);let w;E.onDidChange&&(w=E.onDidChange(y=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...y,id:E.id}),this));const I=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...E,scheme:t,onDidChange:void 0,async provideTimeline(y,s,g,k){k?.resetCache&&(c.clear(),I.get(E.id)?.clear());const i=await E.provideTimeline(y,s,g);if(i==null)return;const a=l(y,k);return{...i,source:E.id,items:i.items.map(a)}},dispose(){for(const y of I.values())y.get(E.id)?.clear();w?.dispose(),c.dispose()}})}convertTimelineItem(t,E,n){return(d,c)=>{let l;if(c?.cacheResults){let w=this._itemsBySourceAndUriMap.get(t);w===void 0&&(w=new Map,this._itemsBySourceAndUriMap.set(t,w));const I=_(d);l=w.get(I),l===void 0&&(l=new Map,w.set(I,l))}return w=>{const{iconPath:I,...y}=w,s=`${t}|${w.id??w.timestamp}`;l?.set(s,w);let g,k,i;return w.iconPath&&(I instanceof F.ThemeIcon?i={id:I.id,color:I.color}:h.URI.isUri(I)?(g=I,k=I):{light:g,dark:k}=I),{...y,id:y.id??void 0,handle:s,source:t,command:w.command?E.toInternal(w.command,n):void 0,icon:g,iconDark:k,themeIcon:i,accessibilityInformation:w.accessibilityInformation}}}}registerTimelineProviderCore(t){if(this._providers.get(t.id))throw new Error(`Timeline Provider ${t.id} already exists.`);return this._proxy.$registerTimelineProvider({id:t.id,label:t.label,scheme:t.scheme}),this._providers.set(t.id,t),(0,T.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(t.id)?.clear();this._providers.delete(t.id),this._proxy.$unregisterTimelineProvider(t.id),t.dispose()})}}e.ExtHostTimeline=D;function _(P){return P?.toString()}}),define(we[206],be([0,1,6,11,2,5]),function(ne,e,h,M,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class F{constructor(_){this._openers=new Map,this._proxy=_.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,P,t,E){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const n=E.schemes.find(d=>!F.supportedSchemes.has(d));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,t),this._proxy.$registerUriOpener(P,E.schemes,_,E.label),(0,h.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(_,P,t){const E=this._openers.get(_);if(!E)throw new Error(`Unknown opener with id: ${_}`);const n=b.URI.revive(P);return E.canOpenExternalUri(n,t)}async $openUri(_,P,t){const E=this._openers.get(_);if(!E)throw new Error(`Unknown opener id: '${_}'`);return E.openExternalUri(b.URI.revive(P.resolvedUri),{sourceUri:b.URI.revive(P.sourceUri)},t)}}e.ExtHostUriOpeners=F,F.supportedSchemes=new Set([M.Schemas.http,M.Schemas.https])}),define(we[207],be([0,1,5,2,6,16,25]),function(ne,e,h,M,b,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(h.MainContext.MainThreadUrls)}registerUriHandler(P,t){if(this.handles.has(F.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const E=D.HandlePool++;return this.handles.add(F.ExtensionIdentifier.toKey(P)),this.handlers.set(E,t),this._proxy.$registerUriHandler(E,P),(0,b.toDisposable)(()=>{this.handles.delete(F.ExtensionIdentifier.toKey(P)),this.handlers.delete(E),this._proxy.$unregisterUriHandler(E)})}$handleExternalUri(P,t){const E=this.handlers.get(P);if(!E)return Promise.resolve(void 0);try{E.handleUri(M.URI.revive(t))}catch(n){(0,T.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(P){return M.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=D,D.HandlePool=0});var Xe=this&&this.__classPrivateFieldSet||function(ne,e,h,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ne,h):b?b.value=h:e.set(ne,h),h},Ae=this&&this.__classPrivateFieldGet||function(ne,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[50],be([0,1,3,2,138,157,66,5]),function(ne,e,h,M,b,T,F,D){"use strict";var _,P,t,E,n,d,c,l,w,I,y,s;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class g{constructor(v,C,R,p,S,u,A){_.set(this,void 0),P.set(this,void 0),t.set(this,void 0),E.set(this,void 0),n.set(this,void 0),d.set(this,void 0),c.set(this,""),l.set(this,void 0),w.set(this,!1),I.set(this,!1),y.set(this,!1),this._onMessageEmitter=new h.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new h.Emitter),this._onDidDispose=Ae(this,s,"f").event,Xe(this,_,v,"f"),Xe(this,P,C,"f"),Xe(this,l,R,"f"),Xe(this,E,p,"f"),Xe(this,n,S,"f"),Xe(this,d,u,"f"),Xe(this,y,k(u),"f"),Xe(this,t,A,"f")}dispose(){Xe(this,w,!0,"f"),Ae(this,s,"f").fire(),Ae(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(v){return Xe(this,I,!0,"f"),(0,F.asWebviewUri)(v,Ae(this,E,"f").remote)}get cspSource(){return F.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ae(this,c,"f")}set html(v){this.assertNotDisposed(),Ae(this,c,"f")!==v&&(Xe(this,c,v,"f"),!Ae(this,I,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(v)&&(Xe(this,I,!0,"f"),Ae(this,t,"f").report("Webview vscode-resource: uris",Ae(this,d,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ae(this,P,"f").$setHtml(Ae(this,_,"f"),v))}get options(){return this.assertNotDisposed(),Ae(this,l,"f")}set options(v){this.assertNotDisposed(),Ae(this,P,"f").$setOptions(Ae(this,_,"f"),r(Ae(this,d,"f"),Ae(this,n,"f"),v)),Xe(this,l,v,"f")}async postMessage(v){if(Ae(this,w,"f"))return!1;const C=(0,T.serializeWebviewMessage)(v,{serializeBuffersForPostMessage:Ae(this,y,"f")});return Ae(this,P,"f").$postMessage(Ae(this,_,"f"),C.message,...C.buffers)}assertNotDisposed(){if(Ae(this,w,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,_=new WeakMap,P=new WeakMap,t=new WeakMap,E=new WeakMap,n=new WeakMap,d=new WeakMap,c=new WeakMap,l=new WeakMap,w=new WeakMap,I=new WeakMap,y=new WeakMap,s=new WeakMap;function k(m){try{const v=(0,b.normalizeVersion)((0,b.parseVersion)(m.engines.vscode));return!!v&&v.majorBase>=1&&v.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=k;class i{constructor(v,C,R,p,S){this.initData=C,this.workspace=R,this._logService=p,this._deprecationService=S,this._webviews=new Map,this._webviewProxy=v.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(v,C,...R){const p=this.getWebview(v);if(p){const{message:S}=(0,T.deserializeWebviewMessage)(C,R);p._onMessageEmitter.fire(S)}}$onMissingCsp(v,C){this._logService.warn(`${C} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(v,C,R){const p=new g(v,this._webviewProxy,o(C),this.initData,this.workspace,R,this._deprecationService);return this._webviews.set(v,p),p._onDidDispose(()=>{this._webviews.delete(v)}),p}deleteWebview(v){this._webviews.delete(v)}getWebview(v){return this._webviews.get(v)}}e.ExtHostWebviews=i;function a(m){return{id:m.identifier,location:m.extensionLocation}}e.toExtensionData=a;function r(m,v,C){return{enableCommandUris:C.enableCommandUris,enableScripts:C.enableScripts,enableForms:C.enableForms,portMapping:C.portMapping,localResourceRoots:C.localResourceRoots||f(m,v)}}e.serializeWebviewOptions=r;function o(m){return{enableCommandUris:m.enableCommandUris,enableScripts:m.enableScripts,enableForms:m.enableForms,portMapping:m.portMapping,localResourceRoots:m.localResourceRoots?.map(v=>M.URI.from(v))}}e.reviveOptions=o;function f(m,v){return[...(v?.getWorkspaceFolders()||[]).map(C=>C.uri),m.extensionLocation]}}),define(we[208],be([0,1,21,58,6,11,24,2,8,50,63,5,7]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class d{constructor(i,a){this.document=i,this._storagePath=a,this._backupCounter=1,this._edits=new t.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,a){await this.getEdit(i).undo(),a||this.disposeBackup()}async redo(i,a){await this.getEdit(i).redo(),a||this.disposeBackup()}disposeEdits(i){for(const a of i)this._edits.delete(a)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=g(this.document.uri)+this._backupCounter++;return(0,F.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const a=this._edits.get(i,0);if(!a)throw new Error("No edit found");return a}}class c{constructor(){this._documents=new Map}get(i,a){return this._documents.get(this.key(i,a))}add(i,a,r){const o=this.key(i,a.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${i} resource:${a.uri}`);const f=new d(a,r);return this._documents.set(o,f),f}delete(i,a){const r=this.key(i,a.uri);this._documents.delete(r)}key(i,a){return`${i}@@@${a}`}}var l;(function(k){k[k.Text=0]="Text",k[k.Custom=1]="Custom"})(l||(l={}));class w{constructor(){this._providers=new Map}addTextProvider(i,a,r){return this.add(0,i,a,r)}addCustomProvider(i,a,r){return this.add(1,i,a,r)}get(i){return this._providers.get(i)}add(i,a,r,o){if(this._providers.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this._providers.set(a,{type:i,extension:r,provider:o}),new n.Disposable(()=>this._providers.delete(a))}}class I{constructor(i,a,r,o,f){this._extHostDocuments=a,this._extensionStoragePaths=r,this._extHostWebview=o,this._extHostWebviewPanels=f,this._editorProviders=new w,this._documents=new c,this._proxy=i.getProxy(E.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,a,r,o){const f=new b.DisposableStore;return y(r)?(f.add(this._editorProviders.addTextProvider(a,i,r)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(i),a,o.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(i))):(f.add(this._editorProviders.addCustomProvider(a,i,r)),this.supportEditing(r)&&f.add(r.onDidChangeCustomDocument(m=>{const v=this.getCustomDocumentEntry(a,m.document.uri);if(s(m)){const C=v.addEdit(m);this._proxy.$onDidEdit(m.document.uri,a,C,m.label)}else this._proxy.$onContentChange(m.document.uri,a)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(i),a,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(i))),n.Disposable.from(f,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(a)}))}async $createCustomDocument(i,a,r,o,f){const m=this._editorProviders.get(a);if(!m)throw new Error(`No provider found for '${a}'`);if(m.type!==1)throw new Error(`Invalid provide type for '${a}'`);const v=D.URI.revive(i),C=await m.provider.openCustomDocument(v,{backupId:r,untitledDocumentData:o?.buffer},f);let R;return this.supportEditing(m.provider)&&this._extensionStoragePaths&&(R=this._extensionStoragePaths.workspaceValue(m.extension)??this._extensionStoragePaths.globalValue(m.extension)),this._documents.add(a,C,R),{editable:this.supportEditing(m.provider)}}async $disposeCustomDocument(i,a){const r=this._editorProviders.get(a);if(!r)throw new Error(`No provider found for '${a}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${a}'`);const o=D.URI.revive(i),{document:f}=this.getCustomDocumentEntry(a,o);this._documents.delete(a,f),f.dispose()}async $resolveWebviewEditor(i,a,r,o,f,m){const v=this._editorProviders.get(r);if(!v)throw new Error(`No provider found for '${r}'`);const C=_.ViewColumn.to(f),R=this._extHostWebview.createNewWebview(a,o.webviewOptions,v.extension),p=this._extHostWebviewPanels.createNewWebviewPanel(a,r,o.title,C,o.panelOptions,R),S=D.URI.revive(i);switch(v.type){case 1:{const{document:u}=this.getCustomDocumentEntry(r,S);return v.provider.resolveCustomEditor(u,p,m)}case 0:{const u=this._extHostDocuments.getDocument(S);return v.provider.resolveCustomTextEditor(u,p,m)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,a,r){this.getCustomDocumentEntry(a,i).disposeEdits(r)}async $onMoveCustomEditor(i,a,r){const o=this._editorProviders.get(r);if(!o)throw new Error(`No provider found for '${r}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const f=this._extHostWebviewPanels.getWebviewPanel(i);if(!f)throw new Error("No webview found");const m=D.URI.revive(a),v=this._extHostDocuments.getDocument(m);await o.provider.moveCustomTextEditor(v,f,h.CancellationToken.None)}async $undo(i,a,r,o){return this.getCustomDocumentEntry(a,i).undo(r,o)}async $redo(i,a,r,o){return this.getCustomDocumentEntry(a,i).redo(r,o)}async $revert(i,a,r){const o=this.getCustomDocumentEntry(a,i);await this.getCustomEditorProvider(a).revertCustomDocument(o.document,r),o.disposeBackup()}async $onSave(i,a,r){const o=this.getCustomDocumentEntry(a,i);await this.getCustomEditorProvider(a).saveCustomDocument(o.document,r),o.disposeBackup()}async $onSaveAs(i,a,r,o){const f=this.getCustomDocumentEntry(a,i);return this.getCustomEditorProvider(a).saveCustomDocumentAs(f.document,D.URI.revive(r),o)}async $backup(i,a,r){const o=this.getCustomDocumentEntry(a,i),m=await this.getCustomEditorProvider(a).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},r);return o.updateBackup(m),m.id}getCustomDocumentEntry(i,a){const r=this._documents.get(i,D.URI.revive(a));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(i){const r=this._editorProviders.get(i)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=I;function y(k){return typeof k.resolveCustomTextEditor=="function"}function s(k){return typeof k.undo=="function"&&typeof k.redo=="function"}function g(k){const i=k.scheme===T.Schemas.file||k.scheme===T.Schemas.untitled?k.fsPath:k.toString();return(0,M.hash)(i)+""}});var Xe=this&&this.__classPrivateFieldSet||function(ne,e,h,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ne,h):b?b.value=h:e.set(ne,h),h},Ae=this&&this.__classPrivateFieldGet||function(ne,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[209],be([0,1,3,6,2,36,8,50,5,7]),function(ne,e,h,M,b,T,F,D,_,P){"use strict";var t,E,n,d,c,l,w,I,y,s,g,k,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class a extends M.Disposable{constructor(m,v,C,R,p,S,u){super();t.set(this,void 0),E.set(this,void 0),n.set(this,void 0),d.set(this,void 0),c.set(this,void 0),l.set(this,void 0),w.set(this,void 0),I.set(this,void 0),y.set(this,!0),s.set(this,!0),g.set(this,!1),k.set(this,this._register(new h.Emitter)),this.onDidDispose=Ae(this,k,"f").event,i.set(this,this._register(new h.Emitter)),this.onDidChangeViewState=Ae(this,i,"f").event,Xe(this,t,m,"f"),Xe(this,E,v,"f"),Xe(this,n,C,"f"),Xe(this,c,S,"f"),Xe(this,I,p,"f"),Xe(this,l,R,"f"),Xe(this,d,u,"f")}dispose(){Ae(this,g,"f")||(Xe(this,g,!0,"f"),Ae(this,k,"f").fire(),Ae(this,E,"f").$disposeWebview(Ae(this,t,"f")),Ae(this,d,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ae(this,d,"f")}get viewType(){return this.assertNotDisposed(),Ae(this,n,"f")}get title(){return this.assertNotDisposed(),Ae(this,l,"f")}set title(m){this.assertNotDisposed(),Ae(this,l,"f")!==m&&(Xe(this,l,m,"f"),Ae(this,E,"f").$setTitle(Ae(this,t,"f"),m))}get iconPath(){return this.assertNotDisposed(),Ae(this,w,"f")}set iconPath(m){this.assertNotDisposed(),Ae(this,w,"f")!==m&&(Xe(this,w,m,"f"),Ae(this,E,"f").$setIconPath(Ae(this,t,"f"),b.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return Ae(this,c,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ae(this,I,"f")=="number"&&Ae(this,I,"f")<0))return Ae(this,I,"f")}get active(){return this.assertNotDisposed(),Ae(this,s,"f")}get visible(){return this.assertNotDisposed(),Ae(this,y,"f")}_updateViewState(m){Ae(this,g,"f")||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(Xe(this,s,m.active,"f"),Xe(this,y,m.visible,"f"),Xe(this,I,m.viewColumn,"f"),Ae(this,i,"f").fire({webviewPanel:this}))}reveal(m,v){this.assertNotDisposed(),Ae(this,E,"f").$reveal(Ae(this,t,"f"),{viewColumn:m?F.ViewColumn.from(m):void 0,preserveFocus:!!v})}assertNotDisposed(){if(Ae(this,g,"f"))throw new Error("Webview is disposed")}}t=new WeakMap,E=new WeakMap,n=new WeakMap,d=new WeakMap,c=new WeakMap,l=new WeakMap,w=new WeakMap,I=new WeakMap,y=new WeakMap,s=new WeakMap,g=new WeakMap,k=new WeakMap,i=new WeakMap;class r{constructor(m,v,C){this.webviews=v,this.workspace=C,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=m.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(m,v,C,R,p={}){const S=typeof R=="object"?R.viewColumn:R,u={viewColumn:F.ViewColumn.from(S),preserveFocus:typeof R=="object"&&!!R.preserveFocus},A=(0,D.shouldSerializeBuffersForPostMessage)(m),L=r.newHandle();this._proxy.$createWebviewPanel((0,D.toExtensionData)(m),L,v,{title:C,panelOptions:o(p),webviewOptions:(0,D.serializeWebviewOptions)(m,this.workspace,p),serializeBuffersForPostMessage:A},u);const V=this.webviews.createNewWebview(L,p,m);return this.createNewWebviewPanel(L,v,C,S,p,V)}$onDidChangeWebviewPanelViewStates(m){const v=Object.keys(m);v.sort((C,R)=>{const p=m[C],S=m[R];return p.active?1:S.active?-1:+p.visible-+S.visible});for(const C of v){const R=this.getWebviewPanel(C);if(!R)continue;const p=m[C];R._updateViewState({active:p.active,visible:p.visible,viewColumn:F.ViewColumn.to(p.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this._webviewPanels.delete(m),this.webviews.deleteWebview(m)}registerWebviewPanelSerializer(m,v,C){if(this._serializers.has(v))throw new Error(`Serializer for '${v}' already registered`);return this._serializers.set(v,{serializer:C,extension:m}),this._proxy.$registerSerializer(v,{serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(m)}),new P.Disposable(()=>{this._serializers.delete(v),this._proxy.$unregisterSerializer(v)})}async $deserializeWebviewPanel(m,v,C,R){const p=this._serializers.get(v);if(!p)throw new Error(`No serializer found for '${v}'`);const{serializer:S,extension:u}=p,A=this.webviews.createNewWebview(m,C.webviewOptions,u),L=this.createNewWebviewPanel(m,v,C.title,R,C.panelOptions,A);await S.deserializeWebviewPanel(L,C.state)}createNewWebviewPanel(m,v,C,R,p,S){const u=new a(m,this._proxy,v,C,R,p,S);return this._webviewPanels.set(m,u),u}getWebviewPanel(m){return this._webviewPanels.get(m)}}e.ExtHostWebviewPanels=r;function o(f){return{enableFindWidget:f.enableFindWidget,retainContextWhenHidden:f.retainContextWhenHidden}}});var Xe=this&&this.__classPrivateFieldSet||function(ne,e,h,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ne,h):b?b.value=h:e.set(ne,h),h},Ae=this&&this.__classPrivateFieldGet||function(ne,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[210],be([0,1,3,6,50,5,7]),function(ne,e,h,M,b,T,F){"use strict";var D,_,P,t,E,n,d,c,l,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class I extends M.Disposable{constructor(g,k,i,a,r,o){super();D.set(this,void 0),_.set(this,void 0),P.set(this,void 0),t.set(this,void 0),E.set(this,!1),n.set(this,void 0),d.set(this,void 0),c.set(this,void 0),l.set(this,this._register(new h.Emitter)),this.onDidChangeVisibility=Ae(this,l,"f").event,w.set(this,this._register(new h.Emitter)),this.onDidDispose=Ae(this,w,"f").event,Xe(this,P,i,"f"),Xe(this,d,a,"f"),Xe(this,D,g,"f"),Xe(this,_,k,"f"),Xe(this,t,r,"f"),Xe(this,n,o,"f")}dispose(){Ae(this,E,"f")||(Xe(this,E,!0,"f"),Ae(this,w,"f").fire(),Ae(this,t,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ae(this,d,"f")}set title(g){this.assertNotDisposed(),Ae(this,d,"f")!==g&&(Xe(this,d,g,"f"),Ae(this,_,"f").$setWebviewViewTitle(Ae(this,D,"f"),g))}get description(){return this.assertNotDisposed(),Ae(this,c,"f")}set description(g){this.assertNotDisposed(),Ae(this,c,"f")!==g&&(Xe(this,c,g,"f"),Ae(this,_,"f").$setWebviewViewDescription(Ae(this,D,"f"),g))}get visible(){return Ae(this,n,"f")}get webview(){return Ae(this,t,"f")}get viewType(){return Ae(this,P,"f")}_setVisible(g){g===Ae(this,n,"f")||Ae(this,E,"f")||(Xe(this,n,g,"f"),Ae(this,l,"f").fire())}show(g){this.assertNotDisposed(),Ae(this,_,"f").$show(Ae(this,D,"f"),!!g)}assertNotDisposed(){if(Ae(this,E,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,_=new WeakMap,P=new WeakMap,t=new WeakMap,E=new WeakMap,n=new WeakMap,d=new WeakMap,c=new WeakMap,l=new WeakMap,w=new WeakMap;class y{constructor(g,k){this._extHostWebview=k,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=g.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(g,k,i,a){if(this._viewProviders.has(k))throw new Error(`View provider for '${k}' already registered`);return this._viewProviders.set(k,{provider:i,extension:g}),this._proxy.$registerWebviewViewProvider((0,b.toExtensionData)(g),k,{retainContextWhenHidden:a?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new F.Disposable(()=>{this._viewProviders.delete(k),this._proxy.$unregisterWebviewViewProvider(k)})}async $resolveWebviewView(g,k,i,a,r){const o=this._viewProviders.get(k);if(!o)throw new Error(`No view provider found for '${k}'`);const{provider:f,extension:m}=o,v=this._extHostWebview.createNewWebview(g,{},m),C=new I(g,this._proxy,k,i,v,!0);this._webviewViews.set(g,C),await f.resolveWebviewView(C,{state:a},r)}async $onDidChangeWebviewViewVisibility(g,k){this.getWebviewView(g)._setVisible(k)}async $disposeWebviewView(g){const k=this.getWebviewView(g);this._webviewViews.delete(g),k.dispose(),this._extHostWebview.deleteWebview(g)}getWebviewView(g){const k=this._webviewViews.get(g);if(!k)throw new Error("No webview found");return k}}e.ExtHostWebviewViews=y}),define(we[97],be([0,1,3,5,2,11,9,4,12]),function(ne,e,h,M,b,T,F,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Ui{constructor(E){this._onDidChangeWindowState=new h.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ui.InitialState,this._proxy=E.getProxy(M.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(E){E!==this._state.focused&&(this._state={...this._state,focused:E},this._onDidChangeWindowState.fire(this._state))}openUri(E,n){let d;if(typeof E=="string"){d=E;try{E=b.URI.parse(E)}catch(c){return Promise.reject(`Invalid uri - '${E}'`)}}return(0,F.isFalsyOrWhitespace)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this._proxy.$openUri(E,d,n)}async asExternalUri(E,n){if((0,F.isFalsyOrWhitespace)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this._proxy.$asExternalUri(E,n);return b.URI.from(d)}};P.InitialState={focused:!0},P=Ue([He(0,_.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,D.createDecorator)("IExtHostWindow")}),define(we[211],be([0,1,15,5,29,12]),function(ne,e,h,M,b,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let F=class extends h.AbstractLogger{constructor(_,P){super();this._proxy=_.getProxy(M.MainContext.MainThreadLog),this._logFile=P.logFile.toJSON(),this.setLevel(P.logLevel)}$setLevel(_){this.setLevel(_)}trace(_,...P){this.getLevel()<=h.LogLevel.Trace&&this._proxy.$log(this._logFile,h.LogLevel.Trace,Array.from(arguments))}debug(_,...P){this.getLevel()<=h.LogLevel.Debug&&this._proxy.$log(this._logFile,h.LogLevel.Debug,Array.from(arguments))}info(_,...P){this.getLevel()<=h.LogLevel.Info&&this._proxy.$log(this._logFile,h.LogLevel.Info,Array.from(arguments))}warn(_,...P){this.getLevel()<=h.LogLevel.Warning&&this._proxy.$log(this._logFile,h.LogLevel.Warning,Array.from(arguments))}error(_,...P){this.getLevel()<=h.LogLevel.Error&&this._proxy.$log(this._logFile,h.LogLevel.Error,Array.from(arguments))}critical(_,...P){this.getLevel()<=h.LogLevel.Critical&&this._proxy.$log(this._logFile,h.LogLevel.Critical,Array.from(arguments))}flush(){}};F=Ue([He(0,T.IExtHostRpcService),He(1,b.IExtHostInitDataService)],F),e.ExtHostLogService=F}),define(we[212],be([0,1,14,23,21,16,3,6,109,179,47]),function(ne,e,h,M,b,T,F,D,_,P,t){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(p,S){try{return JSON.stringify(p,S)}catch(u){return"null"}}const d="$$ref$$",c={[d]:-1};class l{constructor(S,u){this.jsonString=S,this.referencedBuffers=u}}function w(p,S=null,u=!1){const A=[];return{jsonString:(u?n:JSON.stringify)(p,(V,K)=>{if(typeof K=="undefined")return c;if(typeof K=="object"){if(K instanceof M.VSBuffer){const W=A.push(K)-1;return{[d]:W}}if(S)return S(V,K)}return K}),referencedBuffers:A}}e.stringifyJsonWithBufferRefs=w;function I(p,S,u){return JSON.parse(p,(A,L)=>{if(L){const V=L[d];if(typeof V=="number")return S[V];if(u&&L.$mid===1)return u.transformIncoming(L)}return L})}e.parseJsonAndRestoreBufferRefs=I;function y(p,S){return JSON.stringify(p,S)}function s(p){return p?(S,u)=>u&&u.$mid===1?p.transformOutgoing(u):u:null}var g;(function(p){p[p.LocalSide=0]="LocalSide",p[p.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));var k;(function(p){p[p.Responsive=0]="Responsive",p[p.Unresponsive=1]="Unresponsive"})(k=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},a=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class o extends D.Disposable{constructor(S,u=null,A=null){super();this[E]=!0,this._onDidChangeResponsiveState=this._register(new F.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=S,this._logger=u,this._uriTransformer=A,this._uriReplacer=s(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let L=0,V=t.ProxyIdentifier.count;L<V;L++)this._locals[L]=null,this._proxies[L]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new h.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(L=>this._receiveOneMessage(L))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(S=>{this._pendingRPCReplies[S].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(S){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(S){this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(S){this._responsiveState!==S&&(this._responsiveState=S,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(S){return this._uriTransformer?(0,_.transformIncomingURIs)(S,this._uriTransformer):S}getProxy(S){const{nid:u,sid:A}=S;return this._proxies[u]||(this._proxies[u]=this._createProxy(u,A)),this._proxies[u]}_createProxy(S,u){let A={get:(L,V)=>(typeof V=="string"&&!L[V]&&V.charCodeAt(0)===36&&(L[V]=(...K)=>this._remoteCall(S,V,K)),V===r?u:L[V])};return new Proxy(Object.create(null),A)}set(S,u){return this._locals[S.nid]=u,u}assertRegistered(S){for(let u=0,A=S.length;u<A;u++){const L=S[u];if(!this._locals[L.nid])throw new Error(`Missing actor ${L.sid} (isMain: ${L.isMain})`)}}_receiveOneMessage(S){if(this._isDisposed)return;const u=S.byteLength,A=f.read(S,0),L=A.readUInt8(),V=A.readUInt32();switch(L){case 1:case 2:{let{rpcId:K,method:W,args:Q}=v.deserializeRequestJSONArgs(A);this._uriTransformer&&(Q=(0,_.transformIncomingURIs)(Q,this._uriTransformer)),this._receiveRequest(u,V,K,W,Q,L===2);break}case 3:case 4:{let{rpcId:K,method:W,args:Q}=v.deserializeRequestMixedArgs(A);this._uriTransformer&&(Q=(0,_.transformIncomingURIs)(Q,this._uriTransformer)),this._receiveRequest(u,V,K,W,Q,L===4);break}case 5:{this._logger&&this._logger.logIncoming(u,V,0,"ack"),this._onDidReceiveAcknowledge(V);break}case 6:{this._receiveCancel(u,V);break}case 7:{this._receiveReply(u,V,void 0);break}case 9:{let K=v.deserializeReplyOKJSON(A);this._uriTransformer&&(K=(0,_.transformIncomingURIs)(K,this._uriTransformer)),this._receiveReply(u,V,K);break}case 10:{const K=v.deserializeReplyOKJSONWithBuffers(A,this._uriTransformer);this._receiveReply(u,V,K);break}case 8:{let K=v.deserializeReplyOKVSBuffer(A);this._receiveReply(u,V,K);break}case 11:{let K=v.deserializeReplyErrError(A);this._uriTransformer&&(K=(0,_.transformIncomingURIs)(K,this._uriTransformer)),this._receiveReplyErr(u,V,K);break}case 12:{this._receiveReplyErr(u,V,void 0);break}default:console.error("received unexpected message"),console.error(S)}}_receiveRequest(S,u,A,L,V,K){this._logger&&this._logger.logIncoming(S,u,1,`receiveRequest ${(0,t.getStringIdentifierForProxy)(A)}.${L}(`,V);const W=String(u);let Q,$;if(K){const z=new b.CancellationTokenSource;V.push(z.token),Q=this._invokeHandler(A,L,V),$=()=>z.cancel()}else Q=this._invokeHandler(A,L,V),$=i;this._cancelInvokedHandlers[W]=$;const U=v.serializeAcknowledged(u);this._logger&&this._logger.logOutgoing(U.byteLength,u,1,"ack"),this._protocol.send(U),Q.then(z=>{delete this._cancelInvokedHandlers[W];const G=v.serializeReplyOK(u,z,this._uriReplacer);this._logger&&this._logger.logOutgoing(G.byteLength,u,1,"reply:",z),this._protocol.send(G)},z=>{delete this._cancelInvokedHandlers[W];const G=v.serializeReplyErr(u,z);this._logger&&this._logger.logOutgoing(G.byteLength,u,1,"replyErr:",z),this._protocol.send(G)})}_receiveCancel(S,u){this._logger&&this._logger.logIncoming(S,u,1,"receiveCancel");const A=String(u);this._cancelInvokedHandlers[A]&&this._cancelInvokedHandlers[A]()}_receiveReply(S,u,A){this._logger&&this._logger.logIncoming(S,u,0,"receiveReply:",A);const L=String(u);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const V=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L],V.resolveOk(A)}_receiveReplyErr(S,u,A){this._logger&&this._logger.logIncoming(S,u,0,"receiveReplyErr:",A);const L=String(u);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const V=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L];let K;A&&(A.$isError?(K=new Error,K.name=A.name,K.message=A.message,K.stack=A.stack):K=A),V.resolveErr(K)}_invokeHandler(S,u,A){try{return Promise.resolve(this._doInvokeHandler(S,u,A))}catch(L){return Promise.reject(L)}}_doInvokeHandler(S,u,A){const L=this._locals[S];if(!L)throw new Error("Unknown actor "+(0,t.getStringIdentifierForProxy)(S));let V=L[u];if(typeof V!="function")throw new Error("Unknown method "+u+" on actor "+(0,t.getStringIdentifierForProxy)(S));return V.apply(L,A)}_remoteCall(S,u,A){if(this._isDisposed)return Promise.reject(T.canceled());let L=null;if(A.length>0&&b.CancellationToken.isCancellationToken(A[A.length-1])&&(L=A.pop()),L&&L.isCancellationRequested)return Promise.reject(T.canceled());const V=v.serializeRequestArguments(A,this._uriReplacer),K=++this._lastMessageId,W=String(K),Q=new P.LazyPromise;L&&L.onCancellationRequested(()=>{const U=v.serializeCancel(K);this._logger&&this._logger.logOutgoing(U.byteLength,K,0,"cancel"),this._protocol.send(v.serializeCancel(K))}),this._pendingRPCReplies[W]=Q,this._onWillSendRequest(K);const $=v.serializeRequest(K,S,u,V,!!L);return this._logger&&this._logger.logOutgoing($.byteLength,K,0,`request: ${(0,t.getStringIdentifierForProxy)(S)}.${u}(`,A),this._protocol.send($),Q}}e.RPCProtocol=o,E=a,o.UNRESPONSIVE_TIME=3*1e3;class f{constructor(S,u){this._buff=S,this._offset=u}static alloc(S,u,A){let L=new f(M.VSBuffer.alloc(A+1+4),0);return L.writeUInt8(S),L.writeUInt32(u),L}static read(S,u){return new f(S,u)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(S){this._buff.writeUInt8(S,this._offset),this._offset+=1}readUInt8(){const S=this._buff.readUInt8(this._offset);return this._offset+=1,S}writeUInt32(S){this._buff.writeUInt32BE(S,this._offset),this._offset+=4}readUInt32(){const S=this._buff.readUInt32BE(this._offset);return this._offset+=4,S}static sizeShortString(S){return 1+S.byteLength}writeShortString(S){this._buff.writeUInt8(S.byteLength,this._offset),this._offset+=1,this._buff.set(S,this._offset),this._offset+=S.byteLength}readShortString(){const S=this._buff.readUInt8(this._offset);this._offset+=1;const A=this._buff.slice(this._offset,this._offset+S).toString();return this._offset+=S,A}static sizeLongString(S){return 4+S.byteLength}writeLongString(S){this._buff.writeUInt32BE(S.byteLength,this._offset),this._offset+=4,this._buff.set(S,this._offset),this._offset+=S.byteLength}readLongString(){const S=this._buff.readUInt32BE(this._offset);this._offset+=4;const A=this._buff.slice(this._offset,this._offset+S).toString();return this._offset+=S,A}writeBuffer(S){this._buff.writeUInt32BE(S.byteLength,this._offset),this._offset+=4,this._buff.set(S,this._offset),this._offset+=S.byteLength}static sizeVSBuffer(S){return 4+S.byteLength}writeVSBuffer(S){this._buff.writeUInt32BE(S.byteLength,this._offset),this._offset+=4,this._buff.set(S,this._offset),this._offset+=S.byteLength}readVSBuffer(){const S=this._buff.readUInt32BE(this._offset);this._offset+=4;const u=this._buff.slice(this._offset,this._offset+S);return this._offset+=S,u}static sizeMixedArray(S){let u=0;u+=1;for(let A=0,L=S.length;A<L;A++){const V=S[A];switch(u+=1,V.type){case 1:u+=this.sizeLongString(V.value);break;case 2:u+=this.sizeVSBuffer(V.value);break;case 3:u+=this.sizeUInt32,u+=this.sizeLongString(V.value);for(let K=0;K<V.buffers.length;++K)u+=this.sizeVSBuffer(V.buffers[K]);break;case 4:break}}return u}writeMixedArray(S){this._buff.writeUInt8(S.length,this._offset),this._offset+=1;for(let u=0,A=S.length;u<A;u++){const L=S[u];switch(L.type){case 1:this.writeUInt8(1),this.writeLongString(L.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(L.value);break;case 3:this.writeUInt8(3),this.writeUInt32(L.buffers.length),this.writeLongString(L.value);for(let V=0;V<L.buffers.length;++V)this.writeBuffer(L.buffers[V]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const S=this._buff.readUInt8(this._offset);this._offset+=1;let u=new Array(S);for(let A=0;A<S;A++)switch(this.readUInt8()){case 1:u[A]=this.readLongString();break;case 2:u[A]=this.readVSBuffer();break;case 3:const V=this.readUInt32(),K=this.readLongString(),W=[];for(let Q=0;Q<V;++Q)W.push(this.readVSBuffer());u[A]=new t.SerializableObjectWithBuffers(I(K,W,null));break;case 4:u[A]=void 0;break}return u}}f.sizeUInt32=4;var m;(function(p){p[p.Simple=0]="Simple",p[p.Mixed=1]="Mixed"})(m||(m={}));class v{static _useMixedArgSerialization(S){for(let u=0,A=S.length;u<A;u++)if(S[u]instanceof M.VSBuffer||S[u]instanceof t.SerializableObjectWithBuffers||typeof S[u]=="undefined")return!0;return!1}static serializeRequestArguments(S,u){if(this._useMixedArgSerialization(S)){const A=[];for(let L=0,V=S.length;L<V;L++){const K=S[L];if(K instanceof M.VSBuffer)A[L]={type:2,value:K};else if(typeof K=="undefined")A[L]={type:4};else if(K instanceof t.SerializableObjectWithBuffers){const{jsonString:W,referencedBuffers:Q}=w(K.value,u);A[L]={type:3,value:M.VSBuffer.fromString(W),buffers:Q}}else A[L]={type:1,value:M.VSBuffer.fromString(y(K,u))}}return{type:1,args:A}}return{type:0,args:y(S,u)}}static serializeRequest(S,u,A,L,V){switch(L.type){case 0:return this._requestJSONArgs(S,u,A,L.args,V);case 1:return this._requestMixedArgs(S,u,A,L.args,V)}}static _requestJSONArgs(S,u,A,L,V){const K=M.VSBuffer.fromString(A),W=M.VSBuffer.fromString(L);let Q=0;Q+=f.sizeUInt8(),Q+=f.sizeShortString(K),Q+=f.sizeLongString(W);let $=f.alloc(V?2:1,S,Q);return $.writeUInt8(u),$.writeShortString(K),$.writeLongString(W),$.buffer}static deserializeRequestJSONArgs(S){const u=S.readUInt8(),A=S.readShortString(),L=S.readLongString();return{rpcId:u,method:A,args:JSON.parse(L)}}static _requestMixedArgs(S,u,A,L,V){const K=M.VSBuffer.fromString(A);let W=0;W+=f.sizeUInt8(),W+=f.sizeShortString(K),W+=f.sizeMixedArray(L);let Q=f.alloc(V?4:3,S,W);return Q.writeUInt8(u),Q.writeShortString(K),Q.writeMixedArray(L),Q.buffer}static deserializeRequestMixedArgs(S){const u=S.readUInt8(),A=S.readShortString(),L=S.readMixedArray(),V=new Array(L.length);for(let K=0,W=L.length;K<W;K++){const Q=L[K];typeof Q=="string"?V[K]=JSON.parse(Q):V[K]=Q}return{rpcId:u,method:A,args:V}}static serializeAcknowledged(S){return f.alloc(5,S,0).buffer}static serializeCancel(S){return f.alloc(6,S,0).buffer}static serializeReplyOK(S,u,A){if(typeof u=="undefined")return this._serializeReplyOKEmpty(S);if(u instanceof M.VSBuffer)return this._serializeReplyOKVSBuffer(S,u);if(u instanceof t.SerializableObjectWithBuffers){const{jsonString:L,referencedBuffers:V}=w(u.value,A,!0);return this._serializeReplyOKJSONWithBuffers(S,L,V)}else return this._serializeReplyOKJSON(S,n(u,A))}static _serializeReplyOKEmpty(S){return f.alloc(7,S,0).buffer}static _serializeReplyOKVSBuffer(S,u){let A=0;A+=f.sizeVSBuffer(u);let L=f.alloc(8,S,A);return L.writeVSBuffer(u),L.buffer}static deserializeReplyOKVSBuffer(S){return S.readVSBuffer()}static _serializeReplyOKJSON(S,u){const A=M.VSBuffer.fromString(u);let L=0;L+=f.sizeLongString(A);let V=f.alloc(9,S,L);return V.writeLongString(A),V.buffer}static _serializeReplyOKJSONWithBuffers(S,u,A){const L=M.VSBuffer.fromString(u);let V=0;V+=f.sizeUInt32,V+=f.sizeLongString(L);for(const W of A)V+=f.sizeVSBuffer(W);let K=f.alloc(10,S,V);K.writeUInt32(A.length),K.writeLongString(L);for(const W of A)K.writeBuffer(W);return K.buffer}static deserializeReplyOKJSON(S){const u=S.readLongString();return JSON.parse(u)}static deserializeReplyOKJSONWithBuffers(S,u){const A=S.readUInt32(),L=S.readLongString(),V=[];for(let K=0;K<A;++K)V.push(S.readVSBuffer());return new t.SerializableObjectWithBuffers(I(L,V,u))}static serializeReplyErr(S,u){return u?this._serializeReplyErrEror(S,u):this._serializeReplyErrEmpty(S)}static _serializeReplyErrEror(S,u){const A=M.VSBuffer.fromString(n(T.transformErrorForSerialization(u),null));let L=0;L+=f.sizeLongString(A);let V=f.alloc(11,S,L);return V.writeLongString(A),V.buffer}static deserializeReplyErrError(S){const u=S.readLongString();return JSON.parse(u)}static _serializeReplyErrEmpty(S){return f.alloc(12,S,0).buffer}}var C;(function(p){p[p.RequestJSONArgs=1]="RequestJSONArgs",p[p.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",p[p.RequestMixedArgs=3]="RequestMixedArgs",p[p.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",p[p.Acknowledged=5]="Acknowledged",p[p.Cancel=6]="Cancel",p[p.ReplyOKEmpty=7]="ReplyOKEmpty",p[p.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",p[p.ReplyOKJSON=9]="ReplyOKJSON",p[p.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",p[p.ReplyErrError=11]="ReplyErrError",p[p.ReplyErrEmpty=12]="ReplyErrEmpty"})(C||(C={}));var R;(function(p){p[p.String=1]="String",p[p.VSBuffer=2]="VSBuffer",p[p.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",p[p.Undefined=4]="Undefined"})(R||(R={}))}),define(we[213],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const h=function(T){const F=D=>{self.removeEventListener("message",F);const _=D.data;Object.defineProperties(self,{postMessage:{value(P,t){_.postMessage(P,t)}},onmessage:{get(){return _.onmessage},set(P){_.onmessage=P}}}),_.addEventListener("message",P=>{self.dispatchEvent(new MessageEvent("message",{data:P.data}))}),_.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",F)}.toString();class M extends EventTarget{constructor(T,F,D){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const _=`((${h})('${F}'))`,P=new Blob([_],{type:"application/javascript"}),t=URL.createObjectURL(P),E=new MessageChannel,n=t,d={type:"_newWorker",id:n,port:E.port2,url:t,options:D};T(d,[E.port2]),this.postMessage=E.port1.postMessage.bind(E.port1),this.terminate=()=>{const c={type:"_terminateWorker",id:n};E.port1.postMessage(c),URL.revokeObjectURL(t),E.port1.close(),E.port2.close()},Object.defineProperties(this,{onmessage:{get(){return E.port1.onmessage},set(c){E.port1.onmessage=c}},onmessageerror:{get(){return E.port1.onmessageerror},set(c){E.port1.onmessageerror=c}}}),E.port1.addEventListener("messageerror",c=>{const l=new MessageEvent("messageerror",{data:c.data});this.dispatchEvent(l)}),E.port1.addEventListener("message",c=>{const l=new MessageEvent("message",{data:c.data});this.dispatchEvent(l)}),E.port1.start()}}e.NestedWorker=M}),define(we[214],be([0,1,4]),function(ne,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,h.createDecorator)("remoteAgentService")}),define(we[215],be([0,1,11,17,26,2,4,86,45,175,214]),function(ne,e,h,M,b,T,F,D,_,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,F.createDecorator)("pathService");let E=class $i{constructor(d,c,l,w){this.localUserHome=d,this.remoteAgentService=c,this.environmentService=l,this.contextService=w,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||b.OS)(),this.resolveUserHome=(async()=>{const I=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=I?.userHome||d})()}get defaultUriScheme(){return $i.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(d,c){if(d.remoteAuthority)return h.Schemas.vscodeRemote;const l=(0,D.getVirtualWorkspaceScheme)(c.getWorkspace());if(l)return l;const w=c.getWorkspace().folders[0];if(w)return w.uri.scheme;const I=c.getWorkspace().configuration;return I?I.scheme:h.Schemas.file}async userHome(d){return d?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(d=>d===1?M.win32:M.posix)}async fileURI(d){let c="";if(await this.resolveOS===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const w=d.indexOf("/",2);w===-1?(c=d.substring(2),d="/"):(c=d.substring(2,w),d=d.substring(w)||"/")}return T.URI.from({scheme:h.Schemas.file,authority:c,path:d,query:"",fragment:""})}};E=Ue([He(1,t.IRemoteAgentService),He(2,P.IWorkbenchEnvironmentService),He(3,_.IWorkspaceContextService)],E),e.AbstractPathService=E}),define(we[98],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class h{constructor(F,D){this.line=F,this.character=D}isBefore(F){return!1}isBeforeOrEqual(F){return!1}isAfter(F){return!1}isAfterOrEqual(F){return!1}isEqual(F){return!1}compareTo(F){return 0}translate(F,D){return new h(0,0)}with(F){return new h(0,0)}}e.Position=h;class M{constructor(F,D,_,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new h(F,D),this.end=new h(_,P)}contains(F){return!1}isEqual(F){return!1}intersection(F){}union(F){return new M(0,0,0,0)}with(F){return new M(0,0,0,0)}}e.Range=M;var b;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(b=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[39],be([0,1,13,27,22,41,9,4,17,16,98,10]),function(ne,e,h,M,b,T,F,D,_,P,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return t.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",d=" characters skipped \u27EB",c=(n.length+d.length+5)*2;e.ISearchService=(0,D.createDecorator)("searchService");var l;(function(U){U[U.file=0]="file",U[U.text=1]="text"})(l=e.SearchProviderType||(e.SearchProviderType={}));var w;(function(U){U[U.File=1]="File",U[U.Text=2]="Text"})(w=e.QueryType||(e.QueryType={}));function I(U){return!!U.preview}e.resultIsMatch=I;function y(U){return!!U.resource}e.isFileMatch=y;function s(U){return!!U.message}e.isProgressMessage=s;var g;(function(U){U[U.Normal=0]="Normal",U[U.NewSearchStarted=1]="NewSearchStarted"})(g=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class k{constructor(z){this.resource=z,this.results=[]}}e.FileMatch=k;class i{constructor(z,G,ue){this.ranges=G;const q=Array.isArray(G)?G:[G];if(ue&&ue.matchLines===1&&a(q)){z=(0,F.getNLines)(z,ue.matchLines);let le="",se=0,ve=0;const Fe=Math.floor(ue.charsPerLine/5),Me=[];for(const Oe of q){const Ye=Math.max(Oe.startColumn-Fe,0),ze=Oe.startColumn+ue.charsPerLine;if(Ye>ve+Fe+c){const je=n+(Ye-ve)+d;le+=je+z.slice(Ye,ze),se+=Ye-(ve+je.length)}else le+=z.slice(ve,ze);Me.push(new o(0,Oe.startColumn-se,Oe.endColumn-se)),ve=ze}this.preview={text:le,matches:Array.isArray(this.ranges)?Me:Me[0]}}else{const le=Array.isArray(G)?G[0].startLineNumber:G.startLineNumber;this.preview={text:z,matches:(0,h.mapArrayOrNot)(G,se=>new r(se.startLineNumber-le,se.startColumn,se.endLineNumber-le,se.endColumn))}}}}e.TextSearchMatch=i;function a(U){const z=U[0].startLineNumber;for(const G of U)if(G.startLineNumber!==z||G.endLineNumber!==z)return!1;return!0}class r{constructor(z,G,ue,q){this.startLineNumber=z,this.startColumn=G,this.endLineNumber=ue,this.endColumn=q}}e.SearchRange=r;class o extends r{constructor(z,G,ue){super(z,G,z,ue)}}e.OneLineRange=o;var f;(function(U){U.Default="default",U.FileNames="fileNames",U.Type="type",U.Modified="modified",U.CountDescending="countDescending",U.CountAscending="countAscending"})(f=e.SearchSortOrder||(e.SearchSortOrder={}));function m(U,z=!0){const G=U&&U.files&&U.files.exclude,ue=z&&U&&U.search&&U.search.exclude;if(!G&&!ue)return;if(!G||!ue)return G||ue;let q=Object.create(null);return q=b.mixin(q,b.deepClone(G)),q=b.mixin(q,b.deepClone(ue),!0),q}e.getExcludes=m;function v(U,z){return U.excludePattern&&M.match(U.excludePattern,z)?!1:U.includePattern||U.usingSearchPaths?U.includePattern&&M.match(U.includePattern,z)?!0:U.usingSearchPaths?!!U.folderQueries&&U.folderQueries.some(G=>{const ue=G.folder.fsPath;if(T.isEqualOrParent(z,ue)){const q=_.relative(ue,z);return!G.includePattern||!!M.match(G.includePattern,q)}else return!1}):!1:!0}e.pathIncludedInQuery=v;var C;(function(U){U[U.unknownEncoding=1]="unknownEncoding",U[U.regexParseError=2]="regexParseError",U[U.globParseError=3]="globParseError",U[U.invalidLiteral=4]="invalidLiteral",U[U.rgProcessError=5]="rgProcessError",U[U.other=6]="other",U[U.canceled=7]="canceled"})(C=e.SearchErrorCode||(e.SearchErrorCode={}));class R extends Error{constructor(z,G){super(z);this.code=G}}e.SearchError=R;function p(U){const z=U.message;if((0,P.isPromiseCanceledError)(U))return new R(z,C.canceled);try{const G=JSON.parse(z);return new R(G.message,G.code)}catch(G){return new R(z,C.other)}}e.deserializeSearchError=p;function S(U){const z={message:U.message,code:U.code};return new Error(JSON.stringify(z))}e.serializeSearchError=S;function u(U){return U.type==="error"?!0:U.type==="success"}e.isSerializedSearchComplete=u;function A(U){return U.type==="success"}e.isSerializedSearchSuccess=A;function L(U){return!!U.path}e.isSerializedFileMatch=L;function V(U,z){const G=U.searchPath?U.searchPath:U.relativePath;return(0,F.fuzzyContains)(G,z)}e.isFilePatternMatch=V;class K{constructor(z){this.path=z,this.results=[]}addMatch(z){this.results.push(z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=K;function W(U,z){const G={...U||{},...z||{}};return Object.keys(G).filter(ue=>{const q=G[ue];return typeof q=="boolean"&&q})}e.resolvePatternsForProvider=W;class Q{constructor(z,G){this._parsedIncludeExpression=null,this._excludeExpression={...z.excludePattern||{},...G.excludePattern||{}},this._parsedExcludeExpression=M.parse(this._excludeExpression);let ue=z.includePattern;G.includePattern&&(ue?ue={...ue,...G.includePattern}:ue=G.includePattern),ue&&(this._parsedIncludeExpression=M.parse(ue))}includedInQuerySync(z,G,ue){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(z,G,ue)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(z,G,ue))}includedInQuery(z,G,ue){const q=this._parsedExcludeExpression(z,G,ue),le=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(z,G,ue):!0;return(0,E.isPromise)(q)?q.then(se=>se?!1:le()):le()}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=Q;function $(U){for(const z in U)if(typeof U[z]!="boolean")return!0;return!1}}),define(we[31],be([0,1,13,14,21,3,20,11,75,24,9,10,2,130,4,15,145,45,37,29,12,7,39,5]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n,d,c,l,w,I,y,s,g,k,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(S,u,A){return new P.ExtUri(L=>v(L,A)).isEqual(S,u)}function o(S,u,A){return r(S.uri,u.uri,A)?0:(0,t.compare)(S.uri.toString(),u.uri.toString())}function f(S,u,A){return S.index!==u.index?S.index<u.index?-1:1:r(S.uri,u.uri,A)?(0,t.compare)(S.name,u.name):(0,t.compare)(S.uri.toString(),u.uri.toString())}function m(S,u,A,L){const V=S.slice(0).sort((W,Q)=>A(W,Q,L)),K=u.slice(0).sort((W,Q)=>A(W,Q,L));return(0,h.delta)(V,K,(W,Q)=>A(W,Q,L))}function v(S,u){const A=u.getCapabilities(S.scheme);return!(A&&A&1024)}class C extends I.Workspace{constructor(u,A,L,V,K,W){super(u,L.map(Q=>new I.WorkspaceFolder(Q)),V,W);this._name=A,this._isUntitled=K,this._workspaceFolders=[],this._structure=F.TernarySearchTree.forUris(W),L.forEach(Q=>{this._workspaceFolders.push(Q),this._structure.set(Q.uri,Q)})}static toExtHostWorkspace(u,A,L,V){if(!u)return{workspace:null,added:[],removed:[]};const{id:K,name:W,folders:Q,configuration:$,isUntitled:U}=u,z=[],G=A;A?Q.forEach((se,ve)=>{const Fe=n.URI.revive(se.uri),Me=C._findFolder(L||A,Fe,V);Me?(Me.name=se.name,Me.index=se.index,z.push(Me)):z.push({uri:Fe,name:se.name,index:ve})}):z.push(...Q.map(({uri:se,name:ve,index:Fe})=>({uri:n.URI.revive(se),name:ve,index:Fe}))),z.sort((se,ve)=>se.index<ve.index?-1:1);const ue=new C(K,W,z,$?n.URI.revive($):null,!!U,se=>v(se,V)),{added:q,removed:le}=m(G?G.workspaceFolders:[],ue.workspaceFolders,o,V);return{workspace:ue,added:q,removed:le}}static _findFolder(u,A,L){for(let V=0;V<u.folders.length;V++){const K=u.workspaceFolders[V];if(r(K.uri,A,L))return K}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(u,A){return A&&this._structure.get(u)&&(u=(0,P.dirname)(u)),this._structure.findSubstr(u)}resolveWorkspaceFolder(u){return this._structure.get(u)}}let R=class{constructor(u,A,L,V){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=V,this._extHostFileSystemInfo=L,this._requestIdProvider=new _.Counter,this._barrier=new M.Barrier,this._proxy=u.getProxy(a.MainContext.MainThreadWorkspace),this._messageService=u.getProxy(a.MainContext.MainThreadMessageService);const K=A.workspace;this._confirmedWorkspace=K?new C(K.id,K.name,[],K.configuration?n.URI.revive(K.configuration):null,!!K.isUntitled,W=>v(W,L)):void 0}$initializeWorkspace(u,A){this._trusted=A,this.$acceptWorkspaceData(u),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:D.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(u,A,L,...V){const K=[];if(Array.isArray(V)&&V.forEach(z=>{n.URI.isUri(z.uri)&&!K.some(G=>r(G.uri,z.uri,this._extHostFileSystemInfo))&&K.push({uri:z.uri,name:z.name||(0,P.basenameOrAuthority)(z.uri)})}),this._unconfirmedWorkspace||[A,L].some(z=>typeof z!="number"||z<0)||L===0&&K.length===0)return!1;const W=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(A+L>W.length)return!1;const Q=W.slice(0);Q.splice(A,L,...K.map(z=>({uri:z.uri,name:z.name||(0,P.basenameOrAuthority)(z.uri),index:void 0})));for(let z=0;z<Q.length;z++){const G=Q[z];if(Q.some((ue,q)=>q!==z&&r(G.uri,ue.uri,this._extHostFileSystemInfo)))return!1}Q.forEach((z,G)=>z.index=G);const{added:$,removed:U}=m(W,Q,f,this._extHostFileSystemInfo);if($.length===0&&U.length===0)return!1;if(this._proxy){const z=u.displayName||u.name;this._proxy.$updateWorkspaceFolders(z,A,L,K).then(void 0,G=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(w.Severity.Error,(0,d.localize)(0,null,z,G.toString()),{extension:u},[])})}return this.trySetWorkspaceFolders(Q),!0}getWorkspaceFolder(u,A){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(u,A)}async getWorkspaceFolder2(u,A){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(u,A)}async resolveWorkspaceFolder(u){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(u)}getPath(){if(!this._actualWorkspace)return;const{folders:u}=this._actualWorkspace;if(u.length!==0)return u[0].uri.fsPath}getRelativePath(u,A){let L,V="";if(typeof u=="string"?(L=n.URI.file(u),V=u):typeof u!="undefined"&&(L=u,V=u.fsPath),!L)return V;const K=this.getWorkspaceFolder(L,!0);if(!K)return V;typeof A=="undefined"&&this._actualWorkspace&&(A=this._actualWorkspace.folders.length>1);let W=(0,P.relativePath)(K.uri,L);return A&&K.name&&(W=`${K.name}/${W}`),W}trySetWorkspaceFolders(u){this._actualWorkspace&&(this._unconfirmedWorkspace=C.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:u,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(u){const{workspace:A,added:L,removed:V}=C.toExtHostWorkspace(u,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=A||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:L,removed:V}))}findFiles(u,A,L,V,K=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${V.value}, entryPoint: findFiles`);let W;if(A===null?W=!1:A&&(typeof A=="string"?W=A:W=A.pattern),K&&K.isCancellationRequested)return Promise.resolve([]);const{includePattern:Q,folder:$}=p(u);return this._proxy.$startFileSearch((0,E.withUndefinedAsNull)(Q),(0,E.withUndefinedAsNull)($),(0,E.withUndefinedAsNull)(W),(0,E.withUndefinedAsNull)(L),K).then(U=>Array.isArray(U)?U.map(z=>n.URI.revive(z)):[])}async findTextInFiles(u,A,L,V,K=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${V.value}, entryPoint: findTextInFiles`);const W=this._requestIdProvider.getNext(),Q=typeof A.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:A.previewOptions,{includePattern:$,folder:U}=p(A.include),z=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,G={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!0,fileEncoding:A.encoding,maxResults:A.maxResults,previewOptions:Q,afterContext:A.afterContext,beforeContext:A.beforeContext,includePattern:$,excludePattern:z},ue=!1;if(this._activeSearchCallbacks[W]=q=>{if(ue)return;const le=n.URI.revive(q.resource);q.results.forEach(se=>{(0,i.resultIsMatch)(se)?L({uri:le,preview:{text:se.preview.text,matches:(0,h.mapArrayOrNot)(se.preview.matches,ve=>new k.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,h.mapArrayOrNot)(se.ranges,ve=>new k.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):L({uri:le,text:se.text,lineNumber:se.lineNumber})})},K.isCancellationRequested)return{};try{const q=await this._proxy.$startTextSearch(u,(0,E.withUndefinedAsNull)(U),G,W,K);return delete this._activeSearchCallbacks[W],q||{}}catch(q){throw delete this._activeSearchCallbacks[W],q}}$handleTextSearchResult(u,A){this._activeSearchCallbacks[A]&&this._activeSearchCallbacks[A](u)}saveAll(u){return this._proxy.$saveAll(u)}resolveProxy(u){return this._proxy.$resolveProxy(u)}get trusted(){return this._trusted}requestWorkspaceTrust(u){return this._proxy.$requestWorkspaceTrust(u)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};R=Ue([He(0,g.IExtHostRpcService),He(1,s.IExtHostInitDataService),He(2,y.IExtHostFileSystemInfo),He(3,l.ILogService)],R),e.ExtHostWorkspace=R,e.IExtHostWorkspace=(0,c.createDecorator)("IExtHostWorkspace");function p(S){let u,A;return S&&(typeof S=="string"?u=S:(u=S.pattern,A=S.baseFolder||n.URI.file(S.base))),{includePattern:u,folder:A}}}),define(we[32],be([0,1,22,3,31,5,7,148,62,10,14,4,12,15,2]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function l(a,r){if(r){const o=r.split(".");let f=a;for(let m=0;f&&m<o.length;m++)f=f[o[m]];return f}}function w(a){return a instanceof c.URI}function I(a){return a&&a.uri instanceof c.URI&&a.languageId&&typeof a.languageId=="string"}function y(a){return a&&!a.uri&&a.languageId&&typeof a.languageId=="string"}function s(a){return a&&a.uri instanceof c.URI&&(!a.name||typeof a.name=="string")&&(!a.index||typeof a.index=="number")}function g(a){if(w(a))return{resource:a};if(I(a))return{resource:a.uri,overrideIdentifier:a.languageId};if(y(a))return{overrideIdentifier:a.languageId};if(s(a))return{resource:a.uri};if(a===null)return{resource:null}}let k=class{constructor(r,o,f){this._proxy=r.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=f,this._barrier=new t.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new i(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,o){this.getConfigProvider().then(f=>f.$acceptConfigurationChanged(r,o))}};k=Ue([He(0,n.IExtHostRpcService),He(1,b.IExtHostWorkspace),He(2,d.ILogService)],k),e.ExtHostConfiguration=k;class i{constructor(r,o,f,m){this._onDidChangeConfiguration=new M.Emitter,this._proxy=r,this._logService=m,this._extHostWorkspace=o,this._configuration=D.Configuration.parse(f),this._configurationScopes=this._toMap(f.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,o){const f={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,f))}getConfiguration(r,o,f){const m=g(o)||{},v=this._toReadonlyValue(r?l(this._configuration.getValue(void 0,m,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,m,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,m,f?.identifier);function C(p){if(p==null)return null;if(typeof p=="boolean")return p?1:4;switch(p){case F.ConfigurationTarget.Global:return 1;case F.ConfigurationTarget.Workspace:return 4;case F.ConfigurationTarget.WorkspaceFolder:return 5}}const R={has(p){return typeof l(v,p)!="undefined"},get:(p,S)=>{this._validateConfigurationAccess(r?`${r}.${p}`:p,m,f?.identifier);let u=l(v,p);if(typeof u=="undefined")u=S;else{let A;const L=(V,K)=>{let W;const Q=()=>{A=A||(0,h.deepClone)(v),W=W||l(A,K)};return(0,P.isObject)(V)?new Proxy(V,{get:($,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return Q(),()=>W;if(A)return W=W||l(A,K),W[U];const z=$[U];return typeof U=="string"?L(z,`${K}.${U}`):z},set:($,U,z)=>(Q(),W&&(W[U]=z),!0),deleteProperty:($,U)=>(Q(),W&&delete W[U],!0),defineProperty:($,U,z)=>(Q(),W&&Object.defineProperty(W,U,z),!0)}):V};u=L(u,p)}return u},update:(p,S,u,A)=>{p=r?`${r}.${p}`:p;const L=C(u);return S!==void 0?this._proxy.$updateConfigurationOption(L,p,S,m,A):this._proxy.$removeConfigurationOption(L,p,m,A)},inspect:p=>{p=r?`${r}.${p}`:p;const S=(0,h.deepClone)(this._configuration.inspect(p,m,this._extHostWorkspace.workspace));if(S)return{key:p,defaultValue:S.default?.value,globalValue:S.user?.value,workspaceValue:S.workspace?.value,workspaceFolderValue:S.workspaceFolder?.value,defaultLanguageValue:S.default?.override,globalLanguageValue:S.user?.override,workspaceLanguageValue:S.workspace?.override,workspaceFolderLanguageValue:S.workspaceFolder?.override,languageIds:S.overrideIdentifiers}}};return typeof v=="object"&&(0,h.mixin)(R,v,!1),Object.freeze(R)}_toReadonlyValue(r){const o=f=>(0,P.isObject)(f)?new Proxy(f,{get:(m,v)=>o(m[v]),set:(m,v,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(m,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(m,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):f;return o(r)}_validateConfigurationAccess(r,o,f){const m=_.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),v=f?`[${f.value}] `:"";if(m===4){typeof o?.resource=="undefined"&&this._logService.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){o?.resource&&this._logService.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,o){const f=new D.ConfigurationChangeEvent(r,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(m,v)=>f.affectsConfiguration(m,g(v))})}_toMap(r){return r.reduce((o,f)=>(o.set(f[0],f[1]),o),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,E.createDecorator)("IExtHostConfiguration")});var Xe=this&&this.__classPrivateFieldSet||function(ne,e,h,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ne,h):b?b.value=h:e.set(ne,h),h},Ae=this&&this.__classPrivateFieldGet||function(ne,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[99],be([0,1,2,14,3,5,7,31,49,32,21,38,12,29,4,11,26,15,70,165,16]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n,d,c,l,w,I,y,s,g){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function(K){function W($){if($!=null)return $}K.from=W;function Q($){if($!=null)return $}K.to=Q})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var a;(function(K){function W($){if($!=null)return $}K.from=W;function Q($){if($!=null)return $}K.to=Q})(a=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(K){function W($){if($!=null)return $}K.from=W;function Q($){if($!=null)return $}K.to=Q})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var o;(function(K){function W(U){if(U){const z=U;return z&&!!z.process}else return!1}K.is=W;function Q(U){if(U==null)return;const z={process:U.process,args:U.args};return U.options&&(z.options=r.from(U.options)),z}K.from=Q;function $(U){if(U!=null)return new F.ProcessExecution(U.process,U.args,U.options)}K.to=$})(o=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var f;(function(K){function W($){if($!=null)return $}K.from=W;function Q($){if($!=null)return $}K.to=Q})(f=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var m;(function(K){function W(U){if(U){const z=U;return z&&(!!z.commandLine||!!z.command)}else return!1}K.is=W;function Q(U){if(U==null)return;const z={};return U.commandLine!==void 0?z.commandLine=U.commandLine:(z.command=U.command,z.args=U.args),U.options&&(z.options=f.from(U.options)),z}K.from=Q;function $(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new F.ShellExecution(U.commandLine,U.options):new F.ShellExecution(U.command,U.args?U.args:[],U.options)}K.to=$})(m=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var v;(function(K){function W(U){if(U){let z=U;return z&&z.customExecution==="customExecution"}else return!1}K.is=W;function Q(U){return{customExecution:"customExecution"}}K.from=Q;function $(U,z){return z.get(U)}K.to=$})(v=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var C;(function(K){function W(Q,$){let U;return Q.scope!==void 0&&typeof Q.scope!="number"?U=Q.scope.uri:Q.scope!==void 0&&typeof Q.scope=="number"&&(Q.scope===F.TaskScope.Workspace&&$&&$.workspaceFile?U=$.workspaceFile:U=s.USER_TASKS_GROUP_KEY),{id:Q._id,workspaceFolder:U}}K.from=W})(C=e.TaskHandleDTO||(e.TaskHandleDTO={}));var R;(function(K){function W(Q){if(Q!=null)return{_id:Q.id,isDefault:Q.isDefault}}K.from=W})(R=e.TaskGroupDTO||(e.TaskGroupDTO={}));var p;(function(K){function W(U,z){if(U==null)return[];const G=[];for(let ue of U){const q=Q(ue,z);q&&G.push(q)}return G}K.fromMany=W;function Q(U,z){if(U==null)return;let G;U.execution instanceof F.ProcessExecution?G=o.from(U.execution):U.execution instanceof F.ShellExecution?G=m.from(U.execution):U.execution&&U.execution instanceof F.CustomExecution&&(G=v.from(U.execution));const ue=i.from(U.definition);let q;return U.scope?typeof U.scope=="number"?q=U.scope:q=U.scope.uri:q=F.TaskScope.Workspace,!ue||!q?void 0:{_id:U._id,definition:ue,name:U.name,source:{extensionId:z.identifier.value,label:U.source,scope:q},execution:G,isBackground:U.isBackground,group:R.from(U.group),presentationOptions:a.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}K.from=Q;async function $(U,z,G){if(U==null)return;let ue;o.is(U.execution)?ue=o.to(U.execution):m.is(U.execution)?ue=m.to(U.execution):v.is(U.execution)&&(ue=v.to(U._id,G));const q=i.to(U.definition);let le;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?le=U.source.scope:le=await z.resolveWorkspaceFolder(h.URI.revive(U.source.scope)):le=F.TaskScope.Workspace),!q||!le)return;const se=new F.Task(q,le,U.name,U.source.label,ue,U.problemMatchers);return U.isBackground!==void 0&&(se.isBackground=U.isBackground),U.group!==void 0&&(se.group=F.TaskGroup.from(U.group._id),se.group&&(se.group=new F.TaskGroup(se.group.id,se.group.label),U.group.isDefault&&(se.group.isDefault=U.group.isDefault))),U.presentationOptions&&(se.presentationOptions=a.to(U.presentationOptions)),U._id&&(se._id=U._id),U.detail&&(se.detail=U.detail),se}K.to=$})(p=e.TaskDTO||(e.TaskDTO={}));var S;(function(K){function W($){return $}K.from=W;function Q($){if(!!$)return Object.assign(Object.create(null),$)}K.to=Q})(S=e.TaskFilterDTO||(e.TaskFilterDTO={}));class u{constructor(W,Q,$){this._id=Q,this._task=$,k.set(this,void 0),Xe(this,k,W,"f")}get task(){return this._task}terminate(){Ae(this,k,"f").terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}k=new WeakMap;var A;(function(K){function W(Q){return{id:Q._id,task:void 0}}K.from=W})(A=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let L=class{constructor(W,Q,$,U,z,G,ue,q){this._onDidExecuteTask=new b.Emitter,this._onDidTerminateTask=new b.Emitter,this._onDidTaskProcessStarted=new b.Emitter,this._onDidTaskProcessEnded=new b.Emitter,this._proxy=W.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=U,this._configurationService=z,this._terminalService=G,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ue,this._deprecationService=q,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(W,Q,$){if(!$)return new F.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:Q,provider:$,extension:W}),this._proxy.$registerTaskProvider(U,Q),new F.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(W,Q){this._proxy.$registerTaskSystem(W,Q)}fetchTasks(W){return this._proxy.$fetchTasks(S.from(W)).then(async Q=>{const $=[];for(let U of Q){const z=await p.to(U,this._workspaceProvider,this._providedCustomExecutions2);z&&$.push(z)}return $})}get taskExecutions(){const W=[];return this._taskExecutions.forEach(Q=>W.push(Q)),W}terminateTask(W){if(!(W instanceof u))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(W._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(W,Q,$){const U=this._providedCustomExecutions2.get(W.id);if(U){if(this._activeCustomExecutions2.get(W.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(W.id,U),this._terminalService.attachPtyToTerminal(Q,await U.callback($))}this._lastStartedTask=W.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(W)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(W){const Q=await this.getTaskExecution(W);this._taskExecutionPromises.delete(W.id),this._taskExecutions.delete(W.id),this.customExecutionComplete(W),this._onDidTerminateTask.fire({execution:Q})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(W){const Q=await this.getTaskExecution(W.id);this._onDidTaskProcessStarted.fire({execution:Q,processId:W.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(W){const Q=await this.getTaskExecution(W.id);this._onDidTaskProcessEnded.fire({execution:Q,exitCode:W.exitCode})}$provideTasks(W,Q){const $=this._handlers.get(W);if(!$)return Promise.reject(new Error("no handler found"));const U=[],z=(0,M.asPromise)(()=>$.provider.provideTasks(t.CancellationToken.None)).then(G=>this.provideTasksInternal(Q,U,$,G));return new Promise(G=>{z.then(ue=>{Promise.all(U).then(()=>{G(ue)})})})}async $resolveTask(W,Q){const $=this._handlers.get(W);if(!$)return Promise.reject(new Error("no handler found"));if(Q.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${Q.definition.type}] cannot be resolved by provider of type [${$.type}].`);const U=await p.to(Q,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const z=await $.provider.resolveTask(U,t.CancellationToken.None);if(!z)return;this.checkDeprecation(z,$);const G=p.from(z,$.extension);if(!G)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return v.is(G.execution)&&await this.addCustomExecution(G,z,!0),await this.resolveTaskInternal(G)}nextHandle(){return this._handleCounter++}async addCustomExecution(W,Q,$){const U=await this._proxy.$createTaskId(W);!$&&!this._providedCustomExecutions2.has(U)&&this._notProvidedCustomExecutions.add(U),this._providedCustomExecutions2.set(U,Q.execution)}async getTaskExecution(W,Q){if(typeof W=="string"){const z=this._taskExecutionPromises.get(W);if(!z)throw new Error("Unexpected: The specified task is missing an execution");return z}let $=this._taskExecutionPromises.get(W.id);if($)return $;const U=new Promise(async(z,G)=>{const ue=Q||await p.to(W.task,this._workspaceProvider,this._providedCustomExecutions2);ue?z(new u(this,W.id,ue)):G("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(W.id,U),U.then(z=>(this._taskExecutions.set(W.id,z),z),z=>Promise.reject(z))}checkDeprecation(W,Q){W._deprecated&&this._deprecationService.report("Task.constructor",Q.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(W){this._activeCustomExecutions2.get(W.id)&&this._activeCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.has(W.id)&&this._lastStartedTask!==W.id&&(this._providedCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.delete(W.id));let $=this._notProvidedCustomExecutions.values(),U=$.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=$.next()}};L=Ue([He(0,n.IExtHostRpcService),He(1,d.IExtHostInitDataService),He(2,D.IExtHostWorkspace),He(3,_.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,E.IExtHostTerminalService),He(6,I.ILogService),He(7,y.IExtHostApiDeprecationService)],L),e.ExtHostTaskBase=L;let V=class extends L{constructor(W,Q,$,U,z,G,ue,q){super(W,Q,$,U,z,G,ue,q);this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:w.PlatformToString(0)})}async executeTask(W,Q){if(!Q.execution)throw new Error("Tasks to execute must include an execution");const $=p.from(Q,W);if($===void 0)throw new Error("Task is not valid");if(v.is($.execution))await this.addCustomExecution($,Q,!1);else throw new g.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution($),Q);return this._proxy.$executeTask($).catch(z=>{throw new Error(z)}),U}provideTasksInternal(W,Q,$,U){const z=[];if(U)for(let G of U){this.checkDeprecation(G,$),(!G.definition||!W[G.definition.type])&&this._logService.warn(`The task [${G.source}, ${G.name}] uses an undefined task type. The task will be ignored in the future.`);const ue=p.from(G,$.extension);ue&&v.is(ue.execution)?(z.push(ue),Q.push(this.addCustomExecution(ue,G,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:z,extension:$.extension}}async resolveTaskInternal(W){if(v.is(W.execution))return W;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(W,Q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,Q,$){}};V=Ue([He(0,n.IExtHostRpcService),He(1,d.IExtHostInitDataService),He(2,D.IExtHostWorkspace),He(3,_.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,E.IExtHostTerminalService),He(6,I.ILogService),He(7,y.IExtHostApiDeprecationService)],V),e.WorkerExtHostTask=V,e.IExtHostTask=(0,c.createDecorator)("IExtHostTask")}),define(we[216],be([0,1,13,51,27,77,20,11,17,24,9,10,2,111,134,84,45,92,215,39]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n,d,c,l,w,I,y,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let g=class{constructor(C,R,p,S){this.configurationService=C,this.workspaceContextService=R,this.editorGroupsService=p,this.pathService=S}text(C,R,p={}){C=this.getContentPattern(C,p);const S=this.configurationService.getValue(),u=R&&R.some(L=>!this.configurationService.getValue({resource:L}).search.useRipgrep);return{...this.commonQuery(R?.map(w.toWorkspaceFolder),p),type:2,contentPattern:C,previewOptions:p.previewOptions,maxFileSize:p.maxFileSize,usePCRE2:S.search.usePCRE2||u||!1,beforeContext:p.beforeContext,afterContext:p.afterContext,userDisabledExcludesAndIgnoreFiles:p.disregardExcludeSettings&&p.disregardIgnoreFiles}}getContentPattern(C,R){const p=this.configurationService.getValue();C.isRegExp&&(C.pattern=C.pattern.replace(/\r?\n/g,"\\n"));const S={...C,wordSeparators:p.editor.wordSeparators};return this.isCaseSensitive(C,R)&&(S.isCaseSensitive=!0),this.isMultiline(C)&&(S.isMultiline=!0),S}file(C,R={}){return{...this.commonQuery(C,R),type:1,filePattern:R.filePattern?R.filePattern.trim():R.filePattern,exists:R.exists,sortByScore:R.sortByScore,cacheKey:R.cacheKey}}handleIncludeExclude(C,R){return C?(C=Array.isArray(C)?C.map(o):o(C),R?this.parseSearchPaths(C):{pattern:i(...Array.isArray(C)?C:[C])}):{}}commonQuery(C=[],R={}){const p=this.handleIncludeExclude(R.includePattern,R.expandPatterns),S=this.handleIncludeExclude(R.excludePattern,R.expandPatterns),u=C.length>1,A=(p.searchPaths&&p.searchPaths.length?p.searchPaths.map(K=>this.getFolderQueryForSearchPath(K,R,S)):C.map(K=>this.getFolderQueryForRoot(K,R,S,u))).filter(K=>!!K),L={_reason:R._reason,folderQueries:A,usingSearchPaths:!!(p.searchPaths&&p.searchPaths.length),extraFileResources:R.extraFileResources,excludePattern:S.pattern,includePattern:p.pattern,onlyOpenEditors:R.onlyOpenEditors,maxResults:R.maxResults};if(R.onlyOpenEditors){const W=h.coalesce(h.flatten(this.editorGroupsService.groups.map($=>$.editors.map(U=>U.resource)))).filter($=>(0,s.pathIncludedInQuery)(L,$.fsPath)),Q=this.commonQueryFromFileList(W);return{...L,...Q}}const V=R.extraFileResources&&R.extraFileResources.filter(K=>(0,s.pathIncludedInQuery)(L,K.fsPath));return L.extraFileResources=V&&V.length?V:void 0,L}commonQueryFromFileList(C){const R=[],p=new F.ResourceMap,S={};let u=!1;return C.forEach(A=>{if(A.scheme===D.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(A)){const V=this.workspaceContextService.getWorkspaceFolder(A)?.uri??A.with({path:_.dirname(A.fsPath)});let K=p.get(V);K||(u=!0,K={folder:V,includePattern:{}},R.push(K),p.set(V,K));const W=_.relative(V.fsPath,A.fsPath);(0,E.assertIsDefined)(K.includePattern)[W.replace(/\\/g,"/")]=!0}else A.fsPath&&(u=!0,S[A.fsPath]=!0)}),{folderQueries:R,includePattern:S,usingSearchPaths:!0,excludePattern:u?void 0:{"**/*":!0}}}isCaseSensitive(C,R){if(R.isSmartCase){if(C.isRegExp){if(t.containsUppercaseCharacter(C.pattern,!0))return!0}else if(t.containsUppercaseCharacter(C.pattern))return!0}return!!C.isCaseSensitive}isMultiline(C){return C.isMultiline||C.isRegExp&&(0,d.isMultilineRegexSource)(C.pattern)||C.pattern.indexOf(`
`)>=0?!0:!!C.isMultiline}parseSearchPaths(C){const R=Q=>_.isAbsolute(Q)||/^\.\.?([\/\\]|$)/.test(Q),S=(Array.isArray(C)?C:a(C)).map(Q=>{const $=this.pathService.resolvedUserHome;return $?(0,T.untildify)(Q,$.scheme===D.Schemas.file?$.fsPath:$.path):Q}),u=M.groupBy(S,Q=>R(Q)?"searchPaths":"exprSegments"),A=(u.exprSegments||[]).map(Q=>t.rtrim(Q,"/")).map(Q=>t.rtrim(Q,"\\")).map(Q=>(Q[0]==="."&&(Q="*"+Q),r(Q))),L={},V=this.expandSearchPathPatterns(u.searchPaths||[]);V&&V.length&&(L.searchPaths=V);const K=h.flatten(A),W=i(...K);return W&&(L.pattern=W),L}getExcludesForFolder(C,R){return R.disregardExcludeSettings?void 0:(0,s.getExcludes)(C,!R.disregardSearchExcludeSettings)}expandSearchPathPatterns(C){if(!C||!C.length)return[];const R=h.flatten(C.map(S=>{let{pathPortion:u,globPortion:A}=k(S);A&&(A=f(A));const L=this.expandOneSearchPath(u);return h.flatten(L.map(V=>this.resolveOneSearchPathPattern(V,A)))})),p=new Map;return R.forEach(S=>{const u=S.searchPath.toString(),A=p.get(u);A?S.pattern&&(A.pattern=A.pattern||{},A.pattern[S.pattern]=!0):p.set(u,{searchPath:S.searchPath,pattern:S.pattern?i(S.pattern):void 0})}),Array.from(p.values())}expandOneSearchPath(C){if(_.isAbsolute(C)){const R=this.workspaceContextService.getWorkspace().folders;return R[0]&&R[0].uri.scheme!==D.Schemas.file?[{searchPath:R[0].uri.with({path:C})}]:[{searchPath:n.URI.file(_.normalize(C))}]}if(this.workspaceContextService.getWorkbenchState()===2){const R=this.workspaceContextService.getWorkspace().folders[0].uri;if(C=o(C),C.startsWith("../")||C===".."){const S=_.posix.resolve(R.path,C);return[{searchPath:R.with({path:S})}]}const p=f(C);return[{searchPath:R,pattern:p}]}else{if(C==="./"||C===".\\")return[];{const R=C.replace(/^\.[\/\\]/,""),S=this.workspaceContextService.getWorkspace().folders.map(u=>{const A=R.match(new RegExp(`^${t.escapeRegExpCharacters(u.name)}(?:/(.*)|$)`));return A?{match:A,folder:u}:null}).filter(E.isDefined);if(S.length)return S.map(u=>{const A=u.match[1];return{searchPath:u.folder.uri,pattern:A&&f(A)}});{const u=C.match(/\.[\/\\](.+)[\/\\]?/),A=u?u[1]:C,L=c.localize(0,null,A);throw new Error(L)}}}}resolveOneSearchPathPattern(C,R){const p=C.pattern&&R?`${C.pattern}/${R}`:C.pattern||R,S=[{searchPath:C.searchPath,pattern:p}];return p&&!p.endsWith("**")&&S.push({searchPath:C.searchPath,pattern:p+"/**"}),S}getFolderQueryForSearchPath(C,R,p){const S=this.getFolderQueryForRoot((0,w.toWorkspaceFolder)(C.searchPath),R,p,!1);return S?{...S,includePattern:C.pattern}:null}getFolderQueryForRoot(C,R,p,S){let u;const A=n.URI.isUri(C)?C:C.uri;if(p.searchPaths){const Q=p.searchPaths.filter($=>(0,P.isEqual)($.searchPath,A))[0];if(Q&&!Q.pattern)return null;Q&&(u=Q.pattern)}const L=this.configurationService.getValue({resource:A}),K={...this.getExcludesForFolder(L,R)||{},...u||{}},W=n.URI.isUri(C)?(0,P.basename)(C):C.name;return{folder:A,folderName:S?W:void 0,excludePattern:Object.keys(K).length>0?K:void 0,fileEncoding:L.files&&L.files.encoding,disregardIgnoreFiles:typeof R.disregardIgnoreFiles=="boolean"?R.disregardIgnoreFiles:!L.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof R.disregardGlobalIgnoreFiles=="boolean"?R.disregardGlobalIgnoreFiles:!L.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof R.ignoreSymlinks=="boolean"?R.ignoreSymlinks:!L.search.followSymlinks}}};g=Ue([He(0,l.IConfigurationService),He(1,w.IWorkspaceContextService),He(2,I.IEditorGroupsService),He(3,y.IPathService)],g),e.QueryBuilder=g;function k(v){const C=v.match(/[\*\{\}\(\)\[\]\?]/);if(C){const R=C.index,p=v.substr(0,R).match(/[/|\\][^/\\]*$/);if(p){let S=v.substr(0,p.index);return S.match(/[/\\]/)||(S+="/"),{pathPortion:S,globPortion:v.substr((p.index||0)+1)}}}return{pathPortion:v}}function i(...v){return v.length?v.reduce((C,R)=>(C[R]=!0,C),Object.create(null)):void 0}function a(v){return b.splitGlobAware(v,",").map(C=>C.trim()).filter(C=>!!C.length)}function r(v){return[`**/${v}/**`,`**/${v}`].map(R=>R.replace(/\*\*\/\*\*/g,"**"))}function o(v){return v.replace(/\\/g,"/")}function f(v){return o(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function m(v,C){v=h.distinct(v,S=>S.toString());const R=[],p=C.getWorkspace();return v&&v.forEach(S=>{let u;if(C.getWorkbenchState()===2)u=(0,P.relativePath)(p.folders[0].uri,S),u&&u!=="."&&(u="./"+u);else{const A=C.getWorkspaceFolder(S);if(A){const L=A.name;if(p.folders.filter(K=>K.name===L).length===1){const K=(0,P.relativePath)(A.uri,S);K===""?u=`./${A.name}`:u=`./${A.name}/${K}`}else u=S.fsPath}}u&&R.push(u)}),R}e.resolveResourcesForSearchIncludes=m}),define(we[217],be([0,1,24,2,21,16,4,216,39,45]),function(ne,e,h,M,b,T,F,D,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const t=7e3;function E(l,w){const I=w.activationEvents;if(!I)return Promise.resolve(void 0);const y=[],s=[];for(const o of I)if(/^workspaceContains:/.test(o)){const f=o.substr("workspaceContains:".length);f.indexOf("*")>=0||f.indexOf("?")>=0||l.forceUsingSearch?s.push(f):y.push(f)}if(y.length===0&&s.length===0)return Promise.resolve(void 0);let g;const k=new Promise((o,f)=>{g=o}),i=o=>g({activationEvent:o}),a=Promise.all(y.map(o=>n(l,o,i))).then(()=>{}),r=d(l,w.identifier,s,i);return Promise.all([a,r]).then(()=>{g(void 0)}),k}e.checkActivateWorkspaceContainsExtension=E;async function n(l,w,I){for(const y of l.folders)if(await l.exists(h.joinPath(M.URI.revive(y),w))){I(`workspaceContains:${w}`);return}}async function d(l,w,I,y){if(I.length===0)return Promise.resolve(void 0);const s=new b.CancellationTokenSource,g=l.checkExists(l.folders,I,s.token),k=setTimeout(async()=>{s.cancel(),y(`workspaceContainsTimeout:${I.join(",")}`)},t);let i=!1;try{i=await g}catch(a){T.isPromiseCanceledError(a)||T.onUnexpectedError(a)}s.dispose(),clearTimeout(k),i&&y(`workspaceContains:${I.join(",")}`)}function c(l,w,I,y){const s=l.get(F.IInstantiationService),g=l.get(_.ISearchService),i=s.createInstance(D.QueryBuilder).file(w.map(a=>(0,P.toWorkspaceFolder)(M.URI.revive(a))),{_reason:"checkExists",includePattern:I,exists:!0});return g.fileSearch(i,y).then(a=>!!a.limitHit,a=>T.isPromiseCanceledError(a)?!1:Promise.reject(a))}e.checkGlobFileExists=c});var Xe=this&&this.__classPrivateFieldSet||function(ne,e,h,M,b){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?b.call(ne,h):b?b.value=h:e.set(ne,h),h},Ae=this&&this.__classPrivateFieldGet||function(ne,e,h,M){if(h==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?M:h==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[33],be([0,1,125,17,74,24,14,6,20,2,15,5,32,178,72,31,30,176,16,25,23,152,7,85,4,29,73,12,61,64,38,3,217,69,154]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n,d,c,l,w,I,y,s,g,k,i,a,r,o,f,m,v,C,R,p,S,u,A){"use strict";var L,V,K;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let W=class Wi extends D.Disposable{constructor(z,G,ue,q,le,se,ve,Fe,Me,Oe){super();this._onDidChangeRemoteConnectionData=this._register(new p.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=G,this._extHostContext=ue,this._initData=ve,this._extHostWorkspace=q,this._extHostConfiguration=le,this._logService=se,this._extHostTunnelService=Me,this._extHostTerminalService=Oe,this._disposables=new D.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(E.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(E.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(E.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new F.Barrier,this._readyToStartExtensionHost=new F.Barrier,this._readyToRunExtensions=new F.Barrier,this._eagerExtensionsActivated=new F.Barrier,this._registry=new I.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new c.ExtHostStorage(this._extHostContext),this._secretState=new u.ExtHostSecretState(this._extHostContext),this._storagePath=Fe,this._instaService=z.createChild(new v.ServiceCollection([c.IExtHostStorage,this._storage],[u.IExtHostSecretState,this._secretState]));const Ye=new Set;this._initData.hostExtensions.forEach(ze=>Ye.add(s.ExtensionIdentifier.toKey(ze))),this._activator=new d.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ze,je,x)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ze,y.transformErrorForSerialization(je),x)},actualActivateExtension:async(ze,je)=>{if(Ye.has(s.ExtensionIdentifier.toKey(ze)))return await this._mainThreadExtensionsProxy.$activateExtension(ze,je),new d.HostExtension;const x=this._registry.getExtensionDescription(ze);return this._activateExtension(x,je)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),b.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(z){y.onUnexpectedError(z)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let z=[];try{z=this._registry.getAllExtensionDescriptions().map(le=>le.identifier).filter(le=>this.isActivated(le)).map(le=>this._deactivate(le))}catch(G){}await Promise.all(z)}isActivated(z){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(z):!1}_activateByEvent(z,G){return this._activator.activateByEvent(z,G)}_activateById(z,G){return this._activator.activateById(z,G)}activateByIdWithErrors(z,G){return this._activateById(z,G).then(()=>{const ue=this._activator.getActivatedExtension(z);if(ue.activationFailed)return Promise.reject(ue.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(z=>this._registry)}getExtensionExports(z){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(z).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const z=_.TernarySearchTree.forPaths(),G=this._registry.getAllExtensionDescriptions().map(ue=>{if(!!this._getEntryPoint(ue))return this._hostUtils.realpath(ue.extensionLocation.fsPath).then(q=>z.set(P.URI.file(q).fsPath,ue))});this._extensionPathIndex=Promise.all(G).then(()=>z)}return this._extensionPathIndex}_deactivate(z){let G=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(z))return G;const ue=this._activator.getActivatedExtension(z);if(!ue)return G;try{typeof ue.module.deactivate=="function"&&(G=Promise.resolve(ue.module.deactivate()).then(void 0,q=>(this._logService.error(q),Promise.resolve(void 0))))}catch(q){this._logService.error(q)}try{(0,D.dispose)(ue.subscriptions)}catch(q){this._logService.error(q)}return G}async _activateExtension(z,G){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(z.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(z.identifier),this._doActivateExtension(z,G).then(ue=>{const q=ue.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(z.identifier,q.codeLoadingTime,q.activateCallTime,q.activateResolvedTime,G),this._logExtensionActivationTimes(z,G,"success",q),ue},ue=>{throw this._logExtensionActivationTimes(z,G,"failure"),ue})}_logExtensionActivationTimes(z,G,ue,q){const le=Q(z,G);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...le,...q||{},outcome:ue})}_doActivateExtension(z,G){const ue=Q(z,G);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ue);const q=this._getEntryPoint(z);if(!q)return Promise.resolve(new d.EmptyExtension(d.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${z.identifier.value} ${JSON.stringify(G)}`),this._logService.flush();const le=new d.ExtensionActivationTimesBuilder(G.startup);return Promise.all([this._loadCommonJSModule(z.identifier,(0,T.joinPath)(z.extensionLocation,q),le),this._loadExtensionContext(z)]).then(se=>(b.mark(`code/extHost/willActivateExtension/${z.identifier.value}`),Wi._callActivate(this._logService,z.identifier,se[0],se[1],le))).then(se=>(b.mark(`code/extHost/didActivateExtension/${z.identifier.value}`),se))}_loadExtensionContext(z){const G=new k.ExtensionGlobalMemento(z,this._storage),ue=new k.ExtensionMemento(z.identifier.value,!1,this._storage),q=new A.ExtensionSecrets(z,this._secretState),le=z.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,se=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${z.identifier.value}`),Promise.all([G.whenReady,ue.whenReady,this._storagePath.whenReady]).then(()=>{const ve=this;let Fe;return Object.freeze({globalState:G,workspaceState:ue,secrets:q,subscriptions:[],get extensionUri(){return z.extensionLocation},get extensionPath(){return z.extensionLocation.fsPath},asAbsolutePath(Me){return M.join(z.extensionLocation.fsPath,Me)},get storagePath(){return ve._storagePath.workspaceValue(z)?.fsPath},get globalStoragePath(){return ve._storagePath.globalValue(z).fsPath},get logPath(){return M.join(ve._initData.logsLocation.fsPath,z.identifier.value)},get logUri(){return P.URI.joinPath(ve._initData.logsLocation,z.identifier.value)},get storageUri(){return ve._storagePath.workspaceValue(z)},get globalStorageUri(){return ve._storagePath.globalValue(z)},get extensionMode(){return le},get extension(){return Fe===void 0&&(Fe=new $(ve,z.identifier,z,se)),Fe},get extensionRuntime(){return(0,w.checkProposedApiEnabled)(z),ve.extensionRuntime},get environmentVariableCollection(){return ve._extHostTerminalService.getEnvironmentVariableCollection(z)}})})}static _callActivate(z,G,ue,q,le){return ue=ue||{activate:void 0,deactivate:void 0},this._callActivateOptional(z,G,ue,q,le).then(se=>new d.ActivatedExtension(!1,null,le.build(),ue,se,q.subscriptions))}static _callActivateOptional(z,G,ue,q,le){if(typeof ue.activate=="function")try{le.activateCallStart(),z.trace(`ExtensionService#_callActivateOptional ${G.value}`);const se=typeof global=="object"?global:self,ve=ue.activate.apply(se,[q]);return le.activateCallStop(),le.activateResolveStart(),Promise.resolve(ve).then(Fe=>(le.activateResolveStop(),Fe))}catch(se){return Promise.reject(se)}else return Promise.resolve(ue)}_activateOneStartupFinished(z,G){this._activateById(z.identifier,{startup:!1,extensionId:z.identifier,activationEvent:G}).then(void 0,ue=>{this._logService.error(ue)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(b.getMarks());for(const z of this._registry.getAllExtensionDescriptions())if(z.activationEvents)for(const G of z.activationEvents)G==="onStartupFinished"&&this._activateOneStartupFinished(z,G)}_handleEagerExtensions(){const z=this._activateByEvent("*",!0).then(void 0,le=>{this._logService.error(le)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(le=>this._handleWorkspaceContainsEagerExtensions(le.added)));const G=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ue=this._handleWorkspaceContainsEagerExtensions(G),q=Promise.all([z,ue]).then(()=>{});return Promise.race([q,(0,F.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),q}_handleWorkspaceContainsEagerExtensions(z){return z.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(G=>this._handleWorkspaceContainsEagerExtension(z,G))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(z,G){if(this.isActivated(G.identifier))return;const ue=!this._initData.remote.isRemote&&!!this._initData.remote.authority,q={folders:z.map(se=>se.uri),forceUsingSearch:ue,exists:se=>this._hostUtils.exists(se.fsPath),checkExists:(se,ve,Fe)=>this._mainThreadWorkspaceProxy.$checkExists(se,ve,Fe)},le=await(0,S.checkActivateWorkspaceContainsExtension)(q,G);if(!!le)return this._activateById(G.identifier,{startup:!0,extensionId:G.identifier,activationEvent:le.activationEvent}).then(void 0,se=>this._logService.error(se))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(z){throw console.error(z),z}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:z,extensionTestsLocationURI:G}=this._initData.environment;if(!z||!G)throw new Error(h.localize(0,null));const ue=await this._loadCommonJSModule(null,G,new d.ExtensionActivationTimesBuilder(!1));if(!ue||typeof ue.run!="function")throw new Error(h.localize(1,null,G.toString()));return new Promise((q,le)=>{const se=(Me,Oe)=>{Me?le(Me):q(typeof Oe=="number"&&Oe>0?1:0)},ve=(0,T.originalFSPath)(G),Fe=ue.run(ve,se);Fe&&Fe.then&&Fe.then(()=>{q(0)}).catch(Me=>{le(Me.toString())})})}async $extensionTestsExit(z){this._logService.info(`extension host terminating: test runner requested exit with code ${z}`),this._logService.info(`exiting with code ${z}`),this._logService.flush(),this._hostUtils.exit(z)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(z,G){return this._resolvers[z]=G,(0,D.toDisposable)(()=>{delete this._resolvers[z]})}async _activateAndGetResolver(z){const G=z.indexOf("+");if(G===-1)throw new Error("Not an authority that can be resolved!");const ue=z.substr(0,G);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ue}`,!1),{authorityPrefix:ue,resolver:this._resolvers[ue]}}async $resolveAuthority(z,G){const{authorityPrefix:ue,resolver:q}=await this._activateAndGetResolver(z);if(!q)return{type:"error",error:{code:a.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ue}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(q)),b.mark(`code/extHost/willResolveAuthority/${ue}`);const le=await q.resolve(z,{resolveAttempt:G});b.mark(`code/extHost/didResolveAuthorityOK/${ue}`);const se={authority:z,host:le.host,port:le.port,connectionToken:le.connectionToken},ve={extensionHostEnv:le.extensionHostEnv,isTrusted:le.isTrusted};return{type:"ok",value:{authority:se,options:ve,tunnelInformation:{environmentTunnels:le.environmentTunnels}}}}catch(le){if(b.mark(`code/extHost/didResolveAuthorityError/${ue}`),le instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:le._code,message:le._message,detail:le._detail}};throw le}}async $getCanonicalURI(z,G){const{authorityPrefix:ue,resolver:q}=await this._activateAndGetResolver(z);if(!q)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ue}`);const le=P.URI.revive(G);if(typeof q.getCanonicalURI=="undefined")return le;const se=await(0,F.asPromise)(()=>q.getCanonicalURI(le));return se||le}$startExtensionHost(z){return this._registry.keepOnly(z),this._startExtensionHost()}$activateByEvent(z,G){return G===1?this._activateByEvent(z,!1):this._readyToRunExtensions.wait().then(ue=>this._activateByEvent(z,!1))}async $activate(z,G){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(z)?(await this._activateById(z,G),!0):!1}async $deltaExtensions(z,G){z.forEach(q=>q.extensionLocation=P.URI.revive(q.extensionLocation));const ue=await this.getExtensionPathIndex();return await Promise.all(G.map(async q=>{const le=this._registry.getExtensionDescription(q);if(!le)return;const se=await this._hostUtils.realpath(le.extensionLocation.fsPath);ue.delete(P.URI.file(se).fsPath)})),await Promise.all(z.map(async q=>{const le=await this._hostUtils.realpath(q.extensionLocation.fsPath);ue.set(P.URI.file(le).fsPath,q)})),this._registry.deltaExtensions(z,G),Promise.resolve(void 0)}async $test_latency(z){return z}async $test_up(z){return z.byteLength}async $test_down(z){let G=g.VSBuffer.alloc(z),ue=Math.random()%256;for(let q=0;q<z;q++)G.writeUInt8(ue,q);return G}async $updateRemoteConnectionData(z){this._remoteConnectionData=z,this._onDidChangeRemoteConnectionData.fire()}};W=Ue([He(0,r.IInstantiationService),He(1,e.IHostUtils),He(2,m.IExtHostRpcService),He(3,l.IExtHostWorkspace),He(4,n.IExtHostConfiguration),He(5,t.ILogService),He(6,o.IExtHostInitDataService),He(7,f.IExtensionStoragePaths),He(8,C.IExtHostTunnelService),He(9,R.IExtHostTerminalService)],W),e.AbstractExtHostExtensionService=W;function Q(U,z){return{id:U.identifier.value,name:U.name,extensionVersion:U.version,publisherDisplayName:U.publisher,activationEvents:U.activationEvents?U.activationEvents.join(","):null,isBuiltin:U.isBuiltin,reason:z.activationEvent,reasonId:z.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class ${constructor(z,G,ue,q){L.set(this,void 0),V.set(this,void 0),K.set(this,void 0),Xe(this,L,z,"f"),Xe(this,V,G,"f"),Xe(this,K,ue.identifier,"f"),this.id=ue.identifier.value,this.extensionUri=ue.extensionLocation,this.extensionPath=M.normalize((0,T.originalFSPath)(ue.extensionLocation)),this.packageJSON=ue,this.extensionKind=q}get isActive(){return Ae(this,L,"f").isActivated(Ae(this,K,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ae(this,L,"f").getExtensionExports(Ae(this,K,"f"))}activate(){return Ae(this,L,"f").activateByIdWithErrors(Ae(this,K,"f"),{startup:!1,extensionId:Ae(this,V,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=$,L=new WeakMap,V=new WeakMap,K=new WeakMap}),define(we[100],be([0,1,17,2,3,14,5,7,162,31,33,49,167,32,163,12,4,10,91,68]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n,d,c,l,w,I,y,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,w.createDecorator)("IExtHostDebugService");let g=class{constructor(v,C,R,p,S,u){this._workspaceService=C,this._extensionService=R,this._editorsService=p,this._configurationService=S,this._editorTabs=u,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new b.Emitter,this._onDidTerminateDebugSession=new b.Emitter,this._onDidChangeActiveDebugSession=new b.Emitter,this._onDidReceiveDebugSessionCustomEvent=new b.Emitter,this._debugServiceProxy=v.getProxy(F.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new b.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new i(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(A=>{A.onDidChange(L=>{this.registerAllDebugTypes(A)}),this.registerAllDebugTypes(A)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(v,C){const R=v;if(typeof R.sourceReference=="number"&&R.sourceReference>0){let p=`debug:${encodeURIComponent(R.path||"")}`,S="?";return C&&(p+=`${S}session=${encodeURIComponent(C.id)}`,S="&"),p+=`${S}ref=${R.sourceReference}`,M.URI.parse(p)}else{if(R.path)return M.URI.file(R.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(v){const C=[];for(const R of v.getAllExtensionDescriptions())if(R.contributes){const p=R.contributes.debuggers;if(p&&p.length>0)for(const S of p)(0,c.isDebuggerMainContribution)(S)&&C.push(S.type)}this._debugServiceProxy.$registerDebugTypes(C)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const v=[];return this._breakpoints.forEach(C=>v.push(C)),v}addBreakpoints(v){this.startBreakpoints();const C=v.filter(S=>{const u=S.id;return this._breakpoints.has(u)?!1:(this._breakpoints.set(u,S),!0)});this.fireBreakpointChanges(C,[],[]);const R=[],p=new Map;for(const S of C)if(S instanceof D.SourceBreakpoint){let u=p.get(S.location.uri.toString());u||(u={type:"sourceMulti",uri:S.location.uri,lines:[]},p.set(S.location.uri.toString(),u),R.push(u)),u.lines.push({id:S.id,enabled:S.enabled,condition:S.condition,hitCondition:S.hitCondition,logMessage:S.logMessage,line:S.location.range.start.line,character:S.location.range.start.character})}else S instanceof D.FunctionBreakpoint&&R.push({type:"function",id:S.id,enabled:S.enabled,hitCondition:S.hitCondition,logMessage:S.logMessage,condition:S.condition,functionName:S.functionName});return this._debugServiceProxy.$registerBreakpoints(R)}removeBreakpoints(v){this.startBreakpoints();const C=v.filter(u=>this._breakpoints.delete(u.id));this.fireBreakpointChanges([],C,[]);const R=C.filter(u=>u instanceof D.SourceBreakpoint).map(u=>u.id),p=C.filter(u=>u instanceof D.FunctionBreakpoint).map(u=>u.id),S=C.filter(u=>u instanceof D.DataBreakpoint).map(u=>u.id);return this._debugServiceProxy.$unregisterBreakpoints(R,p,S)}startDebugging(v,C,R){return this._debugServiceProxy.$startDebugging(v?v.uri:void 0,C,{parentSessionID:R.parentSession?R.parentSession.id:void 0,lifecycleManagedByParent:R.lifecycleManagedByParent,repl:R.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:R.noDebug,compact:R.compact,debugUI:R.debugUI,suppressSaveBeforeStart:R.suppressSaveBeforeStart})}stopDebugging(v){return this._debugServiceProxy.$stopDebugging(v?v.id:void 0)}registerDebugConfigurationProvider(v,C,R){if(!C)return new D.Disposable(()=>{});const p=this._configProviderHandleCounter++;return this._configProviders.push({type:v,handle:p,provider:C}),this._debugServiceProxy.$registerDebugConfigurationProvider(v,R,!!C.provideDebugConfigurations,!!C.resolveDebugConfiguration,!!C.resolveDebugConfigurationWithSubstitutedVariables,p),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(S=>S.provider!==C),this._debugServiceProxy.$unregisterDebugConfigurationProvider(p)})}registerDebugAdapterDescriptorFactory(v,C,R){if(!R)return new D.Disposable(()=>{});if(!this.definesDebugType(v,C))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${C}' debugger.`);if(this.getAdapterDescriptorFactoryByType(C))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const p=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:C,handle:p,factory:R}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(C,p),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(S=>S.factory!==R),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(p)})}registerDebugAdapterTrackerFactory(v,C){if(!C)return new D.Disposable(()=>{});const R=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:v,handle:R,factory:C}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(p=>p.factory!==C)})}async $runInTerminal(v,C){return Promise.resolve(void 0)}async $substituteVariables(v,C){if(!this._variableResolver){const[S,u]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(S||[],this._editorsService,u)}let R;const p=await this.getFolder(v);return p&&(R={uri:p.uri,name:p.name,index:p.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(R,C)}createDebugAdapter(v,C){if(v.type==="implementation")return new o(v.implementation)}createSignService(){}async $startDASession(v,C){const R=this,p=await this.getSession(C);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(p.type),p).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}' (extension might have failed to activate)`);const u=this.convertToDto(S),A=this.createDebugAdapter(u,p);if(!A)throw new Error(`Couldn't create a debug adapter for type '${p.type}'.`);const L=A;return this._debugAdapters.set(v,L),this.getDebugAdapterTrackers(p).then(V=>(V&&this._debugAdaptersTrackers.set(v,V),L.onMessage(async K=>{if(K.type==="request"&&K.command==="handshake"){const W=K,Q={type:"response",seq:0,command:W.command,request_seq:W.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(W.arguments.value);Q.body={signature:$},L.sendResponse(Q)}else throw new Error("no signer")}catch($){Q.success=!1,Q.message=$.message,L.sendResponse(Q)}}else V&&V.onDidSendMessage&&V.onDidSendMessage(K),K=(0,c.convertToVSCPaths)(K,!0),R._debugServiceProxy.$acceptDAMessage(v,K)}),L.onError(K=>{V&&V.onError&&V.onError(K),this._debugServiceProxy.$acceptDAError(v,K.name,K.message,K.stack)}),L.onExit(K=>{V&&V.onExit&&V.onExit((0,I.withNullAsUndefined)(K),void 0),this._debugServiceProxy.$acceptDAExit(v,(0,I.withNullAsUndefined)(K),void 0)}),V&&V.onWillStartSession&&V.onWillStartSession(),L.startSession()))})}$sendDAMessage(v,C){C=(0,c.convertToDAPaths)(C,!1);const R=this._debugAdaptersTrackers.get(v);R&&R.onWillReceiveMessage&&R.onWillReceiveMessage(C);const p=this._debugAdapters.get(v);p&&p.sendMessage(C)}$stopDASession(v){const C=this._debugAdaptersTrackers.get(v);this._debugAdaptersTrackers.delete(v),C&&C.onWillStopSession&&C.onWillStopSession();const R=this._debugAdapters.get(v);return this._debugAdapters.delete(v),R?R.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(v){const C=[],R=[],p=[];if(v.added)for(const S of v.added){const u=S.id;if(u&&!this._breakpoints.has(u)){let A;if(S.type==="function")A=new D.FunctionBreakpoint(S.functionName,S.enabled,S.condition,S.hitCondition,S.logMessage);else if(S.type==="data")A=new D.DataBreakpoint(S.label,S.dataId,S.canPersist,S.enabled,S.hitCondition,S.condition,S.logMessage);else{const L=M.URI.revive(S.uri);A=new D.SourceBreakpoint(new D.Location(L,new D.Position(S.line,S.character)),S.enabled,S.condition,S.hitCondition,S.logMessage)}A._id=u,this._breakpoints.set(u,A),C.push(A)}}if(v.removed)for(const S of v.removed){const u=this._breakpoints.get(S);u&&(this._breakpoints.delete(S),R.push(u))}if(v.changed){for(const S of v.changed)if(S.id){const u=this._breakpoints.get(S.id);if(u){if(u instanceof D.FunctionBreakpoint&&S.type==="function"){const A=u;A.enabled=S.enabled,A.condition=S.condition,A.hitCondition=S.hitCondition,A.logMessage=S.logMessage,A.functionName=S.functionName}else if(u instanceof D.SourceBreakpoint&&S.type==="source"){const A=u;A.enabled=S.enabled,A.condition=S.condition,A.hitCondition=S.hitCondition,A.logMessage=S.logMessage,A.location=new D.Location(M.URI.revive(S.uri),new D.Position(S.line,S.character))}p.push(u)}}}this.fireBreakpointChanges(C,R,p)}$provideDebugConfigurations(v,C,R){return(0,T.asPromise)(async()=>{const p=this.getConfigProviderByHandle(v);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const S=await this.getFolder(C);return p.provideDebugConfigurations(S,R)}).then(p=>{if(!p)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return p})}$resolveDebugConfiguration(v,C,R,p){return(0,T.asPromise)(async()=>{const S=this.getConfigProviderByHandle(v);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const u=await this.getFolder(C);return S.resolveDebugConfiguration(u,R,p)})}$resolveDebugConfigurationWithSubstitutedVariables(v,C,R,p){return(0,T.asPromise)(async()=>{const S=this.getConfigProviderByHandle(v);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const u=await this.getFolder(C);return S.resolveDebugConfigurationWithSubstitutedVariables(u,R,p)})}async $provideDebugAdapter(v,C){const R=this.getAdapterDescriptorFactoryByHandle(v);if(!R)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const p=await this.getSession(C);return this.getAdapterDescriptor(R,p).then(S=>{if(!S)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}'`);return this.convertToDto(S)})}async $acceptDebugSessionStarted(v){const C=await this.getSession(v);this._onDidStartDebugSession.fire(C)}async $acceptDebugSessionTerminated(v){const C=await this.getSession(v);C&&(this._onDidTerminateDebugSession.fire(C),this._debugSessions.delete(C.id))}async $acceptDebugSessionActiveChanged(v){this._activeDebugSession=v?await this.getSession(v):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(v,C){const R=await this.getSession(v);R&&R._acceptNameChanged(C)}async $acceptDebugSessionCustomEvent(v,C){const p={session:await this.getSession(v),event:C.event,body:C.body};this._onDidReceiveDebugSessionCustomEvent.fire(p)}convertToDto(v){if(v instanceof D.DebugAdapterExecutable)return{type:"executable",command:v.command,args:v.args,options:v.options};if(v instanceof D.DebugAdapterServer)return{type:"server",port:v.port,host:v.host};if(v instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:v.path};if(v instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:v.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(v){const C=this._adapterFactories.filter(R=>R.type===v);if(C.length>0)return C[0].factory}getAdapterDescriptorFactoryByHandle(v){const C=this._adapterFactories.filter(R=>R.handle===v);if(C.length>0)return C[0].factory}getConfigProviderByHandle(v){const C=this._configProviders.filter(R=>R.handle===v);if(C.length>0)return C[0].provider}definesDebugType(v,C){if(v.contributes){const R=v.contributes.debuggers;if(R&&R.length>0){for(const p of R)if(p.label&&p.type&&p.type===C)return!0}}return!1}getDebugAdapterTrackers(v){const R=v.configuration.type,p=this._trackerFactories.filter(S=>S.type===R||S.type==="*").map(S=>(0,T.asPromise)(()=>S.factory.createDebugAdapterTracker(v)).then(u=>u,u=>null));return Promise.race([Promise.all(p).then(S=>{const u=S.filter(A=>!!A);if(u.length>0)return new r(u)}),new Promise((S,u)=>{const A=setTimeout(()=>{clearTimeout(A),u(new Error("timeout"))},1e3)})]).catch(S=>{})}async getAdapterDescriptor(v,C){const R=C.configuration.debugServer;if(typeof R=="number")return Promise.resolve(new D.DebugAdapterServer(R));if(v){const S=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>v.createDebugAdapterDescriptor(C,this.daExecutableFromPackage(C,S))).then(u=>{if(u)return u})}const p=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(C,p))}daExecutableFromPackage(v,C){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(v,C,R){(v.length>0||C.length>0||R.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:v,removed:C,changed:R}))}async getSession(v){if(v)if(typeof v=="string"){const C=this._debugSessions.get(v);if(C)return C}else{let C=this._debugSessions.get(v.id);if(!C){const R=await this.getFolder(v.folderUri),p=v.parent?this._debugSessions.get(v.parent):void 0;C=new k(this._debugServiceProxy,v.id,v.type,v.name,R,v.configuration,p),this._debugSessions.set(C.id,C),this._debugServiceProxy.$sessionCached(C.id)}return C}throw new Error("cannot find session")}getFolder(v){if(v){const C=M.URI.revive(v);return this._workspaceService.resolveWorkspaceFolder(C)}return Promise.resolve(void 0)}};g=Ue([He(0,l.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,t.IExtHostExtensionService),He(3,E.IExtHostDocumentsAndEditors),He(4,d.IExtHostConfiguration),He(5,s.IExtHostEditorTabs)],g),e.ExtHostDebugServiceBase=g;class k{constructor(v,C,R,p,S,u,A){this._debugServiceProxy=v,this._id=C,this._type=R,this._name=p,this._workspaceFolder=S,this._configuration=u,this._parentSession=A}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(v){this._name=v,this._debugServiceProxy.$setDebugSessionName(this._id,v)}get parentSession(){return this._parentSession}_acceptNameChanged(v){this._name=v}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(v,C){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,v,C)}getDebugProtocolBreakpoint(v){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,v.id)}}e.ExtHostDebugSession=k;class i{constructor(v){this.value=Object.freeze({append(C){v.$appendDebugConsole(C)},appendLine(C){this.append(C+`
`)}})}}e.ExtHostDebugConsole=i;class a extends n.AbstractVariableResolverService{constructor(v,C,R,p,S){function u(){if(C){const A=C.activeEditor();if(A)return A.document.uri;const L=p.tabs.filter(V=>V.isActive);if(L.length>0){const V=L[0].resource;return V&&(V.primary||V.secondary)?V.primary??V.secondary:L[0].resource}}}super({getFolderUri:A=>{const L=v.filter(V=>V.name===A);if(L&&L.length>0)return L[0].uri},getWorkspaceFolderCount:()=>v.length,getConfigurationValue:(A,L)=>R.getConfiguration(void 0,A).get(L),getAppRoot:()=>y.cwd(),getExecPath:()=>y.env.VSCODE_EXEC_PATH,getFilePath:()=>{const A=u();if(A)return h.normalize(A.fsPath)},getWorkspaceFolderPathForFile:()=>{if(S){const A=u();if(A){const L=S.getWorkspaceFolder(A);if(L)return h.normalize(L.uri.fsPath)}}},getSelectedText:()=>{if(C){const A=C.activeEditor();if(A&&!A.selection.isEmpty)return A.document.getText(A.selection)}},getLineNumber:()=>{if(C){const A=C.activeEditor();if(A)return String(A.selection.end.line+1)}}},void 0,Promise.resolve(y.env))}}e.ExtHostVariableResolverService=a;class r{constructor(v){this.trackers=v}onWillStartSession(){this.trackers.forEach(v=>v.onWillStartSession?v.onWillStartSession():void 0)}onWillReceiveMessage(v){this.trackers.forEach(C=>C.onWillReceiveMessage?C.onWillReceiveMessage(v):void 0)}onDidSendMessage(v){this.trackers.forEach(C=>C.onDidSendMessage?C.onDidSendMessage(v):void 0)}onWillStopSession(){this.trackers.forEach(v=>v.onWillStopSession?v.onWillStopSession():void 0)}onError(v){this.trackers.forEach(C=>C.onError?C.onError(v):void 0)}onExit(v,C){this.trackers.forEach(R=>R.onExit?R.onExit(v,C):void 0)}}class o extends _.AbstractDebugAdapter{constructor(v){super();this.implementation=v,v.onDidSendMessage(C=>{this.acceptMessage(C)})}startSession(){return Promise.resolve(void 0)}sendMessage(v){this.implementation.handleMessage(v)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let f=class extends g{constructor(v,C,R,p,S,u){super(v,C,R,p,S,u)}createVariableResolver(v,C,R){return new a(v,C,R,this._editorTabs)}};f=Ue([He(0,l.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,t.IExtHostExtensionService),He(3,E.IExtHostDocumentsAndEditors),He(4,d.IExtHostConfiguration),He(5,s.IExtHostEditorTabs)],f),e.WorkerExtHostDebugService=f}),define(we[218],be([0,1,74,2,5,32,30,25,12,29,4,33,91,15]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let c=class{constructor(s,g,k,i,a,r,o){this._apiFactory=s,this._extensionRegistry=g,this._instaService=k,this._extHostConfiguration=i,this._extHostExtensionService=a,this._initData=r,this._logService=o,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),h.mark("code/extHost/willWaitForConfig");const s=await this._extHostConfiguration.getConfigProvider();h.mark("code/extHost/didWaitForConfig");const g=await this._extHostExtensionService.getExtensionPathIndex();this.register(new l(this._apiFactory,g,this._extensionRegistry,s,this._logService)),this.register(this._instaService.createInstance(w)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(I,g,this._initData.environment.appUriScheme))}register(s){if(Array.isArray(s.nodeModuleName))for(let g of s.nodeModuleName)this._factories.set(g,s);else this._factories.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this._alternatives.push(g=>s.alternativeModuleName(g))}};c=Ue([He(2,t.IInstantiationService),He(3,T.IExtHostConfiguration),He(4,E.IExtHostExtensionService),He(5,P.IExtHostInitDataService),He(6,d.ILogService)],c),e.RequireInterceptor=c;class l{constructor(s,g,k,i,a){this._apiFactory=s,this._extensionPaths=g,this._extensionRegistry=k,this._configProvider=i,this._logService=a,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(s,g){const k=this._extensionPaths.findSubstr(g.fsPath);if(k){let i=this._extApiImpl.get(D.ExtensionIdentifier.toKey(k.identifier));return i||(i=this._apiFactory(k,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(k.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((a,r)=>i+=`	${r} -> ${a.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${g.fsPath}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(F.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let w=class{constructor(s,g){this.nodeModuleName="keytar";const{environment:k}=g,i=s.getProxy(b.MainContext.MainThreadKeytar);if(k.appRoot){let a=k.appRoot.fsPath;n.platform==="win32"&&(a=a.replace(/\\/g,"/")),a[a.length-1]==="/"&&(a=a.substr(0,a.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${a}/node_modules.asar/keytar`),this.alternativeNames.add(`${a}/node_modules/keytar`)}this._impl={getPassword:(a,r)=>i.$getPassword(a,r),setPassword:(a,r,o)=>i.$setPassword(a,r,o),deletePassword:(a,r)=>i.$deletePassword(a,r),findPassword:a=>i.$findPassword(a),findCredentials(a){return i.$findCredentials(a)}}}load(s,g){return this._impl}alternativeModuleName(s){const g=s.length;if(g<=7||!this.alternativeNames)return;const k=g-7;if((s.charAt(k)==="/"||s.charAt(k)==="\\")&&s.endsWith("keytar")&&(s=s.replace(/\\/g,"/"),this.alternativeNames.has(s)))return"keytar"}};w=Ue([He(0,_.IExtHostRpcService),He(1,P.IExtHostInitDataService)],w);let I=class{constructor(s,g,k){this._extensionPaths=s,this._appUriScheme=g,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=k.getProxy(b.MainContext.MainThreadTelemetry);const i=k.getProxy(b.MainContext.MainThreadWindow);this._impl=(a,r)=>{const o=M.URI.parse(a);return r?this.callOriginal(a,r):o.scheme==="http"||o.scheme==="https"?i.$openUri(o,a,{allowTunneling:!0}):o.scheme==="mailto"||o.scheme===this._appUriScheme?i.$openUri(o,a,{}):this.callOriginal(a,r)}}load(s,g,k){const i=this._extensionPaths.findSubstr(g.fsPath);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=k(s),this._impl}callOriginal(s,g){return this.sendNoForwardTelemetry(),this._original(s,g)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};I=Ue([He(2,_.IExtHostRpcService)],I)}),define(we[219],be([0,1,14,16,74,6,2,5,212,15,57,61,29,144,12,65,33,38]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n,d,c,l,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class y{constructor(g,k,i,a){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=i,this._rpcProtocol=new _.RPCProtocol(g,null,a),k=y._transform(k,this._rpcProtocol);const r=new E.ServiceCollection(...(0,t.getSingletonServiceDescriptors)());r.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...k}),r.set(c.IExtHostRpcService,new c.ExtHostRpcService(this._rpcProtocol)),r.set(l.IURITransformerService,new l.URITransformerService(a)),r.set(w.IHostUtils,i);const o=new d.InstantiationService(r,!0),f=o.invokeFunction(R=>R.get(I.IExtHostTerminalService));this._disposables.add(f),this._logService=o.invokeFunction(R=>R.get(P.ILogService)),b.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",k),this._extensionService=o.invokeFunction(R=>R.get(w.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const m=new WeakMap;this._extensionService.getExtensionPathIndex().then(R=>{Error.prepareStackTrace=(p,S)=>{let u="",A,L;for(const V of S)u+=`
	at ${V.toString()}`,L=V.getFileName(),!A&&L&&(A=R.findSubstr(L));return m.set(p,A),`${p.name||"Error"}: ${p.message||""}${u}`}});const v=this._rpcProtocol.getProxy(D.MainContext.MainThreadExtensionService),C=this._rpcProtocol.getProxy(D.MainContext.MainThreadErrors);M.setUnexpectedErrorHandler(R=>{const p=M.transformErrorForSerialization(R),S=m.get(R);S?v.$onExtensionRuntimeError(S.identifier,p):C.$onUnexpectedError(p)})}terminate(g){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${g}`),this._logService.flush(),this._disposables.dispose(),M.setUnexpectedErrorHandler(i=>{this._logService.error(i)}),this._rpcProtocol.dispose();const k=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,h.timeout)(4e3),k]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(g,k){g.extensions.forEach(a=>a.extensionLocation=F.URI.revive(k.transformIncomingURIs(a.extensionLocation))),g.environment.appRoot=F.URI.revive(k.transformIncomingURIs(g.environment.appRoot));const i=g.environment.extensionDevelopmentLocationURI;return i&&(g.environment.extensionDevelopmentLocationURI=i.map(a=>F.URI.revive(k.transformIncomingURIs(a)))),g.environment.extensionTestsLocationURI=F.URI.revive(k.transformIncomingURIs(g.environment.extensionTestsLocationURI)),g.environment.globalStorageHome=F.URI.revive(k.transformIncomingURIs(g.environment.globalStorageHome)),g.environment.workspaceStorageHome=F.URI.revive(k.transformIncomingURIs(g.environment.workspaceStorageHome)),g.logsLocation=F.URI.revive(k.transformIncomingURIs(g.logsLocation)),g.logFile=F.URI.revive(k.transformIncomingURIs(g.logFile)),g.workspace=k.transformIncomingURIs(g.workspace),g}}e.ExtensionHostMain=y}),define(we[220],be([0,1,17,21,56,27,24,193,39]),function(ne,e,h,M,b,T,F,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(n,d,c){this.config=n,this.provider=d,this.sessionToken=c,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&T.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&T.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const d=this.config.folderQueries||[];return new Promise((c,l)=>{const w=I=>{this.resultCount++,n(I)};if(this.isCanceled)return c({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(I=>{const y=I.toString(),s=h.basename(y);this.globalExcludePattern&&this.globalExcludePattern(y,s)||this.matchFile(w,{base:I,basename:s})}),Promise.all(d.map(I=>this.searchInFolder(I,w))).then(I=>{c({limitHit:this.isLimitHit,stats:I[0]||void 0})},I=>{l(new Error((0,b.toErrorMessage)(I)))})})}async searchInFolder(n,d){const c=new M.CancellationTokenSource,l=this.getSearchOptionsForFolder(n),w=this.initDirectoryTree(),I=new _.QueryGlobTester(this.config,n),y=!I.hasSiblingExcludeClauses();let s;try{this.activeCancellationTokens.add(c),s=D.StopWatch.create();const g=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},l,c.token),k=s.elapsed(),i=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(g&&g.forEach(a=>{const r=h.posix.relative(n.folder.path,a.path);if(y){const o=h.basename(a.path);this.matchFile(d,{base:n.folder,relativePath:r,basename:o});return}this.addDirectoryEntries(w,n.folder,r,d)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(w,I,d),{providerTime:k,postProcessTime:i.elapsed()})}finally{c.dispose(),this.activeCancellationTokens.delete(c)}}getSearchOptionsForFolder(n){const d=(0,_.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),c=(0,_.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:c,includes:d,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},d,c,l){if(c===this.filePattern){const I=h.basename(this.filePattern);this.matchFile(l,{base:d,relativePath:this.filePattern,basename:I})}function w(I){const y=h.basename(I),s=h.dirname(I);let g=n[s];g||(g=n[s]=[],w(s)),g.push({base:d,relativePath:I,basename:y})}w(c)}matchDirectoryTree({rootEntries:n,pathToEntries:d},c,l){const w=this,I=this.filePattern;function y(s){const g=T.hasSiblingFn(()=>s.map(k=>k.basename));for(let k=0,i=s.length;k<i;k++){const a=s[k],{relativePath:r,basename:o}=a;if(!c.includedInQuerySync(r,o,I!==o?g:void 0))continue;const f=d[r];if(f)y(f);else{if(r===I)continue;w.matchFile(l,a)}if(w.isLimitHit)break}}y(n)}matchFile(n,d){(!this.includePattern||d.relativePath&&this.includePattern(d.relativePath,d.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(d))}}class t{constructor(){this.sessions=new Map}fileSearch(n,d,c,l){const w=this.getSessionTokenSource(n.cacheKey),I=new P(n,d,w&&w.token);let y=0;const s=g=>{y+=g.length,c(g.map(k=>this.rawMatchToSearchItem(k)))};return this.doSearch(I,t.BATCH_SIZE,s,l).then(g=>({limitHit:g.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:y,detailStats:g.stats}}))}clearCache(n){const d=this.getSessionTokenSource(n);d&&d.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new M.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:F.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,d,c,l){l.onCancellationRequested(()=>{n.cancel()});const w=y=>{y&&(I.push(y),d>0&&I.length>=d&&(c(I),I=[]))};let I=[];return n.search(w).then(y=>(I.length&&c(I),y),y=>(I.length&&c(I),Promise.reject(y)))}}e.FileSearchManager=t,t.BATCH_SIZE=512}),define(we[221],be([0,1,13,21,56,27,11,17,24,10,2,39]),function(ne,e,h,M,b,T,F,D,_,P,t,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(s,g,k,i){this.query=s,this.provider=g,this.fileUtils=k,this.processType=i,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(s,g){const k=this.query.folderQueries||[],i=new M.CancellationTokenSource;return g.onCancellationRequested(()=>i.cancel()),new Promise((a,r)=>{this.collector=new c(s);let o=!1;const f=(m,v)=>{if(!o&&!this.isLimitHit){const C=this.resultSize(m);w(m)&&typeof this.query.maxResults=="number"&&this.resultCount+C>this.query.maxResults&&(this.isLimitHit=!0,o=!0,i.cancel(),m=this.trimResultToSize(m,this.query.maxResults-this.resultCount));const R=this.resultSize(m);this.resultCount+=R,(R>0||!w(m))&&this.collector.add(m,v)}};Promise.all(k.map((m,v)=>this.searchInFolder(m,C=>f(C,v),i.token))).then(m=>{i.dispose(),this.collector.flush();const v=m.some(C=>!!C&&!!C.limitHit);a({limitHit:this.isLimitHit||v,messages:(0,h.flatten)(m.map(C=>C?.message?(0,P.isArray)(C.message)?C.message:[C.message]:[])),stats:{type:this.processType}})},m=>{i.dispose();const v=(0,b.toErrorMessage)(m);r(new Error(v))})})}resultSize(s){return w(s)?Array.isArray(s.ranges)?s.ranges.length:1:0}trimResultToSize(s,g){const k=Array.isArray(s.ranges)?s.ranges:[s.ranges],i=Array.isArray(s.preview.matches)?s.preview.matches:[s.preview.matches];return{ranges:k.slice(0,g),preview:{matches:i.slice(0,g),text:s.preview.text},uri:s.uri}}async searchInFolder(s,g,k){const i=new E.QueryGlobTester(this.query,s),a=[],r={report:m=>{if(!this.validateProviderResult(m))return;const v=s.folder.scheme===F.Schemas.file?T.hasSiblingPromiseFn(()=>this.fileUtils.readdir(_.dirname(m.uri))):void 0,C=_.relativePath(s.folder,m.uri);if(C){const R=i.includedInQuery(C,D.basename(C),v);(0,P.isPromise)(R)?a.push(R.then(p=>{p&&g(m)})):R&&g(m)}}},o=this.getSearchOptionsForFolder(s),f=await this.provider.provideTextSearchResults(d(this.query.contentPattern),o,r,k);return a.length&&await Promise.all(a),f}validateProviderResult(s){if(w(s)){if(Array.isArray(s.ranges)){if(!Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(s.preview.matches.length!==s.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(s){const g=(0,E.resolvePatternsForProvider)(this.query.includePattern,s.includePattern),k=(0,E.resolvePatternsForProvider)(this.query.excludePattern,s.excludePattern),i={folder:t.URI.from(s.folder),excludes:k,includes:g,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,followSymlinks:!s.ignoreSymlinks,encoding:s.fileEncoding&&this.fileUtils.toCanonicalName(s.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return i.usePCRE2=this.query.usePCRE2,i}}e.TextSearchManager=n;function d(y){return{isCaseSensitive:y.isCaseSensitive||!1,isRegExp:y.isRegExp||!1,isWordMatch:y.isWordMatch||!1,isMultiline:y.isMultiline||!1,pattern:y.pattern}}class c{constructor(s){this._onResult=s,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new I(512,g=>this.sendItems(g))}add(s,g){this._currentFileMatch&&(this._currentFolderIdx!==g||!_.isEqual(this._currentUri,s.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=g,this._currentFileMatch={resource:s.uri,results:[]}),this._currentFileMatch.results.push(l(s))}pushToCollector(){const s=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,s)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(s){this._onResult(s)}}e.TextSearchResultsCollector=c;function l(y){return w(y)?{preview:{matches:(0,h.mapArrayOrNot)(y.preview.matches,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character})),text:y.preview.text},ranges:(0,h.mapArrayOrNot)(y.ranges,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character}))}:{text:y.text,lineNumber:y.lineNumber}}function w(y){return!!y.preview}e.extensionResultIsMatch=w;class I{constructor(s,g){this.maxBatchSize=s,this.cb=g,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(s,g){!s||this.addItemToBatch(s,g)}addItems(s,g){!s||this.addItemsToBatch(s,g)}addItemToBatch(s,g){this.batch.push(s),this.batchSize+=g,this.onUpdate()}addItemsToBatch(s,g){this.batch=this.batch.concat(s),this.batchSize+=g,this.onUpdate()}onUpdate(){this.totalNumberCompleted<I.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},I.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=I,I.TIMEOUT=4e3,I.START_BATCH_AFTER_COUNT=50}),define(we[101],be([0,1,6,5,4,220,12,65,15,2,221]),function(ne,e,h,M,b,T,F,D,_,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,b.createDecorator)("IExtHostSearch");let E=class{constructor(l,w,I){this.extHostRpc=l,this._uriTransformer=w,this._logService=I,this._proxy=this.extHostRpc.getProxy(M.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(l){return this._uriTransformer.transformOutgoingScheme(l)}registerTextSearchProvider(l,w){if(this._textSearchUsedSchemes.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this._textSearchUsedSchemes.add(l);const I=this._handlePool++;return this._textSearchProvider.set(I,w),this._proxy.$registerTextSearchProvider(I,this._transformScheme(l)),(0,h.toDisposable)(()=>{this._textSearchUsedSchemes.delete(l),this._textSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}registerFileSearchProvider(l,w){if(this._fileSearchUsedSchemes.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this._fileSearchUsedSchemes.add(l);const I=this._handlePool++;return this._fileSearchProvider.set(I,w),this._proxy.$registerFileSearchProvider(I,this._transformScheme(l)),(0,h.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(l),this._fileSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}$provideFileSearchResults(l,w,I,y){const s=n(I),g=this._fileSearchProvider.get(l);if(g)return this._fileSearchManager.fileSearch(s,g,k=>{this._proxy.$handleFileMatch(l,w,k.map(i=>i.resource))},y);throw new Error("unknown provider: "+l)}$clearCache(l){return this._fileSearchManager.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,w,I,y){const s=this._textSearchProvider.get(l);if(!s||!s.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const g=n(I);return this.createTextSearchManager(g,s).search(i=>this._proxy.$handleTextMatch(l,w,i),y)}$enableExtensionHostSearch(){}createTextSearchManager(l,w){return new t.TextSearchManager(l,w,{readdir:I=>Promise.resolve([]),toCanonicalName:I=>I},"textSearchProvider")}};E=Ue([He(0,F.IExtHostRpcService),He(1,D.IURITransformerService),He(2,_.ILogService)],E),e.ExtHostSearch=E;function n(c){return{...c,folderQueries:c.folderQueries&&c.folderQueries.map(d),extraFileResources:c.extraFileResources&&c.extraFileResources.map(l=>P.URI.revive(l))}}e.reviveQuery=n;function d(c){return{...c,folder:P.URI.revive(c.folder)}}}),define(we[222],be([0,1,21,16,3,35,2,117,79,113,55,60,5,183,182,48,184,32,185,186,187,169,188,49,33,189,170,192,194,195,96,172,200,201,202,72,38,204,173,8,7,207,50,97,31,30,51,159,191,86,95,99,100,101,15,65,12,29,196,156,64,70,180,205,155,73,71,210,208,209,181,37,203,206,69,68,87,198,98,199,11,146,197,153,190]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n,d,c,l,w,I,y,s,g,k,i,a,r,o,f,m,v,C,R,p,S,u,A,L,V,K,W,Q,$,U,z,G,ue,q,le,se,ve,Fe,Me,Oe,Ye,ze,je,x,Y,ee,ae,j,oe,he,Te,Be,$e,Qe,_e,nt,H,J,me,Ne,Ke,ot,at,vt,kt,ht,yt,It,ft,Je,Et,Pe,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ce(Z){const ce=Z.get(ee.IExtHostInitDataService),ge=Z.get(Ne.IExtHostFileSystemInfo),fe=Z.get(_e.IExtHostConsumerFileSystem),Ie=Z.get(r.IExtHostExtensionService),xe=Z.get(ue.IExtHostWorkspace),Le=Z.get(kt.IExtHostTelemetry),Ve=Z.get(I.IExtHostConfiguration),Ze=Z.get(x.IURITransformerService),ie=Z.get(Y.IExtHostRpcService),pe=Z.get(L.IExtHostStorage),re=Z.get(Qe.IExtensionStoragePaths),B=Z.get(je.ILogService),De=Z.get(oe.IExtHostTunnelService),Se=Z.get(he.IExtHostApiDeprecationService),qe=Z.get(G.IExtHostWindow),We=Z.get(at.IExtHostSecretState),tt=Z.get(vt.IExtHostEditorTabs);ie.set(n.ExtHostContext.ExtHostFileSystemInfo,ge),ie.set(n.ExtHostContext.ExtHostLogService,B),ie.set(n.ExtHostContext.ExtHostWorkspace,xe),ie.set(n.ExtHostContext.ExtHostConfiguration,Ve),ie.set(n.ExtHostContext.ExtHostExtensionService,Ie),ie.set(n.ExtHostContext.ExtHostStorage,pe),ie.set(n.ExtHostContext.ExtHostTunnelService,De),ie.set(n.ExtHostContext.ExtHostWindow,qe),ie.set(n.ExtHostContext.ExtHostSecretState,We),ie.set(n.ExtHostContext.ExtHostTelemetry,Le),ie.set(n.ExtHostContext.ExtHostEditorTabs,tt);const mt=ie.set(n.ExtHostContext.ExtHostDecorations,Z.get(Me.IExtHostDecorations)),wt=ie.set(n.ExtHostContext.ExtHostDocumentsAndEditors,Z.get(a.IExtHostDocumentsAndEditors)),rt=ie.set(n.ExtHostContext.ExtHostCommands,Z.get(l.IExtHostCommands)),ct=ie.set(n.ExtHostContext.ExtHostTerminalService,Z.get(V.IExtHostTerminalService)),lt=ie.set(n.ExtHostContext.ExtHostDebugService,Z.get(Ye.IExtHostDebugService)),Tt=ie.set(n.ExtHostContext.ExtHostSearch,Z.get(ze.IExtHostSearch)),_t=ie.set(n.ExtHostContext.ExtHostTask,Z.get(Oe.IExtHostTask)),Ut=ie.set(n.ExtHostContext.ExtHostOutputService,Z.get(R.IExtHostOutputService)),$t=ie.set(n.ExtHostContext.ExtHostUrls,new U.ExtHostUrls(ie)),Ct=ie.set(n.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(ie,wt)),Wt=ie.set(n.ExtHostContext.ExtHostDocumentContentProviders,new g.ExtHostDocumentContentProvider(ie,wt,B)),ei=ie.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new k.ExtHostDocumentSaveParticipant(B,Ct,ie.getProxy(n.MainContext.MainThreadBulkEdits))),gt=ie.set(n.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(ie,rt,wt,Ct,re)),Qt=ie.set(n.ExtHostContext.ExtHostNotebookDocuments,new Pe.ExtHostNotebookDocuments(B,gt)),jt=ie.set(n.ExtHostContext.ExtHostNotebookEditors,new Et.ExtHostNotebookEditors(B,ie,gt)),ti=ie.set(n.ExtHostContext.ExtHostNotebookKernels,new ht.ExtHostNotebookKernels(ie,ce,gt,B)),ii=ie.set(n.ExtHostContext.ExtHostNotebookRenderers,new It.ExtHostNotebookRenderers(ie,gt)),Pt=ie.set(n.ExtHostContext.ExtHostEditors,new K.ExtHostEditors(ie,wt)),Yt=ie.set(n.ExtHostContext.ExtHostTreeViews,new W.ExtHostTreeViews(ie.getProxy(n.MainContext.MainThreadTreeViews),rt,B)),wi=ie.set(n.ExtHostContext.ExtHostEditorInsets,new se.ExtHostEditorInsets(ie.getProxy(n.MainContext.MainThreadEditorInsets),Pt,ce)),Ht=ie.set(n.ExtHostContext.ExtHostDiagnostics,new y.ExtHostDiagnostics(ie,B,ge)),zt=ie.set(n.ExtHostContext.ExtHostLanguages,new v.ExtHostLanguages(ie,Ct,rt.converter)),dt=ie.set(n.ExtHostContext.ExtHostLanguageFeatures,new m.ExtHostLanguageFeatures(ie,Ze,Ct,rt,Ht,B,Se)),ni=ie.set(n.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(ie,dt)),Ot=ie.set(n.ExtHostContext.ExtHostFileSystemEventService,new f.ExtHostFileSystemEventService(ie,B,wt)),Nt=ie.set(n.ExtHostContext.ExtHostQuickOpen,(0,S.createExtHostQuickOpen)(ie,xe,rt)),Jt=ie.set(n.ExtHostContext.ExtHostSCM,new u.ExtHostSCM(ie,rt,B)),bi=ie.set(n.ExtHostContext.ExtHostComments,(0,w.createExtHostComments)(ie,rt,Ct)),hi=ie.set(n.ExtHostContext.ExtHostProgress,new p.ExtHostProgress(ie.getProxy(n.MainContext.MainThreadProgress))),Ei=ie.set(n.ExtHostContext.ExtHosLabelService,new ve.ExtHostLabelService(ie)),fi=ie.set(n.ExtHostContext.ExtHostTheming,new j.ExtHostTheming(ie)),ri=ie.set(n.ExtHostContext.ExtHostAuthentication,new Te.ExtHostAuthentication(ie)),si=ie.set(n.ExtHostContext.ExtHostTimeline,new Be.ExtHostTimeline(ie,rt)),qt=ie.set(n.ExtHostContext.ExtHostWebviews,new z.ExtHostWebviews(ie,{remote:ce.remote},xe,B,Se)),oi=ie.set(n.ExtHostContext.ExtHostWebviewPanels,new J.ExtHostWebviewPanels(ie,qt,xe)),_i=ie.set(n.ExtHostContext.ExtHostCustomEditors,new H.ExtHostCustomEditors(ie,Ct,re,qt,oi)),yi=ie.set(n.ExtHostContext.ExtHostWebviewViews,new nt.ExtHostWebviewViews(ie,qt)),Gt=ie.set(n.ExtHostContext.ExtHostTesting,new Ke.ExtHostTesting(ie,rt)),Xt=ie.set(n.ExtHostContext.ExtHostUriOpeners,new ot.ExtHostUriOpeners(ie));ie.set(n.ExtHostContext.ExtHostInteractive,new ye.ExtHostInteractive(ie,gt,wt,rt));const Si=(0,le.values)(n.ExtHostContext);ie.assertRegistered(Si);const Di=new me.ExtHostBulkEdits(ie,wt),ai=new c.ExtHostClipboard(ie),li=new C.ExtHostMessageService(ie,B),Vt=new s.ExtHostDialogs(ie),Mt=new A.ExtHostStatusBar(ie,rt.converter);return d.ExtHostApiCommands.register(rt),function(Re,Rt,Kt){const pt=function(){let X=!Re.isUnderDevelopment;function de(ke){X||(B.info(`Extension '${Re.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function ke(it){if(Array.isArray(it))it.forEach(ke);else if(typeof it=="string")de(it);else{const bt=it;typeof bt.scheme=="undefined"&&de(it),!Re.enableProposedApi&&typeof bt.exclusive=="boolean"&&(0,q.throwProposedApiError)(Re)}return it}}(),Ci={getSession(X,de,ke){return ke?.forceNewSession&&(0,q.checkProposedApiEnabled)(Re),ri.getSession(Re,X,de,ke)},get onDidChangeSessions(){return ri.onDidChangeSessions},registerAuthenticationProvider(X,de,ke,it){return ri.registerAuthenticationProvider(X,de,ke,it)}},ki={registerCommand(X,de,ke){return rt.registerCommand(!0,X,de,ke)},registerTextEditorCommand(X,de,ke){return rt.registerCommand(!0,X,(...it)=>{const bt=Pt.getActiveTextEditor();if(!bt){B.warn("Cannot execute "+X+" because there is no active text editor.");return}return bt.edit(Dt=>{de.apply(ke,[bt,Dt,...it])}).then(Dt=>{Dt||B.warn("Edits from command "+X+" were not applied.")},Dt=>{B.warn("An error occurred while running command "+X,Dt)})})},registerDiffInformationCommand:(X,de,ke)=>((0,q.checkProposedApiEnabled)(Re),rt.registerCommand(!0,X,async(...it)=>{const bt=wt.activeEditor(!0);if(!bt){B.warn("Cannot execute "+X+" because there is no active text editor.");return}const Dt=await Pt.getDiffInformation(bt.id);de.apply(ke,[Dt,...it])})),executeCommand(X,...de){return rt.executeCommand(X,...de)},getCommands(X=!1){return rt.getCommands(X)}},mi={get machineId(){return ce.telemetryInfo.machineId},get sessionId(){return ce.telemetryInfo.sessionId},get language(){return ce.environment.appLanguage},get appName(){return ce.environment.appName},get appRoot(){return ce.environment.appRoot?.fsPath??""},get appHost(){return ce.environment.appHost},get uriScheme(){return ce.environment.appUriScheme},get clipboard(){return ai.value},get shell(){return ct.getDefaultShell(!1)},get isTelemetryEnabled(){return Le.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Le.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(ce.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,de){return qe.openUri(X,{allowTunneling:!!ce.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(X){if(X.scheme===ce.environment.appUriScheme)return $t.createAppUri(X);try{return await qe.asExternalUri(X,{allowTunneling:!!ce.remote.authority})}catch(de){if((0,Je.matchesScheme)(X,ft.Schemas.http)||(0,Je.matchesScheme)(X,ft.Schemas.https))return X;throw de}},get remoteName(){return(0,Fe.getRemoteName)(ce.remote.authority)},get remoteAuthority(){return(0,q.checkProposedApiEnabled)(Re),ce.remote.authority},get uiKind(){return ce.uiKind}};ce.environment.extensionTestsLocationURI||Object.freeze(mi);const gi=ce.remote.isRemote?$.ExtensionKind.Workspace:$.ExtensionKind.UI,Ii={createTestController(X,de){return Gt.createTestController(X,de)},createTestObserver(){return(0,q.checkProposedApiEnabled)(Re),Gt.createTestObserver()},runTests(X){return(0,q.checkProposedApiEnabled)(Re),Gt.runTests(X)},get onDidChangeTestResults(){return(0,q.checkProposedApiEnabled)(Re),Gt.onResultsChanged},get testResults(){return(0,q.checkProposedApiEnabled)(Re),Gt.results}},Pi={getExtension(X){const de=Rt.getExtensionDescription(X);if(de)return new r.Extension(Ie,Re.identifier,de,gi)},get all(){return Rt.getAllExtensionDescriptions().map(X=>new r.Extension(Ie,Re.identifier,X,gi))},get onDidChange(){return Rt.onDidChange}},ui={createDiagnosticCollection(X){return Ht.createDiagnosticCollection(Re.identifier,X)},get onDidChangeDiagnostics(){return Ht.onDidChangeDiagnostics},getDiagnostics:X=>Ht.getDiagnostics(X),getLanguages(){return zt.getLanguages()},setTextDocumentLanguage(X,de){return zt.changeLanguage(X.uri,de)},match(X,de){return(0,t.score)(Q.LanguageSelector.from(X),de.uri,de.languageId,!0)},registerCodeActionsProvider(X,de,ke){return dt.registerCodeActionProvider(Re,pt(X),de,ke)},registerCodeLensProvider(X,de){return dt.registerCodeLensProvider(Re,pt(X),de)},registerDefinitionProvider(X,de){return dt.registerDefinitionProvider(Re,pt(X),de)},registerDeclarationProvider(X,de){return dt.registerDeclarationProvider(Re,pt(X),de)},registerImplementationProvider(X,de){return dt.registerImplementationProvider(Re,pt(X),de)},registerTypeDefinitionProvider(X,de){return dt.registerTypeDefinitionProvider(Re,pt(X),de)},registerHoverProvider(X,de){return dt.registerHoverProvider(Re,pt(X),de,Re.identifier)},registerEvaluatableExpressionProvider(X,de){return dt.registerEvaluatableExpressionProvider(Re,pt(X),de,Re.identifier)},registerInlineValuesProvider(X,de){return dt.registerInlineValuesProvider(Re,pt(X),de,Re.identifier)},registerDocumentHighlightProvider(X,de){return dt.registerDocumentHighlightProvider(Re,pt(X),de)},registerLinkedEditingRangeProvider(X,de){return dt.registerLinkedEditingRangeProvider(Re,pt(X),de)},registerReferenceProvider(X,de){return dt.registerReferenceProvider(Re,pt(X),de)},registerRenameProvider(X,de){return dt.registerRenameProvider(Re,pt(X),de)},registerDocumentSymbolProvider(X,de,ke){return dt.registerDocumentSymbolProvider(Re,pt(X),de,ke)},registerWorkspaceSymbolProvider(X){return dt.registerWorkspaceSymbolProvider(Re,X)},registerDocumentFormattingEditProvider(X,de){return dt.registerDocumentFormattingEditProvider(Re,pt(X),de)},registerDocumentRangeFormattingEditProvider(X,de){return dt.registerDocumentRangeFormattingEditProvider(Re,pt(X),de)},registerOnTypeFormattingEditProvider(X,de,ke,...it){return dt.registerOnTypeFormattingEditProvider(Re,pt(X),de,[ke].concat(it))},registerDocumentSemanticTokensProvider(X,de,ke){return dt.registerDocumentSemanticTokensProvider(Re,pt(X),de,ke)},registerDocumentRangeSemanticTokensProvider(X,de,ke){return dt.registerDocumentRangeSemanticTokensProvider(Re,pt(X),de,ke)},registerSignatureHelpProvider(X,de,ke,...it){return typeof ke=="object"?dt.registerSignatureHelpProvider(Re,pt(X),de,ke):dt.registerSignatureHelpProvider(Re,pt(X),de,typeof ke=="undefined"?[]:[ke,...it])},registerCompletionItemProvider(X,de,...ke){return dt.registerCompletionItemProvider(Re,pt(X),de,ke)},registerInlineCompletionItemProvider(X,de){return(0,q.checkProposedApiEnabled)(Re),dt.registerInlineCompletionsProvider(Re,pt(X),de)},registerDocumentLinkProvider(X,de){return dt.registerDocumentLinkProvider(Re,pt(X),de)},registerColorProvider(X,de){return dt.registerColorProvider(Re,pt(X),de)},registerFoldingRangeProvider(X,de){return dt.registerFoldingRangeProvider(Re,pt(X),de)},registerSelectionRangeProvider(X,de){return dt.registerSelectionRangeProvider(Re,X,de)},registerCallHierarchyProvider(X,de){return dt.registerCallHierarchyProvider(Re,X,de)},registerTypeHierarchyProvider(X,de){return dt.registerTypeHierarchyProvider(Re,X,de)},setLanguageConfiguration:(X,de)=>dt.setLanguageConfiguration(Re,X,de),getTokenInformationAtPosition(X,de){return(0,q.checkProposedApiEnabled)(Re),zt.tokenAtPosition(X,de)},registerInlayHintsProvider(X,de){return(0,q.checkProposedApiEnabled)(Re),dt.registerInlayHintsProvider(Re,X,de)},createLanguageStatusItem(X,de){return(0,q.checkProposedApiEnabled)(Re),zt.createLanguageStatusItem(Re,X,de)}},Ti={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return ct.activeTerminal},get terminals(){return ct.terminals},async showTextDocument(X,de,ke){const it=await(F.URI.isUri(X)?Promise.resolve(pi.openTextDocument(X)):Promise.resolve(X));return Pt.showTextDocument(it,de,ke)},createTextEditorDecorationType(X){return Pt.createTextEditorDecorationType(Re,X)},onDidChangeActiveTextEditor(X,de,ke){return Pt.onDidChangeActiveTextEditor(X,de,ke)},onDidChangeVisibleTextEditors(X,de,ke){return Pt.onDidChangeVisibleTextEditors(X,de,ke)},onDidChangeTextEditorSelection(X,de,ke){return Pt.onDidChangeTextEditorSelection(X,de,ke)},onDidChangeTextEditorOptions(X,de,ke){return Pt.onDidChangeTextEditorOptions(X,de,ke)},onDidChangeTextEditorVisibleRanges(X,de,ke){return Pt.onDidChangeTextEditorVisibleRanges(X,de,ke)},onDidChangeTextEditorViewColumn(X,de,ke){return Pt.onDidChangeTextEditorViewColumn(X,de,ke)},onDidCloseTerminal(X,de,ke){return ct.onDidCloseTerminal(X,de,ke)},onDidOpenTerminal(X,de,ke){return ct.onDidOpenTerminal(X,de,ke)},onDidChangeActiveTerminal(X,de,ke){return ct.onDidChangeActiveTerminal(X,de,ke)},onDidChangeTerminalDimensions(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),ct.onDidChangeTerminalDimensions(X,de,ke)},onDidChangeTerminalState(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),ct.onDidChangeTerminalState(X,de,ke)},onDidWriteTerminalData(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),ct.onDidWriteTerminalData(X,de,ke)},get state(){return qe.state},onDidChangeWindowState(X,de,ke){return qe.onDidChangeWindowState(X,de,ke)},showInformationMessage(X,...de){return li.showMessage(Re,T.default.Info,X,de[0],de.slice(1))},showWarningMessage(X,...de){return li.showMessage(Re,T.default.Warning,X,de[0],de.slice(1))},showErrorMessage(X,...de){return li.showMessage(Re,T.default.Error,X,de[0],de.slice(1))},showQuickPick(X,de,ke){return Nt.showQuickPick(X,!!Re.enableProposedApi,de,ke)},showWorkspaceFolderPick(X){return Nt.showWorkspaceFolderPick(X)},showInputBox(X,de){return Nt.showInput(X,de)},showOpenDialog(X){return Vt.showOpenDialog(X)},showSaveDialog(X){return Vt.showSaveDialog(X)},createStatusBarItem(X,de,ke){let it,bt,Dt;return typeof X=="string"?(it=X,bt=de,Dt=ke):(bt=X,Dt=de),Mt.createStatusBarEntry(Re,it,bt,Dt)},setStatusBarMessage(X,de){return Mt.setStatusBarMessage(X,de)},withScmProgress(X){return Se.report("window.withScmProgress",Re,"Use 'withProgress' instead."),hi.withProgress(Re,{location:$.ProgressLocation.SourceControl},(de,ke)=>X({report(it){}}))},withProgress(X,de){return hi.withProgress(Re,X,de)},createOutputChannel(X){return Ut.createOutputChannel(X,Re)},createWebviewPanel(X,de,ke,it){return oi.createWebviewPanel(Re,X,de,ke,it)},createWebviewTextEditorInset(X,de,ke,it){return(0,q.checkProposedApiEnabled)(Re),wi.createWebviewEditorInset(X,de,ke,it,Re)},createTerminal(X,de,ke){return typeof X=="object"?("location"in X&&(0,q.checkProposedApiEnabled)(Re),"pty"in X?ct.createExtensionTerminal(X):ct.createTerminalFromOptions(X)):ct.createTerminal(X,de,ke)},registerTerminalLinkProvider(X){return ct.registerLinkProvider(X)},registerTerminalProfileProvider(X,de){return ct.registerProfileProvider(Re,X,de)},registerTreeDataProvider(X,de){return Yt.registerTreeDataProvider(X,de,Re)},createTreeView(X,de){return Yt.createTreeView(X,de,Re)},registerWebviewPanelSerializer:(X,de)=>oi.registerWebviewPanelSerializer(Re,X,de),registerCustomEditorProvider:(X,de,ke={})=>_i.registerCustomEditorProvider(Re,X,de,ke),registerFileDecorationProvider(X){return mt.registerFileDecorationProvider(X,Re.identifier)},registerUriHandler(X){return $t.registerUriHandler(Re.identifier,X)},createQuickPick(){return Nt.createQuickPick(Re.identifier,!!Re.enableProposedApi)},createInputBox(){return Nt.createInputBox(Re.identifier)},get activeColorTheme(){return fi.activeColorTheme},onDidChangeActiveColorTheme(X,de,ke){return fi.onDidChangeActiveColorTheme(X,de,ke)},registerWebviewViewProvider(X,de,ke){return yi.registerWebviewViewProvider(Re,X,de,ke?.webviewOptions)},get activeNotebookEditor(){return(0,q.checkProposedApiEnabled)(Re),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),gt.onDidChangeActiveNotebookEditor(X,de,ke)},get visibleNotebookEditors(){return(0,q.checkProposedApiEnabled)(Re),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,q.checkProposedApiEnabled)(Re),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),jt.onDidChangeNotebookEditorSelection(X,de,ke)},onDidChangeNotebookEditorVisibleRanges(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),jt.onDidChangeNotebookEditorVisibleRanges(X,de,ke)},showNotebookDocument(X,de){return(0,q.checkProposedApiEnabled)(Re),gt.showNotebookDocument(X,de)},registerExternalUriOpener(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),Xt.registerExternalUriOpener(Re.identifier,X,de,ke)},get tabs(){return(0,q.checkProposedApiEnabled)(Re),tt.tabs},get activeTab(){return(0,q.checkProposedApiEnabled)(Re),tt.activeTab},get onDidChangeTabs(){return(0,q.checkProposedApiEnabled)(Re),tt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,q.checkProposedApiEnabled)(Re),tt.onDidChangeActiveTab},getInlineCompletionItemController(X){return(0,q.checkProposedApiEnabled)(Re),m.InlineCompletionController.get(X)}},pi={get rootPath(){return Se.report("workspace.rootPath",Re,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),xe.getPath()},set rootPath(X){throw M.readonly()},getWorkspaceFolder(X){return xe.getWorkspaceFolder(X)},get workspaceFolders(){return xe.getWorkspaceFolders()},get name(){return xe.name},set name(X){throw M.readonly()},get workspaceFile(){return xe.workspaceFile},set workspaceFile(X){throw M.readonly()},updateWorkspaceFolders:(X,de,...ke)=>xe.updateWorkspaceFolders(Re,X,de||0,...ke),onDidChangeWorkspaceFolders:function(X,de,ke){return xe.onDidChangeWorkspace(X,de,ke)},asRelativePath:(X,de)=>xe.getRelativePath(X,de),findFiles:(X,de,ke,it)=>xe.findFiles(Q.GlobPattern.from(X),Q.GlobPattern.from(de),ke,Re.identifier,it),findTextInFiles:(X,de,ke,it)=>{let bt,Dt;return typeof de=="object"?(bt=de,Dt=ke):(bt={},Dt=de,it=ke),xe.findTextInFiles(X,bt||{},Dt,Re.identifier,it)},saveAll:X=>xe.saveAll(X),applyEdit(X){return Di.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,de,ke,it)=>Ot.createFileSystemWatcher(Q.GlobPattern.from(X),de,ke,it),get textDocuments(){return Ct.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw M.readonly()},openTextDocument(X){let de;const ke=X;if(typeof X=="string")de=Promise.resolve(F.URI.file(X));else if(F.URI.isUri(X))de=Promise.resolve(X);else if(!ke||typeof ke=="object")de=Ct.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(it=>Ct.ensureDocumentData(it).then(bt=>bt.document))},onDidOpenTextDocument:(X,de,ke)=>Ct.onDidAddDocument(X,de,ke),onDidCloseTextDocument:(X,de,ke)=>Ct.onDidRemoveDocument(X,de,ke),onDidChangeTextDocument:(X,de,ke)=>Ct.onDidChangeDocument(X,de,ke),onDidSaveTextDocument:(X,de,ke)=>Ct.onDidSaveDocument(X,de,ke),onWillSaveTextDocument:(X,de,ke)=>ei.getOnWillSaveTextDocumentEvent(Re)(X,de,ke),get notebookDocuments(){return gt.notebookDocuments.map(X=>X.apiNotebook)},async openNotebookDocument(X,de){let ke;if(F.URI.isUri(X))ke=X,await gt.openNotebookDocument(X);else if(typeof X=="string")ke=F.URI.revive(await gt.createNotebookDocument({viewType:X,content:de}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(ke).apiNotebook},get onDidOpenNotebookDocument(){return gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return gt.onDidCloseNotebookDocument},registerNotebookSerializer(X,de,ke,it){return gt.registerNotebookSerializer(Re,X,de,ke,Re.enableProposedApi?it:void 0)},registerNotebookContentProvider:(X,de,ke,it)=>((0,q.checkProposedApiEnabled)(Re),gt.registerNotebookContentProvider(Re,X,de,ke,Re.enableProposedApi?it:void 0)),onDidChangeConfiguration:(X,de,ke)=>Kt.onDidChangeConfiguration(X,de,ke),getConfiguration(X,de){return de=arguments.length===1?void 0:de,Kt.getConfiguration(X,de,Re)},registerTextDocumentContentProvider(X,de){return Wt.registerTextDocumentContentProvider(X,de)},registerTaskProvider:(X,de)=>(Se.report("window.registerTaskProvider",Re,"Use the corresponding function on the 'tasks' namespace instead"),_t.registerTaskProvider(Re,X,de)),registerFileSystemProvider(X,de,ke){return ni.registerFileSystemProvider(Re.identifier,X,de,ke)},get fs(){return fe.value},registerFileSearchProvider:(X,de)=>((0,q.checkProposedApiEnabled)(Re),Tt.registerFileSearchProvider(X,de)),registerTextSearchProvider:(X,de)=>((0,q.checkProposedApiEnabled)(Re),Tt.registerTextSearchProvider(X,de)),registerRemoteAuthorityResolver:(X,de)=>((0,q.checkProposedApiEnabled)(Re),Ie.registerRemoteAuthorityResolver(X,de)),registerResourceLabelFormatter:X=>((0,q.checkProposedApiEnabled)(Re),Ei.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,de,ke)=>Ot.onDidCreateFile(X,de,ke),onDidDeleteFiles:(X,de,ke)=>Ot.onDidDeleteFile(X,de,ke),onDidRenameFiles:(X,de,ke)=>Ot.onDidRenameFile(X,de,ke),onWillCreateFiles:(X,de,ke)=>Ot.getOnWillCreateFileEvent(Re)(X,de,ke),onWillDeleteFiles:(X,de,ke)=>Ot.getOnWillDeleteFileEvent(Re)(X,de,ke),onWillRenameFiles:(X,de,ke)=>Ot.getOnWillRenameFileEvent(Re)(X,de,ke),openTunnel:X=>((0,q.checkProposedApiEnabled)(Re),De.openTunnel(Re,X).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,q.checkProposedApiEnabled)(Re),De.getTunnels()},onDidChangeTunnels:(X,de,ke)=>((0,q.checkProposedApiEnabled)(Re),De.onDidChangeTunnels(X,de,ke)),registerPortAttributesProvider:(X,de)=>((0,q.checkProposedApiEnabled)(Re),De.registerPortsAttributesProvider(X,de)),registerTimelineProvider:(X,de)=>((0,q.checkProposedApiEnabled)(Re),si.registerTimelineProvider(X,de,Re.identifier,rt.converter)),get isTrusted(){return xe.trusted},requestWorkspaceTrust:X=>((0,q.checkProposedApiEnabled)(Re),xe.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,de,ke)=>xe.onDidGrantWorkspaceTrust(X,de,ke)},Ai={get inputBox(){return Se.report("scm.inputBox",Re,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Re)},createSourceControl(X,de,ke){return Jt.createSourceControl(Re,X,de,ke)}},Ri={createCommentController(X,de){return bi.createCommentController(Re,X,de)}},Fi={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(X,de,ke){return lt.onDidStartDebugSession(X,de,ke)},onDidTerminateDebugSession(X,de,ke){return lt.onDidTerminateDebugSession(X,de,ke)},onDidChangeActiveDebugSession(X,de,ke){return lt.onDidChangeActiveDebugSession(X,de,ke)},onDidReceiveDebugSessionCustomEvent(X,de,ke){return lt.onDidReceiveDebugSessionCustomEvent(X,de,ke)},onDidChangeBreakpoints(X,de,ke){return lt.onDidChangeBreakpoints(X,de,ke)},registerDebugConfigurationProvider(X,de,ke){return lt.registerDebugConfigurationProvider(X,de,ke||$.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,de){return lt.registerDebugAdapterDescriptorFactory(Re,X,de)},registerDebugAdapterTrackerFactory(X,de){return lt.registerDebugAdapterTrackerFactory(X,de)},startDebugging(X,de,ke){return!ke||typeof ke=="object"&&"configuration"in ke?lt.startDebugging(X,de,{parentSession:ke}):lt.startDebugging(X,de,ke||{})},stopDebugging(X){return lt.stopDebugging(X)},addBreakpoints(X){return lt.addBreakpoints(X)},removeBreakpoints(X){return lt.removeBreakpoints(X)},asDebugSourceUri(X,de){return lt.asDebugSourceUri(X,de)}},Mi={registerTaskProvider:(X,de)=>_t.registerTaskProvider(Re,X,de),fetchTasks:X=>_t.fetchTasks(X),executeTask:X=>_t.executeTask(Re,X),get taskExecutions(){return _t.taskExecutions},onDidStartTask:(X,de,ke)=>_t.onDidStartTask(X,de,ke),onDidEndTask:(X,de,ke)=>_t.onDidEndTask(X,de,ke),onDidStartTaskProcess:(X,de,ke)=>_t.onDidStartTaskProcess(X,de,ke),onDidEndTaskProcess:(X,de,ke)=>_t.onDidEndTaskProcess(X,de,ke)},Li={createNotebookController(X,de,ke,it,bt){return ti.createNotebookController(Re,X,de,ke,it,Re.enableProposedApi?bt:void 0)},registerNotebookCellStatusBarItemProvider:(X,de)=>gt.registerNotebookCellStatusBarItemProvider(Re,X,de),get onDidSaveNotebookDocument(){return(0,q.checkProposedApiEnabled)(Re),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(X){return(0,q.checkProposedApiEnabled)(Re),jt.createNotebookEditorDecorationType(X)},createRendererMessaging(X){return ii.createRendererMessaging(Re,X)},onDidChangeNotebookDocumentMetadata(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),Qt.onDidChangeNotebookDocumentMetadata(X,de,ke)},onDidChangeNotebookCells(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),gt.onDidChangeNotebookCells(X,de,ke)},onDidChangeNotebookCellExecutionState(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),gt.onDidChangeNotebookCellExecutionState(X,de,ke)},onDidChangeCellOutputs(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),gt.onDidChangeCellOutputs(X,de,ke)},onDidChangeCellMetadata(X,de,ke){return(0,q.checkProposedApiEnabled)(Re),gt.onDidChangeCellMetadata(X,de,ke)},createConcatTextDocument(X,de){return(0,q.checkProposedApiEnabled)(Re),new $e.ExtHostNotebookConcatDocument(gt,Ct,X,de)}};return{version:ce.version,authentication:Ci,commands:ki,comments:Ri,debug:Fi,env:mi,extensions:Pi,languages:ui,notebooks:Li,scm:Ai,tasks:Mi,tests:Ii,window:Ti,workspace:pi,Breakpoint:$.Breakpoint,CallHierarchyIncomingCall:$.CallHierarchyIncomingCall,CallHierarchyItem:$.CallHierarchyItem,CallHierarchyOutgoingCall:$.CallHierarchyOutgoingCall,CancellationError:M.CancellationError,CancellationTokenSource:h.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:$.CodeAction,CodeActionKind:$.CodeActionKind,CodeActionTriggerKind:$.CodeActionTriggerKind,CodeLens:$.CodeLens,Color:$.Color,ColorInformation:$.ColorInformation,ColorPresentation:$.ColorPresentation,ColorThemeKind:$.ColorThemeKind,CommentMode:$.CommentMode,CommentThreadCollapsibleState:$.CommentThreadCollapsibleState,CompletionItem:$.CompletionItem,CompletionItemKind:$.CompletionItemKind,CompletionItemTag:$.CompletionItemTag,CompletionList:$.CompletionList,CompletionTriggerKind:$.CompletionTriggerKind,ConfigurationTarget:$.ConfigurationTarget,CustomExecution:$.CustomExecution,DebugAdapterExecutable:$.DebugAdapterExecutable,DebugAdapterInlineImplementation:$.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:$.DebugAdapterNamedPipeServer,DebugAdapterServer:$.DebugAdapterServer,DebugConfigurationProviderTriggerKind:$.DebugConfigurationProviderTriggerKind,DebugConsoleMode:$.DebugConsoleMode,DecorationRangeBehavior:$.DecorationRangeBehavior,Diagnostic:$.Diagnostic,DiagnosticRelatedInformation:$.DiagnosticRelatedInformation,DiagnosticSeverity:$.DiagnosticSeverity,DiagnosticTag:$.DiagnosticTag,Disposable:$.Disposable,DocumentHighlight:$.DocumentHighlight,DocumentHighlightKind:$.DocumentHighlightKind,DocumentLink:$.DocumentLink,DocumentSymbol:$.DocumentSymbol,EndOfLine:$.EndOfLine,EnvironmentVariableMutatorType:$.EnvironmentVariableMutatorType,EvaluatableExpression:$.EvaluatableExpression,InlineValueText:$.InlineValueText,InlineValueVariableLookup:$.InlineValueVariableLookup,InlineValueEvaluatableExpression:$.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:$.InlineCompletionTriggerKind,EventEmitter:b.Emitter,ExtensionKind:$.ExtensionKind,ExtensionMode:$.ExtensionMode,ExternalUriOpenerPriority:$.ExternalUriOpenerPriority,FileChangeType:$.FileChangeType,FileDecoration:$.FileDecoration,FileSystemError:$.FileSystemError,FileType:E.FileType,FilePermission:E.FilePermission,FoldingRange:$.FoldingRange,FoldingRangeKind:$.FoldingRangeKind,FunctionBreakpoint:$.FunctionBreakpoint,InlineCompletionItem:$.InlineSuggestion,InlineCompletionList:$.InlineSuggestions,Hover:$.Hover,IndentAction:P.IndentAction,Location:$.Location,MarkdownString:$.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:$.ParameterInformation,PortAutoForwardAction:$.PortAutoForwardAction,Position:$.Position,ProcessExecution:$.ProcessExecution,ProgressLocation:$.ProgressLocation,QuickInputButtons:$.QuickInputButtons,Range:$.Range,RelativePattern:$.RelativePattern,Selection:$.Selection,SelectionRange:$.SelectionRange,SemanticTokens:$.SemanticTokens,SemanticTokensBuilder:$.SemanticTokensBuilder,SemanticTokensEdit:$.SemanticTokensEdit,SemanticTokensEdits:$.SemanticTokensEdits,SemanticTokensLegend:$.SemanticTokensLegend,ShellExecution:$.ShellExecution,ShellQuoting:$.ShellQuoting,SignatureHelp:$.SignatureHelp,SignatureHelpTriggerKind:$.SignatureHelpTriggerKind,SignatureInformation:$.SignatureInformation,SnippetString:$.SnippetString,SourceBreakpoint:$.SourceBreakpoint,StandardTokenType:$.StandardTokenType,StatusBarAlignment:$.StatusBarAlignment,SymbolInformation:$.SymbolInformation,SymbolKind:$.SymbolKind,SymbolTag:$.SymbolTag,Task:$.Task,TaskGroup:$.TaskGroup,TaskPanelKind:$.TaskPanelKind,TaskRevealKind:$.TaskRevealKind,TaskScope:$.TaskScope,TerminalLink:$.TerminalLink,TerminalLocation:$.TerminalLocation,TerminalProfile:$.TerminalProfile,TextDocumentSaveReason:$.TextDocumentSaveReason,TextEdit:$.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:$.TextEditorLineNumbersStyle,TextEditorRevealType:$.TextEditorRevealType,TextEditorSelectionChangeKind:$.TextEditorSelectionChangeKind,TextDocumentChangeReason:$.TextDocumentChangeReason,ThemeColor:$.ThemeColor,ThemeIcon:$.ThemeIcon,TreeItem:$.TreeItem,TreeItemCollapsibleState:$.TreeItemCollapsibleState,TypeHierarchyItem:$.TypeHierarchyItem,UIKind:n.UIKind,Uri:F.URI,ViewColumn:$.ViewColumn,WorkspaceEdit:$.WorkspaceEdit,InlayHint:$.InlayHint,InlayHintKind:$.InlayHintKind,RemoteAuthorityResolverError:$.RemoteAuthorityResolverError,ResolvedAuthority:$.ResolvedAuthority,SourceControlInputBoxValidationType:$.SourceControlInputBoxValidationType,ExtensionRuntime:$.ExtensionRuntime,TimelineItem:$.TimelineItem,NotebookRange:$.NotebookRange,NotebookCellKind:$.NotebookCellKind,NotebookCellExecutionState:$.NotebookCellExecutionState,NotebookCellData:$.NotebookCellData,NotebookData:$.NotebookData,NotebookRendererScript:$.NotebookRendererScript,NotebookCellStatusBarAlignment:$.NotebookCellStatusBarAlignment,NotebookEditorRevealType:$.NotebookEditorRevealType,NotebookCellOutput:$.NotebookCellOutput,NotebookCellOutputItem:$.NotebookCellOutputItem,NotebookCellStatusBarItem:$.NotebookCellStatusBarItem,NotebookControllerAffinity:$.NotebookControllerAffinity,PortAttributes:$.PortAttributes,LinkedEditingRanges:$.LinkedEditingRanges,TestResultState:$.TestResultState,TestRunRequest:$.TestRunRequest,TestMessage:$.TestMessage,TestTag:$.TestTag,TestRunProfileKind:$.TestRunProfileKind,TextSearchCompleteMessageType:yt.TextSearchCompleteMessageType,CoveredCount:$.CoveredCount,FileCoverage:$.FileCoverage,StatementCoverage:$.StatementCoverage,BranchCoverage:$.BranchCoverage,FunctionCoverage:$.FunctionCoverage,WorkspaceTrustState:$.WorkspaceTrustState,LanguageStatusSeverity:$.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ce}),define(we[223],be([0,1,57,96,31,95,32,48,49,38,99,100,101,72,64,70,97,71,37,69,87,68]),function(ne,e,h,M,b,T,F,D,_,P,t,E,n,d,c,l,w,I,y,s,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.registerSingleton)(l.IExtHostApiDeprecationService,l.ExtHostApiDeprecationService),(0,h.registerSingleton)(D.IExtHostCommands,D.ExtHostCommands),(0,h.registerSingleton)(F.IExtHostConfiguration,F.ExtHostConfiguration),(0,h.registerSingleton)(I.IExtHostConsumerFileSystem,I.ExtHostConsumerFileSystem),(0,h.registerSingleton)(E.IExtHostDebugService,E.WorkerExtHostDebugService),(0,h.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,h.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),(0,h.registerSingleton)(y.IExtHostFileSystemInfo,y.ExtHostFileSystemInfo),(0,h.registerSingleton)(M.IExtHostOutputService,M.ExtHostOutputService),(0,h.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,h.registerSingleton)(d.IExtHostStorage,d.ExtHostStorage),(0,h.registerSingleton)(t.IExtHostTask,t.WorkerExtHostTask),(0,h.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,h.registerSingleton)(c.IExtHostTunnelService,c.ExtHostTunnelService),(0,h.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,h.registerSingleton)(b.IExtHostWorkspace,b.ExtHostWorkspace),(0,h.registerSingleton)(s.IExtHostSecretState,s.ExtHostSecretState),(0,h.registerSingleton)(g.IExtHostTelemetry,g.ExtHostTelemetry),(0,h.registerSingleton)(k.IExtHostEditorTabs,k.ExtHostEditorTabs)}),define(we[224],be([0,1,222,33,218,7,14,5,11]),function(ne,e,h,M,b,T,F,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var P;(function(c){const l=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(I,...y)=>{y.forEach(i=>{if(!self.trustedTypes?.isScript(i))throw new Error("TrustedScripts only, please")});const s=y.slice(0,-1).join(","),g=y.pop().toString();return`(function anonymous(${s}) {
${g}
})`}});function w(...I){return l?self.eval(l.createScript("",...I)):new Function(...I)}c.create=w})(P||(P={}));class t extends b.RequireInterceptor{_installInterceptor(){}getModule(l,w){for(let I of this._alternatives){let y=I(l);if(y){l=y;break}}if(this._factories.has(l))return this._factories.get(l).load(l,w,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class E extends M.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const l=this._extHostContext.getProxy(D.MainContext.MainThreadConsole);d(l,this._initData.environment.isExtensionDevelopmentDebug);const w=this._instaService.invokeFunction(h.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(t,w,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(l){return l.browser}async _loadCommonJSModule(l,w,I){w=w.with({path:n(w.path,".js")}),l&&performance.mark(`code/extHost/willFetchExtensionCode/${l.value}`);const y=await fetch(_.FileAccess.asBrowserUri(w).toString(!0));if(l&&performance.mark(`code/extHost/didFetchExtensionCode/${l.value}`),y.status!==200)throw new Error(y.statusText);const s=await y.text(),g=`${w.toString(!0)}#vscode-extension`,k=`${s}
//# sourceURL=${g}`;let i;try{i=P.create(E._ttpExtensionScripts?.createScript("module")??"module",E._ttpExtensionScripts?.createScript("exports")??"exports",E._ttpExtensionScripts?.createScript("require")??"require",E._ttpExtensionScripts?.createScript(k)??k)}catch(f){throw console.error(l?`Loading code for extension ${l.value} failed: ${f.message}`:`Loading code failed: ${f.message}`),console.error(`${w.toString(!0)}${typeof f.line=="number"?` line ${f.line}`:""}${typeof f.column=="number"?` column ${f.column}`:""}`),console.error(f),f}const a={},r={exports:a},o=f=>{const m=this._fakeModules.getModule(f,w);if(m===void 0)throw new Error(`Cannot load module '${f}'`);return m};try{return I.codeLoadingStart(),l&&performance.mark(`code/extHost/willLoadExtensionCode/${l.value}`),i(r,a,o),r.exports!==a?r.exports:a}finally{l&&performance.mark(`code/extHost/didLoadExtensionCode/${l.value}`),I.codeLoadingStop()}}async $setRemoteEnvironment(l){}async _waitForDebuggerAttachment(l=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const w=Date.now()+l;for(;Date.now()<w&&!("__jsDebugIsReady"in globalThis);)await(0,F.timeout)(10)}}e.ExtHostExtensionService=E,E._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:c=>c});function n(c,l){return c.endsWith(l)?c:c+l}function d(c,l){w("info","log"),w("log","log"),w("warn","warn"),w("error","error");function w(s,g){const k=console[s];console[s]=function(){c.$logExtensionHostMessage({type:"__$console",severity:g,arguments:y(arguments)}),l&&k.apply(console,arguments)}}const I=1e5;function y(s){const g=[],k=[];if(s.length)for(let i=0;i<s.length;i++){if(typeof s[i]=="undefined")s[i]="undefined";else if(s[i]instanceof Error){const a=s[i];a.stack?s[i]=a.stack:s[i]=a.toString()}k.push(s[i])}try{const i=JSON.stringify(k,function(a,r){if(r&&typeof r=="object"){if(g.indexOf(r)!==-1)return"[Circular]";g.push(r)}return r});return i.length>I?"Output omitted for a large object that exceeds the limits":i}catch(i){return`Output omitted for an object that cannot be inspected ('${i.toString()}')`}}}}),define(we[225],be([0,1,57,15,33,73,224,211]),function(ne,e,h,M,b,T,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.registerSingleton)(b.IExtHostExtensionService,F.ExtHostExtensionService),(0,h.registerSingleton)(M.ILogService,D.ExtHostLogService),(0,h.registerSingleton)(T.IExtensionStoragePaths,T.ExtensionStoragePaths)}),define(we[235],be([0,1,23,3,177,219,213,17,74,11,2,223,225]),function(ne,e,h,M,b,T,F,D,_,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const E=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const d=fetch.bind(self);if(self.fetch=function(s,g){return s instanceof Request||/^file:/i.test(String(s))&&(s=P.FileAccess.asBrowserUri(t.URI.parse(String(s))).toString(!0)),d(s,g)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,g,k,i,a){return/^file:/i.test(g.toString())&&(g=P.FileAccess.asBrowserUri(t.URI.parse(g.toString())).toString(!0)),super.open(s,g,k??!0,i,a)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const s=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:k=>k}),g=self.Worker;Worker=function(k,i){/^file:/i.test(k.toString())&&(k=P.FileAccess.asBrowserUri(t.URI.parse(k.toString())).toString(!0));const r=`(${function(v){function C(u){return typeof u=="string"||u instanceof URL?String(u).replace(/^file:\/\//i,"vscode-file://vscode-app"):u}const R=fetch.bind(self);self.fetch=function(u,A){return u instanceof Request?R(u,A):R(C(u),A)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,A,L,V,K){return super.open(u,C(A),L??!0,V,K)}};const p=importScripts.bind(self);self.importScripts=(...u)=>{p(...u.map(C))};const S=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:u=>u}):void 0;p(S?S.createScriptURL(v):v)}.toString()}('${k}'))`;i=i||{},i.name=i.name||D.basename(k.toString());const o=new Blob([r],{type:"application/javascript"}),f=URL.createObjectURL(o);return new g(s?s.createScriptURL(f):f,i)}}else self.Worker=class extends F.NestedWorker{constructor(s,g){super(n,s,{name:D.basename(s.toString()),...g})}};const c=new class{exit(s){E()}async exists(s){return!0}async realpath(s){return s}};class l{constructor(){const g=new MessageChannel,k=new M.Emitter;let i=!1;n(g.port2,[g.port2]),g.port1.onmessage=a=>{const{data:r}=a;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const o=h.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,b.isMessageOfType)(o,2)){i=!0,I("received terminate message from renderer");return}k.fire(o)},this.protocol={onMessage:k.event,send:a=>{if(!i){const r=a.buffer.buffer.slice(a.buffer.byteOffset,a.buffer.byteOffset+a.buffer.byteLength);g.port1.postMessage(r,[r])}}}}}function w(s){return new Promise(g=>{const k=s.onMessage(i=>{k.dispose();const a=JSON.parse(i.toString());s.send((0,b.createMessageOfType)(0)),g({protocol:s,initData:a})});s.send((0,b.createMessageOfType)(1))})}let I=s=>E();function y(){const s=new l;_.mark("code/extHost/willConnectToRenderer"),w(s.protocol).then(g=>{_.mark("code/extHost/didWaitForInitData");const k=new T.ExtensionHostMain(g.protocol,g.initData,c,null);I=i=>k.terminate(i)})}e.create=y})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0c83ca1ced83259971d80890d93abbe19cbfc992/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
